#ifndef DOM_BINDINGNAMES_H_
#define DOM_BINDINGNAMES_H_

#include <stddef.h>
#include <stdint.h>
#include "mozilla/Attributes.h"

namespace mozilla::dom {

enum class BindingNamesOffset : uint16_t {
  ANGLE_instanced_arrays = 0,
  APZHitResultFlags = 23,
  AbortController = 41,
  AbortSignal = 57,
  AbstractRange = 69,
  AccessibleNode = 83,
  Addon = 98,
  AddonEvent = 104,
  AddonInstall = 115,
  AddonManager = 128,
  AddonManagerPermissions = 141,
  AnalyserNode = 165,
  Animation = 178,
  AnimationEffect = 188,
  AnimationEvent = 204,
  AnimationPlaybackEvent = 219,
  AnimationTimeline = 242,
  AnonymousContent = 260,
  Attr = 277,
  Audio = 282,
  AudioBuffer = 288,
  AudioBufferSourceNode = 300,
  AudioContext = 322,
  AudioData = 335,
  AudioDecoder = 345,
  AudioDestinationNode = 358,
  AudioEncoder = 379,
  AudioListener = 392,
  AudioNode = 406,
  AudioParam = 416,
  AudioParamMap = 427,
  AudioProcessingEvent = 441,
  AudioScheduledSourceNode = 462,
  AudioTrack = 487,
  AudioTrackList = 498,
  AudioWorklet = 513,
  AudioWorkletGlobalScope = 526,
  AudioWorkletNode = 550,
  AudioWorkletProcessor = 567,
  AuthenticatorAssertionResponse = 589,
  AuthenticatorAttestationResponse = 620,
  AuthenticatorResponse = 653,
  BarProp = 675,
  BaseAudioContext = 683,
  BatteryManager = 700,
  BeforeUnloadEvent = 715,
  BiquadFilterNode = 733,
  Blob = 750,
  BlobEvent = 755,
  BroadcastChannel = 765,
  BrowsingContext = 782,
  BrowsingContextGroup = 798,
  ByteLengthQueuingStrategy = 819,
  CDATASection = 845,
  CSPViolationReportBody = 858,
  CSS = 881,
  CSS2Properties = 885,
  CSSAnimation = 900,
  CSSConditionRule = 913,
  CSSContainerRule = 930,
  CSSCounterStyleRule = 947,
  CSSCustomPropertyRegisteredEvent = 967,
  CSSFontFaceRule = 1000,
  CSSFontFeatureValuesRule = 1016,
  CSSFontPaletteValuesRule = 1041,
  CSSGroupingRule = 1066,
  CSSImportRule = 1082,
  CSSKeyframeRule = 1096,
  CSSKeyframesRule = 1112,
  CSSLayerBlockRule = 1129,
  CSSLayerStatementRule = 1147,
  CSSMarginRule = 1169,
  CSSMediaRule = 1183,
  CSSMozDocumentRule = 1196,
  CSSNamespaceRule = 1215,
  CSSNestedDeclarations = 1232,
  CSSPageDescriptors = 1254,
  CSSPageRule = 1273,
  CSSPositionTryDescriptors = 1285,
  CSSPositionTryRule = 1311,
  CSSPropertyRule = 1330,
  CSSPseudoElement = 1346,
  CSSRule = 1363,
  CSSRuleList = 1371,
  CSSScopeRule = 1383,
  CSSStartingStyleRule = 1396,
  CSSStyleDeclaration = 1417,
  CSSStyleRule = 1437,
  CSSStyleSheet = 1450,
  CSSSupportsRule = 1464,
  CSSTransition = 1480,
  Cache = 1494,
  CacheStorage = 1500,
  CallbackDebuggerNotification = 1513,
  CanonicalBrowsingContext = 1542,
  CanvasCaptureMediaStream = 1567,
  CanvasGradient = 1592,
  CanvasPattern = 1607,
  CanvasRenderingContext2D = 1621,
  CaretPosition = 1646,
  CaretStateChangedEvent = 1660,
  ChannelMergerNode = 1683,
  ChannelSplitterNode = 1701,
  ChannelWrapper = 1721,
  CharacterData = 1736,
  CheckerboardReportService = 1750,
  ChildProcessMessageManager = 1776,
  ChildSHistory = 1803,
  ChromeMessageBroadcaster = 1817,
  ChromeMessageSender = 1842,
  ChromeNodeList = 1862,
  ChromeUtils = 1877,
  ChromeWorker = 1889,
  Client = 1902,
  Clients = 1909,
  Clipboard = 1917,
  ClipboardEvent = 1927,
  ClipboardItem = 1942,
  ClonedErrorHolder = 1956,
  CloseEvent = 1974,
  CloseWatcher = 1985,
  CommandEvent = 1998,
  Comment = 2011,
  CompositionEvent = 2019,
  CompressionStream = 2036,
  ConsoleInstance = 2054,
  ConstantSourceNode = 2070,
  ContentFrameMessageManager = 2089,
  ContentProcessMessageManager = 2116,
  ContentVisibilityAutoStateChangeEvent = 2145,
  ConvolverNode = 2183,
  CookieChangeEvent = 2197,
  CookieStore = 2215,
  CountQueuingStrategy = 2227,
  CreateOfferRequest = 2248,
  Credential = 2267,
  CredentialsContainer = 2278,
  Crypto = 2299,
  CryptoKey = 2306,
  CustomElementRegistry = 2316,
  CustomEvent = 2338,
  CustomStateSet = 2350,
  DOMException = 2365,
  DOMImplementation = 2378,
  DOMLocalization = 2396,
  DOMMatrix = 2412,
  DOMMatrixReadOnly = 2422,
  DOMParser = 2440,
  DOMPoint = 2450,
  DOMPointReadOnly = 2459,
  DOMQuad = 2476,
  DOMRect = 2484,
  DOMRectList = 2492,
  DOMRectReadOnly = 2504,
  DOMStringList = 2520,
  DOMStringMap = 2534,
  DOMTokenList = 2547,
  DataTransfer = 2560,
  DataTransferItem = 2573,
  DataTransferItemList = 2590,
  DebuggerNotification = 2611,
  DebuggerNotificationObserver = 2632,
  DecompressionStream = 2661,
  DedicatedWorkerGlobalScope = 2681,
  DelayNode = 2708,
  DeprecationReportBody = 2718,
  DeviceAcceleration = 2740,
  DeviceLightEvent = 2759,
  DeviceMotionEvent = 2776,
  DeviceOrientationEvent = 2794,
  DeviceRotationRate = 2817,
  Directory = 2836,
  Document = 2846,
  DocumentFragment = 2855,
  DocumentL10n = 2872,
  DocumentTimeline = 2885,
  DocumentType = 2902,
  DominatorTree = 2915,
  DragEvent = 2929,
  DynamicsCompressorNode = 2939,
  EXT_blend_minmax = 2962,
  EXT_color_buffer_float = 2979,
  EXT_color_buffer_half_float = 3002,
  EXT_depth_clamp = 3030,
  EXT_disjoint_timer_query = 3046,
  EXT_float_blend = 3071,
  EXT_frag_depth = 3087,
  EXT_sRGB = 3102,
  EXT_shader_texture_lod = 3111,
  EXT_texture_compression_bptc = 3134,
  EXT_texture_compression_rgtc = 3163,
  EXT_texture_filter_anisotropic = 3192,
  EXT_texture_norm16 = 3223,
  Element = 3242,
  ElementInternals = 3250,
  EncodedAudioChunk = 3267,
  EncodedVideoChunk = 3285,
  ErrorEvent = 3303,
  Event = 3314,
  EventCallbackDebuggerNotification = 3320,
  EventCounts = 3354,
  EventSource = 3366,
  EventTarget = 3378,
  Exception = 3390,
  ExtendableEvent = 3400,
  ExtendableMessageEvent = 3416,
  ExtensionAlarms = 3439,
  ExtensionBrowser = 3455,
  ExtensionBrowserSettings = 3472,
  ExtensionBrowserSettingsColorManagement = 3497,
  ExtensionDns = 3537,
  ExtensionEventManager = 3550,
  ExtensionMockAPI = 3572,
  ExtensionPort = 3589,
  ExtensionProxy = 3603,
  ExtensionRuntime = 3618,
  ExtensionScripting = 3635,
  ExtensionSetting = 3654,
  ExtensionTest = 3671,
  External = 3685,
  FeaturePolicy = 3694,
  FeaturePolicyViolationReportBody = 3708,
  FetchEvent = 3741,
  FetchObserver = 3752,
  File = 3766,
  FileList = 3771,
  FileReader = 3780,
  FileReaderSync = 3791,
  FileSystem = 3806,
  FileSystemDirectoryEntry = 3817,
  FileSystemDirectoryHandle = 3842,
  FileSystemDirectoryHandle_AsyncIterator = 3868,
  FileSystemDirectoryIterator = 3908,
  FileSystemDirectoryReader = 3936,
  FileSystemEntry = 3962,
  FileSystemFileEntry = 3978,
  FileSystemFileHandle = 3998,
  FileSystemHandle = 4019,
  FileSystemSyncAccessHandle = 4036,
  FileSystemWritableFileStream = 4063,
  Flex = 4092,
  FlexItemValues = 4097,
  FlexLineValues = 4112,
  FluentBundle = 4127,
  FluentBundleAsyncIterator = 4140,
  FluentBundleIterator = 4166,
  FluentPattern = 4187,
  FluentResource = 4201,
  FocusEvent = 4216,
  FontFace = 4227,
  FontFaceSet = 4236,
  FontFaceSetIterator = 4248,
  FontFaceSetLoadEvent = 4268,
  FormData = 4289,
  FormData_Iterator = 4298,
  FormDataEvent = 4316,
  FragmentDirective = 4330,
  FrameCrashedEvent = 4348,
  FrameLoader = 4366,
  GPU = 4378,
  GPUAdapter = 4382,
  GPUAdapterInfo = 4393,
  GPUBindGroup = 4408,
  GPUBindGroupLayout = 4421,
  GPUBuffer = 4440,
  GPUBufferUsage = 4450,
  GPUCanvasContext = 4465,
  GPUColorWrite = 4482,
  GPUCommandBuffer = 4496,
  GPUCommandEncoder = 4513,
  GPUCompilationInfo = 4531,
  GPUCompilationMessage = 4550,
  GPUComputePassEncoder = 4572,
  GPUComputePipeline = 4594,
  GPUDevice = 4613,
  GPUDeviceLostInfo = 4623,
  GPUError = 4641,
  GPUInternalError = 4650,
  GPUMapMode = 4667,
  GPUOutOfMemoryError = 4678,
  GPUPipelineLayout = 4698,
  GPUQuerySet = 4716,
  GPUQueue = 4728,
  GPURenderBundle = 4737,
  GPURenderBundleEncoder = 4753,
  GPURenderPassEncoder = 4776,
  GPURenderPipeline = 4797,
  GPUSampler = 4815,
  GPUShaderModule = 4826,
  GPUShaderStage = 4842,
  GPUSupportedFeatures = 4857,
  GPUSupportedLimits = 4878,
  GPUTexture = 4897,
  GPUTextureUsage = 4908,
  GPUTextureView = 4924,
  GPUUncapturedErrorEvent = 4939,
  GPUValidationError = 4963,
  GainNode = 4982,
  Gamepad = 4991,
  GamepadAxisMoveEvent = 4999,
  GamepadButton = 5020,
  GamepadButtonEvent = 5034,
  GamepadEvent = 5053,
  GamepadHapticActuator = 5066,
  GamepadLightIndicator = 5088,
  GamepadPose = 5110,
  GamepadServiceTest = 5122,
  GamepadTouch = 5141,
  Geolocation = 5154,
  GeolocationCoordinates = 5166,
  GeolocationPosition = 5189,
  GeolocationPositionError = 5209,
  GetUserMediaRequest = 5234,
  GleanBoolean = 5254,
  GleanCategory = 5267,
  GleanCounter = 5281,
  GleanCustomDistribution = 5294,
  GleanDatetime = 5318,
  GleanDenominator = 5332,
  GleanEvent = 5349,
  GleanImpl = 5360,
  GleanLabeled = 5370,
  GleanMemoryDistribution = 5383,
  GleanMetric = 5407,
  GleanNumerator = 5419,
  GleanObject = 5434,
  GleanPingsImpl = 5446,
  GleanQuantity = 5461,
  GleanRate = 5475,
  GleanString = 5485,
  GleanStringList = 5497,
  GleanText = 5513,
  GleanTimespan = 5523,
  GleanTimingDistribution = 5537,
  GleanUrl = 5561,
  GleanUuid = 5570,
  Grid = 5580,
  GridArea = 5585,
  GridDimension = 5594,
  GridLine = 5608,
  GridLines = 5617,
  GridTrack = 5627,
  GridTracks = 5637,
  HTMLAllCollection = 5648,
  HTMLAnchorElement = 5666,
  HTMLAreaElement = 5684,
  HTMLAudioElement = 5700,
  HTMLBRElement = 5717,
  HTMLBaseElement = 5731,
  HTMLBodyElement = 5747,
  HTMLButtonElement = 5763,
  HTMLCanvasElement = 5781,
  HTMLCollection = 5799,
  HTMLDListElement = 5814,
  HTMLDataElement = 5831,
  HTMLDataListElement = 5847,
  HTMLDetailsElement = 5867,
  HTMLDialogElement = 5886,
  HTMLDirectoryElement = 5904,
  HTMLDivElement = 5925,
  HTMLDocument = 5940,
  HTMLElement = 5953,
  HTMLEmbedElement = 5965,
  HTMLFieldSetElement = 5982,
  HTMLFontElement = 6002,
  HTMLFormControlsCollection = 6018,
  HTMLFormElement = 6045,
  HTMLFrameElement = 6061,
  HTMLFrameSetElement = 6078,
  HTMLHRElement = 6098,
  HTMLHeadElement = 6112,
  HTMLHeadingElement = 6128,
  HTMLHtmlElement = 6147,
  HTMLIFrameElement = 6163,
  HTMLImageElement = 6181,
  HTMLInputElement = 6198,
  HTMLLIElement = 6215,
  HTMLLabelElement = 6229,
  HTMLLegendElement = 6246,
  HTMLLinkElement = 6264,
  HTMLMapElement = 6280,
  HTMLMarqueeElement = 6295,
  HTMLMediaElement = 6314,
  HTMLMenuElement = 6331,
  HTMLMetaElement = 6347,
  HTMLMeterElement = 6363,
  HTMLModElement = 6380,
  HTMLOListElement = 6395,
  HTMLObjectElement = 6412,
  HTMLOptGroupElement = 6430,
  HTMLOptionElement = 6450,
  HTMLOptionsCollection = 6468,
  HTMLOutputElement = 6490,
  HTMLParagraphElement = 6508,
  HTMLParamElement = 6529,
  HTMLPictureElement = 6546,
  HTMLPreElement = 6565,
  HTMLProgressElement = 6580,
  HTMLQuoteElement = 6600,
  HTMLScriptElement = 6617,
  HTMLSelectElement = 6635,
  HTMLSlotElement = 6653,
  HTMLSourceElement = 6669,
  HTMLSpanElement = 6687,
  HTMLStyleElement = 6703,
  HTMLTableCaptionElement = 6720,
  HTMLTableCellElement = 6744,
  HTMLTableColElement = 6765,
  HTMLTableElement = 6785,
  HTMLTableRowElement = 6802,
  HTMLTableSectionElement = 6822,
  HTMLTemplateElement = 6846,
  HTMLTextAreaElement = 6866,
  HTMLTimeElement = 6886,
  HTMLTitleElement = 6902,
  HTMLTrackElement = 6919,
  HTMLUListElement = 6936,
  HTMLUnknownElement = 6953,
  HTMLVideoElement = 6972,
  HashChangeEvent = 6989,
  Headers = 7005,
  Headers_Iterator = 7013,
  HeapSnapshot = 7030,
  Highlight = 7043,
  HighlightRegistry = 7053,
  History = 7071,
  IDBCursor = 7079,
  IDBCursorWithValue = 7089,
  IDBDatabase = 7108,
  IDBFactory = 7120,
  IDBIndex = 7131,
  IDBKeyRange = 7140,
  IDBObjectStore = 7152,
  IDBOpenDBRequest = 7167,
  IDBRequest = 7184,
  IDBTransaction = 7195,
  IDBVersionChangeEvent = 7210,
  IIRFilterNode = 7232,
  IOUtils = 7246,
  IdentityCredential = 7254,
  IdleDeadline = 7273,
  Image = 7286,
  ImageBitmap = 7292,
  ImageBitmapRenderingContext = 7304,
  ImageCapture = 7332,
  ImageCaptureError = 7345,
  ImageCaptureErrorEvent = 7363,
  ImageData = 7386,
  ImageDecoder = 7396,
  ImageDocument = 7409,
  ImageTrack = 7423,
  ImageTrackList = 7434,
  InputEvent = 7449,
  InspectorCSSParser = 7460,
  InspectorFontFace = 7479,
  InspectorUtils = 7497,
  InstallTriggerImpl = 7512,
  IntersectionObserver = 7531,
  IntersectionObserverEntry = 7552,
  IntlUtils = 7578,
  InvokeEvent = 7588,
  JSProcessActorChild = 7600,
  JSProcessActorParent = 7620,
  JSWindowActorChild = 7641,
  JSWindowActorParent = 7660,
  KeyEvent = 7680,
  KeyboardEvent = 7689,
  KeyframeEffect = 7703,
  L10nFileSource = 7718,
  L10nOverlays = 7733,
  L10nRegistry = 7746,
  LargestContentfulPaint = 7759,
  LegacyMozTCPSocket = 7782,
  Localization = 7801,
  Location = 7814,
  Lock = 7823,
  LockManager = 7828,
  MIDIAccess = 7840,
  MIDIConnectionEvent = 7851,
  MIDIInput = 7871,
  MIDIInputMap = 7881,
  MIDIMessageEvent = 7894,
  MIDIOutput = 7911,
  MIDIOutputMap = 7922,
  MIDIPort = 7936,
  MOZ_debug = 7945,
  MatchGlob = 7955,
  MatchPattern = 7965,
  MatchPatternSet = 7978,
  MathMLElement = 7994,
  MediaCapabilities = 8008,
  MediaControlService = 8026,
  MediaController = 8046,
  MediaDeviceInfo = 8062,
  MediaDevices = 8078,
  MediaElementAudioSourceNode = 8091,
  MediaEncryptedEvent = 8119,
  MediaError = 8139,
  MediaKeyError = 8150,
  MediaKeyMessageEvent = 8164,
  MediaKeySession = 8185,
  MediaKeyStatusMap = 8201,
  MediaKeyStatusMap_Iterator = 8219,
  MediaKeySystemAccess = 8246,
  MediaKeys = 8267,
  MediaList = 8277,
  MediaMetadata = 8287,
  MediaQueryList = 8301,
  MediaQueryListEvent = 8316,
  MediaRecorder = 8336,
  MediaRecorderErrorEvent = 8350,
  MediaSession = 8374,
  MediaSource = 8387,
  MediaStream = 8399,
  MediaStreamAudioDestinationNode = 8411,
  MediaStreamAudioSourceNode = 8443,
  MediaStreamError = 8470,
  MediaStreamEvent = 8487,
  MediaStreamTrack = 8504,
  MediaStreamTrackAudioSourceNode = 8521,
  MediaStreamTrackEvent = 8553,
  MerchantValidationEvent = 8575,
  MessageBroadcaster = 8599,
  MessageChannel = 8618,
  MessageEvent = 8633,
  MessageListenerManager = 8646,
  MessagePort = 8669,
  MessageSender = 8681,
  MimeType = 8695,
  MimeTypeArray = 8704,
  MouseEvent = 8718,
  MouseScrollEvent = 8729,
  MozCanvasPrintState = 8746,
  MozDocumentMatcher = 8766,
  MozDocumentObserver = 8785,
  MozQueryInterface = 8805,
  MozSharedMap = 8823,
  MozSharedMap_Iterator = 8836,
  MozSharedMapChangeEvent = 8858,
  MozStorageAsyncStatementParams = 8882,
  MozStorageStatementParams = 8913,
  MozStorageStatementRow = 8939,
  MozWritableSharedMap = 8962,
  MutationEvent = 8983,
  MutationObserver = 8997,
  MutationRecord = 9014,
  NamedNodeMap = 9029,
  NavigateEvent = 9042,
  Navigation = 9056,
  NavigationActivation = 9067,
  NavigationCurrentEntryChangeEvent = 9088,
  NavigationDestination = 9122,
  NavigationHistoryEntry = 9144,
  NavigationPreloadManager = 9167,
  NavigationTransition = 9192,
  Navigator = 9213,
  NetworkInformation = 9223,
  Node = 9242,
  NodeFilter = 9247,
  NodeIterator = 9258,
  NodeList = 9271,
  Notification = 9280,
  NotificationEvent = 9293,
  NotifyPaintEvent = 9311,
  OES_draw_buffers_indexed = 9328,
  OES_element_index_uint = 9353,
  OES_fbo_render_mipmap = 9376,
  OES_standard_derivatives = 9398,
  OES_texture_float = 9423,
  OES_texture_float_linear = 9441,
  OES_texture_half_float = 9466,
  OES_texture_half_float_linear = 9489,
  OES_vertex_array_object = 9519,
  OVR_multiview2 = 9543,
  OfflineAudioCompletionEvent = 9558,
  OfflineAudioContext = 9586,
  OffscreenCanvas = 9606,
  OffscreenCanvasRenderingContext2D = 9622,
  OnlyForUseInConstructor = 9656,
  Option = 9680,
  OscillatorNode = 9687,
  PageTransitionEvent = 9702,
  PaintRequest = 9722,
  PaintRequestList = 9735,
  PaintWorkletGlobalScope = 9752,
  PannerNode = 9776,
  ParentProcessMessageManager = 9787,
  Path2D = 9815,
  PathUtils = 9822,
  PaymentAddress = 9832,
  PaymentMethodChangeEvent = 9847,
  PaymentRequest = 9872,
  PaymentRequestUpdateEvent = 9887,
  PaymentResponse = 9913,
  PeerConnectionImpl = 9929,
  PeerConnectionObserver = 9948,
  Performance = 9971,
  PerformanceEntry = 9983,
  PerformanceEntryEvent = 10000,
  PerformanceEventTiming = 10022,
  PerformanceMark = 10045,
  PerformanceMeasure = 10061,
  PerformanceNavigation = 10080,
  PerformanceNavigationTiming = 10102,
  PerformanceObserver = 10130,
  PerformanceObserverEntryList = 10150,
  PerformancePaintTiming = 10179,
  PerformanceResourceTiming = 10202,
  PerformanceServerTiming = 10228,
  PerformanceTiming = 10252,
  PeriodicWave = 10270,
  PermissionStatus = 10283,
  Permissions = 10300,
  PlacesBookmark = 10312,
  PlacesBookmarkAddition = 10327,
  PlacesBookmarkChanged = 10350,
  PlacesBookmarkGuid = 10372,
  PlacesBookmarkKeyword = 10391,
  PlacesBookmarkMoved = 10413,
  PlacesBookmarkRemoved = 10433,
  PlacesBookmarkTags = 10455,
  PlacesBookmarkTime = 10474,
  PlacesBookmarkTitle = 10493,
  PlacesBookmarkUrl = 10513,
  PlacesEvent = 10531,
  PlacesEventCounts = 10543,
  PlacesFavicon = 10561,
  PlacesHistoryCleared = 10575,
  PlacesObservers = 10596,
  PlacesPurgeCaches = 10612,
  PlacesRanking = 10630,
  PlacesVisit = 10644,
  PlacesVisitRemoved = 10656,
  PlacesVisitTitle = 10675,
  PlacesWeakCallbackWrapper = 10692,
  Plugin = 10718,
  PluginArray = 10725,
  PluginCrashedEvent = 10737,
  PointerEvent = 10756,
  PopStateEvent = 10769,
  PopupBlockedEvent = 10783,
  PopupPositionedEvent = 10801,
  PositionStateEvent = 10822,
  PrecompiledScript = 10841,
  PrivateAttribution = 10859,
  ProcessMessageManager = 10878,
  ProcessingInstruction = 10900,
  ProgressEvent = 10922,
  PromiseDebugging = 10936,
  PromiseNativeHandler = 10953,
  PromiseRejectionEvent = 10974,
  PublicKeyCredential = 10996,
  PushEvent = 11016,
  PushManager = 11026,
  PushManagerImpl = 11038,
  PushMessageData = 11054,
  PushSubscription = 11070,
  PushSubscriptionOptions = 11087,
  RTCCertificate = 11111,
  RTCDTMFSender = 11126,
  RTCDTMFToneChangeEvent = 11140,
  RTCDataChannel = 11163,
  RTCDataChannelEvent = 11178,
  RTCDtlsTransport = 11198,
  RTCEncodedAudioFrame = 11215,
  RTCEncodedVideoFrame = 11236,
  RTCIceCandidate = 11257,
  RTCIceTransport = 11273,
  RTCIdentityProviderRegistrar = 11289,
  RTCPeerConnection = 11318,
  RTCPeerConnectionIceEvent = 11336,
  RTCPeerConnectionStatic = 11362,
  RTCRtpReceiver = 11386,
  RTCRtpScriptTransform = 11401,
  RTCRtpScriptTransformer = 11423,
  RTCRtpSender = 11447,
  RTCRtpTransceiver = 11460,
  RTCSctpTransport = 11478,
  RTCSessionDescription = 11495,
  RTCStatsReport = 11517,
  RTCTrackEvent = 11532,
  RTCTransformEvent = 11546,
  RadioNodeList = 11564,
  Range = 11578,
  ReadableByteStreamController = 11584,
  ReadableStream = 11613,
  ReadableStream_AsyncIterator = 11628,
  ReadableStreamBYOBReader = 11657,
  ReadableStreamBYOBRequest = 11682,
  ReadableStreamDefaultController = 11708,
  ReadableStreamDefaultReader = 11740,
  Report = 11768,
  ReportBody = 11775,
  ReportingObserver = 11786,
  Request = 11804,
  ResizeObserver = 11812,
  ResizeObserverEntry = 11827,
  ResizeObserverSize = 11847,
  Response = 11866,
  SVGAElement = 11875,
  SVGAngle = 11887,
  SVGAnimateElement = 11896,
  SVGAnimateMotionElement = 11914,
  SVGAnimateTransformElement = 11938,
  SVGAnimatedAngle = 11965,
  SVGAnimatedBoolean = 11982,
  SVGAnimatedEnumeration = 12001,
  SVGAnimatedInteger = 12024,
  SVGAnimatedLength = 12043,
  SVGAnimatedLengthList = 12061,
  SVGAnimatedNumber = 12083,
  SVGAnimatedNumberList = 12101,
  SVGAnimatedPreserveAspectRatio = 12123,
  SVGAnimatedRect = 12154,
  SVGAnimatedString = 12170,
  SVGAnimatedTransformList = 12188,
  SVGAnimationElement = 12213,
  SVGCircleElement = 12233,
  SVGClipPathElement = 12250,
  SVGComponentTransferFunctionElement = 12269,
  SVGDefsElement = 12305,
  SVGDescElement = 12320,
  SVGElement = 12335,
  SVGEllipseElement = 12346,
  SVGFEBlendElement = 12364,
  SVGFEColorMatrixElement = 12382,
  SVGFEComponentTransferElement = 12406,
  SVGFECompositeElement = 12436,
  SVGFEConvolveMatrixElement = 12458,
  SVGFEDiffuseLightingElement = 12485,
  SVGFEDisplacementMapElement = 12513,
  SVGFEDistantLightElement = 12541,
  SVGFEDropShadowElement = 12566,
  SVGFEFloodElement = 12589,
  SVGFEFuncAElement = 12607,
  SVGFEFuncBElement = 12625,
  SVGFEFuncGElement = 12643,
  SVGFEFuncRElement = 12661,
  SVGFEGaussianBlurElement = 12679,
  SVGFEImageElement = 12704,
  SVGFEMergeElement = 12722,
  SVGFEMergeNodeElement = 12740,
  SVGFEMorphologyElement = 12762,
  SVGFEOffsetElement = 12785,
  SVGFEPointLightElement = 12804,
  SVGFESpecularLightingElement = 12827,
  SVGFESpotLightElement = 12856,
  SVGFETileElement = 12878,
  SVGFETurbulenceElement = 12895,
  SVGFilterElement = 12918,
  SVGForeignObjectElement = 12935,
  SVGGElement = 12959,
  SVGGeometryElement = 12971,
  SVGGradientElement = 12990,
  SVGGraphicsElement = 13009,
  SVGImageElement = 13028,
  SVGLength = 13044,
  SVGLengthList = 13054,
  SVGLineElement = 13068,
  SVGLinearGradientElement = 13083,
  SVGMPathElement = 13108,
  SVGMarkerElement = 13124,
  SVGMaskElement = 13141,
  SVGMatrix = 13156,
  SVGMetadataElement = 13166,
  SVGNumber = 13185,
  SVGNumberList = 13195,
  SVGPathElement = 13209,
  SVGPatternElement = 13224,
  SVGPoint = 13242,
  SVGPointList = 13251,
  SVGPolygonElement = 13264,
  SVGPolylineElement = 13282,
  SVGPreserveAspectRatio = 13301,
  SVGRadialGradientElement = 13324,
  SVGRect = 13349,
  SVGRectElement = 13357,
  SVGSVGElement = 13372,
  SVGScriptElement = 13386,
  SVGSetElement = 13403,
  SVGStopElement = 13417,
  SVGStringList = 13432,
  SVGStyleElement = 13446,
  SVGSwitchElement = 13462,
  SVGSymbolElement = 13479,
  SVGTSpanElement = 13496,
  SVGTextContentElement = 13512,
  SVGTextElement = 13534,
  SVGTextPathElement = 13549,
  SVGTextPositioningElement = 13568,
  SVGTitleElement = 13594,
  SVGTransform = 13610,
  SVGTransformList = 13623,
  SVGUnitTypes = 13640,
  SVGUseElement = 13653,
  SVGViewElement = 13667,
  Sanitizer = 13682,
  Scheduler = 13692,
  Screen = 13702,
  ScreenLuminance = 13709,
  ScreenOrientation = 13725,
  ScriptProcessorNode = 13743,
  ScrollAreaEvent = 13763,
  ScrollViewChangeEvent = 13779,
  SecurityPolicyViolationEvent = 13801,
  Selection = 13830,
  ServiceWorker = 13840,
  ServiceWorkerContainer = 13854,
  ServiceWorkerGlobalScope = 13877,
  ServiceWorkerRegistration = 13902,
  SessionStoreFormData = 13928,
  SessionStoreScrollData = 13949,
  SessionStoreUtils = 13972,
  ShadowRealmGlobalScope = 13990,
  ShadowRoot = 14013,
  SharedWorker = 14024,
  SharedWorkerGlobalScope = 14037,
  SimpleGestureEvent = 14061,
  SourceBuffer = 14080,
  SourceBufferList = 14093,
  SpeechGrammar = 14110,
  SpeechGrammarList = 14124,
  SpeechRecognition = 14142,
  SpeechRecognitionAlternative = 14160,
  SpeechRecognitionError = 14189,
  SpeechRecognitionEvent = 14212,
  SpeechRecognitionResult = 14235,
  SpeechRecognitionResultList = 14259,
  SpeechSynthesis = 14287,
  SpeechSynthesisErrorEvent = 14303,
  SpeechSynthesisEvent = 14329,
  SpeechSynthesisUtterance = 14350,
  SpeechSynthesisVoice = 14375,
  StaticRange = 14396,
  StereoPannerNode = 14408,
  Storage = 14425,
  StorageEvent = 14433,
  StorageManager = 14446,
  StreamFilter = 14461,
  StreamFilterDataEvent = 14474,
  StructuredCloneHolder = 14496,
  StructuredCloneTester = 14518,
  StyleSheet = 14540,
  StyleSheetApplicableStateChangeEvent = 14551,
  StyleSheetList = 14588,
  StyleSheetRemovedEvent = 14603,
  SubmitEvent = 14626,
  SubtleCrypto = 14638,
  SyncMessageSender = 14651,
  SyncReadFile = 14669,
  TCPServerSocket = 14682,
  TCPServerSocketEvent = 14698,
  TCPSocket = 14719,
  TCPSocketErrorEvent = 14729,
  TCPSocketEvent = 14749,
  TaskController = 14764,
  TaskPriorityChangeEvent = 14779,
  TaskSignal = 14803,
  TelemetryStopwatch = 14814,
  TestAttributesOnTypes = 14833,
  TestCEReactionsInterface = 14855,
  TestCImplementedInterface = 14880,
  TestCImplementedInterface2 = 14906,
  TestCallbackDictUnionOverload = 14933,
  TestChildInterface = 14963,
  TestConstructorForFuncInterface = 14982,
  TestConstructorForPrefInterface = 15014,
  TestConstructorForSCInterface = 15046,
  TestCppKeywordNamedMethodsInterface = 15076,
  TestDeprecatedInterface = 15112,
  TestExampleInterface = 15136,
  TestExampleProxyInterface = 15157,
  TestExampleThrowingConstructorInterface = 15183,
  TestExampleWorkerInterface = 15223,
  TestFuncConstructorForDifferentFuncInterface = 15250,
  TestFuncConstructorForInterface = 15295,
  TestHTMLConstructorInterface = 15327,
  TestIndexedAndNamedGetterAndSetterInterface = 15356,
  TestIndexedAndNamedGetterInterface = 15400,
  TestIndexedAndNamedSetterInterface = 15435,
  TestIndexedGetterAndSetterAndNamedGetterInterface = 15470,
  TestIndexedGetterInterface = 15520,
  TestIndexedSetterInterface = 15547,
  TestInterface = 15574,
  TestInterfaceWithPromiseConstructorArg = 15588,
  TestJSImplInterface = 15627,
  TestJSImplInterface2 = 15647,
  TestJSImplInterface3 = 15668,
  TestJSImplInterface4 = 15689,
  TestJSImplInterface5 = 15710,
  TestJSImplInterface6 = 15731,
  TestJSImplNoInterfaceObject = 15752,
  TestLegacyFactoryFunctionInterface = 15780,
  TestLegacyFactoryFunctionInterface2 = 15815,
  TestNamedDeleterInterface = 15851,
  TestNamedDeleterWithRetvalInterface = 15877,
  TestNamedGetterInterface = 15913,
  TestNamedSetterInterface = 15938,
  TestNamespace = 15963,
  TestNonWrapperCacheInterface = 15977,
  TestParentInterface = 16006,
  TestPrefChromeOnlySCFuncConstructorForInterface = 16026,
  TestPrefConstructorForDifferentPrefInterface = 16074,
  TestPrefConstructorForInterface = 16119,
  TestProtoObjectHackedNamespace = 16151,
  TestRenamedInterface = 16182,
  TestRenamedNamespace = 16203,
  TestSCConstructorForInterface = 16224,
  TestSecureContextInterface = 16254,
  TestThrowingConstructorInterface = 16281,
  TestUtils = 16314,
  TestWorkerExposedInterface = 16324,
  TestingDeprecatedInterface = 16351,
  Text = 16378,
  TextClause = 16383,
  TextDecoder = 16394,
  TextDecoderStream = 16406,
  TextEncoder = 16424,
  TextEncoderStream = 16436,
  TextEvent = 16454,
  TextMetrics = 16464,
  TextTrack = 16476,
  TextTrackCue = 16486,
  TextTrackCueList = 16499,
  TextTrackList = 16516,
  TimeEvent = 16530,
  TimeRanges = 16540,
  ToggleEvent = 16551,
  Touch = 16563,
  TouchEvent = 16569,
  TouchList = 16580,
  TrackEvent = 16590,
  TransformStream = 16601,
  TransformStreamDefaultController = 16617,
  TransitionEvent = 16650,
  TreeColumn = 16666,
  TreeColumns = 16677,
  TreeContentView = 16689,
  TreeWalker = 16705,
  TrustedHTML = 16716,
  TrustedScript = 16728,
  TrustedScriptURL = 16742,
  TrustedTypePolicy = 16759,
  TrustedTypePolicyFactory = 16777,
  UDPMessageEvent = 16802,
  UDPSocket = 16818,
  UIEvent = 16828,
  URL = 16836,
  URLSearchParams = 16840,
  URLSearchParams_Iterator = 16856,
  UniFFIPointer = 16881,
  UniFFIScaffolding = 16895,
  UserActivation = 16913,
  UserInteraction = 16928,
  UserProximityEvent = 16944,
  VRDisplay = 16963,
  VRDisplayCapabilities = 16973,
  VRDisplayEvent = 16995,
  VREyeParameters = 17010,
  VRFieldOfView = 17026,
  VRFrameData = 17040,
  VRMockController = 17052,
  VRMockDisplay = 17069,
  VRPose = 17083,
  VRServiceTest = 17090,
  VRStageParameters = 17104,
  VTTCue = 17122,
  VTTRegion = 17129,
  ValidityState = 17139,
  VideoColorSpace = 17153,
  VideoDecoder = 17169,
  VideoEncoder = 17182,
  VideoFrame = 17195,
  VideoPlaybackQuality = 17206,
  VideoTrack = 17227,
  VideoTrackList = 17238,
  ViewTransition = 17253,
  VisualViewport = 17268,
  WEBGL_color_buffer_float = 17283,
  WEBGL_compressed_texture_astc = 17308,
  WEBGL_compressed_texture_etc = 17338,
  WEBGL_compressed_texture_etc1 = 17367,
  WEBGL_compressed_texture_pvrtc = 17397,
  WEBGL_compressed_texture_s3tc = 17428,
  WEBGL_compressed_texture_s3tc_srgb = 17458,
  WEBGL_debug_renderer_info = 17493,
  WEBGL_debug_shaders = 17519,
  WEBGL_depth_texture = 17539,
  WEBGL_draw_buffers = 17559,
  WEBGL_explicit_present = 17578,
  WEBGL_lose_context = 17601,
  WEBGL_provoking_vertex = 17620,
  WGSLLanguageFeatures = 17643,
  WakeLock = 17664,
  WakeLockSentinel = 17673,
  WaveShaperNode = 17690,
  WebExtensionContentScript = 17705,
  WebExtensionPolicy = 17731,
  WebGL2RenderingContext = 17750,
  WebGLActiveInfo = 17773,
  WebGLBuffer = 17789,
  WebGLContextEvent = 17801,
  WebGLFramebuffer = 17819,
  WebGLProgram = 17836,
  WebGLQuery = 17849,
  WebGLRenderbuffer = 17860,
  WebGLRenderingContext = 17878,
  WebGLSampler = 17900,
  WebGLShader = 17913,
  WebGLShaderPrecisionFormat = 17925,
  WebGLSync = 17952,
  WebGLTexture = 17962,
  WebGLTransformFeedback = 17975,
  WebGLUniformLocation = 17998,
  WebGLVertexArrayObject = 18019,
  WebKitCSSMatrix = 18042,
  WebSocket = 18058,
  WebTransport = 18068,
  WebTransportBidirectionalStream = 18081,
  WebTransportDatagramDuplexStream = 18113,
  WebTransportError = 18146,
  WebTransportReceiveStream = 18164,
  WebTransportSendStream = 18190,
  WebrtcGlobalInformation = 18213,
  WheelEvent = 18237,
  Window = 18248,
  WindowClient = 18255,
  WindowContext = 18268,
  WindowGlobalChild = 18282,
  WindowGlobalParent = 18300,
  WindowRoot = 18319,
  Worker = 18330,
  WorkerDebuggerGlobalScope = 18337,
  WorkerGlobalScope = 18363,
  WorkerLocation = 18381,
  WorkerNavigator = 18396,
  WorkerTestUtils = 18412,
  Worklet = 18428,
  WorkletGlobalScope = 18436,
  WritableStream = 18455,
  WritableStreamDefaultController = 18470,
  WritableStreamDefaultWriter = 18502,
  XMLDocument = 18530,
  XMLHttpRequest = 18542,
  XMLHttpRequestEventTarget = 18557,
  XMLHttpRequestUpload = 18583,
  XMLSerializer = 18604,
  XPathEvaluator = 18618,
  XPathExpression = 18633,
  XPathResult = 18649,
  XRBoundedReferenceSpace = 18661,
  XRFrame = 18685,
  XRInputSource = 18693,
  XRInputSourceArray = 18707,
  XRInputSourceEvent = 18726,
  XRInputSourcesChangeEvent = 18745,
  XRPose = 18771,
  XRReferenceSpace = 18778,
  XRReferenceSpaceEvent = 18795,
  XRRenderState = 18817,
  XRRigidTransform = 18831,
  XRSession = 18848,
  XRSessionEvent = 18858,
  XRSpace = 18873,
  XRSystem = 18881,
  XRView = 18890,
  XRViewerPose = 18897,
  XRViewport = 18910,
  XRWebGLLayer = 18921,
  XSLTProcessor = 18934,
  XULCommandEvent = 18948,
  XULElement = 18964,
  XULFrameElement = 18975,
  XULMenuElement = 18991,
  XULPopupElement = 19006,
  XULResizerElement = 19022,
  XULTextElement = 19040,
  XULTreeElement = 19055,
  console = 19070,
  webkitSpeechGrammar = 19078,
  webkitSpeechGrammarList = 19098,
  webkitSpeechRecognition = 19122,
  webkitURL = 19146,
};

namespace binding_detail {
extern const char sBindingNames[];
}  // namespace binding_detail

MOZ_ALWAYS_INLINE const char* BindingName(BindingNamesOffset aOffset) {
  return binding_detail::sBindingNames + static_cast<size_t>(aOffset);
}

} // namespace mozilla::dom


#endif // DOM_BINDINGNAMES_H_
