// -*- mode: C++ -*-

/* This file is auto-generated by run_glean_parser.py.
   It is only for internal use by types in
   toolkit/components/glean/bindings/private */

#include "mozilla/AppShutdown.h"
#include "mozilla/ClearOnShutdown.h"
#include "mozilla/glean/bindings/GleanJSMetricsLookup.h"
#include "mozilla/glean/bindings/jog/JOG.h"
#include "mozilla/Maybe.h"
#include "mozilla/Telemetry.h"
#include "nsIThread.h"
#include "nsThreadUtils.h"

#ifndef mozilla_glean_ScalarGifftMap_h
#define mozilla_glean_ScalarGifftMap_h

#define DYNAMIC_METRIC_BIT (26)
#define GLEAN_METRIC_ID(id) ((id) & ((1ULL << 27) - 1))

namespace mozilla::glean {

using Telemetry::ScalarID;

static inline bool IsSubmetricId(uint32_t aId) {
  // Submetrics have the 2^25 bit set.
  // (ID_BITS - ID_SIGNAL_BITS, keep it in sync with js.py).
  return (aId & (1 << 25)) > 0;
}

static inline Maybe<ScalarID> ScalarIdForMetric(uint32_t aId) {
  switch(aId) {
    case 1: { // a11y.always_underline_links
      return Some(ScalarID::A11Y_ALWAYS_UNDERLINE_LINKS);
    }
    case 2: { // a11y.backplate
      return Some(ScalarID::A11Y_BACKPLATE);
    }
    case 3: { // a11y.hcm_background
      return Some(ScalarID::A11Y_HCM_BACKGROUND);
    }
    case 4: { // a11y.hcm_foreground
      return Some(ScalarID::A11Y_HCM_FOREGROUND);
    }
    case 5: { // a11y.instantiators
      return Some(ScalarID::A11Y_INSTANTIATORS);
    }
    case 6: { // a11y.invert_colors
      return Some(ScalarID::A11Y_INVERT_COLORS);
    }
    case 7: { // a11y.theme
      return Some(ScalarID::A11Y_THEME);
    }
    case 8: { // a11y.use_system_colors
      return Some(ScalarID::A11Y_USE_SYSTEM_COLORS);
    }
    case 29: { // browser.backup.browser_extension_data_size
      return Some(ScalarID::BROWSER_BACKUP_BROWSER_EXTENSION_DATA_SIZE);
    }
    case 31: { // browser.backup.cookies_size
      return Some(ScalarID::BROWSER_BACKUP_COOKIES_SIZE);
    }
    case 32: { // browser.backup.credentials_data_size
      return Some(ScalarID::BROWSER_BACKUP_CREDENTIALS_DATA_SIZE);
    }
    case 33: { // browser.backup.extension_store_permissions_data_size
      return Some(ScalarID::BROWSER_BACKUP_EXTENSION_STORE_PERMISSIONS_DATA_SIZE);
    }
    case 34: { // browser.backup.extensions_json_size
      return Some(ScalarID::BROWSER_BACKUP_EXTENSIONS_JSON_SIZE);
    }
    case 35: { // browser.backup.extensions_storage_size
      return Some(ScalarID::BROWSER_BACKUP_EXTENSIONS_STORAGE_SIZE);
    }
    case 36: { // browser.backup.extensions_xpi_directory_size
      return Some(ScalarID::BROWSER_BACKUP_EXTENSIONS_XPI_DIRECTORY_SIZE);
    }
    case 37: { // browser.backup.favicons_size
      return Some(ScalarID::BROWSER_BACKUP_FAVICONS_SIZE);
    }
    case 39: { // browser.backup.form_history_size
      return Some(ScalarID::BROWSER_BACKUP_FORM_HISTORY_SIZE);
    }
    case 40: { // browser.backup.misc_data_size
      return Some(ScalarID::BROWSER_BACKUP_MISC_DATA_SIZE);
    }
    case 41: { // browser.backup.places_size
      return Some(ScalarID::BROWSER_BACKUP_PLACES_SIZE);
    }
    case 43: { // browser.backup.preferences_size
      return Some(ScalarID::BROWSER_BACKUP_PREFERENCES_SIZE);
    }
    case 44: { // browser.backup.prof_d_disk_space
      return Some(ScalarID::BROWSER_BACKUP_PROF_D_DISK_SPACE);
    }
    case 45: { // browser.backup.security_data_size
      return Some(ScalarID::BROWSER_BACKUP_SECURITY_DATA_SIZE);
    }
    case 46: { // browser.backup.session_store_backups_directory_size
      return Some(ScalarID::BROWSER_BACKUP_SESSION_STORE_BACKUPS_DIRECTORY_SIZE);
    }
    case 47: { // browser.backup.session_store_size
      return Some(ScalarID::BROWSER_BACKUP_SESSION_STORE_SIZE);
    }
    case 48: { // browser.backup.storage_sync_size
      return Some(ScalarID::BROWSER_BACKUP_STORAGE_SYNC_SIZE);
    }
    case 61: { // networking.doh_heuristic_ever_tripped
      return Some(ScalarID::NETWORKING_DOH_HEURISTIC_EVER_TRIPPED);
    }
    case 62: { // networking.doh_heuristics_attempts
      return Some(ScalarID::NETWORKING_DOH_HEURISTICS_ATTEMPTS);
    }
    case 63: { // networking.doh_heuristics_pass_count
      return Some(ScalarID::NETWORKING_DOH_HEURISTICS_PASS_COUNT);
    }
    case 64: { // networking.doh_heuristics_result
      return Some(ScalarID::NETWORKING_DOH_HEURISTICS_RESULT);
    }
    case 150: { // networking.speculative_connect_outcome
      return Some(ScalarID::NETWORKING_SPECULATIVE_CONNECT_OUTCOME);
    }
    case 158: { // networking.data_transferred_v3_kb
      return Some(ScalarID::NETWORKING_DATA_TRANSFERRED_V3_KB);
    }
    case 159: { // networking.http3_enabled
      return Some(ScalarID::NETWORKING_HTTP3_ENABLED);
    }
    case 160: { // networking.https_rr_prefs_usage
      return Some(ScalarID::NETWORKING_HTTPS_RR_PREFS_USAGE);
    }
    case 161: { // networking.trr_connection_cycle_count
      return Some(ScalarID::NETWORKING_TRR_CONNECTION_CYCLE_COUNT);
    }
    case 162: { // networking.loading_certs_task
      return Some(ScalarID::NETWORKING_LOADING_CERTS_TASK);
    }
    case 163: { // networking.nss_initialization
      return Some(ScalarID::NETWORKING_NSS_INITIALIZATION);
    }
    case 166: { // downloads.panel_shown
      return Some(ScalarID::DOWNLOADS_PANEL_SHOWN);
    }
    case 168: { // downloads.file_opened
      return Some(ScalarID::DOWNLOADS_FILE_OPENED);
    }
    case 232: { // browser.startup.abouthome_cache_result
      return Some(ScalarID::BROWSER_STARTUP_ABOUTHOME_CACHE_RESULT);
    }
    case 233: { // browser.startup.abouthome_cache_shutdownwrite
      return Some(ScalarID::BROWSER_STARTUP_ABOUTHOME_CACHE_SHUTDOWNWRITE);
    }
    case 234: { // datasanitization.privacy_clear_on_shutdown_cache
      return Some(ScalarID::DATASANITIZATION_PRIVACY_CLEARONSHUTDOWN_CACHE);
    }
    case 235: { // datasanitization.privacy_clear_on_shutdown_cookies
      return Some(ScalarID::DATASANITIZATION_PRIVACY_CLEARONSHUTDOWN_COOKIES);
    }
    case 236: { // datasanitization.privacy_clear_on_shutdown_downloads
      return Some(ScalarID::DATASANITIZATION_PRIVACY_CLEARONSHUTDOWN_DOWNLOADS);
    }
    case 237: { // datasanitization.privacy_clear_on_shutdown_formdata
      return Some(ScalarID::DATASANITIZATION_PRIVACY_CLEARONSHUTDOWN_FORMDATA);
    }
    case 238: { // datasanitization.privacy_clear_on_shutdown_history
      return Some(ScalarID::DATASANITIZATION_PRIVACY_CLEARONSHUTDOWN_HISTORY);
    }
    case 239: { // datasanitization.privacy_clear_on_shutdown_offline_apps
      return Some(ScalarID::DATASANITIZATION_PRIVACY_CLEARONSHUTDOWN_OFFLINEAPPS);
    }
    case 240: { // datasanitization.privacy_clear_on_shutdown_open_windows
      return Some(ScalarID::DATASANITIZATION_PRIVACY_CLEARONSHUTDOWN_OPENWINDOWS);
    }
    case 241: { // datasanitization.privacy_clear_on_shutdown_sessions
      return Some(ScalarID::DATASANITIZATION_PRIVACY_CLEARONSHUTDOWN_SESSIONS);
    }
    case 242: { // datasanitization.privacy_clear_on_shutdown_site_settings
      return Some(ScalarID::DATASANITIZATION_PRIVACY_CLEARONSHUTDOWN_SITESETTINGS);
    }
    case 243: { // datasanitization.privacy_sanitize_sanitize_on_shutdown
      return Some(ScalarID::DATASANITIZATION_PRIVACY_SANITIZE_SANITIZEONSHUTDOWN);
    }
    case 244: { // datasanitization.session_permission_exceptions
      return Some(ScalarID::DATASANITIZATION_SESSION_PERMISSION_EXCEPTIONS);
    }
    case 246: { // os.environment.invoked_to_handle
      return Some(ScalarID::OS_ENVIRONMENT_INVOKED_TO_HANDLE);
    }
    case 247: { // os.environment.is_default_handler
      return Some(ScalarID::OS_ENVIRONMENT_IS_DEFAULT_HANDLER);
    }
    case 248: { // os.environment.is_kept_in_dock
      return Some(ScalarID::OS_ENVIRONMENT_IS_KEPT_IN_DOCK);
    }
    case 249: { // os.environment.is_taskbar_pinned
      return Some(ScalarID::OS_ENVIRONMENT_IS_TASKBAR_PINNED);
    }
    case 250: { // os.environment.is_taskbar_pinned_private
      return Some(ScalarID::OS_ENVIRONMENT_IS_TASKBAR_PINNED_PRIVATE);
    }
    case 251: { // os.environment.launch_method
      return Some(ScalarID::OS_ENVIRONMENT_LAUNCH_METHOD);
    }
    case 252: { // os.environment.launched_to_handle
      return Some(ScalarID::OS_ENVIRONMENT_LAUNCHED_TO_HANDLE);
    }
    case 253: { // os.environment.allowed_app_sources
      return Some(ScalarID::OS_ENVIRONMENT_ALLOWED_APP_SOURCES);
    }
    case 254: { // os.environment.is_admin_without_uac
      return Some(ScalarID::OS_ENVIRONMENT_IS_ADMIN_WITHOUT_UAC);
    }
    case 255: { // security.global_privacy_control_enabled
      return Some(ScalarID::SECURITY_GLOBAL_PRIVACY_CONTROL_ENABLED);
    }
    case 256: { // security.https_only_mode_enabled
      return Some(ScalarID::SECURITY_HTTPS_ONLY_MODE_ENABLED);
    }
    case 257: { // security.https_only_mode_enabled_pbm
      return Some(ScalarID::SECURITY_HTTPS_ONLY_MODE_ENABLED_PBM);
    }
    case 264: { // security.client_auth_cert_usage
      return Some(ScalarID::SECURITY_CLIENT_AUTH_CERT_USAGE);
    }
    case 267: { // startup.is_cold
      return Some(ScalarID::STARTUP_IS_COLD);
    }
    case 268: { // startup.seconds_since_last_os_restart
      return Some(ScalarID::STARTUP_SECONDS_SINCE_LAST_OS_RESTART);
    }
    case 269: { // startup.profile_count
      return Some(ScalarID::STARTUP_PROFILE_COUNT);
    }
    case 270: { // startup.profile_database_version
      return Some(ScalarID::STARTUP_PROFILE_DATABASE_VERSION);
    }
    case 271: { // startup.profile_selection_reason
      return Some(ScalarID::STARTUP_PROFILE_SELECTION_REASON);
    }
    case 285: { // migration.discovered_migrators
      return Some(ScalarID::MIGRATION_DISCOVERED_MIGRATORS);
    }
    case 286: { // migration.time_to_produce_migrator_list
      return Some(ScalarID::MIGRATION_TIME_TO_PRODUCE_MIGRATOR_LIST);
    }
    case 287: { // migration.uninstaller_profile_refresh
      return Some(ScalarID::MIGRATION_UNINSTALLER_PROFILE_REFRESH);
    }
    case 435: { // library.link
      return Some(ScalarID::LIBRARY_LINK);
    }
    case 436: { // library.opened
      return Some(ScalarID::LIBRARY_OPENED);
    }
    case 437: { // library.search
      return Some(ScalarID::LIBRARY_SEARCH);
    }
    case 512: { // browser.engagement.navigation.about_home
      return Some(ScalarID::BROWSER_ENGAGEMENT_NAVIGATION_ABOUT_HOME);
    }
    case 513: { // browser.engagement.navigation.about_newtab
      return Some(ScalarID::BROWSER_ENGAGEMENT_NAVIGATION_ABOUT_NEWTAB);
    }
    case 514: { // browser.engagement.navigation.contextmenu
      return Some(ScalarID::BROWSER_ENGAGEMENT_NAVIGATION_CONTEXTMENU);
    }
    case 515: { // browser.engagement.navigation.searchbar
      return Some(ScalarID::BROWSER_ENGAGEMENT_NAVIGATION_SEARCHBAR);
    }
    case 516: { // browser.engagement.navigation.urlbar
      return Some(ScalarID::BROWSER_ENGAGEMENT_NAVIGATION_URLBAR);
    }
    case 517: { // browser.engagement.navigation.urlbar_handoff
      return Some(ScalarID::BROWSER_ENGAGEMENT_NAVIGATION_URLBAR_HANDOFF);
    }
    case 518: { // browser.engagement.navigation.urlbar_persisted
      return Some(ScalarID::BROWSER_ENGAGEMENT_NAVIGATION_URLBAR_PERSISTED);
    }
    case 519: { // browser.engagement.navigation.urlbar_searchmode
      return Some(ScalarID::BROWSER_ENGAGEMENT_NAVIGATION_URLBAR_SEARCHMODE);
    }
    case 520: { // browser.engagement.navigation.webextension
      return Some(ScalarID::BROWSER_ENGAGEMENT_NAVIGATION_WEBEXTENSION);
    }
    case 521: { // browser.search.adclicks.about_home
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_ABOUT_HOME);
    }
    case 522: { // browser.search.adclicks.about_newtab
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_ABOUT_NEWTAB);
    }
    case 523: { // browser.search.adclicks.contextmenu
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_CONTEXTMENU);
    }
    case 524: { // browser.search.adclicks.reload
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_RELOAD);
    }
    case 525: { // browser.search.adclicks.searchbar
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_SEARCHBAR);
    }
    case 526: { // browser.search.adclicks.system
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_SYSTEM);
    }
    case 527: { // browser.search.adclicks.tabhistory
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_TABHISTORY);
    }
    case 528: { // browser.search.adclicks.unknown
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_UNKNOWN);
    }
    case 529: { // browser.search.adclicks.urlbar
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_URLBAR);
    }
    case 530: { // browser.search.adclicks.urlbar_handoff
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_URLBAR_HANDOFF);
    }
    case 531: { // browser.search.adclicks.urlbar_persisted
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_URLBAR_PERSISTED);
    }
    case 532: { // browser.search.adclicks.urlbar_searchmode
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_URLBAR_SEARCHMODE);
    }
    case 533: { // browser.search.adclicks.webextension
      return Some(ScalarID::BROWSER_SEARCH_ADCLICKS_WEBEXTENSION);
    }
    case 534: { // browser.search.content.about_home
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_ABOUT_HOME);
    }
    case 535: { // browser.search.content.about_newtab
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_ABOUT_NEWTAB);
    }
    case 536: { // browser.search.content.contextmenu
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_CONTEXTMENU);
    }
    case 537: { // browser.search.content.reload
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_RELOAD);
    }
    case 538: { // browser.search.content.searchbar
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_SEARCHBAR);
    }
    case 539: { // browser.search.content.system
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_SYSTEM);
    }
    case 540: { // browser.search.content.tabhistory
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_TABHISTORY);
    }
    case 541: { // browser.search.content.unknown
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_UNKNOWN);
    }
    case 542: { // browser.search.content.urlbar
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_URLBAR);
    }
    case 543: { // browser.search.content.urlbar_handoff
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_URLBAR_HANDOFF);
    }
    case 544: { // browser.search.content.urlbar_persisted
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_URLBAR_PERSISTED);
    }
    case 545: { // browser.search.content.urlbar_searchmode
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_URLBAR_SEARCHMODE);
    }
    case 546: { // browser.search.content.webextension
      return Some(ScalarID::BROWSER_SEARCH_CONTENT_WEBEXTENSION);
    }
    case 547: { // browser.search.withads.about_home
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_ABOUT_HOME);
    }
    case 548: { // browser.search.withads.about_newtab
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_ABOUT_NEWTAB);
    }
    case 549: { // browser.search.withads.contextmenu
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_CONTEXTMENU);
    }
    case 550: { // browser.search.withads.reload
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_RELOAD);
    }
    case 551: { // browser.search.withads.searchbar
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_SEARCHBAR);
    }
    case 552: { // browser.search.withads.system
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_SYSTEM);
    }
    case 553: { // browser.search.withads.tabhistory
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_TABHISTORY);
    }
    case 554: { // browser.search.withads.unknown
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_UNKNOWN);
    }
    case 555: { // browser.search.withads.urlbar
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_URLBAR);
    }
    case 556: { // browser.search.withads.urlbar_handoff
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_URLBAR_HANDOFF);
    }
    case 557: { // browser.search.withads.urlbar_persisted
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_URLBAR_PERSISTED);
    }
    case 558: { // browser.search.withads.urlbar_searchmode
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_URLBAR_SEARCHMODE);
    }
    case 559: { // browser.search.withads.webextension
      return Some(ScalarID::BROWSER_SEARCH_WITHADS_WEBEXTENSION);
    }
    case 573: { // urlbar.searchmode.bookmarkmenu
      return Some(ScalarID::URLBAR_SEARCHMODE_BOOKMARKMENU);
    }
    case 574: { // urlbar.searchmode.handoff
      return Some(ScalarID::URLBAR_SEARCHMODE_HANDOFF);
    }
    case 575: { // urlbar.searchmode.historymenu
      return Some(ScalarID::URLBAR_SEARCHMODE_HISTORYMENU);
    }
    case 576: { // urlbar.searchmode.keywordoffer
      return Some(ScalarID::URLBAR_SEARCHMODE_KEYWORDOFFER);
    }
    case 577: { // urlbar.searchmode.oneoff
      return Some(ScalarID::URLBAR_SEARCHMODE_ONEOFF);
    }
    case 578: { // urlbar.searchmode.other
      return Some(ScalarID::URLBAR_SEARCHMODE_OTHER);
    }
    case 579: { // urlbar.searchmode.searchbutton
      return Some(ScalarID::URLBAR_SEARCHMODE_SEARCHBUTTON);
    }
    case 580: { // urlbar.searchmode.shortcut
      return Some(ScalarID::URLBAR_SEARCHMODE_SHORTCUT);
    }
    case 581: { // urlbar.searchmode.tabmenu
      return Some(ScalarID::URLBAR_SEARCHMODE_TABMENU);
    }
    case 582: { // urlbar.searchmode.tabtosearch
      return Some(ScalarID::URLBAR_SEARCHMODE_TABTOSEARCH);
    }
    case 583: { // urlbar.searchmode.tabtosearch_onboard
      return Some(ScalarID::URLBAR_SEARCHMODE_TABTOSEARCH_ONBOARD);
    }
    case 584: { // urlbar.searchmode.topsites_newtab
      return Some(ScalarID::URLBAR_SEARCHMODE_TOPSITES_NEWTAB);
    }
    case 585: { // urlbar.searchmode.topsites_urlbar
      return Some(ScalarID::URLBAR_SEARCHMODE_TOPSITES_URLBAR);
    }
    case 586: { // urlbar.searchmode.touchbar
      return Some(ScalarID::URLBAR_SEARCHMODE_TOUCHBAR);
    }
    case 587: { // urlbar.searchmode.typed
      return Some(ScalarID::URLBAR_SEARCHMODE_TYPED);
    }
    case 594: { // shopping.product_page_visits
      return Some(ScalarID::SHOPPING_PRODUCT_PAGE_VISITS);
    }
    case 622: { // shopping.settings.auto_open_user_disabled
      return Some(ScalarID::SHOPPING_AUTO_OPEN_USER_DISABLED);
    }
    case 623: { // shopping.settings.component_opted_out
      return Some(ScalarID::SHOPPING_COMPONENT_OPTED_OUT);
    }
    case 624: { // shopping.settings.disabled_ads
      return Some(ScalarID::SHOPPING_DISABLED_ADS);
    }
    case 625: { // shopping.settings.has_onboarded
      return Some(ScalarID::SHOPPING_HAS_ONBOARDED);
    }
    case 626: { // shopping.settings.nimbus_disabled_shopping
      return Some(ScalarID::SHOPPING_NIMBUS_DISABLED);
    }
    case 636: { // sidebar.link
      return Some(ScalarID::SIDEBAR_LINK);
    }
    case 639: { // sidebar.search
      return Some(ScalarID::SIDEBAR_SEARCH);
    }
    case 659: { // browser.ui.interaction.all_tabs_panel_dragstart_tab_event_count
      return Some(ScalarID::BROWSER_UI_INTERACTION_ALL_TABS_PANEL_DRAGSTART_TAB_EVENT_COUNT);
    }
    case 660: { // browser.ui.interaction.all_tabs_panel_entrypoint
      return Some(ScalarID::BROWSER_UI_INTERACTION_ALL_TABS_PANEL_ENTRYPOINT);
    }
    case 661: { // browser.ui.interaction.textrecognition_error
      return Some(ScalarID::BROWSER_UI_INTERACTION_TEXTRECOGNITION_ERROR);
    }
    case 662: { // browser.ui.interaction.app_menu
      return Some(ScalarID::BROWSER_UI_INTERACTION_APP_MENU);
    }
    case 663: { // browser.ui.interaction.bookmarks_bar
      return Some(ScalarID::BROWSER_UI_INTERACTION_BOOKMARKS_BAR);
    }
    case 664: { // browser.ui.interaction.content_context
      return Some(ScalarID::BROWSER_UI_INTERACTION_CONTENT_CONTEXT);
    }
    case 665: { // browser.ui.interaction.menu_bar
      return Some(ScalarID::BROWSER_UI_INTERACTION_MENU_BAR);
    }
    case 666: { // browser.ui.interaction.nav_bar
      return Some(ScalarID::BROWSER_UI_INTERACTION_NAV_BAR);
    }
    case 667: { // browser.ui.interaction.overflow_menu
      return Some(ScalarID::BROWSER_UI_INTERACTION_OVERFLOW_MENU);
    }
    case 668: { // browser.ui.interaction.pageaction_panel
      return Some(ScalarID::BROWSER_UI_INTERACTION_PAGEACTION_PANEL);
    }
    case 669: { // browser.ui.interaction.pageaction_urlbar
      return Some(ScalarID::BROWSER_UI_INTERACTION_PAGEACTION_URLBAR);
    }
    case 670: { // browser.ui.interaction.pinned_overflow_menu
      return Some(ScalarID::BROWSER_UI_INTERACTION_PINNED_OVERFLOW_MENU);
    }
    case 671: { // browser.ui.interaction.preferences_pane_containers
      return Some(ScalarID::BROWSER_UI_INTERACTION_PREFERENCES_PANECONTAINERS);
    }
    case 672: { // browser.ui.interaction.preferences_pane_experimental
      return Some(ScalarID::BROWSER_UI_INTERACTION_PREFERENCES_PANEEXPERIMENTAL);
    }
    case 673: { // browser.ui.interaction.preferences_pane_general
      return Some(ScalarID::BROWSER_UI_INTERACTION_PREFERENCES_PANEGENERAL);
    }
    case 674: { // browser.ui.interaction.preferences_pane_home
      return Some(ScalarID::BROWSER_UI_INTERACTION_PREFERENCES_PANEHOME);
    }
    case 675: { // browser.ui.interaction.preferences_pane_more_from_mozilla
      return Some(ScalarID::BROWSER_UI_INTERACTION_PREFERENCES_PANEMOREFROMMOZILLA);
    }
    case 676: { // browser.ui.interaction.preferences_pane_privacy
      return Some(ScalarID::BROWSER_UI_INTERACTION_PREFERENCES_PANEPRIVACY);
    }
    case 677: { // browser.ui.interaction.preferences_pane_search
      return Some(ScalarID::BROWSER_UI_INTERACTION_PREFERENCES_PANESEARCH);
    }
    case 678: { // browser.ui.interaction.preferences_pane_search_results
      return Some(ScalarID::BROWSER_UI_INTERACTION_PREFERENCES_PANESEARCHRESULTS);
    }
    case 679: { // browser.ui.interaction.preferences_pane_sync
      return Some(ScalarID::BROWSER_UI_INTERACTION_PREFERENCES_PANESYNC);
    }
    case 680: { // browser.ui.interaction.preferences_pane_unknown
      return Some(ScalarID::BROWSER_UI_INTERACTION_PREFERENCES_PANEUNKNOWN);
    }
    case 681: { // browser.ui.interaction.tabs_bar
      return Some(ScalarID::BROWSER_UI_INTERACTION_TABS_BAR);
    }
    case 682: { // browser.ui.interaction.tabs_context
      return Some(ScalarID::BROWSER_UI_INTERACTION_TABS_CONTEXT);
    }
    case 683: { // browser.ui.interaction.tabs_context_entrypoint
      return Some(ScalarID::BROWSER_UI_INTERACTION_TABS_CONTEXT_ENTRYPOINT);
    }
    case 684: { // browser.ui.interaction.unified_extensions_area
      return Some(ScalarID::BROWSER_UI_INTERACTION_UNIFIED_EXTENSIONS_AREA);
    }
    case 685: { // browser.ui.interaction.vertical_tabs_container
      return Some(ScalarID::BROWSER_UI_INTERACTION_VERTICAL_TABS_CONTAINER);
    }
    case 686: { // browser.ui.interaction.keyboard
      return Some(ScalarID::BROWSER_UI_INTERACTION_KEYBOARD);
    }
    case 720: { // browser.engagement.active_ticks
      return Some(ScalarID::BROWSER_ENGAGEMENT_ACTIVE_TICKS);
    }
    case 721: { // browser.engagement.profile_count
      return Some(ScalarID::BROWSER_ENGAGEMENT_PROFILE_COUNT);
    }
    case 722: { // browser.engagement.uri_count
      return Some(ScalarID::BROWSER_ENGAGEMENT_TOTAL_URI_COUNT_NORMAL_AND_PRIVATE_MODE);
    }
    case 723: { // browser.engagement.uri_count_normal_mode
      return Some(ScalarID::BROWSER_ENGAGEMENT_TOTAL_URI_COUNT);
    }
    case 724: { // browser.ui.customized_widgets
      return Some(ScalarID::BROWSER_UI_CUSTOMIZED_WIDGETS);
    }
    case 725: { // browser.ui.mirror_for_toolbar_widgets
      return Some(ScalarID::BROWSER_UI_TOOLBAR_WIDGETS);
    }
    case 732: { // installation.first_seen.admin_user
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_ADMIN_USER);
    }
    case 733: { // installation.first_seen.default_path
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_DEFAULT_PATH);
    }
    case 734: { // installation.first_seen.failure_reason
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_FAILURE_REASON);
    }
    case 735: { // installation.first_seen.from_msi
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_FROM_MSI);
    }
    case 736: { // installation.first_seen.install_existed
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_INSTALL_EXISTED);
    }
    case 737: { // installation.first_seen.installer_type
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_INSTALLER_TYPE);
    }
    case 738: { // installation.first_seen.other_inst
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_OTHER_INST);
    }
    case 739: { // installation.first_seen.other_msix_inst
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_OTHER_MSIX_INST);
    }
    case 740: { // installation.first_seen.profdir_existed
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_PROFDIR_EXISTED);
    }
    case 741: { // installation.first_seen.silent
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_SILENT);
    }
    case 742: { // installation.first_seen.version
      return Some(ScalarID::INSTALLATION_FIRSTSEEN_VERSION);
    }
    case 3190: { // media.decode_error_per_mime_type
      return Some(ScalarID::MEDIA_DECODE_ERROR_PER_MIME_TYPE);
    }
    case 3191: { // media.element_in_page_count
      return Some(ScalarID::MEDIA_ELEMENT_IN_PAGE_COUNT);
    }
    case 3192: { // media.video_hardware_decoding_support
      return Some(ScalarID::MEDIA_VIDEO_HARDWARE_DECODING_SUPPORT);
    }
    case 3193: { // media.video_hd_hardware_decoding_support
      return Some(ScalarID::MEDIA_VIDEO_HD_HARDWARE_DECODING_SUPPORT);
    }
    case 3196: { // media.playback.device_hardware_decoder_support
      return Some(ScalarID::MEDIA_DEVICE_HARDWARE_DECODING_SUPPORT);
    }
    case 3218: { // webrtc.video.recv_codec_used
      return Some(ScalarID::WEBRTC_VIDEO_RECV_CODEC_USED);
    }
    case 3219: { // webrtc.video.send_codec_used
      return Some(ScalarID::WEBRTC_VIDEO_SEND_CODEC_USED);
    }
    case 3227: { // dom.contentprocess.build_id_mismatch
      return Some(ScalarID::DOM_CONTENTPROCESS_BUILDID_MISMATCH);
    }
    case 3228: { // dom.contentprocess.build_id_mismatch_false_positive
      return Some(ScalarID::DOM_CONTENTPROCESS_BUILDID_MISMATCH_FALSE_POSITIVE);
    }
    case 3229: { // dom.contentprocess.os_priority_change_considered
      return Some(ScalarID::DOM_CONTENTPROCESS_OS_PRIORITY_CHANGE_CONSIDERED);
    }
    case 3230: { // dom.contentprocess.os_priority_lowered
      return Some(ScalarID::DOM_CONTENTPROCESS_OS_PRIORITY_LOWERED);
    }
    case 3231: { // dom.contentprocess.os_priority_raised
      return Some(ScalarID::DOM_CONTENTPROCESS_OS_PRIORITY_RAISED);
    }
    case 3232: { // dom.parentprocess.private_window_used
      return Some(ScalarID::DOM_PARENTPROCESS_PRIVATE_WINDOW_USED);
    }
    case 3233: { // dom.parentprocess.process_launch_errors
      return Some(ScalarID::DOM_PARENTPROCESS_PROCESS_LAUNCH_ERRORS);
    }
    case 3241: { // mathml.doc_count
      return Some(ScalarID::MATHML_DOC_COUNT);
    }
    case 3284: { // gfx.linux_window_protocol
      return Some(ScalarID::GFX_LINUX_WINDOW_PROTOCOL);
    }
    case 3285: { // gfx.os_compositor
      return Some(ScalarID::GFX_OS_COMPOSITOR);
    }
    case 3287: { // gfx.skipped_composites
      return Some(ScalarID::GFX_SKIPPED_COMPOSITES);
    }
    case 3288: { // gfx.supports_hdr
      return Some(ScalarID::GFX_SUPPORTS_HDR);
    }
    case 3289: { // gfx.tmp_writable
      return Some(ScalarID::GFX_TMP_WRITABLE);
    }
    case 3315: { // gfx.hdr.windows_display_colorspace_bitfield
      return Some(ScalarID::GFX_HDR_WINDOWS_DISPLAY_COLORSPACE_BITFIELD);
    }
    case 3387: { // preferences.prefs_file_was_invalid
      return Some(ScalarID::PREFERENCES_PREFS_FILE_WAS_INVALID);
    }
    case 3438: { // opaque.response.blocking.cross_origin_opaque_response_count
      return Some(ScalarID::OPAQUE_RESPONSE_BLOCKING_CROSS_ORIGIN_OPAQUE_RESPONSE_COUNT);
    }
    case 3439: { // opaque.response.blocking.javascript_validation_count
      return Some(ScalarID::OPAQUE_RESPONSE_BLOCKING_JAVASCRIPT_VALIDATION_COUNT);
    }
    case 3518: { // contentblocking.category
      return Some(ScalarID::CONTENTBLOCKING_CATEGORY);
    }
    case 3519: { // contentblocking.cryptomining_blocking_enabled
      return Some(ScalarID::CONTENTBLOCKING_CRYPTOMINING_BLOCKING_ENABLED);
    }
    case 3520: { // contentblocking.fingerprinting_blocking_enabled
      return Some(ScalarID::CONTENTBLOCKING_FINGERPRINTING_BLOCKING_ENABLED);
    }
    case 3521: { // contentblocking.trackers_blocked_count
      return Some(ScalarID::CONTENTBLOCKING_TRACKERS_BLOCKED_COUNT);
    }
    case 3553: { // cookie.banners.normal_window_service_mode
      return Some(ScalarID::COOKIE_BANNERS_NORMAL_WINDOW_SERVICE_MODE);
    }
    case 3554: { // cookie.banners.private_window_service_mode
      return Some(ScalarID::COOKIE_BANNERS_PRIVATE_WINDOW_SERVICE_MODE);
    }
    case 3558: { // cookie.banners.service_detect_only
      return Some(ScalarID::COOKIE_BANNERS_SERVICE_DETECT_ONLY);
    }
    case 3615: { // policies.count
      return Some(ScalarID::POLICIES_COUNT);
    }
    case 3616: { // policies.is_enterprise
      return Some(ScalarID::POLICIES_IS_ENTERPRISE);
    }
    case 3618: { // extensions.startup_cache_load_time
      return Some(ScalarID::EXTENSIONS_STARTUPCACHE_LOAD_TIME);
    }
    case 3619: { // extensions.startup_cache_read_errors
      return Some(ScalarID::EXTENSIONS_STARTUPCACHE_READ_ERRORS);
    }
    case 3620: { // extensions.startup_cache_write_bytelength
      return Some(ScalarID::EXTENSIONS_STARTUPCACHE_WRITE_BYTELENGTH);
    }
    case 3623: { // extensions.apis.dnr.evaluate_rules_count_max
      return Some(ScalarID::EXTENSIONS_APIS_DNR_EVALUATE_RULES_COUNT_MAX);
    }
    case 3625: { // extensions.apis.dnr.startup_cache_entries
      return Some(ScalarID::EXTENSIONS_APIS_DNR_STARTUP_CACHE_ENTRIES);
    }
    case 3702: { // formautofill.creditcards.autofill_profiles_count
      return Some(ScalarID::FORMAUTOFILL_CREDITCARDS_AUTOFILL_PROFILES_COUNT);
    }
    case 3735: { // test_only.meaning_of_life
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_QUANTITY);
    }
    case 3736: { // test_only.mirror_time
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_TIMESPAN);
    }
    case 3737: { // test_only.mirror_time_nanos
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_TIMESPAN_NANOS);
    }
    case 3738: { // test_only.mirrors_for_labeled_bools
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_LABELED_BOOL);
    }
    case 3745: { // test_only.ipc.a_bool
      return Some(ScalarID::TELEMETRY_TEST_BOOLEAN_KIND);
    }
    case 3746: { // test_only.ipc.a_counter
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_COUNTER);
    }
    case 3748: { // test_only.ipc.a_date
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_DATE);
    }
    case 3749: { // test_only.ipc.a_labeled_counter
      return Some(ScalarID::TELEMETRY_TEST_ANOTHER_MIRROR_FOR_LABELED_COUNTER);
    }
    case 3752: { // test_only.ipc.a_string
      return Some(ScalarID::TELEMETRY_TEST_MULTIPLE_STORES_STRING);
    }
    case 3753: { // test_only.ipc.a_string_list
      return Some(ScalarID::TELEMETRY_TEST_KEYED_BOOLEAN_KIND);
    }
    case 3756: { // test_only.ipc.a_url
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_URL);
    }
    case 3757: { // test_only.ipc.a_uuid
      return Some(ScalarID::TELEMETRY_TEST_STRING_KIND);
    }
    case 3760: { // test_only.ipc.an_unordered_bool
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_UNORDERED_BOOL);
    }
    case 3761: { // test_only.ipc.an_unordered_labeled_boolean
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_UNORDERED_LABELED_BOOL);
    }
    case 3762: { // test_only.ipc.another_labeled_counter
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_LABELED_COUNTER);
    }
    case 3764: { // test_only.ipc.irate
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_RATE);
    }
    case 3858: { // pwmgr.potentially_breached_passwords
      return Some(ScalarID::PWMGR_POTENTIALLY_BREACHED_PASSWORDS);
    }
    case 3940: { // pictureinpicture.most_concurrent_players
      return Some(ScalarID::PICTUREINPICTURE_MOST_CONCURRENT_PLAYERS);
    }
    case 3949: { // pictureinpicture.toggle_enabled
      return Some(ScalarID::PICTUREINPICTURE_TOGGLE_ENABLED);
    }
    case 3956: { // places.pages_need_frecency_recalculation
      return Some(ScalarID::PLACES_PAGES_NEED_FRECENCY_RECALCULATION);
    }
    case 3958: { // places.previousday_visits
      return Some(ScalarID::PLACES_PREVIOUSDAY_VISITS);
    }
    case 3959: { // places.sponsored_visit_no_triggering_url
      return Some(ScalarID::PLACES_SPONSORED_VISIT_NO_TRIGGERING_URL);
    }
    case 3960: { // printing.dialog_opened_via_preview_tm
      return Some(ScalarID::PRINTING_DIALOG_OPENED_VIA_PREVIEW_TM);
    }
    case 3961: { // printing.dialog_via_preview_cancelled_tm
      return Some(ScalarID::PRINTING_DIALOG_VIA_PREVIEW_CANCELLED_TM);
    }
    case 3962: { // printing.error
      return Some(ScalarID::PRINTING_ERROR);
    }
    case 3963: { // printing.preview_cancelled_tm
      return Some(ScalarID::PRINTING_PREVIEW_CANCELLED_TM);
    }
    case 3964: { // printing.preview_opened_tm
      return Some(ScalarID::PRINTING_PREVIEW_OPENED_TM);
    }
    case 3965: { // printing.settings_changed
      return Some(ScalarID::PRINTING_SETTINGS_CHANGED);
    }
    case 3966: { // printing.silent_print
      return Some(ScalarID::PRINTING_SILENT_PRINT);
    }
    case 3967: { // printing.target_type
      return Some(ScalarID::PRINTING_TARGET_TYPE);
    }
    case 3968: { // power.cpu_time_bogus_values
      return Some(ScalarID::POWER_CPU_TIME_BOGUS_VALUES);
    }
    case 3969: { // power.cpu_time_per_process_type_ms
      return Some(ScalarID::POWER_CPU_TIME_PER_PROCESS_TYPE_MS);
    }
    case 3972: { // power.gpu_time_bogus_values
      return Some(ScalarID::POWER_GPU_TIME_BOGUS_VALUES);
    }
    case 3973: { // power.gpu_time_per_process_type_ms
      return Some(ScalarID::POWER_GPU_TIME_PER_PROCESS_TYPE_MS);
    }
    case 3974: { // power.total_cpu_time_ms
      return Some(ScalarID::POWER_TOTAL_CPU_TIME_MS);
    }
    case 3975: { // power.total_gpu_time_ms
      return Some(ScalarID::POWER_TOTAL_GPU_TIME_MS);
    }
    case 3976: { // power.total_thread_wakeups
      return Some(ScalarID::POWER_TOTAL_THREAD_WAKEUPS);
    }
    case 3977: { // power.wakeups_per_process_type
      return Some(ScalarID::POWER_WAKEUPS_PER_PROCESS_TYPE);
    }
    case 4252: { // telemetry.data_upload_optin
      return Some(ScalarID::TELEMETRY_DATA_UPLOAD_OPTIN);
    }
    case 4300: { // findbar.find_next
      return Some(ScalarID::FINDBAR_FIND_NEXT);
    }
    case 4301: { // findbar.find_prev
      return Some(ScalarID::FINDBAR_FIND_PREV);
    }
    case 4302: { // findbar.highlight_all
      return Some(ScalarID::FINDBAR_HIGHLIGHT_ALL);
    }
    case 4303: { // findbar.match_case
      return Some(ScalarID::FINDBAR_MATCH_CASE);
    }
    case 4304: { // findbar.match_diacritics
      return Some(ScalarID::FINDBAR_MATCH_DIACRITICS);
    }
    case 4305: { // findbar.shown
      return Some(ScalarID::FINDBAR_SHOWN);
    }
    case 4306: { // findbar.whole_words
      return Some(ScalarID::FINDBAR_WHOLE_WORDS);
    }
    case 4406: { // blocklist.mlbf_softblocks_source
      return Some(ScalarID::BLOCKLIST_MLBF_SOFTBLOCKS_SOURCE);
    }
    case 4407: { // blocklist.mlbf_source
      return Some(ScalarID::BLOCKLIST_MLBF_SOURCE);
    }
    case 4412: { // update.bitshresult
      return Some(ScalarID::UPDATE_BITSHRESULT);
    }
    case 4419: { // update.move_result
      return Some(ScalarID::UPDATE_MOVE_RESULT);
    }
    case 4420: { // update.no_window_auto_restarts
      return Some(ScalarID::UPDATE_NO_WINDOW_AUTO_RESTARTS);
    }
    case 4422: { // update.suppress_prompts
      return Some(ScalarID::UPDATE_SUPPRESS_PROMPTS);
    }
    case 4423: { // update.version_pin
      return Some(ScalarID::UPDATE_VERSION_PIN);
    }
    case 4426: { // widget.ime_name_on_mac
      return Some(ScalarID::WIDGET_IME_NAME_ON_MAC);
    }
    case 4427: { // widget.gtk_version
      return Some(ScalarID::WIDGET_GTK_VERSION);
    }
    case 4428: { // widget.ime_name_on_linux
      return Some(ScalarID::WIDGET_IME_NAME_ON_LINUX);
    }
    case 4429: { // widget.dark_mode
      return Some(ScalarID::WIDGET_DARK_MODE);
    }
    case 4430: { // widget.ime_name_on_windows
      return Some(ScalarID::WIDGET_IME_NAME_ON_WINDOWS);
    }
    case 4431: { // widget.ime_name_on_windows_inserted_crlf
      return Some(ScalarID::WIDGET_IME_NAME_ON_WINDOWS_INSERTED_CRLF);
    }
    default: {
      if (MOZ_UNLIKELY(aId & (1 << DYNAMIC_METRIC_BIT))) {
        // Dynamic (runtime-registered) metric. Use its static (compiletime-
        // registered) metric's telemetry_mirror mapping.
        // ...if applicable.

        // Only JS can use dynamic (runtime-registered) metric ids.
        MOZ_ASSERT(NS_IsMainThread());

        auto metricName = JOG::GetMetricName(aId);
        // All of these should have names, but the storage only lasts until
        // XPCOMWillShutdown, so it might return `Nothing()`.
        if (metricName.isSome()) {
          auto maybeMetric = MetricByNameLookup(metricName.ref());
          if (maybeMetric.isSome()) {
            uint32_t staticId = GLEAN_METRIC_ID(maybeMetric.value());
            // Let's ensure we don't infinite loop, huh.
            MOZ_ASSERT(!(staticId & (1 << DYNAMIC_METRIC_BIT)));
            return ScalarIdForMetric(staticId);
          }
        }
      }
      return Nothing();
    }
  }
}

}  // namespace mozilla::glean

#undef GLEAN_METRIC_ID
#undef DYNAMIC_METRIC_BIT

#endif  // mozilla_glean_ScalarGifftMaps_h
