#include "mozilla/EnumTypeTraits.h"
#include "mozilla/dom/BindingNames.h"

namespace mozilla::dom {

namespace binding_detail {

const char sBindingNames[] = {
  /*     0 */ "ANGLE_instanced_arrays" "\0"
  /*    23 */ "APZHitResultFlags" "\0"
  /*    41 */ "AbortController" "\0"
  /*    57 */ "AbortSignal" "\0"
  /*    69 */ "AbstractRange" "\0"
  /*    83 */ "AccessibleNode" "\0"
  /*    98 */ "Addon" "\0"
  /*   104 */ "AddonEvent" "\0"
  /*   115 */ "AddonInstall" "\0"
  /*   128 */ "AddonManager" "\0"
  /*   141 */ "AddonManagerPermissions" "\0"
  /*   165 */ "AnalyserNode" "\0"
  /*   178 */ "Animation" "\0"
  /*   188 */ "AnimationEffect" "\0"
  /*   204 */ "AnimationEvent" "\0"
  /*   219 */ "AnimationPlaybackEvent" "\0"
  /*   242 */ "AnimationTimeline" "\0"
  /*   260 */ "AnonymousContent" "\0"
  /*   277 */ "Attr" "\0"
  /*   282 */ "Audio" "\0"
  /*   288 */ "AudioBuffer" "\0"
  /*   300 */ "AudioBufferSourceNode" "\0"
  /*   322 */ "AudioContext" "\0"
  /*   335 */ "AudioData" "\0"
  /*   345 */ "AudioDecoder" "\0"
  /*   358 */ "AudioDestinationNode" "\0"
  /*   379 */ "AudioEncoder" "\0"
  /*   392 */ "AudioListener" "\0"
  /*   406 */ "AudioNode" "\0"
  /*   416 */ "AudioParam" "\0"
  /*   427 */ "AudioParamMap" "\0"
  /*   441 */ "AudioProcessingEvent" "\0"
  /*   462 */ "AudioScheduledSourceNode" "\0"
  /*   487 */ "AudioTrack" "\0"
  /*   498 */ "AudioTrackList" "\0"
  /*   513 */ "AudioWorklet" "\0"
  /*   526 */ "AudioWorkletGlobalScope" "\0"
  /*   550 */ "AudioWorkletNode" "\0"
  /*   567 */ "AudioWorkletProcessor" "\0"
  /*   589 */ "AuthenticatorAssertionResponse" "\0"
  /*   620 */ "AuthenticatorAttestationResponse" "\0"
  /*   653 */ "AuthenticatorResponse" "\0"
  /*   675 */ "BarProp" "\0"
  /*   683 */ "BaseAudioContext" "\0"
  /*   700 */ "BatteryManager" "\0"
  /*   715 */ "BeforeUnloadEvent" "\0"
  /*   733 */ "BiquadFilterNode" "\0"
  /*   750 */ "Blob" "\0"
  /*   755 */ "BlobEvent" "\0"
  /*   765 */ "BroadcastChannel" "\0"
  /*   782 */ "BrowsingContext" "\0"
  /*   798 */ "BrowsingContextGroup" "\0"
  /*   819 */ "ByteLengthQueuingStrategy" "\0"
  /*   845 */ "CDATASection" "\0"
  /*   858 */ "CSPViolationReportBody" "\0"
  /*   881 */ "CSS" "\0"
  /*   885 */ "CSS2Properties" "\0"
  /*   900 */ "CSSAnimation" "\0"
  /*   913 */ "CSSConditionRule" "\0"
  /*   930 */ "CSSContainerRule" "\0"
  /*   947 */ "CSSCounterStyleRule" "\0"
  /*   967 */ "CSSCustomPropertyRegisteredEvent" "\0"
  /*  1000 */ "CSSFontFaceRule" "\0"
  /*  1016 */ "CSSFontFeatureValuesRule" "\0"
  /*  1041 */ "CSSFontPaletteValuesRule" "\0"
  /*  1066 */ "CSSGroupingRule" "\0"
  /*  1082 */ "CSSImportRule" "\0"
  /*  1096 */ "CSSKeyframeRule" "\0"
  /*  1112 */ "CSSKeyframesRule" "\0"
  /*  1129 */ "CSSLayerBlockRule" "\0"
  /*  1147 */ "CSSLayerStatementRule" "\0"
  /*  1169 */ "CSSMarginRule" "\0"
  /*  1183 */ "CSSMediaRule" "\0"
  /*  1196 */ "CSSMozDocumentRule" "\0"
  /*  1215 */ "CSSNamespaceRule" "\0"
  /*  1232 */ "CSSNestedDeclarations" "\0"
  /*  1254 */ "CSSPageDescriptors" "\0"
  /*  1273 */ "CSSPageRule" "\0"
  /*  1285 */ "CSSPositionTryDescriptors" "\0"
  /*  1311 */ "CSSPositionTryRule" "\0"
  /*  1330 */ "CSSPropertyRule" "\0"
  /*  1346 */ "CSSPseudoElement" "\0"
  /*  1363 */ "CSSRule" "\0"
  /*  1371 */ "CSSRuleList" "\0"
  /*  1383 */ "CSSScopeRule" "\0"
  /*  1396 */ "CSSStartingStyleRule" "\0"
  /*  1417 */ "CSSStyleDeclaration" "\0"
  /*  1437 */ "CSSStyleRule" "\0"
  /*  1450 */ "CSSStyleSheet" "\0"
  /*  1464 */ "CSSSupportsRule" "\0"
  /*  1480 */ "CSSTransition" "\0"
  /*  1494 */ "Cache" "\0"
  /*  1500 */ "CacheStorage" "\0"
  /*  1513 */ "CallbackDebuggerNotification" "\0"
  /*  1542 */ "CanonicalBrowsingContext" "\0"
  /*  1567 */ "CanvasCaptureMediaStream" "\0"
  /*  1592 */ "CanvasGradient" "\0"
  /*  1607 */ "CanvasPattern" "\0"
  /*  1621 */ "CanvasRenderingContext2D" "\0"
  /*  1646 */ "CaretPosition" "\0"
  /*  1660 */ "CaretStateChangedEvent" "\0"
  /*  1683 */ "ChannelMergerNode" "\0"
  /*  1701 */ "ChannelSplitterNode" "\0"
  /*  1721 */ "ChannelWrapper" "\0"
  /*  1736 */ "CharacterData" "\0"
  /*  1750 */ "CheckerboardReportService" "\0"
  /*  1776 */ "ChildProcessMessageManager" "\0"
  /*  1803 */ "ChildSHistory" "\0"
  /*  1817 */ "ChromeMessageBroadcaster" "\0"
  /*  1842 */ "ChromeMessageSender" "\0"
  /*  1862 */ "ChromeNodeList" "\0"
  /*  1877 */ "ChromeUtils" "\0"
  /*  1889 */ "ChromeWorker" "\0"
  /*  1902 */ "Client" "\0"
  /*  1909 */ "Clients" "\0"
  /*  1917 */ "Clipboard" "\0"
  /*  1927 */ "ClipboardEvent" "\0"
  /*  1942 */ "ClipboardItem" "\0"
  /*  1956 */ "ClonedErrorHolder" "\0"
  /*  1974 */ "CloseEvent" "\0"
  /*  1985 */ "CloseWatcher" "\0"
  /*  1998 */ "CommandEvent" "\0"
  /*  2011 */ "Comment" "\0"
  /*  2019 */ "CompositionEvent" "\0"
  /*  2036 */ "CompressionStream" "\0"
  /*  2054 */ "ConsoleInstance" "\0"
  /*  2070 */ "ConstantSourceNode" "\0"
  /*  2089 */ "ContentFrameMessageManager" "\0"
  /*  2116 */ "ContentProcessMessageManager" "\0"
  /*  2145 */ "ContentVisibilityAutoStateChangeEvent" "\0"
  /*  2183 */ "ConvolverNode" "\0"
  /*  2197 */ "CookieChangeEvent" "\0"
  /*  2215 */ "CookieStore" "\0"
  /*  2227 */ "CountQueuingStrategy" "\0"
  /*  2248 */ "CreateOfferRequest" "\0"
  /*  2267 */ "Credential" "\0"
  /*  2278 */ "CredentialsContainer" "\0"
  /*  2299 */ "Crypto" "\0"
  /*  2306 */ "CryptoKey" "\0"
  /*  2316 */ "CustomElementRegistry" "\0"
  /*  2338 */ "CustomEvent" "\0"
  /*  2350 */ "CustomStateSet" "\0"
  /*  2365 */ "DOMException" "\0"
  /*  2378 */ "DOMImplementation" "\0"
  /*  2396 */ "DOMLocalization" "\0"
  /*  2412 */ "DOMMatrix" "\0"
  /*  2422 */ "DOMMatrixReadOnly" "\0"
  /*  2440 */ "DOMParser" "\0"
  /*  2450 */ "DOMPoint" "\0"
  /*  2459 */ "DOMPointReadOnly" "\0"
  /*  2476 */ "DOMQuad" "\0"
  /*  2484 */ "DOMRect" "\0"
  /*  2492 */ "DOMRectList" "\0"
  /*  2504 */ "DOMRectReadOnly" "\0"
  /*  2520 */ "DOMStringList" "\0"
  /*  2534 */ "DOMStringMap" "\0"
  /*  2547 */ "DOMTokenList" "\0"
  /*  2560 */ "DataTransfer" "\0"
  /*  2573 */ "DataTransferItem" "\0"
  /*  2590 */ "DataTransferItemList" "\0"
  /*  2611 */ "DebuggerNotification" "\0"
  /*  2632 */ "DebuggerNotificationObserver" "\0"
  /*  2661 */ "DecompressionStream" "\0"
  /*  2681 */ "DedicatedWorkerGlobalScope" "\0"
  /*  2708 */ "DelayNode" "\0"
  /*  2718 */ "DeprecationReportBody" "\0"
  /*  2740 */ "DeviceAcceleration" "\0"
  /*  2759 */ "DeviceLightEvent" "\0"
  /*  2776 */ "DeviceMotionEvent" "\0"
  /*  2794 */ "DeviceOrientationEvent" "\0"
  /*  2817 */ "DeviceRotationRate" "\0"
  /*  2836 */ "Directory" "\0"
  /*  2846 */ "Document" "\0"
  /*  2855 */ "DocumentFragment" "\0"
  /*  2872 */ "DocumentL10n" "\0"
  /*  2885 */ "DocumentTimeline" "\0"
  /*  2902 */ "DocumentType" "\0"
  /*  2915 */ "DominatorTree" "\0"
  /*  2929 */ "DragEvent" "\0"
  /*  2939 */ "DynamicsCompressorNode" "\0"
  /*  2962 */ "EXT_blend_minmax" "\0"
  /*  2979 */ "EXT_color_buffer_float" "\0"
  /*  3002 */ "EXT_color_buffer_half_float" "\0"
  /*  3030 */ "EXT_depth_clamp" "\0"
  /*  3046 */ "EXT_disjoint_timer_query" "\0"
  /*  3071 */ "EXT_float_blend" "\0"
  /*  3087 */ "EXT_frag_depth" "\0"
  /*  3102 */ "EXT_sRGB" "\0"
  /*  3111 */ "EXT_shader_texture_lod" "\0"
  /*  3134 */ "EXT_texture_compression_bptc" "\0"
  /*  3163 */ "EXT_texture_compression_rgtc" "\0"
  /*  3192 */ "EXT_texture_filter_anisotropic" "\0"
  /*  3223 */ "EXT_texture_norm16" "\0"
  /*  3242 */ "Element" "\0"
  /*  3250 */ "ElementInternals" "\0"
  /*  3267 */ "EncodedAudioChunk" "\0"
  /*  3285 */ "EncodedVideoChunk" "\0"
  /*  3303 */ "ErrorEvent" "\0"
  /*  3314 */ "Event" "\0"
  /*  3320 */ "EventCallbackDebuggerNotification" "\0"
  /*  3354 */ "EventCounts" "\0"
  /*  3366 */ "EventSource" "\0"
  /*  3378 */ "EventTarget" "\0"
  /*  3390 */ "Exception" "\0"
  /*  3400 */ "ExtendableEvent" "\0"
  /*  3416 */ "ExtendableMessageEvent" "\0"
  /*  3439 */ "ExtensionAlarms" "\0"
  /*  3455 */ "ExtensionBrowser" "\0"
  /*  3472 */ "ExtensionBrowserSettings" "\0"
  /*  3497 */ "ExtensionBrowserSettingsColorManagement" "\0"
  /*  3537 */ "ExtensionDns" "\0"
  /*  3550 */ "ExtensionEventManager" "\0"
  /*  3572 */ "ExtensionMockAPI" "\0"
  /*  3589 */ "ExtensionPort" "\0"
  /*  3603 */ "ExtensionProxy" "\0"
  /*  3618 */ "ExtensionRuntime" "\0"
  /*  3635 */ "ExtensionScripting" "\0"
  /*  3654 */ "ExtensionSetting" "\0"
  /*  3671 */ "ExtensionTest" "\0"
  /*  3685 */ "External" "\0"
  /*  3694 */ "FeaturePolicy" "\0"
  /*  3708 */ "FeaturePolicyViolationReportBody" "\0"
  /*  3741 */ "FetchEvent" "\0"
  /*  3752 */ "FetchObserver" "\0"
  /*  3766 */ "File" "\0"
  /*  3771 */ "FileList" "\0"
  /*  3780 */ "FileReader" "\0"
  /*  3791 */ "FileReaderSync" "\0"
  /*  3806 */ "FileSystem" "\0"
  /*  3817 */ "FileSystemDirectoryEntry" "\0"
  /*  3842 */ "FileSystemDirectoryHandle" "\0"
  /*  3868 */ "FileSystemDirectoryHandle AsyncIterator" "\0"
  /*  3908 */ "FileSystemDirectoryIterator" "\0"
  /*  3936 */ "FileSystemDirectoryReader" "\0"
  /*  3962 */ "FileSystemEntry" "\0"
  /*  3978 */ "FileSystemFileEntry" "\0"
  /*  3998 */ "FileSystemFileHandle" "\0"
  /*  4019 */ "FileSystemHandle" "\0"
  /*  4036 */ "FileSystemSyncAccessHandle" "\0"
  /*  4063 */ "FileSystemWritableFileStream" "\0"
  /*  4092 */ "Flex" "\0"
  /*  4097 */ "FlexItemValues" "\0"
  /*  4112 */ "FlexLineValues" "\0"
  /*  4127 */ "FluentBundle" "\0"
  /*  4140 */ "FluentBundleAsyncIterator" "\0"
  /*  4166 */ "FluentBundleIterator" "\0"
  /*  4187 */ "FluentPattern" "\0"
  /*  4201 */ "FluentResource" "\0"
  /*  4216 */ "FocusEvent" "\0"
  /*  4227 */ "FontFace" "\0"
  /*  4236 */ "FontFaceSet" "\0"
  /*  4248 */ "FontFaceSetIterator" "\0"
  /*  4268 */ "FontFaceSetLoadEvent" "\0"
  /*  4289 */ "FormData" "\0"
  /*  4298 */ "FormData Iterator" "\0"
  /*  4316 */ "FormDataEvent" "\0"
  /*  4330 */ "FragmentDirective" "\0"
  /*  4348 */ "FrameCrashedEvent" "\0"
  /*  4366 */ "FrameLoader" "\0"
  /*  4378 */ "GPU" "\0"
  /*  4382 */ "GPUAdapter" "\0"
  /*  4393 */ "GPUAdapterInfo" "\0"
  /*  4408 */ "GPUBindGroup" "\0"
  /*  4421 */ "GPUBindGroupLayout" "\0"
  /*  4440 */ "GPUBuffer" "\0"
  /*  4450 */ "GPUBufferUsage" "\0"
  /*  4465 */ "GPUCanvasContext" "\0"
  /*  4482 */ "GPUColorWrite" "\0"
  /*  4496 */ "GPUCommandBuffer" "\0"
  /*  4513 */ "GPUCommandEncoder" "\0"
  /*  4531 */ "GPUCompilationInfo" "\0"
  /*  4550 */ "GPUCompilationMessage" "\0"
  /*  4572 */ "GPUComputePassEncoder" "\0"
  /*  4594 */ "GPUComputePipeline" "\0"
  /*  4613 */ "GPUDevice" "\0"
  /*  4623 */ "GPUDeviceLostInfo" "\0"
  /*  4641 */ "GPUError" "\0"
  /*  4650 */ "GPUInternalError" "\0"
  /*  4667 */ "GPUMapMode" "\0"
  /*  4678 */ "GPUOutOfMemoryError" "\0"
  /*  4698 */ "GPUPipelineLayout" "\0"
  /*  4716 */ "GPUQuerySet" "\0"
  /*  4728 */ "GPUQueue" "\0"
  /*  4737 */ "GPURenderBundle" "\0"
  /*  4753 */ "GPURenderBundleEncoder" "\0"
  /*  4776 */ "GPURenderPassEncoder" "\0"
  /*  4797 */ "GPURenderPipeline" "\0"
  /*  4815 */ "GPUSampler" "\0"
  /*  4826 */ "GPUShaderModule" "\0"
  /*  4842 */ "GPUShaderStage" "\0"
  /*  4857 */ "GPUSupportedFeatures" "\0"
  /*  4878 */ "GPUSupportedLimits" "\0"
  /*  4897 */ "GPUTexture" "\0"
  /*  4908 */ "GPUTextureUsage" "\0"
  /*  4924 */ "GPUTextureView" "\0"
  /*  4939 */ "GPUUncapturedErrorEvent" "\0"
  /*  4963 */ "GPUValidationError" "\0"
  /*  4982 */ "GainNode" "\0"
  /*  4991 */ "Gamepad" "\0"
  /*  4999 */ "GamepadAxisMoveEvent" "\0"
  /*  5020 */ "GamepadButton" "\0"
  /*  5034 */ "GamepadButtonEvent" "\0"
  /*  5053 */ "GamepadEvent" "\0"
  /*  5066 */ "GamepadHapticActuator" "\0"
  /*  5088 */ "GamepadLightIndicator" "\0"
  /*  5110 */ "GamepadPose" "\0"
  /*  5122 */ "GamepadServiceTest" "\0"
  /*  5141 */ "GamepadTouch" "\0"
  /*  5154 */ "Geolocation" "\0"
  /*  5166 */ "GeolocationCoordinates" "\0"
  /*  5189 */ "GeolocationPosition" "\0"
  /*  5209 */ "GeolocationPositionError" "\0"
  /*  5234 */ "GetUserMediaRequest" "\0"
  /*  5254 */ "GleanBoolean" "\0"
  /*  5267 */ "GleanCategory" "\0"
  /*  5281 */ "GleanCounter" "\0"
  /*  5294 */ "GleanCustomDistribution" "\0"
  /*  5318 */ "GleanDatetime" "\0"
  /*  5332 */ "GleanDenominator" "\0"
  /*  5349 */ "GleanEvent" "\0"
  /*  5360 */ "GleanImpl" "\0"
  /*  5370 */ "GleanLabeled" "\0"
  /*  5383 */ "GleanMemoryDistribution" "\0"
  /*  5407 */ "GleanMetric" "\0"
  /*  5419 */ "GleanNumerator" "\0"
  /*  5434 */ "GleanObject" "\0"
  /*  5446 */ "GleanPingsImpl" "\0"
  /*  5461 */ "GleanQuantity" "\0"
  /*  5475 */ "GleanRate" "\0"
  /*  5485 */ "GleanString" "\0"
  /*  5497 */ "GleanStringList" "\0"
  /*  5513 */ "GleanText" "\0"
  /*  5523 */ "GleanTimespan" "\0"
  /*  5537 */ "GleanTimingDistribution" "\0"
  /*  5561 */ "GleanUrl" "\0"
  /*  5570 */ "GleanUuid" "\0"
  /*  5580 */ "Grid" "\0"
  /*  5585 */ "GridArea" "\0"
  /*  5594 */ "GridDimension" "\0"
  /*  5608 */ "GridLine" "\0"
  /*  5617 */ "GridLines" "\0"
  /*  5627 */ "GridTrack" "\0"
  /*  5637 */ "GridTracks" "\0"
  /*  5648 */ "HTMLAllCollection" "\0"
  /*  5666 */ "HTMLAnchorElement" "\0"
  /*  5684 */ "HTMLAreaElement" "\0"
  /*  5700 */ "HTMLAudioElement" "\0"
  /*  5717 */ "HTMLBRElement" "\0"
  /*  5731 */ "HTMLBaseElement" "\0"
  /*  5747 */ "HTMLBodyElement" "\0"
  /*  5763 */ "HTMLButtonElement" "\0"
  /*  5781 */ "HTMLCanvasElement" "\0"
  /*  5799 */ "HTMLCollection" "\0"
  /*  5814 */ "HTMLDListElement" "\0"
  /*  5831 */ "HTMLDataElement" "\0"
  /*  5847 */ "HTMLDataListElement" "\0"
  /*  5867 */ "HTMLDetailsElement" "\0"
  /*  5886 */ "HTMLDialogElement" "\0"
  /*  5904 */ "HTMLDirectoryElement" "\0"
  /*  5925 */ "HTMLDivElement" "\0"
  /*  5940 */ "HTMLDocument" "\0"
  /*  5953 */ "HTMLElement" "\0"
  /*  5965 */ "HTMLEmbedElement" "\0"
  /*  5982 */ "HTMLFieldSetElement" "\0"
  /*  6002 */ "HTMLFontElement" "\0"
  /*  6018 */ "HTMLFormControlsCollection" "\0"
  /*  6045 */ "HTMLFormElement" "\0"
  /*  6061 */ "HTMLFrameElement" "\0"
  /*  6078 */ "HTMLFrameSetElement" "\0"
  /*  6098 */ "HTMLHRElement" "\0"
  /*  6112 */ "HTMLHeadElement" "\0"
  /*  6128 */ "HTMLHeadingElement" "\0"
  /*  6147 */ "HTMLHtmlElement" "\0"
  /*  6163 */ "HTMLIFrameElement" "\0"
  /*  6181 */ "HTMLImageElement" "\0"
  /*  6198 */ "HTMLInputElement" "\0"
  /*  6215 */ "HTMLLIElement" "\0"
  /*  6229 */ "HTMLLabelElement" "\0"
  /*  6246 */ "HTMLLegendElement" "\0"
  /*  6264 */ "HTMLLinkElement" "\0"
  /*  6280 */ "HTMLMapElement" "\0"
  /*  6295 */ "HTMLMarqueeElement" "\0"
  /*  6314 */ "HTMLMediaElement" "\0"
  /*  6331 */ "HTMLMenuElement" "\0"
  /*  6347 */ "HTMLMetaElement" "\0"
  /*  6363 */ "HTMLMeterElement" "\0"
  /*  6380 */ "HTMLModElement" "\0"
  /*  6395 */ "HTMLOListElement" "\0"
  /*  6412 */ "HTMLObjectElement" "\0"
  /*  6430 */ "HTMLOptGroupElement" "\0"
  /*  6450 */ "HTMLOptionElement" "\0"
  /*  6468 */ "HTMLOptionsCollection" "\0"
  /*  6490 */ "HTMLOutputElement" "\0"
  /*  6508 */ "HTMLParagraphElement" "\0"
  /*  6529 */ "HTMLParamElement" "\0"
  /*  6546 */ "HTMLPictureElement" "\0"
  /*  6565 */ "HTMLPreElement" "\0"
  /*  6580 */ "HTMLProgressElement" "\0"
  /*  6600 */ "HTMLQuoteElement" "\0"
  /*  6617 */ "HTMLScriptElement" "\0"
  /*  6635 */ "HTMLSelectElement" "\0"
  /*  6653 */ "HTMLSlotElement" "\0"
  /*  6669 */ "HTMLSourceElement" "\0"
  /*  6687 */ "HTMLSpanElement" "\0"
  /*  6703 */ "HTMLStyleElement" "\0"
  /*  6720 */ "HTMLTableCaptionElement" "\0"
  /*  6744 */ "HTMLTableCellElement" "\0"
  /*  6765 */ "HTMLTableColElement" "\0"
  /*  6785 */ "HTMLTableElement" "\0"
  /*  6802 */ "HTMLTableRowElement" "\0"
  /*  6822 */ "HTMLTableSectionElement" "\0"
  /*  6846 */ "HTMLTemplateElement" "\0"
  /*  6866 */ "HTMLTextAreaElement" "\0"
  /*  6886 */ "HTMLTimeElement" "\0"
  /*  6902 */ "HTMLTitleElement" "\0"
  /*  6919 */ "HTMLTrackElement" "\0"
  /*  6936 */ "HTMLUListElement" "\0"
  /*  6953 */ "HTMLUnknownElement" "\0"
  /*  6972 */ "HTMLVideoElement" "\0"
  /*  6989 */ "HashChangeEvent" "\0"
  /*  7005 */ "Headers" "\0"
  /*  7013 */ "Headers Iterator" "\0"
  /*  7030 */ "HeapSnapshot" "\0"
  /*  7043 */ "Highlight" "\0"
  /*  7053 */ "HighlightRegistry" "\0"
  /*  7071 */ "History" "\0"
  /*  7079 */ "IDBCursor" "\0"
  /*  7089 */ "IDBCursorWithValue" "\0"
  /*  7108 */ "IDBDatabase" "\0"
  /*  7120 */ "IDBFactory" "\0"
  /*  7131 */ "IDBIndex" "\0"
  /*  7140 */ "IDBKeyRange" "\0"
  /*  7152 */ "IDBObjectStore" "\0"
  /*  7167 */ "IDBOpenDBRequest" "\0"
  /*  7184 */ "IDBRequest" "\0"
  /*  7195 */ "IDBTransaction" "\0"
  /*  7210 */ "IDBVersionChangeEvent" "\0"
  /*  7232 */ "IIRFilterNode" "\0"
  /*  7246 */ "IOUtils" "\0"
  /*  7254 */ "IdentityCredential" "\0"
  /*  7273 */ "IdleDeadline" "\0"
  /*  7286 */ "Image" "\0"
  /*  7292 */ "ImageBitmap" "\0"
  /*  7304 */ "ImageBitmapRenderingContext" "\0"
  /*  7332 */ "ImageCapture" "\0"
  /*  7345 */ "ImageCaptureError" "\0"
  /*  7363 */ "ImageCaptureErrorEvent" "\0"
  /*  7386 */ "ImageData" "\0"
  /*  7396 */ "ImageDecoder" "\0"
  /*  7409 */ "ImageDocument" "\0"
  /*  7423 */ "ImageTrack" "\0"
  /*  7434 */ "ImageTrackList" "\0"
  /*  7449 */ "InputEvent" "\0"
  /*  7460 */ "InspectorCSSParser" "\0"
  /*  7479 */ "InspectorFontFace" "\0"
  /*  7497 */ "InspectorUtils" "\0"
  /*  7512 */ "InstallTriggerImpl" "\0"
  /*  7531 */ "IntersectionObserver" "\0"
  /*  7552 */ "IntersectionObserverEntry" "\0"
  /*  7578 */ "IntlUtils" "\0"
  /*  7588 */ "InvokeEvent" "\0"
  /*  7600 */ "JSProcessActorChild" "\0"
  /*  7620 */ "JSProcessActorParent" "\0"
  /*  7641 */ "JSWindowActorChild" "\0"
  /*  7660 */ "JSWindowActorParent" "\0"
  /*  7680 */ "KeyEvent" "\0"
  /*  7689 */ "KeyboardEvent" "\0"
  /*  7703 */ "KeyframeEffect" "\0"
  /*  7718 */ "L10nFileSource" "\0"
  /*  7733 */ "L10nOverlays" "\0"
  /*  7746 */ "L10nRegistry" "\0"
  /*  7759 */ "LargestContentfulPaint" "\0"
  /*  7782 */ "LegacyMozTCPSocket" "\0"
  /*  7801 */ "Localization" "\0"
  /*  7814 */ "Location" "\0"
  /*  7823 */ "Lock" "\0"
  /*  7828 */ "LockManager" "\0"
  /*  7840 */ "MIDIAccess" "\0"
  /*  7851 */ "MIDIConnectionEvent" "\0"
  /*  7871 */ "MIDIInput" "\0"
  /*  7881 */ "MIDIInputMap" "\0"
  /*  7894 */ "MIDIMessageEvent" "\0"
  /*  7911 */ "MIDIOutput" "\0"
  /*  7922 */ "MIDIOutputMap" "\0"
  /*  7936 */ "MIDIPort" "\0"
  /*  7945 */ "MOZ_debug" "\0"
  /*  7955 */ "MatchGlob" "\0"
  /*  7965 */ "MatchPattern" "\0"
  /*  7978 */ "MatchPatternSet" "\0"
  /*  7994 */ "MathMLElement" "\0"
  /*  8008 */ "MediaCapabilities" "\0"
  /*  8026 */ "MediaControlService" "\0"
  /*  8046 */ "MediaController" "\0"
  /*  8062 */ "MediaDeviceInfo" "\0"
  /*  8078 */ "MediaDevices" "\0"
  /*  8091 */ "MediaElementAudioSourceNode" "\0"
  /*  8119 */ "MediaEncryptedEvent" "\0"
  /*  8139 */ "MediaError" "\0"
  /*  8150 */ "MediaKeyError" "\0"
  /*  8164 */ "MediaKeyMessageEvent" "\0"
  /*  8185 */ "MediaKeySession" "\0"
  /*  8201 */ "MediaKeyStatusMap" "\0"
  /*  8219 */ "MediaKeyStatusMap Iterator" "\0"
  /*  8246 */ "MediaKeySystemAccess" "\0"
  /*  8267 */ "MediaKeys" "\0"
  /*  8277 */ "MediaList" "\0"
  /*  8287 */ "MediaMetadata" "\0"
  /*  8301 */ "MediaQueryList" "\0"
  /*  8316 */ "MediaQueryListEvent" "\0"
  /*  8336 */ "MediaRecorder" "\0"
  /*  8350 */ "MediaRecorderErrorEvent" "\0"
  /*  8374 */ "MediaSession" "\0"
  /*  8387 */ "MediaSource" "\0"
  /*  8399 */ "MediaStream" "\0"
  /*  8411 */ "MediaStreamAudioDestinationNode" "\0"
  /*  8443 */ "MediaStreamAudioSourceNode" "\0"
  /*  8470 */ "MediaStreamError" "\0"
  /*  8487 */ "MediaStreamEvent" "\0"
  /*  8504 */ "MediaStreamTrack" "\0"
  /*  8521 */ "MediaStreamTrackAudioSourceNode" "\0"
  /*  8553 */ "MediaStreamTrackEvent" "\0"
  /*  8575 */ "MerchantValidationEvent" "\0"
  /*  8599 */ "MessageBroadcaster" "\0"
  /*  8618 */ "MessageChannel" "\0"
  /*  8633 */ "MessageEvent" "\0"
  /*  8646 */ "MessageListenerManager" "\0"
  /*  8669 */ "MessagePort" "\0"
  /*  8681 */ "MessageSender" "\0"
  /*  8695 */ "MimeType" "\0"
  /*  8704 */ "MimeTypeArray" "\0"
  /*  8718 */ "MouseEvent" "\0"
  /*  8729 */ "MouseScrollEvent" "\0"
  /*  8746 */ "MozCanvasPrintState" "\0"
  /*  8766 */ "MozDocumentMatcher" "\0"
  /*  8785 */ "MozDocumentObserver" "\0"
  /*  8805 */ "MozQueryInterface" "\0"
  /*  8823 */ "MozSharedMap" "\0"
  /*  8836 */ "MozSharedMap Iterator" "\0"
  /*  8858 */ "MozSharedMapChangeEvent" "\0"
  /*  8882 */ "MozStorageAsyncStatementParams" "\0"
  /*  8913 */ "MozStorageStatementParams" "\0"
  /*  8939 */ "MozStorageStatementRow" "\0"
  /*  8962 */ "MozWritableSharedMap" "\0"
  /*  8983 */ "MutationEvent" "\0"
  /*  8997 */ "MutationObserver" "\0"
  /*  9014 */ "MutationRecord" "\0"
  /*  9029 */ "NamedNodeMap" "\0"
  /*  9042 */ "NavigateEvent" "\0"
  /*  9056 */ "Navigation" "\0"
  /*  9067 */ "NavigationActivation" "\0"
  /*  9088 */ "NavigationCurrentEntryChangeEvent" "\0"
  /*  9122 */ "NavigationDestination" "\0"
  /*  9144 */ "NavigationHistoryEntry" "\0"
  /*  9167 */ "NavigationPreloadManager" "\0"
  /*  9192 */ "NavigationTransition" "\0"
  /*  9213 */ "Navigator" "\0"
  /*  9223 */ "NetworkInformation" "\0"
  /*  9242 */ "Node" "\0"
  /*  9247 */ "NodeFilter" "\0"
  /*  9258 */ "NodeIterator" "\0"
  /*  9271 */ "NodeList" "\0"
  /*  9280 */ "Notification" "\0"
  /*  9293 */ "NotificationEvent" "\0"
  /*  9311 */ "NotifyPaintEvent" "\0"
  /*  9328 */ "OES_draw_buffers_indexed" "\0"
  /*  9353 */ "OES_element_index_uint" "\0"
  /*  9376 */ "OES_fbo_render_mipmap" "\0"
  /*  9398 */ "OES_standard_derivatives" "\0"
  /*  9423 */ "OES_texture_float" "\0"
  /*  9441 */ "OES_texture_float_linear" "\0"
  /*  9466 */ "OES_texture_half_float" "\0"
  /*  9489 */ "OES_texture_half_float_linear" "\0"
  /*  9519 */ "OES_vertex_array_object" "\0"
  /*  9543 */ "OVR_multiview2" "\0"
  /*  9558 */ "OfflineAudioCompletionEvent" "\0"
  /*  9586 */ "OfflineAudioContext" "\0"
  /*  9606 */ "OffscreenCanvas" "\0"
  /*  9622 */ "OffscreenCanvasRenderingContext2D" "\0"
  /*  9656 */ "OnlyForUseInConstructor" "\0"
  /*  9680 */ "Option" "\0"
  /*  9687 */ "OscillatorNode" "\0"
  /*  9702 */ "PageTransitionEvent" "\0"
  /*  9722 */ "PaintRequest" "\0"
  /*  9735 */ "PaintRequestList" "\0"
  /*  9752 */ "PaintWorkletGlobalScope" "\0"
  /*  9776 */ "PannerNode" "\0"
  /*  9787 */ "ParentProcessMessageManager" "\0"
  /*  9815 */ "Path2D" "\0"
  /*  9822 */ "PathUtils" "\0"
  /*  9832 */ "PaymentAddress" "\0"
  /*  9847 */ "PaymentMethodChangeEvent" "\0"
  /*  9872 */ "PaymentRequest" "\0"
  /*  9887 */ "PaymentRequestUpdateEvent" "\0"
  /*  9913 */ "PaymentResponse" "\0"
  /*  9929 */ "PeerConnectionImpl" "\0"
  /*  9948 */ "PeerConnectionObserver" "\0"
  /*  9971 */ "Performance" "\0"
  /*  9983 */ "PerformanceEntry" "\0"
  /* 10000 */ "PerformanceEntryEvent" "\0"
  /* 10022 */ "PerformanceEventTiming" "\0"
  /* 10045 */ "PerformanceMark" "\0"
  /* 10061 */ "PerformanceMeasure" "\0"
  /* 10080 */ "PerformanceNavigation" "\0"
  /* 10102 */ "PerformanceNavigationTiming" "\0"
  /* 10130 */ "PerformanceObserver" "\0"
  /* 10150 */ "PerformanceObserverEntryList" "\0"
  /* 10179 */ "PerformancePaintTiming" "\0"
  /* 10202 */ "PerformanceResourceTiming" "\0"
  /* 10228 */ "PerformanceServerTiming" "\0"
  /* 10252 */ "PerformanceTiming" "\0"
  /* 10270 */ "PeriodicWave" "\0"
  /* 10283 */ "PermissionStatus" "\0"
  /* 10300 */ "Permissions" "\0"
  /* 10312 */ "PlacesBookmark" "\0"
  /* 10327 */ "PlacesBookmarkAddition" "\0"
  /* 10350 */ "PlacesBookmarkChanged" "\0"
  /* 10372 */ "PlacesBookmarkGuid" "\0"
  /* 10391 */ "PlacesBookmarkKeyword" "\0"
  /* 10413 */ "PlacesBookmarkMoved" "\0"
  /* 10433 */ "PlacesBookmarkRemoved" "\0"
  /* 10455 */ "PlacesBookmarkTags" "\0"
  /* 10474 */ "PlacesBookmarkTime" "\0"
  /* 10493 */ "PlacesBookmarkTitle" "\0"
  /* 10513 */ "PlacesBookmarkUrl" "\0"
  /* 10531 */ "PlacesEvent" "\0"
  /* 10543 */ "PlacesEventCounts" "\0"
  /* 10561 */ "PlacesFavicon" "\0"
  /* 10575 */ "PlacesHistoryCleared" "\0"
  /* 10596 */ "PlacesObservers" "\0"
  /* 10612 */ "PlacesPurgeCaches" "\0"
  /* 10630 */ "PlacesRanking" "\0"
  /* 10644 */ "PlacesVisit" "\0"
  /* 10656 */ "PlacesVisitRemoved" "\0"
  /* 10675 */ "PlacesVisitTitle" "\0"
  /* 10692 */ "PlacesWeakCallbackWrapper" "\0"
  /* 10718 */ "Plugin" "\0"
  /* 10725 */ "PluginArray" "\0"
  /* 10737 */ "PluginCrashedEvent" "\0"
  /* 10756 */ "PointerEvent" "\0"
  /* 10769 */ "PopStateEvent" "\0"
  /* 10783 */ "PopupBlockedEvent" "\0"
  /* 10801 */ "PopupPositionedEvent" "\0"
  /* 10822 */ "PositionStateEvent" "\0"
  /* 10841 */ "PrecompiledScript" "\0"
  /* 10859 */ "PrivateAttribution" "\0"
  /* 10878 */ "ProcessMessageManager" "\0"
  /* 10900 */ "ProcessingInstruction" "\0"
  /* 10922 */ "ProgressEvent" "\0"
  /* 10936 */ "PromiseDebugging" "\0"
  /* 10953 */ "PromiseNativeHandler" "\0"
  /* 10974 */ "PromiseRejectionEvent" "\0"
  /* 10996 */ "PublicKeyCredential" "\0"
  /* 11016 */ "PushEvent" "\0"
  /* 11026 */ "PushManager" "\0"
  /* 11038 */ "PushManagerImpl" "\0"
  /* 11054 */ "PushMessageData" "\0"
  /* 11070 */ "PushSubscription" "\0"
  /* 11087 */ "PushSubscriptionOptions" "\0"
  /* 11111 */ "RTCCertificate" "\0"
  /* 11126 */ "RTCDTMFSender" "\0"
  /* 11140 */ "RTCDTMFToneChangeEvent" "\0"
  /* 11163 */ "RTCDataChannel" "\0"
  /* 11178 */ "RTCDataChannelEvent" "\0"
  /* 11198 */ "RTCDtlsTransport" "\0"
  /* 11215 */ "RTCEncodedAudioFrame" "\0"
  /* 11236 */ "RTCEncodedVideoFrame" "\0"
  /* 11257 */ "RTCIceCandidate" "\0"
  /* 11273 */ "RTCIceTransport" "\0"
  /* 11289 */ "RTCIdentityProviderRegistrar" "\0"
  /* 11318 */ "RTCPeerConnection" "\0"
  /* 11336 */ "RTCPeerConnectionIceEvent" "\0"
  /* 11362 */ "RTCPeerConnectionStatic" "\0"
  /* 11386 */ "RTCRtpReceiver" "\0"
  /* 11401 */ "RTCRtpScriptTransform" "\0"
  /* 11423 */ "RTCRtpScriptTransformer" "\0"
  /* 11447 */ "RTCRtpSender" "\0"
  /* 11460 */ "RTCRtpTransceiver" "\0"
  /* 11478 */ "RTCSctpTransport" "\0"
  /* 11495 */ "RTCSessionDescription" "\0"
  /* 11517 */ "RTCStatsReport" "\0"
  /* 11532 */ "RTCTrackEvent" "\0"
  /* 11546 */ "RTCTransformEvent" "\0"
  /* 11564 */ "RadioNodeList" "\0"
  /* 11578 */ "Range" "\0"
  /* 11584 */ "ReadableByteStreamController" "\0"
  /* 11613 */ "ReadableStream" "\0"
  /* 11628 */ "ReadableStream AsyncIterator" "\0"
  /* 11657 */ "ReadableStreamBYOBReader" "\0"
  /* 11682 */ "ReadableStreamBYOBRequest" "\0"
  /* 11708 */ "ReadableStreamDefaultController" "\0"
  /* 11740 */ "ReadableStreamDefaultReader" "\0"
  /* 11768 */ "Report" "\0"
  /* 11775 */ "ReportBody" "\0"
  /* 11786 */ "ReportingObserver" "\0"
  /* 11804 */ "Request" "\0"
  /* 11812 */ "ResizeObserver" "\0"
  /* 11827 */ "ResizeObserverEntry" "\0"
  /* 11847 */ "ResizeObserverSize" "\0"
  /* 11866 */ "Response" "\0"
  /* 11875 */ "SVGAElement" "\0"
  /* 11887 */ "SVGAngle" "\0"
  /* 11896 */ "SVGAnimateElement" "\0"
  /* 11914 */ "SVGAnimateMotionElement" "\0"
  /* 11938 */ "SVGAnimateTransformElement" "\0"
  /* 11965 */ "SVGAnimatedAngle" "\0"
  /* 11982 */ "SVGAnimatedBoolean" "\0"
  /* 12001 */ "SVGAnimatedEnumeration" "\0"
  /* 12024 */ "SVGAnimatedInteger" "\0"
  /* 12043 */ "SVGAnimatedLength" "\0"
  /* 12061 */ "SVGAnimatedLengthList" "\0"
  /* 12083 */ "SVGAnimatedNumber" "\0"
  /* 12101 */ "SVGAnimatedNumberList" "\0"
  /* 12123 */ "SVGAnimatedPreserveAspectRatio" "\0"
  /* 12154 */ "SVGAnimatedRect" "\0"
  /* 12170 */ "SVGAnimatedString" "\0"
  /* 12188 */ "SVGAnimatedTransformList" "\0"
  /* 12213 */ "SVGAnimationElement" "\0"
  /* 12233 */ "SVGCircleElement" "\0"
  /* 12250 */ "SVGClipPathElement" "\0"
  /* 12269 */ "SVGComponentTransferFunctionElement" "\0"
  /* 12305 */ "SVGDefsElement" "\0"
  /* 12320 */ "SVGDescElement" "\0"
  /* 12335 */ "SVGElement" "\0"
  /* 12346 */ "SVGEllipseElement" "\0"
  /* 12364 */ "SVGFEBlendElement" "\0"
  /* 12382 */ "SVGFEColorMatrixElement" "\0"
  /* 12406 */ "SVGFEComponentTransferElement" "\0"
  /* 12436 */ "SVGFECompositeElement" "\0"
  /* 12458 */ "SVGFEConvolveMatrixElement" "\0"
  /* 12485 */ "SVGFEDiffuseLightingElement" "\0"
  /* 12513 */ "SVGFEDisplacementMapElement" "\0"
  /* 12541 */ "SVGFEDistantLightElement" "\0"
  /* 12566 */ "SVGFEDropShadowElement" "\0"
  /* 12589 */ "SVGFEFloodElement" "\0"
  /* 12607 */ "SVGFEFuncAElement" "\0"
  /* 12625 */ "SVGFEFuncBElement" "\0"
  /* 12643 */ "SVGFEFuncGElement" "\0"
  /* 12661 */ "SVGFEFuncRElement" "\0"
  /* 12679 */ "SVGFEGaussianBlurElement" "\0"
  /* 12704 */ "SVGFEImageElement" "\0"
  /* 12722 */ "SVGFEMergeElement" "\0"
  /* 12740 */ "SVGFEMergeNodeElement" "\0"
  /* 12762 */ "SVGFEMorphologyElement" "\0"
  /* 12785 */ "SVGFEOffsetElement" "\0"
  /* 12804 */ "SVGFEPointLightElement" "\0"
  /* 12827 */ "SVGFESpecularLightingElement" "\0"
  /* 12856 */ "SVGFESpotLightElement" "\0"
  /* 12878 */ "SVGFETileElement" "\0"
  /* 12895 */ "SVGFETurbulenceElement" "\0"
  /* 12918 */ "SVGFilterElement" "\0"
  /* 12935 */ "SVGForeignObjectElement" "\0"
  /* 12959 */ "SVGGElement" "\0"
  /* 12971 */ "SVGGeometryElement" "\0"
  /* 12990 */ "SVGGradientElement" "\0"
  /* 13009 */ "SVGGraphicsElement" "\0"
  /* 13028 */ "SVGImageElement" "\0"
  /* 13044 */ "SVGLength" "\0"
  /* 13054 */ "SVGLengthList" "\0"
  /* 13068 */ "SVGLineElement" "\0"
  /* 13083 */ "SVGLinearGradientElement" "\0"
  /* 13108 */ "SVGMPathElement" "\0"
  /* 13124 */ "SVGMarkerElement" "\0"
  /* 13141 */ "SVGMaskElement" "\0"
  /* 13156 */ "SVGMatrix" "\0"
  /* 13166 */ "SVGMetadataElement" "\0"
  /* 13185 */ "SVGNumber" "\0"
  /* 13195 */ "SVGNumberList" "\0"
  /* 13209 */ "SVGPathElement" "\0"
  /* 13224 */ "SVGPatternElement" "\0"
  /* 13242 */ "SVGPoint" "\0"
  /* 13251 */ "SVGPointList" "\0"
  /* 13264 */ "SVGPolygonElement" "\0"
  /* 13282 */ "SVGPolylineElement" "\0"
  /* 13301 */ "SVGPreserveAspectRatio" "\0"
  /* 13324 */ "SVGRadialGradientElement" "\0"
  /* 13349 */ "SVGRect" "\0"
  /* 13357 */ "SVGRectElement" "\0"
  /* 13372 */ "SVGSVGElement" "\0"
  /* 13386 */ "SVGScriptElement" "\0"
  /* 13403 */ "SVGSetElement" "\0"
  /* 13417 */ "SVGStopElement" "\0"
  /* 13432 */ "SVGStringList" "\0"
  /* 13446 */ "SVGStyleElement" "\0"
  /* 13462 */ "SVGSwitchElement" "\0"
  /* 13479 */ "SVGSymbolElement" "\0"
  /* 13496 */ "SVGTSpanElement" "\0"
  /* 13512 */ "SVGTextContentElement" "\0"
  /* 13534 */ "SVGTextElement" "\0"
  /* 13549 */ "SVGTextPathElement" "\0"
  /* 13568 */ "SVGTextPositioningElement" "\0"
  /* 13594 */ "SVGTitleElement" "\0"
  /* 13610 */ "SVGTransform" "\0"
  /* 13623 */ "SVGTransformList" "\0"
  /* 13640 */ "SVGUnitTypes" "\0"
  /* 13653 */ "SVGUseElement" "\0"
  /* 13667 */ "SVGViewElement" "\0"
  /* 13682 */ "Sanitizer" "\0"
  /* 13692 */ "Scheduler" "\0"
  /* 13702 */ "Screen" "\0"
  /* 13709 */ "ScreenLuminance" "\0"
  /* 13725 */ "ScreenOrientation" "\0"
  /* 13743 */ "ScriptProcessorNode" "\0"
  /* 13763 */ "ScrollAreaEvent" "\0"
  /* 13779 */ "ScrollViewChangeEvent" "\0"
  /* 13801 */ "SecurityPolicyViolationEvent" "\0"
  /* 13830 */ "Selection" "\0"
  /* 13840 */ "ServiceWorker" "\0"
  /* 13854 */ "ServiceWorkerContainer" "\0"
  /* 13877 */ "ServiceWorkerGlobalScope" "\0"
  /* 13902 */ "ServiceWorkerRegistration" "\0"
  /* 13928 */ "SessionStoreFormData" "\0"
  /* 13949 */ "SessionStoreScrollData" "\0"
  /* 13972 */ "SessionStoreUtils" "\0"
  /* 13990 */ "ShadowRealmGlobalScope" "\0"
  /* 14013 */ "ShadowRoot" "\0"
  /* 14024 */ "SharedWorker" "\0"
  /* 14037 */ "SharedWorkerGlobalScope" "\0"
  /* 14061 */ "SimpleGestureEvent" "\0"
  /* 14080 */ "SourceBuffer" "\0"
  /* 14093 */ "SourceBufferList" "\0"
  /* 14110 */ "SpeechGrammar" "\0"
  /* 14124 */ "SpeechGrammarList" "\0"
  /* 14142 */ "SpeechRecognition" "\0"
  /* 14160 */ "SpeechRecognitionAlternative" "\0"
  /* 14189 */ "SpeechRecognitionError" "\0"
  /* 14212 */ "SpeechRecognitionEvent" "\0"
  /* 14235 */ "SpeechRecognitionResult" "\0"
  /* 14259 */ "SpeechRecognitionResultList" "\0"
  /* 14287 */ "SpeechSynthesis" "\0"
  /* 14303 */ "SpeechSynthesisErrorEvent" "\0"
  /* 14329 */ "SpeechSynthesisEvent" "\0"
  /* 14350 */ "SpeechSynthesisUtterance" "\0"
  /* 14375 */ "SpeechSynthesisVoice" "\0"
  /* 14396 */ "StaticRange" "\0"
  /* 14408 */ "StereoPannerNode" "\0"
  /* 14425 */ "Storage" "\0"
  /* 14433 */ "StorageEvent" "\0"
  /* 14446 */ "StorageManager" "\0"
  /* 14461 */ "StreamFilter" "\0"
  /* 14474 */ "StreamFilterDataEvent" "\0"
  /* 14496 */ "StructuredCloneHolder" "\0"
  /* 14518 */ "StructuredCloneTester" "\0"
  /* 14540 */ "StyleSheet" "\0"
  /* 14551 */ "StyleSheetApplicableStateChangeEvent" "\0"
  /* 14588 */ "StyleSheetList" "\0"
  /* 14603 */ "StyleSheetRemovedEvent" "\0"
  /* 14626 */ "SubmitEvent" "\0"
  /* 14638 */ "SubtleCrypto" "\0"
  /* 14651 */ "SyncMessageSender" "\0"
  /* 14669 */ "SyncReadFile" "\0"
  /* 14682 */ "TCPServerSocket" "\0"
  /* 14698 */ "TCPServerSocketEvent" "\0"
  /* 14719 */ "TCPSocket" "\0"
  /* 14729 */ "TCPSocketErrorEvent" "\0"
  /* 14749 */ "TCPSocketEvent" "\0"
  /* 14764 */ "TaskController" "\0"
  /* 14779 */ "TaskPriorityChangeEvent" "\0"
  /* 14803 */ "TaskSignal" "\0"
  /* 14814 */ "TelemetryStopwatch" "\0"
  /* 14833 */ "TestAttributesOnTypes" "\0"
  /* 14855 */ "TestCEReactionsInterface" "\0"
  /* 14880 */ "TestCImplementedInterface" "\0"
  /* 14906 */ "TestCImplementedInterface2" "\0"
  /* 14933 */ "TestCallbackDictUnionOverload" "\0"
  /* 14963 */ "TestChildInterface" "\0"
  /* 14982 */ "TestConstructorForFuncInterface" "\0"
  /* 15014 */ "TestConstructorForPrefInterface" "\0"
  /* 15046 */ "TestConstructorForSCInterface" "\0"
  /* 15076 */ "TestCppKeywordNamedMethodsInterface" "\0"
  /* 15112 */ "TestDeprecatedInterface" "\0"
  /* 15136 */ "TestExampleInterface" "\0"
  /* 15157 */ "TestExampleProxyInterface" "\0"
  /* 15183 */ "TestExampleThrowingConstructorInterface" "\0"
  /* 15223 */ "TestExampleWorkerInterface" "\0"
  /* 15250 */ "TestFuncConstructorForDifferentFuncInterface" "\0"
  /* 15295 */ "TestFuncConstructorForInterface" "\0"
  /* 15327 */ "TestHTMLConstructorInterface" "\0"
  /* 15356 */ "TestIndexedAndNamedGetterAndSetterInterface" "\0"
  /* 15400 */ "TestIndexedAndNamedGetterInterface" "\0"
  /* 15435 */ "TestIndexedAndNamedSetterInterface" "\0"
  /* 15470 */ "TestIndexedGetterAndSetterAndNamedGetterInterface" "\0"
  /* 15520 */ "TestIndexedGetterInterface" "\0"
  /* 15547 */ "TestIndexedSetterInterface" "\0"
  /* 15574 */ "TestInterface" "\0"
  /* 15588 */ "TestInterfaceWithPromiseConstructorArg" "\0"
  /* 15627 */ "TestJSImplInterface" "\0"
  /* 15647 */ "TestJSImplInterface2" "\0"
  /* 15668 */ "TestJSImplInterface3" "\0"
  /* 15689 */ "TestJSImplInterface4" "\0"
  /* 15710 */ "TestJSImplInterface5" "\0"
  /* 15731 */ "TestJSImplInterface6" "\0"
  /* 15752 */ "TestJSImplNoInterfaceObject" "\0"
  /* 15780 */ "TestLegacyFactoryFunctionInterface" "\0"
  /* 15815 */ "TestLegacyFactoryFunctionInterface2" "\0"
  /* 15851 */ "TestNamedDeleterInterface" "\0"
  /* 15877 */ "TestNamedDeleterWithRetvalInterface" "\0"
  /* 15913 */ "TestNamedGetterInterface" "\0"
  /* 15938 */ "TestNamedSetterInterface" "\0"
  /* 15963 */ "TestNamespace" "\0"
  /* 15977 */ "TestNonWrapperCacheInterface" "\0"
  /* 16006 */ "TestParentInterface" "\0"
  /* 16026 */ "TestPrefChromeOnlySCFuncConstructorForInterface" "\0"
  /* 16074 */ "TestPrefConstructorForDifferentPrefInterface" "\0"
  /* 16119 */ "TestPrefConstructorForInterface" "\0"
  /* 16151 */ "TestProtoObjectHackedNamespace" "\0"
  /* 16182 */ "TestRenamedInterface" "\0"
  /* 16203 */ "TestRenamedNamespace" "\0"
  /* 16224 */ "TestSCConstructorForInterface" "\0"
  /* 16254 */ "TestSecureContextInterface" "\0"
  /* 16281 */ "TestThrowingConstructorInterface" "\0"
  /* 16314 */ "TestUtils" "\0"
  /* 16324 */ "TestWorkerExposedInterface" "\0"
  /* 16351 */ "TestingDeprecatedInterface" "\0"
  /* 16378 */ "Text" "\0"
  /* 16383 */ "TextClause" "\0"
  /* 16394 */ "TextDecoder" "\0"
  /* 16406 */ "TextDecoderStream" "\0"
  /* 16424 */ "TextEncoder" "\0"
  /* 16436 */ "TextEncoderStream" "\0"
  /* 16454 */ "TextEvent" "\0"
  /* 16464 */ "TextMetrics" "\0"
  /* 16476 */ "TextTrack" "\0"
  /* 16486 */ "TextTrackCue" "\0"
  /* 16499 */ "TextTrackCueList" "\0"
  /* 16516 */ "TextTrackList" "\0"
  /* 16530 */ "TimeEvent" "\0"
  /* 16540 */ "TimeRanges" "\0"
  /* 16551 */ "ToggleEvent" "\0"
  /* 16563 */ "Touch" "\0"
  /* 16569 */ "TouchEvent" "\0"
  /* 16580 */ "TouchList" "\0"
  /* 16590 */ "TrackEvent" "\0"
  /* 16601 */ "TransformStream" "\0"
  /* 16617 */ "TransformStreamDefaultController" "\0"
  /* 16650 */ "TransitionEvent" "\0"
  /* 16666 */ "TreeColumn" "\0"
  /* 16677 */ "TreeColumns" "\0"
  /* 16689 */ "TreeContentView" "\0"
  /* 16705 */ "TreeWalker" "\0"
  /* 16716 */ "TrustedHTML" "\0"
  /* 16728 */ "TrustedScript" "\0"
  /* 16742 */ "TrustedScriptURL" "\0"
  /* 16759 */ "TrustedTypePolicy" "\0"
  /* 16777 */ "TrustedTypePolicyFactory" "\0"
  /* 16802 */ "UDPMessageEvent" "\0"
  /* 16818 */ "UDPSocket" "\0"
  /* 16828 */ "UIEvent" "\0"
  /* 16836 */ "URL" "\0"
  /* 16840 */ "URLSearchParams" "\0"
  /* 16856 */ "URLSearchParams Iterator" "\0"
  /* 16881 */ "UniFFIPointer" "\0"
  /* 16895 */ "UniFFIScaffolding" "\0"
  /* 16913 */ "UserActivation" "\0"
  /* 16928 */ "UserInteraction" "\0"
  /* 16944 */ "UserProximityEvent" "\0"
  /* 16963 */ "VRDisplay" "\0"
  /* 16973 */ "VRDisplayCapabilities" "\0"
  /* 16995 */ "VRDisplayEvent" "\0"
  /* 17010 */ "VREyeParameters" "\0"
  /* 17026 */ "VRFieldOfView" "\0"
  /* 17040 */ "VRFrameData" "\0"
  /* 17052 */ "VRMockController" "\0"
  /* 17069 */ "VRMockDisplay" "\0"
  /* 17083 */ "VRPose" "\0"
  /* 17090 */ "VRServiceTest" "\0"
  /* 17104 */ "VRStageParameters" "\0"
  /* 17122 */ "VTTCue" "\0"
  /* 17129 */ "VTTRegion" "\0"
  /* 17139 */ "ValidityState" "\0"
  /* 17153 */ "VideoColorSpace" "\0"
  /* 17169 */ "VideoDecoder" "\0"
  /* 17182 */ "VideoEncoder" "\0"
  /* 17195 */ "VideoFrame" "\0"
  /* 17206 */ "VideoPlaybackQuality" "\0"
  /* 17227 */ "VideoTrack" "\0"
  /* 17238 */ "VideoTrackList" "\0"
  /* 17253 */ "ViewTransition" "\0"
  /* 17268 */ "VisualViewport" "\0"
  /* 17283 */ "WEBGL_color_buffer_float" "\0"
  /* 17308 */ "WEBGL_compressed_texture_astc" "\0"
  /* 17338 */ "WEBGL_compressed_texture_etc" "\0"
  /* 17367 */ "WEBGL_compressed_texture_etc1" "\0"
  /* 17397 */ "WEBGL_compressed_texture_pvrtc" "\0"
  /* 17428 */ "WEBGL_compressed_texture_s3tc" "\0"
  /* 17458 */ "WEBGL_compressed_texture_s3tc_srgb" "\0"
  /* 17493 */ "WEBGL_debug_renderer_info" "\0"
  /* 17519 */ "WEBGL_debug_shaders" "\0"
  /* 17539 */ "WEBGL_depth_texture" "\0"
  /* 17559 */ "WEBGL_draw_buffers" "\0"
  /* 17578 */ "WEBGL_explicit_present" "\0"
  /* 17601 */ "WEBGL_lose_context" "\0"
  /* 17620 */ "WEBGL_provoking_vertex" "\0"
  /* 17643 */ "WGSLLanguageFeatures" "\0"
  /* 17664 */ "WakeLock" "\0"
  /* 17673 */ "WakeLockSentinel" "\0"
  /* 17690 */ "WaveShaperNode" "\0"
  /* 17705 */ "WebExtensionContentScript" "\0"
  /* 17731 */ "WebExtensionPolicy" "\0"
  /* 17750 */ "WebGL2RenderingContext" "\0"
  /* 17773 */ "WebGLActiveInfo" "\0"
  /* 17789 */ "WebGLBuffer" "\0"
  /* 17801 */ "WebGLContextEvent" "\0"
  /* 17819 */ "WebGLFramebuffer" "\0"
  /* 17836 */ "WebGLProgram" "\0"
  /* 17849 */ "WebGLQuery" "\0"
  /* 17860 */ "WebGLRenderbuffer" "\0"
  /* 17878 */ "WebGLRenderingContext" "\0"
  /* 17900 */ "WebGLSampler" "\0"
  /* 17913 */ "WebGLShader" "\0"
  /* 17925 */ "WebGLShaderPrecisionFormat" "\0"
  /* 17952 */ "WebGLSync" "\0"
  /* 17962 */ "WebGLTexture" "\0"
  /* 17975 */ "WebGLTransformFeedback" "\0"
  /* 17998 */ "WebGLUniformLocation" "\0"
  /* 18019 */ "WebGLVertexArrayObject" "\0"
  /* 18042 */ "WebKitCSSMatrix" "\0"
  /* 18058 */ "WebSocket" "\0"
  /* 18068 */ "WebTransport" "\0"
  /* 18081 */ "WebTransportBidirectionalStream" "\0"
  /* 18113 */ "WebTransportDatagramDuplexStream" "\0"
  /* 18146 */ "WebTransportError" "\0"
  /* 18164 */ "WebTransportReceiveStream" "\0"
  /* 18190 */ "WebTransportSendStream" "\0"
  /* 18213 */ "WebrtcGlobalInformation" "\0"
  /* 18237 */ "WheelEvent" "\0"
  /* 18248 */ "Window" "\0"
  /* 18255 */ "WindowClient" "\0"
  /* 18268 */ "WindowContext" "\0"
  /* 18282 */ "WindowGlobalChild" "\0"
  /* 18300 */ "WindowGlobalParent" "\0"
  /* 18319 */ "WindowRoot" "\0"
  /* 18330 */ "Worker" "\0"
  /* 18337 */ "WorkerDebuggerGlobalScope" "\0"
  /* 18363 */ "WorkerGlobalScope" "\0"
  /* 18381 */ "WorkerLocation" "\0"
  /* 18396 */ "WorkerNavigator" "\0"
  /* 18412 */ "WorkerTestUtils" "\0"
  /* 18428 */ "Worklet" "\0"
  /* 18436 */ "WorkletGlobalScope" "\0"
  /* 18455 */ "WritableStream" "\0"
  /* 18470 */ "WritableStreamDefaultController" "\0"
  /* 18502 */ "WritableStreamDefaultWriter" "\0"
  /* 18530 */ "XMLDocument" "\0"
  /* 18542 */ "XMLHttpRequest" "\0"
  /* 18557 */ "XMLHttpRequestEventTarget" "\0"
  /* 18583 */ "XMLHttpRequestUpload" "\0"
  /* 18604 */ "XMLSerializer" "\0"
  /* 18618 */ "XPathEvaluator" "\0"
  /* 18633 */ "XPathExpression" "\0"
  /* 18649 */ "XPathResult" "\0"
  /* 18661 */ "XRBoundedReferenceSpace" "\0"
  /* 18685 */ "XRFrame" "\0"
  /* 18693 */ "XRInputSource" "\0"
  /* 18707 */ "XRInputSourceArray" "\0"
  /* 18726 */ "XRInputSourceEvent" "\0"
  /* 18745 */ "XRInputSourcesChangeEvent" "\0"
  /* 18771 */ "XRPose" "\0"
  /* 18778 */ "XRReferenceSpace" "\0"
  /* 18795 */ "XRReferenceSpaceEvent" "\0"
  /* 18817 */ "XRRenderState" "\0"
  /* 18831 */ "XRRigidTransform" "\0"
  /* 18848 */ "XRSession" "\0"
  /* 18858 */ "XRSessionEvent" "\0"
  /* 18873 */ "XRSpace" "\0"
  /* 18881 */ "XRSystem" "\0"
  /* 18890 */ "XRView" "\0"
  /* 18897 */ "XRViewerPose" "\0"
  /* 18910 */ "XRViewport" "\0"
  /* 18921 */ "XRWebGLLayer" "\0"
  /* 18934 */ "XSLTProcessor" "\0"
  /* 18948 */ "XULCommandEvent" "\0"
  /* 18964 */ "XULElement" "\0"
  /* 18975 */ "XULFrameElement" "\0"
  /* 18991 */ "XULMenuElement" "\0"
  /* 19006 */ "XULPopupElement" "\0"
  /* 19022 */ "XULResizerElement" "\0"
  /* 19040 */ "XULTextElement" "\0"
  /* 19055 */ "XULTreeElement" "\0"
  /* 19070 */ "console" "\0"
  /* 19078 */ "webkitSpeechGrammar" "\0"
  /* 19098 */ "webkitSpeechGrammarList" "\0"
  /* 19122 */ "webkitSpeechRecognition" "\0"
  /* 19146 */ "webkitURL"
};

}  // namespace binding_detail

// Making this enum bigger than a uint16_t has consequences on the size
// of some structs (eg. WebIDLNameTableEntry) and tables. We should try
// to avoid that.
static_assert(EnumTypeFitsWithin<BindingNamesOffset, uint16_t>::value,
              "Size increase");

} // namespace mozilla::dom

