// -*- mode: Rust -*-

// AUTOGENERATED BY glean_parser.  DO NOT EDIT.

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */


pub enum DynamicLabel { }

pub mod a11y {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from a11y.always_underline_links
    ///
    /// Bool tracking if the user has always underline links enabled in firefox. This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// a11y.always_underline_links.
    pub static always_underline_links: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "always_underline_links".into(),
                category: "a11y".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(1.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from a11y.backplate
    ///
    /// Boolean tracking if the user has the backplate preference enabled or disabled.
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// a11y.backplate.
    pub static backplate: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "backplate".into(),
                category: "a11y".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(2.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from a11y.hcm_background
    ///
    /// Unsigned int tracking the user's prefered background color \ (logged when HCM
    /// is enabled). This metric was generated to correspond to the Legacy Telemetry
    /// scalar a11y.HCM_background.
    pub static hcm_background: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "hcm_background".into(),
                category: "a11y".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from a11y.hcm_foreground
    ///
    /// Unsigned int tracking the user's prefered foreground color \ (logged when HCM
    /// is enabled). This metric was generated to correspond to the Legacy Telemetry
    /// scalar a11y.HCM_foreground.
    pub static hcm_foreground: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "hcm_foreground".into(),
                category: "a11y".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from a11y.instantiators
    ///
    /// The leaf name and version number of the binary for the process responsible for
    /// remotely instantiating a11y. This metric was generated to correspond to the
    /// Legacy Telemetry scalar a11y.instantiators.
    pub static instantiators: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "instantiators".into(),
                category: "a11y".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(5.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from a11y.invert_colors
    ///
    /// Boolean tracking if the user has an invert colors OS setting enabled. This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// a11y.invert_colors.
    pub static invert_colors: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "invert_colors".into(),
                category: "a11y".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(6.into(), meta)
    });

    #[repr(u16)]
    pub enum ThemeLabel {
        EDefault = 0,
        EAlways = 1,
        ENever = 2,
        __Other__,
    }
    impl From<u16> for ThemeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDefault,
                1 => Self::EAlways,
                2 => Self::ENever,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ThemeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDefault => "default",
                Self::EAlways => "always",
                Self::ENever => "never",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from a11y.theme
    ///
    /// OS high contrast or other accessibility theme is enabled. The result is split
    /// into keys which represent the values of browser.display.document_color_use:
    /// "default", "always", or "never". This metric was generated to correspond to the
    /// Legacy Telemetry scalar a11y.theme.
    pub static theme: Lazy<LabeledMetric<LabeledBooleanMetric, ThemeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "theme".into(),
                    category: "a11y".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(7.into(), meta, Some(vec![::std::borrow::Cow::from("always"), ::std::borrow::Cow::from("default"), ::std::borrow::Cow::from("never")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from a11y.use_system_colors
    ///
    /// Bool tracking if the user has system colors enabled in firefox. This metric was
    /// generated to correspond to the Legacy Telemetry scalar a11y.use_system_colors.
    pub static use_system_colors: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "use_system_colors".into(),
                category: "a11y".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(8.into(), meta)
    });

}
pub mod privacy_sanitize {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClearExtra {
        pub r#cache: Option<bool>,
        pub r#context: Option<String>,
        pub r#cookies_and_storage: Option<bool>,
        pub r#history_form_data_downloads: Option<bool>,
        pub r#site_settings: Option<bool>,
    }

    impl ExtraKeys for ClearExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cache", "context", "cookies_and_storage", "history_form_data_downloads", "site_settings"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cache.and_then(|val| map.insert("cache".into(), val.to_string()));
          self.r#context.and_then(|val| map.insert("context".into(), val.to_string()));
          self.r#cookies_and_storage.and_then(|val| map.insert("cookies_and_storage".into(), val.to_string()));
          self.r#history_form_data_downloads.and_then(|val| map.insert("history_form_data_downloads".into(), val.to_string()));
          self.r#site_settings.and_then(|val| map.insert("site_settings".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from privacy.sanitize.clear
    ///
    /// Dispatched when the dialog is accepted (to clear)
    pub static clear: Lazy<EventMetric<ClearExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "clear".into(),
                category: "privacy.sanitize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(9.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClearingTimeSpanSelectedExtra {
        pub r#time_span: Option<String>,
    }

    impl ExtraKeys for ClearingTimeSpanSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["time_span"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#time_span.and_then(|val| map.insert("time_span".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from privacy.sanitize.clearing_time_span_selected
    ///
    /// The time span range selected to sanitize
    pub static clearing_time_span_selected: Lazy<EventMetric<ClearingTimeSpanSelectedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "clearing_time_span_selected".into(),
                category: "privacy.sanitize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(10.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DialogOpenExtra {
        pub r#context: Option<String>,
    }

    impl ExtraKeys for DialogOpenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["context"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#context.and_then(|val| map.insert("context".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from privacy.sanitize.dialog_open
    ///
    /// Dispatched when one of the sanitize dialogs opens
    pub static dialog_open: Lazy<EventMetric<DialogOpenExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dialog_open".into(),
                category: "privacy.sanitize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(11.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from privacy.sanitize.load_time
    ///
    /// How much time was spent to open the dialog, including loading data sizes
    pub static load_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_time".into(),
                category: "privacy.sanitize".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(12.into(), meta, TimeUnit::Millisecond)
    });

}
pub mod security_ui_protectionspopup {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_cookieb_toggle_off
    ///
    /// User interaction by click events in the protections panel. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protectionspopup.click#cookieb_toggle_off.
    pub static click_cookieb_toggle_off: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_cookieb_toggle_off".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(13.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_cookieb_toggle_on
    ///
    /// User interaction by click events in the protections panel. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protectionspopup.click#cookieb_toggle_on.
    pub static click_cookieb_toggle_on: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_cookieb_toggle_on".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(14.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_cookies
    ///
    /// User interaction by click events in the protections panel. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protectionspopup.click#cookies.
    pub static click_cookies: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_cookies".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(15.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_cryptominers
    ///
    /// User interaction by click events in the protections panel. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protectionspopup.click#cryptominers.
    pub static click_cryptominers: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_cryptominers".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(16.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_etp_toggle_off
    ///
    /// User interaction by click events in the protections panel. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protectionspopup.click#etp_toggle_off.
    pub static click_etp_toggle_off: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_etp_toggle_off".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(17.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_etp_toggle_on
    ///
    /// User interaction by click events in the protections panel. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protectionspopup.click#etp_toggle_on.
    pub static click_etp_toggle_on: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_etp_toggle_on".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(18.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_fingerprinters
    ///
    /// User interaction by click events in the protections panel. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protectionspopup.click#fingerprinters.
    pub static click_fingerprinters: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_fingerprinters".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(19.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_full_report
    ///
    /// User interaction by click events in the protections panel. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protectionspopup.click#full_report.
    pub static click_full_report: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_full_report".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(20.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_milestone_message
    ///
    /// User interaction by click events in the protections panel. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protectionspopup.click#milestone_message.
    pub static click_milestone_message: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_milestone_message".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(21.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickProtectionspopupCfrExtra {
        pub r#message: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickProtectionspopupCfrExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["message", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#message.and_then(|val| map.insert("message".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_protectionspopup_cfr
    ///
    /// User interaction by click events in the protections panel. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protectionspopup.click#protectionspopup_cfr.
    pub static click_protectionspopup_cfr: Lazy<EventMetric<ClickProtectionspopupCfrExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_protectionspopup_cfr".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(22.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_settings
    ///
    /// User interaction by click events in the protections panel. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protectionspopup.click#settings.
    pub static click_settings: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_settings".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(23.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_social
    ///
    /// User interaction by click events in the protections panel. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protectionspopup.click#social.
    pub static click_social: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_social".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(24.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSubviewSettingsExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickSubviewSettingsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_subview_settings
    ///
    /// User interaction by click events in the protections panel. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protectionspopup.click#subview_settings.
    pub static click_subview_settings: Lazy<EventMetric<ClickSubviewSettingsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_subview_settings".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(25.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_trackers
    ///
    /// User interaction by click events in the protections panel. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protectionspopup.click#trackers.
    pub static click_trackers: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_trackers".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(26.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.open_protections_popup
    ///
    /// How many times the protections panel was opened. This event was generated to
    /// correspond to the Legacy Telemetry event
    /// security.ui.protectionspopup.open#protections_popup.
    pub static open_protections_popup: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_protections_popup".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(27.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenProtectionspopupCfrExtra {
        pub r#message: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for OpenProtectionspopupCfrExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["message", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#message.and_then(|val| map.insert("message".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.open_protectionspopup_cfr
    ///
    /// How many times the protections panel was opened. This event was generated to
    /// correspond to the Legacy Telemetry event
    /// security.ui.protectionspopup.open#protectionspopup_cfr.
    pub static open_protectionspopup_cfr: Lazy<EventMetric<OpenProtectionspopupCfrExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_protectionspopup_cfr".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(28.into(), meta)
    });

}
pub mod browser_backup {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.browser_extension_data_size
    ///
    /// The total size of the current profiles storage.local legacy JSON backend in the
    /// browser-extension-data directory, rounded to the nearest 10 kilobytes.
    pub static browser_extension_data_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "browser_extension_data_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(29.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.compressed_archive_size
    ///
    /// The total compressed size of a single-file profile data backup archive. To
    /// reduce fingerprintability, we round to the nearest 1 mebibyte.
    pub static compressed_archive_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "compressed_archive_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(30.into(), meta, MemoryUnit::Megabyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.cookies_size
    ///
    /// The total file size of the cookies.sqlite db located in the current profile
    /// directory, in kilobytes.
    pub static cookies_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookies_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(31.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.credentials_data_size
    ///
    /// The total size of logins, payment method, and form autofill related files in
    /// the current profile directory, in kilobytes.
    pub static credentials_data_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "credentials_data_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(32.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.extension_store_permissions_data_size
    ///
    /// The file size of the current profiles extension-store-permissions/data.safe.bin
    /// file, rounded to the nearest 10 kilobytes.
    pub static extension_store_permissions_data_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "extension_store_permissions_data_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(33.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.extensions_json_size
    ///
    /// The total file size of the current profiles extensions metadata files, rounded
    /// to the nearest 10 kilobytes. Files included are:
    ///   - extensions.json
    ///   - extension-settings.json
    ///   - extension-preferences.json
    ///   - addonStartup.json.lz4
    pub static extensions_json_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "extensions_json_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(34.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.extensions_storage_size
    ///
    /// The total size of all extensions storage directories, rounded to the nearest 10
    /// kilobytes.
    pub static extensions_storage_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "extensions_storage_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(35.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.extensions_xpi_directory_size
    ///
    /// The total size of the current profiles extensions directory, rounded to the
    /// nearest 10 kilobytes.
    pub static extensions_xpi_directory_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "extensions_xpi_directory_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(36.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.favicons_size
    ///
    /// The total file size of the favicons.sqlite db located in the current profile
    /// directory, in kilobytes.
    pub static favicons_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "favicons_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(37.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.favicons_time
    ///
    /// Total time, in milliseconds, required to back up a profile's favicons database.
    pub static favicons_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "favicons_time".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(38.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.form_history_size
    ///
    /// The file size of the formhistory.sqlite db located in the current profile
    /// directory, in kilobytes.
    pub static form_history_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "form_history_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(39.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.misc_data_size
    ///
    /// The total size of files for telemetry, site storage, media device origin
    /// mapping, chrome privileged IndexedDB databases, and Mozilla Accounts in the
    /// current profile directory, rounded to the nearest tenth kilobyte.
    pub static misc_data_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "misc_data_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(40.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.places_size
    ///
    /// The total file size of the places.sqlite db located in the current profile
    /// directory, in kilobytes.
    pub static places_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "places_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(41.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.places_time
    ///
    /// Total time, in milliseconds, required to back up a profile's places database.
    pub static places_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "places_time".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(42.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.preferences_size
    ///
    /// The total size of files relating to user preferences and permissions in the
    /// current profile directory, in kilobytes.
    pub static preferences_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "preferences_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(43.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.prof_d_disk_space
    ///
    /// The total disk space available on the storage device that the profile directory
    /// is stored on. To reduce fingerprintability, we round to the nearest 10
    /// megabytes and return the result in kilobytes.
    pub static prof_d_disk_space: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prof_d_disk_space".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(44.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.security_data_size
    ///
    /// The total size of files needed for NSS initialization parameters and security
    /// certificate settings in the current profile directory, in kilobytes.
    pub static security_data_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "security_data_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(45.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.session_store_backups_directory_size
    ///
    /// The total size of the session store backups directory, in kilobytes.
    pub static session_store_backups_directory_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "session_store_backups_directory_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(46.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.session_store_size
    ///
    /// The size of uncompressed session store json, in kilobytes.
    pub static session_store_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "session_store_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(47.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.storage_sync_size
    ///
    /// The file size of the current profiles storage-sync-v2.sqlite db, rounded to the
    /// nearest 10 kilobytes.
    pub static storage_sync_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "storage_sync_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(48.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.total_backup_size
    ///
    /// The total uncompressed size of all profile data included in a completed backup.
    /// To reduce fingerprintability, we round to the nearest 1 mebibyte.
    pub static total_backup_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_backup_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(49.into(), meta, MemoryUnit::Megabyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.total_backup_time
    ///
    /// Total time elapsed, in milliseconds, between the start and end of the profile
    /// backup creation process
    pub static total_backup_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_backup_time".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(50.into(), meta, TimeUnit::Millisecond)
    });

}
pub mod doh {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EvaluateV2HeuristicsExtra {
        pub r#canaries: Option<String>,
        pub r#captiveState: Option<String>,
        pub r#enterprise: Option<String>,
        pub r#evaluateReason: Option<String>,
        pub r#filtering: Option<String>,
        pub r#networkID: Option<String>,
        pub r#platform: Option<String>,
        pub r#steeredProvider: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EvaluateV2HeuristicsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["canaries", "captiveState", "enterprise", "evaluateReason", "filtering", "networkID", "platform", "steeredProvider", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#canaries.and_then(|val| map.insert("canaries".into(), val.to_string()));
          self.r#captiveState.and_then(|val| map.insert("captiveState".into(), val.to_string()));
          self.r#enterprise.and_then(|val| map.insert("enterprise".into(), val.to_string()));
          self.r#evaluateReason.and_then(|val| map.insert("evaluateReason".into(), val.to_string()));
          self.r#filtering.and_then(|val| map.insert("filtering".into(), val.to_string()));
          self.r#networkID.and_then(|val| map.insert("networkID".into(), val.to_string()));
          self.r#platform.and_then(|val| map.insert("platform".into(), val.to_string()));
          self.r#steeredProvider.and_then(|val| map.insert("steeredProvider".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from doh.evaluate_v2_heuristics
    ///
    /// Results of DoH heuristics at startup and after network changes. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// doh.evaluate_v2#heuristics.
    pub static evaluate_v2_heuristics: Lazy<EventMetric<EvaluateV2HeuristicsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "evaluate_v2_heuristics".into(),
                category: "doh".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(51.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StateDisabledExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for StateDisabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from doh.state_disabled
    ///
    /// Results of DoH heuristics at startup and after network changes. This event was
    /// generated to correspond to the Legacy Telemetry event doh.state#disabled.
    pub static state_disabled: Lazy<EventMetric<StateDisabledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_disabled".into(),
                category: "doh".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(52.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StateEnabledExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for StateEnabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from doh.state_enabled
    ///
    /// Results of DoH heuristics at startup and after network changes. This event was
    /// generated to correspond to the Legacy Telemetry event doh.state#enabled.
    pub static state_enabled: Lazy<EventMetric<StateEnabledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_enabled".into(),
                category: "doh".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(53.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StateManuallyDisabledExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for StateManuallyDisabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from doh.state_manually_disabled
    ///
    /// Results of DoH heuristics at startup and after network changes. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// doh.state#manuallyDisabled.
    pub static state_manually_disabled: Lazy<EventMetric<StateManuallyDisabledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_manually_disabled".into(),
                category: "doh".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(54.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StatePolicyDisabledExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for StatePolicyDisabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from doh.state_policy_disabled
    ///
    /// Results of DoH heuristics at startup and after network changes. This event was
    /// generated to correspond to the Legacy Telemetry event doh.state#policyDisabled.
    pub static state_policy_disabled: Lazy<EventMetric<StatePolicyDisabledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_policy_disabled".into(),
                category: "doh".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(55.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StateRollbackExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for StateRollbackExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from doh.state_rollback
    ///
    /// Results of DoH heuristics at startup and after network changes. This event was
    /// generated to correspond to the Legacy Telemetry event doh.state#rollback.
    pub static state_rollback: Lazy<EventMetric<StateRollbackExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_rollback".into(),
                category: "doh".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(56.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StateShutdownExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for StateShutdownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from doh.state_shutdown
    ///
    /// Results of DoH heuristics at startup and after network changes. This event was
    /// generated to correspond to the Legacy Telemetry event doh.state#shutdown.
    pub static state_shutdown: Lazy<EventMetric<StateShutdownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_shutdown".into(),
                category: "doh".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(57.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StateUidisabledExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for StateUidisabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from doh.state_uidisabled
    ///
    /// Results of DoH heuristics at startup and after network changes. This event was
    /// generated to correspond to the Legacy Telemetry event doh.state#UIDisabled.
    pub static state_uidisabled: Lazy<EventMetric<StateUidisabledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_uidisabled".into(),
                category: "doh".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(58.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StateUiokExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for StateUiokExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from doh.state_uiok
    ///
    /// Results of DoH heuristics at startup and after network changes. This event was
    /// generated to correspond to the Legacy Telemetry event doh.state#UIOk.
    pub static state_uiok: Lazy<EventMetric<StateUiokExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_uiok".into(),
                category: "doh".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(59.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StateUninstalledExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for StateUninstalledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from doh.state_uninstalled
    ///
    /// Results of DoH heuristics at startup and after network changes. This event was
    /// generated to correspond to the Legacy Telemetry event doh.state#uninstalled.
    pub static state_uninstalled: Lazy<EventMetric<StateUninstalledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_uninstalled".into(),
                category: "doh".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(60.into(), meta)
    });

}
pub mod networking {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from networking.doh_heuristic_ever_tripped
    ///
    /// True if this heuristic (key) was ever tripped during the session. This metric
    /// was generated to correspond to the Legacy Telemetry scalar
    /// networking.doh_heuristic_ever_tripped.
    pub static doh_heuristic_ever_tripped: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "doh_heuristic_ever_tripped".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(61.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.doh_heuristics_attempts
    ///
    /// The number of times we ran DoH heuristics. This metric was generated to
    /// correspond to the Legacy Telemetry scalar networking.doh_heuristics_attempts.
    pub static doh_heuristics_attempts: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            62,
            "networking",
            "doh_heuristics_attempts",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.doh_heuristics_pass_count
    ///
    /// The number of times we passed DoH heuristics. This metric was generated to
    /// correspond to the Legacy Telemetry scalar networking.doh_heuristics_pass_count.
    pub static doh_heuristics_pass_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            63,
            "networking",
            "doh_heuristics_pass_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.doh_heuristics_result
    ///
    /// The value of this scalar indicates the result of the last heuristic run. 0:
    /// "incomplete" 1: "pass" 2: "opt-out" 3: "manually-disabled" 4: "manually-
    /// enabled" 5: "enterprise-disabled" 6: "enterprise- present" 7: "enterprise-
    /// enabled" 8: "vpn" 9: "proxy" 10: "nrpt" 11: "parental" 12: "modifiedRoots" 13:
    /// "thirdPartyRoots" 14: "google" 15: "youtube" 16: "zscaler" 17: "canary" 18:
    /// "ignored" This metric was generated to correspond to the Legacy Telemetry
    /// scalar networking.doh_heuristics_result.
    pub static doh_heuristics_result: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "doh_heuristics_result".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(64.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cache_metadata_first_read_time
    ///
    /// Time spent to read the first part of the metadata from the cache entry file.
    pub static cache_metadata_first_read_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cache_metadata_first_read_time".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(65.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cache_metadata_second_read_time
    ///
    /// Time spent to read the missing part of the metadata from the cache entry file.
    pub static cache_metadata_second_read_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cache_metadata_second_read_time".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(66.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cache_metadata_size
    ///
    /// Size of the metadata in bytes parsed from the disk.
    pub static cache_metadata_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cache_metadata_size".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(67.into(), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_access_fixup_diff
    ///
    /// If we fix up a cookie lastAccessed timestamp that is in the future this metric
    /// records the number of seconds that timestamp was off from NOW.
    pub static cookie_access_fixup_diff: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_access_fixup_diff".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(68.into(), meta, 0, 315360000000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_chips_partition_limit_overflow
    ///
    /// The number of cookie bytes exceeding chips partition limit capacity for a
    /// single partition
    pub static cookie_chips_partition_limit_overflow: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_chips_partition_limit_overflow".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(69.into(), meta, 0, 16000000, 22, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_count_part_by_key
    ///
    /// A distribution of the partitioned cookies in storage belonging to a particular
    /// cookie key (host + origin attributes)
    pub static cookie_count_part_by_key: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_count_part_by_key".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(70.into(), meta, 1, 220, 10, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_count_partitioned
    ///
    /// Reports the number of partitioned cookies in storage
    pub static cookie_count_partitioned: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_count_partitioned".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(71.into(), meta, 0, 4000, 22, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_count_total
    ///
    /// Reports the total number of cookies in storage
    pub static cookie_count_total: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_count_total".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(72.into(), meta, 0, 4000, 22, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_count_unpart_by_key
    ///
    /// A distribution of the unpartitioned cookies in storage belonging to a
    /// particular cookie key (host + origin attributes)
    pub static cookie_count_unpart_by_key: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_count_unpart_by_key".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(73.into(), meta, 1, 220, 10, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_count_unpartitioned
    ///
    /// Reports the number of unpartitioned cookies in storage
    pub static cookie_count_unpartitioned: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_count_unpartitioned".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(74.into(), meta, 0, 4000, 22, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_creation_fixup_diff
    ///
    /// If we fix up a cookie creation timestamp that is in the future this metric
    /// records the number of seconds that timestamp was off from NOW.
    pub static cookie_creation_fixup_diff: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_creation_fixup_diff".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(75.into(), meta, 0, 315360000000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_purge_entry_max
    ///
    /// A distribution of the number of cookies purged for a single host + OA entry as
    /// a result of exceeding the maximum threshold for the given host + OA (single
    /// purge)
    pub static cookie_purge_entry_max: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_purge_entry_max".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(76.into(), meta, 1, 220, 10, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_purge_max
    ///
    /// A distribution of the number of cookies purged across all host + OAs as a
    /// result of exceeding the cookie maximum threshold (single purge)
    pub static cookie_purge_max: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_purge_max".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(77.into(), meta, 1, 4000, 22, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum CookieTimestampFixedCountLabel {
        ECreationtime = 0,
        ELastaccessed = 1,
        __Other__,
    }
    impl From<u16> for CookieTimestampFixedCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECreationtime,
                1 => Self::ELastaccessed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CookieTimestampFixedCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECreationtime => "creationTime",
                Self::ELastaccessed => "lastAccessed",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_timestamp_fixed_count
    ///
    /// Counts the number of times a cookie's invalid timestamp was fixed when reading
    /// it from the DB.
    pub static cookie_timestamp_fixed_count: Lazy<LabeledMetric<LabeledCounterMetric, CookieTimestampFixedCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cookie_timestamp_fixed_count".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(78.into(), meta, Some(vec![::std::borrow::Cow::from("creationTime"), ::std::borrow::Cow::from("lastAccessed")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.dns_failed_lookup_time
    ///
    /// Time for an unsuccessful DNS OS resolution (msec) | Migrated from Firefox
    /// Telemetry's `DNS_FAILED_LOOKUP_TIME`.
    pub static dns_failed_lookup_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dns_failed_lookup_time".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(79.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.dns_lookup_time
    ///
    /// Time for a successful DNS resolution (msec) | Migrated from Firefox Telemetry's
    /// `DNS_LOOKUP_TIME`.
    pub static dns_lookup_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dns_lookup_time".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(80.into(), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum DnsNativeCountLabel {
        ERegular = 0,
        EPrivate = 1,
        EHttpsRegular = 2,
        EHttpsPrivate = 3,
        __Other__,
    }
    impl From<u16> for DnsNativeCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ERegular,
                1 => Self::EPrivate,
                2 => Self::EHttpsRegular,
                3 => Self::EHttpsPrivate,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for DnsNativeCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ERegular => "regular",
                Self::EPrivate => "private",
                Self::EHttpsRegular => "https_regular",
                Self::EHttpsPrivate => "https_private",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.dns_native_count
    ///
    /// The count of calls to the native DNS APIs
    pub static dns_native_count: Lazy<LabeledMetric<LabeledCounterMetric, DnsNativeCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "dns_native_count".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(81.into(), meta, Some(vec![::std::borrow::Cow::from("https_private"), ::std::borrow::Cow::from("https_regular"), ::std::borrow::Cow::from("private"), ::std::borrow::Cow::from("regular")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.dns_native_https_call_time
    ///
    /// Time spent in the call to the native OS DNS resolution.
    pub static dns_native_https_call_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dns_native_https_call_time".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(82.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.dns_renewal_time
    ///
    /// Time for a renewed DNS OS resolution (msec) | Migrated from Firefox Telemetry's
    /// `DNS_RENEWAL_TIME`.
    pub static dns_renewal_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dns_renewal_time".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(83.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.dns_renewal_time_for_ttl
    ///
    /// Time for a DNS OS resolution (msec) used to get TTL | Migrated from Firefox
    /// Telemetry's `DNS_RENEWAL_TIME_FOR_TTL`.
    pub static dns_renewal_time_for_ttl: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dns_renewal_time_for_ttl".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(84.into(), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum FetchKeepaliveDiscardCountLabel {
        ETotalKeepaliveLimit = 0,
        EPerOriginLimit = 1,
        __Other__,
    }
    impl From<u16> for FetchKeepaliveDiscardCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ETotalKeepaliveLimit,
                1 => Self::EPerOriginLimit,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FetchKeepaliveDiscardCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ETotalKeepaliveLimit => "total_keepalive_limit",
                Self::EPerOriginLimit => "per_origin_limit",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.fetch_keepalive_discard_count
    ///
    /// Counts how many fetch keepalive requests are dropped due to configured resource
    /// limits.
    pub static fetch_keepalive_discard_count: Lazy<LabeledMetric<LabeledCounterMetric, FetchKeepaliveDiscardCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "fetch_keepalive_discard_count".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(85.into(), meta, Some(vec![::std::borrow::Cow::from("per_origin_limit"), ::std::borrow::Cow::from("total_keepalive_limit")]))
    });

    #[repr(u16)]
    pub enum FetchKeepaliveRequestCountLabel {
        EWorker = 0,
        EMain = 1,
        __Other__,
    }
    impl From<u16> for FetchKeepaliveRequestCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EWorker,
                1 => Self::EMain,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FetchKeepaliveRequestCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EWorker => "worker",
                Self::EMain => "main",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.fetch_keepalive_request_count
    ///
    /// Counts how many fetch keepalive requests are made. This counter helps us to
    /// understand the adoption of fetch keepalive for firefox.
    pub static fetch_keepalive_request_count: Lazy<LabeledMetric<LabeledCounterMetric, FetchKeepaliveRequestCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "fetch_keepalive_request_count".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(86.into(), meta, Some(vec![::std::borrow::Cow::from("main"), ::std::borrow::Cow::from("worker")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_1_download_throughput
    ///
    /// The download throughput for  http/1.0, http/1.1 requests larger than 10MB.
    /// Measured in megabits per second, Mbps.
    pub static http_1_download_throughput: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_1_download_throughput".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(87.into(), meta, 0, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_1_upload_throughput
    ///
    /// The upload throughput for http/1.0, http/1.1 requests larger than 10MB.
    /// Measured in megabits per second, Mbps.
    pub static http_1_upload_throughput: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_1_upload_throughput".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(88.into(), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_1_upload_throughput_100
    ///
    /// The upload throughput for http/1.0, http/1.1 request size larger than 100MB.
    /// Measured in megabits per second, Mbps.
    pub static http_1_upload_throughput_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_1_upload_throughput_100".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(89.into(), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_1_upload_throughput_10_50
    ///
    /// The upload throughput for http/1.0, http/1.1 request size between 10MB and
    /// 50MB. Measured in megabits per second, Mbps.
    pub static http_1_upload_throughput_10_50: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_1_upload_throughput_10_50".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(90.into(), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_1_upload_throughput_50_100
    ///
    /// The upload throughput for http/1.0, http/1.1 request size between 50MB and
    /// 100MB. Measured in megabits per second, Mbps.
    pub static http_1_upload_throughput_50_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_1_upload_throughput_50_100".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(91.into(), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_2_download_throughput
    ///
    /// The download throughput for http/2 requests larger than 10MB. Measured in
    /// megabits per second, Mbps.
    pub static http_2_download_throughput: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_2_download_throughput".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(92.into(), meta, 0, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_2_upload_throughput
    ///
    /// The upload throughput for http/2 requests larger than 10MB. Measured in
    /// megabits per second, Mbps.
    pub static http_2_upload_throughput: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_2_upload_throughput".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(93.into(), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_2_upload_throughput_100
    ///
    /// The upload throughput for http/2 request size larger than 100MB. Measured in
    /// megabits per second, Mbps.
    pub static http_2_upload_throughput_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_2_upload_throughput_100".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(94.into(), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_2_upload_throughput_10_50
    ///
    /// The upload throughput for http/2 request size between 10MB and 50MB. Measured
    /// in megabits per second, Mbps.
    pub static http_2_upload_throughput_10_50: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_2_upload_throughput_10_50".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(95.into(), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_2_upload_throughput_50_100
    ///
    /// The upload throughput for http/2 request size between 50MB and 100MB. Measured
    /// in megabits per second, Mbps.
    pub static http_2_upload_throughput_50_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_2_upload_throughput_50_100".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(96.into(), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_download_throughput
    ///
    /// The download throughput for http/3 requests larger than 10MB. Measured in
    /// megabits per second, Mbps.
    pub static http_3_download_throughput: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_download_throughput".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(97.into(), meta, 0, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_download_throughput_100
    ///
    /// The download throughput for http/3 requests size larger than 100MB. Measured in
    /// megabits per second, Mbps.
    pub static http_3_download_throughput_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_download_throughput_100".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(98.into(), meta, 0, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_download_throughput_10_50
    ///
    /// The download throughput for http/3 requests between 10MB and 50MB. Measured in
    /// megabits per second, Mbps.
    pub static http_3_download_throughput_10_50: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_download_throughput_10_50".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(99.into(), meta, 0, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_download_throughput_50_100
    ///
    /// The download throughput for http/3 requests between 50MB and 100MB. Measured in
    /// megabits per second, Mbps.
    pub static http_3_download_throughput_50_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_download_throughput_50_100".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(100.into(), meta, 0, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_ecn_ce_ect0_ratio_received
    ///
    /// HTTP3: ECN CE to ECT0 ratio (multiply by 10000) received.
    pub static http_3_ecn_ce_ect0_ratio_received: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_ecn_ce_ect0_ratio_received".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(101.into(), meta, 0, 2000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_ecn_ce_ect0_ratio_sent
    ///
    /// HTTP3: ECN CE to ECT0 ratio (multiply by 10000) sent.
    pub static http_3_ecn_ce_ect0_ratio_sent: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_ecn_ce_ect0_ratio_sent".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(102.into(), meta, 0, 2000, 100, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum Http3EcnPathCapabilityLabel {
        ECapable = 0,
        ENotCapable = 1,
        __Other__,
    }
    impl From<u16> for Http3EcnPathCapabilityLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECapable,
                1 => Self::ENotCapable,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Http3EcnPathCapabilityLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECapable => "capable",
                Self::ENotCapable => "not-capable",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_ecn_path_capability
    ///
    /// Number of paths known to be ECN capable or not-capable.
    pub static http_3_ecn_path_capability: Lazy<LabeledMetric<LabeledCounterMetric, Http3EcnPathCapabilityLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_3_ecn_path_capability".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(103.into(), meta, Some(vec![::std::borrow::Cow::from("capable"), ::std::borrow::Cow::from("not-capable")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_loss_ratio
    ///
    /// HTTP3: packet loss ratio (multiply by 10000).
    pub static http_3_loss_ratio: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_loss_ratio".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(104.into(), meta, 0, 2000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_udp_datagram_segment_size_received
    ///
    /// HTTP3 UDP datagram size received.
    pub static http_3_udp_datagram_segment_size_received: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_udp_datagram_segment_size_received".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(105.into(), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_udp_datagram_segment_size_sent
    ///
    /// HTTP3 UDP datagram segment size sent.
    pub static http_3_udp_datagram_segment_size_sent: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_udp_datagram_segment_size_sent".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(106.into(), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_udp_datagram_segments_received
    ///
    /// HTTP3 UDP number of segments per datagram received.
    pub static http_3_udp_datagram_segments_received: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_udp_datagram_segments_received".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(107.into(), meta, 0, 128, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_udp_datagram_size_received
    ///
    /// HTTP3 UDP datagram size received.
    pub static http_3_udp_datagram_size_received: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_udp_datagram_size_received".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(108.into(), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_upload_throughput
    ///
    /// The upload throughput for http/3 requests larger than 10MB. Measured in
    /// megabits per second, Mbps.
    pub static http_3_upload_throughput: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_upload_throughput".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(109.into(), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_upload_throughput_100
    ///
    /// The upload throughput for http/3 request size larger than 100MB. Measured in
    /// megabits per second, Mbps.
    pub static http_3_upload_throughput_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_upload_throughput_100".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(110.into(), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_upload_throughput_10_50
    ///
    /// The upload throughput for http/3 request size between 10MB and 50MB. Measured
    /// in megabits per second, Mbps.
    pub static http_3_upload_throughput_10_50: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_upload_throughput_10_50".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(111.into(), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_upload_throughput_50_100
    ///
    /// The upload throughput for http/3 request size between 50MB and 100MB. Measured
    /// in megabits per second, Mbps.
    pub static http_3_upload_throughput_50_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_upload_throughput_50_100".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(112.into(), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum HttpChannelDispositionLabel {
        EHttpCancelled = 0,
        EHttpDisk = 1,
        EHttpNetOk = 2,
        EHttpNetEarlyFail = 3,
        EHttpNetLateFail = 4,
        EHttpsCancelled = 5,
        EHttpsDisk = 6,
        EHttpsNetOk = 7,
        EHttpsNetEarlyFail = 8,
        EHttpsNetLateFail = 9,
        __Other__,
    }
    impl From<u16> for HttpChannelDispositionLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EHttpCancelled,
                1 => Self::EHttpDisk,
                2 => Self::EHttpNetOk,
                3 => Self::EHttpNetEarlyFail,
                4 => Self::EHttpNetLateFail,
                5 => Self::EHttpsCancelled,
                6 => Self::EHttpsDisk,
                7 => Self::EHttpsNetOk,
                8 => Self::EHttpsNetEarlyFail,
                9 => Self::EHttpsNetLateFail,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpChannelDispositionLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EHttpCancelled => "http_cancelled",
                Self::EHttpDisk => "http_disk",
                Self::EHttpNetOk => "http_net_ok",
                Self::EHttpNetEarlyFail => "http_net_early_fail",
                Self::EHttpNetLateFail => "http_net_late_fail",
                Self::EHttpsCancelled => "https_cancelled",
                Self::EHttpsDisk => "https_disk",
                Self::EHttpsNetOk => "https_net_ok",
                Self::EHttpsNetEarlyFail => "https_net_early_fail",
                Self::EHttpsNetLateFail => "https_net_late_fail",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_disposition
    ///
    /// Channel Disposition for HTTP and HTTPS: cancel, disk, net_ok, net_early_fail,
    /// and net_late_fail
    pub static http_channel_disposition: Lazy<LabeledMetric<LabeledCounterMetric, HttpChannelDispositionLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_channel_disposition".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(113.into(), meta, Some(vec![::std::borrow::Cow::from("http_cancelled"), ::std::borrow::Cow::from("http_disk"), ::std::borrow::Cow::from("http_net_early_fail"), ::std::borrow::Cow::from("http_net_late_fail"), ::std::borrow::Cow::from("http_net_ok"), ::std::borrow::Cow::from("https_cancelled"), ::std::borrow::Cow::from("https_disk"), ::std::borrow::Cow::from("https_net_early_fail"), ::std::borrow::Cow::from("https_net_late_fail"), ::std::borrow::Cow::from("https_net_ok")]))
    });

    #[repr(u16)]
    pub enum HttpChannelDispositionDisabledNoReasonLabel {
        ECancel = 0,
        EDisk = 1,
        ENetOk = 2,
        ENetEarlyFail = 3,
        ENetLateFail = 4,
        __Other__,
    }
    impl From<u16> for HttpChannelDispositionDisabledNoReasonLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECancel,
                1 => Self::EDisk,
                2 => Self::ENetOk,
                3 => Self::ENetEarlyFail,
                4 => Self::ENetLateFail,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpChannelDispositionDisabledNoReasonLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECancel => "cancel",
                Self::EDisk => "disk",
                Self::ENetOk => "net_ok",
                Self::ENetEarlyFail => "net_early_fail",
                Self::ENetLateFail => "net_late_fail",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_disposition_disabled_no_reason
    ///
    /// Upgrading display content Channel Disposition (key: disabled_no_reason)
    pub static http_channel_disposition_disabled_no_reason: Lazy<LabeledMetric<LabeledCounterMetric, HttpChannelDispositionDisabledNoReasonLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_channel_disposition_disabled_no_reason".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(114.into(), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("disk"), ::std::borrow::Cow::from("net_early_fail"), ::std::borrow::Cow::from("net_late_fail"), ::std::borrow::Cow::from("net_ok")]))
    });

    #[repr(u16)]
    pub enum HttpChannelDispositionDisabledUpgradeLabel {
        ECancel = 0,
        EDisk = 1,
        ENetOk = 2,
        ENetEarlyFail = 3,
        ENetLateFail = 4,
        __Other__,
    }
    impl From<u16> for HttpChannelDispositionDisabledUpgradeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECancel,
                1 => Self::EDisk,
                2 => Self::ENetOk,
                3 => Self::ENetEarlyFail,
                4 => Self::ENetLateFail,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpChannelDispositionDisabledUpgradeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECancel => "cancel",
                Self::EDisk => "disk",
                Self::ENetOk => "net_ok",
                Self::ENetEarlyFail => "net_early_fail",
                Self::ENetLateFail => "net_late_fail",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_disposition_disabled_upgrade
    ///
    /// Upgrading display content Channel Disposition (key: disable_upgrade)
    pub static http_channel_disposition_disabled_upgrade: Lazy<LabeledMetric<LabeledCounterMetric, HttpChannelDispositionDisabledUpgradeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_channel_disposition_disabled_upgrade".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(115.into(), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("disk"), ::std::borrow::Cow::from("net_early_fail"), ::std::borrow::Cow::from("net_late_fail"), ::std::borrow::Cow::from("net_ok")]))
    });

    #[repr(u16)]
    pub enum HttpChannelDispositionDisabledWontLabel {
        ECancel = 0,
        EDisk = 1,
        ENetOk = 2,
        ENetEarlyFail = 3,
        ENetLateFail = 4,
        __Other__,
    }
    impl From<u16> for HttpChannelDispositionDisabledWontLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECancel,
                1 => Self::EDisk,
                2 => Self::ENetOk,
                3 => Self::ENetEarlyFail,
                4 => Self::ENetLateFail,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpChannelDispositionDisabledWontLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECancel => "cancel",
                Self::EDisk => "disk",
                Self::ENetOk => "net_ok",
                Self::ENetEarlyFail => "net_early_fail",
                Self::ENetLateFail => "net_late_fail",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_disposition_disabled_wont
    ///
    /// Upgrading display content Channel Disposition (key: disabled_wont)
    pub static http_channel_disposition_disabled_wont: Lazy<LabeledMetric<LabeledCounterMetric, HttpChannelDispositionDisabledWontLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_channel_disposition_disabled_wont".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(116.into(), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("disk"), ::std::borrow::Cow::from("net_early_fail"), ::std::borrow::Cow::from("net_late_fail"), ::std::borrow::Cow::from("net_ok")]))
    });

    #[repr(u16)]
    pub enum HttpChannelDispositionEnabledNoReasonLabel {
        ECancel = 0,
        EDisk = 1,
        ENetOk = 2,
        ENetEarlyFail = 3,
        ENetLateFail = 4,
        __Other__,
    }
    impl From<u16> for HttpChannelDispositionEnabledNoReasonLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECancel,
                1 => Self::EDisk,
                2 => Self::ENetOk,
                3 => Self::ENetEarlyFail,
                4 => Self::ENetLateFail,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpChannelDispositionEnabledNoReasonLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECancel => "cancel",
                Self::EDisk => "disk",
                Self::ENetOk => "net_ok",
                Self::ENetEarlyFail => "net_early_fail",
                Self::ENetLateFail => "net_late_fail",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_disposition_enabled_no_reason
    ///
    /// Upgrading display content Channel Disposition (key: enabled_no_reason)
    pub static http_channel_disposition_enabled_no_reason: Lazy<LabeledMetric<LabeledCounterMetric, HttpChannelDispositionEnabledNoReasonLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_channel_disposition_enabled_no_reason".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(117.into(), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("disk"), ::std::borrow::Cow::from("net_early_fail"), ::std::borrow::Cow::from("net_late_fail"), ::std::borrow::Cow::from("net_ok")]))
    });

    #[repr(u16)]
    pub enum HttpChannelDispositionEnabledUpgradeLabel {
        ECancel = 0,
        EDisk = 1,
        ENetOk = 2,
        ENetEarlyFail = 3,
        ENetLateFail = 4,
        __Other__,
    }
    impl From<u16> for HttpChannelDispositionEnabledUpgradeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECancel,
                1 => Self::EDisk,
                2 => Self::ENetOk,
                3 => Self::ENetEarlyFail,
                4 => Self::ENetLateFail,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpChannelDispositionEnabledUpgradeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECancel => "cancel",
                Self::EDisk => "disk",
                Self::ENetOk => "net_ok",
                Self::ENetEarlyFail => "net_early_fail",
                Self::ENetLateFail => "net_late_fail",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_disposition_enabled_upgrade
    ///
    /// Upgrading display content Channel Disposition (key: enable_upgrade)
    pub static http_channel_disposition_enabled_upgrade: Lazy<LabeledMetric<LabeledCounterMetric, HttpChannelDispositionEnabledUpgradeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_channel_disposition_enabled_upgrade".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(118.into(), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("disk"), ::std::borrow::Cow::from("net_early_fail"), ::std::borrow::Cow::from("net_late_fail"), ::std::borrow::Cow::from("net_ok")]))
    });

    #[repr(u16)]
    pub enum HttpChannelDispositionEnabledWontLabel {
        ECancel = 0,
        EDisk = 1,
        ENetOk = 2,
        ENetEarlyFail = 3,
        ENetLateFail = 4,
        __Other__,
    }
    impl From<u16> for HttpChannelDispositionEnabledWontLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECancel,
                1 => Self::EDisk,
                2 => Self::ENetOk,
                3 => Self::ENetEarlyFail,
                4 => Self::ENetLateFail,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpChannelDispositionEnabledWontLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECancel => "cancel",
                Self::EDisk => "disk",
                Self::ENetOk => "net_ok",
                Self::ENetEarlyFail => "net_early_fail",
                Self::ENetLateFail => "net_late_fail",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_disposition_enabled_wont
    ///
    /// Upgrading display content Channel Disposition (key: enabled_wont)
    pub static http_channel_disposition_enabled_wont: Lazy<LabeledMetric<LabeledCounterMetric, HttpChannelDispositionEnabledWontLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_channel_disposition_enabled_wont".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(119.into(), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("disk"), ::std::borrow::Cow::from("net_early_fail"), ::std::borrow::Cow::from("net_late_fail"), ::std::borrow::Cow::from("net_ok")]))
    });

    #[repr(u16)]
    pub enum HttpChannelOnstartStatusLabel {
        ESuccessful = 0,
        EFail = 1,
        __Other__,
    }
    impl From<u16> for HttpChannelOnstartStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccessful,
                1 => Self::EFail,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpChannelOnstartStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccessful => "successful",
                Self::EFail => "fail",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_onstart_status
    ///
    /// Whether successfully started HTTP channels
    pub static http_channel_onstart_status: Lazy<LabeledMetric<LabeledCounterMetric, HttpChannelOnstartStatusLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_channel_onstart_status".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(120.into(), meta, Some(vec![::std::borrow::Cow::from("fail"), ::std::borrow::Cow::from("successful")]))
    });

    #[repr(u16)]
    pub enum HttpChannelOnstartSuccessHttpsRrLabel {
        ESuccess = 0,
        EFailure = 1,
        ESuccessEchUsed = 2,
        EFailureEchUsed = 3,
        __Other__,
    }
    impl From<u16> for HttpChannelOnstartSuccessHttpsRrLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EFailure,
                2 => Self::ESuccessEchUsed,
                3 => Self::EFailureEchUsed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpChannelOnstartSuccessHttpsRrLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EFailure => "failure",
                Self::ESuccessEchUsed => "success_ech_used",
                Self::EFailureEchUsed => "failure_ech_used",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_onstart_success_https_rr
    ///
    /// Successfully started HTTP channels when HTTPS RR is used
    pub static http_channel_onstart_success_https_rr: Lazy<LabeledMetric<LabeledCounterMetric, HttpChannelOnstartSuccessHttpsRrLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_channel_onstart_success_https_rr".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(121.into(), meta, Some(vec![::std::borrow::Cow::from("failure"), ::std::borrow::Cow::from("failure_ech_used"), ::std::borrow::Cow::from("success"), ::std::borrow::Cow::from("success_ech_used")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_page_open_to_first_sent
    ///
    /// Time in milliseconds from AsyncOpen to first byte of request sent, applicable
    /// for page loads without HTTPS RR
    pub static http_channel_page_open_to_first_sent: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_channel_page_open_to_first_sent".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(122.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_page_open_to_first_sent_https_rr
    ///
    /// Time in milliseconds from AsyncOpen to first byte of request sent, applicable
    /// for page loads with HTTPS RR
    pub static http_channel_page_open_to_first_sent_https_rr: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_channel_page_open_to_first_sent_https_rr".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(123.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_sub_open_to_first_sent
    ///
    /// Time in milliseconds from AsyncOpen to first byte of request sent, applicable
    /// for sub-resource loads without HTTPS RR
    pub static http_channel_sub_open_to_first_sent: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_channel_sub_open_to_first_sent".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(124.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_sub_open_to_first_sent_https_rr
    ///
    /// Time in milliseconds from AsyncOpen to first byte of request sent, applicable
    /// for sub-resource loads with HTTPS RR
    pub static http_channel_sub_open_to_first_sent_https_rr: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_channel_sub_open_to_first_sent_https_rr".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(125.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_content_cssloader_ondatafinished_to_onstop_delay
    ///
    /// The time between processing OnDataFinished and processing OnStopRequest for
    /// CSSLoader in the content process
    pub static http_content_cssloader_ondatafinished_to_onstop_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_content_cssloader_ondatafinished_to_onstop_delay".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(126.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_content_html5parser_ondatafinished_to_onstop_delay
    ///
    /// The time between processing OnDataFinished and processing OnStopRequest (if
    /// OnDataFinished comes first)
    pub static http_content_html5parser_ondatafinished_to_onstop_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_content_html5parser_ondatafinished_to_onstop_delay".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(127.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_content_ondatafinished_delay
    ///
    /// The time between dispatching OnDataFinished from the socket thread and
    /// processing it on main/background thread.
    pub static http_content_ondatafinished_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_content_ondatafinished_delay".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(128.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_content_ondatafinished_delay_2
    ///
    /// The time between dispatching OnDataFinished from the socket thread and
    /// processing it on the background thread.
    pub static http_content_ondatafinished_delay_2: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_content_ondatafinished_delay_2".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(129.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_content_ondatafinished_to_onstop_delay
    ///
    /// The time between processing OnDataFinished and processing OnStopRequest (if
    /// OnDataFinished comes first)
    pub static http_content_ondatafinished_to_onstop_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_content_ondatafinished_to_onstop_delay".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(130.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_content_onstart_delay
    ///
    /// The time between dispatching OnStartRequest from the socket thread and
    /// processing it on the main thread (content process).
    pub static http_content_onstart_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_content_onstart_delay".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(131.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_content_onstop_delay
    ///
    /// The time between dispatching OnStopRequest from the socket thread and
    /// processing it on the main thread (content process).
    pub static http_content_onstop_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_content_onstop_delay".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(132.into(), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum HttpIpAddrAnyCountLabel {
        ENotBlockedRequests = 0,
        EBlockedRequests = 1,
        __Other__,
    }
    impl From<u16> for HttpIpAddrAnyCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENotBlockedRequests,
                1 => Self::EBlockedRequests,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpIpAddrAnyCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENotBlockedRequests => "not_blocked_requests",
                Self::EBlockedRequests => "blocked_requests",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_ip_addr_any_count
    ///
    /// The number of times we see the IP address 0.0.0.0 or its IPv6 equivalent.
    pub static http_ip_addr_any_count: Lazy<LabeledMetric<LabeledCounterMetric, HttpIpAddrAnyCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_ip_addr_any_count".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(133.into(), meta, Some(vec![::std::borrow::Cow::from("blocked_requests"), ::std::borrow::Cow::from("not_blocked_requests")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_onstart_suspend_total_time
    ///
    /// Time in milliseconds that http channel spent suspended between AsyncOpen and
    /// OnStartRequest.
    pub static http_onstart_suspend_total_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_onstart_suspend_total_time".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(134.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_redirect_to_scheme_subresource
    ///
    /// Count of the HTTP redirection that triggered by subresource, keyed by the URL
    /// scheme redirected to
    pub static http_redirect_to_scheme_subresource: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_redirect_to_scheme_subresource".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(135.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_redirect_to_scheme_top_level
    ///
    /// Count of the HTTP redirection that triggered by top-level document, keyed by
    /// the URL scheme redirected to
    pub static http_redirect_to_scheme_top_level: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_redirect_to_scheme_top_level".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(136.into(), meta, None)
    });

    #[repr(u16)]
    pub enum HttpResponseStatusCodeLabel {
        E200Ok = 0,
        E301MovedPermanently = 1,
        E302Found = 2,
        E304NotModified = 3,
        E307TemporaryRedirect = 4,
        E308PermanentRedirect = 5,
        E400BadRequest = 6,
        E401Unauthorized = 7,
        E403Forbidden = 8,
        E404NotFound = 9,
        E421MisdirectedRequest = 10,
        E425TooEarly = 11,
        E429TooManyRequests = 12,
        EOther4xx = 13,
        EOther5xx = 14,
        EOther = 15,
        __Other__,
    }
    impl From<u16> for HttpResponseStatusCodeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::E200Ok,
                1 => Self::E301MovedPermanently,
                2 => Self::E302Found,
                3 => Self::E304NotModified,
                4 => Self::E307TemporaryRedirect,
                5 => Self::E308PermanentRedirect,
                6 => Self::E400BadRequest,
                7 => Self::E401Unauthorized,
                8 => Self::E403Forbidden,
                9 => Self::E404NotFound,
                10 => Self::E421MisdirectedRequest,
                11 => Self::E425TooEarly,
                12 => Self::E429TooManyRequests,
                13 => Self::EOther4xx,
                14 => Self::EOther5xx,
                15 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpResponseStatusCodeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::E200Ok => "200_ok",
                Self::E301MovedPermanently => "301_moved_permanently",
                Self::E302Found => "302_found",
                Self::E304NotModified => "304_not_modified",
                Self::E307TemporaryRedirect => "307_temporary_redirect",
                Self::E308PermanentRedirect => "308_permanent_redirect",
                Self::E400BadRequest => "400_bad_request",
                Self::E401Unauthorized => "401_unauthorized",
                Self::E403Forbidden => "403_forbidden",
                Self::E404NotFound => "404_not_found",
                Self::E421MisdirectedRequest => "421_misdirected_request",
                Self::E425TooEarly => "425_too_early",
                Self::E429TooManyRequests => "429_too_many_requests",
                Self::EOther4xx => "other_4xx",
                Self::EOther5xx => "other_5xx",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_response_status_code
    ///
    /// HTTP Response Status Code (200, 301, 302, 304, 307, 308, 400, 401, 403, 404,
    /// 421, 425, 429, other 400 and 500)
    pub static http_response_status_code: Lazy<LabeledMetric<LabeledCounterMetric, HttpResponseStatusCodeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_response_status_code".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(137.into(), meta, Some(vec![::std::borrow::Cow::from("200_ok"), ::std::borrow::Cow::from("301_moved_permanently"), ::std::borrow::Cow::from("302_found"), ::std::borrow::Cow::from("304_not_modified"), ::std::borrow::Cow::from("307_temporary_redirect"), ::std::borrow::Cow::from("308_permanent_redirect"), ::std::borrow::Cow::from("400_bad_request"), ::std::borrow::Cow::from("401_unauthorized"), ::std::borrow::Cow::from("403_forbidden"), ::std::borrow::Cow::from("404_not_found"), ::std::borrow::Cow::from("421_misdirected_request"), ::std::borrow::Cow::from("425_too_early"), ::std::borrow::Cow::from("429_too_many_requests"), ::std::borrow::Cow::from("other"), ::std::borrow::Cow::from("other_4xx"), ::std::borrow::Cow::from("other_5xx")]))
    });

    #[repr(u16)]
    pub enum HttpResponseVersionLabel {
        EUnknown = 0,
        EHttp1 = 1,
        EHttp2 = 2,
        EHttp3 = 3,
        __Other__,
    }
    impl From<u16> for HttpResponseVersionLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUnknown,
                1 => Self::EHttp1,
                2 => Self::EHttp2,
                3 => Self::EHttp3,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpResponseVersionLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUnknown => "unknown",
                Self::EHttp1 => "http_1",
                Self::EHttp2 => "http_2",
                Self::EHttp3 => "http_3",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_response_version
    ///
    /// HTTP protocol version used on response from nsHttp.h
    pub static http_response_version: Lazy<LabeledMetric<LabeledCounterMetric, HttpResponseVersionLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_response_version".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(138.into(), meta, Some(vec![::std::borrow::Cow::from("http_1"), ::std::borrow::Cow::from("http_2"), ::std::borrow::Cow::from("http_3"), ::std::borrow::Cow::from("unknown")]))
    });

    #[repr(u16)]
    pub enum HttpToHttpsUpgradeReasonLabel {
        ENotInitialized = 0,
        ENotInitializedHttps = 1,
        ENoUpgrade = 2,
        ENoUpgradeHttps = 3,
        EAlreadyHttps = 4,
        EHsts = 5,
        EHttpsOnlyUpgrade = 6,
        EHttpsOnlyUpgradeDowngrade = 7,
        EHttpsFirstUpgrade = 8,
        EHttpsFirstUpgradeDowngrade = 9,
        EHttpsFirstSchemelessUpgrade = 10,
        EHttpsFirstSchemelessUpgradeDowngrade = 11,
        ECspUir = 12,
        EHttpsRr = 13,
        EWebExtensionUpgrade = 14,
        EUpgradeException = 15,
        ESkipUpgrade = 16,
        __Other__,
    }
    impl From<u16> for HttpToHttpsUpgradeReasonLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENotInitialized,
                1 => Self::ENotInitializedHttps,
                2 => Self::ENoUpgrade,
                3 => Self::ENoUpgradeHttps,
                4 => Self::EAlreadyHttps,
                5 => Self::EHsts,
                6 => Self::EHttpsOnlyUpgrade,
                7 => Self::EHttpsOnlyUpgradeDowngrade,
                8 => Self::EHttpsFirstUpgrade,
                9 => Self::EHttpsFirstUpgradeDowngrade,
                10 => Self::EHttpsFirstSchemelessUpgrade,
                11 => Self::EHttpsFirstSchemelessUpgradeDowngrade,
                12 => Self::ECspUir,
                13 => Self::EHttpsRr,
                14 => Self::EWebExtensionUpgrade,
                15 => Self::EUpgradeException,
                16 => Self::ESkipUpgrade,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpToHttpsUpgradeReasonLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENotInitialized => "not_initialized",
                Self::ENotInitializedHttps => "not_initialized_https",
                Self::ENoUpgrade => "no_upgrade",
                Self::ENoUpgradeHttps => "no_upgrade_https",
                Self::EAlreadyHttps => "already_https",
                Self::EHsts => "hsts",
                Self::EHttpsOnlyUpgrade => "https_only_upgrade",
                Self::EHttpsOnlyUpgradeDowngrade => "https_only_upgrade_downgrade",
                Self::EHttpsFirstUpgrade => "https_first_upgrade",
                Self::EHttpsFirstUpgradeDowngrade => "https_first_upgrade_downgrade",
                Self::EHttpsFirstSchemelessUpgrade => "https_first_schemeless_upgrade",
                Self::EHttpsFirstSchemelessUpgradeDowngrade => "https_first_schemeless_upgrade_downgrade",
                Self::ECspUir => "csp_uir",
                Self::EHttpsRr => "https_rr",
                Self::EWebExtensionUpgrade => "web_extension_upgrade",
                Self::EUpgradeException => "upgrade_exception",
                Self::ESkipUpgrade => "skip_upgrade",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_to_https_upgrade_reason
    ///
    /// Whether a top-level HTTP request gets upgraded to HTTPS and the reason for it
    pub static http_to_https_upgrade_reason: Lazy<LabeledMetric<LabeledCounterMetric, HttpToHttpsUpgradeReasonLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_to_https_upgrade_reason".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(139.into(), meta, Some(vec![::std::borrow::Cow::from("already_https"), ::std::borrow::Cow::from("csp_uir"), ::std::borrow::Cow::from("hsts"), ::std::borrow::Cow::from("https_first_schemeless_upgrade"), ::std::borrow::Cow::from("https_first_schemeless_upgrade_downgrade"), ::std::borrow::Cow::from("https_first_upgrade"), ::std::borrow::Cow::from("https_first_upgrade_downgrade"), ::std::borrow::Cow::from("https_only_upgrade"), ::std::borrow::Cow::from("https_only_upgrade_downgrade"), ::std::borrow::Cow::from("https_rr"), ::std::borrow::Cow::from("no_upgrade"), ::std::borrow::Cow::from("no_upgrade_https"), ::std::borrow::Cow::from("not_initialized"), ::std::borrow::Cow::from("not_initialized_https"), ::std::borrow::Cow::from("skip_upgrade"), ::std::borrow::Cow::from("upgrade_exception"), ::std::borrow::Cow::from("web_extension_upgrade")]))
    });

    #[repr(u16)]
    pub enum HttpsRrPresentedLabel {
        EPresented = 0,
        EPresentedWithHttp3 = 1,
        ENone = 2,
        __Other__,
    }
    impl From<u16> for HttpsRrPresentedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresented,
                1 => Self::EPresentedWithHttp3,
                2 => Self::ENone,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpsRrPresentedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresented => "presented",
                Self::EPresentedWithHttp3 => "presented_with_http3",
                Self::ENone => "none",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.https_rr_presented
    ///
    /// HTTPS RR is presented or not
    pub static https_rr_presented: Lazy<LabeledMetric<LabeledCounterMetric, HttpsRrPresentedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "https_rr_presented".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(140.into(), meta, Some(vec![::std::borrow::Cow::from("none"), ::std::borrow::Cow::from("presented"), ::std::borrow::Cow::from("presented_with_http3")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.os_socket_limit_reached
    ///
    /// Counts the number of times the os socket limit was reached. i.e.
    /// CanAttachSocket() returned false.
    pub static os_socket_limit_reached: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            141,
            "networking",
            "os_socket_limit_reached",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum ProxyInfoTypeLabel {
        EHttp = 0,
        EHttps = 1,
        ESocks4 = 2,
        ESocks4a = 3,
        ESocks5 = 4,
        ESocks5h = 5,
        EDirect = 6,
        EUnknown = 7,
        __Other__,
    }
    impl From<u16> for ProxyInfoTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EHttp,
                1 => Self::EHttps,
                2 => Self::ESocks4,
                3 => Self::ESocks4a,
                4 => Self::ESocks5,
                5 => Self::ESocks5h,
                6 => Self::EDirect,
                7 => Self::EUnknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ProxyInfoTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EHttp => "http",
                Self::EHttps => "https",
                Self::ESocks4 => "socks4",
                Self::ESocks4a => "socks4a",
                Self::ESocks5 => "socks5",
                Self::ESocks5h => "socks5h",
                Self::EDirect => "direct",
                Self::EUnknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.proxy_info_type
    ///
    /// The proxies configurations created in the browser session (SOCKSv4, SOCKSv5,
    /// HTTP, HTTPS)
    pub static proxy_info_type: Lazy<LabeledMetric<LabeledCounterMetric, ProxyInfoTypeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "proxy_info_type".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(142.into(), meta, Some(vec![::std::borrow::Cow::from("direct"), ::std::borrow::Cow::from("http"), ::std::borrow::Cow::from("https"), ::std::borrow::Cow::from("socks4"), ::std::borrow::Cow::from("socks4a"), ::std::borrow::Cow::from("socks5"), ::std::borrow::Cow::from("socks5h"), ::std::borrow::Cow::from("unknown")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.residual_cache_folder_count
    ///
    /// Counts how often we find a cache folder that wasn't purged at shutdown by a
    /// background task process.
    pub static residual_cache_folder_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            143,
            "networking",
            "residual_cache_folder_count",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum ResidualCacheFolderRemovalLabel {
        ESuccess = 0,
        EFailure = 1,
        __Other__,
    }
    impl From<u16> for ResidualCacheFolderRemovalLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EFailure,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ResidualCacheFolderRemovalLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EFailure => "failure",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.residual_cache_folder_removal
    ///
    /// Counts how often succeed/fail in removing cache folder that wasn't purged at
    /// shutdown
    pub static residual_cache_folder_removal: Lazy<LabeledMetric<LabeledCounterMetric, ResidualCacheFolderRemovalLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "residual_cache_folder_removal".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(144.into(), meta, Some(vec![::std::borrow::Cow::from("failure"), ::std::borrow::Cow::from("success")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.set_cookie
    ///
    /// This counts the number of times we set a cookie. Introduced as a denomenator
    /// for measuring CHIPS adoption.
    pub static set_cookie: Lazy<DenominatorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "set_cookie".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DenominatorMetric::new(145.into(), meta, vec![CommonMetricData {name: "set_cookie_expired_without_server_time".into(), category: "networking".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "set_cookie_foreign".into(), category: "networking".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "set_cookie_foreign_partitioned".into(), category: "networking".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "set_cookie_partitioned".into(), category: "networking".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.set_cookie_expired_without_server_time
    ///
    /// This counts the number of times a cookie is set already expires but it would
    /// not if we considered the server time.
    pub static set_cookie_expired_without_server_time: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "set_cookie_expired_without_server_time".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(146.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.set_cookie_foreign
    ///
    /// This counts the number of times we set a cookie from a foreign (not same-site)
    /// context. Introduced as a denomenator for measuring CHIPS adoption.
    pub static set_cookie_foreign: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "set_cookie_foreign".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(147.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.set_cookie_foreign_partitioned
    ///
    /// This counts the number of times we set a cookie that has the Partitioned
    /// attribute in a foreign (not same-site) context. This tracks the adoption of
    /// CHIPS.
    pub static set_cookie_foreign_partitioned: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "set_cookie_foreign_partitioned".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(148.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.set_cookie_partitioned
    ///
    /// This counts the number of times we set a cookie that has the Partitioned
    /// attribute. This tracks the adoption of CHIPS.
    pub static set_cookie_partitioned: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "set_cookie_partitioned".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(149.into(), meta)
    });

    #[repr(u16)]
    pub enum SpeculativeConnectOutcomeLabel {
        ESuccessful = 0,
        EAbortedSocketLimit = 1,
        EAbortedSocketFail = 2,
        EAbortedHttpsNotEnabled = 3,
        __Other__,
    }
    impl From<u16> for SpeculativeConnectOutcomeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccessful,
                1 => Self::EAbortedSocketLimit,
                2 => Self::EAbortedSocketFail,
                3 => Self::EAbortedHttpsNotEnabled,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SpeculativeConnectOutcomeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccessful => "successful",
                Self::EAbortedSocketLimit => "aborted_socket_limit",
                Self::EAbortedSocketFail => "aborted_socket_fail",
                Self::EAbortedHttpsNotEnabled => "aborted_https_not_enabled",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.speculative_connect_outcome
    ///
    /// Counts the occurrence of each outcome of a speculative connection
    pub static speculative_connect_outcome: Lazy<LabeledMetric<LabeledCounterMetric, SpeculativeConnectOutcomeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "speculative_connect_outcome".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(150.into(), meta, Some(vec![::std::borrow::Cow::from("aborted_https_not_enabled"), ::std::borrow::Cow::from("aborted_socket_fail"), ::std::borrow::Cow::from("aborted_socket_limit"), ::std::borrow::Cow::from("successful")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.sqlite_cookies_block_main_thread
    ///
    /// Time spent on blocking main thread by startup cookie database read (in
    /// milliseconds), only for blocking case
    pub static sqlite_cookies_block_main_thread: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sqlite_cookies_block_main_thread".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(151.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.sqlite_cookies_time_to_block_main_thread
    ///
    /// How long (in milliseconds) after we finished reading the cookie db until the
    /// first cookie request came in (0 implies we blocked the main thread)
    pub static sqlite_cookies_time_to_block_main_thread: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sqlite_cookies_time_to_block_main_thread".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(152.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.transaction_wait_time
    ///
    /// Time from submission to dispatch of transaction without HTTPS RR (ms)
    pub static transaction_wait_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "transaction_wait_time".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(153.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.transaction_wait_time_https_rr
    ///
    /// Time from submission to dispatch of transaction when HTTPS RR is used (ms)
    pub static transaction_wait_time_https_rr: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "transaction_wait_time_https_rr".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(154.into(), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum TrrFetchDurationLabel {
        EH1 = 0,
        EH1NetworkOnly = 1,
        EH2 = 2,
        EH2NetworkOnly = 3,
        EH3 = 4,
        EH3NetworkOnly = 5,
        __Other__,
    }
    impl From<u16> for TrrFetchDurationLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EH1,
                1 => Self::EH1NetworkOnly,
                2 => Self::EH2,
                3 => Self::EH2NetworkOnly,
                4 => Self::EH3,
                5 => Self::EH3NetworkOnly,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrrFetchDurationLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EH1 => "h1",
                Self::EH1NetworkOnly => "h1_network_only",
                Self::EH2 => "h2",
                Self::EH2NetworkOnly => "h2_network_only",
                Self::EH3 => "h3",
                Self::EH3NetworkOnly => "h3_network_only",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.trr_fetch_duration
    ///
    /// Time for a successful DoH request, from AsyncOpen to ReturnData
    pub static trr_fetch_duration: Lazy<LabeledMetric<LabeledTimingDistributionMetric, TrrFetchDurationLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "trr_fetch_duration".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(155.into(), meta, Some(vec![::std::borrow::Cow::from("h1"), ::std::borrow::Cow::from("h1_network_only"), ::std::borrow::Cow::from("h2"), ::std::borrow::Cow::from("h2_network_only"), ::std::borrow::Cow::from("h3"), ::std::borrow::Cow::from("h3_network_only")]))
    });

    #[repr(u16)]
    pub enum TrrRequestCountLabel {
        ERegular = 0,
        EPrivate = 1,
        __Other__,
    }
    impl From<u16> for TrrRequestCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ERegular,
                1 => Self::EPrivate,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrrRequestCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ERegular => "regular",
                Self::EPrivate => "private",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.trr_request_count
    ///
    /// The count of successful TRR requests keyed by regular/private browsing
    pub static trr_request_count: Lazy<LabeledMetric<LabeledCounterMetric, TrrRequestCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "trr_request_count".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(156.into(), meta, Some(vec![::std::borrow::Cow::from("private"), ::std::borrow::Cow::from("regular")]))
    });

    #[repr(u16)]
    pub enum TrrRequestCountPerConnLabel {
        EH1 = 0,
        EH2 = 1,
        EH3 = 2,
        __Other__,
    }
    impl From<u16> for TrrRequestCountPerConnLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EH1,
                1 => Self::EH2,
                2 => Self::EH3,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrrRequestCountPerConnLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EH1 => "h1",
                Self::EH2 => "h2",
                Self::EH3 => "h3",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.trr_request_count_per_conn
    ///
    /// Number of DOH requests per connection keyed by HTTP version
    pub static trr_request_count_per_conn: Lazy<LabeledMetric<LabeledCounterMetric, TrrRequestCountPerConnLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "trr_request_count_per_conn".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(157.into(), meta, Some(vec![::std::borrow::Cow::from("h1"), ::std::borrow::Cow::from("h2"), ::std::borrow::Cow::from("h3")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.data_transferred_v3_kb
    ///
    /// How many KB of HTTP data transferred by type, there are some categories
    /// separated by keys based on 5 parameters:
    ///   1. normal browsing or private browsing
    ///   2. system principal or not
    ///   3. first party or third party
    ///   4. class of service (Leader/Background/Others)
    ///   5. tracking classification (Basic/Content/FingerprintingContent)
    /// 
    /// Available keys are:
    ///   "Y0_N1Sys",
    ///   "Y1_N1",
    ///   "Y2_N3Oth",
    ///   "Y3_N3BasicLead",
    ///   "Y4_N3BasicBg",
    ///   "Y5_N3BasicOth",
    ///   "Y6_N3ContentLead",
    ///   "Y7_N3ContentBg",
    ///   "Y8_N3ContentOth",
    ///   "Y9_N3FpLead",
    ///   "Y10_N3FpBg",
    ///   "Y11_N3FpOth",
    ///   "Y12_P1Sys",
    ///   "Y13_P1",
    ///   "Y14_P3Oth",
    ///   "Y15_P3BasicLead",
    ///   "Y16_P3BasicBg",
    ///   "Y17_P3BasicOth",
    ///   "Y18_P3ContentLead",
    ///   "Y19_P3ContentBg",
    ///   "Y20_P3ContentOth",
    ///   "Y21_P3FpLead",
    ///   "Y22_P3FpBg",
    ///   "Y23_P3FpOth"
    /// 
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// networking.data_transferred_v3_kb.
    pub static data_transferred_v3_kb: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "data_transferred_v3_kb".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(158.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http3_enabled
    ///
    /// True if HTTP3 is enabled at the start of a session. This metric was generated
    /// to correspond to the Legacy Telemetry scalar networking.http3_enabled.
    pub static http3_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http3_enabled".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(159.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.https_rr_prefs_usage
    ///
    /// A bitfield representation for the usage of HTTPS RR prefs. bit 0:
    /// network.dns.upgrade_with_https_rr is enabled or not. bit 1:
    /// network.dns.use_https_rr_as_altsvc is enabled or not. bit 2:
    /// network.dns.echconfig.enabled is enabled or not. This metric was generated to
    /// correspond to the Legacy Telemetry scalar networking.https_rr_prefs_usage.
    pub static https_rr_prefs_usage: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "https_rr_prefs_usage".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(160.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.trr_connection_cycle_count
    ///
    /// Number of times we cycled the TRR connection during a subsession. Keyed by TRR
    /// provider URL. This metric was generated to correspond to the Legacy Telemetry
    /// scalar networking.trr_connection_cycle_count.
    pub static trr_connection_cycle_count: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "trr_connection_cycle_count".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(161.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.loading_certs_task
    ///
    /// The time in milliseconds to load any external certificates. This occurs off of
    /// the main-thread, but can block main-thread operations. This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// networking.loading_certs_task.
    pub static loading_certs_task: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "loading_certs_task".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(162.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.nss_initialization
    ///
    /// The time in milliseconds to initialize the NSS component in the parent process.
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// networking.nss_initialization.
    pub static nss_initialization: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "nss_initialization".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(163.into(), meta)
    });

}
pub mod security_doh_trr_performance {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ResolvedRecordExtra {
        pub r#captivePortal: Option<String>,
        pub r#domain: Option<String>,
        pub r#networkUnstable: Option<String>,
        pub r#retryCount: Option<String>,
        pub r#status: Option<String>,
        pub r#time: Option<String>,
        pub r#trr: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ResolvedRecordExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["captivePortal", "domain", "networkUnstable", "retryCount", "status", "time", "trr", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#captivePortal.and_then(|val| map.insert("captivePortal".into(), val.to_string()));
          self.r#domain.and_then(|val| map.insert("domain".into(), val.to_string()));
          self.r#networkUnstable.and_then(|val| map.insert("networkUnstable".into(), val.to_string()));
          self.r#retryCount.and_then(|val| map.insert("retryCount".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#time.and_then(|val| map.insert("time".into(), val.to_string()));
          self.r#trr.and_then(|val| map.insert("trr".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.trr_performance.resolved_record
    ///
    /// How long it took to resolve a test domain using TRR. This event was generated
    /// to correspond to the Legacy Telemetry event
    /// security.doh.trrPerformance.resolved#record.
    pub static resolved_record: Lazy<EventMetric<ResolvedRecordExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "resolved_record".into(),
                category: "security.doh.trr_performance".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(164.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TrrselectDryrunresultExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for TrrselectDryrunresultExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.trr_performance.trrselect_dryrunresult
    ///
    /// The URL of the DoH provider chosen by the TRR selection dry-run This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.doh.trrPerformance.trrselect#dryrunresult.
    pub static trrselect_dryrunresult: Lazy<EventMetric<TrrselectDryrunresultExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "trrselect_dryrunresult".into(),
                category: "security.doh.trr_performance".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(165.into(), meta)
    });

}
pub mod downloads {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from downloads.panel_shown
    ///
    /// The count of how many times the downloads panel was shown per session. This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// downloads.panel_shown.
    pub static panel_shown: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            166,
            "downloads",
            "panel_shown",
            "metrics"
        )
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AddedFileExtensionExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AddedFileExtensionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from downloads.added_file_extension
    ///
    /// Sent when downloading a new file. This event was generated to correspond to the
    /// Legacy Telemetry event downloads.added#fileExtension.
    pub static added_file_extension: Lazy<EventMetric<AddedFileExtensionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "added_file_extension".into(),
                category: "downloads".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(167.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from downloads.file_opened
    ///
    /// The count of how many times files were opened from the download panel. This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// downloads.file_opened.
    pub static file_opened: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            168,
            "downloads",
            "file_opened",
            "metrics"
        )
    });

}
pub mod firefoxview_next {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct BrowserContextMenuTabsExtra {
        pub r#menu_action: Option<String>,
        pub r#page: Option<String>,
    }

    impl ExtraKeys for BrowserContextMenuTabsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["menu_action", "page"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#menu_action.and_then(|val| map.insert("menu_action".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.browser_context_menu_tabs
    ///
    /// Recorded when a browser context menu selection is made in Firefox View This
    /// event was generated to correspond to the Legacy Telemetry event
    /// firefoxview_next.browser_context_menu#tabs.
    pub static browser_context_menu_tabs: Lazy<EventMetric<BrowserContextMenuTabsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "browser_context_menu_tabs".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(169.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CardCollapsedCardContainerExtra {
        pub r#data_type: Option<String>,
    }

    impl ExtraKeys for CardCollapsedCardContainerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["data_type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#data_type.and_then(|val| map.insert("data_type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.card_collapsed_card_container
    ///
    /// Recorded when a card-container is collapsed on the 'Recent browsing' page This
    /// event was generated to correspond to the Legacy Telemetry event
    /// firefoxview_next.card_collapsed#card_container.
    pub static card_collapsed_card_container: Lazy<EventMetric<CardCollapsedCardContainerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "card_collapsed_card_container".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(170.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CardExpandedCardContainerExtra {
        pub r#data_type: Option<String>,
    }

    impl ExtraKeys for CardExpandedCardContainerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["data_type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#data_type.and_then(|val| map.insert("data_type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.card_expanded_card_container
    ///
    /// Recorded when a card-container is expanded on the 'Recent browsing' page This
    /// event was generated to correspond to the Legacy Telemetry event
    /// firefoxview_next.card_expanded#card_container.
    pub static card_expanded_card_container: Lazy<EventMetric<CardExpandedCardContainerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "card_expanded_card_container".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(171.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ChangePageNavigationExtra {
        pub r#page: Option<String>,
        pub r#source: Option<String>,
    }

    impl ExtraKeys for ChangePageNavigationExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["page", "source"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.change_page_navigation
    ///
    /// Recorded when the page/view is changed in Firefox View This event was generated
    /// to correspond to the Legacy Telemetry event
    /// firefoxview_next.change_page#navigation.
    pub static change_page_navigation: Lazy<EventMetric<ChangePageNavigationExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "change_page_navigation".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(172.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.close_open_tab_tabs
    ///
    /// Recorded when a tab is closed via the close button on an open tab row. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// firefoxview_next.close_open_tab#tabs.
    pub static close_open_tab_tabs: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "close_open_tab_tabs".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(173.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ContextMenuTabsExtra {
        pub r#data_type: Option<String>,
        pub r#menu_action: Option<String>,
    }

    impl ExtraKeys for ContextMenuTabsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["data_type", "menu_action"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#data_type.and_then(|val| map.insert("data_type".into(), val.to_string()));
          self.r#menu_action.and_then(|val| map.insert("menu_action".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.context_menu_tabs
    ///
    /// Recorded when a context menu selection is made in Firefox View This event was
    /// generated to correspond to the Legacy Telemetry event
    /// firefoxview_next.context_menu#tabs.
    pub static context_menu_tabs: Lazy<EventMetric<ContextMenuTabsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "context_menu_tabs".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(174.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DismissClosedTabTabsExtra {
        pub r#delta: Option<String>,
        pub r#page: Option<String>,
        pub r#position: Option<u32>,
    }

    impl ExtraKeys for DismissClosedTabTabsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["delta", "page", "position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#delta.and_then(|val| map.insert("delta".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.dismiss_closed_tab_tabs
    ///
    /// Recorded when a recently closed tab is dismissed This event was generated to
    /// correspond to the Legacy Telemetry event
    /// firefoxview_next.dismiss_closed_tab#tabs.
    pub static dismiss_closed_tab_tabs: Lazy<EventMetric<DismissClosedTabTabsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dismiss_closed_tab_tabs".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(175.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnteredFirefoxviewExtra {
        pub r#page: Option<String>,
    }

    impl ExtraKeys for EnteredFirefoxviewExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["page"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.entered_firefoxview
    ///
    /// Recorded when the Firefox View tab is selected This event was generated to
    /// correspond to the Legacy Telemetry event firefoxview_next.entered#firefoxview.
    pub static entered_firefoxview: Lazy<EventMetric<EnteredFirefoxviewExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "entered_firefoxview".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(176.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.fxa_continue_sync
    ///
    /// Recorded when button to sign in or sign up is clicked This event was generated
    /// to correspond to the Legacy Telemetry event firefoxview_next.fxa_continue#sync.
    pub static fxa_continue_sync: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fxa_continue_sync".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(177.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FxaMobileSyncExtra {
        pub r#has_devices: Option<bool>,
    }

    impl ExtraKeys for FxaMobileSyncExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_devices"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_devices.and_then(|val| map.insert("has_devices".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.fxa_mobile_sync
    ///
    /// Recorded when the 'Try Firefox for mobile' button is clicked This event was
    /// generated to correspond to the Legacy Telemetry event
    /// firefoxview_next.fxa_mobile#sync.
    pub static fxa_mobile_sync: Lazy<EventMetric<FxaMobileSyncExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fxa_mobile_sync".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(178.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.history_visits
    ///
    /// Recorded when a history tab is clicked This event was generated to correspond
    /// to the Legacy Telemetry event firefoxview_next.history#visits.
    pub static history_visits: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "history_visits".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(179.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenTabTabsExtra {
        pub r#page: Option<String>,
        pub r#window: Option<String>,
    }

    impl ExtraKeys for OpenTabTabsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["page", "window"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#window.and_then(|val| map.insert("window".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.open_tab_tabs
    ///
    /// Recorded when an open tab is clicked This event was generated to correspond to
    /// the Legacy Telemetry event firefoxview_next.open_tab#tabs.
    pub static open_tab_tabs: Lazy<EventMetric<OpenTabTabsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_tab_tabs".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(180.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RecentlyClosedTabsExtra {
        pub r#delta: Option<String>,
        pub r#page: Option<String>,
        pub r#position: Option<u32>,
    }

    impl ExtraKeys for RecentlyClosedTabsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["delta", "page", "position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#delta.and_then(|val| map.insert("delta".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.recently_closed_tabs
    ///
    /// Recorded when a recently closed tab is clicked This event was generated to
    /// correspond to the Legacy Telemetry event firefoxview_next.recently_closed#tabs.
    pub static recently_closed_tabs: Lazy<EventMetric<RecentlyClosedTabsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "recently_closed_tabs".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(181.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SearchInitiatedSearchExtra {
        pub r#page: Option<String>,
    }

    impl ExtraKeys for SearchInitiatedSearchExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["page"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.search_initiated_search
    ///
    /// Recorded when search is initiated and from what page. This event was generated
    /// to correspond to the Legacy Telemetry event
    /// firefoxview_next.search_initiated#search.
    pub static search_initiated_search: Lazy<EventMetric<SearchInitiatedSearchExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "search_initiated_search".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(182.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SearchShowAllShowallbuttonExtra {
        pub r#section: Option<String>,
    }

    impl ExtraKeys for SearchShowAllShowallbuttonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["section"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.search_show_all_showallbutton
    ///
    /// Recorded when the show all button is clicked to show more search results. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// firefoxview_next.search_show_all#showallbutton.
    pub static search_show_all_showallbutton: Lazy<EventMetric<SearchShowAllShowallbuttonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "search_show_all_showallbutton".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(183.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.show_all_history_tabs
    ///
    /// Recorded when the 'Show all history' button is clicked on the History page in
    /// Firefox View This event was generated to correspond to the Legacy Telemetry
    /// event firefoxview_next.show_all_history#tabs.
    pub static show_all_history_tabs: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_all_history_tabs".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(184.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SortHistoryTabsExtra {
        pub r#search_start: Option<String>,
        pub r#sort_type: Option<String>,
    }

    impl ExtraKeys for SortHistoryTabsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["search_start", "sort_type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#search_start.and_then(|val| map.insert("search_start".into(), val.to_string()));
          self.r#sort_type.and_then(|val| map.insert("sort_type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.sort_history_tabs
    ///
    /// Recorded when the sort option is changed for History in Firefox View This event
    /// was generated to correspond to the Legacy Telemetry event
    /// firefoxview_next.sort_history#tabs.
    pub static sort_history_tabs: Lazy<EventMetric<SortHistoryTabsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sort_history_tabs".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(185.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SyncedTabsTabsExtra {
        pub r#page: Option<String>,
    }

    impl ExtraKeys for SyncedTabsTabsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["page"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.synced_tabs_tabs
    ///
    /// Recorded when a synced tab is clicked This event was generated to correspond to
    /// the Legacy Telemetry event firefoxview_next.synced_tabs#tabs.
    pub static synced_tabs_tabs: Lazy<EventMetric<SyncedTabsTabsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "synced_tabs_tabs".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(186.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.tab_selected_toolbarbutton
    ///
    /// Recorded when the Firefox View tab is clicked This event was generated to
    /// correspond to the Legacy Telemetry event
    /// firefoxview_next.tab_selected#toolbarbutton.
    pub static tab_selected_toolbarbutton: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tab_selected_toolbarbutton".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(187.into(), meta)
    });

}
pub mod genai_chatbot {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ContextmenuPromptClickExtra {
        pub r#prompt: Option<String>,
        pub r#provider: Option<String>,
        pub r#selection: Option<u32>,
    }

    impl ExtraKeys for ContextmenuPromptClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["prompt", "provider", "selection"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#prompt.and_then(|val| map.insert("prompt".into(), val.to_string()));
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#selection.and_then(|val| map.insert("selection".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.contextmenu_prompt_click
    ///
    /// Chatbot prompt was clicked from the context menu.
    pub static contextmenu_prompt_click: Lazy<EventMetric<ContextmenuPromptClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "contextmenu_prompt_click".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(188.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.enabled
    ///
    /// Indicates if the chatbot feature is enabled.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(189.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExperimentCheckboxClickExtra {
        pub r#enabled: Option<bool>,
    }

    impl ExtraKeys for ExperimentCheckboxClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["enabled"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#enabled.and_then(|val| map.insert("enabled".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.experiment_checkbox_click
    ///
    /// Chatbot experiment checkbox was clicked to enable/disable.
    pub static experiment_checkbox_click: Lazy<EventMetric<ExperimentCheckboxClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "experiment_checkbox_click".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(190.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OnboardingCloseExtra {
        pub r#provider: Option<String>,
        pub r#step: Option<u32>,
    }

    impl ExtraKeys for OnboardingCloseExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider", "step"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.onboarding_close
    ///
    /// Chatbot onboarding closed from provider choice.
    pub static onboarding_close: Lazy<EventMetric<OnboardingCloseExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "onboarding_close".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(191.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OnboardingContinueExtra {
        pub r#provider: Option<String>,
        pub r#step: Option<u32>,
    }

    impl ExtraKeys for OnboardingContinueExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider", "step"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.onboarding_continue
    ///
    /// Chatbot onboarding continued from provider choice.
    pub static onboarding_continue: Lazy<EventMetric<OnboardingContinueExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "onboarding_continue".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(192.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OnboardingFinishExtra {
        pub r#provider: Option<String>,
        pub r#step: Option<u32>,
    }

    impl ExtraKeys for OnboardingFinishExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider", "step"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.onboarding_finish
    ///
    /// Chatbot onboarding finished with start chatting button.
    pub static onboarding_finish: Lazy<EventMetric<OnboardingFinishExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "onboarding_finish".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(193.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OnboardingLearnMoreExtra {
        pub r#provider: Option<String>,
        pub r#step: Option<u32>,
    }

    impl ExtraKeys for OnboardingLearnMoreExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider", "step"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.onboarding_learn_more
    ///
    /// Chatbot onboarding opened feature learn more link.
    pub static onboarding_learn_more: Lazy<EventMetric<OnboardingLearnMoreExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "onboarding_learn_more".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(194.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OnboardingProviderChoiceDisplayedExtra {
        pub r#provider: Option<String>,
        pub r#step: Option<u32>,
    }

    impl ExtraKeys for OnboardingProviderChoiceDisplayedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider", "step"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.onboarding_provider_choice_displayed
    ///
    /// Chatbot onboarding impression for provider choice screen.
    pub static onboarding_provider_choice_displayed: Lazy<EventMetric<OnboardingProviderChoiceDisplayedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "onboarding_provider_choice_displayed".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(195.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OnboardingProviderLearnExtra {
        pub r#provider: Option<String>,
        pub r#step: Option<u32>,
    }

    impl ExtraKeys for OnboardingProviderLearnExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider", "step"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.onboarding_provider_learn
    ///
    /// Chatbot onboarding opened provider learn more link.
    pub static onboarding_provider_learn: Lazy<EventMetric<OnboardingProviderLearnExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "onboarding_provider_learn".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(196.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OnboardingProviderSelectionExtra {
        pub r#provider: Option<String>,
        pub r#step: Option<u32>,
    }

    impl ExtraKeys for OnboardingProviderSelectionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider", "step"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.onboarding_provider_selection
    ///
    /// Chatbot onboarding selected a provider.
    pub static onboarding_provider_selection: Lazy<EventMetric<OnboardingProviderSelectionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "onboarding_provider_selection".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(197.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OnboardingProviderTermsExtra {
        pub r#provider: Option<String>,
        pub r#step: Option<u32>,
        pub r#text: Option<String>,
    }

    impl ExtraKeys for OnboardingProviderTermsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider", "step", "text"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#text.and_then(|val| map.insert("text".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.onboarding_provider_terms
    ///
    /// Chatbot onboarding opened provider terms link.
    pub static onboarding_provider_terms: Lazy<EventMetric<OnboardingProviderTermsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "onboarding_provider_terms".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(198.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OnboardingTextHighlightDisplayedExtra {
        pub r#provider: Option<String>,
        pub r#step: Option<u32>,
    }

    impl ExtraKeys for OnboardingTextHighlightDisplayedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider", "step"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.onboarding_text_highlight_displayed
    ///
    /// Chatbot onboarding impression for text highlight screen.
    pub static onboarding_text_highlight_displayed: Lazy<EventMetric<OnboardingTextHighlightDisplayedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "onboarding_text_highlight_displayed".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(199.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.provider
    ///
    /// Indicates id of activated chatbot provider or "custom" or "none"
    pub static provider: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "provider".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(200.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ProviderChangeExtra {
        pub r#current: Option<String>,
        pub r#previous: Option<String>,
        pub r#surface: Option<String>,
    }

    impl ExtraKeys for ProviderChangeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["current", "previous", "surface"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#current.and_then(|val| map.insert("current".into(), val.to_string()));
          self.r#previous.and_then(|val| map.insert("previous".into(), val.to_string()));
          self.r#surface.and_then(|val| map.insert("surface".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.provider_change
    ///
    /// Chatbot provider UI changed providers.
    pub static provider_change: Lazy<EventMetric<ProviderChangeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "provider_change".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(201.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.shortcuts
    ///
    /// Indicates if the chatbot feature would show shortcuts on selection.
    pub static shortcuts: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shortcuts".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(202.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShortcutsCheckboxClickExtra {
        pub r#enabled: Option<bool>,
    }

    impl ExtraKeys for ShortcutsCheckboxClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["enabled"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#enabled.and_then(|val| map.insert("enabled".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.shortcuts_checkbox_click
    ///
    /// Chatbot shortcuts checkbox was clicked to enable/disable.
    pub static shortcuts_checkbox_click: Lazy<EventMetric<ShortcutsCheckboxClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shortcuts_checkbox_click".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(203.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.shortcuts_custom
    ///
    /// Indicates if the chatbot feature would show shortcuts custom input.
    pub static shortcuts_custom: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shortcuts_custom".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(204.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShortcutsDisplayedExtra {
        pub r#delay: Option<u32>,
        pub r#inputType: Option<String>,
        pub r#selection: Option<u32>,
    }

    impl ExtraKeys for ShortcutsDisplayedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["delay", "inputType", "selection"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#delay.and_then(|val| map.insert("delay".into(), val.to_string()));
          self.r#inputType.and_then(|val| map.insert("inputType".into(), val.to_string()));
          self.r#selection.and_then(|val| map.insert("selection".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.shortcuts_displayed
    ///
    /// Shortcuts displayed on text selection.
    pub static shortcuts_displayed: Lazy<EventMetric<ShortcutsDisplayedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shortcuts_displayed".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(205.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShortcutsExpandedExtra {
        pub r#selection: Option<u32>,
    }

    impl ExtraKeys for ShortcutsExpandedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["selection"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#selection.and_then(|val| map.insert("selection".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.shortcuts_expanded
    ///
    /// Shortcuts expanded to show prompts.
    pub static shortcuts_expanded: Lazy<EventMetric<ShortcutsExpandedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shortcuts_expanded".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(206.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShortcutsHideClickExtra {
        pub r#selection: Option<u32>,
    }

    impl ExtraKeys for ShortcutsHideClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["selection"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#selection.and_then(|val| map.insert("selection".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.shortcuts_hide_click
    ///
    /// Chatbot hide shortcuts was clicked from the shortcuts.
    pub static shortcuts_hide_click: Lazy<EventMetric<ShortcutsHideClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shortcuts_hide_click".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(207.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShortcutsPromptClickExtra {
        pub r#prompt: Option<String>,
        pub r#provider: Option<String>,
        pub r#selection: Option<u32>,
    }

    impl ExtraKeys for ShortcutsPromptClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["prompt", "provider", "selection"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#prompt.and_then(|val| map.insert("prompt".into(), val.to_string()));
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#selection.and_then(|val| map.insert("selection".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.shortcuts_prompt_click
    ///
    /// Chatbot prompt was clicked from the shortcuts.
    pub static shortcuts_prompt_click: Lazy<EventMetric<ShortcutsPromptClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shortcuts_prompt_click".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(208.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.sidebar
    ///
    /// Indicates if the chatbot feature would open in sidebar.
    pub static sidebar: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(209.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarCloseClickExtra {
        pub r#provider: Option<String>,
    }

    impl ExtraKeys for SidebarCloseClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.sidebar_close_click
    ///
    /// Chatbot close X clicked.
    pub static sidebar_close_click: Lazy<EventMetric<SidebarCloseClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_close_click".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(210.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarMoreMenuClickExtra {
        pub r#action: Option<String>,
        pub r#provider: Option<String>,
    }

    impl ExtraKeys for SidebarMoreMenuClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action", "provider"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.sidebar_more_menu_click
    ///
    /// Chatbot more menu clicked an action.
    pub static sidebar_more_menu_click: Lazy<EventMetric<SidebarMoreMenuClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_more_menu_click".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(211.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarMoreMenuDisplayExtra {
        pub r#provider: Option<String>,
    }

    impl ExtraKeys for SidebarMoreMenuDisplayExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.sidebar_more_menu_display
    ///
    /// Chatbot more menu opened.
    pub static sidebar_more_menu_display: Lazy<EventMetric<SidebarMoreMenuDisplayExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_more_menu_display".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(212.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarProviderMenuClickExtra {
        pub r#action: Option<String>,
        pub r#provider: Option<String>,
    }

    impl ExtraKeys for SidebarProviderMenuClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action", "provider"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.sidebar_provider_menu_click
    ///
    /// Chatbot provider menu clicked an action.
    pub static sidebar_provider_menu_click: Lazy<EventMetric<SidebarProviderMenuClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_provider_menu_click".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(213.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarToggleExtra {
        pub r#opened: Option<bool>,
        pub r#provider: Option<String>,
        pub r#reason: Option<String>,
    }

    impl ExtraKeys for SidebarToggleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["opened", "provider", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#opened.and_then(|val| map.insert("opened".into(), val.to_string()));
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.sidebar_toggle
    ///
    /// Chatbot sidebar panel was toggled open/close.
    pub static sidebar_toggle: Lazy<EventMetric<SidebarToggleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_toggle".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(214.into(), meta)
    });

}
pub mod background_update {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from background_update.reasons_to_not_update
    ///
    /// Records which error was causing the background updater to fail. This list
    /// supercedes the `background-update.reason` in `mozapps/update/metrics.yaml`
    pub static reasons_to_not_update: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reasons_to_not_update".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into(), "metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(215.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.time_last_update_scheduled
    ///
    /// Last time the background update was triggered.
    pub static time_last_update_scheduled: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time_last_update_scheduled".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into(), "metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(216.into(), meta, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.automatic_restart_attempted
    ///
    /// True if the background update task successfully attempted an automatic restart.
    pub static automatic_restart_attempted: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "automatic_restart_attempted".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(217.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.automatic_restart_success
    ///
    /// True if the background update task successfully restarted after an automatic
    /// restart.
    pub static automatic_restart_success: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "automatic_restart_success".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(218.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.client_id
    ///
    /// The legacy Telemetry client ID of this installation's default profile.
    /// The default profile is as determined by the Profile Service, namely
    /// `nsIToolkitProfileService.defaultProfile`.  The majority of users have only one
    /// Firefox installation and only one profile, so the default profile is their
    /// regular browsing profile.
    /// It is possible for a Firefox installation to not have a default profile, but in
    /// such cases the background update task will abort before sending any telemetry;
    /// therefore, the legacy Telemetry client ID should always be present.
    pub static client_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "client_id".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into(), "baseline".into(), "events".into(), "metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(219.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.exit_code_exception
    ///
    /// True if the exit code/status of the background update task is 3, which means an
    /// exception was thrown.
    pub static exit_code_exception: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_code_exception".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(220.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.exit_code_success
    ///
    /// True if the exit code/status of the background update task is 0, which means
    /// success.
    pub static exit_code_success: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_code_success".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(221.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.final_state
    ///
    /// String description of the final state the update state machine reached.
    pub static final_state: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "final_state".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(222.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.reasons
    ///
    /// List of reasons that the background update task did not run.
    pub static reasons: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reasons".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(223.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.states
    ///
    /// Ordered list of string descriptions of the states that the update state machine
    /// reached.
    pub static states: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "states".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(224.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_env_current_date
    ///
    /// The `environment.currentDate` of the default profile's serialized targeting
    /// snapshot.
    pub static targeting_env_current_date: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "targeting_env_current_date".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(225.into(), meta, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_env_firefox_version
    ///
    /// The `environment.firefoxVersion` of the default profile's serialized targeting
    /// snapshot.  At the time of writing, this version is an integer representing the
    /// Firefox major version, e.g., `109`.
    pub static targeting_env_firefox_version: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "targeting_env_firefox_version".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(226.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_env_profile_age
    ///
    /// The `environment.profileAgeCreated` of the default profile's serialized
    /// targeting snapshot.
    pub static targeting_env_profile_age: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "targeting_env_profile_age".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(227.into(), meta, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_exception
    ///
    /// True if the default profile had a targeting snapshot serialized to disk, but an
    /// exception was thrown reading it.
    pub static targeting_exception: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "targeting_exception".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(228.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_exists
    ///
    /// True if the default profile had a targeting snapshot serialized to disk, and
    /// there was no exception thrown reading it.
    pub static targeting_exists: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "targeting_exists".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(229.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_version
    ///
    /// If the default profile had a targeting snapshot serialized to disk, the
    /// `version` of the snapshot.
    /// This version number does not have a physical unit: it's only useful to compare
    /// between versions.
    pub static targeting_version: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "targeting_version".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(230.into(), meta)
    });

}
pub mod browser_launched_to_handle {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SystemNotificationExtra {
        pub r#action: Option<String>,
        pub r#name: Option<String>,
    }

    impl ExtraKeys for SystemNotificationExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action", "name"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          self.r#name.and_then(|val| map.insert("name".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.launched_to_handle.system_notification
    ///
    /// Recorded when Firefox launches to complete a native notification popped by a
    /// system (chrome privileged) alert.  Windows-only at the time of writing.
    pub static system_notification: Lazy<EventMetric<SystemNotificationExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "system_notification".into(),
                category: "browser.launched_to_handle".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(231.into(), meta)
    });

}
pub mod browser_startup {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.startup.abouthome_cache_result
    ///
    /// How the about:home startup cache functioned on startup.
    /// 0: Result value was never set (error case) 1: Cache did not exist 2: Cache page
    /// stream was corrupt / inaccessible 3: Cache script stream was corrupt /
    /// inaccessible 4: Cache was invalidated by a version bump 5: Cache was valid, but
    /// read too late to be useful. 6: Cache was valid and used. 7: Cache is disabled.
    /// 8: User did not load about:home on its own by default. 9: Cache is disabled
    /// because about:newtab preloading is disabled.
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.startup.abouthome_cache_result.
    pub static abouthome_cache_result: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "abouthome_cache_result".into(),
                category: "browser.startup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(232.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.startup.abouthome_cache_shutdownwrite
    ///
    /// True if the about:home startup cache was written via the AsyncShutdown blocker.
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.startup.abouthome_cache_shutdownwrite.
    pub static abouthome_cache_shutdownwrite: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "abouthome_cache_shutdownwrite".into(),
                category: "browser.startup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(233.into(), meta)
    });

}
pub mod datasanitization {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.privacy_clear_on_shutdown_cache
    ///
    /// A boolean reporting the value of the privacy.clearOnShutdown.cache pref. This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// datasanitization.privacy_clearOnShutdown_cache.
    pub static privacy_clear_on_shutdown_cache: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_clear_on_shutdown_cache".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(234.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.privacy_clear_on_shutdown_cookies
    ///
    /// A boolean reporting the value of the privacy.clearOnShutdown.cookies pref. This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// datasanitization.privacy_clearOnShutdown_cookies.
    pub static privacy_clear_on_shutdown_cookies: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_clear_on_shutdown_cookies".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(235.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.privacy_clear_on_shutdown_downloads
    ///
    /// A boolean reporting the value of the privacy.clearOnShutdown.downloads pref.
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// datasanitization.privacy_clearOnShutdown_downloads.
    pub static privacy_clear_on_shutdown_downloads: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_clear_on_shutdown_downloads".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(236.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.privacy_clear_on_shutdown_formdata
    ///
    /// A boolean reporting the value of the privacy.clearOnShutdown.formdata pref.
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// datasanitization.privacy_clearOnShutdown_formdata.
    pub static privacy_clear_on_shutdown_formdata: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_clear_on_shutdown_formdata".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(237.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.privacy_clear_on_shutdown_history
    ///
    /// A boolean reporting the value of the privacy.clearOnShutdown.history pref. This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// datasanitization.privacy_clearOnShutdown_history.
    pub static privacy_clear_on_shutdown_history: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_clear_on_shutdown_history".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(238.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.privacy_clear_on_shutdown_offline_apps
    ///
    /// A boolean reporting the value of the privacy.clearOnShutdown.offlineApps pref.
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// datasanitization.privacy_clearOnShutdown_offlineApps.
    pub static privacy_clear_on_shutdown_offline_apps: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_clear_on_shutdown_offline_apps".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(239.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.privacy_clear_on_shutdown_open_windows
    ///
    /// A boolean reporting the value of the privacy.clearOnShutdown.openWindows pref.
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// datasanitization.privacy_clearOnShutdown_openWindows.
    pub static privacy_clear_on_shutdown_open_windows: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_clear_on_shutdown_open_windows".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(240.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.privacy_clear_on_shutdown_sessions
    ///
    /// A boolean reporting the value of the privacy.clearOnShutdown.sessions pref.
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// datasanitization.privacy_clearOnShutdown_sessions.
    pub static privacy_clear_on_shutdown_sessions: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_clear_on_shutdown_sessions".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(241.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.privacy_clear_on_shutdown_site_settings
    ///
    /// A boolean reporting the value of the privacy.clearOnShutdown.siteSettings pref.
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// datasanitization.privacy_clearOnShutdown_siteSettings.
    pub static privacy_clear_on_shutdown_site_settings: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_clear_on_shutdown_site_settings".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(242.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.privacy_sanitize_sanitize_on_shutdown
    ///
    /// A boolean reporting the value of the privacy.sanitize.sanitizeOnShutdown pref.
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// datasanitization.privacy_sanitize_sanitizeOnShutdown.
    pub static privacy_sanitize_sanitize_on_shutdown: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_sanitize_sanitize_on_shutdown".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(243.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.session_permission_exceptions
    ///
    /// A count of how many "session" cookie exceptions a user has set. This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// datasanitization.session_permission_exceptions.
    pub static session_permission_exceptions: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "session_permission_exceptions".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(244.into(), meta)
    });

}
pub mod launch_on_login {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from launch_on_login.last_profile_disable_startup
    ///
    /// Recorded when Launch on login is disabled because the start with last profile
    /// setting has been disabled. This event was generated to correspond to the Legacy
    /// Telemetry event launch_on_login.last_profile_disable#startup.
    pub static last_profile_disable_startup: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "last_profile_disable_startup".into(),
                category: "launch_on_login".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(245.into(), meta)
    });

}
pub mod os_environment {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from os.environment.invoked_to_handle
    ///
    /// Records counts for when Firefox was invoked (i.e., was already running and was
    /// not launched) to handle a file type or protocol with `-osint -url ...`.  The
    /// result is split into keys which represent the file extension: currently, the
    /// set of file types Firefox registers to handle, namely ".avif", ".htm", ".html",
    /// ".pdf", ".shtml", ".xht", ".xhtml", ".svg", ".webp", and the set of protocol
    /// schemes that Firefox registers to handle, namely "about", "http", "https",
    /// "mailto".  If Firefox was invoked to handle a file type or protocol it does not
    /// register to handle by default, the count is recorded as ".<other extension>" or
    /// "<other protocol>", respectively (neither of which are valid extension or
    /// protocol identifiers). This metric was generated to correspond to the Legacy
    /// Telemetry scalar os.environment.invoked_to_handle.
    pub static invoked_to_handle: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "invoked_to_handle".into(),
                    category: "os.environment".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(246.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from os.environment.is_default_handler
    ///
    /// Records whether Firefox was the default handler for particular file types or
    /// protocols.  The result is split into keys which represent the file extension or
    /// scheme: currently, a subset of the file types Firefox registers to handle,
    /// namely ".pdf" and "mailto" as protocol. In the future, more file types may be
    /// recorded. This metric was generated to correspond to the Legacy Telemetry
    /// scalar os.environment.is_default_handler.
    pub static is_default_handler: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "is_default_handler".into(),
                    category: "os.environment".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(247.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from os.environment.is_kept_in_dock
    ///
    /// Whether this app was kept in macOS Dock on startup This metric was generated to
    /// correspond to the Legacy Telemetry scalar os.environment.is_kept_in_dock.
    pub static is_kept_in_dock: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_kept_in_dock".into(),
                category: "os.environment".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(248.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from os.environment.is_taskbar_pinned
    ///
    /// Whether the non-Private Browsing version of this app was pinned to taskbar on
    /// startup This metric was generated to correspond to the Legacy Telemetry scalar
    /// os.environment.is_taskbar_pinned.
    pub static is_taskbar_pinned: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_taskbar_pinned".into(),
                category: "os.environment".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(249.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from os.environment.is_taskbar_pinned_private
    ///
    /// Whether the Private Browsing version of this app was pinned to taskbar on
    /// startup This metric was generated to correspond to the Legacy Telemetry scalar
    /// os.environment.is_taskbar_pinned_private.
    pub static is_taskbar_pinned_private: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_taskbar_pinned_private".into(),
                category: "os.environment".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(250.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from os.environment.launch_method
    ///
    /// Records how Firefox was started on Windows. Currently will be one of "Desktop",
    /// "DesktopPrivate", "StartMenu" (including pins), "StartMenuPrivate", "Taskbar",
    /// "TaskbarPrivate", "OtherShortcut", or "Other" This metric was generated to
    /// correspond to the Legacy Telemetry scalar os.environment.launch_method.
    pub static launch_method: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "launch_method".into(),
                category: "os.environment".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(251.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from os.environment.launched_to_handle
    ///
    /// Records counts for when Firefox was launched afresh (i.e., was not already
    /// running) to handle a file type or protocol with `-osint -url ...`.  The result
    /// is split into keys which represent the file extension: currently, the set of
    /// file types Firefox registers to handle, namely ".avif", ".htm", ".html",
    /// ".pdf", ".shtml", ".xht", ".xhtml", ".svg", ".webp", and the set of protocol
    /// schemes that Firefox registers to handle, namely "about", "http", "https",
    /// "mailto".  If Firefox was launched to handle a file type or protocol it does
    /// not register to handle by default, the count is recorded as ".<other
    /// extension>" or "<other protocol>", respectively (neither of which are valid
    /// extension or protocol identifiers). This metric was generated to correspond to
    /// the Legacy Telemetry scalar os.environment.launched_to_handle.
    pub static launched_to_handle: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "launched_to_handle".into(),
                    category: "os.environment".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(252.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from os.environment.allowed_app_sources
    ///
    /// Indicates what sources the OS is currently configured to allow apps to be
    /// installed from. Possible values are "Anywhere", "Recommendations",
    /// "PreferStore", "StoreOnly", "NoSuchFeature", or "Error". "Recommendations"
    /// allows installs from anywhere, but recommends a comparable app from the store,
    /// if available. "NoSuchFeature" will be reported on versions of Windows that do
    /// not have an app source setting. This metric was generated to correspond to the
    /// Legacy Telemetry scalar os.environment.allowed_app_sources.
    pub static allowed_app_sources: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "allowed_app_sources".into(),
                category: "os.environment".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(253.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from os.environment.is_admin_without_uac
    ///
    /// Indicates that the process is lauched with Admin privileges but without UAC.
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// os.environment.is_admin_without_uac.
    pub static is_admin_without_uac: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_admin_without_uac".into(),
                category: "os.environment".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(254.into(), meta)
    });

}
pub mod security {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from security.global_privacy_control_enabled
    ///
    /// Measures user retention of the Global Privacy Control. 0 = never enabled, 1 =
    /// enabled, 2 = disabled (but was enabled) This metric was generated to correspond
    /// to the Legacy Telemetry scalar security.global_privacy_control_enabled.
    pub static global_privacy_control_enabled: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "global_privacy_control_enabled".into(),
                category: "security".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(255.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.https_only_mode_enabled
    ///
    /// Measures user retention of the HTTPS-Only Mode. 0 = never enabled, 1 = enabled,
    /// 2 = disabled (but was enabled) This metric was generated to correspond to the
    /// Legacy Telemetry scalar security.https_only_mode_enabled.
    pub static https_only_mode_enabled: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "https_only_mode_enabled".into(),
                category: "security".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(256.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.https_only_mode_enabled_pbm
    ///
    /// Measures user retention of the HTTPS-Only Mode in Private Browsing. 0 = https-
    /// only never enabled in PBM, 1 = https-only enabled in PBM, 2 = https-only
    /// disabled in PBM (but was enabled) This metric was generated to correspond to
    /// the Legacy Telemetry scalar security.https_only_mode_enabled_pbm.
    pub static https_only_mode_enabled_pbm: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "https_only_mode_enabled_pbm".into(),
                category: "security".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(257.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FissionPrincipalsExtra {
        pub r#principal_type: Option<String>,
        pub r#scheme: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for FissionPrincipalsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["principal_type", "scheme", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#principal_type.and_then(|val| map.insert("principal_type".into(), val.to_string()));
          self.r#scheme.and_then(|val| map.insert("scheme".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.fission_principals
    ///
    /// When running with Fission, we received an unexpected principal from the content
    /// process. Expected values for this telemetry event are the method names in
    /// ContentParent that received the unexpected principal. This event was generated
    /// to correspond to the Legacy Telemetry event
    /// security.fissionPrincipals#contentParent.
    pub static fission_principals: Lazy<EventMetric<FissionPrincipalsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fission_principals".into(),
                category: "security".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(258.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EvalUsageParentProcessExtra {
        pub r#fileinfo: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EvalUsageParentProcessExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fileinfo", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fileinfo.and_then(|val| map.insert("fileinfo".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.eval_usage_parent_process
    ///
    /// eval() (or an eval()-like method) was called while running in the System
    /// Principal context or the Parent Process. Expected values are: chromeuri -
    /// chrome:// file   resourceuri - resource:// file datauri - a data URI   bloburi
    /// - a blob URI   abouturi - an about URI   singlestring - A single file or string
    /// with no slashes mozillaextension - An extension claiming to be from
    /// *mozilla.org (Deprecated)   otherextension - Another extension not from Mozilla
    /// (Deprecated)   mozillaextension_file - An extension claiming to be from
    /// *mozilla.org, loaded from a file://   otherextension_file - Another extension
    /// not from Mozilla, loaded from a file:// extension_uri - A URI with the moz-
    /// extension:// scheme suspectedUserChromeJS - A filepath ending in .uc.js
    /// sanitizedWindowsPath - A filepath, on Windows, sanitized by
    /// WinUtils::PreparePathForTelemetry                          which is a bare
    /// filename or a subpath of %ProgramFiles%, %SystemRoot%, or %TEMP%
    /// sanitizedWindowsURL - A partial URL, on Windows, consisting of either
    /// file://../ followed by the value prepared as for sanitizedWindowsPath, or the
    /// bare scheme of                         the original url   other - Unknown
    /// other-on-worker - We cannot do a regex; it is not a chrome, resource, data, or
    /// blob uri, but                     could be any other.   regexfailure - Our
    /// Regex Matching code threw an error The fileinfo key may contain additional
    /// information about the file that caused the eval() depending on the above value.
    /// Resource, Chrome, About, and SingleString will contain the full value. (About
    /// URIs will remove any querystring values.) Extensions-from-file will contain the
    /// full value; however .xpi! will be shortened to !, shield.mozilla.org! to s! and
    /// mozilla.org! to m!.  Data, Blob, UserChromeJS, Other, and Regexfailure should
    /// have no value. This event was generated to correspond to the Legacy Telemetry
    /// event security.evalUsage#parentProcess.
    pub static eval_usage_parent_process: Lazy<EventMetric<EvalUsageParentProcessExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "eval_usage_parent_process".into(),
                category: "security".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(259.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EvalUsageSystemContextExtra {
        pub r#fileinfo: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EvalUsageSystemContextExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fileinfo", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fileinfo.and_then(|val| map.insert("fileinfo".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.eval_usage_system_context
    ///
    /// eval() (or an eval()-like method) was called while running in the System
    /// Principal context or the Parent Process. Expected values are:
    ///   - chromeuri - chrome:// file
    ///   - resourceuri - resource:// file
    ///   - datauri - a data URI
    ///   - bloburi - a blob URI
    ///   - abouturi - an about URI
    ///   - singlestring - A single file or string with no slashes
    ///   - mozillaextension - An extension claiming to be from *mozilla.org
    /// (Deprecated)
    ///   - otherextension - Another extension not from Mozilla (Deprecated)
    ///   - mozillaextension_file - An extension claiming to be from *mozilla.org,
    /// loaded from a file://
    ///   - otherextension_file - Another extension not from Mozilla, loaded from a
    /// file://
    ///   - extension_uri - A URI with the moz-extension:// scheme
    ///   - suspectedUserChromeJS - A filepath ending in .uc.js
    ///   - sanitizedWindowsPath - A filepath, on Windows, sanitized by
    /// WinUtils::PreparePathForTelemetry which is a bare filename or a subpath of
    /// %ProgramFiles%, %SystemRoot%, or %TEMP%
    ///   - sanitizedWindowsURL - A partial URL, on Windows, consisting of either
    /// file://../ followed by the value prepared as for sanitizedWindowsPath, or the
    /// bare scheme of the original url
    ///   - other - Unknown
    ///   - other-on-worker - We cannot do a regex; it is not a chrome, resource, data,
    /// or blob uri, but could be any other.
    ///   - regexfailure - Our Regex Matching code threw an error
    /// 
    /// The fileinfo key may contain additional information about the file that caused
    /// the eval() depending on the above value. Resource, Chrome, About, and
    /// SingleString will contain the full value. (About URIs will remove any
    /// querystring values.)
    /// Extensions-from-file will contain the full value; however .xpi! will be
    /// shortened to !, shield.mozilla.org! to s! and mozilla.org! to m!.  Data, Blob,
    /// UserChromeJS, Other, and Regexfailure should have no value.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// security.evalUsage#systemContext.
    pub static eval_usage_system_context: Lazy<EventMetric<EvalUsageSystemContextExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "eval_usage_system_context".into(),
                category: "security".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(260.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct JavascriptLoadParentProcessExtra {
        pub r#fileinfo: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for JavascriptLoadParentProcessExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fileinfo", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fileinfo.and_then(|val| map.insert("fileinfo".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.javascript_load_parent_process
    ///
    /// The javascript engine requested to load a filename that was not allowed.
    /// Expected values, and fileinfo key, are the same possible values as above in
    /// 'evalUsage' This event was generated to correspond to the Legacy Telemetry
    /// event security.javascriptLoad#parentProcess.
    pub static javascript_load_parent_process: Lazy<EventMetric<JavascriptLoadParentProcessExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "javascript_load_parent_process".into(),
                category: "security".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(261.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnexpectedLoadExtra {
        pub r#contenttype: Option<String>,
        pub r#filedetails: Option<String>,
        pub r#redirects: Option<String>,
        pub r#remotetype: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnexpectedLoadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["contenttype", "filedetails", "redirects", "remotetype", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#contenttype.and_then(|val| map.insert("contenttype".into(), val.to_string()));
          self.r#filedetails.and_then(|val| map.insert("filedetails".into(), val.to_string()));
          self.r#redirects.and_then(|val| map.insert("redirects".into(), val.to_string()));
          self.r#remotetype.and_then(|val| map.insert("remotetype".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.unexpected_load
    ///
    /// Long term want to block all loads from the system principal that cause us to
    /// parse non-trivial data. We don't look to break existing functionality and will
    /// allow exceptions, for this we are collecting information about unexpected
    /// requests triggered by the system principal Our measurement *excludes*
    /// acceptable requests. Those are: - annotated using the
    /// 'AllowedDeprecatedSystemRequests' loadinfo flag - using a nsContentPolicyType
    /// of FETCH, XMLHTTPREQUEST, WEBSOCKET, SAVEAS_DOWNLOAD or IMAGE - with a
    /// requested URI object has the flag URI_IS_UI_RESOURCE - if the URL scheme is
    /// 'view-source' - if the URL scheme is 'file' and the Content-Type is STYLESHEET
    /// or OTHER - if the scheme is 'jar', 'about' or 'moz-extension' This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.unexpectedload#systemprincipal.
    pub static unexpected_load: Lazy<EventMetric<UnexpectedLoadExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unexpected_load".into(),
                category: "security".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(262.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PrefUsageContentProcessExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PrefUsageContentProcessExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.pref_usage_content_process
    ///
    /// We block certain preferences from being sent to the content process because
    /// they contain sensitive user data. Some preferences are blocked by name, others
    /// by heuristic. If one of the preferences so blocked is accidently accessed we
    /// want to know about it so we can allowlist it or refactor the access. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// security.prefUsage#contentProcess.
    pub static pref_usage_content_process: Lazy<EventMetric<PrefUsageContentProcessExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_usage_content_process".into(),
                category: "security".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(263.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.client_auth_cert_usage
    ///
    /// Measures how many servers have requested a client authentication certificate
    /// (key: "requested") and how many times the user has opted to send one in
    /// response (key: "sent"). This metric was generated to correspond to the Legacy
    /// Telemetry scalar security.client_auth_cert_usage.
    pub static client_auth_cert_usage: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "client_auth_cert_usage".into(),
                    category: "security".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(264.into(), meta, None)
    });

}
pub mod sslkeylogging {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from sslkeylogging.enabled
    ///
    /// Records whether TLS key logging has been enabled via the environment variable
    /// SSLKEYLOGFILE.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled".into(),
                category: "sslkeylogging".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(265.into(), meta)
    });

}
pub mod start_menu {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from start_menu.manually_unpinned_since_last_launch
    ///
    /// Records whether Firefox has been unpinned from the Windows start menu since
    /// last launch. This will only be recorded on MSIX due to the underlying API only
    /// being available for packaged applications.
    pub static manually_unpinned_since_last_launch: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "manually_unpinned_since_last_launch".into(),
                category: "start_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(266.into(), meta)
    });

}
pub mod startup {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from startup.is_cold
    ///
    /// Whether or not this startup is the first startup since OS reboot (according to
    /// our best guess.) This metric was generated to correspond to the Legacy
    /// Telemetry scalar startup.is_cold.
    pub static is_cold: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_cold".into(),
                category: "startup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(267.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from startup.seconds_since_last_os_restart
    ///
    /// The time in seconds between the first browser window loading, and the time the
    /// OS started. This can give us an indication of whether starting the browser may
    /// have been the first thing the user did after starting their computer. This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// startup.seconds_since_last_os_restart.
    pub static seconds_since_last_os_restart: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "seconds_since_last_os_restart".into(),
                category: "startup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(268.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from startup.profile_count
    ///
    /// This records the number of known profiles after startup completes. This
    /// includes any profiles that were created during startup. This metric was
    /// generated to correspond to the Legacy Telemetry scalar startup.profile_count.
    pub static profile_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "profile_count".into(),
                category: "startup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(269.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from startup.profile_database_version
    ///
    /// The version of the profiles.ini database loaded during startup. A value of "0"
    /// is used to indicate that no file was present during startup. This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// startup.profile_database_version.
    pub static profile_database_version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "profile_database_version".into(),
                category: "startup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(270.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from startup.profile_selection_reason
    ///
    /// How the profile was selected during startup. One of the following reasons:
    ///   unknown:
    ///     Generally should not happen, set as a default in case no other reason
    ///     occured.
    ///   profile-manager:
    ///     The profile was selected by the profile manager.
    ///   profile-selector:
    ///     The profile was selected by the profile selector window.
    ///   profile-reset:
    ///     The profile was selected for reset, normally this would mean a restart.
    ///   restart:
    ///     The user restarted the application, the same profile as previous will
    ///     be used.
    ///   argument-profile:
    ///     The profile was selected by the --profile command line argument.
    ///   argument-p:
    ///     The profile was selected by the -p command line argument.
    ///   firstrun-claimed-default:
    ///     A first run of a dedicated profiles build chose the old default
    ///     profile to be the default for this install.
    ///   firstrun-skipped-default:
    ///     A first run of a dedicated profiles build skipped over the old default
    ///     profile and created a new profile.
    ///   restart-claimed-default:
    ///     A first run of a dedicated profiles build after a restart chose the
    ///     old default profile to be the default for this install.
    ///   restart-skipped-default:
    ///     A first run of a dedicated profiles build after a restart skipped over
    ///     the old default profile and created a new profile.
    ///   firstrun-created-default:
    ///     A first run of the application created a new profile to use.
    ///   default:
    ///     The default profile was selected as normal.
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// startup.profile_selection_reason.
    pub static profile_selection_reason: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "profile_selection_reason".into(),
                category: "startup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(271.into(), meta)
    });

}
pub mod upgrade_dialog {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TriggerReasonExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for TriggerReasonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from upgrade_dialog.trigger_reason
    ///
    /// Triggering behaviors of the upgrade dialog. Value indicates which condition
    /// failed or all satisfied. This event was generated to correspond to the Legacy
    /// Telemetry event upgrade_dialog.trigger#reason.
    pub static trigger_reason: Lazy<EventMetric<TriggerReasonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "trigger_reason".into(),
                category: "upgrade_dialog".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(272.into(), meta)
    });

}
pub mod browser_migration {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct BrowserSelectedWizardExtra {
        pub r#migrator_key: Option<String>,
    }

    impl ExtraKeys for BrowserSelectedWizardExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["migrator_key"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#migrator_key.and_then(|val| map.insert("migrator_key".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.browser_selected_wizard
    ///
    /// Recorded when the user selects a browser to migrate from. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// browser.migration.browser_selected#wizard.
    pub static browser_selected_wizard: Lazy<EventMetric<BrowserSelectedWizardExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "browser_selected_wizard".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(273.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LinuxPermsWizardExtra {
        pub r#migrator_key: Option<String>,
    }

    impl ExtraKeys for LinuxPermsWizardExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["migrator_key"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#migrator_key.and_then(|val| map.insert("migrator_key".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.linux_perms_wizard
    ///
    /// Recorded if the user is on Linux and the browser is installed in a sandboxed
    /// environment that prevents it from reading other browser's data, and the user is
    /// presented with instructions and an option to grant the browser permission to
    /// read that other data. This event was generated to correspond to the Legacy
    /// Telemetry event browser.migration.linux_perms#wizard.
    pub static linux_perms_wizard: Lazy<EventMetric<LinuxPermsWizardExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "linux_perms_wizard".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(274.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.matched_extensions
    ///
    /// Records a list of the Chrome extension IDs that were successfully matched to
    /// Firefox equivalents from the list downloaded from AMO.
    pub static matched_extensions: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "matched_extensions".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(275.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct MigrationFinishedWizardExtra {
        pub r#bookmarks: Option<String>,
        pub r#extensions: Option<String>,
        pub r#formdata: Option<String>,
        pub r#history: Option<String>,
        pub r#migrator_key: Option<String>,
        pub r#other: Option<u32>,
        pub r#passwords: Option<String>,
        pub r#payment_methods: Option<String>,
    }

    impl ExtraKeys for MigrationFinishedWizardExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["bookmarks", "extensions", "formdata", "history", "migrator_key", "other", "passwords", "payment_methods"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#bookmarks.and_then(|val| map.insert("bookmarks".into(), val.to_string()));
          self.r#extensions.and_then(|val| map.insert("extensions".into(), val.to_string()));
          self.r#formdata.and_then(|val| map.insert("formdata".into(), val.to_string()));
          self.r#history.and_then(|val| map.insert("history".into(), val.to_string()));
          self.r#migrator_key.and_then(|val| map.insert("migrator_key".into(), val.to_string()));
          self.r#other.and_then(|val| map.insert("other".into(), val.to_string()));
          self.r#passwords.and_then(|val| map.insert("passwords".into(), val.to_string()));
          self.r#payment_methods.and_then(|val| map.insert("payment_methods".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.migration_finished_wizard
    ///
    /// Recorded when the user finishes a migration. This event was generated to
    /// correspond to the Legacy Telemetry event
    /// browser.migration.migration_finished#wizard.
    pub static migration_finished_wizard: Lazy<EventMetric<MigrationFinishedWizardExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "migration_finished_wizard".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(276.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct MigrationStartedWizardExtra {
        pub r#bookmarks: Option<String>,
        pub r#extensions: Option<String>,
        pub r#formdata: Option<String>,
        pub r#history: Option<String>,
        pub r#migrator_key: Option<String>,
        pub r#other: Option<u32>,
        pub r#passwords: Option<String>,
        pub r#payment_methods: Option<String>,
    }

    impl ExtraKeys for MigrationStartedWizardExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["bookmarks", "extensions", "formdata", "history", "migrator_key", "other", "passwords", "payment_methods"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#bookmarks.and_then(|val| map.insert("bookmarks".into(), val.to_string()));
          self.r#extensions.and_then(|val| map.insert("extensions".into(), val.to_string()));
          self.r#formdata.and_then(|val| map.insert("formdata".into(), val.to_string()));
          self.r#history.and_then(|val| map.insert("history".into(), val.to_string()));
          self.r#migrator_key.and_then(|val| map.insert("migrator_key".into(), val.to_string()));
          self.r#other.and_then(|val| map.insert("other".into(), val.to_string()));
          self.r#passwords.and_then(|val| map.insert("passwords".into(), val.to_string()));
          self.r#payment_methods.and_then(|val| map.insert("payment_methods".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.migration_started_wizard
    ///
    /// Recorded when the user begins a migration. This event was generated to
    /// correspond to the Legacy Telemetry event
    /// browser.migration.migration_started#wizard.
    pub static migration_started_wizard: Lazy<EventMetric<MigrationStartedWizardExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "migration_started_wizard".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(277.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.no_browsers_found_wizard
    ///
    /// Recorded when the migration wizard reports that there are no browsers to
    /// migrate from. This event was generated to correspond to the Legacy Telemetry
    /// event browser.migration.no_browsers_found#wizard.
    pub static no_browsers_found_wizard: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "no_browsers_found_wizard".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(278.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.opened_wizard
    ///
    /// Recorded when the migration wizard opens. This event was generated to
    /// correspond to the Legacy Telemetry event browser.migration.opened#wizard.
    pub static opened_wizard: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "opened_wizard".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(279.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ProfileSelectedWizardExtra {
        pub r#migrator_key: Option<String>,
    }

    impl ExtraKeys for ProfileSelectedWizardExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["migrator_key"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#migrator_key.and_then(|val| map.insert("migrator_key".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.profile_selected_wizard
    ///
    /// Recorded when the user selects a profile to migrate from. If the browser
    /// doesn't support multiple profiles, this will not be recorded. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// browser.migration.profile_selected#wizard.
    pub static profile_selected_wizard: Lazy<EventMetric<ProfileSelectedWizardExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "profile_selected_wizard".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(280.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ResourcesSelectedWizardExtra {
        pub r#bookmarks: Option<String>,
        pub r#configured: Option<String>,
        pub r#extensions: Option<String>,
        pub r#formdata: Option<String>,
        pub r#history: Option<String>,
        pub r#migrator_key: Option<String>,
        pub r#other: Option<u32>,
        pub r#passwords: Option<String>,
        pub r#payment_methods: Option<String>,
    }

    impl ExtraKeys for ResourcesSelectedWizardExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["bookmarks", "configured", "extensions", "formdata", "history", "migrator_key", "other", "passwords", "payment_methods"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#bookmarks.and_then(|val| map.insert("bookmarks".into(), val.to_string()));
          self.r#configured.and_then(|val| map.insert("configured".into(), val.to_string()));
          self.r#extensions.and_then(|val| map.insert("extensions".into(), val.to_string()));
          self.r#formdata.and_then(|val| map.insert("formdata".into(), val.to_string()));
          self.r#history.and_then(|val| map.insert("history".into(), val.to_string()));
          self.r#migrator_key.and_then(|val| map.insert("migrator_key".into(), val.to_string()));
          self.r#other.and_then(|val| map.insert("other".into(), val.to_string()));
          self.r#passwords.and_then(|val| map.insert("passwords".into(), val.to_string()));
          self.r#payment_methods.and_then(|val| map.insert("payment_methods".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.resources_selected_wizard
    ///
    /// Recorded when the user selects resources from the browser / profile to import.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// browser.migration.resources_selected#wizard.
    pub static resources_selected_wizard: Lazy<EventMetric<ResourcesSelectedWizardExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "resources_selected_wizard".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(281.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.safari_password_file_wizard
    ///
    /// Recorded if the user is on macOS, chose to migrate from Safari, and was
    /// presented with the page of the wizard requesting to import passwords from a
    /// file. This only gets recorded in the new migration wizard. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// browser.migration.safari_password_file#wizard.
    pub static safari_password_file_wizard: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "safari_password_file_wizard".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(282.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.safari_perms_wizard
    ///
    /// Recorded if the user is on macOS, chose to migrate from Safari, and was
    /// presented with the page of the wizard requesting permission to read from the
    /// Safari profile folder. This event was generated to correspond to the Legacy
    /// Telemetry event browser.migration.safari_perms#wizard.
    pub static safari_perms_wizard: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "safari_perms_wizard".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(283.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.unmatched_extensions
    ///
    /// Records a list of the Chrome extension IDs that were unsuccessfully matched to
    /// Firefox equivalents from the list downloaded from AMO.
    pub static unmatched_extensions: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unmatched_extensions".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(284.into(), meta)
    });

}
pub mod migration {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from migration.discovered_migrators
    ///
    /// A keyed uint recording how many times the migration wizard detected a browser /
    /// profile pair for a particular browser. This is incremented every time the
    /// discovery occurs, so multiple openings of the wizard will increase the counts
    /// each time. This metric was generated to correspond to the Legacy Telemetry
    /// scalar migration.discovered_migrators.
    pub static discovered_migrators: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "discovered_migrators".into(),
                    category: "migration".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(285.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from migration.time_to_produce_migrator_list
    ///
    /// The amount of time it took in milliseconds to produce the list of migrators and
    /// profiles for the first time the migration wizard opened during the process
    /// lifetime. This metric was generated to correspond to the Legacy Telemetry
    /// scalar migration.time_to_produce_migrator_list.
    pub static time_to_produce_migrator_list: Lazy<TimespanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time_to_produce_migrator_list".into(),
                category: "migration".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimespanMetric::new(286.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from migration.uninstaller_profile_refresh
    ///
    /// Set when a profile refresh is initiated from the uninstaller. This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// migration.uninstaller_profile_refresh.
    pub static uninstaller_profile_refresh: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uninstaller_profile_refresh".into(),
                category: "migration".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(287.into(), meta)
    });

}
pub mod activity_stream {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EndSessionExtra {
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<u32>,
    }

    impl ExtraKeys for EndSessionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.end_session
    ///
    /// This is recorded with every session ended in Activity Stream. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// activity_stream.end#session.
    pub static end_session: Lazy<EventMetric<EndSessionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "end_session".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(288.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventArchiveFromPocketExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventArchiveFromPocketExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_archive_from_pocket
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#ARCHIVE_FROM_POCKET.
    pub static event_archive_from_pocket: Lazy<EventMetric<EventArchiveFromPocketExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_archive_from_pocket".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(289.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventBlockExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventBlockExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_block
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#BLOCK.
    pub static event_block: Lazy<EventMetric<EventBlockExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_block".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(290.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventBookmarkAddExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventBookmarkAddExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_bookmark_add
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#BOOKMARK_ADD.
    pub static event_bookmark_add: Lazy<EventMetric<EventBookmarkAddExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_bookmark_add".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(291.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventBookmarkDeleteExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventBookmarkDeleteExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_bookmark_delete
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#BOOKMARK_DELETE.
    pub static event_bookmark_delete: Lazy<EventMetric<EventBookmarkDeleteExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_bookmark_delete".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(292.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventClickExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_click
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#CLICK.
    pub static event_click: Lazy<EventMetric<EventClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_click".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(293.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventClickPrivacyInfoExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventClickPrivacyInfoExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_click_privacy_info
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#CLICK_PRIVACY_INFO.
    pub static event_click_privacy_info: Lazy<EventMetric<EventClickPrivacyInfoExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_click_privacy_info".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(294.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventCloseNewtabPrefsExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventCloseNewtabPrefsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_close_newtab_prefs
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#CLOSE_NEWTAB_PREFS.
    pub static event_close_newtab_prefs: Lazy<EventMetric<EventCloseNewtabPrefsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_close_newtab_prefs".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(295.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventDeleteExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventDeleteExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_delete
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#DELETE.
    pub static event_delete: Lazy<EventMetric<EventDeleteExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_delete".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(296.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventDeleteConfirmExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventDeleteConfirmExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_delete_confirm
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#DELETE_CONFIRM.
    pub static event_delete_confirm: Lazy<EventMetric<EventDeleteConfirmExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_delete_confirm".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(297.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventDeleteFromPocketExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventDeleteFromPocketExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_delete_from_pocket
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#DELETE_FROM_POCKET.
    pub static event_delete_from_pocket: Lazy<EventMetric<EventDeleteFromPocketExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_delete_from_pocket".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(298.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventDialogCancelExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventDialogCancelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_dialog_cancel
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#DIALOG_CANCEL.
    pub static event_dialog_cancel: Lazy<EventMetric<EventDialogCancelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_dialog_cancel".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(299.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventDialogOpenExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventDialogOpenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_dialog_open
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#DIALOG_OPEN.
    pub static event_dialog_open: Lazy<EventMetric<EventDialogOpenExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_dialog_open".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(300.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventDisclaimerAckedExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventDisclaimerAckedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_disclaimer_acked
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#DISCLAIMER_ACKED.
    pub static event_disclaimer_acked: Lazy<EventMetric<EventDisclaimerAckedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_disclaimer_acked".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(301.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventDragExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventDragExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_drag
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#DRAG.
    pub static event_drag: Lazy<EventMetric<EventDragExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_drag".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(302.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventDropExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventDropExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_drop
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#DROP.
    pub static event_drop: Lazy<EventMetric<EventDropExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_drop".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(303.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventFakespotCategoryExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventFakespotCategoryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_fakespot_category
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#FAKESPOT_CATEGORY.
    pub static event_fakespot_category: Lazy<EventMetric<EventFakespotCategoryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_fakespot_category".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(304.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventFakespotClickExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventFakespotClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_fakespot_click
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#FAKESPOT_CLICK.
    pub static event_fakespot_click: Lazy<EventMetric<EventFakespotClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_fakespot_click".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(305.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventHidePersonalizeExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventHidePersonalizeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_hide_personalize
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#HIDE_PERSONALIZE.
    pub static event_hide_personalize: Lazy<EventMetric<EventHidePersonalizeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_hide_personalize".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(306.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventImpressionExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_impression
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#IMPRESSION.
    pub static event_impression: Lazy<EventMetric<EventImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_impression".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(307.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMenuAddSearchExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMenuAddSearchExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_menu_add_search
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#MENU_ADD_SEARCH.
    pub static event_menu_add_search: Lazy<EventMetric<EventMenuAddSearchExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_menu_add_search".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(308.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMenuAddTopsiteExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMenuAddTopsiteExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_menu_add_topsite
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#MENU_ADD_TOPSITE.
    pub static event_menu_add_topsite: Lazy<EventMetric<EventMenuAddTopsiteExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_menu_add_topsite".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(309.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMenuCollapseExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMenuCollapseExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_menu_collapse
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#MENU_COLLAPSE.
    pub static event_menu_collapse: Lazy<EventMetric<EventMenuCollapseExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_menu_collapse".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(310.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMenuExpandExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMenuExpandExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_menu_expand
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#MENU_EXPAND.
    pub static event_menu_expand: Lazy<EventMetric<EventMenuExpandExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_menu_expand".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(311.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMenuManageExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMenuManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_menu_manage
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#MENU_MANAGE.
    pub static event_menu_manage: Lazy<EventMetric<EventMenuManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_menu_manage".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(312.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMenuMoveDownExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMenuMoveDownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_menu_move_down
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#MENU_MOVE_DOWN.
    pub static event_menu_move_down: Lazy<EventMetric<EventMenuMoveDownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_menu_move_down".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(313.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMenuMoveUpExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMenuMoveUpExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_menu_move_up
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#MENU_MOVE_UP.
    pub static event_menu_move_up: Lazy<EventMetric<EventMenuMoveUpExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_menu_move_up".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(314.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMenuPrivacyNoticeExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMenuPrivacyNoticeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_menu_privacy_notice
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#MENU_PRIVACY_NOTICE.
    pub static event_menu_privacy_notice: Lazy<EventMetric<EventMenuPrivacyNoticeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_menu_privacy_notice".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(315.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMenuRemoveExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMenuRemoveExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_menu_remove
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#MENU_REMOVE.
    pub static event_menu_remove: Lazy<EventMetric<EventMenuRemoveExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_menu_remove".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(316.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMigrationCancelExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMigrationCancelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_migration_cancel
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#MIGRATION_CANCEL.
    pub static event_migration_cancel: Lazy<EventMetric<EventMigrationCancelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_migration_cancel".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(317.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMigrationStartExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMigrationStartExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_migration_start
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#MIGRATION_START.
    pub static event_migration_start: Lazy<EventMetric<EventMigrationStartExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_migration_start".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(318.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventOpenNewWindowExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventOpenNewWindowExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_open_new_window
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#OPEN_NEW_WINDOW.
    pub static event_open_new_window: Lazy<EventMetric<EventOpenNewWindowExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_open_new_window".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(319.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventOpenNewtabPrefsExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventOpenNewtabPrefsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_open_newtab_prefs
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#OPEN_NEWTAB_PREFS.
    pub static event_open_newtab_prefs: Lazy<EventMetric<EventOpenNewtabPrefsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_open_newtab_prefs".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(320.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventOpenPrivateWindowExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventOpenPrivateWindowExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_open_private_window
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#OPEN_PRIVATE_WINDOW.
    pub static event_open_private_window: Lazy<EventMetric<EventOpenPrivateWindowExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_open_private_window".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(321.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventPinExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventPinExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_pin
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#PIN.
    pub static event_pin: Lazy<EventMetric<EventPinExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_pin".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(322.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventPocketThumbsDownExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventPocketThumbsDownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_pocket_thumbs_down
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#POCKET_THUMBS_DOWN.
    pub static event_pocket_thumbs_down: Lazy<EventMetric<EventPocketThumbsDownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_pocket_thumbs_down".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(323.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventPocketThumbsUpExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventPocketThumbsUpExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_pocket_thumbs_up
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#POCKET_THUMBS_UP.
    pub static event_pocket_thumbs_up: Lazy<EventMetric<EventPocketThumbsUpExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_pocket_thumbs_up".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(324.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventPrefChangedExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventPrefChangedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_pref_changed
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#PREF_CHANGED.
    pub static event_pref_changed: Lazy<EventMetric<EventPrefChangedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_pref_changed".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(325.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventPreviewRequestExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventPreviewRequestExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_preview_request
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#PREVIEW_REQUEST.
    pub static event_preview_request: Lazy<EventMetric<EventPreviewRequestExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_preview_request".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(326.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventSaveToPocketExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventSaveToPocketExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_save_to_pocket
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#SAVE_TO_POCKET.
    pub static event_save_to_pocket: Lazy<EventMetric<EventSaveToPocketExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_save_to_pocket".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(327.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventSearchExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventSearchExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_search
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#SEARCH.
    pub static event_search: Lazy<EventMetric<EventSearchExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_search".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(328.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventSearchEditAddExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventSearchEditAddExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_search_edit_add
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#SEARCH_EDIT_ADD.
    pub static event_search_edit_add: Lazy<EventMetric<EventSearchEditAddExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_search_edit_add".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(329.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventSearchEditCloseExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventSearchEditCloseExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_search_edit_close
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#SEARCH_EDIT_CLOSE.
    pub static event_search_edit_close: Lazy<EventMetric<EventSearchEditCloseExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_search_edit_close".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(330.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventSearchEditDeleteExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventSearchEditDeleteExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_search_edit_delete
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#SEARCH_EDIT_DELETE.
    pub static event_search_edit_delete: Lazy<EventMetric<EventSearchEditDeleteExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_search_edit_delete".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(331.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventSearchHandoffExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventSearchHandoffExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_search_handoff
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#SEARCH_HANDOFF.
    pub static event_search_handoff: Lazy<EventMetric<EventSearchHandoffExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_search_handoff".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(332.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventShowPersonalizeExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventShowPersonalizeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_show_personalize
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#SHOW_PERSONALIZE.
    pub static event_show_personalize: Lazy<EventMetric<EventShowPersonalizeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_show_personalize".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(333.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventShowPrivacyInfoExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventShowPrivacyInfoExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_show_privacy_info
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#SHOW_PRIVACY_INFO.
    pub static event_show_privacy_info: Lazy<EventMetric<EventShowPrivacyInfoExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_show_privacy_info".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(334.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventSkippedSigninExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventSkippedSigninExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_skipped_signin
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#SKIPPED_SIGNIN.
    pub static event_skipped_signin: Lazy<EventMetric<EventSkippedSigninExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_skipped_signin".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(335.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventSubmitEmailExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventSubmitEmailExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_submit_email
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#SUBMIT_EMAIL.
    pub static event_submit_email: Lazy<EventMetric<EventSubmitEmailExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_submit_email".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(336.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventTopSitesEditExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventTopSitesEditExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_top_sites_edit
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#TOP_SITES_EDIT.
    pub static event_top_sites_edit: Lazy<EventMetric<EventTopSitesEditExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_top_sites_edit".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(337.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventTopSitesEditCloseExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventTopSitesEditCloseExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_top_sites_edit_close
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#TOP_SITES_EDIT_CLOSE.
    pub static event_top_sites_edit_close: Lazy<EventMetric<EventTopSitesEditCloseExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_top_sites_edit_close".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(338.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventTopsiteSponsorInfoExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventTopsiteSponsorInfoExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_topsite_sponsor_info
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#TOPSITE_SPONSOR_INFO.
    pub static event_topsite_sponsor_info: Lazy<EventMetric<EventTopsiteSponsorInfoExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_topsite_sponsor_info".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(339.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventUnpinExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventUnpinExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_unpin
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// activity_stream.event#UNPIN.
    pub static event_unpin: Lazy<EventMetric<EventUnpinExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_unpin".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(340.into(), meta)
    });

}
pub mod messaging_system {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.addon_version
    ///
    /// Used to hold the system addon's version, now is almost certainly an echo of the
    /// app's build id.
    pub static addon_version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "addon_version".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(341.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.browser_session_id
    ///
    /// The Legacy Telemetry browser "session id". Identifies a specific period from
    /// application start to shutdown. See [the "main" ping docs](https://firefox-
    /// source-docs.mozilla.org/toolkit/components/telemetry/data/main-ping.html) for
    /// details.
    pub static browser_session_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "browser_session_id".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(342.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.bucket_id
    ///
    /// A name shared between multiple messages that may individually be too targetted.
    /// e.g. a message that gets shown on specific websites or a message asking about
    /// personal information.
    pub static bucket_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "bucket_id".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(343.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.client_id
    ///
    /// The client_id according to Telemetry.
    /// Might not always have a value due to policy around specific types of
    /// ping being sent. Value may be the canary client id
    /// `c0ffeec0-ffee-c0ff-eec0-ffeec0ffeec0`
    /// in pings near when the data upload pref is disabled (if Telemetry gets
    /// to go first), or between when a client_id has been removed and when it
    /// has been regenerated.
    /// Present only in some circumstances (see
    /// [bug 1484035]https://bugzilla.mozilla.org/show_bug.cgi?id=1484035)).
    pub static client_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "client_id".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(344.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event
    ///
    /// The type of event. Any user defined string (e.g. “IMPRESSION”, “CLICK_BUTTON”,
    /// "INDEXEDDB_OPEN_FAILED", “SESSION_END”)
    pub static event: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(345.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_context
    ///
    /// The stringified JSON of `event_context`.
    pub static event_context: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_context".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(346.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_context_parse_error
    ///
    /// How often we failed to parse event_context as JSON.
    pub static event_context_parse_error: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            347,
            "messaging_system",
            "event_context_parse_error",
            "messaging-system"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_page
    ///
    /// The event_context's `page`. Almost always "about:welcome".
    pub static event_page: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_page".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(348.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_reason
    ///
    /// The event_context's `reason`. Likely something like
    /// "welcome-window-closed" or "app-shut-down",.
    pub static event_reason: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_reason".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(349.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_screen_family
    ///
    /// A string identifier of the message family derived from the message id
    /// (e.g. MR_WELCOME_DEFAULT).
    pub static event_screen_family: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_screen_family".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(350.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_screen_id
    ///
    /// A string identifier of the message screen id
    /// (e.g. AW_MOBILE_DOWNLOAD).
    pub static event_screen_id: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_screen_id".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(351.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_screen_index
    ///
    /// A number identifier of the screen index in a sequence of screens
    /// (e.g. 0 for first message).
    pub static event_screen_index: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_screen_index".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(352.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_screen_initials
    ///
    /// A string identifier of the message screen initials
    /// (e.g. 'EMAG' for EASY_SETUP, MOBILE_DOWNLOADS, AMO, GRATITUDE).
    pub static event_screen_initials: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_screen_initials".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(353.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_source
    ///
    /// The event_context's `source`. Likely something like "primary_button".
    pub static event_source: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_source".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(354.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.glean_ping_for_ping_failures
    ///
    /// How often something went awry within
    /// `AboutWelcome.submitGleanPingForPing`, preventing ping submission.
    pub static glean_ping_for_ping_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            355,
            "messaging_system",
            "glean_ping_for_ping_failures",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.impression_id
    ///
    /// The unique impression identifier for a specific client.
    pub static impression_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "impression_id".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(356.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.invalid_nested_data
    ///
    /// We received a ping with non-scalar data on a field of this name.
    /// If this is existing pre-PingCentre-replacement data, you may need to
    /// augment the logic in
    /// `AboutWelcome.submitGleanPingForPing` like the other `handledKeys`.
    /// If this is for new, post-PingCentre-replacement data, you should
    /// probably prefer a flat structure.
    /// If you're unsure, please ask in
    /// [the #glean channel](https://chat.mozilla.org/#/room/#glean:mozilla.org).
    pub static invalid_nested_data: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "invalid_nested_data".into(),
                    category: "messaging_system".into(),
                    send_in_pings: vec!["messaging-system".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(357.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.locale
    ///
    /// The locale as supplied to the messaging system by
    /// `Services.locale.appLocaleAsBCP47`.
    pub static locale: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "locale".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(358.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.message_id
    ///
    /// A string identifier of the message in Activity Stream Router.
    pub static message_id: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "message_id".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(359.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.ping_type
    ///
    /// Type of event the ping is capturing. e.g. "cfr", "onboarding"
    pub static ping_type: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ping_type".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(360.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.source
    ///
    /// The source of the interaction described by the other metrics. e.g.
    /// "frecent_links", "newtab", "CFR"
    pub static source: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "source".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(361.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.unknown_key_count
    ///
    /// The sum of all unknown keys counted.
    /// Useful for testing.
    /// Can be removed after bug 1600008 is resolved.
    pub static unknown_key_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            362,
            "messaging_system",
            "unknown_key_count",
            "messaging-system"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.unknown_keys
    ///
    /// Ping keys supplied to the messaging system for which
    /// we did not have a corresponding metric mapped to how often they attempted
    /// to be recorded.
    /// You may have forgotten to define an appropriate metric in
    /// `browser/components/newtab/metrics.yaml`.
    pub static unknown_keys: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "unknown_keys".into(),
                    category: "messaging_system".into(),
                    send_in_pings: vec!["messaging-system".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(363.into(), meta, None)
    });

}
pub mod messaging_system_attribution {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.campaign
    ///
    /// Attribution's campaign, possibly derived from the utm parameter of the
    /// same name.
    pub static campaign: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "campaign".into(),
                category: "messaging_system.attribution".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(364.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.content
    ///
    /// Attribution's content, possibly derived from the utm parameter of the
    /// same name.
    pub static content: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "content".into(),
                category: "messaging_system.attribution".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(365.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.dlsource
    ///
    /// Mozilla-specific download "source" name. Could be something like
    /// "mozillaci" to identify that the installer came from
    /// `{archive|ftp}.mozilla.org`.
    pub static dlsource: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dlsource".into(),
                category: "messaging_system.attribution".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(366.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.dltoken
    ///
    /// String representation of the dltoken identifying the particular
    /// installer used to install this Firefox.
    /// Likely a UUID, if present.
    pub static dltoken: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dltoken".into(),
                category: "messaging_system.attribution".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(367.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.experiment
    ///
    /// Attribution's experiment key.
    pub static experiment: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "experiment".into(),
                category: "messaging_system.attribution".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(368.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.medium
    ///
    /// Attribution's medium, possibly derived from the utm parameter of the same
    /// name.
    pub static medium: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "medium".into(),
                category: "messaging_system.attribution".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(369.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.msstoresignedin
    ///
    /// Either the string "true" or the string "false" to indicate whether the
    /// attributed install came from the Microsoft store and, if so, whether the
    /// user was signed in at the time.
    pub static msstoresignedin: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "msstoresignedin".into(),
                category: "messaging_system.attribution".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(370.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.source
    ///
    /// Attribution's source, possibly derived from the utm parameter of the same
    /// name.
    pub static source: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "source".into(),
                category: "messaging_system.attribution".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(371.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.ua
    ///
    /// Attribution's ua key.
    pub static ua: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ua".into(),
                category: "messaging_system.attribution".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(372.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.unknown_keys
    ///
    /// Attribution keys supplied to the messaging system for which
    /// we did not have a corresponding metric, and the count of how
    /// often that happened.
    /// Either add this key to a list of known attribution keys in
    /// `AboutWelcomeTelemetry` to suppress or define an appropriate metric in
    /// `browser/components/newtab/metrics.yaml` to collect.
    pub static unknown_keys: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "unknown_keys".into(),
                    category: "messaging_system.attribution".into(),
                    send_in_pings: vec!["messaging-system".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(373.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.variation
    ///
    /// Attribution's variation key.
    pub static variation: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "variation".into(),
                category: "messaging_system.attribution".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(374.into(), meta)
    });

}
pub mod newtab {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from newtab.blocked_sponsors
    ///
    /// The advertiser names that have been dismissed by the user.
    pub static blocked_sponsors: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "blocked_sponsors".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(375.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClosedExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for ClosedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.closed
    ///
    /// Recorded when newtab UI is closed by * navigation * closing the tab
    /// Doesn't mean that the newtab was ever visible to a user.
    pub static closed: Lazy<EventMetric<ClosedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(376.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FakespotAboutClickExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for FakespotAboutClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.fakespot_about_click
    ///
    /// Recorded when a user the 'About Fakespot' link in TBR fakespot feed context
    /// menu
    pub static fakespot_about_click: Lazy<EventMetric<FakespotAboutClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fakespot_about_click".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(377.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FakespotCategoryExtra {
        pub r#category: Option<String>,
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for FakespotCategoryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.fakespot_category
    ///
    /// Recorded when a user changes the category in TBR fakespot feed
    pub static fakespot_category: Lazy<EventMetric<FakespotCategoryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fakespot_category".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(378.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FakespotClickExtra {
        pub r#category: Option<String>,
        pub r#newtab_visit_id: Option<String>,
        pub r#product_id: Option<String>,
    }

    impl ExtraKeys for FakespotClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "newtab_visit_id", "product_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#product_id.and_then(|val| map.insert("product_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.fakespot_click
    ///
    /// Recorded when a user clicks on a card in TBR fakespot feed
    pub static fakespot_click: Lazy<EventMetric<FakespotClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fakespot_click".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(379.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FakespotCtaClickExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for FakespotCtaClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.fakespot_cta_click
    ///
    /// Recorded when a user clicks on the CTA in TBR fakespot feed
    pub static fakespot_cta_click: Lazy<EventMetric<FakespotCtaClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fakespot_cta_click".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(380.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FakespotDismissExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for FakespotDismissExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.fakespot_dismiss
    ///
    /// Recorded when a user dissmisses TBR fakespot feed
    pub static fakespot_dismiss: Lazy<EventMetric<FakespotDismissExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fakespot_dismiss".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(381.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FakespotProductImpressionExtra {
        pub r#category: Option<String>,
        pub r#newtab_visit_id: Option<String>,
        pub r#product_id: Option<String>,
        pub r#product_title: Option<String>,
    }

    impl ExtraKeys for FakespotProductImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "newtab_visit_id", "product_id", "product_title"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#product_id.and_then(|val| map.insert("product_id".into(), val.to_string()));
          self.r#product_title.and_then(|val| map.insert("product_title".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.fakespot_product_impression
    ///
    /// Recorded when a user triggers an impression on a card in TBR fakespot feed
    pub static fakespot_product_impression: Lazy<EventMetric<FakespotProductImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fakespot_product_impression".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(382.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.homepage_category
    ///
    /// The current setting of the home page. One of ["enabled", "disabled",
    /// "extension"] or any value from SiteClassifier like "known-hijacker" or "social-
    /// media". Similar to Activity Stream's PAGE_TAKEOVER_DATA event's
    /// `home_url_category`. Sampled once after newtab init.
    pub static homepage_category: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "homepage_category".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(383.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.locale
    ///
    /// The application's locale as of when newtab's TelemetryFeed was init. Comes from
    /// `Services.local.appLocaleAsBCP47`. Looks like `en-US`.
    pub static locale: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "locale".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(384.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.newtab_category
    ///
    /// The current setting of the newtab page. One of ["enabled", "disabled",
    /// "extension"] or any value from SiteClassifier like "known-hijacker" or "social-
    /// media". Similar to Activity Stream's PAGE_TAKEOVER_DATA event's
    /// `newtab_url_category`. Sampled once after newtab init.
    pub static newtab_category: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "newtab_category".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(385.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenedExtra {
        pub r#newtab_visit_id: Option<String>,
        pub r#source: Option<String>,
        pub r#window_inner_height: Option<String>,
        pub r#window_inner_width: Option<String>,
    }

    impl ExtraKeys for OpenedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "source", "window_inner_height", "window_inner_width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#window_inner_height.and_then(|val| map.insert("window_inner_height".into(), val.to_string()));
          self.r#window_inner_width.and_then(|val| map.insert("window_inner_width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.opened
    ///
    /// Recorded when newtab UI is opened via `about:newtab` or `about:home` or
    /// `about:welcome` and has been made visible (see `visibility_event_rcvd_ts` in
    /// [detect-user-session-start.js](https://searchfox.org/mozilla-
    /// central/source/browser/components/newtab/content-src/lib/detect-user-session-
    /// start.js)).
    pub static opened: Lazy<EventMetric<OpenedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "opened".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(386.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.selected_topics
    ///
    /// The list of topics the user selected
    pub static selected_topics: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "selected_topics".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(387.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.sov_allocation
    ///
    /// The partner group assignment for sov
    pub static sov_allocation: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sov_allocation".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(388.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TooltipClickExtra {
        pub r#feature: Option<String>,
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for TooltipClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["feature", "newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#feature.and_then(|val| map.insert("feature".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.tooltip_click
    ///
    /// Recorded when a feature highlight tooltip is opened.
    pub static tooltip_click: Lazy<EventMetric<TooltipClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tooltip_click".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(389.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TopicSelectionDismissExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for TopicSelectionDismissExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.topic_selection_dismiss
    ///
    /// Recorded when the topic selection modal is dismissed (topics are not saved)
    pub static topic_selection_dismiss: Lazy<EventMetric<TopicSelectionDismissExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "topic_selection_dismiss".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(390.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TopicSelectionOpenExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for TopicSelectionOpenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.topic_selection_open
    ///
    /// Recorded when the topic selection modal is opened
    pub static topic_selection_open: Lazy<EventMetric<TopicSelectionOpenExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "topic_selection_open".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(391.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TopicSelectionTopicsSavedExtra {
        pub r#first_save: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#previous_topics: Option<String>,
        pub r#topics: Option<String>,
    }

    impl ExtraKeys for TopicSelectionTopicsSavedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["first_save", "newtab_visit_id", "previous_topics", "topics"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#first_save.and_then(|val| map.insert("first_save".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#previous_topics.and_then(|val| map.insert("previous_topics".into(), val.to_string()));
          self.r#topics.and_then(|val| map.insert("topics".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.topic_selection_topics_saved
    ///
    /// Recorded when topics are saved from the topics selection modal
    pub static topic_selection_topics_saved: Lazy<EventMetric<TopicSelectionTopicsSavedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "topic_selection_topics_saved".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(392.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct WallpaperCategoryClickExtra {
        pub r#newtab_visit_id: Option<String>,
        pub r#selected_category: Option<String>,
    }

    impl ExtraKeys for WallpaperCategoryClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "selected_category"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#selected_category.and_then(|val| map.insert("selected_category".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.wallpaper_category_click
    ///
    /// Recorded when a user clicks a wallpaper category option
    pub static wallpaper_category_click: Lazy<EventMetric<WallpaperCategoryClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wallpaper_category_click".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(393.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct WallpaperClickExtra {
        pub r#had_previous_wallpaper: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#selected_wallpaper: Option<String>,
    }

    impl ExtraKeys for WallpaperClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["had_previous_wallpaper", "newtab_visit_id", "selected_wallpaper"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#had_previous_wallpaper.and_then(|val| map.insert("had_previous_wallpaper".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#selected_wallpaper.and_then(|val| map.insert("selected_wallpaper".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.wallpaper_click
    ///
    /// Recorded when a user clicks on a wallpaper option
    pub static wallpaper_click: Lazy<EventMetric<WallpaperClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wallpaper_click".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(394.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct WallpaperHighlightCtaClickExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for WallpaperHighlightCtaClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.wallpaper_highlight_cta_click
    ///
    /// Recorded when a user clicks the CTA on the wallpaper feature highlight
    pub static wallpaper_highlight_cta_click: Lazy<EventMetric<WallpaperHighlightCtaClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wallpaper_highlight_cta_click".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(395.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct WallpaperHighlightDismissedExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for WallpaperHighlightDismissedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.wallpaper_highlight_dismissed
    ///
    /// Recorded when a user dismisses the wallpaper feature highlight
    pub static wallpaper_highlight_dismissed: Lazy<EventMetric<WallpaperHighlightDismissedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wallpaper_highlight_dismissed".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(396.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct WeatherChangeDisplayExtra {
        pub r#newtab_visit_id: Option<String>,
        pub r#weather_display_mode: Option<String>,
    }

    impl ExtraKeys for WeatherChangeDisplayExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "weather_display_mode"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#weather_display_mode.and_then(|val| map.insert("weather_display_mode".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.weather_change_display
    ///
    /// Recorded when a user changes the weather display.
    pub static weather_change_display: Lazy<EventMetric<WeatherChangeDisplayExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "weather_change_display".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(397.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.weather_enabled
    ///
    /// Whether the weather widget is enabled on the newtab. Corresponds to the value
    /// of the `browser.newtabpage.activity-stream.showWeather` pref.
    pub static weather_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "weather_enabled".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(398.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct WeatherImpressionExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for WeatherImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.weather_impression
    ///
    /// Recorded when the weather widget is viewed
    pub static weather_impression: Lazy<EventMetric<WeatherImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "weather_impression".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(399.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct WeatherLoadErrorExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for WeatherLoadErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.weather_load_error
    ///
    /// Recorded when the weather widget is not available
    pub static weather_load_error: Lazy<EventMetric<WeatherLoadErrorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "weather_load_error".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(400.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct WeatherLocationSelectedExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for WeatherLocationSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.weather_location_selected
    ///
    /// Recorded when a user selects a location for weather widget
    pub static weather_location_selected: Lazy<EventMetric<WeatherLocationSelectedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "weather_location_selected".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(401.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct WeatherOpenProviderUrlExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for WeatherOpenProviderUrlExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.weather_open_provider_url
    ///
    /// Recorded when a user opens a link to the Weather provider website.
    pub static weather_open_provider_url: Lazy<EventMetric<WeatherOpenProviderUrlExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "weather_open_provider_url".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(402.into(), meta)
    });

}
pub mod newtab_handoff_preference {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from newtab.handoff_preference.enabled
    ///
    /// Records whether the browser.newtabpage.activity-
    /// stream.improvesearch.handoffToAwesomebar preference is enabled or disabled
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled".into(),
                category: "newtab.handoff_preference".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(403.into(), meta)
    });

}
pub mod newtab_search {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from newtab.search.enabled
    ///
    /// Whether the search input is enabled on the newtab. Corresponds to the value of
    /// the `browser.newtabpage.activity-stream.showSearch` pref.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled".into(),
                category: "newtab.search".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(404.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct IssuedExtra {
        pub r#newtab_visit_id: Option<String>,
        pub r#search_access_point: Option<String>,
        pub r#telemetry_id: Option<String>,
    }

    impl ExtraKeys for IssuedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "search_access_point", "telemetry_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#search_access_point.and_then(|val| map.insert("search_access_point".into(), val.to_string()));
          self.r#telemetry_id.and_then(|val| map.insert("telemetry_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.search.issued
    ///
    /// When Firefox was asked to issue a search from a Search Access Point (SAP) on a
    /// newtab page. Doesn't record searches in Private Browsing Mode unless
    /// `browser.engagement.search_counts.pbm` is set to `true`.
    pub static issued: Lazy<EventMetric<IssuedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "issued".into(),
                category: "newtab.search".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(405.into(), meta)
    });

}
pub mod pocket {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickExtra {
        pub r#format: Option<String>,
        pub r#is_list_card: Option<bool>,
        pub r#is_sponsored: Option<bool>,
        pub r#matches_selected_topic: Option<String>,
        pub r#newtab_visit_id: Option<String>,
        pub r#position: Option<u32>,
        pub r#received_rank: Option<u32>,
        pub r#recommendation_id: Option<String>,
        pub r#recommended_at: Option<u32>,
        pub r#scheduled_corpus_item_id: Option<String>,
        pub r#selected_topics: Option<String>,
        pub r#tile_id: Option<u32>,
        pub r#topic: Option<String>,
    }

    impl ExtraKeys for ClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["format", "is_list_card", "is_sponsored", "matches_selected_topic", "newtab_visit_id", "position", "received_rank", "recommendation_id", "recommended_at", "scheduled_corpus_item_id", "selected_topics", "tile_id", "topic"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#format.and_then(|val| map.insert("format".into(), val.to_string()));
          self.r#is_list_card.and_then(|val| map.insert("is_list_card".into(), val.to_string()));
          self.r#is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.r#matches_selected_topic.and_then(|val| map.insert("matches_selected_topic".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.r#received_rank.and_then(|val| map.insert("received_rank".into(), val.to_string()));
          self.r#recommendation_id.and_then(|val| map.insert("recommendation_id".into(), val.to_string()));
          self.r#recommended_at.and_then(|val| map.insert("recommended_at".into(), val.to_string()));
          self.r#scheduled_corpus_item_id.and_then(|val| map.insert("scheduled_corpus_item_id".into(), val.to_string()));
          self.r#selected_topics.and_then(|val| map.insert("selected_topics".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          self.r#topic.and_then(|val| map.insert("topic".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.click
    ///
    /// Recorded when a pocket tile is clicked. Only happens on click. Not on middle-
    /// click. Not on "Open in new Tab"-like options in the context menu.
    pub static click: Lazy<EventMetric<ClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click".into(),
                category: "pocket".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(406.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DismissExtra {
        pub r#format: Option<String>,
        pub r#is_list_card: Option<bool>,
        pub r#is_sponsored: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#position: Option<u32>,
        pub r#received_rank: Option<u32>,
        pub r#recommendation_id: Option<String>,
        pub r#recommended_at: Option<u32>,
        pub r#scheduled_corpus_item_id: Option<String>,
        pub r#tile_id: Option<u32>,
    }

    impl ExtraKeys for DismissExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["format", "is_list_card", "is_sponsored", "newtab_visit_id", "position", "received_rank", "recommendation_id", "recommended_at", "scheduled_corpus_item_id", "tile_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#format.and_then(|val| map.insert("format".into(), val.to_string()));
          self.r#is_list_card.and_then(|val| map.insert("is_list_card".into(), val.to_string()));
          self.r#is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.r#received_rank.and_then(|val| map.insert("received_rank".into(), val.to_string()));
          self.r#recommendation_id.and_then(|val| map.insert("recommendation_id".into(), val.to_string()));
          self.r#recommended_at.and_then(|val| map.insert("recommended_at".into(), val.to_string()));
          self.r#scheduled_corpus_item_id.and_then(|val| map.insert("scheduled_corpus_item_id".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.dismiss
    ///
    /// Recorded when a pocket tile is dismissed.
    pub static dismiss: Lazy<EventMetric<DismissExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dismiss".into(),
                category: "pocket".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(407.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.enabled
    ///
    /// Whether Pocket is enabled on the newtab. AKA the "Recommended by Pocket"
    /// section. Corresponds to the value of the `browser.newtabpage.activity-
    /// stream.feeds.section.topstories` pref.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled".into(),
                category: "pocket".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(408.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.fetch_timestamp
    ///
    /// Timestamp of when the spoc was fetched by the client
    pub static fetch_timestamp: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fetch_timestamp".into(),
                category: "pocket".into(),
                send_in_pings: vec!["spoc".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(409.into(), meta, TimeUnit::Millisecond)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ImpressionExtra {
        pub r#format: Option<String>,
        pub r#is_list_card: Option<bool>,
        pub r#is_sponsored: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#position: Option<u32>,
        pub r#received_rank: Option<u32>,
        pub r#recommendation_id: Option<String>,
        pub r#recommended_at: Option<u32>,
        pub r#scheduled_corpus_item_id: Option<String>,
        pub r#selected_topics: Option<String>,
        pub r#tile_id: Option<u32>,
        pub r#topic: Option<String>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["format", "is_list_card", "is_sponsored", "newtab_visit_id", "position", "received_rank", "recommendation_id", "recommended_at", "scheduled_corpus_item_id", "selected_topics", "tile_id", "topic"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#format.and_then(|val| map.insert("format".into(), val.to_string()));
          self.r#is_list_card.and_then(|val| map.insert("is_list_card".into(), val.to_string()));
          self.r#is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.r#received_rank.and_then(|val| map.insert("received_rank".into(), val.to_string()));
          self.r#recommendation_id.and_then(|val| map.insert("recommendation_id".into(), val.to_string()));
          self.r#recommended_at.and_then(|val| map.insert("recommended_at".into(), val.to_string()));
          self.r#scheduled_corpus_item_id.and_then(|val| map.insert("scheduled_corpus_item_id".into(), val.to_string()));
          self.r#selected_topics.and_then(|val| map.insert("selected_topics".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          self.r#topic.and_then(|val| map.insert("topic".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.impression
    ///
    /// Recorded when a pocket tile is visible to the user.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "impression".into(),
                category: "pocket".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(410.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.is_signed_in
    ///
    /// Whether the Firefox user is signed in to Pocket. Does not correspond to a pref,
    /// so its value is resampled at newtab's component init and whenever there is a
    /// Discovery Stream user event.
    pub static is_signed_in: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_signed_in".into(),
                category: "pocket".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(411.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.newtab_creation_timestamp
    ///
    /// Timestamp of when this instance of the newtab was first visible to the user.
    pub static newtab_creation_timestamp: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "newtab_creation_timestamp".into(),
                category: "pocket".into(),
                send_in_pings: vec!["spoc".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(412.into(), meta, TimeUnit::Millisecond)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SaveExtra {
        pub r#format: Option<String>,
        pub r#is_list_card: Option<bool>,
        pub r#is_sponsored: Option<bool>,
        pub r#matches_selected_topic: Option<String>,
        pub r#newtab_visit_id: Option<String>,
        pub r#position: Option<u32>,
        pub r#received_rank: Option<u32>,
        pub r#recommendation_id: Option<String>,
        pub r#recommended_at: Option<u32>,
        pub r#scheduled_corpus_item_id: Option<String>,
        pub r#selected_topics: Option<String>,
        pub r#tile_id: Option<u32>,
        pub r#topic: Option<String>,
    }

    impl ExtraKeys for SaveExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["format", "is_list_card", "is_sponsored", "matches_selected_topic", "newtab_visit_id", "position", "received_rank", "recommendation_id", "recommended_at", "scheduled_corpus_item_id", "selected_topics", "tile_id", "topic"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#format.and_then(|val| map.insert("format".into(), val.to_string()));
          self.r#is_list_card.and_then(|val| map.insert("is_list_card".into(), val.to_string()));
          self.r#is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.r#matches_selected_topic.and_then(|val| map.insert("matches_selected_topic".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.r#received_rank.and_then(|val| map.insert("received_rank".into(), val.to_string()));
          self.r#recommendation_id.and_then(|val| map.insert("recommendation_id".into(), val.to_string()));
          self.r#recommended_at.and_then(|val| map.insert("recommended_at".into(), val.to_string()));
          self.r#scheduled_corpus_item_id.and_then(|val| map.insert("scheduled_corpus_item_id".into(), val.to_string()));
          self.r#selected_topics.and_then(|val| map.insert("selected_topics".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          self.r#topic.and_then(|val| map.insert("topic".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.save
    ///
    /// Recorded when a user decides to save a pocket tile. Does not mean it ends up
    /// successfully saved. Just that the user clicked on "Save to Pocket" in the
    /// little pocket tile menu.
    pub static save: Lazy<EventMetric<SaveExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "save".into(),
                category: "pocket".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(413.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.shim
    ///
    /// Opaque partner identifier for a given ad impression or engagement action,
    /// unique per market and region.
    /// Pocket
    /// [proxies requests to ad partners](https://github.com/Pocket/proxy-server/)
    /// and provides them solely with market, region, and action to generate these
    /// shims. Thus, though the contents of this field are obscure, they cannot
    /// identify clients.
    /// At time of writing this information is a comma-separated trio.
    /// The first item is an index into the proxy server's list of acceptable http
    /// endpoints for contacting the ad service. The second item is a
    /// several-hundred-byte base64-encoded JSON-encoded struct with fields for,
    /// amongst other things, market and region. The third is unknown, but appears
    /// to be a signature or checksum.
    /// This shim should not be sent with the client_id.
    pub static shim: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shim".into(),
                category: "pocket".into(),
                send_in_pings: vec!["spoc".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(414.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.sponsored_stories_enabled
    ///
    /// Whether Pocket sponsored stories are enabled on the newtab. Corresponds to the
    /// value of the `browser.newtabpage.activity-stream.showSponsored` pref. Can be
    /// `true` even if pocket.enabled is `false`.
    pub static sponsored_stories_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sponsored_stories_enabled".into(),
                category: "pocket".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(415.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ThumbVotingInteractionExtra {
        pub r#is_list_card: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#received_rank: Option<u32>,
        pub r#recommendation_id: Option<String>,
        pub r#recommended_at: Option<u32>,
        pub r#scheduled_corpus_item_id: Option<String>,
        pub r#thumbs_down: Option<bool>,
        pub r#thumbs_up: Option<bool>,
        pub r#tile_id: Option<u32>,
        pub r#topic: Option<String>,
    }

    impl ExtraKeys for ThumbVotingInteractionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_list_card", "newtab_visit_id", "received_rank", "recommendation_id", "recommended_at", "scheduled_corpus_item_id", "thumbs_down", "thumbs_up", "tile_id", "topic"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#is_list_card.and_then(|val| map.insert("is_list_card".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#received_rank.and_then(|val| map.insert("received_rank".into(), val.to_string()));
          self.r#recommendation_id.and_then(|val| map.insert("recommendation_id".into(), val.to_string()));
          self.r#recommended_at.and_then(|val| map.insert("recommended_at".into(), val.to_string()));
          self.r#scheduled_corpus_item_id.and_then(|val| map.insert("scheduled_corpus_item_id".into(), val.to_string()));
          self.r#thumbs_down.and_then(|val| map.insert("thumbs_down".into(), val.to_string()));
          self.r#thumbs_up.and_then(|val| map.insert("thumbs_up".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          self.r#topic.and_then(|val| map.insert("topic".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.thumb_voting_interaction
    ///
    /// Recorded when a thumbs up/down on a tile is clicked. Only happens on click. Not
    /// on middle-click. Not on "Open in new Tab"-like options in the context menu.
    pub static thumb_voting_interaction: Lazy<EventMetric<ThumbVotingInteractionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "thumb_voting_interaction".into(),
                category: "pocket".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(416.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TopicClickExtra {
        pub r#newtab_visit_id: Option<String>,
        pub r#topic: Option<String>,
    }

    impl ExtraKeys for TopicClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "topic"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#topic.and_then(|val| map.insert("topic".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.topic_click
    ///
    /// Recorded when a pocket "Popular Topic" is clicked. Only happens on click. Not
    /// on middle-click. Not on "Open in new Tab"-like options in the context menu.
    pub static topic_click: Lazy<EventMetric<TopicClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "topic_click".into(),
                category: "pocket".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(417.into(), meta)
    });

}
pub mod top_sites {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from top_sites.advertiser
    ///
    /// The name of the advertiser providing the sponsored TopSite.
    pub static advertiser: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "advertiser".into(),
                category: "top_sites".into(),
                send_in_pings: vec!["top-sites".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(418.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from top_sites.context_id
    ///
    /// An identifier to identify users for Contextual Services user interaction pings.
    pub static context_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "context_id".into(),
                category: "top_sites".into(),
                send_in_pings: vec!["top-sites".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(419.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from top_sites.ping_type
    ///
    /// The ping's type. In other situations might be designated by an event's name or
    /// an interaction field. E.g. "topsites-impression", "topsites-click".
    pub static ping_type: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ping_type".into(),
                category: "top_sites".into(),
                send_in_pings: vec!["top-sites".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(420.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from top_sites.position
    ///
    /// The position (1-based) of the topsites item being interatcted with.
    pub static position: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "position".into(),
                category: "top_sites".into(),
                send_in_pings: vec!["top-sites".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(421.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from top_sites.reporting_url
    ///
    /// The url to report this interaction to.
    pub static reporting_url: Lazy<UrlMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reporting_url".into(),
                category: "top_sites".into(),
                send_in_pings: vec!["top-sites".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UrlMetric::new(422.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from top_sites.source
    ///
    /// The source of the interaction. Always set to "newtab".
    pub static source: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "source".into(),
                category: "top_sites".into(),
                send_in_pings: vec!["top-sites".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(423.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from top_sites.tile_id
    ///
    /// String-encoded number for the tile's sponsored tile id.
    pub static tile_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tile_id".into(),
                category: "top_sites".into(),
                send_in_pings: vec!["top-sites".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(424.into(), meta)
    });

}
pub mod topsites {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickExtra {
        pub r#advertiser_name: Option<String>,
        pub r#is_sponsored: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#position: Option<u32>,
        pub r#tile_id: Option<u32>,
    }

    impl ExtraKeys for ClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["advertiser_name", "is_sponsored", "newtab_visit_id", "position", "tile_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#advertiser_name.and_then(|val| map.insert("advertiser_name".into(), val.to_string()));
          self.r#is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from topsites.click
    ///
    /// Recorded when a topsite tile is clicked. Only happens on click. Not on middle-
    /// click. Not on "Open in new Tab"-like options in the context menu.
    pub static click: Lazy<EventMetric<ClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click".into(),
                category: "topsites".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(425.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DismissExtra {
        pub r#advertiser_name: Option<String>,
        pub r#is_sponsored: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#position: Option<u32>,
        pub r#tile_id: Option<u32>,
    }

    impl ExtraKeys for DismissExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["advertiser_name", "is_sponsored", "newtab_visit_id", "position", "tile_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#advertiser_name.and_then(|val| map.insert("advertiser_name".into(), val.to_string()));
          self.r#is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from topsites.dismiss
    ///
    /// Recorded when the "Dismiss" menu item in the three-dots menu of a topsite is
    /// clicked. Corresponds to the receipt of a dispatched `BLOCK_URL` action by
    /// `TelemetryFeed`. Applies to both sponsored and non-sponsored topsites.
    /// `advertiser_name` is only provided for sponsored topsites.
    pub static dismiss: Lazy<EventMetric<DismissExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dismiss".into(),
                category: "topsites".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(426.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from topsites.enabled
    ///
    /// Whether "topsites" is enabled on the newtab. AKA the "Shortcuts" section.
    /// Corresponds to the value of the `browser.newtabpage.activity-
    /// stream.feeds.topsites` pref.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled".into(),
                category: "topsites".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(427.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ImpressionExtra {
        pub r#advertiser_name: Option<String>,
        pub r#is_sponsored: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#position: Option<u32>,
        pub r#tile_id: Option<u32>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["advertiser_name", "is_sponsored", "newtab_visit_id", "position", "tile_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#advertiser_name.and_then(|val| map.insert("advertiser_name".into(), val.to_string()));
          self.r#is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from topsites.impression
    ///
    /// Recorded when topsite tiles are loaded.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "impression".into(),
                category: "topsites".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(428.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PrefChangedExtra {
        pub r#new_value: Option<bool>,
        pub r#pref_name: Option<String>,
    }

    impl ExtraKeys for PrefChangedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["new_value", "pref_name"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#new_value.and_then(|val| map.insert("new_value".into(), val.to_string()));
          self.r#pref_name.and_then(|val| map.insert("pref_name".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from topsites.pref_changed
    ///
    /// Recorded when specific topsites prefs have changed.
    /// The list of possible prefs is presently:
    ///  * browser.newtabpage.activity-stream.feeds.topsites
    ///  * browser.newtabpage.activity-stream.showSponsoredTopSites
    pub static pref_changed: Lazy<EventMetric<PrefChangedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_changed".into(),
                category: "topsites".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(429.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from topsites.rows
    ///
    /// The number of topsite tile rows configured to be shown on the newtab page.
    /// Corresponds to the value of the `browser.newtabpage.activity-
    /// stream.topSitesRows` pref. This is not the number of rows actually seen by the
    /// user: if the browser window is partially off-screen, or isn't wide enough to
    /// accommodate eight tiles per row, the actual number of rows may be different.
    pub static rows: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "rows".into(),
                category: "topsites".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(430.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowPrivacyClickExtra {
        pub r#advertiser_name: Option<String>,
        pub r#newtab_visit_id: Option<String>,
        pub r#position: Option<u32>,
        pub r#tile_id: Option<u32>,
    }

    impl ExtraKeys for ShowPrivacyClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["advertiser_name", "newtab_visit_id", "position", "tile_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#advertiser_name.and_then(|val| map.insert("advertiser_name".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from topsites.show_privacy_click
    ///
    /// Recorded when the "Our Sponsors and Your Privacy" menu item in the three- dots
    /// menu of a sponsored topsite is clicked. Corresponds to the receipt of a
    /// dispatched `ABOUT_SPONSORED_TOP_SITES` action by `TelemetryFeed`.
    pub static show_privacy_click: Lazy<EventMetric<ShowPrivacyClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_privacy_click".into(),
                category: "topsites".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(431.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from topsites.sponsored_enabled
    ///
    /// Whether sponsored topsites are enabled on the newtab. AKA the "Sponsored
    /// Shortcuts" section. Corresponds to the value of the
    /// `browser.newtabpage.activity-stream.showSponsoredTopSites` pref. Can be `true`
    /// even if topsites.enabled is `false`.
    pub static sponsored_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sponsored_enabled".into(),
                category: "topsites".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(432.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from topsites.sponsored_tiles_configured
    ///
    /// The number of topsite tiles configured to be shown on newtab.
    pub static sponsored_tiles_configured: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sponsored_tiles_configured".into(),
                category: "topsites".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(433.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from topsites.sponsored_tiles_received
    ///
    /// The stringified JSON of tiles processed for display (array of objects).
    /// Includes tiles not displayed and reason for not displaying. Fields included:
    /// advertiser, provider, display_position, display_fail_reason.
    pub static sponsored_tiles_received: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sponsored_tiles_received".into(),
                category: "topsites".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(434.into(), meta)
    });

}
pub mod library {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from library.link
    ///
    /// The number of history or bookmark items opened from the Library window This
    /// metric was generated to correspond to the Legacy Telemetry scalar library.link.
    pub static link: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "link".into(),
                    category: "library".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(435.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from library.opened
    ///
    /// The number of times the Library window was opened, keyed by 'history' or
    /// 'bookmarks' This metric was generated to correspond to the Legacy Telemetry
    /// scalar library.opened.
    pub static opened: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "opened".into(),
                    category: "library".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(436.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from library.search
    ///
    /// The number of history-specific or bookmark-specific searches made from the
    /// Library window This metric was generated to correspond to the Legacy Telemetry
    /// scalar library.search.
    pub static search: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "search".into(),
                    category: "library".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(437.into(), meta, None)
    });

}
pub mod pocket_button {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from pocket.button.event_action
    ///
    /// The action that was taken, like "click" or... actually, it might only ever be
    /// "click".
    pub static event_action: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_action".into(),
                category: "pocket.button".into(),
                send_in_pings: vec!["pocket-button".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(438.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.button.event_position
    ///
    /// 0-based index of the item on which the action was performed. Not always
    /// provided.
    pub static event_position: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_position".into(),
                category: "pocket.button".into(),
                send_in_pings: vec!["pocket-button".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(439.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.button.event_source
    ///
    /// The source of the taken action, like "save_button", "home_button",
    /// "on_save_recs", or the like.
    pub static event_source: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_source".into(),
                category: "pocket.button".into(),
                send_in_pings: vec!["pocket-button".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(440.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.button.impression_id
    ///
    /// A UUID representing this profile. This isn't client_id, nor can it be used to
    /// link to a client_id. This also means it should never be sent in a ping with a
    /// client_id.
    pub static impression_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "impression_id".into(),
                category: "pocket.button".into(),
                send_in_pings: vec!["pocket-button".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(441.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.button.model
    ///
    /// A string that identifies the ML model (if any) used to generate on-save
    /// recommendations. Like "doc2vec-incremental-best-article-pubspread".
    pub static model: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "model".into(),
                category: "pocket.button".into(),
                send_in_pings: vec!["pocket-button".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(442.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.button.pocket_logged_in_status
    ///
    /// Whether there was a logged-in Pocket account in the Pocket-Firefox integration
    /// at the point in time this action occurred.
    pub static pocket_logged_in_status: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pocket_logged_in_status".into(),
                category: "pocket.button".into(),
                send_in_pings: vec!["pocket-button".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(443.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.button.profile_creation_date
    ///
    /// The days since Jan 1, 1970 that the oldest file in the profile dir was
    /// modified. Or created. Or just the day and time of the first thing to ask for
    /// the profile age called in. Or something earlier or later than that.
    /// You may not want to use this.
    pub static profile_creation_date: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "profile_creation_date".into(),
                category: "pocket.button".into(),
                send_in_pings: vec!["pocket-button".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(444.into(), meta)
    });

}
pub mod aboutpreferences {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowClickExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from aboutpreferences.show_click
    ///
    /// This is recorded when a pane is shown when user clicks category name inside
    /// about:preferences. This event was generated to correspond to the Legacy
    /// Telemetry event aboutpreferences.show#click.
    pub static show_click: Lazy<EventMetric<ShowClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_click".into(),
                category: "aboutpreferences".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(445.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowHashExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowHashExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from aboutpreferences.show_hash
    ///
    /// This is recorded when a pane is shown via a hash change in url. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// aboutpreferences.show#hash.
    pub static show_hash: Lazy<EventMetric<ShowHashExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_hash".into(),
                category: "aboutpreferences".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(446.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowInitialExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowInitialExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from aboutpreferences.show_initial
    ///
    /// This is recorded when a pane is shown direclty. This happens with or without a
    /// hash in the URL. The "general" pane loads without such a hash, when the pane is
    /// loaded via the "main" entrypoints in the menu system or with shortcuts. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// aboutpreferences.show#initial.
    pub static show_initial: Lazy<EventMetric<ShowInitialExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_initial".into(),
                category: "aboutpreferences".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(447.into(), meta)
    });

}
pub mod intl_ui_browser_language {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AcceptDialogExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AcceptDialogExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.accept_dialog
    ///
    /// User interactions for the browser language within about-preferences in the main
    /// pane and in the browser language dialog. Each dialog event (on the dialog
    /// object, and the manage and search methods of the main object) has a value which
    /// is a monotonically increasing number that links it with other events related to
    /// the same dialog instance. This event was generated to correspond to the Legacy
    /// Telemetry event intl.ui.browserLanguage.accept#dialog.
    pub static accept_dialog: Lazy<EventMetric<AcceptDialogExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "accept_dialog".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(448.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AddDialogExtra {
        pub r#installId: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AddDialogExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["installId", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#installId.and_then(|val| map.insert("installId".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.add_dialog
    ///
    /// User interactions for the browser language within about-preferences in the main
    /// pane and in the browser language dialog. Each dialog event (on the dialog
    /// object, and the manage and search methods of the main object) has a value which
    /// is a monotonically increasing number that links it with other events related to
    /// the same dialog instance. This event was generated to correspond to the Legacy
    /// Telemetry event intl.ui.browserLanguage.add#dialog.
    pub static add_dialog: Lazy<EventMetric<AddDialogExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "add_dialog".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(449.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.apply_main
    ///
    /// User interactions for the browser language within about-preferences in the main
    /// pane and in the browser language dialog. Each dialog event (on the dialog
    /// object, and the manage and search methods of the main object) has a value which
    /// is a monotonically increasing number that links it with other events related to
    /// the same dialog instance. This event was generated to correspond to the Legacy
    /// Telemetry event intl.ui.browserLanguage.apply#main.
    pub static apply_main: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "apply_main".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(450.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CancelDialogExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for CancelDialogExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.cancel_dialog
    ///
    /// User interactions for the browser language within about-preferences in the main
    /// pane and in the browser language dialog. Each dialog event (on the dialog
    /// object, and the manage and search methods of the main object) has a value which
    /// is a monotonically increasing number that links it with other events related to
    /// the same dialog instance. This event was generated to correspond to the Legacy
    /// Telemetry event intl.ui.browserLanguage.cancel#dialog.
    pub static cancel_dialog: Lazy<EventMetric<CancelDialogExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel_dialog".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(451.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ManageMainExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ManageMainExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.manage_main
    ///
    /// User interactions for the browser language within about-preferences in the main
    /// pane and in the browser language dialog. Each dialog event (on the dialog
    /// object, and the manage and search methods of the main object) has a value which
    /// is a monotonically increasing number that links it with other events related to
    /// the same dialog instance. This event was generated to correspond to the Legacy
    /// Telemetry event intl.ui.browserLanguage.manage#main.
    pub static manage_main: Lazy<EventMetric<ManageMainExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "manage_main".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(452.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RemoveDialogExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for RemoveDialogExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.remove_dialog
    ///
    /// User interactions for the browser language within about-preferences in the main
    /// pane and in the browser language dialog. Each dialog event (on the dialog
    /// object, and the manage and search methods of the main object) has a value which
    /// is a monotonically increasing number that links it with other events related to
    /// the same dialog instance. This event was generated to correspond to the Legacy
    /// Telemetry event intl.ui.browserLanguage.remove#dialog.
    pub static remove_dialog: Lazy<EventMetric<RemoveDialogExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "remove_dialog".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(453.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReorderDialogExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReorderDialogExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.reorder_dialog
    ///
    /// User interactions for the browser language within about-preferences in the main
    /// pane and in the browser language dialog. Each dialog event (on the dialog
    /// object, and the manage and search methods of the main object) has a value which
    /// is a monotonically increasing number that links it with other events related to
    /// the same dialog instance. This event was generated to correspond to the Legacy
    /// Telemetry event intl.ui.browserLanguage.reorder#dialog.
    pub static reorder_dialog: Lazy<EventMetric<ReorderDialogExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reorder_dialog".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(454.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.reorder_main
    ///
    /// User interactions for the browser language within about-preferences in the main
    /// pane and in the browser language dialog. Each dialog event (on the dialog
    /// object, and the manage and search methods of the main object) has a value which
    /// is a monotonically increasing number that links it with other events related to
    /// the same dialog instance. This event was generated to correspond to the Legacy
    /// Telemetry event intl.ui.browserLanguage.reorder#main.
    pub static reorder_main: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reorder_main".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(455.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SearchDialogExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SearchDialogExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.search_dialog
    ///
    /// User interactions for the browser language within about-preferences in the main
    /// pane and in the browser language dialog. Each dialog event (on the dialog
    /// object, and the manage and search methods of the main object) has a value which
    /// is a monotonically increasing number that links it with other events related to
    /// the same dialog instance. This event was generated to correspond to the Legacy
    /// Telemetry event intl.ui.browserLanguage.search#dialog.
    pub static search_dialog: Lazy<EventMetric<SearchDialogExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "search_dialog".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(456.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SearchMainExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SearchMainExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.search_main
    ///
    /// User interactions for the browser language within about-preferences in the main
    /// pane and in the browser language dialog. Each dialog event (on the dialog
    /// object, and the manage and search methods of the main object) has a value which
    /// is a monotonically increasing number that links it with other events related to
    /// the same dialog instance. This event was generated to correspond to the Legacy
    /// Telemetry event intl.ui.browserLanguage.search#main.
    pub static search_main: Lazy<EventMetric<SearchMainExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "search_main".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(457.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SetFallbackDialogExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SetFallbackDialogExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.set_fallback_dialog
    ///
    /// User interactions for the browser language within about-preferences in the main
    /// pane and in the browser language dialog. Each dialog event (on the dialog
    /// object, and the manage and search methods of the main object) has a value which
    /// is a monotonically increasing number that links it with other events related to
    /// the same dialog instance. This event was generated to correspond to the Legacy
    /// Telemetry event intl.ui.browserLanguage.set_fallback#dialog.
    pub static set_fallback_dialog: Lazy<EventMetric<SetFallbackDialogExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "set_fallback_dialog".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(458.into(), meta)
    });

}
pub mod privacy_ui_fpp_click {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CheckboxExtra {
        pub r#checked: Option<bool>,
    }

    impl ExtraKeys for CheckboxExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["checked"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#checked.and_then(|val| map.insert("checked".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from privacy.ui.fpp.click.checkbox
    ///
    /// User interaction by click events on fingerprinting protection checkbox in the
    /// ETP Custom subpanel.
    pub static checkbox: Lazy<EventMetric<CheckboxExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "checkbox".into(),
                category: "privacy.ui.fpp.click".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(459.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct MenuExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for MenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from privacy.ui.fpp.click.menu
    ///
    /// User interaction by click events on fingerprinting protection menulist in the
    /// ETP Custom subpanel.
    pub static menu: Lazy<EventMetric<MenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "menu".into(),
                category: "privacy.ui.fpp.click".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(460.into(), meta)
    });

}
pub mod security_doh_settings {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ModeChangedButtonExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ModeChangedButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.settings.mode_changed_button
    ///
    /// User changed the TRR mode in about:preferences#privacy settings Value is id of
    /// the clicked button. This event was generated to correspond to the Legacy
    /// Telemetry event security.doh.settings.mode_changed#button.
    pub static mode_changed_button: Lazy<EventMetric<ModeChangedButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mode_changed_button".into(),
                category: "security.doh.settings".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(461.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ProviderChoiceValueExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ProviderChoiceValueExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.settings.provider_choice_value
    ///
    /// User changed their DoH provider. Recorded value is URL of one of the existing
    /// providers or "custom". This event was generated to correspond to the Legacy
    /// Telemetry event security.doh.settings.provider_choice#value.
    pub static provider_choice_value: Lazy<EventMetric<ProviderChoiceValueExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "provider_choice_value".into(),
                category: "security.doh.settings".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(462.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct WarnCheckboxCheckboxExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for WarnCheckboxCheckboxExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.settings.warn_checkbox_checkbox
    ///
    /// User clicked the Warn if a third party actively prevents secure DNS checkbox in
    /// about:preferences#privacy. Value is true or false, reflecting if box is checked
    /// or unchecked. This event was generated to correspond to the Legacy Telemetry
    /// event security.doh.settings.warn_checkbox#checkbox.
    pub static warn_checkbox_checkbox: Lazy<EventMetric<WarnCheckboxCheckboxExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "warn_checkbox_checkbox".into(),
                category: "security.doh.settings".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(463.into(), meta)
    });

}
pub mod aboutprivatebrowsing {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from aboutprivatebrowsing.click_dismiss_button
    ///
    /// This is recorded when a user clicks a link on the private browsing newtab. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// aboutprivatebrowsing.click#dismiss_button.
    pub static click_dismiss_button: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_dismiss_button".into(),
                category: "aboutprivatebrowsing".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(464.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from aboutprivatebrowsing.click_info_link
    ///
    /// This is recorded when a user clicks a link on the private browsing newtab. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// aboutprivatebrowsing.click#info_link.
    pub static click_info_link: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_info_link".into(),
                category: "aboutprivatebrowsing".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(465.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from aboutprivatebrowsing.click_promo_link
    ///
    /// This is recorded when a user clicks a link on the private browsing newtab. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// aboutprivatebrowsing.click#promo_link.
    pub static click_promo_link: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_promo_link".into(),
                category: "aboutprivatebrowsing".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(466.into(), meta)
    });

}
pub mod private_browsing_reset_pbm {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ConfirmPanelExtra {
        pub r#action: Option<String>,
        pub r#reason: Option<String>,
    }

    impl ExtraKeys for ConfirmPanelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from private_browsing.reset_pbm.confirm_panel
    ///
    /// Confirm panel show / hide event.
    pub static confirm_panel: Lazy<EventMetric<ConfirmPanelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "confirm_panel".into(),
                category: "private_browsing.reset_pbm".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(467.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ResetActionExtra {
        pub r#did_confirm: Option<bool>,
    }

    impl ExtraKeys for ResetActionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["did_confirm"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#did_confirm.and_then(|val| map.insert("did_confirm".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from private_browsing.reset_pbm.reset_action
    ///
    /// Dispatched whenever PBM is restarted / reset via the resetPBM feature.
    pub static reset_action: Lazy<EventMetric<ResetActionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reset_action".into(),
                category: "private_browsing.reset_pbm".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(468.into(), meta)
    });

}
pub mod security_ui_protections {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickLwAboutLinkExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickLwAboutLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_lw_about_link
    ///
    /// User interaction by click events on the protection report. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protections.click#lw_about_link.
    pub static click_lw_about_link: Lazy<EventMetric<ClickLwAboutLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_lw_about_link".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(469.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickLwOpenButtonExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickLwOpenButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_lw_open_button
    ///
    /// User interaction by click events on the protection report. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protections.click#lw_open_button.
    pub static click_lw_open_button: Lazy<EventMetric<ClickLwOpenButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_lw_open_button".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(470.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickLwSyncLinkExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickLwSyncLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_lw_sync_link
    ///
    /// User interaction by click events on the protection report. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protections.click#lw_sync_link.
    pub static click_lw_sync_link: Lazy<EventMetric<ClickLwSyncLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_lw_sync_link".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(471.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickMobileAppLinkExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickMobileAppLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_mobile_app_link
    ///
    /// User interaction by click events on the protection report. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protections.click#mobile_app_link.
    pub static click_mobile_app_link: Lazy<EventMetric<ClickMobileAppLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_mobile_app_link".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(472.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickMtrAboutLinkExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickMtrAboutLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_mtr_about_link
    ///
    /// User interaction by click events on the protection report. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protections.click#mtr_about_link.
    pub static click_mtr_about_link: Lazy<EventMetric<ClickMtrAboutLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_mtr_about_link".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(473.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickMtrReportLinkExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickMtrReportLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_mtr_report_link
    ///
    /// User interaction by click events on the protection report. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protections.click#mtr_report_link.
    pub static click_mtr_report_link: Lazy<EventMetric<ClickMtrReportLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_mtr_report_link".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(474.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickMtrSignupButtonExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickMtrSignupButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_mtr_signup_button
    ///
    /// User interaction by click events on the protection report. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protections.click#mtr_signup_button.
    pub static click_mtr_signup_button: Lazy<EventMetric<ClickMtrSignupButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_mtr_signup_button".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(475.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSettingsLinkExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickSettingsLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_settings_link
    ///
    /// User interaction by click events on the protection report. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protections.click#settings_link.
    pub static click_settings_link: Lazy<EventMetric<ClickSettingsLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_settings_link".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(476.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickTrackersAboutLinkExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickTrackersAboutLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_trackers_about_link
    ///
    /// User interaction by click events on the protection report. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protections.click#trackers_about_link.
    pub static click_trackers_about_link: Lazy<EventMetric<ClickTrackersAboutLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_trackers_about_link".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(477.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickVpnAppLinkAndroidExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickVpnAppLinkAndroidExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_vpn_app_link_android
    ///
    /// User interaction by click events on the protection report. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protections.click#vpn_app_link_android.
    pub static click_vpn_app_link_android: Lazy<EventMetric<ClickVpnAppLinkAndroidExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_vpn_app_link_android".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(478.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickVpnAppLinkIosExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickVpnAppLinkIosExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_vpn_app_link_ios
    ///
    /// User interaction by click events on the protection report. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protections.click#vpn_app_link_ios.
    pub static click_vpn_app_link_ios: Lazy<EventMetric<ClickVpnAppLinkIosExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_vpn_app_link_ios".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(479.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickVpnBannerCloseExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickVpnBannerCloseExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_vpn_banner_close
    ///
    /// User interaction by click events on the protection report. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protections.click#vpn_banner_close.
    pub static click_vpn_banner_close: Lazy<EventMetric<ClickVpnBannerCloseExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_vpn_banner_close".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(480.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickVpnBannerLinkExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickVpnBannerLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_vpn_banner_link
    ///
    /// User interaction by click events on the protection report. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protections.click#vpn_banner_link.
    pub static click_vpn_banner_link: Lazy<EventMetric<ClickVpnBannerLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_vpn_banner_link".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(481.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickVpnCardLinkExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickVpnCardLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_vpn_card_link
    ///
    /// User interaction by click events on the protection report. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protections.click#vpn_card_link.
    pub static click_vpn_card_link: Lazy<EventMetric<ClickVpnCardLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_vpn_card_link".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(482.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CloseProtectionReportExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for CloseProtectionReportExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.close_protection_report
    ///
    /// User closed on the protection report. This event was generated to correspond to
    /// the Legacy Telemetry event security.ui.protections.close#protection_report.
    pub static close_protection_report: Lazy<EventMetric<CloseProtectionReportExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "close_protection_report".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(483.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowProtectionReportExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowProtectionReportExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.show_protection_report
    ///
    /// User arrived on the protection report. This also includes a 'value' attribute
    /// which defaults to 'direct' or will be the value that a referring website addds
    /// to the url. This also indicates if the vpn banner has been seen. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protections.show#protection_report.
    pub static show_protection_report: Lazy<EventMetric<ShowProtectionReportExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_protection_report".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(484.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowVpnBannerExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowVpnBannerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.show_vpn_banner
    ///
    /// User arrived on the protection report. This also includes a 'value' attribute
    /// which defaults to 'direct' or will be the value that a referring website addds
    /// to the url. This also indicates if the vpn banner has been seen. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.protections.show#vpn_banner.
    pub static show_vpn_banner: Lazy<EventMetric<ShowVpnBannerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_vpn_banner".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(485.into(), meta)
    });

}
pub mod protocolhandler_mailto {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum HandlerPromptShownLabel {
        EOsDefault = 0,
        EFxDefault = 1,
        __Other__,
    }
    impl From<u16> for HandlerPromptShownLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOsDefault,
                1 => Self::EFxDefault,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HandlerPromptShownLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOsDefault => "os_default",
                Self::EFxDefault => "fx_default",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from protocolhandler.mailto.handler_prompt_shown
    ///
    /// A website was visited, which called registerProtocolHandler for mailto://
    pub static handler_prompt_shown: Lazy<LabeledMetric<LabeledCounterMetric, HandlerPromptShownLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "handler_prompt_shown".into(),
                    category: "protocolhandler.mailto".into(),
                    send_in_pings: vec!["active".into(), "metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(486.into(), meta, Some(vec![::std::borrow::Cow::from("fx_default"), ::std::borrow::Cow::from("os_default")]))
    });

    #[repr(u16)]
    pub enum PromptClickedLabel {
        ESetOsDefault = 0,
        ESetOsDefaultError = 1,
        ESetOsDefaultImpossible = 2,
        EDismissOsDefault = 3,
        ESetLocalDefault = 4,
        EDismissLocalDefault = 5,
        __Other__,
    }
    impl From<u16> for PromptClickedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESetOsDefault,
                1 => Self::ESetOsDefaultError,
                2 => Self::ESetOsDefaultImpossible,
                3 => Self::EDismissOsDefault,
                4 => Self::ESetLocalDefault,
                5 => Self::EDismissLocalDefault,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PromptClickedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESetOsDefault => "set_os_default",
                Self::ESetOsDefaultError => "set_os_default_error",
                Self::ESetOsDefaultImpossible => "set_os_default_impossible",
                Self::EDismissOsDefault => "dismiss_os_default",
                Self::ESetLocalDefault => "set_local_default",
                Self::EDismissLocalDefault => "dismiss_local_default",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from protocolhandler.mailto.prompt_clicked
    ///
    /// User clicked on a button to approve setting the current site as default web
    /// mail site. The sum of all counters is the total amount of user interactions and
    /// dismissing the same dialog often could be a sign of a bug.
    pub static prompt_clicked: Lazy<LabeledMetric<LabeledCounterMetric, PromptClickedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "prompt_clicked".into(),
                    category: "protocolhandler.mailto".into(),
                    send_in_pings: vec!["active".into(), "metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(487.into(), meta, Some(vec![::std::borrow::Cow::from("dismiss_local_default"), ::std::borrow::Cow::from("dismiss_os_default"), ::std::borrow::Cow::from("set_local_default"), ::std::borrow::Cow::from("set_os_default"), ::std::borrow::Cow::from("set_os_default_error"), ::std::borrow::Cow::from("set_os_default_impossible")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct VisitExtra {
        pub r#triggered_externally: Option<bool>,
    }

    impl ExtraKeys for VisitExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["triggered_externally"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#triggered_externally.and_then(|val| map.insert("triggered_externally".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from protocolhandler.mailto.visit
    ///
    /// a URI of type mailto was visited. Furthermore we want to know if from within
    /// the browser.
    pub static visit: Lazy<EventMetric<VisitExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "visit".into(),
                category: "protocolhandler.mailto".into(),
                send_in_pings: vec!["active".into(), "events".into(), "metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(488.into(), meta)
    });

}
pub mod screenshots {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.canceled_context_menu
    ///
    /// Recorded when a user closes the screenshots ui. The screenshots ui is closed
    /// after copying/downloading but we do not record that as canceling the
    /// screenshots ui. This event was generated to correspond to the Legacy Telemetry
    /// event screenshots.canceled#context_menu.
    pub static canceled_context_menu: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canceled_context_menu".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(489.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.canceled_escape
    ///
    /// Recorded when a user closes the screenshots ui. The screenshots ui is closed
    /// after copying/downloading but we do not record that as canceling the
    /// screenshots ui. This event was generated to correspond to the Legacy Telemetry
    /// event screenshots.canceled#escape.
    pub static canceled_escape: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canceled_escape".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(490.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.canceled_navigation
    ///
    /// Recorded when a user closes the screenshots ui. The screenshots ui is closed
    /// after copying/downloading but we do not record that as canceling the
    /// screenshots ui. This event was generated to correspond to the Legacy Telemetry
    /// event screenshots.canceled#navigation.
    pub static canceled_navigation: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canceled_navigation".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(491.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.canceled_overlay_cancel
    ///
    /// Recorded when a user closes the screenshots ui. The screenshots ui is closed
    /// after copying/downloading but we do not record that as canceling the
    /// screenshots ui. This event was generated to correspond to the Legacy Telemetry
    /// event screenshots.canceled#overlay_cancel.
    pub static canceled_overlay_cancel: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canceled_overlay_cancel".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(492.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.canceled_preview_cancel
    ///
    /// Recorded when a user closes the screenshots ui. The screenshots ui is closed
    /// after copying/downloading but we do not record that as canceling the
    /// screenshots ui. This event was generated to correspond to the Legacy Telemetry
    /// event screenshots.canceled#preview_cancel.
    pub static canceled_preview_cancel: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canceled_preview_cancel".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(493.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.canceled_quick_actions
    ///
    /// Recorded when a user closes the screenshots ui. The screenshots ui is closed
    /// after copying/downloading but we do not record that as canceling the
    /// screenshots ui. This event was generated to correspond to the Legacy Telemetry
    /// event screenshots.canceled#quick_actions.
    pub static canceled_quick_actions: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canceled_quick_actions".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(494.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.canceled_shortcut
    ///
    /// Recorded when a user closes the screenshots ui. The screenshots ui is closed
    /// after copying/downloading but we do not record that as canceling the
    /// screenshots ui. This event was generated to correspond to the Legacy Telemetry
    /// event screenshots.canceled#shortcut.
    pub static canceled_shortcut: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canceled_shortcut".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(495.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.canceled_toolbar_button
    ///
    /// Recorded when a user closes the screenshots ui. The screenshots ui is closed
    /// after copying/downloading but we do not record that as canceling the
    /// screenshots ui. This event was generated to correspond to the Legacy Telemetry
    /// event screenshots.canceled#toolbar_button.
    pub static canceled_toolbar_button: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canceled_toolbar_button".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(496.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CopyOverlayCopyExtra {
        pub r#element: Option<String>,
        pub r#fullpage: Option<String>,
        pub r#move: Option<String>,
        pub r#region: Option<String>,
        pub r#resize: Option<String>,
        pub r#visible: Option<String>,
    }

    impl ExtraKeys for CopyOverlayCopyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["element", "fullpage", "move", "region", "resize", "visible"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#element.and_then(|val| map.insert("element".into(), val.to_string()));
          self.r#fullpage.and_then(|val| map.insert("fullpage".into(), val.to_string()));
          self.r#move.and_then(|val| map.insert("move".into(), val.to_string()));
          self.r#region.and_then(|val| map.insert("region".into(), val.to_string()));
          self.r#resize.and_then(|val| map.insert("resize".into(), val.to_string()));
          self.r#visible.and_then(|val| map.insert("visible".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from screenshots.copy_overlay_copy
    ///
    /// Recorded when a user copies a screenshot from the overlay or the preview. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// screenshots.copy#overlay_copy.
    pub static copy_overlay_copy: Lazy<EventMetric<CopyOverlayCopyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "copy_overlay_copy".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(497.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CopyPreviewCopyExtra {
        pub r#element: Option<String>,
        pub r#fullpage: Option<String>,
        pub r#move: Option<String>,
        pub r#region: Option<String>,
        pub r#resize: Option<String>,
        pub r#visible: Option<String>,
    }

    impl ExtraKeys for CopyPreviewCopyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["element", "fullpage", "move", "region", "resize", "visible"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#element.and_then(|val| map.insert("element".into(), val.to_string()));
          self.r#fullpage.and_then(|val| map.insert("fullpage".into(), val.to_string()));
          self.r#move.and_then(|val| map.insert("move".into(), val.to_string()));
          self.r#region.and_then(|val| map.insert("region".into(), val.to_string()));
          self.r#resize.and_then(|val| map.insert("resize".into(), val.to_string()));
          self.r#visible.and_then(|val| map.insert("visible".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from screenshots.copy_preview_copy
    ///
    /// Recorded when a user copies a screenshot from the overlay or the preview. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// screenshots.copy#preview_copy.
    pub static copy_preview_copy: Lazy<EventMetric<CopyPreviewCopyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "copy_preview_copy".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(498.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DownloadOverlayDownloadExtra {
        pub r#element: Option<String>,
        pub r#fullpage: Option<String>,
        pub r#move: Option<String>,
        pub r#region: Option<String>,
        pub r#resize: Option<String>,
        pub r#visible: Option<String>,
    }

    impl ExtraKeys for DownloadOverlayDownloadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["element", "fullpage", "move", "region", "resize", "visible"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#element.and_then(|val| map.insert("element".into(), val.to_string()));
          self.r#fullpage.and_then(|val| map.insert("fullpage".into(), val.to_string()));
          self.r#move.and_then(|val| map.insert("move".into(), val.to_string()));
          self.r#region.and_then(|val| map.insert("region".into(), val.to_string()));
          self.r#resize.and_then(|val| map.insert("resize".into(), val.to_string()));
          self.r#visible.and_then(|val| map.insert("visible".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from screenshots.download_overlay_download
    ///
    /// Recorded when a user downloads a screenshot from the overlay or the preview.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// screenshots.download#overlay_download.
    pub static download_overlay_download: Lazy<EventMetric<DownloadOverlayDownloadExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "download_overlay_download".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(499.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DownloadPreviewDownloadExtra {
        pub r#element: Option<String>,
        pub r#fullpage: Option<String>,
        pub r#move: Option<String>,
        pub r#region: Option<String>,
        pub r#resize: Option<String>,
        pub r#visible: Option<String>,
    }

    impl ExtraKeys for DownloadPreviewDownloadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["element", "fullpage", "move", "region", "resize", "visible"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#element.and_then(|val| map.insert("element".into(), val.to_string()));
          self.r#fullpage.and_then(|val| map.insert("fullpage".into(), val.to_string()));
          self.r#move.and_then(|val| map.insert("move".into(), val.to_string()));
          self.r#region.and_then(|val| map.insert("region".into(), val.to_string()));
          self.r#resize.and_then(|val| map.insert("resize".into(), val.to_string()));
          self.r#visible.and_then(|val| map.insert("visible".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from screenshots.download_preview_download
    ///
    /// Recorded when a user downloads a screenshot from the overlay or the preview.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// screenshots.download#preview_download.
    pub static download_preview_download: Lazy<EventMetric<DownloadPreviewDownloadExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "download_preview_download".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(500.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.failed_screenshot_too_large
    ///
    /// Recorded when a screenshot is too big to capture and we have to crop the
    /// screenshot. This event was generated to correspond to the Legacy Telemetry
    /// event screenshots.failed#screenshot_too_large.
    pub static failed_screenshot_too_large: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "failed_screenshot_too_large".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(501.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.selected_element
    ///
    /// Recorded when a user selects a region by hand, selects an element, selects the
    /// save visible, or selects save full page. Note that this is recorded independent
    /// of whether or not the screenshot is saved. This event was generated to
    /// correspond to the Legacy Telemetry event screenshots.selected#element.
    pub static selected_element: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "selected_element".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(502.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.selected_full_page
    ///
    /// Recorded when a user selects a region by hand, selects an element, selects the
    /// save visible, or selects save full page. Note that this is recorded independent
    /// of whether or not the screenshot is saved. This event was generated to
    /// correspond to the Legacy Telemetry event screenshots.selected#full_page.
    pub static selected_full_page: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "selected_full_page".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(503.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.selected_region_selection
    ///
    /// Recorded when a user selects a region by hand, selects an element, selects the
    /// save visible, or selects save full page. Note that this is recorded independent
    /// of whether or not the screenshot is saved. This event was generated to
    /// correspond to the Legacy Telemetry event screenshots.selected#region_selection.
    pub static selected_region_selection: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "selected_region_selection".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(504.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.selected_visible
    ///
    /// Recorded when a user selects a region by hand, selects an element, selects the
    /// save visible, or selects save full page. Note that this is recorded independent
    /// of whether or not the screenshot is saved. This event was generated to
    /// correspond to the Legacy Telemetry event screenshots.selected#visible.
    pub static selected_visible: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "selected_visible".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(505.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.started_context_menu
    ///
    /// Recorded when a user opens the screenshots ui. This event was generated to
    /// correspond to the Legacy Telemetry event screenshots.started#context_menu.
    pub static started_context_menu: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "started_context_menu".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(506.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.started_overlay_retry
    ///
    /// Recorded when a user opens the screenshots ui. This event was generated to
    /// correspond to the Legacy Telemetry event screenshots.started#overlay_retry.
    pub static started_overlay_retry: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "started_overlay_retry".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(507.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.started_preview_retry
    ///
    /// Recorded when a user opens the screenshots ui. This event was generated to
    /// correspond to the Legacy Telemetry event screenshots.started#preview_retry.
    pub static started_preview_retry: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "started_preview_retry".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(508.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.started_quick_actions
    ///
    /// Recorded when a user opens the screenshots ui. This event was generated to
    /// correspond to the Legacy Telemetry event screenshots.started#quick_actions.
    pub static started_quick_actions: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "started_quick_actions".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(509.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.started_shortcut
    ///
    /// Recorded when a user opens the screenshots ui. This event was generated to
    /// correspond to the Legacy Telemetry event screenshots.started#shortcut.
    pub static started_shortcut: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "started_shortcut".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(510.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.started_toolbar_button
    ///
    /// Recorded when a user opens the screenshots ui. This event was generated to
    /// correspond to the Legacy Telemetry event screenshots.started#toolbar_button.
    pub static started_toolbar_button: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "started_toolbar_button".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(511.into(), meta)
    });

}
pub mod browser_engagement_navigation {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.navigation.about_home
    ///
    /// The count URI loads triggered in a subsession from about:home, broken down by
    /// the originating action. This metric was generated to correspond to the Legacy
    /// Telemetry scalar browser.engagement.navigation.about_home.
    pub static about_home: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "about_home".into(),
                    category: "browser.engagement.navigation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(512.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.navigation.about_newtab
    ///
    /// The count URI loads triggered in a subsession from about:newtab, broken down by
    /// the originating action. This metric was generated to correspond to the Legacy
    /// Telemetry scalar browser.engagement.navigation.about_newtab.
    pub static about_newtab: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "about_newtab".into(),
                    category: "browser.engagement.navigation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(513.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.navigation.contextmenu
    ///
    /// The count URI loads triggered in a subsession from the contextmenu, broken down
    /// by the originating action. This metric was generated to correspond to the
    /// Legacy Telemetry scalar browser.engagement.navigation.contextmenu.
    pub static contextmenu: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "contextmenu".into(),
                    category: "browser.engagement.navigation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(514.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.navigation.searchbar
    ///
    /// The count URI loads triggered in a subsession from the searchbar, broken down
    /// by the originating action. This metric was generated to correspond to the
    /// Legacy Telemetry scalar browser.engagement.navigation.searchbar.
    pub static searchbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "searchbar".into(),
                    category: "browser.engagement.navigation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(515.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.navigation.urlbar
    ///
    /// The count URI loads triggered in a subsession from the urlbar, broken down by
    /// the originating action. This metric was generated to correspond to the Legacy
    /// Telemetry scalar browser.engagement.navigation.urlbar.
    pub static urlbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar".into(),
                    category: "browser.engagement.navigation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(516.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.navigation.urlbar_handoff
    ///
    /// The count URI loads triggered in a subsession from the urlbar via handoff,
    /// broken down by the originating action. This metric was generated to correspond
    /// to the Legacy Telemetry scalar browser.engagement.navigation.urlbar_handoff.
    pub static urlbar_handoff: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_handoff".into(),
                    category: "browser.engagement.navigation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(517.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.navigation.urlbar_persisted
    ///
    /// The count of URI loads triggered in a subsession from the urlbar after the
    /// search term was shown in the urlbar, broken down by the originating action.
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.engagement.navigation.urlbar_persisted.
    pub static urlbar_persisted: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_persisted".into(),
                    category: "browser.engagement.navigation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(518.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.navigation.urlbar_searchmode
    ///
    /// The count URI loads triggered in a subsession from the urlbar's search mode,
    /// broken down by the originating action. This metric was generated to correspond
    /// to the Legacy Telemetry scalar browser.engagement.navigation.urlbar_searchmode.
    pub static urlbar_searchmode: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_searchmode".into(),
                    category: "browser.engagement.navigation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(519.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.navigation.webextension
    ///
    /// The count URI loads triggered in a subsession from a webextension. This metric
    /// was generated to correspond to the Legacy Telemetry scalar
    /// browser.engagement.navigation.webextension.
    pub static webextension: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "webextension".into(),
                    category: "browser.engagement.navigation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(520.into(), meta, None)
    });

}
pub mod browser_search_adclicks {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.about_home
    ///
    /// Records clicks of adverts on SERP pages where the search was started from
    /// about:home. The key format is ‘<provider>:<tagged|organic>’ See
    /// https://firefox-source- docs.mozilla.org/browser/search/telemetry.html#browser-
    /// search- content This metric was generated to correspond to the Legacy Telemetry
    /// scalar browser.search.adclicks.about_home.
    pub static about_home: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "about_home".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(521.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.about_newtab
    ///
    /// Records clicks of adverts on SERP pages where the search was started from
    /// about:newtab. The key format is ‘<provider>:<tagged|organic>’ See
    /// https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
    /// search-content This metric was generated to correspond to the Legacy Telemetry
    /// scalar browser.search.adclicks.about_newtab.
    pub static about_newtab: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "about_newtab".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(522.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.contextmenu
    ///
    /// Records clicks of adverts on SERP pages where the search was started from the
    /// context menu. The key format is ‘<provider>:<tagged|organic>’ See
    /// https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
    /// search-content This metric was generated to correspond to the Legacy Telemetry
    /// scalar browser.search.adclicks.contextmenu.
    pub static contextmenu: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "contextmenu".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(523.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.reload
    ///
    /// Records clicks of adverts on SERP pages where the search was loaded by
    /// reloading the page. The key format is ‘<provider>:<tagged|organic>’ See
    /// https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
    /// search-content This metric was generated to correspond to the Legacy Telemetry
    /// scalar browser.search.adclicks.reload.
    pub static reload: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "reload".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(524.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.searchbar
    ///
    /// Records clicks of adverts on SERP pages where the search was started from the
    /// search bar. The key format is ‘<provider>:<tagged|organic>’ See
    /// https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
    /// search-content This metric was generated to correspond to the Legacy Telemetry
    /// scalar browser.search.adclicks.searchbar.
    pub static searchbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "searchbar".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(525.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.system
    ///
    /// Records clicks of adverts on SERP pages where the search was started from the
    /// system, e.g. command line. The key format is ‘<provider>:<tagged|organic>’ See
    /// https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
    /// search-content This metric was generated to correspond to the Legacy Telemetry
    /// scalar browser.search.adclicks.system.
    pub static system: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "system".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(526.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.tabhistory
    ///
    /// Records clicks of adverts on SERP pages where the search was loaded from the
    /// tab history. The key format is ‘<provider>:<tagged|organic>’ See
    /// https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
    /// search-content This metric was generated to correspond to the Legacy Telemetry
    /// scalar browser.search.adclicks.tabhistory.
    pub static tabhistory: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tabhistory".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(527.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.unknown
    ///
    /// Records clicks of adverts on SERP pages where the search was started from a
    /// place not categorized by the other scalars. The key format is
    /// ‘<provider>:<tagged|organic>’ See https://firefox-source-
    /// docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.search.adclicks.unknown.
    pub static unknown: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "unknown".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(528.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.urlbar
    ///
    /// Records clicks of adverts on SERP pages where the search was started from the
    /// urlbar. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-
    /// source- docs.mozilla.org/browser/search/telemetry.html#browser-search- content
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.search.adclicks.urlbar.
    pub static urlbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(529.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.urlbar_handoff
    ///
    /// The count URI loads triggered in a subsession from the urlbar via handoff,
    /// broken down by the originating action. This metric was generated to correspond
    /// to the Legacy Telemetry scalar browser.search.adclicks.urlbar_handoff.
    pub static urlbar_handoff: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_handoff".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(530.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.urlbar_persisted
    ///
    /// Records clicks of adverts on SERP pages where the search was started from the
    /// urlbar after the search term was shown in the urlbar. The key format is
    /// ‘<provider>:<tagged|organic>’ See https://firefox-source-
    /// docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.search.adclicks.urlbar_persisted.
    pub static urlbar_persisted: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_persisted".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(531.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.urlbar_searchmode
    ///
    /// Records clicks of adverts on SERP pages where the search was started from the
    /// urlbar in search mode. The key format is ‘<provider>:<tagged|organic>’ See
    /// https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
    /// search-content This metric was generated to correspond to the Legacy Telemetry
    /// scalar browser.search.adclicks.urlbar_searchmode.
    pub static urlbar_searchmode: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_searchmode".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(532.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.webextension
    ///
    /// Records clicks of adverts on SERP pages where the search was started from a
    /// webextension. The key format is ‘<provider>:<tagged|organic>’ See
    /// https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
    /// search-content This metric was generated to correspond to the Legacy Telemetry
    /// scalar browser.search.adclicks.webextension.
    pub static webextension: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "webextension".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(533.into(), meta, None)
    });

}
pub mod browser_search_content {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.about_home
    ///
    /// Records counts for in-content searches where the search was most likely started
    /// from the about:home. The key format is <provider>:[tagged|tagged-follow-
    /// on|organic]:[code|other|none] See https://firefox-source-
    /// docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.search.content.about_home.
    pub static about_home: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "about_home".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(534.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.about_newtab
    ///
    /// Records counts for in-content searches where the search was most likely started
    /// from the about:newtab. The key format is <provider>:[tagged|tagged-follow-
    /// on|organic]:[code|other|none] See https://firefox-source-
    /// docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.search.content.about_newtab.
    pub static about_newtab: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "about_newtab".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(535.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.contextmenu
    ///
    /// Records counts for in-content searches where the search was most likely started
    /// from the context menu. The key format is <provider>:[tagged|tagged-follow-
    /// on|organic]:[code|other|none] See https://firefox-source-
    /// docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.search.content.contextmenu.
    pub static contextmenu: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "contextmenu".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(536.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.reload
    ///
    /// Records counts for in-content searches where the search was loaded by reloading
    /// the page. The key format is <provider>:[tagged|tagged-follow-
    /// on|organic]:[code|other|none] See https://firefox-source-
    /// docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.search.content.reload.
    pub static reload: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "reload".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(537.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.searchbar
    ///
    /// Records counts for in-content searches where the search was most likely started
    /// from the search bar. The key format is <provider>:[tagged|tagged-follow-
    /// on|organic]:[code|other|none] See https://firefox-source-
    /// docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.search.content.searchbar.
    pub static searchbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "searchbar".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(538.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.system
    ///
    /// Records counts for in-content searches where the search was most likely started
    /// from the system, e.g. command line. The key format is
    /// <provider>:[tagged|tagged-follow-on|organic]:[code|other|none] See
    /// https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
    /// search-content This metric was generated to correspond to the Legacy Telemetry
    /// scalar browser.search.content.system.
    pub static system: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "system".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(539.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.tabhistory
    ///
    /// Records counts for in-content searches where the search was loaded from the tab
    /// history. The key format is <provider>:[tagged|tagged-follow-
    /// on|organic]:[code|other|none] See https://firefox-source-
    /// docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.search.content.tabhistory.
    pub static tabhistory: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tabhistory".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(540.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.unknown
    ///
    /// Records counts for in-content searches where the search was started from a
    /// place that could not be determined or not categorized by the other scalars. The
    /// key format is <provider>:[tagged|tagged-follow-on|organic]:[code|other|none]
    /// See https://firefox-source-
    /// docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.search.content.unknown.
    pub static unknown: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "unknown".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(541.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.urlbar
    ///
    /// Records counts for in-content searches where the search was most likely started
    /// from the urlbar. The key format is <provider>:[tagged|tagged-follow-
    /// on|organic]:[code|other|none] See https://firefox-source-
    /// docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.search.content.urlbar.
    pub static urlbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(542.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.urlbar_handoff
    ///
    /// The count URI loads triggered in a subsession from the urlbar via handoff,
    /// broken down by the originating action. This metric was generated to correspond
    /// to the Legacy Telemetry scalar browser.search.content.urlbar_handoff.
    pub static urlbar_handoff: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_handoff".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(543.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.urlbar_persisted
    ///
    /// Records counts for in-content searches where the search was most likely started
    /// from the urlbar after the search term was shown in the urlbar. The key format
    /// is <provider>:[tagged|tagged-follow-on|organic]:[code|other|none] See
    /// https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
    /// search-content This metric was generated to correspond to the Legacy Telemetry
    /// scalar browser.search.content.urlbar_persisted.
    pub static urlbar_persisted: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_persisted".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(544.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.urlbar_searchmode
    ///
    /// Records counts for in-content searches where the search was most likely started
    /// from the urlbar in search mode. The key format is <provider>:[tagged|tagged-
    /// follow-on|organic]:[code|other|none] See https://firefox-source-
    /// docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.search.content.urlbar_searchmode.
    pub static urlbar_searchmode: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_searchmode".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(545.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.webextension
    ///
    /// Records counts for in-content searches where the search was most likely started
    /// from a webextension. The key format is <provider>:[tagged|tagged-follow-
    /// on|organic]:[code|other|none] See https://firefox-source-
    /// docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.search.content.webextension.
    pub static webextension: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "webextension".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(546.into(), meta, None)
    });

}
pub mod browser_search_withads {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.about_home
    ///
    /// Records counts of SERP pages with adverts displayed where the search was
    /// started from about:home. The key format is ‘<provider>:<tagged|organic>’ See
    /// https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
    /// search-content This metric was generated to correspond to the Legacy Telemetry
    /// scalar browser.search.withads.about_home.
    pub static about_home: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "about_home".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(547.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.about_newtab
    ///
    /// Records counts of SERP pages with adverts displayed where the search was
    /// started from about:newtab. The key format is ‘<provider>:<tagged|organic>’ See
    /// https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
    /// search-content This metric was generated to correspond to the Legacy Telemetry
    /// scalar browser.search.withads.about_newtab.
    pub static about_newtab: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "about_newtab".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(548.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.contextmenu
    ///
    /// Records counts of SERP pages with adverts displayed where the search was
    /// started from the context menu. The key format is ‘<provider>:<tagged|organic>’
    /// See https://firefox-source-
    /// docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.search.withads.contextmenu.
    pub static contextmenu: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "contextmenu".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(549.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.reload
    ///
    /// Records counts of SERP pages with adverts displayed where the search was loaded
    /// by reloading the page. The key format is ‘<provider>:<tagged|organic>’ See
    /// https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
    /// search-content This metric was generated to correspond to the Legacy Telemetry
    /// scalar browser.search.withads.reload.
    pub static reload: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "reload".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(550.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.searchbar
    ///
    /// Records counts of SERP pages with adverts displayed where the search was
    /// started from the search bar. The key format is ‘<provider>:<tagged|organic>’
    /// See https://firefox-source-
    /// docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.search.withads.searchbar.
    pub static searchbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "searchbar".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(551.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.system
    ///
    /// Records counts of SERP pages with adverts displayed where the search was
    /// started from the system, e.g. command line. The key format is
    /// ‘<provider>:<tagged|organic>’ See https://firefox-source-
    /// docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.search.withads.system.
    pub static system: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "system".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(552.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.tabhistory
    ///
    /// Records counts of SERP pages with adverts displayed where the search was loaded
    /// from the tab history. The key format is ‘<provider>:<tagged|organic>’ See
    /// https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
    /// search-content This metric was generated to correspond to the Legacy Telemetry
    /// scalar browser.search.withads.tabhistory.
    pub static tabhistory: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tabhistory".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(553.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.unknown
    ///
    /// Records counts of SERP pages with adverts displayed where the search was
    /// started from a place not categorized by the other scalars. The key format is
    /// ‘<provider>:<tagged|organic>’ See https://firefox- source-
    /// docs.mozilla.org/browser/search/telemetry.html#browser- search-content This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.search.withads.unknown.
    pub static unknown: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "unknown".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(554.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.urlbar
    ///
    /// Records counts of SERP pages with adverts displayed where the search was
    /// started from the urlbar. The key format is ‘<provider>:<tagged|organic>’ See
    /// https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-
    /// search-content This metric was generated to correspond to the Legacy Telemetry
    /// scalar browser.search.withads.urlbar.
    pub static urlbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(555.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.urlbar_handoff
    ///
    /// The count URI loads triggered in a subsession from the urlbar via handoff,
    /// broken down by the originating action. This metric was generated to correspond
    /// to the Legacy Telemetry scalar browser.search.withads.urlbar_handoff.
    pub static urlbar_handoff: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_handoff".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(556.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.urlbar_persisted
    ///
    /// Records counts of SERP pages with adverts displayed where the search was
    /// started from the urlbar after the search term was shown in the urlbar. The key
    /// format is ‘<provider>:<tagged|organic>’ See https://firefox-source-
    /// docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.search.withads.urlbar_persisted.
    pub static urlbar_persisted: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_persisted".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(557.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.urlbar_searchmode
    ///
    /// Records counts of SERP pages with adverts displayed where the search was
    /// started from the urlbar in search mode. The key format is
    /// ‘<provider>:<tagged|organic>’ See https://firefox-source-
    /// docs.mozilla.org/browser/search/telemetry.html#browser-search-content This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.search.withads.urlbar_searchmode.
    pub static urlbar_searchmode: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_searchmode".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(558.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.webextension
    ///
    /// Records counts of SERP pages with adverts displayed where the search was
    /// started from a webextension. The key format is ‘<provider>:<tagged|organic>’
    /// See https://firefox-source-
    /// docs.mozilla.org/browser/search/telemetry.html#browser-search- content This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.search.withads.webextension.
    pub static webextension: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "webextension".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(559.into(), meta, None)
    });

}
pub mod newtab_search_ad {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickExtra {
        pub r#is_follow_on: Option<bool>,
        pub r#is_tagged: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#search_access_point: Option<String>,
        pub r#telemetry_id: Option<String>,
    }

    impl ExtraKeys for ClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_follow_on", "is_tagged", "newtab_visit_id", "search_access_point", "telemetry_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#is_follow_on.and_then(|val| map.insert("is_follow_on".into(), val.to_string()));
          self.r#is_tagged.and_then(|val| map.insert("is_tagged".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#search_access_point.and_then(|val| map.insert("search_access_point".into(), val.to_string()));
          self.r#telemetry_id.and_then(|val| map.insert("telemetry_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.search.ad.click
    ///
    /// Recorded when an ad link is clicked on a Search Engine Result Page (SERP) which
    /// was loaded by a seach that began on a newtab page.
    pub static click: Lazy<EventMetric<ClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click".into(),
                category: "newtab.search.ad".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(560.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ImpressionExtra {
        pub r#is_follow_on: Option<bool>,
        pub r#is_tagged: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#search_access_point: Option<String>,
        pub r#telemetry_id: Option<String>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_follow_on", "is_tagged", "newtab_visit_id", "search_access_point", "telemetry_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#is_follow_on.and_then(|val| map.insert("is_follow_on".into(), val.to_string()));
          self.r#is_tagged.and_then(|val| map.insert("is_tagged".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#search_access_point.and_then(|val| map.insert("search_access_point".into(), val.to_string()));
          self.r#telemetry_id.and_then(|val| map.insert("telemetry_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.search.ad.impression
    ///
    /// Recorded when a newtab visit resulted in a search that loaded a Search Engine
    /// Result Page (SERP) that contains an ad link. And the SERP is visible.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "impression".into(),
                category: "newtab.search.ad".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(561.into(), meta)
    });

}
pub mod search_with {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from search_with.context_id
    ///
    /// An identifier for Contextual Services user interaction pings. This is used
    /// internally for counting unique users as well as for anti-fraud. It is shared
    /// with other Contextual Services. It is not shared externally.
    pub static context_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "context_id".into(),
                category: "search_with".into(),
                send_in_pings: vec!["search-with".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(562.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search_with.reporting_url
    ///
    /// The external url to report this interaction to.
    pub static reporting_url: Lazy<UrlMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reporting_url".into(),
                category: "search_with".into(),
                send_in_pings: vec!["search-with".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UrlMetric::new(563.into(), meta)
    });

}
pub mod serp {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AbandonmentExtra {
        pub r#impression_id: Option<String>,
        pub r#reason: Option<String>,
    }

    impl ExtraKeys for AbandonmentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["impression_id", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#impression_id.and_then(|val| map.insert("impression_id".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.abandonment
    ///
    /// Recorded when there is no engagement with the SERP before the tab is closed,
    /// the window is closed, the app is closed, or the tab is navigated away from.
    pub static abandonment: Lazy<EventMetric<AbandonmentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "abandonment".into(),
                category: "serp".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(564.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AdImpressionExtra {
        pub r#ads_hidden: Option<u32>,
        pub r#ads_loaded: Option<u32>,
        pub r#ads_visible: Option<u32>,
        pub r#component: Option<String>,
        pub r#impression_id: Option<String>,
    }

    impl ExtraKeys for AdImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["ads_hidden", "ads_loaded", "ads_visible", "component", "impression_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#ads_hidden.and_then(|val| map.insert("ads_hidden".into(), val.to_string()));
          self.r#ads_loaded.and_then(|val| map.insert("ads_loaded".into(), val.to_string()));
          self.r#ads_visible.and_then(|val| map.insert("ads_visible".into(), val.to_string()));
          self.r#component.and_then(|val| map.insert("component".into(), val.to_string()));
          self.r#impression_id.and_then(|val| map.insert("impression_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.ad_impression
    ///
    /// Recorded when a user loads a SERP and ads are detected.
    pub static ad_impression: Lazy<EventMetric<AdImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ad_impression".into(),
                category: "serp".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(565.into(), meta)
    });

    #[repr(u16)]
    pub enum AdsBlockedCountLabel {
        EBeyondViewport = 0,
        EHiddenParent = 1,
        EHiddenChild = 2,
        __Other__,
    }
    impl From<u16> for AdsBlockedCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EBeyondViewport,
                1 => Self::EHiddenParent,
                2 => Self::EHiddenChild,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AdsBlockedCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EBeyondViewport => "beyond_viewport",
                Self::EHiddenParent => "hidden_parent",
                Self::EHiddenChild => "hidden_child",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.ads_blocked_count
    ///
    /// Counts the specific type of block.
    pub static ads_blocked_count: Lazy<LabeledMetric<LabeledCounterMetric, AdsBlockedCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "ads_blocked_count".into(),
                    category: "serp".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(566.into(), meta, Some(vec![::std::borrow::Cow::from("beyond_viewport"), ::std::borrow::Cow::from("hidden_child"), ::std::borrow::Cow::from("hidden_parent")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CategorizationExtra {
        pub r#app_version: Option<u32>,
        pub r#channel: Option<String>,
        pub r#is_shopping_page: Option<bool>,
        pub r#mappings_version: Option<u32>,
        pub r#num_ads_clicked: Option<u32>,
        pub r#num_ads_hidden: Option<u32>,
        pub r#num_ads_loaded: Option<u32>,
        pub r#num_ads_visible: Option<u32>,
        pub r#organic_category: Option<u32>,
        pub r#organic_num_domains: Option<u32>,
        pub r#organic_num_inconclusive: Option<u32>,
        pub r#organic_num_unknown: Option<u32>,
        pub r#partner_code: Option<String>,
        pub r#provider: Option<String>,
        pub r#region: Option<String>,
        pub r#sponsored_category: Option<u32>,
        pub r#sponsored_num_domains: Option<u32>,
        pub r#sponsored_num_inconclusive: Option<u32>,
        pub r#sponsored_num_unknown: Option<u32>,
        pub r#tagged: Option<bool>,
    }

    impl ExtraKeys for CategorizationExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["app_version", "channel", "is_shopping_page", "mappings_version", "num_ads_clicked", "num_ads_hidden", "num_ads_loaded", "num_ads_visible", "organic_category", "organic_num_domains", "organic_num_inconclusive", "organic_num_unknown", "partner_code", "provider", "region", "sponsored_category", "sponsored_num_domains", "sponsored_num_inconclusive", "sponsored_num_unknown", "tagged"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#app_version.and_then(|val| map.insert("app_version".into(), val.to_string()));
          self.r#channel.and_then(|val| map.insert("channel".into(), val.to_string()));
          self.r#is_shopping_page.and_then(|val| map.insert("is_shopping_page".into(), val.to_string()));
          self.r#mappings_version.and_then(|val| map.insert("mappings_version".into(), val.to_string()));
          self.r#num_ads_clicked.and_then(|val| map.insert("num_ads_clicked".into(), val.to_string()));
          self.r#num_ads_hidden.and_then(|val| map.insert("num_ads_hidden".into(), val.to_string()));
          self.r#num_ads_loaded.and_then(|val| map.insert("num_ads_loaded".into(), val.to_string()));
          self.r#num_ads_visible.and_then(|val| map.insert("num_ads_visible".into(), val.to_string()));
          self.r#organic_category.and_then(|val| map.insert("organic_category".into(), val.to_string()));
          self.r#organic_num_domains.and_then(|val| map.insert("organic_num_domains".into(), val.to_string()));
          self.r#organic_num_inconclusive.and_then(|val| map.insert("organic_num_inconclusive".into(), val.to_string()));
          self.r#organic_num_unknown.and_then(|val| map.insert("organic_num_unknown".into(), val.to_string()));
          self.r#partner_code.and_then(|val| map.insert("partner_code".into(), val.to_string()));
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#region.and_then(|val| map.insert("region".into(), val.to_string()));
          self.r#sponsored_category.and_then(|val| map.insert("sponsored_category".into(), val.to_string()));
          self.r#sponsored_num_domains.and_then(|val| map.insert("sponsored_num_domains".into(), val.to_string()));
          self.r#sponsored_num_inconclusive.and_then(|val| map.insert("sponsored_num_inconclusive".into(), val.to_string()));
          self.r#sponsored_num_unknown.and_then(|val| map.insert("sponsored_num_unknown".into(), val.to_string()));
          self.r#tagged.and_then(|val| map.insert("tagged".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.categorization
    ///
    /// A high-level categorization of a SERP (a best guess as to its topic), using
    /// buckets such as "sports" or "travel".
    pub static categorization: Lazy<EventMetric<CategorizationExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "categorization".into(),
                category: "serp".into(),
                send_in_pings: vec!["serp-categorization".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(567.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from serp.categorization_duration
    ///
    /// The time it takes to categorize elements on a SERP.
    pub static categorization_duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "categorization_duration".into(),
                category: "serp".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(568.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from serp.categorization_no_map_found
    ///
    /// A count incremented upon a SERP categorization event being recorded without a
    /// corresponding impression event being recorded. This metric effectively counts
    /// missing impressions due to issues with the domain-to-categories map.
    pub static categorization_no_map_found: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            569,
            "serp",
            "categorization_no_map_found",
            "serp-categorization"
        )
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EngagementExtra {
        pub r#action: Option<String>,
        pub r#impression_id: Option<String>,
        pub r#target: Option<String>,
    }

    impl ExtraKeys for EngagementExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action", "impression_id", "target"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          self.r#impression_id.and_then(|val| map.insert("impression_id".into(), val.to_string()));
          self.r#target.and_then(|val| map.insert("target".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.engagement
    ///
    /// Recorded user actions on a SERP.
    pub static engagement: Lazy<EventMetric<EngagementExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "engagement".into(),
                category: "serp".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(570.into(), meta)
    });

        #[derive(Debug, Hash, Eq, PartialEq, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct ExperimentInfoObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub slug: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub branch: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from serp.experiment_info
    ///
    /// Whether the client is enrolled in a specified experiment and if so, which
    /// branch the client is assigned to. The target experiment is specified in the
    /// Nimbus config by creating a "targetExperiment" key and setting its value to the
    /// experiment's slug (and ensuring the featureId is "search").
    pub static experiment_info: Lazy<ObjectMetric<ExperimentInfoObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "experiment_info".into(),
                category: "serp".into(),
                send_in_pings: vec!["serp-categorization".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(571.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ImpressionExtra {
        pub r#impression_id: Option<String>,
        pub r#is_private: Option<bool>,
        pub r#is_shopping_page: Option<bool>,
        pub r#is_signed_in: Option<bool>,
        pub r#partner_code: Option<String>,
        pub r#provider: Option<String>,
        pub r#shopping_tab_displayed: Option<bool>,
        pub r#source: Option<String>,
        pub r#tagged: Option<bool>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["impression_id", "is_private", "is_shopping_page", "is_signed_in", "partner_code", "provider", "shopping_tab_displayed", "source", "tagged"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#impression_id.and_then(|val| map.insert("impression_id".into(), val.to_string()));
          self.r#is_private.and_then(|val| map.insert("is_private".into(), val.to_string()));
          self.r#is_shopping_page.and_then(|val| map.insert("is_shopping_page".into(), val.to_string()));
          self.r#is_signed_in.and_then(|val| map.insert("is_signed_in".into(), val.to_string()));
          self.r#partner_code.and_then(|val| map.insert("partner_code".into(), val.to_string()));
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#shopping_tab_displayed.and_then(|val| map.insert("shopping_tab_displayed".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#tagged.and_then(|val| map.insert("tagged".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.impression
    ///
    /// Recorded when a search engine results page (SERP) is shown to a user. The
    /// feature began rolling out to all users with Firefox 115, and was permanently
    /// enabled in Firefox 119.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "impression".into(),
                category: "serp".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(572.into(), meta)
    });

}
pub mod urlbar_searchmode {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.bookmarkmenu
    ///
    /// A keyed uint recording how many times the user entered a particular search mode
    /// after selecing the Search Bookmarks menu item in the Library menu. This metric
    /// was generated to correspond to the Legacy Telemetry scalar
    /// urlbar.searchmode.bookmarkmenu.
    pub static bookmarkmenu: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "bookmarkmenu".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(573.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.handoff
    ///
    /// A keyed uint recording how many times the user entered a particular search mode
    /// after being handed off from the search bar on the new tab page. This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// urlbar.searchmode.handoff.
    pub static handoff: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "handoff".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(574.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.historymenu
    ///
    /// A keyed uint recording how many times the user entered a particular search mode
    /// after selecing the Search History menu item in a History menu. This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// urlbar.searchmode.historymenu.
    pub static historymenu: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "historymenu".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(575.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.keywordoffer
    ///
    /// A keyed uint recording how many times the user entered a particular search mode
    /// after selecting a keyword offer result. The scalar key for local search modes
    /// entered using a restrict keyword will be suffixed with "keyword". For example:
    /// tabs_keyword, bookmarks_keyword, history_keyword, and actions_keyword. This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// urlbar.searchmode.keywordoffer.
    pub static keywordoffer: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "keywordoffer".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(576.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.oneoff
    ///
    /// A keyed uint recording how many times the user entered a particular search mode
    /// after selecting a one-off. This metric was generated to correspond to the
    /// Legacy Telemetry scalar urlbar.searchmode.oneoff.
    pub static oneoff: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "oneoff".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(577.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.other
    ///
    /// A keyed uint recording how many times the user entered a particular search mode
    /// from an unknown entry point. If values appear for this probe in Telemetry, we
    /// should review the entry points to search mode. This metric was generated to
    /// correspond to the Legacy Telemetry scalar urlbar.searchmode.other.
    pub static other: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "other".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(578.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.searchbutton
    ///
    /// A keyed uint recording how many times the user entered a particular search mode
    /// by unified search button. This metric was generated to correspond to the Legacy
    /// Telemetry scalar urlbar.searchmode.searchbutton.
    pub static searchbutton: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "searchbutton".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(579.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.shortcut
    ///
    /// A keyed uint recording how many times the user entered a particular search mode
    /// after pressing a keyboard shortcut. This metric was generated to correspond to
    /// the Legacy Telemetry scalar urlbar.searchmode.shortcut.
    pub static shortcut: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "shortcut".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(580.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.tabmenu
    ///
    /// A keyed uint recording how many times the user entered a particular search mode
    /// after selecting the Search Tabs menu item in the Tab Overflow menu. This metric
    /// was generated to correspond to the Legacy Telemetry scalar
    /// urlbar.searchmode.tabmenu.
    pub static tabmenu: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tabmenu".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(581.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.tabtosearch
    ///
    /// A keyed uint recording how many times the user entered a particular search mode
    /// after selecting a tab-to-search result. This metric was generated to correspond
    /// to the Legacy Telemetry scalar urlbar.searchmode.tabtosearch.
    pub static tabtosearch: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tabtosearch".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(582.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.tabtosearch_onboard
    ///
    /// A keyed uint recording how many times the user entered a particular search mode
    /// after selecting a tab-to-search onboarding result. This metric was generated to
    /// correspond to the Legacy Telemetry scalar
    /// urlbar.searchmode.tabtosearch_onboard.
    pub static tabtosearch_onboard: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tabtosearch_onboard".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(583.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.topsites_newtab
    ///
    /// A keyed uint recording how many times the user entered a particular search mode
    /// after selecting a search shortcut Top Site on the New Tab Page. This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// urlbar.searchmode.topsites_newtab.
    pub static topsites_newtab: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "topsites_newtab".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(584.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.topsites_urlbar
    ///
    /// A keyed uint recording how many times the user entered a particular search mode
    /// after selecting a search shortcut Top Site in the Urlbar. This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// urlbar.searchmode.topsites_urlbar.
    pub static topsites_urlbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "topsites_urlbar".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(585.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.touchbar
    ///
    /// A keyed uint recording how many times the user entered a particular search mode
    /// after selecting a search shortcut on the macOS Touch Bar. This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// urlbar.searchmode.touchbar.
    pub static touchbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "touchbar".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(586.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.typed
    ///
    /// A keyed uint recording how many times the user entered a particular search mode
    /// after typing an alias. The scalar keys for local search modes entered by typing
    /// a restrict keyword will be suffixed with "keyword". For example: tabs_keyword,
    /// bookmarks_keyword, history_keyword, and actions_keyword. If instead search mode
    /// was entered by typing a restrict symbol the key will be suffixed with "symbol"
    /// (e.g. typing "%" will generate "tabs_symbol"). This metric was generated to
    /// correspond to the Legacy Telemetry scalar urlbar.searchmode.typed.
    pub static typed: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "typed".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(587.into(), meta, None)
    });

}
pub mod session_restore {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct BackupCanBeLoadedSessionFileExtra {
        pub r#can_load: Option<String>,
        pub r#loadfail_reason: Option<String>,
        pub r#path_key: Option<String>,
    }

    impl ExtraKeys for BackupCanBeLoadedSessionFileExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["can_load", "loadfail_reason", "path_key"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#can_load.and_then(|val| map.insert("can_load".into(), val.to_string()));
          self.r#loadfail_reason.and_then(|val| map.insert("loadfail_reason".into(), val.to_string()));
          self.r#path_key.and_then(|val| map.insert("path_key".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from session_restore.backup_can_be_loaded_session_file
    ///
    /// Recorded when a file is able to be successfully read on startup This event was
    /// generated to correspond to the Legacy Telemetry event
    /// session_restore.backup_can_be_loaded#session_file.
    pub static backup_can_be_loaded_session_file: Lazy<EventMetric<BackupCanBeLoadedSessionFileExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "backup_can_be_loaded_session_file".into(),
                category: "session_restore".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(588.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShutdownSuccessSessionStartupExtra {
        pub r#shutdown_ok: Option<String>,
        pub r#shutdown_reason: Option<String>,
    }

    impl ExtraKeys for ShutdownSuccessSessionStartupExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["shutdown_ok", "shutdown_reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#shutdown_ok.and_then(|val| map.insert("shutdown_ok".into(), val.to_string()));
          self.r#shutdown_reason.and_then(|val| map.insert("shutdown_reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from session_restore.shutdown_success_session_startup
    ///
    /// Report shutdown success This event was generated to correspond to the Legacy
    /// Telemetry event session_restore.shutdown_success#session_startup.
    pub static shutdown_success_session_startup: Lazy<EventMetric<ShutdownSuccessSessionStartupExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shutdown_success_session_startup".into(),
                category: "session_restore".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(589.into(), meta)
    });

}
pub mod shopping {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AddressBarFeatureCalloutDisplayedExtra {
        pub r#configuration: Option<String>,
    }

    impl ExtraKeys for AddressBarFeatureCalloutDisplayedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["configuration"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#configuration.and_then(|val| map.insert("configuration".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.address_bar_feature_callout_displayed
    ///
    /// The user was shown the feature callout for the Shopping component.
    pub static address_bar_feature_callout_displayed: Lazy<EventMetric<AddressBarFeatureCalloutDisplayedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "address_bar_feature_callout_displayed".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(590.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AddressBarIconClickedExtra {
        pub r#action: Option<String>,
    }

    impl ExtraKeys for AddressBarIconClickedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.address_bar_icon_clicked
    ///
    /// The Shopping product Address Bar Icon was clicked by the user.
    pub static address_bar_icon_clicked: Lazy<EventMetric<AddressBarIconClickedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "address_bar_icon_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(591.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.address_bar_icon_displayed
    ///
    /// The Shopping product Address Bar Icon was displayed to the user.
    pub static address_bar_icon_displayed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "address_bar_icon_displayed".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(592.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.ads_exposure
    ///
    /// On a supported product page, the review checker showed analysis, and
    /// the ads exposure pref was enabled, or review checker ads were enabled,
    /// and when we tried to fetch an ad from the ad server, an ad was available.
    /// Does not indicate whether the ad was actually shown.
    pub static ads_exposure: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ads_exposure".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(593.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.product_page_visits
    ///
    /// Counts number of visits to a supported retailer product page
    /// while enrolled in either the control or treatment branches
    /// of the shopping experiment.
    pub static product_page_visits: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            594,
            "shopping",
            "product_page_visits",
            "metrics"
        )
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceAdsClickedExtra {
        pub r#sponsored: Option<bool>,
    }

    impl ExtraKeys for SurfaceAdsClickedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["sponsored"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#sponsored.and_then(|val| map.insert("sponsored".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_ads_clicked
    ///
    /// An ad shown in the sidebar was clicked.
    pub static surface_ads_clicked: Lazy<EventMetric<SurfaceAdsClickedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_ads_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(595.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceAdsImpressionExtra {
        pub r#sponsored: Option<bool>,
    }

    impl ExtraKeys for SurfaceAdsImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["sponsored"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#sponsored.and_then(|val| map.insert("sponsored".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_ads_impression
    ///
    /// An ad was shown and visible in the sidebar for 1.5 seconds.
    pub static surface_ads_impression: Lazy<EventMetric<SurfaceAdsImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_ads_impression".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(596.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceAdsPlacementExtra {
        pub r#sponsored: Option<bool>,
    }

    impl ExtraKeys for SurfaceAdsPlacementExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["sponsored"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#sponsored.and_then(|val| map.insert("sponsored".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_ads_placement
    ///
    /// An ad unit was fetched successfully.
    pub static surface_ads_placement: Lazy<EventMetric<SurfaceAdsPlacementExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_ads_placement".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(597.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceAdsSettingToggledExtra {
        pub r#action: Option<String>,
    }

    impl ExtraKeys for SurfaceAdsSettingToggledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_ads_setting_toggled
    ///
    /// The user clicked the settings toggle to enable or disable ads in the
    /// sidebar settings component.
    pub static surface_ads_setting_toggled: Lazy<EventMetric<SurfaceAdsSettingToggledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_ads_setting_toggled".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(598.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_analyze_reviews_none_available_clicked
    ///
    /// The user clicked to analyze reviews in the case the reliability rating
    /// was not available for display in the shopping side bar. This metric
    /// does not contain any information about the product the user is viewing.
    pub static surface_analyze_reviews_none_available_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_analyze_reviews_none_available_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(599.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceAutoOpenSettingToggledExtra {
        pub r#action: Option<String>,
    }

    impl ExtraKeys for SurfaceAutoOpenSettingToggledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_auto_open_setting_toggled
    ///
    /// The user clicked the settings toggle to enable or disable auto-open in the
    /// sidebar settings component.
    pub static surface_auto_open_setting_toggled: Lazy<EventMetric<SurfaceAutoOpenSettingToggledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_auto_open_setting_toggled".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(600.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceClosedExtra {
        pub r#source: Option<String>,
    }

    impl ExtraKeys for SurfaceClosedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["source"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_closed
    ///
    /// The user opened the settings menu of the shopping component.
    pub static surface_closed: Lazy<EventMetric<SurfaceClosedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_closed".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(601.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceDisplayedExtra {
        pub r#side_bar_state: Option<String>,
    }

    impl ExtraKeys for SurfaceDisplayedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["side_bar_state"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#side_bar_state.and_then(|val| map.insert("side_bar_state".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_displayed
    ///
    /// The Shopping product Sidebar was displayed.
    pub static surface_displayed: Lazy<EventMetric<SurfaceDisplayedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_displayed".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(602.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_learn_more_clicked
    ///
    /// The user clicked the 'Learn More' link in the Shopping onboarding
    /// experience.
    pub static surface_learn_more_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_learn_more_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(603.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_no_ads_available
    ///
    /// On a supported product page, the review checker showed analysis, and
    /// review checker ads were enabled, but when we tried to fetch an ad from
    /// the ad server, no ad was available.
    pub static surface_no_ads_available: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_no_ads_available".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(604.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_no_review_reliability_available
    ///
    /// Review reliability was not available for display in the shopping side
    /// bar. This metric does not contain any information about the product
    /// the user is viewing.
    pub static surface_no_review_reliability_available: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_no_review_reliability_available".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(605.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_no_thanks_button_clicked
    ///
    /// The user clicks the 'No thanks' button when asked if they want to
    /// disable auto-open behavior.
    pub static surface_no_thanks_button_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_no_thanks_button_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(606.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_not_now_clicked
    ///
    /// The user clicked 'Not Now' to dismiss the dialog.
    pub static surface_not_now_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_not_now_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(607.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceOnboardingDisplayedExtra {
        pub r#configuration: Option<String>,
    }

    impl ExtraKeys for SurfaceOnboardingDisplayedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["configuration"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#configuration.and_then(|val| map.insert("configuration".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_onboarding_displayed
    ///
    /// The Shopping Side bar displayed the onboarding experience.
    pub static surface_onboarding_displayed: Lazy<EventMetric<SurfaceOnboardingDisplayedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_onboarding_displayed".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(608.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_opt_in_clicked
    ///
    /// The user clicked the "Yes, try it" element to use the Shopping product's
    /// functionality.
    pub static surface_opt_in_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_opt_in_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(609.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_opt_out_button_clicked
    ///
    /// The user clicked the button in the settings panel to turn off the shopping
    /// experience.
    pub static surface_opt_out_button_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_opt_out_button_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(610.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_powered_by_fakespot_link_clicked
    ///
    /// The user clicked the "Fakespot by Mozilla" link in the shopping side
    /// bar.
    pub static surface_powered_by_fakespot_link_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_powered_by_fakespot_link_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(611.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_reactivated_button_clicked
    ///
    /// The user clicked the reactivated product button.
    pub static surface_reactivated_button_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_reactivated_button_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(612.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_reanalyze_clicked
    ///
    /// The user clicked to REanalyze reviews in the shopping side bar. This
    /// metric does not contain any information about the product the user is
    /// viewing or any displayed trusted deals.
    pub static surface_reanalyze_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_reanalyze_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(613.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceSettingsExpandClickedExtra {
        pub r#action: Option<String>,
    }

    impl ExtraKeys for SurfaceSettingsExpandClickedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_settings_expand_clicked
    ///
    /// The user opened the settings menu of the shopping component.
    pub static surface_settings_expand_clicked: Lazy<EventMetric<SurfaceSettingsExpandClickedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_settings_expand_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(614.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceShowMoreReviewsButtonClickedExtra {
        pub r#action: Option<String>,
    }

    impl ExtraKeys for SurfaceShowMoreReviewsButtonClickedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_show_more_reviews_button_clicked
    ///
    /// The user clicked to expand the recent reviews to see more.
    pub static surface_show_more_reviews_button_clicked: Lazy<EventMetric<SurfaceShowMoreReviewsButtonClickedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_show_more_reviews_button_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(615.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_show_privacy_policy_clicked
    ///
    /// The user clicked to view the Privacy Policy.
    pub static surface_show_privacy_policy_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_show_privacy_policy_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(616.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceShowQualityExplainerClickedExtra {
        pub r#action: Option<String>,
    }

    impl ExtraKeys for SurfaceShowQualityExplainerClickedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_show_quality_explainer_clicked
    ///
    /// The user clicked to see the explanation of Review Quality in the
    /// shopping component.
    pub static surface_show_quality_explainer_clicked: Lazy<EventMetric<SurfaceShowQualityExplainerClickedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_show_quality_explainer_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(617.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_show_quality_explainer_url_clicked
    ///
    /// The user clicked to see the explanation of Review Quality in the
    /// shopping component.
    pub static surface_show_quality_explainer_url_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_show_quality_explainer_url_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(618.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_show_terms_clicked
    ///
    /// The user clicked to view the Terms of Service.
    pub static surface_show_terms_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_show_terms_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(619.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_stale_analysis_shown
    ///
    /// The user was shown the dialogue box indicating that analysis of a product
    /// was stale. No information about the product is included.
    pub static surface_stale_analysis_shown: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_stale_analysis_shown".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(620.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_yes_keep_closed_button_clicked
    ///
    /// The user clicks the 'Yes, keep closed' button when asked if they want to
    /// disable auto-open behavior.
    pub static surface_yes_keep_closed_button_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_yes_keep_closed_button_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(621.into(), meta)
    });

}
pub mod shopping_settings {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from shopping.settings.auto_open_user_disabled
    ///
    /// Indicates if the user has manually disabled the auto open sidebar feature.
    /// Set during shopping component init and updated when changed in browser.
    pub static auto_open_user_disabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "auto_open_user_disabled".into(),
                category: "shopping.settings".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(622.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.settings.component_opted_out
    ///
    /// Indicates if the user has opted out of using the shopping component.
    /// Set during shopping component init and updated when changed in browser.
    pub static component_opted_out: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "component_opted_out".into(),
                category: "shopping.settings".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(623.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.settings.disabled_ads
    ///
    /// Indicates if the user has manually disabled ads. Set during shopping
    /// component init and updated when changed in browser.
    pub static disabled_ads: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disabled_ads".into(),
                category: "shopping.settings".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(624.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.settings.has_onboarded
    ///
    /// Indicates if the user has completed the Shopping product Onboarding
    /// experience. Set during shopping component init and updated when changed
    /// in browser.
    pub static has_onboarded: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "has_onboarded".into(),
                category: "shopping.settings".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(625.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.settings.nimbus_disabled_shopping
    ///
    /// Indicates if Nimbus has disabled the use the shopping component.
    pub static nimbus_disabled_shopping: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "nimbus_disabled_shopping".into(),
                category: "shopping.settings".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(626.into(), meta)
    });

}
pub mod bookmarks {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarToggleExtra {
        pub r#opened: Option<bool>,
    }

    impl ExtraKeys for SidebarToggleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["opened"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#opened.and_then(|val| map.insert("opened".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from bookmarks.sidebar_toggle
    ///
    /// The Bookmarks sidebar panel was loaded or unloaded.
    pub static sidebar_toggle: Lazy<EventMetric<SidebarToggleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_toggle".into(),
                category: "bookmarks".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(627.into(), meta)
    });

}
pub mod extension {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarToggleExtra {
        pub r#addon_id: Option<String>,
        pub r#addon_name: Option<String>,
        pub r#opened: Option<bool>,
    }

    impl ExtraKeys for SidebarToggleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "addon_name", "opened"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#addon_name.and_then(|val| map.insert("addon_name".into(), val.to_string()));
          self.r#opened.and_then(|val| map.insert("opened".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extension.sidebar_toggle
    ///
    /// A sidebar extension panel was loaded or unloaded.
    pub static sidebar_toggle: Lazy<EventMetric<SidebarToggleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_toggle".into(),
                category: "extension".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(628.into(), meta)
    });

}
pub mod history {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarToggleExtra {
        pub r#opened: Option<bool>,
    }

    impl ExtraKeys for SidebarToggleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["opened"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#opened.and_then(|val| map.insert("opened".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from history.sidebar_toggle
    ///
    /// The History sidebar panel was loaded or unloaded.
    pub static sidebar_toggle: Lazy<EventMetric<SidebarToggleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_toggle".into(),
                category: "history".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(629.into(), meta)
    });

}
pub mod sidebar {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AddonIconClickExtra {
        pub r#addon_id: Option<String>,
        pub r#sidebar_open: Option<bool>,
    }

    impl ExtraKeys for AddonIconClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "sidebar_open"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#sidebar_open.and_then(|val| map.insert("sidebar_open".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.addon_icon_click
    ///
    /// An extension icon was clicked.
    pub static addon_icon_click: Lazy<EventMetric<AddonIconClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "addon_icon_click".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(630.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct BookmarksIconClickExtra {
        pub r#sidebar_open: Option<bool>,
    }

    impl ExtraKeys for BookmarksIconClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["sidebar_open"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#sidebar_open.and_then(|val| map.insert("sidebar_open".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.bookmarks_icon_click
    ///
    /// The bookmarks icon was clicked.
    pub static bookmarks_icon_click: Lazy<EventMetric<BookmarksIconClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "bookmarks_icon_click".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(631.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ChatbotIconClickExtra {
        pub r#sidebar_open: Option<bool>,
    }

    impl ExtraKeys for ChatbotIconClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["sidebar_open"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#sidebar_open.and_then(|val| map.insert("sidebar_open".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.chatbot_icon_click
    ///
    /// The chatbot icon was clicked.
    pub static chatbot_icon_click: Lazy<EventMetric<ChatbotIconClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "chatbot_icon_click".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(632.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sidebar.display_settings
    ///
    /// Setting for sidebar display (either "always" or "hide").
    pub static display_settings: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "display_settings".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(633.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sidebar.expand
    ///
    /// The sidebar was expanded.
    pub static expand: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "expand".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(634.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct HistoryIconClickExtra {
        pub r#sidebar_open: Option<bool>,
    }

    impl ExtraKeys for HistoryIconClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["sidebar_open"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#sidebar_open.and_then(|val| map.insert("sidebar_open".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.history_icon_click
    ///
    /// The history icon was clicked.
    pub static history_icon_click: Lazy<EventMetric<HistoryIconClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "history_icon_click".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(635.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sidebar.link
    ///
    /// The number of history items opened from the History sidebar. This metric was
    /// generated to correspond to the Legacy Telemetry scalar sidebar.link.
    pub static link: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "link".into(),
                    category: "sidebar".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(636.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sidebar.position_settings
    ///
    /// Setting for sidebar position (either "left" or "right").
    pub static position_settings: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "position_settings".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(637.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ResizeExtra {
        pub r#current: Option<u32>,
        pub r#percentage: Option<u32>,
        pub r#previous: Option<u32>,
    }

    impl ExtraKeys for ResizeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["current", "percentage", "previous"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#current.and_then(|val| map.insert("current".into(), val.to_string()));
          self.r#percentage.and_then(|val| map.insert("percentage".into(), val.to_string()));
          self.r#previous.and_then(|val| map.insert("previous".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.resize
    ///
    /// User resized the sidebar.
    pub static resize: Lazy<EventMetric<ResizeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "resize".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(638.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sidebar.search
    ///
    /// The number of searches from the sidebar, per view (e.g.: bookmarks, history).
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// sidebar.search.
    pub static search: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "search".into(),
                    category: "sidebar".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(639.into(), meta, None)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SyncedTabsIconClickExtra {
        pub r#sidebar_open: Option<bool>,
    }

    impl ExtraKeys for SyncedTabsIconClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["sidebar_open"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#sidebar_open.and_then(|val| map.insert("sidebar_open".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.synced_tabs_icon_click
    ///
    /// The synced tabs icon was clicked.
    pub static synced_tabs_icon_click: Lazy<EventMetric<SyncedTabsIconClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "synced_tabs_icon_click".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(640.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sidebar.tabs_layout
    ///
    /// Setting for tabs orientation (either "horizontal" or "vertical").
    pub static tabs_layout: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tabs_layout".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(641.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sidebar.width
    ///
    /// Width of the sidebar, in pixels.
    pub static width: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "width".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(642.into(), meta)
    });

}
pub mod sidebar_customize {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct BookmarksEnabledExtra {
        pub r#checked: Option<bool>,
    }

    impl ExtraKeys for BookmarksEnabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["checked"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#checked.and_then(|val| map.insert("checked".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.bookmarks_enabled
    ///
    /// User clicked on the checkbox corresponding to bookmarks on sidebar
    /// customization settings.
    pub static bookmarks_enabled: Lazy<EventMetric<BookmarksEnabledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "bookmarks_enabled".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(643.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ChatbotEnabledExtra {
        pub r#checked: Option<bool>,
    }

    impl ExtraKeys for ChatbotEnabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["checked"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#checked.and_then(|val| map.insert("checked".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.chatbot_enabled
    ///
    /// User clicked on the checkbox corresponding to chatbot on sidebar customization
    /// settings.
    pub static chatbot_enabled: Lazy<EventMetric<ChatbotEnabledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "chatbot_enabled".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(644.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.extensions_clicked
    ///
    /// User clicked on the link to go to Browser Extensions on sidebar customization
    /// settings.
    pub static extensions_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "extensions_clicked".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(645.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.firefox_settings_clicked
    ///
    /// User clicked on the link to Manage Firefox Settings on sidebar customization
    /// settings.
    pub static firefox_settings_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "firefox_settings_clicked".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(646.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct HistoryEnabledExtra {
        pub r#checked: Option<bool>,
    }

    impl ExtraKeys for HistoryEnabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["checked"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#checked.and_then(|val| map.insert("checked".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.history_enabled
    ///
    /// User clicked on the checkbox corresponding to history on sidebar customization
    /// settings.
    pub static history_enabled: Lazy<EventMetric<HistoryEnabledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "history_enabled".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(647.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.icon_click
    ///
    /// User clicked on the gear icon to customize the sidebar.
    pub static icon_click: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "icon_click".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(648.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PanelToggleExtra {
        pub r#opened: Option<bool>,
    }

    impl ExtraKeys for PanelToggleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["opened"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#opened.and_then(|val| map.insert("opened".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.panel_toggle
    ///
    /// The Customize sidebar panel was loaded or unloaded.
    pub static panel_toggle: Lazy<EventMetric<PanelToggleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "panel_toggle".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(649.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarDisplayExtra {
        pub r#preference: Option<String>,
    }

    impl ExtraKeys for SidebarDisplayExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["preference"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#preference.and_then(|val| map.insert("preference".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.sidebar_display
    ///
    /// User selected an option of when the sidebar is shown on sidebar customization
    /// settings.
    pub static sidebar_display: Lazy<EventMetric<SidebarDisplayExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_display".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(650.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarPositionExtra {
        pub r#position: Option<String>,
    }

    impl ExtraKeys for SidebarPositionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.sidebar_position
    ///
    /// User selected an option of in which side the sidebar is displayed from the
    /// sidebar customization settings.
    pub static sidebar_position: Lazy<EventMetric<SidebarPositionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_position".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(651.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SyncedTabsEnabledExtra {
        pub r#checked: Option<bool>,
    }

    impl ExtraKeys for SyncedTabsEnabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["checked"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#checked.and_then(|val| map.insert("checked".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.synced_tabs_enabled
    ///
    /// User clicked on the checkbox corresponding to synced tabs on sidebar
    /// customization settings.
    pub static synced_tabs_enabled: Lazy<EventMetric<SyncedTabsEnabledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "synced_tabs_enabled".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(652.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TabsDisplayExtra {
        pub r#checked: Option<bool>,
    }

    impl ExtraKeys for TabsDisplayExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["checked"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#checked.and_then(|val| map.insert("checked".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.tabs_display
    ///
    /// User clicked on the checkbox corresponding to hiding horizontal tabs on sidebar
    /// customization settings.
    pub static tabs_display: Lazy<EventMetric<TabsDisplayExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tabs_display".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(653.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TabsLayoutExtra {
        pub r#orientation: Option<String>,
    }

    impl ExtraKeys for TabsLayoutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["orientation"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#orientation.and_then(|val| map.insert("orientation".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.tabs_layout
    ///
    /// User selected between horizontal or vertical tabs on sidebar customization
    /// settings.
    pub static tabs_layout: Lazy<EventMetric<TabsLayoutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tabs_layout".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(654.into(), meta)
    });

}
pub mod synced_tabs {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarToggleExtra {
        pub r#opened: Option<bool>,
        pub r#synced_tabs_loaded: Option<bool>,
    }

    impl ExtraKeys for SidebarToggleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["opened", "synced_tabs_loaded"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#opened.and_then(|val| map.insert("opened".into(), val.to_string()));
          self.r#synced_tabs_loaded.and_then(|val| map.insert("synced_tabs_loaded".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from synced_tabs.sidebar_toggle
    ///
    /// The Synced Tabs sidebar panel was loaded or unloaded.
    pub static sidebar_toggle: Lazy<EventMetric<SidebarToggleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_toggle".into(),
                category: "synced_tabs".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(655.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickFxaAppMenuExtra {
        pub r#filter: Option<String>,
        pub r#tab_pos: Option<String>,
    }

    impl ExtraKeys for ClickFxaAppMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["filter", "tab_pos"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#filter.and_then(|val| map.insert("filter".into(), val.to_string()));
          self.r#tab_pos.and_then(|val| map.insert("tab_pos".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from synced_tabs.click_fxa_app_menu
    ///
    /// Record how users access and use synced tabs component This event was generated
    /// to correspond to the Legacy Telemetry event synced_tabs.click#fxa_app_menu.
    pub static click_fxa_app_menu: Lazy<EventMetric<ClickFxaAppMenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_fxa_app_menu".into(),
                category: "synced_tabs".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(656.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickFxaAvatarMenuExtra {
        pub r#filter: Option<String>,
        pub r#tab_pos: Option<String>,
    }

    impl ExtraKeys for ClickFxaAvatarMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["filter", "tab_pos"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#filter.and_then(|val| map.insert("filter".into(), val.to_string()));
          self.r#tab_pos.and_then(|val| map.insert("tab_pos".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from synced_tabs.click_fxa_avatar_menu
    ///
    /// Record how users access and use synced tabs component This event was generated
    /// to correspond to the Legacy Telemetry event synced_tabs.click#fxa_avatar_menu.
    pub static click_fxa_avatar_menu: Lazy<EventMetric<ClickFxaAvatarMenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_fxa_avatar_menu".into(),
                category: "synced_tabs".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(657.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncedTabsSidebarExtra {
        pub r#filter: Option<String>,
        pub r#tab_pos: Option<String>,
    }

    impl ExtraKeys for ClickSyncedTabsSidebarExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["filter", "tab_pos"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#filter.and_then(|val| map.insert("filter".into(), val.to_string()));
          self.r#tab_pos.and_then(|val| map.insert("tab_pos".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from synced_tabs.click_synced_tabs_sidebar
    ///
    /// Record how users access and use synced tabs component This event was generated
    /// to correspond to the Legacy Telemetry event
    /// synced_tabs.click#synced_tabs_sidebar.
    pub static click_synced_tabs_sidebar: Lazy<EventMetric<ClickSyncedTabsSidebarExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_synced_tabs_sidebar".into(),
                category: "synced_tabs".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(658.into(), meta)
    });

}
pub mod browser_ui_interaction {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.all_tabs_panel_dragstart_tab_event_count
    ///
    /// Records a count of how many times a drag event started for a tab within the All
    /// Tabs panel. This metric was generated to correspond to the Legacy Telemetry
    /// scalar browser.ui.interaction.all_tabs_panel_dragstart_tab_event_count.
    pub static all_tabs_panel_dragstart_tab_event_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            659,
            "browser.ui.interaction",
            "all_tabs_panel_dragstart_tab_event_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.all_tabs_panel_entrypoint
    ///
    /// Records a count of how many times the All Tabs Panel was opened, keyed on a
    /// string describing the entrypoint. This metric was generated to correspond to
    /// the Legacy Telemetry scalar browser.ui.interaction.all_tabs_panel_entrypoint.
    pub static all_tabs_panel_entrypoint: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "all_tabs_panel_entrypoint".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(660.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.textrecognition_error
    ///
    /// Recorded when text recognition in images fails for some unknown reason. This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.textrecognition_error.
    pub static textrecognition_error: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            661,
            "browser.ui.interaction",
            "textrecognition_error",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.app_menu
    ///
    /// Records a count of interactions with items in the app menu. See
    /// https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.app_menu.
    pub static app_menu: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "app_menu".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(662.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.bookmarks_bar
    ///
    /// Records a count of interactions with items in the bookmarks bar. See
    /// https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.bookmarks_bar.
    pub static bookmarks_bar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "bookmarks_bar".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(663.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.content_context
    ///
    /// Records a count of interactions with items in the content context menu. See
    /// https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.content_context.
    pub static content_context: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "content_context".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(664.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.menu_bar
    ///
    /// Records a count of interactions with items in the menu bar. See
    /// https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.menu_bar.
    pub static menu_bar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "menu_bar".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(665.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.nav_bar
    ///
    /// Records a count of interactions with items in the nav bar. See https://firefox-
    /// source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.nav_bar.
    pub static nav_bar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "nav_bar".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(666.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.overflow_menu
    ///
    /// Records a count of interactions with items in the overflow menu. See
    /// https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.overflow_menu.
    pub static overflow_menu: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "overflow_menu".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(667.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.pageaction_panel
    ///
    /// Records a count of interactions with page action items in the panel. See
    /// https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.pageaction_panel.
    pub static pageaction_panel: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "pageaction_panel".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(668.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.pageaction_urlbar
    ///
    /// Records a count of interactions with page action items in the url bar. See
    /// https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.pageaction_urlbar.
    pub static pageaction_urlbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "pageaction_urlbar".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(669.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.pinned_overflow_menu
    ///
    /// Records a count of interactions with items in the pinned area of the overflow
    /// menu. See https://firefox-source-
    /// docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated
    /// to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.pinned_overflow_menu.
    pub static pinned_overflow_menu: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "pinned_overflow_menu".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(670.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.preferences_pane_containers
    ///
    /// Records the items interacted with in the Containers section of preferences. See
    /// https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.preferences_paneContainers.
    pub static preferences_pane_containers: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "preferences_pane_containers".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(671.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.preferences_pane_experimental
    ///
    /// Records the items interacted with in the Experimental section of preferences.
    /// See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.preferences_paneExperimental.
    pub static preferences_pane_experimental: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "preferences_pane_experimental".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(672.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.preferences_pane_general
    ///
    /// Records the items interacted with in the General section of preferences. See
    /// https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.preferences_paneGeneral.
    pub static preferences_pane_general: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "preferences_pane_general".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(673.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.preferences_pane_home
    ///
    /// Records the items interacted with in the Home section of preferences. See
    /// https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.preferences_paneHome.
    pub static preferences_pane_home: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "preferences_pane_home".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(674.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.preferences_pane_more_from_mozilla
    ///
    /// Records the items interacted with in the More From Mozilla section of
    /// preferences. See https://firefox-source-
    /// docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated
    /// to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.preferences_paneMoreFromMozilla.
    pub static preferences_pane_more_from_mozilla: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "preferences_pane_more_from_mozilla".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(675.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.preferences_pane_privacy
    ///
    /// Records the items interacted with in the Privacy section of preferences. See
    /// https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.preferences_panePrivacy.
    pub static preferences_pane_privacy: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "preferences_pane_privacy".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(676.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.preferences_pane_search
    ///
    /// Records the items interacted with in the Search section of preferences. See
    /// https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.preferences_paneSearch.
    pub static preferences_pane_search: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "preferences_pane_search".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(677.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.preferences_pane_search_results
    ///
    /// Records the items interacted with in the Search results section of preferences.
    /// See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.preferences_paneSearchResults.
    pub static preferences_pane_search_results: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "preferences_pane_search_results".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(678.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.preferences_pane_sync
    ///
    /// Records the items interacted with in the Sync section of preferences. See
    /// https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.preferences_paneSync.
    pub static preferences_pane_sync: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "preferences_pane_sync".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(679.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.preferences_pane_unknown
    ///
    /// Records the items interacted with in any other section of preferences. See
    /// https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.preferences_paneUnknown.
    pub static preferences_pane_unknown: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "preferences_pane_unknown".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(680.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.tabs_bar
    ///
    /// Records a count of interactions with items in the tab bar. See https://firefox-
    /// source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.tabs_bar.
    pub static tabs_bar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tabs_bar".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(681.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.tabs_context
    ///
    /// Records a count of interactions with items in the tab context menu. See
    /// https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.tabs_context.
    pub static tabs_context: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tabs_context".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(682.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.tabs_context_entrypoint
    ///
    /// Records a count for each entrypoint (the container of the trigger node) when an
    /// item from the tabs context menu is selected. See https://firefox-source-
    /// docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated
    /// to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.tabs_context_entrypoint.
    pub static tabs_context_entrypoint: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tabs_context_entrypoint".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(683.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.unified_extensions_area
    ///
    /// Records a count of interactions with items in the Unified Extensions area. See
    /// https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.unified_extensions_area.
    pub static unified_extensions_area: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "unified_extensions_area".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(684.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.vertical_tabs_container
    ///
    /// Records a count of interactions with items in the vertical tab bar. See
    /// https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.vertical_tabs_container.
    pub static vertical_tabs_container: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "vertical_tabs_container".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(685.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.keyboard
    ///
    /// Records a count of interactions with keyboard shortcuts. See https://firefox-
    /// source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.interaction.keyboard.
    pub static keyboard: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "keyboard".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(686.into(), meta, None)
    });

}
pub mod quick_suggest {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.advertiser
    ///
    /// The name of the advertiser providing the sponsored TopSite.
    pub static advertiser: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "advertiser".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(687.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.block_id
    ///
    /// A unique identifier for the suggestion (a.k.a. a keywords block).
    pub static block_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "block_id".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(688.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.context_id
    ///
    /// An identifier to identify users for Contextual Services user interaction pings.
    pub static context_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "context_id".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(689.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.iab_category
    ///
    /// The suggestion's category. Either "22 - Shopping" or "5 - Educational".
    pub static iab_category: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "iab_category".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(690.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.improve_suggest_experience
    ///
    /// Whether the "Improve Suggest Experience" checkbox is checked.
    pub static improve_suggest_experience: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "improve_suggest_experience".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(691.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.is_clicked
    ///
    /// Whether this quicksuggest-impression ping was for an item that was clicked.
    pub static is_clicked: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_clicked".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(692.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.match_type
    ///
    /// Whether this was a best/top match or not. Either "best-match" or "firefox-
    /// suggest".
    pub static match_type: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "match_type".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(693.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.ping_type
    ///
    /// The ping's type. In other situations might be designated by an event's name or
    /// an interaction field. E.g. "quicksuggest-impression", "quicksuggest-block",
    /// "quicksuggest-click".
    pub static ping_type: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ping_type".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(694.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.position
    ///
    /// The position (1-based) of the QuickSuggest item being interatcted with.
    pub static position: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "position".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(695.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.reporting_url
    ///
    /// The url to report this interaction to.
    pub static reporting_url: Lazy<UrlMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reporting_url".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UrlMetric::new(696.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.request_id
    ///
    /// A request identifier for each API request to [Merino](https://mozilla-
    /// services.github.io/merino/). Only present for suggestions provided by Merino.
    pub static request_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "request_id".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(697.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.source
    ///
    /// The source of the interaction. E.g. "urlbar".
    pub static source: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "source".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(698.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.suggested_index
    ///
    /// A stringified integer value that is the intended index of the suggestion being
    /// interacted with. If `suggested_index_relative_to_group` is true, the index is
    /// relative to the "Firefox Suggest" group; otherwise the index is relative to the
    /// entire list of suggestions. Non-negative values (starting at 0) are relative to
    /// the start/top of the group/list; negative values are relative to the end/bottom
    /// of the group/list.
    pub static suggested_index: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "suggested_index".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(699.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.suggested_index_relative_to_group
    ///
    /// Whether `suggested_index` is relative to the "Firefox Suggest" group. If false,
    /// it is relative to the entire list of suggestions.
    pub static suggested_index_relative_to_group: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "suggested_index_relative_to_group".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(700.into(), meta)
    });

}
pub mod suggest {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum IngestDownloadTimeLabel {
        EIcon = 0,
        EData = 1,
        EAmoSuggestions = 2,
        EPocketSuggestions = 3,
        EYelpSuggestions = 4,
        EMdnSuggestions = 5,
        EWeather = 6,
        EConfiguration = 7,
        EAmpMobileSuggestions = 8,
        EFakespotSuggestions = 9,
        __Other__,
    }
    impl From<u16> for IngestDownloadTimeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EIcon,
                1 => Self::EData,
                2 => Self::EAmoSuggestions,
                3 => Self::EPocketSuggestions,
                4 => Self::EYelpSuggestions,
                5 => Self::EMdnSuggestions,
                6 => Self::EWeather,
                7 => Self::EConfiguration,
                8 => Self::EAmpMobileSuggestions,
                9 => Self::EFakespotSuggestions,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for IngestDownloadTimeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EIcon => "icon",
                Self::EData => "data",
                Self::EAmoSuggestions => "amo-suggestions",
                Self::EPocketSuggestions => "pocket-suggestions",
                Self::EYelpSuggestions => "yelp-suggestions",
                Self::EMdnSuggestions => "mdn-suggestions",
                Self::EWeather => "weather",
                Self::EConfiguration => "configuration",
                Self::EAmpMobileSuggestions => "amp-mobile-suggestions",
                Self::EFakespotSuggestions => "fakespot-suggestions",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from suggest.ingest_download_time
    ///
    /// Download time for ingestion, labelled by record type
    pub static ingest_download_time: Lazy<LabeledMetric<LabeledTimingDistributionMetric, IngestDownloadTimeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "ingest_download_time".into(),
                    category: "suggest".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Microsecond};
        LabeledMetric::new(701.into(), meta, Some(vec![::std::borrow::Cow::from("amo-suggestions"), ::std::borrow::Cow::from("amp-mobile-suggestions"), ::std::borrow::Cow::from("configuration"), ::std::borrow::Cow::from("data"), ::std::borrow::Cow::from("fakespot-suggestions"), ::std::borrow::Cow::from("icon"), ::std::borrow::Cow::from("mdn-suggestions"), ::std::borrow::Cow::from("pocket-suggestions"), ::std::borrow::Cow::from("weather"), ::std::borrow::Cow::from("yelp-suggestions")]))
    });

    #[repr(u16)]
    pub enum IngestTimeLabel {
        EIcon = 0,
        EData = 1,
        EAmoSuggestions = 2,
        EPocketSuggestions = 3,
        EYelpSuggestions = 4,
        EMdnSuggestions = 5,
        EWeather = 6,
        EConfiguration = 7,
        EAmpMobileSuggestions = 8,
        EFakespotSuggestions = 9,
        __Other__,
    }
    impl From<u16> for IngestTimeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EIcon,
                1 => Self::EData,
                2 => Self::EAmoSuggestions,
                3 => Self::EPocketSuggestions,
                4 => Self::EYelpSuggestions,
                5 => Self::EMdnSuggestions,
                6 => Self::EWeather,
                7 => Self::EConfiguration,
                8 => Self::EAmpMobileSuggestions,
                9 => Self::EFakespotSuggestions,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for IngestTimeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EIcon => "icon",
                Self::EData => "data",
                Self::EAmoSuggestions => "amo-suggestions",
                Self::EPocketSuggestions => "pocket-suggestions",
                Self::EYelpSuggestions => "yelp-suggestions",
                Self::EMdnSuggestions => "mdn-suggestions",
                Self::EWeather => "weather",
                Self::EConfiguration => "configuration",
                Self::EAmpMobileSuggestions => "amp-mobile-suggestions",
                Self::EFakespotSuggestions => "fakespot-suggestions",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from suggest.ingest_time
    ///
    /// Time for ingestion (excluding download time), labelled by record type
    pub static ingest_time: Lazy<LabeledMetric<LabeledTimingDistributionMetric, IngestTimeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "ingest_time".into(),
                    category: "suggest".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Microsecond};
        LabeledMetric::new(702.into(), meta, Some(vec![::std::borrow::Cow::from("amo-suggestions"), ::std::borrow::Cow::from("amp-mobile-suggestions"), ::std::borrow::Cow::from("configuration"), ::std::borrow::Cow::from("data"), ::std::borrow::Cow::from("fakespot-suggestions"), ::std::borrow::Cow::from("icon"), ::std::borrow::Cow::from("mdn-suggestions"), ::std::borrow::Cow::from("pocket-suggestions"), ::std::borrow::Cow::from("weather"), ::std::borrow::Cow::from("yelp-suggestions")]))
    });

    #[repr(u16)]
    pub enum QueryTimeLabel {
        EAmp = 0,
        EAmpmobile = 1,
        EWikipedia = 2,
        EAmo = 3,
        EPocket = 4,
        EYelp = 5,
        EMdn = 6,
        EWeather = 7,
        EFakespot = 8,
        __Other__,
    }
    impl From<u16> for QueryTimeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAmp,
                1 => Self::EAmpmobile,
                2 => Self::EWikipedia,
                3 => Self::EAmo,
                4 => Self::EPocket,
                5 => Self::EYelp,
                6 => Self::EMdn,
                7 => Self::EWeather,
                8 => Self::EFakespot,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for QueryTimeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAmp => "amp",
                Self::EAmpmobile => "ampmobile",
                Self::EWikipedia => "wikipedia",
                Self::EAmo => "amo",
                Self::EPocket => "pocket",
                Self::EYelp => "yelp",
                Self::EMdn => "mdn",
                Self::EWeather => "weather",
                Self::EFakespot => "fakespot",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from suggest.query_time
    ///
    /// Time executing queries, labelled by provider type
    pub static query_time: Lazy<LabeledMetric<LabeledTimingDistributionMetric, QueryTimeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "query_time".into(),
                    category: "suggest".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Microsecond};
        LabeledMetric::new(703.into(), meta, Some(vec![::std::borrow::Cow::from("amo"), ::std::borrow::Cow::from("amp"), ::std::borrow::Cow::from("ampmobile"), ::std::borrow::Cow::from("fakespot"), ::std::borrow::Cow::from("mdn"), ::std::borrow::Cow::from("pocket"), ::std::borrow::Cow::from("weather"), ::std::borrow::Cow::from("wikipedia"), ::std::borrow::Cow::from("yelp")]))
    });

}
pub mod suggest_relevance {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum OutcomeLabel {
        EBoosted = 0,
        EDecreased = 1,
        __Other__,
    }
    impl From<u16> for OutcomeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EBoosted,
                1 => Self::EDecreased,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for OutcomeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EBoosted => "boosted",
                Self::EDecreased => "decreased",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from suggest_relevance.outcome
    ///
    /// For each successful scoring, count whether the relevance score gets boosted or
    /// decreased over the original score. Note that given how the score is calculated,
    /// it's practically impossible to have the two scores tied. If that's the case
    /// anyhow, it will increment the "boosted" counter.
    pub static outcome: Lazy<LabeledMetric<LabeledCounterMetric, OutcomeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "outcome".into(),
                    category: "suggest_relevance".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(704.into(), meta, Some(vec![::std::borrow::Cow::from("boosted"), ::std::borrow::Cow::from("decreased")]))
    });

    #[repr(u16)]
    pub enum StatusLabel {
        ESuccess = 0,
        EFailure = 1,
        __Other__,
    }
    impl From<u16> for StatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EFailure,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for StatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EFailure => "failure",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from suggest_relevance.status
    ///
    /// Count the successful / failed attempts of relevance scoring in Firefox Suggest.
    pub static status: Lazy<LabeledMetric<LabeledCounterMetric, StatusLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "status".into(),
                    category: "suggest_relevance".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(705.into(), meta, Some(vec![::std::borrow::Cow::from("failure"), ::std::borrow::Cow::from("success")]))
    });

}
pub mod urlbar {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AbandonmentExtra {
        pub r#abandonment_type: Option<String>,
        pub r#actions: Option<String>,
        pub r#groups: Option<String>,
        pub r#interaction: Option<String>,
        pub r#n_chars: Option<u32>,
        pub r#n_results: Option<u32>,
        pub r#n_words: Option<u32>,
        pub r#results: Option<String>,
        pub r#sap: Option<String>,
        pub r#search_engine_default_id: Option<String>,
        pub r#search_mode: Option<String>,
    }

    impl ExtraKeys for AbandonmentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["abandonment_type", "actions", "groups", "interaction", "n_chars", "n_results", "n_words", "results", "sap", "search_engine_default_id", "search_mode"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#abandonment_type.and_then(|val| map.insert("abandonment_type".into(), val.to_string()));
          self.r#actions.and_then(|val| map.insert("actions".into(), val.to_string()));
          self.r#groups.and_then(|val| map.insert("groups".into(), val.to_string()));
          self.r#interaction.and_then(|val| map.insert("interaction".into(), val.to_string()));
          self.r#n_chars.and_then(|val| map.insert("n_chars".into(), val.to_string()));
          self.r#n_results.and_then(|val| map.insert("n_results".into(), val.to_string()));
          self.r#n_words.and_then(|val| map.insert("n_words".into(), val.to_string()));
          self.r#results.and_then(|val| map.insert("results".into(), val.to_string()));
          self.r#sap.and_then(|val| map.insert("sap".into(), val.to_string()));
          self.r#search_engine_default_id.and_then(|val| map.insert("search_engine_default_id".into(), val.to_string()));
          self.r#search_mode.and_then(|val| map.insert("search_mode".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.abandonment
    ///
    /// Recorded when the user abandons a search (blurring the urlbar).
    pub static abandonment: Lazy<EventMetric<AbandonmentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "abandonment".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(706.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EngagementExtra {
        pub r#actions: Option<String>,
        pub r#engagement_type: Option<String>,
        pub r#groups: Option<String>,
        pub r#interaction: Option<String>,
        pub r#n_chars: Option<u32>,
        pub r#n_results: Option<u32>,
        pub r#n_words: Option<u32>,
        pub r#provider: Option<String>,
        pub r#results: Option<String>,
        pub r#sap: Option<String>,
        pub r#search_engine_default_id: Option<String>,
        pub r#search_mode: Option<String>,
        pub r#selected_position: Option<u32>,
        pub r#selected_result: Option<String>,
    }

    impl ExtraKeys for EngagementExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["actions", "engagement_type", "groups", "interaction", "n_chars", "n_results", "n_words", "provider", "results", "sap", "search_engine_default_id", "search_mode", "selected_position", "selected_result"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#actions.and_then(|val| map.insert("actions".into(), val.to_string()));
          self.r#engagement_type.and_then(|val| map.insert("engagement_type".into(), val.to_string()));
          self.r#groups.and_then(|val| map.insert("groups".into(), val.to_string()));
          self.r#interaction.and_then(|val| map.insert("interaction".into(), val.to_string()));
          self.r#n_chars.and_then(|val| map.insert("n_chars".into(), val.to_string()));
          self.r#n_results.and_then(|val| map.insert("n_results".into(), val.to_string()));
          self.r#n_words.and_then(|val| map.insert("n_words".into(), val.to_string()));
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#results.and_then(|val| map.insert("results".into(), val.to_string()));
          self.r#sap.and_then(|val| map.insert("sap".into(), val.to_string()));
          self.r#search_engine_default_id.and_then(|val| map.insert("search_engine_default_id".into(), val.to_string()));
          self.r#search_mode.and_then(|val| map.insert("search_mode".into(), val.to_string()));
          self.r#selected_position.and_then(|val| map.insert("selected_position".into(), val.to_string()));
          self.r#selected_result.and_then(|val| map.insert("selected_result".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.engagement
    ///
    /// Recorded when the user executes an action on a result.
    pub static engagement: Lazy<EventMetric<EngagementExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "engagement".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(707.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExposureExtra {
        pub r#results: Option<String>,
        pub r#terminal: Option<String>,
    }

    impl ExtraKeys for ExposureExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["results", "terminal"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#results.and_then(|val| map.insert("results".into(), val.to_string()));
          self.r#terminal.and_then(|val| map.insert("terminal".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.exposure
    ///
    /// Recorded when client is exposed to urlbar experiment results.
    pub static exposure: Lazy<EventMetric<ExposureExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exposure".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(708.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FakespotEngagementExtra {
        pub r#grade: Option<String>,
        pub r#provider: Option<String>,
        pub r#rating: Option<String>,
    }

    impl ExtraKeys for FakespotEngagementExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["grade", "provider", "rating"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#grade.and_then(|val| map.insert("grade".into(), val.to_string()));
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#rating.and_then(|val| map.insert("rating".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.fakespot_engagement
    ///
    /// Recorded when the user engages with a Fakespot suggestion.
    pub static fakespot_engagement: Lazy<EventMetric<FakespotEngagementExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fakespot_engagement".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(709.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct KeywordExposureExtra {
        pub r#keyword: Option<String>,
        pub r#result: Option<String>,
        pub r#terminal: Option<bool>,
    }

    impl ExtraKeys for KeywordExposureExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["keyword", "result", "terminal"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#keyword.and_then(|val| map.insert("keyword".into(), val.to_string()));
          self.r#result.and_then(|val| map.insert("result".into(), val.to_string()));
          self.r#terminal.and_then(|val| map.insert("terminal".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.keyword_exposure
    ///
    /// When keyword exposures are enabled, this event is recorded in the `urlbar-
    /// keyword-exposure` ping, which is submitted at the end of urlbar sessions during
    /// which one or more exposure results are matched. The ping will contain one
    /// `keyword_exposure` event for each instance where a result is matched during the
    /// session. See the `urlbar-keyword-exposure` ping for details.
    pub static keyword_exposure: Lazy<EventMetric<KeywordExposureExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "keyword_exposure".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["urlbar-keyword-exposure".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(710.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.pref_max_results
    ///
    /// Maximum results to show in the Address Bar. Corresponds to the value of the
    /// `browser.urlbar.maxRichResults` pref.
    pub static pref_max_results: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_max_results".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(711.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.pref_suggest_data_collection
    ///
    /// Whether the user has opted in to data collection for Firefox Suggest, i.e.,
    /// online suggestions served from Merino. Corresponds to the value of the
    /// `browser.urlbar.quicksuggest.dataCollection.enabled` pref.
    pub static pref_suggest_data_collection: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_suggest_data_collection".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(712.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.pref_suggest_nonsponsored
    ///
    /// Whether non-sponsored quick suggest results are shown in the urlbar.
    /// Corresponds to the value of the
    /// `browser.urlbar.suggest.quicksuggest.nonsponsored` pref.
    pub static pref_suggest_nonsponsored: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_suggest_nonsponsored".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(713.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.pref_suggest_sponsored
    ///
    /// Whether sponsored quick suggest results are shown in the urlbar. Corresponds to
    /// the value of the `browser.urlbar.suggest.quicksuggest.sponsored` pref.
    pub static pref_suggest_sponsored: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_suggest_sponsored".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(714.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.pref_suggest_topsites
    ///
    /// Whether topsite results are enabled in the urlbar. Corresponds to the value of
    /// the `browser.urlbar.suggest.topsites` pref.
    pub static pref_suggest_topsites: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_suggest_topsites".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(715.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct QuickSuggestContextualOptInExtra {
        pub r#interaction: Option<String>,
        pub r#say_hello: Option<bool>,
        pub r#top_position: Option<bool>,
    }

    impl ExtraKeys for QuickSuggestContextualOptInExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["interaction", "say_hello", "top_position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#interaction.and_then(|val| map.insert("interaction".into(), val.to_string()));
          self.r#say_hello.and_then(|val| map.insert("say_hello".into(), val.to_string()));
          self.r#top_position.and_then(|val| map.insert("top_position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.quick_suggest_contextual_opt_in
    ///
    /// Recorded when the contextual opt-in UI is shown or interacted with.
    pub static quick_suggest_contextual_opt_in: Lazy<EventMetric<QuickSuggestContextualOptInExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "quick_suggest_contextual_opt_in".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(716.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.quick_suggest_ingest_time
    ///
    /// Counts how long each successful ingest takes in the Firefox Suggest Rust
    /// component. Ingests that fail for whatever reason are not included.
    pub static quick_suggest_ingest_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "quick_suggest_ingest_time".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(717.into(), meta, TimeUnit::Millisecond)
    });

}
pub mod addons_search_detection {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EtldChangeOtherExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#from: Option<String>,
        pub r#to: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EtldChangeOtherExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "from", "to", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#from.and_then(|val| map.insert("from".into(), val.to_string()));
          self.r#to.and_then(|val| map.insert("to".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons.search_detection.etld_change_other
    ///
    /// Recorded when a request for a search query is redirected to another
    /// domain via something other than the `webRequest` API.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// addonsSearchDetection.etld_change#other.
    pub static etld_change_other: Lazy<EventMetric<EtldChangeOtherExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "etld_change_other".into(),
                category: "addons.search_detection".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(718.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EtldChangeWebrequestExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#from: Option<String>,
        pub r#to: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EtldChangeWebrequestExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "from", "to", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#from.and_then(|val| map.insert("from".into(), val.to_string()));
          self.r#to.and_then(|val| map.insert("to".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons.search_detection.etld_change_webrequest
    ///
    /// Recorded when a request for a search query is redirected to another
    /// domain via the `webRequest` API.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// addonsSearchDetection.etld_change#webrequest.
    pub static etld_change_webrequest: Lazy<EventMetric<EtldChangeWebrequestExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "etld_change_webrequest".into(),
                category: "addons.search_detection".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(719.into(), meta)
    });

}
pub mod browser_engagement {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.active_ticks
    ///
    /// The number of five-second intervals ('ticks') the user was considered
    /// 'active'.
    /// 
    /// 'active' means keyboard or mouse interaction with the application.
    /// It doesn't take into account whether or not the window has focus or is in
    /// the foreground, only if it is receiving these interaction events.
    /// 
    /// Migrated from Telemetry's `browser.engagement.active_ticks`.
    pub static active_ticks: Lazy<CounterMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "active_ticks".into(),
                category: "browser.engagement".into(),
                send_in_pings: vec!["baseline".into(), "dau-reporting".into(), "metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CounterMetric::new(720.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.profile_count
    ///
    /// Windows only count of the browser profiles on the current system. This
    /// counts profiles that have been used across all Windows user accounts on
    /// machine since this probe was added. The value persists across installs.
    /// A value of 0 is reported if there is an error determining the correct
    /// count. Unset on other platforms.
    pub static profile_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "profile_count".into(),
                category: "browser.engagement".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(721.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.uri_count
    ///
    /// The number of total non-unique http(s) URIs visited, including page
    /// reloads, after the session has been restored. URIs on minimized or
    /// background tabs may also be counted. Private browsing uris are included.
    /// 
    /// Migrated from Telemetry's
    /// `browser.engagement.total_uri_count_normal_and_private_mode`.
    pub static uri_count: Lazy<CounterMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uri_count".into(),
                category: "browser.engagement".into(),
                send_in_pings: vec!["baseline".into(), "dau-reporting".into(), "metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CounterMetric::new(722.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.uri_count_normal_mode
    ///
    /// The count of the total non-unique http(s) URIs visited in a subsession,
    /// including page reloads, after the session has been restored. URIs on minimized
    /// or background tabs may also be counted towards this. Private browsing is not
    /// included in this count. This metric was generated to correspond to the Legacy
    /// Telemetry scalar browser.engagement.total_uri_count.
    pub static uri_count_normal_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            723,
            "browser.engagement",
            "uri_count_normal_mode",
            "metrics"
        )
    });

}
pub mod browser_ui {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.customized_widgets
    ///
    /// Records when widgets are added, removed or moved in the UI. See
    /// https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// browser.ui.customized_widgets.
    pub static customized_widgets: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "customized_widgets".into(),
                    category: "browser.ui".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(724.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.mirror_for_toolbar_widgets
    ///
    /// The widgets in the toolbars. See https://firefox-source-
    /// docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated
    /// to correspond to the Legacy Telemetry scalar browser.ui.toolbar_widgets.
    pub static mirror_for_toolbar_widgets: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mirror_for_toolbar_widgets".into(),
                    category: "browser.ui".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(725.into(), meta, None)
    });

        pub type ToolbarWidgetsObject = Vec<ToolbarWidgetsObjectItem>;

        #[derive(Debug, Hash, Eq, PartialEq, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct ToolbarWidgetsObjectItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub position: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub widgetId: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.toolbar_widgets
    ///
    /// What widgets are in which toolbars. Not dissimilar from Telemetry's
    /// `browser.ui.toolbar_widgets`, but in a friendlier format. See https://firefox-
    /// source-docs.mozilla.org/browser/BrowserUsageTelemetry.html for how widget ids
    /// and positions are determined.
    pub static toolbar_widgets: Lazy<ObjectMetric<ToolbarWidgetsObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "toolbar_widgets".into(),
                category: "browser.ui".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(726.into(), meta)
    });

}
pub mod browser_usage {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InteractionExtra {
        pub r#flow_id: Option<String>,
        pub r#source: Option<String>,
        pub r#widget_id: Option<String>,
    }

    impl ExtraKeys for InteractionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "source", "widget_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#widget_id.and_then(|val| map.insert("widget_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.usage.interaction
    ///
    /// The user interacted with something in the Firefox Desktop frontend. Could be
    /// via mouse or keyboard, could be a command or a UI element.
    pub static interaction: Lazy<EventMetric<InteractionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "interaction".into(),
                category: "browser.usage".into(),
                send_in_pings: vec!["prototype-no-code-events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(727.into(), meta)
    });

}
pub mod homepage {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PreferenceIgnoreExtra {
        pub r#value: Option<String>,
        pub r#webExtensionId: Option<String>,
    }

    impl ExtraKeys for PreferenceIgnoreExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value", "webExtensionId"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#webExtensionId.and_then(|val| map.insert("webExtensionId".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from homepage.preference_ignore
    ///
    /// This is recorded whenever the homepage preference is either reset due to being
    /// on the ignore list, or setting is blocked due to being on the same list. The
    /// value field records the reason for the ignore. "saved_reset" for when a saved
    /// preference value is reset. "set_blocked" for when the setting was blocked and
    /// "set_blocked_extension" for when we know a WebExtension attempting to set it
    /// was blocked. This event was generated to correspond to the Legacy Telemetry
    /// event homepage.preference#ignore.
    pub static preference_ignore: Lazy<EventMetric<PreferenceIgnoreExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "preference_ignore".into(),
                category: "homepage".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(728.into(), meta)
    });

}
pub mod installation {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FirstSeenFullExtra {
        pub r#admin_user: Option<String>,
        pub r#build_id: Option<String>,
        pub r#default_path: Option<String>,
        pub r#from_msi: Option<String>,
        pub r#install_existed: Option<String>,
        pub r#other_inst: Option<String>,
        pub r#other_msix_inst: Option<String>,
        pub r#profdir_existed: Option<String>,
        pub r#silent: Option<String>,
        pub r#version: Option<String>,
    }

    impl ExtraKeys for FirstSeenFullExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["admin_user", "build_id", "default_path", "from_msi", "install_existed", "other_inst", "other_msix_inst", "profdir_existed", "silent", "version"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#admin_user.and_then(|val| map.insert("admin_user".into(), val.to_string()));
          self.r#build_id.and_then(|val| map.insert("build_id".into(), val.to_string()));
          self.r#default_path.and_then(|val| map.insert("default_path".into(), val.to_string()));
          self.r#from_msi.and_then(|val| map.insert("from_msi".into(), val.to_string()));
          self.r#install_existed.and_then(|val| map.insert("install_existed".into(), val.to_string()));
          self.r#other_inst.and_then(|val| map.insert("other_inst".into(), val.to_string()));
          self.r#other_msix_inst.and_then(|val| map.insert("other_msix_inst".into(), val.to_string()));
          self.r#profdir_existed.and_then(|val| map.insert("profdir_existed".into(), val.to_string()));
          self.r#silent.and_then(|val| map.insert("silent".into(), val.to_string()));
          self.r#version.and_then(|val| map.insert("version".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen_full
    ///
    /// Recorded after the application has been installed or reinstalled, the first
    /// time that a profile sees that there was a new installation. This includes
    /// information about how the installer was run. This event was generated to
    /// correspond to the Legacy Telemetry event installation.first_seen#full.
    pub static first_seen_full: Lazy<EventMetric<FirstSeenFullExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "first_seen_full".into(),
                category: "installation".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(729.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FirstSeenMsixExtra {
        pub r#admin_user: Option<String>,
        pub r#build_id: Option<String>,
        pub r#default_path: Option<String>,
        pub r#from_msi: Option<String>,
        pub r#install_existed: Option<String>,
        pub r#other_inst: Option<String>,
        pub r#other_msix_inst: Option<String>,
        pub r#profdir_existed: Option<String>,
        pub r#silent: Option<String>,
        pub r#version: Option<String>,
    }

    impl ExtraKeys for FirstSeenMsixExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["admin_user", "build_id", "default_path", "from_msi", "install_existed", "other_inst", "other_msix_inst", "profdir_existed", "silent", "version"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#admin_user.and_then(|val| map.insert("admin_user".into(), val.to_string()));
          self.r#build_id.and_then(|val| map.insert("build_id".into(), val.to_string()));
          self.r#default_path.and_then(|val| map.insert("default_path".into(), val.to_string()));
          self.r#from_msi.and_then(|val| map.insert("from_msi".into(), val.to_string()));
          self.r#install_existed.and_then(|val| map.insert("install_existed".into(), val.to_string()));
          self.r#other_inst.and_then(|val| map.insert("other_inst".into(), val.to_string()));
          self.r#other_msix_inst.and_then(|val| map.insert("other_msix_inst".into(), val.to_string()));
          self.r#profdir_existed.and_then(|val| map.insert("profdir_existed".into(), val.to_string()));
          self.r#silent.and_then(|val| map.insert("silent".into(), val.to_string()));
          self.r#version.and_then(|val| map.insert("version".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen_msix
    ///
    /// Recorded after the application has been installed or reinstalled, the first
    /// time that a profile sees that there was a new installation. This includes
    /// information about how the installer was run. This event was generated to
    /// correspond to the Legacy Telemetry event installation.first_seen#msix.
    pub static first_seen_msix: Lazy<EventMetric<FirstSeenMsixExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "first_seen_msix".into(),
                category: "installation".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(730.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FirstSeenStubExtra {
        pub r#admin_user: Option<String>,
        pub r#build_id: Option<String>,
        pub r#default_path: Option<String>,
        pub r#from_msi: Option<String>,
        pub r#install_existed: Option<String>,
        pub r#other_inst: Option<String>,
        pub r#other_msix_inst: Option<String>,
        pub r#profdir_existed: Option<String>,
        pub r#silent: Option<String>,
        pub r#version: Option<String>,
    }

    impl ExtraKeys for FirstSeenStubExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["admin_user", "build_id", "default_path", "from_msi", "install_existed", "other_inst", "other_msix_inst", "profdir_existed", "silent", "version"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#admin_user.and_then(|val| map.insert("admin_user".into(), val.to_string()));
          self.r#build_id.and_then(|val| map.insert("build_id".into(), val.to_string()));
          self.r#default_path.and_then(|val| map.insert("default_path".into(), val.to_string()));
          self.r#from_msi.and_then(|val| map.insert("from_msi".into(), val.to_string()));
          self.r#install_existed.and_then(|val| map.insert("install_existed".into(), val.to_string()));
          self.r#other_inst.and_then(|val| map.insert("other_inst".into(), val.to_string()));
          self.r#other_msix_inst.and_then(|val| map.insert("other_msix_inst".into(), val.to_string()));
          self.r#profdir_existed.and_then(|val| map.insert("profdir_existed".into(), val.to_string()));
          self.r#silent.and_then(|val| map.insert("silent".into(), val.to_string()));
          self.r#version.and_then(|val| map.insert("version".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen_stub
    ///
    /// Recorded after the application has been installed or reinstalled, the first
    /// time that a profile sees that there was a new installation. This includes
    /// information about how the installer was run. This event was generated to
    /// correspond to the Legacy Telemetry event installation.first_seen#stub.
    pub static first_seen_stub: Lazy<EventMetric<FirstSeenStubExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "first_seen_stub".into(),
                category: "installation".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(731.into(), meta)
    });

}
pub mod installation_first_seen {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.admin_user
    ///
    /// Whether the installer is running from an elevated admin user
    pub static admin_user: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "admin_user".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(732.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.default_path
    ///
    /// (optional, present if installer_type is "full") Whether the default path was
    /// used
    pub static default_path: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "default_path".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(733.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.failure_reason
    ///
    /// Only sent if unable to collect firstSeen data. Can have value "NotFoundError"
    /// if file not found or other values depending on the failure reason.
    pub static failure_reason: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "failure_reason".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(734.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.from_msi
    ///
    /// (optional, present if installer_type is "full") Whether this was an MSI install
    pub static from_msi: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "from_msi".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(735.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.install_existed
    ///
    /// Whether there was already an install in this location
    pub static install_existed: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_existed".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(736.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.installer_type
    ///
    /// The type of installer used to install Firefox. The value is one of "stub",
    /// "full", or "msix"
    pub static installer_type: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "installer_type".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(737.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.other_inst
    ///
    /// Whether there was already any non-MSIX install on this system
    pub static other_inst: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "other_inst".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(738.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.other_msix_inst
    ///
    /// Whether there was already any MSIX install on this system
    pub static other_msix_inst: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "other_msix_inst".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(739.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.profdir_existed
    ///
    /// Whether the top-level profile directory existed
    pub static profdir_existed: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "profdir_existed".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(740.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.silent
    ///
    /// (optional, present if installer_type is "full") Whether this was a silent
    /// install
    pub static silent: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "silent".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(741.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.version
    ///
    /// The application version installed by the installer (not necessarily the current
    /// version)
    pub static version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "version".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(742.into(), meta)
    });

}
pub mod partner_link {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AttributionAbortExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AttributionAbortExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from partner_link.attribution_abort
    ///
    /// This is recorded when sending an attribution request for a partner link. The
    /// value is the partner. This event was generated to correspond to the Legacy
    /// Telemetry event partner_link.attribution#abort.
    pub static attribution_abort: Lazy<EventMetric<AttributionAbortExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "attribution_abort".into(),
                category: "partner_link".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(743.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AttributionFailureExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AttributionFailureExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from partner_link.attribution_failure
    ///
    /// This is recorded when sending an attribution request for a partner link. The
    /// value is the partner. This event was generated to correspond to the Legacy
    /// Telemetry event partner_link.attribution#failure.
    pub static attribution_failure: Lazy<EventMetric<AttributionFailureExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "attribution_failure".into(),
                category: "partner_link".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(744.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AttributionSuccessExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AttributionSuccessExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from partner_link.attribution_success
    ///
    /// This is recorded when sending an attribution request for a partner link. The
    /// value is the partner. This event was generated to correspond to the Legacy
    /// Telemetry event partner_link.attribution#success.
    pub static attribution_success: Lazy<EventMetric<AttributionSuccessExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "attribution_success".into(),
                category: "partner_link".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(745.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickNewtabExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickNewtabExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from partner_link.click_newtab
    ///
    /// This is recorded when clicking a partner link. The value is the partner. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// partner_link.click#newtab.
    pub static click_newtab: Lazy<EventMetric<ClickNewtabExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_newtab".into(),
                category: "partner_link".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(746.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickUrlbarExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickUrlbarExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from partner_link.click_urlbar
    ///
    /// This is recorded when clicking a partner link. The value is the partner. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// partner_link.click#urlbar.
    pub static click_urlbar: Lazy<EventMetric<ClickUrlbarExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_urlbar".into(),
                category: "partner_link".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(747.into(), meta)
    });

}
pub mod performance_interaction {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from performance.interaction.tab_switch_composite
    ///
    /// Time between tab selection and first composite of the tab content onto the
    /// screen. (Migrated from the geckoview metric of the same name.)
    pub static tab_switch_composite: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tab_switch_composite".into(),
                category: "performance.interaction".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(748.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.interaction.keypress_present_latency
    ///
    /// Time between receiving a keypress event in the event loop and compositing its
    /// result onto the screen. (Migrated from the geckoview metric of the same name).
    pub static keypress_present_latency: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "keypress_present_latency".into(),
                category: "performance.interaction".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(749.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.interaction.mouseup_click_present_latency
    ///
    /// Time between receiving a mouseup which follow by a mouseclick on the event loop
    /// and compositing its result onto the screen. (Migrated from the geckoview metric
    /// of the same name).
    pub static mouseup_click_present_latency: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mouseup_click_present_latency".into(),
                category: "performance.interaction".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(750.into(), meta, TimeUnit::Millisecond)
    });

}
pub mod devtools_main {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ActivateResponsiveDesignExtra {
        pub r#host: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ActivateResponsiveDesignExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.activate_responsive_design
    ///
    /// User activates the responsive_design or split_console in the devtools toolbox.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// devtools.main.activate#responsive_design.
    pub static activate_responsive_design: Lazy<EventMetric<ActivateResponsiveDesignExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "activate_responsive_design".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(751.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ActivateSplitConsoleExtra {
        pub r#host: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ActivateSplitConsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.activate_split_console
    ///
    /// User activates the responsive_design or split_console in the devtools toolbox.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// devtools.main.activate#split_console.
    pub static activate_split_console: Lazy<EventMetric<ActivateSplitConsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "activate_split_console".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(752.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AddBreakpointDebuggerExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AddBreakpointDebuggerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.add_breakpoint_debugger
    ///
    /// User has added a breakpoint to a script. This event was generated to correspond
    /// to the Legacy Telemetry event devtools.main.add_breakpoint#debugger.
    pub static add_breakpoint_debugger: Lazy<EventMetric<AddBreakpointDebuggerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "add_breakpoint_debugger".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(753.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct BlackboxDebuggerExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for BlackboxDebuggerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.blackbox_debugger
    ///
    /// User clicked the blackbox button to blackbox a script. This event was generated
    /// to correspond to the Legacy Telemetry event devtools.main.blackbox#debugger.
    pub static blackbox_debugger: Lazy<EventMetric<BlackboxDebuggerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "blackbox_debugger".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(754.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CloseAdbgAboutdebuggingExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for CloseAdbgAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.close_adbg_aboutdebugging
    ///
    /// User closes about:debugging. This event was generated to correspond to the
    /// Legacy Telemetry event devtools.main.close_adbg#aboutdebugging.
    pub static close_adbg_aboutdebugging: Lazy<EventMetric<CloseAdbgAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "close_adbg_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(755.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CloseToolsExtra {
        pub r#host: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for CloseToolsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.close_tools
    ///
    /// User closes devtools toolbox. This event was generated to correspond to the
    /// Legacy Telemetry event devtools.main.close#tools.
    pub static close_tools: Lazy<EventMetric<CloseToolsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "close_tools".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(756.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ConnectionAttemptAboutdebuggingExtra {
        pub r#connection_id: Option<String>,
        pub r#connection_type: Option<String>,
        pub r#runtime_id: Option<String>,
        pub r#session_id: Option<String>,
        pub r#status: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ConnectionAttemptAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["connection_id", "connection_type", "runtime_id", "session_id", "status", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#connection_id.and_then(|val| map.insert("connection_id".into(), val.to_string()));
          self.r#connection_type.and_then(|val| map.insert("connection_type".into(), val.to_string()));
          self.r#runtime_id.and_then(|val| map.insert("runtime_id".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.connection_attempt_aboutdebugging
    ///
    /// User is trying to connect to a remote runtime. This event was generated to
    /// correspond to the Legacy Telemetry event
    /// devtools.main.connection_attempt#aboutdebugging.
    pub static connection_attempt_aboutdebugging: Lazy<EventMetric<ConnectionAttemptAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "connection_attempt_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(757.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ContinueDebuggerExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ContinueDebuggerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.continue_debugger
    ///
    /// User has pressed the continue button on a paused script. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// devtools.main.continue#debugger.
    pub static continue_debugger: Lazy<EventMetric<ContinueDebuggerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "continue_debugger".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(758.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DeactivateResponsiveDesignExtra {
        pub r#host: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for DeactivateResponsiveDesignExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.deactivate_responsive_design
    ///
    /// User deactivates the responsive_design or split_console in the devtools
    /// toolbox. This event was generated to correspond to the Legacy Telemetry event
    /// devtools.main.deactivate#responsive_design.
    pub static deactivate_responsive_design: Lazy<EventMetric<DeactivateResponsiveDesignExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "deactivate_responsive_design".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(759.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DeactivateSplitConsoleExtra {
        pub r#host: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for DeactivateSplitConsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.deactivate_split_console
    ///
    /// User deactivates the responsive_design or split_console in the devtools
    /// toolbox. This event was generated to correspond to the Legacy Telemetry event
    /// devtools.main.deactivate#split_console.
    pub static deactivate_split_console: Lazy<EventMetric<DeactivateSplitConsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "deactivate_split_console".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(760.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DeviceAddedAboutdebuggingExtra {
        pub r#connection_type: Option<String>,
        pub r#device_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DeviceAddedAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["connection_type", "device_name", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#connection_type.and_then(|val| map.insert("connection_type".into(), val.to_string()));
          self.r#device_name.and_then(|val| map.insert("device_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.device_added_aboutdebugging
    ///
    /// A new device was detected in about:debugging This event was generated to
    /// correspond to the Legacy Telemetry event
    /// devtools.main.device_added#aboutdebugging.
    pub static device_added_aboutdebugging: Lazy<EventMetric<DeviceAddedAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "device_added_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(761.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DeviceRemovedAboutdebuggingExtra {
        pub r#connection_type: Option<String>,
        pub r#device_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DeviceRemovedAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["connection_type", "device_name", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#connection_type.and_then(|val| map.insert("connection_type".into(), val.to_string()));
          self.r#device_name.and_then(|val| map.insert("device_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.device_removed_aboutdebugging
    ///
    /// A previously listed device was removed in about:debugging This event was
    /// generated to correspond to the Legacy Telemetry event
    /// devtools.main.device_removed#aboutdebugging.
    pub static device_removed_aboutdebugging: Lazy<EventMetric<DeviceRemovedAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "device_removed_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(762.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EditHtmlInspectorExtra {
        pub r#made_changes: Option<String>,
        pub r#session_id: Option<String>,
        pub r#time_open: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EditHtmlInspectorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["made_changes", "session_id", "time_open", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#made_changes.and_then(|val| map.insert("made_changes".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#time_open.and_then(|val| map.insert("time_open".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.edit_html_inspector
    ///
    /// User is editing HTML via the context menu item in the markup view. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// devtools.main.edit_html#inspector.
    pub static edit_html_inspector: Lazy<EventMetric<EditHtmlInspectorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "edit_html_inspector".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(763.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EditResendNetmonitorExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EditResendNetmonitorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.edit_resend_netmonitor
    ///
    /// User has executed edit / resend in the netmonitor. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.edit_resend#netmonitor.
    pub static edit_resend_netmonitor: Lazy<EventMetric<EditResendNetmonitorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "edit_resend_netmonitor".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(764.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EditRuleRuleviewExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EditRuleRuleviewExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.edit_rule_ruleview
    ///
    /// User is editing a CSS rule by clicking on or next to a CSS property, enabling /
    /// disabling a rule or creating a new property. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.edit_rule#ruleview.
    pub static edit_rule_ruleview: Lazy<EventMetric<EditRuleRuleviewExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "edit_rule_ruleview".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(765.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterAccessibilityExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterAccessibilityExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_accessibility
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.enter#accessibility.
    pub static enter_accessibility: Lazy<EventMetric<EnterAccessibilityExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_accessibility".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(766.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterApplicationExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterApplicationExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_application
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.enter#application.
    pub static enter_application: Lazy<EventMetric<EnterApplicationExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_application".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(767.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterDomExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterDomExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_dom
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.enter#dom.
    pub static enter_dom: Lazy<EventMetric<EnterDomExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_dom".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(768.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterFakeTool4242Extra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterFakeTool4242Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_fake_tool4242
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.enter#fakeTool4242.
    pub static enter_fake_tool4242: Lazy<EventMetric<EnterFakeTool4242Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_fake_tool4242".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(769.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterInspectorExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterInspectorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_inspector
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.enter#inspector.
    pub static enter_inspector: Lazy<EventMetric<EnterInspectorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_inspector".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(770.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterJsdebuggerExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterJsdebuggerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_jsdebugger
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.enter#jsdebugger.
    pub static enter_jsdebugger: Lazy<EventMetric<EnterJsdebuggerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_jsdebugger".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(771.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterMemoryExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterMemoryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_memory
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.enter#memory.
    pub static enter_memory: Lazy<EventMetric<EnterMemoryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_memory".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(772.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterNetmonitorExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterNetmonitorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_netmonitor
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.enter#netmonitor.
    pub static enter_netmonitor: Lazy<EventMetric<EnterNetmonitorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_netmonitor".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(773.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterOptionsExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterOptionsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_options
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.enter#options.
    pub static enter_options: Lazy<EventMetric<EnterOptionsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_options".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(774.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterOtherExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterOtherExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_other
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.enter#other.
    pub static enter_other: Lazy<EventMetric<EnterOtherExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_other".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(775.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterPerformanceExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterPerformanceExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_performance
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.enter#performance.
    pub static enter_performance: Lazy<EventMetric<EnterPerformanceExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_performance".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(776.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterStorageExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterStorageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_storage
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.enter#storage.
    pub static enter_storage: Lazy<EventMetric<EnterStorageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_storage".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(777.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterStyleeditorExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterStyleeditorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_styleeditor
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.enter#styleeditor.
    pub static enter_styleeditor: Lazy<EventMetric<EnterStyleeditorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_styleeditor".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(778.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterTestBlankPanelExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterTestBlankPanelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_test_blank_panel
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.enter#testBlankPanel.
    pub static enter_test_blank_panel: Lazy<EventMetric<EnterTestBlankPanelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_test_blank_panel".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(779.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterTestToolExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterTestToolExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_test_tool
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.enter#testTool.
    pub static enter_test_tool: Lazy<EventMetric<EnterTestToolExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_test_tool".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(780.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterTestTool1072208Extra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterTestTool1072208Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_test_tool1072208
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.enter#testTool1072208.
    pub static enter_test_tool1072208: Lazy<EventMetric<EnterTestTool1072208Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_test_tool1072208".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(781.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterTesttool1Extra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterTesttool1Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_testtool1
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.enter#testtool1.
    pub static enter_testtool1: Lazy<EventMetric<EnterTesttool1Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_testtool1".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(782.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterTesttool2Extra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterTesttool2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_testtool2
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.enter#testtool2.
    pub static enter_testtool2: Lazy<EventMetric<EnterTesttool2Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_testtool2".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(783.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterWebconsoleExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterWebconsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_webconsole
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.enter#webconsole.
    pub static enter_webconsole: Lazy<EventMetric<EnterWebconsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_webconsole".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(784.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterWhatsnewExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterWhatsnewExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_whatsnew
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.enter#whatsnew.
    pub static enter_whatsnew: Lazy<EventMetric<EnterWhatsnewExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_whatsnew".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(785.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExecuteJsWebconsoleExtra {
        pub r#input: Option<String>,
        pub r#lines: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ExecuteJsWebconsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["input", "lines", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#input.and_then(|val| map.insert("input".into(), val.to_string()));
          self.r#lines.and_then(|val| map.insert("lines".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.execute_js_webconsole
    ///
    /// User has executed some JS in the Web Console. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.execute_js#webconsole.
    pub static execute_js_webconsole: Lazy<EventMetric<ExecuteJsWebconsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "execute_js_webconsole".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(786.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitAccessibilityExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitAccessibilityExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_accessibility
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.exit#accessibility.
    pub static exit_accessibility: Lazy<EventMetric<ExitAccessibilityExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_accessibility".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(787.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitApplicationExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitApplicationExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_application
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.exit#application.
    pub static exit_application: Lazy<EventMetric<ExitApplicationExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_application".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(788.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitDomExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitDomExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_dom
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.exit#dom.
    pub static exit_dom: Lazy<EventMetric<ExitDomExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_dom".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(789.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitFakeTool4242Extra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitFakeTool4242Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_fake_tool4242
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.exit#fakeTool4242.
    pub static exit_fake_tool4242: Lazy<EventMetric<ExitFakeTool4242Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_fake_tool4242".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(790.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitInspectorExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitInspectorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_inspector
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.exit#inspector.
    pub static exit_inspector: Lazy<EventMetric<ExitInspectorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_inspector".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(791.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitJsdebuggerExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitJsdebuggerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_jsdebugger
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.exit#jsdebugger.
    pub static exit_jsdebugger: Lazy<EventMetric<ExitJsdebuggerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_jsdebugger".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(792.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitMemoryExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitMemoryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_memory
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.exit#memory.
    pub static exit_memory: Lazy<EventMetric<ExitMemoryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_memory".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(793.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitNetmonitorExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitNetmonitorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_netmonitor
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.exit#netmonitor.
    pub static exit_netmonitor: Lazy<EventMetric<ExitNetmonitorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_netmonitor".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(794.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitOptionsExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitOptionsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_options
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.exit#options.
    pub static exit_options: Lazy<EventMetric<ExitOptionsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_options".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(795.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitOtherExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitOtherExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_other
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.exit#other.
    pub static exit_other: Lazy<EventMetric<ExitOtherExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_other".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(796.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitPerformanceExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitPerformanceExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_performance
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.exit#performance.
    pub static exit_performance: Lazy<EventMetric<ExitPerformanceExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_performance".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(797.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitStorageExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitStorageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_storage
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.exit#storage.
    pub static exit_storage: Lazy<EventMetric<ExitStorageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_storage".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(798.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitStyleeditorExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitStyleeditorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_styleeditor
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.exit#styleeditor.
    pub static exit_styleeditor: Lazy<EventMetric<ExitStyleeditorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_styleeditor".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(799.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitTestBlankPanelExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitTestBlankPanelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_test_blank_panel
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.exit#testBlankPanel.
    pub static exit_test_blank_panel: Lazy<EventMetric<ExitTestBlankPanelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_test_blank_panel".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(800.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitTestToolExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitTestToolExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_test_tool
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.exit#testTool.
    pub static exit_test_tool: Lazy<EventMetric<ExitTestToolExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_test_tool".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(801.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitTestTool1072208Extra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitTestTool1072208Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_test_tool1072208
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.exit#testTool1072208.
    pub static exit_test_tool1072208: Lazy<EventMetric<ExitTestTool1072208Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_test_tool1072208".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(802.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitTesttool1Extra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitTesttool1Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_testtool1
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.exit#testtool1.
    pub static exit_testtool1: Lazy<EventMetric<ExitTesttool1Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_testtool1".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(803.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitTesttool2Extra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitTesttool2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_testtool2
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.exit#testtool2.
    pub static exit_testtool2: Lazy<EventMetric<ExitTesttool2Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_testtool2".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(804.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitWebconsoleExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitWebconsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_webconsole
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.exit#webconsole.
    pub static exit_webconsole: Lazy<EventMetric<ExitWebconsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_webconsole".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(805.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitWhatsnewExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitWhatsnewExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_whatsnew
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.exit#whatsnew.
    pub static exit_whatsnew: Lazy<EventMetric<ExitWhatsnewExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_whatsnew".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(806.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FiltersChangedNetmonitorExtra {
        pub r#active: Option<String>,
        pub r#inactive: Option<String>,
        pub r#session_id: Option<String>,
        pub r#trigger: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for FiltersChangedNetmonitorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["active", "inactive", "session_id", "trigger", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#active.and_then(|val| map.insert("active".into(), val.to_string()));
          self.r#inactive.and_then(|val| map.insert("inactive".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#trigger.and_then(|val| map.insert("trigger".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.filters_changed_netmonitor
    ///
    /// User has changed filters in the web console. This event was generated to
    /// correspond to the Legacy Telemetry event
    /// devtools.main.filters_changed#netmonitor.
    pub static filters_changed_netmonitor: Lazy<EventMetric<FiltersChangedNetmonitorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "filters_changed_netmonitor".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(807.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FiltersChangedWebconsoleExtra {
        pub r#active: Option<String>,
        pub r#inactive: Option<String>,
        pub r#session_id: Option<String>,
        pub r#trigger: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for FiltersChangedWebconsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["active", "inactive", "session_id", "trigger", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#active.and_then(|val| map.insert("active".into(), val.to_string()));
          self.r#inactive.and_then(|val| map.insert("inactive".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#trigger.and_then(|val| map.insert("trigger".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.filters_changed_webconsole
    ///
    /// User has changed filters in the web console. This event was generated to
    /// correspond to the Legacy Telemetry event
    /// devtools.main.filters_changed#webconsole.
    pub static filters_changed_webconsole: Lazy<EventMetric<FiltersChangedWebconsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "filters_changed_webconsole".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(808.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InspectAboutdebuggingExtra {
        pub r#runtime_type: Option<String>,
        pub r#session_id: Option<String>,
        pub r#target_type: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InspectAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["runtime_type", "session_id", "target_type", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#runtime_type.and_then(|val| map.insert("runtime_type".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#target_type.and_then(|val| map.insert("target_type".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.inspect_aboutdebugging
    ///
    /// User has clicked on the inspect button of one of the debug targets of
    /// aboutdebugging. This event was generated to correspond to the Legacy Telemetry
    /// event devtools.main.inspect#aboutdebugging.
    pub static inspect_aboutdebugging: Lazy<EventMetric<InspectAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "inspect_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(809.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct JumpToDefinitionWebconsoleExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for JumpToDefinitionWebconsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.jump_to_definition_webconsole
    ///
    /// User has clicked "Jump to definition" icon (next to logged functions) in the
    /// web console. This event was generated to correspond to the Legacy Telemetry
    /// event devtools.main.jump_to_definition#webconsole.
    pub static jump_to_definition_webconsole: Lazy<EventMetric<JumpToDefinitionWebconsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "jump_to_definition_webconsole".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(810.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct JumpToSourceWebconsoleExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for JumpToSourceWebconsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.jump_to_source_webconsole
    ///
    /// User has clicked a link to a source file in the web console. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// devtools.main.jump_to_source#webconsole.
    pub static jump_to_source_webconsole: Lazy<EventMetric<JumpToSourceWebconsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "jump_to_source_webconsole".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(811.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ObjectExpandedWebconsoleExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ObjectExpandedWebconsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.object_expanded_webconsole
    ///
    /// User has expanded an object in the web console. This event was generated to
    /// correspond to the Legacy Telemetry event
    /// devtools.main.object_expanded#webconsole.
    pub static object_expanded_webconsole: Lazy<EventMetric<ObjectExpandedWebconsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "object_expanded_webconsole".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(812.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenAdbgAboutdebuggingExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for OpenAdbgAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.open_adbg_aboutdebugging
    ///
    /// User opens about:debugging. This event was generated to correspond to the
    /// Legacy Telemetry event devtools.main.open_adbg#aboutdebugging.
    pub static open_adbg_aboutdebugging: Lazy<EventMetric<OpenAdbgAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_adbg_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(813.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenToolsExtra {
        pub r#entrypoint: Option<String>,
        pub r#first_panel: Option<String>,
        pub r#host: Option<String>,
        pub r#session_id: Option<String>,
        pub r#shortcut: Option<String>,
        pub r#splitconsole: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for OpenToolsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["entrypoint", "first_panel", "host", "session_id", "shortcut", "splitconsole", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#entrypoint.and_then(|val| map.insert("entrypoint".into(), val.to_string()));
          self.r#first_panel.and_then(|val| map.insert("first_panel".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#shortcut.and_then(|val| map.insert("shortcut".into(), val.to_string()));
          self.r#splitconsole.and_then(|val| map.insert("splitconsole".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.open_tools
    ///
    /// User opens devtools toolbox. This event was generated to correspond to the
    /// Legacy Telemetry event devtools.main.open#tools.
    pub static open_tools: Lazy<EventMetric<OpenToolsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_tools".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(814.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PauseDebuggerExtra {
        pub r#lib_stacks: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PauseDebuggerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["lib_stacks", "reason", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#lib_stacks.and_then(|val| map.insert("lib_stacks".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.pause_debugger
    ///
    /// Debugger has paused in a script due to a breakpoint or exception. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// devtools.main.pause#debugger.
    pub static pause_debugger: Lazy<EventMetric<PauseDebuggerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pause_debugger".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(815.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PauseOnExceptionsDebuggerExtra {
        pub r#caught_exceptio: Option<String>,
        pub r#exceptions: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PauseOnExceptionsDebuggerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["caught_exceptio", "exceptions", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#caught_exceptio.and_then(|val| map.insert("caught_exceptio".into(), val.to_string()));
          self.r#exceptions.and_then(|val| map.insert("exceptions".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.pause_on_exceptions_debugger
    ///
    /// User has changed pausing behaviour in the debugger. This event was generated to
    /// correspond to the Legacy Telemetry event
    /// devtools.main.pause_on_exceptions#debugger.
    pub static pause_on_exceptions_debugger: Lazy<EventMetric<PauseOnExceptionsDebuggerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pause_on_exceptions_debugger".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(816.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PersistChangedNetmonitorExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PersistChangedNetmonitorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.persist_changed_netmonitor
    ///
    /// User has changed log persist status. This event was generated to correspond to
    /// the Legacy Telemetry event devtools.main.persist_changed#netmonitor.
    pub static persist_changed_netmonitor: Lazy<EventMetric<PersistChangedNetmonitorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "persist_changed_netmonitor".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(817.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PersistChangedWebconsoleExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PersistChangedWebconsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.persist_changed_webconsole
    ///
    /// User has changed log persist status. This event was generated to correspond to
    /// the Legacy Telemetry event devtools.main.persist_changed#webconsole.
    pub static persist_changed_webconsole: Lazy<EventMetric<PersistChangedWebconsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "persist_changed_webconsole".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(818.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PrettyPrintDebuggerExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PrettyPrintDebuggerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.pretty_print_debugger
    ///
    /// User clicked the pretty print button to pretty print a script. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// devtools.main.pretty_print#debugger.
    pub static pretty_print_debugger: Lazy<EventMetric<PrettyPrintDebuggerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pretty_print_debugger".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(819.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RemoveBreakpointDebuggerExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for RemoveBreakpointDebuggerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.remove_breakpoint_debugger
    ///
    /// User has removed a breakpoint from a script. This event was generated to
    /// correspond to the Legacy Telemetry event
    /// devtools.main.remove_breakpoint#debugger.
    pub static remove_breakpoint_debugger: Lazy<EventMetric<RemoveBreakpointDebuggerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "remove_breakpoint_debugger".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(820.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReverseSearchWebconsoleExtra {
        pub r#functionality: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReverseSearchWebconsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["functionality", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#functionality.and_then(|val| map.insert("functionality".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.reverse_search_webconsole
    ///
    /// User has toggled, navigated or evaluated expressions from reverse search . This
    /// event was generated to correspond to the Legacy Telemetry event
    /// devtools.main.reverse_search#webconsole.
    pub static reverse_search_webconsole: Lazy<EventMetric<ReverseSearchWebconsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reverse_search_webconsole".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(821.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RuntimeAddedAboutdebuggingExtra {
        pub r#connection_type: Option<String>,
        pub r#device_name: Option<String>,
        pub r#runtime_id: Option<String>,
        pub r#runtime_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for RuntimeAddedAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["connection_type", "device_name", "runtime_id", "runtime_name", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#connection_type.and_then(|val| map.insert("connection_type".into(), val.to_string()));
          self.r#device_name.and_then(|val| map.insert("device_name".into(), val.to_string()));
          self.r#runtime_id.and_then(|val| map.insert("runtime_id".into(), val.to_string()));
          self.r#runtime_name.and_then(|val| map.insert("runtime_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.runtime_added_aboutdebugging
    ///
    /// A new remote runtime has been detected in about:debugging This event was
    /// generated to correspond to the Legacy Telemetry event
    /// devtools.main.runtime_added#aboutdebugging.
    pub static runtime_added_aboutdebugging: Lazy<EventMetric<RuntimeAddedAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "runtime_added_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(822.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RuntimeConnectedAboutdebuggingExtra {
        pub r#connection_type: Option<String>,
        pub r#device_name: Option<String>,
        pub r#runtime_id: Option<String>,
        pub r#runtime_name: Option<String>,
        pub r#runtime_os: Option<String>,
        pub r#runtime_version: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for RuntimeConnectedAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["connection_type", "device_name", "runtime_id", "runtime_name", "runtime_os", "runtime_version", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#connection_type.and_then(|val| map.insert("connection_type".into(), val.to_string()));
          self.r#device_name.and_then(|val| map.insert("device_name".into(), val.to_string()));
          self.r#runtime_id.and_then(|val| map.insert("runtime_id".into(), val.to_string()));
          self.r#runtime_name.and_then(|val| map.insert("runtime_name".into(), val.to_string()));
          self.r#runtime_os.and_then(|val| map.insert("runtime_os".into(), val.to_string()));
          self.r#runtime_version.and_then(|val| map.insert("runtime_version".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.runtime_connected_aboutdebugging
    ///
    /// Connection was established with a remote runtime in about:debugging This event
    /// was generated to correspond to the Legacy Telemetry event
    /// devtools.main.runtime_connected#aboutdebugging.
    pub static runtime_connected_aboutdebugging: Lazy<EventMetric<RuntimeConnectedAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "runtime_connected_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(823.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RuntimeDisconnectedAboutdebuggingExtra {
        pub r#connection_type: Option<String>,
        pub r#device_name: Option<String>,
        pub r#runtime_id: Option<String>,
        pub r#runtime_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for RuntimeDisconnectedAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["connection_type", "device_name", "runtime_id", "runtime_name", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#connection_type.and_then(|val| map.insert("connection_type".into(), val.to_string()));
          self.r#device_name.and_then(|val| map.insert("device_name".into(), val.to_string()));
          self.r#runtime_id.and_then(|val| map.insert("runtime_id".into(), val.to_string()));
          self.r#runtime_name.and_then(|val| map.insert("runtime_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.runtime_disconnected_aboutdebugging
    ///
    /// Connection was lost with a remote runtime in about debugging This event was
    /// generated to correspond to the Legacy Telemetry event
    /// devtools.main.runtime_disconnected#aboutdebugging.
    pub static runtime_disconnected_aboutdebugging: Lazy<EventMetric<RuntimeDisconnectedAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "runtime_disconnected_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(824.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RuntimeRemovedAboutdebuggingExtra {
        pub r#connection_type: Option<String>,
        pub r#device_name: Option<String>,
        pub r#runtime_id: Option<String>,
        pub r#runtime_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for RuntimeRemovedAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["connection_type", "device_name", "runtime_id", "runtime_name", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#connection_type.and_then(|val| map.insert("connection_type".into(), val.to_string()));
          self.r#device_name.and_then(|val| map.insert("device_name".into(), val.to_string()));
          self.r#runtime_id.and_then(|val| map.insert("runtime_id".into(), val.to_string()));
          self.r#runtime_name.and_then(|val| map.insert("runtime_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.runtime_removed_aboutdebugging
    ///
    /// A previously listed runtime was removed in about:debugging This event was
    /// generated to correspond to the Legacy Telemetry event
    /// devtools.main.runtime_removed#aboutdebugging.
    pub static runtime_removed_aboutdebugging: Lazy<EventMetric<RuntimeRemovedAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "runtime_removed_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(825.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SelectPageAboutdebuggingExtra {
        pub r#page_type: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SelectPageAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["page_type", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#page_type.and_then(|val| map.insert("page_type".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.select_page_aboutdebugging
    ///
    /// User navigates to a new page of an application such as about:debugging This
    /// event was generated to correspond to the Legacy Telemetry event
    /// devtools.main.select_page#aboutdebugging.
    pub static select_page_aboutdebugging: Lazy<EventMetric<SelectPageAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "select_page_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(826.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SelectPageApplicationExtra {
        pub r#page_type: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SelectPageApplicationExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["page_type", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#page_type.and_then(|val| map.insert("page_type".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.select_page_application
    ///
    /// User navigates to a new page of an application such as about:debugging This
    /// event was generated to correspond to the Legacy Telemetry event
    /// devtools.main.select_page#application.
    pub static select_page_application: Lazy<EventMetric<SelectPageApplicationExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "select_page_application".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(827.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SelectWsFrameNetmonitorExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SelectWsFrameNetmonitorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.select_ws_frame_netmonitor
    ///
    /// User has selected a WebSocket frame. This event was generated to correspond to
    /// the Legacy Telemetry event devtools.main.select_ws_frame#netmonitor.
    pub static select_ws_frame_netmonitor: Lazy<EventMetric<SelectWsFrameNetmonitorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "select_ws_frame_netmonitor".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(828.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowProfilerAboutdebuggingExtra {
        pub r#runtime_id: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowProfilerAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["runtime_id", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#runtime_id.and_then(|val| map.insert("runtime_id".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.show_profiler_aboutdebugging
    ///
    /// User has clicked on the "Open Profiler" button in a runtime page of
    /// about:debugging This event was generated to correspond to the Legacy Telemetry
    /// event devtools.main.show_profiler#aboutdebugging.
    pub static show_profiler_aboutdebugging: Lazy<EventMetric<ShowProfilerAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_profiler_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(829.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidepanelChangedInspectorExtra {
        pub r#newpanel: Option<String>,
        pub r#oldpanel: Option<String>,
        pub r#os: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SidepanelChangedInspectorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newpanel", "oldpanel", "os", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newpanel.and_then(|val| map.insert("newpanel".into(), val.to_string()));
          self.r#oldpanel.and_then(|val| map.insert("oldpanel".into(), val.to_string()));
          self.r#os.and_then(|val| map.insert("os".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.sidepanel_changed_inspector
    ///
    /// User has switched sidepanel tabs. This event was generated to correspond to the
    /// Legacy Telemetry event devtools.main.sidepanel_changed#inspector.
    pub static sidepanel_changed_inspector: Lazy<EventMetric<SidepanelChangedInspectorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidepanel_changed_inspector".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(830.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidepanelChangedNetmonitorExtra {
        pub r#newpanel: Option<String>,
        pub r#oldpanel: Option<String>,
        pub r#os: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SidepanelChangedNetmonitorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newpanel", "oldpanel", "os", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newpanel.and_then(|val| map.insert("newpanel".into(), val.to_string()));
          self.r#oldpanel.and_then(|val| map.insert("oldpanel".into(), val.to_string()));
          self.r#os.and_then(|val| map.insert("os".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.sidepanel_changed_netmonitor
    ///
    /// User has switched sidepanel tabs. This event was generated to correspond to the
    /// Legacy Telemetry event devtools.main.sidepanel_changed#netmonitor.
    pub static sidepanel_changed_netmonitor: Lazy<EventMetric<SidepanelChangedNetmonitorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidepanel_changed_netmonitor".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(831.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StartWorkerApplicationExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for StartWorkerApplicationExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.start_worker_application
    ///
    /// User manually starts a service worker This event was generated to correspond to
    /// the Legacy Telemetry event devtools.main.start_worker#application.
    pub static start_worker_application: Lazy<EventMetric<StartWorkerApplicationExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "start_worker_application".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(832.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ThrottleChangedNetmonitorExtra {
        pub r#mode: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ThrottleChangedNetmonitorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["mode", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#mode.and_then(|val| map.insert("mode".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.throttle_changed_netmonitor
    ///
    /// User has changed the throttle setting in the netmonitor. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// devtools.main.throttle_changed#netmonitor.
    pub static throttle_changed_netmonitor: Lazy<EventMetric<ThrottleChangedNetmonitorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "throttle_changed_netmonitor".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(833.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ToolTimerAnimationinspectorExtra {
        pub r#os: Option<String>,
        pub r#session_id: Option<String>,
        pub r#time_open: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ToolTimerAnimationinspectorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["os", "session_id", "time_open", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#os.and_then(|val| map.insert("os".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#time_open.and_then(|val| map.insert("time_open".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.tool_timer_animationinspector
    ///
    /// The amount of time a tool was opened for. This event was generated to
    /// correspond to the Legacy Telemetry event
    /// devtools.main.tool_timer#animationinspector.
    pub static tool_timer_animationinspector: Lazy<EventMetric<ToolTimerAnimationinspectorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tool_timer_animationinspector".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(834.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ToolTimerChangesviewExtra {
        pub r#os: Option<String>,
        pub r#session_id: Option<String>,
        pub r#time_open: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ToolTimerChangesviewExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["os", "session_id", "time_open", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#os.and_then(|val| map.insert("os".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#time_open.and_then(|val| map.insert("time_open".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.tool_timer_changesview
    ///
    /// The amount of time a tool was opened for. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.tool_timer#changesview.
    pub static tool_timer_changesview: Lazy<EventMetric<ToolTimerChangesviewExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tool_timer_changesview".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(835.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ToolTimerCompatibilityviewExtra {
        pub r#os: Option<String>,
        pub r#session_id: Option<String>,
        pub r#time_open: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ToolTimerCompatibilityviewExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["os", "session_id", "time_open", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#os.and_then(|val| map.insert("os".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#time_open.and_then(|val| map.insert("time_open".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.tool_timer_compatibilityview
    ///
    /// The amount of time a tool was opened for. This event was generated to
    /// correspond to the Legacy Telemetry event
    /// devtools.main.tool_timer#compatibilityview.
    pub static tool_timer_compatibilityview: Lazy<EventMetric<ToolTimerCompatibilityviewExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tool_timer_compatibilityview".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(836.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ToolTimerComputedviewExtra {
        pub r#os: Option<String>,
        pub r#session_id: Option<String>,
        pub r#time_open: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ToolTimerComputedviewExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["os", "session_id", "time_open", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#os.and_then(|val| map.insert("os".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#time_open.and_then(|val| map.insert("time_open".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.tool_timer_computedview
    ///
    /// The amount of time a tool was opened for. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.tool_timer#computedview.
    pub static tool_timer_computedview: Lazy<EventMetric<ToolTimerComputedviewExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tool_timer_computedview".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(837.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ToolTimerFontinspectorExtra {
        pub r#os: Option<String>,
        pub r#session_id: Option<String>,
        pub r#time_open: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ToolTimerFontinspectorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["os", "session_id", "time_open", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#os.and_then(|val| map.insert("os".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#time_open.and_then(|val| map.insert("time_open".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.tool_timer_fontinspector
    ///
    /// The amount of time a tool was opened for. This event was generated to
    /// correspond to the Legacy Telemetry event
    /// devtools.main.tool_timer#fontinspector.
    pub static tool_timer_fontinspector: Lazy<EventMetric<ToolTimerFontinspectorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tool_timer_fontinspector".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(838.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ToolTimerLayoutviewExtra {
        pub r#os: Option<String>,
        pub r#session_id: Option<String>,
        pub r#time_open: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ToolTimerLayoutviewExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["os", "session_id", "time_open", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#os.and_then(|val| map.insert("os".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#time_open.and_then(|val| map.insert("time_open".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.tool_timer_layoutview
    ///
    /// The amount of time a tool was opened for. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.tool_timer#layoutview.
    pub static tool_timer_layoutview: Lazy<EventMetric<ToolTimerLayoutviewExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tool_timer_layoutview".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(839.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ToolTimerRuleviewExtra {
        pub r#os: Option<String>,
        pub r#session_id: Option<String>,
        pub r#time_open: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ToolTimerRuleviewExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["os", "session_id", "time_open", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#os.and_then(|val| map.insert("os".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#time_open.and_then(|val| map.insert("time_open".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.tool_timer_ruleview
    ///
    /// The amount of time a tool was opened for. This event was generated to
    /// correspond to the Legacy Telemetry event devtools.main.tool_timer#ruleview.
    pub static tool_timer_ruleview: Lazy<EventMetric<ToolTimerRuleviewExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tool_timer_ruleview".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(840.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnregisterWorkerApplicationExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnregisterWorkerApplicationExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.unregister_worker_application
    ///
    /// User manually unregisters a service worker registration This event was
    /// generated to correspond to the Legacy Telemetry event
    /// devtools.main.unregister_worker#application.
    pub static unregister_worker_application: Lazy<EventMetric<UnregisterWorkerApplicationExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unregister_worker_application".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(841.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateConnPromptAboutdebuggingExtra {
        pub r#prompt_enabled: Option<String>,
        pub r#runtime_id: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateConnPromptAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["prompt_enabled", "runtime_id", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#prompt_enabled.and_then(|val| map.insert("prompt_enabled".into(), val.to_string()));
          self.r#runtime_id.and_then(|val| map.insert("runtime_id".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.update_conn_prompt_aboutdebugging
    ///
    /// User has clicked on the "Enable/Disable connection prompt" button in a runtime
    /// page of about:debugging This event was generated to correspond to the Legacy
    /// Telemetry event devtools.main.update_conn_prompt#aboutdebugging.
    pub static update_conn_prompt_aboutdebugging: Lazy<EventMetric<UpdateConnPromptAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_conn_prompt_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(842.into(), meta)
    });

}
pub mod performance_page {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from performance.page.total_content_page_load
    ///
    /// Time to load all of a page's resources and render. (Migrated from the geckoview
    /// metric of the same name.)
    pub static total_content_page_load: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_content_page_load".into(),
                category: "performance.page".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(843.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.page.non_blank_paint
    ///
    /// The time between navigationStart and the first non-blank paint of a foreground
    /// root content document, in milliseconds. This only records documents that were
    /// in an active docshell throughout the whole time between navigation start and
    /// non-blank paint. The non-blank paint timestamp is taken during display list
    /// building and does not include rasterization or compositing of that paint.
    /// (Migrated from the geckoview metric of the same name.)
    pub static non_blank_paint: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "non_blank_paint".into(),
                category: "performance.page".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(844.into(), meta, TimeUnit::Millisecond)
    });

}
pub mod use_counter {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.content_documents_destroyed
    ///
    /// A count of how many content documents were destroyed. Used to turn document use
    /// counters' counts into rates. Excludes documents for which we do not count use
    /// counters (See `Document::ShouldIncludeInTelemetry`).
    pub static content_documents_destroyed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            845,
            "use.counter",
            "content_documents_destroyed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.dedicated_workers_destroyed
    ///
    /// A count of how many `Dedicated`-kind workers were destroyed. Used to turn
    /// dedicated worker use counters' counts into rates. Excludes chrome workers.
    pub static dedicated_workers_destroyed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            846,
            "use.counter",
            "dedicated_workers_destroyed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.service_workers_destroyed
    ///
    /// A count of how many `Service`-kind workers were destroyed. Used to turn service
    /// worker use counters' counts into rates. Excludes chrome workers.
    pub static service_workers_destroyed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            847,
            "use.counter",
            "service_workers_destroyed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.shared_workers_destroyed
    ///
    /// A count of how many `Shared`-kind workers were destroyed. Used to turn shared
    /// worker use counters' counts into rates. Excludes chrome workers.
    pub static shared_workers_destroyed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            848,
            "use.counter",
            "shared_workers_destroyed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.top_level_content_documents_destroyed
    ///
    /// A count of how many "pages" were destroyed. Used to turn page use counters'
    /// counts into rates. Excludes pages that contain only documents for which we do
    /// not count use counters (See `Document::ShouldIncludeInTelemetry`).
    pub static top_level_content_documents_destroyed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            849,
            "use.counter",
            "top_level_content_documents_destroyed",
            "use-counters"
        )
    });

}
pub mod use_counter_css_doc {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.alignment_baseline
    ///
    /// Whether a document used the (unknown, counted) CSS property alignment-baseline.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static alignment_baseline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            850,
            "use.counter.css.doc",
            "alignment_baseline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.background_repeat_x
    ///
    /// Whether a document used the (unknown, counted) CSS property background-
    /// repeat-x. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static background_repeat_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            851,
            "use.counter.css.doc",
            "background_repeat_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.background_repeat_y
    ///
    /// Whether a document used the (unknown, counted) CSS property background-
    /// repeat-y. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static background_repeat_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            852,
            "use.counter.css.doc",
            "background_repeat_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.baseline_shift
    ///
    /// Whether a document used the (unknown, counted) CSS property baseline-shift.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static baseline_shift: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            853,
            "use.counter.css.doc",
            "baseline_shift",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.buffered_rendering
    ///
    /// Whether a document used the (unknown, counted) CSS property buffered-rendering.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static buffered_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            854,
            "use.counter.css.doc",
            "buffered_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.color_rendering
    ///
    /// Whether a document used the (unknown, counted) CSS property color-rendering.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static color_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            855,
            "use.counter.css.doc",
            "color_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_accent_color
    ///
    /// Whether a document used the CSS property accent-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_accent_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            856,
            "use.counter.css.doc",
            "css_accent_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_align_content
    ///
    /// Whether a document used the CSS property align-content. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_align_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            857,
            "use.counter.css.doc",
            "css_align_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_align_items
    ///
    /// Whether a document used the CSS property align-items. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_align_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            858,
            "use.counter.css.doc",
            "css_align_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_align_self
    ///
    /// Whether a document used the CSS property align-self. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_align_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            859,
            "use.counter.css.doc",
            "css_align_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_all
    ///
    /// Whether a document used the CSS property all. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_all: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            860,
            "use.counter.css.doc",
            "css_all",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_anchor_name
    ///
    /// Whether a document used the CSS property anchor-name. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_anchor_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            861,
            "use.counter.css.doc",
            "css_anchor_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_anchor_scope
    ///
    /// Whether a document used the CSS property anchor-scope. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_anchor_scope: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            862,
            "use.counter.css.doc",
            "css_anchor_scope",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation
    ///
    /// Whether a document used the CSS property animation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            863,
            "use.counter.css.doc",
            "css_animation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_composition
    ///
    /// Whether a document used the CSS property animation-composition. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_composition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            864,
            "use.counter.css.doc",
            "css_animation_composition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_delay
    ///
    /// Whether a document used the CSS property animation-delay. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            865,
            "use.counter.css.doc",
            "css_animation_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_direction
    ///
    /// Whether a document used the CSS property animation-direction. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            866,
            "use.counter.css.doc",
            "css_animation_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_duration
    ///
    /// Whether a document used the CSS property animation-duration. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            867,
            "use.counter.css.doc",
            "css_animation_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_fill_mode
    ///
    /// Whether a document used the CSS property animation-fill-mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_fill_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            868,
            "use.counter.css.doc",
            "css_animation_fill_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_iteration_count
    ///
    /// Whether a document used the CSS property animation-iteration-count. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_iteration_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            869,
            "use.counter.css.doc",
            "css_animation_iteration_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_name
    ///
    /// Whether a document used the CSS property animation-name. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            870,
            "use.counter.css.doc",
            "css_animation_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_play_state
    ///
    /// Whether a document used the CSS property animation-play-state. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_play_state: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            871,
            "use.counter.css.doc",
            "css_animation_play_state",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_timeline
    ///
    /// Whether a document used the CSS property animation-timeline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_timeline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            872,
            "use.counter.css.doc",
            "css_animation_timeline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_timing_function
    ///
    /// Whether a document used the CSS property animation-timing-function. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            873,
            "use.counter.css.doc",
            "css_animation_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_appearance
    ///
    /// Whether a document used the CSS property appearance. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            874,
            "use.counter.css.doc",
            "css_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_aspect_ratio
    ///
    /// Whether a document used the CSS property aspect-ratio. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_aspect_ratio: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            875,
            "use.counter.css.doc",
            "css_aspect_ratio",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_backdrop_filter
    ///
    /// Whether a document used the CSS property backdrop-filter. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_backdrop_filter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            876,
            "use.counter.css.doc",
            "css_backdrop_filter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_backface_visibility
    ///
    /// Whether a document used the CSS property backface-visibility. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_backface_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            877,
            "use.counter.css.doc",
            "css_backface_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background
    ///
    /// Whether a document used the CSS property background. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            878,
            "use.counter.css.doc",
            "css_background",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_attachment
    ///
    /// Whether a document used the CSS property background-attachment. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_attachment: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            879,
            "use.counter.css.doc",
            "css_background_attachment",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_blend_mode
    ///
    /// Whether a document used the CSS property background-blend-mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_blend_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            880,
            "use.counter.css.doc",
            "css_background_blend_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_clip
    ///
    /// Whether a document used the CSS property background-clip. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            881,
            "use.counter.css.doc",
            "css_background_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_color
    ///
    /// Whether a document used the CSS property background-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            882,
            "use.counter.css.doc",
            "css_background_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_image
    ///
    /// Whether a document used the CSS property background-image. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            883,
            "use.counter.css.doc",
            "css_background_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_origin
    ///
    /// Whether a document used the CSS property background-origin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            884,
            "use.counter.css.doc",
            "css_background_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_position
    ///
    /// Whether a document used the CSS property background-position. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            885,
            "use.counter.css.doc",
            "css_background_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_position_x
    ///
    /// Whether a document used the CSS property background-position-x. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_position_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            886,
            "use.counter.css.doc",
            "css_background_position_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_position_y
    ///
    /// Whether a document used the CSS property background-position-y. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_position_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            887,
            "use.counter.css.doc",
            "css_background_position_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_repeat
    ///
    /// Whether a document used the CSS property background-repeat. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            888,
            "use.counter.css.doc",
            "css_background_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_size
    ///
    /// Whether a document used the CSS property background-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            889,
            "use.counter.css.doc",
            "css_background_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_baseline_source
    ///
    /// Whether a document used the CSS property baseline-source. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_baseline_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            890,
            "use.counter.css.doc",
            "css_baseline_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_block_size
    ///
    /// Whether a document used the CSS property block-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            891,
            "use.counter.css.doc",
            "css_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border
    ///
    /// Whether a document used the CSS property border. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            892,
            "use.counter.css.doc",
            "css_border",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block
    ///
    /// Whether a document used the CSS property border-block. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            893,
            "use.counter.css.doc",
            "css_border_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_color
    ///
    /// Whether a document used the CSS property border-block-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            894,
            "use.counter.css.doc",
            "css_border_block_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_end
    ///
    /// Whether a document used the CSS property border-block-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            895,
            "use.counter.css.doc",
            "css_border_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_end_color
    ///
    /// Whether a document used the CSS property border-block-end-color. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            896,
            "use.counter.css.doc",
            "css_border_block_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_end_style
    ///
    /// Whether a document used the CSS property border-block-end-style. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            897,
            "use.counter.css.doc",
            "css_border_block_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_end_width
    ///
    /// Whether a document used the CSS property border-block-end-width. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            898,
            "use.counter.css.doc",
            "css_border_block_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_start
    ///
    /// Whether a document used the CSS property border-block-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            899,
            "use.counter.css.doc",
            "css_border_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_start_color
    ///
    /// Whether a document used the CSS property border-block-start-color. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            900,
            "use.counter.css.doc",
            "css_border_block_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_start_style
    ///
    /// Whether a document used the CSS property border-block-start-style. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            901,
            "use.counter.css.doc",
            "css_border_block_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_start_width
    ///
    /// Whether a document used the CSS property border-block-start-width. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            902,
            "use.counter.css.doc",
            "css_border_block_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_style
    ///
    /// Whether a document used the CSS property border-block-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            903,
            "use.counter.css.doc",
            "css_border_block_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_width
    ///
    /// Whether a document used the CSS property border-block-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            904,
            "use.counter.css.doc",
            "css_border_block_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_bottom
    ///
    /// Whether a document used the CSS property border-bottom. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            905,
            "use.counter.css.doc",
            "css_border_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_bottom_color
    ///
    /// Whether a document used the CSS property border-bottom-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            906,
            "use.counter.css.doc",
            "css_border_bottom_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_bottom_left_radius
    ///
    /// Whether a document used the CSS property border-bottom-left-radius. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            907,
            "use.counter.css.doc",
            "css_border_bottom_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_bottom_right_radius
    ///
    /// Whether a document used the CSS property border-bottom-right-radius. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            908,
            "use.counter.css.doc",
            "css_border_bottom_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_bottom_style
    ///
    /// Whether a document used the CSS property border-bottom-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            909,
            "use.counter.css.doc",
            "css_border_bottom_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_bottom_width
    ///
    /// Whether a document used the CSS property border-bottom-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            910,
            "use.counter.css.doc",
            "css_border_bottom_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_collapse
    ///
    /// Whether a document used the CSS property border-collapse. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            911,
            "use.counter.css.doc",
            "css_border_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_color
    ///
    /// Whether a document used the CSS property border-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            912,
            "use.counter.css.doc",
            "css_border_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_end_end_radius
    ///
    /// Whether a document used the CSS property border-end-end-radius. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_end_end_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            913,
            "use.counter.css.doc",
            "css_border_end_end_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_end_start_radius
    ///
    /// Whether a document used the CSS property border-end-start-radius. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_end_start_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            914,
            "use.counter.css.doc",
            "css_border_end_start_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_image
    ///
    /// Whether a document used the CSS property border-image. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            915,
            "use.counter.css.doc",
            "css_border_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_image_outset
    ///
    /// Whether a document used the CSS property border-image-outset. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_image_outset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            916,
            "use.counter.css.doc",
            "css_border_image_outset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_image_repeat
    ///
    /// Whether a document used the CSS property border-image-repeat. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_image_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            917,
            "use.counter.css.doc",
            "css_border_image_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_image_slice
    ///
    /// Whether a document used the CSS property border-image-slice. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_image_slice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            918,
            "use.counter.css.doc",
            "css_border_image_slice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_image_source
    ///
    /// Whether a document used the CSS property border-image-source. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_image_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            919,
            "use.counter.css.doc",
            "css_border_image_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_image_width
    ///
    /// Whether a document used the CSS property border-image-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_image_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            920,
            "use.counter.css.doc",
            "css_border_image_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline
    ///
    /// Whether a document used the CSS property border-inline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            921,
            "use.counter.css.doc",
            "css_border_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_color
    ///
    /// Whether a document used the CSS property border-inline-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            922,
            "use.counter.css.doc",
            "css_border_inline_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_end
    ///
    /// Whether a document used the CSS property border-inline-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            923,
            "use.counter.css.doc",
            "css_border_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_end_color
    ///
    /// Whether a document used the CSS property border-inline-end-color. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            924,
            "use.counter.css.doc",
            "css_border_inline_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_end_style
    ///
    /// Whether a document used the CSS property border-inline-end-style. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            925,
            "use.counter.css.doc",
            "css_border_inline_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_end_width
    ///
    /// Whether a document used the CSS property border-inline-end-width. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            926,
            "use.counter.css.doc",
            "css_border_inline_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_start
    ///
    /// Whether a document used the CSS property border-inline-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            927,
            "use.counter.css.doc",
            "css_border_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_start_color
    ///
    /// Whether a document used the CSS property border-inline-start-color. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            928,
            "use.counter.css.doc",
            "css_border_inline_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_start_style
    ///
    /// Whether a document used the CSS property border-inline-start-style. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            929,
            "use.counter.css.doc",
            "css_border_inline_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_start_width
    ///
    /// Whether a document used the CSS property border-inline-start-width. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            930,
            "use.counter.css.doc",
            "css_border_inline_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_style
    ///
    /// Whether a document used the CSS property border-inline-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            931,
            "use.counter.css.doc",
            "css_border_inline_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_width
    ///
    /// Whether a document used the CSS property border-inline-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            932,
            "use.counter.css.doc",
            "css_border_inline_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_left
    ///
    /// Whether a document used the CSS property border-left. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            933,
            "use.counter.css.doc",
            "css_border_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_left_color
    ///
    /// Whether a document used the CSS property border-left-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_left_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            934,
            "use.counter.css.doc",
            "css_border_left_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_left_style
    ///
    /// Whether a document used the CSS property border-left-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_left_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            935,
            "use.counter.css.doc",
            "css_border_left_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_left_width
    ///
    /// Whether a document used the CSS property border-left-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_left_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            936,
            "use.counter.css.doc",
            "css_border_left_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_radius
    ///
    /// Whether a document used the CSS property border-radius. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            937,
            "use.counter.css.doc",
            "css_border_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_right
    ///
    /// Whether a document used the CSS property border-right. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            938,
            "use.counter.css.doc",
            "css_border_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_right_color
    ///
    /// Whether a document used the CSS property border-right-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_right_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            939,
            "use.counter.css.doc",
            "css_border_right_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_right_style
    ///
    /// Whether a document used the CSS property border-right-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_right_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            940,
            "use.counter.css.doc",
            "css_border_right_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_right_width
    ///
    /// Whether a document used the CSS property border-right-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_right_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            941,
            "use.counter.css.doc",
            "css_border_right_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_spacing
    ///
    /// Whether a document used the CSS property border-spacing. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            942,
            "use.counter.css.doc",
            "css_border_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_start_end_radius
    ///
    /// Whether a document used the CSS property border-start-end-radius. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_start_end_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            943,
            "use.counter.css.doc",
            "css_border_start_end_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_start_start_radius
    ///
    /// Whether a document used the CSS property border-start-start-radius. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_start_start_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            944,
            "use.counter.css.doc",
            "css_border_start_start_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_style
    ///
    /// Whether a document used the CSS property border-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            945,
            "use.counter.css.doc",
            "css_border_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_top
    ///
    /// Whether a document used the CSS property border-top. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            946,
            "use.counter.css.doc",
            "css_border_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_top_color
    ///
    /// Whether a document used the CSS property border-top-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_top_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            947,
            "use.counter.css.doc",
            "css_border_top_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_top_left_radius
    ///
    /// Whether a document used the CSS property border-top-left-radius. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_top_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            948,
            "use.counter.css.doc",
            "css_border_top_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_top_right_radius
    ///
    /// Whether a document used the CSS property border-top-right-radius. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_top_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            949,
            "use.counter.css.doc",
            "css_border_top_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_top_style
    ///
    /// Whether a document used the CSS property border-top-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_top_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            950,
            "use.counter.css.doc",
            "css_border_top_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_top_width
    ///
    /// Whether a document used the CSS property border-top-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_top_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            951,
            "use.counter.css.doc",
            "css_border_top_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_width
    ///
    /// Whether a document used the CSS property border-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            952,
            "use.counter.css.doc",
            "css_border_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_bottom
    ///
    /// Whether a document used the CSS property bottom. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            953,
            "use.counter.css.doc",
            "css_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_box_decoration_break
    ///
    /// Whether a document used the CSS property box-decoration-break. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_box_decoration_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            954,
            "use.counter.css.doc",
            "css_box_decoration_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_box_shadow
    ///
    /// Whether a document used the CSS property box-shadow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_box_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            955,
            "use.counter.css.doc",
            "css_box_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_box_sizing
    ///
    /// Whether a document used the CSS property box-sizing. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_box_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            956,
            "use.counter.css.doc",
            "css_box_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_break_after
    ///
    /// Whether a document used the CSS property break-after. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_break_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            957,
            "use.counter.css.doc",
            "css_break_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_break_before
    ///
    /// Whether a document used the CSS property break-before. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_break_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            958,
            "use.counter.css.doc",
            "css_break_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_break_inside
    ///
    /// Whether a document used the CSS property break-inside. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_break_inside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            959,
            "use.counter.css.doc",
            "css_break_inside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_caption_side
    ///
    /// Whether a document used the CSS property caption-side. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_caption_side: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            960,
            "use.counter.css.doc",
            "css_caption_side",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_caret_color
    ///
    /// Whether a document used the CSS property caret-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_caret_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            961,
            "use.counter.css.doc",
            "css_caret_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_clear
    ///
    /// Whether a document used the CSS property clear. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_clear: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            962,
            "use.counter.css.doc",
            "css_clear",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_clip
    ///
    /// Whether a document used the CSS property clip. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            963,
            "use.counter.css.doc",
            "css_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_clip_path
    ///
    /// Whether a document used the CSS property clip-path. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_clip_path: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            964,
            "use.counter.css.doc",
            "css_clip_path",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_clip_rule
    ///
    /// Whether a document used the CSS property clip-rule. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_clip_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            965,
            "use.counter.css.doc",
            "css_clip_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_color
    ///
    /// Whether a document used the CSS property color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            966,
            "use.counter.css.doc",
            "css_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_color_adjust
    ///
    /// Whether a document used the CSS property color-adjust. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            967,
            "use.counter.css.doc",
            "css_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_color_interpolation
    ///
    /// Whether a document used the CSS property color-interpolation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_color_interpolation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            968,
            "use.counter.css.doc",
            "css_color_interpolation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_color_interpolation_filters
    ///
    /// Whether a document used the CSS property color-interpolation-filters. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_color_interpolation_filters: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            969,
            "use.counter.css.doc",
            "css_color_interpolation_filters",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_color_scheme
    ///
    /// Whether a document used the CSS property color-scheme. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_color_scheme: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            970,
            "use.counter.css.doc",
            "css_color_scheme",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_count
    ///
    /// Whether a document used the CSS property column-count. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            971,
            "use.counter.css.doc",
            "css_column_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_fill
    ///
    /// Whether a document used the CSS property column-fill. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_fill: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            972,
            "use.counter.css.doc",
            "css_column_fill",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_gap
    ///
    /// Whether a document used the CSS property column-gap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            973,
            "use.counter.css.doc",
            "css_column_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_rule
    ///
    /// Whether a document used the CSS property column-rule. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            974,
            "use.counter.css.doc",
            "css_column_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_rule_color
    ///
    /// Whether a document used the CSS property column-rule-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_rule_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            975,
            "use.counter.css.doc",
            "css_column_rule_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_rule_style
    ///
    /// Whether a document used the CSS property column-rule-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_rule_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            976,
            "use.counter.css.doc",
            "css_column_rule_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_rule_width
    ///
    /// Whether a document used the CSS property column-rule-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_rule_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            977,
            "use.counter.css.doc",
            "css_column_rule_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_span
    ///
    /// Whether a document used the CSS property column-span. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_span: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            978,
            "use.counter.css.doc",
            "css_column_span",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_width
    ///
    /// Whether a document used the CSS property column-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            979,
            "use.counter.css.doc",
            "css_column_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_columns
    ///
    /// Whether a document used the CSS property columns. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            980,
            "use.counter.css.doc",
            "css_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_contain
    ///
    /// Whether a document used the CSS property contain. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_contain: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            981,
            "use.counter.css.doc",
            "css_contain",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_contain_intrinsic_block_size
    ///
    /// Whether a document used the CSS property contain-intrinsic-block-size. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            982,
            "use.counter.css.doc",
            "css_contain_intrinsic_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_contain_intrinsic_height
    ///
    /// Whether a document used the CSS property contain-intrinsic-height. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            983,
            "use.counter.css.doc",
            "css_contain_intrinsic_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_contain_intrinsic_inline_size
    ///
    /// Whether a document used the CSS property contain-intrinsic-inline-size. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            984,
            "use.counter.css.doc",
            "css_contain_intrinsic_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_contain_intrinsic_size
    ///
    /// Whether a document used the CSS property contain-intrinsic-size. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            985,
            "use.counter.css.doc",
            "css_contain_intrinsic_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_contain_intrinsic_width
    ///
    /// Whether a document used the CSS property contain-intrinsic-width. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            986,
            "use.counter.css.doc",
            "css_contain_intrinsic_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_container
    ///
    /// Whether a document used the CSS property container. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_container: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            987,
            "use.counter.css.doc",
            "css_container",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_container_name
    ///
    /// Whether a document used the CSS property container-name. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_container_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            988,
            "use.counter.css.doc",
            "css_container_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_container_type
    ///
    /// Whether a document used the CSS property container-type. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_container_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            989,
            "use.counter.css.doc",
            "css_container_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_content
    ///
    /// Whether a document used the CSS property content. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            990,
            "use.counter.css.doc",
            "css_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_content_visibility
    ///
    /// Whether a document used the CSS property content-visibility. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_content_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            991,
            "use.counter.css.doc",
            "css_content_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_counter_increment
    ///
    /// Whether a document used the CSS property counter-increment. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_counter_increment: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            992,
            "use.counter.css.doc",
            "css_counter_increment",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_counter_reset
    ///
    /// Whether a document used the CSS property counter-reset. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_counter_reset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            993,
            "use.counter.css.doc",
            "css_counter_reset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_counter_set
    ///
    /// Whether a document used the CSS property counter-set. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_counter_set: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            994,
            "use.counter.css.doc",
            "css_counter_set",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_cursor
    ///
    /// Whether a document used the CSS property cursor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_cursor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            995,
            "use.counter.css.doc",
            "css_cursor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_cx
    ///
    /// Whether a document used the CSS property cx. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_cx: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            996,
            "use.counter.css.doc",
            "css_cx",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_cy
    ///
    /// Whether a document used the CSS property cy. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_cy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            997,
            "use.counter.css.doc",
            "css_cy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_d
    ///
    /// Whether a document used the CSS property d. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_d: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            998,
            "use.counter.css.doc",
            "css_d",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_direction
    ///
    /// Whether a document used the CSS property direction. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            999,
            "use.counter.css.doc",
            "css_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_display
    ///
    /// Whether a document used the CSS property display. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_display: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1000,
            "use.counter.css.doc",
            "css_display",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_dominant_baseline
    ///
    /// Whether a document used the CSS property dominant-baseline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_dominant_baseline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1001,
            "use.counter.css.doc",
            "css_dominant_baseline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_empty_cells
    ///
    /// Whether a document used the CSS property empty-cells. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_empty_cells: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1002,
            "use.counter.css.doc",
            "css_empty_cells",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_field_sizing
    ///
    /// Whether a document used the CSS property field-sizing. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_field_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1003,
            "use.counter.css.doc",
            "css_field_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_fill
    ///
    /// Whether a document used the CSS property fill. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_fill: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1004,
            "use.counter.css.doc",
            "css_fill",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_fill_opacity
    ///
    /// Whether a document used the CSS property fill-opacity. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_fill_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1005,
            "use.counter.css.doc",
            "css_fill_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_fill_rule
    ///
    /// Whether a document used the CSS property fill-rule. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_fill_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1006,
            "use.counter.css.doc",
            "css_fill_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_filter
    ///
    /// Whether a document used the CSS property filter. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_filter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1007,
            "use.counter.css.doc",
            "css_filter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flex
    ///
    /// Whether a document used the CSS property flex. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1008,
            "use.counter.css.doc",
            "css_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flex_basis
    ///
    /// Whether a document used the CSS property flex-basis. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flex_basis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1009,
            "use.counter.css.doc",
            "css_flex_basis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flex_direction
    ///
    /// Whether a document used the CSS property flex-direction. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flex_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1010,
            "use.counter.css.doc",
            "css_flex_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flex_flow
    ///
    /// Whether a document used the CSS property flex-flow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flex_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1011,
            "use.counter.css.doc",
            "css_flex_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flex_grow
    ///
    /// Whether a document used the CSS property flex-grow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flex_grow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1012,
            "use.counter.css.doc",
            "css_flex_grow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flex_shrink
    ///
    /// Whether a document used the CSS property flex-shrink. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flex_shrink: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1013,
            "use.counter.css.doc",
            "css_flex_shrink",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flex_wrap
    ///
    /// Whether a document used the CSS property flex-wrap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flex_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1014,
            "use.counter.css.doc",
            "css_flex_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_float
    ///
    /// Whether a document used the CSS property float. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_float: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1015,
            "use.counter.css.doc",
            "css_float",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flood_color
    ///
    /// Whether a document used the CSS property flood-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flood_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1016,
            "use.counter.css.doc",
            "css_flood_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flood_opacity
    ///
    /// Whether a document used the CSS property flood-opacity. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flood_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1017,
            "use.counter.css.doc",
            "css_flood_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font
    ///
    /// Whether a document used the CSS property font. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1018,
            "use.counter.css.doc",
            "css_font",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_family
    ///
    /// Whether a document used the CSS property font-family. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_family: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1019,
            "use.counter.css.doc",
            "css_font_family",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_feature_settings
    ///
    /// Whether a document used the CSS property font-feature-settings. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_feature_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1020,
            "use.counter.css.doc",
            "css_font_feature_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_kerning
    ///
    /// Whether a document used the CSS property font-kerning. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_kerning: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1021,
            "use.counter.css.doc",
            "css_font_kerning",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_language_override
    ///
    /// Whether a document used the CSS property font-language-override. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_language_override: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1022,
            "use.counter.css.doc",
            "css_font_language_override",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_optical_sizing
    ///
    /// Whether a document used the CSS property font-optical-sizing. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_optical_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1023,
            "use.counter.css.doc",
            "css_font_optical_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_palette
    ///
    /// Whether a document used the CSS property font-palette. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_palette: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1024,
            "use.counter.css.doc",
            "css_font_palette",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_size
    ///
    /// Whether a document used the CSS property font-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1025,
            "use.counter.css.doc",
            "css_font_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_size_adjust
    ///
    /// Whether a document used the CSS property font-size-adjust. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1026,
            "use.counter.css.doc",
            "css_font_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_stretch
    ///
    /// Whether a document used the CSS property font-stretch. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_stretch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1027,
            "use.counter.css.doc",
            "css_font_stretch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_style
    ///
    /// Whether a document used the CSS property font-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1028,
            "use.counter.css.doc",
            "css_font_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_synthesis
    ///
    /// Whether a document used the CSS property font-synthesis. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1029,
            "use.counter.css.doc",
            "css_font_synthesis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_synthesis_position
    ///
    /// Whether a document used the CSS property font-synthesis-position. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1030,
            "use.counter.css.doc",
            "css_font_synthesis_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_synthesis_small_caps
    ///
    /// Whether a document used the CSS property font-synthesis-small-caps. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_small_caps: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1031,
            "use.counter.css.doc",
            "css_font_synthesis_small_caps",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_synthesis_style
    ///
    /// Whether a document used the CSS property font-synthesis-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1032,
            "use.counter.css.doc",
            "css_font_synthesis_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_synthesis_weight
    ///
    /// Whether a document used the CSS property font-synthesis-weight. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_weight: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1033,
            "use.counter.css.doc",
            "css_font_synthesis_weight",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant
    ///
    /// Whether a document used the CSS property font-variant. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1034,
            "use.counter.css.doc",
            "css_font_variant",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant_alternates
    ///
    /// Whether a document used the CSS property font-variant-alternates. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_alternates: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1035,
            "use.counter.css.doc",
            "css_font_variant_alternates",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant_caps
    ///
    /// Whether a document used the CSS property font-variant-caps. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_caps: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1036,
            "use.counter.css.doc",
            "css_font_variant_caps",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant_east_asian
    ///
    /// Whether a document used the CSS property font-variant-east-asian. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_east_asian: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1037,
            "use.counter.css.doc",
            "css_font_variant_east_asian",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant_emoji
    ///
    /// Whether a document used the CSS property font-variant-emoji. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_emoji: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1038,
            "use.counter.css.doc",
            "css_font_variant_emoji",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant_ligatures
    ///
    /// Whether a document used the CSS property font-variant-ligatures. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_ligatures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1039,
            "use.counter.css.doc",
            "css_font_variant_ligatures",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant_numeric
    ///
    /// Whether a document used the CSS property font-variant-numeric. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_numeric: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1040,
            "use.counter.css.doc",
            "css_font_variant_numeric",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant_position
    ///
    /// Whether a document used the CSS property font-variant-position. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1041,
            "use.counter.css.doc",
            "css_font_variant_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variation_settings
    ///
    /// Whether a document used the CSS property font-variation-settings. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variation_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1042,
            "use.counter.css.doc",
            "css_font_variation_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_weight
    ///
    /// Whether a document used the CSS property font-weight. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_weight: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1043,
            "use.counter.css.doc",
            "css_font_weight",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_forced_color_adjust
    ///
    /// Whether a document used the CSS property forced-color-adjust. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_forced_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1044,
            "use.counter.css.doc",
            "css_forced_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_gap
    ///
    /// Whether a document used the CSS property gap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1045,
            "use.counter.css.doc",
            "css_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid
    ///
    /// Whether a document used the CSS property grid. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1046,
            "use.counter.css.doc",
            "css_grid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_area
    ///
    /// Whether a document used the CSS property grid-area. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_area: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1047,
            "use.counter.css.doc",
            "css_grid_area",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_auto_columns
    ///
    /// Whether a document used the CSS property grid-auto-columns. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_auto_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1048,
            "use.counter.css.doc",
            "css_grid_auto_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_auto_flow
    ///
    /// Whether a document used the CSS property grid-auto-flow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_auto_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1049,
            "use.counter.css.doc",
            "css_grid_auto_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_auto_rows
    ///
    /// Whether a document used the CSS property grid-auto-rows. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_auto_rows: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1050,
            "use.counter.css.doc",
            "css_grid_auto_rows",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_column
    ///
    /// Whether a document used the CSS property grid-column. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_column: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1051,
            "use.counter.css.doc",
            "css_grid_column",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_column_end
    ///
    /// Whether a document used the CSS property grid-column-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_column_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1052,
            "use.counter.css.doc",
            "css_grid_column_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_column_gap
    ///
    /// Whether a document used the CSS property grid-column-gap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_column_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1053,
            "use.counter.css.doc",
            "css_grid_column_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_column_start
    ///
    /// Whether a document used the CSS property grid-column-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_column_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1054,
            "use.counter.css.doc",
            "css_grid_column_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_gap
    ///
    /// Whether a document used the CSS property grid-gap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1055,
            "use.counter.css.doc",
            "css_grid_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_row
    ///
    /// Whether a document used the CSS property grid-row. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_row: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1056,
            "use.counter.css.doc",
            "css_grid_row",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_row_end
    ///
    /// Whether a document used the CSS property grid-row-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_row_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1057,
            "use.counter.css.doc",
            "css_grid_row_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_row_gap
    ///
    /// Whether a document used the CSS property grid-row-gap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_row_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1058,
            "use.counter.css.doc",
            "css_grid_row_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_row_start
    ///
    /// Whether a document used the CSS property grid-row-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_row_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1059,
            "use.counter.css.doc",
            "css_grid_row_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_template
    ///
    /// Whether a document used the CSS property grid-template. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_template: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1060,
            "use.counter.css.doc",
            "css_grid_template",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_template_areas
    ///
    /// Whether a document used the CSS property grid-template-areas. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_template_areas: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1061,
            "use.counter.css.doc",
            "css_grid_template_areas",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_template_columns
    ///
    /// Whether a document used the CSS property grid-template-columns. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_template_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1062,
            "use.counter.css.doc",
            "css_grid_template_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_template_rows
    ///
    /// Whether a document used the CSS property grid-template-rows. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_template_rows: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1063,
            "use.counter.css.doc",
            "css_grid_template_rows",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_height
    ///
    /// Whether a document used the CSS property height. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1064,
            "use.counter.css.doc",
            "css_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_hyphenate_character
    ///
    /// Whether a document used the CSS property hyphenate-character. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_hyphenate_character: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1065,
            "use.counter.css.doc",
            "css_hyphenate_character",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_hyphens
    ///
    /// Whether a document used the CSS property hyphens. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_hyphens: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1066,
            "use.counter.css.doc",
            "css_hyphens",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_image_orientation
    ///
    /// Whether a document used the CSS property image-orientation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_image_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1067,
            "use.counter.css.doc",
            "css_image_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_image_rendering
    ///
    /// Whether a document used the CSS property image-rendering. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_image_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1068,
            "use.counter.css.doc",
            "css_image_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_ime_mode
    ///
    /// Whether a document used the CSS property ime-mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_ime_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1069,
            "use.counter.css.doc",
            "css_ime_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_initial_letter
    ///
    /// Whether a document used the CSS property initial-letter. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_initial_letter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1070,
            "use.counter.css.doc",
            "css_initial_letter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inline_size
    ///
    /// Whether a document used the CSS property inline-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1071,
            "use.counter.css.doc",
            "css_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset
    ///
    /// Whether a document used the CSS property inset. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1072,
            "use.counter.css.doc",
            "css_inset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset_block
    ///
    /// Whether a document used the CSS property inset-block. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1073,
            "use.counter.css.doc",
            "css_inset_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset_block_end
    ///
    /// Whether a document used the CSS property inset-block-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1074,
            "use.counter.css.doc",
            "css_inset_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset_block_start
    ///
    /// Whether a document used the CSS property inset-block-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1075,
            "use.counter.css.doc",
            "css_inset_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset_inline
    ///
    /// Whether a document used the CSS property inset-inline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1076,
            "use.counter.css.doc",
            "css_inset_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset_inline_end
    ///
    /// Whether a document used the CSS property inset-inline-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1077,
            "use.counter.css.doc",
            "css_inset_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset_inline_start
    ///
    /// Whether a document used the CSS property inset-inline-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1078,
            "use.counter.css.doc",
            "css_inset_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_isolation
    ///
    /// Whether a document used the CSS property isolation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_isolation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1079,
            "use.counter.css.doc",
            "css_isolation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_justify_content
    ///
    /// Whether a document used the CSS property justify-content. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_justify_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1080,
            "use.counter.css.doc",
            "css_justify_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_justify_items
    ///
    /// Whether a document used the CSS property justify-items. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_justify_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1081,
            "use.counter.css.doc",
            "css_justify_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_justify_self
    ///
    /// Whether a document used the CSS property justify-self. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_justify_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1082,
            "use.counter.css.doc",
            "css_justify_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_left
    ///
    /// Whether a document used the CSS property left. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1083,
            "use.counter.css.doc",
            "css_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_letter_spacing
    ///
    /// Whether a document used the CSS property letter-spacing. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_letter_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1084,
            "use.counter.css.doc",
            "css_letter_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_lighting_color
    ///
    /// Whether a document used the CSS property lighting-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_lighting_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1085,
            "use.counter.css.doc",
            "css_lighting_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_line_break
    ///
    /// Whether a document used the CSS property line-break. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_line_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1086,
            "use.counter.css.doc",
            "css_line_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_line_height
    ///
    /// Whether a document used the CSS property line-height. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_line_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1087,
            "use.counter.css.doc",
            "css_line_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_list_style
    ///
    /// Whether a document used the CSS property list-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_list_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1088,
            "use.counter.css.doc",
            "css_list_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_list_style_image
    ///
    /// Whether a document used the CSS property list-style-image. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_list_style_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1089,
            "use.counter.css.doc",
            "css_list_style_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_list_style_position
    ///
    /// Whether a document used the CSS property list-style-position. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_list_style_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1090,
            "use.counter.css.doc",
            "css_list_style_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_list_style_type
    ///
    /// Whether a document used the CSS property list-style-type. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_list_style_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1091,
            "use.counter.css.doc",
            "css_list_style_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin
    ///
    /// Whether a document used the CSS property margin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1092,
            "use.counter.css.doc",
            "css_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_block
    ///
    /// Whether a document used the CSS property margin-block. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1093,
            "use.counter.css.doc",
            "css_margin_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_block_end
    ///
    /// Whether a document used the CSS property margin-block-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1094,
            "use.counter.css.doc",
            "css_margin_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_block_start
    ///
    /// Whether a document used the CSS property margin-block-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1095,
            "use.counter.css.doc",
            "css_margin_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_bottom
    ///
    /// Whether a document used the CSS property margin-bottom. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1096,
            "use.counter.css.doc",
            "css_margin_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_inline
    ///
    /// Whether a document used the CSS property margin-inline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1097,
            "use.counter.css.doc",
            "css_margin_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_inline_end
    ///
    /// Whether a document used the CSS property margin-inline-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1098,
            "use.counter.css.doc",
            "css_margin_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_inline_start
    ///
    /// Whether a document used the CSS property margin-inline-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1099,
            "use.counter.css.doc",
            "css_margin_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_left
    ///
    /// Whether a document used the CSS property margin-left. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1100,
            "use.counter.css.doc",
            "css_margin_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_right
    ///
    /// Whether a document used the CSS property margin-right. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1101,
            "use.counter.css.doc",
            "css_margin_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_top
    ///
    /// Whether a document used the CSS property margin-top. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1102,
            "use.counter.css.doc",
            "css_margin_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_marker
    ///
    /// Whether a document used the CSS property marker. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_marker: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1103,
            "use.counter.css.doc",
            "css_marker",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_marker_end
    ///
    /// Whether a document used the CSS property marker-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_marker_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1104,
            "use.counter.css.doc",
            "css_marker_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_marker_mid
    ///
    /// Whether a document used the CSS property marker-mid. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_marker_mid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1105,
            "use.counter.css.doc",
            "css_marker_mid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_marker_start
    ///
    /// Whether a document used the CSS property marker-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_marker_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1106,
            "use.counter.css.doc",
            "css_marker_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask
    ///
    /// Whether a document used the CSS property mask. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1107,
            "use.counter.css.doc",
            "css_mask",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_clip
    ///
    /// Whether a document used the CSS property mask-clip. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1108,
            "use.counter.css.doc",
            "css_mask_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_composite
    ///
    /// Whether a document used the CSS property mask-composite. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_composite: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1109,
            "use.counter.css.doc",
            "css_mask_composite",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_image
    ///
    /// Whether a document used the CSS property mask-image. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1110,
            "use.counter.css.doc",
            "css_mask_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_mode
    ///
    /// Whether a document used the CSS property mask-mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1111,
            "use.counter.css.doc",
            "css_mask_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_origin
    ///
    /// Whether a document used the CSS property mask-origin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1112,
            "use.counter.css.doc",
            "css_mask_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_position
    ///
    /// Whether a document used the CSS property mask-position. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1113,
            "use.counter.css.doc",
            "css_mask_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_position_x
    ///
    /// Whether a document used the CSS property mask-position-x. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_position_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1114,
            "use.counter.css.doc",
            "css_mask_position_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_position_y
    ///
    /// Whether a document used the CSS property mask-position-y. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_position_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1115,
            "use.counter.css.doc",
            "css_mask_position_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_repeat
    ///
    /// Whether a document used the CSS property mask-repeat. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1116,
            "use.counter.css.doc",
            "css_mask_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_size
    ///
    /// Whether a document used the CSS property mask-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1117,
            "use.counter.css.doc",
            "css_mask_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_type
    ///
    /// Whether a document used the CSS property mask-type. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1118,
            "use.counter.css.doc",
            "css_mask_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_masonry_auto_flow
    ///
    /// Whether a document used the CSS property masonry-auto-flow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_masonry_auto_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1119,
            "use.counter.css.doc",
            "css_masonry_auto_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_math_depth
    ///
    /// Whether a document used the CSS property math-depth. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_math_depth: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1120,
            "use.counter.css.doc",
            "css_math_depth",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_math_style
    ///
    /// Whether a document used the CSS property math-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_math_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1121,
            "use.counter.css.doc",
            "css_math_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_max_block_size
    ///
    /// Whether a document used the CSS property max-block-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_max_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1122,
            "use.counter.css.doc",
            "css_max_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_max_height
    ///
    /// Whether a document used the CSS property max-height. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_max_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1123,
            "use.counter.css.doc",
            "css_max_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_max_inline_size
    ///
    /// Whether a document used the CSS property max-inline-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_max_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1124,
            "use.counter.css.doc",
            "css_max_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_max_width
    ///
    /// Whether a document used the CSS property max-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_max_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1125,
            "use.counter.css.doc",
            "css_max_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_min_block_size
    ///
    /// Whether a document used the CSS property min-block-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_min_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1126,
            "use.counter.css.doc",
            "css_min_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_min_height
    ///
    /// Whether a document used the CSS property min-height. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_min_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1127,
            "use.counter.css.doc",
            "css_min_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_min_inline_size
    ///
    /// Whether a document used the CSS property min-inline-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_min_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1128,
            "use.counter.css.doc",
            "css_min_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_min_width
    ///
    /// Whether a document used the CSS property min-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_min_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1129,
            "use.counter.css.doc",
            "css_min_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mix_blend_mode
    ///
    /// Whether a document used the CSS property mix-blend-mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mix_blend_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1130,
            "use.counter.css.doc",
            "css_mix_blend_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation
    ///
    /// Whether a document used the CSS property -moz-animation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1131,
            "use.counter.css.doc",
            "css_moz_animation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_delay
    ///
    /// Whether a document used the CSS property -moz-animation-delay. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1132,
            "use.counter.css.doc",
            "css_moz_animation_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_direction
    ///
    /// Whether a document used the CSS property -moz-animation-direction. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1133,
            "use.counter.css.doc",
            "css_moz_animation_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_duration
    ///
    /// Whether a document used the CSS property -moz-animation-duration. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1134,
            "use.counter.css.doc",
            "css_moz_animation_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_fill_mode
    ///
    /// Whether a document used the CSS property -moz-animation-fill-mode. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_fill_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1135,
            "use.counter.css.doc",
            "css_moz_animation_fill_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_iteration_count
    ///
    /// Whether a document used the CSS property -moz-animation-iteration-count.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_animation_iteration_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1136,
            "use.counter.css.doc",
            "css_moz_animation_iteration_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_name
    ///
    /// Whether a document used the CSS property -moz-animation-name. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1137,
            "use.counter.css.doc",
            "css_moz_animation_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_play_state
    ///
    /// Whether a document used the CSS property -moz-animation-play-state. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_play_state: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1138,
            "use.counter.css.doc",
            "css_moz_animation_play_state",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_timing_function
    ///
    /// Whether a document used the CSS property -moz-animation-timing-function.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_animation_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1139,
            "use.counter.css.doc",
            "css_moz_animation_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_appearance
    ///
    /// Whether a document used the CSS property -moz-appearance. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1140,
            "use.counter.css.doc",
            "css_moz_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_backface_visibility
    ///
    /// Whether a document used the CSS property -moz-backface-visibility. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_backface_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1141,
            "use.counter.css.doc",
            "css_moz_backface_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_end
    ///
    /// Whether a document used the CSS property -moz-border-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1142,
            "use.counter.css.doc",
            "css_moz_border_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_end_color
    ///
    /// Whether a document used the CSS property -moz-border-end-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1143,
            "use.counter.css.doc",
            "css_moz_border_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_end_style
    ///
    /// Whether a document used the CSS property -moz-border-end-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1144,
            "use.counter.css.doc",
            "css_moz_border_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_end_width
    ///
    /// Whether a document used the CSS property -moz-border-end-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1145,
            "use.counter.css.doc",
            "css_moz_border_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_image
    ///
    /// Whether a document used the CSS property -moz-border-image. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1146,
            "use.counter.css.doc",
            "css_moz_border_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_start
    ///
    /// Whether a document used the CSS property -moz-border-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1147,
            "use.counter.css.doc",
            "css_moz_border_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_start_color
    ///
    /// Whether a document used the CSS property -moz-border-start-color. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1148,
            "use.counter.css.doc",
            "css_moz_border_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_start_style
    ///
    /// Whether a document used the CSS property -moz-border-start-style. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1149,
            "use.counter.css.doc",
            "css_moz_border_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_start_width
    ///
    /// Whether a document used the CSS property -moz-border-start-width. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1150,
            "use.counter.css.doc",
            "css_moz_border_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_align
    ///
    /// Whether a document used the CSS property -moz-box-align. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1151,
            "use.counter.css.doc",
            "css_moz_box_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_collapse
    ///
    /// Whether a document used the CSS property -moz-box-collapse. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1152,
            "use.counter.css.doc",
            "css_moz_box_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_direction
    ///
    /// Whether a document used the CSS property -moz-box-direction. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1153,
            "use.counter.css.doc",
            "css_moz_box_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_flex
    ///
    /// Whether a document used the CSS property -moz-box-flex. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1154,
            "use.counter.css.doc",
            "css_moz_box_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_ordinal_group
    ///
    /// Whether a document used the CSS property -moz-box-ordinal-group. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_ordinal_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1155,
            "use.counter.css.doc",
            "css_moz_box_ordinal_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_orient
    ///
    /// Whether a document used the CSS property -moz-box-orient. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_orient: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1156,
            "use.counter.css.doc",
            "css_moz_box_orient",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_pack
    ///
    /// Whether a document used the CSS property -moz-box-pack. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_pack: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1157,
            "use.counter.css.doc",
            "css_moz_box_pack",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_sizing
    ///
    /// Whether a document used the CSS property -moz-box-sizing. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1158,
            "use.counter.css.doc",
            "css_moz_box_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_context_properties
    ///
    /// Whether a document used the CSS property -moz-context-properties. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_context_properties: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1159,
            "use.counter.css.doc",
            "css_moz_context_properties",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_control_character_visibility
    ///
    /// Whether a document used the CSS property -moz-control-character-visibility.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_control_character_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1160,
            "use.counter.css.doc",
            "css_moz_control_character_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_default_appearance
    ///
    /// Whether a document used the CSS property -moz-default-appearance. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_default_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1161,
            "use.counter.css.doc",
            "css_moz_default_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_float_edge
    ///
    /// Whether a document used the CSS property -moz-float-edge. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_float_edge: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1162,
            "use.counter.css.doc",
            "css_moz_float_edge",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_font_feature_settings
    ///
    /// Whether a document used the CSS property -moz-font-feature-settings. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_font_feature_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1163,
            "use.counter.css.doc",
            "css_moz_font_feature_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_font_language_override
    ///
    /// Whether a document used the CSS property -moz-font-language-override. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_font_language_override: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1164,
            "use.counter.css.doc",
            "css_moz_font_language_override",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_force_broken_image_icon
    ///
    /// Whether a document used the CSS property -moz-force-broken-image-icon. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_force_broken_image_icon: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1165,
            "use.counter.css.doc",
            "css_moz_force_broken_image_icon",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_hyphens
    ///
    /// Whether a document used the CSS property -moz-hyphens. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_hyphens: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1166,
            "use.counter.css.doc",
            "css_moz_hyphens",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_inert
    ///
    /// Whether a document used the CSS property -moz-inert. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_inert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1167,
            "use.counter.css.doc",
            "css_moz_inert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_margin_end
    ///
    /// Whether a document used the CSS property -moz-margin-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_margin_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1168,
            "use.counter.css.doc",
            "css_moz_margin_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_margin_start
    ///
    /// Whether a document used the CSS property -moz-margin-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_margin_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1169,
            "use.counter.css.doc",
            "css_moz_margin_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_math_variant
    ///
    /// Whether a document used the CSS property -moz-math-variant. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_math_variant: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1170,
            "use.counter.css.doc",
            "css_moz_math_variant",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_min_font_size_ratio
    ///
    /// Whether a document used the CSS property -moz-min-font-size-ratio. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_min_font_size_ratio: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1171,
            "use.counter.css.doc",
            "css_moz_min_font_size_ratio",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_orient
    ///
    /// Whether a document used the CSS property -moz-orient. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_orient: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1172,
            "use.counter.css.doc",
            "css_moz_orient",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_osx_font_smoothing
    ///
    /// Whether a document used the CSS property -moz-osx-font-smoothing. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_osx_font_smoothing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1173,
            "use.counter.css.doc",
            "css_moz_osx_font_smoothing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_padding_end
    ///
    /// Whether a document used the CSS property -moz-padding-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_padding_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1174,
            "use.counter.css.doc",
            "css_moz_padding_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_padding_start
    ///
    /// Whether a document used the CSS property -moz-padding-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_padding_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1175,
            "use.counter.css.doc",
            "css_moz_padding_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_perspective
    ///
    /// Whether a document used the CSS property -moz-perspective. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_perspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1176,
            "use.counter.css.doc",
            "css_moz_perspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_perspective_origin
    ///
    /// Whether a document used the CSS property -moz-perspective-origin. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_perspective_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1177,
            "use.counter.css.doc",
            "css_moz_perspective_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_subtree_hidden_only_visually
    ///
    /// Whether a document used the CSS property -moz-subtree-hidden-only-visually.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_subtree_hidden_only_visually: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1178,
            "use.counter.css.doc",
            "css_moz_subtree_hidden_only_visually",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_tab_size
    ///
    /// Whether a document used the CSS property -moz-tab-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_tab_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1179,
            "use.counter.css.doc",
            "css_moz_tab_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_text_size_adjust
    ///
    /// Whether a document used the CSS property -moz-text-size-adjust. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_text_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1180,
            "use.counter.css.doc",
            "css_moz_text_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_theme
    ///
    /// Whether a document used the CSS property -moz-theme. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_theme: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1181,
            "use.counter.css.doc",
            "css_moz_theme",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_top_layer
    ///
    /// Whether a document used the CSS property -moz-top-layer. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_top_layer: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1182,
            "use.counter.css.doc",
            "css_moz_top_layer",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transform
    ///
    /// Whether a document used the CSS property -moz-transform. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1183,
            "use.counter.css.doc",
            "css_moz_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transform_origin
    ///
    /// Whether a document used the CSS property -moz-transform-origin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1184,
            "use.counter.css.doc",
            "css_moz_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transform_style
    ///
    /// Whether a document used the CSS property -moz-transform-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transform_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1185,
            "use.counter.css.doc",
            "css_moz_transform_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transition
    ///
    /// Whether a document used the CSS property -moz-transition. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1186,
            "use.counter.css.doc",
            "css_moz_transition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transition_delay
    ///
    /// Whether a document used the CSS property -moz-transition-delay. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1187,
            "use.counter.css.doc",
            "css_moz_transition_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transition_duration
    ///
    /// Whether a document used the CSS property -moz-transition-duration. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1188,
            "use.counter.css.doc",
            "css_moz_transition_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transition_property
    ///
    /// Whether a document used the CSS property -moz-transition-property. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition_property: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1189,
            "use.counter.css.doc",
            "css_moz_transition_property",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transition_timing_function
    ///
    /// Whether a document used the CSS property -moz-transition-timing-function.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_transition_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1190,
            "use.counter.css.doc",
            "css_moz_transition_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_user_focus
    ///
    /// Whether a document used the CSS property -moz-user-focus. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_focus: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1191,
            "use.counter.css.doc",
            "css_moz_user_focus",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_user_input
    ///
    /// Whether a document used the CSS property -moz-user-input. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_input: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1192,
            "use.counter.css.doc",
            "css_moz_user_input",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_user_modify
    ///
    /// Whether a document used the CSS property -moz-user-modify. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_modify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1193,
            "use.counter.css.doc",
            "css_moz_user_modify",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_user_select
    ///
    /// Whether a document used the CSS property -moz-user-select. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_select: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1194,
            "use.counter.css.doc",
            "css_moz_user_select",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_window_dragging
    ///
    /// Whether a document used the CSS property -moz-window-dragging. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_dragging: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1195,
            "use.counter.css.doc",
            "css_moz_window_dragging",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_window_input_region_margin
    ///
    /// Whether a document used the CSS property -moz-window-input-region-margin.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_window_input_region_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1196,
            "use.counter.css.doc",
            "css_moz_window_input_region_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_window_opacity
    ///
    /// Whether a document used the CSS property -moz-window-opacity. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1197,
            "use.counter.css.doc",
            "css_moz_window_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_window_shadow
    ///
    /// Whether a document used the CSS property -moz-window-shadow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1198,
            "use.counter.css.doc",
            "css_moz_window_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_window_transform
    ///
    /// Whether a document used the CSS property -moz-window-transform. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1199,
            "use.counter.css.doc",
            "css_moz_window_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_window_transform_origin
    ///
    /// Whether a document used the CSS property -moz-window-transform-origin. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1200,
            "use.counter.css.doc",
            "css_moz_window_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_object_fit
    ///
    /// Whether a document used the CSS property object-fit. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_object_fit: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1201,
            "use.counter.css.doc",
            "css_object_fit",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_object_position
    ///
    /// Whether a document used the CSS property object-position. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_object_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1202,
            "use.counter.css.doc",
            "css_object_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_offset
    ///
    /// Whether a document used the CSS property offset. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1203,
            "use.counter.css.doc",
            "css_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_offset_anchor
    ///
    /// Whether a document used the CSS property offset-anchor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_offset_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1204,
            "use.counter.css.doc",
            "css_offset_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_offset_distance
    ///
    /// Whether a document used the CSS property offset-distance. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_offset_distance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1205,
            "use.counter.css.doc",
            "css_offset_distance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_offset_path
    ///
    /// Whether a document used the CSS property offset-path. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_offset_path: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1206,
            "use.counter.css.doc",
            "css_offset_path",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_offset_position
    ///
    /// Whether a document used the CSS property offset-position. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_offset_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1207,
            "use.counter.css.doc",
            "css_offset_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_offset_rotate
    ///
    /// Whether a document used the CSS property offset-rotate. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_offset_rotate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1208,
            "use.counter.css.doc",
            "css_offset_rotate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_opacity
    ///
    /// Whether a document used the CSS property opacity. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1209,
            "use.counter.css.doc",
            "css_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_order
    ///
    /// Whether a document used the CSS property order. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1210,
            "use.counter.css.doc",
            "css_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_outline
    ///
    /// Whether a document used the CSS property outline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_outline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1211,
            "use.counter.css.doc",
            "css_outline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_outline_color
    ///
    /// Whether a document used the CSS property outline-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_outline_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1212,
            "use.counter.css.doc",
            "css_outline_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_outline_offset
    ///
    /// Whether a document used the CSS property outline-offset. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_outline_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1213,
            "use.counter.css.doc",
            "css_outline_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_outline_style
    ///
    /// Whether a document used the CSS property outline-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_outline_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1214,
            "use.counter.css.doc",
            "css_outline_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_outline_width
    ///
    /// Whether a document used the CSS property outline-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_outline_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1215,
            "use.counter.css.doc",
            "css_outline_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow
    ///
    /// Whether a document used the CSS property overflow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1216,
            "use.counter.css.doc",
            "css_overflow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_anchor
    ///
    /// Whether a document used the CSS property overflow-anchor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1217,
            "use.counter.css.doc",
            "css_overflow_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_block
    ///
    /// Whether a document used the CSS property overflow-block. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1218,
            "use.counter.css.doc",
            "css_overflow_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_clip_box
    ///
    /// Whether a document used the CSS property overflow-clip-box. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_box: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1219,
            "use.counter.css.doc",
            "css_overflow_clip_box",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_clip_box_block
    ///
    /// Whether a document used the CSS property overflow-clip-box-block. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_box_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1220,
            "use.counter.css.doc",
            "css_overflow_clip_box_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_clip_box_inline
    ///
    /// Whether a document used the CSS property overflow-clip-box-inline. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_box_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1221,
            "use.counter.css.doc",
            "css_overflow_clip_box_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_clip_margin
    ///
    /// Whether a document used the CSS property overflow-clip-margin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1222,
            "use.counter.css.doc",
            "css_overflow_clip_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_inline
    ///
    /// Whether a document used the CSS property overflow-inline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1223,
            "use.counter.css.doc",
            "css_overflow_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_wrap
    ///
    /// Whether a document used the CSS property overflow-wrap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1224,
            "use.counter.css.doc",
            "css_overflow_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_x
    ///
    /// Whether a document used the CSS property overflow-x. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1225,
            "use.counter.css.doc",
            "css_overflow_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_y
    ///
    /// Whether a document used the CSS property overflow-y. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1226,
            "use.counter.css.doc",
            "css_overflow_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overscroll_behavior
    ///
    /// Whether a document used the CSS property overscroll-behavior. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1227,
            "use.counter.css.doc",
            "css_overscroll_behavior",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overscroll_behavior_block
    ///
    /// Whether a document used the CSS property overscroll-behavior-block. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1228,
            "use.counter.css.doc",
            "css_overscroll_behavior_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overscroll_behavior_inline
    ///
    /// Whether a document used the CSS property overscroll-behavior-inline. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1229,
            "use.counter.css.doc",
            "css_overscroll_behavior_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overscroll_behavior_x
    ///
    /// Whether a document used the CSS property overscroll-behavior-x. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1230,
            "use.counter.css.doc",
            "css_overscroll_behavior_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overscroll_behavior_y
    ///
    /// Whether a document used the CSS property overscroll-behavior-y. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1231,
            "use.counter.css.doc",
            "css_overscroll_behavior_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding
    ///
    /// Whether a document used the CSS property padding. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1232,
            "use.counter.css.doc",
            "css_padding",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_block
    ///
    /// Whether a document used the CSS property padding-block. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1233,
            "use.counter.css.doc",
            "css_padding_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_block_end
    ///
    /// Whether a document used the CSS property padding-block-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1234,
            "use.counter.css.doc",
            "css_padding_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_block_start
    ///
    /// Whether a document used the CSS property padding-block-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1235,
            "use.counter.css.doc",
            "css_padding_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_bottom
    ///
    /// Whether a document used the CSS property padding-bottom. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1236,
            "use.counter.css.doc",
            "css_padding_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_inline
    ///
    /// Whether a document used the CSS property padding-inline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1237,
            "use.counter.css.doc",
            "css_padding_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_inline_end
    ///
    /// Whether a document used the CSS property padding-inline-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1238,
            "use.counter.css.doc",
            "css_padding_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_inline_start
    ///
    /// Whether a document used the CSS property padding-inline-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1239,
            "use.counter.css.doc",
            "css_padding_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_left
    ///
    /// Whether a document used the CSS property padding-left. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1240,
            "use.counter.css.doc",
            "css_padding_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_right
    ///
    /// Whether a document used the CSS property padding-right. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1241,
            "use.counter.css.doc",
            "css_padding_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_top
    ///
    /// Whether a document used the CSS property padding-top. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1242,
            "use.counter.css.doc",
            "css_padding_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_page
    ///
    /// Whether a document used the CSS property page. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_page: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1243,
            "use.counter.css.doc",
            "css_page",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_page_break_after
    ///
    /// Whether a document used the CSS property page-break-after. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_page_break_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1244,
            "use.counter.css.doc",
            "css_page_break_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_page_break_before
    ///
    /// Whether a document used the CSS property page-break-before. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_page_break_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1245,
            "use.counter.css.doc",
            "css_page_break_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_page_break_inside
    ///
    /// Whether a document used the CSS property page-break-inside. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_page_break_inside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1246,
            "use.counter.css.doc",
            "css_page_break_inside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_page_orientation
    ///
    /// Whether a document used the CSS property page-orientation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_page_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1247,
            "use.counter.css.doc",
            "css_page_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_paint_order
    ///
    /// Whether a document used the CSS property paint-order. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_paint_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1248,
            "use.counter.css.doc",
            "css_paint_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_perspective
    ///
    /// Whether a document used the CSS property perspective. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_perspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1249,
            "use.counter.css.doc",
            "css_perspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_perspective_origin
    ///
    /// Whether a document used the CSS property perspective-origin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_perspective_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1250,
            "use.counter.css.doc",
            "css_perspective_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_place_content
    ///
    /// Whether a document used the CSS property place-content. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_place_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1251,
            "use.counter.css.doc",
            "css_place_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_place_items
    ///
    /// Whether a document used the CSS property place-items. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_place_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1252,
            "use.counter.css.doc",
            "css_place_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_place_self
    ///
    /// Whether a document used the CSS property place-self. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_place_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1253,
            "use.counter.css.doc",
            "css_place_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_pointer_events
    ///
    /// Whether a document used the CSS property pointer-events. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_pointer_events: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1254,
            "use.counter.css.doc",
            "css_pointer_events",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_position
    ///
    /// Whether a document used the CSS property position. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1255,
            "use.counter.css.doc",
            "css_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_position_anchor
    ///
    /// Whether a document used the CSS property position-anchor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_position_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1256,
            "use.counter.css.doc",
            "css_position_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_position_area
    ///
    /// Whether a document used the CSS property position-area. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_position_area: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1257,
            "use.counter.css.doc",
            "css_position_area",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_position_try
    ///
    /// Whether a document used the CSS property position-try. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_position_try: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1258,
            "use.counter.css.doc",
            "css_position_try",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_position_try_fallbacks
    ///
    /// Whether a document used the CSS property position-try-fallbacks. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_position_try_fallbacks: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1259,
            "use.counter.css.doc",
            "css_position_try_fallbacks",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_position_try_order
    ///
    /// Whether a document used the CSS property position-try-order. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_position_try_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1260,
            "use.counter.css.doc",
            "css_position_try_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_position_visibility
    ///
    /// Whether a document used the CSS property position-visibility. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_position_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1261,
            "use.counter.css.doc",
            "css_position_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_print_color_adjust
    ///
    /// Whether a document used the CSS property print-color-adjust. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_print_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1262,
            "use.counter.css.doc",
            "css_print_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_quotes
    ///
    /// Whether a document used the CSS property quotes. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_quotes: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1263,
            "use.counter.css.doc",
            "css_quotes",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_r
    ///
    /// Whether a document used the CSS property r. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_r: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1264,
            "use.counter.css.doc",
            "css_r",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_resize
    ///
    /// Whether a document used the CSS property resize. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_resize: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1265,
            "use.counter.css.doc",
            "css_resize",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_right
    ///
    /// Whether a document used the CSS property right. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1266,
            "use.counter.css.doc",
            "css_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_rotate
    ///
    /// Whether a document used the CSS property rotate. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_rotate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1267,
            "use.counter.css.doc",
            "css_rotate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_row_gap
    ///
    /// Whether a document used the CSS property row-gap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_row_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1268,
            "use.counter.css.doc",
            "css_row_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_ruby_align
    ///
    /// Whether a document used the CSS property ruby-align. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_ruby_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1269,
            "use.counter.css.doc",
            "css_ruby_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_ruby_position
    ///
    /// Whether a document used the CSS property ruby-position. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_ruby_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1270,
            "use.counter.css.doc",
            "css_ruby_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_rx
    ///
    /// Whether a document used the CSS property rx. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_rx: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1271,
            "use.counter.css.doc",
            "css_rx",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_ry
    ///
    /// Whether a document used the CSS property ry. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_ry: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1272,
            "use.counter.css.doc",
            "css_ry",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scale
    ///
    /// Whether a document used the CSS property scale. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1273,
            "use.counter.css.doc",
            "css_scale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_behavior
    ///
    /// Whether a document used the CSS property scroll-behavior. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_behavior: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1274,
            "use.counter.css.doc",
            "css_scroll_behavior",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin
    ///
    /// Whether a document used the CSS property scroll-margin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1275,
            "use.counter.css.doc",
            "css_scroll_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_block
    ///
    /// Whether a document used the CSS property scroll-margin-block. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1276,
            "use.counter.css.doc",
            "css_scroll_margin_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_block_end
    ///
    /// Whether a document used the CSS property scroll-margin-block-end. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1277,
            "use.counter.css.doc",
            "css_scroll_margin_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_block_start
    ///
    /// Whether a document used the CSS property scroll-margin-block-start. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1278,
            "use.counter.css.doc",
            "css_scroll_margin_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_bottom
    ///
    /// Whether a document used the CSS property scroll-margin-bottom. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1279,
            "use.counter.css.doc",
            "css_scroll_margin_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_inline
    ///
    /// Whether a document used the CSS property scroll-margin-inline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1280,
            "use.counter.css.doc",
            "css_scroll_margin_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_inline_end
    ///
    /// Whether a document used the CSS property scroll-margin-inline-end. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1281,
            "use.counter.css.doc",
            "css_scroll_margin_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_inline_start
    ///
    /// Whether a document used the CSS property scroll-margin-inline-start. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1282,
            "use.counter.css.doc",
            "css_scroll_margin_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_left
    ///
    /// Whether a document used the CSS property scroll-margin-left. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1283,
            "use.counter.css.doc",
            "css_scroll_margin_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_right
    ///
    /// Whether a document used the CSS property scroll-margin-right. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1284,
            "use.counter.css.doc",
            "css_scroll_margin_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_top
    ///
    /// Whether a document used the CSS property scroll-margin-top. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1285,
            "use.counter.css.doc",
            "css_scroll_margin_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding
    ///
    /// Whether a document used the CSS property scroll-padding. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1286,
            "use.counter.css.doc",
            "css_scroll_padding",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_block
    ///
    /// Whether a document used the CSS property scroll-padding-block. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1287,
            "use.counter.css.doc",
            "css_scroll_padding_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_block_end
    ///
    /// Whether a document used the CSS property scroll-padding-block-end. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1288,
            "use.counter.css.doc",
            "css_scroll_padding_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_block_start
    ///
    /// Whether a document used the CSS property scroll-padding-block-start. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1289,
            "use.counter.css.doc",
            "css_scroll_padding_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_bottom
    ///
    /// Whether a document used the CSS property scroll-padding-bottom. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1290,
            "use.counter.css.doc",
            "css_scroll_padding_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_inline
    ///
    /// Whether a document used the CSS property scroll-padding-inline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1291,
            "use.counter.css.doc",
            "css_scroll_padding_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_inline_end
    ///
    /// Whether a document used the CSS property scroll-padding-inline-end. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1292,
            "use.counter.css.doc",
            "css_scroll_padding_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_inline_start
    ///
    /// Whether a document used the CSS property scroll-padding-inline-start. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1293,
            "use.counter.css.doc",
            "css_scroll_padding_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_left
    ///
    /// Whether a document used the CSS property scroll-padding-left. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1294,
            "use.counter.css.doc",
            "css_scroll_padding_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_right
    ///
    /// Whether a document used the CSS property scroll-padding-right. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1295,
            "use.counter.css.doc",
            "css_scroll_padding_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_top
    ///
    /// Whether a document used the CSS property scroll-padding-top. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1296,
            "use.counter.css.doc",
            "css_scroll_padding_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_snap_align
    ///
    /// Whether a document used the CSS property scroll-snap-align. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_snap_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1297,
            "use.counter.css.doc",
            "css_scroll_snap_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_snap_stop
    ///
    /// Whether a document used the CSS property scroll-snap-stop. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_snap_stop: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1298,
            "use.counter.css.doc",
            "css_scroll_snap_stop",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_snap_type
    ///
    /// Whether a document used the CSS property scroll-snap-type. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_snap_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1299,
            "use.counter.css.doc",
            "css_scroll_snap_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_timeline
    ///
    /// Whether a document used the CSS property scroll-timeline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_timeline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1300,
            "use.counter.css.doc",
            "css_scroll_timeline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_timeline_axis
    ///
    /// Whether a document used the CSS property scroll-timeline-axis. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_timeline_axis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1301,
            "use.counter.css.doc",
            "css_scroll_timeline_axis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_timeline_name
    ///
    /// Whether a document used the CSS property scroll-timeline-name. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_timeline_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1302,
            "use.counter.css.doc",
            "css_scroll_timeline_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scrollbar_color
    ///
    /// Whether a document used the CSS property scrollbar-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scrollbar_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1303,
            "use.counter.css.doc",
            "css_scrollbar_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scrollbar_gutter
    ///
    /// Whether a document used the CSS property scrollbar-gutter. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scrollbar_gutter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1304,
            "use.counter.css.doc",
            "css_scrollbar_gutter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scrollbar_width
    ///
    /// Whether a document used the CSS property scrollbar-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scrollbar_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1305,
            "use.counter.css.doc",
            "css_scrollbar_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_shape_image_threshold
    ///
    /// Whether a document used the CSS property shape-image-threshold. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_shape_image_threshold: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1306,
            "use.counter.css.doc",
            "css_shape_image_threshold",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_shape_margin
    ///
    /// Whether a document used the CSS property shape-margin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_shape_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1307,
            "use.counter.css.doc",
            "css_shape_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_shape_outside
    ///
    /// Whether a document used the CSS property shape-outside. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_shape_outside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1308,
            "use.counter.css.doc",
            "css_shape_outside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_shape_rendering
    ///
    /// Whether a document used the CSS property shape-rendering. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_shape_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1309,
            "use.counter.css.doc",
            "css_shape_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_size
    ///
    /// Whether a document used the CSS property size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1310,
            "use.counter.css.doc",
            "css_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stop_color
    ///
    /// Whether a document used the CSS property stop-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stop_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1311,
            "use.counter.css.doc",
            "css_stop_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stop_opacity
    ///
    /// Whether a document used the CSS property stop-opacity. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stop_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1312,
            "use.counter.css.doc",
            "css_stop_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke
    ///
    /// Whether a document used the CSS property stroke. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1313,
            "use.counter.css.doc",
            "css_stroke",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke_dasharray
    ///
    /// Whether a document used the CSS property stroke-dasharray. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke_dasharray: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1314,
            "use.counter.css.doc",
            "css_stroke_dasharray",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke_dashoffset
    ///
    /// Whether a document used the CSS property stroke-dashoffset. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke_dashoffset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1315,
            "use.counter.css.doc",
            "css_stroke_dashoffset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke_linecap
    ///
    /// Whether a document used the CSS property stroke-linecap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke_linecap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1316,
            "use.counter.css.doc",
            "css_stroke_linecap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke_linejoin
    ///
    /// Whether a document used the CSS property stroke-linejoin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke_linejoin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1317,
            "use.counter.css.doc",
            "css_stroke_linejoin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke_miterlimit
    ///
    /// Whether a document used the CSS property stroke-miterlimit. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke_miterlimit: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1318,
            "use.counter.css.doc",
            "css_stroke_miterlimit",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke_opacity
    ///
    /// Whether a document used the CSS property stroke-opacity. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1319,
            "use.counter.css.doc",
            "css_stroke_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke_width
    ///
    /// Whether a document used the CSS property stroke-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1320,
            "use.counter.css.doc",
            "css_stroke_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_tab_size
    ///
    /// Whether a document used the CSS property tab-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_tab_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1321,
            "use.counter.css.doc",
            "css_tab_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_table_layout
    ///
    /// Whether a document used the CSS property table-layout. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_table_layout: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1322,
            "use.counter.css.doc",
            "css_table_layout",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_align
    ///
    /// Whether a document used the CSS property text-align. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1323,
            "use.counter.css.doc",
            "css_text_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_align_last
    ///
    /// Whether a document used the CSS property text-align-last. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_align_last: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1324,
            "use.counter.css.doc",
            "css_text_align_last",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_anchor
    ///
    /// Whether a document used the CSS property text-anchor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1325,
            "use.counter.css.doc",
            "css_text_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_combine_upright
    ///
    /// Whether a document used the CSS property text-combine-upright. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_combine_upright: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1326,
            "use.counter.css.doc",
            "css_text_combine_upright",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_decoration
    ///
    /// Whether a document used the CSS property text-decoration. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1327,
            "use.counter.css.doc",
            "css_text_decoration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_decoration_color
    ///
    /// Whether a document used the CSS property text-decoration-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1328,
            "use.counter.css.doc",
            "css_text_decoration_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_decoration_line
    ///
    /// Whether a document used the CSS property text-decoration-line. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_line: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1329,
            "use.counter.css.doc",
            "css_text_decoration_line",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_decoration_skip_ink
    ///
    /// Whether a document used the CSS property text-decoration-skip-ink. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_skip_ink: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1330,
            "use.counter.css.doc",
            "css_text_decoration_skip_ink",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_decoration_style
    ///
    /// Whether a document used the CSS property text-decoration-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1331,
            "use.counter.css.doc",
            "css_text_decoration_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_decoration_thickness
    ///
    /// Whether a document used the CSS property text-decoration-thickness. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_thickness: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1332,
            "use.counter.css.doc",
            "css_text_decoration_thickness",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_emphasis
    ///
    /// Whether a document used the CSS property text-emphasis. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1333,
            "use.counter.css.doc",
            "css_text_emphasis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_emphasis_color
    ///
    /// Whether a document used the CSS property text-emphasis-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1334,
            "use.counter.css.doc",
            "css_text_emphasis_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_emphasis_position
    ///
    /// Whether a document used the CSS property text-emphasis-position. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1335,
            "use.counter.css.doc",
            "css_text_emphasis_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_emphasis_style
    ///
    /// Whether a document used the CSS property text-emphasis-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1336,
            "use.counter.css.doc",
            "css_text_emphasis_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_indent
    ///
    /// Whether a document used the CSS property text-indent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_indent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1337,
            "use.counter.css.doc",
            "css_text_indent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_justify
    ///
    /// Whether a document used the CSS property text-justify. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_justify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1338,
            "use.counter.css.doc",
            "css_text_justify",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_orientation
    ///
    /// Whether a document used the CSS property text-orientation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1339,
            "use.counter.css.doc",
            "css_text_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_overflow
    ///
    /// Whether a document used the CSS property text-overflow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_overflow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1340,
            "use.counter.css.doc",
            "css_text_overflow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_rendering
    ///
    /// Whether a document used the CSS property text-rendering. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1341,
            "use.counter.css.doc",
            "css_text_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_shadow
    ///
    /// Whether a document used the CSS property text-shadow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1342,
            "use.counter.css.doc",
            "css_text_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_transform
    ///
    /// Whether a document used the CSS property text-transform. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1343,
            "use.counter.css.doc",
            "css_text_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_underline_offset
    ///
    /// Whether a document used the CSS property text-underline-offset. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_underline_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1344,
            "use.counter.css.doc",
            "css_text_underline_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_underline_position
    ///
    /// Whether a document used the CSS property text-underline-position. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_underline_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1345,
            "use.counter.css.doc",
            "css_text_underline_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_wrap
    ///
    /// Whether a document used the CSS property text-wrap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1346,
            "use.counter.css.doc",
            "css_text_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_wrap_mode
    ///
    /// Whether a document used the CSS property text-wrap-mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_wrap_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1347,
            "use.counter.css.doc",
            "css_text_wrap_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_wrap_style
    ///
    /// Whether a document used the CSS property text-wrap-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_wrap_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1348,
            "use.counter.css.doc",
            "css_text_wrap_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_top
    ///
    /// Whether a document used the CSS property top. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1349,
            "use.counter.css.doc",
            "css_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_touch_action
    ///
    /// Whether a document used the CSS property touch-action. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_touch_action: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1350,
            "use.counter.css.doc",
            "css_touch_action",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transform
    ///
    /// Whether a document used the CSS property transform. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1351,
            "use.counter.css.doc",
            "css_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transform_box
    ///
    /// Whether a document used the CSS property transform-box. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transform_box: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1352,
            "use.counter.css.doc",
            "css_transform_box",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transform_origin
    ///
    /// Whether a document used the CSS property transform-origin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1353,
            "use.counter.css.doc",
            "css_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transform_style
    ///
    /// Whether a document used the CSS property transform-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transform_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1354,
            "use.counter.css.doc",
            "css_transform_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transition
    ///
    /// Whether a document used the CSS property transition. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1355,
            "use.counter.css.doc",
            "css_transition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transition_behavior
    ///
    /// Whether a document used the CSS property transition-behavior. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transition_behavior: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1356,
            "use.counter.css.doc",
            "css_transition_behavior",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transition_delay
    ///
    /// Whether a document used the CSS property transition-delay. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transition_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1357,
            "use.counter.css.doc",
            "css_transition_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transition_duration
    ///
    /// Whether a document used the CSS property transition-duration. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transition_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1358,
            "use.counter.css.doc",
            "css_transition_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transition_property
    ///
    /// Whether a document used the CSS property transition-property. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transition_property: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1359,
            "use.counter.css.doc",
            "css_transition_property",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transition_timing_function
    ///
    /// Whether a document used the CSS property transition-timing-function. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transition_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1360,
            "use.counter.css.doc",
            "css_transition_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_translate
    ///
    /// Whether a document used the CSS property translate. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_translate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1361,
            "use.counter.css.doc",
            "css_translate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_unicode_bidi
    ///
    /// Whether a document used the CSS property unicode-bidi. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_unicode_bidi: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1362,
            "use.counter.css.doc",
            "css_unicode_bidi",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_user_select
    ///
    /// Whether a document used the CSS property user-select. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_user_select: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1363,
            "use.counter.css.doc",
            "css_user_select",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_vector_effect
    ///
    /// Whether a document used the CSS property vector-effect. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_vector_effect: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1364,
            "use.counter.css.doc",
            "css_vector_effect",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_vertical_align
    ///
    /// Whether a document used the CSS property vertical-align. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_vertical_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1365,
            "use.counter.css.doc",
            "css_vertical_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_view_timeline
    ///
    /// Whether a document used the CSS property view-timeline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1366,
            "use.counter.css.doc",
            "css_view_timeline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_view_timeline_axis
    ///
    /// Whether a document used the CSS property view-timeline-axis. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline_axis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1367,
            "use.counter.css.doc",
            "css_view_timeline_axis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_view_timeline_inset
    ///
    /// Whether a document used the CSS property view-timeline-inset. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline_inset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1368,
            "use.counter.css.doc",
            "css_view_timeline_inset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_view_timeline_name
    ///
    /// Whether a document used the CSS property view-timeline-name. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1369,
            "use.counter.css.doc",
            "css_view_timeline_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_view_transition_name
    ///
    /// Whether a document used the CSS property view-transition-name. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_view_transition_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1370,
            "use.counter.css.doc",
            "css_view_transition_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_visibility
    ///
    /// Whether a document used the CSS property visibility. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1371,
            "use.counter.css.doc",
            "css_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_align_content
    ///
    /// Whether a document used the CSS property -webkit-align-content. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_align_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1372,
            "use.counter.css.doc",
            "css_webkit_align_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_align_items
    ///
    /// Whether a document used the CSS property -webkit-align-items. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_align_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1373,
            "use.counter.css.doc",
            "css_webkit_align_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_align_self
    ///
    /// Whether a document used the CSS property -webkit-align-self. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_align_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1374,
            "use.counter.css.doc",
            "css_webkit_align_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation
    ///
    /// Whether a document used the CSS property -webkit-animation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1375,
            "use.counter.css.doc",
            "css_webkit_animation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_delay
    ///
    /// Whether a document used the CSS property -webkit-animation-delay. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1376,
            "use.counter.css.doc",
            "css_webkit_animation_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_direction
    ///
    /// Whether a document used the CSS property -webkit-animation-direction. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1377,
            "use.counter.css.doc",
            "css_webkit_animation_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_duration
    ///
    /// Whether a document used the CSS property -webkit-animation-duration. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1378,
            "use.counter.css.doc",
            "css_webkit_animation_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_fill_mode
    ///
    /// Whether a document used the CSS property -webkit-animation-fill-mode. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_fill_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1379,
            "use.counter.css.doc",
            "css_webkit_animation_fill_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_iteration_count
    ///
    /// Whether a document used the CSS property -webkit-animation-iteration-count.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_animation_iteration_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1380,
            "use.counter.css.doc",
            "css_webkit_animation_iteration_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_name
    ///
    /// Whether a document used the CSS property -webkit-animation-name. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1381,
            "use.counter.css.doc",
            "css_webkit_animation_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_play_state
    ///
    /// Whether a document used the CSS property -webkit-animation-play-state. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_play_state: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1382,
            "use.counter.css.doc",
            "css_webkit_animation_play_state",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_timing_function
    ///
    /// Whether a document used the CSS property -webkit-animation-timing-function.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_animation_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1383,
            "use.counter.css.doc",
            "css_webkit_animation_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_appearance
    ///
    /// Whether a document used the CSS property -webkit-appearance. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1384,
            "use.counter.css.doc",
            "css_webkit_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_backface_visibility
    ///
    /// Whether a document used the CSS property -webkit-backface-visibility. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_backface_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1385,
            "use.counter.css.doc",
            "css_webkit_backface_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_background_clip
    ///
    /// Whether a document used the CSS property -webkit-background-clip. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_background_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1386,
            "use.counter.css.doc",
            "css_webkit_background_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_background_origin
    ///
    /// Whether a document used the CSS property -webkit-background-origin. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_background_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1387,
            "use.counter.css.doc",
            "css_webkit_background_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_background_size
    ///
    /// Whether a document used the CSS property -webkit-background-size. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_background_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1388,
            "use.counter.css.doc",
            "css_webkit_background_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_border_bottom_left_radius
    ///
    /// Whether a document used the CSS property -webkit-border-bottom-left-radius.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_border_bottom_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1389,
            "use.counter.css.doc",
            "css_webkit_border_bottom_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_border_bottom_right_radius
    ///
    /// Whether a document used the CSS property -webkit-border-bottom-right-radius.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_border_bottom_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1390,
            "use.counter.css.doc",
            "css_webkit_border_bottom_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_border_image
    ///
    /// Whether a document used the CSS property -webkit-border-image. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_border_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1391,
            "use.counter.css.doc",
            "css_webkit_border_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_border_radius
    ///
    /// Whether a document used the CSS property -webkit-border-radius. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_border_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1392,
            "use.counter.css.doc",
            "css_webkit_border_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_border_top_left_radius
    ///
    /// Whether a document used the CSS property -webkit-border-top-left-radius.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_border_top_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1393,
            "use.counter.css.doc",
            "css_webkit_border_top_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_border_top_right_radius
    ///
    /// Whether a document used the CSS property -webkit-border-top-right-radius.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_border_top_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1394,
            "use.counter.css.doc",
            "css_webkit_border_top_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_align
    ///
    /// Whether a document used the CSS property -webkit-box-align. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1395,
            "use.counter.css.doc",
            "css_webkit_box_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_direction
    ///
    /// Whether a document used the CSS property -webkit-box-direction. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1396,
            "use.counter.css.doc",
            "css_webkit_box_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_flex
    ///
    /// Whether a document used the CSS property -webkit-box-flex. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1397,
            "use.counter.css.doc",
            "css_webkit_box_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_ordinal_group
    ///
    /// Whether a document used the CSS property -webkit-box-ordinal-group. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_ordinal_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1398,
            "use.counter.css.doc",
            "css_webkit_box_ordinal_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_orient
    ///
    /// Whether a document used the CSS property -webkit-box-orient. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_orient: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1399,
            "use.counter.css.doc",
            "css_webkit_box_orient",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_pack
    ///
    /// Whether a document used the CSS property -webkit-box-pack. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_pack: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1400,
            "use.counter.css.doc",
            "css_webkit_box_pack",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_shadow
    ///
    /// Whether a document used the CSS property -webkit-box-shadow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1401,
            "use.counter.css.doc",
            "css_webkit_box_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_sizing
    ///
    /// Whether a document used the CSS property -webkit-box-sizing. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1402,
            "use.counter.css.doc",
            "css_webkit_box_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_clip_path
    ///
    /// Whether a document used the CSS property -webkit-clip-path. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_clip_path: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1403,
            "use.counter.css.doc",
            "css_webkit_clip_path",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_filter
    ///
    /// Whether a document used the CSS property -webkit-filter. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_filter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1404,
            "use.counter.css.doc",
            "css_webkit_filter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_flex
    ///
    /// Whether a document used the CSS property -webkit-flex. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1405,
            "use.counter.css.doc",
            "css_webkit_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_flex_basis
    ///
    /// Whether a document used the CSS property -webkit-flex-basis. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_basis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1406,
            "use.counter.css.doc",
            "css_webkit_flex_basis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_flex_direction
    ///
    /// Whether a document used the CSS property -webkit-flex-direction. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1407,
            "use.counter.css.doc",
            "css_webkit_flex_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_flex_flow
    ///
    /// Whether a document used the CSS property -webkit-flex-flow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1408,
            "use.counter.css.doc",
            "css_webkit_flex_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_flex_grow
    ///
    /// Whether a document used the CSS property -webkit-flex-grow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_grow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1409,
            "use.counter.css.doc",
            "css_webkit_flex_grow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_flex_shrink
    ///
    /// Whether a document used the CSS property -webkit-flex-shrink. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_shrink: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1410,
            "use.counter.css.doc",
            "css_webkit_flex_shrink",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_flex_wrap
    ///
    /// Whether a document used the CSS property -webkit-flex-wrap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1411,
            "use.counter.css.doc",
            "css_webkit_flex_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_font_feature_settings
    ///
    /// Whether a document used the CSS property -webkit-font-feature-settings. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_font_feature_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1412,
            "use.counter.css.doc",
            "css_webkit_font_feature_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_font_smoothing
    ///
    /// Whether a document used the CSS property -webkit-font-smoothing. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_font_smoothing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1413,
            "use.counter.css.doc",
            "css_webkit_font_smoothing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_justify_content
    ///
    /// Whether a document used the CSS property -webkit-justify-content. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_justify_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1414,
            "use.counter.css.doc",
            "css_webkit_justify_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_line_clamp
    ///
    /// Whether a document used the CSS property -webkit-line-clamp. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_line_clamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1415,
            "use.counter.css.doc",
            "css_webkit_line_clamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask
    ///
    /// Whether a document used the CSS property -webkit-mask. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1416,
            "use.counter.css.doc",
            "css_webkit_mask",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_clip
    ///
    /// Whether a document used the CSS property -webkit-mask-clip. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1417,
            "use.counter.css.doc",
            "css_webkit_mask_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_composite
    ///
    /// Whether a document used the CSS property -webkit-mask-composite. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_composite: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1418,
            "use.counter.css.doc",
            "css_webkit_mask_composite",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_image
    ///
    /// Whether a document used the CSS property -webkit-mask-image. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1419,
            "use.counter.css.doc",
            "css_webkit_mask_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_origin
    ///
    /// Whether a document used the CSS property -webkit-mask-origin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1420,
            "use.counter.css.doc",
            "css_webkit_mask_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_position
    ///
    /// Whether a document used the CSS property -webkit-mask-position. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1421,
            "use.counter.css.doc",
            "css_webkit_mask_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_position_x
    ///
    /// Whether a document used the CSS property -webkit-mask-position-x. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_position_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1422,
            "use.counter.css.doc",
            "css_webkit_mask_position_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_position_y
    ///
    /// Whether a document used the CSS property -webkit-mask-position-y. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_position_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1423,
            "use.counter.css.doc",
            "css_webkit_mask_position_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_repeat
    ///
    /// Whether a document used the CSS property -webkit-mask-repeat. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1424,
            "use.counter.css.doc",
            "css_webkit_mask_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_size
    ///
    /// Whether a document used the CSS property -webkit-mask-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1425,
            "use.counter.css.doc",
            "css_webkit_mask_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_order
    ///
    /// Whether a document used the CSS property -webkit-order. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1426,
            "use.counter.css.doc",
            "css_webkit_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_perspective
    ///
    /// Whether a document used the CSS property -webkit-perspective. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_perspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1427,
            "use.counter.css.doc",
            "css_webkit_perspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_perspective_origin
    ///
    /// Whether a document used the CSS property -webkit-perspective-origin. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_perspective_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1428,
            "use.counter.css.doc",
            "css_webkit_perspective_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_text_fill_color
    ///
    /// Whether a document used the CSS property -webkit-text-fill-color. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_fill_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1429,
            "use.counter.css.doc",
            "css_webkit_text_fill_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_text_security
    ///
    /// Whether a document used the CSS property -webkit-text-security. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_security: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1430,
            "use.counter.css.doc",
            "css_webkit_text_security",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_text_size_adjust
    ///
    /// Whether a document used the CSS property -webkit-text-size-adjust. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1431,
            "use.counter.css.doc",
            "css_webkit_text_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_text_stroke
    ///
    /// Whether a document used the CSS property -webkit-text-stroke. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_stroke: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1432,
            "use.counter.css.doc",
            "css_webkit_text_stroke",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_text_stroke_color
    ///
    /// Whether a document used the CSS property -webkit-text-stroke-color. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_stroke_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1433,
            "use.counter.css.doc",
            "css_webkit_text_stroke_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_text_stroke_width
    ///
    /// Whether a document used the CSS property -webkit-text-stroke-width. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_stroke_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1434,
            "use.counter.css.doc",
            "css_webkit_text_stroke_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transform
    ///
    /// Whether a document used the CSS property -webkit-transform. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1435,
            "use.counter.css.doc",
            "css_webkit_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transform_origin
    ///
    /// Whether a document used the CSS property -webkit-transform-origin. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1436,
            "use.counter.css.doc",
            "css_webkit_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transform_style
    ///
    /// Whether a document used the CSS property -webkit-transform-style. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transform_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1437,
            "use.counter.css.doc",
            "css_webkit_transform_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transition
    ///
    /// Whether a document used the CSS property -webkit-transition. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1438,
            "use.counter.css.doc",
            "css_webkit_transition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transition_delay
    ///
    /// Whether a document used the CSS property -webkit-transition-delay. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1439,
            "use.counter.css.doc",
            "css_webkit_transition_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transition_duration
    ///
    /// Whether a document used the CSS property -webkit-transition-duration. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1440,
            "use.counter.css.doc",
            "css_webkit_transition_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transition_property
    ///
    /// Whether a document used the CSS property -webkit-transition-property. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition_property: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1441,
            "use.counter.css.doc",
            "css_webkit_transition_property",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transition_timing_function
    ///
    /// Whether a document used the CSS property -webkit-transition-timing-function.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_transition_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1442,
            "use.counter.css.doc",
            "css_webkit_transition_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_user_select
    ///
    /// Whether a document used the CSS property -webkit-user-select. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_user_select: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1443,
            "use.counter.css.doc",
            "css_webkit_user_select",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_white_space
    ///
    /// Whether a document used the CSS property white-space. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_white_space: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1444,
            "use.counter.css.doc",
            "css_white_space",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_white_space_collapse
    ///
    /// Whether a document used the CSS property white-space-collapse. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_white_space_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1445,
            "use.counter.css.doc",
            "css_white_space_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_width
    ///
    /// Whether a document used the CSS property width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1446,
            "use.counter.css.doc",
            "css_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_will_change
    ///
    /// Whether a document used the CSS property will-change. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_will_change: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1447,
            "use.counter.css.doc",
            "css_will_change",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_word_break
    ///
    /// Whether a document used the CSS property word-break. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_word_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1448,
            "use.counter.css.doc",
            "css_word_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_word_spacing
    ///
    /// Whether a document used the CSS property word-spacing. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_word_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1449,
            "use.counter.css.doc",
            "css_word_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_word_wrap
    ///
    /// Whether a document used the CSS property word-wrap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_word_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1450,
            "use.counter.css.doc",
            "css_word_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_writing_mode
    ///
    /// Whether a document used the CSS property writing-mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_writing_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1451,
            "use.counter.css.doc",
            "css_writing_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_x
    ///
    /// Whether a document used the CSS property x. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1452,
            "use.counter.css.doc",
            "css_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_x_lang
    ///
    /// Whether a document used the CSS property -x-lang. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_x_lang: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1453,
            "use.counter.css.doc",
            "css_x_lang",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_x_span
    ///
    /// Whether a document used the CSS property -x-span. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_x_span: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1454,
            "use.counter.css.doc",
            "css_x_span",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_x_text_scale
    ///
    /// Whether a document used the CSS property -x-text-scale. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_x_text_scale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1455,
            "use.counter.css.doc",
            "css_x_text_scale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_y
    ///
    /// Whether a document used the CSS property y. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1456,
            "use.counter.css.doc",
            "css_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_z_index
    ///
    /// Whether a document used the CSS property z-index. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_z_index: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1457,
            "use.counter.css.doc",
            "css_z_index",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_zoom
    ///
    /// Whether a document used the CSS property zoom. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1458,
            "use.counter.css.doc",
            "css_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.max_zoom
    ///
    /// Whether a document used the (unknown, counted) CSS property max-zoom. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static max_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1459,
            "use.counter.css.doc",
            "max_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.min_zoom
    ///
    /// Whether a document used the (unknown, counted) CSS property min-zoom. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static min_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1460,
            "use.counter.css.doc",
            "min_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.orientation
    ///
    /// Whether a document used the (unknown, counted) CSS property orientation.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1461,
            "use.counter.css.doc",
            "orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.orphans
    ///
    /// Whether a document used the (unknown, counted) CSS property orphans. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static orphans: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1462,
            "use.counter.css.doc",
            "orphans",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.speak
    ///
    /// Whether a document used the (unknown, counted) CSS property speak. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static speak: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1463,
            "use.counter.css.doc",
            "speak",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.text_size_adjust
    ///
    /// Whether a document used the (unknown, counted) CSS property text-size-adjust.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static text_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1464,
            "use.counter.css.doc",
            "text_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.user_zoom
    ///
    /// Whether a document used the (unknown, counted) CSS property user-zoom. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static user_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1465,
            "use.counter.css.doc",
            "user_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_app_region
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-app-region.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_app_region: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1466,
            "use.counter.css.doc",
            "webkit_app_region",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_after
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// after. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_border_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1467,
            "use.counter.css.doc",
            "webkit_border_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_after_color
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// after-color. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_after_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1468,
            "use.counter.css.doc",
            "webkit_border_after_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_after_style
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// after-style. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_after_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1469,
            "use.counter.css.doc",
            "webkit_border_after_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_after_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// after-width. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_after_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1470,
            "use.counter.css.doc",
            "webkit_border_after_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_before
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// before. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_border_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1471,
            "use.counter.css.doc",
            "webkit_border_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_before_color
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// before-color. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_before_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1472,
            "use.counter.css.doc",
            "webkit_border_before_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_before_style
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// before-style. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_before_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1473,
            "use.counter.css.doc",
            "webkit_border_before_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_before_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// before-width. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_before_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1474,
            "use.counter.css.doc",
            "webkit_border_before_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_end
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-end.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_border_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1475,
            "use.counter.css.doc",
            "webkit_border_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_end_color
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-end-
    /// color. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_border_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1476,
            "use.counter.css.doc",
            "webkit_border_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_end_style
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-end-
    /// style. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_border_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1477,
            "use.counter.css.doc",
            "webkit_border_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_end_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-end-
    /// width. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_border_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1478,
            "use.counter.css.doc",
            "webkit_border_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_horizontal_spacing
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// horizontal-spacing. Compare against `use.counter.content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_border_horizontal_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1479,
            "use.counter.css.doc",
            "webkit_border_horizontal_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_start
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// start. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_border_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1480,
            "use.counter.css.doc",
            "webkit_border_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_start_color
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// start-color. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1481,
            "use.counter.css.doc",
            "webkit_border_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_start_style
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// start-style. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1482,
            "use.counter.css.doc",
            "webkit_border_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_start_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// start-width. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1483,
            "use.counter.css.doc",
            "webkit_border_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_vertical_spacing
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// vertical-spacing. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_vertical_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1484,
            "use.counter.css.doc",
            "webkit_border_vertical_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_box_decoration_break
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-box-
    /// decoration-break. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_box_decoration_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1485,
            "use.counter.css.doc",
            "webkit_box_decoration_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_box_reflect
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-box-
    /// reflect. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_box_reflect: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1486,
            "use.counter.css.doc",
            "webkit_box_reflect",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_break_after
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-
    /// break-after. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_break_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1487,
            "use.counter.css.doc",
            "webkit_column_break_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_break_before
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-
    /// break-before. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_break_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1488,
            "use.counter.css.doc",
            "webkit_column_break_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_break_inside
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-
    /// break-inside. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_break_inside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1489,
            "use.counter.css.doc",
            "webkit_column_break_inside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_count
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-
    /// count. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_column_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1490,
            "use.counter.css.doc",
            "webkit_column_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_gap
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-gap.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_column_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1491,
            "use.counter.css.doc",
            "webkit_column_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_rule
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-
    /// rule. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_column_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1492,
            "use.counter.css.doc",
            "webkit_column_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_rule_color
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-
    /// rule-color. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_rule_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1493,
            "use.counter.css.doc",
            "webkit_column_rule_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_rule_style
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-
    /// rule-style. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_rule_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1494,
            "use.counter.css.doc",
            "webkit_column_rule_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_rule_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-
    /// rule-width. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_rule_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1495,
            "use.counter.css.doc",
            "webkit_column_rule_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_span
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-
    /// span. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_column_span: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1496,
            "use.counter.css.doc",
            "webkit_column_span",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-
    /// width. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_column_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1497,
            "use.counter.css.doc",
            "webkit_column_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_columns
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-columns.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1498,
            "use.counter.css.doc",
            "webkit_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_font_size_delta
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-font-size-
    /// delta. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_font_size_delta: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1499,
            "use.counter.css.doc",
            "webkit_font_size_delta",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_highlight
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-highlight.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_highlight: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1500,
            "use.counter.css.doc",
            "webkit_highlight",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_hyphenate_character
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-hyphenate-
    /// character. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_hyphenate_character: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1501,
            "use.counter.css.doc",
            "webkit_hyphenate_character",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_line_break
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-line-break.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_line_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1502,
            "use.counter.css.doc",
            "webkit_line_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_locale
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-locale.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_locale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1503,
            "use.counter.css.doc",
            "webkit_locale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_logical_height
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-logical-
    /// height. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_logical_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1504,
            "use.counter.css.doc",
            "webkit_logical_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_logical_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-logical-
    /// width. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_logical_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1505,
            "use.counter.css.doc",
            "webkit_logical_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_after
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-
    /// after. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_margin_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1506,
            "use.counter.css.doc",
            "webkit_margin_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_after_collapse
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-
    /// after-collapse. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_margin_after_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1507,
            "use.counter.css.doc",
            "webkit_margin_after_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_before
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-
    /// before. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_margin_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1508,
            "use.counter.css.doc",
            "webkit_margin_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_before_collapse
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-
    /// before-collapse. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_margin_before_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1509,
            "use.counter.css.doc",
            "webkit_margin_before_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_bottom_collapse
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-
    /// bottom-collapse. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_margin_bottom_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1510,
            "use.counter.css.doc",
            "webkit_margin_bottom_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_collapse
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-
    /// collapse. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_margin_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1511,
            "use.counter.css.doc",
            "webkit_margin_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_end
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-end.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_margin_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1512,
            "use.counter.css.doc",
            "webkit_margin_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_start
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-
    /// start. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_margin_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1513,
            "use.counter.css.doc",
            "webkit_margin_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_top_collapse
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-top-
    /// collapse. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_margin_top_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1514,
            "use.counter.css.doc",
            "webkit_margin_top_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_box_image
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
    /// image. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_mask_box_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1515,
            "use.counter.css.doc",
            "webkit_mask_box_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_box_image_outset
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
    /// image-outset. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image_outset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1516,
            "use.counter.css.doc",
            "webkit_mask_box_image_outset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_box_image_repeat
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
    /// image-repeat. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1517,
            "use.counter.css.doc",
            "webkit_mask_box_image_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_box_image_slice
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
    /// image-slice. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image_slice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1518,
            "use.counter.css.doc",
            "webkit_mask_box_image_slice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_box_image_source
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
    /// image-source. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1519,
            "use.counter.css.doc",
            "webkit_mask_box_image_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_box_image_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
    /// image-width. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1520,
            "use.counter.css.doc",
            "webkit_mask_box_image_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_repeat_x
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-
    /// repeat-x. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_repeat_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1521,
            "use.counter.css.doc",
            "webkit_mask_repeat_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_repeat_y
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-
    /// repeat-y. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_repeat_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1522,
            "use.counter.css.doc",
            "webkit_mask_repeat_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_max_logical_height
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-max-
    /// logical-height. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_max_logical_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1523,
            "use.counter.css.doc",
            "webkit_max_logical_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_max_logical_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-max-
    /// logical-width. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_max_logical_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1524,
            "use.counter.css.doc",
            "webkit_max_logical_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_min_logical_height
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-min-
    /// logical-height. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_min_logical_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1525,
            "use.counter.css.doc",
            "webkit_min_logical_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_min_logical_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-min-
    /// logical-width. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_min_logical_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1526,
            "use.counter.css.doc",
            "webkit_min_logical_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_opacity
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-opacity.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1527,
            "use.counter.css.doc",
            "webkit_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_padding_after
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-padding-
    /// after. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_padding_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1528,
            "use.counter.css.doc",
            "webkit_padding_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_padding_before
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-padding-
    /// before. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_padding_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1529,
            "use.counter.css.doc",
            "webkit_padding_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_padding_end
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-padding-
    /// end. Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_padding_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1530,
            "use.counter.css.doc",
            "webkit_padding_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_padding_start
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-padding-
    /// start. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_padding_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1531,
            "use.counter.css.doc",
            "webkit_padding_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_perspective_origin_x
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-
    /// perspective-origin-x. Compare against `use.counter.content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_perspective_origin_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1532,
            "use.counter.css.doc",
            "webkit_perspective_origin_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_perspective_origin_y
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-
    /// perspective-origin-y. Compare against `use.counter.content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_perspective_origin_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1533,
            "use.counter.css.doc",
            "webkit_perspective_origin_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_print_color_adjust
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-print-
    /// color-adjust. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_print_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1534,
            "use.counter.css.doc",
            "webkit_print_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_rtl_ordering
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-rtl-
    /// ordering. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_rtl_ordering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1535,
            "use.counter.css.doc",
            "webkit_rtl_ordering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_ruby_position
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-ruby-
    /// position. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_ruby_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1536,
            "use.counter.css.doc",
            "webkit_ruby_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_shape_image_threshold
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-shape-
    /// image-threshold. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_shape_image_threshold: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1537,
            "use.counter.css.doc",
            "webkit_shape_image_threshold",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_shape_margin
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-shape-
    /// margin. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_shape_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1538,
            "use.counter.css.doc",
            "webkit_shape_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_shape_outside
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-shape-
    /// outside. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_shape_outside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1539,
            "use.counter.css.doc",
            "webkit_shape_outside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_tap_highlight_color
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-tap-
    /// highlight-color. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_tap_highlight_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1540,
            "use.counter.css.doc",
            "webkit_tap_highlight_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_text_combine
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-text-
    /// combine. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_text_combine: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1541,
            "use.counter.css.doc",
            "webkit_text_combine",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_text_decorations_in_effect
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-text-
    /// decorations-in-effect. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_text_decorations_in_effect: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1542,
            "use.counter.css.doc",
            "webkit_text_decorations_in_effect",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_text_emphasis
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-text-
    /// emphasis. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_text_emphasis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1543,
            "use.counter.css.doc",
            "webkit_text_emphasis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_text_emphasis_color
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-text-
    /// emphasis-color. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_text_emphasis_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1544,
            "use.counter.css.doc",
            "webkit_text_emphasis_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_text_emphasis_position
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-text-
    /// emphasis-position. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_text_emphasis_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1545,
            "use.counter.css.doc",
            "webkit_text_emphasis_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_text_emphasis_style
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-text-
    /// emphasis-style. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_text_emphasis_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1546,
            "use.counter.css.doc",
            "webkit_text_emphasis_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_text_orientation
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-text-
    /// orientation. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_text_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1547,
            "use.counter.css.doc",
            "webkit_text_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_transform_origin_x
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-transform-
    /// origin-x. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_transform_origin_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1548,
            "use.counter.css.doc",
            "webkit_transform_origin_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_transform_origin_y
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-transform-
    /// origin-y. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_transform_origin_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1549,
            "use.counter.css.doc",
            "webkit_transform_origin_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_transform_origin_z
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-transform-
    /// origin-z. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_transform_origin_z: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1550,
            "use.counter.css.doc",
            "webkit_transform_origin_z",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_user_drag
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-user-drag.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_user_drag: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1551,
            "use.counter.css.doc",
            "webkit_user_drag",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_user_modify
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-user-
    /// modify. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_user_modify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1552,
            "use.counter.css.doc",
            "webkit_user_modify",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_writing_mode
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-writing-
    /// mode. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_writing_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1553,
            "use.counter.css.doc",
            "webkit_writing_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.widows
    ///
    /// Whether a document used the (unknown, counted) CSS property widows. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static widows: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1554,
            "use.counter.css.doc",
            "widows",
            "use-counters"
        )
    });

}
pub mod use_counter_css_page {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.alignment_baseline
    ///
    /// Whether a page used the (unknown, counted) CSS property alignment-baseline.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static alignment_baseline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1555,
            "use.counter.css.page",
            "alignment_baseline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.background_repeat_x
    ///
    /// Whether a page used the (unknown, counted) CSS property background-repeat-x.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static background_repeat_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1556,
            "use.counter.css.page",
            "background_repeat_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.background_repeat_y
    ///
    /// Whether a page used the (unknown, counted) CSS property background-repeat-y.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static background_repeat_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1557,
            "use.counter.css.page",
            "background_repeat_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.baseline_shift
    ///
    /// Whether a page used the (unknown, counted) CSS property baseline-shift. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static baseline_shift: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1558,
            "use.counter.css.page",
            "baseline_shift",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.buffered_rendering
    ///
    /// Whether a page used the (unknown, counted) CSS property buffered-rendering.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static buffered_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1559,
            "use.counter.css.page",
            "buffered_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.color_rendering
    ///
    /// Whether a page used the (unknown, counted) CSS property color-rendering.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static color_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1560,
            "use.counter.css.page",
            "color_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_accent_color
    ///
    /// Whether a page used the CSS property accent-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_accent_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1561,
            "use.counter.css.page",
            "css_accent_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_align_content
    ///
    /// Whether a page used the CSS property align-content. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_align_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1562,
            "use.counter.css.page",
            "css_align_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_align_items
    ///
    /// Whether a page used the CSS property align-items. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_align_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1563,
            "use.counter.css.page",
            "css_align_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_align_self
    ///
    /// Whether a page used the CSS property align-self. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_align_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1564,
            "use.counter.css.page",
            "css_align_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_all
    ///
    /// Whether a page used the CSS property all. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_all: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1565,
            "use.counter.css.page",
            "css_all",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_anchor_name
    ///
    /// Whether a page used the CSS property anchor-name. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_anchor_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1566,
            "use.counter.css.page",
            "css_anchor_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_anchor_scope
    ///
    /// Whether a page used the CSS property anchor-scope. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_anchor_scope: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1567,
            "use.counter.css.page",
            "css_anchor_scope",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation
    ///
    /// Whether a page used the CSS property animation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1568,
            "use.counter.css.page",
            "css_animation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_composition
    ///
    /// Whether a page used the CSS property animation-composition. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_composition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1569,
            "use.counter.css.page",
            "css_animation_composition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_delay
    ///
    /// Whether a page used the CSS property animation-delay. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1570,
            "use.counter.css.page",
            "css_animation_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_direction
    ///
    /// Whether a page used the CSS property animation-direction. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1571,
            "use.counter.css.page",
            "css_animation_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_duration
    ///
    /// Whether a page used the CSS property animation-duration. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1572,
            "use.counter.css.page",
            "css_animation_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_fill_mode
    ///
    /// Whether a page used the CSS property animation-fill-mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_fill_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1573,
            "use.counter.css.page",
            "css_animation_fill_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_iteration_count
    ///
    /// Whether a page used the CSS property animation-iteration-count. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_iteration_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1574,
            "use.counter.css.page",
            "css_animation_iteration_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_name
    ///
    /// Whether a page used the CSS property animation-name. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1575,
            "use.counter.css.page",
            "css_animation_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_play_state
    ///
    /// Whether a page used the CSS property animation-play-state. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_play_state: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1576,
            "use.counter.css.page",
            "css_animation_play_state",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_timeline
    ///
    /// Whether a page used the CSS property animation-timeline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_timeline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1577,
            "use.counter.css.page",
            "css_animation_timeline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_timing_function
    ///
    /// Whether a page used the CSS property animation-timing-function. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1578,
            "use.counter.css.page",
            "css_animation_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_appearance
    ///
    /// Whether a page used the CSS property appearance. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1579,
            "use.counter.css.page",
            "css_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_aspect_ratio
    ///
    /// Whether a page used the CSS property aspect-ratio. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_aspect_ratio: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1580,
            "use.counter.css.page",
            "css_aspect_ratio",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_backdrop_filter
    ///
    /// Whether a page used the CSS property backdrop-filter. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_backdrop_filter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1581,
            "use.counter.css.page",
            "css_backdrop_filter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_backface_visibility
    ///
    /// Whether a page used the CSS property backface-visibility. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_backface_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1582,
            "use.counter.css.page",
            "css_backface_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background
    ///
    /// Whether a page used the CSS property background. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1583,
            "use.counter.css.page",
            "css_background",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_attachment
    ///
    /// Whether a page used the CSS property background-attachment. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_attachment: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1584,
            "use.counter.css.page",
            "css_background_attachment",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_blend_mode
    ///
    /// Whether a page used the CSS property background-blend-mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_blend_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1585,
            "use.counter.css.page",
            "css_background_blend_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_clip
    ///
    /// Whether a page used the CSS property background-clip. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1586,
            "use.counter.css.page",
            "css_background_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_color
    ///
    /// Whether a page used the CSS property background-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1587,
            "use.counter.css.page",
            "css_background_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_image
    ///
    /// Whether a page used the CSS property background-image. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1588,
            "use.counter.css.page",
            "css_background_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_origin
    ///
    /// Whether a page used the CSS property background-origin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1589,
            "use.counter.css.page",
            "css_background_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_position
    ///
    /// Whether a page used the CSS property background-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1590,
            "use.counter.css.page",
            "css_background_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_position_x
    ///
    /// Whether a page used the CSS property background-position-x. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_position_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1591,
            "use.counter.css.page",
            "css_background_position_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_position_y
    ///
    /// Whether a page used the CSS property background-position-y. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_position_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1592,
            "use.counter.css.page",
            "css_background_position_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_repeat
    ///
    /// Whether a page used the CSS property background-repeat. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1593,
            "use.counter.css.page",
            "css_background_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_size
    ///
    /// Whether a page used the CSS property background-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1594,
            "use.counter.css.page",
            "css_background_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_baseline_source
    ///
    /// Whether a page used the CSS property baseline-source. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_baseline_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1595,
            "use.counter.css.page",
            "css_baseline_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_block_size
    ///
    /// Whether a page used the CSS property block-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1596,
            "use.counter.css.page",
            "css_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border
    ///
    /// Whether a page used the CSS property border. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1597,
            "use.counter.css.page",
            "css_border",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block
    ///
    /// Whether a page used the CSS property border-block. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1598,
            "use.counter.css.page",
            "css_border_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_color
    ///
    /// Whether a page used the CSS property border-block-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1599,
            "use.counter.css.page",
            "css_border_block_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_end
    ///
    /// Whether a page used the CSS property border-block-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1600,
            "use.counter.css.page",
            "css_border_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_end_color
    ///
    /// Whether a page used the CSS property border-block-end-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1601,
            "use.counter.css.page",
            "css_border_block_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_end_style
    ///
    /// Whether a page used the CSS property border-block-end-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1602,
            "use.counter.css.page",
            "css_border_block_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_end_width
    ///
    /// Whether a page used the CSS property border-block-end-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1603,
            "use.counter.css.page",
            "css_border_block_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_start
    ///
    /// Whether a page used the CSS property border-block-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1604,
            "use.counter.css.page",
            "css_border_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_start_color
    ///
    /// Whether a page used the CSS property border-block-start-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1605,
            "use.counter.css.page",
            "css_border_block_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_start_style
    ///
    /// Whether a page used the CSS property border-block-start-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1606,
            "use.counter.css.page",
            "css_border_block_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_start_width
    ///
    /// Whether a page used the CSS property border-block-start-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1607,
            "use.counter.css.page",
            "css_border_block_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_style
    ///
    /// Whether a page used the CSS property border-block-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1608,
            "use.counter.css.page",
            "css_border_block_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_width
    ///
    /// Whether a page used the CSS property border-block-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1609,
            "use.counter.css.page",
            "css_border_block_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_bottom
    ///
    /// Whether a page used the CSS property border-bottom. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1610,
            "use.counter.css.page",
            "css_border_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_bottom_color
    ///
    /// Whether a page used the CSS property border-bottom-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1611,
            "use.counter.css.page",
            "css_border_bottom_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_bottom_left_radius
    ///
    /// Whether a page used the CSS property border-bottom-left-radius. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1612,
            "use.counter.css.page",
            "css_border_bottom_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_bottom_right_radius
    ///
    /// Whether a page used the CSS property border-bottom-right-radius. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_border_bottom_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1613,
            "use.counter.css.page",
            "css_border_bottom_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_bottom_style
    ///
    /// Whether a page used the CSS property border-bottom-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1614,
            "use.counter.css.page",
            "css_border_bottom_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_bottom_width
    ///
    /// Whether a page used the CSS property border-bottom-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1615,
            "use.counter.css.page",
            "css_border_bottom_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_collapse
    ///
    /// Whether a page used the CSS property border-collapse. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1616,
            "use.counter.css.page",
            "css_border_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_color
    ///
    /// Whether a page used the CSS property border-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1617,
            "use.counter.css.page",
            "css_border_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_end_end_radius
    ///
    /// Whether a page used the CSS property border-end-end-radius. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_end_end_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1618,
            "use.counter.css.page",
            "css_border_end_end_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_end_start_radius
    ///
    /// Whether a page used the CSS property border-end-start-radius. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_end_start_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1619,
            "use.counter.css.page",
            "css_border_end_start_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_image
    ///
    /// Whether a page used the CSS property border-image. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1620,
            "use.counter.css.page",
            "css_border_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_image_outset
    ///
    /// Whether a page used the CSS property border-image-outset. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_image_outset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1621,
            "use.counter.css.page",
            "css_border_image_outset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_image_repeat
    ///
    /// Whether a page used the CSS property border-image-repeat. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_image_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1622,
            "use.counter.css.page",
            "css_border_image_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_image_slice
    ///
    /// Whether a page used the CSS property border-image-slice. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_image_slice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1623,
            "use.counter.css.page",
            "css_border_image_slice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_image_source
    ///
    /// Whether a page used the CSS property border-image-source. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_image_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1624,
            "use.counter.css.page",
            "css_border_image_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_image_width
    ///
    /// Whether a page used the CSS property border-image-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_image_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1625,
            "use.counter.css.page",
            "css_border_image_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline
    ///
    /// Whether a page used the CSS property border-inline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1626,
            "use.counter.css.page",
            "css_border_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_color
    ///
    /// Whether a page used the CSS property border-inline-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1627,
            "use.counter.css.page",
            "css_border_inline_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_end
    ///
    /// Whether a page used the CSS property border-inline-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1628,
            "use.counter.css.page",
            "css_border_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_end_color
    ///
    /// Whether a page used the CSS property border-inline-end-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1629,
            "use.counter.css.page",
            "css_border_inline_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_end_style
    ///
    /// Whether a page used the CSS property border-inline-end-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1630,
            "use.counter.css.page",
            "css_border_inline_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_end_width
    ///
    /// Whether a page used the CSS property border-inline-end-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1631,
            "use.counter.css.page",
            "css_border_inline_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_start
    ///
    /// Whether a page used the CSS property border-inline-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1632,
            "use.counter.css.page",
            "css_border_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_start_color
    ///
    /// Whether a page used the CSS property border-inline-start-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1633,
            "use.counter.css.page",
            "css_border_inline_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_start_style
    ///
    /// Whether a page used the CSS property border-inline-start-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1634,
            "use.counter.css.page",
            "css_border_inline_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_start_width
    ///
    /// Whether a page used the CSS property border-inline-start-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1635,
            "use.counter.css.page",
            "css_border_inline_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_style
    ///
    /// Whether a page used the CSS property border-inline-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1636,
            "use.counter.css.page",
            "css_border_inline_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_width
    ///
    /// Whether a page used the CSS property border-inline-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1637,
            "use.counter.css.page",
            "css_border_inline_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_left
    ///
    /// Whether a page used the CSS property border-left. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1638,
            "use.counter.css.page",
            "css_border_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_left_color
    ///
    /// Whether a page used the CSS property border-left-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_left_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1639,
            "use.counter.css.page",
            "css_border_left_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_left_style
    ///
    /// Whether a page used the CSS property border-left-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_left_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1640,
            "use.counter.css.page",
            "css_border_left_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_left_width
    ///
    /// Whether a page used the CSS property border-left-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_left_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1641,
            "use.counter.css.page",
            "css_border_left_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_radius
    ///
    /// Whether a page used the CSS property border-radius. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1642,
            "use.counter.css.page",
            "css_border_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_right
    ///
    /// Whether a page used the CSS property border-right. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1643,
            "use.counter.css.page",
            "css_border_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_right_color
    ///
    /// Whether a page used the CSS property border-right-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_right_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1644,
            "use.counter.css.page",
            "css_border_right_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_right_style
    ///
    /// Whether a page used the CSS property border-right-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_right_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1645,
            "use.counter.css.page",
            "css_border_right_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_right_width
    ///
    /// Whether a page used the CSS property border-right-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_right_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1646,
            "use.counter.css.page",
            "css_border_right_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_spacing
    ///
    /// Whether a page used the CSS property border-spacing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1647,
            "use.counter.css.page",
            "css_border_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_start_end_radius
    ///
    /// Whether a page used the CSS property border-start-end-radius. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_start_end_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1648,
            "use.counter.css.page",
            "css_border_start_end_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_start_start_radius
    ///
    /// Whether a page used the CSS property border-start-start-radius. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_start_start_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1649,
            "use.counter.css.page",
            "css_border_start_start_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_style
    ///
    /// Whether a page used the CSS property border-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1650,
            "use.counter.css.page",
            "css_border_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_top
    ///
    /// Whether a page used the CSS property border-top. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1651,
            "use.counter.css.page",
            "css_border_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_top_color
    ///
    /// Whether a page used the CSS property border-top-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_top_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1652,
            "use.counter.css.page",
            "css_border_top_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_top_left_radius
    ///
    /// Whether a page used the CSS property border-top-left-radius. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_top_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1653,
            "use.counter.css.page",
            "css_border_top_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_top_right_radius
    ///
    /// Whether a page used the CSS property border-top-right-radius. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_top_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1654,
            "use.counter.css.page",
            "css_border_top_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_top_style
    ///
    /// Whether a page used the CSS property border-top-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_top_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1655,
            "use.counter.css.page",
            "css_border_top_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_top_width
    ///
    /// Whether a page used the CSS property border-top-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_top_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1656,
            "use.counter.css.page",
            "css_border_top_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_width
    ///
    /// Whether a page used the CSS property border-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1657,
            "use.counter.css.page",
            "css_border_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_bottom
    ///
    /// Whether a page used the CSS property bottom. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1658,
            "use.counter.css.page",
            "css_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_box_decoration_break
    ///
    /// Whether a page used the CSS property box-decoration-break. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_box_decoration_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1659,
            "use.counter.css.page",
            "css_box_decoration_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_box_shadow
    ///
    /// Whether a page used the CSS property box-shadow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_box_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1660,
            "use.counter.css.page",
            "css_box_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_box_sizing
    ///
    /// Whether a page used the CSS property box-sizing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_box_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1661,
            "use.counter.css.page",
            "css_box_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_break_after
    ///
    /// Whether a page used the CSS property break-after. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_break_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1662,
            "use.counter.css.page",
            "css_break_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_break_before
    ///
    /// Whether a page used the CSS property break-before. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_break_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1663,
            "use.counter.css.page",
            "css_break_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_break_inside
    ///
    /// Whether a page used the CSS property break-inside. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_break_inside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1664,
            "use.counter.css.page",
            "css_break_inside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_caption_side
    ///
    /// Whether a page used the CSS property caption-side. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_caption_side: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1665,
            "use.counter.css.page",
            "css_caption_side",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_caret_color
    ///
    /// Whether a page used the CSS property caret-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_caret_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1666,
            "use.counter.css.page",
            "css_caret_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_clear
    ///
    /// Whether a page used the CSS property clear. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_clear: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1667,
            "use.counter.css.page",
            "css_clear",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_clip
    ///
    /// Whether a page used the CSS property clip. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1668,
            "use.counter.css.page",
            "css_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_clip_path
    ///
    /// Whether a page used the CSS property clip-path. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_clip_path: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1669,
            "use.counter.css.page",
            "css_clip_path",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_clip_rule
    ///
    /// Whether a page used the CSS property clip-rule. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_clip_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1670,
            "use.counter.css.page",
            "css_clip_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_color
    ///
    /// Whether a page used the CSS property color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1671,
            "use.counter.css.page",
            "css_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_color_adjust
    ///
    /// Whether a page used the CSS property color-adjust. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1672,
            "use.counter.css.page",
            "css_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_color_interpolation
    ///
    /// Whether a page used the CSS property color-interpolation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_color_interpolation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1673,
            "use.counter.css.page",
            "css_color_interpolation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_color_interpolation_filters
    ///
    /// Whether a page used the CSS property color-interpolation-filters. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_color_interpolation_filters: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1674,
            "use.counter.css.page",
            "css_color_interpolation_filters",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_color_scheme
    ///
    /// Whether a page used the CSS property color-scheme. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_color_scheme: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1675,
            "use.counter.css.page",
            "css_color_scheme",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_count
    ///
    /// Whether a page used the CSS property column-count. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1676,
            "use.counter.css.page",
            "css_column_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_fill
    ///
    /// Whether a page used the CSS property column-fill. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_fill: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1677,
            "use.counter.css.page",
            "css_column_fill",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_gap
    ///
    /// Whether a page used the CSS property column-gap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1678,
            "use.counter.css.page",
            "css_column_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_rule
    ///
    /// Whether a page used the CSS property column-rule. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1679,
            "use.counter.css.page",
            "css_column_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_rule_color
    ///
    /// Whether a page used the CSS property column-rule-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_rule_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1680,
            "use.counter.css.page",
            "css_column_rule_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_rule_style
    ///
    /// Whether a page used the CSS property column-rule-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_rule_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1681,
            "use.counter.css.page",
            "css_column_rule_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_rule_width
    ///
    /// Whether a page used the CSS property column-rule-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_rule_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1682,
            "use.counter.css.page",
            "css_column_rule_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_span
    ///
    /// Whether a page used the CSS property column-span. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_span: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1683,
            "use.counter.css.page",
            "css_column_span",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_width
    ///
    /// Whether a page used the CSS property column-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1684,
            "use.counter.css.page",
            "css_column_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_columns
    ///
    /// Whether a page used the CSS property columns. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1685,
            "use.counter.css.page",
            "css_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_contain
    ///
    /// Whether a page used the CSS property contain. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_contain: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1686,
            "use.counter.css.page",
            "css_contain",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_contain_intrinsic_block_size
    ///
    /// Whether a page used the CSS property contain-intrinsic-block-size. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_contain_intrinsic_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1687,
            "use.counter.css.page",
            "css_contain_intrinsic_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_contain_intrinsic_height
    ///
    /// Whether a page used the CSS property contain-intrinsic-height. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1688,
            "use.counter.css.page",
            "css_contain_intrinsic_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_contain_intrinsic_inline_size
    ///
    /// Whether a page used the CSS property contain-intrinsic-inline-size. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_contain_intrinsic_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1689,
            "use.counter.css.page",
            "css_contain_intrinsic_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_contain_intrinsic_size
    ///
    /// Whether a page used the CSS property contain-intrinsic-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1690,
            "use.counter.css.page",
            "css_contain_intrinsic_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_contain_intrinsic_width
    ///
    /// Whether a page used the CSS property contain-intrinsic-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1691,
            "use.counter.css.page",
            "css_contain_intrinsic_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_container
    ///
    /// Whether a page used the CSS property container. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_container: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1692,
            "use.counter.css.page",
            "css_container",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_container_name
    ///
    /// Whether a page used the CSS property container-name. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_container_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1693,
            "use.counter.css.page",
            "css_container_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_container_type
    ///
    /// Whether a page used the CSS property container-type. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_container_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1694,
            "use.counter.css.page",
            "css_container_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_content
    ///
    /// Whether a page used the CSS property content. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1695,
            "use.counter.css.page",
            "css_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_content_visibility
    ///
    /// Whether a page used the CSS property content-visibility. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_content_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1696,
            "use.counter.css.page",
            "css_content_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_counter_increment
    ///
    /// Whether a page used the CSS property counter-increment. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_counter_increment: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1697,
            "use.counter.css.page",
            "css_counter_increment",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_counter_reset
    ///
    /// Whether a page used the CSS property counter-reset. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_counter_reset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1698,
            "use.counter.css.page",
            "css_counter_reset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_counter_set
    ///
    /// Whether a page used the CSS property counter-set. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_counter_set: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1699,
            "use.counter.css.page",
            "css_counter_set",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_cursor
    ///
    /// Whether a page used the CSS property cursor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_cursor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1700,
            "use.counter.css.page",
            "css_cursor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_cx
    ///
    /// Whether a page used the CSS property cx. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_cx: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1701,
            "use.counter.css.page",
            "css_cx",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_cy
    ///
    /// Whether a page used the CSS property cy. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_cy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1702,
            "use.counter.css.page",
            "css_cy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_d
    ///
    /// Whether a page used the CSS property d. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_d: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1703,
            "use.counter.css.page",
            "css_d",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_direction
    ///
    /// Whether a page used the CSS property direction. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1704,
            "use.counter.css.page",
            "css_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_display
    ///
    /// Whether a page used the CSS property display. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_display: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1705,
            "use.counter.css.page",
            "css_display",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_dominant_baseline
    ///
    /// Whether a page used the CSS property dominant-baseline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_dominant_baseline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1706,
            "use.counter.css.page",
            "css_dominant_baseline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_empty_cells
    ///
    /// Whether a page used the CSS property empty-cells. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_empty_cells: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1707,
            "use.counter.css.page",
            "css_empty_cells",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_field_sizing
    ///
    /// Whether a page used the CSS property field-sizing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_field_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1708,
            "use.counter.css.page",
            "css_field_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_fill
    ///
    /// Whether a page used the CSS property fill. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_fill: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1709,
            "use.counter.css.page",
            "css_fill",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_fill_opacity
    ///
    /// Whether a page used the CSS property fill-opacity. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_fill_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1710,
            "use.counter.css.page",
            "css_fill_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_fill_rule
    ///
    /// Whether a page used the CSS property fill-rule. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_fill_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1711,
            "use.counter.css.page",
            "css_fill_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_filter
    ///
    /// Whether a page used the CSS property filter. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_filter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1712,
            "use.counter.css.page",
            "css_filter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flex
    ///
    /// Whether a page used the CSS property flex. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1713,
            "use.counter.css.page",
            "css_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flex_basis
    ///
    /// Whether a page used the CSS property flex-basis. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flex_basis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1714,
            "use.counter.css.page",
            "css_flex_basis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flex_direction
    ///
    /// Whether a page used the CSS property flex-direction. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flex_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1715,
            "use.counter.css.page",
            "css_flex_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flex_flow
    ///
    /// Whether a page used the CSS property flex-flow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flex_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1716,
            "use.counter.css.page",
            "css_flex_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flex_grow
    ///
    /// Whether a page used the CSS property flex-grow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flex_grow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1717,
            "use.counter.css.page",
            "css_flex_grow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flex_shrink
    ///
    /// Whether a page used the CSS property flex-shrink. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flex_shrink: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1718,
            "use.counter.css.page",
            "css_flex_shrink",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flex_wrap
    ///
    /// Whether a page used the CSS property flex-wrap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flex_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1719,
            "use.counter.css.page",
            "css_flex_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_float
    ///
    /// Whether a page used the CSS property float. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_float: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1720,
            "use.counter.css.page",
            "css_float",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flood_color
    ///
    /// Whether a page used the CSS property flood-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flood_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1721,
            "use.counter.css.page",
            "css_flood_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flood_opacity
    ///
    /// Whether a page used the CSS property flood-opacity. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flood_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1722,
            "use.counter.css.page",
            "css_flood_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font
    ///
    /// Whether a page used the CSS property font. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1723,
            "use.counter.css.page",
            "css_font",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_family
    ///
    /// Whether a page used the CSS property font-family. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_family: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1724,
            "use.counter.css.page",
            "css_font_family",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_feature_settings
    ///
    /// Whether a page used the CSS property font-feature-settings. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_feature_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1725,
            "use.counter.css.page",
            "css_font_feature_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_kerning
    ///
    /// Whether a page used the CSS property font-kerning. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_kerning: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1726,
            "use.counter.css.page",
            "css_font_kerning",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_language_override
    ///
    /// Whether a page used the CSS property font-language-override. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_language_override: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1727,
            "use.counter.css.page",
            "css_font_language_override",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_optical_sizing
    ///
    /// Whether a page used the CSS property font-optical-sizing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_optical_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1728,
            "use.counter.css.page",
            "css_font_optical_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_palette
    ///
    /// Whether a page used the CSS property font-palette. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_palette: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1729,
            "use.counter.css.page",
            "css_font_palette",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_size
    ///
    /// Whether a page used the CSS property font-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1730,
            "use.counter.css.page",
            "css_font_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_size_adjust
    ///
    /// Whether a page used the CSS property font-size-adjust. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1731,
            "use.counter.css.page",
            "css_font_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_stretch
    ///
    /// Whether a page used the CSS property font-stretch. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_stretch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1732,
            "use.counter.css.page",
            "css_font_stretch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_style
    ///
    /// Whether a page used the CSS property font-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1733,
            "use.counter.css.page",
            "css_font_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_synthesis
    ///
    /// Whether a page used the CSS property font-synthesis. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1734,
            "use.counter.css.page",
            "css_font_synthesis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_synthesis_position
    ///
    /// Whether a page used the CSS property font-synthesis-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1735,
            "use.counter.css.page",
            "css_font_synthesis_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_synthesis_small_caps
    ///
    /// Whether a page used the CSS property font-synthesis-small-caps. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_small_caps: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1736,
            "use.counter.css.page",
            "css_font_synthesis_small_caps",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_synthesis_style
    ///
    /// Whether a page used the CSS property font-synthesis-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1737,
            "use.counter.css.page",
            "css_font_synthesis_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_synthesis_weight
    ///
    /// Whether a page used the CSS property font-synthesis-weight. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_weight: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1738,
            "use.counter.css.page",
            "css_font_synthesis_weight",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant
    ///
    /// Whether a page used the CSS property font-variant. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1739,
            "use.counter.css.page",
            "css_font_variant",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant_alternates
    ///
    /// Whether a page used the CSS property font-variant-alternates. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_alternates: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1740,
            "use.counter.css.page",
            "css_font_variant_alternates",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant_caps
    ///
    /// Whether a page used the CSS property font-variant-caps. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_caps: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1741,
            "use.counter.css.page",
            "css_font_variant_caps",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant_east_asian
    ///
    /// Whether a page used the CSS property font-variant-east-asian. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_east_asian: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1742,
            "use.counter.css.page",
            "css_font_variant_east_asian",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant_emoji
    ///
    /// Whether a page used the CSS property font-variant-emoji. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_emoji: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1743,
            "use.counter.css.page",
            "css_font_variant_emoji",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant_ligatures
    ///
    /// Whether a page used the CSS property font-variant-ligatures. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_ligatures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1744,
            "use.counter.css.page",
            "css_font_variant_ligatures",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant_numeric
    ///
    /// Whether a page used the CSS property font-variant-numeric. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_numeric: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1745,
            "use.counter.css.page",
            "css_font_variant_numeric",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant_position
    ///
    /// Whether a page used the CSS property font-variant-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1746,
            "use.counter.css.page",
            "css_font_variant_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variation_settings
    ///
    /// Whether a page used the CSS property font-variation-settings. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variation_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1747,
            "use.counter.css.page",
            "css_font_variation_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_weight
    ///
    /// Whether a page used the CSS property font-weight. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_weight: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1748,
            "use.counter.css.page",
            "css_font_weight",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_forced_color_adjust
    ///
    /// Whether a page used the CSS property forced-color-adjust. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_forced_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1749,
            "use.counter.css.page",
            "css_forced_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_gap
    ///
    /// Whether a page used the CSS property gap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1750,
            "use.counter.css.page",
            "css_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid
    ///
    /// Whether a page used the CSS property grid. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1751,
            "use.counter.css.page",
            "css_grid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_area
    ///
    /// Whether a page used the CSS property grid-area. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_area: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1752,
            "use.counter.css.page",
            "css_grid_area",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_auto_columns
    ///
    /// Whether a page used the CSS property grid-auto-columns. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_auto_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1753,
            "use.counter.css.page",
            "css_grid_auto_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_auto_flow
    ///
    /// Whether a page used the CSS property grid-auto-flow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_auto_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1754,
            "use.counter.css.page",
            "css_grid_auto_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_auto_rows
    ///
    /// Whether a page used the CSS property grid-auto-rows. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_auto_rows: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1755,
            "use.counter.css.page",
            "css_grid_auto_rows",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_column
    ///
    /// Whether a page used the CSS property grid-column. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_column: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1756,
            "use.counter.css.page",
            "css_grid_column",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_column_end
    ///
    /// Whether a page used the CSS property grid-column-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_column_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1757,
            "use.counter.css.page",
            "css_grid_column_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_column_gap
    ///
    /// Whether a page used the CSS property grid-column-gap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_column_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1758,
            "use.counter.css.page",
            "css_grid_column_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_column_start
    ///
    /// Whether a page used the CSS property grid-column-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_column_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1759,
            "use.counter.css.page",
            "css_grid_column_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_gap
    ///
    /// Whether a page used the CSS property grid-gap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1760,
            "use.counter.css.page",
            "css_grid_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_row
    ///
    /// Whether a page used the CSS property grid-row. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_row: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1761,
            "use.counter.css.page",
            "css_grid_row",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_row_end
    ///
    /// Whether a page used the CSS property grid-row-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_row_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1762,
            "use.counter.css.page",
            "css_grid_row_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_row_gap
    ///
    /// Whether a page used the CSS property grid-row-gap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_row_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1763,
            "use.counter.css.page",
            "css_grid_row_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_row_start
    ///
    /// Whether a page used the CSS property grid-row-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_row_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1764,
            "use.counter.css.page",
            "css_grid_row_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_template
    ///
    /// Whether a page used the CSS property grid-template. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_template: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1765,
            "use.counter.css.page",
            "css_grid_template",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_template_areas
    ///
    /// Whether a page used the CSS property grid-template-areas. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_template_areas: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1766,
            "use.counter.css.page",
            "css_grid_template_areas",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_template_columns
    ///
    /// Whether a page used the CSS property grid-template-columns. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_template_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1767,
            "use.counter.css.page",
            "css_grid_template_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_template_rows
    ///
    /// Whether a page used the CSS property grid-template-rows. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_template_rows: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1768,
            "use.counter.css.page",
            "css_grid_template_rows",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_height
    ///
    /// Whether a page used the CSS property height. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1769,
            "use.counter.css.page",
            "css_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_hyphenate_character
    ///
    /// Whether a page used the CSS property hyphenate-character. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_hyphenate_character: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1770,
            "use.counter.css.page",
            "css_hyphenate_character",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_hyphens
    ///
    /// Whether a page used the CSS property hyphens. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_hyphens: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1771,
            "use.counter.css.page",
            "css_hyphens",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_image_orientation
    ///
    /// Whether a page used the CSS property image-orientation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_image_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1772,
            "use.counter.css.page",
            "css_image_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_image_rendering
    ///
    /// Whether a page used the CSS property image-rendering. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_image_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1773,
            "use.counter.css.page",
            "css_image_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_ime_mode
    ///
    /// Whether a page used the CSS property ime-mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_ime_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1774,
            "use.counter.css.page",
            "css_ime_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_initial_letter
    ///
    /// Whether a page used the CSS property initial-letter. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_initial_letter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1775,
            "use.counter.css.page",
            "css_initial_letter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inline_size
    ///
    /// Whether a page used the CSS property inline-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1776,
            "use.counter.css.page",
            "css_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset
    ///
    /// Whether a page used the CSS property inset. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1777,
            "use.counter.css.page",
            "css_inset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset_block
    ///
    /// Whether a page used the CSS property inset-block. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1778,
            "use.counter.css.page",
            "css_inset_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset_block_end
    ///
    /// Whether a page used the CSS property inset-block-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1779,
            "use.counter.css.page",
            "css_inset_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset_block_start
    ///
    /// Whether a page used the CSS property inset-block-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1780,
            "use.counter.css.page",
            "css_inset_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset_inline
    ///
    /// Whether a page used the CSS property inset-inline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1781,
            "use.counter.css.page",
            "css_inset_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset_inline_end
    ///
    /// Whether a page used the CSS property inset-inline-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1782,
            "use.counter.css.page",
            "css_inset_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset_inline_start
    ///
    /// Whether a page used the CSS property inset-inline-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1783,
            "use.counter.css.page",
            "css_inset_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_isolation
    ///
    /// Whether a page used the CSS property isolation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_isolation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1784,
            "use.counter.css.page",
            "css_isolation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_justify_content
    ///
    /// Whether a page used the CSS property justify-content. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_justify_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1785,
            "use.counter.css.page",
            "css_justify_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_justify_items
    ///
    /// Whether a page used the CSS property justify-items. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_justify_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1786,
            "use.counter.css.page",
            "css_justify_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_justify_self
    ///
    /// Whether a page used the CSS property justify-self. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_justify_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1787,
            "use.counter.css.page",
            "css_justify_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_left
    ///
    /// Whether a page used the CSS property left. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1788,
            "use.counter.css.page",
            "css_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_letter_spacing
    ///
    /// Whether a page used the CSS property letter-spacing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_letter_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1789,
            "use.counter.css.page",
            "css_letter_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_lighting_color
    ///
    /// Whether a page used the CSS property lighting-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_lighting_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1790,
            "use.counter.css.page",
            "css_lighting_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_line_break
    ///
    /// Whether a page used the CSS property line-break. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_line_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1791,
            "use.counter.css.page",
            "css_line_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_line_height
    ///
    /// Whether a page used the CSS property line-height. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_line_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1792,
            "use.counter.css.page",
            "css_line_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_list_style
    ///
    /// Whether a page used the CSS property list-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_list_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1793,
            "use.counter.css.page",
            "css_list_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_list_style_image
    ///
    /// Whether a page used the CSS property list-style-image. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_list_style_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1794,
            "use.counter.css.page",
            "css_list_style_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_list_style_position
    ///
    /// Whether a page used the CSS property list-style-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_list_style_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1795,
            "use.counter.css.page",
            "css_list_style_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_list_style_type
    ///
    /// Whether a page used the CSS property list-style-type. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_list_style_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1796,
            "use.counter.css.page",
            "css_list_style_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin
    ///
    /// Whether a page used the CSS property margin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1797,
            "use.counter.css.page",
            "css_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_block
    ///
    /// Whether a page used the CSS property margin-block. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1798,
            "use.counter.css.page",
            "css_margin_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_block_end
    ///
    /// Whether a page used the CSS property margin-block-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1799,
            "use.counter.css.page",
            "css_margin_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_block_start
    ///
    /// Whether a page used the CSS property margin-block-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1800,
            "use.counter.css.page",
            "css_margin_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_bottom
    ///
    /// Whether a page used the CSS property margin-bottom. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1801,
            "use.counter.css.page",
            "css_margin_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_inline
    ///
    /// Whether a page used the CSS property margin-inline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1802,
            "use.counter.css.page",
            "css_margin_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_inline_end
    ///
    /// Whether a page used the CSS property margin-inline-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1803,
            "use.counter.css.page",
            "css_margin_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_inline_start
    ///
    /// Whether a page used the CSS property margin-inline-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1804,
            "use.counter.css.page",
            "css_margin_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_left
    ///
    /// Whether a page used the CSS property margin-left. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1805,
            "use.counter.css.page",
            "css_margin_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_right
    ///
    /// Whether a page used the CSS property margin-right. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1806,
            "use.counter.css.page",
            "css_margin_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_top
    ///
    /// Whether a page used the CSS property margin-top. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1807,
            "use.counter.css.page",
            "css_margin_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_marker
    ///
    /// Whether a page used the CSS property marker. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_marker: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1808,
            "use.counter.css.page",
            "css_marker",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_marker_end
    ///
    /// Whether a page used the CSS property marker-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_marker_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1809,
            "use.counter.css.page",
            "css_marker_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_marker_mid
    ///
    /// Whether a page used the CSS property marker-mid. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_marker_mid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1810,
            "use.counter.css.page",
            "css_marker_mid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_marker_start
    ///
    /// Whether a page used the CSS property marker-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_marker_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1811,
            "use.counter.css.page",
            "css_marker_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask
    ///
    /// Whether a page used the CSS property mask. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1812,
            "use.counter.css.page",
            "css_mask",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_clip
    ///
    /// Whether a page used the CSS property mask-clip. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1813,
            "use.counter.css.page",
            "css_mask_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_composite
    ///
    /// Whether a page used the CSS property mask-composite. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_composite: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1814,
            "use.counter.css.page",
            "css_mask_composite",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_image
    ///
    /// Whether a page used the CSS property mask-image. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1815,
            "use.counter.css.page",
            "css_mask_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_mode
    ///
    /// Whether a page used the CSS property mask-mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1816,
            "use.counter.css.page",
            "css_mask_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_origin
    ///
    /// Whether a page used the CSS property mask-origin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1817,
            "use.counter.css.page",
            "css_mask_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_position
    ///
    /// Whether a page used the CSS property mask-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1818,
            "use.counter.css.page",
            "css_mask_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_position_x
    ///
    /// Whether a page used the CSS property mask-position-x. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_position_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1819,
            "use.counter.css.page",
            "css_mask_position_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_position_y
    ///
    /// Whether a page used the CSS property mask-position-y. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_position_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1820,
            "use.counter.css.page",
            "css_mask_position_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_repeat
    ///
    /// Whether a page used the CSS property mask-repeat. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1821,
            "use.counter.css.page",
            "css_mask_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_size
    ///
    /// Whether a page used the CSS property mask-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1822,
            "use.counter.css.page",
            "css_mask_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_type
    ///
    /// Whether a page used the CSS property mask-type. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1823,
            "use.counter.css.page",
            "css_mask_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_masonry_auto_flow
    ///
    /// Whether a page used the CSS property masonry-auto-flow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_masonry_auto_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1824,
            "use.counter.css.page",
            "css_masonry_auto_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_math_depth
    ///
    /// Whether a page used the CSS property math-depth. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_math_depth: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1825,
            "use.counter.css.page",
            "css_math_depth",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_math_style
    ///
    /// Whether a page used the CSS property math-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_math_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1826,
            "use.counter.css.page",
            "css_math_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_max_block_size
    ///
    /// Whether a page used the CSS property max-block-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_max_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1827,
            "use.counter.css.page",
            "css_max_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_max_height
    ///
    /// Whether a page used the CSS property max-height. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_max_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1828,
            "use.counter.css.page",
            "css_max_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_max_inline_size
    ///
    /// Whether a page used the CSS property max-inline-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_max_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1829,
            "use.counter.css.page",
            "css_max_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_max_width
    ///
    /// Whether a page used the CSS property max-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_max_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1830,
            "use.counter.css.page",
            "css_max_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_min_block_size
    ///
    /// Whether a page used the CSS property min-block-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_min_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1831,
            "use.counter.css.page",
            "css_min_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_min_height
    ///
    /// Whether a page used the CSS property min-height. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_min_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1832,
            "use.counter.css.page",
            "css_min_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_min_inline_size
    ///
    /// Whether a page used the CSS property min-inline-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_min_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1833,
            "use.counter.css.page",
            "css_min_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_min_width
    ///
    /// Whether a page used the CSS property min-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_min_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1834,
            "use.counter.css.page",
            "css_min_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mix_blend_mode
    ///
    /// Whether a page used the CSS property mix-blend-mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mix_blend_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1835,
            "use.counter.css.page",
            "css_mix_blend_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation
    ///
    /// Whether a page used the CSS property -moz-animation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1836,
            "use.counter.css.page",
            "css_moz_animation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_delay
    ///
    /// Whether a page used the CSS property -moz-animation-delay. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1837,
            "use.counter.css.page",
            "css_moz_animation_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_direction
    ///
    /// Whether a page used the CSS property -moz-animation-direction. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1838,
            "use.counter.css.page",
            "css_moz_animation_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_duration
    ///
    /// Whether a page used the CSS property -moz-animation-duration. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1839,
            "use.counter.css.page",
            "css_moz_animation_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_fill_mode
    ///
    /// Whether a page used the CSS property -moz-animation-fill-mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_fill_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1840,
            "use.counter.css.page",
            "css_moz_animation_fill_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_iteration_count
    ///
    /// Whether a page used the CSS property -moz-animation-iteration-count. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_animation_iteration_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1841,
            "use.counter.css.page",
            "css_moz_animation_iteration_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_name
    ///
    /// Whether a page used the CSS property -moz-animation-name. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1842,
            "use.counter.css.page",
            "css_moz_animation_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_play_state
    ///
    /// Whether a page used the CSS property -moz-animation-play-state. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_play_state: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1843,
            "use.counter.css.page",
            "css_moz_animation_play_state",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_timing_function
    ///
    /// Whether a page used the CSS property -moz-animation-timing-function. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_animation_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1844,
            "use.counter.css.page",
            "css_moz_animation_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_appearance
    ///
    /// Whether a page used the CSS property -moz-appearance. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1845,
            "use.counter.css.page",
            "css_moz_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_backface_visibility
    ///
    /// Whether a page used the CSS property -moz-backface-visibility. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_backface_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1846,
            "use.counter.css.page",
            "css_moz_backface_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_end
    ///
    /// Whether a page used the CSS property -moz-border-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1847,
            "use.counter.css.page",
            "css_moz_border_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_end_color
    ///
    /// Whether a page used the CSS property -moz-border-end-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1848,
            "use.counter.css.page",
            "css_moz_border_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_end_style
    ///
    /// Whether a page used the CSS property -moz-border-end-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1849,
            "use.counter.css.page",
            "css_moz_border_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_end_width
    ///
    /// Whether a page used the CSS property -moz-border-end-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1850,
            "use.counter.css.page",
            "css_moz_border_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_image
    ///
    /// Whether a page used the CSS property -moz-border-image. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1851,
            "use.counter.css.page",
            "css_moz_border_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_start
    ///
    /// Whether a page used the CSS property -moz-border-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1852,
            "use.counter.css.page",
            "css_moz_border_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_start_color
    ///
    /// Whether a page used the CSS property -moz-border-start-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1853,
            "use.counter.css.page",
            "css_moz_border_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_start_style
    ///
    /// Whether a page used the CSS property -moz-border-start-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1854,
            "use.counter.css.page",
            "css_moz_border_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_start_width
    ///
    /// Whether a page used the CSS property -moz-border-start-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1855,
            "use.counter.css.page",
            "css_moz_border_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_align
    ///
    /// Whether a page used the CSS property -moz-box-align. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1856,
            "use.counter.css.page",
            "css_moz_box_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_collapse
    ///
    /// Whether a page used the CSS property -moz-box-collapse. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1857,
            "use.counter.css.page",
            "css_moz_box_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_direction
    ///
    /// Whether a page used the CSS property -moz-box-direction. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1858,
            "use.counter.css.page",
            "css_moz_box_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_flex
    ///
    /// Whether a page used the CSS property -moz-box-flex. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1859,
            "use.counter.css.page",
            "css_moz_box_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_ordinal_group
    ///
    /// Whether a page used the CSS property -moz-box-ordinal-group. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_ordinal_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1860,
            "use.counter.css.page",
            "css_moz_box_ordinal_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_orient
    ///
    /// Whether a page used the CSS property -moz-box-orient. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_orient: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1861,
            "use.counter.css.page",
            "css_moz_box_orient",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_pack
    ///
    /// Whether a page used the CSS property -moz-box-pack. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_pack: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1862,
            "use.counter.css.page",
            "css_moz_box_pack",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_sizing
    ///
    /// Whether a page used the CSS property -moz-box-sizing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1863,
            "use.counter.css.page",
            "css_moz_box_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_context_properties
    ///
    /// Whether a page used the CSS property -moz-context-properties. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_context_properties: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1864,
            "use.counter.css.page",
            "css_moz_context_properties",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_control_character_visibility
    ///
    /// Whether a page used the CSS property -moz-control-character-visibility. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_control_character_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1865,
            "use.counter.css.page",
            "css_moz_control_character_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_default_appearance
    ///
    /// Whether a page used the CSS property -moz-default-appearance. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_default_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1866,
            "use.counter.css.page",
            "css_moz_default_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_float_edge
    ///
    /// Whether a page used the CSS property -moz-float-edge. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_float_edge: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1867,
            "use.counter.css.page",
            "css_moz_float_edge",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_font_feature_settings
    ///
    /// Whether a page used the CSS property -moz-font-feature-settings. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_font_feature_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1868,
            "use.counter.css.page",
            "css_moz_font_feature_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_font_language_override
    ///
    /// Whether a page used the CSS property -moz-font-language-override. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_font_language_override: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1869,
            "use.counter.css.page",
            "css_moz_font_language_override",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_force_broken_image_icon
    ///
    /// Whether a page used the CSS property -moz-force-broken-image-icon. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_force_broken_image_icon: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1870,
            "use.counter.css.page",
            "css_moz_force_broken_image_icon",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_hyphens
    ///
    /// Whether a page used the CSS property -moz-hyphens. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_hyphens: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1871,
            "use.counter.css.page",
            "css_moz_hyphens",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_inert
    ///
    /// Whether a page used the CSS property -moz-inert. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_inert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1872,
            "use.counter.css.page",
            "css_moz_inert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_margin_end
    ///
    /// Whether a page used the CSS property -moz-margin-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_margin_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1873,
            "use.counter.css.page",
            "css_moz_margin_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_margin_start
    ///
    /// Whether a page used the CSS property -moz-margin-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_margin_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1874,
            "use.counter.css.page",
            "css_moz_margin_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_math_variant
    ///
    /// Whether a page used the CSS property -moz-math-variant. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_math_variant: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1875,
            "use.counter.css.page",
            "css_moz_math_variant",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_min_font_size_ratio
    ///
    /// Whether a page used the CSS property -moz-min-font-size-ratio. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_min_font_size_ratio: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1876,
            "use.counter.css.page",
            "css_moz_min_font_size_ratio",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_orient
    ///
    /// Whether a page used the CSS property -moz-orient. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_orient: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1877,
            "use.counter.css.page",
            "css_moz_orient",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_osx_font_smoothing
    ///
    /// Whether a page used the CSS property -moz-osx-font-smoothing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_osx_font_smoothing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1878,
            "use.counter.css.page",
            "css_moz_osx_font_smoothing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_padding_end
    ///
    /// Whether a page used the CSS property -moz-padding-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_padding_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1879,
            "use.counter.css.page",
            "css_moz_padding_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_padding_start
    ///
    /// Whether a page used the CSS property -moz-padding-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_padding_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1880,
            "use.counter.css.page",
            "css_moz_padding_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_perspective
    ///
    /// Whether a page used the CSS property -moz-perspective. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_perspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1881,
            "use.counter.css.page",
            "css_moz_perspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_perspective_origin
    ///
    /// Whether a page used the CSS property -moz-perspective-origin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_perspective_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1882,
            "use.counter.css.page",
            "css_moz_perspective_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_subtree_hidden_only_visually
    ///
    /// Whether a page used the CSS property -moz-subtree-hidden-only-visually. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_subtree_hidden_only_visually: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1883,
            "use.counter.css.page",
            "css_moz_subtree_hidden_only_visually",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_tab_size
    ///
    /// Whether a page used the CSS property -moz-tab-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_tab_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1884,
            "use.counter.css.page",
            "css_moz_tab_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_text_size_adjust
    ///
    /// Whether a page used the CSS property -moz-text-size-adjust. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_text_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1885,
            "use.counter.css.page",
            "css_moz_text_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_theme
    ///
    /// Whether a page used the CSS property -moz-theme. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_theme: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1886,
            "use.counter.css.page",
            "css_moz_theme",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_top_layer
    ///
    /// Whether a page used the CSS property -moz-top-layer. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_top_layer: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1887,
            "use.counter.css.page",
            "css_moz_top_layer",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transform
    ///
    /// Whether a page used the CSS property -moz-transform. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1888,
            "use.counter.css.page",
            "css_moz_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transform_origin
    ///
    /// Whether a page used the CSS property -moz-transform-origin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1889,
            "use.counter.css.page",
            "css_moz_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transform_style
    ///
    /// Whether a page used the CSS property -moz-transform-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transform_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1890,
            "use.counter.css.page",
            "css_moz_transform_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transition
    ///
    /// Whether a page used the CSS property -moz-transition. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1891,
            "use.counter.css.page",
            "css_moz_transition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transition_delay
    ///
    /// Whether a page used the CSS property -moz-transition-delay. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1892,
            "use.counter.css.page",
            "css_moz_transition_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transition_duration
    ///
    /// Whether a page used the CSS property -moz-transition-duration. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1893,
            "use.counter.css.page",
            "css_moz_transition_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transition_property
    ///
    /// Whether a page used the CSS property -moz-transition-property. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition_property: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1894,
            "use.counter.css.page",
            "css_moz_transition_property",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transition_timing_function
    ///
    /// Whether a page used the CSS property -moz-transition-timing-function. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_transition_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1895,
            "use.counter.css.page",
            "css_moz_transition_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_user_focus
    ///
    /// Whether a page used the CSS property -moz-user-focus. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_focus: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1896,
            "use.counter.css.page",
            "css_moz_user_focus",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_user_input
    ///
    /// Whether a page used the CSS property -moz-user-input. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_input: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1897,
            "use.counter.css.page",
            "css_moz_user_input",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_user_modify
    ///
    /// Whether a page used the CSS property -moz-user-modify. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_modify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1898,
            "use.counter.css.page",
            "css_moz_user_modify",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_user_select
    ///
    /// Whether a page used the CSS property -moz-user-select. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_select: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1899,
            "use.counter.css.page",
            "css_moz_user_select",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_window_dragging
    ///
    /// Whether a page used the CSS property -moz-window-dragging. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_dragging: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1900,
            "use.counter.css.page",
            "css_moz_window_dragging",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_window_input_region_margin
    ///
    /// Whether a page used the CSS property -moz-window-input-region-margin. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_window_input_region_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1901,
            "use.counter.css.page",
            "css_moz_window_input_region_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_window_opacity
    ///
    /// Whether a page used the CSS property -moz-window-opacity. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1902,
            "use.counter.css.page",
            "css_moz_window_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_window_shadow
    ///
    /// Whether a page used the CSS property -moz-window-shadow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1903,
            "use.counter.css.page",
            "css_moz_window_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_window_transform
    ///
    /// Whether a page used the CSS property -moz-window-transform. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1904,
            "use.counter.css.page",
            "css_moz_window_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_window_transform_origin
    ///
    /// Whether a page used the CSS property -moz-window-transform-origin. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_window_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1905,
            "use.counter.css.page",
            "css_moz_window_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_object_fit
    ///
    /// Whether a page used the CSS property object-fit. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_object_fit: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1906,
            "use.counter.css.page",
            "css_object_fit",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_object_position
    ///
    /// Whether a page used the CSS property object-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_object_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1907,
            "use.counter.css.page",
            "css_object_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_offset
    ///
    /// Whether a page used the CSS property offset. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1908,
            "use.counter.css.page",
            "css_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_offset_anchor
    ///
    /// Whether a page used the CSS property offset-anchor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_offset_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1909,
            "use.counter.css.page",
            "css_offset_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_offset_distance
    ///
    /// Whether a page used the CSS property offset-distance. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_offset_distance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1910,
            "use.counter.css.page",
            "css_offset_distance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_offset_path
    ///
    /// Whether a page used the CSS property offset-path. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_offset_path: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1911,
            "use.counter.css.page",
            "css_offset_path",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_offset_position
    ///
    /// Whether a page used the CSS property offset-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_offset_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1912,
            "use.counter.css.page",
            "css_offset_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_offset_rotate
    ///
    /// Whether a page used the CSS property offset-rotate. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_offset_rotate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1913,
            "use.counter.css.page",
            "css_offset_rotate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_opacity
    ///
    /// Whether a page used the CSS property opacity. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1914,
            "use.counter.css.page",
            "css_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_order
    ///
    /// Whether a page used the CSS property order. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1915,
            "use.counter.css.page",
            "css_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_outline
    ///
    /// Whether a page used the CSS property outline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_outline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1916,
            "use.counter.css.page",
            "css_outline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_outline_color
    ///
    /// Whether a page used the CSS property outline-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_outline_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1917,
            "use.counter.css.page",
            "css_outline_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_outline_offset
    ///
    /// Whether a page used the CSS property outline-offset. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_outline_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1918,
            "use.counter.css.page",
            "css_outline_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_outline_style
    ///
    /// Whether a page used the CSS property outline-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_outline_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1919,
            "use.counter.css.page",
            "css_outline_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_outline_width
    ///
    /// Whether a page used the CSS property outline-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_outline_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1920,
            "use.counter.css.page",
            "css_outline_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow
    ///
    /// Whether a page used the CSS property overflow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1921,
            "use.counter.css.page",
            "css_overflow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_anchor
    ///
    /// Whether a page used the CSS property overflow-anchor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1922,
            "use.counter.css.page",
            "css_overflow_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_block
    ///
    /// Whether a page used the CSS property overflow-block. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1923,
            "use.counter.css.page",
            "css_overflow_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_clip_box
    ///
    /// Whether a page used the CSS property overflow-clip-box. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_box: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1924,
            "use.counter.css.page",
            "css_overflow_clip_box",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_clip_box_block
    ///
    /// Whether a page used the CSS property overflow-clip-box-block. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_box_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1925,
            "use.counter.css.page",
            "css_overflow_clip_box_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_clip_box_inline
    ///
    /// Whether a page used the CSS property overflow-clip-box-inline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_box_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1926,
            "use.counter.css.page",
            "css_overflow_clip_box_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_clip_margin
    ///
    /// Whether a page used the CSS property overflow-clip-margin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1927,
            "use.counter.css.page",
            "css_overflow_clip_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_inline
    ///
    /// Whether a page used the CSS property overflow-inline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1928,
            "use.counter.css.page",
            "css_overflow_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_wrap
    ///
    /// Whether a page used the CSS property overflow-wrap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1929,
            "use.counter.css.page",
            "css_overflow_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_x
    ///
    /// Whether a page used the CSS property overflow-x. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1930,
            "use.counter.css.page",
            "css_overflow_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_y
    ///
    /// Whether a page used the CSS property overflow-y. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1931,
            "use.counter.css.page",
            "css_overflow_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overscroll_behavior
    ///
    /// Whether a page used the CSS property overscroll-behavior. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1932,
            "use.counter.css.page",
            "css_overscroll_behavior",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overscroll_behavior_block
    ///
    /// Whether a page used the CSS property overscroll-behavior-block. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1933,
            "use.counter.css.page",
            "css_overscroll_behavior_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overscroll_behavior_inline
    ///
    /// Whether a page used the CSS property overscroll-behavior-inline. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_overscroll_behavior_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1934,
            "use.counter.css.page",
            "css_overscroll_behavior_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overscroll_behavior_x
    ///
    /// Whether a page used the CSS property overscroll-behavior-x. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1935,
            "use.counter.css.page",
            "css_overscroll_behavior_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overscroll_behavior_y
    ///
    /// Whether a page used the CSS property overscroll-behavior-y. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1936,
            "use.counter.css.page",
            "css_overscroll_behavior_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding
    ///
    /// Whether a page used the CSS property padding. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1937,
            "use.counter.css.page",
            "css_padding",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_block
    ///
    /// Whether a page used the CSS property padding-block. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1938,
            "use.counter.css.page",
            "css_padding_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_block_end
    ///
    /// Whether a page used the CSS property padding-block-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1939,
            "use.counter.css.page",
            "css_padding_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_block_start
    ///
    /// Whether a page used the CSS property padding-block-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1940,
            "use.counter.css.page",
            "css_padding_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_bottom
    ///
    /// Whether a page used the CSS property padding-bottom. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1941,
            "use.counter.css.page",
            "css_padding_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_inline
    ///
    /// Whether a page used the CSS property padding-inline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1942,
            "use.counter.css.page",
            "css_padding_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_inline_end
    ///
    /// Whether a page used the CSS property padding-inline-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1943,
            "use.counter.css.page",
            "css_padding_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_inline_start
    ///
    /// Whether a page used the CSS property padding-inline-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1944,
            "use.counter.css.page",
            "css_padding_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_left
    ///
    /// Whether a page used the CSS property padding-left. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1945,
            "use.counter.css.page",
            "css_padding_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_right
    ///
    /// Whether a page used the CSS property padding-right. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1946,
            "use.counter.css.page",
            "css_padding_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_top
    ///
    /// Whether a page used the CSS property padding-top. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1947,
            "use.counter.css.page",
            "css_padding_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_page
    ///
    /// Whether a page used the CSS property page. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_page: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1948,
            "use.counter.css.page",
            "css_page",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_page_break_after
    ///
    /// Whether a page used the CSS property page-break-after. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_page_break_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1949,
            "use.counter.css.page",
            "css_page_break_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_page_break_before
    ///
    /// Whether a page used the CSS property page-break-before. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_page_break_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1950,
            "use.counter.css.page",
            "css_page_break_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_page_break_inside
    ///
    /// Whether a page used the CSS property page-break-inside. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_page_break_inside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1951,
            "use.counter.css.page",
            "css_page_break_inside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_page_orientation
    ///
    /// Whether a page used the CSS property page-orientation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_page_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1952,
            "use.counter.css.page",
            "css_page_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_paint_order
    ///
    /// Whether a page used the CSS property paint-order. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_paint_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1953,
            "use.counter.css.page",
            "css_paint_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_perspective
    ///
    /// Whether a page used the CSS property perspective. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_perspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1954,
            "use.counter.css.page",
            "css_perspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_perspective_origin
    ///
    /// Whether a page used the CSS property perspective-origin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_perspective_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1955,
            "use.counter.css.page",
            "css_perspective_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_place_content
    ///
    /// Whether a page used the CSS property place-content. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_place_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1956,
            "use.counter.css.page",
            "css_place_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_place_items
    ///
    /// Whether a page used the CSS property place-items. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_place_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1957,
            "use.counter.css.page",
            "css_place_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_place_self
    ///
    /// Whether a page used the CSS property place-self. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_place_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1958,
            "use.counter.css.page",
            "css_place_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_pointer_events
    ///
    /// Whether a page used the CSS property pointer-events. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_pointer_events: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1959,
            "use.counter.css.page",
            "css_pointer_events",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_position
    ///
    /// Whether a page used the CSS property position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1960,
            "use.counter.css.page",
            "css_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_position_anchor
    ///
    /// Whether a page used the CSS property position-anchor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_position_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1961,
            "use.counter.css.page",
            "css_position_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_position_area
    ///
    /// Whether a page used the CSS property position-area. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_position_area: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1962,
            "use.counter.css.page",
            "css_position_area",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_position_try
    ///
    /// Whether a page used the CSS property position-try. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_position_try: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1963,
            "use.counter.css.page",
            "css_position_try",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_position_try_fallbacks
    ///
    /// Whether a page used the CSS property position-try-fallbacks. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_position_try_fallbacks: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1964,
            "use.counter.css.page",
            "css_position_try_fallbacks",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_position_try_order
    ///
    /// Whether a page used the CSS property position-try-order. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_position_try_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1965,
            "use.counter.css.page",
            "css_position_try_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_position_visibility
    ///
    /// Whether a page used the CSS property position-visibility. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_position_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1966,
            "use.counter.css.page",
            "css_position_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_print_color_adjust
    ///
    /// Whether a page used the CSS property print-color-adjust. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_print_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1967,
            "use.counter.css.page",
            "css_print_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_quotes
    ///
    /// Whether a page used the CSS property quotes. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_quotes: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1968,
            "use.counter.css.page",
            "css_quotes",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_r
    ///
    /// Whether a page used the CSS property r. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_r: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1969,
            "use.counter.css.page",
            "css_r",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_resize
    ///
    /// Whether a page used the CSS property resize. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_resize: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1970,
            "use.counter.css.page",
            "css_resize",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_right
    ///
    /// Whether a page used the CSS property right. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1971,
            "use.counter.css.page",
            "css_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_rotate
    ///
    /// Whether a page used the CSS property rotate. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_rotate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1972,
            "use.counter.css.page",
            "css_rotate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_row_gap
    ///
    /// Whether a page used the CSS property row-gap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_row_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1973,
            "use.counter.css.page",
            "css_row_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_ruby_align
    ///
    /// Whether a page used the CSS property ruby-align. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_ruby_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1974,
            "use.counter.css.page",
            "css_ruby_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_ruby_position
    ///
    /// Whether a page used the CSS property ruby-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_ruby_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1975,
            "use.counter.css.page",
            "css_ruby_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_rx
    ///
    /// Whether a page used the CSS property rx. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_rx: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1976,
            "use.counter.css.page",
            "css_rx",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_ry
    ///
    /// Whether a page used the CSS property ry. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_ry: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1977,
            "use.counter.css.page",
            "css_ry",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scale
    ///
    /// Whether a page used the CSS property scale. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1978,
            "use.counter.css.page",
            "css_scale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_behavior
    ///
    /// Whether a page used the CSS property scroll-behavior. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_behavior: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1979,
            "use.counter.css.page",
            "css_scroll_behavior",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin
    ///
    /// Whether a page used the CSS property scroll-margin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1980,
            "use.counter.css.page",
            "css_scroll_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_block
    ///
    /// Whether a page used the CSS property scroll-margin-block. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1981,
            "use.counter.css.page",
            "css_scroll_margin_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_block_end
    ///
    /// Whether a page used the CSS property scroll-margin-block-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1982,
            "use.counter.css.page",
            "css_scroll_margin_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_block_start
    ///
    /// Whether a page used the CSS property scroll-margin-block-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1983,
            "use.counter.css.page",
            "css_scroll_margin_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_bottom
    ///
    /// Whether a page used the CSS property scroll-margin-bottom. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1984,
            "use.counter.css.page",
            "css_scroll_margin_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_inline
    ///
    /// Whether a page used the CSS property scroll-margin-inline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1985,
            "use.counter.css.page",
            "css_scroll_margin_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_inline_end
    ///
    /// Whether a page used the CSS property scroll-margin-inline-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1986,
            "use.counter.css.page",
            "css_scroll_margin_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_inline_start
    ///
    /// Whether a page used the CSS property scroll-margin-inline-start. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_scroll_margin_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1987,
            "use.counter.css.page",
            "css_scroll_margin_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_left
    ///
    /// Whether a page used the CSS property scroll-margin-left. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1988,
            "use.counter.css.page",
            "css_scroll_margin_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_right
    ///
    /// Whether a page used the CSS property scroll-margin-right. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1989,
            "use.counter.css.page",
            "css_scroll_margin_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_top
    ///
    /// Whether a page used the CSS property scroll-margin-top. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1990,
            "use.counter.css.page",
            "css_scroll_margin_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding
    ///
    /// Whether a page used the CSS property scroll-padding. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1991,
            "use.counter.css.page",
            "css_scroll_padding",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_block
    ///
    /// Whether a page used the CSS property scroll-padding-block. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1992,
            "use.counter.css.page",
            "css_scroll_padding_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_block_end
    ///
    /// Whether a page used the CSS property scroll-padding-block-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1993,
            "use.counter.css.page",
            "css_scroll_padding_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_block_start
    ///
    /// Whether a page used the CSS property scroll-padding-block-start. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_scroll_padding_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1994,
            "use.counter.css.page",
            "css_scroll_padding_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_bottom
    ///
    /// Whether a page used the CSS property scroll-padding-bottom. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1995,
            "use.counter.css.page",
            "css_scroll_padding_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_inline
    ///
    /// Whether a page used the CSS property scroll-padding-inline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1996,
            "use.counter.css.page",
            "css_scroll_padding_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_inline_end
    ///
    /// Whether a page used the CSS property scroll-padding-inline-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1997,
            "use.counter.css.page",
            "css_scroll_padding_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_inline_start
    ///
    /// Whether a page used the CSS property scroll-padding-inline-start. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_scroll_padding_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1998,
            "use.counter.css.page",
            "css_scroll_padding_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_left
    ///
    /// Whether a page used the CSS property scroll-padding-left. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1999,
            "use.counter.css.page",
            "css_scroll_padding_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_right
    ///
    /// Whether a page used the CSS property scroll-padding-right. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2000,
            "use.counter.css.page",
            "css_scroll_padding_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_top
    ///
    /// Whether a page used the CSS property scroll-padding-top. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2001,
            "use.counter.css.page",
            "css_scroll_padding_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_snap_align
    ///
    /// Whether a page used the CSS property scroll-snap-align. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_snap_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2002,
            "use.counter.css.page",
            "css_scroll_snap_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_snap_stop
    ///
    /// Whether a page used the CSS property scroll-snap-stop. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_snap_stop: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2003,
            "use.counter.css.page",
            "css_scroll_snap_stop",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_snap_type
    ///
    /// Whether a page used the CSS property scroll-snap-type. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_snap_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2004,
            "use.counter.css.page",
            "css_scroll_snap_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_timeline
    ///
    /// Whether a page used the CSS property scroll-timeline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_timeline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2005,
            "use.counter.css.page",
            "css_scroll_timeline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_timeline_axis
    ///
    /// Whether a page used the CSS property scroll-timeline-axis. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_timeline_axis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2006,
            "use.counter.css.page",
            "css_scroll_timeline_axis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_timeline_name
    ///
    /// Whether a page used the CSS property scroll-timeline-name. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_timeline_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2007,
            "use.counter.css.page",
            "css_scroll_timeline_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scrollbar_color
    ///
    /// Whether a page used the CSS property scrollbar-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scrollbar_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2008,
            "use.counter.css.page",
            "css_scrollbar_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scrollbar_gutter
    ///
    /// Whether a page used the CSS property scrollbar-gutter. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scrollbar_gutter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2009,
            "use.counter.css.page",
            "css_scrollbar_gutter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scrollbar_width
    ///
    /// Whether a page used the CSS property scrollbar-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scrollbar_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2010,
            "use.counter.css.page",
            "css_scrollbar_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_shape_image_threshold
    ///
    /// Whether a page used the CSS property shape-image-threshold. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_shape_image_threshold: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2011,
            "use.counter.css.page",
            "css_shape_image_threshold",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_shape_margin
    ///
    /// Whether a page used the CSS property shape-margin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_shape_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2012,
            "use.counter.css.page",
            "css_shape_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_shape_outside
    ///
    /// Whether a page used the CSS property shape-outside. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_shape_outside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2013,
            "use.counter.css.page",
            "css_shape_outside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_shape_rendering
    ///
    /// Whether a page used the CSS property shape-rendering. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_shape_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2014,
            "use.counter.css.page",
            "css_shape_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_size
    ///
    /// Whether a page used the CSS property size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2015,
            "use.counter.css.page",
            "css_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stop_color
    ///
    /// Whether a page used the CSS property stop-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stop_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2016,
            "use.counter.css.page",
            "css_stop_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stop_opacity
    ///
    /// Whether a page used the CSS property stop-opacity. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stop_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2017,
            "use.counter.css.page",
            "css_stop_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke
    ///
    /// Whether a page used the CSS property stroke. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2018,
            "use.counter.css.page",
            "css_stroke",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke_dasharray
    ///
    /// Whether a page used the CSS property stroke-dasharray. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke_dasharray: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2019,
            "use.counter.css.page",
            "css_stroke_dasharray",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke_dashoffset
    ///
    /// Whether a page used the CSS property stroke-dashoffset. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke_dashoffset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2020,
            "use.counter.css.page",
            "css_stroke_dashoffset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke_linecap
    ///
    /// Whether a page used the CSS property stroke-linecap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke_linecap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2021,
            "use.counter.css.page",
            "css_stroke_linecap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke_linejoin
    ///
    /// Whether a page used the CSS property stroke-linejoin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke_linejoin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2022,
            "use.counter.css.page",
            "css_stroke_linejoin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke_miterlimit
    ///
    /// Whether a page used the CSS property stroke-miterlimit. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke_miterlimit: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2023,
            "use.counter.css.page",
            "css_stroke_miterlimit",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke_opacity
    ///
    /// Whether a page used the CSS property stroke-opacity. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2024,
            "use.counter.css.page",
            "css_stroke_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke_width
    ///
    /// Whether a page used the CSS property stroke-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2025,
            "use.counter.css.page",
            "css_stroke_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_tab_size
    ///
    /// Whether a page used the CSS property tab-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_tab_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2026,
            "use.counter.css.page",
            "css_tab_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_table_layout
    ///
    /// Whether a page used the CSS property table-layout. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_table_layout: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2027,
            "use.counter.css.page",
            "css_table_layout",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_align
    ///
    /// Whether a page used the CSS property text-align. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2028,
            "use.counter.css.page",
            "css_text_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_align_last
    ///
    /// Whether a page used the CSS property text-align-last. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_align_last: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2029,
            "use.counter.css.page",
            "css_text_align_last",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_anchor
    ///
    /// Whether a page used the CSS property text-anchor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2030,
            "use.counter.css.page",
            "css_text_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_combine_upright
    ///
    /// Whether a page used the CSS property text-combine-upright. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_combine_upright: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2031,
            "use.counter.css.page",
            "css_text_combine_upright",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_decoration
    ///
    /// Whether a page used the CSS property text-decoration. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2032,
            "use.counter.css.page",
            "css_text_decoration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_decoration_color
    ///
    /// Whether a page used the CSS property text-decoration-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2033,
            "use.counter.css.page",
            "css_text_decoration_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_decoration_line
    ///
    /// Whether a page used the CSS property text-decoration-line. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_line: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2034,
            "use.counter.css.page",
            "css_text_decoration_line",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_decoration_skip_ink
    ///
    /// Whether a page used the CSS property text-decoration-skip-ink. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_skip_ink: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2035,
            "use.counter.css.page",
            "css_text_decoration_skip_ink",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_decoration_style
    ///
    /// Whether a page used the CSS property text-decoration-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2036,
            "use.counter.css.page",
            "css_text_decoration_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_decoration_thickness
    ///
    /// Whether a page used the CSS property text-decoration-thickness. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_thickness: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2037,
            "use.counter.css.page",
            "css_text_decoration_thickness",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_emphasis
    ///
    /// Whether a page used the CSS property text-emphasis. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2038,
            "use.counter.css.page",
            "css_text_emphasis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_emphasis_color
    ///
    /// Whether a page used the CSS property text-emphasis-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2039,
            "use.counter.css.page",
            "css_text_emphasis_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_emphasis_position
    ///
    /// Whether a page used the CSS property text-emphasis-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2040,
            "use.counter.css.page",
            "css_text_emphasis_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_emphasis_style
    ///
    /// Whether a page used the CSS property text-emphasis-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2041,
            "use.counter.css.page",
            "css_text_emphasis_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_indent
    ///
    /// Whether a page used the CSS property text-indent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_indent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2042,
            "use.counter.css.page",
            "css_text_indent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_justify
    ///
    /// Whether a page used the CSS property text-justify. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_justify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2043,
            "use.counter.css.page",
            "css_text_justify",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_orientation
    ///
    /// Whether a page used the CSS property text-orientation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2044,
            "use.counter.css.page",
            "css_text_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_overflow
    ///
    /// Whether a page used the CSS property text-overflow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_overflow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2045,
            "use.counter.css.page",
            "css_text_overflow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_rendering
    ///
    /// Whether a page used the CSS property text-rendering. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2046,
            "use.counter.css.page",
            "css_text_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_shadow
    ///
    /// Whether a page used the CSS property text-shadow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2047,
            "use.counter.css.page",
            "css_text_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_transform
    ///
    /// Whether a page used the CSS property text-transform. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2048,
            "use.counter.css.page",
            "css_text_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_underline_offset
    ///
    /// Whether a page used the CSS property text-underline-offset. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_underline_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2049,
            "use.counter.css.page",
            "css_text_underline_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_underline_position
    ///
    /// Whether a page used the CSS property text-underline-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_underline_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2050,
            "use.counter.css.page",
            "css_text_underline_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_wrap
    ///
    /// Whether a page used the CSS property text-wrap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2051,
            "use.counter.css.page",
            "css_text_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_wrap_mode
    ///
    /// Whether a page used the CSS property text-wrap-mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_wrap_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2052,
            "use.counter.css.page",
            "css_text_wrap_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_wrap_style
    ///
    /// Whether a page used the CSS property text-wrap-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_wrap_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2053,
            "use.counter.css.page",
            "css_text_wrap_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_top
    ///
    /// Whether a page used the CSS property top. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2054,
            "use.counter.css.page",
            "css_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_touch_action
    ///
    /// Whether a page used the CSS property touch-action. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_touch_action: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2055,
            "use.counter.css.page",
            "css_touch_action",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transform
    ///
    /// Whether a page used the CSS property transform. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2056,
            "use.counter.css.page",
            "css_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transform_box
    ///
    /// Whether a page used the CSS property transform-box. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transform_box: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2057,
            "use.counter.css.page",
            "css_transform_box",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transform_origin
    ///
    /// Whether a page used the CSS property transform-origin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2058,
            "use.counter.css.page",
            "css_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transform_style
    ///
    /// Whether a page used the CSS property transform-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transform_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2059,
            "use.counter.css.page",
            "css_transform_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transition
    ///
    /// Whether a page used the CSS property transition. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2060,
            "use.counter.css.page",
            "css_transition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transition_behavior
    ///
    /// Whether a page used the CSS property transition-behavior. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transition_behavior: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2061,
            "use.counter.css.page",
            "css_transition_behavior",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transition_delay
    ///
    /// Whether a page used the CSS property transition-delay. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transition_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2062,
            "use.counter.css.page",
            "css_transition_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transition_duration
    ///
    /// Whether a page used the CSS property transition-duration. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transition_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2063,
            "use.counter.css.page",
            "css_transition_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transition_property
    ///
    /// Whether a page used the CSS property transition-property. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transition_property: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2064,
            "use.counter.css.page",
            "css_transition_property",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transition_timing_function
    ///
    /// Whether a page used the CSS property transition-timing-function. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_transition_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2065,
            "use.counter.css.page",
            "css_transition_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_translate
    ///
    /// Whether a page used the CSS property translate. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_translate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2066,
            "use.counter.css.page",
            "css_translate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_unicode_bidi
    ///
    /// Whether a page used the CSS property unicode-bidi. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_unicode_bidi: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2067,
            "use.counter.css.page",
            "css_unicode_bidi",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_user_select
    ///
    /// Whether a page used the CSS property user-select. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_user_select: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2068,
            "use.counter.css.page",
            "css_user_select",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_vector_effect
    ///
    /// Whether a page used the CSS property vector-effect. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_vector_effect: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2069,
            "use.counter.css.page",
            "css_vector_effect",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_vertical_align
    ///
    /// Whether a page used the CSS property vertical-align. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_vertical_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2070,
            "use.counter.css.page",
            "css_vertical_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_view_timeline
    ///
    /// Whether a page used the CSS property view-timeline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2071,
            "use.counter.css.page",
            "css_view_timeline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_view_timeline_axis
    ///
    /// Whether a page used the CSS property view-timeline-axis. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline_axis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2072,
            "use.counter.css.page",
            "css_view_timeline_axis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_view_timeline_inset
    ///
    /// Whether a page used the CSS property view-timeline-inset. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline_inset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2073,
            "use.counter.css.page",
            "css_view_timeline_inset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_view_timeline_name
    ///
    /// Whether a page used the CSS property view-timeline-name. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2074,
            "use.counter.css.page",
            "css_view_timeline_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_view_transition_name
    ///
    /// Whether a page used the CSS property view-transition-name. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_view_transition_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2075,
            "use.counter.css.page",
            "css_view_transition_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_visibility
    ///
    /// Whether a page used the CSS property visibility. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2076,
            "use.counter.css.page",
            "css_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_align_content
    ///
    /// Whether a page used the CSS property -webkit-align-content. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_align_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2077,
            "use.counter.css.page",
            "css_webkit_align_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_align_items
    ///
    /// Whether a page used the CSS property -webkit-align-items. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_align_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2078,
            "use.counter.css.page",
            "css_webkit_align_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_align_self
    ///
    /// Whether a page used the CSS property -webkit-align-self. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_align_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2079,
            "use.counter.css.page",
            "css_webkit_align_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation
    ///
    /// Whether a page used the CSS property -webkit-animation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2080,
            "use.counter.css.page",
            "css_webkit_animation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_delay
    ///
    /// Whether a page used the CSS property -webkit-animation-delay. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2081,
            "use.counter.css.page",
            "css_webkit_animation_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_direction
    ///
    /// Whether a page used the CSS property -webkit-animation-direction. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_animation_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2082,
            "use.counter.css.page",
            "css_webkit_animation_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_duration
    ///
    /// Whether a page used the CSS property -webkit-animation-duration. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_animation_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2083,
            "use.counter.css.page",
            "css_webkit_animation_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_fill_mode
    ///
    /// Whether a page used the CSS property -webkit-animation-fill-mode. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_animation_fill_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2084,
            "use.counter.css.page",
            "css_webkit_animation_fill_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_iteration_count
    ///
    /// Whether a page used the CSS property -webkit-animation-iteration-count. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_animation_iteration_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2085,
            "use.counter.css.page",
            "css_webkit_animation_iteration_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_name
    ///
    /// Whether a page used the CSS property -webkit-animation-name. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2086,
            "use.counter.css.page",
            "css_webkit_animation_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_play_state
    ///
    /// Whether a page used the CSS property -webkit-animation-play-state. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_animation_play_state: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2087,
            "use.counter.css.page",
            "css_webkit_animation_play_state",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_timing_function
    ///
    /// Whether a page used the CSS property -webkit-animation-timing-function. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_animation_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2088,
            "use.counter.css.page",
            "css_webkit_animation_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_appearance
    ///
    /// Whether a page used the CSS property -webkit-appearance. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2089,
            "use.counter.css.page",
            "css_webkit_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_backface_visibility
    ///
    /// Whether a page used the CSS property -webkit-backface-visibility. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_backface_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2090,
            "use.counter.css.page",
            "css_webkit_backface_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_background_clip
    ///
    /// Whether a page used the CSS property -webkit-background-clip. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_background_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2091,
            "use.counter.css.page",
            "css_webkit_background_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_background_origin
    ///
    /// Whether a page used the CSS property -webkit-background-origin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_background_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2092,
            "use.counter.css.page",
            "css_webkit_background_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_background_size
    ///
    /// Whether a page used the CSS property -webkit-background-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_background_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2093,
            "use.counter.css.page",
            "css_webkit_background_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_border_bottom_left_radius
    ///
    /// Whether a page used the CSS property -webkit-border-bottom-left-radius. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_border_bottom_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2094,
            "use.counter.css.page",
            "css_webkit_border_bottom_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_border_bottom_right_radius
    ///
    /// Whether a page used the CSS property -webkit-border-bottom-right-radius.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static css_webkit_border_bottom_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2095,
            "use.counter.css.page",
            "css_webkit_border_bottom_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_border_image
    ///
    /// Whether a page used the CSS property -webkit-border-image. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_border_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2096,
            "use.counter.css.page",
            "css_webkit_border_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_border_radius
    ///
    /// Whether a page used the CSS property -webkit-border-radius. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_border_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2097,
            "use.counter.css.page",
            "css_webkit_border_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_border_top_left_radius
    ///
    /// Whether a page used the CSS property -webkit-border-top-left-radius. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_border_top_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2098,
            "use.counter.css.page",
            "css_webkit_border_top_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_border_top_right_radius
    ///
    /// Whether a page used the CSS property -webkit-border-top-right-radius. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_border_top_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2099,
            "use.counter.css.page",
            "css_webkit_border_top_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_align
    ///
    /// Whether a page used the CSS property -webkit-box-align. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2100,
            "use.counter.css.page",
            "css_webkit_box_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_direction
    ///
    /// Whether a page used the CSS property -webkit-box-direction. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2101,
            "use.counter.css.page",
            "css_webkit_box_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_flex
    ///
    /// Whether a page used the CSS property -webkit-box-flex. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2102,
            "use.counter.css.page",
            "css_webkit_box_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_ordinal_group
    ///
    /// Whether a page used the CSS property -webkit-box-ordinal-group. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_ordinal_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2103,
            "use.counter.css.page",
            "css_webkit_box_ordinal_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_orient
    ///
    /// Whether a page used the CSS property -webkit-box-orient. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_orient: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2104,
            "use.counter.css.page",
            "css_webkit_box_orient",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_pack
    ///
    /// Whether a page used the CSS property -webkit-box-pack. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_pack: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2105,
            "use.counter.css.page",
            "css_webkit_box_pack",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_shadow
    ///
    /// Whether a page used the CSS property -webkit-box-shadow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2106,
            "use.counter.css.page",
            "css_webkit_box_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_sizing
    ///
    /// Whether a page used the CSS property -webkit-box-sizing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2107,
            "use.counter.css.page",
            "css_webkit_box_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_clip_path
    ///
    /// Whether a page used the CSS property -webkit-clip-path. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_clip_path: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2108,
            "use.counter.css.page",
            "css_webkit_clip_path",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_filter
    ///
    /// Whether a page used the CSS property -webkit-filter. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_filter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2109,
            "use.counter.css.page",
            "css_webkit_filter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_flex
    ///
    /// Whether a page used the CSS property -webkit-flex. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2110,
            "use.counter.css.page",
            "css_webkit_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_flex_basis
    ///
    /// Whether a page used the CSS property -webkit-flex-basis. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_basis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2111,
            "use.counter.css.page",
            "css_webkit_flex_basis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_flex_direction
    ///
    /// Whether a page used the CSS property -webkit-flex-direction. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2112,
            "use.counter.css.page",
            "css_webkit_flex_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_flex_flow
    ///
    /// Whether a page used the CSS property -webkit-flex-flow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2113,
            "use.counter.css.page",
            "css_webkit_flex_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_flex_grow
    ///
    /// Whether a page used the CSS property -webkit-flex-grow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_grow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2114,
            "use.counter.css.page",
            "css_webkit_flex_grow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_flex_shrink
    ///
    /// Whether a page used the CSS property -webkit-flex-shrink. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_shrink: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2115,
            "use.counter.css.page",
            "css_webkit_flex_shrink",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_flex_wrap
    ///
    /// Whether a page used the CSS property -webkit-flex-wrap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2116,
            "use.counter.css.page",
            "css_webkit_flex_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_font_feature_settings
    ///
    /// Whether a page used the CSS property -webkit-font-feature-settings. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_font_feature_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2117,
            "use.counter.css.page",
            "css_webkit_font_feature_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_font_smoothing
    ///
    /// Whether a page used the CSS property -webkit-font-smoothing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_font_smoothing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2118,
            "use.counter.css.page",
            "css_webkit_font_smoothing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_justify_content
    ///
    /// Whether a page used the CSS property -webkit-justify-content. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_justify_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2119,
            "use.counter.css.page",
            "css_webkit_justify_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_line_clamp
    ///
    /// Whether a page used the CSS property -webkit-line-clamp. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_line_clamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2120,
            "use.counter.css.page",
            "css_webkit_line_clamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask
    ///
    /// Whether a page used the CSS property -webkit-mask. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2121,
            "use.counter.css.page",
            "css_webkit_mask",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_clip
    ///
    /// Whether a page used the CSS property -webkit-mask-clip. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2122,
            "use.counter.css.page",
            "css_webkit_mask_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_composite
    ///
    /// Whether a page used the CSS property -webkit-mask-composite. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_composite: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2123,
            "use.counter.css.page",
            "css_webkit_mask_composite",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_image
    ///
    /// Whether a page used the CSS property -webkit-mask-image. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2124,
            "use.counter.css.page",
            "css_webkit_mask_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_origin
    ///
    /// Whether a page used the CSS property -webkit-mask-origin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2125,
            "use.counter.css.page",
            "css_webkit_mask_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_position
    ///
    /// Whether a page used the CSS property -webkit-mask-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2126,
            "use.counter.css.page",
            "css_webkit_mask_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_position_x
    ///
    /// Whether a page used the CSS property -webkit-mask-position-x. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_position_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2127,
            "use.counter.css.page",
            "css_webkit_mask_position_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_position_y
    ///
    /// Whether a page used the CSS property -webkit-mask-position-y. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_position_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2128,
            "use.counter.css.page",
            "css_webkit_mask_position_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_repeat
    ///
    /// Whether a page used the CSS property -webkit-mask-repeat. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2129,
            "use.counter.css.page",
            "css_webkit_mask_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_size
    ///
    /// Whether a page used the CSS property -webkit-mask-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2130,
            "use.counter.css.page",
            "css_webkit_mask_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_order
    ///
    /// Whether a page used the CSS property -webkit-order. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2131,
            "use.counter.css.page",
            "css_webkit_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_perspective
    ///
    /// Whether a page used the CSS property -webkit-perspective. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_perspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2132,
            "use.counter.css.page",
            "css_webkit_perspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_perspective_origin
    ///
    /// Whether a page used the CSS property -webkit-perspective-origin. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_perspective_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2133,
            "use.counter.css.page",
            "css_webkit_perspective_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_text_fill_color
    ///
    /// Whether a page used the CSS property -webkit-text-fill-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_fill_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2134,
            "use.counter.css.page",
            "css_webkit_text_fill_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_text_security
    ///
    /// Whether a page used the CSS property -webkit-text-security. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_security: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2135,
            "use.counter.css.page",
            "css_webkit_text_security",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_text_size_adjust
    ///
    /// Whether a page used the CSS property -webkit-text-size-adjust. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2136,
            "use.counter.css.page",
            "css_webkit_text_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_text_stroke
    ///
    /// Whether a page used the CSS property -webkit-text-stroke. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_stroke: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2137,
            "use.counter.css.page",
            "css_webkit_text_stroke",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_text_stroke_color
    ///
    /// Whether a page used the CSS property -webkit-text-stroke-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_stroke_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2138,
            "use.counter.css.page",
            "css_webkit_text_stroke_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_text_stroke_width
    ///
    /// Whether a page used the CSS property -webkit-text-stroke-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_stroke_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2139,
            "use.counter.css.page",
            "css_webkit_text_stroke_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transform
    ///
    /// Whether a page used the CSS property -webkit-transform. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2140,
            "use.counter.css.page",
            "css_webkit_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transform_origin
    ///
    /// Whether a page used the CSS property -webkit-transform-origin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2141,
            "use.counter.css.page",
            "css_webkit_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transform_style
    ///
    /// Whether a page used the CSS property -webkit-transform-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transform_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2142,
            "use.counter.css.page",
            "css_webkit_transform_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transition
    ///
    /// Whether a page used the CSS property -webkit-transition. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2143,
            "use.counter.css.page",
            "css_webkit_transition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transition_delay
    ///
    /// Whether a page used the CSS property -webkit-transition-delay. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2144,
            "use.counter.css.page",
            "css_webkit_transition_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transition_duration
    ///
    /// Whether a page used the CSS property -webkit-transition-duration. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_transition_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2145,
            "use.counter.css.page",
            "css_webkit_transition_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transition_property
    ///
    /// Whether a page used the CSS property -webkit-transition-property. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_transition_property: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2146,
            "use.counter.css.page",
            "css_webkit_transition_property",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transition_timing_function
    ///
    /// Whether a page used the CSS property -webkit-transition-timing-function.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static css_webkit_transition_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2147,
            "use.counter.css.page",
            "css_webkit_transition_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_user_select
    ///
    /// Whether a page used the CSS property -webkit-user-select. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_user_select: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2148,
            "use.counter.css.page",
            "css_webkit_user_select",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_white_space
    ///
    /// Whether a page used the CSS property white-space. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_white_space: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2149,
            "use.counter.css.page",
            "css_white_space",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_white_space_collapse
    ///
    /// Whether a page used the CSS property white-space-collapse. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_white_space_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2150,
            "use.counter.css.page",
            "css_white_space_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_width
    ///
    /// Whether a page used the CSS property width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2151,
            "use.counter.css.page",
            "css_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_will_change
    ///
    /// Whether a page used the CSS property will-change. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_will_change: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2152,
            "use.counter.css.page",
            "css_will_change",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_word_break
    ///
    /// Whether a page used the CSS property word-break. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_word_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2153,
            "use.counter.css.page",
            "css_word_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_word_spacing
    ///
    /// Whether a page used the CSS property word-spacing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_word_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2154,
            "use.counter.css.page",
            "css_word_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_word_wrap
    ///
    /// Whether a page used the CSS property word-wrap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_word_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2155,
            "use.counter.css.page",
            "css_word_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_writing_mode
    ///
    /// Whether a page used the CSS property writing-mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_writing_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2156,
            "use.counter.css.page",
            "css_writing_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_x
    ///
    /// Whether a page used the CSS property x. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2157,
            "use.counter.css.page",
            "css_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_x_lang
    ///
    /// Whether a page used the CSS property -x-lang. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_x_lang: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2158,
            "use.counter.css.page",
            "css_x_lang",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_x_span
    ///
    /// Whether a page used the CSS property -x-span. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_x_span: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2159,
            "use.counter.css.page",
            "css_x_span",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_x_text_scale
    ///
    /// Whether a page used the CSS property -x-text-scale. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_x_text_scale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2160,
            "use.counter.css.page",
            "css_x_text_scale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_y
    ///
    /// Whether a page used the CSS property y. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2161,
            "use.counter.css.page",
            "css_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_z_index
    ///
    /// Whether a page used the CSS property z-index. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_z_index: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2162,
            "use.counter.css.page",
            "css_z_index",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_zoom
    ///
    /// Whether a page used the CSS property zoom. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2163,
            "use.counter.css.page",
            "css_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.max_zoom
    ///
    /// Whether a page used the (unknown, counted) CSS property max-zoom. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static max_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2164,
            "use.counter.css.page",
            "max_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.min_zoom
    ///
    /// Whether a page used the (unknown, counted) CSS property min-zoom. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static min_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2165,
            "use.counter.css.page",
            "min_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.orientation
    ///
    /// Whether a page used the (unknown, counted) CSS property orientation. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2166,
            "use.counter.css.page",
            "orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.orphans
    ///
    /// Whether a page used the (unknown, counted) CSS property orphans. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static orphans: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2167,
            "use.counter.css.page",
            "orphans",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.speak
    ///
    /// Whether a page used the (unknown, counted) CSS property speak. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static speak: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2168,
            "use.counter.css.page",
            "speak",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.text_size_adjust
    ///
    /// Whether a page used the (unknown, counted) CSS property text-size-adjust.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static text_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2169,
            "use.counter.css.page",
            "text_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.user_zoom
    ///
    /// Whether a page used the (unknown, counted) CSS property user-zoom. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static user_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2170,
            "use.counter.css.page",
            "user_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_app_region
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-app-region.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_app_region: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2171,
            "use.counter.css.page",
            "webkit_app_region",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_after
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-after.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2172,
            "use.counter.css.page",
            "webkit_border_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_after_color
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-after-
    /// color. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_after_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2173,
            "use.counter.css.page",
            "webkit_border_after_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_after_style
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-after-
    /// style. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_after_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2174,
            "use.counter.css.page",
            "webkit_border_after_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_after_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-after-
    /// width. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_after_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2175,
            "use.counter.css.page",
            "webkit_border_after_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_before
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-before.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2176,
            "use.counter.css.page",
            "webkit_border_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_before_color
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-before-
    /// color. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_before_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2177,
            "use.counter.css.page",
            "webkit_border_before_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_before_style
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-before-
    /// style. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_before_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2178,
            "use.counter.css.page",
            "webkit_border_before_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_before_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-before-
    /// width. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_before_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2179,
            "use.counter.css.page",
            "webkit_border_before_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_end
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-end.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2180,
            "use.counter.css.page",
            "webkit_border_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_end_color
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-end-
    /// color. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2181,
            "use.counter.css.page",
            "webkit_border_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_end_style
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-end-
    /// style. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2182,
            "use.counter.css.page",
            "webkit_border_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_end_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-end-
    /// width. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2183,
            "use.counter.css.page",
            "webkit_border_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_horizontal_spacing
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-
    /// horizontal-spacing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_horizontal_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2184,
            "use.counter.css.page",
            "webkit_border_horizontal_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_start
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-start.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2185,
            "use.counter.css.page",
            "webkit_border_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_start_color
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-start-
    /// color. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2186,
            "use.counter.css.page",
            "webkit_border_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_start_style
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-start-
    /// style. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2187,
            "use.counter.css.page",
            "webkit_border_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_start_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-start-
    /// width. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2188,
            "use.counter.css.page",
            "webkit_border_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_vertical_spacing
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-
    /// vertical-spacing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_vertical_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2189,
            "use.counter.css.page",
            "webkit_border_vertical_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_box_decoration_break
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-box-decoration-
    /// break. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_box_decoration_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2190,
            "use.counter.css.page",
            "webkit_box_decoration_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_box_reflect
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-box-reflect.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_box_reflect: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2191,
            "use.counter.css.page",
            "webkit_box_reflect",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_break_after
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-break-
    /// after. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_break_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2192,
            "use.counter.css.page",
            "webkit_column_break_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_break_before
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-break-
    /// before. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_break_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2193,
            "use.counter.css.page",
            "webkit_column_break_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_break_inside
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-break-
    /// inside. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_break_inside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2194,
            "use.counter.css.page",
            "webkit_column_break_inside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_count
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-count.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2195,
            "use.counter.css.page",
            "webkit_column_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_gap
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-gap.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2196,
            "use.counter.css.page",
            "webkit_column_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_rule
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-rule.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2197,
            "use.counter.css.page",
            "webkit_column_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_rule_color
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-rule-
    /// color. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_rule_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2198,
            "use.counter.css.page",
            "webkit_column_rule_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_rule_style
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-rule-
    /// style. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_rule_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2199,
            "use.counter.css.page",
            "webkit_column_rule_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_rule_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-rule-
    /// width. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_rule_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2200,
            "use.counter.css.page",
            "webkit_column_rule_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_span
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-span.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_span: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2201,
            "use.counter.css.page",
            "webkit_column_span",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-width.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2202,
            "use.counter.css.page",
            "webkit_column_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_columns
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-columns.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2203,
            "use.counter.css.page",
            "webkit_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_font_size_delta
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-font-size-
    /// delta. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_font_size_delta: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2204,
            "use.counter.css.page",
            "webkit_font_size_delta",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_highlight
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-highlight.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_highlight: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2205,
            "use.counter.css.page",
            "webkit_highlight",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_hyphenate_character
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-hyphenate-
    /// character. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_hyphenate_character: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2206,
            "use.counter.css.page",
            "webkit_hyphenate_character",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_line_break
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-line-break.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_line_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2207,
            "use.counter.css.page",
            "webkit_line_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_locale
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-locale. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_locale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2208,
            "use.counter.css.page",
            "webkit_locale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_logical_height
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-logical-height.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_logical_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2209,
            "use.counter.css.page",
            "webkit_logical_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_logical_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-logical-width.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_logical_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2210,
            "use.counter.css.page",
            "webkit_logical_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_after
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-after.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_margin_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2211,
            "use.counter.css.page",
            "webkit_margin_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_after_collapse
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-after-
    /// collapse. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_margin_after_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2212,
            "use.counter.css.page",
            "webkit_margin_after_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_before
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-before.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_margin_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2213,
            "use.counter.css.page",
            "webkit_margin_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_before_collapse
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-before-
    /// collapse. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_margin_before_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2214,
            "use.counter.css.page",
            "webkit_margin_before_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_bottom_collapse
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-bottom-
    /// collapse. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_margin_bottom_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2215,
            "use.counter.css.page",
            "webkit_margin_bottom_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_collapse
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-
    /// collapse. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_margin_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2216,
            "use.counter.css.page",
            "webkit_margin_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_end
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-end.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_margin_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2217,
            "use.counter.css.page",
            "webkit_margin_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_start
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-start.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_margin_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2218,
            "use.counter.css.page",
            "webkit_margin_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_top_collapse
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-top-
    /// collapse. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_margin_top_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2219,
            "use.counter.css.page",
            "webkit_margin_top_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_box_image
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2220,
            "use.counter.css.page",
            "webkit_mask_box_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_box_image_outset
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-
    /// outset. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image_outset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2221,
            "use.counter.css.page",
            "webkit_mask_box_image_outset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_box_image_repeat
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-
    /// repeat. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2222,
            "use.counter.css.page",
            "webkit_mask_box_image_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_box_image_slice
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-
    /// slice. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image_slice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2223,
            "use.counter.css.page",
            "webkit_mask_box_image_slice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_box_image_source
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-
    /// source. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2224,
            "use.counter.css.page",
            "webkit_mask_box_image_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_box_image_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-
    /// width. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2225,
            "use.counter.css.page",
            "webkit_mask_box_image_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_repeat_x
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-repeat-x.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_repeat_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2226,
            "use.counter.css.page",
            "webkit_mask_repeat_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_repeat_y
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-repeat-y.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_repeat_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2227,
            "use.counter.css.page",
            "webkit_mask_repeat_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_max_logical_height
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-max-logical-
    /// height. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_max_logical_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2228,
            "use.counter.css.page",
            "webkit_max_logical_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_max_logical_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-max-logical-
    /// width. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_max_logical_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2229,
            "use.counter.css.page",
            "webkit_max_logical_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_min_logical_height
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-min-logical-
    /// height. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_min_logical_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2230,
            "use.counter.css.page",
            "webkit_min_logical_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_min_logical_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-min-logical-
    /// width. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_min_logical_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2231,
            "use.counter.css.page",
            "webkit_min_logical_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_opacity
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-opacity.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2232,
            "use.counter.css.page",
            "webkit_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_padding_after
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-padding-after.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_padding_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2233,
            "use.counter.css.page",
            "webkit_padding_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_padding_before
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-padding-before.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_padding_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2234,
            "use.counter.css.page",
            "webkit_padding_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_padding_end
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-padding-end.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_padding_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2235,
            "use.counter.css.page",
            "webkit_padding_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_padding_start
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-padding-start.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_padding_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2236,
            "use.counter.css.page",
            "webkit_padding_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_perspective_origin_x
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-perspective-
    /// origin-x. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_perspective_origin_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2237,
            "use.counter.css.page",
            "webkit_perspective_origin_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_perspective_origin_y
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-perspective-
    /// origin-y. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_perspective_origin_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2238,
            "use.counter.css.page",
            "webkit_perspective_origin_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_print_color_adjust
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-print-color-
    /// adjust. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_print_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2239,
            "use.counter.css.page",
            "webkit_print_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_rtl_ordering
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-rtl-ordering.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_rtl_ordering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2240,
            "use.counter.css.page",
            "webkit_rtl_ordering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_ruby_position
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-ruby-position.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_ruby_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2241,
            "use.counter.css.page",
            "webkit_ruby_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_shape_image_threshold
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-shape-image-
    /// threshold. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_shape_image_threshold: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2242,
            "use.counter.css.page",
            "webkit_shape_image_threshold",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_shape_margin
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-shape-margin.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_shape_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2243,
            "use.counter.css.page",
            "webkit_shape_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_shape_outside
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-shape-outside.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_shape_outside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2244,
            "use.counter.css.page",
            "webkit_shape_outside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_tap_highlight_color
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-tap-highlight-
    /// color. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_tap_highlight_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2245,
            "use.counter.css.page",
            "webkit_tap_highlight_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_text_combine
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-text-combine.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_text_combine: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2246,
            "use.counter.css.page",
            "webkit_text_combine",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_text_decorations_in_effect
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-text-
    /// decorations-in-effect. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_text_decorations_in_effect: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2247,
            "use.counter.css.page",
            "webkit_text_decorations_in_effect",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_text_emphasis
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-text-emphasis.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_text_emphasis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2248,
            "use.counter.css.page",
            "webkit_text_emphasis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_text_emphasis_color
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-text-emphasis-
    /// color. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_text_emphasis_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2249,
            "use.counter.css.page",
            "webkit_text_emphasis_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_text_emphasis_position
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-text-emphasis-
    /// position. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_text_emphasis_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2250,
            "use.counter.css.page",
            "webkit_text_emphasis_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_text_emphasis_style
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-text-emphasis-
    /// style. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_text_emphasis_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2251,
            "use.counter.css.page",
            "webkit_text_emphasis_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_text_orientation
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-text-
    /// orientation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_text_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2252,
            "use.counter.css.page",
            "webkit_text_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_transform_origin_x
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-transform-
    /// origin-x. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_transform_origin_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2253,
            "use.counter.css.page",
            "webkit_transform_origin_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_transform_origin_y
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-transform-
    /// origin-y. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_transform_origin_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2254,
            "use.counter.css.page",
            "webkit_transform_origin_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_transform_origin_z
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-transform-
    /// origin-z. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_transform_origin_z: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2255,
            "use.counter.css.page",
            "webkit_transform_origin_z",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_user_drag
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-user-drag.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_user_drag: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2256,
            "use.counter.css.page",
            "webkit_user_drag",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_user_modify
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-user-modify.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_user_modify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2257,
            "use.counter.css.page",
            "webkit_user_modify",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_writing_mode
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-writing-mode.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_writing_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2258,
            "use.counter.css.page",
            "webkit_writing_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.widows
    ///
    /// Whether a page used the (unknown, counted) CSS property widows. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static widows: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2259,
            "use.counter.css.page",
            "widows",
            "use-counters"
        )
    });

}
pub mod use_counter_deprecated_ops_doc {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.ambient_light_event
    ///
    /// Whether a document used AmbientLightEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static ambient_light_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2260,
            "use.counter.deprecated_ops.doc",
            "ambient_light_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.app_cache
    ///
    /// Whether a document used AppCache. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static app_cache: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2261,
            "use.counter.deprecated_ops.doc",
            "app_cache",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.components
    ///
    /// Whether a document used Components. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static components: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2262,
            "use.counter.deprecated_ops.doc",
            "components",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.create_image_bitmap_canvas_rendering_context2_d
    ///
    /// Whether a document used CreateImageBitmapCanvasRenderingContext2D. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static create_image_bitmap_canvas_rendering_context2_d: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2263,
            "use.counter.deprecated_ops.doc",
            "create_image_bitmap_canvas_rendering_context2_d",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.deprecated_testing_attribute
    ///
    /// Whether a document used DeprecatedTestingAttribute. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static deprecated_testing_attribute: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2264,
            "use.counter.deprecated_ops.doc",
            "deprecated_testing_attribute",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.deprecated_testing_interface
    ///
    /// Whether a document used DeprecatedTestingInterface. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static deprecated_testing_interface: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2265,
            "use.counter.deprecated_ops.doc",
            "deprecated_testing_interface",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.deprecated_testing_method
    ///
    /// Whether a document used DeprecatedTestingMethod. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static deprecated_testing_method: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2266,
            "use.counter.deprecated_ops.doc",
            "deprecated_testing_method",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.document_release_capture
    ///
    /// Whether a document used DocumentReleaseCapture. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_release_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2267,
            "use.counter.deprecated_ops.doc",
            "document_release_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domattr_modified
    ///
    /// Whether a document used DOMAttrModified. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domattr_modified: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2268,
            "use.counter.deprecated_ops.doc",
            "domattr_modified",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domcharacter_data_modified
    ///
    /// Whether a document used DOMCharacterDataModified. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domcharacter_data_modified: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2269,
            "use.counter.deprecated_ops.doc",
            "domcharacter_data_modified",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domnode_inserted
    ///
    /// Whether a document used DOMNodeInserted. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domnode_inserted: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2270,
            "use.counter.deprecated_ops.doc",
            "domnode_inserted",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domnode_inserted_into_document
    ///
    /// Whether a document used DOMNodeInsertedIntoDocument. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domnode_inserted_into_document: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2271,
            "use.counter.deprecated_ops.doc",
            "domnode_inserted_into_document",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domnode_removed
    ///
    /// Whether a document used DOMNodeRemoved. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domnode_removed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2272,
            "use.counter.deprecated_ops.doc",
            "domnode_removed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domnode_removed_from_document
    ///
    /// Whether a document used DOMNodeRemovedFromDocument. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domnode_removed_from_document: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2273,
            "use.counter.deprecated_ops.doc",
            "domnode_removed_from_document",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domquad_bounds_attr
    ///
    /// Whether a document used DOMQuadBoundsAttr. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domquad_bounds_attr: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2274,
            "use.counter.deprecated_ops.doc",
            "domquad_bounds_attr",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domsubtree_modified
    ///
    /// Whether a document used DOMSubtreeModified. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domsubtree_modified: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2275,
            "use.counter.deprecated_ops.doc",
            "domsubtree_modified",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.draw_window_canvas_rendering_context2_d
    ///
    /// Whether a document used DrawWindowCanvasRenderingContext2D. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static draw_window_canvas_rendering_context2_d: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2276,
            "use.counter.deprecated_ops.doc",
            "draw_window_canvas_rendering_context2_d",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.element_release_capture
    ///
    /// Whether a document used ElementReleaseCapture. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_release_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2277,
            "use.counter.deprecated_ops.doc",
            "element_release_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.element_set_capture
    ///
    /// Whether a document used ElementSetCapture. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_set_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2278,
            "use.counter.deprecated_ops.doc",
            "element_set_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.external__add_search_provider
    ///
    /// Whether a document used External_AddSearchProvider. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static external__add_search_provider: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2279,
            "use.counter.deprecated_ops.doc",
            "external__add_search_provider",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.form_submission_untrusted_event
    ///
    /// Whether a document used FormSubmissionUntrustedEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static form_submission_untrusted_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2280,
            "use.counter.deprecated_ops.doc",
            "form_submission_untrusted_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.idbobject_store_create_index_locale
    ///
    /// Whether a document used IDBObjectStoreCreateIndexLocale. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static idbobject_store_create_index_locale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2281,
            "use.counter.deprecated_ops.doc",
            "idbobject_store_create_index_locale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.idbopen_dboptions__storage_type
    ///
    /// Whether a document used IDBOpenDBOptions_StorageType. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static idbopen_dboptions__storage_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2282,
            "use.counter.deprecated_ops.doc",
            "idbopen_dboptions__storage_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.image_bitmap_rendering_context__transfer_image_bitmap
    ///
    /// Whether a document used ImageBitmapRenderingContext_TransferImageBitmap.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static image_bitmap_rendering_context__transfer_image_bitmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2283,
            "use.counter.deprecated_ops.doc",
            "image_bitmap_rendering_context__transfer_image_bitmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.import_xulinto_content
    ///
    /// Whether a document used ImportXULIntoContent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static import_xulinto_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2284,
            "use.counter.deprecated_ops.doc",
            "import_xulinto_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.init_mouse_event
    ///
    /// Whether a document used InitMouseEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static init_mouse_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2285,
            "use.counter.deprecated_ops.doc",
            "init_mouse_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.init_nsmouse_event
    ///
    /// Whether a document used InitNSMouseEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static init_nsmouse_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2286,
            "use.counter.deprecated_ops.doc",
            "init_nsmouse_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.install_trigger_deprecated
    ///
    /// Whether a document used InstallTriggerDeprecated. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static install_trigger_deprecated: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2287,
            "use.counter.deprecated_ops.doc",
            "install_trigger_deprecated",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.install_trigger_install_deprecated
    ///
    /// Whether a document used InstallTriggerInstallDeprecated. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static install_trigger_install_deprecated: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2288,
            "use.counter.deprecated_ops.doc",
            "install_trigger_install_deprecated",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.lenient_setter
    ///
    /// Whether a document used LenientSetter. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static lenient_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2289,
            "use.counter.deprecated_ops.doc",
            "lenient_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.lenient_this
    ///
    /// Whether a document used LenientThis. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static lenient_this: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2290,
            "use.counter.deprecated_ops.doc",
            "lenient_this",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.math_ml__deprecated_math_space_value2
    ///
    /// Whether a document used MathML_DeprecatedMathSpaceValue2. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static math_ml__deprecated_math_space_value2: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2291,
            "use.counter.deprecated_ops.doc",
            "math_ml__deprecated_math_space_value2",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.math_ml__deprecated_math_variant
    ///
    /// Whether a document used MathML_DeprecatedMathVariant. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static math_ml__deprecated_math_variant: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2292,
            "use.counter.deprecated_ops.doc",
            "math_ml__deprecated_math_variant",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.math_ml__deprecated_stixgeneral_operator_stretching
    ///
    /// Whether a document used MathML_DeprecatedStixgeneralOperatorStretching. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static math_ml__deprecated_stixgeneral_operator_stretching: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2293,
            "use.counter.deprecated_ops.doc",
            "math_ml__deprecated_stixgeneral_operator_stretching",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.motion_event
    ///
    /// Whether a document used MotionEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static motion_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2294,
            "use.counter.deprecated_ops.doc",
            "motion_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.mouse_event__moz_pressure
    ///
    /// Whether a document used MouseEvent_MozPressure. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mouse_event__moz_pressure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2295,
            "use.counter.deprecated_ops.doc",
            "mouse_event__moz_pressure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.moz_input_source
    ///
    /// Whether a document used MozInputSource. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static moz_input_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2296,
            "use.counter.deprecated_ops.doc",
            "moz_input_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.moz_request_full_screen_deprecated_prefix
    ///
    /// Whether a document used MozRequestFullScreenDeprecatedPrefix. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static moz_request_full_screen_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2297,
            "use.counter.deprecated_ops.doc",
            "moz_request_full_screen_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.mozfullscreenchange_deprecated_prefix
    ///
    /// Whether a document used MozfullscreenchangeDeprecatedPrefix. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mozfullscreenchange_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2298,
            "use.counter.deprecated_ops.doc",
            "mozfullscreenchange_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.mozfullscreenerror_deprecated_prefix
    ///
    /// Whether a document used MozfullscreenerrorDeprecatedPrefix. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mozfullscreenerror_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2299,
            "use.counter.deprecated_ops.doc",
            "mozfullscreenerror_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.navigator_get_user_media
    ///
    /// Whether a document used NavigatorGetUserMedia. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static navigator_get_user_media: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2300,
            "use.counter.deprecated_ops.doc",
            "navigator_get_user_media",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.node_iterator_detach
    ///
    /// Whether a document used NodeIteratorDetach. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static node_iterator_detach: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2301,
            "use.counter.deprecated_ops.doc",
            "node_iterator_detach",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.offscreen_canvas_to_blob
    ///
    /// Whether a document used OffscreenCanvasToBlob. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static offscreen_canvas_to_blob: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2302,
            "use.counter.deprecated_ops.doc",
            "offscreen_canvas_to_blob",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.orientation_event
    ///
    /// Whether a document used OrientationEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static orientation_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2303,
            "use.counter.deprecated_ops.doc",
            "orientation_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.proximity_event
    ///
    /// Whether a document used ProximityEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static proximity_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2304,
            "use.counter.deprecated_ops.doc",
            "proximity_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.rtcpeer_connection_get_streams
    ///
    /// Whether a document used RTCPeerConnectionGetStreams. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static rtcpeer_connection_get_streams: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2305,
            "use.counter.deprecated_ops.doc",
            "rtcpeer_connection_get_streams",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.svgdeselect_all
    ///
    /// Whether a document used SVGDeselectAll. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static svgdeselect_all: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2306,
            "use.counter.deprecated_ops.doc",
            "svgdeselect_all",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.svgfarthest_viewport_element
    ///
    /// Whether a document used SVGFarthestViewportElement. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static svgfarthest_viewport_element: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2307,
            "use.counter.deprecated_ops.doc",
            "svgfarthest_viewport_element",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.svgnearest_viewport_element
    ///
    /// Whether a document used SVGNearestViewportElement. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static svgnearest_viewport_element: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2308,
            "use.counter.deprecated_ops.doc",
            "svgnearest_viewport_element",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.sync_xmlhttp_request_deprecated
    ///
    /// Whether a document used SyncXMLHttpRequestDeprecated. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static sync_xmlhttp_request_deprecated: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2309,
            "use.counter.deprecated_ops.doc",
            "sync_xmlhttp_request_deprecated",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.use_of_capture_events
    ///
    /// Whether a document used UseOfCaptureEvents. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static use_of_capture_events: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2310,
            "use.counter.deprecated_ops.doc",
            "use_of_capture_events",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.use_of_release_events
    ///
    /// Whether a document used UseOfReleaseEvents. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static use_of_release_events: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2311,
            "use.counter.deprecated_ops.doc",
            "use_of_release_events",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.webrtc_deprecated_prefix
    ///
    /// Whether a document used WebrtcDeprecatedPrefix. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webrtc_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2312,
            "use.counter.deprecated_ops.doc",
            "webrtc_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.window__cc_ontrollers
    ///
    /// Whether a document used Window_Cc_ontrollers. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window__cc_ontrollers: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2313,
            "use.counter.deprecated_ops.doc",
            "window__cc_ontrollers",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.window_content_untrusted
    ///
    /// Whether a document used WindowContentUntrusted. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_content_untrusted: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2314,
            "use.counter.deprecated_ops.doc",
            "window_content_untrusted",
            "use-counters"
        )
    });

}
pub mod use_counter_deprecated_ops_page {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.ambient_light_event
    ///
    /// Whether a page used AmbientLightEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static ambient_light_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2315,
            "use.counter.deprecated_ops.page",
            "ambient_light_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.app_cache
    ///
    /// Whether a page used AppCache. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static app_cache: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2316,
            "use.counter.deprecated_ops.page",
            "app_cache",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.components
    ///
    /// Whether a page used Components. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static components: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2317,
            "use.counter.deprecated_ops.page",
            "components",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.create_image_bitmap_canvas_rendering_context2_d
    ///
    /// Whether a page used CreateImageBitmapCanvasRenderingContext2D. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static create_image_bitmap_canvas_rendering_context2_d: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2318,
            "use.counter.deprecated_ops.page",
            "create_image_bitmap_canvas_rendering_context2_d",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.deprecated_testing_attribute
    ///
    /// Whether a page used DeprecatedTestingAttribute. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static deprecated_testing_attribute: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2319,
            "use.counter.deprecated_ops.page",
            "deprecated_testing_attribute",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.deprecated_testing_interface
    ///
    /// Whether a page used DeprecatedTestingInterface. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static deprecated_testing_interface: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2320,
            "use.counter.deprecated_ops.page",
            "deprecated_testing_interface",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.deprecated_testing_method
    ///
    /// Whether a page used DeprecatedTestingMethod. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static deprecated_testing_method: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2321,
            "use.counter.deprecated_ops.page",
            "deprecated_testing_method",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.document_release_capture
    ///
    /// Whether a page used DocumentReleaseCapture. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_release_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2322,
            "use.counter.deprecated_ops.page",
            "document_release_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domattr_modified
    ///
    /// Whether a page used DOMAttrModified. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domattr_modified: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2323,
            "use.counter.deprecated_ops.page",
            "domattr_modified",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domcharacter_data_modified
    ///
    /// Whether a page used DOMCharacterDataModified. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domcharacter_data_modified: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2324,
            "use.counter.deprecated_ops.page",
            "domcharacter_data_modified",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domnode_inserted
    ///
    /// Whether a page used DOMNodeInserted. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domnode_inserted: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2325,
            "use.counter.deprecated_ops.page",
            "domnode_inserted",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domnode_inserted_into_document
    ///
    /// Whether a page used DOMNodeInsertedIntoDocument. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domnode_inserted_into_document: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2326,
            "use.counter.deprecated_ops.page",
            "domnode_inserted_into_document",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domnode_removed
    ///
    /// Whether a page used DOMNodeRemoved. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domnode_removed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2327,
            "use.counter.deprecated_ops.page",
            "domnode_removed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domnode_removed_from_document
    ///
    /// Whether a page used DOMNodeRemovedFromDocument. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domnode_removed_from_document: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2328,
            "use.counter.deprecated_ops.page",
            "domnode_removed_from_document",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domquad_bounds_attr
    ///
    /// Whether a page used DOMQuadBoundsAttr. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domquad_bounds_attr: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2329,
            "use.counter.deprecated_ops.page",
            "domquad_bounds_attr",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domsubtree_modified
    ///
    /// Whether a page used DOMSubtreeModified. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domsubtree_modified: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2330,
            "use.counter.deprecated_ops.page",
            "domsubtree_modified",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.draw_window_canvas_rendering_context2_d
    ///
    /// Whether a page used DrawWindowCanvasRenderingContext2D. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static draw_window_canvas_rendering_context2_d: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2331,
            "use.counter.deprecated_ops.page",
            "draw_window_canvas_rendering_context2_d",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.element_release_capture
    ///
    /// Whether a page used ElementReleaseCapture. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_release_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2332,
            "use.counter.deprecated_ops.page",
            "element_release_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.element_set_capture
    ///
    /// Whether a page used ElementSetCapture. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_set_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2333,
            "use.counter.deprecated_ops.page",
            "element_set_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.external__add_search_provider
    ///
    /// Whether a page used External_AddSearchProvider. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static external__add_search_provider: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2334,
            "use.counter.deprecated_ops.page",
            "external__add_search_provider",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.form_submission_untrusted_event
    ///
    /// Whether a page used FormSubmissionUntrustedEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static form_submission_untrusted_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2335,
            "use.counter.deprecated_ops.page",
            "form_submission_untrusted_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.idbobject_store_create_index_locale
    ///
    /// Whether a page used IDBObjectStoreCreateIndexLocale. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static idbobject_store_create_index_locale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2336,
            "use.counter.deprecated_ops.page",
            "idbobject_store_create_index_locale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.idbopen_dboptions__storage_type
    ///
    /// Whether a page used IDBOpenDBOptions_StorageType. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static idbopen_dboptions__storage_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2337,
            "use.counter.deprecated_ops.page",
            "idbopen_dboptions__storage_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.image_bitmap_rendering_context__transfer_image_bitmap
    ///
    /// Whether a page used ImageBitmapRenderingContext_TransferImageBitmap. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static image_bitmap_rendering_context__transfer_image_bitmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2338,
            "use.counter.deprecated_ops.page",
            "image_bitmap_rendering_context__transfer_image_bitmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.import_xulinto_content
    ///
    /// Whether a page used ImportXULIntoContent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static import_xulinto_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2339,
            "use.counter.deprecated_ops.page",
            "import_xulinto_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.init_mouse_event
    ///
    /// Whether a page used InitMouseEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static init_mouse_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2340,
            "use.counter.deprecated_ops.page",
            "init_mouse_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.init_nsmouse_event
    ///
    /// Whether a page used InitNSMouseEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static init_nsmouse_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2341,
            "use.counter.deprecated_ops.page",
            "init_nsmouse_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.install_trigger_deprecated
    ///
    /// Whether a page used InstallTriggerDeprecated. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static install_trigger_deprecated: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2342,
            "use.counter.deprecated_ops.page",
            "install_trigger_deprecated",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.install_trigger_install_deprecated
    ///
    /// Whether a page used InstallTriggerInstallDeprecated. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static install_trigger_install_deprecated: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2343,
            "use.counter.deprecated_ops.page",
            "install_trigger_install_deprecated",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.lenient_setter
    ///
    /// Whether a page used LenientSetter. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static lenient_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2344,
            "use.counter.deprecated_ops.page",
            "lenient_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.lenient_this
    ///
    /// Whether a page used LenientThis. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static lenient_this: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2345,
            "use.counter.deprecated_ops.page",
            "lenient_this",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.math_ml__deprecated_math_space_value2
    ///
    /// Whether a page used MathML_DeprecatedMathSpaceValue2. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static math_ml__deprecated_math_space_value2: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2346,
            "use.counter.deprecated_ops.page",
            "math_ml__deprecated_math_space_value2",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.math_ml__deprecated_math_variant
    ///
    /// Whether a page used MathML_DeprecatedMathVariant. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static math_ml__deprecated_math_variant: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2347,
            "use.counter.deprecated_ops.page",
            "math_ml__deprecated_math_variant",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.math_ml__deprecated_stixgeneral_operator_stretching
    ///
    /// Whether a page used MathML_DeprecatedStixgeneralOperatorStretching. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static math_ml__deprecated_stixgeneral_operator_stretching: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2348,
            "use.counter.deprecated_ops.page",
            "math_ml__deprecated_stixgeneral_operator_stretching",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.motion_event
    ///
    /// Whether a page used MotionEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static motion_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2349,
            "use.counter.deprecated_ops.page",
            "motion_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.mouse_event__moz_pressure
    ///
    /// Whether a page used MouseEvent_MozPressure. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mouse_event__moz_pressure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2350,
            "use.counter.deprecated_ops.page",
            "mouse_event__moz_pressure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.moz_input_source
    ///
    /// Whether a page used MozInputSource. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static moz_input_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2351,
            "use.counter.deprecated_ops.page",
            "moz_input_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.moz_request_full_screen_deprecated_prefix
    ///
    /// Whether a page used MozRequestFullScreenDeprecatedPrefix. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static moz_request_full_screen_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2352,
            "use.counter.deprecated_ops.page",
            "moz_request_full_screen_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.mozfullscreenchange_deprecated_prefix
    ///
    /// Whether a page used MozfullscreenchangeDeprecatedPrefix. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mozfullscreenchange_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2353,
            "use.counter.deprecated_ops.page",
            "mozfullscreenchange_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.mozfullscreenerror_deprecated_prefix
    ///
    /// Whether a page used MozfullscreenerrorDeprecatedPrefix. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mozfullscreenerror_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2354,
            "use.counter.deprecated_ops.page",
            "mozfullscreenerror_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.navigator_get_user_media
    ///
    /// Whether a page used NavigatorGetUserMedia. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static navigator_get_user_media: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2355,
            "use.counter.deprecated_ops.page",
            "navigator_get_user_media",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.node_iterator_detach
    ///
    /// Whether a page used NodeIteratorDetach. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static node_iterator_detach: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2356,
            "use.counter.deprecated_ops.page",
            "node_iterator_detach",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.offscreen_canvas_to_blob
    ///
    /// Whether a page used OffscreenCanvasToBlob. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static offscreen_canvas_to_blob: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2357,
            "use.counter.deprecated_ops.page",
            "offscreen_canvas_to_blob",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.orientation_event
    ///
    /// Whether a page used OrientationEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static orientation_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2358,
            "use.counter.deprecated_ops.page",
            "orientation_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.proximity_event
    ///
    /// Whether a page used ProximityEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static proximity_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2359,
            "use.counter.deprecated_ops.page",
            "proximity_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.rtcpeer_connection_get_streams
    ///
    /// Whether a page used RTCPeerConnectionGetStreams. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static rtcpeer_connection_get_streams: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2360,
            "use.counter.deprecated_ops.page",
            "rtcpeer_connection_get_streams",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.svgdeselect_all
    ///
    /// Whether a page used SVGDeselectAll. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static svgdeselect_all: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2361,
            "use.counter.deprecated_ops.page",
            "svgdeselect_all",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.svgfarthest_viewport_element
    ///
    /// Whether a page used SVGFarthestViewportElement. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static svgfarthest_viewport_element: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2362,
            "use.counter.deprecated_ops.page",
            "svgfarthest_viewport_element",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.svgnearest_viewport_element
    ///
    /// Whether a page used SVGNearestViewportElement. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static svgnearest_viewport_element: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2363,
            "use.counter.deprecated_ops.page",
            "svgnearest_viewport_element",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.sync_xmlhttp_request_deprecated
    ///
    /// Whether a page used SyncXMLHttpRequestDeprecated. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static sync_xmlhttp_request_deprecated: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2364,
            "use.counter.deprecated_ops.page",
            "sync_xmlhttp_request_deprecated",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.use_of_capture_events
    ///
    /// Whether a page used UseOfCaptureEvents. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static use_of_capture_events: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2365,
            "use.counter.deprecated_ops.page",
            "use_of_capture_events",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.use_of_release_events
    ///
    /// Whether a page used UseOfReleaseEvents. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static use_of_release_events: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2366,
            "use.counter.deprecated_ops.page",
            "use_of_release_events",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.webrtc_deprecated_prefix
    ///
    /// Whether a page used WebrtcDeprecatedPrefix. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webrtc_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2367,
            "use.counter.deprecated_ops.page",
            "webrtc_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.window__cc_ontrollers
    ///
    /// Whether a page used Window_Cc_ontrollers. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window__cc_ontrollers: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2368,
            "use.counter.deprecated_ops.page",
            "window__cc_ontrollers",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.window_content_untrusted
    ///
    /// Whether a page used WindowContentUntrusted. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_content_untrusted: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2369,
            "use.counter.deprecated_ops.page",
            "window_content_untrusted",
            "use-counters"
        )
    });

}
pub mod use_counter_doc {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.clipboard_read
    ///
    /// Whether a document called called Clipboard.read. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static clipboard_read: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2370,
            "use.counter.doc",
            "clipboard_read",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.clipboard_readtext
    ///
    /// Whether a document called called Clipboard.readText. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static clipboard_readtext: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2371,
            "use.counter.doc",
            "clipboard_readtext",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.clipboard_write
    ///
    /// Whether a document called called Clipboard.write. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static clipboard_write: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2372,
            "use.counter.doc",
            "clipboard_write",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_assert
    ///
    /// Whether a document called called console.assert. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_assert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2373,
            "use.counter.doc",
            "console_assert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_clear
    ///
    /// Whether a document called called console.clear. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_clear: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2374,
            "use.counter.doc",
            "console_clear",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_count
    ///
    /// Whether a document called called console.count. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2375,
            "use.counter.doc",
            "console_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_countreset
    ///
    /// Whether a document called called console.countReset. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_countreset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2376,
            "use.counter.doc",
            "console_countreset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_debug
    ///
    /// Whether a document called called console.debug. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_debug: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2377,
            "use.counter.doc",
            "console_debug",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_dir
    ///
    /// Whether a document called called console.dir. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_dir: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2378,
            "use.counter.doc",
            "console_dir",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_dirxml
    ///
    /// Whether a document called called console.dirxml. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_dirxml: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2379,
            "use.counter.doc",
            "console_dirxml",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_error
    ///
    /// Whether a document called called console.error. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_error: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2380,
            "use.counter.doc",
            "console_error",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_exception
    ///
    /// Whether a document called called console.exception. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_exception: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2381,
            "use.counter.doc",
            "console_exception",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_group
    ///
    /// Whether a document called called console.group. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2382,
            "use.counter.doc",
            "console_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_groupcollapsed
    ///
    /// Whether a document called called console.groupCollapsed. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_groupcollapsed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2383,
            "use.counter.doc",
            "console_groupcollapsed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_groupend
    ///
    /// Whether a document called called console.groupEnd. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_groupend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2384,
            "use.counter.doc",
            "console_groupend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_info
    ///
    /// Whether a document called called console.info. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_info: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2385,
            "use.counter.doc",
            "console_info",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_log
    ///
    /// Whether a document called called console.log. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_log: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2386,
            "use.counter.doc",
            "console_log",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_profile
    ///
    /// Whether a document called called console.profile. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_profile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2387,
            "use.counter.doc",
            "console_profile",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_profileend
    ///
    /// Whether a document called called console.profileEnd. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_profileend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2388,
            "use.counter.doc",
            "console_profileend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_table
    ///
    /// Whether a document called called console.table. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_table: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2389,
            "use.counter.doc",
            "console_table",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_time
    ///
    /// Whether a document called called console.time. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_time: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2390,
            "use.counter.doc",
            "console_time",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_timeend
    ///
    /// Whether a document called called console.timeEnd. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_timeend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2391,
            "use.counter.doc",
            "console_timeend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_timelog
    ///
    /// Whether a document called called console.timeLog. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_timelog: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2392,
            "use.counter.doc",
            "console_timelog",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_timestamp
    ///
    /// Whether a document called called console.timeStamp. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_timestamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2393,
            "use.counter.doc",
            "console_timestamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_trace
    ///
    /// Whether a document called called console.trace. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_trace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2394,
            "use.counter.doc",
            "console_trace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_warn
    ///
    /// Whether a document called called console.warn. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_warn: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2395,
            "use.counter.doc",
            "console_warn",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.customelementregistry_define
    ///
    /// Whether a document called called CustomElementRegistry.define. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static customelementregistry_define: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2396,
            "use.counter.doc",
            "customelementregistry_define",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.customized_builtin
    ///
    /// Whether a document registers a customized built-in element. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static customized_builtin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2397,
            "use.counter.doc",
            "customized_builtin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_addelement
    ///
    /// Whether a document called called DataTransfer.addElement. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_addelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2398,
            "use.counter.doc",
            "datatransfer_addelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozcleardataat
    ///
    /// Whether a document called called DataTransfer.mozClearDataAt. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozcleardataat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2399,
            "use.counter.doc",
            "datatransfer_mozcleardataat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozcursor_getter
    ///
    /// Whether a document got DataTransfer.mozCursor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozcursor_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2400,
            "use.counter.doc",
            "datatransfer_mozcursor_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozcursor_setter
    ///
    /// Whether a document set DataTransfer.mozCursor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozcursor_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2401,
            "use.counter.doc",
            "datatransfer_mozcursor_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozgetdataat
    ///
    /// Whether a document called called DataTransfer.mozGetDataAt. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozgetdataat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2402,
            "use.counter.doc",
            "datatransfer_mozgetdataat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozitemcount_getter
    ///
    /// Whether a document got DataTransfer.mozItemCount. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozitemcount_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2403,
            "use.counter.doc",
            "datatransfer_mozitemcount_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozitemcount_setter
    ///
    /// Whether a document set DataTransfer.mozItemCount. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozitemcount_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2404,
            "use.counter.doc",
            "datatransfer_mozitemcount_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozsetdataat
    ///
    /// Whether a document called called DataTransfer.mozSetDataAt. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozsetdataat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2405,
            "use.counter.doc",
            "datatransfer_mozsetdataat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozsourcenode_getter
    ///
    /// Whether a document got DataTransfer.mozSourceNode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozsourcenode_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2406,
            "use.counter.doc",
            "datatransfer_mozsourcenode_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozsourcenode_setter
    ///
    /// Whether a document set DataTransfer.mozSourceNode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozsourcenode_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2407,
            "use.counter.doc",
            "datatransfer_mozsourcenode_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_moztypesat
    ///
    /// Whether a document called called DataTransfer.mozTypesAt. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_moztypesat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2408,
            "use.counter.doc",
            "datatransfer_moztypesat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozusercancelled_getter
    ///
    /// Whether a document got DataTransfer.mozUserCancelled. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozusercancelled_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2409,
            "use.counter.doc",
            "datatransfer_mozusercancelled_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozusercancelled_setter
    ///
    /// Whether a document set DataTransfer.mozUserCancelled. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozusercancelled_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2410,
            "use.counter.doc",
            "datatransfer_mozusercancelled_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransferitem_webkitgetasentry
    ///
    /// Whether a document called called DataTransferItem.webkitGetAsEntry. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransferitem_webkitgetasentry: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2411,
            "use.counter.doc",
            "datatransferitem_webkitgetasentry",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_caretrangefrompoint
    ///
    /// Whether a document called called Document.caretRangeFromPoint. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_caretrangefrompoint: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2412,
            "use.counter.doc",
            "document_caretrangefrompoint",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_exec_command_content_read_only
    ///
    /// Whether a document calls execCommand with contentReadOnly. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_exec_command_content_read_only: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2413,
            "use.counter.doc",
            "document_exec_command_content_read_only",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_exitpictureinpicture
    ///
    /// Whether a document called called Document.exitPictureInPicture. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_exitpictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2414,
            "use.counter.doc",
            "document_exitpictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_featurepolicy
    ///
    /// Whether a document called called Document.featurePolicy. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_featurepolicy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2415,
            "use.counter.doc",
            "document_featurepolicy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_mozsetimageelement
    ///
    /// Whether a document called called Document.mozSetImageElement. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_mozsetimageelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2416,
            "use.counter.doc",
            "document_mozsetimageelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_onbeforecopy
    ///
    /// Whether a document called called Document.onbeforecopy. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_onbeforecopy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2417,
            "use.counter.doc",
            "document_onbeforecopy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_onbeforecut
    ///
    /// Whether a document called called Document.onbeforecut. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_onbeforecut: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2418,
            "use.counter.doc",
            "document_onbeforecut",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_onbeforepaste
    ///
    /// Whether a document called called Document.onbeforepaste. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_onbeforepaste: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2419,
            "use.counter.doc",
            "document_onbeforepaste",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_oncancel
    ///
    /// Whether a document called called Document.oncancel. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_oncancel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2420,
            "use.counter.doc",
            "document_oncancel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_onfreeze
    ///
    /// Whether a document called called Document.onfreeze. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_onfreeze: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2421,
            "use.counter.doc",
            "document_onfreeze",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_onmousewheel
    ///
    /// Whether a document called called Document.onmousewheel. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_onmousewheel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2422,
            "use.counter.doc",
            "document_onmousewheel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_onresume
    ///
    /// Whether a document called called Document.onresume. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_onresume: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2423,
            "use.counter.doc",
            "document_onresume",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_onsearch
    ///
    /// Whether a document called called Document.onsearch. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_onsearch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2424,
            "use.counter.doc",
            "document_onsearch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_onwebkitfullscreenchange
    ///
    /// Whether a document called called Document.onwebkitfullscreenchange. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_onwebkitfullscreenchange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2425,
            "use.counter.doc",
            "document_onwebkitfullscreenchange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_onwebkitfullscreenerror
    ///
    /// Whether a document called called Document.onwebkitfullscreenerror. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_onwebkitfullscreenerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2426,
            "use.counter.doc",
            "document_onwebkitfullscreenerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_open
    ///
    /// Whether a document calls document.open in a way that creates a new Window
    /// object. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static document_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2427,
            "use.counter.doc",
            "document_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_pictureinpictureelement
    ///
    /// Whether a document called called Document.pictureInPictureElement. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_pictureinpictureelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2428,
            "use.counter.doc",
            "document_pictureinpictureelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_pictureinpictureenabled
    ///
    /// Whether a document called called Document.pictureInPictureEnabled. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_pictureinpictureenabled: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2429,
            "use.counter.doc",
            "document_pictureinpictureenabled",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_query_command_state_or_value_content_read_only
    ///
    /// Whether a document calls queryCommandState or queryCommandValue with
    /// contentReadOnly. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static document_query_command_state_or_value_content_read_only: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2430,
            "use.counter.doc",
            "document_query_command_state_or_value_content_read_only",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_query_command_state_or_value_insert_br_on_return
    ///
    /// Whether a document calls queryCommandState or queryCommandValue with
    /// insertBrOnReturn. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static document_query_command_state_or_value_insert_br_on_return: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2431,
            "use.counter.doc",
            "document_query_command_state_or_value_insert_br_on_return",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_query_command_supported_or_enabled_content_read_only
    ///
    /// Whether a document calls queryCommandSupported or queryCommandEnabled with
    /// contentReadOnly. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static document_query_command_supported_or_enabled_content_read_only: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2432,
            "use.counter.doc",
            "document_query_command_supported_or_enabled_content_read_only",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_query_command_supported_or_enabled_insert_br_on_return
    ///
    /// Whether a document calls queryCommandSupported or queryCommandEnabled with
    /// insertBrOnReturn. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static document_query_command_supported_or_enabled_insert_br_on_return: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2433,
            "use.counter.doc",
            "document_query_command_supported_or_enabled_insert_br_on_return",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_registerelement
    ///
    /// Whether a document called called Document.registerElement. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_registerelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2434,
            "use.counter.doc",
            "document_registerelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_wasdiscarded
    ///
    /// Whether a document called called Document.wasDiscarded. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_wasdiscarded: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2435,
            "use.counter.doc",
            "document_wasdiscarded",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_webkitcancelfullscreen
    ///
    /// Whether a document called called Document.webkitCancelFullScreen. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_webkitcancelfullscreen: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2436,
            "use.counter.doc",
            "document_webkitcancelfullscreen",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_webkitcurrentfullscreenelement
    ///
    /// Whether a document called called Document.webkitCurrentFullScreenElement.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static document_webkitcurrentfullscreenelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2437,
            "use.counter.doc",
            "document_webkitcurrentfullscreenelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_webkitexitfullscreen
    ///
    /// Whether a document called called Document.webkitExitFullscreen. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_webkitexitfullscreen: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2438,
            "use.counter.doc",
            "document_webkitexitfullscreen",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_webkitfullscreenelement
    ///
    /// Whether a document called called Document.webkitFullscreenElement. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_webkitfullscreenelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2439,
            "use.counter.doc",
            "document_webkitfullscreenelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_webkitfullscreenenabled
    ///
    /// Whether a document called called Document.webkitFullscreenEnabled. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_webkitfullscreenenabled: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2440,
            "use.counter.doc",
            "document_webkitfullscreenenabled",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_webkithidden
    ///
    /// Whether a document called called Document.webkitHidden. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_webkithidden: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2441,
            "use.counter.doc",
            "document_webkithidden",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_webkitisfullscreen
    ///
    /// Whether a document called called Document.webkitIsFullScreen. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_webkitisfullscreen: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2442,
            "use.counter.doc",
            "document_webkitisfullscreen",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_webkitvisibilitystate
    ///
    /// Whether a document called called Document.webkitVisibilityState. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_webkitvisibilitystate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2443,
            "use.counter.doc",
            "document_webkitvisibilitystate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_xmlencoding
    ///
    /// Whether a document called called Document.xmlEncoding. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_xmlencoding: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2444,
            "use.counter.doc",
            "document_xmlencoding",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_xmlstandalone
    ///
    /// Whether a document called called Document.xmlStandalone. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_xmlstandalone: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2445,
            "use.counter.doc",
            "document_xmlstandalone",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_xmlversion
    ///
    /// Whether a document called called Document.xmlVersion. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_xmlversion: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2446,
            "use.counter.doc",
            "document_xmlversion",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.domparser_parsefromstring
    ///
    /// Whether a document called called DOMParser.parseFromString. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domparser_parsefromstring: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2447,
            "use.counter.doc",
            "domparser_parsefromstring",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_attachshadow
    ///
    /// Whether a document called called Element.attachShadow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_attachshadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2448,
            "use.counter.doc",
            "element_attachshadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_computedstylemap
    ///
    /// Whether a document called called Element.computedStyleMap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_computedstylemap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2449,
            "use.counter.doc",
            "element_computedstylemap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_onmousewheel
    ///
    /// Whether a document called called Element.onmousewheel. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_onmousewheel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2450,
            "use.counter.doc",
            "element_onmousewheel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_releasecapture
    ///
    /// Whether a document called called Element.releaseCapture. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_releasecapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2451,
            "use.counter.doc",
            "element_releasecapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_releasepointercapture
    ///
    /// Whether a document called called Element.releasePointerCapture. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_releasepointercapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2452,
            "use.counter.doc",
            "element_releasepointercapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_scrollintoviewifneeded
    ///
    /// Whether a document called called Element.scrollIntoViewIfNeeded. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_scrollintoviewifneeded: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2453,
            "use.counter.doc",
            "element_scrollintoviewifneeded",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_setcapture
    ///
    /// Whether a document called called Element.setCapture. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_setcapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2454,
            "use.counter.doc",
            "element_setcapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_sethtml
    ///
    /// Whether a document called called Element.setHTML. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_sethtml: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2455,
            "use.counter.doc",
            "element_sethtml",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_setpointercapture
    ///
    /// Whether a document called called Element.setPointerCapture. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_setpointercapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2456,
            "use.counter.doc",
            "element_setpointercapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.enumerate_devices_insec
    ///
    /// Whether a document calls MediaDevices.enumerateDevices from an insecure
    /// context. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static enumerate_devices_insec: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2457,
            "use.counter.doc",
            "enumerate_devices_insec",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.enumerate_devices_unfocused
    ///
    /// Whether a document calls MediaDevices.enumerateDevices from a unfocused
    /// document. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static enumerate_devices_unfocused: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2458,
            "use.counter.doc",
            "enumerate_devices_unfocused",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_blend
    ///
    /// Whether a document uses the feBlend SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_blend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2459,
            "use.counter.doc",
            "fe_blend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_color_matrix
    ///
    /// Whether a document uses the feColorMatrix SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_color_matrix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2460,
            "use.counter.doc",
            "fe_color_matrix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_component_transfer
    ///
    /// Whether a document uses the feComponentTransfer SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_component_transfer: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2461,
            "use.counter.doc",
            "fe_component_transfer",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_composite
    ///
    /// Whether a document uses the feComposite SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_composite: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2462,
            "use.counter.doc",
            "fe_composite",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_convolve_matrix
    ///
    /// Whether a document uses the feConvolveMatrix SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_convolve_matrix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2463,
            "use.counter.doc",
            "fe_convolve_matrix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_diffuse_lighting
    ///
    /// Whether a document uses the feDiffuseLighting SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_diffuse_lighting: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2464,
            "use.counter.doc",
            "fe_diffuse_lighting",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_displacement_map
    ///
    /// Whether a document uses the feDisplacementMap SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_displacement_map: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2465,
            "use.counter.doc",
            "fe_displacement_map",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_flood
    ///
    /// Whether a document uses the feFlood SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_flood: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2466,
            "use.counter.doc",
            "fe_flood",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_gaussian_blur
    ///
    /// Whether a document uses the feGaussianBlur SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_gaussian_blur: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2467,
            "use.counter.doc",
            "fe_gaussian_blur",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_image
    ///
    /// Whether a document uses the feImage SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2468,
            "use.counter.doc",
            "fe_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_merge
    ///
    /// Whether a document uses the feMerge SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_merge: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2469,
            "use.counter.doc",
            "fe_merge",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_morphology
    ///
    /// Whether a document uses the feMorphology SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_morphology: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2470,
            "use.counter.doc",
            "fe_morphology",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_offset
    ///
    /// Whether a document uses the feOffset SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2471,
            "use.counter.doc",
            "fe_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_specular_lighting
    ///
    /// Whether a document uses the feSpecularLighting SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_specular_lighting: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2472,
            "use.counter.doc",
            "fe_specular_lighting",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_tile
    ///
    /// Whether a document uses the feTile SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_tile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2473,
            "use.counter.doc",
            "fe_tile",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_turbulence
    ///
    /// Whether a document uses the feTurbulence SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_turbulence: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2474,
            "use.counter.doc",
            "fe_turbulence",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.filtered_cross_origin_iframe
    ///
    /// Whether a document cross-origin <iframe> within a CSS/SVG filter. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static filtered_cross_origin_iframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2475,
            "use.counter.doc",
            "filtered_cross_origin_iframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.get_user_media_insec
    ///
    /// Whether a document calls MediaDevices.getUserMedia from an insecure context.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static get_user_media_insec: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2476,
            "use.counter.doc",
            "get_user_media_insec",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.get_user_media_unfocused
    ///
    /// Whether a document calls MediaDevices.getUserMedia from an unfocused document.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static get_user_media_unfocused: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2477,
            "use.counter.doc",
            "get_user_media_unfocused",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlbuttonelement_popovertargetaction
    ///
    /// Whether a document called called HTMLButtonElement.popoverTargetAction. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlbuttonelement_popovertargetaction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2478,
            "use.counter.doc",
            "htmlbuttonelement_popovertargetaction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlbuttonelement_popovertargetelement
    ///
    /// Whether a document called called HTMLButtonElement.popoverTargetElement.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlbuttonelement_popovertargetelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2479,
            "use.counter.doc",
            "htmlbuttonelement_popovertargetelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldialogelement_show
    ///
    /// Whether a document called called HTMLDialogElement.show. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldialogelement_show: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2480,
            "use.counter.doc",
            "htmldialogelement_show",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_named_getter_hit
    ///
    /// Whether a document calls to the named getter on HTMLDocument that find
    /// something via the name lookup. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_named_getter_hit: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2481,
            "use.counter.doc",
            "htmldocument_named_getter_hit",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlelement_attributestylemap
    ///
    /// Whether a document called called HTMLElement.attributeStyleMap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlelement_attributestylemap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2482,
            "use.counter.doc",
            "htmlelement_attributestylemap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlelement_hidepopover
    ///
    /// Whether a document called called HTMLElement.hidePopover. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlelement_hidepopover: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2483,
            "use.counter.doc",
            "htmlelement_hidepopover",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlelement_popover
    ///
    /// Whether a document called called HTMLElement.popover. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlelement_popover: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2484,
            "use.counter.doc",
            "htmlelement_popover",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlelement_showpopover
    ///
    /// Whether a document called called HTMLElement.showPopover. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlelement_showpopover: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2485,
            "use.counter.doc",
            "htmlelement_showpopover",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlelement_togglepopover
    ///
    /// Whether a document called called HTMLElement.togglePopover. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlelement_togglepopover: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2486,
            "use.counter.doc",
            "htmlelement_togglepopover",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmliframeelement_loading
    ///
    /// Whether a document called called HTMLIFrameElement.loading. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmliframeelement_loading: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2487,
            "use.counter.doc",
            "htmliframeelement_loading",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlinputelement_capture
    ///
    /// Whether a document called called HTMLInputElement.capture. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2488,
            "use.counter.doc",
            "htmlinputelement_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlinputelement_incremental
    ///
    /// Whether a document called called HTMLInputElement.incremental. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_incremental: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2489,
            "use.counter.doc",
            "htmlinputelement_incremental",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlinputelement_onsearch
    ///
    /// Whether a document called called HTMLInputElement.onsearch. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_onsearch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2490,
            "use.counter.doc",
            "htmlinputelement_onsearch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlinputelement_popovertargetaction
    ///
    /// Whether a document called called HTMLInputElement.popoverTargetAction. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_popovertargetaction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2491,
            "use.counter.doc",
            "htmlinputelement_popovertargetaction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlinputelement_popovertargetelement
    ///
    /// Whether a document called called HTMLInputElement.popoverTargetElement. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_popovertargetelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2492,
            "use.counter.doc",
            "htmlinputelement_popovertargetelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlinputelement_webkitdirectory
    ///
    /// Whether a document called called HTMLInputElement.webkitdirectory. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_webkitdirectory: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2493,
            "use.counter.doc",
            "htmlinputelement_webkitdirectory",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlinputelement_webkitentries
    ///
    /// Whether a document called called HTMLInputElement.webkitEntries. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_webkitentries: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2494,
            "use.counter.doc",
            "htmlinputelement_webkitentries",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlmediaelement_disableremoteplayback
    ///
    /// Whether a document called called HTMLMediaElement.disableRemotePlayback.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlmediaelement_disableremoteplayback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2495,
            "use.counter.doc",
            "htmlmediaelement_disableremoteplayback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlmediaelement_remote
    ///
    /// Whether a document called called HTMLMediaElement.remote. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlmediaelement_remote: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2496,
            "use.counter.doc",
            "htmlmediaelement_remote",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlvideoelement_cancelvideoframecallback
    ///
    /// Whether a document called called HTMLVideoElement.cancelVideoFrameCallback.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_cancelvideoframecallback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2497,
            "use.counter.doc",
            "htmlvideoelement_cancelvideoframecallback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlvideoelement_disablepictureinpicture
    ///
    /// Whether a document called called HTMLVideoElement.disablePictureInPicture.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_disablepictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2498,
            "use.counter.doc",
            "htmlvideoelement_disablepictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlvideoelement_onenterpictureinpicture
    ///
    /// Whether a document called called HTMLVideoElement.onenterpictureinpicture.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_onenterpictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2499,
            "use.counter.doc",
            "htmlvideoelement_onenterpictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlvideoelement_onleavepictureinpicture
    ///
    /// Whether a document called called HTMLVideoElement.onleavepictureinpicture.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_onleavepictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2500,
            "use.counter.doc",
            "htmlvideoelement_onleavepictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlvideoelement_playsinline
    ///
    /// Whether a document called called HTMLVideoElement.playsInline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlvideoelement_playsinline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2501,
            "use.counter.doc",
            "htmlvideoelement_playsinline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlvideoelement_requestpictureinpicture
    ///
    /// Whether a document called called HTMLVideoElement.requestPictureInPicture.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_requestpictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2502,
            "use.counter.doc",
            "htmlvideoelement_requestpictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlvideoelement_requestvideoframecallback
    ///
    /// Whether a document called called HTMLVideoElement.requestVideoFrameCallback.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_requestvideoframecallback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2503,
            "use.counter.doc",
            "htmlvideoelement_requestvideoframecallback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.imagedata_colorspace
    ///
    /// Whether a document called called ImageData.colorSpace. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static imagedata_colorspace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2504,
            "use.counter.doc",
            "imagedata_colorspace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_asmjs
    ///
    /// Whether a document uses asm.js. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_asmjs: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2505,
            "use.counter.doc",
            "js_asmjs",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_wasm
    ///
    /// Whether a document uses WebAssembly. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_wasm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2506,
            "use.counter.doc",
            "js_wasm",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_wasm_legacy_exceptions
    ///
    /// Whether a document uses WebAssembly legacy exception-handling. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_wasm_legacy_exceptions: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2507,
            "use.counter.doc",
            "js_wasm_legacy_exceptions",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.location_ancestororigins
    ///
    /// Whether a document called called Location.ancestorOrigins. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static location_ancestororigins: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2508,
            "use.counter.doc",
            "location_ancestororigins",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mediadevices_enumeratedevices
    ///
    /// Whether a document called called MediaDevices.enumerateDevices. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mediadevices_enumeratedevices: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2509,
            "use.counter.doc",
            "mediadevices_enumeratedevices",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mediadevices_getdisplaymedia
    ///
    /// Whether a document called called MediaDevices.getDisplayMedia. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mediadevices_getdisplaymedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2510,
            "use.counter.doc",
            "mediadevices_getdisplaymedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mediadevices_getusermedia
    ///
    /// Whether a document called called MediaDevices.getUserMedia. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mediadevices_getusermedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2511,
            "use.counter.doc",
            "mediadevices_getusermedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_not_upgraded_audio_failure
    ///
    /// Whether a document includes a mixed content audio element that does not load..
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_not_upgraded_audio_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2512,
            "use.counter.doc",
            "mixed_content_not_upgraded_audio_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_not_upgraded_audio_success
    ///
    /// Whether a document includes a mixed content audio element that loads.. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_not_upgraded_audio_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2513,
            "use.counter.doc",
            "mixed_content_not_upgraded_audio_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_not_upgraded_image_failure
    ///
    /// Whether a document includes a mixed content img element that does not load..
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_not_upgraded_image_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2514,
            "use.counter.doc",
            "mixed_content_not_upgraded_image_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_not_upgraded_image_success
    ///
    /// Whether a document includes a mixed content img element that loads.. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_not_upgraded_image_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2515,
            "use.counter.doc",
            "mixed_content_not_upgraded_image_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_not_upgraded_video_failure
    ///
    /// Whether a document includes a mixed content video element that does not laod..
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_not_upgraded_video_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2516,
            "use.counter.doc",
            "mixed_content_not_upgraded_video_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_not_upgraded_video_success
    ///
    /// Whether a document includes a mixed content video element that loads.. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_not_upgraded_video_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2517,
            "use.counter.doc",
            "mixed_content_not_upgraded_video_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_upgraded_audio_failure
    ///
    /// Whether a document includes a mixed content audio element that does not load..
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_upgraded_audio_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2518,
            "use.counter.doc",
            "mixed_content_upgraded_audio_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_upgraded_audio_success
    ///
    /// Whether a document includes a mixed content audio element that loads.. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_upgraded_audio_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2519,
            "use.counter.doc",
            "mixed_content_upgraded_audio_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_upgraded_image_failure
    ///
    /// Whether a document includes a mixed content img element that does not load..
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_upgraded_image_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2520,
            "use.counter.doc",
            "mixed_content_upgraded_image_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_upgraded_image_success
    ///
    /// Whether a document includes a mixed content img element that loads.. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_upgraded_image_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2521,
            "use.counter.doc",
            "mixed_content_upgraded_image_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_upgraded_video_failure
    ///
    /// Whether a document includes a mixed content video element that does not laod..
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_upgraded_video_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2522,
            "use.counter.doc",
            "mixed_content_upgraded_video_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_upgraded_video_success
    ///
    /// Whether a document includes a mixed content video element that loads.. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_upgraded_video_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2523,
            "use.counter.doc",
            "mixed_content_upgraded_video_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.moz_get_user_media_insec
    ///
    /// Whether a document calls Navigator.mozGetUserMedia from an insecure context.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static moz_get_user_media_insec: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2524,
            "use.counter.doc",
            "moz_get_user_media_insec",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.navigator_canshare
    ///
    /// Whether a document called called Navigator.canShare. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static navigator_canshare: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2525,
            "use.counter.doc",
            "navigator_canshare",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.navigator_clearappbadge
    ///
    /// Whether a document called called Navigator.clearAppBadge. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static navigator_clearappbadge: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2526,
            "use.counter.doc",
            "navigator_clearappbadge",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.navigator_mozgetusermedia
    ///
    /// Whether a document called called Navigator.mozGetUserMedia. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static navigator_mozgetusermedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2527,
            "use.counter.doc",
            "navigator_mozgetusermedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.navigator_setappbadge
    ///
    /// Whether a document called called Navigator.setAppBadge. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static navigator_setappbadge: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2528,
            "use.counter.doc",
            "navigator_setappbadge",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.navigator_share
    ///
    /// Whether a document called called Navigator.share. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static navigator_share: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2529,
            "use.counter.doc",
            "navigator_share",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.navigator_useractivation
    ///
    /// Whether a document called called Navigator.userActivation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static navigator_useractivation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2530,
            "use.counter.doc",
            "navigator_useractivation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.navigator_wakelock
    ///
    /// Whether a document called called Navigator.wakeLock. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static navigator_wakelock: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2531,
            "use.counter.doc",
            "navigator_wakelock",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.ondommousescroll
    ///
    /// Whether a document sets DOMMouseScroll event listener. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static ondommousescroll: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2532,
            "use.counter.doc",
            "ondommousescroll",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.onmozmousepixelscroll
    ///
    /// Whether a document sets MozMousePixelScroll event listener. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static onmozmousepixelscroll: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2533,
            "use.counter.doc",
            "onmozmousepixelscroll",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.onoverflow
    ///
    /// Whether a document sets an element onoverflow event listener. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static onoverflow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2534,
            "use.counter.doc",
            "onoverflow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.onunderflow
    ///
    /// Whether a document sets an element onunderflow event listener. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static onunderflow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2535,
            "use.counter.doc",
            "onunderflow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.percentage_stroke_width_in_svg
    ///
    /// Whether a document whether percentage stroke-width is used in SVG elements
    /// (excluding <text>). Compare against `use.counter.content_documents_destroyed`
    /// to calculate the rate.
    pub static percentage_stroke_width_in_svg: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2536,
            "use.counter.doc",
            "percentage_stroke_width_in_svg",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.percentage_stroke_width_in_svgtext
    ///
    /// Whether a document whether percentage stroke-width is used in SVG <text>.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static percentage_stroke_width_in_svgtext: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2537,
            "use.counter.doc",
            "percentage_stroke_width_in_svgtext",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_caches_delete
    ///
    /// Whether a document calls caches.delete in Private Browsing Mode. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_delete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2538,
            "use.counter.doc",
            "private_browsing_caches_delete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_caches_has
    ///
    /// Whether a document calls caches.has in Private Browsing Mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_has: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2539,
            "use.counter.doc",
            "private_browsing_caches_has",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_caches_keys
    ///
    /// Whether a document calls caches.keys in Private Browsing Mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_keys: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2540,
            "use.counter.doc",
            "private_browsing_caches_keys",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_caches_match
    ///
    /// Whether a document calls caches.match in Private Browsing Mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_match: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2541,
            "use.counter.doc",
            "private_browsing_caches_match",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_caches_open
    ///
    /// Whether a document calls caches.open in Private Browsing Mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2542,
            "use.counter.doc",
            "private_browsing_caches_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_idbfactory_delete_database
    ///
    /// Whether a document calls indexedDB.deleteDatabase in Private Browsing Mode.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static private_browsing_idbfactory_delete_database: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2543,
            "use.counter.doc",
            "private_browsing_idbfactory_delete_database",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_idbfactory_open
    ///
    /// Whether a document calls indexedDB.open in Private Browsing Mode. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static private_browsing_idbfactory_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2544,
            "use.counter.doc",
            "private_browsing_idbfactory_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_navigator_service_worker
    ///
    /// Whether a document accesses navigator.serviceWorker in Private Browsing Mode.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static private_browsing_navigator_service_worker: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2545,
            "use.counter.doc",
            "private_browsing_navigator_service_worker",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.pushmanager_subscribe
    ///
    /// Whether a document called called PushManager.subscribe. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static pushmanager_subscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2546,
            "use.counter.doc",
            "pushmanager_subscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.pushsubscription_unsubscribe
    ///
    /// Whether a document called called PushSubscription.unsubscribe. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static pushsubscription_unsubscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2547,
            "use.counter.doc",
            "pushsubscription_unsubscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.range_createcontextualfragment
    ///
    /// Whether a document called called Range.createContextualFragment. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static range_createcontextualfragment: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2548,
            "use.counter.doc",
            "range_createcontextualfragment",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.sanitizer_constructor
    ///
    /// Whether a document called called Sanitizer.constructor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static sanitizer_constructor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2549,
            "use.counter.doc",
            "sanitizer_constructor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.sanitizer_sanitize
    ///
    /// Whether a document called called Sanitizer.sanitize. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static sanitizer_sanitize: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2550,
            "use.counter.doc",
            "sanitizer_sanitize",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.scheduler_posttask
    ///
    /// Whether a document called called Scheduler.postTask. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static scheduler_posttask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2551,
            "use.counter.doc",
            "scheduler_posttask",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.shadowroot_pictureinpictureelement
    ///
    /// Whether a document called called ShadowRoot.pictureInPictureElement. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static shadowroot_pictureinpictureelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2552,
            "use.counter.doc",
            "shadowroot_pictureinpictureelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.svgsvgelement_currentscale_getter
    ///
    /// Whether a document got SVGSVGElement.currentScale. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static svgsvgelement_currentscale_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2553,
            "use.counter.doc",
            "svgsvgelement_currentscale_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.svgsvgelement_currentscale_setter
    ///
    /// Whether a document set SVGSVGElement.currentScale. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static svgsvgelement_currentscale_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2554,
            "use.counter.doc",
            "svgsvgelement_currentscale_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.svgsvgelement_getelementbyid
    ///
    /// Whether a document called called SVGSVGElement.getElementById. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static svgsvgelement_getelementbyid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2555,
            "use.counter.doc",
            "svgsvgelement_getelementbyid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_absoluteorientationsensor
    ///
    /// Whether a document called called Window.AbsoluteOrientationSensor. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_absoluteorientationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2556,
            "use.counter.doc",
            "window_absoluteorientationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_accelerometer
    ///
    /// Whether a document called called Window.Accelerometer. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_accelerometer: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2557,
            "use.counter.doc",
            "window_accelerometer",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_backgroundfetchmanager
    ///
    /// Whether a document called called Window.BackgroundFetchManager. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_backgroundfetchmanager: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2558,
            "use.counter.doc",
            "window_backgroundfetchmanager",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_backgroundfetchrecord
    ///
    /// Whether a document called called Window.BackgroundFetchRecord. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_backgroundfetchrecord: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2559,
            "use.counter.doc",
            "window_backgroundfetchrecord",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_backgroundfetchregistration
    ///
    /// Whether a document called called Window.BackgroundFetchRegistration. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_backgroundfetchregistration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2560,
            "use.counter.doc",
            "window_backgroundfetchregistration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_beforeinstallpromptevent
    ///
    /// Whether a document called called Window.BeforeInstallPromptEvent. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_beforeinstallpromptevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2561,
            "use.counter.doc",
            "window_beforeinstallpromptevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetooth
    ///
    /// Whether a document called called Window.Bluetooth. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_bluetooth: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2562,
            "use.counter.doc",
            "window_bluetooth",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetoothcharacteristicproperties
    ///
    /// Whether a document called called Window.BluetoothCharacteristicProperties.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static window_bluetoothcharacteristicproperties: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2563,
            "use.counter.doc",
            "window_bluetoothcharacteristicproperties",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetoothdevice
    ///
    /// Whether a document called called Window.BluetoothDevice. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothdevice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2564,
            "use.counter.doc",
            "window_bluetoothdevice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetoothremotegattcharacteristic
    ///
    /// Whether a document called called Window.BluetoothRemoteGATTCharacteristic.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static window_bluetoothremotegattcharacteristic: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2565,
            "use.counter.doc",
            "window_bluetoothremotegattcharacteristic",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetoothremotegattdescriptor
    ///
    /// Whether a document called called Window.BluetoothRemoteGATTDescriptor. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothremotegattdescriptor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2566,
            "use.counter.doc",
            "window_bluetoothremotegattdescriptor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetoothremotegattserver
    ///
    /// Whether a document called called Window.BluetoothRemoteGATTServer. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothremotegattserver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2567,
            "use.counter.doc",
            "window_bluetoothremotegattserver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetoothremotegattservice
    ///
    /// Whether a document called called Window.BluetoothRemoteGATTService. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothremotegattservice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2568,
            "use.counter.doc",
            "window_bluetoothremotegattservice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetoothuuid
    ///
    /// Whether a document called called Window.BluetoothUUID. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothuuid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2569,
            "use.counter.doc",
            "window_bluetoothuuid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_canvascapturemediastreamtrack
    ///
    /// Whether a document called called Window.CanvasCaptureMediaStreamTrack. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_canvascapturemediastreamtrack: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2570,
            "use.counter.doc",
            "window_canvascapturemediastreamtrack",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_chrome
    ///
    /// Whether a document called called Window.chrome. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_chrome: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2571,
            "use.counter.doc",
            "window_chrome",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_clipboarditem
    ///
    /// Whether a document called called Window.ClipboardItem. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_clipboarditem: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2572,
            "use.counter.doc",
            "window_clipboarditem",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssimagevalue
    ///
    /// Whether a document called called Window.CSSImageValue. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssimagevalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2573,
            "use.counter.doc",
            "window_cssimagevalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_csskeywordvalue
    ///
    /// Whether a document called called Window.CSSKeywordValue. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_csskeywordvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2574,
            "use.counter.doc",
            "window_csskeywordvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathclamp
    ///
    /// Whether a document called called Window.CSSMathClamp. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathclamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2575,
            "use.counter.doc",
            "window_cssmathclamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathinvert
    ///
    /// Whether a document called called Window.CSSMathInvert. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathinvert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2576,
            "use.counter.doc",
            "window_cssmathinvert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathmax
    ///
    /// Whether a document called called Window.CSSMathMax. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathmax: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2577,
            "use.counter.doc",
            "window_cssmathmax",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathmin
    ///
    /// Whether a document called called Window.CSSMathMin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathmin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2578,
            "use.counter.doc",
            "window_cssmathmin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathnegate
    ///
    /// Whether a document called called Window.CSSMathNegate. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathnegate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2579,
            "use.counter.doc",
            "window_cssmathnegate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathproduct
    ///
    /// Whether a document called called Window.CSSMathProduct. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathproduct: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2580,
            "use.counter.doc",
            "window_cssmathproduct",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathsum
    ///
    /// Whether a document called called Window.CSSMathSum. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathsum: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2581,
            "use.counter.doc",
            "window_cssmathsum",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathvalue
    ///
    /// Whether a document called called Window.CSSMathValue. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2582,
            "use.counter.doc",
            "window_cssmathvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmatrixcomponent
    ///
    /// Whether a document called called Window.CSSMatrixComponent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmatrixcomponent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2583,
            "use.counter.doc",
            "window_cssmatrixcomponent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssnumericarray
    ///
    /// Whether a document called called Window.CSSNumericArray. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssnumericarray: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2584,
            "use.counter.doc",
            "window_cssnumericarray",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssnumericvalue
    ///
    /// Whether a document called called Window.CSSNumericValue. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssnumericvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2585,
            "use.counter.doc",
            "window_cssnumericvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssperspective
    ///
    /// Whether a document called called Window.CSSPerspective. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssperspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2586,
            "use.counter.doc",
            "window_cssperspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_csspositionvalue
    ///
    /// Whether a document called called Window.CSSPositionValue. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_csspositionvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2587,
            "use.counter.doc",
            "window_csspositionvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_csspropertyrule
    ///
    /// Whether a document called called Window.CSSPropertyRule. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_csspropertyrule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2588,
            "use.counter.doc",
            "window_csspropertyrule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssrotate
    ///
    /// Whether a document called called Window.CSSRotate. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssrotate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2589,
            "use.counter.doc",
            "window_cssrotate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssscale
    ///
    /// Whether a document called called Window.CSSScale. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssscale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2590,
            "use.counter.doc",
            "window_cssscale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssskew
    ///
    /// Whether a document called called Window.CSSSkew. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssskew: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2591,
            "use.counter.doc",
            "window_cssskew",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssskewx
    ///
    /// Whether a document called called Window.CSSSkewX. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssskewx: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2592,
            "use.counter.doc",
            "window_cssskewx",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssskewy
    ///
    /// Whether a document called called Window.CSSSkewY. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssskewy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2593,
            "use.counter.doc",
            "window_cssskewy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssstylevalue
    ///
    /// Whether a document called called Window.CSSStyleValue. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssstylevalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2594,
            "use.counter.doc",
            "window_cssstylevalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_csstransformcomponent
    ///
    /// Whether a document called called Window.CSSTransformComponent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_csstransformcomponent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2595,
            "use.counter.doc",
            "window_csstransformcomponent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_csstransformvalue
    ///
    /// Whether a document called called Window.CSSTransformValue. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_csstransformvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2596,
            "use.counter.doc",
            "window_csstransformvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_csstranslate
    ///
    /// Whether a document called called Window.CSSTranslate. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_csstranslate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2597,
            "use.counter.doc",
            "window_csstranslate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssunitvalue
    ///
    /// Whether a document called called Window.CSSUnitValue. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssunitvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2598,
            "use.counter.doc",
            "window_cssunitvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssunparsedvalue
    ///
    /// Whether a document called called Window.CSSUnparsedValue. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssunparsedvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2599,
            "use.counter.doc",
            "window_cssunparsedvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssvariablereferencevalue
    ///
    /// Whether a document called called Window.CSSVariableReferenceValue. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssvariablereferencevalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2600,
            "use.counter.doc",
            "window_cssvariablereferencevalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_defaultstatus
    ///
    /// Whether a document called called Window.defaultStatus. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_defaultstatus: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2601,
            "use.counter.doc",
            "window_defaultstatus",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_devicemotioneventacceleration
    ///
    /// Whether a document called called Window.DeviceMotionEventAcceleration. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_devicemotioneventacceleration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2602,
            "use.counter.doc",
            "window_devicemotioneventacceleration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_devicemotioneventrotationrate
    ///
    /// Whether a document called called Window.DeviceMotionEventRotationRate. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_devicemotioneventrotationrate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2603,
            "use.counter.doc",
            "window_devicemotioneventrotationrate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_domerror
    ///
    /// Whether a document called called Window.DOMError. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_domerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2604,
            "use.counter.doc",
            "window_domerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_encodedvideochunk
    ///
    /// Whether a document called called Window.EncodedVideoChunk. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_encodedvideochunk: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2605,
            "use.counter.doc",
            "window_encodedvideochunk",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_enterpictureinpictureevent
    ///
    /// Whether a document called called Window.EnterPictureInPictureEvent. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_enterpictureinpictureevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2606,
            "use.counter.doc",
            "window_enterpictureinpictureevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_external
    ///
    /// Whether a document called called Window.External. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_external: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2607,
            "use.counter.doc",
            "window_external",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_federatedcredential
    ///
    /// Whether a document called called Window.FederatedCredential. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_federatedcredential: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2608,
            "use.counter.doc",
            "window_federatedcredential",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_gyroscope
    ///
    /// Whether a document called called Window.Gyroscope. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_gyroscope: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2609,
            "use.counter.doc",
            "window_gyroscope",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_htmlcontentelement
    ///
    /// Whether a document called called Window.HTMLContentElement. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_htmlcontentelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2610,
            "use.counter.doc",
            "window_htmlcontentelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_htmlshadowelement
    ///
    /// Whether a document called called Window.HTMLShadowElement. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_htmlshadowelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2611,
            "use.counter.doc",
            "window_htmlshadowelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_imagecapture
    ///
    /// Whether a document called called Window.ImageCapture. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_imagecapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2612,
            "use.counter.doc",
            "window_imagecapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_inputdevicecapabilities
    ///
    /// Whether a document called called Window.InputDeviceCapabilities. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_inputdevicecapabilities: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2613,
            "use.counter.doc",
            "window_inputdevicecapabilities",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_inputdeviceinfo
    ///
    /// Whether a document called called Window.InputDeviceInfo. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_inputdeviceinfo: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2614,
            "use.counter.doc",
            "window_inputdeviceinfo",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_keyboard
    ///
    /// Whether a document called called Window.Keyboard. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_keyboard: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2615,
            "use.counter.doc",
            "window_keyboard",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_keyboardlayoutmap
    ///
    /// Whether a document called called Window.KeyboardLayoutMap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_keyboardlayoutmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2616,
            "use.counter.doc",
            "window_keyboardlayoutmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_linearaccelerationsensor
    ///
    /// Whether a document called called Window.LinearAccelerationSensor. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_linearaccelerationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2617,
            "use.counter.doc",
            "window_linearaccelerationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_mediasettingsrange
    ///
    /// Whether a document called called Window.MediaSettingsRange. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_mediasettingsrange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2618,
            "use.counter.doc",
            "window_mediasettingsrange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midiaccess
    ///
    /// Whether a document called called Window.MIDIAccess. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midiaccess: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2619,
            "use.counter.doc",
            "window_midiaccess",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midiconnectionevent
    ///
    /// Whether a document called called Window.MIDIConnectionEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midiconnectionevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2620,
            "use.counter.doc",
            "window_midiconnectionevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midiinput
    ///
    /// Whether a document called called Window.MIDIInput. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midiinput: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2621,
            "use.counter.doc",
            "window_midiinput",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midiinputmap
    ///
    /// Whether a document called called Window.MIDIInputMap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midiinputmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2622,
            "use.counter.doc",
            "window_midiinputmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midimessageevent
    ///
    /// Whether a document called called Window.MIDIMessageEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midimessageevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2623,
            "use.counter.doc",
            "window_midimessageevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midioutput
    ///
    /// Whether a document called called Window.MIDIOutput. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midioutput: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2624,
            "use.counter.doc",
            "window_midioutput",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midioutputmap
    ///
    /// Whether a document called called Window.MIDIOutputMap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midioutputmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2625,
            "use.counter.doc",
            "window_midioutputmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midiport
    ///
    /// Whether a document called called Window.MIDIPort. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midiport: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2626,
            "use.counter.doc",
            "window_midiport",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_networkinformation
    ///
    /// Whether a document called called Window.NetworkInformation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_networkinformation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2627,
            "use.counter.doc",
            "window_networkinformation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_offscreenbuffering
    ///
    /// Whether a document called called Window.offscreenBuffering. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_offscreenbuffering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2628,
            "use.counter.doc",
            "window_offscreenbuffering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_onbeforeinstallprompt
    ///
    /// Whether a document called called Window.onbeforeinstallprompt. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_onbeforeinstallprompt: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2629,
            "use.counter.doc",
            "window_onbeforeinstallprompt",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_oncancel
    ///
    /// Whether a document called called Window.oncancel. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_oncancel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2630,
            "use.counter.doc",
            "window_oncancel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_onmousewheel
    ///
    /// Whether a document called called Window.onmousewheel. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_onmousewheel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2631,
            "use.counter.doc",
            "window_onmousewheel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_onorientationchange
    ///
    /// Whether a document called called Window.onorientationchange. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_onorientationchange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2632,
            "use.counter.doc",
            "window_onorientationchange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_onsearch
    ///
    /// Whether a document called called Window.onsearch. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_onsearch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2633,
            "use.counter.doc",
            "window_onsearch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_onselectionchange
    ///
    /// Whether a document called called Window.onselectionchange. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_onselectionchange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2634,
            "use.counter.doc",
            "window_onselectionchange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_open_empty_url
    ///
    /// Whether a document calls window.open with an empty url argument. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_open_empty_url: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2635,
            "use.counter.doc",
            "window_open_empty_url",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_opendatabase
    ///
    /// Whether a document called called Window.openDatabase. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_opendatabase: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2636,
            "use.counter.doc",
            "window_opendatabase",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_orientation
    ///
    /// Whether a document called called Window.orientation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2637,
            "use.counter.doc",
            "window_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_orientationsensor
    ///
    /// Whether a document called called Window.OrientationSensor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_orientationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2638,
            "use.counter.doc",
            "window_orientationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_overconstrainederror
    ///
    /// Whether a document called called Window.OverconstrainedError. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_overconstrainederror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2639,
            "use.counter.doc",
            "window_overconstrainederror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_passwordcredential
    ///
    /// Whether a document called called Window.PasswordCredential. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_passwordcredential: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2640,
            "use.counter.doc",
            "window_passwordcredential",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_paymentaddress
    ///
    /// Whether a document called called Window.PaymentAddress. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_paymentaddress: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2641,
            "use.counter.doc",
            "window_paymentaddress",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_paymentinstruments
    ///
    /// Whether a document called called Window.PaymentInstruments. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_paymentinstruments: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2642,
            "use.counter.doc",
            "window_paymentinstruments",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_paymentmanager
    ///
    /// Whether a document called called Window.PaymentManager. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_paymentmanager: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2643,
            "use.counter.doc",
            "window_paymentmanager",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_paymentmethodchangeevent
    ///
    /// Whether a document called called Window.PaymentMethodChangeEvent. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_paymentmethodchangeevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2644,
            "use.counter.doc",
            "window_paymentmethodchangeevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_paymentrequest
    ///
    /// Whether a document called called Window.PaymentRequest. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_paymentrequest: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2645,
            "use.counter.doc",
            "window_paymentrequest",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_paymentrequestupdateevent
    ///
    /// Whether a document called called Window.PaymentRequestUpdateEvent. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_paymentrequestupdateevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2646,
            "use.counter.doc",
            "window_paymentrequestupdateevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_paymentresponse
    ///
    /// Whether a document called called Window.PaymentResponse. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_paymentresponse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2647,
            "use.counter.doc",
            "window_paymentresponse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_performancelongtasktiming
    ///
    /// Whether a document called called Window.PerformanceLongTaskTiming. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_performancelongtasktiming: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2648,
            "use.counter.doc",
            "window_performancelongtasktiming",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_photocapabilities
    ///
    /// Whether a document called called Window.PhotoCapabilities. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_photocapabilities: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2649,
            "use.counter.doc",
            "window_photocapabilities",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_pictureinpictureevent
    ///
    /// Whether a document called called Window.PictureInPictureEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_pictureinpictureevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2650,
            "use.counter.doc",
            "window_pictureinpictureevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_pictureinpicturewindow
    ///
    /// Whether a document called called Window.PictureInPictureWindow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_pictureinpicturewindow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2651,
            "use.counter.doc",
            "window_pictureinpicturewindow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentation
    ///
    /// Whether a document called called Window.Presentation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_presentation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2652,
            "use.counter.doc",
            "window_presentation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentationavailability
    ///
    /// Whether a document called called Window.PresentationAvailability. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_presentationavailability: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2653,
            "use.counter.doc",
            "window_presentationavailability",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentationconnection
    ///
    /// Whether a document called called Window.PresentationConnection. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_presentationconnection: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2654,
            "use.counter.doc",
            "window_presentationconnection",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentationconnectionavailableevent
    ///
    /// Whether a document called called Window.PresentationConnectionAvailableEvent.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static window_presentationconnectionavailableevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2655,
            "use.counter.doc",
            "window_presentationconnectionavailableevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentationconnectioncloseevent
    ///
    /// Whether a document called called Window.PresentationConnectionCloseEvent.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static window_presentationconnectioncloseevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2656,
            "use.counter.doc",
            "window_presentationconnectioncloseevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentationconnectionlist
    ///
    /// Whether a document called called Window.PresentationConnectionList. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_presentationconnectionlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2657,
            "use.counter.doc",
            "window_presentationconnectionlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentationreceiver
    ///
    /// Whether a document called called Window.PresentationReceiver. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_presentationreceiver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2658,
            "use.counter.doc",
            "window_presentationreceiver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentationrequest
    ///
    /// Whether a document called called Window.PresentationRequest. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_presentationrequest: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2659,
            "use.counter.doc",
            "window_presentationrequest",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_relativeorientationsensor
    ///
    /// Whether a document called called Window.RelativeOrientationSensor. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_relativeorientationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2660,
            "use.counter.doc",
            "window_relativeorientationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_remoteplayback
    ///
    /// Whether a document called called Window.RemotePlayback. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_remoteplayback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2661,
            "use.counter.doc",
            "window_remoteplayback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_report
    ///
    /// Whether a document called called Window.Report. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_report: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2662,
            "use.counter.doc",
            "window_report",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_reportbody
    ///
    /// Whether a document called called Window.ReportBody. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_reportbody: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2663,
            "use.counter.doc",
            "window_reportbody",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_reportingobserver
    ///
    /// Whether a document called called Window.ReportingObserver. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_reportingobserver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2664,
            "use.counter.doc",
            "window_reportingobserver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_rtcerror
    ///
    /// Whether a document called called Window.RTCError. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_rtcerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2665,
            "use.counter.doc",
            "window_rtcerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_rtcerrorevent
    ///
    /// Whether a document called called Window.RTCErrorEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_rtcerrorevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2666,
            "use.counter.doc",
            "window_rtcerrorevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_rtcicetransport
    ///
    /// Whether a document called called Window.RTCIceTransport. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_rtcicetransport: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2667,
            "use.counter.doc",
            "window_rtcicetransport",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_rtcpeerconnectioniceerrorevent
    ///
    /// Whether a document called called Window.RTCPeerConnectionIceErrorEvent. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_rtcpeerconnectioniceerrorevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2668,
            "use.counter.doc",
            "window_rtcpeerconnectioniceerrorevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_sensor
    ///
    /// Whether a document called called Window.Sensor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_sensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2669,
            "use.counter.doc",
            "window_sensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_sensorerrorevent
    ///
    /// Whether a document called called Window.SensorErrorEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_sensorerrorevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2670,
            "use.counter.doc",
            "window_sensorerrorevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_sidebar_getter
    ///
    /// Whether a document got Window.sidebar. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_sidebar_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2671,
            "use.counter.doc",
            "window_sidebar_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_sidebar_setter
    ///
    /// Whether a document set Window.sidebar. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_sidebar_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2672,
            "use.counter.doc",
            "window_sidebar_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_speechrecognitionalternative
    ///
    /// Whether a document called called Window.SpeechRecognitionAlternative. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_speechrecognitionalternative: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2673,
            "use.counter.doc",
            "window_speechrecognitionalternative",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_speechrecognitionresult
    ///
    /// Whether a document called called Window.SpeechRecognitionResult. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_speechrecognitionresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2674,
            "use.counter.doc",
            "window_speechrecognitionresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_speechrecognitionresultlist
    ///
    /// Whether a document called called Window.SpeechRecognitionResultList. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_speechrecognitionresultlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2675,
            "use.counter.doc",
            "window_speechrecognitionresultlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_stylemedia
    ///
    /// Whether a document called called Window.styleMedia. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_stylemedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2676,
            "use.counter.doc",
            "window_stylemedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_stylepropertymap
    ///
    /// Whether a document called called Window.StylePropertyMap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_stylepropertymap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2677,
            "use.counter.doc",
            "window_stylepropertymap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_stylepropertymapreadonly
    ///
    /// Whether a document called called Window.StylePropertyMapReadOnly. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_stylepropertymapreadonly: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2678,
            "use.counter.doc",
            "window_stylepropertymapreadonly",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_svgdiscardelement
    ///
    /// Whether a document called called Window.SVGDiscardElement. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_svgdiscardelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2679,
            "use.counter.doc",
            "window_svgdiscardelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_syncmanager
    ///
    /// Whether a document called called Window.SyncManager. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_syncmanager: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2680,
            "use.counter.doc",
            "window_syncmanager",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_taskattributiontiming
    ///
    /// Whether a document called called Window.TaskAttributionTiming. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_taskattributiontiming: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2681,
            "use.counter.doc",
            "window_taskattributiontiming",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_textevent
    ///
    /// Whether a document called called Window.TextEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_textevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2682,
            "use.counter.doc",
            "window_textevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_touch
    ///
    /// Whether a document called called Window.Touch. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_touch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2683,
            "use.counter.doc",
            "window_touch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_touchevent
    ///
    /// Whether a document called called Window.TouchEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_touchevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2684,
            "use.counter.doc",
            "window_touchevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_touchlist
    ///
    /// Whether a document called called Window.TouchList. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_touchlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2685,
            "use.counter.doc",
            "window_touchlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usb
    ///
    /// Whether a document called called Window.USB. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usb: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2686,
            "use.counter.doc",
            "window_usb",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbalternateinterface
    ///
    /// Whether a document called called Window.USBAlternateInterface. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbalternateinterface: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2687,
            "use.counter.doc",
            "window_usbalternateinterface",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbconfiguration
    ///
    /// Whether a document called called Window.USBConfiguration. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbconfiguration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2688,
            "use.counter.doc",
            "window_usbconfiguration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbconnectionevent
    ///
    /// Whether a document called called Window.USBConnectionEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbconnectionevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2689,
            "use.counter.doc",
            "window_usbconnectionevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbdevice
    ///
    /// Whether a document called called Window.USBDevice. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbdevice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2690,
            "use.counter.doc",
            "window_usbdevice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbendpoint
    ///
    /// Whether a document called called Window.USBEndpoint. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbendpoint: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2691,
            "use.counter.doc",
            "window_usbendpoint",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbinterface
    ///
    /// Whether a document called called Window.USBInterface. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbinterface: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2692,
            "use.counter.doc",
            "window_usbinterface",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbintransferresult
    ///
    /// Whether a document called called Window.USBInTransferResult. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbintransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2693,
            "use.counter.doc",
            "window_usbintransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbisochronousintransferpacket
    ///
    /// Whether a document called called Window.USBIsochronousInTransferPacket. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbisochronousintransferpacket: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2694,
            "use.counter.doc",
            "window_usbisochronousintransferpacket",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbisochronousintransferresult
    ///
    /// Whether a document called called Window.USBIsochronousInTransferResult. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbisochronousintransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2695,
            "use.counter.doc",
            "window_usbisochronousintransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbisochronousouttransferpacket
    ///
    /// Whether a document called called Window.USBIsochronousOutTransferPacket.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static window_usbisochronousouttransferpacket: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2696,
            "use.counter.doc",
            "window_usbisochronousouttransferpacket",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbisochronousouttransferresult
    ///
    /// Whether a document called called Window.USBIsochronousOutTransferResult.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static window_usbisochronousouttransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2697,
            "use.counter.doc",
            "window_usbisochronousouttransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbouttransferresult
    ///
    /// Whether a document called called Window.USBOutTransferResult. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbouttransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2698,
            "use.counter.doc",
            "window_usbouttransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_useractivation
    ///
    /// Whether a document called called Window.UserActivation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_useractivation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2699,
            "use.counter.doc",
            "window_useractivation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_videocolorspace
    ///
    /// Whether a document called called Window.VideoColorSpace. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_videocolorspace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2700,
            "use.counter.doc",
            "window_videocolorspace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_videodecoder
    ///
    /// Whether a document called called Window.VideoDecoder. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_videodecoder: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2701,
            "use.counter.doc",
            "window_videodecoder",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_videoencoder
    ///
    /// Whether a document called called Window.VideoEncoder. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_videoencoder: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2702,
            "use.counter.doc",
            "window_videoencoder",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_videoframe
    ///
    /// Whether a document called called Window.VideoFrame. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_videoframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2703,
            "use.counter.doc",
            "window_videoframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_wakelock
    ///
    /// Whether a document called called Window.WakeLock. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_wakelock: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2704,
            "use.counter.doc",
            "window_wakelock",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_wakelocksentinel
    ///
    /// Whether a document called called Window.WakeLockSentinel. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_wakelocksentinel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2705,
            "use.counter.doc",
            "window_wakelocksentinel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitcancelanimationframe
    ///
    /// Whether a document called called Window.webkitCancelAnimationFrame. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitcancelanimationframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2706,
            "use.counter.doc",
            "window_webkitcancelanimationframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitmediastream
    ///
    /// Whether a document called called Window.webkitMediaStream. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitmediastream: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2707,
            "use.counter.doc",
            "window_webkitmediastream",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitmutationobserver
    ///
    /// Whether a document called called Window.WebKitMutationObserver. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitmutationobserver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2708,
            "use.counter.doc",
            "window_webkitmutationobserver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitrequestanimationframe
    ///
    /// Whether a document called called Window.webkitRequestAnimationFrame. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitrequestanimationframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2709,
            "use.counter.doc",
            "window_webkitrequestanimationframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitrequestfilesystem
    ///
    /// Whether a document called called Window.webkitRequestFileSystem. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitrequestfilesystem: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2710,
            "use.counter.doc",
            "window_webkitrequestfilesystem",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitresolvelocalfilesystemurl
    ///
    /// Whether a document called called Window.webkitResolveLocalFileSystemURL.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static window_webkitresolvelocalfilesystemurl: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2711,
            "use.counter.doc",
            "window_webkitresolvelocalfilesystemurl",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitrtcpeerconnection
    ///
    /// Whether a document called called Window.webkitRTCPeerConnection. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitrtcpeerconnection: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2712,
            "use.counter.doc",
            "window_webkitrtcpeerconnection",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitspeechgrammar
    ///
    /// Whether a document called called Window.webkitSpeechGrammar. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechgrammar: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2713,
            "use.counter.doc",
            "window_webkitspeechgrammar",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitspeechgrammarlist
    ///
    /// Whether a document called called Window.webkitSpeechGrammarList. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechgrammarlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2714,
            "use.counter.doc",
            "window_webkitspeechgrammarlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitspeechrecognition
    ///
    /// Whether a document called called Window.webkitSpeechRecognition. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechrecognition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2715,
            "use.counter.doc",
            "window_webkitspeechrecognition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitspeechrecognitionerror
    ///
    /// Whether a document called called Window.webkitSpeechRecognitionError. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechrecognitionerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2716,
            "use.counter.doc",
            "window_webkitspeechrecognitionerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitspeechrecognitionevent
    ///
    /// Whether a document called called Window.webkitSpeechRecognitionEvent. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechrecognitionevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2717,
            "use.counter.doc",
            "window_webkitspeechrecognitionevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitstorageinfo
    ///
    /// Whether a document called called Window.webkitStorageInfo. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitstorageinfo: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2718,
            "use.counter.doc",
            "window_webkitstorageinfo",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.workernavigator_permissions
    ///
    /// Whether a document called called WorkerNavigator.permissions. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static workernavigator_permissions: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2719,
            "use.counter.doc",
            "workernavigator_permissions",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.wr_filter_fallback
    ///
    /// Whether a document triggers the blob fallback for an SVG filter.. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static wr_filter_fallback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2720,
            "use.counter.doc",
            "wr_filter_fallback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.xslstylesheet
    ///
    /// Whether a document uses an XSL Stylesheet. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static xslstylesheet: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2721,
            "use.counter.doc",
            "xslstylesheet",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.xsltprocessor_constructor
    ///
    /// Whether a document called called XSLTProcessor.constructor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static xsltprocessor_constructor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2722,
            "use.counter.doc",
            "xsltprocessor_constructor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.you_tube_flash_embed
    ///
    /// Whether a document in <object> or <embed>. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static you_tube_flash_embed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2723,
            "use.counter.doc",
            "you_tube_flash_embed",
            "use-counters"
        )
    });

}
pub mod use_counter_page {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.clipboard_read
    ///
    /// Whether a page called called Clipboard.read. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static clipboard_read: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2724,
            "use.counter.page",
            "clipboard_read",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.clipboard_readtext
    ///
    /// Whether a page called called Clipboard.readText. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static clipboard_readtext: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2725,
            "use.counter.page",
            "clipboard_readtext",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.clipboard_write
    ///
    /// Whether a page called called Clipboard.write. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static clipboard_write: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2726,
            "use.counter.page",
            "clipboard_write",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_assert
    ///
    /// Whether a page called called console.assert. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_assert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2727,
            "use.counter.page",
            "console_assert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_clear
    ///
    /// Whether a page called called console.clear. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_clear: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2728,
            "use.counter.page",
            "console_clear",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_count
    ///
    /// Whether a page called called console.count. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2729,
            "use.counter.page",
            "console_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_countreset
    ///
    /// Whether a page called called console.countReset. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_countreset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2730,
            "use.counter.page",
            "console_countreset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_debug
    ///
    /// Whether a page called called console.debug. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_debug: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2731,
            "use.counter.page",
            "console_debug",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_dir
    ///
    /// Whether a page called called console.dir. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_dir: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2732,
            "use.counter.page",
            "console_dir",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_dirxml
    ///
    /// Whether a page called called console.dirxml. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_dirxml: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2733,
            "use.counter.page",
            "console_dirxml",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_error
    ///
    /// Whether a page called called console.error. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_error: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2734,
            "use.counter.page",
            "console_error",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_exception
    ///
    /// Whether a page called called console.exception. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_exception: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2735,
            "use.counter.page",
            "console_exception",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_group
    ///
    /// Whether a page called called console.group. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2736,
            "use.counter.page",
            "console_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_groupcollapsed
    ///
    /// Whether a page called called console.groupCollapsed. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_groupcollapsed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2737,
            "use.counter.page",
            "console_groupcollapsed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_groupend
    ///
    /// Whether a page called called console.groupEnd. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_groupend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2738,
            "use.counter.page",
            "console_groupend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_info
    ///
    /// Whether a page called called console.info. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_info: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2739,
            "use.counter.page",
            "console_info",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_log
    ///
    /// Whether a page called called console.log. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_log: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2740,
            "use.counter.page",
            "console_log",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_profile
    ///
    /// Whether a page called called console.profile. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_profile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2741,
            "use.counter.page",
            "console_profile",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_profileend
    ///
    /// Whether a page called called console.profileEnd. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_profileend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2742,
            "use.counter.page",
            "console_profileend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_table
    ///
    /// Whether a page called called console.table. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_table: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2743,
            "use.counter.page",
            "console_table",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_time
    ///
    /// Whether a page called called console.time. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_time: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2744,
            "use.counter.page",
            "console_time",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_timeend
    ///
    /// Whether a page called called console.timeEnd. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_timeend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2745,
            "use.counter.page",
            "console_timeend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_timelog
    ///
    /// Whether a page called called console.timeLog. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_timelog: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2746,
            "use.counter.page",
            "console_timelog",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_timestamp
    ///
    /// Whether a page called called console.timeStamp. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_timestamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2747,
            "use.counter.page",
            "console_timestamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_trace
    ///
    /// Whether a page called called console.trace. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_trace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2748,
            "use.counter.page",
            "console_trace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_warn
    ///
    /// Whether a page called called console.warn. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_warn: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2749,
            "use.counter.page",
            "console_warn",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.customelementregistry_define
    ///
    /// Whether a page called called CustomElementRegistry.define. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static customelementregistry_define: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2750,
            "use.counter.page",
            "customelementregistry_define",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.customized_builtin
    ///
    /// Whether a page registers a customized built-in element. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static customized_builtin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2751,
            "use.counter.page",
            "customized_builtin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_addelement
    ///
    /// Whether a page called called DataTransfer.addElement. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_addelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2752,
            "use.counter.page",
            "datatransfer_addelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozcleardataat
    ///
    /// Whether a page called called DataTransfer.mozClearDataAt. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozcleardataat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2753,
            "use.counter.page",
            "datatransfer_mozcleardataat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozcursor_getter
    ///
    /// Whether a page got DataTransfer.mozCursor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozcursor_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2754,
            "use.counter.page",
            "datatransfer_mozcursor_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozcursor_setter
    ///
    /// Whether a page set DataTransfer.mozCursor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozcursor_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2755,
            "use.counter.page",
            "datatransfer_mozcursor_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozgetdataat
    ///
    /// Whether a page called called DataTransfer.mozGetDataAt. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozgetdataat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2756,
            "use.counter.page",
            "datatransfer_mozgetdataat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozitemcount_getter
    ///
    /// Whether a page got DataTransfer.mozItemCount. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozitemcount_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2757,
            "use.counter.page",
            "datatransfer_mozitemcount_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozitemcount_setter
    ///
    /// Whether a page set DataTransfer.mozItemCount. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozitemcount_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2758,
            "use.counter.page",
            "datatransfer_mozitemcount_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozsetdataat
    ///
    /// Whether a page called called DataTransfer.mozSetDataAt. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozsetdataat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2759,
            "use.counter.page",
            "datatransfer_mozsetdataat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozsourcenode_getter
    ///
    /// Whether a page got DataTransfer.mozSourceNode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozsourcenode_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2760,
            "use.counter.page",
            "datatransfer_mozsourcenode_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozsourcenode_setter
    ///
    /// Whether a page set DataTransfer.mozSourceNode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozsourcenode_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2761,
            "use.counter.page",
            "datatransfer_mozsourcenode_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_moztypesat
    ///
    /// Whether a page called called DataTransfer.mozTypesAt. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_moztypesat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2762,
            "use.counter.page",
            "datatransfer_moztypesat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozusercancelled_getter
    ///
    /// Whether a page got DataTransfer.mozUserCancelled. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozusercancelled_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2763,
            "use.counter.page",
            "datatransfer_mozusercancelled_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozusercancelled_setter
    ///
    /// Whether a page set DataTransfer.mozUserCancelled. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozusercancelled_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2764,
            "use.counter.page",
            "datatransfer_mozusercancelled_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransferitem_webkitgetasentry
    ///
    /// Whether a page called called DataTransferItem.webkitGetAsEntry. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransferitem_webkitgetasentry: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2765,
            "use.counter.page",
            "datatransferitem_webkitgetasentry",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_caretrangefrompoint
    ///
    /// Whether a page called called Document.caretRangeFromPoint. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_caretrangefrompoint: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2766,
            "use.counter.page",
            "document_caretrangefrompoint",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_exec_command_content_read_only
    ///
    /// Whether a page calls execCommand with contentReadOnly. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_exec_command_content_read_only: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2767,
            "use.counter.page",
            "document_exec_command_content_read_only",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_exitpictureinpicture
    ///
    /// Whether a page called called Document.exitPictureInPicture. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_exitpictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2768,
            "use.counter.page",
            "document_exitpictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_featurepolicy
    ///
    /// Whether a page called called Document.featurePolicy. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_featurepolicy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2769,
            "use.counter.page",
            "document_featurepolicy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_mozsetimageelement
    ///
    /// Whether a page called called Document.mozSetImageElement. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_mozsetimageelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2770,
            "use.counter.page",
            "document_mozsetimageelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_onbeforecopy
    ///
    /// Whether a page called called Document.onbeforecopy. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_onbeforecopy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2771,
            "use.counter.page",
            "document_onbeforecopy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_onbeforecut
    ///
    /// Whether a page called called Document.onbeforecut. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_onbeforecut: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2772,
            "use.counter.page",
            "document_onbeforecut",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_onbeforepaste
    ///
    /// Whether a page called called Document.onbeforepaste. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_onbeforepaste: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2773,
            "use.counter.page",
            "document_onbeforepaste",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_oncancel
    ///
    /// Whether a page called called Document.oncancel. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_oncancel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2774,
            "use.counter.page",
            "document_oncancel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_onfreeze
    ///
    /// Whether a page called called Document.onfreeze. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_onfreeze: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2775,
            "use.counter.page",
            "document_onfreeze",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_onmousewheel
    ///
    /// Whether a page called called Document.onmousewheel. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_onmousewheel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2776,
            "use.counter.page",
            "document_onmousewheel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_onresume
    ///
    /// Whether a page called called Document.onresume. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_onresume: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2777,
            "use.counter.page",
            "document_onresume",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_onsearch
    ///
    /// Whether a page called called Document.onsearch. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_onsearch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2778,
            "use.counter.page",
            "document_onsearch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_onwebkitfullscreenchange
    ///
    /// Whether a page called called Document.onwebkitfullscreenchange. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_onwebkitfullscreenchange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2779,
            "use.counter.page",
            "document_onwebkitfullscreenchange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_onwebkitfullscreenerror
    ///
    /// Whether a page called called Document.onwebkitfullscreenerror. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_onwebkitfullscreenerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2780,
            "use.counter.page",
            "document_onwebkitfullscreenerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_open
    ///
    /// Whether a page calls document.open in a way that creates a new Window object.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static document_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2781,
            "use.counter.page",
            "document_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_pictureinpictureelement
    ///
    /// Whether a page called called Document.pictureInPictureElement. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_pictureinpictureelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2782,
            "use.counter.page",
            "document_pictureinpictureelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_pictureinpictureenabled
    ///
    /// Whether a page called called Document.pictureInPictureEnabled. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_pictureinpictureenabled: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2783,
            "use.counter.page",
            "document_pictureinpictureenabled",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_query_command_state_or_value_content_read_only
    ///
    /// Whether a page calls queryCommandState or queryCommandValue with
    /// contentReadOnly. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_query_command_state_or_value_content_read_only: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2784,
            "use.counter.page",
            "document_query_command_state_or_value_content_read_only",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_query_command_state_or_value_insert_br_on_return
    ///
    /// Whether a page calls queryCommandState or queryCommandValue with
    /// insertBrOnReturn. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_query_command_state_or_value_insert_br_on_return: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2785,
            "use.counter.page",
            "document_query_command_state_or_value_insert_br_on_return",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_query_command_supported_or_enabled_content_read_only
    ///
    /// Whether a page calls queryCommandSupported or queryCommandEnabled with
    /// contentReadOnly. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_query_command_supported_or_enabled_content_read_only: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2786,
            "use.counter.page",
            "document_query_command_supported_or_enabled_content_read_only",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_query_command_supported_or_enabled_insert_br_on_return
    ///
    /// Whether a page calls queryCommandSupported or queryCommandEnabled with
    /// insertBrOnReturn. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_query_command_supported_or_enabled_insert_br_on_return: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2787,
            "use.counter.page",
            "document_query_command_supported_or_enabled_insert_br_on_return",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_registerelement
    ///
    /// Whether a page called called Document.registerElement. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_registerelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2788,
            "use.counter.page",
            "document_registerelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_wasdiscarded
    ///
    /// Whether a page called called Document.wasDiscarded. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_wasdiscarded: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2789,
            "use.counter.page",
            "document_wasdiscarded",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_webkitcancelfullscreen
    ///
    /// Whether a page called called Document.webkitCancelFullScreen. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_webkitcancelfullscreen: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2790,
            "use.counter.page",
            "document_webkitcancelfullscreen",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_webkitcurrentfullscreenelement
    ///
    /// Whether a page called called Document.webkitCurrentFullScreenElement. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static document_webkitcurrentfullscreenelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2791,
            "use.counter.page",
            "document_webkitcurrentfullscreenelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_webkitexitfullscreen
    ///
    /// Whether a page called called Document.webkitExitFullscreen. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_webkitexitfullscreen: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2792,
            "use.counter.page",
            "document_webkitexitfullscreen",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_webkitfullscreenelement
    ///
    /// Whether a page called called Document.webkitFullscreenElement. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_webkitfullscreenelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2793,
            "use.counter.page",
            "document_webkitfullscreenelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_webkitfullscreenenabled
    ///
    /// Whether a page called called Document.webkitFullscreenEnabled. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_webkitfullscreenenabled: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2794,
            "use.counter.page",
            "document_webkitfullscreenenabled",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_webkithidden
    ///
    /// Whether a page called called Document.webkitHidden. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_webkithidden: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2795,
            "use.counter.page",
            "document_webkithidden",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_webkitisfullscreen
    ///
    /// Whether a page called called Document.webkitIsFullScreen. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_webkitisfullscreen: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2796,
            "use.counter.page",
            "document_webkitisfullscreen",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_webkitvisibilitystate
    ///
    /// Whether a page called called Document.webkitVisibilityState. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_webkitvisibilitystate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2797,
            "use.counter.page",
            "document_webkitvisibilitystate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_xmlencoding
    ///
    /// Whether a page called called Document.xmlEncoding. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_xmlencoding: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2798,
            "use.counter.page",
            "document_xmlencoding",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_xmlstandalone
    ///
    /// Whether a page called called Document.xmlStandalone. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_xmlstandalone: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2799,
            "use.counter.page",
            "document_xmlstandalone",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_xmlversion
    ///
    /// Whether a page called called Document.xmlVersion. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_xmlversion: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2800,
            "use.counter.page",
            "document_xmlversion",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.domparser_parsefromstring
    ///
    /// Whether a page called called DOMParser.parseFromString. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domparser_parsefromstring: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2801,
            "use.counter.page",
            "domparser_parsefromstring",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_attachshadow
    ///
    /// Whether a page called called Element.attachShadow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_attachshadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2802,
            "use.counter.page",
            "element_attachshadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_computedstylemap
    ///
    /// Whether a page called called Element.computedStyleMap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_computedstylemap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2803,
            "use.counter.page",
            "element_computedstylemap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_onmousewheel
    ///
    /// Whether a page called called Element.onmousewheel. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_onmousewheel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2804,
            "use.counter.page",
            "element_onmousewheel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_releasecapture
    ///
    /// Whether a page called called Element.releaseCapture. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_releasecapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2805,
            "use.counter.page",
            "element_releasecapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_releasepointercapture
    ///
    /// Whether a page called called Element.releasePointerCapture. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_releasepointercapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2806,
            "use.counter.page",
            "element_releasepointercapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_scrollintoviewifneeded
    ///
    /// Whether a page called called Element.scrollIntoViewIfNeeded. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_scrollintoviewifneeded: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2807,
            "use.counter.page",
            "element_scrollintoviewifneeded",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_setcapture
    ///
    /// Whether a page called called Element.setCapture. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_setcapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2808,
            "use.counter.page",
            "element_setcapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_sethtml
    ///
    /// Whether a page called called Element.setHTML. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_sethtml: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2809,
            "use.counter.page",
            "element_sethtml",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_setpointercapture
    ///
    /// Whether a page called called Element.setPointerCapture. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_setpointercapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2810,
            "use.counter.page",
            "element_setpointercapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.enumerate_devices_insec
    ///
    /// Whether a page calls MediaDevices.enumerateDevices from an insecure context.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static enumerate_devices_insec: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2811,
            "use.counter.page",
            "enumerate_devices_insec",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.enumerate_devices_unfocused
    ///
    /// Whether a page calls MediaDevices.enumerateDevices from a unfocused document.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static enumerate_devices_unfocused: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2812,
            "use.counter.page",
            "enumerate_devices_unfocused",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_blend
    ///
    /// Whether a page uses the feBlend SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_blend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2813,
            "use.counter.page",
            "fe_blend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_color_matrix
    ///
    /// Whether a page uses the feColorMatrix SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_color_matrix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2814,
            "use.counter.page",
            "fe_color_matrix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_component_transfer
    ///
    /// Whether a page uses the feComponentTransfer SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_component_transfer: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2815,
            "use.counter.page",
            "fe_component_transfer",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_composite
    ///
    /// Whether a page uses the feComposite SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_composite: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2816,
            "use.counter.page",
            "fe_composite",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_convolve_matrix
    ///
    /// Whether a page uses the feConvolveMatrix SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_convolve_matrix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2817,
            "use.counter.page",
            "fe_convolve_matrix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_diffuse_lighting
    ///
    /// Whether a page uses the feDiffuseLighting SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_diffuse_lighting: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2818,
            "use.counter.page",
            "fe_diffuse_lighting",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_displacement_map
    ///
    /// Whether a page uses the feDisplacementMap SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_displacement_map: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2819,
            "use.counter.page",
            "fe_displacement_map",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_flood
    ///
    /// Whether a page uses the feFlood SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_flood: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2820,
            "use.counter.page",
            "fe_flood",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_gaussian_blur
    ///
    /// Whether a page uses the feGaussianBlur SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_gaussian_blur: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2821,
            "use.counter.page",
            "fe_gaussian_blur",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_image
    ///
    /// Whether a page uses the feImage SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2822,
            "use.counter.page",
            "fe_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_merge
    ///
    /// Whether a page uses the feMerge SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_merge: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2823,
            "use.counter.page",
            "fe_merge",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_morphology
    ///
    /// Whether a page uses the feMorphology SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_morphology: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2824,
            "use.counter.page",
            "fe_morphology",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_offset
    ///
    /// Whether a page uses the feOffset SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2825,
            "use.counter.page",
            "fe_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_specular_lighting
    ///
    /// Whether a page uses the feSpecularLighting SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_specular_lighting: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2826,
            "use.counter.page",
            "fe_specular_lighting",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_tile
    ///
    /// Whether a page uses the feTile SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_tile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2827,
            "use.counter.page",
            "fe_tile",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_turbulence
    ///
    /// Whether a page uses the feTurbulence SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_turbulence: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2828,
            "use.counter.page",
            "fe_turbulence",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.filtered_cross_origin_iframe
    ///
    /// Whether a page cross-origin <iframe> within a CSS/SVG filter. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static filtered_cross_origin_iframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2829,
            "use.counter.page",
            "filtered_cross_origin_iframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.get_user_media_insec
    ///
    /// Whether a page calls MediaDevices.getUserMedia from an insecure context.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static get_user_media_insec: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2830,
            "use.counter.page",
            "get_user_media_insec",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.get_user_media_unfocused
    ///
    /// Whether a page calls MediaDevices.getUserMedia from an unfocused document.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static get_user_media_unfocused: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2831,
            "use.counter.page",
            "get_user_media_unfocused",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlbuttonelement_popovertargetaction
    ///
    /// Whether a page called called HTMLButtonElement.popoverTargetAction. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlbuttonelement_popovertargetaction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2832,
            "use.counter.page",
            "htmlbuttonelement_popovertargetaction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlbuttonelement_popovertargetelement
    ///
    /// Whether a page called called HTMLButtonElement.popoverTargetElement. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlbuttonelement_popovertargetelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2833,
            "use.counter.page",
            "htmlbuttonelement_popovertargetelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldialogelement_show
    ///
    /// Whether a page called called HTMLDialogElement.show. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldialogelement_show: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2834,
            "use.counter.page",
            "htmldialogelement_show",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_named_getter_hit
    ///
    /// Whether a page calls to the named getter on HTMLDocument that find something
    /// via the name lookup. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_named_getter_hit: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2835,
            "use.counter.page",
            "htmldocument_named_getter_hit",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlelement_attributestylemap
    ///
    /// Whether a page called called HTMLElement.attributeStyleMap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlelement_attributestylemap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2836,
            "use.counter.page",
            "htmlelement_attributestylemap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlelement_hidepopover
    ///
    /// Whether a page called called HTMLElement.hidePopover. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlelement_hidepopover: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2837,
            "use.counter.page",
            "htmlelement_hidepopover",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlelement_popover
    ///
    /// Whether a page called called HTMLElement.popover. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlelement_popover: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2838,
            "use.counter.page",
            "htmlelement_popover",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlelement_showpopover
    ///
    /// Whether a page called called HTMLElement.showPopover. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlelement_showpopover: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2839,
            "use.counter.page",
            "htmlelement_showpopover",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlelement_togglepopover
    ///
    /// Whether a page called called HTMLElement.togglePopover. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlelement_togglepopover: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2840,
            "use.counter.page",
            "htmlelement_togglepopover",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmliframeelement_loading
    ///
    /// Whether a page called called HTMLIFrameElement.loading. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmliframeelement_loading: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2841,
            "use.counter.page",
            "htmliframeelement_loading",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlinputelement_capture
    ///
    /// Whether a page called called HTMLInputElement.capture. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2842,
            "use.counter.page",
            "htmlinputelement_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlinputelement_incremental
    ///
    /// Whether a page called called HTMLInputElement.incremental. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_incremental: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2843,
            "use.counter.page",
            "htmlinputelement_incremental",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlinputelement_onsearch
    ///
    /// Whether a page called called HTMLInputElement.onsearch. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_onsearch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2844,
            "use.counter.page",
            "htmlinputelement_onsearch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlinputelement_popovertargetaction
    ///
    /// Whether a page called called HTMLInputElement.popoverTargetAction. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlinputelement_popovertargetaction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2845,
            "use.counter.page",
            "htmlinputelement_popovertargetaction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlinputelement_popovertargetelement
    ///
    /// Whether a page called called HTMLInputElement.popoverTargetElement. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlinputelement_popovertargetelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2846,
            "use.counter.page",
            "htmlinputelement_popovertargetelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlinputelement_webkitdirectory
    ///
    /// Whether a page called called HTMLInputElement.webkitdirectory. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_webkitdirectory: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2847,
            "use.counter.page",
            "htmlinputelement_webkitdirectory",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlinputelement_webkitentries
    ///
    /// Whether a page called called HTMLInputElement.webkitEntries. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_webkitentries: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2848,
            "use.counter.page",
            "htmlinputelement_webkitentries",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlmediaelement_disableremoteplayback
    ///
    /// Whether a page called called HTMLMediaElement.disableRemotePlayback. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlmediaelement_disableremoteplayback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2849,
            "use.counter.page",
            "htmlmediaelement_disableremoteplayback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlmediaelement_remote
    ///
    /// Whether a page called called HTMLMediaElement.remote. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlmediaelement_remote: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2850,
            "use.counter.page",
            "htmlmediaelement_remote",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlvideoelement_cancelvideoframecallback
    ///
    /// Whether a page called called HTMLVideoElement.cancelVideoFrameCallback. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_cancelvideoframecallback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2851,
            "use.counter.page",
            "htmlvideoelement_cancelvideoframecallback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlvideoelement_disablepictureinpicture
    ///
    /// Whether a page called called HTMLVideoElement.disablePictureInPicture. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_disablepictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2852,
            "use.counter.page",
            "htmlvideoelement_disablepictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlvideoelement_onenterpictureinpicture
    ///
    /// Whether a page called called HTMLVideoElement.onenterpictureinpicture. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_onenterpictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2853,
            "use.counter.page",
            "htmlvideoelement_onenterpictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlvideoelement_onleavepictureinpicture
    ///
    /// Whether a page called called HTMLVideoElement.onleavepictureinpicture. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_onleavepictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2854,
            "use.counter.page",
            "htmlvideoelement_onleavepictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlvideoelement_playsinline
    ///
    /// Whether a page called called HTMLVideoElement.playsInline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlvideoelement_playsinline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2855,
            "use.counter.page",
            "htmlvideoelement_playsinline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlvideoelement_requestpictureinpicture
    ///
    /// Whether a page called called HTMLVideoElement.requestPictureInPicture. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_requestpictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2856,
            "use.counter.page",
            "htmlvideoelement_requestpictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlvideoelement_requestvideoframecallback
    ///
    /// Whether a page called called HTMLVideoElement.requestVideoFrameCallback.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static htmlvideoelement_requestvideoframecallback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2857,
            "use.counter.page",
            "htmlvideoelement_requestvideoframecallback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.imagedata_colorspace
    ///
    /// Whether a page called called ImageData.colorSpace. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static imagedata_colorspace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2858,
            "use.counter.page",
            "imagedata_colorspace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_asmjs
    ///
    /// Whether a page uses asm.js. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_asmjs: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2859,
            "use.counter.page",
            "js_asmjs",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_wasm
    ///
    /// Whether a page uses WebAssembly. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_wasm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2860,
            "use.counter.page",
            "js_wasm",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_wasm_legacy_exceptions
    ///
    /// Whether a page uses WebAssembly legacy exception-handling. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_wasm_legacy_exceptions: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2861,
            "use.counter.page",
            "js_wasm_legacy_exceptions",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.location_ancestororigins
    ///
    /// Whether a page called called Location.ancestorOrigins. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static location_ancestororigins: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2862,
            "use.counter.page",
            "location_ancestororigins",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mediadevices_enumeratedevices
    ///
    /// Whether a page called called MediaDevices.enumerateDevices. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mediadevices_enumeratedevices: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2863,
            "use.counter.page",
            "mediadevices_enumeratedevices",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mediadevices_getdisplaymedia
    ///
    /// Whether a page called called MediaDevices.getDisplayMedia. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mediadevices_getdisplaymedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2864,
            "use.counter.page",
            "mediadevices_getdisplaymedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mediadevices_getusermedia
    ///
    /// Whether a page called called MediaDevices.getUserMedia. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mediadevices_getusermedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2865,
            "use.counter.page",
            "mediadevices_getusermedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_not_upgraded_audio_failure
    ///
    /// Whether a page includes a mixed content audio element that does not load..
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static mixed_content_not_upgraded_audio_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2866,
            "use.counter.page",
            "mixed_content_not_upgraded_audio_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_not_upgraded_audio_success
    ///
    /// Whether a page includes a mixed content audio element that loads.. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_not_upgraded_audio_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2867,
            "use.counter.page",
            "mixed_content_not_upgraded_audio_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_not_upgraded_image_failure
    ///
    /// Whether a page includes a mixed content img element that does not load..
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static mixed_content_not_upgraded_image_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2868,
            "use.counter.page",
            "mixed_content_not_upgraded_image_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_not_upgraded_image_success
    ///
    /// Whether a page includes a mixed content img element that loads.. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_not_upgraded_image_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2869,
            "use.counter.page",
            "mixed_content_not_upgraded_image_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_not_upgraded_video_failure
    ///
    /// Whether a page includes a mixed content video element that does not laod..
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static mixed_content_not_upgraded_video_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2870,
            "use.counter.page",
            "mixed_content_not_upgraded_video_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_not_upgraded_video_success
    ///
    /// Whether a page includes a mixed content video element that loads.. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_not_upgraded_video_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2871,
            "use.counter.page",
            "mixed_content_not_upgraded_video_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_upgraded_audio_failure
    ///
    /// Whether a page includes a mixed content audio element that does not load..
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static mixed_content_upgraded_audio_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2872,
            "use.counter.page",
            "mixed_content_upgraded_audio_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_upgraded_audio_success
    ///
    /// Whether a page includes a mixed content audio element that loads.. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_upgraded_audio_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2873,
            "use.counter.page",
            "mixed_content_upgraded_audio_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_upgraded_image_failure
    ///
    /// Whether a page includes a mixed content img element that does not load..
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static mixed_content_upgraded_image_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2874,
            "use.counter.page",
            "mixed_content_upgraded_image_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_upgraded_image_success
    ///
    /// Whether a page includes a mixed content img element that loads.. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_upgraded_image_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2875,
            "use.counter.page",
            "mixed_content_upgraded_image_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_upgraded_video_failure
    ///
    /// Whether a page includes a mixed content video element that does not laod..
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static mixed_content_upgraded_video_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2876,
            "use.counter.page",
            "mixed_content_upgraded_video_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_upgraded_video_success
    ///
    /// Whether a page includes a mixed content video element that loads.. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_upgraded_video_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2877,
            "use.counter.page",
            "mixed_content_upgraded_video_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.moz_get_user_media_insec
    ///
    /// Whether a page calls Navigator.mozGetUserMedia from an insecure context.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static moz_get_user_media_insec: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2878,
            "use.counter.page",
            "moz_get_user_media_insec",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.navigator_canshare
    ///
    /// Whether a page called called Navigator.canShare. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static navigator_canshare: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2879,
            "use.counter.page",
            "navigator_canshare",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.navigator_clearappbadge
    ///
    /// Whether a page called called Navigator.clearAppBadge. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static navigator_clearappbadge: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2880,
            "use.counter.page",
            "navigator_clearappbadge",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.navigator_mozgetusermedia
    ///
    /// Whether a page called called Navigator.mozGetUserMedia. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static navigator_mozgetusermedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2881,
            "use.counter.page",
            "navigator_mozgetusermedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.navigator_setappbadge
    ///
    /// Whether a page called called Navigator.setAppBadge. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static navigator_setappbadge: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2882,
            "use.counter.page",
            "navigator_setappbadge",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.navigator_share
    ///
    /// Whether a page called called Navigator.share. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static navigator_share: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2883,
            "use.counter.page",
            "navigator_share",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.navigator_useractivation
    ///
    /// Whether a page called called Navigator.userActivation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static navigator_useractivation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2884,
            "use.counter.page",
            "navigator_useractivation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.navigator_wakelock
    ///
    /// Whether a page called called Navigator.wakeLock. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static navigator_wakelock: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2885,
            "use.counter.page",
            "navigator_wakelock",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.ondommousescroll
    ///
    /// Whether a page sets DOMMouseScroll event listener. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static ondommousescroll: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2886,
            "use.counter.page",
            "ondommousescroll",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.onmozmousepixelscroll
    ///
    /// Whether a page sets MozMousePixelScroll event listener. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static onmozmousepixelscroll: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2887,
            "use.counter.page",
            "onmozmousepixelscroll",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.onoverflow
    ///
    /// Whether a page sets an element onoverflow event listener. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static onoverflow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2888,
            "use.counter.page",
            "onoverflow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.onunderflow
    ///
    /// Whether a page sets an element onunderflow event listener. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static onunderflow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2889,
            "use.counter.page",
            "onunderflow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.percentage_stroke_width_in_svg
    ///
    /// Whether a page whether percentage stroke-width is used in SVG elements
    /// (excluding <text>). Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static percentage_stroke_width_in_svg: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2890,
            "use.counter.page",
            "percentage_stroke_width_in_svg",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.percentage_stroke_width_in_svgtext
    ///
    /// Whether a page whether percentage stroke-width is used in SVG <text>. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static percentage_stroke_width_in_svgtext: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2891,
            "use.counter.page",
            "percentage_stroke_width_in_svgtext",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_caches_delete
    ///
    /// Whether a page calls caches.delete in Private Browsing Mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_delete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2892,
            "use.counter.page",
            "private_browsing_caches_delete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_caches_has
    ///
    /// Whether a page calls caches.has in Private Browsing Mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_has: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2893,
            "use.counter.page",
            "private_browsing_caches_has",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_caches_keys
    ///
    /// Whether a page calls caches.keys in Private Browsing Mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_keys: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2894,
            "use.counter.page",
            "private_browsing_caches_keys",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_caches_match
    ///
    /// Whether a page calls caches.match in Private Browsing Mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_match: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2895,
            "use.counter.page",
            "private_browsing_caches_match",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_caches_open
    ///
    /// Whether a page calls caches.open in Private Browsing Mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2896,
            "use.counter.page",
            "private_browsing_caches_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_idbfactory_delete_database
    ///
    /// Whether a page calls indexedDB.deleteDatabase in Private Browsing Mode. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static private_browsing_idbfactory_delete_database: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2897,
            "use.counter.page",
            "private_browsing_idbfactory_delete_database",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_idbfactory_open
    ///
    /// Whether a page calls indexedDB.open in Private Browsing Mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static private_browsing_idbfactory_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2898,
            "use.counter.page",
            "private_browsing_idbfactory_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_navigator_service_worker
    ///
    /// Whether a page accesses navigator.serviceWorker in Private Browsing Mode.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static private_browsing_navigator_service_worker: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2899,
            "use.counter.page",
            "private_browsing_navigator_service_worker",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.pushmanager_subscribe
    ///
    /// Whether a page called called PushManager.subscribe. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static pushmanager_subscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2900,
            "use.counter.page",
            "pushmanager_subscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.pushsubscription_unsubscribe
    ///
    /// Whether a page called called PushSubscription.unsubscribe. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static pushsubscription_unsubscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2901,
            "use.counter.page",
            "pushsubscription_unsubscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.range_createcontextualfragment
    ///
    /// Whether a page called called Range.createContextualFragment. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static range_createcontextualfragment: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2902,
            "use.counter.page",
            "range_createcontextualfragment",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.sanitizer_constructor
    ///
    /// Whether a page called called Sanitizer.constructor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static sanitizer_constructor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2903,
            "use.counter.page",
            "sanitizer_constructor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.sanitizer_sanitize
    ///
    /// Whether a page called called Sanitizer.sanitize. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static sanitizer_sanitize: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2904,
            "use.counter.page",
            "sanitizer_sanitize",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.scheduler_posttask
    ///
    /// Whether a page called called Scheduler.postTask. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static scheduler_posttask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2905,
            "use.counter.page",
            "scheduler_posttask",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.shadowroot_pictureinpictureelement
    ///
    /// Whether a page called called ShadowRoot.pictureInPictureElement. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static shadowroot_pictureinpictureelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2906,
            "use.counter.page",
            "shadowroot_pictureinpictureelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.svgsvgelement_currentscale_getter
    ///
    /// Whether a page got SVGSVGElement.currentScale. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static svgsvgelement_currentscale_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2907,
            "use.counter.page",
            "svgsvgelement_currentscale_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.svgsvgelement_currentscale_setter
    ///
    /// Whether a page set SVGSVGElement.currentScale. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static svgsvgelement_currentscale_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2908,
            "use.counter.page",
            "svgsvgelement_currentscale_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.svgsvgelement_getelementbyid
    ///
    /// Whether a page called called SVGSVGElement.getElementById. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static svgsvgelement_getelementbyid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2909,
            "use.counter.page",
            "svgsvgelement_getelementbyid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_absoluteorientationsensor
    ///
    /// Whether a page called called Window.AbsoluteOrientationSensor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_absoluteorientationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2910,
            "use.counter.page",
            "window_absoluteorientationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_accelerometer
    ///
    /// Whether a page called called Window.Accelerometer. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_accelerometer: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2911,
            "use.counter.page",
            "window_accelerometer",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_backgroundfetchmanager
    ///
    /// Whether a page called called Window.BackgroundFetchManager. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_backgroundfetchmanager: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2912,
            "use.counter.page",
            "window_backgroundfetchmanager",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_backgroundfetchrecord
    ///
    /// Whether a page called called Window.BackgroundFetchRecord. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_backgroundfetchrecord: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2913,
            "use.counter.page",
            "window_backgroundfetchrecord",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_backgroundfetchregistration
    ///
    /// Whether a page called called Window.BackgroundFetchRegistration. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_backgroundfetchregistration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2914,
            "use.counter.page",
            "window_backgroundfetchregistration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_beforeinstallpromptevent
    ///
    /// Whether a page called called Window.BeforeInstallPromptEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_beforeinstallpromptevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2915,
            "use.counter.page",
            "window_beforeinstallpromptevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetooth
    ///
    /// Whether a page called called Window.Bluetooth. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_bluetooth: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2916,
            "use.counter.page",
            "window_bluetooth",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetoothcharacteristicproperties
    ///
    /// Whether a page called called Window.BluetoothCharacteristicProperties. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_bluetoothcharacteristicproperties: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2917,
            "use.counter.page",
            "window_bluetoothcharacteristicproperties",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetoothdevice
    ///
    /// Whether a page called called Window.BluetoothDevice. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothdevice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2918,
            "use.counter.page",
            "window_bluetoothdevice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetoothremotegattcharacteristic
    ///
    /// Whether a page called called Window.BluetoothRemoteGATTCharacteristic. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_bluetoothremotegattcharacteristic: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2919,
            "use.counter.page",
            "window_bluetoothremotegattcharacteristic",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetoothremotegattdescriptor
    ///
    /// Whether a page called called Window.BluetoothRemoteGATTDescriptor. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_bluetoothremotegattdescriptor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2920,
            "use.counter.page",
            "window_bluetoothremotegattdescriptor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetoothremotegattserver
    ///
    /// Whether a page called called Window.BluetoothRemoteGATTServer. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothremotegattserver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2921,
            "use.counter.page",
            "window_bluetoothremotegattserver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetoothremotegattservice
    ///
    /// Whether a page called called Window.BluetoothRemoteGATTService. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothremotegattservice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2922,
            "use.counter.page",
            "window_bluetoothremotegattservice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetoothuuid
    ///
    /// Whether a page called called Window.BluetoothUUID. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothuuid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2923,
            "use.counter.page",
            "window_bluetoothuuid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_canvascapturemediastreamtrack
    ///
    /// Whether a page called called Window.CanvasCaptureMediaStreamTrack. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_canvascapturemediastreamtrack: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2924,
            "use.counter.page",
            "window_canvascapturemediastreamtrack",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_chrome
    ///
    /// Whether a page called called Window.chrome. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_chrome: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2925,
            "use.counter.page",
            "window_chrome",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_clipboarditem
    ///
    /// Whether a page called called Window.ClipboardItem. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_clipboarditem: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2926,
            "use.counter.page",
            "window_clipboarditem",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssimagevalue
    ///
    /// Whether a page called called Window.CSSImageValue. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssimagevalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2927,
            "use.counter.page",
            "window_cssimagevalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_csskeywordvalue
    ///
    /// Whether a page called called Window.CSSKeywordValue. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_csskeywordvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2928,
            "use.counter.page",
            "window_csskeywordvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathclamp
    ///
    /// Whether a page called called Window.CSSMathClamp. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathclamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2929,
            "use.counter.page",
            "window_cssmathclamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathinvert
    ///
    /// Whether a page called called Window.CSSMathInvert. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathinvert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2930,
            "use.counter.page",
            "window_cssmathinvert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathmax
    ///
    /// Whether a page called called Window.CSSMathMax. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathmax: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2931,
            "use.counter.page",
            "window_cssmathmax",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathmin
    ///
    /// Whether a page called called Window.CSSMathMin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathmin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2932,
            "use.counter.page",
            "window_cssmathmin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathnegate
    ///
    /// Whether a page called called Window.CSSMathNegate. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathnegate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2933,
            "use.counter.page",
            "window_cssmathnegate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathproduct
    ///
    /// Whether a page called called Window.CSSMathProduct. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathproduct: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2934,
            "use.counter.page",
            "window_cssmathproduct",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathsum
    ///
    /// Whether a page called called Window.CSSMathSum. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathsum: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2935,
            "use.counter.page",
            "window_cssmathsum",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathvalue
    ///
    /// Whether a page called called Window.CSSMathValue. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2936,
            "use.counter.page",
            "window_cssmathvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmatrixcomponent
    ///
    /// Whether a page called called Window.CSSMatrixComponent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmatrixcomponent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2937,
            "use.counter.page",
            "window_cssmatrixcomponent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssnumericarray
    ///
    /// Whether a page called called Window.CSSNumericArray. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssnumericarray: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2938,
            "use.counter.page",
            "window_cssnumericarray",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssnumericvalue
    ///
    /// Whether a page called called Window.CSSNumericValue. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssnumericvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2939,
            "use.counter.page",
            "window_cssnumericvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssperspective
    ///
    /// Whether a page called called Window.CSSPerspective. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssperspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2940,
            "use.counter.page",
            "window_cssperspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_csspositionvalue
    ///
    /// Whether a page called called Window.CSSPositionValue. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_csspositionvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2941,
            "use.counter.page",
            "window_csspositionvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_csspropertyrule
    ///
    /// Whether a page called called Window.CSSPropertyRule. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_csspropertyrule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2942,
            "use.counter.page",
            "window_csspropertyrule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssrotate
    ///
    /// Whether a page called called Window.CSSRotate. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssrotate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2943,
            "use.counter.page",
            "window_cssrotate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssscale
    ///
    /// Whether a page called called Window.CSSScale. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssscale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2944,
            "use.counter.page",
            "window_cssscale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssskew
    ///
    /// Whether a page called called Window.CSSSkew. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssskew: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2945,
            "use.counter.page",
            "window_cssskew",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssskewx
    ///
    /// Whether a page called called Window.CSSSkewX. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssskewx: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2946,
            "use.counter.page",
            "window_cssskewx",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssskewy
    ///
    /// Whether a page called called Window.CSSSkewY. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssskewy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2947,
            "use.counter.page",
            "window_cssskewy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssstylevalue
    ///
    /// Whether a page called called Window.CSSStyleValue. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssstylevalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2948,
            "use.counter.page",
            "window_cssstylevalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_csstransformcomponent
    ///
    /// Whether a page called called Window.CSSTransformComponent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_csstransformcomponent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2949,
            "use.counter.page",
            "window_csstransformcomponent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_csstransformvalue
    ///
    /// Whether a page called called Window.CSSTransformValue. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_csstransformvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2950,
            "use.counter.page",
            "window_csstransformvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_csstranslate
    ///
    /// Whether a page called called Window.CSSTranslate. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_csstranslate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2951,
            "use.counter.page",
            "window_csstranslate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssunitvalue
    ///
    /// Whether a page called called Window.CSSUnitValue. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssunitvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2952,
            "use.counter.page",
            "window_cssunitvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssunparsedvalue
    ///
    /// Whether a page called called Window.CSSUnparsedValue. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssunparsedvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2953,
            "use.counter.page",
            "window_cssunparsedvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssvariablereferencevalue
    ///
    /// Whether a page called called Window.CSSVariableReferenceValue. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssvariablereferencevalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2954,
            "use.counter.page",
            "window_cssvariablereferencevalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_defaultstatus
    ///
    /// Whether a page called called Window.defaultStatus. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_defaultstatus: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2955,
            "use.counter.page",
            "window_defaultstatus",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_devicemotioneventacceleration
    ///
    /// Whether a page called called Window.DeviceMotionEventAcceleration. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_devicemotioneventacceleration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2956,
            "use.counter.page",
            "window_devicemotioneventacceleration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_devicemotioneventrotationrate
    ///
    /// Whether a page called called Window.DeviceMotionEventRotationRate. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_devicemotioneventrotationrate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2957,
            "use.counter.page",
            "window_devicemotioneventrotationrate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_domerror
    ///
    /// Whether a page called called Window.DOMError. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_domerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2958,
            "use.counter.page",
            "window_domerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_encodedvideochunk
    ///
    /// Whether a page called called Window.EncodedVideoChunk. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_encodedvideochunk: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2959,
            "use.counter.page",
            "window_encodedvideochunk",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_enterpictureinpictureevent
    ///
    /// Whether a page called called Window.EnterPictureInPictureEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_enterpictureinpictureevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2960,
            "use.counter.page",
            "window_enterpictureinpictureevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_external
    ///
    /// Whether a page called called Window.External. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_external: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2961,
            "use.counter.page",
            "window_external",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_federatedcredential
    ///
    /// Whether a page called called Window.FederatedCredential. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_federatedcredential: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2962,
            "use.counter.page",
            "window_federatedcredential",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_gyroscope
    ///
    /// Whether a page called called Window.Gyroscope. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_gyroscope: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2963,
            "use.counter.page",
            "window_gyroscope",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_htmlcontentelement
    ///
    /// Whether a page called called Window.HTMLContentElement. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_htmlcontentelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2964,
            "use.counter.page",
            "window_htmlcontentelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_htmlshadowelement
    ///
    /// Whether a page called called Window.HTMLShadowElement. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_htmlshadowelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2965,
            "use.counter.page",
            "window_htmlshadowelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_imagecapture
    ///
    /// Whether a page called called Window.ImageCapture. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_imagecapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2966,
            "use.counter.page",
            "window_imagecapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_inputdevicecapabilities
    ///
    /// Whether a page called called Window.InputDeviceCapabilities. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_inputdevicecapabilities: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2967,
            "use.counter.page",
            "window_inputdevicecapabilities",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_inputdeviceinfo
    ///
    /// Whether a page called called Window.InputDeviceInfo. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_inputdeviceinfo: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2968,
            "use.counter.page",
            "window_inputdeviceinfo",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_keyboard
    ///
    /// Whether a page called called Window.Keyboard. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_keyboard: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2969,
            "use.counter.page",
            "window_keyboard",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_keyboardlayoutmap
    ///
    /// Whether a page called called Window.KeyboardLayoutMap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_keyboardlayoutmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2970,
            "use.counter.page",
            "window_keyboardlayoutmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_linearaccelerationsensor
    ///
    /// Whether a page called called Window.LinearAccelerationSensor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_linearaccelerationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2971,
            "use.counter.page",
            "window_linearaccelerationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_mediasettingsrange
    ///
    /// Whether a page called called Window.MediaSettingsRange. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_mediasettingsrange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2972,
            "use.counter.page",
            "window_mediasettingsrange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midiaccess
    ///
    /// Whether a page called called Window.MIDIAccess. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midiaccess: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2973,
            "use.counter.page",
            "window_midiaccess",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midiconnectionevent
    ///
    /// Whether a page called called Window.MIDIConnectionEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midiconnectionevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2974,
            "use.counter.page",
            "window_midiconnectionevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midiinput
    ///
    /// Whether a page called called Window.MIDIInput. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midiinput: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2975,
            "use.counter.page",
            "window_midiinput",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midiinputmap
    ///
    /// Whether a page called called Window.MIDIInputMap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midiinputmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2976,
            "use.counter.page",
            "window_midiinputmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midimessageevent
    ///
    /// Whether a page called called Window.MIDIMessageEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midimessageevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2977,
            "use.counter.page",
            "window_midimessageevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midioutput
    ///
    /// Whether a page called called Window.MIDIOutput. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midioutput: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2978,
            "use.counter.page",
            "window_midioutput",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midioutputmap
    ///
    /// Whether a page called called Window.MIDIOutputMap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midioutputmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2979,
            "use.counter.page",
            "window_midioutputmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midiport
    ///
    /// Whether a page called called Window.MIDIPort. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midiport: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2980,
            "use.counter.page",
            "window_midiport",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_networkinformation
    ///
    /// Whether a page called called Window.NetworkInformation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_networkinformation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2981,
            "use.counter.page",
            "window_networkinformation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_offscreenbuffering
    ///
    /// Whether a page called called Window.offscreenBuffering. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_offscreenbuffering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2982,
            "use.counter.page",
            "window_offscreenbuffering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_onbeforeinstallprompt
    ///
    /// Whether a page called called Window.onbeforeinstallprompt. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_onbeforeinstallprompt: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2983,
            "use.counter.page",
            "window_onbeforeinstallprompt",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_oncancel
    ///
    /// Whether a page called called Window.oncancel. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_oncancel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2984,
            "use.counter.page",
            "window_oncancel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_onmousewheel
    ///
    /// Whether a page called called Window.onmousewheel. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_onmousewheel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2985,
            "use.counter.page",
            "window_onmousewheel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_onorientationchange
    ///
    /// Whether a page called called Window.onorientationchange. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_onorientationchange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2986,
            "use.counter.page",
            "window_onorientationchange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_onsearch
    ///
    /// Whether a page called called Window.onsearch. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_onsearch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2987,
            "use.counter.page",
            "window_onsearch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_onselectionchange
    ///
    /// Whether a page called called Window.onselectionchange. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_onselectionchange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2988,
            "use.counter.page",
            "window_onselectionchange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_open_empty_url
    ///
    /// Whether a page calls window.open with an empty url argument. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_open_empty_url: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2989,
            "use.counter.page",
            "window_open_empty_url",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_opendatabase
    ///
    /// Whether a page called called Window.openDatabase. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_opendatabase: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2990,
            "use.counter.page",
            "window_opendatabase",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_orientation
    ///
    /// Whether a page called called Window.orientation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2991,
            "use.counter.page",
            "window_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_orientationsensor
    ///
    /// Whether a page called called Window.OrientationSensor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_orientationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2992,
            "use.counter.page",
            "window_orientationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_overconstrainederror
    ///
    /// Whether a page called called Window.OverconstrainedError. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_overconstrainederror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2993,
            "use.counter.page",
            "window_overconstrainederror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_passwordcredential
    ///
    /// Whether a page called called Window.PasswordCredential. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_passwordcredential: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2994,
            "use.counter.page",
            "window_passwordcredential",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_paymentaddress
    ///
    /// Whether a page called called Window.PaymentAddress. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_paymentaddress: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2995,
            "use.counter.page",
            "window_paymentaddress",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_paymentinstruments
    ///
    /// Whether a page called called Window.PaymentInstruments. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_paymentinstruments: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2996,
            "use.counter.page",
            "window_paymentinstruments",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_paymentmanager
    ///
    /// Whether a page called called Window.PaymentManager. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_paymentmanager: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2997,
            "use.counter.page",
            "window_paymentmanager",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_paymentmethodchangeevent
    ///
    /// Whether a page called called Window.PaymentMethodChangeEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_paymentmethodchangeevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2998,
            "use.counter.page",
            "window_paymentmethodchangeevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_paymentrequest
    ///
    /// Whether a page called called Window.PaymentRequest. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_paymentrequest: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2999,
            "use.counter.page",
            "window_paymentrequest",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_paymentrequestupdateevent
    ///
    /// Whether a page called called Window.PaymentRequestUpdateEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_paymentrequestupdateevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3000,
            "use.counter.page",
            "window_paymentrequestupdateevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_paymentresponse
    ///
    /// Whether a page called called Window.PaymentResponse. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_paymentresponse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3001,
            "use.counter.page",
            "window_paymentresponse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_performancelongtasktiming
    ///
    /// Whether a page called called Window.PerformanceLongTaskTiming. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_performancelongtasktiming: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3002,
            "use.counter.page",
            "window_performancelongtasktiming",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_photocapabilities
    ///
    /// Whether a page called called Window.PhotoCapabilities. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_photocapabilities: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3003,
            "use.counter.page",
            "window_photocapabilities",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_pictureinpictureevent
    ///
    /// Whether a page called called Window.PictureInPictureEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_pictureinpictureevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3004,
            "use.counter.page",
            "window_pictureinpictureevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_pictureinpicturewindow
    ///
    /// Whether a page called called Window.PictureInPictureWindow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_pictureinpicturewindow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3005,
            "use.counter.page",
            "window_pictureinpicturewindow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentation
    ///
    /// Whether a page called called Window.Presentation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_presentation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3006,
            "use.counter.page",
            "window_presentation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentationavailability
    ///
    /// Whether a page called called Window.PresentationAvailability. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_presentationavailability: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3007,
            "use.counter.page",
            "window_presentationavailability",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentationconnection
    ///
    /// Whether a page called called Window.PresentationConnection. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_presentationconnection: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3008,
            "use.counter.page",
            "window_presentationconnection",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentationconnectionavailableevent
    ///
    /// Whether a page called called Window.PresentationConnectionAvailableEvent.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static window_presentationconnectionavailableevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3009,
            "use.counter.page",
            "window_presentationconnectionavailableevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentationconnectioncloseevent
    ///
    /// Whether a page called called Window.PresentationConnectionCloseEvent. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_presentationconnectioncloseevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3010,
            "use.counter.page",
            "window_presentationconnectioncloseevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentationconnectionlist
    ///
    /// Whether a page called called Window.PresentationConnectionList. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_presentationconnectionlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3011,
            "use.counter.page",
            "window_presentationconnectionlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentationreceiver
    ///
    /// Whether a page called called Window.PresentationReceiver. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_presentationreceiver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3012,
            "use.counter.page",
            "window_presentationreceiver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentationrequest
    ///
    /// Whether a page called called Window.PresentationRequest. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_presentationrequest: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3013,
            "use.counter.page",
            "window_presentationrequest",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_relativeorientationsensor
    ///
    /// Whether a page called called Window.RelativeOrientationSensor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_relativeorientationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3014,
            "use.counter.page",
            "window_relativeorientationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_remoteplayback
    ///
    /// Whether a page called called Window.RemotePlayback. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_remoteplayback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3015,
            "use.counter.page",
            "window_remoteplayback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_report
    ///
    /// Whether a page called called Window.Report. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_report: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3016,
            "use.counter.page",
            "window_report",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_reportbody
    ///
    /// Whether a page called called Window.ReportBody. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_reportbody: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3017,
            "use.counter.page",
            "window_reportbody",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_reportingobserver
    ///
    /// Whether a page called called Window.ReportingObserver. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_reportingobserver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3018,
            "use.counter.page",
            "window_reportingobserver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_rtcerror
    ///
    /// Whether a page called called Window.RTCError. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_rtcerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3019,
            "use.counter.page",
            "window_rtcerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_rtcerrorevent
    ///
    /// Whether a page called called Window.RTCErrorEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_rtcerrorevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3020,
            "use.counter.page",
            "window_rtcerrorevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_rtcicetransport
    ///
    /// Whether a page called called Window.RTCIceTransport. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_rtcicetransport: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3021,
            "use.counter.page",
            "window_rtcicetransport",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_rtcpeerconnectioniceerrorevent
    ///
    /// Whether a page called called Window.RTCPeerConnectionIceErrorEvent. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_rtcpeerconnectioniceerrorevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3022,
            "use.counter.page",
            "window_rtcpeerconnectioniceerrorevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_sensor
    ///
    /// Whether a page called called Window.Sensor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_sensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3023,
            "use.counter.page",
            "window_sensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_sensorerrorevent
    ///
    /// Whether a page called called Window.SensorErrorEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_sensorerrorevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3024,
            "use.counter.page",
            "window_sensorerrorevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_sidebar_getter
    ///
    /// Whether a page got Window.sidebar. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_sidebar_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3025,
            "use.counter.page",
            "window_sidebar_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_sidebar_setter
    ///
    /// Whether a page set Window.sidebar. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_sidebar_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3026,
            "use.counter.page",
            "window_sidebar_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_speechrecognitionalternative
    ///
    /// Whether a page called called Window.SpeechRecognitionAlternative. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_speechrecognitionalternative: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3027,
            "use.counter.page",
            "window_speechrecognitionalternative",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_speechrecognitionresult
    ///
    /// Whether a page called called Window.SpeechRecognitionResult. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_speechrecognitionresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3028,
            "use.counter.page",
            "window_speechrecognitionresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_speechrecognitionresultlist
    ///
    /// Whether a page called called Window.SpeechRecognitionResultList. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_speechrecognitionresultlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3029,
            "use.counter.page",
            "window_speechrecognitionresultlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_stylemedia
    ///
    /// Whether a page called called Window.styleMedia. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_stylemedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3030,
            "use.counter.page",
            "window_stylemedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_stylepropertymap
    ///
    /// Whether a page called called Window.StylePropertyMap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_stylepropertymap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3031,
            "use.counter.page",
            "window_stylepropertymap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_stylepropertymapreadonly
    ///
    /// Whether a page called called Window.StylePropertyMapReadOnly. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_stylepropertymapreadonly: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3032,
            "use.counter.page",
            "window_stylepropertymapreadonly",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_svgdiscardelement
    ///
    /// Whether a page called called Window.SVGDiscardElement. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_svgdiscardelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3033,
            "use.counter.page",
            "window_svgdiscardelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_syncmanager
    ///
    /// Whether a page called called Window.SyncManager. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_syncmanager: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3034,
            "use.counter.page",
            "window_syncmanager",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_taskattributiontiming
    ///
    /// Whether a page called called Window.TaskAttributionTiming. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_taskattributiontiming: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3035,
            "use.counter.page",
            "window_taskattributiontiming",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_textevent
    ///
    /// Whether a page called called Window.TextEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_textevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3036,
            "use.counter.page",
            "window_textevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_touch
    ///
    /// Whether a page called called Window.Touch. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_touch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3037,
            "use.counter.page",
            "window_touch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_touchevent
    ///
    /// Whether a page called called Window.TouchEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_touchevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3038,
            "use.counter.page",
            "window_touchevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_touchlist
    ///
    /// Whether a page called called Window.TouchList. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_touchlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3039,
            "use.counter.page",
            "window_touchlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usb
    ///
    /// Whether a page called called Window.USB. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usb: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3040,
            "use.counter.page",
            "window_usb",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbalternateinterface
    ///
    /// Whether a page called called Window.USBAlternateInterface. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbalternateinterface: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3041,
            "use.counter.page",
            "window_usbalternateinterface",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbconfiguration
    ///
    /// Whether a page called called Window.USBConfiguration. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbconfiguration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3042,
            "use.counter.page",
            "window_usbconfiguration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbconnectionevent
    ///
    /// Whether a page called called Window.USBConnectionEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbconnectionevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3043,
            "use.counter.page",
            "window_usbconnectionevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbdevice
    ///
    /// Whether a page called called Window.USBDevice. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbdevice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3044,
            "use.counter.page",
            "window_usbdevice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbendpoint
    ///
    /// Whether a page called called Window.USBEndpoint. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbendpoint: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3045,
            "use.counter.page",
            "window_usbendpoint",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbinterface
    ///
    /// Whether a page called called Window.USBInterface. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbinterface: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3046,
            "use.counter.page",
            "window_usbinterface",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbintransferresult
    ///
    /// Whether a page called called Window.USBInTransferResult. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbintransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3047,
            "use.counter.page",
            "window_usbintransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbisochronousintransferpacket
    ///
    /// Whether a page called called Window.USBIsochronousInTransferPacket. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_usbisochronousintransferpacket: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3048,
            "use.counter.page",
            "window_usbisochronousintransferpacket",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbisochronousintransferresult
    ///
    /// Whether a page called called Window.USBIsochronousInTransferResult. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_usbisochronousintransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3049,
            "use.counter.page",
            "window_usbisochronousintransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbisochronousouttransferpacket
    ///
    /// Whether a page called called Window.USBIsochronousOutTransferPacket. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_usbisochronousouttransferpacket: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3050,
            "use.counter.page",
            "window_usbisochronousouttransferpacket",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbisochronousouttransferresult
    ///
    /// Whether a page called called Window.USBIsochronousOutTransferResult. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_usbisochronousouttransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3051,
            "use.counter.page",
            "window_usbisochronousouttransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbouttransferresult
    ///
    /// Whether a page called called Window.USBOutTransferResult. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbouttransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3052,
            "use.counter.page",
            "window_usbouttransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_useractivation
    ///
    /// Whether a page called called Window.UserActivation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_useractivation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3053,
            "use.counter.page",
            "window_useractivation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_videocolorspace
    ///
    /// Whether a page called called Window.VideoColorSpace. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_videocolorspace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3054,
            "use.counter.page",
            "window_videocolorspace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_videodecoder
    ///
    /// Whether a page called called Window.VideoDecoder. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_videodecoder: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3055,
            "use.counter.page",
            "window_videodecoder",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_videoencoder
    ///
    /// Whether a page called called Window.VideoEncoder. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_videoencoder: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3056,
            "use.counter.page",
            "window_videoencoder",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_videoframe
    ///
    /// Whether a page called called Window.VideoFrame. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_videoframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3057,
            "use.counter.page",
            "window_videoframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_wakelock
    ///
    /// Whether a page called called Window.WakeLock. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_wakelock: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3058,
            "use.counter.page",
            "window_wakelock",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_wakelocksentinel
    ///
    /// Whether a page called called Window.WakeLockSentinel. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_wakelocksentinel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3059,
            "use.counter.page",
            "window_wakelocksentinel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitcancelanimationframe
    ///
    /// Whether a page called called Window.webkitCancelAnimationFrame. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitcancelanimationframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3060,
            "use.counter.page",
            "window_webkitcancelanimationframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitmediastream
    ///
    /// Whether a page called called Window.webkitMediaStream. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitmediastream: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3061,
            "use.counter.page",
            "window_webkitmediastream",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitmutationobserver
    ///
    /// Whether a page called called Window.WebKitMutationObserver. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitmutationobserver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3062,
            "use.counter.page",
            "window_webkitmutationobserver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitrequestanimationframe
    ///
    /// Whether a page called called Window.webkitRequestAnimationFrame. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_webkitrequestanimationframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3063,
            "use.counter.page",
            "window_webkitrequestanimationframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitrequestfilesystem
    ///
    /// Whether a page called called Window.webkitRequestFileSystem. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitrequestfilesystem: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3064,
            "use.counter.page",
            "window_webkitrequestfilesystem",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitresolvelocalfilesystemurl
    ///
    /// Whether a page called called Window.webkitResolveLocalFileSystemURL. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_webkitresolvelocalfilesystemurl: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3065,
            "use.counter.page",
            "window_webkitresolvelocalfilesystemurl",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitrtcpeerconnection
    ///
    /// Whether a page called called Window.webkitRTCPeerConnection. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitrtcpeerconnection: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3066,
            "use.counter.page",
            "window_webkitrtcpeerconnection",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitspeechgrammar
    ///
    /// Whether a page called called Window.webkitSpeechGrammar. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechgrammar: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3067,
            "use.counter.page",
            "window_webkitspeechgrammar",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitspeechgrammarlist
    ///
    /// Whether a page called called Window.webkitSpeechGrammarList. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechgrammarlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3068,
            "use.counter.page",
            "window_webkitspeechgrammarlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitspeechrecognition
    ///
    /// Whether a page called called Window.webkitSpeechRecognition. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechrecognition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3069,
            "use.counter.page",
            "window_webkitspeechrecognition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitspeechrecognitionerror
    ///
    /// Whether a page called called Window.webkitSpeechRecognitionError. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_webkitspeechrecognitionerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3070,
            "use.counter.page",
            "window_webkitspeechrecognitionerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitspeechrecognitionevent
    ///
    /// Whether a page called called Window.webkitSpeechRecognitionEvent. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_webkitspeechrecognitionevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3071,
            "use.counter.page",
            "window_webkitspeechrecognitionevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitstorageinfo
    ///
    /// Whether a page called called Window.webkitStorageInfo. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitstorageinfo: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3072,
            "use.counter.page",
            "window_webkitstorageinfo",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.workernavigator_permissions
    ///
    /// Whether a page called called WorkerNavigator.permissions. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static workernavigator_permissions: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3073,
            "use.counter.page",
            "workernavigator_permissions",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.wr_filter_fallback
    ///
    /// Whether a page triggers the blob fallback for an SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static wr_filter_fallback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3074,
            "use.counter.page",
            "wr_filter_fallback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.xslstylesheet
    ///
    /// Whether a page uses an XSL Stylesheet. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static xslstylesheet: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3075,
            "use.counter.page",
            "xslstylesheet",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.xsltprocessor_constructor
    ///
    /// Whether a page called called XSLTProcessor.constructor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static xsltprocessor_constructor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3076,
            "use.counter.page",
            "xsltprocessor_constructor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.you_tube_flash_embed
    ///
    /// Whether a page in <object> or <embed>. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static you_tube_flash_embed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3077,
            "use.counter.page",
            "you_tube_flash_embed",
            "use-counters"
        )
    });

}
pub mod use_counter_worker_dedicated {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_assert
    ///
    /// Whether a dedicated worker called called console.assert. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_assert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3078,
            "use.counter.worker.dedicated",
            "console_assert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_clear
    ///
    /// Whether a dedicated worker called called console.clear. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_clear: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3079,
            "use.counter.worker.dedicated",
            "console_clear",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_count
    ///
    /// Whether a dedicated worker called called console.count. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3080,
            "use.counter.worker.dedicated",
            "console_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_countreset
    ///
    /// Whether a dedicated worker called called console.countReset. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_countreset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3081,
            "use.counter.worker.dedicated",
            "console_countreset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_debug
    ///
    /// Whether a dedicated worker called called console.debug. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_debug: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3082,
            "use.counter.worker.dedicated",
            "console_debug",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_dir
    ///
    /// Whether a dedicated worker called called console.dir. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_dir: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3083,
            "use.counter.worker.dedicated",
            "console_dir",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_dirxml
    ///
    /// Whether a dedicated worker called called console.dirxml. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_dirxml: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3084,
            "use.counter.worker.dedicated",
            "console_dirxml",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_error
    ///
    /// Whether a dedicated worker called called console.error. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_error: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3085,
            "use.counter.worker.dedicated",
            "console_error",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_exception
    ///
    /// Whether a dedicated worker called called console.exception. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_exception: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3086,
            "use.counter.worker.dedicated",
            "console_exception",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_group
    ///
    /// Whether a dedicated worker called called console.group. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3087,
            "use.counter.worker.dedicated",
            "console_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_groupcollapsed
    ///
    /// Whether a dedicated worker called called console.groupCollapsed. Compare
    /// against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_groupcollapsed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3088,
            "use.counter.worker.dedicated",
            "console_groupcollapsed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_groupend
    ///
    /// Whether a dedicated worker called called console.groupEnd. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_groupend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3089,
            "use.counter.worker.dedicated",
            "console_groupend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_info
    ///
    /// Whether a dedicated worker called called console.info. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_info: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3090,
            "use.counter.worker.dedicated",
            "console_info",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_log
    ///
    /// Whether a dedicated worker called called console.log. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_log: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3091,
            "use.counter.worker.dedicated",
            "console_log",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_profile
    ///
    /// Whether a dedicated worker called called console.profile. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_profile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3092,
            "use.counter.worker.dedicated",
            "console_profile",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_profileend
    ///
    /// Whether a dedicated worker called called console.profileEnd. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_profileend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3093,
            "use.counter.worker.dedicated",
            "console_profileend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_table
    ///
    /// Whether a dedicated worker called called console.table. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_table: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3094,
            "use.counter.worker.dedicated",
            "console_table",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_time
    ///
    /// Whether a dedicated worker called called console.time. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_time: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3095,
            "use.counter.worker.dedicated",
            "console_time",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_timeend
    ///
    /// Whether a dedicated worker called called console.timeEnd. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_timeend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3096,
            "use.counter.worker.dedicated",
            "console_timeend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_timelog
    ///
    /// Whether a dedicated worker called called console.timeLog. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_timelog: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3097,
            "use.counter.worker.dedicated",
            "console_timelog",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_timestamp
    ///
    /// Whether a dedicated worker called called console.timeStamp. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_timestamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3098,
            "use.counter.worker.dedicated",
            "console_timestamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_trace
    ///
    /// Whether a dedicated worker called called console.trace. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_trace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3099,
            "use.counter.worker.dedicated",
            "console_trace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_warn
    ///
    /// Whether a dedicated worker called called console.warn. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_warn: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3100,
            "use.counter.worker.dedicated",
            "console_warn",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.private_browsing_caches_delete
    ///
    /// Whether a dedicated worker calls caches.delete in Private Browsing Mode.
    /// Compare against `use.counter.dedicated_workers_destroyed` to calculate the
    /// rate.
    pub static private_browsing_caches_delete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3101,
            "use.counter.worker.dedicated",
            "private_browsing_caches_delete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.private_browsing_caches_has
    ///
    /// Whether a dedicated worker calls caches.has in Private Browsing Mode. Compare
    /// against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_has: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3102,
            "use.counter.worker.dedicated",
            "private_browsing_caches_has",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.private_browsing_caches_keys
    ///
    /// Whether a dedicated worker calls caches.keys in Private Browsing Mode. Compare
    /// against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_keys: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3103,
            "use.counter.worker.dedicated",
            "private_browsing_caches_keys",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.private_browsing_caches_match
    ///
    /// Whether a dedicated worker calls caches.match in Private Browsing Mode. Compare
    /// against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_match: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3104,
            "use.counter.worker.dedicated",
            "private_browsing_caches_match",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.private_browsing_caches_open
    ///
    /// Whether a dedicated worker calls caches.open in Private Browsing Mode. Compare
    /// against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3105,
            "use.counter.worker.dedicated",
            "private_browsing_caches_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.private_browsing_idbfactory_delete_database
    ///
    /// Whether a dedicated worker calls indexedDB.deleteDatabase in Private Browsing
    /// Mode. Compare against `use.counter.dedicated_workers_destroyed` to calculate
    /// the rate.
    pub static private_browsing_idbfactory_delete_database: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3106,
            "use.counter.worker.dedicated",
            "private_browsing_idbfactory_delete_database",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.private_browsing_idbfactory_open
    ///
    /// Whether a dedicated worker calls indexedDB.open in Private Browsing Mode.
    /// Compare against `use.counter.dedicated_workers_destroyed` to calculate the
    /// rate.
    pub static private_browsing_idbfactory_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3107,
            "use.counter.worker.dedicated",
            "private_browsing_idbfactory_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.pushmanager_subscribe
    ///
    /// Whether a dedicated worker called called PushManager.subscribe. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static pushmanager_subscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3108,
            "use.counter.worker.dedicated",
            "pushmanager_subscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.pushsubscription_unsubscribe
    ///
    /// Whether a dedicated worker called called PushSubscription.unsubscribe. Compare
    /// against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static pushsubscription_unsubscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3109,
            "use.counter.worker.dedicated",
            "pushsubscription_unsubscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.scheduler_posttask
    ///
    /// Whether a dedicated worker called called Scheduler.postTask. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static scheduler_posttask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3110,
            "use.counter.worker.dedicated",
            "scheduler_posttask",
            "use-counters"
        )
    });

}
pub mod use_counter_worker_service {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_assert
    ///
    /// Whether a service worker called called console.assert. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_assert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3111,
            "use.counter.worker.service",
            "console_assert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_clear
    ///
    /// Whether a service worker called called console.clear. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_clear: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3112,
            "use.counter.worker.service",
            "console_clear",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_count
    ///
    /// Whether a service worker called called console.count. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3113,
            "use.counter.worker.service",
            "console_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_countreset
    ///
    /// Whether a service worker called called console.countReset. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_countreset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3114,
            "use.counter.worker.service",
            "console_countreset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_debug
    ///
    /// Whether a service worker called called console.debug. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_debug: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3115,
            "use.counter.worker.service",
            "console_debug",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_dir
    ///
    /// Whether a service worker called called console.dir. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_dir: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3116,
            "use.counter.worker.service",
            "console_dir",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_dirxml
    ///
    /// Whether a service worker called called console.dirxml. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_dirxml: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3117,
            "use.counter.worker.service",
            "console_dirxml",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_error
    ///
    /// Whether a service worker called called console.error. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_error: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3118,
            "use.counter.worker.service",
            "console_error",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_exception
    ///
    /// Whether a service worker called called console.exception. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_exception: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3119,
            "use.counter.worker.service",
            "console_exception",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_group
    ///
    /// Whether a service worker called called console.group. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3120,
            "use.counter.worker.service",
            "console_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_groupcollapsed
    ///
    /// Whether a service worker called called console.groupCollapsed. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_groupcollapsed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3121,
            "use.counter.worker.service",
            "console_groupcollapsed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_groupend
    ///
    /// Whether a service worker called called console.groupEnd. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_groupend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3122,
            "use.counter.worker.service",
            "console_groupend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_info
    ///
    /// Whether a service worker called called console.info. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_info: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3123,
            "use.counter.worker.service",
            "console_info",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_log
    ///
    /// Whether a service worker called called console.log. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_log: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3124,
            "use.counter.worker.service",
            "console_log",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_profile
    ///
    /// Whether a service worker called called console.profile. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_profile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3125,
            "use.counter.worker.service",
            "console_profile",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_profileend
    ///
    /// Whether a service worker called called console.profileEnd. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_profileend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3126,
            "use.counter.worker.service",
            "console_profileend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_table
    ///
    /// Whether a service worker called called console.table. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_table: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3127,
            "use.counter.worker.service",
            "console_table",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_time
    ///
    /// Whether a service worker called called console.time. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_time: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3128,
            "use.counter.worker.service",
            "console_time",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_timeend
    ///
    /// Whether a service worker called called console.timeEnd. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_timeend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3129,
            "use.counter.worker.service",
            "console_timeend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_timelog
    ///
    /// Whether a service worker called called console.timeLog. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_timelog: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3130,
            "use.counter.worker.service",
            "console_timelog",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_timestamp
    ///
    /// Whether a service worker called called console.timeStamp. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_timestamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3131,
            "use.counter.worker.service",
            "console_timestamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_trace
    ///
    /// Whether a service worker called called console.trace. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_trace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3132,
            "use.counter.worker.service",
            "console_trace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_warn
    ///
    /// Whether a service worker called called console.warn. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_warn: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3133,
            "use.counter.worker.service",
            "console_warn",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.private_browsing_caches_delete
    ///
    /// Whether a service worker calls caches.delete in Private Browsing Mode. Compare
    /// against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_delete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3134,
            "use.counter.worker.service",
            "private_browsing_caches_delete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.private_browsing_caches_has
    ///
    /// Whether a service worker calls caches.has in Private Browsing Mode. Compare
    /// against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_has: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3135,
            "use.counter.worker.service",
            "private_browsing_caches_has",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.private_browsing_caches_keys
    ///
    /// Whether a service worker calls caches.keys in Private Browsing Mode. Compare
    /// against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_keys: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3136,
            "use.counter.worker.service",
            "private_browsing_caches_keys",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.private_browsing_caches_match
    ///
    /// Whether a service worker calls caches.match in Private Browsing Mode. Compare
    /// against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_match: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3137,
            "use.counter.worker.service",
            "private_browsing_caches_match",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.private_browsing_caches_open
    ///
    /// Whether a service worker calls caches.open in Private Browsing Mode. Compare
    /// against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3138,
            "use.counter.worker.service",
            "private_browsing_caches_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.private_browsing_idbfactory_delete_database
    ///
    /// Whether a service worker calls indexedDB.deleteDatabase in Private Browsing
    /// Mode. Compare against `use.counter.service_workers_destroyed` to calculate the
    /// rate.
    pub static private_browsing_idbfactory_delete_database: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3139,
            "use.counter.worker.service",
            "private_browsing_idbfactory_delete_database",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.private_browsing_idbfactory_open
    ///
    /// Whether a service worker calls indexedDB.open in Private Browsing Mode. Compare
    /// against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static private_browsing_idbfactory_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3140,
            "use.counter.worker.service",
            "private_browsing_idbfactory_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.pushmanager_subscribe
    ///
    /// Whether a service worker called called PushManager.subscribe. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static pushmanager_subscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3141,
            "use.counter.worker.service",
            "pushmanager_subscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.pushsubscription_unsubscribe
    ///
    /// Whether a service worker called called PushSubscription.unsubscribe. Compare
    /// against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static pushsubscription_unsubscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3142,
            "use.counter.worker.service",
            "pushsubscription_unsubscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.scheduler_posttask
    ///
    /// Whether a service worker called called Scheduler.postTask. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static scheduler_posttask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3143,
            "use.counter.worker.service",
            "scheduler_posttask",
            "use-counters"
        )
    });

}
pub mod use_counter_worker_shared {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_assert
    ///
    /// Whether a shared worker called called console.assert. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_assert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3144,
            "use.counter.worker.shared",
            "console_assert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_clear
    ///
    /// Whether a shared worker called called console.clear. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_clear: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3145,
            "use.counter.worker.shared",
            "console_clear",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_count
    ///
    /// Whether a shared worker called called console.count. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3146,
            "use.counter.worker.shared",
            "console_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_countreset
    ///
    /// Whether a shared worker called called console.countReset. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_countreset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3147,
            "use.counter.worker.shared",
            "console_countreset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_debug
    ///
    /// Whether a shared worker called called console.debug. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_debug: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3148,
            "use.counter.worker.shared",
            "console_debug",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_dir
    ///
    /// Whether a shared worker called called console.dir. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_dir: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3149,
            "use.counter.worker.shared",
            "console_dir",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_dirxml
    ///
    /// Whether a shared worker called called console.dirxml. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_dirxml: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3150,
            "use.counter.worker.shared",
            "console_dirxml",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_error
    ///
    /// Whether a shared worker called called console.error. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_error: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3151,
            "use.counter.worker.shared",
            "console_error",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_exception
    ///
    /// Whether a shared worker called called console.exception. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_exception: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3152,
            "use.counter.worker.shared",
            "console_exception",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_group
    ///
    /// Whether a shared worker called called console.group. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3153,
            "use.counter.worker.shared",
            "console_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_groupcollapsed
    ///
    /// Whether a shared worker called called console.groupCollapsed. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_groupcollapsed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3154,
            "use.counter.worker.shared",
            "console_groupcollapsed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_groupend
    ///
    /// Whether a shared worker called called console.groupEnd. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_groupend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3155,
            "use.counter.worker.shared",
            "console_groupend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_info
    ///
    /// Whether a shared worker called called console.info. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_info: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3156,
            "use.counter.worker.shared",
            "console_info",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_log
    ///
    /// Whether a shared worker called called console.log. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_log: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3157,
            "use.counter.worker.shared",
            "console_log",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_profile
    ///
    /// Whether a shared worker called called console.profile. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_profile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3158,
            "use.counter.worker.shared",
            "console_profile",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_profileend
    ///
    /// Whether a shared worker called called console.profileEnd. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_profileend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3159,
            "use.counter.worker.shared",
            "console_profileend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_table
    ///
    /// Whether a shared worker called called console.table. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_table: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3160,
            "use.counter.worker.shared",
            "console_table",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_time
    ///
    /// Whether a shared worker called called console.time. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_time: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3161,
            "use.counter.worker.shared",
            "console_time",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_timeend
    ///
    /// Whether a shared worker called called console.timeEnd. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_timeend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3162,
            "use.counter.worker.shared",
            "console_timeend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_timelog
    ///
    /// Whether a shared worker called called console.timeLog. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_timelog: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3163,
            "use.counter.worker.shared",
            "console_timelog",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_timestamp
    ///
    /// Whether a shared worker called called console.timeStamp. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_timestamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3164,
            "use.counter.worker.shared",
            "console_timestamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_trace
    ///
    /// Whether a shared worker called called console.trace. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_trace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3165,
            "use.counter.worker.shared",
            "console_trace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_warn
    ///
    /// Whether a shared worker called called console.warn. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_warn: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3166,
            "use.counter.worker.shared",
            "console_warn",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.private_browsing_caches_delete
    ///
    /// Whether a shared worker calls caches.delete in Private Browsing Mode. Compare
    /// against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_delete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3167,
            "use.counter.worker.shared",
            "private_browsing_caches_delete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.private_browsing_caches_has
    ///
    /// Whether a shared worker calls caches.has in Private Browsing Mode. Compare
    /// against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_has: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3168,
            "use.counter.worker.shared",
            "private_browsing_caches_has",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.private_browsing_caches_keys
    ///
    /// Whether a shared worker calls caches.keys in Private Browsing Mode. Compare
    /// against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_keys: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3169,
            "use.counter.worker.shared",
            "private_browsing_caches_keys",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.private_browsing_caches_match
    ///
    /// Whether a shared worker calls caches.match in Private Browsing Mode. Compare
    /// against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_match: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3170,
            "use.counter.worker.shared",
            "private_browsing_caches_match",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.private_browsing_caches_open
    ///
    /// Whether a shared worker calls caches.open in Private Browsing Mode. Compare
    /// against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3171,
            "use.counter.worker.shared",
            "private_browsing_caches_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.private_browsing_idbfactory_delete_database
    ///
    /// Whether a shared worker calls indexedDB.deleteDatabase in Private Browsing
    /// Mode. Compare against `use.counter.shared_workers_destroyed` to calculate the
    /// rate.
    pub static private_browsing_idbfactory_delete_database: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3172,
            "use.counter.worker.shared",
            "private_browsing_idbfactory_delete_database",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.private_browsing_idbfactory_open
    ///
    /// Whether a shared worker calls indexedDB.open in Private Browsing Mode. Compare
    /// against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static private_browsing_idbfactory_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3173,
            "use.counter.worker.shared",
            "private_browsing_idbfactory_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.pushmanager_subscribe
    ///
    /// Whether a shared worker called called PushManager.subscribe. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static pushmanager_subscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3174,
            "use.counter.worker.shared",
            "pushmanager_subscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.pushsubscription_unsubscribe
    ///
    /// Whether a shared worker called called PushSubscription.unsubscribe. Compare
    /// against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static pushsubscription_unsubscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3175,
            "use.counter.worker.shared",
            "pushsubscription_unsubscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.scheduler_posttask
    ///
    /// Whether a shared worker called called Scheduler.postTask. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static scheduler_posttask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3176,
            "use.counter.worker.shared",
            "scheduler_posttask",
            "use-counters"
        )
    });

}
pub mod geolocation {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from geolocation.accuracy
    ///
    /// Accuracy returned by the Geolocation API
    pub static accuracy: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "accuracy".into(),
                category: "geolocation".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3177.into(), meta, 1, 66355200, 50, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum FallbackLabel {
        ENone = 0,
        EOnError = 1,
        EOnTimeout = 2,
        __Other__,
    }
    impl From<u16> for FallbackLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENone,
                1 => Self::EOnError,
                2 => Self::EOnTimeout,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FallbackLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENone => "none",
                Self::EOnError => "on_error",
                Self::EOnTimeout => "on_timeout",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from geolocation.fallback
    ///
    /// Whether the default provider falled back to NetworkGeolocationProvider.
    pub static fallback: Lazy<LabeledMetric<LabeledCounterMetric, FallbackLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "fallback".into(),
                    category: "geolocation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3178.into(), meta, Some(vec![::std::borrow::Cow::from("none"), ::std::borrow::Cow::from("on_error"), ::std::borrow::Cow::from("on_timeout")]))
    });

    #[repr(u16)]
    pub enum LinuxProviderLabel {
        ENone = 0,
        EPortal = 1,
        EGeoclue = 2,
        __Other__,
    }
    impl From<u16> for LinuxProviderLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENone,
                1 => Self::EPortal,
                2 => Self::EGeoclue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for LinuxProviderLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENone => "none",
                Self::EPortal => "portal",
                Self::EGeoclue => "geoclue",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from geolocation.linux_provider
    ///
    /// Which system provider are we using on Linux
    pub static linux_provider: Lazy<LabeledMetric<LabeledBooleanMetric, LinuxProviderLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "linux_provider".into(),
                    category: "geolocation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3179.into(), meta, Some(vec![::std::borrow::Cow::from("geoclue"), ::std::borrow::Cow::from("none"), ::std::borrow::Cow::from("portal")]))
    });

    #[repr(u16)]
    pub enum RequestResultLabel {
        ESuccess = 0,
        EPermissionDenied = 1,
        EPositionUnavailable = 2,
        ETimeout = 3,
        __Other__,
    }
    impl From<u16> for RequestResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EPermissionDenied,
                2 => Self::EPositionUnavailable,
                3 => Self::ETimeout,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RequestResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EPermissionDenied => "permission_denied",
                Self::EPositionUnavailable => "position_unavailable",
                Self::ETimeout => "timeout",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from geolocation.request_result
    ///
    /// The result for each geolocation request. Success label will only happen once
    /// for each request, even if it's a watch request.
    pub static request_result: Lazy<LabeledMetric<LabeledCounterMetric, RequestResultLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "request_result".into(),
                    category: "geolocation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3180.into(), meta, Some(vec![::std::borrow::Cow::from("permission_denied"), ::std::borrow::Cow::from("position_unavailable"), ::std::borrow::Cow::from("success"), ::std::borrow::Cow::from("timeout")]))
    });

}
pub mod ls_preparedatastore {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from ls.preparedatastore.processing_time
    ///
    /// Time it took for the parent process to prepare a Datastore. This duration can
    /// be significantly affected by Datastore preloading, which is triggered when a
    /// page begins to load. When a Datastore is already preloaded, the preparation is
    /// usually fast since it doesn't need to do any I/O. If an error occurs, the time
    /// is not recorded. In future, we might want to introduce additional separate
    /// metrics for different types of datastore preparations (data needs to be loaded
    /// from disk, data already available, etc.)
    pub static processing_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "processing_time".into(),
                category: "ls.preparedatastore".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3181.into(), meta, TimeUnit::Microsecond)
    });

}
pub mod ls_preparelsdatabase {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from ls.preparelsdatabase.processing_time
    ///
    /// Time it took for the content process to fully prepare a new LSDatabase,
    /// including any time required to prepare a Datastore in the parent. This duration
    /// can be significantly affected by Datastore preloading, which is triggered when
    /// a page begins to load. If an error occurs, the time is not recorded.
    pub static processing_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "processing_time".into(),
                category: "ls.preparelsdatabase".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3182.into(), meta, TimeUnit::Microsecond)
    });

}
pub mod ls_request {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from ls.request.recv_cancellation
    ///
    /// Upticks whenever a LS request cancellation message is received. This includes
    /// requests for ensuring either LSDatabase or LSObserver in the child.
    pub static recv_cancellation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3183,
            "ls.request",
            "recv_cancellation",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from ls.request.send_cancellation
    ///
    /// Upticks whenever a LS request cancellation message is sent. This includes
    /// requests for ensuring either LSDatabase or LSObserver.
    pub static send_cancellation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3184,
            "ls.request",
            "send_cancellation",
            "metrics"
        )
    });

}
pub mod mediadrm {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EmePlaybackExtra {
        pub r#key_system: Option<String>,
        pub r#played_time: Option<u32>,
        pub r#resolution: Option<String>,
        pub r#video_codec: Option<String>,
    }

    impl ExtraKeys for EmePlaybackExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["key_system", "played_time", "resolution", "video_codec"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#key_system.and_then(|val| map.insert("key_system".into(), val.to_string()));
          self.r#played_time.and_then(|val| map.insert("played_time".into(), val.to_string()));
          self.r#resolution.and_then(|val| map.insert("resolution".into(), val.to_string()));
          self.r#video_codec.and_then(|val| map.insert("video_codec".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from mediadrm.eme_playback
    ///
    /// Record the EME play time with the video codec and resolutions.
    pub static eme_playback: Lazy<EventMetric<EmePlaybackExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "eme_playback".into(),
                category: "mediadrm".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3185.into(), meta)
    });

}
pub mod hls {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from hls.canplay_requested
    ///
    /// Record when a page requests canPlayType for a HLS media type.
    pub static canplay_requested: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3186,
            "hls",
            "canplay_requested",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from hls.canplay_supported
    ///
    /// Record when a canPlayType request supports HLS.
    pub static canplay_supported: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3187,
            "hls",
            "canplay_supported",
            "metrics"
        )
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct MediaLoadExtra {
        pub r#media_extension: Option<String>,
    }

    impl ExtraKeys for MediaLoadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["media_extension"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#media_extension.and_then(|val| map.insert("media_extension".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from hls.media_load
    ///
    /// Record the information about the HLS playback on Android using ExoPlayer. The
    /// value of this event contains the media format.
    pub static media_load: Lazy<EventMetric<MediaLoadExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "media_load".into(),
                category: "hls".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3188.into(), meta)
    });

}
pub mod gmp {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum UpdateXmlFetchResultLabel {
        ECertPinSuccess = 0,
        ECertPinNetRequestError = 1,
        ECertPinNetTimeout = 2,
        ECertPinAbort = 3,
        ECertPinMissingData = 4,
        ECertPinFailed = 5,
        ECertPinInvalid = 6,
        ECertPinXmlParseError = 7,
        ECertPinUnknownError = 8,
        EContentSigSuccess = 9,
        EContentSigNetRequestError = 10,
        EContentSigNetTimeout = 11,
        EContentSigAbort = 12,
        EContentSigMissingData = 13,
        EContentSigFailed = 14,
        EContentSigInvalid = 15,
        EContentSigXmlParseError = 16,
        EContentSigUnknownError = 17,
        __Other__,
    }
    impl From<u16> for UpdateXmlFetchResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECertPinSuccess,
                1 => Self::ECertPinNetRequestError,
                2 => Self::ECertPinNetTimeout,
                3 => Self::ECertPinAbort,
                4 => Self::ECertPinMissingData,
                5 => Self::ECertPinFailed,
                6 => Self::ECertPinInvalid,
                7 => Self::ECertPinXmlParseError,
                8 => Self::ECertPinUnknownError,
                9 => Self::EContentSigSuccess,
                10 => Self::EContentSigNetRequestError,
                11 => Self::EContentSigNetTimeout,
                12 => Self::EContentSigAbort,
                13 => Self::EContentSigMissingData,
                14 => Self::EContentSigFailed,
                15 => Self::EContentSigInvalid,
                16 => Self::EContentSigXmlParseError,
                17 => Self::EContentSigUnknownError,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for UpdateXmlFetchResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECertPinSuccess => "cert_pin_success",
                Self::ECertPinNetRequestError => "cert_pin_net_request_error",
                Self::ECertPinNetTimeout => "cert_pin_net_timeout",
                Self::ECertPinAbort => "cert_pin_abort",
                Self::ECertPinMissingData => "cert_pin_missing_data",
                Self::ECertPinFailed => "cert_pin_failed",
                Self::ECertPinInvalid => "cert_pin_invalid",
                Self::ECertPinXmlParseError => "cert_pin_xml_parse_error",
                Self::ECertPinUnknownError => "cert_pin_unknown_error",
                Self::EContentSigSuccess => "content_sig_success",
                Self::EContentSigNetRequestError => "content_sig_net_request_error",
                Self::EContentSigNetTimeout => "content_sig_net_timeout",
                Self::EContentSigAbort => "content_sig_abort",
                Self::EContentSigMissingData => "content_sig_missing_data",
                Self::EContentSigFailed => "content_sig_failed",
                Self::EContentSigInvalid => "content_sig_invalid",
                Self::EContentSigXmlParseError => "content_sig_xml_parse_error",
                Self::EContentSigUnknownError => "content_sig_unknown_error",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from gmp.update_xml_fetch_result
    ///
    /// The result of Gecko fetching an update.xml from Balrog. This captures 3
    /// different data points: success or failure of the request, if cert pinning or
    /// content signatures were used to verify the result, and the reason for failure,
    /// if the request failed.
    pub static update_xml_fetch_result: Lazy<LabeledMetric<LabeledCounterMetric, UpdateXmlFetchResultLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "update_xml_fetch_result".into(),
                    category: "gmp".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3189.into(), meta, Some(vec![::std::borrow::Cow::from("cert_pin_abort"), ::std::borrow::Cow::from("cert_pin_failed"), ::std::borrow::Cow::from("cert_pin_invalid"), ::std::borrow::Cow::from("cert_pin_missing_data"), ::std::borrow::Cow::from("cert_pin_net_request_error"), ::std::borrow::Cow::from("cert_pin_net_timeout"), ::std::borrow::Cow::from("cert_pin_success"), ::std::borrow::Cow::from("cert_pin_unknown_error"), ::std::borrow::Cow::from("cert_pin_xml_parse_error"), ::std::borrow::Cow::from("content_sig_abort"), ::std::borrow::Cow::from("content_sig_failed"), ::std::borrow::Cow::from("content_sig_invalid"), ::std::borrow::Cow::from("content_sig_missing_data"), ::std::borrow::Cow::from("content_sig_net_request_error"), ::std::borrow::Cow::from("content_sig_net_timeout"), ::std::borrow::Cow::from("content_sig_success"), ::std::borrow::Cow::from("content_sig_unknown_error"), ::std::borrow::Cow::from("content_sig_xml_parse_error")]))
    });

}
pub mod media {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from media.decode_error_per_mime_type
    ///
    /// Count the number of times the media with a specific mime type (Eg.
    /// audio/vorbis, that would be used as the key) encounters a decode error during
    /// playback. This metric was generated to correspond to the Legacy Telemetry
    /// scalar media.decode_error_per_mime_type.
    pub static decode_error_per_mime_type: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "decode_error_per_mime_type".into(),
                    category: "media".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3190.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.element_in_page_count
    ///
    /// The number of times a document hierarchy contained at least one
    /// HTMLMediaElement. In addition, the telemetry probe
    /// 'MIXED_CONTENT_UNBLOCK_COUNTER' records the total number of loaded top level
    /// content documents, which can help us calculate the result of the percentage of
    /// documents using media. This metric was generated to correspond to the Legacy
    /// Telemetry scalar media.element_in_page_count.
    pub static element_in_page_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3191,
            "media",
            "element_in_page_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.video_hardware_decoding_support
    ///
    /// Record whether hardware decoding is supported for the specific video codec. The
    /// key is the type of video codec, eg. video/vp9. This metric was generated to
    /// correspond to the Legacy Telemetry scalar
    /// media.video_hardware_decoding_support.
    pub static video_hardware_decoding_support: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "video_hardware_decoding_support".into(),
                    category: "media".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::with_unordered_ipc(3192.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.video_hd_hardware_decoding_support
    ///
    /// Record whether hardware decoding is supported for the specific video codec,
    /// this only records video in HD (1280*720) or higher resultion. The key is the
    /// type of video codec, eg. video/vp9. This metric was generated to correspond to
    /// the Legacy Telemetry scalar media.video_hd_hardware_decoding_support.
    pub static video_hd_hardware_decoding_support: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "video_hd_hardware_decoding_support".into(),
                    category: "media".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::with_unordered_ipc(3193.into(), meta, None)
    });

}
pub mod media_audio {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum BackendLabel {
        EUnknown = 0,
        EAudiounit = 1,
        EAudiounitRust = 2,
        EAaudio = 3,
        EOpensl = 4,
        EWasapi = 5,
        EWinmm = 6,
        EAlsa = 7,
        EJack = 8,
        EOss = 9,
        EPulse = 10,
        EPulseRust = 11,
        ESndio = 12,
        ESunaudio = 13,
        __Other__,
    }
    impl From<u16> for BackendLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUnknown,
                1 => Self::EAudiounit,
                2 => Self::EAudiounitRust,
                3 => Self::EAaudio,
                4 => Self::EOpensl,
                5 => Self::EWasapi,
                6 => Self::EWinmm,
                7 => Self::EAlsa,
                8 => Self::EJack,
                9 => Self::EOss,
                10 => Self::EPulse,
                11 => Self::EPulseRust,
                12 => Self::ESndio,
                13 => Self::ESunaudio,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for BackendLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUnknown => "unknown",
                Self::EAudiounit => "audiounit",
                Self::EAudiounitRust => "audiounit-rust",
                Self::EAaudio => "aaudio",
                Self::EOpensl => "opensl",
                Self::EWasapi => "wasapi",
                Self::EWinmm => "winmm",
                Self::EAlsa => "alsa",
                Self::EJack => "jack",
                Self::EOss => "oss",
                Self::EPulse => "pulse",
                Self::EPulseRust => "pulse-rust",
                Self::ESndio => "sndio",
                Self::ESunaudio => "sunaudio",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from media.audio.backend
    ///
    /// The operating system audio backend (Migrated from the geckoview metric of the
    /// same name).
    pub static backend: Lazy<LabeledMetric<LabeledCounterMetric, BackendLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "backend".into(),
                    category: "media.audio".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3194.into(), meta, Some(vec![::std::borrow::Cow::from("aaudio"), ::std::borrow::Cow::from("alsa"), ::std::borrow::Cow::from("audiounit"), ::std::borrow::Cow::from("audiounit-rust"), ::std::borrow::Cow::from("jack"), ::std::borrow::Cow::from("opensl"), ::std::borrow::Cow::from("oss"), ::std::borrow::Cow::from("pulse"), ::std::borrow::Cow::from("pulse-rust"), ::std::borrow::Cow::from("sndio"), ::std::borrow::Cow::from("sunaudio"), ::std::borrow::Cow::from("unknown"), ::std::borrow::Cow::from("wasapi"), ::std::borrow::Cow::from("winmm")]))
    });

    #[repr(u16)]
    pub enum InitFailureLabel {
        EFirst = 0,
        EOther = 1,
        __Other__,
    }
    impl From<u16> for InitFailureLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFirst,
                1 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for InitFailureLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFirst => "first",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from media.audio.init_failure
    ///
    /// Failure occurs when initializing the audio stream. (Migrated from the geckoview
    /// metric of the same name).
    pub static init_failure: Lazy<LabeledMetric<LabeledCounterMetric, InitFailureLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "init_failure".into(),
                    category: "media.audio".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3195.into(), meta, Some(vec![::std::borrow::Cow::from("first"), ::std::borrow::Cow::from("other")]))
    });

}
pub mod media_playback {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum DeviceHardwareDecoderSupportLabel {
        EH264 = 0,
        EVp8 = 1,
        EVp9 = 2,
        EAv1 = 3,
        EHevc = 4,
        __Other__,
    }
    impl From<u16> for DeviceHardwareDecoderSupportLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EH264,
                1 => Self::EVp8,
                2 => Self::EVp9,
                3 => Self::EAv1,
                4 => Self::EHevc,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for DeviceHardwareDecoderSupportLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EH264 => "h264",
                Self::EVp8 => "vp8",
                Self::EVp9 => "vp9",
                Self::EAv1 => "av1",
                Self::EHevc => "hevc",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from media.playback.device_hardware_decoder_support
    ///
    /// The results of hardware decoder support for different video codecs. True means
    /// that codec can be decoded by hardware on user's device.
    pub static device_hardware_decoder_support: Lazy<LabeledMetric<LabeledBooleanMetric, DeviceHardwareDecoderSupportLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "device_hardware_decoder_support".into(),
                    category: "media.playback".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3196.into(), meta, Some(vec![::std::borrow::Cow::from("av1"), ::std::borrow::Cow::from("h264"), ::std::borrow::Cow::from("hevc"), ::std::borrow::Cow::from("vp8"), ::std::borrow::Cow::from("vp9")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FirstFrameLoadedExtra {
        pub r#buffering_time: Option<u32>,
        pub r#first_frame_loaded_time: Option<u32>,
        pub r#hls_decoder: Option<bool>,
        pub r#is_hardware_decoding: Option<bool>,
        pub r#key_system: Option<String>,
        pub r#metadata_loaded_time: Option<u32>,
        pub r#playback_type: Option<String>,
        pub r#resolution: Option<String>,
        pub r#total_waiting_data_time: Option<u32>,
        pub r#video_codec: Option<String>,
    }

    impl ExtraKeys for FirstFrameLoadedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["buffering_time", "first_frame_loaded_time", "hls_decoder", "is_hardware_decoding", "key_system", "metadata_loaded_time", "playback_type", "resolution", "total_waiting_data_time", "video_codec"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#buffering_time.and_then(|val| map.insert("buffering_time".into(), val.to_string()));
          self.r#first_frame_loaded_time.and_then(|val| map.insert("first_frame_loaded_time".into(), val.to_string()));
          self.r#hls_decoder.and_then(|val| map.insert("hls_decoder".into(), val.to_string()));
          self.r#is_hardware_decoding.and_then(|val| map.insert("is_hardware_decoding".into(), val.to_string()));
          self.r#key_system.and_then(|val| map.insert("key_system".into(), val.to_string()));
          self.r#metadata_loaded_time.and_then(|val| map.insert("metadata_loaded_time".into(), val.to_string()));
          self.r#playback_type.and_then(|val| map.insert("playback_type".into(), val.to_string()));
          self.r#resolution.and_then(|val| map.insert("resolution".into(), val.to_string()));
          self.r#total_waiting_data_time.and_then(|val| map.insert("total_waiting_data_time".into(), val.to_string()));
          self.r#video_codec.and_then(|val| map.insert("video_codec".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from media.playback.first_frame_loaded
    ///
    /// The time that the media pipeline takes to load the first video frame.
    pub static first_frame_loaded: Lazy<EventMetric<FirstFrameLoadedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "first_frame_loaded".into(),
                category: "media.playback".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3197.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.playback.not_supported_video_per_mime_type
    ///
    /// Count the amount of times where video playback is failed to start due to the
    /// mime type is not supported by Firefox. The result is accumulated per mime type,
    /// eg. video/hevc.
    pub static not_supported_video_per_mime_type: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "not_supported_video_per_mime_type".into(),
                    category: "media.playback".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3198.into(), meta, None)
    });

}
pub mod mfcdm {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EmePlaybackExtra {
        pub r#dropped_frames: Option<u32>,
        pub r#key_system: Option<String>,
        pub r#played_time: Option<u32>,
        pub r#rendered_frames: Option<u32>,
        pub r#resolution: Option<String>,
        pub r#video_codec: Option<String>,
    }

    impl ExtraKeys for EmePlaybackExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["dropped_frames", "key_system", "played_time", "rendered_frames", "resolution", "video_codec"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#dropped_frames.and_then(|val| map.insert("dropped_frames".into(), val.to_string()));
          self.r#key_system.and_then(|val| map.insert("key_system".into(), val.to_string()));
          self.r#played_time.and_then(|val| map.insert("played_time".into(), val.to_string()));
          self.r#rendered_frames.and_then(|val| map.insert("rendered_frames".into(), val.to_string()));
          self.r#resolution.and_then(|val| map.insert("resolution".into(), val.to_string()));
          self.r#video_codec.and_then(|val| map.insert("video_codec".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from mfcdm.eme_playback
    ///
    /// Record the information about the EME playback when using the media engine. The
    /// value of this event is the key system name.
    pub static eme_playback: Lazy<EventMetric<EmePlaybackExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "eme_playback".into(),
                category: "mfcdm".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3199.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ErrorExtra {
        pub r#audio_codec: Option<String>,
        pub r#current_state: Option<String>,
        pub r#error_name: Option<String>,
        pub r#key_system: Option<String>,
        pub r#resolution: Option<String>,
        pub r#video_codec: Option<String>,
    }

    impl ExtraKeys for ErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["audio_codec", "current_state", "error_name", "key_system", "resolution", "video_codec"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#audio_codec.and_then(|val| map.insert("audio_codec".into(), val.to_string()));
          self.r#current_state.and_then(|val| map.insert("current_state".into(), val.to_string()));
          self.r#error_name.and_then(|val| map.insert("error_name".into(), val.to_string()));
          self.r#key_system.and_then(|val| map.insert("key_system".into(), val.to_string()));
          self.r#resolution.and_then(|val| map.insert("resolution".into(), val.to_string()));
          self.r#video_codec.and_then(|val| map.insert("video_codec".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from mfcdm.error
    ///
    /// Record the error or crash happened while using the media engine playback. The
    /// value of this event is the name of error. This probe covers both EME and non-
    /// EME playback.
    pub static error: Lazy<EventMetric<ErrorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "error".into(),
                category: "mfcdm".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3200.into(), meta)
    });

}
pub mod codec_stats {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from codec.stats.audio_preferred_codec
    ///
    /// Counts the preferred audio codec being signaled to us to identify preferred
    /// audio codec.
    pub static audio_preferred_codec: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "audio_preferred_codec".into(),
                    category: "codec.stats".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3201.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from codec.stats.other_fec_signaled
    ///
    /// Count how many other fec options are being offered.
    pub static other_fec_signaled: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "other_fec_signaled".into(),
                    category: "codec.stats".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3202.into(), meta, None)
    });

    #[repr(u16)]
    pub enum UlpfecNegotiatedLabel {
        ENegotiated = 0,
        ENotNegotiated = 1,
        __Other__,
    }
    impl From<u16> for UlpfecNegotiatedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENegotiated,
                1 => Self::ENotNegotiated,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for UlpfecNegotiatedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENegotiated => "negotiated",
                Self::ENotNegotiated => "not_negotiated",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from codec.stats.ulpfec_negotiated
    ///
    /// Counts the number of times that ulpfec is negotiated or not negotiated on the
    /// first negotiation for each video transceiver.
    pub static ulpfec_negotiated: Lazy<LabeledMetric<LabeledCounterMetric, UlpfecNegotiatedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "ulpfec_negotiated".into(),
                    category: "codec.stats".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3203.into(), meta, Some(vec![::std::borrow::Cow::from("negotiated"), ::std::borrow::Cow::from("not_negotiated")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from codec.stats.video_preferred_codec
    ///
    /// Counts the preferred video codec being signaled to us to identify preferred
    /// video codec.
    pub static video_preferred_codec: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "video_preferred_codec".into(),
                    category: "codec.stats".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3204.into(), meta, None)
    });

}
pub mod rtcrtpsender {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.count
    ///
    /// The number of RTCRtpSenders created.
    pub static count: Lazy<DenominatorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "count".into(),
                category: "rtcrtpsender".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DenominatorMetric::new(3205.into(), meta, vec![CommonMetricData {name: "used_sendencodings".into(), category: "rtcrtpsender".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_length_changed".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_no_getparameters".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_no_transactionid".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_other".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_rid_changed".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_stale_transactionid".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.count_setparameters_compat
    ///
    /// The number of RTCRtpSenders created that use the compatibility mode for
    /// setParameters.
    pub static count_setparameters_compat: Lazy<DenominatorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "count_setparameters_compat".into(),
                category: "rtcrtpsender".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DenominatorMetric::new(3206.into(), meta, vec![CommonMetricData {name: "fail_no_encodings".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "warn_length_changed".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "warn_no_getparameters".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "warn_no_transactionid".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.used_sendencodings
    ///
    /// The proportion of RTCRtpSenders that were created by an addTransceivers call
    /// that was passed a sendEncodings.
    pub static used_sendencodings: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "used_sendencodings".into(),
                category: "rtcrtpsender".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3207.into(), meta)
    });

}
pub mod rtcrtpsender_setparameters {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_length_changed
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call that attempted to change the number of encodings.
    pub static fail_length_changed: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fail_length_changed".into(),
                category: "rtcrtpsender.setparameters".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3208.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_no_encodings
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode
    /// that have thrown an error at least once about a setParameters call that had no
    /// encodings (we do not measure this against the general population of
    /// RTCRtpSenders, since without the compat mode this failure is never observed,
    /// because it fails the length change check).
    pub static fail_no_encodings: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fail_no_encodings".into(),
                category: "rtcrtpsender.setparameters".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3209.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_no_getparameters
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call because [[LastReturnedParameters]] was not set. (ie; there
    /// was not a recent enough call to getParameters)
    pub static fail_no_getparameters: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fail_no_getparameters".into(),
                category: "rtcrtpsender.setparameters".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3210.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_no_transactionid
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call that did not set the transactionId field.
    pub static fail_no_transactionid: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fail_no_transactionid".into(),
                category: "rtcrtpsender.setparameters".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3211.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_other
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call that had no encodings.
    pub static fail_other: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fail_other".into(),
                category: "rtcrtpsender.setparameters".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3212.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_rid_changed
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call that attempted to change the rid on an encoding (note that
    /// we only check this if the encoding count did not change, see
    /// fail_length_changed).
    pub static fail_rid_changed: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fail_rid_changed".into(),
                category: "rtcrtpsender.setparameters".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3213.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_stale_transactionid
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call that used a stale transaction id.
    pub static fail_stale_transactionid: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fail_stale_transactionid".into(),
                category: "rtcrtpsender.setparameters".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3214.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.warn_length_changed
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode
    /// that have warned at least once about a setParameters call that attempted to
    /// change the number of encodings.
    pub static warn_length_changed: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "warn_length_changed".into(),
                category: "rtcrtpsender.setparameters".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3215.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.warn_no_getparameters
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode
    /// that have warned at least once about a setParameters call because
    /// [[LastReturnedParameters]] was not set.  (ie; there was not a recent enough
    /// call to getParameters)
    pub static warn_no_getparameters: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "warn_no_getparameters".into(),
                category: "rtcrtpsender.setparameters".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3216.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.warn_no_transactionid
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode
    /// that have warned at least once about a setParameters call that did not set the
    /// transactionId field.
    pub static warn_no_transactionid: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "warn_no_transactionid".into(),
                category: "rtcrtpsender.setparameters".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3217.into(), meta)
    });

}
pub mod webrtc_video {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.video.recv_codec_used
    ///
    /// The video codec used for receiving video on a WebRTC call. This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// webrtc.video.recv_codec_used.
    pub static recv_codec_used: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "recv_codec_used".into(),
                    category: "webrtc.video".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3218.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.video.send_codec_used
    ///
    /// The video codec used for sending video on a WebRTC call. This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// webrtc.video.send_codec_used.
    pub static send_codec_used: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "send_codec_used".into(),
                    category: "webrtc.video".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3219.into(), meta, None)
    });

}
pub mod webrtcdtls {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from webrtcdtls.cipher
    ///
    /// The CipherSuite used for each webrtc DTLS connection, as a string
    /// representation of the CipherSuite's ID in 4 hex digits (eg;
    /// TLS_DHE_RSA_WITH_AES_128_CBC_SHA would be "0x0033")
    pub static cipher: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cipher".into(),
                    category: "webrtcdtls".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3220.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtcdtls.client_handshake_result
    ///
    /// The result of each webrtc client DTLS handshake as a string containing either
    /// the name of the error code (eg; SSL_ERROR_BAD_CERTIFICATE), SUCCESS for
    /// successful handshakes, ALPN_FAILURE when ALPN negotiation fails, or
    /// CERT_FAILURE when cert validation fails.
    pub static client_handshake_result: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "client_handshake_result".into(),
                    category: "webrtcdtls".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3221.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtcdtls.client_handshake_started_counter
    ///
    /// The number of webrtc transports that have started a DTLS handshake as the
    /// client.
    pub static client_handshake_started_counter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3222,
            "webrtcdtls",
            "client_handshake_started_counter",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtcdtls.protocol_version
    ///
    /// The version of DTLS used for each webrtc connection. Can be 1.0, 1.2, or 1.3
    /// (there is no 1.1 version of DTLS)
    pub static protocol_version: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "protocol_version".into(),
                    category: "webrtcdtls".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3223.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtcdtls.server_handshake_result
    ///
    /// The result of each webrtc server DTLS handshake, as the name of the error code
    /// (eg; SSL_ERROR_BAD_CERTIFICATE), the empty string for successful handshakes,
    /// ALPN_FAILURE when ALPN negotiation fails, or CERT_FAILURE when cert validation
    /// fails.
    pub static server_handshake_result: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "server_handshake_result".into(),
                    category: "webrtcdtls".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3224.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtcdtls.server_handshake_started_counter
    ///
    /// The number of webrtc transports that have started a DTLS handshake as the
    /// server.
    pub static server_handshake_started_counter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3225,
            "webrtcdtls",
            "server_handshake_started_counter",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtcdtls.srtp_cipher
    ///
    /// The SRTPProtectionProfile (see RFC 5764) used for each webrtc SRTP connection,
    /// as a string representation of the SRTPProtectionProfile's ID in 4 hex digits
    /// (eg; SRTP_AES128_CM_HMAC_SHA1_80 would be "0x0001")
    pub static srtp_cipher: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "srtp_cipher".into(),
                    category: "webrtcdtls".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3226.into(), meta, None)
    });

}
pub mod dom_contentprocess {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from dom.contentprocess.build_id_mismatch
    ///
    /// The number of times the about:restartrequired page appeared due to a buildID
    /// mismatch between the parent and the content processes. This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// dom.contentprocess.buildID_mismatch.
    pub static build_id_mismatch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3227,
            "dom.contentprocess",
            "build_id_mismatch",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.contentprocess.build_id_mismatch_false_positive
    ///
    /// The number of times a process crashed early but we could verify it was not
    /// because of buildID mismatch between the parent and the content processes. This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// dom.contentprocess.buildID_mismatch_false_positive.
    pub static build_id_mismatch_false_positive: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3228,
            "dom.contentprocess",
            "build_id_mismatch_false_positive",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.contentprocess.os_priority_change_considered
    ///
    /// The number of times we've had the opportunity to change content process
    /// priority due to a tab switch or a tab being opened. This metric was generated
    /// to correspond to the Legacy Telemetry scalar
    /// dom.contentprocess.os_priority_change_considered.
    pub static os_priority_change_considered: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3229,
            "dom.contentprocess",
            "os_priority_change_considered",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.contentprocess.os_priority_lowered
    ///
    /// The number of times a content process has had its OS priority lowered due to
    /// only containing background tabs without audible media playing. This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// dom.contentprocess.os_priority_lowered.
    pub static os_priority_lowered: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3230,
            "dom.contentprocess",
            "os_priority_lowered",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.contentprocess.os_priority_raised
    ///
    /// The number of times a content process has had its OS priority raised due to
    /// containing at least one foregrounded tab, or a tab with audible media has
    /// started playing in it. This metric was generated to correspond to the Legacy
    /// Telemetry scalar dom.contentprocess.os_priority_raised.
    pub static os_priority_raised: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3231,
            "dom.contentprocess",
            "os_priority_raised",
            "metrics"
        )
    });

}
pub mod dom_parentprocess {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from dom.parentprocess.private_window_used
    ///
    /// Whether a private browsing window has been used in the session. This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// dom.parentprocess.private_window_used.
    pub static private_window_used: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "private_window_used".into(),
                category: "dom.parentprocess".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3232.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.parentprocess.process_launch_errors
    ///
    /// Collect precise set of error code and calling site upon process creation
    /// failure path. This metric was generated to correspond to the Legacy Telemetry
    /// scalar dom.parentprocess.process_launch_errors.
    pub static process_launch_errors: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "process_launch_errors".into(),
                    category: "dom.parentprocess".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3233.into(), meta, None)
    });

}
pub mod javascript_pageload {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from javascript.pageload.baseline_compile_time
    ///
    /// Time spent during page load baseline compiling Javascript in ms. (Migrated from
    /// the geckoview metric of the same name.)
    pub static baseline_compile_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "baseline_compile_time".into(),
                category: "javascript.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3234.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.pageload.delazification_time
    ///
    /// Time spent during page load delazifying Javascript in ms. (Migrated from the
    /// geckoview metric of the same name.)
    pub static delazification_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "delazification_time".into(),
                category: "javascript.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3235.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.pageload.execution_time
    ///
    /// Time spent during page load executing Javascript in ms. (Migrated from the
    /// geckoview metric of the same name.)
    pub static execution_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "execution_time".into(),
                category: "javascript.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3236.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.pageload.gc_time
    ///
    /// Time spent during page load in the GC in ms. (Migrated from the geckoview
    /// metric of the same name.)
    pub static gc_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gc_time".into(),
                category: "javascript.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3237.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.pageload.parse_time
    ///
    /// Time spent during page load syntax parsing JS scripts on the main thread in ms.
    /// (Migrated from the geckoview metric of the same name.)
    pub static parse_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "parse_time".into(),
                category: "javascript.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3238.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.pageload.protect_time
    ///
    /// Time spent during page load protecting JIT executable memory. (Migrated from
    /// the geckoview metric of the same name.)
    pub static protect_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "protect_time".into(),
                category: "javascript.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3239.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.pageload.xdr_encode_time
    ///
    /// Time spent during page load XDR encoding Javascript in ms. (Migrated from the
    /// geckoview metric of the same name.)
    pub static xdr_encode_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "xdr_encode_time".into(),
                category: "javascript.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3240.into(), meta, TimeUnit::Millisecond)
    });

}
pub mod mathml {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from mathml.doc_count
    ///
    /// The number of documents that contained enabled MathML elements. This metric was
    /// generated to correspond to the Legacy Telemetry scalar mathml.doc_count.
    pub static doc_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3241,
            "mathml",
            "doc_count",
            "metrics"
        )
    });

}
pub mod perf {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from perf.largest_contentful_paint
    ///
    /// Time from navigation start to largest contentful paint.
    pub static largest_contentful_paint: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "largest_contentful_paint".into(),
                category: "perf".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3242.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from perf.largest_contentful_paint_from_response_start
    ///
    /// Time from response start to largest contentful paint.
    pub static largest_contentful_paint_from_response_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "largest_contentful_paint_from_response_start".into(),
                category: "perf".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3243.into(), meta, TimeUnit::Millisecond)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PageLoadExtra {
        pub r#dns_lookup_time: Option<u32>,
        pub r#fcp_time: Option<u32>,
        pub r#features: Option<u32>,
        pub r#http_ver: Option<u32>,
        pub r#js_exec_time: Option<u32>,
        pub r#lcp_time: Option<u32>,
        pub r#load_time: Option<u32>,
        pub r#load_type: Option<String>,
        pub r#redirect_count: Option<u32>,
        pub r#redirect_time: Option<u32>,
        pub r#response_time: Option<u32>,
        pub r#same_origin_nav: Option<bool>,
        pub r#time_to_request_start: Option<u32>,
        pub r#trr_domain: Option<String>,
        pub r#using_webdriver: Option<bool>,
    }

    impl ExtraKeys for PageLoadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["dns_lookup_time", "fcp_time", "features", "http_ver", "js_exec_time", "lcp_time", "load_time", "load_type", "redirect_count", "redirect_time", "response_time", "same_origin_nav", "time_to_request_start", "trr_domain", "using_webdriver"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#dns_lookup_time.and_then(|val| map.insert("dns_lookup_time".into(), val.to_string()));
          self.r#fcp_time.and_then(|val| map.insert("fcp_time".into(), val.to_string()));
          self.r#features.and_then(|val| map.insert("features".into(), val.to_string()));
          self.r#http_ver.and_then(|val| map.insert("http_ver".into(), val.to_string()));
          self.r#js_exec_time.and_then(|val| map.insert("js_exec_time".into(), val.to_string()));
          self.r#lcp_time.and_then(|val| map.insert("lcp_time".into(), val.to_string()));
          self.r#load_time.and_then(|val| map.insert("load_time".into(), val.to_string()));
          self.r#load_type.and_then(|val| map.insert("load_type".into(), val.to_string()));
          self.r#redirect_count.and_then(|val| map.insert("redirect_count".into(), val.to_string()));
          self.r#redirect_time.and_then(|val| map.insert("redirect_time".into(), val.to_string()));
          self.r#response_time.and_then(|val| map.insert("response_time".into(), val.to_string()));
          self.r#same_origin_nav.and_then(|val| map.insert("same_origin_nav".into(), val.to_string()));
          self.r#time_to_request_start.and_then(|val| map.insert("time_to_request_start".into(), val.to_string()));
          self.r#trr_domain.and_then(|val| map.insert("trr_domain".into(), val.to_string()));
          self.r#using_webdriver.and_then(|val| map.insert("using_webdriver".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from perf.page_load
    ///
    /// Recorded when a top level content document has been loaded.
    pub static page_load: Lazy<EventMetric<PageLoadExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "page_load".into(),
                category: "perf".into(),
                send_in_pings: vec!["pageload".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3244.into(), meta)
    });

}
pub mod performance_pageload {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.fcp
    ///
    /// The time between navigationStart and the first contentful paint of a foreground
    /// http or https root content document, in milliseconds. The contentful paint
    /// timestamp is taken during display list building and does not include
    /// rasterization or compositing of that paint. (Migrated from the geckoview metric
    /// of the same name).
    pub static fcp: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fcp".into(),
                category: "performance.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3245.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.fcp_responsestart
    ///
    /// The time between responseStart and the first contentful paint of a foreground
    /// http or https root content document, in milliseconds. The contentful paint
    /// timestamp is taken during display list building and does not include
    /// rasterization or compositing of that paint. (Migrated from the geckoview metric
    /// of the same name).
    pub static fcp_responsestart: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fcp_responsestart".into(),
                category: "performance.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3246.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.h3p_fcp_with_priority
    ///
    /// The time between navigationStart and the first contentful paint of a foreground
    /// http or https root content document, in milliseconds. The contentful paint
    /// timestamp is taken during display list building and does not include
    /// rasterization or compositing of that paint. This is collected only on page load
    /// where the main document uses HTTP3. A "priority" header has been received.
    pub static h3p_fcp_with_priority: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "h3p_fcp_with_priority".into(),
                category: "performance.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3247.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.http3_fcp_http3
    ///
    /// The time between navigationStart and the first contentful paint of a foreground
    /// http or https root content document, in milliseconds. The contentful paint
    /// timestamp is taken during display list building and does not include
    /// rasterization or compositing of that paint. This is collected only on page load
    /// where the main document uses or suppports HTTP3.
    pub static http3_fcp_http3: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http3_fcp_http3".into(),
                category: "performance.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3248.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.http3_fcp_supports_http3
    ///
    /// The time between navigationStart and the first contentful paint of a foreground
    /// http or https root content document, in milliseconds. The contentful paint
    /// timestamp is taken during display list building and does not include
    /// rasterization or compositing of that paint. This is collected only on page load
    /// where the main document supports but is not using HTTP3.
    pub static http3_fcp_supports_http3: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http3_fcp_supports_http3".into(),
                category: "performance.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3249.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.http3_fcp_without_priority
    ///
    /// The time between navigationStart and the first contentful paint of a foreground
    /// http or https root content document, in milliseconds. The contentful paint
    /// timestamp is taken during display list building and does not include
    /// rasterization or compositing of that paint. This is collected only on page load
    /// where the main document uses HTTP3. A "priority" header has not been received.
    pub static http3_fcp_without_priority: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http3_fcp_without_priority".into(),
                category: "performance.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3250.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.load_time
    ///
    /// Time in milliseconds from navigationStart to loadEventStart for the foreground
    /// http or https root content document. (Migrated from the geckoview metric of the
    /// same name).
    pub static load_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_time".into(),
                category: "performance.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3251.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.load_time_responsestart
    ///
    /// Time in milliseconds from responseStart to loadEventStart for the foreground
    /// http or https root content document. (Migrated from the geckoview metric of the
    /// same name).
    pub static load_time_responsestart: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_time_responsestart".into(),
                category: "performance.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3252.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.async_sheet_load
    ///
    /// Time spent in milliseconds since a style sheet started loading async until it
    /// finished.
    pub static async_sheet_load: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "async_sheet_load".into(),
                category: "performance.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3253.into(), meta, TimeUnit::Millisecond)
    });

}
pub mod performance_time {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.dom_complete
    ///
    /// Time from navigationStart to domComplete as per the W3C Performance Timing API.
    /// (Migrated from the geckoview metric of the same name.)
    pub static dom_complete: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dom_complete".into(),
                category: "performance.time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3254.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.dom_content_loaded_end
    ///
    /// Time from navigationStart to domContentLoadedEventEnd as per the W3C
    /// Performance Timing API. (Migrated from the geckoview metric of the same name.)
    pub static dom_content_loaded_end: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dom_content_loaded_end".into(),
                category: "performance.time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3255.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.dom_content_loaded_start
    ///
    /// Time from navigationStart to domContentLoadedEventStart as per the W3C
    /// Performance Timing API. (Migrated from the geckoview metric of the same name.)
    pub static dom_content_loaded_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dom_content_loaded_start".into(),
                category: "performance.time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3256.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.dom_interactive
    ///
    /// Time from navigationStart to domInteractive as per the W3C Performance Timing
    /// API. (Migrated from the geckoview metric of the same name.)
    pub static dom_interactive: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dom_interactive".into(),
                category: "performance.time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3257.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.load_event_end
    ///
    /// Time from navigationStart to loadEventEnd as per the W3C Performance Timing
    /// API. (Migrated from the geckoview metric of the same name.)
    pub static load_event_end: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_event_end".into(),
                category: "performance.time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3258.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.load_event_start
    ///
    /// Time from navigationStart to loadEventStart as per the W3C Performance Timing
    /// API. (Migrated from the geckoview metric of the same name.)
    pub static load_event_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_event_start".into(),
                category: "performance.time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3259.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.response_start
    ///
    /// Time from navigationStart to responseStart as per the W3C Performance Timing
    /// API. (Migrated from the geckoview metric of the same name.)
    pub static response_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "response_start".into(),
                category: "performance.time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3260.into(), meta, TimeUnit::Millisecond)
    });

}
pub mod web_notification {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from web_notification.insecure_context_permission_request
    ///
    /// Whether we saw a permission request from an insecure context.
    pub static insecure_context_permission_request: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3261,
            "web_notification",
            "insecure_context_permission_request",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum PermissionOriginLabel {
        EFirstParty = 0,
        EThirdParty = 1,
        ENestedFirstParty = 2,
        __Other__,
    }
    impl From<u16> for PermissionOriginLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFirstParty,
                1 => Self::EThirdParty,
                2 => Self::ENestedFirstParty,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PermissionOriginLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFirstParty => "first_party",
                Self::EThirdParty => "third_party",
                Self::ENestedFirstParty => "nested_first_party",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from web_notification.permission_origin
    ///
    /// The category of the origin that retrieves Notification.permission.
    pub static permission_origin: Lazy<LabeledMetric<LabeledCounterMetric, PermissionOriginLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "permission_origin".into(),
                    category: "web_notification".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3262.into(), meta, Some(vec![::std::borrow::Cow::from("first_party"), ::std::borrow::Cow::from("nested_first_party"), ::std::borrow::Cow::from("third_party")]))
    });

    #[repr(u16)]
    pub enum RequestPermissionOriginLabel {
        EFirstParty = 0,
        EThirdParty = 1,
        ENestedFirstParty = 2,
        __Other__,
    }
    impl From<u16> for RequestPermissionOriginLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFirstParty,
                1 => Self::EThirdParty,
                2 => Self::ENestedFirstParty,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RequestPermissionOriginLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFirstParty => "first_party",
                Self::EThirdParty => "third_party",
                Self::ENestedFirstParty => "nested_first_party",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from web_notification.request_permission_origin
    ///
    /// The category of the origin that calls Notification.requestPermission().
    pub static request_permission_origin: Lazy<LabeledMetric<LabeledCounterMetric, RequestPermissionOriginLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "request_permission_origin".into(),
                    category: "web_notification".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3263.into(), meta, Some(vec![::std::borrow::Cow::from("first_party"), ::std::borrow::Cow::from("nested_first_party"), ::std::borrow::Cow::from("third_party")]))
    });

    #[repr(u16)]
    pub enum ShowOriginLabel {
        EFirstParty = 0,
        EThirdParty = 1,
        ENestedFirstParty = 2,
        __Other__,
    }
    impl From<u16> for ShowOriginLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFirstParty,
                1 => Self::EThirdParty,
                2 => Self::ENestedFirstParty,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ShowOriginLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFirstParty => "first_party",
                Self::EThirdParty => "third_party",
                Self::ENestedFirstParty => "nested_first_party",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from web_notification.show_origin
    ///
    /// The category of the origin that calls new Notification/showNotification().
    pub static show_origin: Lazy<LabeledMetric<LabeledCounterMetric, ShowOriginLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "show_origin".into(),
                    category: "web_notification".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3264.into(), meta, Some(vec![::std::borrow::Cow::from("first_party"), ::std::borrow::Cow::from("nested_first_party"), ::std::borrow::Cow::from("third_party")]))
    });

}
pub mod web_push {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from web_push.detected_duplicated_message_ids
    ///
    /// Counts the duplicated IDs from the server. The ability to detect depends on the
    /// pref `dom.push.maxRecentMessageIDsPerSubscription`.
    pub static detected_duplicated_message_ids: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3265,
            "web_push",
            "detected_duplicated_message_ids",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum ErrorCodeLabel {
        EDecryptionError = 0,
        ENotDelivered = 1,
        EUncaughtException = 2,
        EUnhandledRejection = 3,
        EInternalError = 4,
        __Other__,
    }
    impl From<u16> for ErrorCodeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDecryptionError,
                1 => Self::ENotDelivered,
                2 => Self::EUncaughtException,
                3 => Self::EUnhandledRejection,
                4 => Self::EInternalError,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ErrorCodeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDecryptionError => "decryption_error",
                Self::ENotDelivered => "not_delivered",
                Self::EUncaughtException => "uncaught_exception",
                Self::EUnhandledRejection => "unhandled_rejection",
                Self::EInternalError => "internal_error",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from web_push.error_code
    ///
    /// The code indicating why the push message couldn't be processed.
    pub static error_code: Lazy<LabeledMetric<LabeledCounterMetric, ErrorCodeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "error_code".into(),
                    category: "web_push".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3266.into(), meta, Some(vec![::std::borrow::Cow::from("decryption_error"), ::std::borrow::Cow::from("internal_error"), ::std::borrow::Cow::from("not_delivered"), ::std::borrow::Cow::from("uncaught_exception"), ::std::borrow::Cow::from("unhandled_rejection")]))
    });

}
pub mod dom_quota_try {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ErrorStepExtra {
        pub r#context: Option<String>,
        pub r#frame_id: Option<String>,
        pub r#process_id: Option<String>,
        pub r#result: Option<String>,
        pub r#seq: Option<u32>,
        pub r#severity: Option<String>,
        pub r#source_file: Option<String>,
        pub r#source_line: Option<u32>,
        pub r#stack_id: Option<String>,
    }

    impl ExtraKeys for ErrorStepExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["context", "frame_id", "process_id", "result", "seq", "severity", "source_file", "source_line", "stack_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#context.and_then(|val| map.insert("context".into(), val.to_string()));
          self.r#frame_id.and_then(|val| map.insert("frame_id".into(), val.to_string()));
          self.r#process_id.and_then(|val| map.insert("process_id".into(), val.to_string()));
          self.r#result.and_then(|val| map.insert("result".into(), val.to_string()));
          self.r#seq.and_then(|val| map.insert("seq".into(), val.to_string()));
          self.r#severity.and_then(|val| map.insert("severity".into(), val.to_string()));
          self.r#source_file.and_then(|val| map.insert("source_file".into(), val.to_string()));
          self.r#source_line.and_then(|val| map.insert("source_line".into(), val.to_string()));
          self.r#stack_id.and_then(|val| map.insert("stack_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from dom.quota.try.error_step
    ///
    /// An event recorded on an error of the quota manager or its clients. Since errors
    /// are usually propagated up the call chain, all such propagation steps are
    /// recorded for an error. This is only active during specific contexts, in
    /// particular during storage initialization. No dynamic data is included in the
    /// event beyond the error code which will be added through Bug 1670555. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// dom.quota.try.error#step.
    pub static error_step: Lazy<EventMetric<ErrorStepExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "error_step".into(),
                category: "dom.quota.try".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3267.into(), meta)
    });

}
pub mod httpsfirst {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.downgrade_time
    ///
    /// If a HTTPS-First (`dom.security.https_first` enabled) upgrade isn't successful,
    /// measures the timespan between the navigation start and the downgrade.
    pub static downgrade_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "downgrade_time".into(),
                category: "httpsfirst".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3268.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.downgrade_time_schemeless
    ///
    /// If a schemeless HTTPS-First (`dom.security.https_first` disabled, but load
    /// marked as schemeless) upgrade isn't successful, measures the timespan between
    /// the navigation start and the downgrade.
    pub static downgrade_time_schemeless: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "downgrade_time_schemeless".into(),
                category: "httpsfirst".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3269.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.downgraded
    ///
    /// How many regular HTTPS-First (`dom.security.https_first` enabled) upgrades fail
    /// and get downgraded again.
    pub static downgraded: Lazy<DenominatorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "downgraded".into(),
                category: "httpsfirst".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DenominatorMetric::new(3270.into(), meta, vec![CommonMetricData {name: "downgraded_on_timer".into(), category: "httpsfirst".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.downgraded_on_timer
    ///
    /// How many HTTPS-First (`dom.security.https_first` enabled) upgrades get
    /// downgraded again because the HTTP request fired after 3s received a answer
    /// faster than the HTTPS request.
    pub static downgraded_on_timer: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "downgraded_on_timer".into(),
                category: "httpsfirst".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3271.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.downgraded_on_timer_schemeless
    ///
    /// How many of schemeless HTTPS-First (`dom.security.https_first` disabled, but
    /// load marked as schemeless) upgrades get downgraded again because the HTTP
    /// request fired after 3s received a answer faster than the HTTPS request
    pub static downgraded_on_timer_schemeless: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "downgraded_on_timer_schemeless".into(),
                category: "httpsfirst".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3272.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.downgraded_schemeless
    ///
    /// How many schemeless HTTPS-First (`dom.security.https_first` disabled, but load
    /// marked as schemeless) upgrades fail and get downgraded again.
    pub static downgraded_schemeless: Lazy<DenominatorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "downgraded_schemeless".into(),
                category: "httpsfirst".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DenominatorMetric::new(3273.into(), meta, vec![CommonMetricData {name: "downgraded_on_timer_schemeless".into(), category: "httpsfirst".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.upgraded
    ///
    /// Counts how often a load is successfully upgraded to HTTPS because of HTTPS-
    /// First (`dom.security.https_first` enabled). This does not include loads that
    /// get downgraded again.
    pub static upgraded: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3274,
            "httpsfirst",
            "upgraded",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.upgraded_schemeless
    ///
    /// Counts how often a load is successfully upgraded to HTTPS because of schemeless
    /// HTTPS-First (`dom.security.https_first` disabled, but load marked as
    /// schemeless). This does not include loads that get downgraded again.
    pub static upgraded_schemeless: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3275,
            "httpsfirst",
            "upgraded_schemeless",
            "metrics"
        )
    });

}
pub mod webauthn_create {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum AuthenticatorAttachmentLabel {
        ECrossPlatform = 0,
        EPlatform = 1,
        EUnknown = 2,
        __Other__,
    }
    impl From<u16> for AuthenticatorAttachmentLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECrossPlatform,
                1 => Self::EPlatform,
                2 => Self::EUnknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AuthenticatorAttachmentLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECrossPlatform => "cross-platform",
                Self::EPlatform => "platform",
                Self::EUnknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webauthn_create.authenticator_attachment
    ///
    /// The number of successfully created credentials by authenticator attachment
    /// modality.
    pub static authenticator_attachment: Lazy<LabeledMetric<LabeledCounterMetric, AuthenticatorAttachmentLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "authenticator_attachment".into(),
                    category: "webauthn_create".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3276.into(), meta, Some(vec![::std::borrow::Cow::from("cross-platform"), ::std::borrow::Cow::from("platform"), ::std::borrow::Cow::from("unknown")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from webauthn_create.failure
    ///
    /// The total number of failed calls to navigator.credentials.create.
    pub static failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3277,
            "webauthn_create",
            "failure",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from webauthn_create.passkey
    ///
    /// The number of client-side discoverable credentials (passkeys) created.
    pub static passkey: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3278,
            "webauthn_create",
            "passkey",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from webauthn_create.success
    ///
    /// The total number of successful calls to navigator.credentials.create.
    pub static success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3279,
            "webauthn_create",
            "success",
            "metrics"
        )
    });

}
pub mod webauthn_get {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum AuthenticatorAttachmentLabel {
        ECrossPlatform = 0,
        EPlatform = 1,
        EUnknown = 2,
        __Other__,
    }
    impl From<u16> for AuthenticatorAttachmentLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECrossPlatform,
                1 => Self::EPlatform,
                2 => Self::EUnknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AuthenticatorAttachmentLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECrossPlatform => "cross-platform",
                Self::EPlatform => "platform",
                Self::EUnknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webauthn_get.authenticator_attachment
    ///
    /// The number of successfully asserted credentials by authenticator attachment
    /// modality.
    pub static authenticator_attachment: Lazy<LabeledMetric<LabeledCounterMetric, AuthenticatorAttachmentLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "authenticator_attachment".into(),
                    category: "webauthn_get".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3280.into(), meta, Some(vec![::std::borrow::Cow::from("cross-platform"), ::std::borrow::Cow::from("platform"), ::std::borrow::Cow::from("unknown")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from webauthn_get.failure
    ///
    /// The total number of failed calls to navigator.credentials.get.
    pub static failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3281,
            "webauthn_get",
            "failure",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from webauthn_get.success
    ///
    /// The total number of successful calls to navigator.credentials.get.
    pub static success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3282,
            "webauthn_get",
            "success",
            "metrics"
        )
    });

}
pub mod gfx {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.composite_time
    ///
    /// The time taken to composite a frame. On non-webrender this is the time taken in
    /// `CompositorBridgeParent::CompositeToTarget()`. On webrender, this is the time
    /// taken from the start of `WebRenderBridgeParent::CompositeToTarget()`, until the
    /// render thread has rendered the frame (in `RenderThread::HandleFrameOneDoc()`).
    /// (Migrated from the geckoview metric of the same name).
    pub static composite_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "composite_time".into(),
                category: "gfx".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3283.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.linux_window_protocol
    ///
    /// Windowing protocol on Linux. Can be Wayland, WaylandDRM, XWayland, or X11 This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// gfx.linux_window_protocol.
    pub static linux_window_protocol: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "linux_window_protocol".into(),
                category: "gfx".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3284.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.os_compositor
    ///
    /// Boolean indicating whether the os compositor is being used by WebRender. Only
    /// collected in the first subsession. This metric was generated to correspond to
    /// the Legacy Telemetry scalar gfx.os_compositor.
    pub static os_compositor: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "os_compositor".into(),
                category: "gfx".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3285.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.scroll_present_latency
    ///
    /// Time between receiving a scroll event on the event loop and compositing its
    /// result onto the screen (ms). (Migrated from the geckoview metric of the same
    /// name).
    pub static scroll_present_latency: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "scroll_present_latency".into(),
                category: "gfx".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3286.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.skipped_composites
    ///
    /// Number of skipped composites, happening when rendering is too slow to keep up
    /// with content. This metric was generated to correspond to the Legacy Telemetry
    /// scalar gfx.skipped_composites.
    pub static skipped_composites: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3287,
            "gfx",
            "skipped_composites",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.supports_hdr
    ///
    /// Does the hardware support accurate display of HDR content This metric was
    /// generated to correspond to the Legacy Telemetry scalar gfx.supports_hdr.
    pub static supports_hdr: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "supports_hdr".into(),
                category: "gfx".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3288.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.tmp_writable
    ///
    /// Is the system temporary directory writable This metric was generated to
    /// correspond to the Legacy Telemetry scalar gfx.tmp_writable.
    pub static tmp_writable: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tmp_writable".into(),
                category: "gfx".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3289.into(), meta)
    });

}
pub mod gfx_adapter_primary {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.description
    ///
    /// Long form description of the Graphics adapter (Migrated from the geckoview
    /// metric of the same name).
    pub static description: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "description".into(),
                category: "gfx.adapter.primary".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3290.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.device_id
    ///
    /// Graphics adapter device identification (Migrated from the geckoview metric of
    /// the same name).
    pub static device_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "device_id".into(),
                category: "gfx.adapter.primary".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3291.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.driver_date
    ///
    /// Graphics adapter driver date (Migrated from the geckoview metric of the same
    /// name).
    pub static driver_date: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "driver_date".into(),
                category: "gfx.adapter.primary".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3292.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.driver_files
    ///
    /// List of graphics adapter driver files (Migrated from the geckoview metric of
    /// the same name).
    pub static driver_files: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "driver_files".into(),
                category: "gfx.adapter.primary".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3293.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.driver_vendor
    ///
    /// Graphics adapter driver vendor identification (Migrated from the geckoview
    /// metric of the same name).
    pub static driver_vendor: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "driver_vendor".into(),
                category: "gfx.adapter.primary".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3294.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.driver_version
    ///
    /// Graphics adapter driver version (Migrated from the geckoview metric of the same
    /// name).
    pub static driver_version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "driver_version".into(),
                category: "gfx.adapter.primary".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3295.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.ram
    ///
    /// Graphics adapter dedicated memory (Migrated from the geckoview metric of the
    /// same name).
    pub static ram: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ram".into(),
                category: "gfx.adapter.primary".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3296.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.subsystem_id
    ///
    /// Graphics adapter subsystem identification (Migrated from the geckoview metric
    /// of the same name).
    pub static subsystem_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "subsystem_id".into(),
                category: "gfx.adapter.primary".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3297.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.vendor_id
    ///
    /// Graphics adapter vendor identification (Migrated from the geckoview metric of
    /// the same name).
    pub static vendor_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "vendor_id".into(),
                category: "gfx.adapter.primary".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3298.into(), meta)
    });

}
pub mod gfx_checkerboard {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.checkerboard.duration
    ///
    /// The duration of a checkerboard event. Checkerboarding is when painting has not
    /// kept up with asynchronous panning and zooming so the compositor has to display
    /// a "checkerboard pattern" (or in practice, the background color) rather than the
    /// actual page content. (Migrated from the geckoview metric of the same name).
    pub static duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "duration".into(),
                category: "gfx.checkerboard".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3299.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.checkerboard.peak_pixel_count
    ///
    /// The peak number of CSS pixels that checkerboarded during a checkerboard event.
    /// The minimum value of the largest histogram bucket is the size of a 4k display
    /// with maximum APZ zooming. (Migrated from the geckoview metric of the same
    /// name).
    pub static peak_pixel_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "peak_pixel_count".into(),
                category: "gfx.checkerboard".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3300.into(), meta, 1, 66355200, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.checkerboard.potential_duration
    ///
    /// The total amount of time that we could reasonably be checkerboarding. This is
    /// the union of two possibly-intersecting sets of time periods: The first set is
    /// that in which checkerboarding was actually happening, since by definition it
    /// could potentially be happening. The second set is that in which the APZC is
    /// actively transforming content in the compositor, since it could potentially
    /// transform it so as to display checkerboarding to the user. Combined with other
    /// information, this allows us to meaningfully say how frequently users actually
    /// enncounters checkerboarding. (Migrated from the geckoview metric of the same
    /// name).
    pub static potential_duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "potential_duration".into(),
                category: "gfx.checkerboard".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3301.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.checkerboard.severity
    ///
    /// An opaque measurement of the severity of a checkerboard event. This doesn't
    /// have units, it's just useful for comparing two checkerboard events to see which
    /// one is worse, for some implementation-specific definition of "worse". The
    /// larger the value, the worse the checkerboarding. (Migrated from the geckoview
    /// metric of the same name).
    pub static severity: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "severity".into(),
                category: "gfx.checkerboard".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3302.into(), meta, 1, 1073741824, 50, HistogramType::Exponential)
    });

}
pub mod gfx_content {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.full_paint_time
    ///
    /// Time spent in the full paint pipeline for content until it's ready for
    /// composition. For non-webrender this includes `paint_time`, plus rasterization
    /// if OMTP is enabled. For webrender, this includes `paint_time`, plus scene
    /// building time. (Migrated from the geckoview metric of the same name).
    pub static full_paint_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "full_paint_time".into(),
                category: "gfx.content".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3303.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.paint_time
    ///
    /// Time spent in the main-thread paint pipeline for content. For non-webrender,
    /// this includes display list building, layer building, and when OMTP is disabled,
    /// rasterization. For webrender, this includes display list building, and
    /// webrender display list building. (Migrated from the geckoview metric of the
    /// same name).
    pub static paint_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "paint_time".into(),
                category: "gfx.content".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3304.into(), meta, TimeUnit::Millisecond)
    });

}
pub mod gfx_content_frame_time {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.frame_time.from_paint
    ///
    /// The time, in percentage of a vsync interval, spent from beginning a paint in
    /// the content process until that frame is presented in the compositor. (Migrated
    /// from the geckoview metric of the same name).
    pub static from_paint: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "from_paint".into(),
                category: "gfx.content.frame_time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3305.into(), meta, 1, 5000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.frame_time.from_vsync
    ///
    /// The time, in percentage of a vsync interval, spent from the vsync that started
    /// a paint in the content process until that frame is presented in the compositor.
    /// (Migrated from the geckoview metric of the same name).
    pub static from_vsync: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "from_vsync".into(),
                category: "gfx.content.frame_time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3306.into(), meta, 8, 792, 100, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum ReasonLabel {
        EOnTime = 0,
        ENoVsync = 1,
        EMissedComposite = 2,
        ESlowComposite = 3,
        EMissedCompositeMid = 4,
        EMissedCompositeLong = 5,
        EMissedCompositeLow = 6,
        ENoVsyncNoId = 7,
        __Other__,
    }
    impl From<u16> for ReasonLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOnTime,
                1 => Self::ENoVsync,
                2 => Self::EMissedComposite,
                3 => Self::ESlowComposite,
                4 => Self::EMissedCompositeMid,
                5 => Self::EMissedCompositeLong,
                6 => Self::EMissedCompositeLow,
                7 => Self::ENoVsyncNoId,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ReasonLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOnTime => "on_time",
                Self::ENoVsync => "no_vsync",
                Self::EMissedComposite => "missed_composite",
                Self::ESlowComposite => "slow_composite",
                Self::EMissedCompositeMid => "missed_composite_mid",
                Self::EMissedCompositeLong => "missed_composite_long",
                Self::EMissedCompositeLow => "missed_composite_low",
                Self::ENoVsyncNoId => "no_vsync_no_id",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.frame_time.reason
    ///
    /// The reason that `gfx.content.frame_time.from_paint` recorded a slow (>200ms)
    /// result, if any. (Migrated from the geckoview metric of the same name).
    pub static reason: Lazy<LabeledMetric<LabeledCounterMetric, ReasonLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "reason".into(),
                    category: "gfx.content.frame_time".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3307.into(), meta, Some(vec![::std::borrow::Cow::from("missed_composite"), ::std::borrow::Cow::from("missed_composite_long"), ::std::borrow::Cow::from("missed_composite_low"), ::std::borrow::Cow::from("missed_composite_mid"), ::std::borrow::Cow::from("no_vsync"), ::std::borrow::Cow::from("no_vsync_no_id"), ::std::borrow::Cow::from("on_time"), ::std::borrow::Cow::from("slow_composite")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.frame_time.with_svg
    ///
    /// The time, in percentage of a vsync interval, spent from beginning a paint in
    /// the content process until that frame is presented in the compositor, for frames
    /// that contained an SVG to be drawn by webrender. (Migrated from the geckoview
    /// metric of the same name).
    pub static with_svg: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "with_svg".into(),
                category: "gfx.content.frame_time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3308.into(), meta, 1, 5000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.frame_time.without_resource_upload
    ///
    /// The time, in percentage of a vsync interval, spent from beginning a paint in
    /// the content process until that frame is presented in the compositor by
    /// webrender, excluding time spent uploading resources. (Migrated from the
    /// geckoview metric of the same name).
    pub static without_resource_upload: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "without_resource_upload".into(),
                category: "gfx.content.frame_time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3309.into(), meta, 1, 5000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.frame_time.without_upload
    ///
    /// The time, in percentage of a vsync interval, spent from beginning a paint in
    /// the content process until that frame is presented in the compositor by
    /// webrender, excluding time spent uploading any content. (Migrated from the
    /// geckoview metric of the same name).
    pub static without_upload: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "without_upload".into(),
                category: "gfx.content.frame_time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3310.into(), meta, 1, 5000, 50, HistogramType::Exponential)
    });

}
pub mod gfx_display {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.display.count
    ///
    /// Amount of displays connected to the device (Migrated from the geckoview metric
    /// of the same name).
    pub static count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "count".into(),
                category: "gfx.display".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3311.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.display.primary_height
    ///
    /// Height of the primary display, takes device rotation into account. (Migrated
    /// from the geckoview metric of the same name).
    pub static primary_height: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "primary_height".into(),
                category: "gfx.display".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3312.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.display.primary_width
    ///
    /// Width of the primary display, takes device rotation into account. (Migrated
    /// from the geckoview metric of the same name).
    pub static primary_width: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "primary_width".into(),
                category: "gfx.display".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3313.into(), meta)
    });

}
pub mod gfx_feature {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.feature.webrender
    ///
    /// Whether webrender is enabled or disabled, and why. (Migrated from the geckoview
    /// metric of the same name).
    pub static webrender: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "webrender".into(),
                category: "gfx.feature".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3314.into(), meta)
    });

}
pub mod gfx_hdr {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.hdr.windows_display_colorspace_bitfield
    ///
    /// A bitfield representation of the available DXGI color spaces of the connected
    /// displays on Windows. See (https://docs.microsoft.com/en-
    /// us/windows/desktop/api/dxgicommon/ne-dxgicommon- dxgi_color_space_type) for
    /// definitions of color spaces. Each N'th bit of this scalar indicates whether the
    /// DXGI color space with index 'N' is available on at least one connected monitor.
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// gfx.hdr.windows_display_colorspace_bitfield.
    pub static windows_display_colorspace_bitfield: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "windows_display_colorspace_bitfield".into(),
                category: "gfx.hdr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3315.into(), meta)
    });

}
pub mod gfx_status {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.status.compositor
    ///
    /// Name of the graphics compositor in use. Possible values are "opengl, d3d11,
    /// client, webrender or basic" (Migrated from the geckoview metric of the same
    /// name).
    pub static compositor: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "compositor".into(),
                category: "gfx.status".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3316.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.status.headless
    ///
    /// Boolean indicated whether graphics is running in headless (no display) mode
    /// (Migrated from the geckoview metric of the same name).
    pub static headless: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "headless".into(),
                category: "gfx.status".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3317.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.status.last_compositor_gecko_version
    ///
    /// The gecko version at the last time a compositor was initialized, and therefore
    /// when gfx_status_compositor was last updated. Due to gfx_status_compositor's
    /// user lifetime we see lots of unexpected values for the current gecko version.
    /// We believe this is because the user has not opened a tab since they were
    /// updated to a version where webrender should be enabled on their device. This
    /// can be used to verify that theory. (Migrated from the geckoview metric of the
    /// same name).
    pub static last_compositor_gecko_version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "last_compositor_gecko_version".into(),
                category: "gfx.status".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3318.into(), meta)
    });

}
pub mod gpu_process {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum CrashFallbacksLabel {
        ENone = 0,
        EDecodingDisabled = 1,
        EDisabled = 2,
        __Other__,
    }
    impl From<u16> for CrashFallbacksLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENone,
                1 => Self::EDecodingDisabled,
                2 => Self::EDisabled,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CrashFallbacksLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENone => "none",
                Self::EDecodingDisabled => "decoding_disabled",
                Self::EDisabled => "disabled",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from gpu_process.crash_fallbacks
    ///
    /// How often we use different fallbacks when the GPU process crashes
    pub static crash_fallbacks: Lazy<LabeledMetric<LabeledCounterMetric, CrashFallbacksLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "crash_fallbacks".into(),
                    category: "gpu_process".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3319.into(), meta, Some(vec![::std::borrow::Cow::from("decoding_disabled"), ::std::borrow::Cow::from("disabled"), ::std::borrow::Cow::from("none")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from gpu_process.feature_status
    ///
    /// Current status of the GPU process feature
    pub static feature_status: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "feature_status".into(),
                category: "gpu_process".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3320.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gpu_process.total_launch_attempts
    ///
    /// The number of total GPU process launch attempts.
    pub static total_launch_attempts: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_launch_attempts".into(),
                category: "gpu_process".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3321.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gpu_process.unstable_launch_attempts
    ///
    /// The number of consecutive unstable launch attempts.
    pub static unstable_launch_attempts: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unstable_launch_attempts".into(),
                category: "gpu_process".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3322.into(), meta)
    });

}
pub mod paint {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from paint.build_displaylist_time
    ///
    /// The time to build a Gecko display list.
    pub static build_displaylist_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "build_displaylist_time".into(),
                category: "paint".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3323.into(), meta, TimeUnit::Nanosecond)
    });

}
pub mod wr {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from wr.framebuild_time
    ///
    /// The time to rasterize glyphs for consumption by WebRender.
    pub static framebuild_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "framebuild_time".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3324.into(), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.gpu_wait_time
    ///
    /// The time spent waiting for the GPU to complete previously issued drawing
    /// commands.
    pub static gpu_wait_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gpu_wait_time".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3325.into(), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.rasterize_blobs_time
    ///
    /// The time to rasterize blobs for consumption by WebRender.
    pub static rasterize_blobs_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "rasterize_blobs_time".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3326.into(), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.rasterize_glyphs_time
    ///
    /// The time to rasterize glyphs for consumption by WebRender.
    pub static rasterize_glyphs_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "rasterize_glyphs_time".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3327.into(), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.renderer_time
    ///
    /// WebRender renderer time.
    pub static renderer_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "renderer_time".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3328.into(), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.renderer_time_no_sc
    ///
    /// WebRender renderer time excluding frames in which shader compilation took
    /// place.
    pub static renderer_time_no_sc: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "renderer_time_no_sc".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3329.into(), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.scenebuild_time
    ///
    /// WebRender scene build time.
    pub static scenebuild_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "scenebuild_time".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3330.into(), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.sceneswap_time
    ///
    /// WebRender scene swap time.
    pub static sceneswap_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sceneswap_time".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3331.into(), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.texture_cache_update_time
    ///
    /// Time taken by WebRender to update the texture cache.
    pub static texture_cache_update_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "texture_cache_update_time".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3332.into(), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.time_to_frame_build
    ///
    /// Time elapsed between the construction of a transaction and the associated frame
    /// build beginning.
    pub static time_to_frame_build: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time_to_frame_build".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3333.into(), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.time_to_render_start
    ///
    /// Time elapsed between the construction of a frame and the start of rendering.
    pub static time_to_render_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time_to_render_start".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3334.into(), meta, TimeUnit::Microsecond)
    });

}
pub mod avif {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum A1lxLabel {
        EPresent = 0,
        EAbsent = 1,
        __Other__,
    }
    impl From<u16> for A1lxLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresent,
                1 => Self::EAbsent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for A1lxLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresent => "present",
                Self::EAbsent => "absent",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.a1lx
    ///
    /// AV1LayeredImageIndexingProperty (a1lx). (Migrated from the geckoview metric of
    /// the same name).
    pub static a1lx: Lazy<LabeledMetric<LabeledCounterMetric, A1lxLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "a1lx".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3335.into(), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum A1opLabel {
        EPresent = 0,
        EAbsent = 1,
        __Other__,
    }
    impl From<u16> for A1opLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresent,
                1 => Self::EAbsent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for A1opLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresent => "present",
                Self::EAbsent => "absent",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.a1op
    ///
    /// AVIF OperatingPointSelectorProperty (a1op). (Migrated from the geckoview metric
    /// of the same name).
    pub static a1op: Lazy<LabeledMetric<LabeledCounterMetric, A1opLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "a1op".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3336.into(), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum AlphaLabel {
        EAbsent = 0,
        EPresent = 1,
        __Other__,
    }
    impl From<u16> for AlphaLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAbsent,
                1 => Self::EPresent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AlphaLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAbsent => "absent",
                Self::EPresent => "present",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.alpha
    ///
    /// AVIF alpha plane. (Migrated from the geckoview metric of the same name).
    pub static alpha: Lazy<LabeledMetric<LabeledCounterMetric, AlphaLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "alpha".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3337.into(), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum AomDecodeErrorLabel {
        EError = 0,
        EMemError = 1,
        EAbiMismatch = 2,
        EIncapable = 3,
        EUnsupBitstream = 4,
        EUnsupFeature = 5,
        ECorruptFrame = 6,
        EInvalidParam = 7,
        __Other__,
    }
    impl From<u16> for AomDecodeErrorLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EError,
                1 => Self::EMemError,
                2 => Self::EAbiMismatch,
                3 => Self::EIncapable,
                4 => Self::EUnsupBitstream,
                5 => Self::EUnsupFeature,
                6 => Self::ECorruptFrame,
                7 => Self::EInvalidParam,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AomDecodeErrorLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EError => "error",
                Self::EMemError => "mem_error",
                Self::EAbiMismatch => "abi_mismatch",
                Self::EIncapable => "incapable",
                Self::EUnsupBitstream => "unsup_bitstream",
                Self::EUnsupFeature => "unsup_feature",
                Self::ECorruptFrame => "corrupt_frame",
                Self::EInvalidParam => "invalid_param",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.aom_decode_error
    ///
    /// Image-decode Error from AOM decoder (Migrated from the geckoview metric of the
    /// same name).
    pub static aom_decode_error: Lazy<LabeledMetric<LabeledCounterMetric, AomDecodeErrorLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "aom_decode_error".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3338.into(), meta, Some(vec![::std::borrow::Cow::from("abi_mismatch"), ::std::borrow::Cow::from("corrupt_frame"), ::std::borrow::Cow::from("error"), ::std::borrow::Cow::from("incapable"), ::std::borrow::Cow::from("invalid_param"), ::std::borrow::Cow::from("mem_error"), ::std::borrow::Cow::from("unsup_bitstream"), ::std::borrow::Cow::from("unsup_feature")]))
    });

    #[repr(u16)]
    pub enum BitDepthLabel {
        EColor8 = 0,
        EColor10 = 1,
        EColor12 = 2,
        EColor16 = 3,
        EUnknown = 4,
        __Other__,
    }
    impl From<u16> for BitDepthLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EColor8,
                1 => Self::EColor10,
                2 => Self::EColor12,
                3 => Self::EColor16,
                4 => Self::EUnknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for BitDepthLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EColor8 => "color_8",
                Self::EColor10 => "color_10",
                Self::EColor12 => "color_12",
                Self::EColor16 => "color_16",
                Self::EUnknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.bit_depth
    ///
    /// Bits per pixel of AVIF image. (Migrated from the geckoview metric of the same
    /// name).
    pub static bit_depth: Lazy<LabeledMetric<LabeledCounterMetric, BitDepthLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "bit_depth".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3339.into(), meta, Some(vec![::std::borrow::Cow::from("color_10"), ::std::borrow::Cow::from("color_12"), ::std::borrow::Cow::from("color_16"), ::std::borrow::Cow::from("color_8"), ::std::borrow::Cow::from("unknown")]))
    });

    #[repr(u16)]
    pub enum CicpCpLabel {
        EReserved = 0,
        EBt709 = 1,
        EUnspecified = 2,
        EReserved3 = 3,
        EBt470m = 4,
        EBt470bg = 5,
        EBt601 = 6,
        ESmpte240 = 7,
        EGenericFilm = 8,
        EBt2020 = 9,
        EXyz = 10,
        ESmpte431 = 11,
        ESmpte432 = 12,
        EReserved13 = 13,
        EReserved14 = 14,
        EReserved15 = 15,
        EReserved16 = 16,
        EReserved17 = 17,
        EReserved18 = 18,
        EReserved19 = 19,
        EReserved20 = 20,
        EReserved21 = 21,
        EEbu3213 = 22,
        EReservedRest = 23,
        __Other__,
    }
    impl From<u16> for CicpCpLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EReserved,
                1 => Self::EBt709,
                2 => Self::EUnspecified,
                3 => Self::EReserved3,
                4 => Self::EBt470m,
                5 => Self::EBt470bg,
                6 => Self::EBt601,
                7 => Self::ESmpte240,
                8 => Self::EGenericFilm,
                9 => Self::EBt2020,
                10 => Self::EXyz,
                11 => Self::ESmpte431,
                12 => Self::ESmpte432,
                13 => Self::EReserved13,
                14 => Self::EReserved14,
                15 => Self::EReserved15,
                16 => Self::EReserved16,
                17 => Self::EReserved17,
                18 => Self::EReserved18,
                19 => Self::EReserved19,
                20 => Self::EReserved20,
                21 => Self::EReserved21,
                22 => Self::EEbu3213,
                23 => Self::EReservedRest,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CicpCpLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EReserved => "reserved",
                Self::EBt709 => "bt709",
                Self::EUnspecified => "unspecified",
                Self::EReserved3 => "reserved_3",
                Self::EBt470m => "bt470m",
                Self::EBt470bg => "bt470bg",
                Self::EBt601 => "bt601",
                Self::ESmpte240 => "smpte240",
                Self::EGenericFilm => "generic_film",
                Self::EBt2020 => "bt2020",
                Self::EXyz => "xyz",
                Self::ESmpte431 => "smpte431",
                Self::ESmpte432 => "smpte432",
                Self::EReserved13 => "reserved_13",
                Self::EReserved14 => "reserved_14",
                Self::EReserved15 => "reserved_15",
                Self::EReserved16 => "reserved_16",
                Self::EReserved17 => "reserved_17",
                Self::EReserved18 => "reserved_18",
                Self::EReserved19 => "reserved_19",
                Self::EReserved20 => "reserved_20",
                Self::EReserved21 => "reserved_21",
                Self::EEbu3213 => "ebu3213",
                Self::EReservedRest => "reserved_rest",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.cicp_cp
    ///
    /// AVIF CICP colour primaries. (Migrated from the geckoview metric of the same
    /// name).
    pub static cicp_cp: Lazy<LabeledMetric<LabeledCounterMetric, CicpCpLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cicp_cp".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3340.into(), meta, Some(vec![::std::borrow::Cow::from("bt2020"), ::std::borrow::Cow::from("bt470bg"), ::std::borrow::Cow::from("bt470m"), ::std::borrow::Cow::from("bt601"), ::std::borrow::Cow::from("bt709"), ::std::borrow::Cow::from("ebu3213"), ::std::borrow::Cow::from("generic_film"), ::std::borrow::Cow::from("reserved"), ::std::borrow::Cow::from("reserved_13"), ::std::borrow::Cow::from("reserved_14"), ::std::borrow::Cow::from("reserved_15"), ::std::borrow::Cow::from("reserved_16"), ::std::borrow::Cow::from("reserved_17"), ::std::borrow::Cow::from("reserved_18"), ::std::borrow::Cow::from("reserved_19"), ::std::borrow::Cow::from("reserved_20"), ::std::borrow::Cow::from("reserved_21"), ::std::borrow::Cow::from("reserved_3"), ::std::borrow::Cow::from("reserved_rest"), ::std::borrow::Cow::from("smpte240"), ::std::borrow::Cow::from("smpte431"), ::std::borrow::Cow::from("smpte432"), ::std::borrow::Cow::from("unspecified"), ::std::borrow::Cow::from("xyz")]))
    });

    #[repr(u16)]
    pub enum CicpMcLabel {
        EIdentity = 0,
        EBt709 = 1,
        EUnspecified = 2,
        EReserved = 3,
        EFcc = 4,
        EBt470bg = 5,
        EBt601 = 6,
        ESmpte240 = 7,
        EYcgco = 8,
        EBt2020Ncl = 9,
        EBt2020Cl = 10,
        ESmpte2085 = 11,
        EChromatNcl = 12,
        EChromatCl = 13,
        EIctcp = 14,
        EReservedRest = 15,
        __Other__,
    }
    impl From<u16> for CicpMcLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EIdentity,
                1 => Self::EBt709,
                2 => Self::EUnspecified,
                3 => Self::EReserved,
                4 => Self::EFcc,
                5 => Self::EBt470bg,
                6 => Self::EBt601,
                7 => Self::ESmpte240,
                8 => Self::EYcgco,
                9 => Self::EBt2020Ncl,
                10 => Self::EBt2020Cl,
                11 => Self::ESmpte2085,
                12 => Self::EChromatNcl,
                13 => Self::EChromatCl,
                14 => Self::EIctcp,
                15 => Self::EReservedRest,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CicpMcLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EIdentity => "identity",
                Self::EBt709 => "bt709",
                Self::EUnspecified => "unspecified",
                Self::EReserved => "reserved",
                Self::EFcc => "fcc",
                Self::EBt470bg => "bt470bg",
                Self::EBt601 => "bt601",
                Self::ESmpte240 => "smpte240",
                Self::EYcgco => "ycgco",
                Self::EBt2020Ncl => "bt2020_ncl",
                Self::EBt2020Cl => "bt2020_cl",
                Self::ESmpte2085 => "smpte2085",
                Self::EChromatNcl => "chromat_ncl",
                Self::EChromatCl => "chromat_cl",
                Self::EIctcp => "ictcp",
                Self::EReservedRest => "reserved_rest",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.cicp_mc
    ///
    /// AVIF CICP transfer characteristics. (Migrated from the geckoview metric of the
    /// same name).
    pub static cicp_mc: Lazy<LabeledMetric<LabeledCounterMetric, CicpMcLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cicp_mc".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3341.into(), meta, Some(vec![::std::borrow::Cow::from("bt2020_cl"), ::std::borrow::Cow::from("bt2020_ncl"), ::std::borrow::Cow::from("bt470bg"), ::std::borrow::Cow::from("bt601"), ::std::borrow::Cow::from("bt709"), ::std::borrow::Cow::from("chromat_cl"), ::std::borrow::Cow::from("chromat_ncl"), ::std::borrow::Cow::from("fcc"), ::std::borrow::Cow::from("ictcp"), ::std::borrow::Cow::from("identity"), ::std::borrow::Cow::from("reserved"), ::std::borrow::Cow::from("reserved_rest"), ::std::borrow::Cow::from("smpte2085"), ::std::borrow::Cow::from("smpte240"), ::std::borrow::Cow::from("unspecified"), ::std::borrow::Cow::from("ycgco")]))
    });

    #[repr(u16)]
    pub enum CicpTcLabel {
        EReserved = 0,
        EBt709 = 1,
        EUnspecified = 2,
        EReserved3 = 3,
        EBt470m = 4,
        EBt470bg = 5,
        EBt601 = 6,
        ESmpte240 = 7,
        ELinear = 8,
        ELog100 = 9,
        ELog100Sqrt10 = 10,
        EIec61966 = 11,
        EBt1361 = 12,
        ESrgb = 13,
        EBt202010bit = 14,
        EBt202012bit = 15,
        ESmpte2084 = 16,
        ESmpte428 = 17,
        EHlg = 18,
        EReservedRest = 19,
        __Other__,
    }
    impl From<u16> for CicpTcLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EReserved,
                1 => Self::EBt709,
                2 => Self::EUnspecified,
                3 => Self::EReserved3,
                4 => Self::EBt470m,
                5 => Self::EBt470bg,
                6 => Self::EBt601,
                7 => Self::ESmpte240,
                8 => Self::ELinear,
                9 => Self::ELog100,
                10 => Self::ELog100Sqrt10,
                11 => Self::EIec61966,
                12 => Self::EBt1361,
                13 => Self::ESrgb,
                14 => Self::EBt202010bit,
                15 => Self::EBt202012bit,
                16 => Self::ESmpte2084,
                17 => Self::ESmpte428,
                18 => Self::EHlg,
                19 => Self::EReservedRest,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CicpTcLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EReserved => "reserved",
                Self::EBt709 => "bt709",
                Self::EUnspecified => "unspecified",
                Self::EReserved3 => "reserved_3",
                Self::EBt470m => "bt470m",
                Self::EBt470bg => "bt470bg",
                Self::EBt601 => "bt601",
                Self::ESmpte240 => "smpte240",
                Self::ELinear => "linear",
                Self::ELog100 => "log_100",
                Self::ELog100Sqrt10 => "log_100_sqrt10",
                Self::EIec61966 => "iec61966",
                Self::EBt1361 => "bt_1361",
                Self::ESrgb => "srgb",
                Self::EBt202010bit => "bt2020_10bit",
                Self::EBt202012bit => "bt2020_12bit",
                Self::ESmpte2084 => "smpte2084",
                Self::ESmpte428 => "smpte428",
                Self::EHlg => "hlg",
                Self::EReservedRest => "reserved_rest",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.cicp_tc
    ///
    /// AVIF CICP transfer characteristics. (Migrated from the geckoview metric of the
    /// same name).
    pub static cicp_tc: Lazy<LabeledMetric<LabeledCounterMetric, CicpTcLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cicp_tc".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3342.into(), meta, Some(vec![::std::borrow::Cow::from("bt2020_10bit"), ::std::borrow::Cow::from("bt2020_12bit"), ::std::borrow::Cow::from("bt470bg"), ::std::borrow::Cow::from("bt470m"), ::std::borrow::Cow::from("bt601"), ::std::borrow::Cow::from("bt709"), ::std::borrow::Cow::from("bt_1361"), ::std::borrow::Cow::from("hlg"), ::std::borrow::Cow::from("iec61966"), ::std::borrow::Cow::from("linear"), ::std::borrow::Cow::from("log_100"), ::std::borrow::Cow::from("log_100_sqrt10"), ::std::borrow::Cow::from("reserved"), ::std::borrow::Cow::from("reserved_3"), ::std::borrow::Cow::from("reserved_rest"), ::std::borrow::Cow::from("smpte2084"), ::std::borrow::Cow::from("smpte240"), ::std::borrow::Cow::from("smpte428"), ::std::borrow::Cow::from("srgb"), ::std::borrow::Cow::from("unspecified")]))
    });

    #[repr(u16)]
    pub enum ClapLabel {
        EPresent = 0,
        EAbsent = 1,
        __Other__,
    }
    impl From<u16> for ClapLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresent,
                1 => Self::EAbsent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ClapLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresent => "present",
                Self::EAbsent => "absent",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.clap
    ///
    /// AVIF CleanApertureBox (clap). (Migrated from the geckoview metric of the same
    /// name).
    pub static clap: Lazy<LabeledMetric<LabeledCounterMetric, ClapLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "clap".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3343.into(), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum ColrLabel {
        ENclx = 0,
        EIcc = 1,
        EAbsent = 2,
        EBoth = 3,
        __Other__,
    }
    impl From<u16> for ColrLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENclx,
                1 => Self::EIcc,
                2 => Self::EAbsent,
                3 => Self::EBoth,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ColrLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENclx => "nclx",
                Self::EIcc => "icc",
                Self::EAbsent => "absent",
                Self::EBoth => "both",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.colr
    ///
    /// AVIF colour information type. (Migrated from the geckoview metric of the same
    /// name).
    pub static colr: Lazy<LabeledMetric<LabeledCounterMetric, ColrLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "colr".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3344.into(), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("both"), ::std::borrow::Cow::from("icc"), ::std::borrow::Cow::from("nclx")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct Dav1dGetPictureReturnValueExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for Dav1dGetPictureReturnValueExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.dav1d_get_picture_return_value
    ///
    /// Return value from dav1d_get_picture This event was generated to correspond to
    /// the Legacy Telemetry event avif.dav1d_get_picture#return_value.
    pub static dav1d_get_picture_return_value: Lazy<EventMetric<Dav1dGetPictureReturnValueExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dav1d_get_picture_return_value".into(),
                category: "avif".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3345.into(), meta)
    });

    #[repr(u16)]
    pub enum DecodeResultLabel {
        ESuccess = 0,
        EParseError = 1,
        ENoPrimaryItem = 2,
        EDecodeError = 3,
        ESizeOverflow = 4,
        EOutOfMemory = 5,
        EPipeInitError = 6,
        EWriteBufferError = 7,
        EAlphaYSzMismatch = 8,
        EAlphaYBpcMismatch = 9,
        EIspeMismatch = 10,
        ERenderSizeMismatch = 11,
        EFrameSizeChanged = 12,
        EInvalidCicp = 13,
        EInvalidParseStatus = 14,
        EMissingBrand = 15,
        EFtypNotFirst = 16,
        ENoImage = 17,
        EMultipleMoov = 18,
        ENoMoov = 19,
        ELselNoEssential = 20,
        EA1opNoEssential = 21,
        EA1lxEssential = 22,
        ETxformNoEssential = 23,
        EImageItemType = 24,
        EItemTypeMissing = 25,
        EConstructionMethod = 26,
        EItemLocNotFound = 27,
        ENoItemDataBox = 28,
        ENoSamples = 29,
        EConvertycbcrFailure = 30,
        EUncategorized = 31,
        __Other__,
    }
    impl From<u16> for DecodeResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EParseError,
                2 => Self::ENoPrimaryItem,
                3 => Self::EDecodeError,
                4 => Self::ESizeOverflow,
                5 => Self::EOutOfMemory,
                6 => Self::EPipeInitError,
                7 => Self::EWriteBufferError,
                8 => Self::EAlphaYSzMismatch,
                9 => Self::EAlphaYBpcMismatch,
                10 => Self::EIspeMismatch,
                11 => Self::ERenderSizeMismatch,
                12 => Self::EFrameSizeChanged,
                13 => Self::EInvalidCicp,
                14 => Self::EInvalidParseStatus,
                15 => Self::EMissingBrand,
                16 => Self::EFtypNotFirst,
                17 => Self::ENoImage,
                18 => Self::EMultipleMoov,
                19 => Self::ENoMoov,
                20 => Self::ELselNoEssential,
                21 => Self::EA1opNoEssential,
                22 => Self::EA1lxEssential,
                23 => Self::ETxformNoEssential,
                24 => Self::EImageItemType,
                25 => Self::EItemTypeMissing,
                26 => Self::EConstructionMethod,
                27 => Self::EItemLocNotFound,
                28 => Self::ENoItemDataBox,
                29 => Self::ENoSamples,
                30 => Self::EConvertycbcrFailure,
                31 => Self::EUncategorized,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for DecodeResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EParseError => "parse_error",
                Self::ENoPrimaryItem => "no_primary_item",
                Self::EDecodeError => "decode_error",
                Self::ESizeOverflow => "size_overflow",
                Self::EOutOfMemory => "out_of_memory",
                Self::EPipeInitError => "pipe_init_error",
                Self::EWriteBufferError => "write_buffer_error",
                Self::EAlphaYSzMismatch => "alpha_y_sz_mismatch",
                Self::EAlphaYBpcMismatch => "alpha_y_bpc_mismatch",
                Self::EIspeMismatch => "ispe_mismatch",
                Self::ERenderSizeMismatch => "render_size_mismatch",
                Self::EFrameSizeChanged => "frame_size_changed",
                Self::EInvalidCicp => "invalid_cicp",
                Self::EInvalidParseStatus => "invalid_parse_status",
                Self::EMissingBrand => "missing_brand",
                Self::EFtypNotFirst => "ftyp_not_first",
                Self::ENoImage => "no_image",
                Self::EMultipleMoov => "multiple_moov",
                Self::ENoMoov => "no_moov",
                Self::ELselNoEssential => "lsel_no_essential",
                Self::EA1opNoEssential => "a1op_no_essential",
                Self::EA1lxEssential => "a1lx_essential",
                Self::ETxformNoEssential => "txform_no_essential",
                Self::EImageItemType => "image_item_type",
                Self::EItemTypeMissing => "item_type_missing",
                Self::EConstructionMethod => "construction_method",
                Self::EItemLocNotFound => "item_loc_not_found",
                Self::ENoItemDataBox => "no_item_data_box",
                Self::ENoSamples => "no_samples",
                Self::EConvertycbcrFailure => "ConvertYCbCr_failure",
                Self::EUncategorized => "uncategorized",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.decode_result
    ///
    /// Decode result of AVIF image. (Migrated from the geckoview metric of the same
    /// name).
    pub static decode_result: Lazy<LabeledMetric<LabeledCounterMetric, DecodeResultLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "decode_result".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3346.into(), meta, Some(vec![::std::borrow::Cow::from("ConvertYCbCr_failure"), ::std::borrow::Cow::from("a1lx_essential"), ::std::borrow::Cow::from("a1op_no_essential"), ::std::borrow::Cow::from("alpha_y_bpc_mismatch"), ::std::borrow::Cow::from("alpha_y_sz_mismatch"), ::std::borrow::Cow::from("construction_method"), ::std::borrow::Cow::from("decode_error"), ::std::borrow::Cow::from("frame_size_changed"), ::std::borrow::Cow::from("ftyp_not_first"), ::std::borrow::Cow::from("image_item_type"), ::std::borrow::Cow::from("invalid_cicp"), ::std::borrow::Cow::from("invalid_parse_status"), ::std::borrow::Cow::from("ispe_mismatch"), ::std::borrow::Cow::from("item_loc_not_found"), ::std::borrow::Cow::from("item_type_missing"), ::std::borrow::Cow::from("lsel_no_essential"), ::std::borrow::Cow::from("missing_brand"), ::std::borrow::Cow::from("multiple_moov"), ::std::borrow::Cow::from("no_image"), ::std::borrow::Cow::from("no_item_data_box"), ::std::borrow::Cow::from("no_moov"), ::std::borrow::Cow::from("no_primary_item"), ::std::borrow::Cow::from("no_samples"), ::std::borrow::Cow::from("out_of_memory"), ::std::borrow::Cow::from("parse_error"), ::std::borrow::Cow::from("pipe_init_error"), ::std::borrow::Cow::from("render_size_mismatch"), ::std::borrow::Cow::from("size_overflow"), ::std::borrow::Cow::from("success"), ::std::borrow::Cow::from("txform_no_essential"), ::std::borrow::Cow::from("uncategorized"), ::std::borrow::Cow::from("write_buffer_error")]))
    });

    #[repr(u16)]
    pub enum DecoderLabel {
        EDav1d = 0,
        EAom = 1,
        __Other__,
    }
    impl From<u16> for DecoderLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDav1d,
                1 => Self::EAom,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for DecoderLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDav1d => "dav1d",
                Self::EAom => "aom",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.decoder
    ///
    /// Decoder of AVIF image. (Migrated from the geckoview metric of the same name).
    pub static decoder: Lazy<LabeledMetric<LabeledCounterMetric, DecoderLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "decoder".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3347.into(), meta, Some(vec![::std::borrow::Cow::from("aom"), ::std::borrow::Cow::from("dav1d")]))
    });

    #[repr(u16)]
    pub enum GridLabel {
        EPresent = 0,
        EAbsent = 1,
        __Other__,
    }
    impl From<u16> for GridLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresent,
                1 => Self::EAbsent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GridLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresent => "present",
                Self::EAbsent => "absent",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.grid
    ///
    /// AVIF AVIF grid-based image. (Migrated from the geckoview metric of the same
    /// name).
    pub static grid: Lazy<LabeledMetric<LabeledCounterMetric, GridLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "grid".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3348.into(), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum IproLabel {
        EPresent = 0,
        EAbsent = 1,
        __Other__,
    }
    impl From<u16> for IproLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresent,
                1 => Self::EAbsent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for IproLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresent => "present",
                Self::EAbsent => "absent",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.ipro
    ///
    /// AVIF ItemProtectionBox (ipro). (Migrated from the geckoview metric of the same
    /// name).
    pub static ipro: Lazy<LabeledMetric<LabeledCounterMetric, IproLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "ipro".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3349.into(), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum IspeLabel {
        EValid = 0,
        EAbsent = 1,
        EBitstreamMismatch = 2,
        __Other__,
    }
    impl From<u16> for IspeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EValid,
                1 => Self::EAbsent,
                2 => Self::EBitstreamMismatch,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for IspeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EValid => "valid",
                Self::EAbsent => "absent",
                Self::EBitstreamMismatch => "bitstream_mismatch",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.ispe
    ///
    /// AVIF spatial extents (image size). (Migrated from the geckoview metric of the
    /// same name).
    pub static ispe: Lazy<LabeledMetric<LabeledCounterMetric, IspeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "ispe".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3350.into(), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("bitstream_mismatch"), ::std::borrow::Cow::from("valid")]))
    });

    #[repr(u16)]
    pub enum LselLabel {
        EPresent = 0,
        EAbsent = 1,
        __Other__,
    }
    impl From<u16> for LselLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresent,
                1 => Self::EAbsent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for LselLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresent => "present",
                Self::EAbsent => "absent",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.lsel
    ///
    /// AVIF LayerSelectorProperty (lsel). (Migrated from the geckoview metric of the
    /// same name).
    pub static lsel: Lazy<LabeledMetric<LabeledCounterMetric, LselLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "lsel".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3351.into(), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum PaspLabel {
        EAbsent = 0,
        ESquare = 1,
        ENonsquare = 2,
        EInvalid = 3,
        __Other__,
    }
    impl From<u16> for PaspLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAbsent,
                1 => Self::ESquare,
                2 => Self::ENonsquare,
                3 => Self::EInvalid,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PaspLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAbsent => "absent",
                Self::ESquare => "square",
                Self::ENonsquare => "nonsquare",
                Self::EInvalid => "invalid",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.pasp
    ///
    /// AVIF pixel aspect ratio. (Migrated from the geckoview metric of the same name).
    pub static pasp: Lazy<LabeledMetric<LabeledCounterMetric, PaspLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "pasp".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3352.into(), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("invalid"), ::std::borrow::Cow::from("nonsquare"), ::std::borrow::Cow::from("square")]))
    });

    #[repr(u16)]
    pub enum PixiLabel {
        EValid = 0,
        EAbsent = 1,
        EBitstreamMismatch = 2,
        __Other__,
    }
    impl From<u16> for PixiLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EValid,
                1 => Self::EAbsent,
                2 => Self::EBitstreamMismatch,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PixiLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EValid => "valid",
                Self::EAbsent => "absent",
                Self::EBitstreamMismatch => "bitstream_mismatch",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.pixi
    ///
    /// AVIF pixel information (bits per channel). (Migrated from the geckoview metric
    /// of the same name).
    pub static pixi: Lazy<LabeledMetric<LabeledCounterMetric, PixiLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "pixi".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3353.into(), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("bitstream_mismatch"), ::std::borrow::Cow::from("valid")]))
    });

    #[repr(u16)]
    pub enum YuvColorSpaceLabel {
        EBt601 = 0,
        EBt709 = 1,
        EBt2020 = 2,
        EIdentity = 3,
        EUnknown = 4,
        __Other__,
    }
    impl From<u16> for YuvColorSpaceLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EBt601,
                1 => Self::EBt709,
                2 => Self::EBt2020,
                3 => Self::EIdentity,
                4 => Self::EUnknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for YuvColorSpaceLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EBt601 => "bt601",
                Self::EBt709 => "bt709",
                Self::EBt2020 => "bt2020",
                Self::EIdentity => "identity",
                Self::EUnknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.yuv_color_space
    ///
    /// YUV color space of AVIF image. (Migrated from the geckoview metric of the same
    /// name).
    pub static yuv_color_space: Lazy<LabeledMetric<LabeledCounterMetric, YuvColorSpaceLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "yuv_color_space".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3354.into(), meta, Some(vec![::std::borrow::Cow::from("bt2020"), ::std::borrow::Cow::from("bt601"), ::std::borrow::Cow::from("bt709"), ::std::borrow::Cow::from("identity"), ::std::borrow::Cow::from("unknown")]))
    });

}
pub mod javascript_gc {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.compact_time
    ///
    /// The time spent in the compact phase. (Migrated from the geckoview metric of the
    /// same name.)
    pub static compact_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "compact_time".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3355.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.mark_roots_time
    ///
    /// The time spent marking GC roots. (Migrated from the geckoview metric of the
    /// same name.)
    pub static mark_roots_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mark_roots_time".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3356.into(), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.mark_time
    ///
    /// The time spent in the mark phase. (Migrated from the geckoview metric of the
    /// same name.)
    pub static mark_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mark_time".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3357.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.minor_time
    ///
    /// The time taked by a minor (nursery) collection. (Migrated from the geckoview
    /// metric of the same name.)
    pub static minor_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "minor_time".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3358.into(), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.prepare_time
    ///
    /// The time spent in the preparation phase. (Migrated from the geckoview metric of
    /// the same name.)
    pub static prepare_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prepare_time".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3359.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.slice_time
    ///
    /// The time spent running a GC slice. (Migrated from the geckoview metric of the
    /// same name.)
    pub static slice_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "slice_time".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3360.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.sweep_time
    ///
    /// The time spent in the sweep phase. (Migrated from the geckoview metric of the
    /// same name.)
    pub static sweep_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sweep_time".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3361.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.total_time
    ///
    /// The total time taken by a major collection. (Migrated from the geckoview metric
    /// of the same name.)
    pub static total_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_time".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3362.into(), meta, TimeUnit::Millisecond)
    });

}
pub mod performance_clone_deserialize {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from performance.clone.deserialize.items
    ///
    /// Size of deserialized data, in items
    pub static items: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "items".into(),
                category: "performance.clone.deserialize".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3363.into(), meta, 1, 2147483646, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.clone.deserialize.size
    ///
    /// Size of deserialized data, in bytes
    pub static size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "size".into(),
                category: "performance.clone.deserialize".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(3364.into(), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.clone.deserialize.time
    ///
    /// Time spent deserializing structured data
    pub static time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time".into(),
                category: "performance.clone.deserialize".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3365.into(), meta, TimeUnit::Microsecond)
    });

}
pub mod slow_script_warning {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShownBrowserExtra {
        pub r#hang_duration: Option<String>,
        pub r#uri_type: Option<String>,
    }

    impl ExtraKeys for ShownBrowserExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["hang_duration", "uri_type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#hang_duration.and_then(|val| map.insert("hang_duration".into(), val.to_string()));
          self.r#uri_type.and_then(|val| map.insert("uri_type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from slow_script_warning.shown_browser
    ///
    /// Recorded when a slow script hang is resolved. This event was generated to
    /// correspond to the Legacy Telemetry event slow_script_warning.shown#browser.
    pub static shown_browser: Lazy<EventMetric<ShownBrowserExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shown_browser".into(),
                category: "slow_script_warning".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3366.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShownContentExtra {
        pub r#end_reason: Option<String>,
        pub r#hang_duration: Option<String>,
        pub r#n_tab_deselect: Option<u32>,
        pub r#uptime: Option<String>,
        pub r#uri_type: Option<String>,
        pub r#wait_count: Option<u32>,
    }

    impl ExtraKeys for ShownContentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["end_reason", "hang_duration", "n_tab_deselect", "uptime", "uri_type", "wait_count"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#end_reason.and_then(|val| map.insert("end_reason".into(), val.to_string()));
          self.r#hang_duration.and_then(|val| map.insert("hang_duration".into(), val.to_string()));
          self.r#n_tab_deselect.and_then(|val| map.insert("n_tab_deselect".into(), val.to_string()));
          self.r#uptime.and_then(|val| map.insert("uptime".into(), val.to_string()));
          self.r#uri_type.and_then(|val| map.insert("uri_type".into(), val.to_string()));
          self.r#wait_count.and_then(|val| map.insert("wait_count".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from slow_script_warning.shown_content
    ///
    /// Recorded when a slow script hang is resolved. This event was generated to
    /// correspond to the Legacy Telemetry event slow_script_warning.shown#content.
    pub static shown_content: Lazy<EventMetric<ShownContentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shown_content".into(),
                category: "slow_script_warning".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3367.into(), meta)
    });

}
pub mod geckoview {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from geckoview.content_process_lifetime
    ///
    /// The uptime of content processes. (Migrated from the geckoview metric of the
    /// same name).
    pub static content_process_lifetime: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "content_process_lifetime".into(),
                category: "geckoview".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3368.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from geckoview.document_site_origins
    ///
    /// When a document is loaded, report the number of [site
    /// origins](https://searchfox.org/ mozilla-central/rev/
    /// 3300072e993ae05d50d5c63d815260367eaf9179/ caps/nsIPrincipal.idl#264) of the
    /// entire browser if it has been at least 5 minutes since last time we collect
    /// this data. (Migrated from the geckoview metric of the same name).
    pub static document_site_origins: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "document_site_origins".into(),
                category: "geckoview".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3369.into(), meta, 0, 100, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from geckoview.page_load_progress_time
    ///
    /// Time between page load progress starts (0) and completion (100). (Migrated from
    /// the geckoview metric of the same name).
    pub static page_load_progress_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "page_load_progress_time".into(),
                category: "geckoview".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3370.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from geckoview.page_load_time
    ///
    /// The time taken to load a page. This includes all static contents, no dynamic
    /// content. Loading of about: pages is not counted. Back back navigation
    /// (sometimes via BFCache) is included which is a source of bimodality due to the
    /// <50ms load times. (Migrated from the geckoview metric of the same name).
    pub static page_load_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "page_load_time".into(),
                category: "geckoview".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3371.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from geckoview.page_reload_time
    ///
    /// Time taken to reload a page. This includes all static contents, no dynamic
    /// content. Loading of about: pages is not counted. (Migrated from the geckoview
    /// metric of the same name).
    pub static page_reload_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "page_reload_time".into(),
                category: "geckoview".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3372.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from geckoview.per_document_site_origins
    ///
    /// When a document is unloaded, report the highest number of [site
    /// origins](https://searchfox.org/ mozilla-central/rev/
    /// 3300072e993ae05d50d5c63d815260367eaf9179/ caps/nsIPrincipal.idl#264) loaded
    /// simultaneously in that document. (Migrated from the geckoview metric of the
    /// same name).
    pub static per_document_site_origins: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "per_document_site_origins".into(),
                category: "geckoview".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3373.into(), meta, 0, 100, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from geckoview.startup_runtime
    ///
    /// The time taken to initialize GeckoRuntime. (Migrated from the geckoview metric
    /// of the same name).
    pub static startup_runtime: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "startup_runtime".into(),
                category: "geckoview".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3374.into(), meta, TimeUnit::Millisecond)
    });

}
pub mod zero_byte_load {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadCssExtra {
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadCssExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_css
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death
    /// analysis. When a file is loaded synchronously, this event gets recorded in
    /// nsJARChannel::Open if the content length is zero. For asynchronous loads, this
    /// event gets recorded in onStopRequest. Note that when the load has been
    /// cancelled, the consumer could already receive some data, so this event also
    /// captures non-zero-byte loads. This event was generated to correspond to the
    /// Legacy Telemetry event zero_byte_load.load#css.
    pub static load_css: Lazy<EventMetric<LoadCssExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_css".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3375.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadDtdExtra {
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadDtdExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_dtd
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death
    /// analysis. When a file is loaded synchronously, this event gets recorded in
    /// nsJARChannel::Open if the content length is zero. For asynchronous loads, this
    /// event gets recorded in onStopRequest. Note that when the load has been
    /// cancelled, the consumer could already receive some data, so this event also
    /// captures non-zero-byte loads. This event was generated to correspond to the
    /// Legacy Telemetry event zero_byte_load.load#dtd.
    pub static load_dtd: Lazy<EventMetric<LoadDtdExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_dtd".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3376.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadFtlExtra {
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadFtlExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_ftl
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death
    /// analysis. When a file is loaded synchronously, this event gets recorded in
    /// nsJARChannel::Open if the content length is zero. For asynchronous loads, this
    /// event gets recorded in onStopRequest. Note that when the load has been
    /// cancelled, the consumer could already receive some data, so this event also
    /// captures non-zero-byte loads. This event was generated to correspond to the
    /// Legacy Telemetry event zero_byte_load.load#ftl.
    pub static load_ftl: Lazy<EventMetric<LoadFtlExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_ftl".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3377.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadHtmlExtra {
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadHtmlExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_html
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death
    /// analysis. When a file is loaded synchronously, this event gets recorded in
    /// nsJARChannel::Open if the content length is zero. For asynchronous loads, this
    /// event gets recorded in onStopRequest. Note that when the load has been
    /// cancelled, the consumer could already receive some data, so this event also
    /// captures non-zero-byte loads. This event was generated to correspond to the
    /// Legacy Telemetry event zero_byte_load.load#html.
    pub static load_html: Lazy<EventMetric<LoadHtmlExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_html".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3378.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadJsExtra {
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadJsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_js
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death
    /// analysis. When a file is loaded synchronously, this event gets recorded in
    /// nsJARChannel::Open if the content length is zero. For asynchronous loads, this
    /// event gets recorded in onStopRequest. Note that when the load has been
    /// cancelled, the consumer could already receive some data, so this event also
    /// captures non-zero-byte loads. This event was generated to correspond to the
    /// Legacy Telemetry event zero_byte_load.load#js.
    pub static load_js: Lazy<EventMetric<LoadJsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_js".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3379.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadJsonExtra {
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadJsonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_json
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death
    /// analysis. When a file is loaded synchronously, this event gets recorded in
    /// nsJARChannel::Open if the content length is zero. For asynchronous loads, this
    /// event gets recorded in onStopRequest. Note that when the load has been
    /// cancelled, the consumer could already receive some data, so this event also
    /// captures non-zero-byte loads. This event was generated to correspond to the
    /// Legacy Telemetry event zero_byte_load.load#json.
    pub static load_json: Lazy<EventMetric<LoadJsonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_json".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3380.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadOthersExtra {
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadOthersExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_others
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death
    /// analysis. When a file is loaded synchronously, this event gets recorded in
    /// nsJARChannel::Open if the content length is zero. For asynchronous loads, this
    /// event gets recorded in onStopRequest. Note that when the load has been
    /// cancelled, the consumer could already receive some data, so this event also
    /// captures non-zero-byte loads. This event was generated to correspond to the
    /// Legacy Telemetry event zero_byte_load.load#others.
    pub static load_others: Lazy<EventMetric<LoadOthersExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_others".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3381.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadPngExtra {
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadPngExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_png
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death
    /// analysis. When a file is loaded synchronously, this event gets recorded in
    /// nsJARChannel::Open if the content length is zero. For asynchronous loads, this
    /// event gets recorded in onStopRequest. Note that when the load has been
    /// cancelled, the consumer could already receive some data, so this event also
    /// captures non-zero-byte loads. This event was generated to correspond to the
    /// Legacy Telemetry event zero_byte_load.load#png.
    pub static load_png: Lazy<EventMetric<LoadPngExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_png".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3382.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadPropertiesExtra {
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadPropertiesExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_properties
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death
    /// analysis. When a file is loaded synchronously, this event gets recorded in
    /// nsJARChannel::Open if the content length is zero. For asynchronous loads, this
    /// event gets recorded in onStopRequest. Note that when the load has been
    /// cancelled, the consumer could already receive some data, so this event also
    /// captures non-zero-byte loads. This event was generated to correspond to the
    /// Legacy Telemetry event zero_byte_load.load#properties.
    pub static load_properties: Lazy<EventMetric<LoadPropertiesExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_properties".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3383.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadSvgExtra {
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadSvgExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_svg
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death
    /// analysis. When a file is loaded synchronously, this event gets recorded in
    /// nsJARChannel::Open if the content length is zero. For asynchronous loads, this
    /// event gets recorded in onStopRequest. Note that when the load has been
    /// cancelled, the consumer could already receive some data, so this event also
    /// captures non-zero-byte loads. This event was generated to correspond to the
    /// Legacy Telemetry event zero_byte_load.load#svg.
    pub static load_svg: Lazy<EventMetric<LoadSvgExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_svg".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3384.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadXhtmlExtra {
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadXhtmlExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_xhtml
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death
    /// analysis. When a file is loaded synchronously, this event gets recorded in
    /// nsJARChannel::Open if the content length is zero. For asynchronous loads, this
    /// event gets recorded in onStopRequest. Note that when the load has been
    /// cancelled, the consumer could already receive some data, so this event also
    /// captures non-zero-byte loads. This event was generated to correspond to the
    /// Legacy Telemetry event zero_byte_load.load#xhtml.
    pub static load_xhtml: Lazy<EventMetric<LoadXhtmlExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_xhtml".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3385.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadXmlExtra {
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadXmlExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_xml
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death
    /// analysis. When a file is loaded synchronously, this event gets recorded in
    /// nsJARChannel::Open if the content length is zero. For asynchronous loads, this
    /// event gets recorded in onStopRequest. Note that when the load has been
    /// cancelled, the consumer could already receive some data, so this event also
    /// captures non-zero-byte loads. This event was generated to correspond to the
    /// Legacy Telemetry event zero_byte_load.load#xml.
    pub static load_xml: Lazy<EventMetric<LoadXmlExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_xml".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3386.into(), meta)
    });

}
pub mod preferences {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from preferences.prefs_file_was_invalid
    ///
    /// Set to true if a failure occurred reading profile/prefs.js. This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// preferences.prefs_file_was_invalid.
    pub static prefs_file_was_invalid: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_file_was_invalid".into(),
                category: "preferences".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3387.into(), meta)
    });

}
pub mod network_dns {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TrrConfirmationContextExtra {
        pub r#attemptCount: Option<u32>,
        pub r#captivePortal: Option<String>,
        pub r#contextReason: Option<String>,
        pub r#failedLookups: Option<String>,
        pub r#networkID: Option<String>,
        pub r#results: Option<String>,
        pub r#time: Option<String>,
        pub r#trigger: Option<String>,
        pub r#value: Option<u32>,
    }

    impl ExtraKeys for TrrConfirmationContextExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["attemptCount", "captivePortal", "contextReason", "failedLookups", "networkID", "results", "time", "trigger", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#attemptCount.and_then(|val| map.insert("attemptCount".into(), val.to_string()));
          self.r#captivePortal.and_then(|val| map.insert("captivePortal".into(), val.to_string()));
          self.r#contextReason.and_then(|val| map.insert("contextReason".into(), val.to_string()));
          self.r#failedLookups.and_then(|val| map.insert("failedLookups".into(), val.to_string()));
          self.r#networkID.and_then(|val| map.insert("networkID".into(), val.to_string()));
          self.r#results.and_then(|val| map.insert("results".into(), val.to_string()));
          self.r#time.and_then(|val| map.insert("time".into(), val.to_string()));
          self.r#trigger.and_then(|val| map.insert("trigger".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.dns.trr_confirmation_context
    ///
    /// This telemetry records the status of the TRR confirmation across. The value of
    /// the event is one of:   "ok"   "trying" This event was generated to correspond
    /// to the Legacy Telemetry event network.dns.trrConfirmation#context.
    pub static trr_confirmation_context: Lazy<EventMetric<TrrConfirmationContextExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "trr_confirmation_context".into(),
                category: "network.dns".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3388.into(), meta)
    });

}
pub mod netwerk {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum Http30rttStateLabel {
        ENotUsed = 0,
        ESucceeded = 1,
        ERejected = 2,
        EConnError = 3,
        EConnClosedByNecko = 4,
        __Other__,
    }
    impl From<u16> for Http30rttStateLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENotUsed,
                1 => Self::ESucceeded,
                2 => Self::ERejected,
                3 => Self::EConnError,
                4 => Self::EConnClosedByNecko,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Http30rttStateLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENotUsed => "not_used",
                Self::ESucceeded => "succeeded",
                Self::ERejected => "rejected",
                Self::EConnError => "conn_error",
                Self::EConnClosedByNecko => "conn_closed_by_necko",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from netwerk.http3_0rtt_state
    ///
    /// Gather the outcome of 0-RTT usage: - "not_used": 0RTT_NOT_USED - "succeeded":
    /// 0RTT_USED_SUCCESS - "rejected": 0RTT_USED_REJECT - "conn_error":
    /// 0RTT_USED_CONN_ERROR - "conn_closed_by_necko": 0RTT_CONN_CLOSED_BY_NECKO
    pub static http3_0rtt_state: Lazy<LabeledMetric<LabeledCounterMetric, Http30rttStateLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http3_0rtt_state".into(),
                    category: "netwerk".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3389.into(), meta, Some(vec![::std::borrow::Cow::from("conn_closed_by_necko"), ::std::borrow::Cow::from("conn_error"), ::std::borrow::Cow::from("not_used"), ::std::borrow::Cow::from("rejected"), ::std::borrow::Cow::from("succeeded")]))
    });

    #[repr(u16)]
    pub enum Http30rttStateDurationLabel {
        ESucceeded = 0,
        ERejected = 1,
        EConnError = 2,
        EConnClosedByNecko = 3,
        ENotUsed = 4,
        __Other__,
    }
    impl From<u16> for Http30rttStateDurationLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESucceeded,
                1 => Self::ERejected,
                2 => Self::EConnError,
                3 => Self::EConnClosedByNecko,
                4 => Self::ENotUsed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Http30rttStateDurationLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESucceeded => "succeeded",
                Self::ERejected => "rejected",
                Self::EConnError => "conn_error",
                Self::EConnClosedByNecko => "conn_closed_by_necko",
                Self::ENotUsed => "not_used",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from netwerk.http3_0rtt_state_duration
    ///
    /// The time a connection was in the 0-RTT state
    pub static http3_0rtt_state_duration: Lazy<LabeledMetric<LabeledTimingDistributionMetric, Http30rttStateDurationLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "http3_0rtt_state_duration".into(),
                    category: "netwerk".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(3390.into(), meta, Some(vec![::std::borrow::Cow::from("conn_closed_by_necko"), ::std::borrow::Cow::from("conn_error"), ::std::borrow::Cow::from("not_used"), ::std::borrow::Cow::from("rejected"), ::std::borrow::Cow::from("succeeded")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from netwerk.parent_connect_timeout
    ///
    /// Counts how often the parent-connect-timeout timer is necessary to clear up
    /// EarlyHintPreloader
    pub static parent_connect_timeout: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3391,
            "netwerk",
            "parent_connect_timeout",
            "metrics"
        )
    });

}
pub mod network {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum ByteRangeRequestLabel {
        ECacheable = 0,
        ENotCacheable = 1,
        __Other__,
    }
    impl From<u16> for ByteRangeRequestLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECacheable,
                1 => Self::ENotCacheable,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ByteRangeRequestLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECacheable => "cacheable",
                Self::ENotCacheable => "not_cacheable",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.byte_range_request
    ///
    /// Counts of cacheable/non-cacheable byte-range requests
    pub static byte_range_request: Lazy<LabeledMetric<LabeledCounterMetric, ByteRangeRequestLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "byte_range_request".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3392.into(), meta, Some(vec![::std::borrow::Cow::from("cacheable"), ::std::borrow::Cow::from("not_cacheable")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.cache_hit_time
    ///
    /// Time to open existing cache entry file. (Migrated from the geckoview metric of
    /// the same name).
    pub static cache_hit_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cache_hit_time".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3393.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.cache_read_time
    ///
    /// In the HTTP page channel, time from connection cache read start to cache read
    /// end. Corresponds to Legacy histogram HTTP_PAGE_CACHE_READ_TIME_V2 in Desktop.
    pub static cache_read_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cache_read_time".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3394.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.complete_load
    ///
    /// In the HTTP page channel, time from connection open to complete load (cache
    /// read end/until the last byte received) Corresponds to Legacy histogram
    /// HTTP_PAGE_COMPLETE_LOAD_V2 in Desktop.
    pub static complete_load: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "complete_load".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3395.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.complete_load_cached
    ///
    /// In the HTTP page channel, time from connection open to cache read end.
    /// Corresponds to Legacy histogram HTTP_PAGE_COMPLETE_LOAD_CACHED_V2 in Desktop.
    pub static complete_load_cached: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "complete_load_cached".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3396.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.complete_load_net
    ///
    /// In the HTTP page channel, time from connection open to the last byte received.
    /// Corresponds to Legacy histogram HTTP_PAGE_COMPLETE_LOAD_NET_V2 in Desktop.
    pub static complete_load_net: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "complete_load_net".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3397.into(), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum CorsAuthorizationHeaderLabel {
        EAllowed = 0,
        EDisallowed = 1,
        ECoveredByWildcard = 2,
        __Other__,
    }
    impl From<u16> for CorsAuthorizationHeaderLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAllowed,
                1 => Self::EDisallowed,
                2 => Self::ECoveredByWildcard,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CorsAuthorizationHeaderLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAllowed => "allowed",
                Self::EDisallowed => "disallowed",
                Self::ECoveredByWildcard => "covered_by_wildcard",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.cors_authorization_header
    ///
    /// Count how many times we see `Authorization` header in `Access-Control-Request-
    /// Headers` header and the possible outcomes.
    pub static cors_authorization_header: Lazy<LabeledMetric<LabeledCounterMetric, CorsAuthorizationHeaderLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cors_authorization_header".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3398.into(), meta, Some(vec![::std::borrow::Cow::from("allowed"), ::std::borrow::Cow::from("covered_by_wildcard"), ::std::borrow::Cow::from("disallowed")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.dns_end
    ///
    /// In the HTTP page channel, time from the DNS request being issued to the
    /// response. Corresponds to Legacy histogram HTTP_PAGE_DNS_LOOKUP_TIME in Desktop.
    /// (Migrated from the geckoview metric of the same name).
    pub static dns_end: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dns_end".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3399.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.dns_start
    ///
    /// In the HTTP page channel, time from connection open to the DNS request being
    /// issued. Corresponds to Legacy histogram HTTP_PAGE_DNS_ISSUE_TIME in Desktop.
    /// (Migrated from the geckoview metric of the same name).
    pub static dns_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dns_start".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3400.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.first_from_cache
    ///
    /// In the HTTP page channel, time from connection open to cache read start.
    /// Corresponds to Legacy histogram HTTP_PAGE_OPEN_TO_FIRST_FROM_CACHE_V2 in
    /// Desktop.
    pub static first_from_cache: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "first_from_cache".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3401.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.first_sent_to_last_received
    ///
    /// In the HTTP page channel, time from first byte of request sent to the last byte
    /// received. Corresponds to Legacy histogram HTTP_PAGE_FIRST_SENT_TO_LAST_RECEIVED
    /// in Desktop. (Migrated from the geckoview metric of the same name).
    pub static first_sent_to_last_received: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "first_sent_to_last_received".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3402.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.font_download_end
    ///
    /// Time after navigationStart that all webfont downloads are completed. (Migrated
    /// from the geckoview metric of the same name).
    pub static font_download_end: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_download_end".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3403.into(), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum Http3CompleteLoadLabel {
        EUsesHttp3Page = 0,
        EUsesHttp3Sub = 1,
        ESupportsHttp3Page = 2,
        ESupportsHttp3Sub = 3,
        __Other__,
    }
    impl From<u16> for Http3CompleteLoadLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUsesHttp3Page,
                1 => Self::EUsesHttp3Sub,
                2 => Self::ESupportsHttp3Page,
                3 => Self::ESupportsHttp3Sub,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Http3CompleteLoadLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUsesHttp3Page => "uses_http3_page",
                Self::EUsesHttp3Sub => "uses_http3_sub",
                Self::ESupportsHttp3Page => "supports_http3_page",
                Self::ESupportsHttp3Sub => "supports_http3_sub",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.http3_complete_load
    ///
    /// In the HTTP channel (keys: uses_http3_page, uses_http3_sub,
    /// supports_http3_page, supports_http3_sub), overall load time
    pub static http3_complete_load: Lazy<LabeledMetric<LabeledTimingDistributionMetric, Http3CompleteLoadLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "http3_complete_load".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(3404.into(), meta, Some(vec![::std::borrow::Cow::from("supports_http3_page"), ::std::borrow::Cow::from("supports_http3_sub"), ::std::borrow::Cow::from("uses_http3_page"), ::std::borrow::Cow::from("uses_http3_sub")]))
    });

    #[repr(u16)]
    pub enum Http3FirstSentToLastReceivedLabel {
        EUsesHttp3Page = 0,
        EUsesHttp3Sub = 1,
        ESupportsHttp3Page = 2,
        ESupportsHttp3Sub = 3,
        __Other__,
    }
    impl From<u16> for Http3FirstSentToLastReceivedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUsesHttp3Page,
                1 => Self::EUsesHttp3Sub,
                2 => Self::ESupportsHttp3Page,
                3 => Self::ESupportsHttp3Sub,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Http3FirstSentToLastReceivedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUsesHttp3Page => "uses_http3_page",
                Self::EUsesHttp3Sub => "uses_http3_sub",
                Self::ESupportsHttp3Page => "supports_http3_page",
                Self::ESupportsHttp3Sub => "supports_http3_sub",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.http3_first_sent_to_last_received
    ///
    /// In the HTTP channel (keys: uses_http3_page, uses_http3_sub,
    /// supports_http3_page, supports_http3_sub), time from first byte of request sent
    /// to last byte of response received
    pub static http3_first_sent_to_last_received: Lazy<LabeledMetric<LabeledTimingDistributionMetric, Http3FirstSentToLastReceivedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "http3_first_sent_to_last_received".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(3405.into(), meta, Some(vec![::std::borrow::Cow::from("supports_http3_page"), ::std::borrow::Cow::from("supports_http3_sub"), ::std::borrow::Cow::from("uses_http3_page"), ::std::borrow::Cow::from("uses_http3_sub")]))
    });

    #[repr(u16)]
    pub enum Http3OpenToFirstReceivedLabel {
        EUsesHttp3Page = 0,
        EUsesHttp3Sub = 1,
        ESupportsHttp3Page = 2,
        ESupportsHttp3Sub = 3,
        __Other__,
    }
    impl From<u16> for Http3OpenToFirstReceivedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUsesHttp3Page,
                1 => Self::EUsesHttp3Sub,
                2 => Self::ESupportsHttp3Page,
                3 => Self::ESupportsHttp3Sub,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Http3OpenToFirstReceivedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUsesHttp3Page => "uses_http3_page",
                Self::EUsesHttp3Sub => "uses_http3_sub",
                Self::ESupportsHttp3Page => "supports_http3_page",
                Self::ESupportsHttp3Sub => "supports_http3_sub",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.http3_open_to_first_received
    ///
    /// In the HTTP channel (keys: uses_http3_page, uses_http3_sub,
    /// supports_http3_page, supports_http3_sub), time from open to first byte of reply
    /// received
    pub static http3_open_to_first_received: Lazy<LabeledMetric<LabeledTimingDistributionMetric, Http3OpenToFirstReceivedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "http3_open_to_first_received".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(3406.into(), meta, Some(vec![::std::borrow::Cow::from("supports_http3_page"), ::std::borrow::Cow::from("supports_http3_sub"), ::std::borrow::Cow::from("uses_http3_page"), ::std::borrow::Cow::from("uses_http3_sub")]))
    });

    #[repr(u16)]
    pub enum Http3OpenToFirstSentLabel {
        EUsesHttp3Page = 0,
        EUsesHttp3Sub = 1,
        ESupportsHttp3Page = 2,
        ESupportsHttp3Sub = 3,
        __Other__,
    }
    impl From<u16> for Http3OpenToFirstSentLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUsesHttp3Page,
                1 => Self::EUsesHttp3Sub,
                2 => Self::ESupportsHttp3Page,
                3 => Self::ESupportsHttp3Sub,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Http3OpenToFirstSentLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUsesHttp3Page => "uses_http3_page",
                Self::EUsesHttp3Sub => "uses_http3_sub",
                Self::ESupportsHttp3Page => "supports_http3_page",
                Self::ESupportsHttp3Sub => "supports_http3_sub",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.http3_open_to_first_sent
    ///
    /// In the HTTP channel (keys: uses_http3_page, uses_http3_sub,
    /// supports_http3_page, supports_http3_sub), time from open to first byte of
    /// request
    pub static http3_open_to_first_sent: Lazy<LabeledMetric<LabeledTimingDistributionMetric, Http3OpenToFirstSentLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "http3_open_to_first_sent".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(3407.into(), meta, Some(vec![::std::borrow::Cow::from("supports_http3_page"), ::std::borrow::Cow::from("supports_http3_sub"), ::std::borrow::Cow::from("uses_http3_page"), ::std::borrow::Cow::from("uses_http3_sub")]))
    });

    #[repr(u16)]
    pub enum Http3TlsHandshakeLabel {
        EUsesHttp3Page = 0,
        EUsesHttp3Sub = 1,
        ESupportsHttp3Page = 2,
        ESupportsHttp3Sub = 3,
        __Other__,
    }
    impl From<u16> for Http3TlsHandshakeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUsesHttp3Page,
                1 => Self::EUsesHttp3Sub,
                2 => Self::ESupportsHttp3Page,
                3 => Self::ESupportsHttp3Sub,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Http3TlsHandshakeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUsesHttp3Page => "uses_http3_page",
                Self::EUsesHttp3Sub => "uses_http3_sub",
                Self::ESupportsHttp3Page => "supports_http3_page",
                Self::ESupportsHttp3Sub => "supports_http3_sub",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.http3_tls_handshake
    ///
    /// In the HTTP channel (keys: uses_http3_page, uses_http3_sub,
    /// supports_http3_page, supports_http3_sub), time from secure connection start
    /// (after TCP SYN) to ready for HTTP
    pub static http3_tls_handshake: Lazy<LabeledMetric<LabeledTimingDistributionMetric, Http3TlsHandshakeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "http3_tls_handshake".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(3408.into(), meta, Some(vec![::std::borrow::Cow::from("supports_http3_page"), ::std::borrow::Cow::from("supports_http3_sub"), ::std::borrow::Cow::from("uses_http3_page"), ::std::borrow::Cow::from("uses_http3_sub")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.http_revalidation
    ///
    /// In the HTTP page channel, time for positive cache validation Corresponds to
    /// Legacy histogram HTTP_PAGE_REVALIDATION in Desktop.
    pub static http_revalidation: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_revalidation".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3409.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.open_to_first_received
    ///
    /// In the HTTP subitem channel,time from connection open to the first byte
    /// received. Corresponds to Legacy histogram HTTP_PAGE_OPEN_TO_FIRST_RECEIVED in
    /// Desktop. (Migrated from the geckoview metric of the same name).
    pub static open_to_first_received: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_to_first_received".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3410.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.open_to_first_sent
    ///
    /// In the HTTP page channel, time from connection open to the first byte of requst
    /// sent. Corresponds to Legacy histogram HTTP_PAGE_OPEN_TO_FIRST_SENT in Desktop.
    /// (Migrated from the geckoview metric of the same name).
    pub static open_to_first_sent: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_to_first_sent".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3411.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_cache_read_time
    ///
    /// In the HTTP subitem channel, time from connection cache read start to cache
    /// read end. Corresponds to Legacy histogram HTTP_SUB_CACHE_READ_TIME_V2 in
    /// Desktop.
    pub static sub_cache_read_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_cache_read_time".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3412.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_complete_load
    ///
    /// In the HTTP subitem channel, time from connection open to complete load (cache
    /// read end/until the last byte received) Corresponds to Legacy histogram
    /// HTTP_SUB_COMPLETE_LOAD_V2 in Desktop.
    pub static sub_complete_load: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_complete_load".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3413.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_complete_load_cached
    ///
    /// In the HTTP subitem channel, time from connection open to cache read end.
    /// Corresponds to Legacy histogram HTTP_SUB_COMPLETE_LOAD_CACHED_V2 in Desktop.
    pub static sub_complete_load_cached: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_complete_load_cached".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3414.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_complete_load_net
    ///
    /// In the HTTP subitem channel, time from connection open to the last byte
    /// received. Corresponds to Legacy histogram HTTP_SUB_COMPLETE_LOAD_NET_V2 in
    /// Desktop.
    pub static sub_complete_load_net: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_complete_load_net".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3415.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_dns_end
    ///
    /// In the HTTP subitem channel, time from the DNS request being issued to the
    /// response. Corresponds to Legacy histogram HTTP_SUB_DNS_LOOKUP_TIME in Desktop.
    /// (Migrated from the geckoview metric of the same name).
    pub static sub_dns_end: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_dns_end".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3416.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_dns_start
    ///
    /// In the HTTP subitem channel, time from connection open to the DNS request being
    /// issued. Corresponds to Legacy histogram HTTP_SUB_DNS_ISSUE_TIME in Desktop.
    /// (Migrated from the geckoview metric of the same name).
    pub static sub_dns_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_dns_start".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3417.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_first_from_cache
    ///
    /// In the HTTP subitem channel, time from connection open to cache read start.
    /// Corresponds to Legacy histogram HTTP_SUB_OPEN_TO_FIRST_FROM_CACHE_V2 in
    /// Desktop.
    pub static sub_first_from_cache: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_first_from_cache".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3418.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_first_sent_to_last_received
    ///
    /// In the HTTP subitem channel, time from first byte of request sent to the last
    /// byte received. Corresponds to Legacy histogram
    /// HTTP_SUB_FIRST_SENT_TO_LAST_RECEIVED in Desktop. (Migrated from the geckoview
    /// metric of the same name).
    pub static sub_first_sent_to_last_received: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_first_sent_to_last_received".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3419.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_http_revalidation
    ///
    /// In the HTTP subitem channel, time for positive cache validation Corresponds to
    /// Legacy histogram HTTP_SUB_REVALIDATION in Desktop.
    pub static sub_http_revalidation: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_http_revalidation".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3420.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_open_to_first_received
    ///
    /// In the HTTP subitem channel, time from connection open to the first byte
    /// received. Corresponds to Legacy histogram HTTP_SUB_OPEN_TO_FIRST_RECEIVED in
    /// Desktop. (Migrated from the geckoview metric of the same name).
    pub static sub_open_to_first_received: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_open_to_first_received".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3421.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_open_to_first_sent
    ///
    /// In the HTTP subitem channel, time from connection open to the first byte of
    /// requst sent. Corresponds to Legacy histogram HTTP_SUB_OPEN_TO_FIRST_SENT in
    /// Desktop. (Migrated from the geckoview metric of the same name).
    pub static sub_open_to_first_sent: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_open_to_first_sent".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3422.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_tcp_connection
    ///
    /// In the HTTP subitem channel, time from the TCP SYN packet is received to the
    /// connection is established and ready for HTTP. Corresponds to Legacy histogram
    /// HTTP_SUB_TCP_CONNECTION_2 in Desktop (Migrated from the geckoview metric of the
    /// same name).
    pub static sub_tcp_connection: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_tcp_connection".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3423.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_tls_handshake
    ///
    /// In the HTTP subitem channel, time from after the TCP SYN packet is received to
    /// the secure connection is established and ready for HTTP. Corresponds to Legacy
    /// histogram HTTP_SUB_TLS_HANDSHAKE in Desktop. (Migrated from the geckoview
    /// metric of the same name).
    pub static sub_tls_handshake: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_tls_handshake".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3424.into(), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum SupHttp3TcpConnectionLabel {
        ESupportsHttp3Page = 0,
        ESupportsHttp3Sub = 1,
        __Other__,
    }
    impl From<u16> for SupHttp3TcpConnectionLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESupportsHttp3Page,
                1 => Self::ESupportsHttp3Sub,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SupHttp3TcpConnectionLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESupportsHttp3Page => "supports_http3_page",
                Self::ESupportsHttp3Sub => "supports_http3_sub",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.sup_http3_tcp_connection
    ///
    /// In the HTTP channel (keys: supports_http3_page, supports_http3_sub), time from
    /// TCP SYN to ready for HTTP
    pub static sup_http3_tcp_connection: Lazy<LabeledMetric<LabeledTimingDistributionMetric, SupHttp3TcpConnectionLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "sup_http3_tcp_connection".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(3425.into(), meta, Some(vec![::std::borrow::Cow::from("supports_http3_page"), ::std::borrow::Cow::from("supports_http3_sub")]))
    });

    #[repr(u16)]
    pub enum SystemChannelAddonStatusLabel {
        EOk = 0,
        EOffline = 1,
        EConnectivity = 2,
        EDns = 3,
        EConnectFail = 4,
        ETlsFail = 5,
        EHttpStatus = 6,
        ECancel = 7,
        ETimeout = 8,
        EReset = 9,
        ERefused = 10,
        EPartial = 11,
        EOther = 12,
        __Other__,
    }
    impl From<u16> for SystemChannelAddonStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOk,
                1 => Self::EOffline,
                2 => Self::EConnectivity,
                3 => Self::EDns,
                4 => Self::EConnectFail,
                5 => Self::ETlsFail,
                6 => Self::EHttpStatus,
                7 => Self::ECancel,
                8 => Self::ETimeout,
                9 => Self::EReset,
                10 => Self::ERefused,
                11 => Self::EPartial,
                12 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SystemChannelAddonStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOk => "ok",
                Self::EOffline => "offline",
                Self::EConnectivity => "connectivity",
                Self::EDns => "dns",
                Self::EConnectFail => "connect_fail",
                Self::ETlsFail => "tls_fail",
                Self::EHttpStatus => "http_status",
                Self::ECancel => "cancel",
                Self::ETimeout => "timeout",
                Self::EReset => "reset",
                Self::ERefused => "refused",
                Self::EPartial => "partial",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.system_channel_addon_status
    ///
    /// Counts the status of succeeded and failed requests to addons.mozilla.org
    pub static system_channel_addon_status: Lazy<LabeledMetric<LabeledCounterMetric, SystemChannelAddonStatusLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "system_channel_addon_status".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3426.into(), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("connect_fail"), ::std::borrow::Cow::from("connectivity"), ::std::borrow::Cow::from("dns"), ::std::borrow::Cow::from("http_status"), ::std::borrow::Cow::from("offline"), ::std::borrow::Cow::from("ok"), ::std::borrow::Cow::from("other"), ::std::borrow::Cow::from("partial"), ::std::borrow::Cow::from("refused"), ::std::borrow::Cow::from("reset"), ::std::borrow::Cow::from("timeout"), ::std::borrow::Cow::from("tls_fail")]))
    });

    #[repr(u16)]
    pub enum SystemChannelAddonversionStatusLabel {
        EOk = 0,
        EOffline = 1,
        EConnectivity = 2,
        EDns = 3,
        EConnectFail = 4,
        ETlsFail = 5,
        EHttpStatus = 6,
        ECancel = 7,
        ETimeout = 8,
        EReset = 9,
        ERefused = 10,
        EPartial = 11,
        EOther = 12,
        __Other__,
    }
    impl From<u16> for SystemChannelAddonversionStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOk,
                1 => Self::EOffline,
                2 => Self::EConnectivity,
                3 => Self::EDns,
                4 => Self::EConnectFail,
                5 => Self::ETlsFail,
                6 => Self::EHttpStatus,
                7 => Self::ECancel,
                8 => Self::ETimeout,
                9 => Self::EReset,
                10 => Self::ERefused,
                11 => Self::EPartial,
                12 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SystemChannelAddonversionStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOk => "ok",
                Self::EOffline => "offline",
                Self::EConnectivity => "connectivity",
                Self::EDns => "dns",
                Self::EConnectFail => "connect_fail",
                Self::ETlsFail => "tls_fail",
                Self::EHttpStatus => "http_status",
                Self::ECancel => "cancel",
                Self::ETimeout => "timeout",
                Self::EReset => "reset",
                Self::ERefused => "refused",
                Self::EPartial => "partial",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.system_channel_addonversion_status
    ///
    /// Counts the status of succeeded and failed requests to *.addons.mozilla.org
    pub static system_channel_addonversion_status: Lazy<LabeledMetric<LabeledCounterMetric, SystemChannelAddonversionStatusLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "system_channel_addonversion_status".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3427.into(), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("connect_fail"), ::std::borrow::Cow::from("connectivity"), ::std::borrow::Cow::from("dns"), ::std::borrow::Cow::from("http_status"), ::std::borrow::Cow::from("offline"), ::std::borrow::Cow::from("ok"), ::std::borrow::Cow::from("other"), ::std::borrow::Cow::from("partial"), ::std::borrow::Cow::from("refused"), ::std::borrow::Cow::from("reset"), ::std::borrow::Cow::from("timeout"), ::std::borrow::Cow::from("tls_fail")]))
    });

    #[repr(u16)]
    pub enum SystemChannelOtherStatusLabel {
        EOk = 0,
        EOffline = 1,
        EConnectivity = 2,
        EDns = 3,
        EConnectFail = 4,
        ETlsFail = 5,
        EHttpStatus = 6,
        ECancel = 7,
        ETimeout = 8,
        EReset = 9,
        ERefused = 10,
        EPartial = 11,
        EOther = 12,
        __Other__,
    }
    impl From<u16> for SystemChannelOtherStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOk,
                1 => Self::EOffline,
                2 => Self::EConnectivity,
                3 => Self::EDns,
                4 => Self::EConnectFail,
                5 => Self::ETlsFail,
                6 => Self::EHttpStatus,
                7 => Self::ECancel,
                8 => Self::ETimeout,
                9 => Self::EReset,
                10 => Self::ERefused,
                11 => Self::EPartial,
                12 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SystemChannelOtherStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOk => "ok",
                Self::EOffline => "offline",
                Self::EConnectivity => "connectivity",
                Self::EDns => "dns",
                Self::EConnectFail => "connect_fail",
                Self::ETlsFail => "tls_fail",
                Self::EHttpStatus => "http_status",
                Self::ECancel => "cancel",
                Self::ETimeout => "timeout",
                Self::EReset => "reset",
                Self::ERefused => "refused",
                Self::EPartial => "partial",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.system_channel_other_status
    ///
    /// Counts the status of succeeded and failed requests to other mozilla.org domains
    pub static system_channel_other_status: Lazy<LabeledMetric<LabeledCounterMetric, SystemChannelOtherStatusLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "system_channel_other_status".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3428.into(), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("connect_fail"), ::std::borrow::Cow::from("connectivity"), ::std::borrow::Cow::from("dns"), ::std::borrow::Cow::from("http_status"), ::std::borrow::Cow::from("offline"), ::std::borrow::Cow::from("ok"), ::std::borrow::Cow::from("other"), ::std::borrow::Cow::from("partial"), ::std::borrow::Cow::from("refused"), ::std::borrow::Cow::from("reset"), ::std::borrow::Cow::from("timeout"), ::std::borrow::Cow::from("tls_fail")]))
    });

    #[repr(u16)]
    pub enum SystemChannelRemoteSettingsStatusLabel {
        EOk = 0,
        EOffline = 1,
        EConnectivity = 2,
        EDns = 3,
        EConnectFail = 4,
        ETlsFail = 5,
        EHttpStatus = 6,
        ECancel = 7,
        ETimeout = 8,
        EReset = 9,
        ERefused = 10,
        EPartial = 11,
        EOther = 12,
        __Other__,
    }
    impl From<u16> for SystemChannelRemoteSettingsStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOk,
                1 => Self::EOffline,
                2 => Self::EConnectivity,
                3 => Self::EDns,
                4 => Self::EConnectFail,
                5 => Self::ETlsFail,
                6 => Self::EHttpStatus,
                7 => Self::ECancel,
                8 => Self::ETimeout,
                9 => Self::EReset,
                10 => Self::ERefused,
                11 => Self::EPartial,
                12 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SystemChannelRemoteSettingsStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOk => "ok",
                Self::EOffline => "offline",
                Self::EConnectivity => "connectivity",
                Self::EDns => "dns",
                Self::EConnectFail => "connect_fail",
                Self::ETlsFail => "tls_fail",
                Self::EHttpStatus => "http_status",
                Self::ECancel => "cancel",
                Self::ETimeout => "timeout",
                Self::EReset => "reset",
                Self::ERefused => "refused",
                Self::EPartial => "partial",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.system_channel_remote_settings_status
    ///
    /// Counts the status of succeeded and failed requests to
    /// firefox.settings.services.mozilla.com
    pub static system_channel_remote_settings_status: Lazy<LabeledMetric<LabeledCounterMetric, SystemChannelRemoteSettingsStatusLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "system_channel_remote_settings_status".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3429.into(), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("connect_fail"), ::std::borrow::Cow::from("connectivity"), ::std::borrow::Cow::from("dns"), ::std::borrow::Cow::from("http_status"), ::std::borrow::Cow::from("offline"), ::std::borrow::Cow::from("ok"), ::std::borrow::Cow::from("other"), ::std::borrow::Cow::from("partial"), ::std::borrow::Cow::from("refused"), ::std::borrow::Cow::from("reset"), ::std::borrow::Cow::from("timeout"), ::std::borrow::Cow::from("tls_fail")]))
    });

    #[repr(u16)]
    pub enum SystemChannelSuccessOrFailureLabel {
        EOk = 0,
        EOffline = 1,
        EConnectivity = 2,
        EDns = 3,
        EConnectFail = 4,
        ETlsFail = 5,
        EHttpStatus = 6,
        ECancel = 7,
        ETimeout = 8,
        EReset = 9,
        ERefused = 10,
        EPartial = 11,
        EOther = 12,
        __Other__,
    }
    impl From<u16> for SystemChannelSuccessOrFailureLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOk,
                1 => Self::EOffline,
                2 => Self::EConnectivity,
                3 => Self::EDns,
                4 => Self::EConnectFail,
                5 => Self::ETlsFail,
                6 => Self::EHttpStatus,
                7 => Self::ECancel,
                8 => Self::ETimeout,
                9 => Self::EReset,
                10 => Self::ERefused,
                11 => Self::EPartial,
                12 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SystemChannelSuccessOrFailureLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOk => "ok",
                Self::EOffline => "offline",
                Self::EConnectivity => "connectivity",
                Self::EDns => "dns",
                Self::EConnectFail => "connect_fail",
                Self::ETlsFail => "tls_fail",
                Self::EHttpStatus => "http_status",
                Self::ECancel => "cancel",
                Self::ETimeout => "timeout",
                Self::EReset => "reset",
                Self::ERefused => "refused",
                Self::EPartial => "partial",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.system_channel_success_or_failure
    ///
    /// Counts the number of succeeded and failed channels with a system principal to a
    /// mozilla domain. Label contains ok or failure reason.
    pub static system_channel_success_or_failure: Lazy<LabeledMetric<LabeledCounterMetric, SystemChannelSuccessOrFailureLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "system_channel_success_or_failure".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3430.into(), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("connect_fail"), ::std::borrow::Cow::from("connectivity"), ::std::borrow::Cow::from("dns"), ::std::borrow::Cow::from("http_status"), ::std::borrow::Cow::from("offline"), ::std::borrow::Cow::from("ok"), ::std::borrow::Cow::from("other"), ::std::borrow::Cow::from("partial"), ::std::borrow::Cow::from("refused"), ::std::borrow::Cow::from("reset"), ::std::borrow::Cow::from("timeout"), ::std::borrow::Cow::from("tls_fail")]))
    });

    #[repr(u16)]
    pub enum SystemChannelTelemetryStatusLabel {
        EOk = 0,
        EOffline = 1,
        EConnectivity = 2,
        EDns = 3,
        EConnectFail = 4,
        ETlsFail = 5,
        EHttpStatus = 6,
        ECancel = 7,
        ETimeout = 8,
        EReset = 9,
        ERefused = 10,
        EPartial = 11,
        EOther = 12,
        __Other__,
    }
    impl From<u16> for SystemChannelTelemetryStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOk,
                1 => Self::EOffline,
                2 => Self::EConnectivity,
                3 => Self::EDns,
                4 => Self::EConnectFail,
                5 => Self::ETlsFail,
                6 => Self::EHttpStatus,
                7 => Self::ECancel,
                8 => Self::ETimeout,
                9 => Self::EReset,
                10 => Self::ERefused,
                11 => Self::EPartial,
                12 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SystemChannelTelemetryStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOk => "ok",
                Self::EOffline => "offline",
                Self::EConnectivity => "connectivity",
                Self::EDns => "dns",
                Self::EConnectFail => "connect_fail",
                Self::ETlsFail => "tls_fail",
                Self::EHttpStatus => "http_status",
                Self::ECancel => "cancel",
                Self::ETimeout => "timeout",
                Self::EReset => "reset",
                Self::ERefused => "refused",
                Self::EPartial => "partial",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.system_channel_telemetry_status
    ///
    /// Counts the status of succeeded and failed requests to
    /// incoming.telemetry.mozilla.org
    pub static system_channel_telemetry_status: Lazy<LabeledMetric<LabeledCounterMetric, SystemChannelTelemetryStatusLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "system_channel_telemetry_status".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3431.into(), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("connect_fail"), ::std::borrow::Cow::from("connectivity"), ::std::borrow::Cow::from("dns"), ::std::borrow::Cow::from("http_status"), ::std::borrow::Cow::from("offline"), ::std::borrow::Cow::from("ok"), ::std::borrow::Cow::from("other"), ::std::borrow::Cow::from("partial"), ::std::borrow::Cow::from("refused"), ::std::borrow::Cow::from("reset"), ::std::borrow::Cow::from("timeout"), ::std::borrow::Cow::from("tls_fail")]))
    });

    #[repr(u16)]
    pub enum SystemChannelUpdateStatusLabel {
        EOk = 0,
        EOffline = 1,
        EConnectivity = 2,
        EDns = 3,
        EConnectFail = 4,
        ETlsFail = 5,
        EHttpStatus = 6,
        ECancel = 7,
        ETimeout = 8,
        EReset = 9,
        ERefused = 10,
        EPartial = 11,
        EOther = 12,
        __Other__,
    }
    impl From<u16> for SystemChannelUpdateStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOk,
                1 => Self::EOffline,
                2 => Self::EConnectivity,
                3 => Self::EDns,
                4 => Self::EConnectFail,
                5 => Self::ETlsFail,
                6 => Self::EHttpStatus,
                7 => Self::ECancel,
                8 => Self::ETimeout,
                9 => Self::EReset,
                10 => Self::ERefused,
                11 => Self::EPartial,
                12 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SystemChannelUpdateStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOk => "ok",
                Self::EOffline => "offline",
                Self::EConnectivity => "connectivity",
                Self::EDns => "dns",
                Self::EConnectFail => "connect_fail",
                Self::ETlsFail => "tls_fail",
                Self::EHttpStatus => "http_status",
                Self::ECancel => "cancel",
                Self::ETimeout => "timeout",
                Self::EReset => "reset",
                Self::ERefused => "refused",
                Self::EPartial => "partial",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.system_channel_update_status
    ///
    /// Counts the status of succeeded and failed requests to aus5.mozilla.org
    pub static system_channel_update_status: Lazy<LabeledMetric<LabeledCounterMetric, SystemChannelUpdateStatusLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "system_channel_update_status".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3432.into(), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("connect_fail"), ::std::borrow::Cow::from("connectivity"), ::std::borrow::Cow::from("dns"), ::std::borrow::Cow::from("http_status"), ::std::borrow::Cow::from("offline"), ::std::borrow::Cow::from("ok"), ::std::borrow::Cow::from("other"), ::std::borrow::Cow::from("partial"), ::std::borrow::Cow::from("refused"), ::std::borrow::Cow::from("reset"), ::std::borrow::Cow::from("timeout"), ::std::borrow::Cow::from("tls_fail")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.tcp_connection
    ///
    /// In the HTTP page channel, time from the TCP SYN packet is received to the
    /// connection is established and ready for HTTP. Corresponds to Legacy histogram
    /// HTTP_PAGE_TCP_CONNECTION_2 in Desktop (Migrated from the geckoview metric of
    /// the same name).
    pub static tcp_connection: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tcp_connection".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3433.into(), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum TlsEarlyDataAcceptedLabel {
        EAccepted = 0,
        ERejected = 1,
        __Other__,
    }
    impl From<u16> for TlsEarlyDataAcceptedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAccepted,
                1 => Self::ERejected,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TlsEarlyDataAcceptedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAccepted => "accepted",
                Self::ERejected => "rejected",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.tls_early_data_accepted
    ///
    /// TLS early data was used and it was accepted or rejected by the remote host.
    pub static tls_early_data_accepted: Lazy<LabeledMetric<LabeledCounterMetric, TlsEarlyDataAcceptedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tls_early_data_accepted".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3434.into(), meta, Some(vec![::std::borrow::Cow::from("accepted"), ::std::borrow::Cow::from("rejected")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.tls_early_data_bytes_written
    ///
    /// Amount of bytes sent using TLS early data at the start of a TLS connection for
    /// a given channel.
    pub static tls_early_data_bytes_written: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tls_early_data_bytes_written".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3435.into(), meta, 0, 60000, 100, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum TlsEarlyDataNegotiatedLabel {
        ENotAvailable = 0,
        EAvailableAndUsed = 1,
        EAvailableButNotUsed = 2,
        __Other__,
    }
    impl From<u16> for TlsEarlyDataNegotiatedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENotAvailable,
                1 => Self::EAvailableAndUsed,
                2 => Self::EAvailableButNotUsed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TlsEarlyDataNegotiatedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENotAvailable => "not_available",
                Self::EAvailableAndUsed => "available_and_used",
                Self::EAvailableButNotUsed => "available_but_not_used",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.tls_early_data_negotiated
    ///
    /// Sending TLS early data was not possible, possible and used, or possible but not
    /// used.
    pub static tls_early_data_negotiated: Lazy<LabeledMetric<LabeledCounterMetric, TlsEarlyDataNegotiatedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tls_early_data_negotiated".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3436.into(), meta, Some(vec![::std::borrow::Cow::from("available_and_used"), ::std::borrow::Cow::from("available_but_not_used"), ::std::borrow::Cow::from("not_available")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.tls_handshake
    ///
    /// In the HTTP page channel, time from after the TCP SYN packet is received to the
    /// secure connection is established and ready for HTTP. Corresponds to Legacy
    /// histogram HTTP_PAGE_TLS_HANDSHAKE in Desktop. (Migrated from the geckoview
    /// metric of the same name).
    pub static tls_handshake: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tls_handshake".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3437.into(), meta, TimeUnit::Millisecond)
    });

}
pub mod opaque_response_blocking {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from opaque.response.blocking.cross_origin_opaque_response_count
    ///
    /// The number of loads of cross origin opaque resources. This metric was generated
    /// to correspond to the Legacy Telemetry scalar
    /// opaque.response.blocking.cross_origin_opaque_response_count.
    pub static cross_origin_opaque_response_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3438,
            "opaque.response.blocking",
            "cross_origin_opaque_response_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from opaque.response.blocking.javascript_validation_count
    ///
    /// The number of times we run the JS validator. This metric was generated to
    /// correspond to the Legacy Telemetry scalar
    /// opaque.response.blocking.javascript_validation_count.
    pub static javascript_validation_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3439,
            "opaque.response.blocking",
            "javascript_validation_count",
            "metrics"
        )
    });

}
pub mod parsing {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from parsing.svg_unusual_pcdata
    ///
    /// The rate of svg elements that have child elements during parsing, where their
    /// HTML counterpart would not have children.
    pub static svg_unusual_pcdata: Lazy<RateMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "svg_unusual_pcdata".into(),
                category: "parsing".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        RateMetric::new(3440.into(), meta)
    });

}
pub mod ysod {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShownYsodExtra {
        pub r#destroyed: Option<String>,
        pub r#error_code: Option<u32>,
        pub r#hidden: Option<bool>,
        pub r#last_line: Option<String>,
        pub r#last_line_len: Option<u32>,
        pub r#location: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShownYsodExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["destroyed", "error_code", "hidden", "last_line", "last_line_len", "location", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#destroyed.and_then(|val| map.insert("destroyed".into(), val.to_string()));
          self.r#error_code.and_then(|val| map.insert("error_code".into(), val.to_string()));
          self.r#hidden.and_then(|val| map.insert("hidden".into(), val.to_string()));
          self.r#last_line.and_then(|val| map.insert("last_line".into(), val.to_string()));
          self.r#last_line_len.and_then(|val| map.insert("last_line_len".into(), val.to_string()));
          self.r#location.and_then(|val| map.insert("location".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from ysod.shown_ysod
    ///
    /// This event is recorded only for Firefox UI documents (chrome). Recorded when a
    /// Yellow Screen of Death is shown. The `value` is a url on which the error
    /// happened. Yellow Screen of Death happens when XML or XHTML document encounters
    /// a parsing error. It is commonly a result of the document being malformed or
    /// missing DTD entity. This data should be reviewed periodically for urls that
    /// error frequently. This event was generated to correspond to the Legacy
    /// Telemetry event ysod.shown#ysod.
    pub static shown_ysod: Lazy<EventMetric<ShownYsodExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shown_ysod".into(),
                category: "ysod".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3441.into(), meta)
    });

}
pub mod cert_signature_cache {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cert_signature_cache.hits
    ///
    /// How often a certificate signature to be verified is in the cache already.
    pub static hits: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "hits".into(),
                category: "cert_signature_cache".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3442.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cert_signature_cache.total
    ///
    /// How many certificate signature verifications are performed.
    pub static total: Lazy<DenominatorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total".into(),
                category: "cert_signature_cache".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DenominatorMetric::new(3443.into(), meta, vec![CommonMetricData {name: "hits".into(), category: "cert_signature_cache".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

}
pub mod cert_trust_cache {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cert_trust_cache.hits
    ///
    /// How often a certificate's trust is in the cache already.
    pub static hits: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "hits".into(),
                category: "cert_trust_cache".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3444.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cert_trust_cache.total
    ///
    /// How many certificate trust lookups are performed.
    pub static total: Lazy<DenominatorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total".into(),
                category: "cert_trust_cache".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DenominatorMetric::new(3445.into(), meta, vec![CommonMetricData {name: "hits".into(), category: "cert_trust_cache".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

}
pub mod cert_verifier {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum CertRevocationMechanismsLabel {
        ECrlite = 0,
        EStapledocsp = 1,
        ECachedocsp = 2,
        EOcsp = 3,
        EOnecrl = 4,
        EShortvalidity = 5,
        __Other__,
    }
    impl From<u16> for CertRevocationMechanismsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECrlite,
                1 => Self::EStapledocsp,
                2 => Self::ECachedocsp,
                3 => Self::EOcsp,
                4 => Self::EOnecrl,
                5 => Self::EShortvalidity,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CertRevocationMechanismsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECrlite => "CRLite",
                Self::EStapledocsp => "StapledOCSP",
                Self::ECachedocsp => "CachedOCSP",
                Self::EOcsp => "OCSP",
                Self::EOnecrl => "OneCRL",
                Self::EShortvalidity => "ShortValidity",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cert_verifier.cert_revocation_mechanisms
    ///
    /// Which revocation checking mechanisms were used in a TLS handshake?
    pub static cert_revocation_mechanisms: Lazy<LabeledMetric<LabeledCounterMetric, CertRevocationMechanismsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cert_revocation_mechanisms".into(),
                    category: "cert_verifier".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3446.into(), meta, Some(vec![::std::borrow::Cow::from("CRLite"), ::std::borrow::Cow::from("CachedOCSP"), ::std::borrow::Cow::from("OCSP"), ::std::borrow::Cow::from("OneCRL"), ::std::borrow::Cow::from("ShortValidity"), ::std::borrow::Cow::from("StapledOCSP")]))
    });

    #[repr(u16)]
    pub enum CrliteStatusLabel {
        ENoFilter = 0,
        ENotCovered = 1,
        ENotEnrolled = 2,
        ENotRevoked = 3,
        ERevokedInFilter = 4,
        ERevokedInStash = 5,
        __Other__,
    }
    impl From<u16> for CrliteStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENoFilter,
                1 => Self::ENotCovered,
                2 => Self::ENotEnrolled,
                3 => Self::ENotRevoked,
                4 => Self::ERevokedInFilter,
                5 => Self::ERevokedInStash,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CrliteStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENoFilter => "no_filter",
                Self::ENotCovered => "not_covered",
                Self::ENotEnrolled => "not_enrolled",
                Self::ENotRevoked => "not_revoked",
                Self::ERevokedInFilter => "revoked_in_filter",
                Self::ERevokedInStash => "revoked_in_stash",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cert_verifier.crlite_status
    ///
    /// Counts the number of times different CRLite statuses were returned.
    pub static crlite_status: Lazy<LabeledMetric<LabeledCounterMetric, CrliteStatusLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "crlite_status".into(),
                    category: "cert_verifier".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3447.into(), meta, Some(vec![::std::borrow::Cow::from("no_filter"), ::std::borrow::Cow::from("not_covered"), ::std::borrow::Cow::from("not_enrolled"), ::std::borrow::Cow::from("not_revoked"), ::std::borrow::Cow::from("revoked_in_filter"), ::std::borrow::Cow::from("revoked_in_stash")]))
    });

    #[repr(u16)]
    pub enum CrliteVsOcspResultLabel {
        ECrliterevocspfail = 0,
        ECrliterevocspok = 1,
        ECrliterevocsprev = 2,
        ECrliterevocspunk = 3,
        ECrliterevocspsoft = 4,
        __Other__,
    }
    impl From<u16> for CrliteVsOcspResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECrliterevocspfail,
                1 => Self::ECrliterevocspok,
                2 => Self::ECrliterevocsprev,
                3 => Self::ECrliterevocspunk,
                4 => Self::ECrliterevocspsoft,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CrliteVsOcspResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECrliterevocspfail => "CRLiteRevOCSPFail",
                Self::ECrliterevocspok => "CRLiteRevOCSPOk",
                Self::ECrliterevocsprev => "CRLiteRevOCSPRev",
                Self::ECrliterevocspunk => "CRLiteRevOCSPUnk",
                Self::ECrliterevocspsoft => "CRLiteRevOCSPSoft",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cert_verifier.crlite_vs_ocsp_result
    ///
    /// The OCSP result when CRLite claims a certificate is revoked.
    pub static crlite_vs_ocsp_result: Lazy<LabeledMetric<LabeledCounterMetric, CrliteVsOcspResultLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "crlite_vs_ocsp_result".into(),
                    category: "cert_verifier".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3448.into(), meta, Some(vec![::std::borrow::Cow::from("CRLiteRevOCSPFail"), ::std::borrow::Cow::from("CRLiteRevOCSPOk"), ::std::borrow::Cow::from("CRLiteRevOCSPRev"), ::std::borrow::Cow::from("CRLiteRevOCSPSoft"), ::std::borrow::Cow::from("CRLiteRevOCSPUnk")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from cert_verifier.trust_obj_count
    ///
    /// The total number of trust objects in cert9.db
    pub static trust_obj_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "trust_obj_count".into(),
                category: "cert_verifier".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3449.into(), meta)
    });

}
pub mod sct_signature_cache {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from sct_signature_cache.hits
    ///
    /// How often an SCT signature to be verified is in the cache already.
    pub static hits: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "hits".into(),
                category: "sct_signature_cache".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3450.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sct_signature_cache.total
    ///
    /// How many SCT signature verifications are performed.
    pub static total: Lazy<DenominatorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total".into(),
                category: "sct_signature_cache".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DenominatorMetric::new(3451.into(), meta, vec![CommonMetricData {name: "hits".into(), category: "sct_signature_cache".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

}
pub mod cert_compression {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cert_compression.brotli_saved_bytes
    ///
    /// The difference between the length of encoded certificate vs the actual
    /// certificate.
    pub static brotli_saved_bytes: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "brotli_saved_bytes".into(),
                category: "cert_compression".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3452.into(), meta, 1, 65536, 100, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum FailuresLabel {
        EZlib = 0,
        EBrotli = 1,
        EZstd = 2,
        __Other__,
    }
    impl From<u16> for FailuresLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EZlib,
                1 => Self::EBrotli,
                2 => Self::EZstd,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FailuresLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EZlib => "zlib",
                Self::EBrotli => "brotli",
                Self::EZstd => "zstd",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cert_compression.failures
    ///
    /// The number of times each certificate compression algorithm returned an error.
    pub static failures: Lazy<LabeledMetric<LabeledCounterMetric, FailuresLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "failures".into(),
                    category: "cert_compression".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3453.into(), meta, Some(vec![::std::borrow::Cow::from("brotli"), ::std::borrow::Cow::from("zlib"), ::std::borrow::Cow::from("zstd")]))
    });

    #[repr(u16)]
    pub enum UsedLabel {
        EZlib = 0,
        EBrotli = 1,
        EZstd = 2,
        __Other__,
    }
    impl From<u16> for UsedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EZlib,
                1 => Self::EBrotli,
                2 => Self::EZstd,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for UsedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EZlib => "zlib",
                Self::EBrotli => "brotli",
                Self::EZstd => "zstd",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cert_compression.used
    ///
    /// The number of times each certificate compression algorithm was used.
    pub static used: Lazy<LabeledMetric<LabeledCounterMetric, UsedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "used".into(),
                    category: "cert_compression".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3454.into(), meta, Some(vec![::std::borrow::Cow::from("brotli"), ::std::borrow::Cow::from("zlib"), ::std::borrow::Cow::from("zstd")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from cert_compression.zlib_saved_bytes
    ///
    /// The difference between the length of encoded certificate vs the actual
    /// certificate.
    pub static zlib_saved_bytes: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "zlib_saved_bytes".into(),
                category: "cert_compression".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3455.into(), meta, 1, 65536, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cert_compression.zstd_saved_bytes
    ///
    /// The difference between the length of encoded certificate vs the actual
    /// certificate.
    pub static zstd_saved_bytes: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "zstd_saved_bytes".into(),
                category: "cert_compression".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3456.into(), meta, 1, 65536, 100, HistogramType::Exponential)
    });

}
pub mod cert_storage {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cert_storage.memory
    ///
    /// Heap memory used by cert_storage.
    pub static memory: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "memory".into(),
                category: "cert_storage".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(3457.into(), meta, MemoryUnit::Byte)
    });

}
pub mod cert_verification_time {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cert_verification_time.failure
    ///
    /// The time it takes to fail to verify a certificate in a TLS handshake.
    pub static failure: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "failure".into(),
                category: "cert_verification_time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3458.into(), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cert_verification_time.success
    ///
    /// The time it takes to successfully verify a certificate in a TLS handshake.
    pub static success: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "success".into(),
                category: "cert_verification_time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3459.into(), meta, TimeUnit::Microsecond)
    });

}
pub mod data_storage {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from data_storage.alternate_services
    ///
    /// The number of entries stored in the AlternateServices nsIDataStorage
    pub static alternate_services: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "alternate_services".into(),
                category: "data_storage".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3460.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from data_storage.client_auth_remember_list
    ///
    /// The number of entries stored in the ClientAuthRememberList nsIDataStorage
    pub static client_auth_remember_list: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "client_auth_remember_list".into(),
                category: "data_storage".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3461.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from data_storage.site_security_service_state
    ///
    /// The number of entries stored in the SiteSecurityServiceState nsIDataStorage
    pub static site_security_service_state: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "site_security_service_state".into(),
                category: "data_storage".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3462.into(), meta)
    });

}
pub mod ocsp_request_time {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from ocsp_request_time.cancel
    ///
    /// The time it takes to make an OCSP request that was cancelled.
    pub static cancel: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel".into(),
                category: "ocsp_request_time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3463.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ocsp_request_time.failure
    ///
    /// The time it takes to make an OCSP request that failed.
    pub static failure: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "failure".into(),
                category: "ocsp_request_time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3464.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ocsp_request_time.success
    ///
    /// The time it takes to make an OCSP request that succeeded.
    pub static success: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "success".into(),
                category: "ocsp_request_time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3465.into(), meta, TimeUnit::Millisecond)
    });

}
pub mod pkcs11 {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from pkcs11.third_party_modules_loaded
    ///
    /// The number of third-party PKCS#11 modules loaded.
    pub static third_party_modules_loaded: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "third_party_modules_loaded".into(),
                category: "pkcs11".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3466.into(), meta)
    });

}
pub mod tls {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from tls.certificate_verifications
    ///
    /// The total number of successful TLS server certificate verifications.
    pub static certificate_verifications: Lazy<DenominatorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "certificate_verifications".into(),
                category: "tls".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DenominatorMetric::new(3467.into(), meta, vec![CommonMetricData {name: "built_in_roots_module".into(), category: "verification_used_cert_from".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "nss_cert_db".into(), category: "verification_used_cert_from".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "preloaded_intermediates".into(), category: "verification_used_cert_from".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "third_party_certificates".into(), category: "verification_used_cert_from".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "tls_handshake".into(), category: "verification_used_cert_from".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[repr(u16)]
    pub enum XyberIntoleranceReasonLabel {
        EPrConnectResetError = 0,
        EPrEndOfFileError = 1,
        ESslErrorBadHandshakeHashValue = 2,
        ESslErrorBadMacAlert = 3,
        ESslErrorBadMacRead = 4,
        ESslErrorDecodeErrorAlert = 5,
        ESslErrorHandshakeFailed = 6,
        ESslErrorHandshakeFailureAlert = 7,
        ESslErrorHandshakeUnexpectedAlert = 8,
        ESslErrorIllegalParameterAlert = 9,
        ESslErrorInternalErrorAlert = 10,
        ESslErrorKeyExchangeFailure = 11,
        ESslErrorNoCypherOverlap = 12,
        ESslErrorProtocolVersionAlert = 13,
        ESslErrorRxUnexpectedRecordType = 14,
        ESslErrorRxMalformedHybridKeyShare = 15,
        ESslErrorUnsupportedVersion = 16,
        __Other__,
    }
    impl From<u16> for XyberIntoleranceReasonLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPrConnectResetError,
                1 => Self::EPrEndOfFileError,
                2 => Self::ESslErrorBadHandshakeHashValue,
                3 => Self::ESslErrorBadMacAlert,
                4 => Self::ESslErrorBadMacRead,
                5 => Self::ESslErrorDecodeErrorAlert,
                6 => Self::ESslErrorHandshakeFailed,
                7 => Self::ESslErrorHandshakeFailureAlert,
                8 => Self::ESslErrorHandshakeUnexpectedAlert,
                9 => Self::ESslErrorIllegalParameterAlert,
                10 => Self::ESslErrorInternalErrorAlert,
                11 => Self::ESslErrorKeyExchangeFailure,
                12 => Self::ESslErrorNoCypherOverlap,
                13 => Self::ESslErrorProtocolVersionAlert,
                14 => Self::ESslErrorRxUnexpectedRecordType,
                15 => Self::ESslErrorRxMalformedHybridKeyShare,
                16 => Self::ESslErrorUnsupportedVersion,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for XyberIntoleranceReasonLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPrConnectResetError => "PR_CONNECT_RESET_ERROR",
                Self::EPrEndOfFileError => "PR_END_OF_FILE_ERROR",
                Self::ESslErrorBadHandshakeHashValue => "SSL_ERROR_BAD_HANDSHAKE_HASH_VALUE",
                Self::ESslErrorBadMacAlert => "SSL_ERROR_BAD_MAC_ALERT",
                Self::ESslErrorBadMacRead => "SSL_ERROR_BAD_MAC_READ",
                Self::ESslErrorDecodeErrorAlert => "SSL_ERROR_DECODE_ERROR_ALERT",
                Self::ESslErrorHandshakeFailed => "SSL_ERROR_HANDSHAKE_FAILED",
                Self::ESslErrorHandshakeFailureAlert => "SSL_ERROR_HANDSHAKE_FAILURE_ALERT",
                Self::ESslErrorHandshakeUnexpectedAlert => "SSL_ERROR_HANDSHAKE_UNEXPECTED_ALERT",
                Self::ESslErrorIllegalParameterAlert => "SSL_ERROR_ILLEGAL_PARAMETER_ALERT",
                Self::ESslErrorInternalErrorAlert => "SSL_ERROR_INTERNAL_ERROR_ALERT",
                Self::ESslErrorKeyExchangeFailure => "SSL_ERROR_KEY_EXCHANGE_FAILURE",
                Self::ESslErrorNoCypherOverlap => "SSL_ERROR_NO_CYPHER_OVERLAP",
                Self::ESslErrorProtocolVersionAlert => "SSL_ERROR_PROTOCOL_VERSION_ALERT",
                Self::ESslErrorRxUnexpectedRecordType => "SSL_ERROR_RX_UNEXPECTED_RECORD_TYPE",
                Self::ESslErrorRxMalformedHybridKeyShare => "SSL_ERROR_RX_MALFORMED_HYBRID_KEY_SHARE",
                Self::ESslErrorUnsupportedVersion => "SSL_ERROR_UNSUPPORTED_VERSION",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from tls.xyber_intolerance_reason
    ///
    /// The error that was returned from a failed TLS 1.3 handshake in which the client
    /// sent a mlkem768x25519 key share (see tlsIntoleranceTelemetryBucket() in
    /// nsNSSIOLayer.cpp).
    pub static xyber_intolerance_reason: Lazy<LabeledMetric<LabeledCounterMetric, XyberIntoleranceReasonLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "xyber_intolerance_reason".into(),
                    category: "tls".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3468.into(), meta, Some(vec![::std::borrow::Cow::from("PR_CONNECT_RESET_ERROR"), ::std::borrow::Cow::from("PR_END_OF_FILE_ERROR"), ::std::borrow::Cow::from("SSL_ERROR_BAD_HANDSHAKE_HASH_VALUE"), ::std::borrow::Cow::from("SSL_ERROR_BAD_MAC_ALERT"), ::std::borrow::Cow::from("SSL_ERROR_BAD_MAC_READ"), ::std::borrow::Cow::from("SSL_ERROR_DECODE_ERROR_ALERT"), ::std::borrow::Cow::from("SSL_ERROR_HANDSHAKE_FAILED"), ::std::borrow::Cow::from("SSL_ERROR_HANDSHAKE_FAILURE_ALERT"), ::std::borrow::Cow::from("SSL_ERROR_HANDSHAKE_UNEXPECTED_ALERT"), ::std::borrow::Cow::from("SSL_ERROR_ILLEGAL_PARAMETER_ALERT"), ::std::borrow::Cow::from("SSL_ERROR_INTERNAL_ERROR_ALERT"), ::std::borrow::Cow::from("SSL_ERROR_KEY_EXCHANGE_FAILURE"), ::std::borrow::Cow::from("SSL_ERROR_NO_CYPHER_OVERLAP"), ::std::borrow::Cow::from("SSL_ERROR_PROTOCOL_VERSION_ALERT"), ::std::borrow::Cow::from("SSL_ERROR_RX_MALFORMED_HYBRID_KEY_SHARE"), ::std::borrow::Cow::from("SSL_ERROR_RX_UNEXPECTED_RECORD_TYPE"), ::std::borrow::Cow::from("SSL_ERROR_UNSUPPORTED_VERSION")]))
    });

}
pub mod verification_used_cert_from {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from verification_used_cert_from.built_in_roots_module
    ///
    /// How many successfully-built certificate chains used a certificate from the
    /// built-in roots module.
    pub static built_in_roots_module: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "built_in_roots_module".into(),
                category: "verification_used_cert_from".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3469.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from verification_used_cert_from.nss_cert_db
    ///
    /// How many successfully-built certificate chains used a certificate from the NSS
    /// cert DB.
    pub static nss_cert_db: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "nss_cert_db".into(),
                category: "verification_used_cert_from".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3470.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from verification_used_cert_from.preloaded_intermediates
    ///
    /// How many successfully-built certificate chains used a certificate from
    /// preloaded intermediates.
    pub static preloaded_intermediates: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "preloaded_intermediates".into(),
                category: "verification_used_cert_from".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3471.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from verification_used_cert_from.third_party_certificates
    ///
    /// How many successfully-built certificate chains used a third-party certificate
    /// from the OS.
    pub static third_party_certificates: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "third_party_certificates".into(),
                category: "verification_used_cert_from".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3472.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from verification_used_cert_from.tls_handshake
    ///
    /// How many successfully-built certificate chains used a certificate from the TLS
    /// handshake.
    pub static tls_handshake: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tls_handshake".into(),
                category: "verification_used_cert_from".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3473.into(), meta)
    });

}
pub mod uptake_remotecontent_result {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UptakeNormandyExtra {
        pub r#age: Option<String>,
        pub r#duration: Option<String>,
        pub r#errorName: Option<String>,
        pub r#source: Option<String>,
        pub r#timestamp: Option<String>,
        pub r#trigger: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UptakeNormandyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["age", "duration", "errorName", "source", "timestamp", "trigger", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#age.and_then(|val| map.insert("age".into(), val.to_string()));
          self.r#duration.and_then(|val| map.insert("duration".into(), val.to_string()));
          self.r#errorName.and_then(|val| map.insert("errorName".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#timestamp.and_then(|val| map.insert("timestamp".into(), val.to_string()));
          self.r#trigger.and_then(|val| map.insert("trigger".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from uptake.remotecontent.result.uptake_normandy
    ///
    /// Was the remote content successfully pulled? This uptake telemetry allows to
    /// monitor the behaviour of our clients when it comes to fetching data from remote
    /// servers. This helps defect-detection and allow observation of the proportion of
    /// success among clients and sources, the distribution of error causes, and its
    /// evolution over time. This event was generated to correspond to the Legacy
    /// Telemetry event uptake.remotecontent.result.uptake#normandy.
    pub static uptake_normandy: Lazy<EventMetric<UptakeNormandyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uptake_normandy".into(),
                category: "uptake.remotecontent.result".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3474.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UptakeRemotesettingsExtra {
        pub r#age: Option<String>,
        pub r#duration: Option<String>,
        pub r#errorName: Option<String>,
        pub r#source: Option<String>,
        pub r#timestamp: Option<String>,
        pub r#trigger: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UptakeRemotesettingsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["age", "duration", "errorName", "source", "timestamp", "trigger", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#age.and_then(|val| map.insert("age".into(), val.to_string()));
          self.r#duration.and_then(|val| map.insert("duration".into(), val.to_string()));
          self.r#errorName.and_then(|val| map.insert("errorName".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#timestamp.and_then(|val| map.insert("timestamp".into(), val.to_string()));
          self.r#trigger.and_then(|val| map.insert("trigger".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from uptake.remotecontent.result.uptake_remotesettings
    ///
    /// Was the remote content successfully pulled? This uptake telemetry allows to
    /// monitor the behaviour of our clients when it comes to fetching data from remote
    /// servers. This helps defect-detection and allow observation of the proportion of
    /// success among clients and sources, the distribution of error causes, and its
    /// evolution over time. This event was generated to correspond to the Legacy
    /// Telemetry event uptake.remotecontent.result.uptake#remotesettings.
    pub static uptake_remotesettings: Lazy<EventMetric<UptakeRemotesettingsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uptake_remotesettings".into(),
                category: "uptake.remotecontent.result".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3475.into(), meta)
    });

}
pub mod client_association {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from client_association.legacy_client_id
    ///
    /// The legacy Telemetry client ID associated with this user profile.
    pub static legacy_client_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "legacy_client_id".into(),
                category: "client_association".into(),
                send_in_pings: vec!["fx-accounts".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(3476.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from client_association.uid
    ///
    /// The Mozilla Account UID associated with the user.
    pub static uid: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uid".into(),
                category: "client_association".into(),
                send_in_pings: vec!["fx-accounts".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3477.into(), meta)
    });

}
pub mod fxa {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ConnectAccountExtra {
        pub r#fxa: Option<String>,
        pub r#sync: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ConnectAccountExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa", "sync", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa.and_then(|val| map.insert("fxa".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa.connect_account
    ///
    /// Records when a Firefox Account, or a Firefox Account service, is explicitly
    /// connected from the browser via an intentional user action. This event was
    /// generated to correspond to the Legacy Telemetry event fxa.connect#account.
    pub static connect_account: Lazy<EventMetric<ConnectAccountExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "connect_account".into(),
                category: "fxa".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3478.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisconnectAccountExtra {
        pub r#fxa: Option<String>,
        pub r#sync: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisconnectAccountExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa", "sync", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa.and_then(|val| map.insert("fxa".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa.disconnect_account
    ///
    /// Records when a Firefox Account, or a Firefox Account service, is explicitly
    /// disconnected from the browser via an intentional user action. This event was
    /// generated to correspond to the Legacy Telemetry event fxa.disconnect#account.
    pub static disconnect_account: Lazy<EventMetric<DisconnectAccountExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disconnect_account".into(),
                category: "fxa".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3479.into(), meta)
    });

}
pub mod fxa_app_menu {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickAccountSettingsExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickAccountSettingsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_account_settings
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu
    /// This event was generated to correspond to the Legacy Telemetry event
    /// fxa_app_menu.click#account_settings.
    pub static click_account_settings: Lazy<EventMetric<ClickAccountSettingsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_account_settings".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3480.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickCadExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickCadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_cad
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu
    /// This event was generated to correspond to the Legacy Telemetry event
    /// fxa_app_menu.click#cad.
    pub static click_cad: Lazy<EventMetric<ClickCadExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_cad".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3481.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickLoginExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_login
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu
    /// This event was generated to correspond to the Legacy Telemetry event
    /// fxa_app_menu.click#login.
    pub static click_login: Lazy<EventMetric<ClickLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_login".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3482.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickMonitorCtaExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickMonitorCtaExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_monitor_cta
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu
    /// This event was generated to correspond to the Legacy Telemetry event
    /// fxa_app_menu.click#monitor_cta.
    pub static click_monitor_cta: Lazy<EventMetric<ClickMonitorCtaExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_monitor_cta".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3483.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickOpenMonitorExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickOpenMonitorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_open_monitor
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu
    /// This event was generated to correspond to the Legacy Telemetry event
    /// fxa_app_menu.click#open_monitor.
    pub static click_open_monitor: Lazy<EventMetric<ClickOpenMonitorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_open_monitor".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3484.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickOpenSendExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickOpenSendExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_open_send
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu
    /// This event was generated to correspond to the Legacy Telemetry event
    /// fxa_app_menu.click#open_send.
    pub static click_open_send: Lazy<EventMetric<ClickOpenSendExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_open_send".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3485.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickRelayCtaExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickRelayCtaExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_relay_cta
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu
    /// This event was generated to correspond to the Legacy Telemetry event
    /// fxa_app_menu.click#relay_cta.
    pub static click_relay_cta: Lazy<EventMetric<ClickRelayCtaExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_relay_cta".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3486.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSendTabExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickSendTabExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_send_tab
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu
    /// This event was generated to correspond to the Legacy Telemetry event
    /// fxa_app_menu.click#send_tab.
    pub static click_send_tab: Lazy<EventMetric<ClickSendTabExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_send_tab".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3487.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncCtaExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickSyncCtaExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_sync_cta
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu
    /// This event was generated to correspond to the Legacy Telemetry event
    /// fxa_app_menu.click#sync_cta.
    pub static click_sync_cta: Lazy<EventMetric<ClickSyncCtaExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_sync_cta".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3488.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncNowExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickSyncNowExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_sync_now
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu
    /// This event was generated to correspond to the Legacy Telemetry event
    /// fxa_app_menu.click#sync_now.
    pub static click_sync_now: Lazy<EventMetric<ClickSyncNowExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_sync_now".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3489.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncSettingsExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickSyncSettingsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_sync_settings
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu
    /// This event was generated to correspond to the Legacy Telemetry event
    /// fxa_app_menu.click#sync_settings.
    pub static click_sync_settings: Lazy<EventMetric<ClickSyncSettingsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_sync_settings".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3490.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncTabsExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickSyncTabsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_sync_tabs
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu
    /// This event was generated to correspond to the Legacy Telemetry event
    /// fxa_app_menu.click#sync_tabs.
    pub static click_sync_tabs: Lazy<EventMetric<ClickSyncTabsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_sync_tabs".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3491.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncTabsSidebarExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickSyncTabsSidebarExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_sync_tabs_sidebar
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu
    /// This event was generated to correspond to the Legacy Telemetry event
    /// fxa_app_menu.click#sync_tabs_sidebar.
    pub static click_sync_tabs_sidebar: Lazy<EventMetric<ClickSyncTabsSidebarExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_sync_tabs_sidebar".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3492.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickToolbarIconExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickToolbarIconExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_toolbar_icon
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu
    /// This event was generated to correspond to the Legacy Telemetry event
    /// fxa_app_menu.click#toolbar_icon.
    pub static click_toolbar_icon: Lazy<EventMetric<ClickToolbarIconExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_toolbar_icon".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3493.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickUnverSyncSettingsExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickUnverSyncSettingsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_unver_sync_settings
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu
    /// This event was generated to correspond to the Legacy Telemetry event
    /// fxa_app_menu.click#unver_sync_settings.
    pub static click_unver_sync_settings: Lazy<EventMetric<ClickUnverSyncSettingsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_unver_sync_settings".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3494.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickVpnCtaExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickVpnCtaExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_vpn_cta
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu
    /// This event was generated to correspond to the Legacy Telemetry event
    /// fxa_app_menu.click#vpn_cta.
    pub static click_vpn_cta: Lazy<EventMetric<ClickVpnCtaExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_vpn_cta".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3495.into(), meta)
    });

}
pub mod fxa_avatar_menu {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickAccountSettingsExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickAccountSettingsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_account_settings
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This
    /// event was generated to correspond to the Legacy Telemetry event
    /// fxa_avatar_menu.click#account_settings.
    pub static click_account_settings: Lazy<EventMetric<ClickAccountSettingsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_account_settings".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3496.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickCadExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickCadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_cad
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This
    /// event was generated to correspond to the Legacy Telemetry event
    /// fxa_avatar_menu.click#cad.
    pub static click_cad: Lazy<EventMetric<ClickCadExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_cad".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3497.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickLoginExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_login
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This
    /// event was generated to correspond to the Legacy Telemetry event
    /// fxa_avatar_menu.click#login.
    pub static click_login: Lazy<EventMetric<ClickLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_login".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3498.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickMonitorCtaExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickMonitorCtaExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_monitor_cta
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This
    /// event was generated to correspond to the Legacy Telemetry event
    /// fxa_avatar_menu.click#monitor_cta.
    pub static click_monitor_cta: Lazy<EventMetric<ClickMonitorCtaExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_monitor_cta".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3499.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickOpenMonitorExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickOpenMonitorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_open_monitor
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This
    /// event was generated to correspond to the Legacy Telemetry event
    /// fxa_avatar_menu.click#open_monitor.
    pub static click_open_monitor: Lazy<EventMetric<ClickOpenMonitorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_open_monitor".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3500.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickOpenSendExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickOpenSendExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_open_send
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This
    /// event was generated to correspond to the Legacy Telemetry event
    /// fxa_avatar_menu.click#open_send.
    pub static click_open_send: Lazy<EventMetric<ClickOpenSendExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_open_send".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3501.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickRelayCtaExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickRelayCtaExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_relay_cta
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This
    /// event was generated to correspond to the Legacy Telemetry event
    /// fxa_avatar_menu.click#relay_cta.
    pub static click_relay_cta: Lazy<EventMetric<ClickRelayCtaExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_relay_cta".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3502.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSendTabExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickSendTabExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_send_tab
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This
    /// event was generated to correspond to the Legacy Telemetry event
    /// fxa_avatar_menu.click#send_tab.
    pub static click_send_tab: Lazy<EventMetric<ClickSendTabExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_send_tab".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3503.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncCtaExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickSyncCtaExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_sync_cta
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This
    /// event was generated to correspond to the Legacy Telemetry event
    /// fxa_avatar_menu.click#sync_cta.
    pub static click_sync_cta: Lazy<EventMetric<ClickSyncCtaExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_sync_cta".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3504.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncNowExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickSyncNowExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_sync_now
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This
    /// event was generated to correspond to the Legacy Telemetry event
    /// fxa_avatar_menu.click#sync_now.
    pub static click_sync_now: Lazy<EventMetric<ClickSyncNowExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_sync_now".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3505.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncSettingsExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickSyncSettingsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_sync_settings
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This
    /// event was generated to correspond to the Legacy Telemetry event
    /// fxa_avatar_menu.click#sync_settings.
    pub static click_sync_settings: Lazy<EventMetric<ClickSyncSettingsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_sync_settings".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3506.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncTabsExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickSyncTabsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_sync_tabs
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This
    /// event was generated to correspond to the Legacy Telemetry event
    /// fxa_avatar_menu.click#sync_tabs.
    pub static click_sync_tabs: Lazy<EventMetric<ClickSyncTabsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_sync_tabs".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3507.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncTabsSidebarExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickSyncTabsSidebarExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_sync_tabs_sidebar
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This
    /// event was generated to correspond to the Legacy Telemetry event
    /// fxa_avatar_menu.click#sync_tabs_sidebar.
    pub static click_sync_tabs_sidebar: Lazy<EventMetric<ClickSyncTabsSidebarExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_sync_tabs_sidebar".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3508.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickToolbarIconExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickToolbarIconExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_toolbar_icon
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This
    /// event was generated to correspond to the Legacy Telemetry event
    /// fxa_avatar_menu.click#toolbar_icon.
    pub static click_toolbar_icon: Lazy<EventMetric<ClickToolbarIconExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_toolbar_icon".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3509.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickUnverSyncSettingsExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickUnverSyncSettingsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_unver_sync_settings
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This
    /// event was generated to correspond to the Legacy Telemetry event
    /// fxa_avatar_menu.click#unver_sync_settings.
    pub static click_unver_sync_settings: Lazy<EventMetric<ClickUnverSyncSettingsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_unver_sync_settings".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3510.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickVpnCtaExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
    }

    impl ExtraKeys for ClickVpnCtaExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_vpn_cta
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This
    /// event was generated to correspond to the Legacy Telemetry event
    /// fxa_avatar_menu.click#vpn_cta.
    pub static click_vpn_cta: Lazy<EventMetric<ClickVpnCtaExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_vpn_cta".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3511.into(), meta)
    });

}
pub mod bounce_tracking_protection {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from bounce.tracking.protection.mode
    ///
    /// Records the pref value of privacy.bounceTrackingProtection.mode. Values are any
    /// of nsIBounceTrackingProtection#Modes.
    pub static mode: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mode".into(),
                category: "bounce.tracking.protection".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3512.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from bounce.tracking.protection.num_hosts_per_purge_run
    ///
    /// Number of bounce trackers purged successfully per scheduled purge.
    pub static num_hosts_per_purge_run: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "num_hosts_per_purge_run".into(),
                category: "bounce.tracking.protection".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3513.into(), meta, 1, 99, 100, HistogramType::Linear)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PurgeActionExtra {
        pub r#bounce_time: Option<u32>,
        pub r#is_dry_run: Option<bool>,
        pub r#site_host: Option<String>,
        pub r#success: Option<bool>,
    }

    impl ExtraKeys for PurgeActionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["bounce_time", "is_dry_run", "site_host", "success"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#bounce_time.and_then(|val| map.insert("bounce_time".into(), val.to_string()));
          self.r#is_dry_run.and_then(|val| map.insert("is_dry_run".into(), val.to_string()));
          self.r#site_host.and_then(|val| map.insert("site_host".into(), val.to_string()));
          self.r#success.and_then(|val| map.insert("success".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from bounce.tracking.protection.purge_action
    ///
    /// Dispatched whenever a bounce tracker site is purged.
    pub static purge_action: Lazy<EventMetric<PurgeActionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "purge_action".into(),
                category: "bounce.tracking.protection".into(),
                send_in_pings: vec!["bounce-tracking-protection".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3514.into(), meta)
    });

    #[repr(u16)]
    pub enum PurgeCountLabel {
        ESuccess = 0,
        EFailure = 1,
        EDry = 2,
        __Other__,
    }
    impl From<u16> for PurgeCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EFailure,
                2 => Self::EDry,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PurgeCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EFailure => "failure",
                Self::EDry => "dry",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from bounce.tracking.protection.purge_count
    ///
    /// Counts how often we purge trackers. Giving a high level overview about the
    /// effectivness of bounce tracking protection. Allows determining error rate with
    /// failure/success label. When in dry mode, we count the purges that would have
    /// happened under the dry label.
    pub static purge_count: Lazy<LabeledMetric<LabeledCounterMetric, PurgeCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "purge_count".into(),
                    category: "bounce.tracking.protection".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3515.into(), meta, Some(vec![::std::borrow::Cow::from("dry"), ::std::borrow::Cow::from("failure"), ::std::borrow::Cow::from("success")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from bounce.tracking.protection.purge_count_classified_tracker
    ///
    /// Counts sites purged from BTP that are classified as trackers as part of the
    /// following lists: [emailtracking-protection, fingerprinting-protection,
    /// socialtracking-protection, tracking-protection]
    pub static purge_count_classified_tracker: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3516,
            "bounce.tracking.protection",
            "purge_count_classified_tracker",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from bounce.tracking.protection.purge_duration
    ///
    /// For every purge that is scheduled, we call the ClearDataService to purge
    /// persistent storage for each detected bounce tracker. This may do some blocking
    /// work on main thread and dispatch some cleanups to other threads. Collect
    /// telemetry on how long it takes to clear in the wild to determine whether we
    /// need to improve performance here.
    pub static purge_duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "purge_duration".into(),
                category: "bounce.tracking.protection".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3517.into(), meta, TimeUnit::Nanosecond)
    });

}
pub mod contentblocking {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.category
    ///
    /// This scalar reports the value of the content blocking category pref (0 =
    /// "standard", 1 = "strict", 2 = "custom", 3 = some other value, this is not
    /// supported). This metric was generated to correspond to the Legacy Telemetry
    /// scalar contentblocking.category.
    pub static category: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "category".into(),
                category: "contentblocking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3518.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.cryptomining_blocking_enabled
    ///
    /// True if cryptominer blocking is enabled globally at startup. This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// contentblocking.cryptomining_blocking_enabled.
    pub static cryptomining_blocking_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cryptomining_blocking_enabled".into(),
                category: "contentblocking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3519.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.fingerprinting_blocking_enabled
    ///
    /// True if fingerprinter blocking is enabled globally at startup. This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// contentblocking.fingerprinting_blocking_enabled.
    pub static fingerprinting_blocking_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fingerprinting_blocking_enabled".into(),
                category: "contentblocking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3520.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.trackers_blocked_count
    ///
    /// A count of the number of tracking events blocked. This metric was generated to
    /// correspond to the Legacy Telemetry scalar
    /// contentblocking.trackers_blocked_count.
    pub static trackers_blocked_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3521,
            "contentblocking",
            "trackers_blocked_count",
            "metrics"
        )
    });

}
pub mod background_tasks_rmdir_base {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.elapsed_ms
    ///
    /// The amount of time the task took for removing the directories.
    pub static elapsed_ms: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "elapsed_ms".into(),
                category: "background_tasks.rmdir.base".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3522.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.metric_base
    ///
    /// The base metric template for removeDirectory.
    pub static metric_base: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "metric_base".into(),
                category: "background_tasks.rmdir.base".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3523.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.removal_count
    ///
    /// The number of the removed entries at each call, even if the target directory
    /// itself couldn't be removed.
    pub static removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "removal_count".into(),
                category: "background_tasks.rmdir.base".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3524.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.retry_count
    ///
    /// The number of retries before the task started removing the child directory.
    /// This can happen when the target directory doesn't exist.
    pub static retry_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "retry_count".into(),
                category: "background_tasks.rmdir.base".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3525.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.succeeded
    ///
    /// Whether the target directory removal succeeded.
    pub static succeeded: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "succeeded".into(),
                category: "background_tasks.rmdir.base".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3526.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.suffix_ever_failed
    ///
    /// Whether removing the suffixed directories ever failed.
    pub static suffix_ever_failed: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "suffix_ever_failed".into(),
                category: "background_tasks.rmdir.base".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3527.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.suffix_removal_count
    ///
    /// The number of the removed entries of the suffixed directories.
    pub static suffix_removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "suffix_removal_count".into(),
                category: "background_tasks.rmdir.base".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3528.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.was_first
    ///
    /// Whether this task is the first one removing the directory.
    pub static was_first: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "was_first".into(),
                category: "background_tasks.rmdir.base".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3529.into(), meta)
    });

}
pub mod background_tasks_rmdir_http_cache {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.elapsed_ms
    ///
    /// The amount of time the task took for removing the directories.
    pub static elapsed_ms: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "elapsed_ms".into(),
                category: "background_tasks.rmdir.http_cache".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3530.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.metric_base
    ///
    /// The base metric template for removeDirectory.
    pub static metric_base: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "metric_base".into(),
                category: "background_tasks.rmdir.http_cache".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3531.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.removal_count
    ///
    /// The number of the removed entries at each call, even if the target directory
    /// itself couldn't be removed.
    pub static removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "removal_count".into(),
                category: "background_tasks.rmdir.http_cache".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3532.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.retry_count
    ///
    /// The number of retries before the task started removing the child directory.
    /// This can happen when the target directory doesn't exist.
    pub static retry_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "retry_count".into(),
                category: "background_tasks.rmdir.http_cache".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3533.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.succeeded
    ///
    /// Whether the target directory removal succeeded.
    pub static succeeded: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "succeeded".into(),
                category: "background_tasks.rmdir.http_cache".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3534.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.suffix_ever_failed
    ///
    /// Whether removing the suffixed directories ever failed.
    pub static suffix_ever_failed: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "suffix_ever_failed".into(),
                category: "background_tasks.rmdir.http_cache".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3535.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.suffix_removal_count
    ///
    /// The number of the removed entries of the suffixed directories.
    pub static suffix_removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "suffix_removal_count".into(),
                category: "background_tasks.rmdir.http_cache".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3536.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.was_first
    ///
    /// Whether this task is the first one removing the directory.
    pub static was_first: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "was_first".into(),
                category: "background_tasks.rmdir.http_cache".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3537.into(), meta)
    });

}
pub mod background_tasks_rmdir_quota {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.elapsed_ms
    ///
    /// The amount of time the task took for removing the directories.
    pub static elapsed_ms: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "elapsed_ms".into(),
                category: "background_tasks.rmdir.quota".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3538.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.metric_base
    ///
    /// The base metric template for removeDirectory.
    pub static metric_base: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "metric_base".into(),
                category: "background_tasks.rmdir.quota".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3539.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.removal_count
    ///
    /// The number of the removed entries at each call, even if the target directory
    /// itself couldn't be removed.
    pub static removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "removal_count".into(),
                category: "background_tasks.rmdir.quota".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3540.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.retry_count
    ///
    /// The number of retries before the task started removing the child directory.
    /// This can happen when the target directory doesn't exist.
    pub static retry_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "retry_count".into(),
                category: "background_tasks.rmdir.quota".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3541.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.succeeded
    ///
    /// Whether the target directory removal succeeded.
    pub static succeeded: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "succeeded".into(),
                category: "background_tasks.rmdir.quota".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3542.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.suffix_ever_failed
    ///
    /// Whether removing the suffixed directories ever failed.
    pub static suffix_ever_failed: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "suffix_ever_failed".into(),
                category: "background_tasks.rmdir.quota".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3543.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.suffix_removal_count
    ///
    /// The number of the removed entries of the suffixed directories.
    pub static suffix_removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "suffix_removal_count".into(),
                category: "background_tasks.rmdir.quota".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3544.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.was_first
    ///
    /// Whether this task is the first one removing the directory.
    pub static was_first: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "was_first".into(),
                category: "background_tasks.rmdir.quota".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3545.into(), meta)
    });

}
pub mod relevancy_classify {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from relevancy.classify.duration
    ///
    /// Record the duration (in ms) of a successful classification.
    pub static duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "duration".into(),
                category: "relevancy.classify".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3546.into(), meta, TimeUnit::Millisecond)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FailExtra {
        pub r#reason: Option<String>,
    }

    impl ExtraKeys for FailExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relevancy.classify.fail
    ///
    /// Record an event of a failed / aborted user interest classification.
    pub static fail: Lazy<EventMetric<FailExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fail".into(),
                category: "relevancy.classify".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3547.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SucceedExtra {
        pub r#input_classified_size: Option<u32>,
        pub r#input_inconclusive_size: Option<u32>,
        pub r#input_size: Option<u32>,
        pub r#interest_top_1_hits: Option<u32>,
        pub r#interest_top_2_hits: Option<u32>,
        pub r#interest_top_3_hits: Option<u32>,
        pub r#output_interest_size: Option<u32>,
    }

    impl ExtraKeys for SucceedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["input_classified_size", "input_inconclusive_size", "input_size", "interest_top_1_hits", "interest_top_2_hits", "interest_top_3_hits", "output_interest_size"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#input_classified_size.and_then(|val| map.insert("input_classified_size".into(), val.to_string()));
          self.r#input_inconclusive_size.and_then(|val| map.insert("input_inconclusive_size".into(), val.to_string()));
          self.r#input_size.and_then(|val| map.insert("input_size".into(), val.to_string()));
          self.r#interest_top_1_hits.and_then(|val| map.insert("interest_top_1_hits".into(), val.to_string()));
          self.r#interest_top_2_hits.and_then(|val| map.insert("interest_top_2_hits".into(), val.to_string()));
          self.r#interest_top_3_hits.and_then(|val| map.insert("interest_top_3_hits".into(), val.to_string()));
          self.r#output_interest_size.and_then(|val| map.insert("output_interest_size".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relevancy.classify.succeed
    ///
    /// Record an event of a successful user interest classification.
    pub static succeed: Lazy<EventMetric<SucceedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "succeed".into(),
                category: "relevancy.classify".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3548.into(), meta)
    });

}
pub mod cookie_banners {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.cookie_injection_fail
    ///
    /// Counts how often the cookie banner is still shown even if we have injected
    /// cookies.
    pub static cookie_injection_fail: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3549,
            "cookie.banners",
            "cookie_injection_fail",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.google_gdpr_choice_cookie
    ///
    /// Records the GDPR choice on Google Search based on the "SOCS" cookie of the
    /// Google Search domains. The value could be "Accept", "Reject" or "Custom". We
    /// use the label to record different choices on different Google domains. We only
    /// collect this if the default search engine is Google.
    pub static google_gdpr_choice_cookie: Lazy<LabeledMetric<LabeledStringMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "google_gdpr_choice_cookie".into(),
                    category: "cookie.banners".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3550.into(), meta, None)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct GoogleGdprChoiceCookieEventExtra {
        pub r#choice: Option<String>,
        pub r#region: Option<String>,
        pub r#search_domain: Option<String>,
    }

    impl ExtraKeys for GoogleGdprChoiceCookieEventExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["choice", "region", "search_domain"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#choice.and_then(|val| map.insert("choice".into(), val.to_string()));
          self.r#region.and_then(|val| map.insert("region".into(), val.to_string()));
          self.r#search_domain.and_then(|val| map.insert("search_domain".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.google_gdpr_choice_cookie_event
    ///
    /// Recorded whenever a GDPR choice is made on a Google Search page. We assess the
    /// "SOCS" cookie to know the GDPR choice.
    pub static google_gdpr_choice_cookie_event: Lazy<EventMetric<GoogleGdprChoiceCookieEventExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "google_gdpr_choice_cookie_event".into(),
                category: "cookie.banners".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3551.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct GoogleGdprChoiceCookieEventPbmExtra {
        pub r#choice: Option<String>,
    }

    impl ExtraKeys for GoogleGdprChoiceCookieEventPbmExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["choice"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#choice.and_then(|val| map.insert("choice".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.google_gdpr_choice_cookie_event_pbm
    ///
    /// Recorded whenever a GDPR choice is made on a Google Search page on private
    /// browsing windows. We assess the "SOCS" cookie to know the GDPR choice.
    pub static google_gdpr_choice_cookie_event_pbm: Lazy<EventMetric<GoogleGdprChoiceCookieEventPbmExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "google_gdpr_choice_cookie_event_pbm".into(),
                category: "cookie.banners".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3552.into(), meta)
    });

    #[repr(u16)]
    pub enum NormalWindowServiceModeLabel {
        EDisabled = 0,
        EReject = 1,
        ERejectOrAccept = 2,
        EInvalid = 3,
        __Other__,
    }
    impl From<u16> for NormalWindowServiceModeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDisabled,
                1 => Self::EReject,
                2 => Self::ERejectOrAccept,
                3 => Self::EInvalid,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for NormalWindowServiceModeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDisabled => "disabled",
                Self::EReject => "reject",
                Self::ERejectOrAccept => "reject_or_accept",
                Self::EInvalid => "invalid",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.normal_window_service_mode
    ///
    /// The pref value of the cookie banner service mode for normal windows.
    pub static normal_window_service_mode: Lazy<LabeledMetric<LabeledBooleanMetric, NormalWindowServiceModeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "normal_window_service_mode".into(),
                    category: "cookie.banners".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3553.into(), meta, Some(vec![::std::borrow::Cow::from("disabled"), ::std::borrow::Cow::from("invalid"), ::std::borrow::Cow::from("reject"), ::std::borrow::Cow::from("reject_or_accept")]))
    });

    #[repr(u16)]
    pub enum PrivateWindowServiceModeLabel {
        EDisabled = 0,
        EReject = 1,
        ERejectOrAccept = 2,
        EInvalid = 3,
        __Other__,
    }
    impl From<u16> for PrivateWindowServiceModeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDisabled,
                1 => Self::EReject,
                2 => Self::ERejectOrAccept,
                3 => Self::EInvalid,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PrivateWindowServiceModeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDisabled => "disabled",
                Self::EReject => "reject",
                Self::ERejectOrAccept => "reject_or_accept",
                Self::EInvalid => "invalid",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.private_window_service_mode
    ///
    /// The pref value of the cookie banner service mode for private windows.
    pub static private_window_service_mode: Lazy<LabeledMetric<LabeledBooleanMetric, PrivateWindowServiceModeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "private_window_service_mode".into(),
                    category: "cookie.banners".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3554.into(), meta, Some(vec![::std::borrow::Cow::from("disabled"), ::std::borrow::Cow::from("invalid"), ::std::borrow::Cow::from("reject"), ::std::borrow::Cow::from("reject_or_accept")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReloadExtra {
        pub r#has_click_rule: Option<bool>,
        pub r#has_cookie_rule: Option<bool>,
        pub r#no_rule: Option<bool>,
    }

    impl ExtraKeys for ReloadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_click_rule", "has_cookie_rule", "no_rule"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_click_rule.and_then(|val| map.insert("has_click_rule".into(), val.to_string()));
          self.r#has_cookie_rule.and_then(|val| map.insert("has_cookie_rule".into(), val.to_string()));
          self.r#no_rule.and_then(|val| map.insert("no_rule".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.reload
    ///
    /// Recorded when the top-level page is reloaded. We use this event metric to know
    /// whether or not the reloading domain has cookie banner rule.
    pub static reload: Lazy<EventMetric<ReloadExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reload".into(),
                category: "cookie.banners".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3555.into(), meta)
    });

    #[repr(u16)]
    pub enum RuleLookupByDomainLabel {
        ETopHit = 0,
        ETopHitOptIn = 1,
        ETopHitOptOut = 2,
        ETopMiss = 3,
        EIframeHit = 4,
        EIframeHitOptIn = 5,
        EIframeHitOptOut = 6,
        EIframeMiss = 7,
        ETopCookieHit = 8,
        ETopCookieHitOptIn = 9,
        ETopCookieHitOptOut = 10,
        ETopCookieMiss = 11,
        EIframeCookieHit = 12,
        EIframeCookieHitOptIn = 13,
        EIframeCookieHitOptOut = 14,
        EIframeCookieMiss = 15,
        ETopClickHit = 16,
        ETopClickHitOptIn = 17,
        ETopClickHitOptOut = 18,
        ETopClickMiss = 19,
        EIframeClickHit = 20,
        EIframeClickHitOptIn = 21,
        EIframeClickHitOptOut = 22,
        EIframeClickMiss = 23,
        __Other__,
    }
    impl From<u16> for RuleLookupByDomainLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ETopHit,
                1 => Self::ETopHitOptIn,
                2 => Self::ETopHitOptOut,
                3 => Self::ETopMiss,
                4 => Self::EIframeHit,
                5 => Self::EIframeHitOptIn,
                6 => Self::EIframeHitOptOut,
                7 => Self::EIframeMiss,
                8 => Self::ETopCookieHit,
                9 => Self::ETopCookieHitOptIn,
                10 => Self::ETopCookieHitOptOut,
                11 => Self::ETopCookieMiss,
                12 => Self::EIframeCookieHit,
                13 => Self::EIframeCookieHitOptIn,
                14 => Self::EIframeCookieHitOptOut,
                15 => Self::EIframeCookieMiss,
                16 => Self::ETopClickHit,
                17 => Self::ETopClickHitOptIn,
                18 => Self::ETopClickHitOptOut,
                19 => Self::ETopClickMiss,
                20 => Self::EIframeClickHit,
                21 => Self::EIframeClickHitOptIn,
                22 => Self::EIframeClickHitOptOut,
                23 => Self::EIframeClickMiss,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RuleLookupByDomainLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ETopHit => "top_hit",
                Self::ETopHitOptIn => "top_hit_opt_in",
                Self::ETopHitOptOut => "top_hit_opt_out",
                Self::ETopMiss => "top_miss",
                Self::EIframeHit => "iframe_hit",
                Self::EIframeHitOptIn => "iframe_hit_opt_in",
                Self::EIframeHitOptOut => "iframe_hit_opt_out",
                Self::EIframeMiss => "iframe_miss",
                Self::ETopCookieHit => "top_cookie_hit",
                Self::ETopCookieHitOptIn => "top_cookie_hit_opt_in",
                Self::ETopCookieHitOptOut => "top_cookie_hit_opt_out",
                Self::ETopCookieMiss => "top_cookie_miss",
                Self::EIframeCookieHit => "iframe_cookie_hit",
                Self::EIframeCookieHitOptIn => "iframe_cookie_hit_opt_in",
                Self::EIframeCookieHitOptOut => "iframe_cookie_hit_opt_out",
                Self::EIframeCookieMiss => "iframe_cookie_miss",
                Self::ETopClickHit => "top_click_hit",
                Self::ETopClickHitOptIn => "top_click_hit_opt_in",
                Self::ETopClickHitOptOut => "top_click_hit_opt_out",
                Self::ETopClickMiss => "top_click_miss",
                Self::EIframeClickHit => "iframe_click_hit",
                Self::EIframeClickHitOptIn => "iframe_click_hit_opt_in",
                Self::EIframeClickHitOptOut => "iframe_click_hit_opt_out",
                Self::EIframeClickMiss => "iframe_click_miss",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.rule_lookup_by_domain
    ///
    /// Counts the number of hit/miss of cookie banner rule lookups for domain. We
    /// collect three types of counters, including counters for overall rule lookup,
    /// counters for cookie rule lookup and counters for click rule lookup. We also
    /// divide the counter by top-level loads and iframe loads. For each domain, we
    /// will only collect once.
    pub static rule_lookup_by_domain: Lazy<LabeledMetric<LabeledCounterMetric, RuleLookupByDomainLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "rule_lookup_by_domain".into(),
                    category: "cookie.banners".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3556.into(), meta, Some(vec![::std::borrow::Cow::from("iframe_click_hit"), ::std::borrow::Cow::from("iframe_click_hit_opt_in"), ::std::borrow::Cow::from("iframe_click_hit_opt_out"), ::std::borrow::Cow::from("iframe_click_miss"), ::std::borrow::Cow::from("iframe_cookie_hit"), ::std::borrow::Cow::from("iframe_cookie_hit_opt_in"), ::std::borrow::Cow::from("iframe_cookie_hit_opt_out"), ::std::borrow::Cow::from("iframe_cookie_miss"), ::std::borrow::Cow::from("iframe_hit"), ::std::borrow::Cow::from("iframe_hit_opt_in"), ::std::borrow::Cow::from("iframe_hit_opt_out"), ::std::borrow::Cow::from("iframe_miss"), ::std::borrow::Cow::from("top_click_hit"), ::std::borrow::Cow::from("top_click_hit_opt_in"), ::std::borrow::Cow::from("top_click_hit_opt_out"), ::std::borrow::Cow::from("top_click_miss"), ::std::borrow::Cow::from("top_cookie_hit"), ::std::borrow::Cow::from("top_cookie_hit_opt_in"), ::std::borrow::Cow::from("top_cookie_hit_opt_out"), ::std::borrow::Cow::from("top_cookie_miss"), ::std::borrow::Cow::from("top_hit"), ::std::borrow::Cow::from("top_hit_opt_in"), ::std::borrow::Cow::from("top_hit_opt_out"), ::std::borrow::Cow::from("top_miss")]))
    });

    #[repr(u16)]
    pub enum RuleLookupByLoadLabel {
        ETopHit = 0,
        ETopHitOptIn = 1,
        ETopHitOptOut = 2,
        ETopMiss = 3,
        EIframeHit = 4,
        EIframeHitOptIn = 5,
        EIframeHitOptOut = 6,
        EIframeMiss = 7,
        ETopCookieHit = 8,
        ETopCookieHitOptIn = 9,
        ETopCookieHitOptOut = 10,
        ETopCookieMiss = 11,
        EIframeCookieHit = 12,
        EIframeCookieHitOptIn = 13,
        EIframeCookieHitOptOut = 14,
        EIframeCookieMiss = 15,
        ETopClickHit = 16,
        ETopClickHitOptIn = 17,
        ETopClickHitOptOut = 18,
        ETopClickMiss = 19,
        EIframeClickHit = 20,
        EIframeClickHitOptIn = 21,
        EIframeClickHitOptOut = 22,
        EIframeClickMiss = 23,
        __Other__,
    }
    impl From<u16> for RuleLookupByLoadLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ETopHit,
                1 => Self::ETopHitOptIn,
                2 => Self::ETopHitOptOut,
                3 => Self::ETopMiss,
                4 => Self::EIframeHit,
                5 => Self::EIframeHitOptIn,
                6 => Self::EIframeHitOptOut,
                7 => Self::EIframeMiss,
                8 => Self::ETopCookieHit,
                9 => Self::ETopCookieHitOptIn,
                10 => Self::ETopCookieHitOptOut,
                11 => Self::ETopCookieMiss,
                12 => Self::EIframeCookieHit,
                13 => Self::EIframeCookieHitOptIn,
                14 => Self::EIframeCookieHitOptOut,
                15 => Self::EIframeCookieMiss,
                16 => Self::ETopClickHit,
                17 => Self::ETopClickHitOptIn,
                18 => Self::ETopClickHitOptOut,
                19 => Self::ETopClickMiss,
                20 => Self::EIframeClickHit,
                21 => Self::EIframeClickHitOptIn,
                22 => Self::EIframeClickHitOptOut,
                23 => Self::EIframeClickMiss,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RuleLookupByLoadLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ETopHit => "top_hit",
                Self::ETopHitOptIn => "top_hit_opt_in",
                Self::ETopHitOptOut => "top_hit_opt_out",
                Self::ETopMiss => "top_miss",
                Self::EIframeHit => "iframe_hit",
                Self::EIframeHitOptIn => "iframe_hit_opt_in",
                Self::EIframeHitOptOut => "iframe_hit_opt_out",
                Self::EIframeMiss => "iframe_miss",
                Self::ETopCookieHit => "top_cookie_hit",
                Self::ETopCookieHitOptIn => "top_cookie_hit_opt_in",
                Self::ETopCookieHitOptOut => "top_cookie_hit_opt_out",
                Self::ETopCookieMiss => "top_cookie_miss",
                Self::EIframeCookieHit => "iframe_cookie_hit",
                Self::EIframeCookieHitOptIn => "iframe_cookie_hit_opt_in",
                Self::EIframeCookieHitOptOut => "iframe_cookie_hit_opt_out",
                Self::EIframeCookieMiss => "iframe_cookie_miss",
                Self::ETopClickHit => "top_click_hit",
                Self::ETopClickHitOptIn => "top_click_hit_opt_in",
                Self::ETopClickHitOptOut => "top_click_hit_opt_out",
                Self::ETopClickMiss => "top_click_miss",
                Self::EIframeClickHit => "iframe_click_hit",
                Self::EIframeClickHitOptIn => "iframe_click_hit_opt_in",
                Self::EIframeClickHitOptOut => "iframe_click_hit_opt_out",
                Self::EIframeClickMiss => "iframe_click_miss",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.rule_lookup_by_load
    ///
    /// Counts the number of hit/miss of cookie banner rule lookups for every load. We
    /// collect three types of counters, including counters for overall rule lookup,
    /// counters for cookie rule lookup and counters for click rule lookup. We also
    /// divide the counter by top-level loads and iframe loads.
    pub static rule_lookup_by_load: Lazy<LabeledMetric<LabeledCounterMetric, RuleLookupByLoadLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "rule_lookup_by_load".into(),
                    category: "cookie.banners".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3557.into(), meta, Some(vec![::std::borrow::Cow::from("iframe_click_hit"), ::std::borrow::Cow::from("iframe_click_hit_opt_in"), ::std::borrow::Cow::from("iframe_click_hit_opt_out"), ::std::borrow::Cow::from("iframe_click_miss"), ::std::borrow::Cow::from("iframe_cookie_hit"), ::std::borrow::Cow::from("iframe_cookie_hit_opt_in"), ::std::borrow::Cow::from("iframe_cookie_hit_opt_out"), ::std::borrow::Cow::from("iframe_cookie_miss"), ::std::borrow::Cow::from("iframe_hit"), ::std::borrow::Cow::from("iframe_hit_opt_in"), ::std::borrow::Cow::from("iframe_hit_opt_out"), ::std::borrow::Cow::from("iframe_miss"), ::std::borrow::Cow::from("top_click_hit"), ::std::borrow::Cow::from("top_click_hit_opt_in"), ::std::borrow::Cow::from("top_click_hit_opt_out"), ::std::borrow::Cow::from("top_click_miss"), ::std::borrow::Cow::from("top_cookie_hit"), ::std::borrow::Cow::from("top_cookie_hit_opt_in"), ::std::borrow::Cow::from("top_cookie_hit_opt_out"), ::std::borrow::Cow::from("top_cookie_miss"), ::std::borrow::Cow::from("top_hit"), ::std::borrow::Cow::from("top_hit_opt_in"), ::std::borrow::Cow::from("top_hit_opt_out"), ::std::borrow::Cow::from("top_miss")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.service_detect_only
    ///
    /// Tracks the value of the cookiebanners.service.detectOnly pref.
    pub static service_detect_only: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "service_detect_only".into(),
                category: "cookie.banners".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3558.into(), meta)
    });

}
pub mod cookie_banners_click {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.click.query_selector_run_count_per_window_frame
    ///
    /// How often a query selector is run during the lifetime of a sub-frame content
    /// window.
    pub static query_selector_run_count_per_window_frame: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "query_selector_run_count_per_window_frame".into(),
                category: "cookie.banners.click".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3559.into(), meta, 1, 2500, 20, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.click.query_selector_run_count_per_window_top_level
    ///
    /// How often a query selector is run during the lifetime of a top-level content
    /// window.
    pub static query_selector_run_count_per_window_top_level: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "query_selector_run_count_per_window_top_level".into(),
                category: "cookie.banners.click".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3560.into(), meta, 1, 2500, 20, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.click.query_selector_run_duration_per_window_frame
    ///
    /// Total time spent (in microseconds) on running querySelector for the lifetime of
    /// a sub-frame content window.
    pub static query_selector_run_duration_per_window_frame: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "query_selector_run_duration_per_window_frame".into(),
                category: "cookie.banners.click".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3561.into(), meta, 1, 30000000, 8, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.click.query_selector_run_duration_per_window_top_level
    ///
    /// Total time spent (in microseconds) on running querySelector for the lifetime of
    /// a top-level content window.
    pub static query_selector_run_duration_per_window_top_level: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "query_selector_run_duration_per_window_top_level".into(),
                category: "cookie.banners.click".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3562.into(), meta, 1, 30000000, 8, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum ResultLabel {
        ESuccess = 0,
        ESuccessCookieInjected = 1,
        ESuccessDomContentLoaded = 2,
        ESuccessMutationPreLoad = 3,
        ESuccessMutationPostLoad = 4,
        EFail = 5,
        EFailBannerNotFound = 6,
        EFailBannerNotVisible = 7,
        EFailButtonNotFound = 8,
        EFailNoRuleForMode = 9,
        EFailActorDestroyed = 10,
        __Other__,
    }
    impl From<u16> for ResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::ESuccessCookieInjected,
                2 => Self::ESuccessDomContentLoaded,
                3 => Self::ESuccessMutationPreLoad,
                4 => Self::ESuccessMutationPostLoad,
                5 => Self::EFail,
                6 => Self::EFailBannerNotFound,
                7 => Self::EFailBannerNotVisible,
                8 => Self::EFailButtonNotFound,
                9 => Self::EFailNoRuleForMode,
                10 => Self::EFailActorDestroyed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::ESuccessCookieInjected => "success_cookie_injected",
                Self::ESuccessDomContentLoaded => "success_dom_content_loaded",
                Self::ESuccessMutationPreLoad => "success_mutation_pre_load",
                Self::ESuccessMutationPostLoad => "success_mutation_post_load",
                Self::EFail => "fail",
                Self::EFailBannerNotFound => "fail_banner_not_found",
                Self::EFailBannerNotVisible => "fail_banner_not_visible",
                Self::EFailButtonNotFound => "fail_button_not_found",
                Self::EFailNoRuleForMode => "fail_no_rule_for_mode",
                Self::EFailActorDestroyed => "fail_actor_destroyed",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.click.result
    ///
    /// Given a matching cookie banner rule, how often do we handle or fail to handle
    /// cookie banners, labelled by reason. The 'success' and 'fail' counters count the
    /// total numbers independently of the reason counters. Counters are incremented
    /// after the content window has been destroyed. This metric additionally reports
    /// cookie injections after which we didn't see a banner as
    /// "success_cookie_injected".
    pub static result: Lazy<LabeledMetric<LabeledCounterMetric, ResultLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "result".into(),
                    category: "cookie.banners.click".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3563.into(), meta, Some(vec![::std::borrow::Cow::from("fail"), ::std::borrow::Cow::from("fail_actor_destroyed"), ::std::borrow::Cow::from("fail_banner_not_found"), ::std::borrow::Cow::from("fail_banner_not_visible"), ::std::borrow::Cow::from("fail_button_not_found"), ::std::borrow::Cow::from("fail_no_rule_for_mode"), ::std::borrow::Cow::from("success"), ::std::borrow::Cow::from("success_cookie_injected"), ::std::borrow::Cow::from("success_dom_content_loaded"), ::std::borrow::Cow::from("success_mutation_post_load"), ::std::borrow::Cow::from("success_mutation_pre_load")]))
    });

}
pub mod cookie_banners_cmp {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.cmp.detected_cmp
    ///
    /// Counts how often a specific cmp has been detected by our cookie banner
    /// handling.
    pub static detected_cmp: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "detected_cmp".into(),
                    category: "cookie.banners.cmp".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3564.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.cmp.ratio_handled_by_cmp_rule
    ///
    /// The proportion of cookie banners handled by CMP rules within the total number
    /// of cases handled, including those handled by site-specific rules.
    pub static ratio_handled_by_cmp_rule: Lazy<RateMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ratio_handled_by_cmp_rule".into(),
                category: "cookie.banners.cmp".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        RateMetric::new(3565.into(), meta)
    });

    #[repr(u16)]
    pub enum ResultLabel {
        ESuccess = 0,
        ESuccessDomContentLoaded = 1,
        ESuccessMutationPreLoad = 2,
        ESuccessMutationPostLoad = 3,
        EFail = 4,
        EFailBannerNotFound = 5,
        EFailBannerNotVisible = 6,
        EFailButtonNotFound = 7,
        EFailNoRuleForMode = 8,
        EFailActorDestroyed = 9,
        __Other__,
    }
    impl From<u16> for ResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::ESuccessDomContentLoaded,
                2 => Self::ESuccessMutationPreLoad,
                3 => Self::ESuccessMutationPostLoad,
                4 => Self::EFail,
                5 => Self::EFailBannerNotFound,
                6 => Self::EFailBannerNotVisible,
                7 => Self::EFailButtonNotFound,
                8 => Self::EFailNoRuleForMode,
                9 => Self::EFailActorDestroyed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::ESuccessDomContentLoaded => "success_dom_content_loaded",
                Self::ESuccessMutationPreLoad => "success_mutation_pre_load",
                Self::ESuccessMutationPostLoad => "success_mutation_post_load",
                Self::EFail => "fail",
                Self::EFailBannerNotFound => "fail_banner_not_found",
                Self::EFailBannerNotVisible => "fail_banner_not_visible",
                Self::EFailButtonNotFound => "fail_button_not_found",
                Self::EFailNoRuleForMode => "fail_no_rule_for_mode",
                Self::EFailActorDestroyed => "fail_actor_destroyed",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.cmp.result
    ///
    /// Given a matching CMP rule, how often do we handle or fail to handle cookie
    /// banners, labelled by reason. The 'success' and 'fail' counters count the total
    /// numbers independently of the reason counters. Counters are incremented after
    /// the content window has been destroyed.
    pub static result: Lazy<LabeledMetric<LabeledCounterMetric, ResultLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "result".into(),
                    category: "cookie.banners.cmp".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3566.into(), meta, Some(vec![::std::borrow::Cow::from("fail"), ::std::borrow::Cow::from("fail_actor_destroyed"), ::std::borrow::Cow::from("fail_banner_not_found"), ::std::borrow::Cow::from("fail_banner_not_visible"), ::std::borrow::Cow::from("fail_button_not_found"), ::std::borrow::Cow::from("fail_no_rule_for_mode"), ::std::borrow::Cow::from("success"), ::std::borrow::Cow::from("success_dom_content_loaded"), ::std::borrow::Cow::from("success_mutation_post_load"), ::std::borrow::Cow::from("success_mutation_pre_load")]))
    });

}
pub mod crash {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from crash.app_build
    ///
    /// The build id of the application. This may differ from `client_info` because a
    /// main process crash may be reported later by a different (e.g. updated) client.
    pub static app_build: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "app_build".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3567.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.app_channel
    ///
    /// The release channel of the application. This may differ from `client_info`
    /// because a main process crash may be reported later by a different (e.g.
    /// updated) client.
    pub static app_channel: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "app_channel".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3568.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.app_display_version
    ///
    /// The version of the application. This may differ from `client_info` because a
    /// main process crash may be reported later by a different (e.g. updated) client.
    pub static app_display_version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "app_display_version".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3569.into(), meta)
    });

        #[derive(Debug, Hash, Eq, PartialEq, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct AsyncShutdownTimeoutObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub phase: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub conditions: Option<String>,
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new")]
          pub broken_add_blockers: AsyncShutdownTimeoutObjectItemBrokenAddBlockers,
    }

            pub type AsyncShutdownTimeoutObjectItemBrokenAddBlockers = Vec<AsyncShutdownTimeoutObjectItemBrokenAddBlockersItem>;

    pub type AsyncShutdownTimeoutObjectItemBrokenAddBlockersItem = String;
    #[allow(non_upper_case_globals)]
    /// generated from crash.async_shutdown_timeout
    ///
    /// Present when a shutdown blocker failed to respond within a reasonable amount of
    /// time.
    pub static async_shutdown_timeout: Lazy<ObjectMetric<AsyncShutdownTimeoutObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "async_shutdown_timeout".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(3570.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.background_task_name
    ///
    /// The name of the background task if launched as one.
    pub static background_task_name: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "background_task_name".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3571.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.event_loop_nesting_level
    ///
    /// Indicates the nesting level of the event loop.
    pub static event_loop_nesting_level: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_loop_nesting_level".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3572.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.font_name
    ///
    /// The font family name that is being loaded when the crash occurred.
    pub static font_name: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3573.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.gpu_process_launch
    ///
    /// The number of times that the GPU process was launched.
    pub static gpu_process_launch: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gpu_process_launch".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3574.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.ipc_channel_error
    ///
    /// The error reason for an ipc-based content crash.
    pub static ipc_channel_error: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ipc_channel_error".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3575.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.is_garbage_collecting
    ///
    /// Indicates that the crash occurred while the garbage collector was running.
    pub static is_garbage_collecting: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_garbage_collecting".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3576.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.main_thread_runnable_name
    ///
    /// Name of the currently executing `nsIRunnable` on the main thread. Nightly-only.
    pub static main_thread_runnable_name: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "main_thread_runnable_name".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3577.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.minidump_sha256_hash
    ///
    /// The SHA256 hash of the associated minidump file, if any.
    pub static minidump_sha256_hash: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "minidump_sha256_hash".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3578.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.moz_crash_reason
    ///
    /// Contains the string passed to `MOZ_CRASH()`.
    pub static moz_crash_reason: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "moz_crash_reason".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3579.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.process_type
    ///
    /// The type of process that experienced a crash. See the full list of options
    /// [here](https://firefox-source-
    /// docs.mozilla.org/toolkit/components/telemetry/data/crash-ping.html#process-
    /// types).
    pub static process_type: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "process_type".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3580.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.profiler_child_shutdown_phase
    ///
    /// The shutdown phase of the profiler.
    pub static profiler_child_shutdown_phase: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "profiler_child_shutdown_phase".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3581.into(), meta)
    });

        pub type QuotaManagerShutdownTimeoutObject = Vec<QuotaManagerShutdownTimeoutObjectItem>;

    pub type QuotaManagerShutdownTimeoutObjectItem = String;
    #[allow(non_upper_case_globals)]
    /// generated from crash.quota_manager_shutdown_timeout
    ///
    /// Contains a list of shutdown steps and status of the quota manager clients.
    pub static quota_manager_shutdown_timeout: Lazy<ObjectMetric<QuotaManagerShutdownTimeoutObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "quota_manager_shutdown_timeout".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(3582.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.remote_type
    ///
    /// The type of the content process. See the full list of options
    /// [here](https://firefox-source-
    /// docs.mozilla.org/toolkit/components/telemetry/data/crash-ping.html#remote-
    /// process-types).
    pub static remote_type: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "remote_type".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3583.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.shutdown_progress
    ///
    /// The shutdown phase in which the crash occurred.
    pub static shutdown_progress: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shutdown_progress".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3584.into(), meta)
    });

        #[derive(Debug, Hash, Eq, PartialEq, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct StackTracesObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub error: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub crash_type: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub crash_address: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub crash_thread: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub main_module: Option<i64>,
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new")]
          pub modules: StackTracesObjectItemModules,
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new")]
          pub threads: StackTracesObjectItemThreads,
    }

            pub type StackTracesObjectItemModules = Vec<StackTracesObjectItemModulesItem>;

        #[derive(Debug, Hash, Eq, PartialEq, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct StackTracesObjectItemModulesItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub base_address: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub end_address: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub code_id: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub debug_file: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub debug_id: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub filename: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub version: Option<String>,
    }

            pub type StackTracesObjectItemThreads = Vec<StackTracesObjectItemThreadsItem>;

        #[derive(Debug, Hash, Eq, PartialEq, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct StackTracesObjectItemThreadsItem {
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new")]
          pub frames: StackTracesObjectItemThreadsItemItemFrames,
    }

            pub type StackTracesObjectItemThreadsItemItemFrames = Vec<StackTracesObjectItemThreadsItemItemFramesItem>;

        #[derive(Debug, Hash, Eq, PartialEq, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct StackTracesObjectItemThreadsItemItemFramesItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub module_index: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub ip: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub trust: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from crash.stack_traces
    ///
    /// Stack trace and module information of the crashing process.
    pub static stack_traces: Lazy<ObjectMetric<StackTracesObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "stack_traces".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(3585.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.startup
    ///
    /// If true, the crash occurred during process startup.
    pub static startup: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "startup".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3586.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.time
    ///
    /// The time at which the crash occurred.
    pub static time: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(3587.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.utility_actors_name
    ///
    /// List of IPC actor names running on a utility process instance (if the crashing
    /// process was a utility process).
    pub static utility_actors_name: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "utility_actors_name".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(3588.into(), meta)
    });

}
pub mod crash_windows {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from crash.windows.error_reporting
    ///
    /// Indicates if the crash was intercepted by the Windows Error Reporting runtime
    /// exception module.
    pub static error_reporting: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "error_reporting".into(),
                category: "crash.windows".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3589.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.windows.file_dialog_error_code
    ///
    /// The HRESULT returned from a Win32 system call leading to termination of the
    /// file-dialog utility process. MozCrashReason is expected to provide context for
    /// the value.
    pub static file_dialog_error_code: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "file_dialog_error_code".into(),
                category: "crash.windows".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3590.into(), meta)
    });

}
pub mod crash_submission {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from crash_submission.channel_status
    ///
    /// Collecting XHR channel status on error code when statusCode == 0.
    pub static channel_status: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "channel_status".into(),
                    category: "crash_submission".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3591.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash_submission.collector_errors
    ///
    /// Amount and error name reported when performing crash submission.
    pub static collector_errors: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "collector_errors".into(),
                    category: "crash_submission".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3592.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash_submission.failure
    ///
    /// Number of failed crash report submissions
    pub static failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3593,
            "crash_submission",
            "failure",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash_submission.pending
    ///
    /// Number of pending crash report submissions
    pub static pending: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3594,
            "crash_submission",
            "pending",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash_submission.success
    ///
    /// Number of successfull crash report submissions
    pub static success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3595,
            "crash_submission",
            "success",
            "metrics"
        )
    });

}
pub mod dll_blocklist {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from dll_blocklist.init_failed
    ///
    /// Indicates whether initialization of the DLL blocklist failed.
    pub static init_failed: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "init_failed".into(),
                category: "dll_blocklist".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3596.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dll_blocklist.list
    ///
    /// A list of blocked DLLs.
    pub static list: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "list".into(),
                category: "dll_blocklist".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(3597.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dll_blocklist.user32_loaded_before
    ///
    /// Indicates whether `user32.dll` was loaded before the DLL blocklist was
    /// initialized.
    pub static user32_loaded_before: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "user32_loaded_before".into(),
                category: "dll_blocklist".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3598.into(), meta)
    });

}
pub mod environment {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from environment.experimental_features
    ///
    /// Specifies the enabled experimental features from
    /// about:preferences#experimental.
    pub static experimental_features: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "experimental_features".into(),
                category: "environment".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(3599.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from environment.headless_mode
    ///
    /// Whether the app was invoked in headless mode via `--headless` or
    /// `--backgroundtask`.
    pub static headless_mode: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "headless_mode".into(),
                category: "environment".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3600.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from environment.uptime
    ///
    /// The start time of the application.
    pub static uptime: Lazy<TimespanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uptime".into(),
                category: "environment".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimespanMetric::new(3601.into(), meta, TimeUnit::Millisecond)
    });

}
pub mod memory {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from memory.available_commit
    ///
    /// Available commit size.
    pub static available_commit: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "available_commit".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3602.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.available_physical
    ///
    /// Available physical memory.
    pub static available_physical: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "available_physical".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3603.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.available_swap
    ///
    /// Available swap memory.
    pub static available_swap: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "available_swap".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3604.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.available_virtual
    ///
    /// Available virtual memory.
    pub static available_virtual: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "available_virtual".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3605.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.low_physical
    ///
    /// The number of times the available memory tracker has detected that free
    /// physical memory is running low.
    pub static low_physical: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "low_physical".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3606.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.oom_allocation_size
    ///
    /// The size of the allocation that caused on OOM crash.
    pub static oom_allocation_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "oom_allocation_size".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3607.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.purgeable_physical
    ///
    /// The amount of memory that can be deallocated by the OS in case of memory
    /// pressure.
    pub static purgeable_physical: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "purgeable_physical".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3608.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.system_use_percentage
    ///
    /// The percentage of memory in use.
    pub static system_use_percentage: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "system_use_percentage".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3609.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.texture
    ///
    /// The amount of memory used in textures.
    pub static texture: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "texture".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3610.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.total_page_file
    ///
    /// The total page file size.
    pub static total_page_file: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_page_file".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3611.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.total_physical
    ///
    /// The total physical memory.
    pub static total_physical: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_physical".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3612.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.total_virtual
    ///
    /// The total virtual memory.
    pub static total_virtual: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_virtual".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3613.into(), meta)
    });

}
pub mod windows {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from windows.package_family_name
    ///
    /// The Package Family Name of Firefox, if installed through an MSIX package.
    pub static package_family_name: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "package_family_name".into(),
                category: "windows".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3614.into(), meta)
    });

}
pub mod policies {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from policies.count
    ///
    /// A uint with the number of active enterprise policies, collected once at
    /// startup. This metric was generated to correspond to the Legacy Telemetry scalar
    /// policies.count.
    pub static count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "count".into(),
                category: "policies".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3615.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from policies.is_enterprise
    ///
    /// Attempt to determine if the user is an enterprise user based on various
    /// signals. This metric was generated to correspond to the Legacy Telemetry scalar
    /// policies.is_enterprise.
    pub static is_enterprise: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_enterprise".into(),
                category: "policies".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3616.into(), meta)
    });

}
pub mod extensions {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum ProcessEventLabel {
        ECrashedBg = 0,
        ECrashedFg = 1,
        ECreatedBg = 2,
        ECreatedFg = 3,
        ECrashedOverThresholdBg = 4,
        ECrashedOverThresholdFg = 5,
        __Other__,
    }
    impl From<u16> for ProcessEventLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECrashedBg,
                1 => Self::ECrashedFg,
                2 => Self::ECreatedBg,
                3 => Self::ECreatedFg,
                4 => Self::ECrashedOverThresholdBg,
                5 => Self::ECrashedOverThresholdFg,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ProcessEventLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECrashedBg => "crashed_bg",
                Self::ECrashedFg => "crashed_fg",
                Self::ECreatedBg => "created_bg",
                Self::ECreatedFg => "created_fg",
                Self::ECrashedOverThresholdBg => "crashed_over_threshold_bg",
                Self::ECrashedOverThresholdFg => "crashed_over_threshold_fg",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.process_event
    ///
    /// Counters for how many times the extension process has crashed or been created.
    /// The labels with "_fg" / "_bg" suffixes are only recorded in Android builds,
    /// while the "created" and "crashed" labels are recorded on both Desktop and
    /// Android
    /// builds.
    pub static process_event: Lazy<LabeledMetric<LabeledCounterMetric, ProcessEventLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "process_event".into(),
                    category: "extensions".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Application,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3617.into(), meta, Some(vec![::std::borrow::Cow::from("crashed_bg"), ::std::borrow::Cow::from("crashed_fg"), ::std::borrow::Cow::from("crashed_over_threshold_bg"), ::std::borrow::Cow::from("crashed_over_threshold_fg"), ::std::borrow::Cow::from("created_bg"), ::std::borrow::Cow::from("created_fg")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.startup_cache_load_time
    ///
    /// Time to load and deserialize the extensions startupCache data.
    pub static startup_cache_load_time: Lazy<TimespanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "startup_cache_load_time".into(),
                category: "extensions".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TimespanMetric::new(3618.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.startup_cache_read_errors
    ///
    /// The number of times an unexpected error has been raised while reading
    /// the extensions StartupCache file.
    pub static startup_cache_read_errors: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "startup_cache_read_errors".into(),
                    category: "extensions".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Application,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3619.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.startup_cache_write_bytelength
    ///
    /// The amount of bytes written to the extensions StartupCache file.
    pub static startup_cache_write_bytelength: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "startup_cache_write_bytelength".into(),
                category: "extensions".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3620.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.use_remote_policy
    ///
    /// Corresponds to the value of `WebExtensionPolicy.useRemoteWebExtensions`.
    pub static use_remote_policy: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "use_remote_policy".into(),
                category: "extensions".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3621.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.use_remote_pref
    ///
    /// Corresponds to the value of `extensions.webextensions.remote` pref.
    pub static use_remote_pref: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "use_remote_pref".into(),
                category: "extensions".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3622.into(), meta)
    });

}
pub mod extensions_apis_dnr {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.evaluate_rules_count_max
    ///
    /// Max amount of DNR rules being evaluated.
    pub static evaluate_rules_count_max: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "evaluate_rules_count_max".into(),
                category: "extensions.apis.dnr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3623.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.evaluate_rules_time
    ///
    /// Amount of time it takes to evaluate DNR rules for one network request.
    pub static evaluate_rules_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "evaluate_rules_time".into(),
                category: "extensions.apis.dnr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3624.into(), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum StartupCacheEntriesLabel {
        EHit = 0,
        EMiss = 1,
        __Other__,
    }
    impl From<u16> for StartupCacheEntriesLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EHit,
                1 => Self::EMiss,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for StartupCacheEntriesLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EHit => "hit",
                Self::EMiss => "miss",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.startup_cache_entries
    ///
    /// Counters for startup cache data hits or misses on initializating
    /// DNR rules for extensions loaded on application startup.
    pub static startup_cache_entries: Lazy<LabeledMetric<LabeledCounterMetric, StartupCacheEntriesLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "startup_cache_entries".into(),
                    category: "extensions.apis.dnr".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Application,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3625.into(), meta, Some(vec![::std::borrow::Cow::from("hit"), ::std::borrow::Cow::from("miss")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.startup_cache_read_size
    ///
    /// Amount of data read from the DNR startup cache file.
    pub static startup_cache_read_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "startup_cache_read_size".into(),
                category: "extensions.apis.dnr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(3626.into(), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.startup_cache_read_time
    ///
    /// Amount of time it takes to read data into the DNR startup cache file.
    pub static startup_cache_read_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "startup_cache_read_time".into(),
                category: "extensions.apis.dnr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3627.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.startup_cache_write_size
    ///
    /// Amount of data written to the DNR startup cache file.
    pub static startup_cache_write_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "startup_cache_write_size".into(),
                category: "extensions.apis.dnr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(3628.into(), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.startup_cache_write_time
    ///
    /// Amount of time it takes to write data into the DNR startup cache file.
    pub static startup_cache_write_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "startup_cache_write_time".into(),
                category: "extensions.apis.dnr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3629.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.validate_rules_time
    ///
    /// Amount of time it takes to validate DNR rules of individual ruleset
    /// when dynamic or static rulesets have been loaded from disk.
    pub static validate_rules_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "validate_rules_time".into(),
                category: "extensions.apis.dnr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3630.into(), meta, TimeUnit::Millisecond)
    });

}
pub mod extensions_counters {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum BrowserActionPreloadResultLabel {
        EPopupshown = 0,
        EClearafterhover = 1,
        EClearaftermousedown = 2,
        __Other__,
    }
    impl From<u16> for BrowserActionPreloadResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPopupshown,
                1 => Self::EClearafterhover,
                2 => Self::EClearaftermousedown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for BrowserActionPreloadResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPopupshown => "popupShown",
                Self::EClearafterhover => "clearAfterHover",
                Self::EClearaftermousedown => "clearAfterMousedown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.counters.browser_action_preload_result
    ///
    /// Number of times an event page hit the idle timeout and results in one of the
    /// labels.
    pub static browser_action_preload_result: Lazy<LabeledMetric<LabeledCounterMetric, BrowserActionPreloadResultLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "browser_action_preload_result".into(),
                    category: "extensions.counters".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Application,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3631.into(), meta, Some(vec![::std::borrow::Cow::from("clearAfterHover"), ::std::borrow::Cow::from("clearAfterMousedown"), ::std::borrow::Cow::from("popupShown")]))
    });

    #[repr(u16)]
    pub enum EventPageIdleResultLabel {
        ESuspend = 0,
        EResetOther = 1,
        EResetEvent = 2,
        EResetListeners = 3,
        EResetNativeapp = 4,
        EResetStreamfilter = 5,
        EResetParentapicall = 6,
        EPermissionsRequest = 7,
        ELaunchwebauthflow = 8,
        __Other__,
    }
    impl From<u16> for EventPageIdleResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuspend,
                1 => Self::EResetOther,
                2 => Self::EResetEvent,
                3 => Self::EResetListeners,
                4 => Self::EResetNativeapp,
                5 => Self::EResetStreamfilter,
                6 => Self::EResetParentapicall,
                7 => Self::EPermissionsRequest,
                8 => Self::ELaunchwebauthflow,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EventPageIdleResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuspend => "suspend",
                Self::EResetOther => "reset_other",
                Self::EResetEvent => "reset_event",
                Self::EResetListeners => "reset_listeners",
                Self::EResetNativeapp => "reset_nativeapp",
                Self::EResetStreamfilter => "reset_streamfilter",
                Self::EResetParentapicall => "reset_parentapicall",
                Self::EPermissionsRequest => "permissions_request",
                Self::ELaunchwebauthflow => "launchWebAuthFlow",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.counters.event_page_idle_result
    ///
    /// Number of times an event page hit the idle timeout and results in one of the
    /// labels.
    pub static event_page_idle_result: Lazy<LabeledMetric<LabeledCounterMetric, EventPageIdleResultLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "event_page_idle_result".into(),
                    category: "extensions.counters".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Application,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3632.into(), meta, Some(vec![::std::borrow::Cow::from("launchWebAuthFlow"), ::std::borrow::Cow::from("permissions_request"), ::std::borrow::Cow::from("reset_event"), ::std::borrow::Cow::from("reset_listeners"), ::std::borrow::Cow::from("reset_nativeapp"), ::std::borrow::Cow::from("reset_other"), ::std::borrow::Cow::from("reset_parentapicall"), ::std::borrow::Cow::from("reset_streamfilter"), ::std::borrow::Cow::from("suspend")]))
    });

}
pub mod extensions_data {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct MigrateResultExtra {
        pub r#addon_id: Option<String>,
        pub r#backend: Option<String>,
        pub r#data_migrated: Option<String>,
        pub r#error_name: Option<String>,
        pub r#has_jsonfile: Option<String>,
        pub r#has_olddata: Option<String>,
    }

    impl ExtraKeys for MigrateResultExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "backend", "data_migrated", "error_name", "has_jsonfile", "has_olddata"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#backend.and_then(|val| map.insert("backend".into(), val.to_string()));
          self.r#data_migrated.and_then(|val| map.insert("data_migrated".into(), val.to_string()));
          self.r#error_name.and_then(|val| map.insert("error_name".into(), val.to_string()));
          self.r#has_jsonfile.and_then(|val| map.insert("has_jsonfile".into(), val.to_string()));
          self.r#has_olddata.and_then(|val| map.insert("has_olddata".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.data.migrate_result
    ///
    /// These events are sent when an extension is migrating its data to the new
    /// IndexedDB backend.
    pub static migrate_result: Lazy<EventMetric<MigrateResultExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "migrate_result".into(),
                category: "extensions.data".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3633.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StorageLocalErrorExtra {
        pub r#addon_id: Option<String>,
        pub r#error_name: Option<String>,
        pub r#method: Option<String>,
    }

    impl ExtraKeys for StorageLocalErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "error_name", "method"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#error_name.and_then(|val| map.insert("error_name".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.data.storage_local_error
    ///
    /// These events are collected when an extension triggers an unexpected error
    /// while running a storage.local API call (e.g. because of some underlying
    /// QuotaManager and/or IndexedDB error).
    pub static storage_local_error: Lazy<EventMetric<StorageLocalErrorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "storage_local_error".into(),
                category: "extensions.data".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3634.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SyncUsageQuotasExtra {
        pub r#addon_id: Option<String>,
        pub r#backend: Option<String>,
        pub r#items_count: Option<u32>,
        pub r#items_over_quota: Option<u32>,
        pub r#total_size_bytes: Option<u32>,
    }

    impl ExtraKeys for SyncUsageQuotasExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "backend", "items_count", "items_over_quota", "total_size_bytes"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#backend.and_then(|val| map.insert("backend".into(), val.to_string()));
          self.r#items_count.and_then(|val| map.insert("items_count".into(), val.to_string()));
          self.r#items_over_quota.and_then(|val| map.insert("items_over_quota".into(), val.to_string()));
          self.r#total_size_bytes.and_then(|val| map.insert("total_size_bytes".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.data.sync_usage_quotas
    ///
    /// These events record the basic stat about usage, and are collected the
    /// first time an extension uses the sync storage API during a session.
    pub static sync_usage_quotas: Lazy<EventMetric<SyncUsageQuotasExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sync_usage_quotas".into(),
                category: "extensions.data".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3635.into(), meta)
    });

}
pub mod extensions_timing {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.background_page_load
    ///
    /// Amount of time it takes to load a WebExtensions background page, from when the
    /// build function is called to when the page has finished processing the onload
    /// event.
    pub static background_page_load: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "background_page_load".into(),
                category: "extensions.timing".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3636.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.browser_action_popup_open
    ///
    /// Amount of time it takes for a BrowserAction popup to open.
    pub static browser_action_popup_open: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "browser_action_popup_open".into(),
                category: "extensions.timing".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3637.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.content_script_injection
    ///
    /// Amount of time it takes for content scripts from a WebExtension to be injected
    /// into a window.
    pub static content_script_injection: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "content_script_injection".into(),
                category: "extensions.timing".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3638.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.event_page_running_time
    ///
    /// Amount of time (keyed by addon id) that an event page has been running before
    /// being suspended,
    /// or the entire addon shutdown.
    pub static event_page_running_time: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_page_running_time".into(),
                category: "extensions.timing".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3639.into(), meta, 1, 60000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.extension_startup
    ///
    /// Amount of time it takes for a WebExtension to start up, from when the
    /// startup function is called to when the startup promise resolves.
    pub static extension_startup: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "extension_startup".into(),
                category: "extensions.timing".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3640.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.page_action_popup_open
    ///
    /// Amount of time it takes for a PageAction popup to open.
    pub static page_action_popup_open: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "page_action_popup_open".into(),
                category: "extensions.timing".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3641.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.storage_local_get_idb
    ///
    /// Amount of time it takes to perform a get via storage.local using the IndexedDB
    /// backend.
    pub static storage_local_get_idb: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "storage_local_get_idb".into(),
                category: "extensions.timing".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3642.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.storage_local_set_idb
    ///
    /// Amount of time it takes to perform a set via storage.local using the Indexed
    /// backend.
    pub static storage_local_set_idb: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "storage_local_set_idb".into(),
                category: "extensions.timing".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3643.into(), meta, TimeUnit::Millisecond)
    });

}
pub mod address {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AddManageExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AddManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.add_manage
    ///
    /// User interactions for address autofill preferences management UI. This event
    /// was generated to correspond to the Legacy Telemetry event address.add#manage.
    pub static add_manage: Lazy<EventMetric<AddManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "add_manage".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3644.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CancelCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for CancelCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.cancel_capture_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// address.cancel#capture_doorhanger.
    pub static cancel_capture_doorhanger: Lazy<EventMetric<CancelCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel_capture_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3645.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CancelEditDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for CancelEditDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.cancel_edit_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// address.cancel#edit_doorhanger.
    pub static cancel_edit_doorhanger: Lazy<EventMetric<CancelEditDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel_edit_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3646.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CancelUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for CancelUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.cancel_update_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// address.cancel#update_doorhanger.
    pub static cancel_update_doorhanger: Lazy<EventMetric<CancelUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel_update_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3647.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClearedAddressFormExtra {
        pub r#field_name: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClearedAddressFormExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["field_name", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.cleared_address_form
    ///
    /// Recorded when a form is cleared. Using field_name to record the field that
    /// triggers this event
    /// This event was generated to correspond to the Legacy Telemetry event
    /// address.cleared#address_form.
    pub static cleared_address_form: Lazy<EventMetric<ClearedAddressFormExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cleared_address_form".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3648.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DeleteManageExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DeleteManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.delete_manage
    ///
    /// User interactions for address autofill preferences management UI. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// address.delete#manage.
    pub static delete_manage: Lazy<EventMetric<DeleteManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "delete_manage".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3649.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DetectedAddressFormExtra {
        pub r#address_level1: Option<String>,
        pub r#address_level2: Option<String>,
        pub r#address_line1: Option<String>,
        pub r#address_line2: Option<String>,
        pub r#address_line3: Option<String>,
        pub r#country: Option<String>,
        pub r#postal_code: Option<String>,
        pub r#street_address: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DetectedAddressFormExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["address_level1", "address_level2", "address_line1", "address_line2", "address_line3", "country", "postal_code", "street_address", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#address_level1.and_then(|val| map.insert("address_level1".into(), val.to_string()));
          self.r#address_level2.and_then(|val| map.insert("address_level2".into(), val.to_string()));
          self.r#address_line1.and_then(|val| map.insert("address_line1".into(), val.to_string()));
          self.r#address_line2.and_then(|val| map.insert("address_line2".into(), val.to_string()));
          self.r#address_line3.and_then(|val| map.insert("address_line3".into(), val.to_string()));
          self.r#country.and_then(|val| map.insert("country".into(), val.to_string()));
          self.r#postal_code.and_then(|val| map.insert("postal_code".into(), val.to_string()));
          self.r#street_address.and_then(|val| map.insert("street_address".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.detected_address_form
    ///
    /// Recorded when a form is recognized as an address form. The possible values in
    /// the extra_keys are "true", "false", or 0. When the value is "true", the field
    /// is identified via autocomplete attribute. When the value is "false", the field
    /// is not detected in the form. When the value is an 0, then the field is
    /// identified by regexp-based heuristic.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// address.detected#address_form.
    pub static detected_address_form: Lazy<EventMetric<DetectedAddressFormExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "detected_address_form".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3650.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DetectedAddressFormExtExtra {
        pub r#additional_name: Option<String>,
        pub r#email: Option<String>,
        pub r#family_name: Option<String>,
        pub r#given_name: Option<String>,
        pub r#name: Option<String>,
        pub r#organization: Option<String>,
        pub r#tel: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DetectedAddressFormExtExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["additional_name", "email", "family_name", "given_name", "name", "organization", "tel", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#additional_name.and_then(|val| map.insert("additional_name".into(), val.to_string()));
          self.r#email.and_then(|val| map.insert("email".into(), val.to_string()));
          self.r#family_name.and_then(|val| map.insert("family_name".into(), val.to_string()));
          self.r#given_name.and_then(|val| map.insert("given_name".into(), val.to_string()));
          self.r#name.and_then(|val| map.insert("name".into(), val.to_string()));
          self.r#organization.and_then(|val| map.insert("organization".into(), val.to_string()));
          self.r#tel.and_then(|val| map.insert("tel".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.detected_address_form_ext
    ///
    /// Address has too many fields so we cannot cover them all in the above
    /// `address_form` telemetry This telemetry is used to record address fields that
    /// are not listed in `address_form` This event was generated to correspond to the
    /// Legacy Telemetry event address.detected#address_form_ext.
    pub static detected_address_form_ext: Lazy<EventMetric<DetectedAddressFormExtExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "detected_address_form_ext".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3651.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.disable_capture_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// address.disable#capture_doorhanger.
    pub static disable_capture_doorhanger: Lazy<EventMetric<DisableCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_capture_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3652.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableEditDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableEditDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.disable_edit_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// address.disable#edit_doorhanger.
    pub static disable_edit_doorhanger: Lazy<EventMetric<DisableEditDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_edit_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3653.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.disable_update_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// address.disable#update_doorhanger.
    pub static disable_update_doorhanger: Lazy<EventMetric<DisableUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_update_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3654.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EditManageExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EditManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.edit_manage
    ///
    /// User interactions for address autofill preferences management UI. This event
    /// was generated to correspond to the Legacy Telemetry event address.edit#manage.
    pub static edit_manage: Lazy<EventMetric<EditManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "edit_manage".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3655.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FilledAddressFormExtra {
        pub r#address_level1: Option<String>,
        pub r#address_level2: Option<String>,
        pub r#address_line1: Option<String>,
        pub r#address_line2: Option<String>,
        pub r#address_line3: Option<String>,
        pub r#country: Option<String>,
        pub r#postal_code: Option<String>,
        pub r#street_address: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for FilledAddressFormExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["address_level1", "address_level2", "address_line1", "address_line2", "address_line3", "country", "postal_code", "street_address", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#address_level1.and_then(|val| map.insert("address_level1".into(), val.to_string()));
          self.r#address_level2.and_then(|val| map.insert("address_level2".into(), val.to_string()));
          self.r#address_line1.and_then(|val| map.insert("address_line1".into(), val.to_string()));
          self.r#address_line2.and_then(|val| map.insert("address_line2".into(), val.to_string()));
          self.r#address_line3.and_then(|val| map.insert("address_line3".into(), val.to_string()));
          self.r#country.and_then(|val| map.insert("country".into(), val.to_string()));
          self.r#postal_code.and_then(|val| map.insert("postal_code".into(), val.to_string()));
          self.r#street_address.and_then(|val| map.insert("street_address".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.filled_address_form
    ///
    /// Recorded when a form is autofiled. Possible values are `filled`, `not_filled`,
    /// `user_filled` or `unavailable`.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// address.filled#address_form.
    pub static filled_address_form: Lazy<EventMetric<FilledAddressFormExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "filled_address_form".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3656.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FilledAddressFormExtExtra {
        pub r#additional_name: Option<String>,
        pub r#email: Option<String>,
        pub r#family_name: Option<String>,
        pub r#given_name: Option<String>,
        pub r#name: Option<String>,
        pub r#organization: Option<String>,
        pub r#tel: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for FilledAddressFormExtExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["additional_name", "email", "family_name", "given_name", "name", "organization", "tel", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#additional_name.and_then(|val| map.insert("additional_name".into(), val.to_string()));
          self.r#email.and_then(|val| map.insert("email".into(), val.to_string()));
          self.r#family_name.and_then(|val| map.insert("family_name".into(), val.to_string()));
          self.r#given_name.and_then(|val| map.insert("given_name".into(), val.to_string()));
          self.r#name.and_then(|val| map.insert("name".into(), val.to_string()));
          self.r#organization.and_then(|val| map.insert("organization".into(), val.to_string()));
          self.r#tel.and_then(|val| map.insert("tel".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.filled_address_form_ext
    ///
    /// Address has too many fields so we cannot cover them all in the above
    /// `address_form` telemetry This telemetry is used to record address fields that
    /// are not listed in `address_form` This event was generated to correspond to the
    /// Legacy Telemetry event address.filled#address_form_ext.
    pub static filled_address_form_ext: Lazy<EventMetric<FilledAddressFormExtExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "filled_address_form_ext".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3657.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FilledModifiedAddressFormExtra {
        pub r#address_level1: Option<String>,
        pub r#address_level2: Option<String>,
        pub r#address_line1: Option<String>,
        pub r#address_line2: Option<String>,
        pub r#address_line3: Option<String>,
        pub r#country: Option<String>,
        pub r#field_name: Option<String>,
        pub r#postal_code: Option<String>,
        pub r#street_address: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for FilledModifiedAddressFormExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["address_level1", "address_level2", "address_line1", "address_line2", "address_line3", "country", "field_name", "postal_code", "street_address", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#address_level1.and_then(|val| map.insert("address_level1".into(), val.to_string()));
          self.r#address_level2.and_then(|val| map.insert("address_level2".into(), val.to_string()));
          self.r#address_line1.and_then(|val| map.insert("address_line1".into(), val.to_string()));
          self.r#address_line2.and_then(|val| map.insert("address_line2".into(), val.to_string()));
          self.r#address_line3.and_then(|val| map.insert("address_line3".into(), val.to_string()));
          self.r#country.and_then(|val| map.insert("country".into(), val.to_string()));
          self.r#field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.r#postal_code.and_then(|val| map.insert("postal_code".into(), val.to_string()));
          self.r#street_address.and_then(|val| map.insert("street_address".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.filled_modified_address_form
    ///
    /// Recorded when a field is autofilled and then modified by the user. Using
    /// field_name to record the field that triggers this event.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// address.filled_modified#address_form.
    pub static filled_modified_address_form: Lazy<EventMetric<FilledModifiedAddressFormExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "filled_modified_address_form".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3658.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LearnMoreCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for LearnMoreCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.learn_more_capture_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// address.learn_more#capture_doorhanger.
    pub static learn_more_capture_doorhanger: Lazy<EventMetric<LearnMoreCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "learn_more_capture_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3659.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LearnMoreEditDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for LearnMoreEditDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.learn_more_edit_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// address.learn_more#edit_doorhanger.
    pub static learn_more_edit_doorhanger: Lazy<EventMetric<LearnMoreEditDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "learn_more_edit_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3660.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LearnMoreUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for LearnMoreUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.learn_more_update_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// address.learn_more#update_doorhanger.
    pub static learn_more_update_doorhanger: Lazy<EventMetric<LearnMoreUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "learn_more_update_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3661.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PopupShownAddressFormExtra {
        pub r#field_name: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PopupShownAddressFormExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["field_name", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.popup_shown_address_form
    ///
    /// Recorded when autofill popup is shown. Using field_name to record the field
    /// that triggers this event.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// address.popup_shown#address_form.
    pub static popup_shown_address_form: Lazy<EventMetric<PopupShownAddressFormExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "popup_shown_address_form".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3662.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PrefCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PrefCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.pref_capture_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// address.pref#capture_doorhanger.
    pub static pref_capture_doorhanger: Lazy<EventMetric<PrefCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_capture_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3663.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PrefEditDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PrefEditDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.pref_edit_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// address.pref#edit_doorhanger.
    pub static pref_edit_doorhanger: Lazy<EventMetric<PrefEditDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_edit_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3664.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PrefUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PrefUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.pref_update_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// address.pref#update_doorhanger.
    pub static pref_update_doorhanger: Lazy<EventMetric<PrefUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_update_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3665.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SaveCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SaveCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.save_capture_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// address.save#capture_doorhanger.
    pub static save_capture_doorhanger: Lazy<EventMetric<SaveCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "save_capture_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3666.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SaveEditDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SaveEditDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.save_edit_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// address.save#edit_doorhanger.
    pub static save_edit_doorhanger: Lazy<EventMetric<SaveEditDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "save_edit_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3667.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SaveUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SaveUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.save_update_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// address.save#update_doorhanger.
    pub static save_update_doorhanger: Lazy<EventMetric<SaveUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "save_update_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3668.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.show_capture_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// address.show#capture_doorhanger.
    pub static show_capture_doorhanger: Lazy<EventMetric<ShowCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_capture_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3669.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowEditDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowEditDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.show_edit_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// address.show#edit_doorhanger.
    pub static show_edit_doorhanger: Lazy<EventMetric<ShowEditDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_edit_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3670.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowEntryManageExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowEntryManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.show_entry_manage
    ///
    /// User interactions for address autofill preferences management UI. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// address.show_entry#manage.
    pub static show_entry_manage: Lazy<EventMetric<ShowEntryManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_entry_manage".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3671.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowManageExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.show_manage
    ///
    /// User interactions for address autofill preferences management UI. This event
    /// was generated to correspond to the Legacy Telemetry event address.show#manage.
    pub static show_manage: Lazy<EventMetric<ShowManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_manage".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3672.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.show_update_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// address.show#update_doorhanger.
    pub static show_update_doorhanger: Lazy<EventMetric<ShowUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_update_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3673.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SubmittedAddressFormExtra {
        pub r#address_level1: Option<String>,
        pub r#address_level2: Option<String>,
        pub r#address_line1: Option<String>,
        pub r#address_line2: Option<String>,
        pub r#address_line3: Option<String>,
        pub r#country: Option<String>,
        pub r#postal_code: Option<String>,
        pub r#street_address: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SubmittedAddressFormExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["address_level1", "address_level2", "address_line1", "address_line2", "address_line3", "country", "postal_code", "street_address", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#address_level1.and_then(|val| map.insert("address_level1".into(), val.to_string()));
          self.r#address_level2.and_then(|val| map.insert("address_level2".into(), val.to_string()));
          self.r#address_line1.and_then(|val| map.insert("address_line1".into(), val.to_string()));
          self.r#address_line2.and_then(|val| map.insert("address_line2".into(), val.to_string()));
          self.r#address_line3.and_then(|val| map.insert("address_line3".into(), val.to_string()));
          self.r#country.and_then(|val| map.insert("country".into(), val.to_string()));
          self.r#postal_code.and_then(|val| map.insert("postal_code".into(), val.to_string()));
          self.r#street_address.and_then(|val| map.insert("street_address".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.submitted_address_form
    ///
    /// Recorded when a form is submitted. Possible values are `autofilled`,
    /// `not_filled`, `user_filled` or `unavailable`.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// address.submitted#address_form.
    pub static submitted_address_form: Lazy<EventMetric<SubmittedAddressFormExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "submitted_address_form".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3674.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SubmittedAddressFormExtExtra {
        pub r#additional_name: Option<String>,
        pub r#email: Option<String>,
        pub r#family_name: Option<String>,
        pub r#given_name: Option<String>,
        pub r#name: Option<String>,
        pub r#organization: Option<String>,
        pub r#tel: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SubmittedAddressFormExtExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["additional_name", "email", "family_name", "given_name", "name", "organization", "tel", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#additional_name.and_then(|val| map.insert("additional_name".into(), val.to_string()));
          self.r#email.and_then(|val| map.insert("email".into(), val.to_string()));
          self.r#family_name.and_then(|val| map.insert("family_name".into(), val.to_string()));
          self.r#given_name.and_then(|val| map.insert("given_name".into(), val.to_string()));
          self.r#name.and_then(|val| map.insert("name".into(), val.to_string()));
          self.r#organization.and_then(|val| map.insert("organization".into(), val.to_string()));
          self.r#tel.and_then(|val| map.insert("tel".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.submitted_address_form_ext
    ///
    /// Address has too many fields so we cannot cover them all in the above
    /// `address_form` telemetry This telemetry is used to record address fields that
    /// are not listed in `address_form` This event was generated to correspond to the
    /// Legacy Telemetry event address.submitted#address_form_ext.
    pub static submitted_address_form_ext: Lazy<EventMetric<SubmittedAddressFormExtExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "submitted_address_form_ext".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3675.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.update_capture_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// address.update#capture_doorhanger.
    pub static update_capture_doorhanger: Lazy<EventMetric<UpdateCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_capture_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3676.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateEditDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateEditDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.update_edit_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// address.update#edit_doorhanger.
    pub static update_edit_doorhanger: Lazy<EventMetric<UpdateEditDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_edit_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3677.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.update_update_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// address.update#update_doorhanger.
    pub static update_update_doorhanger: Lazy<EventMetric<UpdateUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_update_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3678.into(), meta)
    });

}
pub mod creditcard {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AddManageExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AddManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.add_manage
    ///
    /// User interactions for credit card autofill preferences management UI. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// creditcard.add#manage.
    pub static add_manage: Lazy<EventMetric<AddManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "add_manage".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3679.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CancelCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for CancelCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.cancel_capture_doorhanger
    ///
    /// User interactions for the browser credit card autofill doorhanger. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// creditcard.cancel#capture_doorhanger.
    pub static cancel_capture_doorhanger: Lazy<EventMetric<CancelCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel_capture_doorhanger".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3680.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CancelUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for CancelUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.cancel_update_doorhanger
    ///
    /// User interactions for the browser credit card autofill doorhanger. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// creditcard.cancel#update_doorhanger.
    pub static cancel_update_doorhanger: Lazy<EventMetric<CancelUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel_update_doorhanger".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3681.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClearedCcFormV2Extra {
        pub r#cc_exp: Option<String>,
        pub r#cc_exp_month: Option<String>,
        pub r#cc_exp_year: Option<String>,
        pub r#cc_name: Option<String>,
        pub r#cc_number: Option<String>,
        pub r#cc_type: Option<String>,
        pub r#field_name: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClearedCcFormV2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cc_exp", "cc_exp_month", "cc_exp_year", "cc_name", "cc_number", "cc_type", "field_name", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cc_exp.and_then(|val| map.insert("cc_exp".into(), val.to_string()));
          self.r#cc_exp_month.and_then(|val| map.insert("cc_exp_month".into(), val.to_string()));
          self.r#cc_exp_year.and_then(|val| map.insert("cc_exp_year".into(), val.to_string()));
          self.r#cc_name.and_then(|val| map.insert("cc_name".into(), val.to_string()));
          self.r#cc_number.and_then(|val| map.insert("cc_number".into(), val.to_string()));
          self.r#cc_type.and_then(|val| map.insert("cc_type".into(), val.to_string()));
          self.r#field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.cleared_cc_form_v2
    ///
    /// Recorded when a form is cleared. Using field_name to record the field that
    /// triggers this event.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// creditcard.cleared#cc_form_v2.
    pub static cleared_cc_form_v2: Lazy<EventMetric<ClearedCcFormV2Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cleared_cc_form_v2".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3682.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DeleteManageExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DeleteManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.delete_manage
    ///
    /// User interactions for credit card autofill preferences management UI. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// creditcard.delete#manage.
    pub static delete_manage: Lazy<EventMetric<DeleteManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "delete_manage".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3683.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DetectedCcFormV2Extra {
        pub r#cc_exp: Option<String>,
        pub r#cc_exp_month: Option<String>,
        pub r#cc_exp_year: Option<String>,
        pub r#cc_name: Option<String>,
        pub r#cc_number: Option<String>,
        pub r#cc_type: Option<String>,
        pub r#field_name: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DetectedCcFormV2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cc_exp", "cc_exp_month", "cc_exp_year", "cc_name", "cc_number", "cc_type", "field_name", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cc_exp.and_then(|val| map.insert("cc_exp".into(), val.to_string()));
          self.r#cc_exp_month.and_then(|val| map.insert("cc_exp_month".into(), val.to_string()));
          self.r#cc_exp_year.and_then(|val| map.insert("cc_exp_year".into(), val.to_string()));
          self.r#cc_name.and_then(|val| map.insert("cc_name".into(), val.to_string()));
          self.r#cc_number.and_then(|val| map.insert("cc_number".into(), val.to_string()));
          self.r#cc_type.and_then(|val| map.insert("cc_type".into(), val.to_string()));
          self.r#field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.detected_cc_form_v2
    ///
    /// Recorded when a form is recognized as a credit card form. The possible value of
    /// cc_* in extra_keys are "true", "false", or an integer between 0-100. When the
    /// value is "true", the field is identified via autocomplete attribute. When the
    /// value is "false", the field is not detected in the form. When the value is an
    /// integer greater than 0, the value indicates the confidence value from fathom
    /// (normalized to 0-100). When the value is an 0, then the field is identified by
    /// regexp-based heuristic.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// creditcard.detected#cc_form_v2.
    pub static detected_cc_form_v2: Lazy<EventMetric<DetectedCcFormV2Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "detected_cc_form_v2".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3684.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.disable_capture_doorhanger
    ///
    /// User interactions for the browser credit card autofill doorhanger. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// creditcard.disable#capture_doorhanger.
    pub static disable_capture_doorhanger: Lazy<EventMetric<DisableCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_capture_doorhanger".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3685.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.disable_update_doorhanger
    ///
    /// User interactions for the browser credit card autofill doorhanger. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// creditcard.disable#update_doorhanger.
    pub static disable_update_doorhanger: Lazy<EventMetric<DisableUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_update_doorhanger".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3686.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EditManageExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EditManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.edit_manage
    ///
    /// User interactions for credit card autofill preferences management UI. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// creditcard.edit#manage.
    pub static edit_manage: Lazy<EventMetric<EditManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "edit_manage".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3687.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FilledCcFormV2Extra {
        pub r#cc_exp: Option<String>,
        pub r#cc_exp_month: Option<String>,
        pub r#cc_exp_year: Option<String>,
        pub r#cc_name: Option<String>,
        pub r#cc_number: Option<String>,
        pub r#cc_type: Option<String>,
        pub r#field_name: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for FilledCcFormV2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cc_exp", "cc_exp_month", "cc_exp_year", "cc_name", "cc_number", "cc_type", "field_name", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cc_exp.and_then(|val| map.insert("cc_exp".into(), val.to_string()));
          self.r#cc_exp_month.and_then(|val| map.insert("cc_exp_month".into(), val.to_string()));
          self.r#cc_exp_year.and_then(|val| map.insert("cc_exp_year".into(), val.to_string()));
          self.r#cc_name.and_then(|val| map.insert("cc_name".into(), val.to_string()));
          self.r#cc_number.and_then(|val| map.insert("cc_number".into(), val.to_string()));
          self.r#cc_type.and_then(|val| map.insert("cc_type".into(), val.to_string()));
          self.r#field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.filled_cc_form_v2
    ///
    /// Recorded when a form is autofiled. Possible values are `filled`, `not_filled`,
    /// `user_filled` or `unavailable`.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// creditcard.filled#cc_form_v2.
    pub static filled_cc_form_v2: Lazy<EventMetric<FilledCcFormV2Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "filled_cc_form_v2".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3688.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FilledModifiedCcFormV2Extra {
        pub r#cc_exp: Option<String>,
        pub r#cc_exp_month: Option<String>,
        pub r#cc_exp_year: Option<String>,
        pub r#cc_name: Option<String>,
        pub r#cc_number: Option<String>,
        pub r#cc_type: Option<String>,
        pub r#field_name: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for FilledModifiedCcFormV2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cc_exp", "cc_exp_month", "cc_exp_year", "cc_name", "cc_number", "cc_type", "field_name", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cc_exp.and_then(|val| map.insert("cc_exp".into(), val.to_string()));
          self.r#cc_exp_month.and_then(|val| map.insert("cc_exp_month".into(), val.to_string()));
          self.r#cc_exp_year.and_then(|val| map.insert("cc_exp_year".into(), val.to_string()));
          self.r#cc_name.and_then(|val| map.insert("cc_name".into(), val.to_string()));
          self.r#cc_number.and_then(|val| map.insert("cc_number".into(), val.to_string()));
          self.r#cc_type.and_then(|val| map.insert("cc_type".into(), val.to_string()));
          self.r#field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.filled_modified_cc_form_v2
    ///
    /// Recorded when a field is autofilled and then modified by the user. Using
    /// field_name to record the field that triggers this event.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// creditcard.filled_modified#cc_form_v2.
    pub static filled_modified_cc_form_v2: Lazy<EventMetric<FilledModifiedCcFormV2Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "filled_modified_cc_form_v2".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3689.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PopupShownCcFormV2Extra {
        pub r#cc_exp: Option<String>,
        pub r#cc_exp_month: Option<String>,
        pub r#cc_exp_year: Option<String>,
        pub r#cc_name: Option<String>,
        pub r#cc_number: Option<String>,
        pub r#cc_type: Option<String>,
        pub r#field_name: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PopupShownCcFormV2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cc_exp", "cc_exp_month", "cc_exp_year", "cc_name", "cc_number", "cc_type", "field_name", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cc_exp.and_then(|val| map.insert("cc_exp".into(), val.to_string()));
          self.r#cc_exp_month.and_then(|val| map.insert("cc_exp_month".into(), val.to_string()));
          self.r#cc_exp_year.and_then(|val| map.insert("cc_exp_year".into(), val.to_string()));
          self.r#cc_name.and_then(|val| map.insert("cc_name".into(), val.to_string()));
          self.r#cc_number.and_then(|val| map.insert("cc_number".into(), val.to_string()));
          self.r#cc_type.and_then(|val| map.insert("cc_type".into(), val.to_string()));
          self.r#field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.popup_shown_cc_form_v2
    ///
    /// Recorded when autofill popup is shown. Using field_name to record the field
    /// that triggers this event.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// creditcard.popup_shown#cc_form_v2.
    pub static popup_shown_cc_form_v2: Lazy<EventMetric<PopupShownCcFormV2Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "popup_shown_cc_form_v2".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3690.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SaveCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SaveCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.save_capture_doorhanger
    ///
    /// User interactions for the browser credit card autofill doorhanger. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// creditcard.save#capture_doorhanger.
    pub static save_capture_doorhanger: Lazy<EventMetric<SaveCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "save_capture_doorhanger".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3691.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SaveUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SaveUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.save_update_doorhanger
    ///
    /// User interactions for the browser credit card autofill doorhanger. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// creditcard.save#update_doorhanger.
    pub static save_update_doorhanger: Lazy<EventMetric<SaveUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "save_update_doorhanger".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3692.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.show_capture_doorhanger
    ///
    /// User interactions for the browser credit card autofill doorhanger. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// creditcard.show#capture_doorhanger.
    pub static show_capture_doorhanger: Lazy<EventMetric<ShowCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_capture_doorhanger".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3693.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowEntryManageExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowEntryManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.show_entry_manage
    ///
    /// User interactions for credit card autofill preferences management UI. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// creditcard.show_entry#manage.
    pub static show_entry_manage: Lazy<EventMetric<ShowEntryManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_entry_manage".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3694.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowManageExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.show_manage
    ///
    /// User interactions for credit card autofill preferences management UI. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// creditcard.show#manage.
    pub static show_manage: Lazy<EventMetric<ShowManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_manage".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3695.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.show_update_doorhanger
    ///
    /// User interactions for the browser credit card autofill doorhanger. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// creditcard.show#update_doorhanger.
    pub static show_update_doorhanger: Lazy<EventMetric<ShowUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_update_doorhanger".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3696.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SubmittedCcFormV2Extra {
        pub r#cc_exp: Option<String>,
        pub r#cc_exp_month: Option<String>,
        pub r#cc_exp_year: Option<String>,
        pub r#cc_name: Option<String>,
        pub r#cc_number: Option<String>,
        pub r#cc_type: Option<String>,
        pub r#field_name: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SubmittedCcFormV2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cc_exp", "cc_exp_month", "cc_exp_year", "cc_name", "cc_number", "cc_type", "field_name", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cc_exp.and_then(|val| map.insert("cc_exp".into(), val.to_string()));
          self.r#cc_exp_month.and_then(|val| map.insert("cc_exp_month".into(), val.to_string()));
          self.r#cc_exp_year.and_then(|val| map.insert("cc_exp_year".into(), val.to_string()));
          self.r#cc_name.and_then(|val| map.insert("cc_name".into(), val.to_string()));
          self.r#cc_number.and_then(|val| map.insert("cc_number".into(), val.to_string()));
          self.r#cc_type.and_then(|val| map.insert("cc_type".into(), val.to_string()));
          self.r#field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.submitted_cc_form_v2
    ///
    /// Recorded when a form is submitted. Possible values are `autofilled`,
    /// `user_filled` or `unavailable`.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// creditcard.submitted#cc_form_v2.
    pub static submitted_cc_form_v2: Lazy<EventMetric<SubmittedCcFormV2Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "submitted_cc_form_v2".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3697.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.update_capture_doorhanger
    ///
    /// User interactions for the browser credit card autofill doorhanger. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// creditcard.update#capture_doorhanger.
    pub static update_capture_doorhanger: Lazy<EventMetric<UpdateCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_capture_doorhanger".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3698.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.update_update_doorhanger
    ///
    /// User interactions for the browser credit card autofill doorhanger. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// creditcard.update#update_doorhanger.
    pub static update_update_doorhanger: Lazy<EventMetric<UpdateUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_update_doorhanger".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3699.into(), meta)
    });

}
pub mod formautofill {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum FormSubmissionHeuristicLabel {
        EFormSubmitEvent = 0,
        EFormRemovalAfterFetch = 1,
        EPageNavigation = 2,
        EIframePagehide = 3,
        __Other__,
    }
    impl From<u16> for FormSubmissionHeuristicLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFormSubmitEvent,
                1 => Self::EFormRemovalAfterFetch,
                2 => Self::EPageNavigation,
                3 => Self::EIframePagehide,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FormSubmissionHeuristicLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFormSubmitEvent => "form-submit-event",
                Self::EFormRemovalAfterFetch => "form-removal-after-fetch",
                Self::EPageNavigation => "page-navigation",
                Self::EIframePagehide => "iframe-pagehide",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from formautofill.form_submission_heuristic
    ///
    /// The heuristic that detected the form submission.
    pub static form_submission_heuristic: Lazy<LabeledMetric<LabeledCounterMetric, FormSubmissionHeuristicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "form_submission_heuristic".into(),
                    category: "formautofill".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3700.into(), meta, Some(vec![::std::borrow::Cow::from("form-removal-after-fetch"), ::std::borrow::Cow::from("form-submit-event"), ::std::borrow::Cow::from("iframe-pagehide"), ::std::borrow::Cow::from("page-navigation")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct IframeLayoutDetectionExtra {
        pub r#category: Option<String>,
        pub r#cross_origin: Option<String>,
        pub r#flow_id: Option<String>,
        pub r#iframe: Option<String>,
        pub r#iframe_count: Option<u32>,
        pub r#main_frame: Option<String>,
        pub r#sandboxed: Option<String>,
    }

    impl ExtraKeys for IframeLayoutDetectionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "cross_origin", "flow_id", "iframe", "iframe_count", "main_frame", "sandboxed"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#cross_origin.and_then(|val| map.insert("cross_origin".into(), val.to_string()));
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#iframe.and_then(|val| map.insert("iframe".into(), val.to_string()));
          self.r#iframe_count.and_then(|val| map.insert("iframe_count".into(), val.to_string()));
          self.r#main_frame.and_then(|val| map.insert("main_frame".into(), val.to_string()));
          self.r#sandboxed.and_then(|val| map.insert("sandboxed".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from formautofill.iframe_layout_detection
    ///
    /// Record the number of iframe in a form and what fields are in an iframe when a
    /// form is detected
    pub static iframe_layout_detection: Lazy<EventMetric<IframeLayoutDetectionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "iframe_layout_detection".into(),
                category: "formautofill".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3701.into(), meta)
    });

}
pub mod formautofill_creditcards {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from formautofill.creditcards.autofill_profiles_count
    ///
    /// Count at store time how many credit card autofill profiles the user has.
    pub static autofill_profiles_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "autofill_profiles_count".into(),
                category: "formautofill.creditcards".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3702.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FormClearedExtra {
        pub r#field_name: Option<String>,
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for FormClearedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["field_name", "flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from formautofill.creditcards.form_cleared
    ///
    /// Recorded when a credit card form is cleared . The flow id indicates an
    /// interaction session with the a form and is shared across cc_form events. The
    /// field_name is used to record the field that triggers this event
    pub static form_cleared: Lazy<EventMetric<FormClearedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "form_cleared".into(),
                category: "formautofill.creditcards".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3703.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FormDetectedExtra {
        pub r#cc_exp: Option<String>,
        pub r#cc_exp_month: Option<String>,
        pub r#cc_exp_year: Option<String>,
        pub r#cc_name: Option<String>,
        pub r#cc_number: Option<String>,
        pub r#cc_number_multi_parts: Option<u32>,
        pub r#cc_type: Option<String>,
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for FormDetectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cc_exp", "cc_exp_month", "cc_exp_year", "cc_name", "cc_number", "cc_number_multi_parts", "cc_type", "flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cc_exp.and_then(|val| map.insert("cc_exp".into(), val.to_string()));
          self.r#cc_exp_month.and_then(|val| map.insert("cc_exp_month".into(), val.to_string()));
          self.r#cc_exp_year.and_then(|val| map.insert("cc_exp_year".into(), val.to_string()));
          self.r#cc_name.and_then(|val| map.insert("cc_name".into(), val.to_string()));
          self.r#cc_number.and_then(|val| map.insert("cc_number".into(), val.to_string()));
          self.r#cc_number_multi_parts.and_then(|val| map.insert("cc_number_multi_parts".into(), val.to_string()));
          self.r#cc_type.and_then(|val| map.insert("cc_type".into(), val.to_string()));
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from formautofill.creditcards.form_detected
    ///
    /// Recorded when a form is recognized as a credit card form. The possible value of
    /// cc_* are "autocomplete", "undetected", "regexp" or an integer between 0-100:
    ///   - When the value is "autocomplete", the field is identified via autocomplete
    /// attribute
    ///   - When the value is "undetected", the field is not detected in the form
    ///   - When the value is "regexp", then the field is identified by regexp-based
    /// heuristic
    ///   - When the value is an integer greater than 0, the value indicates the
    /// confidence value from fathom (normalized to 0-100)
    /// The flow id points to an interaction session with a credit card form and is
    /// shared across cc_form events .
    pub static form_detected: Lazy<EventMetric<FormDetectedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "form_detected".into(),
                category: "formautofill.creditcards".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3704.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FormFilledExtra {
        pub r#cc_exp: Option<String>,
        pub r#cc_exp_month: Option<String>,
        pub r#cc_exp_year: Option<String>,
        pub r#cc_name: Option<String>,
        pub r#cc_number: Option<String>,
        pub r#cc_type: Option<String>,
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for FormFilledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cc_exp", "cc_exp_month", "cc_exp_year", "cc_name", "cc_number", "cc_type", "flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cc_exp.and_then(|val| map.insert("cc_exp".into(), val.to_string()));
          self.r#cc_exp_month.and_then(|val| map.insert("cc_exp_month".into(), val.to_string()));
          self.r#cc_exp_year.and_then(|val| map.insert("cc_exp_year".into(), val.to_string()));
          self.r#cc_name.and_then(|val| map.insert("cc_name".into(), val.to_string()));
          self.r#cc_number.and_then(|val| map.insert("cc_number".into(), val.to_string()));
          self.r#cc_type.and_then(|val| map.insert("cc_type".into(), val.to_string()));
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from formautofill.creditcards.form_filled
    ///
    /// Recorded when a credit card form is autofilled. The flow id indicates an
    /// interaction session with the a form and is shared across cc_form events. The
    /// possible value of cc_* are `filled`, `not_filled`, `user_filled` or
    /// `unavailable`
    pub static form_filled: Lazy<EventMetric<FormFilledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "form_filled".into(),
                category: "formautofill.creditcards".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3705.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FormFilledModifiedExtra {
        pub r#field_name: Option<String>,
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for FormFilledModifiedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["field_name", "flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from formautofill.creditcards.form_filled_modified
    ///
    /// Recorded when a field in a credit card form is autofilled and then modified by
    /// the user. The flow id indicates an interaction session with the a form and is
    /// shared across cc_form events. The field_name is used to record the field that
    /// triggers this event.
    pub static form_filled_modified: Lazy<EventMetric<FormFilledModifiedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "form_filled_modified".into(),
                category: "formautofill.creditcards".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3706.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FormPopupShownExtra {
        pub r#field_name: Option<String>,
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for FormPopupShownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["field_name", "flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from formautofill.creditcards.form_popup_shown
    ///
    /// Recorded when autofill popup is shown for a credit card form. The flow id
    /// indicates an interaction session with the a form and is shared across cc_form
    /// events. The field_name is used to record the field that triggers this event.
    pub static form_popup_shown: Lazy<EventMetric<FormPopupShownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "form_popup_shown".into(),
                category: "formautofill.creditcards".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3707.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FormSubmittedExtra {
        pub r#cc_exp: Option<String>,
        pub r#cc_exp_month: Option<String>,
        pub r#cc_exp_year: Option<String>,
        pub r#cc_name: Option<String>,
        pub r#cc_number: Option<String>,
        pub r#cc_type: Option<String>,
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for FormSubmittedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cc_exp", "cc_exp_month", "cc_exp_year", "cc_name", "cc_number", "cc_type", "flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cc_exp.and_then(|val| map.insert("cc_exp".into(), val.to_string()));
          self.r#cc_exp_month.and_then(|val| map.insert("cc_exp_month".into(), val.to_string()));
          self.r#cc_exp_year.and_then(|val| map.insert("cc_exp_year".into(), val.to_string()));
          self.r#cc_name.and_then(|val| map.insert("cc_name".into(), val.to_string()));
          self.r#cc_number.and_then(|val| map.insert("cc_number".into(), val.to_string()));
          self.r#cc_type.and_then(|val| map.insert("cc_type".into(), val.to_string()));
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from formautofill.creditcards.form_submitted
    ///
    /// Recorded when a credit card form is submitted. The flow id indicates an
    /// interaction session with the a form and is shared across cc_form events. The
    /// possible value of cc_* are `autofilled`, `user_filled` or `unavailable`
    pub static form_submitted: Lazy<EventMetric<FormSubmittedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "form_submitted".into(),
                category: "formautofill.creditcards".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3708.into(), meta)
    });

}
pub mod fog {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from fog.failed_idle_registration
    ///
    /// True if we failed to register with the idle service. Absent otherwise.
    /// Means IPC probably isn't working well.
    /// Child-process data will likely be absent, or incomplete.
    pub static failed_idle_registration: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "failed_idle_registration".into(),
                category: "fog".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3709.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.initialization
    ///
    /// Time the FOG initialization takes.
    pub static initialization: Lazy<TimespanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "initialization".into(),
                category: "fog".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimespanMetric::new(3710.into(), meta, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.inits_during_shutdown
    ///
    /// Counts the number of times init had to be called during shutdown.
    /// Should never have a value for any session long enough to grow idle.
    pub static inits_during_shutdown: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3711,
            "fog",
            "inits_during_shutdown",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.max_pings_per_minute
    ///
    /// Value of the configurable rate limit, in pings per minute, for Glean pings as
    /// set at init.
    pub static max_pings_per_minute: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "max_pings_per_minute".into(),
                category: "fog".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3712.into(), meta)
    });

}
pub mod fog_ipc {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.buffer_sizes
    ///
    /// The number and size of the IPC buffers being received over FOG IPC.
    pub static buffer_sizes: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "buffer_sizes".into(),
                category: "fog.ipc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(3713.into(), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.flush_durations
    ///
    /// The length of time between asking the child processes for their
    /// IPC buffers and all of them being received by the parent.
    pub static flush_durations: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "flush_durations".into(),
                category: "fog.ipc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3714.into(), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.flush_failures
    ///
    /// The number of times we failed to flush all non-parent-process data,
    /// throwing even partial results into the trash.
    /// If this number is high, we might consider writing custom `MozPromise`-
    /// handling code instead of using `MozPromise::All`.
    pub static flush_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3715,
            "fog.ipc",
            "flush_failures",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.replay_failures
    ///
    /// The number of times the ipc buffer failed to be replayed in the
    /// parent process.
    pub static replay_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3716,
            "fog.ipc",
            "replay_failures",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.shutdown_registration_failures
    ///
    /// The number of times we tried to register shutdown flush routines for
    /// content child processes, and failed (probably because there was no main
    /// thread).
    /// As a result there may be data loss from content child processes.
    /// Large or rising number of clients experiencing this indicates we should
    /// perhaps refactor content child shutdown in FOG to try harder to register
    /// flush operations.
    /// Will likely be obsoleted by bug 1641989.
    pub static shutdown_registration_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3717,
            "fog.ipc",
            "shutdown_registration_failures",
            "metrics"
        )
    });

}
pub mod test_only {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from test_only.bad_code
    ///
    /// Number of times we encountered bad code.
    /// This is a test-only metric.
    pub static bad_code: Lazy<CounterMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "bad_code".into(),
                category: "test_only".into(),
                send_in_pings: vec!["ride-along-ping".into(), "test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CounterMetric::new(3718.into(), meta)
    });

        pub type BalloonsObject = Vec<BalloonsObjectItem>;

        #[derive(Debug, Hash, Eq, PartialEq, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct BalloonsObjectItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub colour: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub diameter: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub CamelCasedParameter: Option<i64>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from test_only.balloons
    ///
    /// A collection of balloons
    pub static balloons: Lazy<ObjectMetric<BalloonsObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "balloons".into(),
                category: "test_only".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(3719.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.can_we_flag_it
    ///
    /// Test metric for a boolean.
    /// This is a test-only metric.
    pub static can_we_flag_it: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "can_we_flag_it".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3720.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.can_we_time_it
    ///
    /// Test metric for a timespan.
    /// This is a test-only metric.
    pub static can_we_time_it: Lazy<TimespanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "can_we_time_it".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimespanMetric::new(3721.into(), meta, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.cheesy_string
    ///
    /// Only the cheesiest of strings.
    /// This is a test-only metric.
    pub static cheesy_string: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cheesy_string".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3722.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.cheesy_string_list
    ///
    /// Only the cheesiest of strings. In list form!
    /// This is a test-only metric.
    pub static cheesy_string_list: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cheesy_string_list".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(3723.into(), meta)
    });

        #[derive(Debug, Hash, Eq, PartialEq, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct CrashStackObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub status: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub main_module: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub crash_info: Option<CrashStackObjectItemCrashInfoObject>,
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new")]
          pub modules: CrashStackObjectItemModules,
    }

            #[derive(Debug, Hash, Eq, PartialEq, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct CrashStackObjectItemCrashInfoObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub typ: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub address: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub crashing_thread: Option<i64>,
    }

            pub type CrashStackObjectItemModules = Vec<CrashStackObjectItemModulesItem>;

        #[derive(Debug, Hash, Eq, PartialEq, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct CrashStackObjectItemModulesItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub base_addr: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub end_addr: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from test_only.crash_stack
    ///
    /// A not-real crash stack
    pub static crash_stack: Lazy<ObjectMetric<CrashStackObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "crash_stack".into(),
                category: "test_only".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(3724.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.do_you_remember
    ///
    /// They say it's the second thing to go.
    /// This is a test-only metric.
    pub static do_you_remember: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "do_you_remember".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(3725.into(), meta, MemoryUnit::Megabyte)
    });

    #[repr(u16)]
    pub enum MabelsBalloonLabelsLabel {
        ECelebratory = 0,
        ECelebratoryAndSnarky = 1,
        __Other__,
    }
    impl From<u16> for MabelsBalloonLabelsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECelebratory,
                1 => Self::ECelebratoryAndSnarky,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MabelsBalloonLabelsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECelebratory => "celebratory",
                Self::ECelebratoryAndSnarky => "celebratory_and_snarky",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_balloon_labels
    ///
    /// How does Mabel label her balloons?
    /// This is a test-only metric.
    pub static mabels_balloon_labels: Lazy<LabeledMetric<LabeledStringMetric, MabelsBalloonLabelsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mabels_balloon_labels".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3726.into(), meta, Some(vec![::std::borrow::Cow::from("celebratory"), ::std::borrow::Cow::from("celebratory_and_snarky")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_balloon_strings
    ///
    /// What do the labeled Mabel's liked balloons' strings say?
    /// This is a test-only metric.
    pub static mabels_balloon_strings: Lazy<LabeledMetric<LabeledStringMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mabels_balloon_strings".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3727.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_bathroom_counters
    ///
    /// Counts Mabels labeled by their bathroom counters.
    /// This is a test-only metric.
    pub static mabels_bathroom_counters: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mabels_bathroom_counters".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3728.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_custom_label_lengths
    ///
    /// Mabel wants to track the length of their new label maker's labels.
    pub static mabels_custom_label_lengths: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "mabels_custom_label_lengths".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 2147483646, bucket_count: 10, histogram_type: HistogramType::Linear};
        LabeledMetric::new(3729.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_kitchen_counters
    ///
    /// Counts Mabels labeled by their kitchen counters.
    /// This is a test-only metric.
    pub static mabels_kitchen_counters: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mabels_kitchen_counters".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3730.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_label_maker
    ///
    /// Mabel just got a label maker and wants to party like it's
    /// 1999.
    /// This is a test-only metric.
    pub static mabels_label_maker: Lazy<LabeledMetric<LabeledStringMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mabels_label_maker".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3731.into(), meta, None)
    });

    #[repr(u16)]
    pub enum MabelsLabeledCountersLabel {
        ENextToTheFridge = 0,
        EClean = 1,
        E1stCounter = 2,
        __Other__,
    }
    impl From<u16> for MabelsLabeledCountersLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENextToTheFridge,
                1 => Self::EClean,
                2 => Self::E1stCounter,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MabelsLabeledCountersLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENextToTheFridge => "next_to_the_fridge",
                Self::EClean => "clean",
                Self::E1stCounter => "1st_counter",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_labeled_counters
    ///
    /// Counts Mabels labeled by their kitchen counters.
    /// Now with static labels.
    /// This is a test-only metric.
    pub static mabels_labeled_counters: Lazy<LabeledMetric<LabeledCounterMetric, MabelsLabeledCountersLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mabels_labeled_counters".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3732.into(), meta, Some(vec![::std::borrow::Cow::from("1st_counter"), ::std::borrow::Cow::from("clean"), ::std::borrow::Cow::from("next_to_the_fridge")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_like_balloons
    ///
    /// Does the labeled Mabel like balloons?
    /// This is a test-only metric.
    pub static mabels_like_balloons: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mabels_like_balloons".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3733.into(), meta, None)
    });

    #[repr(u16)]
    pub enum MabelsLikeLabeledBalloonsLabel {
        EWater = 0,
        EBirthdayParty = 1,
        __Other__,
    }
    impl From<u16> for MabelsLikeLabeledBalloonsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EWater,
                1 => Self::EBirthdayParty,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MabelsLikeLabeledBalloonsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EWater => "water",
                Self::EBirthdayParty => "birthday_party",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_like_labeled_balloons
    ///
    /// Does the labeled Mabel like balloons?
    /// This is a test-only metric.
    pub static mabels_like_labeled_balloons: Lazy<LabeledMetric<LabeledBooleanMetric, MabelsLikeLabeledBalloonsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mabels_like_labeled_balloons".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3734.into(), meta, Some(vec![::std::borrow::Cow::from("birthday_party"), ::std::borrow::Cow::from("water")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.meaning_of_life
    ///
    /// Measures the one true answer to the Ultimate Question of Life,
    /// the Universe, and Everything.
    /// Approximately.
    /// This is a test-only metric.
    pub static meaning_of_life: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "meaning_of_life".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3735.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mirror_time
    ///
    /// Mirrored metric for a timespan.
    /// This is a test-only metric.
    pub static mirror_time: Lazy<TimespanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mirror_time".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimespanMetric::new(3736.into(), meta, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mirror_time_nanos
    ///
    /// Mirrored metric for a timespan.
    /// This is a test-only metric.
    pub static mirror_time_nanos: Lazy<TimespanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mirror_time_nanos".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimespanMetric::new(3737.into(), meta, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mirrors_for_labeled_bools
    ///
    /// Mirrored metric.
    /// This is a test-only metric.
    pub static mirrors_for_labeled_bools: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mirrors_for_labeled_bools".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3738.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.one_ping_one_bool
    ///
    /// One bool for one ping only.
    /// This is a test-only metric.
    pub static one_ping_one_bool: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "one_ping_one_bool".into(),
                category: "test_only".into(),
                send_in_pings: vec!["one-ping-only".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3739.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.what_a_date
    ///
    /// ...To be writing FOG code. This is a test-only metric.
    pub static what_a_date: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "what_a_date".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(3740.into(), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.what_do_you_remember
    ///
    /// What do they say is the second thing to go?
    /// This is a test-only metric.
    pub static what_do_you_remember: Lazy<LabeledMetric<LabeledMemoryDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::MemoryDistribution {
                cmd: CommonMetricData {
                    name: "what_do_you_remember".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: MemoryUnit::Megabyte};
        LabeledMetric::new(3741.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.what_id_it
    ///
    /// Just a UUID.
    /// This is a test-only metric.
    pub static what_id_it: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "what_id_it".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(3742.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.what_time_is_it
    ///
    /// Adheres to at least two of the top ten fallacies programmers believe
    /// about time.
    /// This is a test-only metric.
    pub static what_time_is_it: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "what_time_is_it".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3743.into(), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.where_has_the_time_gone
    ///
    /// Time is different in different places.
    /// This is a test-only metric.
    pub static where_has_the_time_gone: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "where_has_the_time_gone".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Microsecond};
        LabeledMetric::new(3744.into(), meta, None)
    });

}
pub mod test_only_ipc {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_bool
    ///
    /// This is a test-only metric.
    /// Just flagging things.
    pub static a_bool: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_bool".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["store1".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3745.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_counter
    ///
    /// This is a test-only metric.
    /// Just counting things.
    pub static a_counter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3746,
            "test_only.ipc",
            "a_counter",
            "store1"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_custom_dist
    ///
    /// This is a test-only metric.
    /// Just measuring samples.
    pub static a_custom_dist: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_custom_dist".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["store1".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3747.into(), meta, 1, 2147483646, 10, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_date
    ///
    /// This is a test-only metric.
    /// Just putting things on the calendar.
    pub static a_date: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_date".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["store1".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(3748.into(), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_labeled_counter
    ///
    /// This is a test-only metric.
    /// Just counting labeled things.
    pub static a_labeled_counter: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "a_labeled_counter".into(),
                    category: "test_only.ipc".into(),
                    send_in_pings: vec!["store1".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3749.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_memory_dist
    ///
    /// This is a test-only metric.
    /// Just measuring memory.
    pub static a_memory_dist: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_memory_dist".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["store1".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(3750.into(), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_quantity
    ///
    /// This is a test-only metric.
    /// Just quantifying things.
    pub static a_quantity: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_quantity".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["store1".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3751.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_string
    ///
    /// This is a test-only metric.
    /// Just setting some strings.
    pub static a_string: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_string".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["store1".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3752.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_string_list
    ///
    /// This is a test-only metric.
    /// Just appending some strings.
    pub static a_string_list: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_string_list".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["store1".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(3753.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_text
    ///
    /// This is a test-only metric.
    /// For holding Text data.
    pub static a_text: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_text".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["store1".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(3754.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_timing_dist
    ///
    /// This is a test-only metric.
    /// Just measuring time.
    pub static a_timing_dist: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_timing_dist".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["store1".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(3755.into(), meta, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_url
    ///
    /// This is a test-only metric.
    /// Just setting some Urls.
    pub static a_url: Lazy<UrlMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_url".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["store1".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UrlMetric::new(3756.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_uuid
    ///
    /// This is a test-only metric.
    /// Just recording some unique identifiers.
    pub static a_uuid: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_uuid".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["store1".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(3757.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AnEventExtra {
        pub r#extra1: Option<String>,
        pub r#extra2: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AnEventExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["extra1", "extra2", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#extra1.and_then(|val| map.insert("extra1".into(), val.to_string()));
          self.r#extra2.and_then(|val| map.insert("extra2".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.an_event
    ///
    /// This is a test-only metric.
    /// Just recording some events.
    pub static an_event: Lazy<EventMetric<AnEventExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "an_event".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["store1".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3758.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.an_external_denominator
    ///
    /// This is a test-only metric.
    /// A denominator not from around here.
    pub static an_external_denominator: Lazy<DenominatorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "an_external_denominator".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["store1".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DenominatorMetric::new(3759.into(), meta, vec![CommonMetricData {name: "rate_with_external_denominator".into(), category: "test_only.ipc".into(), send_in_pings: vec!["store1".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.an_unordered_bool
    ///
    /// This is a test-only metric.
    /// Just flagging things unorderedly in child processes.
    pub static an_unordered_bool: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "an_unordered_bool".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["store1".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::with_unordered_ipc(3760.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.an_unordered_labeled_boolean
    ///
    /// This is a test-only metric.
    /// Just flagging labeled things unorderedly in child processes.
    pub static an_unordered_labeled_boolean: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "an_unordered_labeled_boolean".into(),
                    category: "test_only.ipc".into(),
                    send_in_pings: vec!["store1".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::with_unordered_ipc(3761.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.another_labeled_counter
    ///
    /// This is a test-only metric.
    /// Just another metric counting labeled things.
    pub static another_labeled_counter: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "another_labeled_counter".into(),
                    category: "test_only.ipc".into(),
                    send_in_pings: vec!["store1".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3762.into(), meta, None)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventWithExtraExtra {
        pub r#extra1: Option<String>,
        pub r#extra2: Option<u32>,
        pub r#extra3_longer_name: Option<bool>,
        pub r#extra4CamelCase: Option<bool>,
    }

    impl ExtraKeys for EventWithExtraExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["extra1", "extra2", "extra3_longer_name", "extra4CamelCase"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#extra1.and_then(|val| map.insert("extra1".into(), val.to_string()));
          self.r#extra2.and_then(|val| map.insert("extra2".into(), val.to_string()));
          self.r#extra3_longer_name.and_then(|val| map.insert("extra3_longer_name".into(), val.to_string()));
          self.r#extra4CamelCase.and_then(|val| map.insert("extra4CamelCase".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.event_with_extra
    ///
    /// This is a test-only metric.
    /// Just recording some events.
    pub static event_with_extra: Lazy<EventMetric<EventWithExtraExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_with_extra".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["store1".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3763.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.irate
    ///
    /// This is a test-only metric.
    /// A rate that isn't happy about it.
    pub static irate: Lazy<RateMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "irate".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["store1".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        RateMetric::new(3764.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.no_extra_event
    ///
    /// This is a test-only metric.
    /// Just recording some events without the extra fuss.
    pub static no_extra_event: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "no_extra_event".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["store1".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3765.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.rate_with_external_denominator
    ///
    /// This is a test-only metric.
    /// A rate with a denominator that is Out There.
    pub static rate_with_external_denominator: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "rate_with_external_denominator".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["store1".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(3766.into(), meta)
    });

}
pub mod test_only_jog {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from test_only.jog.a_counter
    ///
    /// This is a test-only metric.
    /// Just counting things.
    /// Tied closely to test_jog_name_collision.
    pub static a_counter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3767,
            "test_only.jog",
            "a_counter",
            "store1"
        )
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AnEventExtra {
        pub r#extra1: Option<String>,
        pub r#extra2: Option<String>,
    }

    impl ExtraKeys for AnEventExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["extra1", "extra2"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#extra1.and_then(|val| map.insert("extra1".into(), val.to_string()));
          self.r#extra2.and_then(|val| map.insert("extra2".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.jog.an_event
    ///
    /// This is a test-only metric.
    /// Just recording some events.
    /// Tied closely to test_jog_name_collision.
    pub static an_event: Lazy<EventMetric<AnEventExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "an_event".into(),
                category: "test_only.jog".into(),
                send_in_pings: vec!["store1".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3768.into(), meta)
    });

}
pub mod messaging_experiments {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachCfrExtra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachCfrExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_cfr
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System
    /// experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
    /// for each active experiment, and the event 'value' will be the experiment ID
    /// This event was generated to correspond to the Legacy Telemetry event
    /// messaging_experiments.reach#cfr.
    pub static reach_cfr: Lazy<EventMetric<ReachCfrExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_cfr".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3769.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFeatureCalloutExtra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFeatureCalloutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_feature_callout
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System
    /// experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
    /// for each active experiment, and the event 'value' will be the experiment ID
    /// This event was generated to correspond to the Legacy Telemetry event
    /// messaging_experiments.reach#featureCallout.
    pub static reach_feature_callout: Lazy<EventMetric<ReachFeatureCalloutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_feature_callout".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3770.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsBmbButtonExtra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsBmbButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_bmb_button
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System
    /// experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
    /// for each active experiment, and the event 'value' will be the experiment ID
    /// This event was generated to correspond to the Legacy Telemetry event
    /// messaging_experiments.reach#fxms_bmb_button.
    pub static reach_fxms_bmb_button: Lazy<EventMetric<ReachFxmsBmbButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_bmb_button".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3771.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage1Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage1Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_1
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System
    /// experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
    /// for each active experiment, and the event 'value' will be the experiment ID
    /// This event was generated to correspond to the Legacy Telemetry event
    /// messaging_experiments.reach#fxms_message_1.
    pub static reach_fxms_message_1: Lazy<EventMetric<ReachFxmsMessage1Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_1".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3772.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage10Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage10Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_10
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System
    /// experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
    /// for each active experiment, and the event 'value' will be the experiment ID
    /// This event was generated to correspond to the Legacy Telemetry event
    /// messaging_experiments.reach#fxms_message_10.
    pub static reach_fxms_message_10: Lazy<EventMetric<ReachFxmsMessage10Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_10".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3773.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage11Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage11Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_11
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System
    /// experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
    /// for each active experiment, and the event 'value' will be the experiment ID
    /// This event was generated to correspond to the Legacy Telemetry event
    /// messaging_experiments.reach#fxms_message_11.
    pub static reach_fxms_message_11: Lazy<EventMetric<ReachFxmsMessage11Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_11".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3774.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage2Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_2
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System
    /// experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
    /// for each active experiment, and the event 'value' will be the experiment ID
    /// This event was generated to correspond to the Legacy Telemetry event
    /// messaging_experiments.reach#fxms_message_2.
    pub static reach_fxms_message_2: Lazy<EventMetric<ReachFxmsMessage2Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_2".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3775.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage3Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage3Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_3
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System
    /// experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
    /// for each active experiment, and the event 'value' will be the experiment ID
    /// This event was generated to correspond to the Legacy Telemetry event
    /// messaging_experiments.reach#fxms_message_3.
    pub static reach_fxms_message_3: Lazy<EventMetric<ReachFxmsMessage3Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_3".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3776.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage4Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage4Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_4
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System
    /// experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
    /// for each active experiment, and the event 'value' will be the experiment ID
    /// This event was generated to correspond to the Legacy Telemetry event
    /// messaging_experiments.reach#fxms_message_4.
    pub static reach_fxms_message_4: Lazy<EventMetric<ReachFxmsMessage4Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_4".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3777.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage5Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage5Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_5
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System
    /// experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
    /// for each active experiment, and the event 'value' will be the experiment ID
    /// This event was generated to correspond to the Legacy Telemetry event
    /// messaging_experiments.reach#fxms_message_5.
    pub static reach_fxms_message_5: Lazy<EventMetric<ReachFxmsMessage5Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_5".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3778.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage6Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage6Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_6
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System
    /// experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
    /// for each active experiment, and the event 'value' will be the experiment ID
    /// This event was generated to correspond to the Legacy Telemetry event
    /// messaging_experiments.reach#fxms_message_6.
    pub static reach_fxms_message_6: Lazy<EventMetric<ReachFxmsMessage6Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_6".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3779.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage7Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage7Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_7
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System
    /// experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
    /// for each active experiment, and the event 'value' will be the experiment ID
    /// This event was generated to correspond to the Legacy Telemetry event
    /// messaging_experiments.reach#fxms_message_7.
    pub static reach_fxms_message_7: Lazy<EventMetric<ReachFxmsMessage7Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_7".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3780.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage8Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage8Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_8
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System
    /// experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
    /// for each active experiment, and the event 'value' will be the experiment ID
    /// This event was generated to correspond to the Legacy Telemetry event
    /// messaging_experiments.reach#fxms_message_8.
    pub static reach_fxms_message_8: Lazy<EventMetric<ReachFxmsMessage8Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_8".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3781.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage9Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage9Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_9
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System
    /// experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
    /// for each active experiment, and the event 'value' will be the experiment ID
    /// This event was generated to correspond to the Legacy Telemetry event
    /// messaging_experiments.reach#fxms_message_9.
    pub static reach_fxms_message_9: Lazy<EventMetric<ReachFxmsMessage9Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_9".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3782.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachInfobarExtra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachInfobarExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_infobar
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System
    /// experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
    /// for each active experiment, and the event 'value' will be the experiment ID
    /// This event was generated to correspond to the Legacy Telemetry event
    /// messaging_experiments.reach#infobar.
    pub static reach_infobar: Lazy<EventMetric<ReachInfobarExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_infobar".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3783.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachMomentsPageExtra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachMomentsPageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_moments_page
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System
    /// experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
    /// for each active experiment, and the event 'value' will be the experiment ID
    /// This event was generated to correspond to the Legacy Telemetry event
    /// messaging_experiments.reach#moments_page.
    pub static reach_moments_page: Lazy<EventMetric<ReachMomentsPageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_moments_page".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3784.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachSpotlightExtra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachSpotlightExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_spotlight
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System
    /// experiments. All qualified branch ID(s) will be recorded in the 'extra_keys'
    /// for each active experiment, and the event 'value' will be the experiment ID
    /// This event was generated to correspond to the Legacy Telemetry event
    /// messaging_experiments.reach#spotlight.
    pub static reach_spotlight: Lazy<EventMetric<ReachSpotlightExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_spotlight".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3785.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TargetingAttributeErrorExtra {
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for TargetingAttributeErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.targeting_attribute_error
    ///
    /// Record generic JEXL errors that result from issues with experiment or message
    /// targeting expressions. The value field contains the namespace and attribute
    /// name that caused the error. This event was generated to correspond to the
    /// Legacy Telemetry event messaging_experiments.targeting#attribute_error.
    pub static targeting_attribute_error: Lazy<EventMetric<TargetingAttributeErrorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "targeting_attribute_error".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3786.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TargetingAttributeTimeoutExtra {
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for TargetingAttributeTimeoutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.targeting_attribute_timeout
    ///
    /// Record generic JEXL errors that result from issues with experiment or message
    /// targeting expressions. The value field contains the namespace and attribute
    /// name that caused the error. This event was generated to correspond to the
    /// Legacy Telemetry event messaging_experiments.targeting#attribute_timeout.
    pub static targeting_attribute_timeout: Lazy<EventMetric<TargetingAttributeTimeoutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "targeting_attribute_timeout".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3787.into(), meta)
    });

}
pub mod nimbus_events {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollFailedExtra {
        pub r#branch: Option<String>,
        pub r#experiment: Option<String>,
        pub r#reason: Option<String>,
    }

    impl ExtraKeys for EnrollFailedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "experiment", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.enroll_failed
    ///
    /// Recorded when an enrollment fails, including the reason for the failure.
    pub static enroll_failed: Lazy<EventMetric<EnrollFailedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_failed".into(),
                category: "nimbus_events".into(),
                send_in_pings: vec!["background-update".into(), "events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3788.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollmentExtra {
        pub r#branch: Option<String>,
        pub r#experiment: Option<String>,
        pub r#experiment_type: Option<String>,
    }

    impl ExtraKeys for EnrollmentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "experiment", "experiment_type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.r#experiment_type.and_then(|val| map.insert("experiment_type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.enrollment
    ///
    /// Recorded when a user has met the conditions and is first bucketed into an
    /// experiment (i.e. targeting matched and they were randomized into a bucket and
    /// branch of the experiment). Expected a maximum of once per experiment per user.
    pub static enrollment: Lazy<EventMetric<EnrollmentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enrollment".into(),
                category: "nimbus_events".into(),
                send_in_pings: vec!["background-update".into(), "events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3789.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollmentStatusExtra {
        pub r#branch: Option<String>,
        pub r#conflict_slug: Option<String>,
        pub r#error_string: Option<String>,
        pub r#reason: Option<String>,
        pub r#slug: Option<String>,
        pub r#status: Option<String>,
    }

    impl ExtraKeys for EnrollmentStatusExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "conflict_slug", "error_string", "reason", "slug", "status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#conflict_slug.and_then(|val| map.insert("conflict_slug".into(), val.to_string()));
          self.r#error_string.and_then(|val| map.insert("error_string".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#slug.and_then(|val| map.insert("slug".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.enrollment_status
    ///
    /// Recorded for each enrollment status each time the SDK completes application of
    /// pending experiments.
    pub static enrollment_status: Lazy<EventMetric<EnrollmentStatusExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enrollment_status".into(),
                category: "nimbus_events".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: true,
                ..Default::default()
            };
        EventMetric::new(3790.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExposureExtra {
        pub r#branch: Option<String>,
        pub r#experiment: Option<String>,
        pub r#feature_id: Option<String>,
    }

    impl ExtraKeys for ExposureExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "experiment", "feature_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.r#feature_id.and_then(|val| map.insert("feature_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.exposure
    ///
    /// Recorded when a user actually observes an experimental treatment, or would have
    /// observed an experimental treatment if they had been in a branch that would have
    /// shown one.
    pub static exposure: Lazy<EventMetric<ExposureExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exposure".into(),
                category: "nimbus_events".into(),
                send_in_pings: vec!["background-update".into(), "events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3791.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.is_ready
    ///
    /// An event sent when Nimbus is ready — sent upon completion of each update of the
    /// recipes.
    pub static is_ready: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_ready".into(),
                category: "nimbus_events".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3792.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollFailedExtra {
        pub r#experiment: Option<String>,
        pub r#reason: Option<String>,
    }

    impl ExtraKeys for UnenrollFailedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["experiment", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.unenroll_failed
    ///
    /// Recorded when an unenrollment fails, including the reason for the failure.
    pub static unenroll_failed: Lazy<EventMetric<UnenrollFailedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenroll_failed".into(),
                category: "nimbus_events".into(),
                send_in_pings: vec!["background-update".into(), "events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3793.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollmentExtra {
        pub r#branch: Option<String>,
        pub r#changed_pref: Option<String>,
        pub r#conflicting_slug: Option<String>,
        pub r#experiment: Option<String>,
        pub r#pref_name: Option<String>,
        pub r#pref_type: Option<String>,
        pub r#reason: Option<String>,
    }

    impl ExtraKeys for UnenrollmentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "changed_pref", "conflicting_slug", "experiment", "pref_name", "pref_type", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#changed_pref.and_then(|val| map.insert("changed_pref".into(), val.to_string()));
          self.r#conflicting_slug.and_then(|val| map.insert("conflicting_slug".into(), val.to_string()));
          self.r#experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.r#pref_name.and_then(|val| map.insert("pref_name".into(), val.to_string()));
          self.r#pref_type.and_then(|val| map.insert("pref_type".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.unenrollment
    ///
    /// Recorded when either telemetry is disabled, or the experiment has run for its
    /// designed duration (i.e. it is no longer present in the Nimbus Remote Settings
    /// collection)
    pub static unenrollment: Lazy<EventMetric<UnenrollmentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenrollment".into(),
                category: "nimbus_events".into(),
                send_in_pings: vec!["background-update".into(), "events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3794.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ValidationFailedExtra {
        pub r#branch: Option<String>,
        pub r#experiment: Option<String>,
        pub r#feature: Option<String>,
        pub r#l10n_ids: Option<String>,
        pub r#locale: Option<String>,
        pub r#reason: Option<String>,
    }

    impl ExtraKeys for ValidationFailedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "experiment", "feature", "l10n_ids", "locale", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.r#feature.and_then(|val| map.insert("feature".into(), val.to_string()));
          self.r#l10n_ids.and_then(|val| map.insert("l10n_ids".into(), val.to_string()));
          self.r#locale.and_then(|val| map.insert("locale".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.validation_failed
    ///
    /// This records when validation of a recipe fails.
    pub static validation_failed: Lazy<EventMetric<ValidationFailedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "validation_failed".into(),
                category: "nimbus_events".into(),
                send_in_pings: vec!["background-update".into(), "events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3795.into(), meta)
    });

}
pub mod normandy {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExposeNimbusExperimentExtra {
        pub r#branchSlug: Option<String>,
        pub r#featureId: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ExposeNimbusExperimentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branchSlug", "featureId", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branchSlug.and_then(|val| map.insert("branchSlug".into(), val.to_string()));
          self.r#featureId.and_then(|val| map.insert("featureId".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.expose_nimbus_experiment
    ///
    /// This records an event at the moment the user is exposed to an experiment
    /// treatment. The event is triggered either by the code checking that a certain
    /// experiment feature is enabled or when that feature value is used. This is
    /// different from enrollment or experiment activation because it registers when a
    /// user actually gets exposed to the experiment feature. This event was generated
    /// to correspond to the Legacy Telemetry event normandy.expose#nimbus_experiment.
    pub static expose_nimbus_experiment: Lazy<EventMetric<ExposeNimbusExperimentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "expose_nimbus_experiment".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3796.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollAddonRolloutExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#experimentType: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnrollAddonRolloutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "experimentType", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#experimentType.and_then(|val| map.insert("experimentType".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.enroll_addon_rollout
    ///
    /// Sent when applying a Normandy recipe of the above types has succeeded. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// normandy.enroll#addon_rollout.
    pub static enroll_addon_rollout: Lazy<EventMetric<EnrollAddonRolloutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_addon_rollout".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3797.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollAddonStudyExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#experimentType: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnrollAddonStudyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "experimentType", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#experimentType.and_then(|val| map.insert("experimentType".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.enroll_addon_study
    ///
    /// Sent when applying a Normandy recipe of the above types has succeeded. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// normandy.enroll#addon_study.
    pub static enroll_addon_study: Lazy<EventMetric<EnrollAddonStudyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_addon_study".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3798.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollFailedAddonRolloutExtra {
        pub r#addonId: Option<String>,
        pub r#branch: Option<String>,
        pub r#conflictingSlug: Option<String>,
        pub r#detail: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#prefBranch: Option<String>,
        pub r#preference: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnrollFailedAddonRolloutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "branch", "conflictingSlug", "detail", "enrollmentId", "prefBranch", "preference", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#conflictingSlug.and_then(|val| map.insert("conflictingSlug".into(), val.to_string()));
          self.r#detail.and_then(|val| map.insert("detail".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#prefBranch.and_then(|val| map.insert("prefBranch".into(), val.to_string()));
          self.r#preference.and_then(|val| map.insert("preference".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.enroll_failed_addon_rollout
    ///
    /// Sent when applying a Normandy recipe of the above types has failed. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// normandy.enrollFailed#addon_rollout.
    pub static enroll_failed_addon_rollout: Lazy<EventMetric<EnrollFailedAddonRolloutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_failed_addon_rollout".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3799.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollFailedAddonStudyExtra {
        pub r#addonId: Option<String>,
        pub r#branch: Option<String>,
        pub r#conflictingSlug: Option<String>,
        pub r#detail: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#prefBranch: Option<String>,
        pub r#preference: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnrollFailedAddonStudyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "branch", "conflictingSlug", "detail", "enrollmentId", "prefBranch", "preference", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#conflictingSlug.and_then(|val| map.insert("conflictingSlug".into(), val.to_string()));
          self.r#detail.and_then(|val| map.insert("detail".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#prefBranch.and_then(|val| map.insert("prefBranch".into(), val.to_string()));
          self.r#preference.and_then(|val| map.insert("preference".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.enroll_failed_addon_study
    ///
    /// Sent when applying a Normandy recipe of the above types has failed. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// normandy.enrollFailed#addon_study.
    pub static enroll_failed_addon_study: Lazy<EventMetric<EnrollFailedAddonStudyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_failed_addon_study".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3800.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollFailedNimbusExperimentExtra {
        pub r#addonId: Option<String>,
        pub r#branch: Option<String>,
        pub r#conflictingSlug: Option<String>,
        pub r#detail: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#prefBranch: Option<String>,
        pub r#preference: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnrollFailedNimbusExperimentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "branch", "conflictingSlug", "detail", "enrollmentId", "prefBranch", "preference", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#conflictingSlug.and_then(|val| map.insert("conflictingSlug".into(), val.to_string()));
          self.r#detail.and_then(|val| map.insert("detail".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#prefBranch.and_then(|val| map.insert("prefBranch".into(), val.to_string()));
          self.r#preference.and_then(|val| map.insert("preference".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.enroll_failed_nimbus_experiment
    ///
    /// Sent when applying a Normandy recipe of the above types has failed. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// normandy.enrollFailed#nimbus_experiment.
    pub static enroll_failed_nimbus_experiment: Lazy<EventMetric<EnrollFailedNimbusExperimentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_failed_nimbus_experiment".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3801.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollFailedPreferenceRolloutExtra {
        pub r#addonId: Option<String>,
        pub r#branch: Option<String>,
        pub r#conflictingSlug: Option<String>,
        pub r#detail: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#prefBranch: Option<String>,
        pub r#preference: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnrollFailedPreferenceRolloutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "branch", "conflictingSlug", "detail", "enrollmentId", "prefBranch", "preference", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#conflictingSlug.and_then(|val| map.insert("conflictingSlug".into(), val.to_string()));
          self.r#detail.and_then(|val| map.insert("detail".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#prefBranch.and_then(|val| map.insert("prefBranch".into(), val.to_string()));
          self.r#preference.and_then(|val| map.insert("preference".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.enroll_failed_preference_rollout
    ///
    /// Sent when applying a Normandy recipe of the above types has failed. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// normandy.enrollFailed#preference_rollout.
    pub static enroll_failed_preference_rollout: Lazy<EventMetric<EnrollFailedPreferenceRolloutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_failed_preference_rollout".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3802.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollFailedPreferenceStudyExtra {
        pub r#addonId: Option<String>,
        pub r#branch: Option<String>,
        pub r#conflictingSlug: Option<String>,
        pub r#detail: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#prefBranch: Option<String>,
        pub r#preference: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnrollFailedPreferenceStudyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "branch", "conflictingSlug", "detail", "enrollmentId", "prefBranch", "preference", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#conflictingSlug.and_then(|val| map.insert("conflictingSlug".into(), val.to_string()));
          self.r#detail.and_then(|val| map.insert("detail".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#prefBranch.and_then(|val| map.insert("prefBranch".into(), val.to_string()));
          self.r#preference.and_then(|val| map.insert("preference".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.enroll_failed_preference_study
    ///
    /// Sent when applying a Normandy recipe of the above types has failed. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// normandy.enrollFailed#preference_study.
    pub static enroll_failed_preference_study: Lazy<EventMetric<EnrollFailedPreferenceStudyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_failed_preference_study".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3803.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollNimbusExperimentExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#experimentType: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnrollNimbusExperimentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "experimentType", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#experimentType.and_then(|val| map.insert("experimentType".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.enroll_nimbus_experiment
    ///
    /// Sent when applying a Normandy recipe of the above types has succeeded. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// normandy.enroll#nimbus_experiment.
    pub static enroll_nimbus_experiment: Lazy<EventMetric<EnrollNimbusExperimentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_nimbus_experiment".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3804.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollPreferenceRolloutExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#experimentType: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnrollPreferenceRolloutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "experimentType", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#experimentType.and_then(|val| map.insert("experimentType".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.enroll_preference_rollout
    ///
    /// Sent when applying a Normandy recipe of the above types has succeeded. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// normandy.enroll#preference_rollout.
    pub static enroll_preference_rollout: Lazy<EventMetric<EnrollPreferenceRolloutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_preference_rollout".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3805.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollPreferenceStudyExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#experimentType: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnrollPreferenceStudyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "experimentType", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#experimentType.and_then(|val| map.insert("experimentType".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.enroll_preference_study
    ///
    /// Sent when applying a Normandy recipe of the above types has succeeded. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// normandy.enroll#preference_study.
    pub static enroll_preference_study: Lazy<EventMetric<EnrollPreferenceStudyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_preference_study".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3806.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExpPrefChangedPreferenceStudyExtra {
        pub r#enrollmentId: Option<String>,
        pub r#preferenceName: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ExpPrefChangedPreferenceStudyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["enrollmentId", "preferenceName", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#preferenceName.and_then(|val| map.insert("preferenceName".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.exp_pref_changed_preference_study
    ///
    /// This records that a preference that was set by an experiment has been changed
    /// away from its experimental value. This can be triggered by a user changing a
    /// preference at runtime, by the preference being changed on disk when Firefox is
    /// not running, or by the preference already having a user-set value when a user
    /// has enrolls in a default branch experiment. This event was generated to
    /// correspond to the Legacy Telemetry event
    /// normandy.expPrefChanged#preference_study.
    pub static exp_pref_changed_preference_study: Lazy<EventMetric<ExpPrefChangedPreferenceStudyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exp_pref_changed_preference_study".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3807.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct GraduatePreferenceRolloutExtra {
        pub r#enrollmentId: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for GraduatePreferenceRolloutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["enrollmentId", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.graduate_preference_rollout
    ///
    /// Sent when a preference rollout ends due to the rolled-out preference becoming a
    /// new default. This event was generated to correspond to the Legacy Telemetry
    /// event normandy.graduate#preference_rollout.
    pub static graduate_preference_rollout: Lazy<EventMetric<GraduatePreferenceRolloutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "graduate_preference_rollout".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3808.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollAddonRollbackExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#changedPref: Option<String>,
        pub r#conflictingSlug: Option<String>,
        pub r#didResetValue: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#prefName: Option<String>,
        pub r#prefType: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnenrollAddonRollbackExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "changedPref", "conflictingSlug", "didResetValue", "enrollmentId", "prefName", "prefType", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#changedPref.and_then(|val| map.insert("changedPref".into(), val.to_string()));
          self.r#conflictingSlug.and_then(|val| map.insert("conflictingSlug".into(), val.to_string()));
          self.r#didResetValue.and_then(|val| map.insert("didResetValue".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#prefName.and_then(|val| map.insert("prefName".into(), val.to_string()));
          self.r#prefType.and_then(|val| map.insert("prefType".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.unenroll_addon_rollback
    ///
    /// Sent when a Normandy recipe of certain types "ends".  N.B. For
    /// preference_rollback, this is fired when the recipe is fired (the recipe that
    /// "ends" is a corresponding preference_rollout). This event was generated to
    /// correspond to the Legacy Telemetry event normandy.unenroll#addon_rollback.
    pub static unenroll_addon_rollback: Lazy<EventMetric<UnenrollAddonRollbackExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenroll_addon_rollback".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3809.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollAddonStudyExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#changedPref: Option<String>,
        pub r#conflictingSlug: Option<String>,
        pub r#didResetValue: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#prefName: Option<String>,
        pub r#prefType: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnenrollAddonStudyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "changedPref", "conflictingSlug", "didResetValue", "enrollmentId", "prefName", "prefType", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#changedPref.and_then(|val| map.insert("changedPref".into(), val.to_string()));
          self.r#conflictingSlug.and_then(|val| map.insert("conflictingSlug".into(), val.to_string()));
          self.r#didResetValue.and_then(|val| map.insert("didResetValue".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#prefName.and_then(|val| map.insert("prefName".into(), val.to_string()));
          self.r#prefType.and_then(|val| map.insert("prefType".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.unenroll_addon_study
    ///
    /// Sent when a Normandy recipe of certain types "ends".  N.B. For
    /// preference_rollback, this is fired when the recipe is fired (the recipe that
    /// "ends" is a corresponding preference_rollout). This event was generated to
    /// correspond to the Legacy Telemetry event normandy.unenroll#addon_study.
    pub static unenroll_addon_study: Lazy<EventMetric<UnenrollAddonStudyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenroll_addon_study".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3810.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollFailedAddonRollbackExtra {
        pub r#caller: Option<String>,
        pub r#changedPref: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#originalReason: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnenrollFailedAddonRollbackExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["caller", "changedPref", "enrollmentId", "originalReason", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#caller.and_then(|val| map.insert("caller".into(), val.to_string()));
          self.r#changedPref.and_then(|val| map.insert("changedPref".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#originalReason.and_then(|val| map.insert("originalReason".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.unenroll_failed_addon_rollback
    ///
    /// Sent when unenrolling a user fails (see the unenroll event). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// normandy.unenrollFailed#addon_rollback.
    pub static unenroll_failed_addon_rollback: Lazy<EventMetric<UnenrollFailedAddonRollbackExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenroll_failed_addon_rollback".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3811.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollFailedNimbusExperimentExtra {
        pub r#caller: Option<String>,
        pub r#changedPref: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#originalReason: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnenrollFailedNimbusExperimentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["caller", "changedPref", "enrollmentId", "originalReason", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#caller.and_then(|val| map.insert("caller".into(), val.to_string()));
          self.r#changedPref.and_then(|val| map.insert("changedPref".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#originalReason.and_then(|val| map.insert("originalReason".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.unenroll_failed_nimbus_experiment
    ///
    /// Sent when unenrolling a user fails (see the unenroll event). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// normandy.unenrollFailed#nimbus_experiment.
    pub static unenroll_failed_nimbus_experiment: Lazy<EventMetric<UnenrollFailedNimbusExperimentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenroll_failed_nimbus_experiment".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3812.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollFailedPreferenceRollbackExtra {
        pub r#caller: Option<String>,
        pub r#changedPref: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#originalReason: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnenrollFailedPreferenceRollbackExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["caller", "changedPref", "enrollmentId", "originalReason", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#caller.and_then(|val| map.insert("caller".into(), val.to_string()));
          self.r#changedPref.and_then(|val| map.insert("changedPref".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#originalReason.and_then(|val| map.insert("originalReason".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.unenroll_failed_preference_rollback
    ///
    /// Sent when unenrolling a user fails (see the unenroll event). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// normandy.unenrollFailed#preference_rollback.
    pub static unenroll_failed_preference_rollback: Lazy<EventMetric<UnenrollFailedPreferenceRollbackExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenroll_failed_preference_rollback".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3813.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollFailedPreferenceStudyExtra {
        pub r#caller: Option<String>,
        pub r#changedPref: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#originalReason: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnenrollFailedPreferenceStudyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["caller", "changedPref", "enrollmentId", "originalReason", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#caller.and_then(|val| map.insert("caller".into(), val.to_string()));
          self.r#changedPref.and_then(|val| map.insert("changedPref".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#originalReason.and_then(|val| map.insert("originalReason".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.unenroll_failed_preference_study
    ///
    /// Sent when unenrolling a user fails (see the unenroll event). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// normandy.unenrollFailed#preference_study.
    pub static unenroll_failed_preference_study: Lazy<EventMetric<UnenrollFailedPreferenceStudyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenroll_failed_preference_study".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3814.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollNimbusExperimentExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#changedPref: Option<String>,
        pub r#conflictingSlug: Option<String>,
        pub r#didResetValue: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#prefName: Option<String>,
        pub r#prefType: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnenrollNimbusExperimentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "changedPref", "conflictingSlug", "didResetValue", "enrollmentId", "prefName", "prefType", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#changedPref.and_then(|val| map.insert("changedPref".into(), val.to_string()));
          self.r#conflictingSlug.and_then(|val| map.insert("conflictingSlug".into(), val.to_string()));
          self.r#didResetValue.and_then(|val| map.insert("didResetValue".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#prefName.and_then(|val| map.insert("prefName".into(), val.to_string()));
          self.r#prefType.and_then(|val| map.insert("prefType".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.unenroll_nimbus_experiment
    ///
    /// Sent when a Normandy recipe of certain types "ends".  N.B. For
    /// preference_rollback, this is fired when the recipe is fired (the recipe that
    /// "ends" is a corresponding preference_rollout). This event was generated to
    /// correspond to the Legacy Telemetry event normandy.unenroll#nimbus_experiment.
    pub static unenroll_nimbus_experiment: Lazy<EventMetric<UnenrollNimbusExperimentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenroll_nimbus_experiment".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3815.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollPreferenceRollbackExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#changedPref: Option<String>,
        pub r#conflictingSlug: Option<String>,
        pub r#didResetValue: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#prefName: Option<String>,
        pub r#prefType: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnenrollPreferenceRollbackExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "changedPref", "conflictingSlug", "didResetValue", "enrollmentId", "prefName", "prefType", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#changedPref.and_then(|val| map.insert("changedPref".into(), val.to_string()));
          self.r#conflictingSlug.and_then(|val| map.insert("conflictingSlug".into(), val.to_string()));
          self.r#didResetValue.and_then(|val| map.insert("didResetValue".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#prefName.and_then(|val| map.insert("prefName".into(), val.to_string()));
          self.r#prefType.and_then(|val| map.insert("prefType".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.unenroll_preference_rollback
    ///
    /// Sent when a Normandy recipe of certain types "ends".  N.B. For
    /// preference_rollback, this is fired when the recipe is fired (the recipe that
    /// "ends" is a corresponding preference_rollout). This event was generated to
    /// correspond to the Legacy Telemetry event normandy.unenroll#preference_rollback.
    pub static unenroll_preference_rollback: Lazy<EventMetric<UnenrollPreferenceRollbackExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenroll_preference_rollback".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3816.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollPreferenceStudyExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#changedPref: Option<String>,
        pub r#conflictingSlug: Option<String>,
        pub r#didResetValue: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#prefName: Option<String>,
        pub r#prefType: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnenrollPreferenceStudyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "changedPref", "conflictingSlug", "didResetValue", "enrollmentId", "prefName", "prefType", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#changedPref.and_then(|val| map.insert("changedPref".into(), val.to_string()));
          self.r#conflictingSlug.and_then(|val| map.insert("conflictingSlug".into(), val.to_string()));
          self.r#didResetValue.and_then(|val| map.insert("didResetValue".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#prefName.and_then(|val| map.insert("prefName".into(), val.to_string()));
          self.r#prefType.and_then(|val| map.insert("prefType".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.unenroll_preference_study
    ///
    /// Sent when a Normandy recipe of certain types "ends".  N.B. For
    /// preference_rollback, this is fired when the recipe is fired (the recipe that
    /// "ends" is a corresponding preference_rollout). This event was generated to
    /// correspond to the Legacy Telemetry event normandy.unenroll#preference_study.
    pub static unenroll_preference_study: Lazy<EventMetric<UnenrollPreferenceStudyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenroll_preference_study".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3817.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateAddonRolloutExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#previousState: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateAddonRolloutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "enrollmentId", "previousState", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#previousState.and_then(|val| map.insert("previousState".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.update_addon_rollout
    ///
    /// This event is fired when a client detects that a recipe of the ahove types has
    /// changed on the server, and the new version of the recipe is being applied over
    /// an existing, older version previously fetched from the server. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// normandy.update#addon_rollout.
    pub static update_addon_rollout: Lazy<EventMetric<UpdateAddonRolloutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_addon_rollout".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3818.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateAddonStudyExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#previousState: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateAddonStudyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "enrollmentId", "previousState", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#previousState.and_then(|val| map.insert("previousState".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.update_addon_study
    ///
    /// This event is fired when a client detects that a recipe of the ahove types has
    /// changed on the server, and the new version of the recipe is being applied over
    /// an existing, older version previously fetched from the server. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// normandy.update#addon_study.
    pub static update_addon_study: Lazy<EventMetric<UpdateAddonStudyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_addon_study".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3819.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateFailedAddonRolloutExtra {
        pub r#branch: Option<String>,
        pub r#detail: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateFailedAddonRolloutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "detail", "enrollmentId", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#detail.and_then(|val| map.insert("detail".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.update_failed_addon_rollout
    ///
    /// Sent when applying a new version of a Normandy recipe of the above types (over
    /// an existing, older version previously fetched from the server) has failed. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// normandy.updateFailed#addon_rollout.
    pub static update_failed_addon_rollout: Lazy<EventMetric<UpdateFailedAddonRolloutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_failed_addon_rollout".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3820.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateFailedAddonStudyExtra {
        pub r#branch: Option<String>,
        pub r#detail: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateFailedAddonStudyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "detail", "enrollmentId", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#detail.and_then(|val| map.insert("detail".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.update_failed_addon_study
    ///
    /// Sent when applying a new version of a Normandy recipe of the above types (over
    /// an existing, older version previously fetched from the server) has failed. This
    /// event was generated to correspond to the Legacy Telemetry event
    /// normandy.updateFailed#addon_study.
    pub static update_failed_addon_study: Lazy<EventMetric<UpdateFailedAddonStudyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_failed_addon_study".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3821.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateNimbusExperimentExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#previousState: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateNimbusExperimentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "enrollmentId", "previousState", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#previousState.and_then(|val| map.insert("previousState".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.update_nimbus_experiment
    ///
    /// This event is fired when a client detects that a recipe of the ahove types has
    /// changed on the server, and the new version of the recipe is being applied over
    /// an existing, older version previously fetched from the server. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// normandy.update#nimbus_experiment.
    pub static update_nimbus_experiment: Lazy<EventMetric<UpdateNimbusExperimentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_nimbus_experiment".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3822.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdatePreferenceRolloutExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#previousState: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdatePreferenceRolloutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "enrollmentId", "previousState", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#previousState.and_then(|val| map.insert("previousState".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.update_preference_rollout
    ///
    /// This event is fired when a client detects that a recipe of the ahove types has
    /// changed on the server, and the new version of the recipe is being applied over
    /// an existing, older version previously fetched from the server. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// normandy.update#preference_rollout.
    pub static update_preference_rollout: Lazy<EventMetric<UpdatePreferenceRolloutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_preference_rollout".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3823.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ValidationFailedNimbusExperimentExtra {
        pub r#branch: Option<String>,
        pub r#feature: Option<String>,
        pub r#l10n_ids: Option<String>,
        pub r#locale: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ValidationFailedNimbusExperimentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "feature", "l10n_ids", "locale", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#feature.and_then(|val| map.insert("feature".into(), val.to_string()));
          self.r#l10n_ids.and_then(|val| map.insert("l10n_ids".into(), val.to_string()));
          self.r#locale.and_then(|val| map.insert("locale".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.validation_failed_nimbus_experiment
    ///
    /// This records when validation of a recipe fails. This event was generated to
    /// correspond to the Legacy Telemetry event
    /// normandy.validationFailed#nimbus_experiment.
    pub static validation_failed_nimbus_experiment: Lazy<EventMetric<ValidationFailedNimbusExperimentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "validation_failed_nimbus_experiment".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3824.into(), meta)
    });

}
pub mod form_autocomplete {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowLoginsExtra {
        pub r#acFieldName: Option<String>,
        pub r#fieldType: Option<String>,
        pub r#generatedPasswo: Option<String>,
        pub r#hadPrevious: Option<String>,
        pub r#importableLogin: Option<String>,
        pub r#insecureWarning: Option<String>,
        pub r#login: Option<String>,
        pub r#loginsFooter: Option<String>,
        pub r#stringLength: Option<String>,
        pub r#typeWasPassword: Option<String>,
        pub r#value: Option<u32>,
    }

    impl ExtraKeys for ShowLoginsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["acFieldName", "fieldType", "generatedPasswo", "hadPrevious", "importableLogin", "insecureWarning", "login", "loginsFooter", "stringLength", "typeWasPassword", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#acFieldName.and_then(|val| map.insert("acFieldName".into(), val.to_string()));
          self.r#fieldType.and_then(|val| map.insert("fieldType".into(), val.to_string()));
          self.r#generatedPasswo.and_then(|val| map.insert("generatedPasswo".into(), val.to_string()));
          self.r#hadPrevious.and_then(|val| map.insert("hadPrevious".into(), val.to_string()));
          self.r#importableLogin.and_then(|val| map.insert("importableLogin".into(), val.to_string()));
          self.r#insecureWarning.and_then(|val| map.insert("insecureWarning".into(), val.to_string()));
          self.r#login.and_then(|val| map.insert("login".into(), val.to_string()));
          self.r#loginsFooter.and_then(|val| map.insert("loginsFooter".into(), val.to_string()));
          self.r#stringLength.and_then(|val| map.insert("stringLength".into(), val.to_string()));
          self.r#typeWasPassword.and_then(|val| map.insert("typeWasPassword".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from form_autocomplete.show_logins
    ///
    /// An content form autocomplete popup was shown. Details on the timing and context
    /// are provided. This event was generated to correspond to the Legacy Telemetry
    /// event form_autocomplete.show#logins.
    pub static show_logins: Lazy<EventMetric<ShowLoginsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_logins".into(),
                category: "form_autocomplete".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3825.into(), meta)
    });

}
pub mod pwmgr {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.autocomplete_field_generatedpassword
    ///
    /// "autocomplete_field": The first time each unique generated password is used to
    /// fill a login field - i.e. the user selects it from from the autocomplete
    /// dropdown on a password input "autocomplete_shown": The first time the password
    /// generation option is shown in the autocomplete dropdown on a password input for
    /// a site per session This event was generated to correspond to the Legacy
    /// Telemetry event pwmgr.autocomplete_field#generatedpassword.
    pub static autocomplete_field_generatedpassword: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "autocomplete_field_generatedpassword".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3826.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.autocomplete_shown_generatedpassword
    ///
    /// "autocomplete_field": The first time each unique generated password is used to
    /// fill a login field - i.e. the user selects it from from the autocomplete
    /// dropdown on a password input "autocomplete_shown": The first time the password
    /// generation option is shown in the autocomplete dropdown on a password input for
    /// a site per session This event was generated to correspond to the Legacy
    /// Telemetry event pwmgr.autocomplete_shown#generatedpassword.
    pub static autocomplete_shown_generatedpassword: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "autocomplete_shown_generatedpassword".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3827.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CancelExistingLoginExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for CancelExistingLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.cancel_existing_login
    ///
    /// These events record interactions on the about:logins page. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pwmgr.cancel#existing_login.
    pub static cancel_existing_login: Lazy<EventMetric<CancelExistingLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel_existing_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3828.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CancelNewLoginExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for CancelNewLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.cancel_new_login
    ///
    /// These events record interactions on the about:logins page. This event was
    /// generated to correspond to the Legacy Telemetry event pwmgr.cancel#new_login.
    pub static cancel_new_login: Lazy<EventMetric<CancelNewLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel_new_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3829.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CopyPasswordExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for CopyPasswordExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.copy_password
    ///
    /// These events record interactions on the about:logins page. This event was
    /// generated to correspond to the Legacy Telemetry event pwmgr.copy#password.
    pub static copy_password: Lazy<EventMetric<CopyPasswordExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "copy_password".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3830.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CopyUsernameExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for CopyUsernameExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.copy_username
    ///
    /// These events record interactions on the about:logins page. This event was
    /// generated to correspond to the Legacy Telemetry event pwmgr.copy#username.
    pub static copy_username: Lazy<EventMetric<CopyUsernameExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "copy_username".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3831.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DeleteExistingLoginExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for DeleteExistingLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.delete_existing_login
    ///
    /// These events record interactions on the about:logins page. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pwmgr.delete#existing_login.
    pub static delete_existing_login: Lazy<EventMetric<DeleteExistingLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "delete_existing_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3832.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DeleteNewLoginExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for DeleteNewLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.delete_new_login
    ///
    /// These events record interactions on the about:logins page. This event was
    /// generated to correspond to the Legacy Telemetry event pwmgr.delete#new_login.
    pub static delete_new_login: Lazy<EventMetric<DeleteNewLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "delete_new_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3833.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DoorhangerSubmittedSaveExtra {
        pub r#did_edit_pw: Option<bool>,
        pub r#did_edit_un: Option<bool>,
        pub r#did_select_pw: Option<bool>,
        pub r#did_select_un: Option<bool>,
    }

    impl ExtraKeys for DoorhangerSubmittedSaveExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["did_edit_pw", "did_edit_un", "did_select_pw", "did_select_un"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#did_edit_pw.and_then(|val| map.insert("did_edit_pw".into(), val.to_string()));
          self.r#did_edit_un.and_then(|val| map.insert("did_edit_un".into(), val.to_string()));
          self.r#did_select_pw.and_then(|val| map.insert("did_select_pw".into(), val.to_string()));
          self.r#did_select_un.and_then(|val| map.insert("did_select_un".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.doorhanger_submitted_save
    ///
    /// A login is saved or updated via the capture doorhanger. Carries information
    /// about whether the username and password _that were saved/updated by the user_
    /// were modified in the doorhanger, selected from the suggestion autocomplete, or
    /// neither. `did_edit_X` and `did_select_X` will never both be true in the same
    /// event. The `object` describes the type of doorhanger when it was originally
    /// created. Note that user updates to the doorhanger may change whether a login is
    /// actually saved or updated, but will not impact the sent object. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pwmgr.doorhanger_submitted#save.
    pub static doorhanger_submitted_save: Lazy<EventMetric<DoorhangerSubmittedSaveExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "doorhanger_submitted_save".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3834.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DoorhangerSubmittedUpdateExtra {
        pub r#did_edit_pw: Option<bool>,
        pub r#did_edit_un: Option<bool>,
        pub r#did_select_pw: Option<bool>,
        pub r#did_select_un: Option<bool>,
    }

    impl ExtraKeys for DoorhangerSubmittedUpdateExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["did_edit_pw", "did_edit_un", "did_select_pw", "did_select_un"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#did_edit_pw.and_then(|val| map.insert("did_edit_pw".into(), val.to_string()));
          self.r#did_edit_un.and_then(|val| map.insert("did_edit_un".into(), val.to_string()));
          self.r#did_select_pw.and_then(|val| map.insert("did_select_pw".into(), val.to_string()));
          self.r#did_select_un.and_then(|val| map.insert("did_select_un".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.doorhanger_submitted_update
    ///
    /// A login is saved or updated via the capture doorhanger. Carries information
    /// about whether the username and password _that were saved/updated by the user_
    /// were modified in the doorhanger, selected from the suggestion autocomplete, or
    /// neither. `did_edit_X` and `did_select_X` will never both be true in the same
    /// event. The `object` describes the type of doorhanger when it was originally
    /// created. Note that user updates to the doorhanger may change whether a login is
    /// actually saved or updated, but will not impact the sent object. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pwmgr.doorhanger_submitted#update.
    pub static doorhanger_submitted_update: Lazy<EventMetric<DoorhangerSubmittedUpdateExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "doorhanger_submitted_update".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3835.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EditExistingLoginExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for EditExistingLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.edit_existing_login
    ///
    /// These events record interactions on the about:logins page. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pwmgr.edit#existing_login.
    pub static edit_existing_login: Lazy<EventMetric<EditExistingLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "edit_existing_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3836.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.filled_field_edited_generatedpassword
    ///
    /// The first time each generated password filled in a website form field is edited
    /// by the user in a field it was filled in This event was generated to correspond
    /// to the Legacy Telemetry event pwmgr.filled_field_edited#generatedpassword.
    pub static filled_field_edited_generatedpassword: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "filled_field_edited_generatedpassword".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3837.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.filter_list
    ///
    /// These events record interactions on the about:logins page. This event was
    /// generated to correspond to the Legacy Telemetry event pwmgr.filter#list.
    pub static filter_list: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "filter_list".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3838.into(), meta)
    });

    #[repr(u16)]
    pub enum FormAutofillResultLabel {
        EFilled = 0,
        ENoPasswordField = 1,
        EPasswordDisabledReadonly = 2,
        ENoLoginsFit = 3,
        ENoSavedLogins = 4,
        EExistingPassword = 5,
        EExistingUsername = 6,
        EMultipleLogins = 7,
        ENoAutofillForms = 8,
        EAutocompleteOff = 9,
        EInsecure = 10,
        EPasswordAutocompleteNewPassword = 11,
        ETypeNoLongerPassword = 12,
        EFormInCrossoriginSubframe = 13,
        EFilledUsernameOnlyForm = 14,
        __Other__,
    }
    impl From<u16> for FormAutofillResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFilled,
                1 => Self::ENoPasswordField,
                2 => Self::EPasswordDisabledReadonly,
                3 => Self::ENoLoginsFit,
                4 => Self::ENoSavedLogins,
                5 => Self::EExistingPassword,
                6 => Self::EExistingUsername,
                7 => Self::EMultipleLogins,
                8 => Self::ENoAutofillForms,
                9 => Self::EAutocompleteOff,
                10 => Self::EInsecure,
                11 => Self::EPasswordAutocompleteNewPassword,
                12 => Self::ETypeNoLongerPassword,
                13 => Self::EFormInCrossoriginSubframe,
                14 => Self::EFilledUsernameOnlyForm,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FormAutofillResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFilled => "filled",
                Self::ENoPasswordField => "no_password_field",
                Self::EPasswordDisabledReadonly => "password_disabled_readonly",
                Self::ENoLoginsFit => "no_logins_fit",
                Self::ENoSavedLogins => "no_saved_logins",
                Self::EExistingPassword => "existing_password",
                Self::EExistingUsername => "existing_username",
                Self::EMultipleLogins => "multiple_logins",
                Self::ENoAutofillForms => "no_autofill_forms",
                Self::EAutocompleteOff => "autocomplete_off",
                Self::EInsecure => "insecure",
                Self::EPasswordAutocompleteNewPassword => "password_autocomplete_new_password",
                Self::ETypeNoLongerPassword => "type_no_longer_password",
                Self::EFormInCrossoriginSubframe => "form_in_crossorigin_subframe",
                Self::EFilledUsernameOnlyForm => "filled_username_only_form",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.form_autofill_result
    ///
    /// The result of auto-filling a login form.
    pub static form_autofill_result: Lazy<LabeledMetric<LabeledCounterMetric, FormAutofillResultLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "form_autofill_result".into(),
                    category: "pwmgr".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3839.into(), meta, Some(vec![::std::borrow::Cow::from("autocomplete_off"), ::std::borrow::Cow::from("existing_password"), ::std::borrow::Cow::from("existing_username"), ::std::borrow::Cow::from("filled"), ::std::borrow::Cow::from("filled_username_only_form"), ::std::borrow::Cow::from("form_in_crossorigin_subframe"), ::std::borrow::Cow::from("insecure"), ::std::borrow::Cow::from("multiple_logins"), ::std::borrow::Cow::from("no_autofill_forms"), ::std::borrow::Cow::from("no_logins_fit"), ::std::borrow::Cow::from("no_password_field"), ::std::borrow::Cow::from("no_saved_logins"), ::std::borrow::Cow::from("password_autocomplete_new_password"), ::std::borrow::Cow::from("password_disabled_readonly"), ::std::borrow::Cow::from("type_no_longer_password")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct HidePasswordExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for HidePasswordExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.hide_password
    ///
    /// These events record interactions on the about:logins page. This event was
    /// generated to correspond to the Legacy Telemetry event pwmgr.hide#password.
    pub static hide_password: Lazy<EventMetric<HidePasswordExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "hide_password".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3840.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LearnMoreVulnExistingLoginExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for LearnMoreVulnExistingLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.learn_more_vuln_existing_login
    ///
    /// These events record interactions on the about:logins page. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pwmgr.learn_more_vuln#existing_login.
    pub static learn_more_vuln_existing_login: Lazy<EventMetric<LearnMoreVulnExistingLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "learn_more_vuln_existing_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3841.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.mgmt_menu_item_used_export
    ///
    /// Record interactions with the about:logins menu. This event was generated to
    /// correspond to the Legacy Telemetry event pwmgr.mgmt_menu_item_used#export.
    pub static mgmt_menu_item_used_export: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mgmt_menu_item_used_export".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3842.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.mgmt_menu_item_used_export_complete
    ///
    /// Record interactions with the about:logins menu. This event was generated to
    /// correspond to the Legacy Telemetry event
    /// pwmgr.mgmt_menu_item_used#export_complete.
    pub static mgmt_menu_item_used_export_complete: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mgmt_menu_item_used_export_complete".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3843.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.mgmt_menu_item_used_import_csv_complete
    ///
    /// Record interactions with the about:logins menu. This event was generated to
    /// correspond to the Legacy Telemetry event
    /// pwmgr.mgmt_menu_item_used#import_csv_complete.
    pub static mgmt_menu_item_used_import_csv_complete: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mgmt_menu_item_used_import_csv_complete".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3844.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.mgmt_menu_item_used_import_from_browser
    ///
    /// Record interactions with the about:logins menu. This event was generated to
    /// correspond to the Legacy Telemetry event
    /// pwmgr.mgmt_menu_item_used#import_from_browser.
    pub static mgmt_menu_item_used_import_from_browser: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mgmt_menu_item_used_import_from_browser".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3845.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.mgmt_menu_item_used_import_from_csv
    ///
    /// Record interactions with the about:logins menu. This event was generated to
    /// correspond to the Legacy Telemetry event
    /// pwmgr.mgmt_menu_item_used#import_from_csv.
    pub static mgmt_menu_item_used_import_from_csv: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mgmt_menu_item_used_import_from_csv".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3846.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.mgmt_menu_item_used_preferences
    ///
    /// Record interactions with the about:logins menu. This event was generated to
    /// correspond to the Legacy Telemetry event pwmgr.mgmt_menu_item_used#preferences.
    pub static mgmt_menu_item_used_preferences: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mgmt_menu_item_used_preferences".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3847.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.new_new_login
    ///
    /// These events record interactions on the about:logins page. This event was
    /// generated to correspond to the Legacy Telemetry event pwmgr.new#new_login.
    pub static new_new_login: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "new_new_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3848.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.open_management_aboutprotections
    ///
    /// Sent when opening the password management UI. This event was generated to
    /// correspond to the Legacy Telemetry event
    /// pwmgr.open_management#aboutprotections.
    pub static open_management_aboutprotections: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_management_aboutprotections".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3849.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.open_management_autocomplete
    ///
    /// Sent when opening the password management UI. This event was generated to
    /// correspond to the Legacy Telemetry event pwmgr.open_management#autocomplete.
    pub static open_management_autocomplete: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_management_autocomplete".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3850.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.open_management_contextmenu
    ///
    /// Sent when opening the password management UI. This event was generated to
    /// correspond to the Legacy Telemetry event pwmgr.open_management#contextmenu.
    pub static open_management_contextmenu: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_management_contextmenu".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3851.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.open_management_direct
    ///
    /// Sent when opening the password management UI. This event was generated to
    /// correspond to the Legacy Telemetry event pwmgr.open_management#direct.
    pub static open_management_direct: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_management_direct".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3852.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.open_management_mainmenu
    ///
    /// Sent when opening the password management UI. This event was generated to
    /// correspond to the Legacy Telemetry event pwmgr.open_management#mainmenu.
    pub static open_management_mainmenu: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_management_mainmenu".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3853.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.open_management_pageinfo
    ///
    /// Sent when opening the password management UI. This event was generated to
    /// correspond to the Legacy Telemetry event pwmgr.open_management#pageinfo.
    pub static open_management_pageinfo: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_management_pageinfo".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3854.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.open_management_preferences
    ///
    /// Sent when opening the password management UI. This event was generated to
    /// correspond to the Legacy Telemetry event pwmgr.open_management#preferences.
    pub static open_management_preferences: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_management_preferences".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3855.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.open_management_snippet
    ///
    /// Sent when opening the password management UI. This event was generated to
    /// correspond to the Legacy Telemetry event pwmgr.open_management#snippet.
    pub static open_management_snippet: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_management_snippet".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3856.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenSiteExistingLoginExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for OpenSiteExistingLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.open_site_existing_login
    ///
    /// These events record interactions on the about:logins page. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pwmgr.open_site#existing_login.
    pub static open_site_existing_login: Lazy<EventMetric<OpenSiteExistingLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_site_existing_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3857.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.potentially_breached_passwords
    ///
    /// The number of potentially breached passwords, as determined by
    /// LoginBreaches.getPotentialBreachesByLoginGUID. This metric was generated to
    /// correspond to the Legacy Telemetry scalar pwmgr.potentially_breached_passwords.
    pub static potentially_breached_passwords: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "potentially_breached_passwords".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3858.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReauthenticateMasterPasswordExtra {
        pub r#auto_admin: Option<String>,
        pub r#require_signon: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReauthenticateMasterPasswordExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["auto_admin", "require_signon", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#auto_admin.and_then(|val| map.insert("auto_admin".into(), val.to_string()));
          self.r#require_signon.and_then(|val| map.insert("require_signon".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.reauthenticate_master_password
    ///
    /// Measure how often users are asked to authenticate with their Operating System
    /// or Master Password to gain access to stored passwords. Possible values are as
    /// follows,
    ///   "success" should be used when the user authenticates and provides a password
    /// or other authentication factor.
    ///   "success_no_prompt" should be used when the feature is enabled but no prompt
    /// is given to the user because they have recently authenticated.
    ///   "success_disabled" is used when the feature is disabled.
    ///   "success_unsupported_platform" should be set when the user attempts to
    /// authenticate on an unsupported platform.
    ///   "success_no_password" should be used when the user doesn't have an OS
    /// password set.
    ///   "fail" should be used when the user cancels the authentication prompt or an
    /// unexpected exception is encountered. The user may or may not have provided an
    /// incorrect password before cancelling.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// pwmgr.reauthenticate#master_password.
    pub static reauthenticate_master_password: Lazy<EventMetric<ReauthenticateMasterPasswordExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reauthenticate_master_password".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3859.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReauthenticateOsAuthExtra {
        pub r#auto_admin: Option<String>,
        pub r#require_signon: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReauthenticateOsAuthExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["auto_admin", "require_signon", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#auto_admin.and_then(|val| map.insert("auto_admin".into(), val.to_string()));
          self.r#require_signon.and_then(|val| map.insert("require_signon".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.reauthenticate_os_auth
    ///
    /// Measure how often users are asked to authenticate with their Operating System
    /// or Master Password to gain access to stored passwords. Possible values are as
    /// follows,
    ///   "success" should be used when the user authenticates and provides a password
    /// or other authentication factor.
    ///   "success_no_prompt" should be used when the feature is enabled but no prompt
    /// is given to the user because they have recently authenticated.
    ///   "success_disabled" is used when the feature is disabled.
    ///   "success_unsupported_platform" should be set when the user attempts to
    /// authenticate on an unsupported platform.
    ///   "success_no_password" should be used when the user doesn't have an OS
    /// password set.
    ///   "fail" should be used when the user cancels the authentication prompt or an
    /// unexpected exception is encountered. The user may or may not have provided an
    /// incorrect password before cancelling.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// pwmgr.reauthenticate#os_auth.
    pub static reauthenticate_os_auth: Lazy<EventMetric<ReauthenticateOsAuthExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reauthenticate_os_auth".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3860.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SaveExistingLoginExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for SaveExistingLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.save_existing_login
    ///
    /// These events record interactions on the about:logins page. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pwmgr.save#existing_login.
    pub static save_existing_login: Lazy<EventMetric<SaveExistingLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "save_existing_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3861.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SaveNewLoginExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for SaveNewLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.save_new_login
    ///
    /// These events record interactions on the about:logins page. This event was
    /// generated to correspond to the Legacy Telemetry event pwmgr.save#new_login.
    pub static save_new_login: Lazy<EventMetric<SaveNewLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "save_new_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3862.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SavedLoginUsedAuthLoginExtra {
        pub r#filled: Option<bool>,
    }

    impl ExtraKeys for SavedLoginUsedAuthLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["filled"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#filled.and_then(|val| map.insert("filled".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.saved_login_used_auth_login
    ///
    /// Each time a saved login is used in a form or authentication dialog. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// pwmgr.saved_login_used#auth_login.
    pub static saved_login_used_auth_login: Lazy<EventMetric<SavedLoginUsedAuthLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "saved_login_used_auth_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3863.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SavedLoginUsedFormLoginExtra {
        pub r#filled: Option<bool>,
    }

    impl ExtraKeys for SavedLoginUsedFormLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["filled"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#filled.and_then(|val| map.insert("filled".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.saved_login_used_form_login
    ///
    /// Each time a saved login is used in a form or authentication dialog. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// pwmgr.saved_login_used#form_login.
    pub static saved_login_used_form_login: Lazy<EventMetric<SavedLoginUsedFormLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "saved_login_used_form_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3864.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SavedLoginUsedFormPasswordExtra {
        pub r#filled: Option<bool>,
    }

    impl ExtraKeys for SavedLoginUsedFormPasswordExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["filled"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#filled.and_then(|val| map.insert("filled".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.saved_login_used_form_password
    ///
    /// Each time a saved login is used in a form or authentication dialog. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// pwmgr.saved_login_used#form_password.
    pub static saved_login_used_form_password: Lazy<EventMetric<SavedLoginUsedFormPasswordExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "saved_login_used_form_password".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3865.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SavedLoginUsedPromptLoginExtra {
        pub r#filled: Option<bool>,
    }

    impl ExtraKeys for SavedLoginUsedPromptLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["filled"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#filled.and_then(|val| map.insert("filled".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.saved_login_used_prompt_login
    ///
    /// Each time a saved login is used in a form or authentication dialog. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// pwmgr.saved_login_used#prompt_login.
    pub static saved_login_used_prompt_login: Lazy<EventMetric<SavedLoginUsedPromptLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "saved_login_used_prompt_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3866.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SelectExistingLoginExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for SelectExistingLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.select_existing_login
    ///
    /// These events record interactions on the about:logins page. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pwmgr.select#existing_login.
    pub static select_existing_login: Lazy<EventMetric<SelectExistingLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "select_existing_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3867.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowPasswordExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for ShowPasswordExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.show_password
    ///
    /// These events record interactions on the about:logins page. This event was
    /// generated to correspond to the Legacy Telemetry event pwmgr.show#password.
    pub static show_password: Lazy<EventMetric<ShowPasswordExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_password".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3868.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SortListExtra {
        pub r#sort_key: Option<String>,
    }

    impl ExtraKeys for SortListExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["sort_key"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#sort_key.and_then(|val| map.insert("sort_key".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.sort_list
    ///
    /// These events record interactions on the about:logins page. This event was
    /// generated to correspond to the Legacy Telemetry event pwmgr.sort#list.
    pub static sort_list: Lazy<EventMetric<SortListExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sort_list".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3869.into(), meta)
    });

}
pub mod relay_integration {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickedFillUsernameExtra {
        pub r#error_code: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickedFillUsernameExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["error_code", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#error_code.and_then(|val| map.insert("error_code".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.clicked_fill_username
    ///
    /// Firefox relay integration autocomplete popup This event was generated to
    /// correspond to the Legacy Telemetry event
    /// relay_integration.clicked#fill_username.
    pub static clicked_fill_username: Lazy<EventMetric<ClickedFillUsernameExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "clicked_fill_username".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3870.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickedOfferRelayExtra {
        pub r#scenario: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickedOfferRelayExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["scenario", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#scenario.and_then(|val| map.insert("scenario".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.clicked_offer_relay
    ///
    /// Firefox relay integration autocomplete popup This event was generated to
    /// correspond to the Legacy Telemetry event relay_integration.clicked#offer_relay.
    pub static clicked_offer_relay: Lazy<EventMetric<ClickedOfferRelayExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "clicked_offer_relay".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3871.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisabledOptInPanelExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisabledOptInPanelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.disabled_opt_in_panel
    ///
    /// Panel to opt-in Firefox Relay Integration This event was generated to
    /// correspond to the Legacy Telemetry event
    /// relay_integration.disabled#opt_in_panel.
    pub static disabled_opt_in_panel: Lazy<EventMetric<DisabledOptInPanelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disabled_opt_in_panel".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3872.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.disabled_pref_change
    ///
    /// Checkbox in the settings page to enable/disable relay This event was generated
    /// to correspond to the Legacy Telemetry event
    /// relay_integration.disabled#pref_change.
    pub static disabled_pref_change: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disabled_pref_change".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3873.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnabledOptInPanelExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnabledOptInPanelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.enabled_opt_in_panel
    ///
    /// Panel to opt-in Firefox Relay Integration This event was generated to
    /// correspond to the Legacy Telemetry event
    /// relay_integration.enabled#opt_in_panel.
    pub static enabled_opt_in_panel: Lazy<EventMetric<EnabledOptInPanelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled_opt_in_panel".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3874.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.enabled_pref_change
    ///
    /// Checkbox in the settings page to enable/disable relay This event was generated
    /// to correspond to the Legacy Telemetry event
    /// relay_integration.enabled#pref_change.
    pub static enabled_pref_change: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled_pref_change".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3875.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct GetUnlimitedMasksReusePanelExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for GetUnlimitedMasksReusePanelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.get_unlimited_masks_reuse_panel
    ///
    /// Panels to show the state of the email alias generation This event was generated
    /// to correspond to the Legacy Telemetry event
    /// relay_integration.get_unlimited_masks#reuse_panel.
    pub static get_unlimited_masks_reuse_panel: Lazy<EventMetric<GetUnlimitedMasksReusePanelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "get_unlimited_masks_reuse_panel".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3876.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PostponedOptInPanelExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PostponedOptInPanelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.postponed_opt_in_panel
    ///
    /// Panel to opt-in Firefox Relay Integration This event was generated to
    /// correspond to the Legacy Telemetry event
    /// relay_integration.postponed#opt_in_panel.
    pub static postponed_opt_in_panel: Lazy<EventMetric<PostponedOptInPanelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "postponed_opt_in_panel".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3877.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReuseMaskReusePanelExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReuseMaskReusePanelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.reuse_mask_reuse_panel
    ///
    /// Panels to show the state of the email alias generation This event was generated
    /// to correspond to the Legacy Telemetry event
    /// relay_integration.reuse_mask#reuse_panel.
    pub static reuse_mask_reuse_panel: Lazy<EventMetric<ReuseMaskReusePanelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reuse_mask_reuse_panel".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3878.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShownFillUsernameExtra {
        pub r#error_code: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShownFillUsernameExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["error_code", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#error_code.and_then(|val| map.insert("error_code".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.shown_fill_username
    ///
    /// Firefox relay integration autocomplete popup This event was generated to
    /// correspond to the Legacy Telemetry event relay_integration.shown#fill_username.
    pub static shown_fill_username: Lazy<EventMetric<ShownFillUsernameExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shown_fill_username".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3879.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShownOfferRelayExtra {
        pub r#scenario: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShownOfferRelayExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["scenario", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#scenario.and_then(|val| map.insert("scenario".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.shown_offer_relay
    ///
    /// Firefox relay integration autocomplete popup This event was generated to
    /// correspond to the Legacy Telemetry event relay_integration.shown#offer_relay.
    pub static shown_offer_relay: Lazy<EventMetric<ShownOfferRelayExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shown_offer_relay".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3880.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShownOptInPanelExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShownOptInPanelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.shown_opt_in_panel
    ///
    /// Panel to opt-in Firefox Relay Integration This event was generated to
    /// correspond to the Legacy Telemetry event relay_integration.shown#opt_in_panel.
    pub static shown_opt_in_panel: Lazy<EventMetric<ShownOptInPanelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shown_opt_in_panel".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3881.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShownReusePanelExtra {
        pub r#error_code: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShownReusePanelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["error_code", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#error_code.and_then(|val| map.insert("error_code".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.shown_reuse_panel
    ///
    /// Panels to show the state of the email alias generation This event was generated
    /// to correspond to the Legacy Telemetry event
    /// relay_integration.shown#reuse_panel.
    pub static shown_reuse_panel: Lazy<EventMetric<ShownReusePanelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shown_reuse_panel".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3882.into(), meta)
    });

}
pub mod pdfjs {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum ButtonsLabel {
        EPresentationMode = 0,
        EPresentationModeKeyboard = 1,
        EViewBookmark = 2,
        EFirstPage = 3,
        ELastPage = 4,
        EPageRotateCw = 5,
        EPageRotateCcw = 6,
        ECursorSelectTool = 7,
        ECursorHandTool = 8,
        EScrollPage = 9,
        EScrollVertical = 10,
        EScrollHorizontal = 11,
        EScrollWrapped = 12,
        ESpreadNone = 13,
        ESpreadOdd = 14,
        ESpreadEven = 15,
        EDocumentProperties = 16,
        __Other__,
    }
    impl From<u16> for ButtonsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresentationMode,
                1 => Self::EPresentationModeKeyboard,
                2 => Self::EViewBookmark,
                3 => Self::EFirstPage,
                4 => Self::ELastPage,
                5 => Self::EPageRotateCw,
                6 => Self::EPageRotateCcw,
                7 => Self::ECursorSelectTool,
                8 => Self::ECursorHandTool,
                9 => Self::EScrollPage,
                10 => Self::EScrollVertical,
                11 => Self::EScrollHorizontal,
                12 => Self::EScrollWrapped,
                13 => Self::ESpreadNone,
                14 => Self::ESpreadOdd,
                15 => Self::ESpreadEven,
                16 => Self::EDocumentProperties,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ButtonsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresentationMode => "presentation_mode",
                Self::EPresentationModeKeyboard => "presentation_mode_keyboard",
                Self::EViewBookmark => "view_bookmark",
                Self::EFirstPage => "first_page",
                Self::ELastPage => "last_page",
                Self::EPageRotateCw => "page_rotate_cw",
                Self::EPageRotateCcw => "page_rotate_ccw",
                Self::ECursorSelectTool => "cursor_select_tool",
                Self::ECursorHandTool => "cursor_hand_tool",
                Self::EScrollPage => "scroll_page",
                Self::EScrollVertical => "scroll_vertical",
                Self::EScrollHorizontal => "scroll_horizontal",
                Self::EScrollWrapped => "scroll_wrapped",
                Self::ESpreadNone => "spread_none",
                Self::ESpreadOdd => "spread_odd",
                Self::ESpreadEven => "spread_even",
                Self::EDocumentProperties => "document_properties",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.buttons
    ///
    /// Counts the number of times some actions are executed in the PDF viewer.
    pub static buttons: Lazy<LabeledMetric<LabeledCounterMetric, ButtonsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "buttons".into(),
                    category: "pdfjs".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3883.into(), meta, Some(vec![::std::borrow::Cow::from("cursor_hand_tool"), ::std::borrow::Cow::from("cursor_select_tool"), ::std::borrow::Cow::from("document_properties"), ::std::borrow::Cow::from("first_page"), ::std::borrow::Cow::from("last_page"), ::std::borrow::Cow::from("page_rotate_ccw"), ::std::borrow::Cow::from("page_rotate_cw"), ::std::borrow::Cow::from("presentation_mode"), ::std::borrow::Cow::from("presentation_mode_keyboard"), ::std::borrow::Cow::from("scroll_horizontal"), ::std::borrow::Cow::from("scroll_page"), ::std::borrow::Cow::from("scroll_vertical"), ::std::borrow::Cow::from("scroll_wrapped"), ::std::borrow::Cow::from("spread_even"), ::std::borrow::Cow::from("spread_none"), ::std::borrow::Cow::from("spread_odd"), ::std::borrow::Cow::from("view_bookmark")]))
    });

    #[repr(u16)]
    pub enum EditingLabel {
        EInk = 0,
        EFreetext = 1,
        EStamp = 2,
        ESave = 3,
        EPrint = 4,
        __Other__,
    }
    impl From<u16> for EditingLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EInk,
                1 => Self::EFreetext,
                2 => Self::EStamp,
                3 => Self::ESave,
                4 => Self::EPrint,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EditingLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EInk => "ink",
                Self::EFreetext => "freetext",
                Self::EStamp => "stamp",
                Self::ESave => "save",
                Self::EPrint => "print",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing
    ///
    /// Counts the number of times some PDF editing features are used.
    pub static editing: Lazy<LabeledMetric<LabeledCounterMetric, EditingLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "editing".into(),
                    category: "pdfjs".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3884.into(), meta, Some(vec![::std::borrow::Cow::from("freetext"), ::std::borrow::Cow::from("ink"), ::std::borrow::Cow::from("print"), ::std::borrow::Cow::from("save"), ::std::borrow::Cow::from("stamp")]))
    });

    #[repr(u16)]
    pub enum GeckoviewLabel {
        EDownloadTapped = 0,
        EOpenInAppTapped = 1,
        EOpenInAppJustOnce = 2,
        EOpenInAppAlways = 3,
        EDownloadFailed = 4,
        EDownloadSucceeded = 5,
        ESaveAsPdfTapped = 6,
        __Other__,
    }
    impl From<u16> for GeckoviewLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDownloadTapped,
                1 => Self::EOpenInAppTapped,
                2 => Self::EOpenInAppJustOnce,
                3 => Self::EOpenInAppAlways,
                4 => Self::EDownloadFailed,
                5 => Self::EDownloadSucceeded,
                6 => Self::ESaveAsPdfTapped,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GeckoviewLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDownloadTapped => "download_tapped",
                Self::EOpenInAppTapped => "open_in_app_tapped",
                Self::EOpenInAppJustOnce => "open_in_app_just_once",
                Self::EOpenInAppAlways => "open_in_app_always",
                Self::EDownloadFailed => "download_failed",
                Self::EDownloadSucceeded => "download_succeeded",
                Self::ESaveAsPdfTapped => "save_as_pdf_tapped",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.geckoview
    ///
    /// Counts the number of times some actions are executed in the PDF viewer.
    pub static geckoview: Lazy<LabeledMetric<LabeledCounterMetric, GeckoviewLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "geckoview".into(),
                    category: "pdfjs".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3885.into(), meta, Some(vec![::std::borrow::Cow::from("download_failed"), ::std::borrow::Cow::from("download_succeeded"), ::std::borrow::Cow::from("download_tapped"), ::std::borrow::Cow::from("open_in_app_always"), ::std::borrow::Cow::from("open_in_app_just_once"), ::std::borrow::Cow::from("open_in_app_tapped"), ::std::borrow::Cow::from("save_as_pdf_tapped")]))
    });

    #[repr(u16)]
    pub enum StampLabel {
        EInsertedImage = 0,
        EAltTextSave = 1,
        EAltTextCancel = 2,
        EAltTextTooltip = 3,
        EAltTextEdit = 4,
        EAltTextDescription = 5,
        EAltTextDecorative = 6,
        EAltTextKeyboard = 7,
        __Other__,
    }
    impl From<u16> for StampLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EInsertedImage,
                1 => Self::EAltTextSave,
                2 => Self::EAltTextCancel,
                3 => Self::EAltTextTooltip,
                4 => Self::EAltTextEdit,
                5 => Self::EAltTextDescription,
                6 => Self::EAltTextDecorative,
                7 => Self::EAltTextKeyboard,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for StampLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EInsertedImage => "inserted_image",
                Self::EAltTextSave => "alt_text_save",
                Self::EAltTextCancel => "alt_text_cancel",
                Self::EAltTextTooltip => "alt_text_tooltip",
                Self::EAltTextEdit => "alt_text_edit",
                Self::EAltTextDescription => "alt_text_description",
                Self::EAltTextDecorative => "alt_text_decorative",
                Self::EAltTextKeyboard => "alt_text_keyboard",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.stamp
    ///
    /// Counts the number of times some PDF editing features are used.
    pub static stamp: Lazy<LabeledMetric<LabeledCounterMetric, StampLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "stamp".into(),
                    category: "pdfjs".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3886.into(), meta, Some(vec![::std::borrow::Cow::from("alt_text_cancel"), ::std::borrow::Cow::from("alt_text_decorative"), ::std::borrow::Cow::from("alt_text_description"), ::std::borrow::Cow::from("alt_text_edit"), ::std::borrow::Cow::from("alt_text_keyboard"), ::std::borrow::Cow::from("alt_text_save"), ::std::borrow::Cow::from("alt_text_tooltip"), ::std::borrow::Cow::from("inserted_image")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.time_to_view
    ///
    /// Time spent to display first page in PDF Viewer (ms).
    pub static time_to_view: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time_to_view".into(),
                category: "pdfjs".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3887.into(), meta, 1, 10000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.used
    ///
    /// How many times PDF Viewer was used.
    pub static used: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3888,
            "pdfjs",
            "used",
            "metrics"
        )
    });

}
pub mod pdfjs_editing_highlight {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum ColorLabel {
        EYellow = 0,
        EGreen = 1,
        EBlue = 2,
        EPink = 3,
        ERed = 4,
        __Other__,
    }
    impl From<u16> for ColorLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EYellow,
                1 => Self::EGreen,
                2 => Self::EBlue,
                3 => Self::EPink,
                4 => Self::ERed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ColorLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EYellow => "yellow",
                Self::EGreen => "green",
                Self::EBlue => "blue",
                Self::EPink => "pink",
                Self::ERed => "red",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.color
    ///
    /// Counts the number of times a given color is used to highlight.
    pub static color: Lazy<LabeledMetric<LabeledCounterMetric, ColorLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "color".into(),
                    category: "pdfjs.editing.highlight".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3889.into(), meta, Some(vec![::std::borrow::Cow::from("blue"), ::std::borrow::Cow::from("green"), ::std::borrow::Cow::from("pink"), ::std::borrow::Cow::from("red"), ::std::borrow::Cow::from("yellow")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.color_changed
    ///
    /// Counts the number of times the user changes the color of a highlight.
    pub static color_changed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3890,
            "pdfjs.editing.highlight",
            "color_changed",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.deleted
    ///
    /// Counts the number of times the user deletes highlights.
    pub static deleted: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3891,
            "pdfjs.editing.highlight",
            "deleted",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.edited
    ///
    /// Counts the number of times the user edits highlights.
    pub static edited: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3892,
            "pdfjs.editing.highlight",
            "edited",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum KindLabel {
        EFreeHighlight = 0,
        EHighlight = 1,
        __Other__,
    }
    impl From<u16> for KindLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFreeHighlight,
                1 => Self::EHighlight,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for KindLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFreeHighlight => "free_highlight",
                Self::EHighlight => "highlight",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.kind
    ///
    /// Counts the number of times a given kind is used to highlight.
    pub static kind: Lazy<LabeledMetric<LabeledCounterMetric, KindLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "kind".into(),
                    category: "pdfjs.editing.highlight".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3893.into(), meta, Some(vec![::std::borrow::Cow::from("free_highlight"), ::std::borrow::Cow::from("highlight")]))
    });

    #[repr(u16)]
    pub enum MethodLabel {
        EContextMenu = 0,
        EMainToolbar = 1,
        EFloatingButton = 2,
        __Other__,
    }
    impl From<u16> for MethodLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EContextMenu,
                1 => Self::EMainToolbar,
                2 => Self::EFloatingButton,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MethodLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EContextMenu => "context_menu",
                Self::EMainToolbar => "main_toolbar",
                Self::EFloatingButton => "floating_button",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.method
    ///
    /// Counts the number of times a given method is used to highlight.
    pub static method: Lazy<LabeledMetric<LabeledCounterMetric, MethodLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "method".into(),
                    category: "pdfjs.editing.highlight".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3894.into(), meta, Some(vec![::std::borrow::Cow::from("context_menu"), ::std::borrow::Cow::from("floating_button"), ::std::borrow::Cow::from("main_toolbar")]))
    });

    #[repr(u16)]
    pub enum NumberOfColorsLabel {
        EOne = 0,
        ETwo = 1,
        EThree = 2,
        EFour = 3,
        EFive = 4,
        __Other__,
    }
    impl From<u16> for NumberOfColorsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOne,
                1 => Self::ETwo,
                2 => Self::EThree,
                3 => Self::EFour,
                4 => Self::EFive,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for NumberOfColorsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOne => "one",
                Self::ETwo => "two",
                Self::EThree => "three",
                Self::EFour => "four",
                Self::EFive => "five",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.number_of_colors
    ///
    /// Counts the number of different colors used to highlight.
    pub static number_of_colors: Lazy<LabeledMetric<LabeledCounterMetric, NumberOfColorsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "number_of_colors".into(),
                    category: "pdfjs.editing.highlight".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3895.into(), meta, Some(vec![::std::borrow::Cow::from("five"), ::std::borrow::Cow::from("four"), ::std::borrow::Cow::from("one"), ::std::borrow::Cow::from("three"), ::std::borrow::Cow::from("two")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.print
    ///
    /// Counts the number of times the user prints a PDF with highlights.
    pub static print: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3896,
            "pdfjs.editing.highlight",
            "print",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.save
    ///
    /// Counts the number of times the user saves a PDF with highlights.
    pub static save: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3897,
            "pdfjs.editing.highlight",
            "save",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.thickness
    ///
    /// The thickness used to draw a free highlight.
    pub static thickness: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "thickness".into(),
                category: "pdfjs.editing.highlight".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3898.into(), meta, 8, 24, 17, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.thickness_changed
    ///
    /// Counts the number of times the user changes the thickness of a free highlight.
    pub static thickness_changed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3899,
            "pdfjs.editing.highlight",
            "thickness_changed",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.toggle_visibility
    ///
    /// Counts the number of times the user toggles the visibility of highlights.
    pub static toggle_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3900,
            "pdfjs.editing.highlight",
            "toggle_visibility",
            "metrics"
        )
    });

}
pub mod pdfjs_image {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.add_image_click
    ///
    /// Recorded when the Add Image label is clicked.
    pub static add_image_click: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "add_image_click".into(),
                category: "pdfjs.image".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3901.into(), meta)
    });

    #[repr(u16)]
    pub enum AddedLabel {
        EWithAltText = 0,
        EWithoutAltText = 1,
        __Other__,
    }
    impl From<u16> for AddedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EWithAltText,
                1 => Self::EWithoutAltText,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AddedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EWithAltText => "with_alt_text",
                Self::EWithoutAltText => "without_alt_text",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.added
    ///
    /// Number of images added with/without alt text.
    pub static added: Lazy<LabeledMetric<LabeledCounterMetric, AddedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "added".into(),
                    category: "pdfjs.image".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3902.into(), meta, Some(vec![::std::borrow::Cow::from("with_alt_text"), ::std::borrow::Cow::from("without_alt_text")]))
    });

    #[repr(u16)]
    pub enum AltTextEditLabel {
        EAskToEdit = 0,
        EAiGeneration = 1,
        __Other__,
    }
    impl From<u16> for AltTextEditLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAskToEdit,
                1 => Self::EAiGeneration,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AltTextEditLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAskToEdit => "ask_to_edit",
                Self::EAiGeneration => "ai_generation",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text_edit
    ///
    /// Stores alt text modal settings for the user.
    pub static alt_text_edit: Lazy<LabeledMetric<LabeledBooleanMetric, AltTextEditLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "alt_text_edit".into(),
                    category: "pdfjs.image".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3903.into(), meta, Some(vec![::std::borrow::Cow::from("ai_generation"), ::std::borrow::Cow::from("ask_to_edit")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.icon_click
    ///
    /// Recorded when the image toolbar icon is clicked.
    pub static icon_click: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "icon_click".into(),
                category: "pdfjs.image".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3904.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ImageAddedExtra {
        pub r#alt_text_modal: Option<bool>,
        pub r#alt_text_type: Option<String>,
    }

    impl ExtraKeys for ImageAddedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["alt_text_modal", "alt_text_type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#alt_text_modal.and_then(|val| map.insert("alt_text_modal".into(), val.to_string()));
          self.r#alt_text_type.and_then(|val| map.insert("alt_text_type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.image_added
    ///
    /// Recorded once the image is added to the pdf.
    pub static image_added: Lazy<EventMetric<ImageAddedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "image_added".into(),
                category: "pdfjs.image".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3905.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ImageSelectedExtra {
        pub r#alt_text_modal: Option<bool>,
    }

    impl ExtraKeys for ImageSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["alt_text_modal"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#alt_text_modal.and_then(|val| map.insert("alt_text_modal".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.image_selected
    ///
    /// Recorded when the user selects an image file from their computer.
    pub static image_selected: Lazy<EventMetric<ImageSelectedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "image_selected".into(),
                category: "pdfjs.image".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3906.into(), meta)
    });

}
pub mod pdfjs_image_alt_text {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AiGenerationCheckExtra {
        pub r#status: Option<bool>,
    }

    impl ExtraKeys for AiGenerationCheckExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.ai_generation_check
    ///
    /// Recorded when the user interacts with the alt text setting in the alt text
    /// modal to create alt text with AI.
    pub static ai_generation_check: Lazy<EventMetric<AiGenerationCheckExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ai_generation_check".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3907.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.callout_dismissed
    ///
    /// Recorded when the callout describing automatic alt text generation is
    /// dismissed.
    pub static callout_dismissed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "callout_dismissed".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3908.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.callout_displayed
    ///
    /// Recorded when the callout describing automatic alt text generation is
    /// displayed.
    pub static callout_displayed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "callout_displayed".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3909.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DismissExtra {
        pub r#alt_text_type: Option<String>,
        pub r#flow: Option<String>,
    }

    impl ExtraKeys for DismissExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["alt_text_type", "flow"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#alt_text_type.and_then(|val| map.insert("alt_text_type".into(), val.to_string()));
          self.r#flow.and_then(|val| map.insert("flow".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.dismiss
    ///
    /// Recorded when the user clicks Not now or Cancel on the alt text modal.
    pub static dismiss: Lazy<EventMetric<DismissExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dismiss".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3910.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ImageStatusLabelClickedExtra {
        pub r#label: Option<String>,
    }

    impl ExtraKeys for ImageStatusLabelClickedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["label"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#label.and_then(|val| map.insert("label".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.image_status_label_clicked
    ///
    /// Recorded when the user clicks on the alt text status button.
    pub static image_status_label_clicked: Lazy<EventMetric<ImageStatusLabelClickedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "image_status_label_clicked".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3911.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ImageStatusLabelDisplayedExtra {
        pub r#label: Option<String>,
    }

    impl ExtraKeys for ImageStatusLabelDisplayedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["label"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#label.and_then(|val| map.insert("label".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.image_status_label_displayed
    ///
    /// Recorded when the alt text status button on an image is shown .
    pub static image_status_label_displayed: Lazy<EventMetric<ImageStatusLabelDisplayedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "image_status_label_displayed".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3912.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InfoExtra {
        pub r#topic: Option<String>,
    }

    impl ExtraKeys for InfoExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["topic"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#topic.and_then(|val| map.insert("topic".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.info
    ///
    /// Recorded on the alt text modal when the user clicks on "i" to learn about alt
    /// text or "Learn More" to learn about AI generation.
    pub static info: Lazy<EventMetric<InfoExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "info".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3913.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.model_deleted
    ///
    /// Recorded when the user clicks to delete the model from the alt text settings.
    pub static model_deleted: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "model_deleted".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3914.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.model_download_complete
    ///
    /// Recorded when download completes for the alt text generation model.
    pub static model_download_complete: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "model_download_complete".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3915.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ModelDownloadErrorExtra {
        pub r#error: Option<String>,
    }

    impl ExtraKeys for ModelDownloadErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["error"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.model_download_error
    ///
    /// Recorded when an error occurs during the download for the alt text generation
    /// model.
    pub static model_download_error: Lazy<EventMetric<ModelDownloadErrorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "model_download_error".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3916.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.model_download_start
    ///
    /// Recorded when download starts for the alt text generation model.
    pub static model_download_start: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "model_download_start".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3917.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ModelResultExtra {
        pub r#length: Option<u32>,
        pub r#time: Option<u32>,
    }

    impl ExtraKeys for ModelResultExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["length", "time"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#length.and_then(|val| map.insert("length".into(), val.to_string()));
          self.r#time.and_then(|val| map.insert("time".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.model_result
    ///
    /// Records how long it takes to generate the alt text and what is the length of
    /// the result.
    pub static model_result: Lazy<EventMetric<ModelResultExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "model_result".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3918.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SaveExtra {
        pub r#alt_text_type: Option<String>,
        pub r#flow: Option<String>,
    }

    impl ExtraKeys for SaveExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["alt_text_type", "flow"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#alt_text_type.and_then(|val| map.insert("alt_text_type".into(), val.to_string()));
          self.r#flow.and_then(|val| map.insert("flow".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.save
    ///
    /// Recorded when the user clicks Save on the alt text modal.
    pub static save: Lazy<EventMetric<SaveExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "save".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3919.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SettingsAiGenerationCheckExtra {
        pub r#status: Option<bool>,
    }

    impl ExtraKeys for SettingsAiGenerationCheckExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.settings_ai_generation_check
    ///
    /// Recorded when the user interacts with the alt text setting to create alt text
    /// with AI.
    pub static settings_ai_generation_check: Lazy<EventMetric<SettingsAiGenerationCheckExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "settings_ai_generation_check".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3920.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.settings_displayed
    ///
    /// Recorded when alt text settings dialog is displayed to a user.
    pub static settings_displayed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "settings_displayed".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3921.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SettingsEditAltTextCheckExtra {
        pub r#status: Option<bool>,
    }

    impl ExtraKeys for SettingsEditAltTextCheckExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.settings_edit_alt_text_check
    ///
    /// Recorded when the user interacts with the alt text modal setting to edit alt
    /// text on this pdf.
    pub static settings_edit_alt_text_check: Lazy<EventMetric<SettingsEditAltTextCheckExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "settings_edit_alt_text_check".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3922.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UserEditExtra {
        pub r#total_words: Option<u32>,
        pub r#words_added: Option<u32>,
        pub r#words_removed: Option<u32>,
    }

    impl ExtraKeys for UserEditExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["total_words", "words_added", "words_removed"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#total_words.and_then(|val| map.insert("total_words".into(), val.to_string()));
          self.r#words_added.and_then(|val| map.insert("words_added".into(), val.to_string()));
          self.r#words_removed.and_then(|val| map.insert("words_removed".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.user_edit
    ///
    /// Recorded once the alt text is confirmed, when the user makes changes to the alt
    /// text generated. By comparing the initially generated text with the final
    /// version, quantifies how many words were changed.
    pub static user_edit: Lazy<EventMetric<UserEditExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "user_edit".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3923.into(), meta)
    });

}
pub mod pictureinpicture {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_browser_crash
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.closed_method#browserCrash.
    pub static closed_method_browser_crash: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_browser_crash".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3924.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_close_button
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.closed_method#closeButton.
    pub static closed_method_close_button: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_close_button".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3925.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_close_player_shortcut
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.closed_method#closePlayerShortcut.
    pub static closed_method_close_player_shortcut: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_close_player_shortcut".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3926.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_context_menu
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.closed_method#contextMenu.
    pub static closed_method_context_menu: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_context_menu".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3927.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_foregrounded
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.closed_method#foregrounded.
    pub static closed_method_foregrounded: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_foregrounded".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3928.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_fullscreen
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.closed_method#fullscreen.
    pub static closed_method_fullscreen: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_fullscreen".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3929.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_pagehide
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.closed_method#pagehide.
    pub static closed_method_pagehide: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_pagehide".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3930.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_setup_failure
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.closed_method#setupFailure.
    pub static closed_method_setup_failure: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_setup_failure".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3931.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_shortcut
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.closed_method#shortcut.
    pub static closed_method_shortcut: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_shortcut".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3932.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_unpip
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.closed_method#unpip.
    pub static closed_method_unpip: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_unpip".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3933.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_url_bar
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.closed_method#urlBar.
    pub static closed_method_url_bar: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_url_bar".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3934.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_video_el_emptied
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.closed_method#videoElEmptied.
    pub static closed_method_video_el_emptied: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_video_el_emptied".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3935.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_video_el_remove
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.closed_method#videoElRemove.
    pub static closed_method_video_el_remove: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_video_el_remove".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3936.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CreatePlayerExtra {
        pub r#ccEnabled: Option<bool>,
        pub r#height: Option<u32>,
        pub r#screenX: Option<u32>,
        pub r#screenY: Option<u32>,
        pub r#value: Option<String>,
        pub r#webVTTSubtitles: Option<bool>,
        pub r#width: Option<u32>,
    }

    impl ExtraKeys for CreatePlayerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["ccEnabled", "height", "screenX", "screenY", "value", "webVTTSubtitles", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#ccEnabled.and_then(|val| map.insert("ccEnabled".into(), val.to_string()));
          self.r#height.and_then(|val| map.insert("height".into(), val.to_string()));
          self.r#screenX.and_then(|val| map.insert("screenX".into(), val.to_string()));
          self.r#screenY.and_then(|val| map.insert("screenY".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#webVTTSubtitles.and_then(|val| map.insert("webVTTSubtitles".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.create_player
    ///
    /// Recorded when the Picture-in-Picture player window is created. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.create#player.
    pub static create_player: Lazy<EventMetric<CreatePlayerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "create_player".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3937.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.disrespect_disable_url_bar
    ///
    /// Recorded when the user chooses to enable PiP anyway on a PiP disabled video
    /// This event was generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.disrespect_disable#urlBar.
    pub static disrespect_disable_url_bar: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disrespect_disable_url_bar".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3938.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FullscreenPlayerExtra {
        pub r#enter: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for FullscreenPlayerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["enter", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#enter.and_then(|val| map.insert("enter".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.fullscreen_player
    ///
    /// Recorded when the user clicks the fullscreen button This event was generated to
    /// correspond to the Legacy Telemetry event pictureinpicture.fullscreen#player.
    pub static fullscreen_player: Lazy<EventMetric<FullscreenPlayerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fullscreen_player".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3939.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.most_concurrent_players
    ///
    /// The most concurrent Picture-in-Picture players the user had open at any one
    /// time. This metric was generated to correspond to the Legacy Telemetry scalar
    /// pictureinpicture.most_concurrent_players.
    pub static most_concurrent_players: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "most_concurrent_players".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3940.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenedMethodAutoPipExtra {
        pub r#callout: Option<bool>,
        pub r#disableDialog: Option<bool>,
        pub r#firstTimeToggle: Option<bool>,
    }

    impl ExtraKeys for OpenedMethodAutoPipExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["callout", "disableDialog", "firstTimeToggle"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#callout.and_then(|val| map.insert("callout".into(), val.to_string()));
          self.r#disableDialog.and_then(|val| map.insert("disableDialog".into(), val.to_string()));
          self.r#firstTimeToggle.and_then(|val| map.insert("firstTimeToggle".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.opened_method_auto_pip
    ///
    /// Records the method for opening the Picture-in-Picture window. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.opened_method#autoPip.
    pub static opened_method_auto_pip: Lazy<EventMetric<OpenedMethodAutoPipExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "opened_method_auto_pip".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3941.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenedMethodContextMenuExtra {
        pub r#callout: Option<bool>,
        pub r#disableDialog: Option<bool>,
        pub r#firstTimeToggle: Option<bool>,
    }

    impl ExtraKeys for OpenedMethodContextMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["callout", "disableDialog", "firstTimeToggle"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#callout.and_then(|val| map.insert("callout".into(), val.to_string()));
          self.r#disableDialog.and_then(|val| map.insert("disableDialog".into(), val.to_string()));
          self.r#firstTimeToggle.and_then(|val| map.insert("firstTimeToggle".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.opened_method_context_menu
    ///
    /// Records the method for opening the Picture-in-Picture window. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.opened_method#contextMenu.
    pub static opened_method_context_menu: Lazy<EventMetric<OpenedMethodContextMenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "opened_method_context_menu".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3942.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenedMethodShortcutExtra {
        pub r#callout: Option<bool>,
        pub r#disableDialog: Option<bool>,
        pub r#firstTimeToggle: Option<bool>,
    }

    impl ExtraKeys for OpenedMethodShortcutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["callout", "disableDialog", "firstTimeToggle"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#callout.and_then(|val| map.insert("callout".into(), val.to_string()));
          self.r#disableDialog.and_then(|val| map.insert("disableDialog".into(), val.to_string()));
          self.r#firstTimeToggle.and_then(|val| map.insert("firstTimeToggle".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.opened_method_shortcut
    ///
    /// Records the method for opening the Picture-in-Picture window. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.opened_method#shortcut.
    pub static opened_method_shortcut: Lazy<EventMetric<OpenedMethodShortcutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "opened_method_shortcut".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3943.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenedMethodToggleExtra {
        pub r#callout: Option<bool>,
        pub r#disableDialog: Option<bool>,
        pub r#firstTimeToggle: Option<bool>,
    }

    impl ExtraKeys for OpenedMethodToggleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["callout", "disableDialog", "firstTimeToggle"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#callout.and_then(|val| map.insert("callout".into(), val.to_string()));
          self.r#disableDialog.and_then(|val| map.insert("disableDialog".into(), val.to_string()));
          self.r#firstTimeToggle.and_then(|val| map.insert("firstTimeToggle".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.opened_method_toggle
    ///
    /// Records the method for opening the Picture-in-Picture window. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.opened_method#toggle.
    pub static opened_method_toggle: Lazy<EventMetric<OpenedMethodToggleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "opened_method_toggle".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3944.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenedMethodUrlBarExtra {
        pub r#callout: Option<bool>,
        pub r#disableDialog: Option<bool>,
        pub r#firstTimeToggle: Option<bool>,
    }

    impl ExtraKeys for OpenedMethodUrlBarExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["callout", "disableDialog", "firstTimeToggle"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#callout.and_then(|val| map.insert("callout".into(), val.to_string()));
          self.r#disableDialog.and_then(|val| map.insert("disableDialog".into(), val.to_string()));
          self.r#firstTimeToggle.and_then(|val| map.insert("firstTimeToggle".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.opened_method_url_bar
    ///
    /// Records the method for opening the Picture-in-Picture window. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.opened_method#urlBar.
    pub static opened_method_url_bar: Lazy<EventMetric<OpenedMethodUrlBarExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "opened_method_url_bar".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3945.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ResizePlayerExtra {
        pub r#height: Option<u32>,
        pub r#value: Option<String>,
        pub r#width: Option<u32>,
    }

    impl ExtraKeys for ResizePlayerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["height", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#height.and_then(|val| map.insert("height".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.resize_player
    ///
    /// Recorded when the Picture-in-Picture player window is resized. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.resize#player.
    pub static resize_player: Lazy<EventMetric<ResizePlayerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "resize_player".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3946.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SawToggleToggleExtra {
        pub r#firstTime: Option<bool>,
    }

    impl ExtraKeys for SawToggleToggleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["firstTime"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#firstTime.and_then(|val| map.insert("firstTime".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.saw_toggle_toggle
    ///
    /// Recorded when the Picture-in-Picture toggle is shown This event was generated
    /// to correspond to the Legacy Telemetry event pictureinpicture.saw_toggle#toggle.
    pub static saw_toggle_toggle: Lazy<EventMetric<SawToggleToggleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "saw_toggle_toggle".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3947.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SubtitlesShownSubtitlesExtra {
        pub r#webVTTSubtitles: Option<bool>,
    }

    impl ExtraKeys for SubtitlesShownSubtitlesExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["webVTTSubtitles"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#webVTTSubtitles.and_then(|val| map.insert("webVTTSubtitles".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.subtitles_shown_subtitles
    ///
    /// Records if subtitles are shown in the Picture-in-Picture window. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.subtitles_shown#subtitles.
    pub static subtitles_shown_subtitles: Lazy<EventMetric<SubtitlesShownSubtitlesExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "subtitles_shown_subtitles".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3948.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.toggle_enabled
    ///
    /// Whether the user has Picture-in-Picture enabled. This metric was generated to
    /// correspond to the Legacy Telemetry scalar pictureinpicture.toggle_enabled.
    pub static toggle_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "toggle_enabled".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3949.into(), meta)
    });

}
pub mod pictureinpicture_settings {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.settings.disable_player
    ///
    /// Recorded with "settings" object when Picture-in-Picture is disabled via
    /// settings Recorded with "player" object when Picture-in-Picture is disabled via
    /// PiP context menu This event was generated to correspond to the Legacy Telemetry
    /// event pictureinpicture.settings.disable#player.
    pub static disable_player: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_player".into(),
                category: "pictureinpicture.settings".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3950.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.settings.disable_settings
    ///
    /// Recorded with "settings" object when Picture-in-Picture is disabled via
    /// settings Recorded with "player" object when Picture-in-Picture is disabled via
    /// PiP context menu This event was generated to correspond to the Legacy Telemetry
    /// event pictureinpicture.settings.disable#settings.
    pub static disable_settings: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_settings".into(),
                category: "pictureinpicture.settings".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3951.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.settings.enable_autotrigger_settings
    ///
    /// Recorded when the Picture-in-Picture auto-trigger is enabled. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// pictureinpicture.settings.enable_autotrigger#settings.
    pub static enable_autotrigger_settings: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enable_autotrigger_settings".into(),
                category: "pictureinpicture.settings".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3952.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.settings.enable_settings
    ///
    /// Recorded when Picture-in-Picture is enabled. This event was generated to
    /// correspond to the Legacy Telemetry event
    /// pictureinpicture.settings.enable#settings.
    pub static enable_settings: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enable_settings".into(),
                category: "pictureinpicture.settings".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3953.into(), meta)
    });

}
pub mod page_icon {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from page_icon.fit_icon_count
    ///
    /// Number of times the page-icon protocol serves an icon equal to or larger than
    /// requested.
    pub static fit_icon_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3954,
            "page_icon",
            "fit_icon_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from page_icon.small_icon_count
    ///
    /// Number of times the page-icon protocol serves an icon smaller than requested.
    pub static small_icon_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3955,
            "page_icon",
            "small_icon_count",
            "metrics"
        )
    });

}
pub mod places {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from places.pages_need_frecency_recalculation
    ///
    /// Number of pages that need a frecency recalculation. This metric was generated
    /// to correspond to the Legacy Telemetry scalar
    /// places.pages_need_frecency_recalculation.
    pub static pages_need_frecency_recalculation: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pages_need_frecency_recalculation".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3956.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.places_database_corruption_handling_stage
    ///
    /// PLACES - stage reached when trying to fix a database corruption, see
    /// Places::Database::eCorruptDBReplaceStage.
    pub static places_database_corruption_handling_stage: Lazy<LabeledMetric<LabeledStringMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "places_database_corruption_handling_stage".into(),
                    category: "places".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3957.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.previousday_visits
    ///
    /// Number of history entries for the previous day. This metric was generated to
    /// correspond to the Legacy Telemetry scalar places.previousday_visits.
    pub static previousday_visits: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "previousday_visits".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(3958.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.sponsored_visit_no_triggering_url
    ///
    /// Number of sponsored visits that could not find their triggering URL in history.
    /// We expect this to be a small number just due to the navigation layer
    /// manipulating URLs. A large or growing value may be a concern. This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// places.sponsored_visit_no_triggering_url.
    pub static sponsored_visit_no_triggering_url: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3959,
            "places",
            "sponsored_visit_no_triggering_url",
            "metrics"
        )
    });

}
pub mod printing {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from printing.dialog_opened_via_preview_tm
    ///
    /// A counter incremented every time a user opens the system print dialog from the
    /// print preview interface. This metric was generated to correspond to the Legacy
    /// Telemetry scalar printing.dialog_opened_via_preview_tm.
    pub static dialog_opened_via_preview_tm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3960,
            "printing",
            "dialog_opened_via_preview_tm",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from printing.dialog_via_preview_cancelled_tm
    ///
    /// A counter incremented every time a user cancels a system print dialog that they
    /// opened from the print preview interface. This metric was generated to
    /// correspond to the Legacy Telemetry scalar
    /// printing.dialog_via_preview_cancelled_tm.
    pub static dialog_via_preview_cancelled_tm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3961,
            "printing",
            "dialog_via_preview_cancelled_tm",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum ErrorLabel {
        EGfxPrinterNoPrinterAvailable = 0,
        EGfxPrinterNameNotFound = 1,
        EGfxPrinterCouldNotOpenFile = 2,
        EGfxPrinterStartdoc = 3,
        EGfxPrinterEnddoc = 4,
        EGfxPrinterStartpage = 5,
        EGfxPrinterDocIsBusy = 6,
        EAbort = 7,
        ENotAvailable = 8,
        ENotImplemented = 9,
        EOutOfMemory = 10,
        EUnexpected = 11,
        EFailure = 12,
        EFallbackPaperList = 13,
        ELastUsedPrinter = 14,
        EPaperMargins = 15,
        EPrintDestinations = 16,
        EPrintPreview = 17,
        EPrinterList = 18,
        EPrinterProperties = 19,
        EPrinterSettings = 20,
        EUnwriteableMargin = 21,
        __Other__,
    }
    impl From<u16> for ErrorLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EGfxPrinterNoPrinterAvailable,
                1 => Self::EGfxPrinterNameNotFound,
                2 => Self::EGfxPrinterCouldNotOpenFile,
                3 => Self::EGfxPrinterStartdoc,
                4 => Self::EGfxPrinterEnddoc,
                5 => Self::EGfxPrinterStartpage,
                6 => Self::EGfxPrinterDocIsBusy,
                7 => Self::EAbort,
                8 => Self::ENotAvailable,
                9 => Self::ENotImplemented,
                10 => Self::EOutOfMemory,
                11 => Self::EUnexpected,
                12 => Self::EFailure,
                13 => Self::EFallbackPaperList,
                14 => Self::ELastUsedPrinter,
                15 => Self::EPaperMargins,
                16 => Self::EPrintDestinations,
                17 => Self::EPrintPreview,
                18 => Self::EPrinterList,
                19 => Self::EPrinterProperties,
                20 => Self::EPrinterSettings,
                21 => Self::EUnwriteableMargin,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ErrorLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EGfxPrinterNoPrinterAvailable => "GFX_PRINTER_NO_PRINTER_AVAILABLE",
                Self::EGfxPrinterNameNotFound => "GFX_PRINTER_NAME_NOT_FOUND",
                Self::EGfxPrinterCouldNotOpenFile => "GFX_PRINTER_COULD_NOT_OPEN_FILE",
                Self::EGfxPrinterStartdoc => "GFX_PRINTER_STARTDOC",
                Self::EGfxPrinterEnddoc => "GFX_PRINTER_ENDDOC",
                Self::EGfxPrinterStartpage => "GFX_PRINTER_STARTPAGE",
                Self::EGfxPrinterDocIsBusy => "GFX_PRINTER_DOC_IS_BUSY",
                Self::EAbort => "ABORT",
                Self::ENotAvailable => "NOT_AVAILABLE",
                Self::ENotImplemented => "NOT_IMPLEMENTED",
                Self::EOutOfMemory => "OUT_OF_MEMORY",
                Self::EUnexpected => "UNEXPECTED",
                Self::EFailure => "FAILURE",
                Self::EFallbackPaperList => "FALLBACK_PAPER_LIST",
                Self::ELastUsedPrinter => "LAST_USED_PRINTER",
                Self::EPaperMargins => "PAPER_MARGINS",
                Self::EPrintDestinations => "PRINT_DESTINATIONS",
                Self::EPrintPreview => "PRINT_PREVIEW",
                Self::EPrinterList => "PRINTER_LIST",
                Self::EPrinterProperties => "PRINTER_PROPERTIES",
                Self::EPrinterSettings => "PRINTER_SETTINGS",
                Self::EUnwriteableMargin => "UNWRITEABLE_MARGIN",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from printing.error
    ///
    /// A counter incremented every time the user encounters an error printing. The
    /// result is split into keys which represent the values of error codes related to
    /// printing. Possible values are listed in 'keys'. "FAILURE" is a catch-all code
    /// for an error we don't recognize. This metric was generated to correspond to the
    /// Legacy Telemetry scalar printing.error.
    pub static error: Lazy<LabeledMetric<LabeledCounterMetric, ErrorLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "error".into(),
                    category: "printing".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3962.into(), meta, Some(vec![::std::borrow::Cow::from("ABORT"), ::std::borrow::Cow::from("FAILURE"), ::std::borrow::Cow::from("FALLBACK_PAPER_LIST"), ::std::borrow::Cow::from("GFX_PRINTER_COULD_NOT_OPEN_FILE"), ::std::borrow::Cow::from("GFX_PRINTER_DOC_IS_BUSY"), ::std::borrow::Cow::from("GFX_PRINTER_ENDDOC"), ::std::borrow::Cow::from("GFX_PRINTER_NAME_NOT_FOUND"), ::std::borrow::Cow::from("GFX_PRINTER_NO_PRINTER_AVAILABLE"), ::std::borrow::Cow::from("GFX_PRINTER_STARTDOC"), ::std::borrow::Cow::from("GFX_PRINTER_STARTPAGE"), ::std::borrow::Cow::from("LAST_USED_PRINTER"), ::std::borrow::Cow::from("NOT_AVAILABLE"), ::std::borrow::Cow::from("NOT_IMPLEMENTED"), ::std::borrow::Cow::from("OUT_OF_MEMORY"), ::std::borrow::Cow::from("PAPER_MARGINS"), ::std::borrow::Cow::from("PRINTER_LIST"), ::std::borrow::Cow::from("PRINTER_PROPERTIES"), ::std::borrow::Cow::from("PRINTER_SETTINGS"), ::std::borrow::Cow::from("PRINT_DESTINATIONS"), ::std::borrow::Cow::from("PRINT_PREVIEW"), ::std::borrow::Cow::from("UNEXPECTED"), ::std::borrow::Cow::from("UNWRITEABLE_MARGIN")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from printing.preview_cancelled_tm
    ///
    /// A counter incremented every time a user exits print preview without printing.
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// printing.preview_cancelled_tm.
    pub static preview_cancelled_tm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3963,
            "printing",
            "preview_cancelled_tm",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from printing.preview_opened_tm
    ///
    /// A counter incremented every time a user opens print preview. This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// printing.preview_opened_tm.
    pub static preview_opened_tm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3964,
            "printing",
            "preview_opened_tm",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from printing.settings_changed
    ///
    /// A count of how many times the user changed a setting in print preview, broken
    /// down per setting. This metric was generated to correspond to the Legacy
    /// Telemetry scalar printing.settings_changed.
    pub static settings_changed: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "settings_changed".into(),
                    category: "printing".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3965.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from printing.silent_print
    ///
    /// A counter incremented every time a silent print (a print without a print
    /// settings dialog being opened) is initiated.  This happens when extensions
    /// invoke ExtensionAPI.tabs.saveAsPDF, for example, or when the
    /// print.always_print_silent pref is set. This metric was generated to correspond
    /// to the Legacy Telemetry scalar printing.silent_print.
    pub static silent_print: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3966,
            "printing",
            "silent_print",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum TargetTypeLabel {
        EPdfFile = 0,
        EPdfUnknown = 1,
        EXpsFile = 2,
        EUnknown = 3,
        __Other__,
    }
    impl From<u16> for TargetTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPdfFile,
                1 => Self::EPdfUnknown,
                2 => Self::EXpsFile,
                3 => Self::EUnknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TargetTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPdfFile => "pdf_file",
                Self::EPdfUnknown => "pdf_unknown",
                Self::EXpsFile => "xps_file",
                Self::EUnknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from printing.target_type
    ///
    /// A counter incremented every time the user prints to a certain target type.  The
    /// 'pdf_unknown' count is for printers with names that we don't know about/check
    /// for, but that have 'pdf' in their name, and is mainly a sanity check that we're
    /// not missing significant counts in 'pdf_file'. For the most part, the 'unknown'
    /// count will be prints to a physical printer, but we can't know for sure since
    /// third party drivers could also be print to file drivers that we don't otherwise
    /// catch in the other counts. This metric was generated to correspond to the
    /// Legacy Telemetry scalar printing.target_type.
    pub static target_type: Lazy<LabeledMetric<LabeledCounterMetric, TargetTypeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "target_type".into(),
                    category: "printing".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3967.into(), meta, Some(vec![::std::borrow::Cow::from("pdf_file"), ::std::borrow::Cow::from("pdf_unknown"), ::std::borrow::Cow::from("unknown"), ::std::borrow::Cow::from("xps_file")]))
    });

}
pub mod power {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_time_bogus_values
    ///
    /// Impossibly large CPU time values that were discarded.
    pub static cpu_time_bogus_values: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3968,
            "power",
            "cpu_time_bogus_values",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum CpuTimePerProcessTypeMsLabel {
        EParentActive = 0,
        EParentActivePlayingAudio = 1,
        EParentActivePlayingVideo = 2,
        EParentInactive = 3,
        EParentInactivePlayingAudio = 4,
        EParentInactivePlayingVideo = 5,
        EPrealloc = 6,
        EPrivilegedabout = 7,
        ERdd = 8,
        ESocket = 9,
        EWebBackground = 10,
        EWebBackgroundPerceivable = 11,
        EWebForeground = 12,
        EExtension = 13,
        EGpu = 14,
        EGmplugin = 15,
        EUtility = 16,
        __Other__,
    }
    impl From<u16> for CpuTimePerProcessTypeMsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EParentActive,
                1 => Self::EParentActivePlayingAudio,
                2 => Self::EParentActivePlayingVideo,
                3 => Self::EParentInactive,
                4 => Self::EParentInactivePlayingAudio,
                5 => Self::EParentInactivePlayingVideo,
                6 => Self::EPrealloc,
                7 => Self::EPrivilegedabout,
                8 => Self::ERdd,
                9 => Self::ESocket,
                10 => Self::EWebBackground,
                11 => Self::EWebBackgroundPerceivable,
                12 => Self::EWebForeground,
                13 => Self::EExtension,
                14 => Self::EGpu,
                15 => Self::EGmplugin,
                16 => Self::EUtility,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CpuTimePerProcessTypeMsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EParentActive => "parent.active",
                Self::EParentActivePlayingAudio => "parent.active.playing-audio",
                Self::EParentActivePlayingVideo => "parent.active.playing-video",
                Self::EParentInactive => "parent.inactive",
                Self::EParentInactivePlayingAudio => "parent.inactive.playing-audio",
                Self::EParentInactivePlayingVideo => "parent.inactive.playing-video",
                Self::EPrealloc => "prealloc",
                Self::EPrivilegedabout => "privilegedabout",
                Self::ERdd => "rdd",
                Self::ESocket => "socket",
                Self::EWebBackground => "web.background",
                Self::EWebBackgroundPerceivable => "web.background-perceivable",
                Self::EWebForeground => "web.foreground",
                Self::EExtension => "extension",
                Self::EGpu => "gpu",
                Self::EGmplugin => "gmplugin",
                Self::EUtility => "utility",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_time_per_process_type_ms
    ///
    /// CPU time used by each process type in ms.
    pub static cpu_time_per_process_type_ms: Lazy<LabeledMetric<LabeledCounterMetric, CpuTimePerProcessTypeMsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cpu_time_per_process_type_ms".into(),
                    category: "power".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3969.into(), meta, Some(vec![::std::borrow::Cow::from("extension"), ::std::borrow::Cow::from("gmplugin"), ::std::borrow::Cow::from("gpu"), ::std::borrow::Cow::from("parent.active"), ::std::borrow::Cow::from("parent.active.playing-audio"), ::std::borrow::Cow::from("parent.active.playing-video"), ::std::borrow::Cow::from("parent.inactive"), ::std::borrow::Cow::from("parent.inactive.playing-audio"), ::std::borrow::Cow::from("parent.inactive.playing-video"), ::std::borrow::Cow::from("prealloc"), ::std::borrow::Cow::from("privilegedabout"), ::std::borrow::Cow::from("rdd"), ::std::borrow::Cow::from("socket"), ::std::borrow::Cow::from("utility"), ::std::borrow::Cow::from("web.background"), ::std::borrow::Cow::from("web.background-perceivable"), ::std::borrow::Cow::from("web.foreground")]))
    });

    #[repr(u16)]
    pub enum CpuTimePerTrackerTypeMsLabel {
        EAd = 0,
        EAnalytics = 1,
        ECryptomining = 2,
        EFingerprinting = 3,
        ESocial = 4,
        EUnknown = 5,
        __Other__,
    }
    impl From<u16> for CpuTimePerTrackerTypeMsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAd,
                1 => Self::EAnalytics,
                2 => Self::ECryptomining,
                3 => Self::EFingerprinting,
                4 => Self::ESocial,
                5 => Self::EUnknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CpuTimePerTrackerTypeMsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAd => "ad",
                Self::EAnalytics => "analytics",
                Self::ECryptomining => "cryptomining",
                Self::EFingerprinting => "fingerprinting",
                Self::ESocial => "social",
                Self::EUnknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_time_per_tracker_type_ms
    ///
    /// CPU time used by content processes used only for tracking resources, labeled by
    /// the category of the tracker.
    pub static cpu_time_per_tracker_type_ms: Lazy<LabeledMetric<LabeledCounterMetric, CpuTimePerTrackerTypeMsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cpu_time_per_tracker_type_ms".into(),
                    category: "power".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3970.into(), meta, Some(vec![::std::borrow::Cow::from("ad"), ::std::borrow::Cow::from("analytics"), ::std::borrow::Cow::from("cryptomining"), ::std::borrow::Cow::from("fingerprinting"), ::std::borrow::Cow::from("social"), ::std::borrow::Cow::from("unknown")]))
    });

    #[repr(u16)]
    pub enum EnergyPerProcessTypeLabel {
        EParentActive = 0,
        EParentActivePlayingAudio = 1,
        EParentActivePlayingVideo = 2,
        EParentInactive = 3,
        EParentInactivePlayingAudio = 4,
        EParentInactivePlayingVideo = 5,
        EPrealloc = 6,
        EPrivilegedabout = 7,
        ERdd = 8,
        ESocket = 9,
        EWebBackground = 10,
        EWebBackgroundPerceivable = 11,
        EWebForeground = 12,
        EExtension = 13,
        EGpu = 14,
        EGmplugin = 15,
        EUtility = 16,
        __Other__,
    }
    impl From<u16> for EnergyPerProcessTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EParentActive,
                1 => Self::EParentActivePlayingAudio,
                2 => Self::EParentActivePlayingVideo,
                3 => Self::EParentInactive,
                4 => Self::EParentInactivePlayingAudio,
                5 => Self::EParentInactivePlayingVideo,
                6 => Self::EPrealloc,
                7 => Self::EPrivilegedabout,
                8 => Self::ERdd,
                9 => Self::ESocket,
                10 => Self::EWebBackground,
                11 => Self::EWebBackgroundPerceivable,
                12 => Self::EWebForeground,
                13 => Self::EExtension,
                14 => Self::EGpu,
                15 => Self::EGmplugin,
                16 => Self::EUtility,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EnergyPerProcessTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EParentActive => "parent.active",
                Self::EParentActivePlayingAudio => "parent.active.playing-audio",
                Self::EParentActivePlayingVideo => "parent.active.playing-video",
                Self::EParentInactive => "parent.inactive",
                Self::EParentInactivePlayingAudio => "parent.inactive.playing-audio",
                Self::EParentInactivePlayingVideo => "parent.inactive.playing-video",
                Self::EPrealloc => "prealloc",
                Self::EPrivilegedabout => "privilegedabout",
                Self::ERdd => "rdd",
                Self::ESocket => "socket",
                Self::EWebBackground => "web.background",
                Self::EWebBackgroundPerceivable => "web.background-perceivable",
                Self::EWebForeground => "web.foreground",
                Self::EExtension => "extension",
                Self::EGpu => "gpu",
                Self::EGmplugin => "gmplugin",
                Self::EUtility => "utility",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.energy_per_process_type
    ///
    /// How much energy (in µWh) has been used, broken down by process type. Only
    /// available on Apple Silicon.
    pub static energy_per_process_type: Lazy<LabeledMetric<LabeledCounterMetric, EnergyPerProcessTypeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "energy_per_process_type".into(),
                    category: "power".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3971.into(), meta, Some(vec![::std::borrow::Cow::from("extension"), ::std::borrow::Cow::from("gmplugin"), ::std::borrow::Cow::from("gpu"), ::std::borrow::Cow::from("parent.active"), ::std::borrow::Cow::from("parent.active.playing-audio"), ::std::borrow::Cow::from("parent.active.playing-video"), ::std::borrow::Cow::from("parent.inactive"), ::std::borrow::Cow::from("parent.inactive.playing-audio"), ::std::borrow::Cow::from("parent.inactive.playing-video"), ::std::borrow::Cow::from("prealloc"), ::std::borrow::Cow::from("privilegedabout"), ::std::borrow::Cow::from("rdd"), ::std::borrow::Cow::from("socket"), ::std::borrow::Cow::from("utility"), ::std::borrow::Cow::from("web.background"), ::std::borrow::Cow::from("web.background-perceivable"), ::std::borrow::Cow::from("web.foreground")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.gpu_time_bogus_values
    ///
    /// Impossibly large GPU time values that were discarded.
    pub static gpu_time_bogus_values: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3972,
            "power",
            "gpu_time_bogus_values",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum GpuTimePerProcessTypeMsLabel {
        EParentActive = 0,
        EParentActivePlayingAudio = 1,
        EParentActivePlayingVideo = 2,
        EParentInactive = 3,
        EParentInactivePlayingAudio = 4,
        EParentInactivePlayingVideo = 5,
        EPrealloc = 6,
        EPrivilegedabout = 7,
        ERdd = 8,
        ESocket = 9,
        EWebBackground = 10,
        EWebBackgroundPerceivable = 11,
        EWebForeground = 12,
        EExtension = 13,
        EGpu = 14,
        EGmplugin = 15,
        EUtility = 16,
        __Other__,
    }
    impl From<u16> for GpuTimePerProcessTypeMsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EParentActive,
                1 => Self::EParentActivePlayingAudio,
                2 => Self::EParentActivePlayingVideo,
                3 => Self::EParentInactive,
                4 => Self::EParentInactivePlayingAudio,
                5 => Self::EParentInactivePlayingVideo,
                6 => Self::EPrealloc,
                7 => Self::EPrivilegedabout,
                8 => Self::ERdd,
                9 => Self::ESocket,
                10 => Self::EWebBackground,
                11 => Self::EWebBackgroundPerceivable,
                12 => Self::EWebForeground,
                13 => Self::EExtension,
                14 => Self::EGpu,
                15 => Self::EGmplugin,
                16 => Self::EUtility,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GpuTimePerProcessTypeMsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EParentActive => "parent.active",
                Self::EParentActivePlayingAudio => "parent.active.playing-audio",
                Self::EParentActivePlayingVideo => "parent.active.playing-video",
                Self::EParentInactive => "parent.inactive",
                Self::EParentInactivePlayingAudio => "parent.inactive.playing-audio",
                Self::EParentInactivePlayingVideo => "parent.inactive.playing-video",
                Self::EPrealloc => "prealloc",
                Self::EPrivilegedabout => "privilegedabout",
                Self::ERdd => "rdd",
                Self::ESocket => "socket",
                Self::EWebBackground => "web.background",
                Self::EWebBackgroundPerceivable => "web.background-perceivable",
                Self::EWebForeground => "web.foreground",
                Self::EExtension => "extension",
                Self::EGpu => "gpu",
                Self::EGmplugin => "gmplugin",
                Self::EUtility => "utility",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.gpu_time_per_process_type_ms
    ///
    /// GPU time used by each process type in ms.
    pub static gpu_time_per_process_type_ms: Lazy<LabeledMetric<LabeledCounterMetric, GpuTimePerProcessTypeMsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "gpu_time_per_process_type_ms".into(),
                    category: "power".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3973.into(), meta, Some(vec![::std::borrow::Cow::from("extension"), ::std::borrow::Cow::from("gmplugin"), ::std::borrow::Cow::from("gpu"), ::std::borrow::Cow::from("parent.active"), ::std::borrow::Cow::from("parent.active.playing-audio"), ::std::borrow::Cow::from("parent.active.playing-video"), ::std::borrow::Cow::from("parent.inactive"), ::std::borrow::Cow::from("parent.inactive.playing-audio"), ::std::borrow::Cow::from("parent.inactive.playing-video"), ::std::borrow::Cow::from("prealloc"), ::std::borrow::Cow::from("privilegedabout"), ::std::borrow::Cow::from("rdd"), ::std::borrow::Cow::from("socket"), ::std::borrow::Cow::from("utility"), ::std::borrow::Cow::from("web.background"), ::std::borrow::Cow::from("web.background-perceivable"), ::std::borrow::Cow::from("web.foreground")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.total_cpu_time_ms
    ///
    /// Total CPU time used by all processes in ms.
    pub static total_cpu_time_ms: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3974,
            "power",
            "total_cpu_time_ms",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.total_gpu_time_ms
    ///
    /// Total GPU time used by all processes in ms.
    pub static total_gpu_time_ms: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3975,
            "power",
            "total_gpu_time_ms",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.total_thread_wakeups
    ///
    /// How many times threads woke up and could have woken up a CPU core.
    pub static total_thread_wakeups: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3976,
            "power",
            "total_thread_wakeups",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum WakeupsPerProcessTypeLabel {
        EParentActive = 0,
        EParentActivePlayingAudio = 1,
        EParentActivePlayingVideo = 2,
        EParentInactive = 3,
        EParentInactivePlayingAudio = 4,
        EParentInactivePlayingVideo = 5,
        EPrealloc = 6,
        EPrivilegedabout = 7,
        ERdd = 8,
        ESocket = 9,
        EWebBackground = 10,
        EWebBackgroundPerceivable = 11,
        EWebForeground = 12,
        EExtension = 13,
        EGpu = 14,
        EGmplugin = 15,
        EUtility = 16,
        __Other__,
    }
    impl From<u16> for WakeupsPerProcessTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EParentActive,
                1 => Self::EParentActivePlayingAudio,
                2 => Self::EParentActivePlayingVideo,
                3 => Self::EParentInactive,
                4 => Self::EParentInactivePlayingAudio,
                5 => Self::EParentInactivePlayingVideo,
                6 => Self::EPrealloc,
                7 => Self::EPrivilegedabout,
                8 => Self::ERdd,
                9 => Self::ESocket,
                10 => Self::EWebBackground,
                11 => Self::EWebBackgroundPerceivable,
                12 => Self::EWebForeground,
                13 => Self::EExtension,
                14 => Self::EGpu,
                15 => Self::EGmplugin,
                16 => Self::EUtility,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for WakeupsPerProcessTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EParentActive => "parent.active",
                Self::EParentActivePlayingAudio => "parent.active.playing-audio",
                Self::EParentActivePlayingVideo => "parent.active.playing-video",
                Self::EParentInactive => "parent.inactive",
                Self::EParentInactivePlayingAudio => "parent.inactive.playing-audio",
                Self::EParentInactivePlayingVideo => "parent.inactive.playing-video",
                Self::EPrealloc => "prealloc",
                Self::EPrivilegedabout => "privilegedabout",
                Self::ERdd => "rdd",
                Self::ESocket => "socket",
                Self::EWebBackground => "web.background",
                Self::EWebBackgroundPerceivable => "web.background-perceivable",
                Self::EWebForeground => "web.foreground",
                Self::EExtension => "extension",
                Self::EGpu => "gpu",
                Self::EGmplugin => "gmplugin",
                Self::EUtility => "utility",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_process_type
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by process type.
    pub static wakeups_per_process_type: Lazy<LabeledMetric<LabeledCounterMetric, WakeupsPerProcessTypeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "wakeups_per_process_type".into(),
                    category: "power".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3977.into(), meta, Some(vec![::std::borrow::Cow::from("extension"), ::std::borrow::Cow::from("gmplugin"), ::std::borrow::Cow::from("gpu"), ::std::borrow::Cow::from("parent.active"), ::std::borrow::Cow::from("parent.active.playing-audio"), ::std::borrow::Cow::from("parent.active.playing-video"), ::std::borrow::Cow::from("parent.inactive"), ::std::borrow::Cow::from("parent.inactive.playing-audio"), ::std::borrow::Cow::from("parent.inactive.playing-video"), ::std::borrow::Cow::from("prealloc"), ::std::borrow::Cow::from("privilegedabout"), ::std::borrow::Cow::from("rdd"), ::std::borrow::Cow::from("socket"), ::std::borrow::Cow::from("utility"), ::std::borrow::Cow::from("web.background"), ::std::borrow::Cow::from("web.background-perceivable"), ::std::borrow::Cow::from("web.foreground")]))
    });

}
pub mod power_battery {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from power.battery.percentage_when_user_active
    ///
    /// Records how many percent of battery was available for each period of user
    /// activity.
    pub static percentage_when_user_active: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "percentage_when_user_active".into(),
                category: "power.battery".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(3978.into(), meta, 0, 100, 100, HistogramType::Linear)
    });

}
pub mod power_cpu_ms_per_thread {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum ContentBackgroundLabel {
        EAndroidui = 0,
        EAsynclogger = 1,
        EAudioipc = 2,
        EAudioipcCallbackRpc = 3,
        EAudioipcClientCallback = 4,
        EAudioipcClientRpc = 5,
        EAudioipcDevicecollectionRpc = 6,
        EAudioipcServerCallback = 7,
        EAudioipcServerRpc = 8,
        EBackgroundthreadpool = 9,
        EBgiothreadpool = 10,
        EBgreadurls = 11,
        EBhmgrMonitor = 12,
        EBhmgrProcessor = 13,
        ECamerasIpc = 14,
        ECanvasrenderer = 15,
        ECapturethread = 16,
        EClassifierUpdate = 17,
        EComMta = 18,
        ECompositor = 19,
        EConvolverworker = 20,
        ECookie = 21,
        ECubeboperation = 22,
        EDatachannelIo = 23,
        EDnsResolver = 24,
        EDomWorker = 25,
        EDomWorklet = 26,
        EDomcachethread = 27,
        EExtensionprotocolhandler = 28,
        EFontLoader = 29,
        EFontenumthread = 30,
        EFsBroker = 31,
        EGeckomain = 32,
        EGmpthread = 33,
        EGraphrunner = 34,
        EHrtfdatabaseldr = 35,
        EHtml5Parser = 36,
        EImagebridgechld = 37,
        EImageio = 38,
        EIndexeddb = 39,
        EInitfontlist = 40,
        EInotifyeventthread = 41,
        EIndexeddbIo = 42,
        EIpcIOChild = 43,
        EIpcIOParent = 44,
        EIpcLaunch = 45,
        EIpdlBackground = 46,
        EJsWatchdog = 47,
        EJumpList = 48,
        ELibwebrtcmodulethread = 49,
        ELinkMonitor = 50,
        ELsThread = 51,
        EMdnsService = 52,
        EMediacache = 53,
        EMediadecoderstatemachine = 54,
        EMediapdecoder = 55,
        EMediasupervisor = 56,
        EMediatimer = 57,
        EMediatrackgrph = 58,
        EMemorypoller = 59,
        EMozstorage = 60,
        EMtransport = 61,
        ENetlinkMonitor = 62,
        EPacerthread = 63,
        EPermission = 64,
        EPlayeventsound = 65,
        EProcesshangmon = 66,
        EProfilerchild = 67,
        EProxyresolution = 68,
        EQuotamanagerIo = 69,
        ERegisterfonts = 70,
        ERemotebackbuffer = 71,
        ERemotelzystream = 72,
        ERemvidchild = 73,
        ERenderer = 74,
        ESandboxreporter = 75,
        ESavescripts = 76,
        ESocketThread = 77,
        ESoftwarevsyncthread = 78,
        ESqldbContentPrefsSqlite = 79,
        ESqldbCookiesSqlite = 80,
        ESqldbFormhistorySqlite = 81,
        ESslCert = 82,
        EStartupcache = 83,
        EStreamtrans = 84,
        EStylethread = 85,
        ESwcomposite = 86,
        ETaskcontroller = 87,
        ETimer = 88,
        EToastbgthread = 89,
        ETrrBackground = 90,
        EUntrustedModules = 91,
        EUrlClassifier = 92,
        EVideocapture = 93,
        EVsynciothread = 94,
        EWebrtccallthread = 95,
        EWebrtcworker = 96,
        EWincompositor = 97,
        EWindowsvsyncthread = 98,
        EWinwindowocclusioncalc = 99,
        EWifiTickler = 100,
        EWorkerLauncher = 101,
        EWrrenderbackend = 102,
        EWrscenebuilder = 103,
        EWrscenebuilderlp = 104,
        EWrworker = 105,
        EWrworkerlp = 106,
        __Other__,
    }
    impl From<u16> for ContentBackgroundLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAndroidui,
                1 => Self::EAsynclogger,
                2 => Self::EAudioipc,
                3 => Self::EAudioipcCallbackRpc,
                4 => Self::EAudioipcClientCallback,
                5 => Self::EAudioipcClientRpc,
                6 => Self::EAudioipcDevicecollectionRpc,
                7 => Self::EAudioipcServerCallback,
                8 => Self::EAudioipcServerRpc,
                9 => Self::EBackgroundthreadpool,
                10 => Self::EBgiothreadpool,
                11 => Self::EBgreadurls,
                12 => Self::EBhmgrMonitor,
                13 => Self::EBhmgrProcessor,
                14 => Self::ECamerasIpc,
                15 => Self::ECanvasrenderer,
                16 => Self::ECapturethread,
                17 => Self::EClassifierUpdate,
                18 => Self::EComMta,
                19 => Self::ECompositor,
                20 => Self::EConvolverworker,
                21 => Self::ECookie,
                22 => Self::ECubeboperation,
                23 => Self::EDatachannelIo,
                24 => Self::EDnsResolver,
                25 => Self::EDomWorker,
                26 => Self::EDomWorklet,
                27 => Self::EDomcachethread,
                28 => Self::EExtensionprotocolhandler,
                29 => Self::EFontLoader,
                30 => Self::EFontenumthread,
                31 => Self::EFsBroker,
                32 => Self::EGeckomain,
                33 => Self::EGmpthread,
                34 => Self::EGraphrunner,
                35 => Self::EHrtfdatabaseldr,
                36 => Self::EHtml5Parser,
                37 => Self::EImagebridgechld,
                38 => Self::EImageio,
                39 => Self::EIndexeddb,
                40 => Self::EInitfontlist,
                41 => Self::EInotifyeventthread,
                42 => Self::EIndexeddbIo,
                43 => Self::EIpcIOChild,
                44 => Self::EIpcIOParent,
                45 => Self::EIpcLaunch,
                46 => Self::EIpdlBackground,
                47 => Self::EJsWatchdog,
                48 => Self::EJumpList,
                49 => Self::ELibwebrtcmodulethread,
                50 => Self::ELinkMonitor,
                51 => Self::ELsThread,
                52 => Self::EMdnsService,
                53 => Self::EMediacache,
                54 => Self::EMediadecoderstatemachine,
                55 => Self::EMediapdecoder,
                56 => Self::EMediasupervisor,
                57 => Self::EMediatimer,
                58 => Self::EMediatrackgrph,
                59 => Self::EMemorypoller,
                60 => Self::EMozstorage,
                61 => Self::EMtransport,
                62 => Self::ENetlinkMonitor,
                63 => Self::EPacerthread,
                64 => Self::EPermission,
                65 => Self::EPlayeventsound,
                66 => Self::EProcesshangmon,
                67 => Self::EProfilerchild,
                68 => Self::EProxyresolution,
                69 => Self::EQuotamanagerIo,
                70 => Self::ERegisterfonts,
                71 => Self::ERemotebackbuffer,
                72 => Self::ERemotelzystream,
                73 => Self::ERemvidchild,
                74 => Self::ERenderer,
                75 => Self::ESandboxreporter,
                76 => Self::ESavescripts,
                77 => Self::ESocketThread,
                78 => Self::ESoftwarevsyncthread,
                79 => Self::ESqldbContentPrefsSqlite,
                80 => Self::ESqldbCookiesSqlite,
                81 => Self::ESqldbFormhistorySqlite,
                82 => Self::ESslCert,
                83 => Self::EStartupcache,
                84 => Self::EStreamtrans,
                85 => Self::EStylethread,
                86 => Self::ESwcomposite,
                87 => Self::ETaskcontroller,
                88 => Self::ETimer,
                89 => Self::EToastbgthread,
                90 => Self::ETrrBackground,
                91 => Self::EUntrustedModules,
                92 => Self::EUrlClassifier,
                93 => Self::EVideocapture,
                94 => Self::EVsynciothread,
                95 => Self::EWebrtccallthread,
                96 => Self::EWebrtcworker,
                97 => Self::EWincompositor,
                98 => Self::EWindowsvsyncthread,
                99 => Self::EWinwindowocclusioncalc,
                100 => Self::EWifiTickler,
                101 => Self::EWorkerLauncher,
                102 => Self::EWrrenderbackend,
                103 => Self::EWrscenebuilder,
                104 => Self::EWrscenebuilderlp,
                105 => Self::EWrworker,
                106 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ContentBackgroundLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAndroidui => "androidui",
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECanvasrenderer => "canvasrenderer",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::EConvolverworker => "convolverworker",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomWorklet => "dom_worklet",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHrtfdatabaseldr => "hrtfdatabaseldr",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIndexeddbIo => "indexeddb_io",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMdnsService => "mdns_service",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESqldbContentPrefsSqlite => "sqldb_content-prefs_sqlite",
                Self::ESqldbCookiesSqlite => "sqldb_cookies_sqlite",
                Self::ESqldbFormhistorySqlite => "sqldb_formhistory_sqlite",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWifiTickler => "wifi_tickler",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.content_background
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a
    /// given process type.
    pub static content_background: Lazy<LabeledMetric<LabeledCounterMetric, ContentBackgroundLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "content_background".into(),
                    category: "power.cpu_ms_per_thread".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3979.into(), meta, Some(vec![::std::borrow::Cow::from("androidui"), ::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("canvasrenderer"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("convolverworker"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("dom_worklet"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("hrtfdatabaseldr"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("indexeddb_io"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mdns_service"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("sqldb_content-prefs_sqlite"), ::std::borrow::Cow::from("sqldb_cookies_sqlite"), ::std::borrow::Cow::from("sqldb_formhistory_sqlite"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wifi_tickler"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ContentForegroundLabel {
        EAndroidui = 0,
        EAsynclogger = 1,
        EAudioipc = 2,
        EAudioipcCallbackRpc = 3,
        EAudioipcClientCallback = 4,
        EAudioipcClientRpc = 5,
        EAudioipcDevicecollectionRpc = 6,
        EAudioipcServerCallback = 7,
        EAudioipcServerRpc = 8,
        EBackgroundthreadpool = 9,
        EBgiothreadpool = 10,
        EBgreadurls = 11,
        EBhmgrMonitor = 12,
        EBhmgrProcessor = 13,
        ECamerasIpc = 14,
        ECanvasrenderer = 15,
        ECapturethread = 16,
        EClassifierUpdate = 17,
        EComMta = 18,
        ECompositor = 19,
        EConvolverworker = 20,
        ECookie = 21,
        ECubeboperation = 22,
        EDatachannelIo = 23,
        EDnsResolver = 24,
        EDomWorker = 25,
        EDomWorklet = 26,
        EDomcachethread = 27,
        EExtensionprotocolhandler = 28,
        EFontLoader = 29,
        EFontenumthread = 30,
        EFsBroker = 31,
        EGeckomain = 32,
        EGmpthread = 33,
        EGraphrunner = 34,
        EHrtfdatabaseldr = 35,
        EHtml5Parser = 36,
        EImagebridgechld = 37,
        EImageio = 38,
        EIndexeddb = 39,
        EInitfontlist = 40,
        EInotifyeventthread = 41,
        EIndexeddbIo = 42,
        EIpcIOChild = 43,
        EIpcIOParent = 44,
        EIpcLaunch = 45,
        EIpdlBackground = 46,
        EJsWatchdog = 47,
        EJumpList = 48,
        ELibwebrtcmodulethread = 49,
        ELinkMonitor = 50,
        ELsThread = 51,
        EMdnsService = 52,
        EMediacache = 53,
        EMediadecoderstatemachine = 54,
        EMediapdecoder = 55,
        EMediasupervisor = 56,
        EMediatimer = 57,
        EMediatrackgrph = 58,
        EMemorypoller = 59,
        EMozstorage = 60,
        EMtransport = 61,
        ENetlinkMonitor = 62,
        EPacerthread = 63,
        EPermission = 64,
        EPlayeventsound = 65,
        EProcesshangmon = 66,
        EProfilerchild = 67,
        EProxyresolution = 68,
        EQuotamanagerIo = 69,
        ERegisterfonts = 70,
        ERemotebackbuffer = 71,
        ERemotelzystream = 72,
        ERemvidchild = 73,
        ERenderer = 74,
        ESandboxreporter = 75,
        ESavescripts = 76,
        ESocketThread = 77,
        ESoftwarevsyncthread = 78,
        ESqldbContentPrefsSqlite = 79,
        ESqldbCookiesSqlite = 80,
        ESqldbFormhistorySqlite = 81,
        ESslCert = 82,
        EStartupcache = 83,
        EStreamtrans = 84,
        EStylethread = 85,
        ESwcomposite = 86,
        ETaskcontroller = 87,
        ETimer = 88,
        EToastbgthread = 89,
        ETrrBackground = 90,
        EUntrustedModules = 91,
        EUrlClassifier = 92,
        EVideocapture = 93,
        EVsynciothread = 94,
        EWebrtccallthread = 95,
        EWebrtcworker = 96,
        EWincompositor = 97,
        EWindowsvsyncthread = 98,
        EWinwindowocclusioncalc = 99,
        EWifiTickler = 100,
        EWorkerLauncher = 101,
        EWrrenderbackend = 102,
        EWrscenebuilder = 103,
        EWrscenebuilderlp = 104,
        EWrworker = 105,
        EWrworkerlp = 106,
        __Other__,
    }
    impl From<u16> for ContentForegroundLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAndroidui,
                1 => Self::EAsynclogger,
                2 => Self::EAudioipc,
                3 => Self::EAudioipcCallbackRpc,
                4 => Self::EAudioipcClientCallback,
                5 => Self::EAudioipcClientRpc,
                6 => Self::EAudioipcDevicecollectionRpc,
                7 => Self::EAudioipcServerCallback,
                8 => Self::EAudioipcServerRpc,
                9 => Self::EBackgroundthreadpool,
                10 => Self::EBgiothreadpool,
                11 => Self::EBgreadurls,
                12 => Self::EBhmgrMonitor,
                13 => Self::EBhmgrProcessor,
                14 => Self::ECamerasIpc,
                15 => Self::ECanvasrenderer,
                16 => Self::ECapturethread,
                17 => Self::EClassifierUpdate,
                18 => Self::EComMta,
                19 => Self::ECompositor,
                20 => Self::EConvolverworker,
                21 => Self::ECookie,
                22 => Self::ECubeboperation,
                23 => Self::EDatachannelIo,
                24 => Self::EDnsResolver,
                25 => Self::EDomWorker,
                26 => Self::EDomWorklet,
                27 => Self::EDomcachethread,
                28 => Self::EExtensionprotocolhandler,
                29 => Self::EFontLoader,
                30 => Self::EFontenumthread,
                31 => Self::EFsBroker,
                32 => Self::EGeckomain,
                33 => Self::EGmpthread,
                34 => Self::EGraphrunner,
                35 => Self::EHrtfdatabaseldr,
                36 => Self::EHtml5Parser,
                37 => Self::EImagebridgechld,
                38 => Self::EImageio,
                39 => Self::EIndexeddb,
                40 => Self::EInitfontlist,
                41 => Self::EInotifyeventthread,
                42 => Self::EIndexeddbIo,
                43 => Self::EIpcIOChild,
                44 => Self::EIpcIOParent,
                45 => Self::EIpcLaunch,
                46 => Self::EIpdlBackground,
                47 => Self::EJsWatchdog,
                48 => Self::EJumpList,
                49 => Self::ELibwebrtcmodulethread,
                50 => Self::ELinkMonitor,
                51 => Self::ELsThread,
                52 => Self::EMdnsService,
                53 => Self::EMediacache,
                54 => Self::EMediadecoderstatemachine,
                55 => Self::EMediapdecoder,
                56 => Self::EMediasupervisor,
                57 => Self::EMediatimer,
                58 => Self::EMediatrackgrph,
                59 => Self::EMemorypoller,
                60 => Self::EMozstorage,
                61 => Self::EMtransport,
                62 => Self::ENetlinkMonitor,
                63 => Self::EPacerthread,
                64 => Self::EPermission,
                65 => Self::EPlayeventsound,
                66 => Self::EProcesshangmon,
                67 => Self::EProfilerchild,
                68 => Self::EProxyresolution,
                69 => Self::EQuotamanagerIo,
                70 => Self::ERegisterfonts,
                71 => Self::ERemotebackbuffer,
                72 => Self::ERemotelzystream,
                73 => Self::ERemvidchild,
                74 => Self::ERenderer,
                75 => Self::ESandboxreporter,
                76 => Self::ESavescripts,
                77 => Self::ESocketThread,
                78 => Self::ESoftwarevsyncthread,
                79 => Self::ESqldbContentPrefsSqlite,
                80 => Self::ESqldbCookiesSqlite,
                81 => Self::ESqldbFormhistorySqlite,
                82 => Self::ESslCert,
                83 => Self::EStartupcache,
                84 => Self::EStreamtrans,
                85 => Self::EStylethread,
                86 => Self::ESwcomposite,
                87 => Self::ETaskcontroller,
                88 => Self::ETimer,
                89 => Self::EToastbgthread,
                90 => Self::ETrrBackground,
                91 => Self::EUntrustedModules,
                92 => Self::EUrlClassifier,
                93 => Self::EVideocapture,
                94 => Self::EVsynciothread,
                95 => Self::EWebrtccallthread,
                96 => Self::EWebrtcworker,
                97 => Self::EWincompositor,
                98 => Self::EWindowsvsyncthread,
                99 => Self::EWinwindowocclusioncalc,
                100 => Self::EWifiTickler,
                101 => Self::EWorkerLauncher,
                102 => Self::EWrrenderbackend,
                103 => Self::EWrscenebuilder,
                104 => Self::EWrscenebuilderlp,
                105 => Self::EWrworker,
                106 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ContentForegroundLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAndroidui => "androidui",
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECanvasrenderer => "canvasrenderer",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::EConvolverworker => "convolverworker",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomWorklet => "dom_worklet",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHrtfdatabaseldr => "hrtfdatabaseldr",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIndexeddbIo => "indexeddb_io",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMdnsService => "mdns_service",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESqldbContentPrefsSqlite => "sqldb_content-prefs_sqlite",
                Self::ESqldbCookiesSqlite => "sqldb_cookies_sqlite",
                Self::ESqldbFormhistorySqlite => "sqldb_formhistory_sqlite",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWifiTickler => "wifi_tickler",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.content_foreground
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a
    /// given process type.
    pub static content_foreground: Lazy<LabeledMetric<LabeledCounterMetric, ContentForegroundLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "content_foreground".into(),
                    category: "power.cpu_ms_per_thread".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3980.into(), meta, Some(vec![::std::borrow::Cow::from("androidui"), ::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("canvasrenderer"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("convolverworker"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("dom_worklet"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("hrtfdatabaseldr"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("indexeddb_io"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mdns_service"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("sqldb_content-prefs_sqlite"), ::std::borrow::Cow::from("sqldb_cookies_sqlite"), ::std::borrow::Cow::from("sqldb_formhistory_sqlite"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wifi_tickler"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum GpuProcessLabel {
        EAndroidui = 0,
        EAsynclogger = 1,
        EAudioipc = 2,
        EAudioipcCallbackRpc = 3,
        EAudioipcClientCallback = 4,
        EAudioipcClientRpc = 5,
        EAudioipcDevicecollectionRpc = 6,
        EAudioipcServerCallback = 7,
        EAudioipcServerRpc = 8,
        EBackgroundthreadpool = 9,
        EBgiothreadpool = 10,
        EBgreadurls = 11,
        EBhmgrMonitor = 12,
        EBhmgrProcessor = 13,
        ECamerasIpc = 14,
        ECanvasrenderer = 15,
        ECapturethread = 16,
        EClassifierUpdate = 17,
        EComMta = 18,
        ECompositor = 19,
        EConvolverworker = 20,
        ECookie = 21,
        ECubeboperation = 22,
        EDatachannelIo = 23,
        EDnsResolver = 24,
        EDomWorker = 25,
        EDomWorklet = 26,
        EDomcachethread = 27,
        EExtensionprotocolhandler = 28,
        EFontLoader = 29,
        EFontenumthread = 30,
        EFsBroker = 31,
        EGeckomain = 32,
        EGmpthread = 33,
        EGraphrunner = 34,
        EHrtfdatabaseldr = 35,
        EHtml5Parser = 36,
        EImagebridgechld = 37,
        EImageio = 38,
        EIndexeddb = 39,
        EInitfontlist = 40,
        EInotifyeventthread = 41,
        EIndexeddbIo = 42,
        EIpcIOChild = 43,
        EIpcIOParent = 44,
        EIpcLaunch = 45,
        EIpdlBackground = 46,
        EJsWatchdog = 47,
        EJumpList = 48,
        ELibwebrtcmodulethread = 49,
        ELinkMonitor = 50,
        ELsThread = 51,
        EMdnsService = 52,
        EMediacache = 53,
        EMediadecoderstatemachine = 54,
        EMediapdecoder = 55,
        EMediasupervisor = 56,
        EMediatimer = 57,
        EMediatrackgrph = 58,
        EMemorypoller = 59,
        EMozstorage = 60,
        EMtransport = 61,
        ENetlinkMonitor = 62,
        EPacerthread = 63,
        EPermission = 64,
        EPlayeventsound = 65,
        EProcesshangmon = 66,
        EProfilerchild = 67,
        EProxyresolution = 68,
        EQuotamanagerIo = 69,
        ERegisterfonts = 70,
        ERemotebackbuffer = 71,
        ERemotelzystream = 72,
        ERemvidchild = 73,
        ERenderer = 74,
        ESandboxreporter = 75,
        ESavescripts = 76,
        ESocketThread = 77,
        ESoftwarevsyncthread = 78,
        ESqldbContentPrefsSqlite = 79,
        ESqldbCookiesSqlite = 80,
        ESqldbFormhistorySqlite = 81,
        ESslCert = 82,
        EStartupcache = 83,
        EStreamtrans = 84,
        EStylethread = 85,
        ESwcomposite = 86,
        ETaskcontroller = 87,
        ETimer = 88,
        EToastbgthread = 89,
        ETrrBackground = 90,
        EUntrustedModules = 91,
        EUrlClassifier = 92,
        EVideocapture = 93,
        EVsynciothread = 94,
        EWebrtccallthread = 95,
        EWebrtcworker = 96,
        EWincompositor = 97,
        EWindowsvsyncthread = 98,
        EWinwindowocclusioncalc = 99,
        EWifiTickler = 100,
        EWorkerLauncher = 101,
        EWrrenderbackend = 102,
        EWrscenebuilder = 103,
        EWrscenebuilderlp = 104,
        EWrworker = 105,
        EWrworkerlp = 106,
        __Other__,
    }
    impl From<u16> for GpuProcessLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAndroidui,
                1 => Self::EAsynclogger,
                2 => Self::EAudioipc,
                3 => Self::EAudioipcCallbackRpc,
                4 => Self::EAudioipcClientCallback,
                5 => Self::EAudioipcClientRpc,
                6 => Self::EAudioipcDevicecollectionRpc,
                7 => Self::EAudioipcServerCallback,
                8 => Self::EAudioipcServerRpc,
                9 => Self::EBackgroundthreadpool,
                10 => Self::EBgiothreadpool,
                11 => Self::EBgreadurls,
                12 => Self::EBhmgrMonitor,
                13 => Self::EBhmgrProcessor,
                14 => Self::ECamerasIpc,
                15 => Self::ECanvasrenderer,
                16 => Self::ECapturethread,
                17 => Self::EClassifierUpdate,
                18 => Self::EComMta,
                19 => Self::ECompositor,
                20 => Self::EConvolverworker,
                21 => Self::ECookie,
                22 => Self::ECubeboperation,
                23 => Self::EDatachannelIo,
                24 => Self::EDnsResolver,
                25 => Self::EDomWorker,
                26 => Self::EDomWorklet,
                27 => Self::EDomcachethread,
                28 => Self::EExtensionprotocolhandler,
                29 => Self::EFontLoader,
                30 => Self::EFontenumthread,
                31 => Self::EFsBroker,
                32 => Self::EGeckomain,
                33 => Self::EGmpthread,
                34 => Self::EGraphrunner,
                35 => Self::EHrtfdatabaseldr,
                36 => Self::EHtml5Parser,
                37 => Self::EImagebridgechld,
                38 => Self::EImageio,
                39 => Self::EIndexeddb,
                40 => Self::EInitfontlist,
                41 => Self::EInotifyeventthread,
                42 => Self::EIndexeddbIo,
                43 => Self::EIpcIOChild,
                44 => Self::EIpcIOParent,
                45 => Self::EIpcLaunch,
                46 => Self::EIpdlBackground,
                47 => Self::EJsWatchdog,
                48 => Self::EJumpList,
                49 => Self::ELibwebrtcmodulethread,
                50 => Self::ELinkMonitor,
                51 => Self::ELsThread,
                52 => Self::EMdnsService,
                53 => Self::EMediacache,
                54 => Self::EMediadecoderstatemachine,
                55 => Self::EMediapdecoder,
                56 => Self::EMediasupervisor,
                57 => Self::EMediatimer,
                58 => Self::EMediatrackgrph,
                59 => Self::EMemorypoller,
                60 => Self::EMozstorage,
                61 => Self::EMtransport,
                62 => Self::ENetlinkMonitor,
                63 => Self::EPacerthread,
                64 => Self::EPermission,
                65 => Self::EPlayeventsound,
                66 => Self::EProcesshangmon,
                67 => Self::EProfilerchild,
                68 => Self::EProxyresolution,
                69 => Self::EQuotamanagerIo,
                70 => Self::ERegisterfonts,
                71 => Self::ERemotebackbuffer,
                72 => Self::ERemotelzystream,
                73 => Self::ERemvidchild,
                74 => Self::ERenderer,
                75 => Self::ESandboxreporter,
                76 => Self::ESavescripts,
                77 => Self::ESocketThread,
                78 => Self::ESoftwarevsyncthread,
                79 => Self::ESqldbContentPrefsSqlite,
                80 => Self::ESqldbCookiesSqlite,
                81 => Self::ESqldbFormhistorySqlite,
                82 => Self::ESslCert,
                83 => Self::EStartupcache,
                84 => Self::EStreamtrans,
                85 => Self::EStylethread,
                86 => Self::ESwcomposite,
                87 => Self::ETaskcontroller,
                88 => Self::ETimer,
                89 => Self::EToastbgthread,
                90 => Self::ETrrBackground,
                91 => Self::EUntrustedModules,
                92 => Self::EUrlClassifier,
                93 => Self::EVideocapture,
                94 => Self::EVsynciothread,
                95 => Self::EWebrtccallthread,
                96 => Self::EWebrtcworker,
                97 => Self::EWincompositor,
                98 => Self::EWindowsvsyncthread,
                99 => Self::EWinwindowocclusioncalc,
                100 => Self::EWifiTickler,
                101 => Self::EWorkerLauncher,
                102 => Self::EWrrenderbackend,
                103 => Self::EWrscenebuilder,
                104 => Self::EWrscenebuilderlp,
                105 => Self::EWrworker,
                106 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GpuProcessLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAndroidui => "androidui",
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECanvasrenderer => "canvasrenderer",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::EConvolverworker => "convolverworker",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomWorklet => "dom_worklet",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHrtfdatabaseldr => "hrtfdatabaseldr",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIndexeddbIo => "indexeddb_io",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMdnsService => "mdns_service",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESqldbContentPrefsSqlite => "sqldb_content-prefs_sqlite",
                Self::ESqldbCookiesSqlite => "sqldb_cookies_sqlite",
                Self::ESqldbFormhistorySqlite => "sqldb_formhistory_sqlite",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWifiTickler => "wifi_tickler",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.gpu_process
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a
    /// given process type.
    pub static gpu_process: Lazy<LabeledMetric<LabeledCounterMetric, GpuProcessLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "gpu_process".into(),
                    category: "power.cpu_ms_per_thread".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3981.into(), meta, Some(vec![::std::borrow::Cow::from("androidui"), ::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("canvasrenderer"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("convolverworker"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("dom_worklet"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("hrtfdatabaseldr"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("indexeddb_io"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mdns_service"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("sqldb_content-prefs_sqlite"), ::std::borrow::Cow::from("sqldb_cookies_sqlite"), ::std::borrow::Cow::from("sqldb_formhistory_sqlite"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wifi_tickler"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ParentActiveLabel {
        EAndroidui = 0,
        EAsynclogger = 1,
        EAudioipc = 2,
        EAudioipcCallbackRpc = 3,
        EAudioipcClientCallback = 4,
        EAudioipcClientRpc = 5,
        EAudioipcDevicecollectionRpc = 6,
        EAudioipcServerCallback = 7,
        EAudioipcServerRpc = 8,
        EBackgroundthreadpool = 9,
        EBgiothreadpool = 10,
        EBgreadurls = 11,
        EBhmgrMonitor = 12,
        EBhmgrProcessor = 13,
        ECamerasIpc = 14,
        ECanvasrenderer = 15,
        ECapturethread = 16,
        EClassifierUpdate = 17,
        EComMta = 18,
        ECompositor = 19,
        EConvolverworker = 20,
        ECookie = 21,
        ECubeboperation = 22,
        EDatachannelIo = 23,
        EDnsResolver = 24,
        EDomWorker = 25,
        EDomWorklet = 26,
        EDomcachethread = 27,
        EExtensionprotocolhandler = 28,
        EFontLoader = 29,
        EFontenumthread = 30,
        EFsBroker = 31,
        EGeckomain = 32,
        EGmpthread = 33,
        EGraphrunner = 34,
        EHrtfdatabaseldr = 35,
        EHtml5Parser = 36,
        EImagebridgechld = 37,
        EImageio = 38,
        EIndexeddb = 39,
        EInitfontlist = 40,
        EInotifyeventthread = 41,
        EIndexeddbIo = 42,
        EIpcIOChild = 43,
        EIpcIOParent = 44,
        EIpcLaunch = 45,
        EIpdlBackground = 46,
        EJsWatchdog = 47,
        EJumpList = 48,
        ELibwebrtcmodulethread = 49,
        ELinkMonitor = 50,
        ELsThread = 51,
        EMdnsService = 52,
        EMediacache = 53,
        EMediadecoderstatemachine = 54,
        EMediapdecoder = 55,
        EMediasupervisor = 56,
        EMediatimer = 57,
        EMediatrackgrph = 58,
        EMemorypoller = 59,
        EMozstorage = 60,
        EMtransport = 61,
        ENetlinkMonitor = 62,
        EPacerthread = 63,
        EPermission = 64,
        EPlayeventsound = 65,
        EProcesshangmon = 66,
        EProfilerchild = 67,
        EProxyresolution = 68,
        EQuotamanagerIo = 69,
        ERegisterfonts = 70,
        ERemotebackbuffer = 71,
        ERemotelzystream = 72,
        ERemvidchild = 73,
        ERenderer = 74,
        ESandboxreporter = 75,
        ESavescripts = 76,
        ESocketThread = 77,
        ESoftwarevsyncthread = 78,
        ESqldbContentPrefsSqlite = 79,
        ESqldbCookiesSqlite = 80,
        ESqldbFormhistorySqlite = 81,
        ESslCert = 82,
        EStartupcache = 83,
        EStreamtrans = 84,
        EStylethread = 85,
        ESwcomposite = 86,
        ETaskcontroller = 87,
        ETimer = 88,
        EToastbgthread = 89,
        ETrrBackground = 90,
        EUntrustedModules = 91,
        EUrlClassifier = 92,
        EVideocapture = 93,
        EVsynciothread = 94,
        EWebrtccallthread = 95,
        EWebrtcworker = 96,
        EWincompositor = 97,
        EWindowsvsyncthread = 98,
        EWinwindowocclusioncalc = 99,
        EWifiTickler = 100,
        EWorkerLauncher = 101,
        EWrrenderbackend = 102,
        EWrscenebuilder = 103,
        EWrscenebuilderlp = 104,
        EWrworker = 105,
        EWrworkerlp = 106,
        __Other__,
    }
    impl From<u16> for ParentActiveLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAndroidui,
                1 => Self::EAsynclogger,
                2 => Self::EAudioipc,
                3 => Self::EAudioipcCallbackRpc,
                4 => Self::EAudioipcClientCallback,
                5 => Self::EAudioipcClientRpc,
                6 => Self::EAudioipcDevicecollectionRpc,
                7 => Self::EAudioipcServerCallback,
                8 => Self::EAudioipcServerRpc,
                9 => Self::EBackgroundthreadpool,
                10 => Self::EBgiothreadpool,
                11 => Self::EBgreadurls,
                12 => Self::EBhmgrMonitor,
                13 => Self::EBhmgrProcessor,
                14 => Self::ECamerasIpc,
                15 => Self::ECanvasrenderer,
                16 => Self::ECapturethread,
                17 => Self::EClassifierUpdate,
                18 => Self::EComMta,
                19 => Self::ECompositor,
                20 => Self::EConvolverworker,
                21 => Self::ECookie,
                22 => Self::ECubeboperation,
                23 => Self::EDatachannelIo,
                24 => Self::EDnsResolver,
                25 => Self::EDomWorker,
                26 => Self::EDomWorklet,
                27 => Self::EDomcachethread,
                28 => Self::EExtensionprotocolhandler,
                29 => Self::EFontLoader,
                30 => Self::EFontenumthread,
                31 => Self::EFsBroker,
                32 => Self::EGeckomain,
                33 => Self::EGmpthread,
                34 => Self::EGraphrunner,
                35 => Self::EHrtfdatabaseldr,
                36 => Self::EHtml5Parser,
                37 => Self::EImagebridgechld,
                38 => Self::EImageio,
                39 => Self::EIndexeddb,
                40 => Self::EInitfontlist,
                41 => Self::EInotifyeventthread,
                42 => Self::EIndexeddbIo,
                43 => Self::EIpcIOChild,
                44 => Self::EIpcIOParent,
                45 => Self::EIpcLaunch,
                46 => Self::EIpdlBackground,
                47 => Self::EJsWatchdog,
                48 => Self::EJumpList,
                49 => Self::ELibwebrtcmodulethread,
                50 => Self::ELinkMonitor,
                51 => Self::ELsThread,
                52 => Self::EMdnsService,
                53 => Self::EMediacache,
                54 => Self::EMediadecoderstatemachine,
                55 => Self::EMediapdecoder,
                56 => Self::EMediasupervisor,
                57 => Self::EMediatimer,
                58 => Self::EMediatrackgrph,
                59 => Self::EMemorypoller,
                60 => Self::EMozstorage,
                61 => Self::EMtransport,
                62 => Self::ENetlinkMonitor,
                63 => Self::EPacerthread,
                64 => Self::EPermission,
                65 => Self::EPlayeventsound,
                66 => Self::EProcesshangmon,
                67 => Self::EProfilerchild,
                68 => Self::EProxyresolution,
                69 => Self::EQuotamanagerIo,
                70 => Self::ERegisterfonts,
                71 => Self::ERemotebackbuffer,
                72 => Self::ERemotelzystream,
                73 => Self::ERemvidchild,
                74 => Self::ERenderer,
                75 => Self::ESandboxreporter,
                76 => Self::ESavescripts,
                77 => Self::ESocketThread,
                78 => Self::ESoftwarevsyncthread,
                79 => Self::ESqldbContentPrefsSqlite,
                80 => Self::ESqldbCookiesSqlite,
                81 => Self::ESqldbFormhistorySqlite,
                82 => Self::ESslCert,
                83 => Self::EStartupcache,
                84 => Self::EStreamtrans,
                85 => Self::EStylethread,
                86 => Self::ESwcomposite,
                87 => Self::ETaskcontroller,
                88 => Self::ETimer,
                89 => Self::EToastbgthread,
                90 => Self::ETrrBackground,
                91 => Self::EUntrustedModules,
                92 => Self::EUrlClassifier,
                93 => Self::EVideocapture,
                94 => Self::EVsynciothread,
                95 => Self::EWebrtccallthread,
                96 => Self::EWebrtcworker,
                97 => Self::EWincompositor,
                98 => Self::EWindowsvsyncthread,
                99 => Self::EWinwindowocclusioncalc,
                100 => Self::EWifiTickler,
                101 => Self::EWorkerLauncher,
                102 => Self::EWrrenderbackend,
                103 => Self::EWrscenebuilder,
                104 => Self::EWrscenebuilderlp,
                105 => Self::EWrworker,
                106 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ParentActiveLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAndroidui => "androidui",
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECanvasrenderer => "canvasrenderer",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::EConvolverworker => "convolverworker",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomWorklet => "dom_worklet",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHrtfdatabaseldr => "hrtfdatabaseldr",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIndexeddbIo => "indexeddb_io",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMdnsService => "mdns_service",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESqldbContentPrefsSqlite => "sqldb_content-prefs_sqlite",
                Self::ESqldbCookiesSqlite => "sqldb_cookies_sqlite",
                Self::ESqldbFormhistorySqlite => "sqldb_formhistory_sqlite",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWifiTickler => "wifi_tickler",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.parent_active
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a
    /// given process type.
    pub static parent_active: Lazy<LabeledMetric<LabeledCounterMetric, ParentActiveLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "parent_active".into(),
                    category: "power.cpu_ms_per_thread".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3982.into(), meta, Some(vec![::std::borrow::Cow::from("androidui"), ::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("canvasrenderer"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("convolverworker"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("dom_worklet"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("hrtfdatabaseldr"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("indexeddb_io"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mdns_service"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("sqldb_content-prefs_sqlite"), ::std::borrow::Cow::from("sqldb_cookies_sqlite"), ::std::borrow::Cow::from("sqldb_formhistory_sqlite"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wifi_tickler"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ParentInactiveLabel {
        EAndroidui = 0,
        EAsynclogger = 1,
        EAudioipc = 2,
        EAudioipcCallbackRpc = 3,
        EAudioipcClientCallback = 4,
        EAudioipcClientRpc = 5,
        EAudioipcDevicecollectionRpc = 6,
        EAudioipcServerCallback = 7,
        EAudioipcServerRpc = 8,
        EBackgroundthreadpool = 9,
        EBgiothreadpool = 10,
        EBgreadurls = 11,
        EBhmgrMonitor = 12,
        EBhmgrProcessor = 13,
        ECamerasIpc = 14,
        ECanvasrenderer = 15,
        ECapturethread = 16,
        EClassifierUpdate = 17,
        EComMta = 18,
        ECompositor = 19,
        EConvolverworker = 20,
        ECookie = 21,
        ECubeboperation = 22,
        EDatachannelIo = 23,
        EDnsResolver = 24,
        EDomWorker = 25,
        EDomWorklet = 26,
        EDomcachethread = 27,
        EExtensionprotocolhandler = 28,
        EFontLoader = 29,
        EFontenumthread = 30,
        EFsBroker = 31,
        EGeckomain = 32,
        EGmpthread = 33,
        EGraphrunner = 34,
        EHrtfdatabaseldr = 35,
        EHtml5Parser = 36,
        EImagebridgechld = 37,
        EImageio = 38,
        EIndexeddb = 39,
        EInitfontlist = 40,
        EInotifyeventthread = 41,
        EIndexeddbIo = 42,
        EIpcIOChild = 43,
        EIpcIOParent = 44,
        EIpcLaunch = 45,
        EIpdlBackground = 46,
        EJsWatchdog = 47,
        EJumpList = 48,
        ELibwebrtcmodulethread = 49,
        ELinkMonitor = 50,
        ELsThread = 51,
        EMdnsService = 52,
        EMediacache = 53,
        EMediadecoderstatemachine = 54,
        EMediapdecoder = 55,
        EMediasupervisor = 56,
        EMediatimer = 57,
        EMediatrackgrph = 58,
        EMemorypoller = 59,
        EMozstorage = 60,
        EMtransport = 61,
        ENetlinkMonitor = 62,
        EPacerthread = 63,
        EPermission = 64,
        EPlayeventsound = 65,
        EProcesshangmon = 66,
        EProfilerchild = 67,
        EProxyresolution = 68,
        EQuotamanagerIo = 69,
        ERegisterfonts = 70,
        ERemotebackbuffer = 71,
        ERemotelzystream = 72,
        ERemvidchild = 73,
        ERenderer = 74,
        ESandboxreporter = 75,
        ESavescripts = 76,
        ESocketThread = 77,
        ESoftwarevsyncthread = 78,
        ESqldbContentPrefsSqlite = 79,
        ESqldbCookiesSqlite = 80,
        ESqldbFormhistorySqlite = 81,
        ESslCert = 82,
        EStartupcache = 83,
        EStreamtrans = 84,
        EStylethread = 85,
        ESwcomposite = 86,
        ETaskcontroller = 87,
        ETimer = 88,
        EToastbgthread = 89,
        ETrrBackground = 90,
        EUntrustedModules = 91,
        EUrlClassifier = 92,
        EVideocapture = 93,
        EVsynciothread = 94,
        EWebrtccallthread = 95,
        EWebrtcworker = 96,
        EWincompositor = 97,
        EWindowsvsyncthread = 98,
        EWinwindowocclusioncalc = 99,
        EWifiTickler = 100,
        EWorkerLauncher = 101,
        EWrrenderbackend = 102,
        EWrscenebuilder = 103,
        EWrscenebuilderlp = 104,
        EWrworker = 105,
        EWrworkerlp = 106,
        __Other__,
    }
    impl From<u16> for ParentInactiveLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAndroidui,
                1 => Self::EAsynclogger,
                2 => Self::EAudioipc,
                3 => Self::EAudioipcCallbackRpc,
                4 => Self::EAudioipcClientCallback,
                5 => Self::EAudioipcClientRpc,
                6 => Self::EAudioipcDevicecollectionRpc,
                7 => Self::EAudioipcServerCallback,
                8 => Self::EAudioipcServerRpc,
                9 => Self::EBackgroundthreadpool,
                10 => Self::EBgiothreadpool,
                11 => Self::EBgreadurls,
                12 => Self::EBhmgrMonitor,
                13 => Self::EBhmgrProcessor,
                14 => Self::ECamerasIpc,
                15 => Self::ECanvasrenderer,
                16 => Self::ECapturethread,
                17 => Self::EClassifierUpdate,
                18 => Self::EComMta,
                19 => Self::ECompositor,
                20 => Self::EConvolverworker,
                21 => Self::ECookie,
                22 => Self::ECubeboperation,
                23 => Self::EDatachannelIo,
                24 => Self::EDnsResolver,
                25 => Self::EDomWorker,
                26 => Self::EDomWorklet,
                27 => Self::EDomcachethread,
                28 => Self::EExtensionprotocolhandler,
                29 => Self::EFontLoader,
                30 => Self::EFontenumthread,
                31 => Self::EFsBroker,
                32 => Self::EGeckomain,
                33 => Self::EGmpthread,
                34 => Self::EGraphrunner,
                35 => Self::EHrtfdatabaseldr,
                36 => Self::EHtml5Parser,
                37 => Self::EImagebridgechld,
                38 => Self::EImageio,
                39 => Self::EIndexeddb,
                40 => Self::EInitfontlist,
                41 => Self::EInotifyeventthread,
                42 => Self::EIndexeddbIo,
                43 => Self::EIpcIOChild,
                44 => Self::EIpcIOParent,
                45 => Self::EIpcLaunch,
                46 => Self::EIpdlBackground,
                47 => Self::EJsWatchdog,
                48 => Self::EJumpList,
                49 => Self::ELibwebrtcmodulethread,
                50 => Self::ELinkMonitor,
                51 => Self::ELsThread,
                52 => Self::EMdnsService,
                53 => Self::EMediacache,
                54 => Self::EMediadecoderstatemachine,
                55 => Self::EMediapdecoder,
                56 => Self::EMediasupervisor,
                57 => Self::EMediatimer,
                58 => Self::EMediatrackgrph,
                59 => Self::EMemorypoller,
                60 => Self::EMozstorage,
                61 => Self::EMtransport,
                62 => Self::ENetlinkMonitor,
                63 => Self::EPacerthread,
                64 => Self::EPermission,
                65 => Self::EPlayeventsound,
                66 => Self::EProcesshangmon,
                67 => Self::EProfilerchild,
                68 => Self::EProxyresolution,
                69 => Self::EQuotamanagerIo,
                70 => Self::ERegisterfonts,
                71 => Self::ERemotebackbuffer,
                72 => Self::ERemotelzystream,
                73 => Self::ERemvidchild,
                74 => Self::ERenderer,
                75 => Self::ESandboxreporter,
                76 => Self::ESavescripts,
                77 => Self::ESocketThread,
                78 => Self::ESoftwarevsyncthread,
                79 => Self::ESqldbContentPrefsSqlite,
                80 => Self::ESqldbCookiesSqlite,
                81 => Self::ESqldbFormhistorySqlite,
                82 => Self::ESslCert,
                83 => Self::EStartupcache,
                84 => Self::EStreamtrans,
                85 => Self::EStylethread,
                86 => Self::ESwcomposite,
                87 => Self::ETaskcontroller,
                88 => Self::ETimer,
                89 => Self::EToastbgthread,
                90 => Self::ETrrBackground,
                91 => Self::EUntrustedModules,
                92 => Self::EUrlClassifier,
                93 => Self::EVideocapture,
                94 => Self::EVsynciothread,
                95 => Self::EWebrtccallthread,
                96 => Self::EWebrtcworker,
                97 => Self::EWincompositor,
                98 => Self::EWindowsvsyncthread,
                99 => Self::EWinwindowocclusioncalc,
                100 => Self::EWifiTickler,
                101 => Self::EWorkerLauncher,
                102 => Self::EWrrenderbackend,
                103 => Self::EWrscenebuilder,
                104 => Self::EWrscenebuilderlp,
                105 => Self::EWrworker,
                106 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ParentInactiveLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAndroidui => "androidui",
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECanvasrenderer => "canvasrenderer",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::EConvolverworker => "convolverworker",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomWorklet => "dom_worklet",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHrtfdatabaseldr => "hrtfdatabaseldr",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIndexeddbIo => "indexeddb_io",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMdnsService => "mdns_service",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESqldbContentPrefsSqlite => "sqldb_content-prefs_sqlite",
                Self::ESqldbCookiesSqlite => "sqldb_cookies_sqlite",
                Self::ESqldbFormhistorySqlite => "sqldb_formhistory_sqlite",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWifiTickler => "wifi_tickler",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.parent_inactive
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a
    /// given process type.
    pub static parent_inactive: Lazy<LabeledMetric<LabeledCounterMetric, ParentInactiveLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "parent_inactive".into(),
                    category: "power.cpu_ms_per_thread".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3983.into(), meta, Some(vec![::std::borrow::Cow::from("androidui"), ::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("canvasrenderer"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("convolverworker"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("dom_worklet"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("hrtfdatabaseldr"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("indexeddb_io"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mdns_service"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("sqldb_content-prefs_sqlite"), ::std::borrow::Cow::from("sqldb_cookies_sqlite"), ::std::borrow::Cow::from("sqldb_formhistory_sqlite"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wifi_tickler"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

}
pub mod power_wakeups_per_thread {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum ContentBackgroundLabel {
        EAndroidui = 0,
        EAsynclogger = 1,
        EAudioipc = 2,
        EAudioipcCallbackRpc = 3,
        EAudioipcClientCallback = 4,
        EAudioipcClientRpc = 5,
        EAudioipcDevicecollectionRpc = 6,
        EAudioipcServerCallback = 7,
        EAudioipcServerRpc = 8,
        EBackgroundthreadpool = 9,
        EBgiothreadpool = 10,
        EBgreadurls = 11,
        EBhmgrMonitor = 12,
        EBhmgrProcessor = 13,
        ECamerasIpc = 14,
        ECanvasrenderer = 15,
        ECapturethread = 16,
        EClassifierUpdate = 17,
        EComMta = 18,
        ECompositor = 19,
        EConvolverworker = 20,
        ECookie = 21,
        ECubeboperation = 22,
        EDatachannelIo = 23,
        EDnsResolver = 24,
        EDomWorker = 25,
        EDomWorklet = 26,
        EDomcachethread = 27,
        EExtensionprotocolhandler = 28,
        EFontLoader = 29,
        EFontenumthread = 30,
        EFsBroker = 31,
        EGeckomain = 32,
        EGmpthread = 33,
        EGraphrunner = 34,
        EHrtfdatabaseldr = 35,
        EHtml5Parser = 36,
        EImagebridgechld = 37,
        EImageio = 38,
        EIndexeddb = 39,
        EInitfontlist = 40,
        EInotifyeventthread = 41,
        EIndexeddbIo = 42,
        EIpcIOChild = 43,
        EIpcIOParent = 44,
        EIpcLaunch = 45,
        EIpdlBackground = 46,
        EJsWatchdog = 47,
        EJumpList = 48,
        ELibwebrtcmodulethread = 49,
        ELinkMonitor = 50,
        ELsThread = 51,
        EMdnsService = 52,
        EMediacache = 53,
        EMediadecoderstatemachine = 54,
        EMediapdecoder = 55,
        EMediasupervisor = 56,
        EMediatimer = 57,
        EMediatrackgrph = 58,
        EMemorypoller = 59,
        EMozstorage = 60,
        EMtransport = 61,
        ENetlinkMonitor = 62,
        EPacerthread = 63,
        EPermission = 64,
        EPlayeventsound = 65,
        EProcesshangmon = 66,
        EProfilerchild = 67,
        EProxyresolution = 68,
        EQuotamanagerIo = 69,
        ERegisterfonts = 70,
        ERemotebackbuffer = 71,
        ERemotelzystream = 72,
        ERemvidchild = 73,
        ERenderer = 74,
        ESandboxreporter = 75,
        ESavescripts = 76,
        ESocketThread = 77,
        ESoftwarevsyncthread = 78,
        ESqldbContentPrefsSqlite = 79,
        ESqldbCookiesSqlite = 80,
        ESqldbFormhistorySqlite = 81,
        ESslCert = 82,
        EStartupcache = 83,
        EStreamtrans = 84,
        EStylethread = 85,
        ESwcomposite = 86,
        ETaskcontroller = 87,
        ETimer = 88,
        EToastbgthread = 89,
        ETrrBackground = 90,
        EUntrustedModules = 91,
        EUrlClassifier = 92,
        EVideocapture = 93,
        EVsynciothread = 94,
        EWebrtccallthread = 95,
        EWebrtcworker = 96,
        EWincompositor = 97,
        EWindowsvsyncthread = 98,
        EWinwindowocclusioncalc = 99,
        EWifiTickler = 100,
        EWorkerLauncher = 101,
        EWrrenderbackend = 102,
        EWrscenebuilder = 103,
        EWrscenebuilderlp = 104,
        EWrworker = 105,
        EWrworkerlp = 106,
        __Other__,
    }
    impl From<u16> for ContentBackgroundLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAndroidui,
                1 => Self::EAsynclogger,
                2 => Self::EAudioipc,
                3 => Self::EAudioipcCallbackRpc,
                4 => Self::EAudioipcClientCallback,
                5 => Self::EAudioipcClientRpc,
                6 => Self::EAudioipcDevicecollectionRpc,
                7 => Self::EAudioipcServerCallback,
                8 => Self::EAudioipcServerRpc,
                9 => Self::EBackgroundthreadpool,
                10 => Self::EBgiothreadpool,
                11 => Self::EBgreadurls,
                12 => Self::EBhmgrMonitor,
                13 => Self::EBhmgrProcessor,
                14 => Self::ECamerasIpc,
                15 => Self::ECanvasrenderer,
                16 => Self::ECapturethread,
                17 => Self::EClassifierUpdate,
                18 => Self::EComMta,
                19 => Self::ECompositor,
                20 => Self::EConvolverworker,
                21 => Self::ECookie,
                22 => Self::ECubeboperation,
                23 => Self::EDatachannelIo,
                24 => Self::EDnsResolver,
                25 => Self::EDomWorker,
                26 => Self::EDomWorklet,
                27 => Self::EDomcachethread,
                28 => Self::EExtensionprotocolhandler,
                29 => Self::EFontLoader,
                30 => Self::EFontenumthread,
                31 => Self::EFsBroker,
                32 => Self::EGeckomain,
                33 => Self::EGmpthread,
                34 => Self::EGraphrunner,
                35 => Self::EHrtfdatabaseldr,
                36 => Self::EHtml5Parser,
                37 => Self::EImagebridgechld,
                38 => Self::EImageio,
                39 => Self::EIndexeddb,
                40 => Self::EInitfontlist,
                41 => Self::EInotifyeventthread,
                42 => Self::EIndexeddbIo,
                43 => Self::EIpcIOChild,
                44 => Self::EIpcIOParent,
                45 => Self::EIpcLaunch,
                46 => Self::EIpdlBackground,
                47 => Self::EJsWatchdog,
                48 => Self::EJumpList,
                49 => Self::ELibwebrtcmodulethread,
                50 => Self::ELinkMonitor,
                51 => Self::ELsThread,
                52 => Self::EMdnsService,
                53 => Self::EMediacache,
                54 => Self::EMediadecoderstatemachine,
                55 => Self::EMediapdecoder,
                56 => Self::EMediasupervisor,
                57 => Self::EMediatimer,
                58 => Self::EMediatrackgrph,
                59 => Self::EMemorypoller,
                60 => Self::EMozstorage,
                61 => Self::EMtransport,
                62 => Self::ENetlinkMonitor,
                63 => Self::EPacerthread,
                64 => Self::EPermission,
                65 => Self::EPlayeventsound,
                66 => Self::EProcesshangmon,
                67 => Self::EProfilerchild,
                68 => Self::EProxyresolution,
                69 => Self::EQuotamanagerIo,
                70 => Self::ERegisterfonts,
                71 => Self::ERemotebackbuffer,
                72 => Self::ERemotelzystream,
                73 => Self::ERemvidchild,
                74 => Self::ERenderer,
                75 => Self::ESandboxreporter,
                76 => Self::ESavescripts,
                77 => Self::ESocketThread,
                78 => Self::ESoftwarevsyncthread,
                79 => Self::ESqldbContentPrefsSqlite,
                80 => Self::ESqldbCookiesSqlite,
                81 => Self::ESqldbFormhistorySqlite,
                82 => Self::ESslCert,
                83 => Self::EStartupcache,
                84 => Self::EStreamtrans,
                85 => Self::EStylethread,
                86 => Self::ESwcomposite,
                87 => Self::ETaskcontroller,
                88 => Self::ETimer,
                89 => Self::EToastbgthread,
                90 => Self::ETrrBackground,
                91 => Self::EUntrustedModules,
                92 => Self::EUrlClassifier,
                93 => Self::EVideocapture,
                94 => Self::EVsynciothread,
                95 => Self::EWebrtccallthread,
                96 => Self::EWebrtcworker,
                97 => Self::EWincompositor,
                98 => Self::EWindowsvsyncthread,
                99 => Self::EWinwindowocclusioncalc,
                100 => Self::EWifiTickler,
                101 => Self::EWorkerLauncher,
                102 => Self::EWrrenderbackend,
                103 => Self::EWrscenebuilder,
                104 => Self::EWrscenebuilderlp,
                105 => Self::EWrworker,
                106 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ContentBackgroundLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAndroidui => "androidui",
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECanvasrenderer => "canvasrenderer",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::EConvolverworker => "convolverworker",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomWorklet => "dom_worklet",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHrtfdatabaseldr => "hrtfdatabaseldr",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIndexeddbIo => "indexeddb_io",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMdnsService => "mdns_service",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESqldbContentPrefsSqlite => "sqldb_content-prefs_sqlite",
                Self::ESqldbCookiesSqlite => "sqldb_cookies_sqlite",
                Self::ESqldbFormhistorySqlite => "sqldb_formhistory_sqlite",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWifiTickler => "wifi_tickler",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.content_background
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by thread name for a given process type.
    pub static content_background: Lazy<LabeledMetric<LabeledCounterMetric, ContentBackgroundLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "content_background".into(),
                    category: "power.wakeups_per_thread".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3984.into(), meta, Some(vec![::std::borrow::Cow::from("androidui"), ::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("canvasrenderer"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("convolverworker"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("dom_worklet"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("hrtfdatabaseldr"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("indexeddb_io"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mdns_service"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("sqldb_content-prefs_sqlite"), ::std::borrow::Cow::from("sqldb_cookies_sqlite"), ::std::borrow::Cow::from("sqldb_formhistory_sqlite"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wifi_tickler"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ContentForegroundLabel {
        EAndroidui = 0,
        EAsynclogger = 1,
        EAudioipc = 2,
        EAudioipcCallbackRpc = 3,
        EAudioipcClientCallback = 4,
        EAudioipcClientRpc = 5,
        EAudioipcDevicecollectionRpc = 6,
        EAudioipcServerCallback = 7,
        EAudioipcServerRpc = 8,
        EBackgroundthreadpool = 9,
        EBgiothreadpool = 10,
        EBgreadurls = 11,
        EBhmgrMonitor = 12,
        EBhmgrProcessor = 13,
        ECamerasIpc = 14,
        ECanvasrenderer = 15,
        ECapturethread = 16,
        EClassifierUpdate = 17,
        EComMta = 18,
        ECompositor = 19,
        EConvolverworker = 20,
        ECookie = 21,
        ECubeboperation = 22,
        EDatachannelIo = 23,
        EDnsResolver = 24,
        EDomWorker = 25,
        EDomWorklet = 26,
        EDomcachethread = 27,
        EExtensionprotocolhandler = 28,
        EFontLoader = 29,
        EFontenumthread = 30,
        EFsBroker = 31,
        EGeckomain = 32,
        EGmpthread = 33,
        EGraphrunner = 34,
        EHrtfdatabaseldr = 35,
        EHtml5Parser = 36,
        EImagebridgechld = 37,
        EImageio = 38,
        EIndexeddb = 39,
        EInitfontlist = 40,
        EInotifyeventthread = 41,
        EIndexeddbIo = 42,
        EIpcIOChild = 43,
        EIpcIOParent = 44,
        EIpcLaunch = 45,
        EIpdlBackground = 46,
        EJsWatchdog = 47,
        EJumpList = 48,
        ELibwebrtcmodulethread = 49,
        ELinkMonitor = 50,
        ELsThread = 51,
        EMdnsService = 52,
        EMediacache = 53,
        EMediadecoderstatemachine = 54,
        EMediapdecoder = 55,
        EMediasupervisor = 56,
        EMediatimer = 57,
        EMediatrackgrph = 58,
        EMemorypoller = 59,
        EMozstorage = 60,
        EMtransport = 61,
        ENetlinkMonitor = 62,
        EPacerthread = 63,
        EPermission = 64,
        EPlayeventsound = 65,
        EProcesshangmon = 66,
        EProfilerchild = 67,
        EProxyresolution = 68,
        EQuotamanagerIo = 69,
        ERegisterfonts = 70,
        ERemotebackbuffer = 71,
        ERemotelzystream = 72,
        ERemvidchild = 73,
        ERenderer = 74,
        ESandboxreporter = 75,
        ESavescripts = 76,
        ESocketThread = 77,
        ESoftwarevsyncthread = 78,
        ESqldbContentPrefsSqlite = 79,
        ESqldbCookiesSqlite = 80,
        ESqldbFormhistorySqlite = 81,
        ESslCert = 82,
        EStartupcache = 83,
        EStreamtrans = 84,
        EStylethread = 85,
        ESwcomposite = 86,
        ETaskcontroller = 87,
        ETimer = 88,
        EToastbgthread = 89,
        ETrrBackground = 90,
        EUntrustedModules = 91,
        EUrlClassifier = 92,
        EVideocapture = 93,
        EVsynciothread = 94,
        EWebrtccallthread = 95,
        EWebrtcworker = 96,
        EWincompositor = 97,
        EWindowsvsyncthread = 98,
        EWinwindowocclusioncalc = 99,
        EWifiTickler = 100,
        EWorkerLauncher = 101,
        EWrrenderbackend = 102,
        EWrscenebuilder = 103,
        EWrscenebuilderlp = 104,
        EWrworker = 105,
        EWrworkerlp = 106,
        __Other__,
    }
    impl From<u16> for ContentForegroundLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAndroidui,
                1 => Self::EAsynclogger,
                2 => Self::EAudioipc,
                3 => Self::EAudioipcCallbackRpc,
                4 => Self::EAudioipcClientCallback,
                5 => Self::EAudioipcClientRpc,
                6 => Self::EAudioipcDevicecollectionRpc,
                7 => Self::EAudioipcServerCallback,
                8 => Self::EAudioipcServerRpc,
                9 => Self::EBackgroundthreadpool,
                10 => Self::EBgiothreadpool,
                11 => Self::EBgreadurls,
                12 => Self::EBhmgrMonitor,
                13 => Self::EBhmgrProcessor,
                14 => Self::ECamerasIpc,
                15 => Self::ECanvasrenderer,
                16 => Self::ECapturethread,
                17 => Self::EClassifierUpdate,
                18 => Self::EComMta,
                19 => Self::ECompositor,
                20 => Self::EConvolverworker,
                21 => Self::ECookie,
                22 => Self::ECubeboperation,
                23 => Self::EDatachannelIo,
                24 => Self::EDnsResolver,
                25 => Self::EDomWorker,
                26 => Self::EDomWorklet,
                27 => Self::EDomcachethread,
                28 => Self::EExtensionprotocolhandler,
                29 => Self::EFontLoader,
                30 => Self::EFontenumthread,
                31 => Self::EFsBroker,
                32 => Self::EGeckomain,
                33 => Self::EGmpthread,
                34 => Self::EGraphrunner,
                35 => Self::EHrtfdatabaseldr,
                36 => Self::EHtml5Parser,
                37 => Self::EImagebridgechld,
                38 => Self::EImageio,
                39 => Self::EIndexeddb,
                40 => Self::EInitfontlist,
                41 => Self::EInotifyeventthread,
                42 => Self::EIndexeddbIo,
                43 => Self::EIpcIOChild,
                44 => Self::EIpcIOParent,
                45 => Self::EIpcLaunch,
                46 => Self::EIpdlBackground,
                47 => Self::EJsWatchdog,
                48 => Self::EJumpList,
                49 => Self::ELibwebrtcmodulethread,
                50 => Self::ELinkMonitor,
                51 => Self::ELsThread,
                52 => Self::EMdnsService,
                53 => Self::EMediacache,
                54 => Self::EMediadecoderstatemachine,
                55 => Self::EMediapdecoder,
                56 => Self::EMediasupervisor,
                57 => Self::EMediatimer,
                58 => Self::EMediatrackgrph,
                59 => Self::EMemorypoller,
                60 => Self::EMozstorage,
                61 => Self::EMtransport,
                62 => Self::ENetlinkMonitor,
                63 => Self::EPacerthread,
                64 => Self::EPermission,
                65 => Self::EPlayeventsound,
                66 => Self::EProcesshangmon,
                67 => Self::EProfilerchild,
                68 => Self::EProxyresolution,
                69 => Self::EQuotamanagerIo,
                70 => Self::ERegisterfonts,
                71 => Self::ERemotebackbuffer,
                72 => Self::ERemotelzystream,
                73 => Self::ERemvidchild,
                74 => Self::ERenderer,
                75 => Self::ESandboxreporter,
                76 => Self::ESavescripts,
                77 => Self::ESocketThread,
                78 => Self::ESoftwarevsyncthread,
                79 => Self::ESqldbContentPrefsSqlite,
                80 => Self::ESqldbCookiesSqlite,
                81 => Self::ESqldbFormhistorySqlite,
                82 => Self::ESslCert,
                83 => Self::EStartupcache,
                84 => Self::EStreamtrans,
                85 => Self::EStylethread,
                86 => Self::ESwcomposite,
                87 => Self::ETaskcontroller,
                88 => Self::ETimer,
                89 => Self::EToastbgthread,
                90 => Self::ETrrBackground,
                91 => Self::EUntrustedModules,
                92 => Self::EUrlClassifier,
                93 => Self::EVideocapture,
                94 => Self::EVsynciothread,
                95 => Self::EWebrtccallthread,
                96 => Self::EWebrtcworker,
                97 => Self::EWincompositor,
                98 => Self::EWindowsvsyncthread,
                99 => Self::EWinwindowocclusioncalc,
                100 => Self::EWifiTickler,
                101 => Self::EWorkerLauncher,
                102 => Self::EWrrenderbackend,
                103 => Self::EWrscenebuilder,
                104 => Self::EWrscenebuilderlp,
                105 => Self::EWrworker,
                106 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ContentForegroundLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAndroidui => "androidui",
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECanvasrenderer => "canvasrenderer",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::EConvolverworker => "convolverworker",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomWorklet => "dom_worklet",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHrtfdatabaseldr => "hrtfdatabaseldr",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIndexeddbIo => "indexeddb_io",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMdnsService => "mdns_service",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESqldbContentPrefsSqlite => "sqldb_content-prefs_sqlite",
                Self::ESqldbCookiesSqlite => "sqldb_cookies_sqlite",
                Self::ESqldbFormhistorySqlite => "sqldb_formhistory_sqlite",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWifiTickler => "wifi_tickler",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.content_foreground
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by thread name for a given process type.
    pub static content_foreground: Lazy<LabeledMetric<LabeledCounterMetric, ContentForegroundLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "content_foreground".into(),
                    category: "power.wakeups_per_thread".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3985.into(), meta, Some(vec![::std::borrow::Cow::from("androidui"), ::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("canvasrenderer"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("convolverworker"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("dom_worklet"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("hrtfdatabaseldr"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("indexeddb_io"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mdns_service"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("sqldb_content-prefs_sqlite"), ::std::borrow::Cow::from("sqldb_cookies_sqlite"), ::std::borrow::Cow::from("sqldb_formhistory_sqlite"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wifi_tickler"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum GpuProcessLabel {
        EAndroidui = 0,
        EAsynclogger = 1,
        EAudioipc = 2,
        EAudioipcCallbackRpc = 3,
        EAudioipcClientCallback = 4,
        EAudioipcClientRpc = 5,
        EAudioipcDevicecollectionRpc = 6,
        EAudioipcServerCallback = 7,
        EAudioipcServerRpc = 8,
        EBackgroundthreadpool = 9,
        EBgiothreadpool = 10,
        EBgreadurls = 11,
        EBhmgrMonitor = 12,
        EBhmgrProcessor = 13,
        ECamerasIpc = 14,
        ECanvasrenderer = 15,
        ECapturethread = 16,
        EClassifierUpdate = 17,
        EComMta = 18,
        ECompositor = 19,
        EConvolverworker = 20,
        ECookie = 21,
        ECubeboperation = 22,
        EDatachannelIo = 23,
        EDnsResolver = 24,
        EDomWorker = 25,
        EDomWorklet = 26,
        EDomcachethread = 27,
        EExtensionprotocolhandler = 28,
        EFontLoader = 29,
        EFontenumthread = 30,
        EFsBroker = 31,
        EGeckomain = 32,
        EGmpthread = 33,
        EGraphrunner = 34,
        EHrtfdatabaseldr = 35,
        EHtml5Parser = 36,
        EImagebridgechld = 37,
        EImageio = 38,
        EIndexeddb = 39,
        EInitfontlist = 40,
        EInotifyeventthread = 41,
        EIndexeddbIo = 42,
        EIpcIOChild = 43,
        EIpcIOParent = 44,
        EIpcLaunch = 45,
        EIpdlBackground = 46,
        EJsWatchdog = 47,
        EJumpList = 48,
        ELibwebrtcmodulethread = 49,
        ELinkMonitor = 50,
        ELsThread = 51,
        EMdnsService = 52,
        EMediacache = 53,
        EMediadecoderstatemachine = 54,
        EMediapdecoder = 55,
        EMediasupervisor = 56,
        EMediatimer = 57,
        EMediatrackgrph = 58,
        EMemorypoller = 59,
        EMozstorage = 60,
        EMtransport = 61,
        ENetlinkMonitor = 62,
        EPacerthread = 63,
        EPermission = 64,
        EPlayeventsound = 65,
        EProcesshangmon = 66,
        EProfilerchild = 67,
        EProxyresolution = 68,
        EQuotamanagerIo = 69,
        ERegisterfonts = 70,
        ERemotebackbuffer = 71,
        ERemotelzystream = 72,
        ERemvidchild = 73,
        ERenderer = 74,
        ESandboxreporter = 75,
        ESavescripts = 76,
        ESocketThread = 77,
        ESoftwarevsyncthread = 78,
        ESqldbContentPrefsSqlite = 79,
        ESqldbCookiesSqlite = 80,
        ESqldbFormhistorySqlite = 81,
        ESslCert = 82,
        EStartupcache = 83,
        EStreamtrans = 84,
        EStylethread = 85,
        ESwcomposite = 86,
        ETaskcontroller = 87,
        ETimer = 88,
        EToastbgthread = 89,
        ETrrBackground = 90,
        EUntrustedModules = 91,
        EUrlClassifier = 92,
        EVideocapture = 93,
        EVsynciothread = 94,
        EWebrtccallthread = 95,
        EWebrtcworker = 96,
        EWincompositor = 97,
        EWindowsvsyncthread = 98,
        EWinwindowocclusioncalc = 99,
        EWifiTickler = 100,
        EWorkerLauncher = 101,
        EWrrenderbackend = 102,
        EWrscenebuilder = 103,
        EWrscenebuilderlp = 104,
        EWrworker = 105,
        EWrworkerlp = 106,
        __Other__,
    }
    impl From<u16> for GpuProcessLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAndroidui,
                1 => Self::EAsynclogger,
                2 => Self::EAudioipc,
                3 => Self::EAudioipcCallbackRpc,
                4 => Self::EAudioipcClientCallback,
                5 => Self::EAudioipcClientRpc,
                6 => Self::EAudioipcDevicecollectionRpc,
                7 => Self::EAudioipcServerCallback,
                8 => Self::EAudioipcServerRpc,
                9 => Self::EBackgroundthreadpool,
                10 => Self::EBgiothreadpool,
                11 => Self::EBgreadurls,
                12 => Self::EBhmgrMonitor,
                13 => Self::EBhmgrProcessor,
                14 => Self::ECamerasIpc,
                15 => Self::ECanvasrenderer,
                16 => Self::ECapturethread,
                17 => Self::EClassifierUpdate,
                18 => Self::EComMta,
                19 => Self::ECompositor,
                20 => Self::EConvolverworker,
                21 => Self::ECookie,
                22 => Self::ECubeboperation,
                23 => Self::EDatachannelIo,
                24 => Self::EDnsResolver,
                25 => Self::EDomWorker,
                26 => Self::EDomWorklet,
                27 => Self::EDomcachethread,
                28 => Self::EExtensionprotocolhandler,
                29 => Self::EFontLoader,
                30 => Self::EFontenumthread,
                31 => Self::EFsBroker,
                32 => Self::EGeckomain,
                33 => Self::EGmpthread,
                34 => Self::EGraphrunner,
                35 => Self::EHrtfdatabaseldr,
                36 => Self::EHtml5Parser,
                37 => Self::EImagebridgechld,
                38 => Self::EImageio,
                39 => Self::EIndexeddb,
                40 => Self::EInitfontlist,
                41 => Self::EInotifyeventthread,
                42 => Self::EIndexeddbIo,
                43 => Self::EIpcIOChild,
                44 => Self::EIpcIOParent,
                45 => Self::EIpcLaunch,
                46 => Self::EIpdlBackground,
                47 => Self::EJsWatchdog,
                48 => Self::EJumpList,
                49 => Self::ELibwebrtcmodulethread,
                50 => Self::ELinkMonitor,
                51 => Self::ELsThread,
                52 => Self::EMdnsService,
                53 => Self::EMediacache,
                54 => Self::EMediadecoderstatemachine,
                55 => Self::EMediapdecoder,
                56 => Self::EMediasupervisor,
                57 => Self::EMediatimer,
                58 => Self::EMediatrackgrph,
                59 => Self::EMemorypoller,
                60 => Self::EMozstorage,
                61 => Self::EMtransport,
                62 => Self::ENetlinkMonitor,
                63 => Self::EPacerthread,
                64 => Self::EPermission,
                65 => Self::EPlayeventsound,
                66 => Self::EProcesshangmon,
                67 => Self::EProfilerchild,
                68 => Self::EProxyresolution,
                69 => Self::EQuotamanagerIo,
                70 => Self::ERegisterfonts,
                71 => Self::ERemotebackbuffer,
                72 => Self::ERemotelzystream,
                73 => Self::ERemvidchild,
                74 => Self::ERenderer,
                75 => Self::ESandboxreporter,
                76 => Self::ESavescripts,
                77 => Self::ESocketThread,
                78 => Self::ESoftwarevsyncthread,
                79 => Self::ESqldbContentPrefsSqlite,
                80 => Self::ESqldbCookiesSqlite,
                81 => Self::ESqldbFormhistorySqlite,
                82 => Self::ESslCert,
                83 => Self::EStartupcache,
                84 => Self::EStreamtrans,
                85 => Self::EStylethread,
                86 => Self::ESwcomposite,
                87 => Self::ETaskcontroller,
                88 => Self::ETimer,
                89 => Self::EToastbgthread,
                90 => Self::ETrrBackground,
                91 => Self::EUntrustedModules,
                92 => Self::EUrlClassifier,
                93 => Self::EVideocapture,
                94 => Self::EVsynciothread,
                95 => Self::EWebrtccallthread,
                96 => Self::EWebrtcworker,
                97 => Self::EWincompositor,
                98 => Self::EWindowsvsyncthread,
                99 => Self::EWinwindowocclusioncalc,
                100 => Self::EWifiTickler,
                101 => Self::EWorkerLauncher,
                102 => Self::EWrrenderbackend,
                103 => Self::EWrscenebuilder,
                104 => Self::EWrscenebuilderlp,
                105 => Self::EWrworker,
                106 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GpuProcessLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAndroidui => "androidui",
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECanvasrenderer => "canvasrenderer",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::EConvolverworker => "convolverworker",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomWorklet => "dom_worklet",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHrtfdatabaseldr => "hrtfdatabaseldr",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIndexeddbIo => "indexeddb_io",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMdnsService => "mdns_service",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESqldbContentPrefsSqlite => "sqldb_content-prefs_sqlite",
                Self::ESqldbCookiesSqlite => "sqldb_cookies_sqlite",
                Self::ESqldbFormhistorySqlite => "sqldb_formhistory_sqlite",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWifiTickler => "wifi_tickler",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.gpu_process
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by thread name for a given process type.
    pub static gpu_process: Lazy<LabeledMetric<LabeledCounterMetric, GpuProcessLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "gpu_process".into(),
                    category: "power.wakeups_per_thread".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3986.into(), meta, Some(vec![::std::borrow::Cow::from("androidui"), ::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("canvasrenderer"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("convolverworker"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("dom_worklet"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("hrtfdatabaseldr"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("indexeddb_io"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mdns_service"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("sqldb_content-prefs_sqlite"), ::std::borrow::Cow::from("sqldb_cookies_sqlite"), ::std::borrow::Cow::from("sqldb_formhistory_sqlite"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wifi_tickler"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ParentActiveLabel {
        EAndroidui = 0,
        EAsynclogger = 1,
        EAudioipc = 2,
        EAudioipcCallbackRpc = 3,
        EAudioipcClientCallback = 4,
        EAudioipcClientRpc = 5,
        EAudioipcDevicecollectionRpc = 6,
        EAudioipcServerCallback = 7,
        EAudioipcServerRpc = 8,
        EBackgroundthreadpool = 9,
        EBgiothreadpool = 10,
        EBgreadurls = 11,
        EBhmgrMonitor = 12,
        EBhmgrProcessor = 13,
        ECamerasIpc = 14,
        ECanvasrenderer = 15,
        ECapturethread = 16,
        EClassifierUpdate = 17,
        EComMta = 18,
        ECompositor = 19,
        EConvolverworker = 20,
        ECookie = 21,
        ECubeboperation = 22,
        EDatachannelIo = 23,
        EDnsResolver = 24,
        EDomWorker = 25,
        EDomWorklet = 26,
        EDomcachethread = 27,
        EExtensionprotocolhandler = 28,
        EFontLoader = 29,
        EFontenumthread = 30,
        EFsBroker = 31,
        EGeckomain = 32,
        EGmpthread = 33,
        EGraphrunner = 34,
        EHrtfdatabaseldr = 35,
        EHtml5Parser = 36,
        EImagebridgechld = 37,
        EImageio = 38,
        EIndexeddb = 39,
        EInitfontlist = 40,
        EInotifyeventthread = 41,
        EIndexeddbIo = 42,
        EIpcIOChild = 43,
        EIpcIOParent = 44,
        EIpcLaunch = 45,
        EIpdlBackground = 46,
        EJsWatchdog = 47,
        EJumpList = 48,
        ELibwebrtcmodulethread = 49,
        ELinkMonitor = 50,
        ELsThread = 51,
        EMdnsService = 52,
        EMediacache = 53,
        EMediadecoderstatemachine = 54,
        EMediapdecoder = 55,
        EMediasupervisor = 56,
        EMediatimer = 57,
        EMediatrackgrph = 58,
        EMemorypoller = 59,
        EMozstorage = 60,
        EMtransport = 61,
        ENetlinkMonitor = 62,
        EPacerthread = 63,
        EPermission = 64,
        EPlayeventsound = 65,
        EProcesshangmon = 66,
        EProfilerchild = 67,
        EProxyresolution = 68,
        EQuotamanagerIo = 69,
        ERegisterfonts = 70,
        ERemotebackbuffer = 71,
        ERemotelzystream = 72,
        ERemvidchild = 73,
        ERenderer = 74,
        ESandboxreporter = 75,
        ESavescripts = 76,
        ESocketThread = 77,
        ESoftwarevsyncthread = 78,
        ESqldbContentPrefsSqlite = 79,
        ESqldbCookiesSqlite = 80,
        ESqldbFormhistorySqlite = 81,
        ESslCert = 82,
        EStartupcache = 83,
        EStreamtrans = 84,
        EStylethread = 85,
        ESwcomposite = 86,
        ETaskcontroller = 87,
        ETimer = 88,
        EToastbgthread = 89,
        ETrrBackground = 90,
        EUntrustedModules = 91,
        EUrlClassifier = 92,
        EVideocapture = 93,
        EVsynciothread = 94,
        EWebrtccallthread = 95,
        EWebrtcworker = 96,
        EWincompositor = 97,
        EWindowsvsyncthread = 98,
        EWinwindowocclusioncalc = 99,
        EWifiTickler = 100,
        EWorkerLauncher = 101,
        EWrrenderbackend = 102,
        EWrscenebuilder = 103,
        EWrscenebuilderlp = 104,
        EWrworker = 105,
        EWrworkerlp = 106,
        __Other__,
    }
    impl From<u16> for ParentActiveLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAndroidui,
                1 => Self::EAsynclogger,
                2 => Self::EAudioipc,
                3 => Self::EAudioipcCallbackRpc,
                4 => Self::EAudioipcClientCallback,
                5 => Self::EAudioipcClientRpc,
                6 => Self::EAudioipcDevicecollectionRpc,
                7 => Self::EAudioipcServerCallback,
                8 => Self::EAudioipcServerRpc,
                9 => Self::EBackgroundthreadpool,
                10 => Self::EBgiothreadpool,
                11 => Self::EBgreadurls,
                12 => Self::EBhmgrMonitor,
                13 => Self::EBhmgrProcessor,
                14 => Self::ECamerasIpc,
                15 => Self::ECanvasrenderer,
                16 => Self::ECapturethread,
                17 => Self::EClassifierUpdate,
                18 => Self::EComMta,
                19 => Self::ECompositor,
                20 => Self::EConvolverworker,
                21 => Self::ECookie,
                22 => Self::ECubeboperation,
                23 => Self::EDatachannelIo,
                24 => Self::EDnsResolver,
                25 => Self::EDomWorker,
                26 => Self::EDomWorklet,
                27 => Self::EDomcachethread,
                28 => Self::EExtensionprotocolhandler,
                29 => Self::EFontLoader,
                30 => Self::EFontenumthread,
                31 => Self::EFsBroker,
                32 => Self::EGeckomain,
                33 => Self::EGmpthread,
                34 => Self::EGraphrunner,
                35 => Self::EHrtfdatabaseldr,
                36 => Self::EHtml5Parser,
                37 => Self::EImagebridgechld,
                38 => Self::EImageio,
                39 => Self::EIndexeddb,
                40 => Self::EInitfontlist,
                41 => Self::EInotifyeventthread,
                42 => Self::EIndexeddbIo,
                43 => Self::EIpcIOChild,
                44 => Self::EIpcIOParent,
                45 => Self::EIpcLaunch,
                46 => Self::EIpdlBackground,
                47 => Self::EJsWatchdog,
                48 => Self::EJumpList,
                49 => Self::ELibwebrtcmodulethread,
                50 => Self::ELinkMonitor,
                51 => Self::ELsThread,
                52 => Self::EMdnsService,
                53 => Self::EMediacache,
                54 => Self::EMediadecoderstatemachine,
                55 => Self::EMediapdecoder,
                56 => Self::EMediasupervisor,
                57 => Self::EMediatimer,
                58 => Self::EMediatrackgrph,
                59 => Self::EMemorypoller,
                60 => Self::EMozstorage,
                61 => Self::EMtransport,
                62 => Self::ENetlinkMonitor,
                63 => Self::EPacerthread,
                64 => Self::EPermission,
                65 => Self::EPlayeventsound,
                66 => Self::EProcesshangmon,
                67 => Self::EProfilerchild,
                68 => Self::EProxyresolution,
                69 => Self::EQuotamanagerIo,
                70 => Self::ERegisterfonts,
                71 => Self::ERemotebackbuffer,
                72 => Self::ERemotelzystream,
                73 => Self::ERemvidchild,
                74 => Self::ERenderer,
                75 => Self::ESandboxreporter,
                76 => Self::ESavescripts,
                77 => Self::ESocketThread,
                78 => Self::ESoftwarevsyncthread,
                79 => Self::ESqldbContentPrefsSqlite,
                80 => Self::ESqldbCookiesSqlite,
                81 => Self::ESqldbFormhistorySqlite,
                82 => Self::ESslCert,
                83 => Self::EStartupcache,
                84 => Self::EStreamtrans,
                85 => Self::EStylethread,
                86 => Self::ESwcomposite,
                87 => Self::ETaskcontroller,
                88 => Self::ETimer,
                89 => Self::EToastbgthread,
                90 => Self::ETrrBackground,
                91 => Self::EUntrustedModules,
                92 => Self::EUrlClassifier,
                93 => Self::EVideocapture,
                94 => Self::EVsynciothread,
                95 => Self::EWebrtccallthread,
                96 => Self::EWebrtcworker,
                97 => Self::EWincompositor,
                98 => Self::EWindowsvsyncthread,
                99 => Self::EWinwindowocclusioncalc,
                100 => Self::EWifiTickler,
                101 => Self::EWorkerLauncher,
                102 => Self::EWrrenderbackend,
                103 => Self::EWrscenebuilder,
                104 => Self::EWrscenebuilderlp,
                105 => Self::EWrworker,
                106 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ParentActiveLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAndroidui => "androidui",
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECanvasrenderer => "canvasrenderer",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::EConvolverworker => "convolverworker",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomWorklet => "dom_worklet",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHrtfdatabaseldr => "hrtfdatabaseldr",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIndexeddbIo => "indexeddb_io",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMdnsService => "mdns_service",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESqldbContentPrefsSqlite => "sqldb_content-prefs_sqlite",
                Self::ESqldbCookiesSqlite => "sqldb_cookies_sqlite",
                Self::ESqldbFormhistorySqlite => "sqldb_formhistory_sqlite",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWifiTickler => "wifi_tickler",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.parent_active
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by thread name for a given process type.
    pub static parent_active: Lazy<LabeledMetric<LabeledCounterMetric, ParentActiveLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "parent_active".into(),
                    category: "power.wakeups_per_thread".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3987.into(), meta, Some(vec![::std::borrow::Cow::from("androidui"), ::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("canvasrenderer"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("convolverworker"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("dom_worklet"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("hrtfdatabaseldr"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("indexeddb_io"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mdns_service"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("sqldb_content-prefs_sqlite"), ::std::borrow::Cow::from("sqldb_cookies_sqlite"), ::std::borrow::Cow::from("sqldb_formhistory_sqlite"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wifi_tickler"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ParentInactiveLabel {
        EAndroidui = 0,
        EAsynclogger = 1,
        EAudioipc = 2,
        EAudioipcCallbackRpc = 3,
        EAudioipcClientCallback = 4,
        EAudioipcClientRpc = 5,
        EAudioipcDevicecollectionRpc = 6,
        EAudioipcServerCallback = 7,
        EAudioipcServerRpc = 8,
        EBackgroundthreadpool = 9,
        EBgiothreadpool = 10,
        EBgreadurls = 11,
        EBhmgrMonitor = 12,
        EBhmgrProcessor = 13,
        ECamerasIpc = 14,
        ECanvasrenderer = 15,
        ECapturethread = 16,
        EClassifierUpdate = 17,
        EComMta = 18,
        ECompositor = 19,
        EConvolverworker = 20,
        ECookie = 21,
        ECubeboperation = 22,
        EDatachannelIo = 23,
        EDnsResolver = 24,
        EDomWorker = 25,
        EDomWorklet = 26,
        EDomcachethread = 27,
        EExtensionprotocolhandler = 28,
        EFontLoader = 29,
        EFontenumthread = 30,
        EFsBroker = 31,
        EGeckomain = 32,
        EGmpthread = 33,
        EGraphrunner = 34,
        EHrtfdatabaseldr = 35,
        EHtml5Parser = 36,
        EImagebridgechld = 37,
        EImageio = 38,
        EIndexeddb = 39,
        EInitfontlist = 40,
        EInotifyeventthread = 41,
        EIndexeddbIo = 42,
        EIpcIOChild = 43,
        EIpcIOParent = 44,
        EIpcLaunch = 45,
        EIpdlBackground = 46,
        EJsWatchdog = 47,
        EJumpList = 48,
        ELibwebrtcmodulethread = 49,
        ELinkMonitor = 50,
        ELsThread = 51,
        EMdnsService = 52,
        EMediacache = 53,
        EMediadecoderstatemachine = 54,
        EMediapdecoder = 55,
        EMediasupervisor = 56,
        EMediatimer = 57,
        EMediatrackgrph = 58,
        EMemorypoller = 59,
        EMozstorage = 60,
        EMtransport = 61,
        ENetlinkMonitor = 62,
        EPacerthread = 63,
        EPermission = 64,
        EPlayeventsound = 65,
        EProcesshangmon = 66,
        EProfilerchild = 67,
        EProxyresolution = 68,
        EQuotamanagerIo = 69,
        ERegisterfonts = 70,
        ERemotebackbuffer = 71,
        ERemotelzystream = 72,
        ERemvidchild = 73,
        ERenderer = 74,
        ESandboxreporter = 75,
        ESavescripts = 76,
        ESocketThread = 77,
        ESoftwarevsyncthread = 78,
        ESqldbContentPrefsSqlite = 79,
        ESqldbCookiesSqlite = 80,
        ESqldbFormhistorySqlite = 81,
        ESslCert = 82,
        EStartupcache = 83,
        EStreamtrans = 84,
        EStylethread = 85,
        ESwcomposite = 86,
        ETaskcontroller = 87,
        ETimer = 88,
        EToastbgthread = 89,
        ETrrBackground = 90,
        EUntrustedModules = 91,
        EUrlClassifier = 92,
        EVideocapture = 93,
        EVsynciothread = 94,
        EWebrtccallthread = 95,
        EWebrtcworker = 96,
        EWincompositor = 97,
        EWindowsvsyncthread = 98,
        EWinwindowocclusioncalc = 99,
        EWifiTickler = 100,
        EWorkerLauncher = 101,
        EWrrenderbackend = 102,
        EWrscenebuilder = 103,
        EWrscenebuilderlp = 104,
        EWrworker = 105,
        EWrworkerlp = 106,
        __Other__,
    }
    impl From<u16> for ParentInactiveLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAndroidui,
                1 => Self::EAsynclogger,
                2 => Self::EAudioipc,
                3 => Self::EAudioipcCallbackRpc,
                4 => Self::EAudioipcClientCallback,
                5 => Self::EAudioipcClientRpc,
                6 => Self::EAudioipcDevicecollectionRpc,
                7 => Self::EAudioipcServerCallback,
                8 => Self::EAudioipcServerRpc,
                9 => Self::EBackgroundthreadpool,
                10 => Self::EBgiothreadpool,
                11 => Self::EBgreadurls,
                12 => Self::EBhmgrMonitor,
                13 => Self::EBhmgrProcessor,
                14 => Self::ECamerasIpc,
                15 => Self::ECanvasrenderer,
                16 => Self::ECapturethread,
                17 => Self::EClassifierUpdate,
                18 => Self::EComMta,
                19 => Self::ECompositor,
                20 => Self::EConvolverworker,
                21 => Self::ECookie,
                22 => Self::ECubeboperation,
                23 => Self::EDatachannelIo,
                24 => Self::EDnsResolver,
                25 => Self::EDomWorker,
                26 => Self::EDomWorklet,
                27 => Self::EDomcachethread,
                28 => Self::EExtensionprotocolhandler,
                29 => Self::EFontLoader,
                30 => Self::EFontenumthread,
                31 => Self::EFsBroker,
                32 => Self::EGeckomain,
                33 => Self::EGmpthread,
                34 => Self::EGraphrunner,
                35 => Self::EHrtfdatabaseldr,
                36 => Self::EHtml5Parser,
                37 => Self::EImagebridgechld,
                38 => Self::EImageio,
                39 => Self::EIndexeddb,
                40 => Self::EInitfontlist,
                41 => Self::EInotifyeventthread,
                42 => Self::EIndexeddbIo,
                43 => Self::EIpcIOChild,
                44 => Self::EIpcIOParent,
                45 => Self::EIpcLaunch,
                46 => Self::EIpdlBackground,
                47 => Self::EJsWatchdog,
                48 => Self::EJumpList,
                49 => Self::ELibwebrtcmodulethread,
                50 => Self::ELinkMonitor,
                51 => Self::ELsThread,
                52 => Self::EMdnsService,
                53 => Self::EMediacache,
                54 => Self::EMediadecoderstatemachine,
                55 => Self::EMediapdecoder,
                56 => Self::EMediasupervisor,
                57 => Self::EMediatimer,
                58 => Self::EMediatrackgrph,
                59 => Self::EMemorypoller,
                60 => Self::EMozstorage,
                61 => Self::EMtransport,
                62 => Self::ENetlinkMonitor,
                63 => Self::EPacerthread,
                64 => Self::EPermission,
                65 => Self::EPlayeventsound,
                66 => Self::EProcesshangmon,
                67 => Self::EProfilerchild,
                68 => Self::EProxyresolution,
                69 => Self::EQuotamanagerIo,
                70 => Self::ERegisterfonts,
                71 => Self::ERemotebackbuffer,
                72 => Self::ERemotelzystream,
                73 => Self::ERemvidchild,
                74 => Self::ERenderer,
                75 => Self::ESandboxreporter,
                76 => Self::ESavescripts,
                77 => Self::ESocketThread,
                78 => Self::ESoftwarevsyncthread,
                79 => Self::ESqldbContentPrefsSqlite,
                80 => Self::ESqldbCookiesSqlite,
                81 => Self::ESqldbFormhistorySqlite,
                82 => Self::ESslCert,
                83 => Self::EStartupcache,
                84 => Self::EStreamtrans,
                85 => Self::EStylethread,
                86 => Self::ESwcomposite,
                87 => Self::ETaskcontroller,
                88 => Self::ETimer,
                89 => Self::EToastbgthread,
                90 => Self::ETrrBackground,
                91 => Self::EUntrustedModules,
                92 => Self::EUrlClassifier,
                93 => Self::EVideocapture,
                94 => Self::EVsynciothread,
                95 => Self::EWebrtccallthread,
                96 => Self::EWebrtcworker,
                97 => Self::EWincompositor,
                98 => Self::EWindowsvsyncthread,
                99 => Self::EWinwindowocclusioncalc,
                100 => Self::EWifiTickler,
                101 => Self::EWorkerLauncher,
                102 => Self::EWrrenderbackend,
                103 => Self::EWrscenebuilder,
                104 => Self::EWrscenebuilderlp,
                105 => Self::EWrworker,
                106 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ParentInactiveLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAndroidui => "androidui",
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECanvasrenderer => "canvasrenderer",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::EConvolverworker => "convolverworker",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomWorklet => "dom_worklet",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHrtfdatabaseldr => "hrtfdatabaseldr",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIndexeddbIo => "indexeddb_io",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMdnsService => "mdns_service",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESqldbContentPrefsSqlite => "sqldb_content-prefs_sqlite",
                Self::ESqldbCookiesSqlite => "sqldb_cookies_sqlite",
                Self::ESqldbFormhistorySqlite => "sqldb_formhistory_sqlite",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWifiTickler => "wifi_tickler",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.parent_inactive
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by thread name for a given process type.
    pub static parent_inactive: Lazy<LabeledMetric<LabeledCounterMetric, ParentInactiveLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "parent_inactive".into(),
                    category: "power.wakeups_per_thread".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(3988.into(), meta, Some(vec![::std::borrow::Cow::from("androidui"), ::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("canvasrenderer"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("convolverworker"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("dom_worklet"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("hrtfdatabaseldr"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("indexeddb_io"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mdns_service"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("sqldb_content-prefs_sqlite"), ::std::borrow::Cow::from("sqldb_cookies_sqlite"), ::std::borrow::Cow::from("sqldb_formhistory_sqlite"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wifi_tickler"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

}
pub mod readermode {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ButtonClickExtra {
        pub r#label: Option<String>,
    }

    impl ExtraKeys for ButtonClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["label"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#label.and_then(|val| map.insert("label".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from readermode.button_click
    ///
    /// This is recorded any time a Reader Mode button is clicked. This event was
    /// generated to correspond to the Legacy Telemetry event readermode.button#click.
    pub static button_click: Lazy<EventMetric<ButtonClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "button_click".into(),
                category: "readermode".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3989.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ViewOffExtra {
        pub r#reader_time: Option<String>,
        pub r#scroll_position: Option<String>,
        pub r#subcategory: Option<String>,
    }

    impl ExtraKeys for ViewOffExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["reader_time", "scroll_position", "subcategory"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#reader_time.and_then(|val| map.insert("reader_time".into(), val.to_string()));
          self.r#scroll_position.and_then(|val| map.insert("scroll_position".into(), val.to_string()));
          self.r#subcategory.and_then(|val| map.insert("subcategory".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from readermode.view_off
    ///
    /// This is recorded any time Reader Mode is turned on or off. This event was
    /// generated to correspond to the Legacy Telemetry event readermode.view#off.
    pub static view_off: Lazy<EventMetric<ViewOffExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "view_off".into(),
                category: "readermode".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3990.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ViewOnExtra {
        pub r#reader_time: Option<String>,
        pub r#scroll_position: Option<String>,
        pub r#subcategory: Option<String>,
    }

    impl ExtraKeys for ViewOnExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["reader_time", "scroll_position", "subcategory"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#reader_time.and_then(|val| map.insert("reader_time".into(), val.to_string()));
          self.r#scroll_position.and_then(|val| map.insert("scroll_position".into(), val.to_string()));
          self.r#subcategory.and_then(|val| map.insert("subcategory".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from readermode.view_on
    ///
    /// This is recorded any time Reader Mode is turned on or off. This event was
    /// generated to correspond to the Legacy Telemetry event readermode.view#on.
    pub static view_on: Lazy<EventMetric<ViewOnExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "view_on".into(),
                category: "readermode".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(3991.into(), meta)
    });

}
pub mod broken_site_report {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.breakage_category
    ///
    /// An optional select-box choice (options may eventually change)
    pub static breakage_category: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "breakage_category".into(),
                category: "broken_site_report".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3992.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.description
    ///
    /// An optional description of the site issue the user is experiencing. May contain
    /// PII.
    pub static description: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "description".into(),
                category: "broken_site_report".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(3993.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.url
    ///
    /// The URL of the site being reported. May contain PII.
    pub static url: Lazy<UrlMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "url".into(),
                category: "broken_site_report".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UrlMetric::new(3994.into(), meta)
    });

}
pub mod broken_site_report_browser_info_app {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.app.default_locales
    ///
    /// Locale strings, ie `["en-US", "en"]`
    pub static default_locales: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "default_locales".into(),
                category: "broken_site_report.browser_info.app".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(3995.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.app.default_useragent_string
    ///
    /// The default user-agent string of the browser
    pub static default_useragent_string: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "default_useragent_string".into(),
                category: "broken_site_report.browser_info.app".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(3996.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.app.fission_enabled
    ///
    /// Whether Fission is enabled
    pub static fission_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fission_enabled".into(),
                category: "broken_site_report.browser_info.app".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(3997.into(), meta)
    });

}
pub mod broken_site_report_browser_info_graphics {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.graphics.device_pixel_ratio
    ///
    /// A decimal number
    pub static device_pixel_ratio: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "device_pixel_ratio".into(),
                category: "broken_site_report.browser_info.graphics".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(3998.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.graphics.devices_json
    ///
    /// JSON array of objects with `vendorID` and `deviceID`. For instance,
    /// `[{"vendorID":"0x000", "deviceID":"0x001"}]`
    pub static devices_json: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "devices_json".into(),
                category: "broken_site_report.browser_info.graphics".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(3999.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.graphics.drivers_json
    ///
    /// JSON array of objects with `renderer` and `version`. For instance,
    /// `[{"renderer":"demo", "version":"0.2"}]`
    pub static drivers_json: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "drivers_json".into(),
                category: "broken_site_report.browser_info.graphics".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4000.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.graphics.features_json
    ///
    /// JSON object. For instance,
    /// `{"WEBRENDER":"available","WEBRENDER_PARTIAL":"disabled (User disabled via
    /// pref)"}`
    pub static features_json: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "features_json".into(),
                category: "broken_site_report.browser_info.graphics".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4001.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.graphics.has_touch_screen
    ///
    /// Whether a touch screen was detected
    pub static has_touch_screen: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "has_touch_screen".into(),
                category: "broken_site_report.browser_info.graphics".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4002.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.graphics.monitors_json
    ///
    /// JSON array of objects with `screenWidth`, 'screenHeight`, and `scale`. For
    /// instance, `[{"screenWidth":3584,"screenHeight":2240,"scale":2}]`
    pub static monitors_json: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "monitors_json".into(),
                category: "broken_site_report.browser_info.graphics".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4003.into(), meta)
    });

}
pub mod broken_site_report_browser_info_prefs {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.cookie_behavior
    ///
    /// Value of `network.cookie.cookieBehavior`
    pub static cookie_behavior: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_behavior".into(),
                category: "broken_site_report.browser_info.prefs".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4004.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.forced_accelerated_layers
    ///
    /// Value of `layers.acceleration_force.enabled`
    pub static forced_accelerated_layers: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "forced_accelerated_layers".into(),
                category: "broken_site_report.browser_info.prefs".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4005.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.global_privacy_control_enabled
    ///
    /// Value of `privacy.globalprivacycontrol.enabled`
    pub static global_privacy_control_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "global_privacy_control_enabled".into(),
                category: "broken_site_report.browser_info.prefs".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4006.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.installtrigger_enabled
    ///
    /// Value of `extensions.InstallTrigger.enabled`
    pub static installtrigger_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "installtrigger_enabled".into(),
                category: "broken_site_report.browser_info.prefs".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4007.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.opaque_response_blocking
    ///
    /// Value of `browser.opaqueResponseBlocking`
    pub static opaque_response_blocking: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "opaque_response_blocking".into(),
                category: "broken_site_report.browser_info.prefs".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4008.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.resist_fingerprinting_enabled
    ///
    /// Value of `privacy.resistFingerprinting`
    pub static resist_fingerprinting_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "resist_fingerprinting_enabled".into(),
                category: "broken_site_report.browser_info.prefs".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4009.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.software_webrender
    ///
    /// Value of `gfx.webrender.software`
    pub static software_webrender: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "software_webrender".into(),
                category: "broken_site_report.browser_info.prefs".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4010.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.third_party_cookie_blocking_enabled
    ///
    /// Value of `network.cookie.cookieBehavior.optInPartitioning`
    pub static third_party_cookie_blocking_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "third_party_cookie_blocking_enabled".into(),
                category: "broken_site_report.browser_info.prefs".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4011.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.third_party_cookie_blocking_enabled_in_pbm
    ///
    /// Value of `network.cookie.cookieBehavior.optInPartitioning.pbmode`
    pub static third_party_cookie_blocking_enabled_in_pbm: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "third_party_cookie_blocking_enabled_in_pbm".into(),
                category: "broken_site_report.browser_info.prefs".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4012.into(), meta)
    });

}
pub mod broken_site_report_browser_info_security {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.security.antispyware
    ///
    /// Which antispyware software was reported on this system.
    pub static antispyware: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "antispyware".into(),
                category: "broken_site_report.browser_info.security".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(4013.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.security.antivirus
    ///
    /// Which antivirus software was reported on this system.
    pub static antivirus: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "antivirus".into(),
                category: "broken_site_report.browser_info.security".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(4014.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.security.firewall
    ///
    /// Which firewall software was reported on this system.
    pub static firewall: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "firewall".into(),
                category: "broken_site_report.browser_info.security".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(4015.into(), meta)
    });

}
pub mod broken_site_report_browser_info_system {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.system.is_tablet
    ///
    /// Whether the device is a tablet
    pub static is_tablet: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_tablet".into(),
                category: "broken_site_report.browser_info.system".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4016.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.system.memory
    ///
    /// How many mb of RAM is reported for the system
    pub static memory: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "memory".into(),
                category: "broken_site_report.browser_info.system".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4017.into(), meta)
    });

}
pub mod broken_site_report_tab_info {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.languages
    ///
    /// The languages the site actually sees (may be overridden)
    pub static languages: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "languages".into(),
                category: "broken_site_report.tab_info".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(4018.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.useragent_string
    ///
    /// The userAgent the site actually sees (may be overridden)
    pub static useragent_string: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "useragent_string".into(),
                category: "broken_site_report.tab_info".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4019.into(), meta)
    });

}
pub mod broken_site_report_tab_info_antitracking {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.antitracking.block_list
    ///
    /// Currently either `basic` or `strict`, may change in the future.
    pub static block_list: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "block_list".into(),
                category: "broken_site_report.tab_info.antitracking".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4020.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.antitracking.has_mixed_active_content_blocked
    ///
    /// Whether the reported tab has any blocked mixed active content
    pub static has_mixed_active_content_blocked: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "has_mixed_active_content_blocked".into(),
                category: "broken_site_report.tab_info.antitracking".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4021.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.antitracking.has_mixed_display_content_blocked
    ///
    /// Whether the reported tab has any blocked mixed display content
    pub static has_mixed_display_content_blocked: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "has_mixed_display_content_blocked".into(),
                category: "broken_site_report.tab_info.antitracking".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4022.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.antitracking.has_tracking_content_blocked
    ///
    /// Whether the reported tab has any blocked tracking content
    pub static has_tracking_content_blocked: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "has_tracking_content_blocked".into(),
                category: "broken_site_report.tab_info.antitracking".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4023.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.antitracking.is_private_browsing
    ///
    /// Whether the tab the user was on when reporting is in private browsing mode
    pub static is_private_browsing: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_private_browsing".into(),
                category: "broken_site_report.tab_info.antitracking".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4024.into(), meta)
    });

}
pub mod broken_site_report_tab_info_frameworks {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.frameworks.fastclick
    ///
    /// Whether the FastClick web library was detected on the original tab.
    pub static fastclick: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fastclick".into(),
                category: "broken_site_report.tab_info.frameworks".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4025.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.frameworks.marfeel
    ///
    /// Whether the Marfeel web framework was detected on the original tab.
    pub static marfeel: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "marfeel".into(),
                category: "broken_site_report.tab_info.frameworks".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4026.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.frameworks.mobify
    ///
    /// Whether the Mobify web framework was detected on the original tab.
    pub static mobify: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mobify".into(),
                category: "broken_site_report.tab_info.frameworks".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4027.into(), meta)
    });

}
pub mod webcompatreporting {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenedExtra {
        pub r#source: Option<String>,
    }

    impl ExtraKeys for OpenedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["source"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webcompatreporting.opened
    ///
    /// Records the method for opening the webcompat reporting window.
    pub static opened: Lazy<EventMetric<OpenedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "opened".into(),
                category: "webcompatreporting".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4028.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReasonDropdownExtra {
        pub r#setting: Option<String>,
    }

    impl ExtraKeys for ReasonDropdownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["setting"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#setting.and_then(|val| map.insert("setting".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webcompatreporting.reason_dropdown
    ///
    /// Record whether the user has a dropdown enabled + whether the dropdown menu is
    /// optional or mandatory.
    pub static reason_dropdown: Lazy<EventMetric<ReasonDropdownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reason_dropdown".into(),
                category: "webcompatreporting".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4029.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webcompatreporting.send
    ///
    /// Recorded when a user selects the Send button to submit webcompat report data.
    pub static send: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "send".into(),
                category: "webcompatreporting".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4030.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webcompatreporting.send_more_info
    ///
    /// Recorded when a user clicks on the Send More Info link in the reporting UI The
    /// user will be redirected to webcompat.com to submit a more comprehensive report.
    /// (This is only enabled on beta/nightly/pre-release channels).
    pub static send_more_info: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "send_more_info".into(),
                category: "webcompatreporting".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4031.into(), meta)
    });

}
pub mod characteristics {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.any_pointer_type
    ///
    /// Union of pointers available. We apply union to determine if the user have both
    /// coarse and fine pointer.
    pub static any_pointer_type: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "any_pointer_type".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4032.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.audio_channels
    ///
    /// Audio sampling rate
    pub static audio_channels: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "audio_channels".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4033.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.audio_fingerprint
    ///
    /// Audio fingerprint of the user. A float number multiplied by 10e7.
    pub static audio_fingerprint: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "audio_fingerprint".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4034.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.audio_frames
    ///
    /// Audio frames
    pub static audio_frames: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "audio_frames".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4035.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.audio_rate
    ///
    /// Audio sampling rate
    pub static audio_rate: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "audio_rate".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4036.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.avail_height
    ///
    /// Available height property
    pub static avail_height: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "avail_height".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4037.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.avail_width
    ///
    /// Available width property
    pub static avail_width: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "avail_width".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4038.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.build_date
    ///
    /// Firefox build's build date in unix time
    pub static build_date: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "build_date".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4039.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.camera_count
    ///
    /// Number of cameras available on the device.
    pub static camera_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "camera_count".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4040.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata1
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a simple organge
    /// box and used as a control image
    pub static canvasdata1: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata1".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4041.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata10
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a font shipped
    /// with Firefox rendered with italics, rotation, and shadow-blur.
    pub static canvasdata10: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata10".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4042.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata10software
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a font shipped
    /// with Firefox rendered with italics, rotation, and shadow-blur.
    pub static canvasdata10software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata10software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4043.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata11_webgl
    ///
    /// The sha1 hash of an image rendered on a WebGL canvas (instead of Canvas2D). IT
    /// is a RGB gradient cube.
    pub static canvasdata11_webgl: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata11_webgl".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4044.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata11_webglsoftware
    ///
    /// The sha1 hash of an image rendered on a WebGL canvas (instead of Canvas2D). IT
    /// is a RGB gradient cube.
    pub static canvasdata11_webglsoftware: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata11_webglsoftware".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4045.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata12_fingerprintjs1
    ///
    /// The sha1 hash of an image rendered on a canvas, it is a copy of fingerprintjs'
    /// text canvas
    pub static canvasdata12_fingerprintjs1: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata12_fingerprintjs1".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4046.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata12_fingerprintjs1software
    ///
    /// The sha1 hash of an image rendered on a canvas, it is a copy of fingerprintjs'
    /// text canvas
    pub static canvasdata12_fingerprintjs1software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata12_fingerprintjs1software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4047.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata13_fingerprintjs2
    ///
    /// The sha1 hash of an image rendered on a canvas, it is a copy of fingerprintjs'
    /// geometry canvas
    pub static canvasdata13_fingerprintjs2: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata13_fingerprintjs2".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4048.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata13_fingerprintjs2software
    ///
    /// The sha1 hash of an image rendered on a canvas, it is a copy of fingerprintjs'
    /// geometry canvas
    pub static canvasdata13_fingerprintjs2software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata13_fingerprintjs2software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4049.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata1software
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a simple organge
    /// box and used as a control image
    pub static canvasdata1software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata1software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4050.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata2
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a bordered triage,
    /// and used to test point interpolation
    pub static canvasdata2: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata2".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4051.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata2software
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a bordered triage,
    /// and used to test point interpolation
    pub static canvasdata2software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata2software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4052.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata3
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a stretched
    /// photographic image, used to test image operations.
    pub static canvasdata3: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata3".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4053.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata3software
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a stretched
    /// photographic image, used to test image operations.
    pub static canvasdata3software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata3software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4054.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata4
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is two rotated, semi-
    /// transparenct overlapping squares, used to test transparency and point
    /// interpolation.
    pub static canvasdata4: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata4".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4055.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata4software
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is two rotated, semi-
    /// transparenct overlapping squares, used to test transparency and point
    /// interpolation.
    pub static canvasdata4software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata4software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4056.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata5
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a local font
    /// rendered normally.
    pub static canvasdata5: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata5".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4057.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata5software
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a local font
    /// rendered normally.
    pub static canvasdata5software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata5software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4058.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata6
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a local font
    /// rendered with italics, rotation, and shadow-blur.
    pub static canvasdata6: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata6".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4059.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata6software
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a local font
    /// rendered with italics, rotation, and shadow-blur.
    pub static canvasdata6software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata6software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4060.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata7
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a system-ui font
    /// rendered normally.
    pub static canvasdata7: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata7".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4061.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata7software
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a system-ui font
    /// rendered normally.
    pub static canvasdata7software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata7software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4062.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata8
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a system-ui font
    /// rendered with italics, rotation, and shadow-blur.
    pub static canvasdata8: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata8".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4063.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata8software
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a system-ui font
    /// rendered with italics, rotation, and shadow-blur.
    pub static canvasdata8software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata8software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4064.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata9
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a font shipped
    /// with Firefox rendered normally.
    pub static canvasdata9: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata9".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4065.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata9software
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a font shipped
    /// with Firefox rendered normally.
    pub static canvasdata9software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata9software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4066.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.changed_media_prefs
    ///
    /// Changed media prefs and their values.
    pub static changed_media_prefs: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "changed_media_prefs".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4067.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.channel
    ///
    /// Firefox build channel
    pub static channel: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "channel".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4068.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.client_identifier
    ///
    /// A unique identifier for a user, not the same as the normal Telemetry client_id,
    /// but needed so we can deduplicate reports and only take the most recent one per
    /// user.
    pub static client_identifier: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "client_identifier".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["deletion-request".into(), "user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(4069.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_accentcolor
    ///
    /// The CSS system-color Accentcolor.
    pub static color_accentcolor: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "color_accentcolor".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4070.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_accentcolortext
    ///
    /// The CSS system-color Accentcolortext.
    pub static color_accentcolortext: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "color_accentcolortext".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4071.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_canvas
    ///
    /// The CSS system-color Canvas.
    pub static color_canvas: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "color_canvas".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4072.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_canvastext
    ///
    /// The CSS system-color Canvastext.
    pub static color_canvastext: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "color_canvastext".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4073.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_depth
    ///
    /// The Color Depth reported by CSS
    pub static color_depth: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "color_depth".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4074.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_gamut
    ///
    /// The Color Gamut reported by CSS
    pub static color_gamut: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "color_gamut".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4075.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_highlight
    ///
    /// The CSS system-color Highlight.
    pub static color_highlight: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "color_highlight".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4076.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_highlighttext
    ///
    /// The CSS system-color Highlighttext.
    pub static color_highlighttext: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "color_highlighttext".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4077.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_scheme
    ///
    /// The Color Scheme used for Content, from ContentPrefs() Preference Sheet.
    pub static color_scheme: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "color_scheme".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4078.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_selecteditem
    ///
    /// The CSS system-color Selecteditem.
    pub static color_selecteditem: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "color_selecteditem".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4079.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_selecteditemtext
    ///
    /// The CSS system-color Selecteditemtext.
    pub static color_selecteditemtext: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "color_selecteditemtext".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4080.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.cpu_model
    ///
    /// CPU model of the user's device
    pub static cpu_model: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cpu_model".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4081.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.errors
    ///
    /// Errors occured on C++ side of data collection
    pub static errors: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "errors".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4082.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_default_default_group
    ///
    /// The value of the font.default.<default language group> pref
    pub static font_default_default_group: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_default_default_group".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4083.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_default_modified
    ///
    /// The number of other modified font.default prefs.
    pub static font_default_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_default_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4084.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_default_western
    ///
    /// The value of the font.default.x-western pref
    pub static font_default_western: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_default_western".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4085.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_minimum_size_default_group
    ///
    /// The value of the font.minimum-size.<default language group> pref
    pub static font_minimum_size_default_group: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_minimum_size_default_group".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4086.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_minimum_size_modified
    ///
    /// The number of other modified font.minimum-size prefs.
    pub static font_minimum_size_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_minimum_size_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4087.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_minimum_size_western
    ///
    /// The value of the font.minimum-size.x-western pref
    pub static font_minimum_size_western: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_minimum_size_western".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4088.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_list_cursive_modified
    ///
    /// The number of modified font.name-list.cursive. prefs.
    pub static font_name_list_cursive_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_list_cursive_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4089.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_list_emoji_modified
    ///
    /// Whether the pref font.name-list.emoji was modified.
    pub static font_name_list_emoji_modified: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_list_emoji_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4090.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_list_monospace_modified
    ///
    /// The number of modified font.name-list.monospace. prefs.
    pub static font_name_list_monospace_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_list_monospace_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4091.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_list_sans_serif_modified
    ///
    /// The number of modified font.name-list.sans-serif. prefs.
    pub static font_name_list_sans_serif_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_list_sans_serif_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4092.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_list_serif_modified
    ///
    /// The number of modified font.name-list.serif. prefs.
    pub static font_name_list_serif_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_list_serif_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4093.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_monospace_default_group
    ///
    /// The value of the font.name.monospace.<default language group> pref
    pub static font_name_monospace_default_group: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_monospace_default_group".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4094.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_monospace_modified
    ///
    /// The number of other modified font.name.monospace prefs.
    pub static font_name_monospace_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_monospace_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4095.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_monospace_western
    ///
    /// The value of the font.name.monospace.x-western pref
    pub static font_name_monospace_western: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_monospace_western".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4096.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_sans_serif_default_group
    ///
    /// The value of the font.name.sans-serif.<default language group> pref
    pub static font_name_sans_serif_default_group: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_sans_serif_default_group".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4097.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_sans_serif_modified
    ///
    /// The number of other modified font.name.sans-serif prefs.
    pub static font_name_sans_serif_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_sans_serif_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4098.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_sans_serif_western
    ///
    /// The value of the font.name.sans-serif.x-western pref
    pub static font_name_sans_serif_western: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_sans_serif_western".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4099.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_serif_default_group
    ///
    /// The value of the font.name.serif.<default language group> pref
    pub static font_name_serif_default_group: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_serif_default_group".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4100.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_serif_modified
    ///
    /// The number of other modified font.name.serif prefs.
    pub static font_name_serif_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_serif_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4101.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_serif_western
    ///
    /// The value of the font.name.serif.x-western pref
    pub static font_name_serif_western: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_serif_western".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4102.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_size_monospace_default_group
    ///
    /// The value of the font.size.monospace.<default language group> pref
    pub static font_size_monospace_default_group: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_size_monospace_default_group".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4103.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_size_monospace_modified
    ///
    /// The number of other modified font.size.monospace prefs.
    pub static font_size_monospace_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_size_monospace_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4104.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_size_monospace_western
    ///
    /// The value of the font.size.monospace.x-western pref
    pub static font_size_monospace_western: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_size_monospace_western".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4105.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_size_variable_default_group
    ///
    /// The value of the font.size.variable.<default language group> pref
    pub static font_size_variable_default_group: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_size_variable_default_group".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4106.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_size_variable_modified
    ///
    /// The number of other modified font.size.variable prefs.
    pub static font_size_variable_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_size_variable_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4107.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_size_variable_western
    ///
    /// The value of the font.size.variable.x-western pref
    pub static font_size_variable_western: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_size_variable_western".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4108.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gamepads
    ///
    /// The information of the gamepads inserted on the user device. Each string
    /// represents one gamepad. We use a JSON array to describe a gamepad, every value
    /// represents one property of the gamepad. Following are the details:
    ///   index 0: The ID of the game pad
    ///   index 1: Which hand for the gamepad.
    ///   index 2: Number of buttons
    ///   index 3: Number of axes
    ///   index 4: Number of haptics
    ///   index 5: Number of lights
    ///   index 6: Number of touches
    pub static gamepads: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gamepads".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(4109.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_extensions
    ///
    /// The list of OpenGL extensions supported by the user's system.
    pub static gl_extensions: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_extensions".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4110.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_extensions_raw
    ///
    /// The raw list of OpenGL extensions supported by the user's system.
    pub static gl_extensions_raw: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_extensions_raw".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4111.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_fragment_shader
    ///
    /// Hash of the transformed source of the fragment shader.
    pub static gl_fragment_shader: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_fragment_shader".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4112.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_minimal_source
    ///
    /// Transformed source of the minimal shader.
    pub static gl_minimal_source: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_minimal_source".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4113.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_params_extensions
    ///
    /// The list of GL parameters of the extensions.
    pub static gl_params_extensions: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_params_extensions".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4114.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_params_v1
    ///
    /// The list of GL parameters of GL1.
    pub static gl_params_v1: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_params_v1".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4115.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_params_v2
    ///
    /// The list of GL parameters of GL2.
    pub static gl_params_v2: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_params_v2".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4116.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_precision_fragment
    ///
    /// Precisions of the fragment shader.
    pub static gl_precision_fragment: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_precision_fragment".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4117.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_precision_vertex
    ///
    /// Precisions of the vertex shader.
    pub static gl_precision_vertex: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_precision_vertex".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4118.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_renderer
    ///
    /// The OpenGL renderer string.
    pub static gl_renderer: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_renderer".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4119.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_renderer_raw
    ///
    /// The raw OpenGL renderer string.
    pub static gl_renderer_raw: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_renderer_raw".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4120.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_vendor
    ///
    /// The OpenGL vendor string.
    pub static gl_vendor: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_vendor".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4121.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_vendor_raw
    ///
    /// The raw OpenGL vendor string.
    pub static gl_vendor_raw: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_vendor_raw".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4122.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_version
    ///
    /// The version of OpenGL supported by the user's system.
    pub static gl_version: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_version".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4123.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_version_raw
    ///
    /// The raw OpenGL version string.
    pub static gl_version_raw: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_version_raw".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4124.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_vertex_shader
    ///
    /// Hash of the transformed source of the vertex shader.
    pub static gl_vertex_shader: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_vertex_shader".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4125.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.group_count
    ///
    /// Number of device groups reported by the device.
    pub static group_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "group_count".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4126.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.group_count_wo_speakers
    ///
    /// Number of device groups without speakers reported by the device.
    pub static group_count_wo_speakers: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "group_count_wo_speakers".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4127.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.ice_foundations
    ///
    /// Unique ICE foundations occurance count and the standard deviation of latencies
    pub static ice_foundations: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ice_foundations".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4128.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.ice_order
    ///
    /// Unique ICE foundations occurrence count
    pub static ice_order: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ice_order".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4129.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.ice_sd
    ///
    /// ICE foundation discovery latency standard deviation sum multiplied by 1000
    pub static ice_sd: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ice_sd".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4130.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.inner_height
    ///
    /// Inner height of user's browser.
    pub static inner_height: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "inner_height".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4131.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.inner_width
    ///
    /// Inner width of user's browser.
    pub static inner_width: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "inner_width".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4132.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.intl_locale
    ///
    /// Locale information provided by Intl
    pub static intl_locale: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "intl_locale".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4133.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.inverted_colors
    ///
    /// What LookAndFeel(InvertedColors) reports.
    pub static inverted_colors: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "inverted_colors".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4134.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.js_errors
    ///
    /// Errors occured on JavaScript side of data collection
    pub static js_errors: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "js_errors".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4135.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.keyboard_layout
    ///
    /// Name of the current keyboard layout.
    pub static keyboard_layout: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "keyboard_layout".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4136.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.languages
    ///
    /// Languages the user set. Returns intl.accept_languages pref, if it is empty,
    /// returns the first matched OS's language or the default language.
    pub static languages: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "languages".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4137.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.math_ops
    ///
    /// Result of fingerprintable math operations
    pub static math_ops: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "math_ops".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4138.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.mathml1
    ///
    /// Width of the drawn MathML element
    pub static mathml1: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mathml1".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4139.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.mathml10
    ///
    /// Width of the drawn MathML element
    pub static mathml10: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mathml10".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4140.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.mathml2
    ///
    /// Width of the drawn MathML element
    pub static mathml2: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mathml2".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4141.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.mathml3
    ///
    /// Width of the drawn MathML element
    pub static mathml3: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mathml3".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4142.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.mathml4
    ///
    /// Width of the drawn MathML element
    pub static mathml4: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mathml4".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4143.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.mathml5
    ///
    /// Width of the drawn MathML element
    pub static mathml5: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mathml5".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4144.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.mathml6
    ///
    /// Width of the drawn MathML element
    pub static mathml6: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mathml6".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4145.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.mathml7
    ///
    /// Width of the drawn MathML element
    pub static mathml7: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mathml7".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4146.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.mathml8
    ///
    /// Width of the drawn MathML element
    pub static mathml8: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mathml8".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4147.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.mathml9
    ///
    /// Width of the drawn MathML element
    pub static mathml9: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mathml9".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4148.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.max_touch_points
    ///
    /// The number of touch points we will report to the web. On Android, this is based
    /// on Android's FEATURE_TOUCHSCREEN* constants - Mozilla caps this at 5 as Android
    /// stops distinguishing between numbers greater than 5.  On Windows this comes
    /// from the SM_MAXIMUMTOUCHES System Metric.
    pub static max_touch_points: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "max_touch_points".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4149.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.media_capabilities
    ///
    /// Which, if any, media types are not supported, and whether they can be run
    /// smoothly and power-efficiently.
    pub static media_capabilities: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "media_capabilities".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4150.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.media_capabilities_h264
    ///
    /// Levels of support for H264 codec.
    pub static media_capabilities_h264: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "media_capabilities_h264".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4151.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.media_capabilities_not_efficient
    ///
    /// Which, if any, media types are not power efficient.
    pub static media_capabilities_not_efficient: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "media_capabilities_not_efficient".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4152.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.media_capabilities_not_smooth
    ///
    /// Which, if any, media types are not smooth.
    pub static media_capabilities_not_smooth: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "media_capabilities_not_smooth".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4153.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.media_capabilities_unsupported
    ///
    /// Which, if any, media types are not supported.
    pub static media_capabilities_unsupported: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "media_capabilities_unsupported".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4154.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.media_devices
    ///
    /// A JSON object containing the number of audio input/output, video input and the
    /// number of unique group ids.
    pub static media_devices: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "media_devices".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4155.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.microphone_count
    ///
    /// Number of microphones available on the device.
    pub static microphone_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "microphone_count".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4156.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.missing_fonts
    ///
    /// If a Font List is available for the user's platform, this string_list contains
    /// the fonts that are missing from the user's computer.
    pub static missing_fonts: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "missing_fonts".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4157.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.monochrome
    ///
    /// Whether the user's device is monochrome
    pub static monochrome: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "monochrome".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4158.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.motion_decimals
    ///
    /// devicemotion event's decimal places count
    pub static motion_decimals: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "motion_decimals".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4159.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.motion_freq
    ///
    /// devicemotion event's frequency
    pub static motion_freq: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "motion_freq".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4160.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.orientation_angle
    ///
    /// Orientation angle of the screen
    pub static orientation_angle: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "orientation_angle".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4161.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.orientation_decimals
    ///
    /// deviceorientation event's decimal places count
    pub static orientation_decimals: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "orientation_decimals".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4162.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.orientation_freq
    ///
    /// deviceorientation event's frequency
    pub static orientation_freq: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "orientation_freq".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4163.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.orientationabs_decimals
    ///
    /// deviceorientationabsolute event's decimal places count
    pub static orientationabs_decimals: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "orientationabs_decimals".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4164.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.orientationabs_freq
    ///
    /// deviceorientationabsolute event's frequency
    pub static orientationabs_freq: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "orientationabs_freq".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4165.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.os_name
    ///
    /// User's OS name
    pub static os_name: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "os_name".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4166.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.os_version
    ///
    /// User's OS version
    pub static os_version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "os_version".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4167.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.oscpu
    ///
    /// User's OS CPU reported by the navigator
    pub static oscpu: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "oscpu".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4168.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.outer_height
    ///
    /// Outer height of user's browser.
    pub static outer_height: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "outer_height".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4169.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.outer_width
    ///
    /// Outer width of user's browser.
    pub static outer_width: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "outer_width".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4170.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pdf_viewer
    ///
    /// PDF viewer support reported by the navigator
    pub static pdf_viewer: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pdf_viewer".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4171.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pixel_depth
    ///
    /// Screen pixel depth property
    pub static pixel_depth: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pixel_depth".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4172.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pixel_ratio
    ///
    /// The value of window.devicePixelRatio multiplied by 100 to include some of the
    /// decimal places
    pub static pixel_ratio: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pixel_ratio".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4173.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.platform
    ///
    /// Platform reported by the navigator
    pub static platform: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "platform".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4174.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pointer_height
    ///
    /// Height of user's pointer
    pub static pointer_height: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pointer_height".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4175.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pointer_pressure
    ///
    /// Pressure of user's pointer
    pub static pointer_pressure: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pointer_pressure".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4176.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pointer_tangentinal_pressure
    ///
    /// Tangential Pressure of user's pointer
    pub static pointer_tangentinal_pressure: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pointer_tangentinal_pressure".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4177.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pointer_tiltx
    ///
    /// TiltX of user's pointer
    pub static pointer_tiltx: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pointer_tiltx".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4178.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pointer_tilty
    ///
    /// TiltY of user's pointer
    pub static pointer_tilty: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pointer_tilty".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4179.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pointer_twist
    ///
    /// Twist of user's pointer
    pub static pointer_twist: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pointer_twist".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4180.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pointer_type
    ///
    /// Pointer type of the user's primary pointer device.
    pub static pointer_type: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pointer_type".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4181.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pointer_width
    ///
    /// Width of user's pointer
    pub static pointer_width: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pointer_width".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4182.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.posx
    ///
    /// window.screen.left value. Provides us the position of the browser and the width
    /// of any possible task/menu bar
    pub static posx: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "posx".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4183.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.posy
    ///
    /// window.screen.top value. Provides us the position of the browser and the height
    /// of any possible task/menu bar
    pub static posy: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "posy".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4184.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefers_contrast
    ///
    /// What Gecko_MediaFeatures_PrefersContrast reports for a ContentDocument
    pub static prefers_contrast: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefers_contrast".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4185.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefers_reduced_motion
    ///
    /// What LookAndFeel(PrefersReducedMotion) reports.
    pub static prefers_reduced_motion: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefers_reduced_motion".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4186.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefers_reduced_transparency
    ///
    /// What LookAndFeel(PrefersReducedTransparency) reports.
    pub static prefers_reduced_transparency: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefers_reduced_transparency".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4187.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_block_popups
    ///
    /// Block pop-up windows (The dom.disable_open_during_load pref)
    pub static prefs_block_popups: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_block_popups".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4188.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_browser_display_use_document_fonts
    ///
    /// Allow pages to choose their own fonts.
    pub static prefs_browser_display_use_document_fonts: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_browser_display_use_document_fonts".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4189.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_general_autoscroll
    ///
    /// Use autoscrolling
    pub static prefs_general_autoscroll: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_general_autoscroll".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4190.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_general_smoothscroll
    ///
    /// Use smooth scrolling
    pub static prefs_general_smoothscroll: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_general_smoothscroll".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4191.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_intl_accept_languages
    ///
    /// Value of the intl.accept_languages pref.
    pub static prefs_intl_accept_languages: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_intl_accept_languages".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4192.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_media_eme_enabled
    ///
    /// Value of the media.eme.enabled pref.
    pub static prefs_media_eme_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_media_eme_enabled".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4193.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_network_cookie_cookiebehavior
    ///
    /// Value of the network.cookie.cookieBehavior pref.
    pub static prefs_network_cookie_cookiebehavior: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_network_cookie_cookiebehavior".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4194.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_overlay_scrollbars
    ///
    /// Use overlay scrollbars (or otherwise "Always show scrollbars")
    pub static prefs_overlay_scrollbars: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_overlay_scrollbars".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4195.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_privacy_donottrackheader_enabled
    ///
    /// Sending "do not track" HTTP header
    pub static prefs_privacy_donottrackheader_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_privacy_donottrackheader_enabled".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4196.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_privacy_globalprivacycontrol_enabled
    ///
    /// Sending "global privacy control" HTTP header
    pub static prefs_privacy_globalprivacycontrol_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_privacy_globalprivacycontrol_enabled".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4197.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_zoom_text_only
    ///
    /// Text-only zoom enabled (vs. full-zoom)
    pub static prefs_zoom_text_only: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_zoom_text_only".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4198.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.processor_count
    ///
    /// Number of processors.
    pub static processor_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "processor_count".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4199.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.scalings
    ///
    /// Screen(s) scaling/zoom level
    pub static scalings: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "scalings".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4200.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.screen_height
    ///
    /// Height of the primary screen in pixels.
    pub static screen_height: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "screen_height".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4201.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.screen_orientation
    ///
    /// Orientation of the primary screen.
    pub static screen_orientation: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "screen_orientation".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4202.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.screen_width
    ///
    /// Width of the primary screen in pixels.
    pub static screen_width: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "screen_width".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4203.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.size_mode
    ///
    /// Whether window is maximized, minimized, normal or fullscreen
    pub static size_mode: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "size_mode".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4204.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.speaker_count
    ///
    /// Number of speakers available on the device.
    pub static speaker_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "speaker_count".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4205.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.submission_schema
    ///
    /// An incrementing constant that represents the current schema/source of the data
    /// present in a ping. By referring to this value in a ping, one can know for
    /// certain the provenance of other data present in the ping, and what data may or
    /// may not be present.
    pub static submission_schema: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "submission_schema".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4206.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.system_locale
    ///
    /// The locale used by the host OS for localization.
    pub static system_locale: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "system_locale".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4207.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.target_frame_rate
    ///
    /// The target frame rate in frames-per-second.
    pub static target_frame_rate: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "target_frame_rate".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4208.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.text_anti_aliasing
    ///
    /// Font anti aliasing level
    pub static text_anti_aliasing: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "text_anti_aliasing".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4209.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.timezone
    ///
    /// The the current timezone of the system
    pub static timezone: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "timezone".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4210.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.touch_rotation_angle
    ///
    /// Rotation angle of user's touch
    pub static touch_rotation_angle: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "touch_rotation_angle".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4211.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.use_document_colors
    ///
    /// This is the derived PreferenceSheet::Prefs::mUseDocumentColors value.
    pub static use_document_colors: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "use_document_colors".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4212.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.version
    ///
    /// Firefox build version
    pub static version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "version".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4213.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.video_dynamic_range
    ///
    /// What LookAndFeel(VideoDynamicRange) reports. Note that CSSVideoDynamicRange has
    /// an additional dependency on Color Depth.
    pub static video_dynamic_range: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_dynamic_range".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4214.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.voices
    ///
    /// Available speechSynthesis voices.
    pub static voices: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "voices".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4215.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.voices_all_ssdeep
    ///
    /// ssdeep hash of all speechSynthesis voices.
    pub static voices_all_ssdeep: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "voices_all_ssdeep".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4216.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.voices_count
    ///
    /// Number of speechSynthesis voices available to the user.
    pub static voices_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "voices_count".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4217.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.voices_default
    ///
    /// The default speechSynthesis voice.
    pub static voices_default: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "voices_default".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4218.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.voices_local_count
    ///
    /// Number of local speechSynthesis voices available to the user.
    pub static voices_local_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "voices_local_count".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4219.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.voices_local_ssdeep
    ///
    /// ssdeep hash of local speechSynthesis voices.
    pub static voices_local_ssdeep: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "voices_local_ssdeep".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4220.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.voices_nonlocal_ssdeep
    ///
    /// ssdeep hash of non-local speechSynthesis voices.
    pub static voices_nonlocal_ssdeep: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "voices_nonlocal_ssdeep".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4221.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.voices_sample
    ///
    /// Names of 5 sample speechSynthesis voices.
    pub static voices_sample: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "voices_sample".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4222.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.voices_sha1
    ///
    /// SHA1 hash of all the voices.
    pub static voices_sha1: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "voices_sha1".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4223.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.webglinfo
    ///
    /// A JSON blob that contains information about the graphics hardware exposed by
    /// WebGL.
    pub static webglinfo: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "webglinfo".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(4224.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.zoom_count
    ///
    /// Number of domains the users has a non-default zoom level.
    pub static zoom_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "zoom_count".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4225.into(), meta)
    });

}
pub mod fingerprinting_protection {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from fingerprinting.protection.canvas_noise_calculate_time
    ///
    /// Counts how long to generate canvas random noises.
    pub static canvas_noise_calculate_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvas_noise_calculate_time".into(),
                category: "fingerprinting.protection".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(4226.into(), meta, TimeUnit::Millisecond)
    });

}
pub mod search_engine_default {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ChangedExtra {
        pub r#change_source: Option<String>,
        pub r#new_display_name: Option<String>,
        pub r#new_engine_id: Option<String>,
        pub r#new_load_path: Option<String>,
        pub r#new_submission_url: Option<String>,
        pub r#previous_engine_id: Option<String>,
    }

    impl ExtraKeys for ChangedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["change_source", "new_display_name", "new_engine_id", "new_load_path", "new_submission_url", "previous_engine_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#change_source.and_then(|val| map.insert("change_source".into(), val.to_string()));
          self.r#new_display_name.and_then(|val| map.insert("new_display_name".into(), val.to_string()));
          self.r#new_engine_id.and_then(|val| map.insert("new_engine_id".into(), val.to_string()));
          self.r#new_load_path.and_then(|val| map.insert("new_load_path".into(), val.to_string()));
          self.r#new_submission_url.and_then(|val| map.insert("new_submission_url".into(), val.to_string()));
          self.r#previous_engine_id.and_then(|val| map.insert("previous_engine_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.changed
    ///
    /// Recorded when the default search engine is changed.
    pub static changed: Lazy<EventMetric<ChangedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "changed".into(),
                category: "search.engine.default".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4227.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.display_name
    ///
    /// The display name of the user's default engine.
    pub static display_name: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "display_name".into(),
                category: "search.engine.default".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4228.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.engine_id
    ///
    /// The telemetry id of the search engine.
    /// For application provided engines, this is either supplied by the
    /// configuration or from the first part of the associated WebExtension Id.
    /// For other engines, this is `other-<extensionName>`.
    pub static engine_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "engine_id".into(),
                category: "search.engine.default".into(),
                send_in_pings: vec!["metrics".into(), "newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4229.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.load_path
    ///
    /// A path relating to where the search engine was installed/loaded from.
    /// For example:
    ///   `[addon]<extension id>` for a WebExtension based
    ///   engine.
    ///   `[https]developer.mozilla.org/mdn-web-docs.xml` for an OpenSearch based
    ///   engine.
    /// Note: this metric is truncated at 100 characters.
    pub static load_path: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_path".into(),
                category: "search.engine.default".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4230.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.submission_url
    ///
    /// The submission URL of the default engine. This is only reported in the
    /// cases where:
    ///   The engine is an application provided engine.
    ///   The engine has the same name as an application provided engine.
    ///   The engine matches one of a specific list of well known search engines.
    pub static submission_url: Lazy<UrlMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "submission_url".into(),
                category: "search.engine.default".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        UrlMetric::new(4231.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.verified
    ///
    /// The verified status of the search engine.
    /// For application provided engines, this will always be `default`.
    /// For other engines this will either be `verified` or `unverified` depending
    /// on if the loadPathHash is valid.
    pub static verified: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "verified".into(),
                category: "search.engine.default".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4232.into(), meta)
    });

}
pub mod search_engine_private {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ChangedExtra {
        pub r#change_source: Option<String>,
        pub r#new_display_name: Option<String>,
        pub r#new_engine_id: Option<String>,
        pub r#new_load_path: Option<String>,
        pub r#new_submission_url: Option<String>,
        pub r#previous_engine_id: Option<String>,
    }

    impl ExtraKeys for ChangedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["change_source", "new_display_name", "new_engine_id", "new_load_path", "new_submission_url", "previous_engine_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#change_source.and_then(|val| map.insert("change_source".into(), val.to_string()));
          self.r#new_display_name.and_then(|val| map.insert("new_display_name".into(), val.to_string()));
          self.r#new_engine_id.and_then(|val| map.insert("new_engine_id".into(), val.to_string()));
          self.r#new_load_path.and_then(|val| map.insert("new_load_path".into(), val.to_string()));
          self.r#new_submission_url.and_then(|val| map.insert("new_submission_url".into(), val.to_string()));
          self.r#previous_engine_id.and_then(|val| map.insert("previous_engine_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.changed
    ///
    /// Recorded when the default search engine is changed
    pub static changed: Lazy<EventMetric<ChangedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "changed".into(),
                category: "search.engine.private".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4233.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.display_name
    ///
    /// The display name of the user's default engine.
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static display_name: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "display_name".into(),
                category: "search.engine.private".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4234.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.engine_id
    ///
    /// The telemetry id of the search engine.
    /// For application provided engines, this is either supplied by the
    /// configuration or from the first part of the associated WebExtension Id.
    /// For other engines, this is `other-<extensionName>`.
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static engine_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "engine_id".into(),
                category: "search.engine.private".into(),
                send_in_pings: vec!["metrics".into(), "newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4235.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.load_path
    ///
    /// A path relating to where the search engine was installed/loaded from.
    /// For example:
    ///   `[addon]<extension id>` for a WebExtension based
    ///   engine.
    ///   `[https]developer.mozilla.org/mdn-web-docs.xml` for an OpenSearch based
    ///   engine.
    /// Note: this metric is truncated at 100 characters.
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static load_path: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_path".into(),
                category: "search.engine.private".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4236.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.submission_url
    ///
    /// The submission URL of the default engine. This is only reported in the
    /// cases where:
    ///   The engine is an application provided engine.
    ///   The engine has the same name as an application provided engine.
    ///   The engine matches one of a specific list of well known search engines.
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static submission_url: Lazy<UrlMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "submission_url".into(),
                category: "search.engine.private".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        UrlMetric::new(4237.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.verified
    ///
    /// The verified status of the search engine.
    /// For application provided engines, this will always be `default`.
    /// For other engines this will either be `verified` or `unverified` depending
    /// on if the loadPathHash is valid.
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static verified: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "verified".into(),
                category: "search.engine.private".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4238.into(), meta)
    });

}
pub mod search_service {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum InitializationStatusLabel {
        EFailedsettings = 0,
        EFailedfetchengines = 1,
        EFailedloadengines = 2,
        ESuccess = 3,
        __Other__,
    }
    impl From<u16> for InitializationStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFailedsettings,
                1 => Self::EFailedfetchengines,
                2 => Self::EFailedloadengines,
                3 => Self::ESuccess,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for InitializationStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFailedsettings => "failedSettings",
                Self::EFailedfetchengines => "failedFetchEngines",
                Self::EFailedloadengines => "failedLoadEngines",
                Self::ESuccess => "success",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from search.service.initialization_status
    ///
    /// Counts the type of initialization statuses on start up.
    /// failedSettings - failed loading and migrating the search settings file.
    /// failedFetchEngines - failed to load or parse the configuration from remote
    ///                      settings.
    /// failedLoadEngines - failed to create all the search engines from the
    ///                     configuration or user installed engines.
    /// success - search service successfully initialized.
    pub static initialization_status: Lazy<LabeledMetric<LabeledCounterMetric, InitializationStatusLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "initialization_status".into(),
                    category: "search.service".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(4239.into(), meta, Some(vec![::std::borrow::Cow::from("failedFetchEngines"), ::std::borrow::Cow::from("failedLoadEngines"), ::std::borrow::Cow::from("failedSettings"), ::std::borrow::Cow::from("success")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.service.startup_time
    ///
    /// The time duration it takes for the search service to start up.
    pub static startup_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "startup_time".into(),
                category: "search.service".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(4240.into(), meta, TimeUnit::Nanosecond)
    });

}
pub mod shopping_product {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.invalid_ohttp_config
    ///
    /// OHTTP was configured for shopping but the config is invalid.
    pub static invalid_ohttp_config: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "invalid_ohttp_config".into(),
                category: "shopping_product".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4241.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.invalid_request
    ///
    /// An invalid JSON request was sent to the Fakespot API.
    pub static invalid_request: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "invalid_request".into(),
                category: "shopping_product".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4242.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.invalid_response
    ///
    /// An invalid JSON response was received from the Fakespot API.
    pub static invalid_response: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "invalid_response".into(),
                category: "shopping_product".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4243.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.request_aborted
    ///
    /// Request to the Fakespot API was aborted.
    pub static request_aborted: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "request_aborted".into(),
                category: "shopping_product".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4244.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.request_error
    ///
    /// There was an error requesting the Fakespot API.
    pub static request_error: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "request_error".into(),
                category: "shopping_product".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4245.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.request_failure
    ///
    /// There was a failure with the request to the Fakespot API.
    pub static request_failure: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "request_failure".into(),
                category: "shopping_product".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4246.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.request_retried
    ///
    /// Status returned a 500 error when requesting the Fakespot API
    /// and will be retried.
    pub static request_retried: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "request_retried".into(),
                category: "shopping_product".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4247.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.request_retries_failed
    ///
    /// Request still failed after the maxiumn number of
    /// retry events.
    pub static request_retries_failed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "request_retries_failed".into(),
                category: "shopping_product".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4248.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.server_failure
    ///
    /// There was a Fakespot API server issue that prevented
    /// the request from succeeding.
    pub static server_failure: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "server_failure".into(),
                category: "shopping_product".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4249.into(), meta)
    });

}
pub mod legacy_telemetry {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from legacy.telemetry.client_id
    ///
    /// The client_id according to Telemetry.
    /// Might not always have a value due to being too early for it to have
    /// loaded.
    /// Value may be the canary client id `c0ffeec0-ffee-c0ff-eec0-ffeec0ffeec0`
    /// in pings near when the data upload pref is disabled (if Telemetry gets
    /// to go first), or between when a client_id has been removed and when it
    /// has been regenerated.
    /// Does not need to be sent in the Glean "deletion-request" ping.
    pub static client_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "client_id".into(),
                category: "legacy.telemetry".into(),
                send_in_pings: vec!["baseline".into(), "dau-reporting".into(), "events".into(), "metrics".into(), "newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(4250.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from legacy.telemetry.profile_group_id
    ///
    /// The profile_group_id according to Telemetry.
    /// Might not always have a value due to being too early for it to have
    /// loaded.
    /// Does not need to be sent in the Glean "deletion-request" ping.
    pub static profile_group_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "profile_group_id".into(),
                category: "legacy.telemetry".into(),
                send_in_pings: vec!["baseline".into(), "dau-reporting".into(), "events".into(), "metrics".into(), "newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(4251.into(), meta)
    });

}
pub mod telemetry {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.data_upload_optin
    ///
    /// User opted into sending Telemetry data again. This metric was generated to
    /// correspond to the Legacy Telemetry scalar telemetry.data_upload_optin.
    pub static data_upload_optin: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "data_upload_optin".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4252.into(), meta)
    });

}
pub mod telemetry_test {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct Test1Object1Extra {
        pub r#key1: Option<String>,
        pub r#key2: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for Test1Object1Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["key1", "key2", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#key1.and_then(|val| map.insert("key1".into(), val.to_string()));
          self.r#key2.and_then(|val| map.insert("key2".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from telemetry.test.test1_object1
    ///
    /// This is a test entry for Telemetry. This event was generated to correspond to
    /// the Legacy Telemetry event telemetry.test.test1#object1.
    pub static test1_object1: Lazy<EventMetric<Test1Object1Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "test1_object1".into(),
                category: "telemetry.test".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4253.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct Test2Object1Extra {
        pub r#key1: Option<String>,
        pub r#key2: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for Test2Object1Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["key1", "key2", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#key1.and_then(|val| map.insert("key1".into(), val.to_string()));
          self.r#key2.and_then(|val| map.insert("key2".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from telemetry.test.test2_object1
    ///
    /// This is a test entry for Telemetry. This event was generated to correspond to
    /// the Legacy Telemetry event telemetry.test.test2#object1.
    pub static test2_object1: Lazy<EventMetric<Test2Object1Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "test2_object1".into(),
                category: "telemetry.test".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4254.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct Test2Object2Extra {
        pub r#key1: Option<String>,
        pub r#key2: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for Test2Object2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["key1", "key2", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#key1.and_then(|val| map.insert("key1".into(), val.to_string()));
          self.r#key2.and_then(|val| map.insert("key2".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from telemetry.test.test2_object2
    ///
    /// This is a test entry for Telemetry. This event was generated to correspond to
    /// the Legacy Telemetry event telemetry.test.test2#object2.
    pub static test2_object2: Lazy<EventMetric<Test2Object2Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "test2_object2".into(),
                category: "telemetry.test".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4255.into(), meta)
    });

}
pub mod translations {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ErrorExtra {
        pub r#flow_id: Option<String>,
        pub r#reason: Option<String>,
    }

    impl ExtraKeys for ErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.error
    ///
    /// The specific translations error that caused a full_page translation failure.
    pub static error: Lazy<EventMetric<ErrorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "error".into(),
                category: "translations".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4256.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from translations.error_rate
    ///
    /// The rate of failed translations requests.
    pub static error_rate: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "error_rate".into(),
                category: "translations".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(4257.into(), meta)
    });

    #[repr(u16)]
    pub enum RequestCountLabel {
        EFullPage = 0,
        ESelect = 1,
        __Other__,
    }
    impl From<u16> for RequestCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFullPage,
                1 => Self::ESelect,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RequestCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFullPage => "full_page",
                Self::ESelect => "select",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.request_count
    ///
    /// The count of translation requests, along with their type.
    pub static request_count: Lazy<LabeledMetric<LabeledCounterMetric, RequestCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "request_count".into(),
                    category: "translations".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(4258.into(), meta, Some(vec![::std::borrow::Cow::from("full_page"), ::std::borrow::Cow::from("select")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from translations.requests_count
    ///
    /// The count of translation requests.
    pub static requests_count: Lazy<DenominatorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "requests_count".into(),
                category: "translations".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DenominatorMetric::new(4259.into(), meta, vec![CommonMetricData {name: "error_rate".into(), category: "translations".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RestorePageExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for RestorePageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.restore_page
    ///
    /// Triggers when the a restore-page event is triggered.
    pub static restore_page: Lazy<EventMetric<RestorePageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "restore_page".into(),
                category: "translations".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4260.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TranslationRequestExtra {
        pub r#auto_translate: Option<bool>,
        pub r#document_language: Option<String>,
        pub r#flow_id: Option<String>,
        pub r#from_language: Option<String>,
        pub r#request_target: Option<String>,
        pub r#source_text_code_units: Option<u32>,
        pub r#source_text_word_count: Option<u32>,
        pub r#to_language: Option<String>,
        pub r#top_preferred_language: Option<String>,
    }

    impl ExtraKeys for TranslationRequestExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["auto_translate", "document_language", "flow_id", "from_language", "request_target", "source_text_code_units", "source_text_word_count", "to_language", "top_preferred_language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#auto_translate.and_then(|val| map.insert("auto_translate".into(), val.to_string()));
          self.r#document_language.and_then(|val| map.insert("document_language".into(), val.to_string()));
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#from_language.and_then(|val| map.insert("from_language".into(), val.to_string()));
          self.r#request_target.and_then(|val| map.insert("request_target".into(), val.to_string()));
          self.r#source_text_code_units.and_then(|val| map.insert("source_text_code_units".into(), val.to_string()));
          self.r#source_text_word_count.and_then(|val| map.insert("source_text_word_count".into(), val.to_string()));
          self.r#to_language.and_then(|val| map.insert("to_language".into(), val.to_string()));
          self.r#top_preferred_language.and_then(|val| map.insert("top_preferred_language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.translation_request
    ///
    /// Triggers when a full-page translation request is sent.
    pub static translation_request: Lazy<EventMetric<TranslationRequestExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "translation_request".into(),
                category: "translations".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4261.into(), meta)
    });

}
pub mod translations_panel {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AboutTranslationsExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for AboutTranslationsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.about_translations
    ///
    /// Triggers when the about-translations menuitem is invoked in the full-page
    /// translations panel settings.
    pub static about_translations: Lazy<EventMetric<AboutTranslationsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "about_translations".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4262.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AlwaysOfferTranslationsExtra {
        pub r#flow_id: Option<String>,
        pub r#toggled_on: Option<bool>,
    }

    impl ExtraKeys for AlwaysOfferTranslationsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "toggled_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#toggled_on.and_then(|val| map.insert("toggled_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.always_offer_translations
    ///
    /// Triggers when the always-offer-translations menuitem is invoked in the full-
    /// page translations panel seeings.
    pub static always_offer_translations: Lazy<EventMetric<AlwaysOfferTranslationsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "always_offer_translations".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4263.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AlwaysTranslateLanguageExtra {
        pub r#flow_id: Option<String>,
        pub r#language: Option<String>,
        pub r#toggled_on: Option<bool>,
    }

    impl ExtraKeys for AlwaysTranslateLanguageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "language", "toggled_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#language.and_then(|val| map.insert("language".into(), val.to_string()));
          self.r#toggled_on.and_then(|val| map.insert("toggled_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.always_translate_language
    ///
    /// Triggers when the always-translate-language menuitem is invoked in the full-
    /// page translations panel settings.
    pub static always_translate_language: Lazy<EventMetric<AlwaysTranslateLanguageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "always_translate_language".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4264.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CancelButtonExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for CancelButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.cancel_button
    ///
    /// Triggers when the cancel button is invoked in the full-page translations panel.
    pub static cancel_button: Lazy<EventMetric<CancelButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel_button".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4265.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ChangeFromLanguageExtra {
        pub r#flow_id: Option<String>,
        pub r#language: Option<String>,
    }

    impl ExtraKeys for ChangeFromLanguageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#language.and_then(|val| map.insert("language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.change_from_language
    ///
    /// Triggers when the from-language selected value is changed.
    pub static change_from_language: Lazy<EventMetric<ChangeFromLanguageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "change_from_language".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4266.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ChangeSourceLanguageButtonExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for ChangeSourceLanguageButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.change_source_language_button
    ///
    /// Triggers when the change-source-language button is invoked in the full-page
    /// translations panel.
    pub static change_source_language_button: Lazy<EventMetric<ChangeSourceLanguageButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "change_source_language_button".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4267.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ChangeToLanguageExtra {
        pub r#flow_id: Option<String>,
        pub r#language: Option<String>,
    }

    impl ExtraKeys for ChangeToLanguageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#language.and_then(|val| map.insert("language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.change_to_language
    ///
    /// Triggers when the to-language selected value is changed.
    pub static change_to_language: Lazy<EventMetric<ChangeToLanguageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "change_to_language".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4268.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CloseExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for CloseExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.close
    ///
    /// Triggers when full-page translations panel is closed.
    pub static close: Lazy<EventMetric<CloseExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "close".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4269.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CloseFromLanguageMenuExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for CloseFromLanguageMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.close_from_language_menu
    ///
    /// Triggers when the from-language dropdown is closed in the full-page
    /// translations panel.
    pub static close_from_language_menu: Lazy<EventMetric<CloseFromLanguageMenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "close_from_language_menu".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4270.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CloseSettingsMenuExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for CloseSettingsMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.close_settings_menu
    ///
    /// Triggers when the settings menu is closed in the full-page translations panel.
    pub static close_settings_menu: Lazy<EventMetric<CloseSettingsMenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "close_settings_menu".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4271.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CloseToLanguageMenuExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for CloseToLanguageMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.close_to_language_menu
    ///
    /// Triggers when the from-language dropdown is closed in the full-page
    /// translations panel.
    pub static close_to_language_menu: Lazy<EventMetric<CloseToLanguageMenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "close_to_language_menu".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4272.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DismissErrorButtonExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for DismissErrorButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.dismiss_error_button
    ///
    /// Triggers when the dismiss-error button is invoked in the full-page translations
    /// panel.
    pub static dismiss_error_button: Lazy<EventMetric<DismissErrorButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dismiss_error_button".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4273.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LearnMoreExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for LearnMoreExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.learn_more
    ///
    /// Triggers when the learn-more link is invoked in the full-page translations
    /// panel first interaction.
    pub static learn_more: Lazy<EventMetric<LearnMoreExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "learn_more".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4274.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ManageLanguagesExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for ManageLanguagesExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.manage_languages
    ///
    /// Triggers when the manage-languages menuitem is invoked in the full-page
    /// translations panel settings.
    pub static manage_languages: Lazy<EventMetric<ManageLanguagesExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "manage_languages".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4275.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct NeverTranslateLanguageExtra {
        pub r#flow_id: Option<String>,
        pub r#language: Option<String>,
        pub r#toggled_on: Option<bool>,
    }

    impl ExtraKeys for NeverTranslateLanguageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "language", "toggled_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#language.and_then(|val| map.insert("language".into(), val.to_string()));
          self.r#toggled_on.and_then(|val| map.insert("toggled_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.never_translate_language
    ///
    /// Triggers when the never-translate-language menuitem is invoked in the full-page
    /// translations panel settings.
    pub static never_translate_language: Lazy<EventMetric<NeverTranslateLanguageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "never_translate_language".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4276.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct NeverTranslateSiteExtra {
        pub r#flow_id: Option<String>,
        pub r#toggled_on: Option<bool>,
    }

    impl ExtraKeys for NeverTranslateSiteExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "toggled_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#toggled_on.and_then(|val| map.insert("toggled_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.never_translate_site
    ///
    /// Triggers when the never-translate-site menuitem is invoked in the full-page
    /// translations panel settings.
    pub static never_translate_site: Lazy<EventMetric<NeverTranslateSiteExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "never_translate_site".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4277.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenExtra {
        pub r#auto_show: Option<bool>,
        pub r#document_language: Option<String>,
        pub r#flow_id: Option<String>,
        pub r#opened_from: Option<String>,
        pub r#view_name: Option<String>,
    }

    impl ExtraKeys for OpenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["auto_show", "document_language", "flow_id", "opened_from", "view_name"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#auto_show.and_then(|val| map.insert("auto_show".into(), val.to_string()));
          self.r#document_language.and_then(|val| map.insert("document_language".into(), val.to_string()));
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#opened_from.and_then(|val| map.insert("opened_from".into(), val.to_string()));
          self.r#view_name.and_then(|val| map.insert("view_name".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.open
    ///
    /// Triggers when the full-page translations panel is opened.
    pub static open: Lazy<EventMetric<OpenExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4278.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenFromLanguageMenuExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for OpenFromLanguageMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.open_from_language_menu
    ///
    /// Triggers when the from-language dropdown is opened in the full-page
    /// translations panel.
    pub static open_from_language_menu: Lazy<EventMetric<OpenFromLanguageMenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_from_language_menu".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4279.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenSettingsMenuExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for OpenSettingsMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.open_settings_menu
    ///
    /// Triggers when the settings menu is opened in the full-page translations panel.
    pub static open_settings_menu: Lazy<EventMetric<OpenSettingsMenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_settings_menu".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4280.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenToLanguageMenuExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for OpenToLanguageMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.open_to_language_menu
    ///
    /// Triggers when the from-language dropdown is opened in the full-page
    /// translations panel.
    pub static open_to_language_menu: Lazy<EventMetric<OpenToLanguageMenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_to_language_menu".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4281.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RestorePageButtonExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for RestorePageButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.restore_page_button
    ///
    /// Triggers when the restore-page button is invoked in the full-page translations
    /// panel.
    pub static restore_page_button: Lazy<EventMetric<RestorePageButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "restore_page_button".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4282.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TranslateButtonExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for TranslateButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.translate_button
    ///
    /// Triggers when the translate button is invoked in the full-page translations
    /// panel.
    pub static translate_button: Lazy<EventMetric<TranslateButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "translate_button".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4283.into(), meta)
    });

}
pub mod translations_select_translations_panel {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AboutTranslationsExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for AboutTranslationsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.about_translations
    ///
    /// Triggers when the about-translations menuitem is invoked in the select
    /// translations panel settings.
    pub static about_translations: Lazy<EventMetric<AboutTranslationsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "about_translations".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4284.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CancelButtonExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for CancelButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.cancel_button
    ///
    /// Triggers when the cancel button is invoked in the select translations panel.
    pub static cancel_button: Lazy<EventMetric<CancelButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel_button".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4285.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ChangeFromLanguageExtra {
        pub r#document_language: Option<String>,
        pub r#flow_id: Option<String>,
        pub r#language: Option<String>,
        pub r#previous_language: Option<String>,
    }

    impl ExtraKeys for ChangeFromLanguageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["document_language", "flow_id", "language", "previous_language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#document_language.and_then(|val| map.insert("document_language".into(), val.to_string()));
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#language.and_then(|val| map.insert("language".into(), val.to_string()));
          self.r#previous_language.and_then(|val| map.insert("previous_language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.change_from_language
    ///
    /// Triggers when the from-language selected value is changed.
    pub static change_from_language: Lazy<EventMetric<ChangeFromLanguageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "change_from_language".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4286.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ChangeToLanguageExtra {
        pub r#flow_id: Option<String>,
        pub r#language: Option<String>,
    }

    impl ExtraKeys for ChangeToLanguageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#language.and_then(|val| map.insert("language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.change_to_language
    ///
    /// Triggers when the to-language selected value is changed.
    pub static change_to_language: Lazy<EventMetric<ChangeToLanguageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "change_to_language".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4287.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CloseExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for CloseExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.close
    ///
    /// Triggers when the select translations panel is closed.
    pub static close: Lazy<EventMetric<CloseExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "close".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4288.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CopyButtonExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for CopyButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.copy_button
    ///
    /// Triggers when the copy button is invoked in the select translations panel.
    pub static copy_button: Lazy<EventMetric<CopyButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "copy_button".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4289.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DoneButtonExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for DoneButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.done_button
    ///
    /// Triggers when the done button is invoked in the select translations panel.
    pub static done_button: Lazy<EventMetric<DoneButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "done_button".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4290.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InitializationFailureMessageExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for InitializationFailureMessageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.initialization_failure_message
    ///
    /// Triggers when the initialization-failure message is shown in the select
    /// translations panel.
    pub static initialization_failure_message: Lazy<EventMetric<InitializationFailureMessageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "initialization_failure_message".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4291.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenExtra {
        pub r#document_language: Option<String>,
        pub r#flow_id: Option<String>,
        pub r#from_language: Option<String>,
        pub r#text_source: Option<String>,
        pub r#to_language: Option<String>,
        pub r#top_preferred_language: Option<String>,
    }

    impl ExtraKeys for OpenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["document_language", "flow_id", "from_language", "text_source", "to_language", "top_preferred_language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#document_language.and_then(|val| map.insert("document_language".into(), val.to_string()));
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#from_language.and_then(|val| map.insert("from_language".into(), val.to_string()));
          self.r#text_source.and_then(|val| map.insert("text_source".into(), val.to_string()));
          self.r#to_language.and_then(|val| map.insert("to_language".into(), val.to_string()));
          self.r#top_preferred_language.and_then(|val| map.insert("top_preferred_language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.open
    ///
    /// Triggers when the select translations panel is opened.
    pub static open: Lazy<EventMetric<OpenExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4292.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenSettingsMenuExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for OpenSettingsMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.open_settings_menu
    ///
    /// Triggers when the settings menu is opened in the select translations panel.
    pub static open_settings_menu: Lazy<EventMetric<OpenSettingsMenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_settings_menu".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4293.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TranslateButtonExtra {
        pub r#detected_language: Option<String>,
        pub r#flow_id: Option<String>,
        pub r#from_language: Option<String>,
        pub r#to_language: Option<String>,
    }

    impl ExtraKeys for TranslateButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["detected_language", "flow_id", "from_language", "to_language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#detected_language.and_then(|val| map.insert("detected_language".into(), val.to_string()));
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#from_language.and_then(|val| map.insert("from_language".into(), val.to_string()));
          self.r#to_language.and_then(|val| map.insert("to_language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.translate_button
    ///
    /// Triggers when the translate button is invoked in the select translations panel.
    pub static translate_button: Lazy<EventMetric<TranslateButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "translate_button".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4294.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TranslateFullPageButtonExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for TranslateFullPageButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.translate_full_page_button
    ///
    /// Triggers when the translate-full-page button is invoked in the select
    /// translations panel.
    pub static translate_full_page_button: Lazy<EventMetric<TranslateFullPageButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "translate_full_page_button".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4295.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TranslationFailureMessageExtra {
        pub r#flow_id: Option<String>,
        pub r#from_language: Option<String>,
        pub r#to_language: Option<String>,
    }

    impl ExtraKeys for TranslationFailureMessageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "from_language", "to_language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#from_language.and_then(|val| map.insert("from_language".into(), val.to_string()));
          self.r#to_language.and_then(|val| map.insert("to_language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.translation_failure_message
    ///
    /// Triggers when the translation-failure message is shown in the select
    /// translations panel.
    pub static translation_failure_message: Lazy<EventMetric<TranslationFailureMessageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "translation_failure_message".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4296.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TranslationSettingsExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for TranslationSettingsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.translation_settings
    ///
    /// Triggers when the translation-settings menuitem is invoked in the select
    /// translations panel settings.
    pub static translation_settings: Lazy<EventMetric<TranslationSettingsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "translation_settings".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4297.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TryAgainButtonExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for TryAgainButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.try_again_button
    ///
    /// Triggers when the try-again button is invoked in the select translations panel.
    pub static try_again_button: Lazy<EventMetric<TryAgainButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "try_again_button".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4298.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnsupportedLanguageMessageExtra {
        pub r#detected_language: Option<String>,
        pub r#document_language: Option<String>,
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for UnsupportedLanguageMessageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["detected_language", "document_language", "flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#detected_language.and_then(|val| map.insert("detected_language".into(), val.to_string()));
          self.r#document_language.and_then(|val| map.insert("document_language".into(), val.to_string()));
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.unsupported_language_message
    ///
    /// Triggers when the unsupported-language message is shown in the select
    /// translations panel.
    pub static unsupported_language_message: Lazy<EventMetric<UnsupportedLanguageMessageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unsupported_language_message".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4299.into(), meta)
    });

}
pub mod findbar {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from findbar.find_next
    ///
    /// The count of how many times the find next button was used per session. This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// findbar.find_next.
    pub static find_next: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4300,
            "findbar",
            "find_next",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from findbar.find_prev
    ///
    /// The count of how many times the find previous button was used per session. This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// findbar.find_prev.
    pub static find_prev: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4301,
            "findbar",
            "find_prev",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from findbar.highlight_all
    ///
    /// The count of how many times the "Highlight All" button was used in find
    /// toolbar. This metric was generated to correspond to the Legacy Telemetry scalar
    /// findbar.highlight_all.
    pub static highlight_all: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4302,
            "findbar",
            "highlight_all",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from findbar.match_case
    ///
    /// The count of how many times the "Match Case" button was used in find toolbar.
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// findbar.match_case.
    pub static match_case: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4303,
            "findbar",
            "match_case",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from findbar.match_diacritics
    ///
    /// The count of how many times the "Match Diacritics" button was used in find
    /// toolbar. This metric was generated to correspond to the Legacy Telemetry scalar
    /// findbar.match_diacritics.
    pub static match_diacritics: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4304,
            "findbar",
            "match_diacritics",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from findbar.shown
    ///
    /// The count of how many times the "Find toolbar" was shown per session. This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// findbar.shown.
    pub static shown: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4305,
            "findbar",
            "shown",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from findbar.whole_words
    ///
    /// The count of how many times the "Whole Words" button was used in find toolbar.
    /// This metric was generated to correspond to the Legacy Telemetry scalar
    /// findbar.whole_words.
    pub static whole_words: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4306,
            "findbar",
            "whole_words",
            "metrics"
        )
    });

}
pub mod security_doh_neterror {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickAddExceptionButtonExtra {
        pub r#mode: Option<String>,
        pub r#provider_key: Option<String>,
        pub r#skip_reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickAddExceptionButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["mode", "provider_key", "skip_reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#mode.and_then(|val| map.insert("mode".into(), val.to_string()));
          self.r#provider_key.and_then(|val| map.insert("provider_key".into(), val.to_string()));
          self.r#skip_reason.and_then(|val| map.insert("skip_reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.neterror.click_add_exception_button
    ///
    /// User interaction by click buttons on the DoH warning page. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.doh.neterror.click#add_exception_button.
    pub static click_add_exception_button: Lazy<EventMetric<ClickAddExceptionButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_add_exception_button".into(),
                category: "security.doh.neterror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4307.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickContinueButtonExtra {
        pub r#mode: Option<String>,
        pub r#provider_key: Option<String>,
        pub r#skip_reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickContinueButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["mode", "provider_key", "skip_reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#mode.and_then(|val| map.insert("mode".into(), val.to_string()));
          self.r#provider_key.and_then(|val| map.insert("provider_key".into(), val.to_string()));
          self.r#skip_reason.and_then(|val| map.insert("skip_reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.neterror.click_continue_button
    ///
    /// User interaction by click buttons on the DoH warning page. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.doh.neterror.click#continue_button.
    pub static click_continue_button: Lazy<EventMetric<ClickContinueButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_continue_button".into(),
                category: "security.doh.neterror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4308.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickDisableWarningExtra {
        pub r#mode: Option<String>,
        pub r#provider_key: Option<String>,
        pub r#skip_reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickDisableWarningExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["mode", "provider_key", "skip_reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#mode.and_then(|val| map.insert("mode".into(), val.to_string()));
          self.r#provider_key.and_then(|val| map.insert("provider_key".into(), val.to_string()));
          self.r#skip_reason.and_then(|val| map.insert("skip_reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.neterror.click_disable_warning
    ///
    /// User interaction by click buttons on the DoH warning page. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.doh.neterror.click#disable_warning.
    pub static click_disable_warning: Lazy<EventMetric<ClickDisableWarningExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_disable_warning".into(),
                category: "security.doh.neterror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4309.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickLearnMoreLinkExtra {
        pub r#mode: Option<String>,
        pub r#provider_key: Option<String>,
        pub r#skip_reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickLearnMoreLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["mode", "provider_key", "skip_reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#mode.and_then(|val| map.insert("mode".into(), val.to_string()));
          self.r#provider_key.and_then(|val| map.insert("provider_key".into(), val.to_string()));
          self.r#skip_reason.and_then(|val| map.insert("skip_reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.neterror.click_learn_more_link
    ///
    /// User interaction by click buttons on the DoH warning page. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.doh.neterror.click#learn_more_link.
    pub static click_learn_more_link: Lazy<EventMetric<ClickLearnMoreLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_learn_more_link".into(),
                category: "security.doh.neterror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4310.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSettingsButtonExtra {
        pub r#mode: Option<String>,
        pub r#provider_key: Option<String>,
        pub r#skip_reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickSettingsButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["mode", "provider_key", "skip_reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#mode.and_then(|val| map.insert("mode".into(), val.to_string()));
          self.r#provider_key.and_then(|val| map.insert("provider_key".into(), val.to_string()));
          self.r#skip_reason.and_then(|val| map.insert("skip_reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.neterror.click_settings_button
    ///
    /// User interaction by click buttons on the DoH warning page. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.doh.neterror.click#settings_button.
    pub static click_settings_button: Lazy<EventMetric<ClickSettingsButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_settings_button".into(),
                category: "security.doh.neterror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4311.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickTryAgainButtonExtra {
        pub r#mode: Option<String>,
        pub r#provider_key: Option<String>,
        pub r#skip_reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickTryAgainButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["mode", "provider_key", "skip_reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#mode.and_then(|val| map.insert("mode".into(), val.to_string()));
          self.r#provider_key.and_then(|val| map.insert("provider_key".into(), val.to_string()));
          self.r#skip_reason.and_then(|val| map.insert("skip_reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.neterror.click_try_again_button
    ///
    /// User interaction by click buttons on the DoH warning page. This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.doh.neterror.click#try_again_button.
    pub static click_try_again_button: Lazy<EventMetric<ClickTryAgainButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_try_again_button".into(),
                category: "security.doh.neterror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4312.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadDohwarningExtra {
        pub r#mode: Option<u32>,
        pub r#provider_key: Option<String>,
        pub r#skip_reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for LoadDohwarningExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["mode", "provider_key", "skip_reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#mode.and_then(|val| map.insert("mode".into(), val.to_string()));
          self.r#provider_key.and_then(|val| map.insert("provider_key".into(), val.to_string()));
          self.r#skip_reason.and_then(|val| map.insert("skip_reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.neterror.load_dohwarning
    ///
    /// The DoH warning page is loaded. This event was generated to correspond to the
    /// Legacy Telemetry event security.doh.neterror.load#dohwarning.
    pub static load_dohwarning: Lazy<EventMetric<LoadDohwarningExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_dohwarning".into(),
                category: "security.doh.neterror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4313.into(), meta)
    });

}
pub mod security_ui_certerror {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickAdvancedButtonExtra {
        pub r#has_sts: Option<bool>,
        pub r#is_frame: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickAdvancedButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_sts", "is_frame", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_sts.and_then(|val| map.insert("has_sts".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.certerror.click_advanced_button
    ///
    /// User interaction by click events on the cert error page. Keyed by error code,
    /// see https://searchfox.org/mozilla-
    /// central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.certerror.click#advanced_button.
    pub static click_advanced_button: Lazy<EventMetric<ClickAdvancedButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_advanced_button".into(),
                category: "security.ui.certerror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4314.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickAutoReportCbExtra {
        pub r#has_sts: Option<bool>,
        pub r#is_frame: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickAutoReportCbExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_sts", "is_frame", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_sts.and_then(|val| map.insert("has_sts".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.certerror.click_auto_report_cb
    ///
    /// User interaction by click events on the cert error page. Keyed by error code,
    /// see https://searchfox.org/mozilla-
    /// central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.certerror.click#auto_report_cb.
    pub static click_auto_report_cb: Lazy<EventMetric<ClickAutoReportCbExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_auto_report_cb".into(),
                category: "security.ui.certerror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4315.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickClipboardButtonBotExtra {
        pub r#has_sts: Option<bool>,
        pub r#is_frame: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickClipboardButtonBotExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_sts", "is_frame", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_sts.and_then(|val| map.insert("has_sts".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.certerror.click_clipboard_button_bot
    ///
    /// User interaction by click events on the cert error page. Keyed by error code,
    /// see https://searchfox.org/mozilla-
    /// central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.certerror.click#clipboard_button_bot.
    pub static click_clipboard_button_bot: Lazy<EventMetric<ClickClipboardButtonBotExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_clipboard_button_bot".into(),
                category: "security.ui.certerror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4316.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickClipboardButtonTopExtra {
        pub r#has_sts: Option<bool>,
        pub r#is_frame: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickClipboardButtonTopExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_sts", "is_frame", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_sts.and_then(|val| map.insert("has_sts".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.certerror.click_clipboard_button_top
    ///
    /// User interaction by click events on the cert error page. Keyed by error code,
    /// see https://searchfox.org/mozilla-
    /// central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.certerror.click#clipboard_button_top.
    pub static click_clipboard_button_top: Lazy<EventMetric<ClickClipboardButtonTopExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_clipboard_button_top".into(),
                category: "security.ui.certerror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4317.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickErrorCodeLinkExtra {
        pub r#has_sts: Option<bool>,
        pub r#is_frame: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickErrorCodeLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_sts", "is_frame", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_sts.and_then(|val| map.insert("has_sts".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.certerror.click_error_code_link
    ///
    /// User interaction by click events on the cert error page. Keyed by error code,
    /// see https://searchfox.org/mozilla-
    /// central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.certerror.click#error_code_link.
    pub static click_error_code_link: Lazy<EventMetric<ClickErrorCodeLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_error_code_link".into(),
                category: "security.ui.certerror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4318.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickExceptionButtonExtra {
        pub r#has_sts: Option<bool>,
        pub r#is_frame: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickExceptionButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_sts", "is_frame", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_sts.and_then(|val| map.insert("has_sts".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.certerror.click_exception_button
    ///
    /// User interaction by click events on the cert error page. Keyed by error code,
    /// see https://searchfox.org/mozilla-
    /// central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.certerror.click#exception_button.
    pub static click_exception_button: Lazy<EventMetric<ClickExceptionButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_exception_button".into(),
                category: "security.ui.certerror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4319.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickLearnMoreLinkExtra {
        pub r#has_sts: Option<bool>,
        pub r#is_frame: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickLearnMoreLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_sts", "is_frame", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_sts.and_then(|val| map.insert("has_sts".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.certerror.click_learn_more_link
    ///
    /// User interaction by click events on the cert error page. Keyed by error code,
    /// see https://searchfox.org/mozilla-
    /// central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.certerror.click#learn_more_link.
    pub static click_learn_more_link: Lazy<EventMetric<ClickLearnMoreLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_learn_more_link".into(),
                category: "security.ui.certerror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4320.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickReturnButtonAdvExtra {
        pub r#has_sts: Option<bool>,
        pub r#is_frame: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickReturnButtonAdvExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_sts", "is_frame", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_sts.and_then(|val| map.insert("has_sts".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.certerror.click_return_button_adv
    ///
    /// User interaction by click events on the cert error page. Keyed by error code,
    /// see https://searchfox.org/mozilla-
    /// central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.certerror.click#return_button_adv.
    pub static click_return_button_adv: Lazy<EventMetric<ClickReturnButtonAdvExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_return_button_adv".into(),
                category: "security.ui.certerror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4321.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickReturnButtonTopExtra {
        pub r#has_sts: Option<bool>,
        pub r#is_frame: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickReturnButtonTopExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_sts", "is_frame", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_sts.and_then(|val| map.insert("has_sts".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.certerror.click_return_button_top
    ///
    /// User interaction by click events on the cert error page. Keyed by error code,
    /// see https://searchfox.org/mozilla-
    /// central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.certerror.click#return_button_top.
    pub static click_return_button_top: Lazy<EventMetric<ClickReturnButtonTopExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_return_button_top".into(),
                category: "security.ui.certerror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4322.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadAboutcerterrorExtra {
        pub r#channel_status: Option<u32>,
        pub r#has_sts: Option<bool>,
        pub r#is_frame: Option<bool>,
        pub r#issued_by_cca: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for LoadAboutcerterrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["channel_status", "has_sts", "is_frame", "issued_by_cca", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#channel_status.and_then(|val| map.insert("channel_status".into(), val.to_string()));
          self.r#has_sts.and_then(|val| map.insert("has_sts".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#issued_by_cca.and_then(|val| map.insert("issued_by_cca".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.certerror.load_aboutcerterror
    ///
    /// The about:certerror page is loaded, keyed by error code, see
    /// https://searchfox.org/mozilla-
    /// central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was
    /// generated to correspond to the Legacy Telemetry event
    /// security.ui.certerror.load#aboutcerterror.
    pub static load_aboutcerterror: Lazy<EventMetric<LoadAboutcerterrorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_aboutcerterror".into(),
                category: "security.ui.certerror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4323.into(), meta)
    });

}
pub mod security_ui_tlserror {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadAbouttlserrorExtra {
        pub r#channel_status: Option<u32>,
        pub r#is_frame: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for LoadAbouttlserrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["channel_status", "is_frame", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#channel_status.and_then(|val| map.insert("channel_status".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.tlserror.load_abouttlserror
    ///
    /// The about:neterror page is loaded with a TLS error or non- overridable
    /// certificate error, keyed by error code. This event was generated to correspond
    /// to the Legacy Telemetry event security.ui.tlserror.load#abouttlserror.
    pub static load_abouttlserror: Lazy<EventMetric<LoadAbouttlserrorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_abouttlserror".into(),
                category: "security.ui.tlserror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4324.into(), meta)
    });

}
pub mod first_startup {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from first_startup.delete_tasks_time
    ///
    /// Number of milliseconds until TaskScheduler.deleteAllTasks resolved in
    /// FirstStartup.
    pub static delete_tasks_time: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "delete_tasks_time".into(),
                category: "first_startup".into(),
                send_in_pings: vec!["first-startup".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4325.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from first_startup.elapsed
    ///
    /// Number of milliseconds the FirstStartup service took to run.
    pub static elapsed: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "elapsed".into(),
                category: "first_startup".into(),
                send_in_pings: vec!["first-startup".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4326.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from first_startup.new_profile
    ///
    /// True if FirstStartup was initted after a new profile was just created. If
    /// false, this means that FirstStartup was initted with a pre-existing profile,
    /// which is a no-op.
    pub static new_profile: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "new_profile".into(),
                category: "first_startup".into(),
                send_in_pings: vec!["first-startup".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4327.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from first_startup.normandy_init_time
    ///
    /// Number of milliseconds until Normandy.init resolved in FirstStartup.
    pub static normandy_init_time: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "normandy_init_time".into(),
                category: "first_startup".into(),
                send_in_pings: vec!["first-startup".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4328.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from first_startup.status_code
    ///
    /// Status of the FirstStartup service, which runs
    /// post-install/early-startup in Firefox.
    pub static status_code: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "status_code".into(),
                category: "first_startup".into(),
                send_in_pings: vec!["first-startup".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4329.into(), meta)
    });

}
pub mod jsonfile {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadAutofillprofilesExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for LoadAutofillprofilesExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from jsonfile.load_autofillprofiles
    ///
    /// Records when JSONFile.sys.mjs consumers are trying to access a missing or
    /// corrupt json file. For example, Login Store trying to access logins.json when
    /// it has gone missing or corrupt. This event was generated to correspond to the
    /// Legacy Telemetry event jsonfile.load#autofillprofiles.
    pub static load_autofillprofiles: Lazy<EventMetric<LoadAutofillprofilesExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_autofillprofiles".into(),
                category: "jsonfile".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4330.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadLoginsExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for LoadLoginsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from jsonfile.load_logins
    ///
    /// Records when JSONFile.sys.mjs consumers are trying to access a missing or
    /// corrupt json file. For example, Login Store trying to access logins.json when
    /// it has gone missing or corrupt. This event was generated to correspond to the
    /// Legacy Telemetry event jsonfile.load#logins.
    pub static load_logins: Lazy<EventMetric<LoadLoginsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_logins".into(),
                category: "jsonfile".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4331.into(), meta)
    });

}
pub mod service_request {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct BypassProxyInfoExtra {
        pub r#source: Option<String>,
        pub r#type: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for BypassProxyInfoExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["source", "type", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#type.and_then(|val| map.insert("type".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from service_request.bypass_proxy_info
    ///
    /// This event is recorded by a small set of services when a proxy failure causes a
    /// service to re-request with a proxy bypass.  It records some basic information
    /// such as the type of proxy configuration, and the source of the proxy
    /// configuration.  The value of the event is the name of the service that triggers
    /// the event (e.g. telemetry, remote-settings). This event was generated to
    /// correspond to the Legacy Telemetry event service_request.bypass#proxy_info.
    pub static bypass_proxy_info: Lazy<EventMetric<BypassProxyInfoExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "bypass_proxy_info".into(),
                category: "service_request".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4332.into(), meta)
    });

}
pub mod defaultagent {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from defaultagent.days_since_last_app_launch
    ///
    /// Number of days since the app last launched. Once this reaches 90 days, the
    /// installation will stop running the default browser agent.
    pub static days_since_last_app_launch: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "days_since_last_app_launch".into(),
                category: "defaultagent".into(),
                send_in_pings: vec!["default-agent".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(4333.into(), meta)
    });

}
pub mod notification {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from notification.action
    ///
    /// The action that the user took in response to the notification. Possible values
    /// currently include the following: * “dismissed-by-timeout” * “dismissed-to-
    /// action-center” * “dismissed-by-button” * “dismissed-by-application-hidden” *
    /// “make-firefox-default-button” * “toast-clicked”
    /// Many of the values correspond to buttons on the notification and should be
    /// pretty self explanatory, but a few are less so. * “dismissed-to-action-center”
    /// will be used if the user clicks the arrow in
    ///   the top right corner of the notification to dismiss it to the
    ///   action center.
    /// * “dismissed-by-application-hidden” is provided because that is a method of
    ///   dismissal that the notification API could give but, in practice, should
    ///   never be seen.
    /// * “dismissed-by-timeout” indicates that the user did not interact with the
    ///   notification and it timed out.
    pub static action: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "action".into(),
                category: "notification".into(),
                send_in_pings: vec!["default-agent".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4334.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from notification.show_success
    ///
    /// Whether a notification was shown or not. Possible value include "shown" and
    /// "error".
    pub static show_success: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_success".into(),
                category: "notification".into(),
                send_in_pings: vec!["default-agent".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4335.into(), meta)
    });

}
pub mod system {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from system.os_version
    ///
    /// The current Windows OS version, usually as a dotted quad ("x.y.z.w") with
    /// Windows Update Build Revision (UBR), but potentially as a dotted triple
    /// ("x.y.z") without UBR.
    pub static os_version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "os_version".into(),
                category: "system".into(),
                send_in_pings: vec!["default-agent".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4336.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from system.previous_os_version
    ///
    /// The Windows OS version before it was changed to the current setting. The
    /// possible values are the same as for `system.os_version`.
    /// The OS does not keep track of the previous OS version, so the agent records
    /// this information itself. That means that it will be inaccurate until the first
    /// time the default is changed after the agent task begins running. Before then,
    /// the value of `previous_os_version` will be the same as `os_version`.
    /// This value is updated every time the Default Agent runs, so when the default
    /// browser is first changed the values for `os_version` and `previous_os_version`
    /// will be different. But on subsequent executions of the Default Agent, the two
    /// values will be the same.
    pub static previous_os_version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "previous_os_version".into(),
                category: "system".into(),
                send_in_pings: vec!["default-agent".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4337.into(), meta)
    });

}
pub mod system_default {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from system_default.browser
    ///
    /// Which browser is currently set as the system default web browser. This is
    /// simply a string with the name of the browser binned to a fixed set of known
    /// browsers.
    /// Possible values currently include the following (from
    /// [DefaultBrowser.cpp](https://searchfox.org/mozilla-
    /// central/source/toolkit/mozapps/defaultagent/DefaultBrowser.cpp)): * "error" *
    /// "" (unknown) * "firefox" * "chrome" * "edge" * "edge-chrome" * "ie" * "opera" *
    /// "brave" * "yandex" * "qq-browser" * "360-browser" * "sogou" * "duckduckgo"
    pub static browser: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "browser".into(),
                category: "system_default".into(),
                send_in_pings: vec!["default-agent".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4338.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from system_default.pdf_handler
    ///
    /// Which pdf handler is currently set as the system default handler. This is
    /// simply a string with the name of the handler binned to a fixed set of known
    /// handlers.
    /// Possible values currently include the following (from
    /// [DefaultPDF.cpp](https://searchfox.org/mozilla-
    /// central/source/toolkit/mozapps/defaultagent/DefaultPDF.cpp)): * "Error" * ""
    /// (unknown) * "Firefox" * "Microsoft Edge" * "Google Chrome" * "Adobe Acrobat" *
    /// "WPS" * "Nitro" * "Foxit" * "PDF-XChange" * "Avast" * "Sumatra"
    pub static pdf_handler: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pdf_handler".into(),
                category: "system_default".into(),
                send_in_pings: vec!["default-agent".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4339.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from system_default.previous_browser
    ///
    /// Which browser was set as the system default before it was changed to the
    /// current setting. The possible values are the same as for
    /// `system_default.browser`.
    /// The OS does not keep track of previous default settings, so the agent records
    /// this information itself. That means that it will be inaccurate until the first
    /// time the default is changed after the agent task begins running. Before then,
    /// the value of `previous_browser` will be the same as `browser`.
    /// This value is updated every time the Default Agent runs, so when the default
    /// browser is first changed the values for `browser` and `previous_browser` will
    /// be different. But on subsequent executions of the Default Agent, the two values
    /// will be the same.
    pub static previous_browser: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "previous_browser".into(),
                category: "system_default".into(),
                send_in_pings: vec!["default-agent".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4340.into(), meta)
    });

}
pub mod addons_manager {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallExtra {
        pub r#addon_id: Option<String>,
        pub r#addon_type: Option<String>,
        pub r#download_time: Option<u32>,
        pub r#error: Option<String>,
        pub r#install_id: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#num_strings: Option<u32>,
        pub r#source: Option<String>,
        pub r#source_method: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
    }

    impl ExtraKeys for InstallExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "addon_type", "download_time", "error", "install_id", "install_origins", "num_strings", "source", "source_method", "step", "updated_from"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#addon_type.and_then(|val| map.insert("addon_type".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_id.and_then(|val| map.insert("install_id".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#source_method.and_then(|val| map.insert("source_method".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install
    ///
    /// These events are recorded during the install and update flow for
    /// extensions and themes.
    pub static install: Lazy<EventMetric<InstallExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4341.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallStatsExtra {
        pub r#addon_id: Option<String>,
        pub r#addon_type: Option<String>,
        pub r#taar_based: Option<String>,
        pub r#utm_campaign: Option<String>,
        pub r#utm_content: Option<String>,
        pub r#utm_medium: Option<String>,
        pub r#utm_source: Option<String>,
    }

    impl ExtraKeys for InstallStatsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "addon_type", "taar_based", "utm_campaign", "utm_content", "utm_medium", "utm_source"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#addon_type.and_then(|val| map.insert("addon_type".into(), val.to_string()));
          self.r#taar_based.and_then(|val| map.insert("taar_based".into(), val.to_string()));
          self.r#utm_campaign.and_then(|val| map.insert("utm_campaign".into(), val.to_string()));
          self.r#utm_content.and_then(|val| map.insert("utm_content".into(), val.to_string()));
          self.r#utm_medium.and_then(|val| map.insert("utm_medium".into(), val.to_string()));
          self.r#utm_source.and_then(|val| map.insert("utm_source".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_stats
    ///
    /// These events are recorded at the end of the install flow, but only
    /// when the source that originally triggered the add-on installation
    /// is "amo", "rtamo" or "disco".
    pub static install_stats: Lazy<EventMetric<InstallStatsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_stats".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4342.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ManageExtra {
        pub r#addon_id: Option<String>,
        pub r#addon_type: Option<String>,
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<u32>,
        pub r#source: Option<String>,
        pub r#source_method: Option<String>,
    }

    impl ExtraKeys for ManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "addon_type", "blocklist_state", "method", "num_strings", "source", "source_method"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#addon_type.and_then(|val| map.insert("addon_type".into(), val.to_string()));
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#source_method.and_then(|val| map.insert("source_method".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.manage
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled.
    pub static manage: Lazy<EventMetric<ManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "manage".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4343.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReportSuspiciousSiteExtra {
        pub r#suspicious_site: Option<String>,
    }

    impl ExtraKeys for ReportSuspiciousSiteExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["suspicious_site"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#suspicious_site.and_then(|val| map.insert("suspicious_site".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.report_suspicious_site
    ///
    /// Sent when a user clicks "Report Suspicious Site" on the dropdown
    /// menu of the third-party xpinstall doorhanger.
    pub static report_suspicious_site: Lazy<EventMetric<ReportSuspiciousSiteExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "report_suspicious_site".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4344.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateExtra {
        pub r#addon_id: Option<String>,
        pub r#addon_type: Option<String>,
        pub r#download_time: Option<u32>,
        pub r#error: Option<String>,
        pub r#install_id: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#num_strings: Option<u32>,
        pub r#source: Option<String>,
        pub r#source_method: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
    }

    impl ExtraKeys for UpdateExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "addon_type", "download_time", "error", "install_id", "install_origins", "num_strings", "source", "source_method", "step", "updated_from"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#addon_type.and_then(|val| map.insert("addon_type".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_id.and_then(|val| map.insert("install_id".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#source_method.and_then(|val| map.insert("source_method".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.update
    ///
    /// These events are recorded during the install and update flow for
    /// extensions and themes.
    pub static update: Lazy<EventMetric<UpdateExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4345.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableDictionaryExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableDictionaryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.disable_dictionary
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.disable#dictionary.
    pub static disable_dictionary: Lazy<EventMetric<DisableDictionaryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_dictionary".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4346.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableExtensionExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableExtensionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.disable_extension
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.disable#extension.
    pub static disable_extension: Lazy<EventMetric<DisableExtensionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_extension".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4347.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableLocaleExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableLocaleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.disable_locale
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.disable#locale.
    pub static disable_locale: Lazy<EventMetric<DisableLocaleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_locale".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4348.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableOtherExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableOtherExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.disable_other
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.disable#other.
    pub static disable_other: Lazy<EventMetric<DisableOtherExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_other".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4349.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableSitepermDeprecatedExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableSitepermDeprecatedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.disable_siteperm_deprecated
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.disable#siteperm_deprecated.
    pub static disable_siteperm_deprecated: Lazy<EventMetric<DisableSitepermDeprecatedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_siteperm_deprecated".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4350.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableSitepermissionExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableSitepermissionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.disable_sitepermission
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.disable#sitepermission.
    pub static disable_sitepermission: Lazy<EventMetric<DisableSitepermissionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_sitepermission".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4351.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableThemeExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableThemeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.disable_theme
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.disable#theme.
    pub static disable_theme: Lazy<EventMetric<DisableThemeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_theme".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4352.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableUnknownExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableUnknownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.disable_unknown
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.disable#unknown.
    pub static disable_unknown: Lazy<EventMetric<DisableUnknownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_unknown".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4353.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnableDictionaryExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnableDictionaryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.enable_dictionary
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.enable#dictionary.
    pub static enable_dictionary: Lazy<EventMetric<EnableDictionaryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enable_dictionary".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4354.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnableExtensionExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnableExtensionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.enable_extension
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.enable#extension.
    pub static enable_extension: Lazy<EventMetric<EnableExtensionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enable_extension".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4355.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnableLocaleExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnableLocaleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.enable_locale
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.enable#locale.
    pub static enable_locale: Lazy<EventMetric<EnableLocaleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enable_locale".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4356.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnableOtherExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnableOtherExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.enable_other
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.enable#other.
    pub static enable_other: Lazy<EventMetric<EnableOtherExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enable_other".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4357.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnableSitepermDeprecatedExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnableSitepermDeprecatedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.enable_siteperm_deprecated
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.enable#siteperm_deprecated.
    pub static enable_siteperm_deprecated: Lazy<EventMetric<EnableSitepermDeprecatedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enable_siteperm_deprecated".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4358.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnableSitepermissionExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnableSitepermissionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.enable_sitepermission
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.enable#sitepermission.
    pub static enable_sitepermission: Lazy<EventMetric<EnableSitepermissionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enable_sitepermission".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4359.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnableThemeExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnableThemeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.enable_theme
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.enable#theme.
    pub static enable_theme: Lazy<EventMetric<EnableThemeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enable_theme".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4360.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnableUnknownExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnableUnknownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.enable_unknown
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.enable#unknown.
    pub static enable_unknown: Lazy<EventMetric<EnableUnknownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enable_unknown".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4361.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallDictionaryExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallDictionaryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_dictionary
    ///
    /// These events are recorded during the install and update flow for extensions and
    /// themes, the value of the event is an install_id shared by the events related to
    /// the same install or update flow. This event was generated to correspond to the
    /// Legacy Telemetry event addonsManager.install#dictionary.
    pub static install_dictionary: Lazy<EventMetric<InstallDictionaryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_dictionary".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4362.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallExtensionExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallExtensionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_extension
    ///
    /// These events are recorded during the install and update flow for extensions and
    /// themes, the value of the event is an install_id shared by the events related to
    /// the same install or update flow. This event was generated to correspond to the
    /// Legacy Telemetry event addonsManager.install#extension.
    pub static install_extension: Lazy<EventMetric<InstallExtensionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_extension".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4363.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallLocaleExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallLocaleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_locale
    ///
    /// These events are recorded during the install and update flow for extensions and
    /// themes, the value of the event is an install_id shared by the events related to
    /// the same install or update flow. This event was generated to correspond to the
    /// Legacy Telemetry event addonsManager.install#locale.
    pub static install_locale: Lazy<EventMetric<InstallLocaleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_locale".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4364.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallOtherExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallOtherExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_other
    ///
    /// These events are recorded during the install and update flow for extensions and
    /// themes, the value of the event is an install_id shared by the events related to
    /// the same install or update flow. This event was generated to correspond to the
    /// Legacy Telemetry event addonsManager.install#other.
    pub static install_other: Lazy<EventMetric<InstallOtherExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_other".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4365.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallSitepermDeprecatedExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallSitepermDeprecatedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_siteperm_deprecated
    ///
    /// These events are recorded during the install and update flow for extensions and
    /// themes, the value of the event is an install_id shared by the events related to
    /// the same install or update flow. This event was generated to correspond to the
    /// Legacy Telemetry event addonsManager.install#siteperm_deprecated.
    pub static install_siteperm_deprecated: Lazy<EventMetric<InstallSitepermDeprecatedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_siteperm_deprecated".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4366.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallSitepermissionExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallSitepermissionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_sitepermission
    ///
    /// These events are recorded during the install and update flow for extensions and
    /// themes, the value of the event is an install_id shared by the events related to
    /// the same install or update flow. This event was generated to correspond to the
    /// Legacy Telemetry event addonsManager.install#sitepermission.
    pub static install_sitepermission: Lazy<EventMetric<InstallSitepermissionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_sitepermission".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4367.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallStatsDictionaryExtra {
        pub r#addon_id: Option<String>,
        pub r#taar_based: Option<String>,
        pub r#utm_campaign: Option<String>,
        pub r#utm_content: Option<String>,
        pub r#utm_medium: Option<String>,
        pub r#utm_source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallStatsDictionaryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "taar_based", "utm_campaign", "utm_content", "utm_medium", "utm_source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#taar_based.and_then(|val| map.insert("taar_based".into(), val.to_string()));
          self.r#utm_campaign.and_then(|val| map.insert("utm_campaign".into(), val.to_string()));
          self.r#utm_content.and_then(|val| map.insert("utm_content".into(), val.to_string()));
          self.r#utm_medium.and_then(|val| map.insert("utm_medium".into(), val.to_string()));
          self.r#utm_source.and_then(|val| map.insert("utm_source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_stats_dictionary
    ///
    /// These events are recorded at the end of the install flow, but only when the
    /// source that originally triggered the add-on installation is "amo", "rtamo" or
    /// "disco". The value of an event is the SHA256 hash of the addon_id. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// addonsManager.install_stats#dictionary.
    pub static install_stats_dictionary: Lazy<EventMetric<InstallStatsDictionaryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_stats_dictionary".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4368.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallStatsExtensionExtra {
        pub r#addon_id: Option<String>,
        pub r#taar_based: Option<String>,
        pub r#utm_campaign: Option<String>,
        pub r#utm_content: Option<String>,
        pub r#utm_medium: Option<String>,
        pub r#utm_source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallStatsExtensionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "taar_based", "utm_campaign", "utm_content", "utm_medium", "utm_source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#taar_based.and_then(|val| map.insert("taar_based".into(), val.to_string()));
          self.r#utm_campaign.and_then(|val| map.insert("utm_campaign".into(), val.to_string()));
          self.r#utm_content.and_then(|val| map.insert("utm_content".into(), val.to_string()));
          self.r#utm_medium.and_then(|val| map.insert("utm_medium".into(), val.to_string()));
          self.r#utm_source.and_then(|val| map.insert("utm_source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_stats_extension
    ///
    /// These events are recorded at the end of the install flow, but only when the
    /// source that originally triggered the add-on installation is "amo", "rtamo" or
    /// "disco". The value of an event is the SHA256 hash of the addon_id. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// addonsManager.install_stats#extension.
    pub static install_stats_extension: Lazy<EventMetric<InstallStatsExtensionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_stats_extension".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4369.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallStatsLocaleExtra {
        pub r#addon_id: Option<String>,
        pub r#taar_based: Option<String>,
        pub r#utm_campaign: Option<String>,
        pub r#utm_content: Option<String>,
        pub r#utm_medium: Option<String>,
        pub r#utm_source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallStatsLocaleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "taar_based", "utm_campaign", "utm_content", "utm_medium", "utm_source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#taar_based.and_then(|val| map.insert("taar_based".into(), val.to_string()));
          self.r#utm_campaign.and_then(|val| map.insert("utm_campaign".into(), val.to_string()));
          self.r#utm_content.and_then(|val| map.insert("utm_content".into(), val.to_string()));
          self.r#utm_medium.and_then(|val| map.insert("utm_medium".into(), val.to_string()));
          self.r#utm_source.and_then(|val| map.insert("utm_source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_stats_locale
    ///
    /// These events are recorded at the end of the install flow, but only when the
    /// source that originally triggered the add-on installation is "amo", "rtamo" or
    /// "disco". The value of an event is the SHA256 hash of the addon_id. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// addonsManager.install_stats#locale.
    pub static install_stats_locale: Lazy<EventMetric<InstallStatsLocaleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_stats_locale".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4370.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallStatsOtherExtra {
        pub r#addon_id: Option<String>,
        pub r#taar_based: Option<String>,
        pub r#utm_campaign: Option<String>,
        pub r#utm_content: Option<String>,
        pub r#utm_medium: Option<String>,
        pub r#utm_source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallStatsOtherExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "taar_based", "utm_campaign", "utm_content", "utm_medium", "utm_source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#taar_based.and_then(|val| map.insert("taar_based".into(), val.to_string()));
          self.r#utm_campaign.and_then(|val| map.insert("utm_campaign".into(), val.to_string()));
          self.r#utm_content.and_then(|val| map.insert("utm_content".into(), val.to_string()));
          self.r#utm_medium.and_then(|val| map.insert("utm_medium".into(), val.to_string()));
          self.r#utm_source.and_then(|val| map.insert("utm_source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_stats_other
    ///
    /// These events are recorded at the end of the install flow, but only when the
    /// source that originally triggered the add-on installation is "amo", "rtamo" or
    /// "disco". The value of an event is the SHA256 hash of the addon_id. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// addonsManager.install_stats#other.
    pub static install_stats_other: Lazy<EventMetric<InstallStatsOtherExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_stats_other".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4371.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallStatsSitepermDeprecatedExtra {
        pub r#addon_id: Option<String>,
        pub r#taar_based: Option<String>,
        pub r#utm_campaign: Option<String>,
        pub r#utm_content: Option<String>,
        pub r#utm_medium: Option<String>,
        pub r#utm_source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallStatsSitepermDeprecatedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "taar_based", "utm_campaign", "utm_content", "utm_medium", "utm_source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#taar_based.and_then(|val| map.insert("taar_based".into(), val.to_string()));
          self.r#utm_campaign.and_then(|val| map.insert("utm_campaign".into(), val.to_string()));
          self.r#utm_content.and_then(|val| map.insert("utm_content".into(), val.to_string()));
          self.r#utm_medium.and_then(|val| map.insert("utm_medium".into(), val.to_string()));
          self.r#utm_source.and_then(|val| map.insert("utm_source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_stats_siteperm_deprecated
    ///
    /// These events are recorded at the end of the install flow, but only when the
    /// source that originally triggered the add-on installation is "amo", "rtamo" or
    /// "disco". The value of an event is the SHA256 hash of the addon_id. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// addonsManager.install_stats#siteperm_deprecated.
    pub static install_stats_siteperm_deprecated: Lazy<EventMetric<InstallStatsSitepermDeprecatedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_stats_siteperm_deprecated".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4372.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallStatsSitepermissionExtra {
        pub r#addon_id: Option<String>,
        pub r#taar_based: Option<String>,
        pub r#utm_campaign: Option<String>,
        pub r#utm_content: Option<String>,
        pub r#utm_medium: Option<String>,
        pub r#utm_source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallStatsSitepermissionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "taar_based", "utm_campaign", "utm_content", "utm_medium", "utm_source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#taar_based.and_then(|val| map.insert("taar_based".into(), val.to_string()));
          self.r#utm_campaign.and_then(|val| map.insert("utm_campaign".into(), val.to_string()));
          self.r#utm_content.and_then(|val| map.insert("utm_content".into(), val.to_string()));
          self.r#utm_medium.and_then(|val| map.insert("utm_medium".into(), val.to_string()));
          self.r#utm_source.and_then(|val| map.insert("utm_source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_stats_sitepermission
    ///
    /// These events are recorded at the end of the install flow, but only when the
    /// source that originally triggered the add-on installation is "amo", "rtamo" or
    /// "disco". The value of an event is the SHA256 hash of the addon_id. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// addonsManager.install_stats#sitepermission.
    pub static install_stats_sitepermission: Lazy<EventMetric<InstallStatsSitepermissionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_stats_sitepermission".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4373.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallStatsThemeExtra {
        pub r#addon_id: Option<String>,
        pub r#taar_based: Option<String>,
        pub r#utm_campaign: Option<String>,
        pub r#utm_content: Option<String>,
        pub r#utm_medium: Option<String>,
        pub r#utm_source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallStatsThemeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "taar_based", "utm_campaign", "utm_content", "utm_medium", "utm_source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#taar_based.and_then(|val| map.insert("taar_based".into(), val.to_string()));
          self.r#utm_campaign.and_then(|val| map.insert("utm_campaign".into(), val.to_string()));
          self.r#utm_content.and_then(|val| map.insert("utm_content".into(), val.to_string()));
          self.r#utm_medium.and_then(|val| map.insert("utm_medium".into(), val.to_string()));
          self.r#utm_source.and_then(|val| map.insert("utm_source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_stats_theme
    ///
    /// These events are recorded at the end of the install flow, but only when the
    /// source that originally triggered the add-on installation is "amo", "rtamo" or
    /// "disco". The value of an event is the SHA256 hash of the addon_id. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// addonsManager.install_stats#theme.
    pub static install_stats_theme: Lazy<EventMetric<InstallStatsThemeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_stats_theme".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4374.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallStatsUnknownExtra {
        pub r#addon_id: Option<String>,
        pub r#taar_based: Option<String>,
        pub r#utm_campaign: Option<String>,
        pub r#utm_content: Option<String>,
        pub r#utm_medium: Option<String>,
        pub r#utm_source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallStatsUnknownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "taar_based", "utm_campaign", "utm_content", "utm_medium", "utm_source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#taar_based.and_then(|val| map.insert("taar_based".into(), val.to_string()));
          self.r#utm_campaign.and_then(|val| map.insert("utm_campaign".into(), val.to_string()));
          self.r#utm_content.and_then(|val| map.insert("utm_content".into(), val.to_string()));
          self.r#utm_medium.and_then(|val| map.insert("utm_medium".into(), val.to_string()));
          self.r#utm_source.and_then(|val| map.insert("utm_source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_stats_unknown
    ///
    /// These events are recorded at the end of the install flow, but only when the
    /// source that originally triggered the add-on installation is "amo", "rtamo" or
    /// "disco". The value of an event is the SHA256 hash of the addon_id. This event
    /// was generated to correspond to the Legacy Telemetry event
    /// addonsManager.install_stats#unknown.
    pub static install_stats_unknown: Lazy<EventMetric<InstallStatsUnknownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_stats_unknown".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4375.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallThemeExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallThemeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_theme
    ///
    /// These events are recorded during the install and update flow for extensions and
    /// themes, the value of the event is an install_id shared by the events related to
    /// the same install or update flow. This event was generated to correspond to the
    /// Legacy Telemetry event addonsManager.install#theme.
    pub static install_theme: Lazy<EventMetric<InstallThemeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_theme".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4376.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallUnknownExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallUnknownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_unknown
    ///
    /// These events are recorded during the install and update flow for extensions and
    /// themes, the value of the event is an install_id shared by the events related to
    /// the same install or update flow. This event was generated to correspond to the
    /// Legacy Telemetry event addonsManager.install#unknown.
    pub static install_unknown: Lazy<EventMetric<InstallUnknownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_unknown".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4377.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SideloadPromptDictionaryExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SideloadPromptDictionaryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.sideload_prompt_dictionary
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.sideload_prompt#dictionary.
    pub static sideload_prompt_dictionary: Lazy<EventMetric<SideloadPromptDictionaryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sideload_prompt_dictionary".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4378.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SideloadPromptExtensionExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SideloadPromptExtensionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.sideload_prompt_extension
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.sideload_prompt#extension.
    pub static sideload_prompt_extension: Lazy<EventMetric<SideloadPromptExtensionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sideload_prompt_extension".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4379.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SideloadPromptLocaleExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SideloadPromptLocaleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.sideload_prompt_locale
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.sideload_prompt#locale.
    pub static sideload_prompt_locale: Lazy<EventMetric<SideloadPromptLocaleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sideload_prompt_locale".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4380.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SideloadPromptOtherExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SideloadPromptOtherExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.sideload_prompt_other
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.sideload_prompt#other.
    pub static sideload_prompt_other: Lazy<EventMetric<SideloadPromptOtherExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sideload_prompt_other".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4381.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SideloadPromptSitepermDeprecatedExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SideloadPromptSitepermDeprecatedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.sideload_prompt_siteperm_deprecated
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.sideload_prompt#siteperm_deprecated.
    pub static sideload_prompt_siteperm_deprecated: Lazy<EventMetric<SideloadPromptSitepermDeprecatedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sideload_prompt_siteperm_deprecated".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4382.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SideloadPromptSitepermissionExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SideloadPromptSitepermissionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.sideload_prompt_sitepermission
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.sideload_prompt#sitepermission.
    pub static sideload_prompt_sitepermission: Lazy<EventMetric<SideloadPromptSitepermissionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sideload_prompt_sitepermission".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4383.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SideloadPromptThemeExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SideloadPromptThemeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.sideload_prompt_theme
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.sideload_prompt#theme.
    pub static sideload_prompt_theme: Lazy<EventMetric<SideloadPromptThemeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sideload_prompt_theme".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4384.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SideloadPromptUnknownExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SideloadPromptUnknownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.sideload_prompt_unknown
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.sideload_prompt#unknown.
    pub static sideload_prompt_unknown: Lazy<EventMetric<SideloadPromptUnknownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sideload_prompt_unknown".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4385.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UninstallDictionaryExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UninstallDictionaryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.uninstall_dictionary
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.uninstall#dictionary.
    pub static uninstall_dictionary: Lazy<EventMetric<UninstallDictionaryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uninstall_dictionary".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4386.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UninstallExtensionExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UninstallExtensionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.uninstall_extension
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.uninstall#extension.
    pub static uninstall_extension: Lazy<EventMetric<UninstallExtensionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uninstall_extension".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4387.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UninstallLocaleExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UninstallLocaleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.uninstall_locale
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.uninstall#locale.
    pub static uninstall_locale: Lazy<EventMetric<UninstallLocaleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uninstall_locale".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4388.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UninstallOtherExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UninstallOtherExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.uninstall_other
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.uninstall#other.
    pub static uninstall_other: Lazy<EventMetric<UninstallOtherExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uninstall_other".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4389.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UninstallSitepermDeprecatedExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UninstallSitepermDeprecatedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.uninstall_siteperm_deprecated
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.uninstall#siteperm_deprecated.
    pub static uninstall_siteperm_deprecated: Lazy<EventMetric<UninstallSitepermDeprecatedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uninstall_siteperm_deprecated".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4390.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UninstallSitepermissionExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UninstallSitepermissionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.uninstall_sitepermission
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.uninstall#sitepermission.
    pub static uninstall_sitepermission: Lazy<EventMetric<UninstallSitepermissionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uninstall_sitepermission".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4391.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UninstallThemeExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UninstallThemeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.uninstall_theme
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.uninstall#theme.
    pub static uninstall_theme: Lazy<EventMetric<UninstallThemeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uninstall_theme".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4392.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UninstallUnknownExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UninstallUnknownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.uninstall_unknown
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled, the value of the event is the addon_id (which also
    /// allow to correlate multiple events related to each other). This event was
    /// generated to correspond to the Legacy Telemetry event
    /// addonsManager.uninstall#unknown.
    pub static uninstall_unknown: Lazy<EventMetric<UninstallUnknownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uninstall_unknown".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4393.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateDictionaryExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateDictionaryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.update_dictionary
    ///
    /// These events are recorded during the install and update flow for extensions and
    /// themes, the value of the event is an install_id shared by the events related to
    /// the same install or update flow. This event was generated to correspond to the
    /// Legacy Telemetry event addonsManager.update#dictionary.
    pub static update_dictionary: Lazy<EventMetric<UpdateDictionaryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_dictionary".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4394.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateExtensionExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateExtensionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.update_extension
    ///
    /// These events are recorded during the install and update flow for extensions and
    /// themes, the value of the event is an install_id shared by the events related to
    /// the same install or update flow. This event was generated to correspond to the
    /// Legacy Telemetry event addonsManager.update#extension.
    pub static update_extension: Lazy<EventMetric<UpdateExtensionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_extension".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4395.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateLocaleExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateLocaleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.update_locale
    ///
    /// These events are recorded during the install and update flow for extensions and
    /// themes, the value of the event is an install_id shared by the events related to
    /// the same install or update flow. This event was generated to correspond to the
    /// Legacy Telemetry event addonsManager.update#locale.
    pub static update_locale: Lazy<EventMetric<UpdateLocaleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_locale".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4396.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateOtherExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateOtherExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.update_other
    ///
    /// These events are recorded during the install and update flow for extensions and
    /// themes, the value of the event is an install_id shared by the events related to
    /// the same install or update flow. This event was generated to correspond to the
    /// Legacy Telemetry event addonsManager.update#other.
    pub static update_other: Lazy<EventMetric<UpdateOtherExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_other".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4397.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateSitepermDeprecatedExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateSitepermDeprecatedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.update_siteperm_deprecated
    ///
    /// These events are recorded during the install and update flow for extensions and
    /// themes, the value of the event is an install_id shared by the events related to
    /// the same install or update flow. This event was generated to correspond to the
    /// Legacy Telemetry event addonsManager.update#siteperm_deprecated.
    pub static update_siteperm_deprecated: Lazy<EventMetric<UpdateSitepermDeprecatedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_siteperm_deprecated".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4398.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateSitepermissionExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateSitepermissionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.update_sitepermission
    ///
    /// These events are recorded during the install and update flow for extensions and
    /// themes, the value of the event is an install_id shared by the events related to
    /// the same install or update flow. This event was generated to correspond to the
    /// Legacy Telemetry event addonsManager.update#sitepermission.
    pub static update_sitepermission: Lazy<EventMetric<UpdateSitepermissionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_sitepermission".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4399.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateThemeExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateThemeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.update_theme
    ///
    /// These events are recorded during the install and update flow for extensions and
    /// themes, the value of the event is an install_id shared by the events related to
    /// the same install or update flow. This event was generated to correspond to the
    /// Legacy Telemetry event addonsManager.update#theme.
    pub static update_theme: Lazy<EventMetric<UpdateThemeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_theme".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4400.into(), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateUnknownExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateUnknownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.update_unknown
    ///
    /// These events are recorded during the install and update flow for extensions and
    /// themes, the value of the event is an install_id shared by the events related to
    /// the same install or update flow. This event was generated to correspond to the
    /// Legacy Telemetry event addonsManager.update#unknown.
    pub static update_unknown: Lazy<EventMetric<UpdateUnknownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_unknown".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4401.into(), meta)
    });

}
pub mod blocklist {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AddonBlockChangeExtra {
        pub r#addon_version: Option<String>,
        pub r#blocklist_state: Option<String>,
        pub r#hours_since: Option<String>,
        pub r#mlbf_generation: Option<String>,
        pub r#mlbf_last_time: Option<String>,
        pub r#mlbf_softblocks_generation: Option<String>,
        pub r#mlbf_softblocks_source: Option<String>,
        pub r#mlbf_source: Option<String>,
        pub r#object: Option<String>,
        pub r#signed_date: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AddonBlockChangeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_version", "blocklist_state", "hours_since", "mlbf_generation", "mlbf_last_time", "mlbf_softblocks_generation", "mlbf_softblocks_source", "mlbf_source", "object", "signed_date", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#hours_since.and_then(|val| map.insert("hours_since".into(), val.to_string()));
          self.r#mlbf_generation.and_then(|val| map.insert("mlbf_generation".into(), val.to_string()));
          self.r#mlbf_last_time.and_then(|val| map.insert("mlbf_last_time".into(), val.to_string()));
          self.r#mlbf_softblocks_generation.and_then(|val| map.insert("mlbf_softblocks_generation".into(), val.to_string()));
          self.r#mlbf_softblocks_source.and_then(|val| map.insert("mlbf_softblocks_source".into(), val.to_string()));
          self.r#mlbf_source.and_then(|val| map.insert("mlbf_source".into(), val.to_string()));
          self.r#object.and_then(|val| map.insert("object".into(), val.to_string()));
          self.r#signed_date.and_then(|val| map.insert("signed_date".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from blocklist.addon_block_change
    ///
    /// An add-on is blocked, or an installed add-on is unblocked. When an add-on
    /// install/update is blocked, its installation is aborted and the add-on is no
    /// longer listed in the activeAddons field of TelemetryEnvironment.
    pub static addon_block_change: Lazy<EventMetric<AddonBlockChangeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "addon_block_change".into(),
                category: "blocklist".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4402.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.last_modified_rs_addons_mblf
    ///
    /// Keep track of the last time the "addons-bloomfilters" remotesetting blocklist
    /// has been successfully updated.
    pub static last_modified_rs_addons_mblf: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "last_modified_rs_addons_mblf".into(),
                category: "blocklist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(4403.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.mlbf_generation_time
    ///
    /// Keep track of the generation time of the addon blocklist's bloom filter. This
    /// marks the point in time until which signed add-ons are recognized by the
    /// selected bloom filter from the addons-bloomfilters collection.
    pub static mlbf_generation_time: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mlbf_generation_time".into(),
                category: "blocklist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(4404.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.mlbf_softblocks_generation_time
    ///
    /// Keep track of the generation time of the addon blocklist's bloom filter. This
    /// marks the point in time until which signed add-ons are recognized by the
    /// selected bloom filter from the addons-bloomfilters collection.
    pub static mlbf_softblocks_generation_time: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mlbf_softblocks_generation_time".into(),
                category: "blocklist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(4405.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.mlbf_softblocks_source
    ///
    /// The source of the RemoteSettings attachment that holds the bloom filter.
    /// Possible values are "dump_match", "cache_match",
    /// "remote_match","dump_fallback", "cache_fallback", "unknown". "dump_match",
    /// "cache_match" and "remote_match" are expected known-good values, and means that
    /// the loaded bloomfilter matches the blocklist record in the RemoteSettings
    /// collection. The prefix denotes the immediate source of the loaded data: "dump"
    /// means packaged with the application, "remote" means a freshly downloaded
    /// bloomfilter, "cache" means a previously downloaded bloomfilter. "dump_fallback"
    /// and "cache_fallback" means that the last known bloomfilter was used, despite it
    /// not matching the latest record in the RemoteSettings collection. In this case
    /// the outdated bloomfilter is used as a fallback (e.g. because the latest version
    /// cannot be downloaded). "unknown"  means that the bloomfilter cannot be loaded
    /// at all. This can happen if the blocklist is disabled via preferences or
    /// enterprise policies.
    pub static mlbf_softblocks_source: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mlbf_softblocks_source".into(),
                category: "blocklist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4406.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.mlbf_source
    ///
    /// The source of the RemoteSettings attachment that holds the bloom filter.
    /// Possible values are "dump_match", "cache_match",
    /// "remote_match","dump_fallback", "cache_fallback", "unknown". "dump_match",
    /// "cache_match" and "remote_match" are expected known-good values, and means that
    /// the loaded bloomfilter matches the blocklist record in the RemoteSettings
    /// collection. The prefix denotes the immediate source of the loaded data: "dump"
    /// means packaged with the application, "remote" means a freshly downloaded
    /// bloomfilter, "cache" means a previously downloaded bloomfilter. "dump_fallback"
    /// and "cache_fallback" means that the last known bloomfilter was used, despite it
    /// not matching the latest record in the RemoteSettings collection. In this case
    /// the outdated bloomfilter is used as a fallback (e.g. because the latest version
    /// cannot be downloaded). "unknown"  means that the bloomfilter cannot be loaded
    /// at all. This can happen if the blocklist is disabled via preferences or
    /// enterprise policies.
    pub static mlbf_source: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mlbf_source".into(),
                category: "blocklist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4407.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.mlbf_stash_time_newest
    ///
    /// Keep track of the timestamp of the most recent stash of the addons blocklist.
    pub static mlbf_stash_time_newest: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mlbf_stash_time_newest".into(),
                category: "blocklist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(4408.into(), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.mlbf_stash_time_oldest
    ///
    /// Keep track of the timestamp of the oldest stash of the addons blocklist.
    pub static mlbf_stash_time_oldest: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mlbf_stash_time_oldest".into(),
                category: "blocklist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(4409.into(), meta, TimeUnit::Millisecond)
    });

}
pub mod update {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from update.auto_download
    ///
    /// Per-installation preference "app.update.auto": whether to fetch and install
    /// updates without user intervention.
    pub static auto_download: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "auto_download".into(),
                category: "update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4410.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.background_update
    ///
    /// Per-installation preference "app.update.background.enabled": whether to fetch
    /// and install updates in the background when Firefox is not running.
    pub static background_update: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "background_update".into(),
                category: "update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4411.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.bitshresult
    ///
    /// If a BITS download fails on the Windows side (that is to say, BITS ecounters an
    /// error rather than Firefox failing to interact with BITS), it will likely give
    /// an hresult error indicating what happened. This probe reports those error codes
    /// to allow us to see if BITS is commonly failing on some systems. This probe is
    /// keyed on the type of update download, either "PARTIAL" or "COMPLETE". This
    /// metric was generated to correspond to the Legacy Telemetry scalar
    /// update.bitshresult.
    pub static bitshresult: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "bitshresult".into(),
                    category: "update".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(4412.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.can_usually_apply_updates
    ///
    /// Whether or not the Update Service can usually download and install updates. See
    /// `canUsuallyApplyUpdates` in https://searchfox.org/mozilla-
    /// central/source/toolkit/mozapps/update/nsIUpdateService.idl.
    pub static can_usually_apply_updates: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "can_usually_apply_updates".into(),
                category: "update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4413.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.can_usually_check_for_updates
    ///
    /// Whether or not the Update Service can usually check for updates. See
    /// `canUsuallyCheckForUpdates` in https://searchfox.org/mozilla-
    /// central/source/toolkit/mozapps/update/nsIUpdateService.idl.
    pub static can_usually_check_for_updates: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "can_usually_check_for_updates".into(),
                category: "update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4414.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.can_usually_stage_updates
    ///
    /// Whether the Update Service is usually able to stage updates. See
    /// `canUsuallyStageUpdates` in https://searchfox.org/mozilla-
    /// central/source/toolkit/mozapps/update/nsIUpdateService.idl.
    pub static can_usually_stage_updates: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "can_usually_stage_updates".into(),
                category: "update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4415.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.can_usually_use_bits
    ///
    /// On Windows, whether the Update Service can usually use BITS. See
    /// `canUsuallyUseBits` in https://searchfox.org/mozilla-
    /// central/source/toolkit/mozapps/update/nsIUpdateService.idl.
    pub static can_usually_use_bits: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "can_usually_use_bits".into(),
                category: "update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4416.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.channel
    ///
    /// The update channel.
    pub static channel: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "channel".into(),
                category: "update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4417.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.enabled
    ///
    /// True when policies are disabled or when the "DisableAppUpdate" is not in
    /// effect.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled".into(),
                category: "update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4418.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.move_result
    ///
    /// Firefox keeps downloading updates in a different place from updates that are
    /// ready to install. Once the download completes, the resulting file has to be
    /// moved from the downloading update directory to the ready update directory. This
    /// probe counts the results that we get when attempting to perform this file move.
    /// Valid values for the keys for this probe are stored in the MOVE_RESULT_* values
    /// in UpdateTelemetry.sys.mjs. This metric was generated to correspond to the
    /// Legacy Telemetry scalar update.move_result.
    pub static move_result: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "move_result".into(),
                    category: "update".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(4419.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.no_window_auto_restarts
    ///
    /// On macOS, all browser windows can be closed without exiting Firefox. If there
    /// is an update pending in that case, and we can install it silently, we restart
    /// automatically in order to do so. This probe counts the number of times the
    /// browser restarts to silently install a pending update. This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// update.no_window_auto_restarts.
    pub static no_window_auto_restarts: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4420,
            "update",
            "no_window_auto_restarts",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.service_enabled
    ///
    /// Preference "app.update.service.enabled": whether the Mozilla Maintenance
    /// Service is enabled.
    pub static service_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "service_enabled".into(),
                category: "update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4421.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.suppress_prompts
    ///
    /// When an update is available and app.update.auto is disabled, a popup is opened
    /// prompting the user to download and install the update. The pref
    /// app.update.suppressPrompts causes Firefox Nightly to wait up to 7 days before
    /// showing the prompt, instead showing a badge and banner in the meantime. It also
    /// prevents Nightly from showing update restart prompts, instead showing a badge
    /// and banner immediately. This value is set for the users who set this pref to
    /// true. This metric was generated to correspond to the Legacy Telemetry scalar
    /// update.suppress_prompts.
    pub static suppress_prompts: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "suppress_prompts".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4422.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.version_pin
    ///
    /// The AppUpdatePin Enterprise Policy controls the maximum version that the
    /// browser can update to. If the policy is set, this probe will report the
    /// policy's value. The possible policy values are "X." and "X.Y.", where X is the
    /// pinned major version and Y is the pinned minor version. This metric was
    /// generated to correspond to the Legacy Telemetry scalar update.version_pin.
    pub static version_pin: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "version_pin".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4423.into(), meta)
    });

}
pub mod gecko {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gecko.build_id
    ///
    /// The Buildid of the Gecko engine, example: 20200205124310 (Migrated from the
    /// geckoview metric of the same name).
    pub static build_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "build_id".into(),
                category: "gecko".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4424.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gecko.version
    ///
    /// The version of the Gecko engine, example: 74.0a1 (Migrated from the geckoview
    /// metric of the same name).
    pub static version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "version".into(),
                category: "gecko".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4425.into(), meta)
    });

}
pub mod widget {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from widget.ime_name_on_mac
    ///
    /// Name of IME which was selected by users on macOS.  The value is Input Source ID
    /// if non-Japanese IME was open.  Otherwise, if Japanese IME was open, the value
    /// is Bundle ID.  Input Source ID includes input mode, but Bundle ID does not
    /// include input mode. This metric was generated to correspond to the Legacy
    /// Telemetry scalar widget.ime_name_on_mac.
    pub static ime_name_on_mac: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "ime_name_on_mac".into(),
                    category: "widget".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(4426.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from widget.gtk_version
    ///
    /// The version of Gtk 3 in use. This metric was generated to correspond to the
    /// Legacy Telemetry scalar widget.gtk_version.
    pub static gtk_version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gtk_version".into(),
                category: "widget".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(4427.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from widget.ime_name_on_linux
    ///
    /// Name of active IM (e.g., xim, fcitx, ibus, etc) which was actually set by env
    /// on Linux.  Different from Windows and macOS, this value includes non-IME users
    /// even though this is recoded when first compositionstart event because dead key
    /// is also implemented by IME on Linux. This metric was generated to correspond to
    /// the Legacy Telemetry scalar widget.ime_name_on_linux.
    pub static ime_name_on_linux: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "ime_name_on_linux".into(),
                    category: "widget".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(4428.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from widget.dark_mode
    ///
    /// Whether the OS theme is dark. This metric was generated to correspond to the
    /// Legacy Telemetry scalar widget.dark_mode.
    pub static dark_mode: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dark_mode".into(),
                category: "widget".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(4429.into(), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from widget.ime_name_on_windows
    ///
    /// Locale ID and name of IME which was selected by users on Windows. This does NOT
    /// collect legacy IMM-IME names since we cannot get readable names and we do not
    /// support IMM-IME so aggressively because IME vendors should've already released
    /// TIP for TSF for supporting Windows 8 or later completely. This metric was
    /// generated to correspond to the Legacy Telemetry scalar
    /// widget.ime_name_on_windows.
    pub static ime_name_on_windows: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "ime_name_on_windows".into(),
                    category: "widget".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(4430.into(), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from widget.ime_name_on_windows_inserted_crlf
    ///
    /// Same data as ime_name_on_windows, but only collecting IME names which inserted
    /// CRLF to check whether the feature works. This metric was generated to
    /// correspond to the Legacy Telemetry scalar
    /// widget.ime_name_on_windows_inserted_crlf.
    pub static ime_name_on_windows_inserted_crlf: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "ime_name_on_windows_inserted_crlf".into(),
                    category: "widget".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(4431.into(), meta, None)
    });

}
pub mod file_dialog {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FallbackV21Extra {
        pub r#in_shutdown: Option<bool>,
        pub r#succeeded: Option<bool>,
        pub r#time_local: Option<u32>,
        pub r#time_remote: Option<u32>,
        pub r#where_local: Option<String>,
        pub r#where_remote: Option<String>,
        pub r#why_local: Option<String>,
        pub r#why_remote: Option<String>,
    }

    impl ExtraKeys for FallbackV21Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["in_shutdown", "succeeded", "time_local", "time_remote", "where_local", "where_remote", "why_local", "why_remote"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#in_shutdown.and_then(|val| map.insert("in_shutdown".into(), val.to_string()));
          self.r#succeeded.and_then(|val| map.insert("succeeded".into(), val.to_string()));
          self.r#time_local.and_then(|val| map.insert("time_local".into(), val.to_string()));
          self.r#time_remote.and_then(|val| map.insert("time_remote".into(), val.to_string()));
          self.r#where_local.and_then(|val| map.insert("where_local".into(), val.to_string()));
          self.r#where_remote.and_then(|val| map.insert("where_remote".into(), val.to_string()));
          self.r#why_local.and_then(|val| map.insert("why_local".into(), val.to_string()));
          self.r#why_remote.and_then(|val| map.insert("why_remote".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from file_dialog.fallback_v2_1
    ///
    /// Records the result of an attempt to open and use the out-of-process file dialog
    /// when the in-process file-dialog is available as a fallback.
    pub static fallback_v2_1: Lazy<EventMetric<FallbackV21Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fallback_v2_1".into(),
                category: "file_dialog".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4432.into(), meta)
    });

}
pub mod memory_watcher {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OnHighMemoryStatsExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for OnHighMemoryStatsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from memory_watcher.on_high_memory_stats
    ///
    /// This event is recorded when the memory situation is no longer low. The "stats"
    /// object consists of three numbers comma-delimited: 1) how many times a tab was
    /// unloaded 2) how many memory-pressure events were dispatched 3) how long we were
    /// in the low-memory situation in seconds This event was generated to correspond
    /// to the Legacy Telemetry event memory_watcher.on_high_memory#stats.
    pub static on_high_memory_stats: Lazy<EventMetric<OnHighMemoryStatsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "on_high_memory_stats".into(),
                category: "memory_watcher".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(4433.into(), meta)
    });

}
pub mod timer_thread {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from timer_thread.timers_fired_per_wakeup
    ///
    /// How many timers were processed in a single wake-up of the Timer Thread.
    pub static timers_fired_per_wakeup: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "timers_fired_per_wakeup".into(),
                category: "timer_thread".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(4434.into(), meta, 0, 80, 20, HistogramType::Exponential)
    });

}

#[allow(dead_code)]
pub(crate) mod __glean_metric_maps {
    use std::collections::HashMap;

    use crate::metrics::extra_keys_len;
    use crate::private::*;
    use once_cell::sync::Lazy;

    pub static BOOLEAN_MAP: Lazy<HashMap<MetricId, &Lazy<BooleanMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(143);
        map.insert(1.into(), &super::a11y::always_underline_links);
        map.insert(2.into(), &super::a11y::backplate);
        map.insert(6.into(), &super::a11y::invert_colors);
        map.insert(8.into(), &super::a11y::use_system_colors);
        map.insert(159.into(), &super::networking::http3_enabled);
        map.insert(189.into(), &super::genai_chatbot::enabled);
        map.insert(202.into(), &super::genai_chatbot::shortcuts);
        map.insert(204.into(), &super::genai_chatbot::shortcuts_custom);
        map.insert(209.into(), &super::genai_chatbot::sidebar);
        map.insert(217.into(), &super::background_update::automatic_restart_attempted);
        map.insert(218.into(), &super::background_update::automatic_restart_success);
        map.insert(220.into(), &super::background_update::exit_code_exception);
        map.insert(221.into(), &super::background_update::exit_code_success);
        map.insert(228.into(), &super::background_update::targeting_exception);
        map.insert(229.into(), &super::background_update::targeting_exists);
        map.insert(233.into(), &super::browser_startup::abouthome_cache_shutdownwrite);
        map.insert(234.into(), &super::datasanitization::privacy_clear_on_shutdown_cache);
        map.insert(235.into(), &super::datasanitization::privacy_clear_on_shutdown_cookies);
        map.insert(236.into(), &super::datasanitization::privacy_clear_on_shutdown_downloads);
        map.insert(237.into(), &super::datasanitization::privacy_clear_on_shutdown_formdata);
        map.insert(238.into(), &super::datasanitization::privacy_clear_on_shutdown_history);
        map.insert(239.into(), &super::datasanitization::privacy_clear_on_shutdown_offline_apps);
        map.insert(240.into(), &super::datasanitization::privacy_clear_on_shutdown_open_windows);
        map.insert(241.into(), &super::datasanitization::privacy_clear_on_shutdown_sessions);
        map.insert(242.into(), &super::datasanitization::privacy_clear_on_shutdown_site_settings);
        map.insert(243.into(), &super::datasanitization::privacy_sanitize_sanitize_on_shutdown);
        map.insert(248.into(), &super::os_environment::is_kept_in_dock);
        map.insert(249.into(), &super::os_environment::is_taskbar_pinned);
        map.insert(250.into(), &super::os_environment::is_taskbar_pinned_private);
        map.insert(254.into(), &super::os_environment::is_admin_without_uac);
        map.insert(265.into(), &super::sslkeylogging::enabled);
        map.insert(267.into(), &super::startup::is_cold);
        map.insert(287.into(), &super::migration::uninstaller_profile_refresh);
        map.insert(398.into(), &super::newtab::weather_enabled);
        map.insert(403.into(), &super::newtab_handoff_preference::enabled);
        map.insert(404.into(), &super::newtab_search::enabled);
        map.insert(408.into(), &super::pocket::enabled);
        map.insert(411.into(), &super::pocket::is_signed_in);
        map.insert(415.into(), &super::pocket::sponsored_stories_enabled);
        map.insert(427.into(), &super::topsites::enabled);
        map.insert(432.into(), &super::topsites::sponsored_enabled);
        map.insert(443.into(), &super::pocket_button::pocket_logged_in_status);
        map.insert(622.into(), &super::shopping_settings::auto_open_user_disabled);
        map.insert(623.into(), &super::shopping_settings::component_opted_out);
        map.insert(624.into(), &super::shopping_settings::disabled_ads);
        map.insert(625.into(), &super::shopping_settings::has_onboarded);
        map.insert(626.into(), &super::shopping_settings::nimbus_disabled_shopping);
        map.insert(691.into(), &super::quick_suggest::improve_suggest_experience);
        map.insert(692.into(), &super::quick_suggest::is_clicked);
        map.insert(700.into(), &super::quick_suggest::suggested_index_relative_to_group);
        map.insert(712.into(), &super::urlbar::pref_suggest_data_collection);
        map.insert(713.into(), &super::urlbar::pref_suggest_nonsponsored);
        map.insert(714.into(), &super::urlbar::pref_suggest_sponsored);
        map.insert(715.into(), &super::urlbar::pref_suggest_topsites);
        map.insert(732.into(), &super::installation_first_seen::admin_user);
        map.insert(733.into(), &super::installation_first_seen::default_path);
        map.insert(735.into(), &super::installation_first_seen::from_msi);
        map.insert(736.into(), &super::installation_first_seen::install_existed);
        map.insert(738.into(), &super::installation_first_seen::other_inst);
        map.insert(739.into(), &super::installation_first_seen::other_msix_inst);
        map.insert(740.into(), &super::installation_first_seen::profdir_existed);
        map.insert(741.into(), &super::installation_first_seen::silent);
        map.insert(3232.into(), &super::dom_parentprocess::private_window_used);
        map.insert(3285.into(), &super::gfx::os_compositor);
        map.insert(3288.into(), &super::gfx::supports_hdr);
        map.insert(3289.into(), &super::gfx::tmp_writable);
        map.insert(3317.into(), &super::gfx_status::headless);
        map.insert(3387.into(), &super::preferences::prefs_file_was_invalid);
        map.insert(3519.into(), &super::contentblocking::cryptomining_blocking_enabled);
        map.insert(3520.into(), &super::contentblocking::fingerprinting_blocking_enabled);
        map.insert(3526.into(), &super::background_tasks_rmdir_base::succeeded);
        map.insert(3527.into(), &super::background_tasks_rmdir_base::suffix_ever_failed);
        map.insert(3529.into(), &super::background_tasks_rmdir_base::was_first);
        map.insert(3534.into(), &super::background_tasks_rmdir_http_cache::succeeded);
        map.insert(3535.into(), &super::background_tasks_rmdir_http_cache::suffix_ever_failed);
        map.insert(3537.into(), &super::background_tasks_rmdir_http_cache::was_first);
        map.insert(3542.into(), &super::background_tasks_rmdir_quota::succeeded);
        map.insert(3543.into(), &super::background_tasks_rmdir_quota::suffix_ever_failed);
        map.insert(3545.into(), &super::background_tasks_rmdir_quota::was_first);
        map.insert(3558.into(), &super::cookie_banners::service_detect_only);
        map.insert(3576.into(), &super::crash::is_garbage_collecting);
        map.insert(3586.into(), &super::crash::startup);
        map.insert(3589.into(), &super::crash_windows::error_reporting);
        map.insert(3596.into(), &super::dll_blocklist::init_failed);
        map.insert(3598.into(), &super::dll_blocklist::user32_loaded_before);
        map.insert(3600.into(), &super::environment::headless_mode);
        map.insert(3616.into(), &super::policies::is_enterprise);
        map.insert(3621.into(), &super::extensions::use_remote_policy);
        map.insert(3622.into(), &super::extensions::use_remote_pref);
        map.insert(3709.into(), &super::fog::failed_idle_registration);
        map.insert(3720.into(), &super::test_only::can_we_flag_it);
        map.insert(3739.into(), &super::test_only::one_ping_one_bool);
        map.insert(3745.into(), &super::test_only_ipc::a_bool);
        map.insert(3760.into(), &super::test_only_ipc::an_unordered_bool);
        map.insert(3949.into(), &super::pictureinpicture::toggle_enabled);
        map.insert(3997.into(), &super::broken_site_report_browser_info_app::fission_enabled);
        map.insert(4002.into(), &super::broken_site_report_browser_info_graphics::has_touch_screen);
        map.insert(4005.into(), &super::broken_site_report_browser_info_prefs::forced_accelerated_layers);
        map.insert(4006.into(), &super::broken_site_report_browser_info_prefs::global_privacy_control_enabled);
        map.insert(4007.into(), &super::broken_site_report_browser_info_prefs::installtrigger_enabled);
        map.insert(4008.into(), &super::broken_site_report_browser_info_prefs::opaque_response_blocking);
        map.insert(4009.into(), &super::broken_site_report_browser_info_prefs::resist_fingerprinting_enabled);
        map.insert(4010.into(), &super::broken_site_report_browser_info_prefs::software_webrender);
        map.insert(4011.into(), &super::broken_site_report_browser_info_prefs::third_party_cookie_blocking_enabled);
        map.insert(4012.into(), &super::broken_site_report_browser_info_prefs::third_party_cookie_blocking_enabled_in_pbm);
        map.insert(4016.into(), &super::broken_site_report_browser_info_system::is_tablet);
        map.insert(4021.into(), &super::broken_site_report_tab_info_antitracking::has_mixed_active_content_blocked);
        map.insert(4022.into(), &super::broken_site_report_tab_info_antitracking::has_mixed_display_content_blocked);
        map.insert(4023.into(), &super::broken_site_report_tab_info_antitracking::has_tracking_content_blocked);
        map.insert(4024.into(), &super::broken_site_report_tab_info_antitracking::is_private_browsing);
        map.insert(4025.into(), &super::broken_site_report_tab_info_frameworks::fastclick);
        map.insert(4026.into(), &super::broken_site_report_tab_info_frameworks::marfeel);
        map.insert(4027.into(), &super::broken_site_report_tab_info_frameworks::mobify);
        map.insert(4090.into(), &super::characteristics::font_name_list_emoji_modified);
        map.insert(4134.into(), &super::characteristics::inverted_colors);
        map.insert(4158.into(), &super::characteristics::monochrome);
        map.insert(4171.into(), &super::characteristics::pdf_viewer);
        map.insert(4186.into(), &super::characteristics::prefers_reduced_motion);
        map.insert(4187.into(), &super::characteristics::prefers_reduced_transparency);
        map.insert(4188.into(), &super::characteristics::prefs_block_popups);
        map.insert(4189.into(), &super::characteristics::prefs_browser_display_use_document_fonts);
        map.insert(4190.into(), &super::characteristics::prefs_general_autoscroll);
        map.insert(4191.into(), &super::characteristics::prefs_general_smoothscroll);
        map.insert(4193.into(), &super::characteristics::prefs_media_eme_enabled);
        map.insert(4195.into(), &super::characteristics::prefs_overlay_scrollbars);
        map.insert(4196.into(), &super::characteristics::prefs_privacy_donottrackheader_enabled);
        map.insert(4197.into(), &super::characteristics::prefs_privacy_globalprivacycontrol_enabled);
        map.insert(4198.into(), &super::characteristics::prefs_zoom_text_only);
        map.insert(4212.into(), &super::characteristics::use_document_colors);
        map.insert(4214.into(), &super::characteristics::video_dynamic_range);
        map.insert(4252.into(), &super::telemetry::data_upload_optin);
        map.insert(4327.into(), &super::first_startup::new_profile);
        map.insert(4335.into(), &super::notification::show_success);
        map.insert(4410.into(), &super::update::auto_download);
        map.insert(4411.into(), &super::update::background_update);
        map.insert(4413.into(), &super::update::can_usually_apply_updates);
        map.insert(4414.into(), &super::update::can_usually_check_for_updates);
        map.insert(4415.into(), &super::update::can_usually_stage_updates);
        map.insert(4416.into(), &super::update::can_usually_use_bits);
        map.insert(4418.into(), &super::update::enabled);
        map.insert(4421.into(), &super::update::service_enabled);
        map.insert(4422.into(), &super::update::suppress_prompts);
        map.insert(4429.into(), &super::widget::dark_mode);
        map
    });

    pub static QUANTITY_MAP: Lazy<HashMap<MetricId, &Lazy<QuantityMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(182);
        map.insert(3.into(), &super::a11y::hcm_background);
        map.insert(4.into(), &super::a11y::hcm_foreground);
        map.insert(29.into(), &super::browser_backup::browser_extension_data_size);
        map.insert(31.into(), &super::browser_backup::cookies_size);
        map.insert(32.into(), &super::browser_backup::credentials_data_size);
        map.insert(33.into(), &super::browser_backup::extension_store_permissions_data_size);
        map.insert(34.into(), &super::browser_backup::extensions_json_size);
        map.insert(35.into(), &super::browser_backup::extensions_storage_size);
        map.insert(36.into(), &super::browser_backup::extensions_xpi_directory_size);
        map.insert(37.into(), &super::browser_backup::favicons_size);
        map.insert(39.into(), &super::browser_backup::form_history_size);
        map.insert(40.into(), &super::browser_backup::misc_data_size);
        map.insert(41.into(), &super::browser_backup::places_size);
        map.insert(43.into(), &super::browser_backup::preferences_size);
        map.insert(44.into(), &super::browser_backup::prof_d_disk_space);
        map.insert(45.into(), &super::browser_backup::security_data_size);
        map.insert(46.into(), &super::browser_backup::session_store_backups_directory_size);
        map.insert(47.into(), &super::browser_backup::session_store_size);
        map.insert(48.into(), &super::browser_backup::storage_sync_size);
        map.insert(64.into(), &super::networking::doh_heuristics_result);
        map.insert(160.into(), &super::networking::https_rr_prefs_usage);
        map.insert(162.into(), &super::networking::loading_certs_task);
        map.insert(163.into(), &super::networking::nss_initialization);
        map.insert(226.into(), &super::background_update::targeting_env_firefox_version);
        map.insert(230.into(), &super::background_update::targeting_version);
        map.insert(232.into(), &super::browser_startup::abouthome_cache_result);
        map.insert(244.into(), &super::datasanitization::session_permission_exceptions);
        map.insert(255.into(), &super::security::global_privacy_control_enabled);
        map.insert(256.into(), &super::security::https_only_mode_enabled);
        map.insert(257.into(), &super::security::https_only_mode_enabled_pbm);
        map.insert(268.into(), &super::startup::seconds_since_last_os_restart);
        map.insert(269.into(), &super::startup::profile_count);
        map.insert(352.into(), &super::messaging_system::event_screen_index);
        map.insert(421.into(), &super::top_sites::position);
        map.insert(430.into(), &super::topsites::rows);
        map.insert(433.into(), &super::topsites::sponsored_tiles_configured);
        map.insert(439.into(), &super::pocket_button::event_position);
        map.insert(444.into(), &super::pocket_button::profile_creation_date);
        map.insert(642.into(), &super::sidebar::width);
        map.insert(695.into(), &super::quick_suggest::position);
        map.insert(711.into(), &super::urlbar::pref_max_results);
        map.insert(721.into(), &super::browser_engagement::profile_count);
        map.insert(3296.into(), &super::gfx_adapter_primary::ram);
        map.insert(3311.into(), &super::gfx_display::count);
        map.insert(3312.into(), &super::gfx_display::primary_height);
        map.insert(3313.into(), &super::gfx_display::primary_width);
        map.insert(3315.into(), &super::gfx_hdr::windows_display_colorspace_bitfield);
        map.insert(3321.into(), &super::gpu_process::total_launch_attempts);
        map.insert(3322.into(), &super::gpu_process::unstable_launch_attempts);
        map.insert(3449.into(), &super::cert_verifier::trust_obj_count);
        map.insert(3460.into(), &super::data_storage::alternate_services);
        map.insert(3461.into(), &super::data_storage::client_auth_remember_list);
        map.insert(3462.into(), &super::data_storage::site_security_service_state);
        map.insert(3466.into(), &super::pkcs11::third_party_modules_loaded);
        map.insert(3512.into(), &super::bounce_tracking_protection::mode);
        map.insert(3518.into(), &super::contentblocking::category);
        map.insert(3522.into(), &super::background_tasks_rmdir_base::elapsed_ms);
        map.insert(3524.into(), &super::background_tasks_rmdir_base::removal_count);
        map.insert(3525.into(), &super::background_tasks_rmdir_base::retry_count);
        map.insert(3528.into(), &super::background_tasks_rmdir_base::suffix_removal_count);
        map.insert(3530.into(), &super::background_tasks_rmdir_http_cache::elapsed_ms);
        map.insert(3532.into(), &super::background_tasks_rmdir_http_cache::removal_count);
        map.insert(3533.into(), &super::background_tasks_rmdir_http_cache::retry_count);
        map.insert(3536.into(), &super::background_tasks_rmdir_http_cache::suffix_removal_count);
        map.insert(3538.into(), &super::background_tasks_rmdir_quota::elapsed_ms);
        map.insert(3540.into(), &super::background_tasks_rmdir_quota::removal_count);
        map.insert(3541.into(), &super::background_tasks_rmdir_quota::retry_count);
        map.insert(3544.into(), &super::background_tasks_rmdir_quota::suffix_removal_count);
        map.insert(3572.into(), &super::crash::event_loop_nesting_level);
        map.insert(3574.into(), &super::crash::gpu_process_launch);
        map.insert(3602.into(), &super::memory::available_commit);
        map.insert(3603.into(), &super::memory::available_physical);
        map.insert(3604.into(), &super::memory::available_swap);
        map.insert(3605.into(), &super::memory::available_virtual);
        map.insert(3606.into(), &super::memory::low_physical);
        map.insert(3607.into(), &super::memory::oom_allocation_size);
        map.insert(3608.into(), &super::memory::purgeable_physical);
        map.insert(3609.into(), &super::memory::system_use_percentage);
        map.insert(3610.into(), &super::memory::texture);
        map.insert(3611.into(), &super::memory::total_page_file);
        map.insert(3612.into(), &super::memory::total_physical);
        map.insert(3613.into(), &super::memory::total_virtual);
        map.insert(3615.into(), &super::policies::count);
        map.insert(3620.into(), &super::extensions::startup_cache_write_bytelength);
        map.insert(3623.into(), &super::extensions_apis_dnr::evaluate_rules_count_max);
        map.insert(3702.into(), &super::formautofill_creditcards::autofill_profiles_count);
        map.insert(3712.into(), &super::fog::max_pings_per_minute);
        map.insert(3735.into(), &super::test_only::meaning_of_life);
        map.insert(3751.into(), &super::test_only_ipc::a_quantity);
        map.insert(3858.into(), &super::pwmgr::potentially_breached_passwords);
        map.insert(3940.into(), &super::pictureinpicture::most_concurrent_players);
        map.insert(3956.into(), &super::places::pages_need_frecency_recalculation);
        map.insert(3958.into(), &super::places::previousday_visits);
        map.insert(4004.into(), &super::broken_site_report_browser_info_prefs::cookie_behavior);
        map.insert(4017.into(), &super::broken_site_report_browser_info_system::memory);
        map.insert(4032.into(), &super::characteristics::any_pointer_type);
        map.insert(4033.into(), &super::characteristics::audio_channels);
        map.insert(4034.into(), &super::characteristics::audio_fingerprint);
        map.insert(4035.into(), &super::characteristics::audio_frames);
        map.insert(4036.into(), &super::characteristics::audio_rate);
        map.insert(4037.into(), &super::characteristics::avail_height);
        map.insert(4038.into(), &super::characteristics::avail_width);
        map.insert(4039.into(), &super::characteristics::build_date);
        map.insert(4040.into(), &super::characteristics::camera_count);
        map.insert(4070.into(), &super::characteristics::color_accentcolor);
        map.insert(4071.into(), &super::characteristics::color_accentcolortext);
        map.insert(4072.into(), &super::characteristics::color_canvas);
        map.insert(4073.into(), &super::characteristics::color_canvastext);
        map.insert(4074.into(), &super::characteristics::color_depth);
        map.insert(4075.into(), &super::characteristics::color_gamut);
        map.insert(4076.into(), &super::characteristics::color_highlight);
        map.insert(4077.into(), &super::characteristics::color_highlighttext);
        map.insert(4078.into(), &super::characteristics::color_scheme);
        map.insert(4079.into(), &super::characteristics::color_selecteditem);
        map.insert(4080.into(), &super::characteristics::color_selecteditemtext);
        map.insert(4084.into(), &super::characteristics::font_default_modified);
        map.insert(4087.into(), &super::characteristics::font_minimum_size_modified);
        map.insert(4089.into(), &super::characteristics::font_name_list_cursive_modified);
        map.insert(4091.into(), &super::characteristics::font_name_list_monospace_modified);
        map.insert(4092.into(), &super::characteristics::font_name_list_sans_serif_modified);
        map.insert(4093.into(), &super::characteristics::font_name_list_serif_modified);
        map.insert(4095.into(), &super::characteristics::font_name_monospace_modified);
        map.insert(4098.into(), &super::characteristics::font_name_sans_serif_modified);
        map.insert(4101.into(), &super::characteristics::font_name_serif_modified);
        map.insert(4104.into(), &super::characteristics::font_size_monospace_modified);
        map.insert(4107.into(), &super::characteristics::font_size_variable_modified);
        map.insert(4123.into(), &super::characteristics::gl_version);
        map.insert(4126.into(), &super::characteristics::group_count);
        map.insert(4127.into(), &super::characteristics::group_count_wo_speakers);
        map.insert(4129.into(), &super::characteristics::ice_order);
        map.insert(4130.into(), &super::characteristics::ice_sd);
        map.insert(4131.into(), &super::characteristics::inner_height);
        map.insert(4132.into(), &super::characteristics::inner_width);
        map.insert(4139.into(), &super::characteristics::mathml1);
        map.insert(4140.into(), &super::characteristics::mathml10);
        map.insert(4141.into(), &super::characteristics::mathml2);
        map.insert(4142.into(), &super::characteristics::mathml3);
        map.insert(4143.into(), &super::characteristics::mathml4);
        map.insert(4144.into(), &super::characteristics::mathml5);
        map.insert(4145.into(), &super::characteristics::mathml6);
        map.insert(4146.into(), &super::characteristics::mathml7);
        map.insert(4147.into(), &super::characteristics::mathml8);
        map.insert(4148.into(), &super::characteristics::mathml9);
        map.insert(4149.into(), &super::characteristics::max_touch_points);
        map.insert(4156.into(), &super::characteristics::microphone_count);
        map.insert(4159.into(), &super::characteristics::motion_decimals);
        map.insert(4160.into(), &super::characteristics::motion_freq);
        map.insert(4161.into(), &super::characteristics::orientation_angle);
        map.insert(4162.into(), &super::characteristics::orientation_decimals);
        map.insert(4163.into(), &super::characteristics::orientation_freq);
        map.insert(4164.into(), &super::characteristics::orientationabs_decimals);
        map.insert(4165.into(), &super::characteristics::orientationabs_freq);
        map.insert(4169.into(), &super::characteristics::outer_height);
        map.insert(4170.into(), &super::characteristics::outer_width);
        map.insert(4172.into(), &super::characteristics::pixel_depth);
        map.insert(4173.into(), &super::characteristics::pixel_ratio);
        map.insert(4175.into(), &super::characteristics::pointer_height);
        map.insert(4178.into(), &super::characteristics::pointer_tiltx);
        map.insert(4179.into(), &super::characteristics::pointer_tilty);
        map.insert(4180.into(), &super::characteristics::pointer_twist);
        map.insert(4181.into(), &super::characteristics::pointer_type);
        map.insert(4182.into(), &super::characteristics::pointer_width);
        map.insert(4183.into(), &super::characteristics::posx);
        map.insert(4184.into(), &super::characteristics::posy);
        map.insert(4185.into(), &super::characteristics::prefers_contrast);
        map.insert(4194.into(), &super::characteristics::prefs_network_cookie_cookiebehavior);
        map.insert(4199.into(), &super::characteristics::processor_count);
        map.insert(4201.into(), &super::characteristics::screen_height);
        map.insert(4202.into(), &super::characteristics::screen_orientation);
        map.insert(4203.into(), &super::characteristics::screen_width);
        map.insert(4204.into(), &super::characteristics::size_mode);
        map.insert(4205.into(), &super::characteristics::speaker_count);
        map.insert(4206.into(), &super::characteristics::submission_schema);
        map.insert(4208.into(), &super::characteristics::target_frame_rate);
        map.insert(4217.into(), &super::characteristics::voices_count);
        map.insert(4219.into(), &super::characteristics::voices_local_count);
        map.insert(4225.into(), &super::characteristics::zoom_count);
        map.insert(4325.into(), &super::first_startup::delete_tasks_time);
        map.insert(4326.into(), &super::first_startup::elapsed);
        map.insert(4328.into(), &super::first_startup::normandy_init_time);
        map.insert(4329.into(), &super::first_startup::status_code);
        map.insert(4333.into(), &super::defaultagent::days_since_last_app_launch);
        map
    });

    pub static STRING_MAP: Lazy<HashMap<MetricId, &Lazy<StringMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(175);
        map.insert(5.into(), &super::a11y::instantiators);
        map.insert(200.into(), &super::genai_chatbot::provider);
        map.insert(222.into(), &super::background_update::final_state);
        map.insert(251.into(), &super::os_environment::launch_method);
        map.insert(253.into(), &super::os_environment::allowed_app_sources);
        map.insert(270.into(), &super::startup::profile_database_version);
        map.insert(271.into(), &super::startup::profile_selection_reason);
        map.insert(341.into(), &super::messaging_system::addon_version);
        map.insert(343.into(), &super::messaging_system::bucket_id);
        map.insert(345.into(), &super::messaging_system::event);
        map.insert(348.into(), &super::messaging_system::event_page);
        map.insert(349.into(), &super::messaging_system::event_reason);
        map.insert(354.into(), &super::messaging_system::event_source);
        map.insert(358.into(), &super::messaging_system::locale);
        map.insert(360.into(), &super::messaging_system::ping_type);
        map.insert(361.into(), &super::messaging_system::source);
        map.insert(364.into(), &super::messaging_system_attribution::campaign);
        map.insert(365.into(), &super::messaging_system_attribution::content);
        map.insert(366.into(), &super::messaging_system_attribution::dlsource);
        map.insert(367.into(), &super::messaging_system_attribution::dltoken);
        map.insert(368.into(), &super::messaging_system_attribution::experiment);
        map.insert(369.into(), &super::messaging_system_attribution::medium);
        map.insert(370.into(), &super::messaging_system_attribution::msstoresignedin);
        map.insert(371.into(), &super::messaging_system_attribution::source);
        map.insert(372.into(), &super::messaging_system_attribution::ua);
        map.insert(374.into(), &super::messaging_system_attribution::variation);
        map.insert(383.into(), &super::newtab::homepage_category);
        map.insert(384.into(), &super::newtab::locale);
        map.insert(385.into(), &super::newtab::newtab_category);
        map.insert(418.into(), &super::top_sites::advertiser);
        map.insert(420.into(), &super::top_sites::ping_type);
        map.insert(423.into(), &super::top_sites::source);
        map.insert(424.into(), &super::top_sites::tile_id);
        map.insert(438.into(), &super::pocket_button::event_action);
        map.insert(440.into(), &super::pocket_button::event_source);
        map.insert(442.into(), &super::pocket_button::model);
        map.insert(633.into(), &super::sidebar::display_settings);
        map.insert(637.into(), &super::sidebar::position_settings);
        map.insert(641.into(), &super::sidebar::tabs_layout);
        map.insert(687.into(), &super::quick_suggest::advertiser);
        map.insert(688.into(), &super::quick_suggest::block_id);
        map.insert(690.into(), &super::quick_suggest::iab_category);
        map.insert(693.into(), &super::quick_suggest::match_type);
        map.insert(694.into(), &super::quick_suggest::ping_type);
        map.insert(697.into(), &super::quick_suggest::request_id);
        map.insert(698.into(), &super::quick_suggest::source);
        map.insert(699.into(), &super::quick_suggest::suggested_index);
        map.insert(734.into(), &super::installation_first_seen::failure_reason);
        map.insert(737.into(), &super::installation_first_seen::installer_type);
        map.insert(742.into(), &super::installation_first_seen::version);
        map.insert(3284.into(), &super::gfx::linux_window_protocol);
        map.insert(3290.into(), &super::gfx_adapter_primary::description);
        map.insert(3291.into(), &super::gfx_adapter_primary::device_id);
        map.insert(3292.into(), &super::gfx_adapter_primary::driver_date);
        map.insert(3293.into(), &super::gfx_adapter_primary::driver_files);
        map.insert(3294.into(), &super::gfx_adapter_primary::driver_vendor);
        map.insert(3295.into(), &super::gfx_adapter_primary::driver_version);
        map.insert(3297.into(), &super::gfx_adapter_primary::subsystem_id);
        map.insert(3298.into(), &super::gfx_adapter_primary::vendor_id);
        map.insert(3314.into(), &super::gfx_feature::webrender);
        map.insert(3316.into(), &super::gfx_status::compositor);
        map.insert(3318.into(), &super::gfx_status::last_compositor_gecko_version);
        map.insert(3320.into(), &super::gpu_process::feature_status);
        map.insert(3477.into(), &super::client_association::uid);
        map.insert(3567.into(), &super::crash::app_build);
        map.insert(3568.into(), &super::crash::app_channel);
        map.insert(3569.into(), &super::crash::app_display_version);
        map.insert(3571.into(), &super::crash::background_task_name);
        map.insert(3573.into(), &super::crash::font_name);
        map.insert(3575.into(), &super::crash::ipc_channel_error);
        map.insert(3577.into(), &super::crash::main_thread_runnable_name);
        map.insert(3578.into(), &super::crash::minidump_sha256_hash);
        map.insert(3579.into(), &super::crash::moz_crash_reason);
        map.insert(3580.into(), &super::crash::process_type);
        map.insert(3581.into(), &super::crash::profiler_child_shutdown_phase);
        map.insert(3583.into(), &super::crash::remote_type);
        map.insert(3584.into(), &super::crash::shutdown_progress);
        map.insert(3590.into(), &super::crash_windows::file_dialog_error_code);
        map.insert(3614.into(), &super::windows::package_family_name);
        map.insert(3722.into(), &super::test_only::cheesy_string);
        map.insert(3752.into(), &super::test_only_ipc::a_string);
        map.insert(3992.into(), &super::broken_site_report::breakage_category);
        map.insert(3998.into(), &super::broken_site_report_browser_info_graphics::device_pixel_ratio);
        map.insert(4020.into(), &super::broken_site_report_tab_info_antitracking::block_list);
        map.insert(4041.into(), &super::characteristics::canvasdata1);
        map.insert(4042.into(), &super::characteristics::canvasdata10);
        map.insert(4043.into(), &super::characteristics::canvasdata10software);
        map.insert(4044.into(), &super::characteristics::canvasdata11_webgl);
        map.insert(4045.into(), &super::characteristics::canvasdata11_webglsoftware);
        map.insert(4046.into(), &super::characteristics::canvasdata12_fingerprintjs1);
        map.insert(4047.into(), &super::characteristics::canvasdata12_fingerprintjs1software);
        map.insert(4048.into(), &super::characteristics::canvasdata13_fingerprintjs2);
        map.insert(4049.into(), &super::characteristics::canvasdata13_fingerprintjs2software);
        map.insert(4050.into(), &super::characteristics::canvasdata1software);
        map.insert(4051.into(), &super::characteristics::canvasdata2);
        map.insert(4052.into(), &super::characteristics::canvasdata2software);
        map.insert(4053.into(), &super::characteristics::canvasdata3);
        map.insert(4054.into(), &super::characteristics::canvasdata3software);
        map.insert(4055.into(), &super::characteristics::canvasdata4);
        map.insert(4056.into(), &super::characteristics::canvasdata4software);
        map.insert(4057.into(), &super::characteristics::canvasdata5);
        map.insert(4058.into(), &super::characteristics::canvasdata5software);
        map.insert(4059.into(), &super::characteristics::canvasdata6);
        map.insert(4060.into(), &super::characteristics::canvasdata6software);
        map.insert(4061.into(), &super::characteristics::canvasdata7);
        map.insert(4062.into(), &super::characteristics::canvasdata7software);
        map.insert(4063.into(), &super::characteristics::canvasdata8);
        map.insert(4064.into(), &super::characteristics::canvasdata8software);
        map.insert(4065.into(), &super::characteristics::canvasdata9);
        map.insert(4066.into(), &super::characteristics::canvasdata9software);
        map.insert(4067.into(), &super::characteristics::changed_media_prefs);
        map.insert(4068.into(), &super::characteristics::channel);
        map.insert(4081.into(), &super::characteristics::cpu_model);
        map.insert(4083.into(), &super::characteristics::font_default_default_group);
        map.insert(4085.into(), &super::characteristics::font_default_western);
        map.insert(4086.into(), &super::characteristics::font_minimum_size_default_group);
        map.insert(4088.into(), &super::characteristics::font_minimum_size_western);
        map.insert(4094.into(), &super::characteristics::font_name_monospace_default_group);
        map.insert(4096.into(), &super::characteristics::font_name_monospace_western);
        map.insert(4097.into(), &super::characteristics::font_name_sans_serif_default_group);
        map.insert(4099.into(), &super::characteristics::font_name_sans_serif_western);
        map.insert(4100.into(), &super::characteristics::font_name_serif_default_group);
        map.insert(4102.into(), &super::characteristics::font_name_serif_western);
        map.insert(4103.into(), &super::characteristics::font_size_monospace_default_group);
        map.insert(4105.into(), &super::characteristics::font_size_monospace_western);
        map.insert(4106.into(), &super::characteristics::font_size_variable_default_group);
        map.insert(4108.into(), &super::characteristics::font_size_variable_western);
        map.insert(4112.into(), &super::characteristics::gl_fragment_shader);
        map.insert(4119.into(), &super::characteristics::gl_renderer);
        map.insert(4120.into(), &super::characteristics::gl_renderer_raw);
        map.insert(4121.into(), &super::characteristics::gl_vendor);
        map.insert(4122.into(), &super::characteristics::gl_vendor_raw);
        map.insert(4124.into(), &super::characteristics::gl_version_raw);
        map.insert(4125.into(), &super::characteristics::gl_vertex_shader);
        map.insert(4133.into(), &super::characteristics::intl_locale);
        map.insert(4136.into(), &super::characteristics::keyboard_layout);
        map.insert(4137.into(), &super::characteristics::languages);
        map.insert(4166.into(), &super::characteristics::os_name);
        map.insert(4167.into(), &super::characteristics::os_version);
        map.insert(4168.into(), &super::characteristics::oscpu);
        map.insert(4174.into(), &super::characteristics::platform);
        map.insert(4176.into(), &super::characteristics::pointer_pressure);
        map.insert(4177.into(), &super::characteristics::pointer_tangentinal_pressure);
        map.insert(4192.into(), &super::characteristics::prefs_intl_accept_languages);
        map.insert(4200.into(), &super::characteristics::scalings);
        map.insert(4207.into(), &super::characteristics::system_locale);
        map.insert(4209.into(), &super::characteristics::text_anti_aliasing);
        map.insert(4210.into(), &super::characteristics::timezone);
        map.insert(4211.into(), &super::characteristics::touch_rotation_angle);
        map.insert(4213.into(), &super::characteristics::version);
        map.insert(4216.into(), &super::characteristics::voices_all_ssdeep);
        map.insert(4218.into(), &super::characteristics::voices_default);
        map.insert(4220.into(), &super::characteristics::voices_local_ssdeep);
        map.insert(4221.into(), &super::characteristics::voices_nonlocal_ssdeep);
        map.insert(4228.into(), &super::search_engine_default::display_name);
        map.insert(4229.into(), &super::search_engine_default::engine_id);
        map.insert(4230.into(), &super::search_engine_default::load_path);
        map.insert(4232.into(), &super::search_engine_default::verified);
        map.insert(4234.into(), &super::search_engine_private::display_name);
        map.insert(4235.into(), &super::search_engine_private::engine_id);
        map.insert(4236.into(), &super::search_engine_private::load_path);
        map.insert(4238.into(), &super::search_engine_private::verified);
        map.insert(4334.into(), &super::notification::action);
        map.insert(4336.into(), &super::system::os_version);
        map.insert(4337.into(), &super::system::previous_os_version);
        map.insert(4338.into(), &super::system_default::browser);
        map.insert(4339.into(), &super::system_default::pdf_handler);
        map.insert(4340.into(), &super::system_default::previous_browser);
        map.insert(4406.into(), &super::blocklist::mlbf_softblocks_source);
        map.insert(4407.into(), &super::blocklist::mlbf_source);
        map.insert(4417.into(), &super::update::channel);
        map.insert(4423.into(), &super::update::version_pin);
        map.insert(4424.into(), &super::gecko::build_id);
        map.insert(4425.into(), &super::gecko::version);
        map.insert(4427.into(), &super::widget::gtk_version);
        map
    });

    pub static TIMING_DISTRIBUTION_MAP: Lazy<HashMap<MetricId, &Lazy<TimingDistributionMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(146);
        map.insert(12.into(), &super::privacy_sanitize::load_time);
        map.insert(38.into(), &super::browser_backup::favicons_time);
        map.insert(42.into(), &super::browser_backup::places_time);
        map.insert(50.into(), &super::browser_backup::total_backup_time);
        map.insert(65.into(), &super::networking::cache_metadata_first_read_time);
        map.insert(66.into(), &super::networking::cache_metadata_second_read_time);
        map.insert(79.into(), &super::networking::dns_failed_lookup_time);
        map.insert(80.into(), &super::networking::dns_lookup_time);
        map.insert(82.into(), &super::networking::dns_native_https_call_time);
        map.insert(83.into(), &super::networking::dns_renewal_time);
        map.insert(84.into(), &super::networking::dns_renewal_time_for_ttl);
        map.insert(122.into(), &super::networking::http_channel_page_open_to_first_sent);
        map.insert(123.into(), &super::networking::http_channel_page_open_to_first_sent_https_rr);
        map.insert(124.into(), &super::networking::http_channel_sub_open_to_first_sent);
        map.insert(125.into(), &super::networking::http_channel_sub_open_to_first_sent_https_rr);
        map.insert(126.into(), &super::networking::http_content_cssloader_ondatafinished_to_onstop_delay);
        map.insert(127.into(), &super::networking::http_content_html5parser_ondatafinished_to_onstop_delay);
        map.insert(128.into(), &super::networking::http_content_ondatafinished_delay);
        map.insert(129.into(), &super::networking::http_content_ondatafinished_delay_2);
        map.insert(130.into(), &super::networking::http_content_ondatafinished_to_onstop_delay);
        map.insert(131.into(), &super::networking::http_content_onstart_delay);
        map.insert(132.into(), &super::networking::http_content_onstop_delay);
        map.insert(134.into(), &super::networking::http_onstart_suspend_total_time);
        map.insert(151.into(), &super::networking::sqlite_cookies_block_main_thread);
        map.insert(152.into(), &super::networking::sqlite_cookies_time_to_block_main_thread);
        map.insert(153.into(), &super::networking::transaction_wait_time);
        map.insert(154.into(), &super::networking::transaction_wait_time_https_rr);
        map.insert(568.into(), &super::serp::categorization_duration);
        map.insert(717.into(), &super::urlbar::quick_suggest_ingest_time);
        map.insert(748.into(), &super::performance_interaction::tab_switch_composite);
        map.insert(749.into(), &super::performance_interaction::keypress_present_latency);
        map.insert(750.into(), &super::performance_interaction::mouseup_click_present_latency);
        map.insert(843.into(), &super::performance_page::total_content_page_load);
        map.insert(844.into(), &super::performance_page::non_blank_paint);
        map.insert(3181.into(), &super::ls_preparedatastore::processing_time);
        map.insert(3182.into(), &super::ls_preparelsdatabase::processing_time);
        map.insert(3234.into(), &super::javascript_pageload::baseline_compile_time);
        map.insert(3235.into(), &super::javascript_pageload::delazification_time);
        map.insert(3236.into(), &super::javascript_pageload::execution_time);
        map.insert(3237.into(), &super::javascript_pageload::gc_time);
        map.insert(3238.into(), &super::javascript_pageload::parse_time);
        map.insert(3239.into(), &super::javascript_pageload::protect_time);
        map.insert(3240.into(), &super::javascript_pageload::xdr_encode_time);
        map.insert(3242.into(), &super::perf::largest_contentful_paint);
        map.insert(3243.into(), &super::perf::largest_contentful_paint_from_response_start);
        map.insert(3245.into(), &super::performance_pageload::fcp);
        map.insert(3246.into(), &super::performance_pageload::fcp_responsestart);
        map.insert(3247.into(), &super::performance_pageload::h3p_fcp_with_priority);
        map.insert(3248.into(), &super::performance_pageload::http3_fcp_http3);
        map.insert(3249.into(), &super::performance_pageload::http3_fcp_supports_http3);
        map.insert(3250.into(), &super::performance_pageload::http3_fcp_without_priority);
        map.insert(3251.into(), &super::performance_pageload::load_time);
        map.insert(3252.into(), &super::performance_pageload::load_time_responsestart);
        map.insert(3253.into(), &super::performance_pageload::async_sheet_load);
        map.insert(3254.into(), &super::performance_time::dom_complete);
        map.insert(3255.into(), &super::performance_time::dom_content_loaded_end);
        map.insert(3256.into(), &super::performance_time::dom_content_loaded_start);
        map.insert(3257.into(), &super::performance_time::dom_interactive);
        map.insert(3258.into(), &super::performance_time::load_event_end);
        map.insert(3259.into(), &super::performance_time::load_event_start);
        map.insert(3260.into(), &super::performance_time::response_start);
        map.insert(3268.into(), &super::httpsfirst::downgrade_time);
        map.insert(3269.into(), &super::httpsfirst::downgrade_time_schemeless);
        map.insert(3283.into(), &super::gfx::composite_time);
        map.insert(3286.into(), &super::gfx::scroll_present_latency);
        map.insert(3299.into(), &super::gfx_checkerboard::duration);
        map.insert(3301.into(), &super::gfx_checkerboard::potential_duration);
        map.insert(3303.into(), &super::gfx_content::full_paint_time);
        map.insert(3304.into(), &super::gfx_content::paint_time);
        map.insert(3323.into(), &super::paint::build_displaylist_time);
        map.insert(3324.into(), &super::wr::framebuild_time);
        map.insert(3325.into(), &super::wr::gpu_wait_time);
        map.insert(3326.into(), &super::wr::rasterize_blobs_time);
        map.insert(3327.into(), &super::wr::rasterize_glyphs_time);
        map.insert(3328.into(), &super::wr::renderer_time);
        map.insert(3329.into(), &super::wr::renderer_time_no_sc);
        map.insert(3330.into(), &super::wr::scenebuild_time);
        map.insert(3331.into(), &super::wr::sceneswap_time);
        map.insert(3332.into(), &super::wr::texture_cache_update_time);
        map.insert(3333.into(), &super::wr::time_to_frame_build);
        map.insert(3334.into(), &super::wr::time_to_render_start);
        map.insert(3355.into(), &super::javascript_gc::compact_time);
        map.insert(3356.into(), &super::javascript_gc::mark_roots_time);
        map.insert(3357.into(), &super::javascript_gc::mark_time);
        map.insert(3358.into(), &super::javascript_gc::minor_time);
        map.insert(3359.into(), &super::javascript_gc::prepare_time);
        map.insert(3360.into(), &super::javascript_gc::slice_time);
        map.insert(3361.into(), &super::javascript_gc::sweep_time);
        map.insert(3362.into(), &super::javascript_gc::total_time);
        map.insert(3365.into(), &super::performance_clone_deserialize::time);
        map.insert(3368.into(), &super::geckoview::content_process_lifetime);
        map.insert(3370.into(), &super::geckoview::page_load_progress_time);
        map.insert(3371.into(), &super::geckoview::page_load_time);
        map.insert(3372.into(), &super::geckoview::page_reload_time);
        map.insert(3374.into(), &super::geckoview::startup_runtime);
        map.insert(3393.into(), &super::network::cache_hit_time);
        map.insert(3394.into(), &super::network::cache_read_time);
        map.insert(3395.into(), &super::network::complete_load);
        map.insert(3396.into(), &super::network::complete_load_cached);
        map.insert(3397.into(), &super::network::complete_load_net);
        map.insert(3399.into(), &super::network::dns_end);
        map.insert(3400.into(), &super::network::dns_start);
        map.insert(3401.into(), &super::network::first_from_cache);
        map.insert(3402.into(), &super::network::first_sent_to_last_received);
        map.insert(3403.into(), &super::network::font_download_end);
        map.insert(3409.into(), &super::network::http_revalidation);
        map.insert(3410.into(), &super::network::open_to_first_received);
        map.insert(3411.into(), &super::network::open_to_first_sent);
        map.insert(3412.into(), &super::network::sub_cache_read_time);
        map.insert(3413.into(), &super::network::sub_complete_load);
        map.insert(3414.into(), &super::network::sub_complete_load_cached);
        map.insert(3415.into(), &super::network::sub_complete_load_net);
        map.insert(3416.into(), &super::network::sub_dns_end);
        map.insert(3417.into(), &super::network::sub_dns_start);
        map.insert(3418.into(), &super::network::sub_first_from_cache);
        map.insert(3419.into(), &super::network::sub_first_sent_to_last_received);
        map.insert(3420.into(), &super::network::sub_http_revalidation);
        map.insert(3421.into(), &super::network::sub_open_to_first_received);
        map.insert(3422.into(), &super::network::sub_open_to_first_sent);
        map.insert(3423.into(), &super::network::sub_tcp_connection);
        map.insert(3424.into(), &super::network::sub_tls_handshake);
        map.insert(3433.into(), &super::network::tcp_connection);
        map.insert(3437.into(), &super::network::tls_handshake);
        map.insert(3458.into(), &super::cert_verification_time::failure);
        map.insert(3459.into(), &super::cert_verification_time::success);
        map.insert(3463.into(), &super::ocsp_request_time::cancel);
        map.insert(3464.into(), &super::ocsp_request_time::failure);
        map.insert(3465.into(), &super::ocsp_request_time::success);
        map.insert(3517.into(), &super::bounce_tracking_protection::purge_duration);
        map.insert(3546.into(), &super::relevancy_classify::duration);
        map.insert(3624.into(), &super::extensions_apis_dnr::evaluate_rules_time);
        map.insert(3627.into(), &super::extensions_apis_dnr::startup_cache_read_time);
        map.insert(3629.into(), &super::extensions_apis_dnr::startup_cache_write_time);
        map.insert(3630.into(), &super::extensions_apis_dnr::validate_rules_time);
        map.insert(3636.into(), &super::extensions_timing::background_page_load);
        map.insert(3637.into(), &super::extensions_timing::browser_action_popup_open);
        map.insert(3638.into(), &super::extensions_timing::content_script_injection);
        map.insert(3640.into(), &super::extensions_timing::extension_startup);
        map.insert(3641.into(), &super::extensions_timing::page_action_popup_open);
        map.insert(3642.into(), &super::extensions_timing::storage_local_get_idb);
        map.insert(3643.into(), &super::extensions_timing::storage_local_set_idb);
        map.insert(3714.into(), &super::fog_ipc::flush_durations);
        map.insert(3743.into(), &super::test_only::what_time_is_it);
        map.insert(3755.into(), &super::test_only_ipc::a_timing_dist);
        map.insert(4226.into(), &super::fingerprinting_protection::canvas_noise_calculate_time);
        map.insert(4240.into(), &super::search_service::startup_time);
        map
    });

    pub static MEMORY_DISTRIBUTION_MAP: Lazy<HashMap<MetricId, &Lazy<MemoryDistributionMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(13);
        map.insert(30.into(), &super::browser_backup::compressed_archive_size);
        map.insert(49.into(), &super::browser_backup::total_backup_size);
        map.insert(67.into(), &super::networking::cache_metadata_size);
        map.insert(105.into(), &super::networking::http_3_udp_datagram_segment_size_received);
        map.insert(106.into(), &super::networking::http_3_udp_datagram_segment_size_sent);
        map.insert(108.into(), &super::networking::http_3_udp_datagram_size_received);
        map.insert(3364.into(), &super::performance_clone_deserialize::size);
        map.insert(3457.into(), &super::cert_storage::memory);
        map.insert(3626.into(), &super::extensions_apis_dnr::startup_cache_read_size);
        map.insert(3628.into(), &super::extensions_apis_dnr::startup_cache_write_size);
        map.insert(3713.into(), &super::fog_ipc::buffer_sizes);
        map.insert(3725.into(), &super::test_only::do_you_remember);
        map.insert(3750.into(), &super::test_only_ipc::a_memory_dist);
        map
    });

    pub static COUNTER_MAP: Lazy<HashMap<MetricId, &Lazy<CounterMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(2416);
        map.insert(62.into(), &super::networking::doh_heuristics_attempts);
        map.insert(63.into(), &super::networking::doh_heuristics_pass_count);
        map.insert(141.into(), &super::networking::os_socket_limit_reached);
        map.insert(143.into(), &super::networking::residual_cache_folder_count);
        map.insert(166.into(), &super::downloads::panel_shown);
        map.insert(168.into(), &super::downloads::file_opened);
        map.insert(347.into(), &super::messaging_system::event_context_parse_error);
        map.insert(355.into(), &super::messaging_system::glean_ping_for_ping_failures);
        map.insert(362.into(), &super::messaging_system::unknown_key_count);
        map.insert(569.into(), &super::serp::categorization_no_map_found);
        map.insert(594.into(), &super::shopping::product_page_visits);
        map.insert(659.into(), &super::browser_ui_interaction::all_tabs_panel_dragstart_tab_event_count);
        map.insert(661.into(), &super::browser_ui_interaction::textrecognition_error);
        map.insert(720.into(), &super::browser_engagement::active_ticks);
        map.insert(722.into(), &super::browser_engagement::uri_count);
        map.insert(723.into(), &super::browser_engagement::uri_count_normal_mode);
        map.insert(845.into(), &super::use_counter::content_documents_destroyed);
        map.insert(846.into(), &super::use_counter::dedicated_workers_destroyed);
        map.insert(847.into(), &super::use_counter::service_workers_destroyed);
        map.insert(848.into(), &super::use_counter::shared_workers_destroyed);
        map.insert(849.into(), &super::use_counter::top_level_content_documents_destroyed);
        map.insert(850.into(), &super::use_counter_css_doc::alignment_baseline);
        map.insert(851.into(), &super::use_counter_css_doc::background_repeat_x);
        map.insert(852.into(), &super::use_counter_css_doc::background_repeat_y);
        map.insert(853.into(), &super::use_counter_css_doc::baseline_shift);
        map.insert(854.into(), &super::use_counter_css_doc::buffered_rendering);
        map.insert(855.into(), &super::use_counter_css_doc::color_rendering);
        map.insert(856.into(), &super::use_counter_css_doc::css_accent_color);
        map.insert(857.into(), &super::use_counter_css_doc::css_align_content);
        map.insert(858.into(), &super::use_counter_css_doc::css_align_items);
        map.insert(859.into(), &super::use_counter_css_doc::css_align_self);
        map.insert(860.into(), &super::use_counter_css_doc::css_all);
        map.insert(861.into(), &super::use_counter_css_doc::css_anchor_name);
        map.insert(862.into(), &super::use_counter_css_doc::css_anchor_scope);
        map.insert(863.into(), &super::use_counter_css_doc::css_animation);
        map.insert(864.into(), &super::use_counter_css_doc::css_animation_composition);
        map.insert(865.into(), &super::use_counter_css_doc::css_animation_delay);
        map.insert(866.into(), &super::use_counter_css_doc::css_animation_direction);
        map.insert(867.into(), &super::use_counter_css_doc::css_animation_duration);
        map.insert(868.into(), &super::use_counter_css_doc::css_animation_fill_mode);
        map.insert(869.into(), &super::use_counter_css_doc::css_animation_iteration_count);
        map.insert(870.into(), &super::use_counter_css_doc::css_animation_name);
        map.insert(871.into(), &super::use_counter_css_doc::css_animation_play_state);
        map.insert(872.into(), &super::use_counter_css_doc::css_animation_timeline);
        map.insert(873.into(), &super::use_counter_css_doc::css_animation_timing_function);
        map.insert(874.into(), &super::use_counter_css_doc::css_appearance);
        map.insert(875.into(), &super::use_counter_css_doc::css_aspect_ratio);
        map.insert(876.into(), &super::use_counter_css_doc::css_backdrop_filter);
        map.insert(877.into(), &super::use_counter_css_doc::css_backface_visibility);
        map.insert(878.into(), &super::use_counter_css_doc::css_background);
        map.insert(879.into(), &super::use_counter_css_doc::css_background_attachment);
        map.insert(880.into(), &super::use_counter_css_doc::css_background_blend_mode);
        map.insert(881.into(), &super::use_counter_css_doc::css_background_clip);
        map.insert(882.into(), &super::use_counter_css_doc::css_background_color);
        map.insert(883.into(), &super::use_counter_css_doc::css_background_image);
        map.insert(884.into(), &super::use_counter_css_doc::css_background_origin);
        map.insert(885.into(), &super::use_counter_css_doc::css_background_position);
        map.insert(886.into(), &super::use_counter_css_doc::css_background_position_x);
        map.insert(887.into(), &super::use_counter_css_doc::css_background_position_y);
        map.insert(888.into(), &super::use_counter_css_doc::css_background_repeat);
        map.insert(889.into(), &super::use_counter_css_doc::css_background_size);
        map.insert(890.into(), &super::use_counter_css_doc::css_baseline_source);
        map.insert(891.into(), &super::use_counter_css_doc::css_block_size);
        map.insert(892.into(), &super::use_counter_css_doc::css_border);
        map.insert(893.into(), &super::use_counter_css_doc::css_border_block);
        map.insert(894.into(), &super::use_counter_css_doc::css_border_block_color);
        map.insert(895.into(), &super::use_counter_css_doc::css_border_block_end);
        map.insert(896.into(), &super::use_counter_css_doc::css_border_block_end_color);
        map.insert(897.into(), &super::use_counter_css_doc::css_border_block_end_style);
        map.insert(898.into(), &super::use_counter_css_doc::css_border_block_end_width);
        map.insert(899.into(), &super::use_counter_css_doc::css_border_block_start);
        map.insert(900.into(), &super::use_counter_css_doc::css_border_block_start_color);
        map.insert(901.into(), &super::use_counter_css_doc::css_border_block_start_style);
        map.insert(902.into(), &super::use_counter_css_doc::css_border_block_start_width);
        map.insert(903.into(), &super::use_counter_css_doc::css_border_block_style);
        map.insert(904.into(), &super::use_counter_css_doc::css_border_block_width);
        map.insert(905.into(), &super::use_counter_css_doc::css_border_bottom);
        map.insert(906.into(), &super::use_counter_css_doc::css_border_bottom_color);
        map.insert(907.into(), &super::use_counter_css_doc::css_border_bottom_left_radius);
        map.insert(908.into(), &super::use_counter_css_doc::css_border_bottom_right_radius);
        map.insert(909.into(), &super::use_counter_css_doc::css_border_bottom_style);
        map.insert(910.into(), &super::use_counter_css_doc::css_border_bottom_width);
        map.insert(911.into(), &super::use_counter_css_doc::css_border_collapse);
        map.insert(912.into(), &super::use_counter_css_doc::css_border_color);
        map.insert(913.into(), &super::use_counter_css_doc::css_border_end_end_radius);
        map.insert(914.into(), &super::use_counter_css_doc::css_border_end_start_radius);
        map.insert(915.into(), &super::use_counter_css_doc::css_border_image);
        map.insert(916.into(), &super::use_counter_css_doc::css_border_image_outset);
        map.insert(917.into(), &super::use_counter_css_doc::css_border_image_repeat);
        map.insert(918.into(), &super::use_counter_css_doc::css_border_image_slice);
        map.insert(919.into(), &super::use_counter_css_doc::css_border_image_source);
        map.insert(920.into(), &super::use_counter_css_doc::css_border_image_width);
        map.insert(921.into(), &super::use_counter_css_doc::css_border_inline);
        map.insert(922.into(), &super::use_counter_css_doc::css_border_inline_color);
        map.insert(923.into(), &super::use_counter_css_doc::css_border_inline_end);
        map.insert(924.into(), &super::use_counter_css_doc::css_border_inline_end_color);
        map.insert(925.into(), &super::use_counter_css_doc::css_border_inline_end_style);
        map.insert(926.into(), &super::use_counter_css_doc::css_border_inline_end_width);
        map.insert(927.into(), &super::use_counter_css_doc::css_border_inline_start);
        map.insert(928.into(), &super::use_counter_css_doc::css_border_inline_start_color);
        map.insert(929.into(), &super::use_counter_css_doc::css_border_inline_start_style);
        map.insert(930.into(), &super::use_counter_css_doc::css_border_inline_start_width);
        map.insert(931.into(), &super::use_counter_css_doc::css_border_inline_style);
        map.insert(932.into(), &super::use_counter_css_doc::css_border_inline_width);
        map.insert(933.into(), &super::use_counter_css_doc::css_border_left);
        map.insert(934.into(), &super::use_counter_css_doc::css_border_left_color);
        map.insert(935.into(), &super::use_counter_css_doc::css_border_left_style);
        map.insert(936.into(), &super::use_counter_css_doc::css_border_left_width);
        map.insert(937.into(), &super::use_counter_css_doc::css_border_radius);
        map.insert(938.into(), &super::use_counter_css_doc::css_border_right);
        map.insert(939.into(), &super::use_counter_css_doc::css_border_right_color);
        map.insert(940.into(), &super::use_counter_css_doc::css_border_right_style);
        map.insert(941.into(), &super::use_counter_css_doc::css_border_right_width);
        map.insert(942.into(), &super::use_counter_css_doc::css_border_spacing);
        map.insert(943.into(), &super::use_counter_css_doc::css_border_start_end_radius);
        map.insert(944.into(), &super::use_counter_css_doc::css_border_start_start_radius);
        map.insert(945.into(), &super::use_counter_css_doc::css_border_style);
        map.insert(946.into(), &super::use_counter_css_doc::css_border_top);
        map.insert(947.into(), &super::use_counter_css_doc::css_border_top_color);
        map.insert(948.into(), &super::use_counter_css_doc::css_border_top_left_radius);
        map.insert(949.into(), &super::use_counter_css_doc::css_border_top_right_radius);
        map.insert(950.into(), &super::use_counter_css_doc::css_border_top_style);
        map.insert(951.into(), &super::use_counter_css_doc::css_border_top_width);
        map.insert(952.into(), &super::use_counter_css_doc::css_border_width);
        map.insert(953.into(), &super::use_counter_css_doc::css_bottom);
        map.insert(954.into(), &super::use_counter_css_doc::css_box_decoration_break);
        map.insert(955.into(), &super::use_counter_css_doc::css_box_shadow);
        map.insert(956.into(), &super::use_counter_css_doc::css_box_sizing);
        map.insert(957.into(), &super::use_counter_css_doc::css_break_after);
        map.insert(958.into(), &super::use_counter_css_doc::css_break_before);
        map.insert(959.into(), &super::use_counter_css_doc::css_break_inside);
        map.insert(960.into(), &super::use_counter_css_doc::css_caption_side);
        map.insert(961.into(), &super::use_counter_css_doc::css_caret_color);
        map.insert(962.into(), &super::use_counter_css_doc::css_clear);
        map.insert(963.into(), &super::use_counter_css_doc::css_clip);
        map.insert(964.into(), &super::use_counter_css_doc::css_clip_path);
        map.insert(965.into(), &super::use_counter_css_doc::css_clip_rule);
        map.insert(966.into(), &super::use_counter_css_doc::css_color);
        map.insert(967.into(), &super::use_counter_css_doc::css_color_adjust);
        map.insert(968.into(), &super::use_counter_css_doc::css_color_interpolation);
        map.insert(969.into(), &super::use_counter_css_doc::css_color_interpolation_filters);
        map.insert(970.into(), &super::use_counter_css_doc::css_color_scheme);
        map.insert(971.into(), &super::use_counter_css_doc::css_column_count);
        map.insert(972.into(), &super::use_counter_css_doc::css_column_fill);
        map.insert(973.into(), &super::use_counter_css_doc::css_column_gap);
        map.insert(974.into(), &super::use_counter_css_doc::css_column_rule);
        map.insert(975.into(), &super::use_counter_css_doc::css_column_rule_color);
        map.insert(976.into(), &super::use_counter_css_doc::css_column_rule_style);
        map.insert(977.into(), &super::use_counter_css_doc::css_column_rule_width);
        map.insert(978.into(), &super::use_counter_css_doc::css_column_span);
        map.insert(979.into(), &super::use_counter_css_doc::css_column_width);
        map.insert(980.into(), &super::use_counter_css_doc::css_columns);
        map.insert(981.into(), &super::use_counter_css_doc::css_contain);
        map.insert(982.into(), &super::use_counter_css_doc::css_contain_intrinsic_block_size);
        map.insert(983.into(), &super::use_counter_css_doc::css_contain_intrinsic_height);
        map.insert(984.into(), &super::use_counter_css_doc::css_contain_intrinsic_inline_size);
        map.insert(985.into(), &super::use_counter_css_doc::css_contain_intrinsic_size);
        map.insert(986.into(), &super::use_counter_css_doc::css_contain_intrinsic_width);
        map.insert(987.into(), &super::use_counter_css_doc::css_container);
        map.insert(988.into(), &super::use_counter_css_doc::css_container_name);
        map.insert(989.into(), &super::use_counter_css_doc::css_container_type);
        map.insert(990.into(), &super::use_counter_css_doc::css_content);
        map.insert(991.into(), &super::use_counter_css_doc::css_content_visibility);
        map.insert(992.into(), &super::use_counter_css_doc::css_counter_increment);
        map.insert(993.into(), &super::use_counter_css_doc::css_counter_reset);
        map.insert(994.into(), &super::use_counter_css_doc::css_counter_set);
        map.insert(995.into(), &super::use_counter_css_doc::css_cursor);
        map.insert(996.into(), &super::use_counter_css_doc::css_cx);
        map.insert(997.into(), &super::use_counter_css_doc::css_cy);
        map.insert(998.into(), &super::use_counter_css_doc::css_d);
        map.insert(999.into(), &super::use_counter_css_doc::css_direction);
        map.insert(1000.into(), &super::use_counter_css_doc::css_display);
        map.insert(1001.into(), &super::use_counter_css_doc::css_dominant_baseline);
        map.insert(1002.into(), &super::use_counter_css_doc::css_empty_cells);
        map.insert(1003.into(), &super::use_counter_css_doc::css_field_sizing);
        map.insert(1004.into(), &super::use_counter_css_doc::css_fill);
        map.insert(1005.into(), &super::use_counter_css_doc::css_fill_opacity);
        map.insert(1006.into(), &super::use_counter_css_doc::css_fill_rule);
        map.insert(1007.into(), &super::use_counter_css_doc::css_filter);
        map.insert(1008.into(), &super::use_counter_css_doc::css_flex);
        map.insert(1009.into(), &super::use_counter_css_doc::css_flex_basis);
        map.insert(1010.into(), &super::use_counter_css_doc::css_flex_direction);
        map.insert(1011.into(), &super::use_counter_css_doc::css_flex_flow);
        map.insert(1012.into(), &super::use_counter_css_doc::css_flex_grow);
        map.insert(1013.into(), &super::use_counter_css_doc::css_flex_shrink);
        map.insert(1014.into(), &super::use_counter_css_doc::css_flex_wrap);
        map.insert(1015.into(), &super::use_counter_css_doc::css_float);
        map.insert(1016.into(), &super::use_counter_css_doc::css_flood_color);
        map.insert(1017.into(), &super::use_counter_css_doc::css_flood_opacity);
        map.insert(1018.into(), &super::use_counter_css_doc::css_font);
        map.insert(1019.into(), &super::use_counter_css_doc::css_font_family);
        map.insert(1020.into(), &super::use_counter_css_doc::css_font_feature_settings);
        map.insert(1021.into(), &super::use_counter_css_doc::css_font_kerning);
        map.insert(1022.into(), &super::use_counter_css_doc::css_font_language_override);
        map.insert(1023.into(), &super::use_counter_css_doc::css_font_optical_sizing);
        map.insert(1024.into(), &super::use_counter_css_doc::css_font_palette);
        map.insert(1025.into(), &super::use_counter_css_doc::css_font_size);
        map.insert(1026.into(), &super::use_counter_css_doc::css_font_size_adjust);
        map.insert(1027.into(), &super::use_counter_css_doc::css_font_stretch);
        map.insert(1028.into(), &super::use_counter_css_doc::css_font_style);
        map.insert(1029.into(), &super::use_counter_css_doc::css_font_synthesis);
        map.insert(1030.into(), &super::use_counter_css_doc::css_font_synthesis_position);
        map.insert(1031.into(), &super::use_counter_css_doc::css_font_synthesis_small_caps);
        map.insert(1032.into(), &super::use_counter_css_doc::css_font_synthesis_style);
        map.insert(1033.into(), &super::use_counter_css_doc::css_font_synthesis_weight);
        map.insert(1034.into(), &super::use_counter_css_doc::css_font_variant);
        map.insert(1035.into(), &super::use_counter_css_doc::css_font_variant_alternates);
        map.insert(1036.into(), &super::use_counter_css_doc::css_font_variant_caps);
        map.insert(1037.into(), &super::use_counter_css_doc::css_font_variant_east_asian);
        map.insert(1038.into(), &super::use_counter_css_doc::css_font_variant_emoji);
        map.insert(1039.into(), &super::use_counter_css_doc::css_font_variant_ligatures);
        map.insert(1040.into(), &super::use_counter_css_doc::css_font_variant_numeric);
        map.insert(1041.into(), &super::use_counter_css_doc::css_font_variant_position);
        map.insert(1042.into(), &super::use_counter_css_doc::css_font_variation_settings);
        map.insert(1043.into(), &super::use_counter_css_doc::css_font_weight);
        map.insert(1044.into(), &super::use_counter_css_doc::css_forced_color_adjust);
        map.insert(1045.into(), &super::use_counter_css_doc::css_gap);
        map.insert(1046.into(), &super::use_counter_css_doc::css_grid);
        map.insert(1047.into(), &super::use_counter_css_doc::css_grid_area);
        map.insert(1048.into(), &super::use_counter_css_doc::css_grid_auto_columns);
        map.insert(1049.into(), &super::use_counter_css_doc::css_grid_auto_flow);
        map.insert(1050.into(), &super::use_counter_css_doc::css_grid_auto_rows);
        map.insert(1051.into(), &super::use_counter_css_doc::css_grid_column);
        map.insert(1052.into(), &super::use_counter_css_doc::css_grid_column_end);
        map.insert(1053.into(), &super::use_counter_css_doc::css_grid_column_gap);
        map.insert(1054.into(), &super::use_counter_css_doc::css_grid_column_start);
        map.insert(1055.into(), &super::use_counter_css_doc::css_grid_gap);
        map.insert(1056.into(), &super::use_counter_css_doc::css_grid_row);
        map.insert(1057.into(), &super::use_counter_css_doc::css_grid_row_end);
        map.insert(1058.into(), &super::use_counter_css_doc::css_grid_row_gap);
        map.insert(1059.into(), &super::use_counter_css_doc::css_grid_row_start);
        map.insert(1060.into(), &super::use_counter_css_doc::css_grid_template);
        map.insert(1061.into(), &super::use_counter_css_doc::css_grid_template_areas);
        map.insert(1062.into(), &super::use_counter_css_doc::css_grid_template_columns);
        map.insert(1063.into(), &super::use_counter_css_doc::css_grid_template_rows);
        map.insert(1064.into(), &super::use_counter_css_doc::css_height);
        map.insert(1065.into(), &super::use_counter_css_doc::css_hyphenate_character);
        map.insert(1066.into(), &super::use_counter_css_doc::css_hyphens);
        map.insert(1067.into(), &super::use_counter_css_doc::css_image_orientation);
        map.insert(1068.into(), &super::use_counter_css_doc::css_image_rendering);
        map.insert(1069.into(), &super::use_counter_css_doc::css_ime_mode);
        map.insert(1070.into(), &super::use_counter_css_doc::css_initial_letter);
        map.insert(1071.into(), &super::use_counter_css_doc::css_inline_size);
        map.insert(1072.into(), &super::use_counter_css_doc::css_inset);
        map.insert(1073.into(), &super::use_counter_css_doc::css_inset_block);
        map.insert(1074.into(), &super::use_counter_css_doc::css_inset_block_end);
        map.insert(1075.into(), &super::use_counter_css_doc::css_inset_block_start);
        map.insert(1076.into(), &super::use_counter_css_doc::css_inset_inline);
        map.insert(1077.into(), &super::use_counter_css_doc::css_inset_inline_end);
        map.insert(1078.into(), &super::use_counter_css_doc::css_inset_inline_start);
        map.insert(1079.into(), &super::use_counter_css_doc::css_isolation);
        map.insert(1080.into(), &super::use_counter_css_doc::css_justify_content);
        map.insert(1081.into(), &super::use_counter_css_doc::css_justify_items);
        map.insert(1082.into(), &super::use_counter_css_doc::css_justify_self);
        map.insert(1083.into(), &super::use_counter_css_doc::css_left);
        map.insert(1084.into(), &super::use_counter_css_doc::css_letter_spacing);
        map.insert(1085.into(), &super::use_counter_css_doc::css_lighting_color);
        map.insert(1086.into(), &super::use_counter_css_doc::css_line_break);
        map.insert(1087.into(), &super::use_counter_css_doc::css_line_height);
        map.insert(1088.into(), &super::use_counter_css_doc::css_list_style);
        map.insert(1089.into(), &super::use_counter_css_doc::css_list_style_image);
        map.insert(1090.into(), &super::use_counter_css_doc::css_list_style_position);
        map.insert(1091.into(), &super::use_counter_css_doc::css_list_style_type);
        map.insert(1092.into(), &super::use_counter_css_doc::css_margin);
        map.insert(1093.into(), &super::use_counter_css_doc::css_margin_block);
        map.insert(1094.into(), &super::use_counter_css_doc::css_margin_block_end);
        map.insert(1095.into(), &super::use_counter_css_doc::css_margin_block_start);
        map.insert(1096.into(), &super::use_counter_css_doc::css_margin_bottom);
        map.insert(1097.into(), &super::use_counter_css_doc::css_margin_inline);
        map.insert(1098.into(), &super::use_counter_css_doc::css_margin_inline_end);
        map.insert(1099.into(), &super::use_counter_css_doc::css_margin_inline_start);
        map.insert(1100.into(), &super::use_counter_css_doc::css_margin_left);
        map.insert(1101.into(), &super::use_counter_css_doc::css_margin_right);
        map.insert(1102.into(), &super::use_counter_css_doc::css_margin_top);
        map.insert(1103.into(), &super::use_counter_css_doc::css_marker);
        map.insert(1104.into(), &super::use_counter_css_doc::css_marker_end);
        map.insert(1105.into(), &super::use_counter_css_doc::css_marker_mid);
        map.insert(1106.into(), &super::use_counter_css_doc::css_marker_start);
        map.insert(1107.into(), &super::use_counter_css_doc::css_mask);
        map.insert(1108.into(), &super::use_counter_css_doc::css_mask_clip);
        map.insert(1109.into(), &super::use_counter_css_doc::css_mask_composite);
        map.insert(1110.into(), &super::use_counter_css_doc::css_mask_image);
        map.insert(1111.into(), &super::use_counter_css_doc::css_mask_mode);
        map.insert(1112.into(), &super::use_counter_css_doc::css_mask_origin);
        map.insert(1113.into(), &super::use_counter_css_doc::css_mask_position);
        map.insert(1114.into(), &super::use_counter_css_doc::css_mask_position_x);
        map.insert(1115.into(), &super::use_counter_css_doc::css_mask_position_y);
        map.insert(1116.into(), &super::use_counter_css_doc::css_mask_repeat);
        map.insert(1117.into(), &super::use_counter_css_doc::css_mask_size);
        map.insert(1118.into(), &super::use_counter_css_doc::css_mask_type);
        map.insert(1119.into(), &super::use_counter_css_doc::css_masonry_auto_flow);
        map.insert(1120.into(), &super::use_counter_css_doc::css_math_depth);
        map.insert(1121.into(), &super::use_counter_css_doc::css_math_style);
        map.insert(1122.into(), &super::use_counter_css_doc::css_max_block_size);
        map.insert(1123.into(), &super::use_counter_css_doc::css_max_height);
        map.insert(1124.into(), &super::use_counter_css_doc::css_max_inline_size);
        map.insert(1125.into(), &super::use_counter_css_doc::css_max_width);
        map.insert(1126.into(), &super::use_counter_css_doc::css_min_block_size);
        map.insert(1127.into(), &super::use_counter_css_doc::css_min_height);
        map.insert(1128.into(), &super::use_counter_css_doc::css_min_inline_size);
        map.insert(1129.into(), &super::use_counter_css_doc::css_min_width);
        map.insert(1130.into(), &super::use_counter_css_doc::css_mix_blend_mode);
        map.insert(1131.into(), &super::use_counter_css_doc::css_moz_animation);
        map.insert(1132.into(), &super::use_counter_css_doc::css_moz_animation_delay);
        map.insert(1133.into(), &super::use_counter_css_doc::css_moz_animation_direction);
        map.insert(1134.into(), &super::use_counter_css_doc::css_moz_animation_duration);
        map.insert(1135.into(), &super::use_counter_css_doc::css_moz_animation_fill_mode);
        map.insert(1136.into(), &super::use_counter_css_doc::css_moz_animation_iteration_count);
        map.insert(1137.into(), &super::use_counter_css_doc::css_moz_animation_name);
        map.insert(1138.into(), &super::use_counter_css_doc::css_moz_animation_play_state);
        map.insert(1139.into(), &super::use_counter_css_doc::css_moz_animation_timing_function);
        map.insert(1140.into(), &super::use_counter_css_doc::css_moz_appearance);
        map.insert(1141.into(), &super::use_counter_css_doc::css_moz_backface_visibility);
        map.insert(1142.into(), &super::use_counter_css_doc::css_moz_border_end);
        map.insert(1143.into(), &super::use_counter_css_doc::css_moz_border_end_color);
        map.insert(1144.into(), &super::use_counter_css_doc::css_moz_border_end_style);
        map.insert(1145.into(), &super::use_counter_css_doc::css_moz_border_end_width);
        map.insert(1146.into(), &super::use_counter_css_doc::css_moz_border_image);
        map.insert(1147.into(), &super::use_counter_css_doc::css_moz_border_start);
        map.insert(1148.into(), &super::use_counter_css_doc::css_moz_border_start_color);
        map.insert(1149.into(), &super::use_counter_css_doc::css_moz_border_start_style);
        map.insert(1150.into(), &super::use_counter_css_doc::css_moz_border_start_width);
        map.insert(1151.into(), &super::use_counter_css_doc::css_moz_box_align);
        map.insert(1152.into(), &super::use_counter_css_doc::css_moz_box_collapse);
        map.insert(1153.into(), &super::use_counter_css_doc::css_moz_box_direction);
        map.insert(1154.into(), &super::use_counter_css_doc::css_moz_box_flex);
        map.insert(1155.into(), &super::use_counter_css_doc::css_moz_box_ordinal_group);
        map.insert(1156.into(), &super::use_counter_css_doc::css_moz_box_orient);
        map.insert(1157.into(), &super::use_counter_css_doc::css_moz_box_pack);
        map.insert(1158.into(), &super::use_counter_css_doc::css_moz_box_sizing);
        map.insert(1159.into(), &super::use_counter_css_doc::css_moz_context_properties);
        map.insert(1160.into(), &super::use_counter_css_doc::css_moz_control_character_visibility);
        map.insert(1161.into(), &super::use_counter_css_doc::css_moz_default_appearance);
        map.insert(1162.into(), &super::use_counter_css_doc::css_moz_float_edge);
        map.insert(1163.into(), &super::use_counter_css_doc::css_moz_font_feature_settings);
        map.insert(1164.into(), &super::use_counter_css_doc::css_moz_font_language_override);
        map.insert(1165.into(), &super::use_counter_css_doc::css_moz_force_broken_image_icon);
        map.insert(1166.into(), &super::use_counter_css_doc::css_moz_hyphens);
        map.insert(1167.into(), &super::use_counter_css_doc::css_moz_inert);
        map.insert(1168.into(), &super::use_counter_css_doc::css_moz_margin_end);
        map.insert(1169.into(), &super::use_counter_css_doc::css_moz_margin_start);
        map.insert(1170.into(), &super::use_counter_css_doc::css_moz_math_variant);
        map.insert(1171.into(), &super::use_counter_css_doc::css_moz_min_font_size_ratio);
        map.insert(1172.into(), &super::use_counter_css_doc::css_moz_orient);
        map.insert(1173.into(), &super::use_counter_css_doc::css_moz_osx_font_smoothing);
        map.insert(1174.into(), &super::use_counter_css_doc::css_moz_padding_end);
        map.insert(1175.into(), &super::use_counter_css_doc::css_moz_padding_start);
        map.insert(1176.into(), &super::use_counter_css_doc::css_moz_perspective);
        map.insert(1177.into(), &super::use_counter_css_doc::css_moz_perspective_origin);
        map.insert(1178.into(), &super::use_counter_css_doc::css_moz_subtree_hidden_only_visually);
        map.insert(1179.into(), &super::use_counter_css_doc::css_moz_tab_size);
        map.insert(1180.into(), &super::use_counter_css_doc::css_moz_text_size_adjust);
        map.insert(1181.into(), &super::use_counter_css_doc::css_moz_theme);
        map.insert(1182.into(), &super::use_counter_css_doc::css_moz_top_layer);
        map.insert(1183.into(), &super::use_counter_css_doc::css_moz_transform);
        map.insert(1184.into(), &super::use_counter_css_doc::css_moz_transform_origin);
        map.insert(1185.into(), &super::use_counter_css_doc::css_moz_transform_style);
        map.insert(1186.into(), &super::use_counter_css_doc::css_moz_transition);
        map.insert(1187.into(), &super::use_counter_css_doc::css_moz_transition_delay);
        map.insert(1188.into(), &super::use_counter_css_doc::css_moz_transition_duration);
        map.insert(1189.into(), &super::use_counter_css_doc::css_moz_transition_property);
        map.insert(1190.into(), &super::use_counter_css_doc::css_moz_transition_timing_function);
        map.insert(1191.into(), &super::use_counter_css_doc::css_moz_user_focus);
        map.insert(1192.into(), &super::use_counter_css_doc::css_moz_user_input);
        map.insert(1193.into(), &super::use_counter_css_doc::css_moz_user_modify);
        map.insert(1194.into(), &super::use_counter_css_doc::css_moz_user_select);
        map.insert(1195.into(), &super::use_counter_css_doc::css_moz_window_dragging);
        map.insert(1196.into(), &super::use_counter_css_doc::css_moz_window_input_region_margin);
        map.insert(1197.into(), &super::use_counter_css_doc::css_moz_window_opacity);
        map.insert(1198.into(), &super::use_counter_css_doc::css_moz_window_shadow);
        map.insert(1199.into(), &super::use_counter_css_doc::css_moz_window_transform);
        map.insert(1200.into(), &super::use_counter_css_doc::css_moz_window_transform_origin);
        map.insert(1201.into(), &super::use_counter_css_doc::css_object_fit);
        map.insert(1202.into(), &super::use_counter_css_doc::css_object_position);
        map.insert(1203.into(), &super::use_counter_css_doc::css_offset);
        map.insert(1204.into(), &super::use_counter_css_doc::css_offset_anchor);
        map.insert(1205.into(), &super::use_counter_css_doc::css_offset_distance);
        map.insert(1206.into(), &super::use_counter_css_doc::css_offset_path);
        map.insert(1207.into(), &super::use_counter_css_doc::css_offset_position);
        map.insert(1208.into(), &super::use_counter_css_doc::css_offset_rotate);
        map.insert(1209.into(), &super::use_counter_css_doc::css_opacity);
        map.insert(1210.into(), &super::use_counter_css_doc::css_order);
        map.insert(1211.into(), &super::use_counter_css_doc::css_outline);
        map.insert(1212.into(), &super::use_counter_css_doc::css_outline_color);
        map.insert(1213.into(), &super::use_counter_css_doc::css_outline_offset);
        map.insert(1214.into(), &super::use_counter_css_doc::css_outline_style);
        map.insert(1215.into(), &super::use_counter_css_doc::css_outline_width);
        map.insert(1216.into(), &super::use_counter_css_doc::css_overflow);
        map.insert(1217.into(), &super::use_counter_css_doc::css_overflow_anchor);
        map.insert(1218.into(), &super::use_counter_css_doc::css_overflow_block);
        map.insert(1219.into(), &super::use_counter_css_doc::css_overflow_clip_box);
        map.insert(1220.into(), &super::use_counter_css_doc::css_overflow_clip_box_block);
        map.insert(1221.into(), &super::use_counter_css_doc::css_overflow_clip_box_inline);
        map.insert(1222.into(), &super::use_counter_css_doc::css_overflow_clip_margin);
        map.insert(1223.into(), &super::use_counter_css_doc::css_overflow_inline);
        map.insert(1224.into(), &super::use_counter_css_doc::css_overflow_wrap);
        map.insert(1225.into(), &super::use_counter_css_doc::css_overflow_x);
        map.insert(1226.into(), &super::use_counter_css_doc::css_overflow_y);
        map.insert(1227.into(), &super::use_counter_css_doc::css_overscroll_behavior);
        map.insert(1228.into(), &super::use_counter_css_doc::css_overscroll_behavior_block);
        map.insert(1229.into(), &super::use_counter_css_doc::css_overscroll_behavior_inline);
        map.insert(1230.into(), &super::use_counter_css_doc::css_overscroll_behavior_x);
        map.insert(1231.into(), &super::use_counter_css_doc::css_overscroll_behavior_y);
        map.insert(1232.into(), &super::use_counter_css_doc::css_padding);
        map.insert(1233.into(), &super::use_counter_css_doc::css_padding_block);
        map.insert(1234.into(), &super::use_counter_css_doc::css_padding_block_end);
        map.insert(1235.into(), &super::use_counter_css_doc::css_padding_block_start);
        map.insert(1236.into(), &super::use_counter_css_doc::css_padding_bottom);
        map.insert(1237.into(), &super::use_counter_css_doc::css_padding_inline);
        map.insert(1238.into(), &super::use_counter_css_doc::css_padding_inline_end);
        map.insert(1239.into(), &super::use_counter_css_doc::css_padding_inline_start);
        map.insert(1240.into(), &super::use_counter_css_doc::css_padding_left);
        map.insert(1241.into(), &super::use_counter_css_doc::css_padding_right);
        map.insert(1242.into(), &super::use_counter_css_doc::css_padding_top);
        map.insert(1243.into(), &super::use_counter_css_doc::css_page);
        map.insert(1244.into(), &super::use_counter_css_doc::css_page_break_after);
        map.insert(1245.into(), &super::use_counter_css_doc::css_page_break_before);
        map.insert(1246.into(), &super::use_counter_css_doc::css_page_break_inside);
        map.insert(1247.into(), &super::use_counter_css_doc::css_page_orientation);
        map.insert(1248.into(), &super::use_counter_css_doc::css_paint_order);
        map.insert(1249.into(), &super::use_counter_css_doc::css_perspective);
        map.insert(1250.into(), &super::use_counter_css_doc::css_perspective_origin);
        map.insert(1251.into(), &super::use_counter_css_doc::css_place_content);
        map.insert(1252.into(), &super::use_counter_css_doc::css_place_items);
        map.insert(1253.into(), &super::use_counter_css_doc::css_place_self);
        map.insert(1254.into(), &super::use_counter_css_doc::css_pointer_events);
        map.insert(1255.into(), &super::use_counter_css_doc::css_position);
        map.insert(1256.into(), &super::use_counter_css_doc::css_position_anchor);
        map.insert(1257.into(), &super::use_counter_css_doc::css_position_area);
        map.insert(1258.into(), &super::use_counter_css_doc::css_position_try);
        map.insert(1259.into(), &super::use_counter_css_doc::css_position_try_fallbacks);
        map.insert(1260.into(), &super::use_counter_css_doc::css_position_try_order);
        map.insert(1261.into(), &super::use_counter_css_doc::css_position_visibility);
        map.insert(1262.into(), &super::use_counter_css_doc::css_print_color_adjust);
        map.insert(1263.into(), &super::use_counter_css_doc::css_quotes);
        map.insert(1264.into(), &super::use_counter_css_doc::css_r);
        map.insert(1265.into(), &super::use_counter_css_doc::css_resize);
        map.insert(1266.into(), &super::use_counter_css_doc::css_right);
        map.insert(1267.into(), &super::use_counter_css_doc::css_rotate);
        map.insert(1268.into(), &super::use_counter_css_doc::css_row_gap);
        map.insert(1269.into(), &super::use_counter_css_doc::css_ruby_align);
        map.insert(1270.into(), &super::use_counter_css_doc::css_ruby_position);
        map.insert(1271.into(), &super::use_counter_css_doc::css_rx);
        map.insert(1272.into(), &super::use_counter_css_doc::css_ry);
        map.insert(1273.into(), &super::use_counter_css_doc::css_scale);
        map.insert(1274.into(), &super::use_counter_css_doc::css_scroll_behavior);
        map.insert(1275.into(), &super::use_counter_css_doc::css_scroll_margin);
        map.insert(1276.into(), &super::use_counter_css_doc::css_scroll_margin_block);
        map.insert(1277.into(), &super::use_counter_css_doc::css_scroll_margin_block_end);
        map.insert(1278.into(), &super::use_counter_css_doc::css_scroll_margin_block_start);
        map.insert(1279.into(), &super::use_counter_css_doc::css_scroll_margin_bottom);
        map.insert(1280.into(), &super::use_counter_css_doc::css_scroll_margin_inline);
        map.insert(1281.into(), &super::use_counter_css_doc::css_scroll_margin_inline_end);
        map.insert(1282.into(), &super::use_counter_css_doc::css_scroll_margin_inline_start);
        map.insert(1283.into(), &super::use_counter_css_doc::css_scroll_margin_left);
        map.insert(1284.into(), &super::use_counter_css_doc::css_scroll_margin_right);
        map.insert(1285.into(), &super::use_counter_css_doc::css_scroll_margin_top);
        map.insert(1286.into(), &super::use_counter_css_doc::css_scroll_padding);
        map.insert(1287.into(), &super::use_counter_css_doc::css_scroll_padding_block);
        map.insert(1288.into(), &super::use_counter_css_doc::css_scroll_padding_block_end);
        map.insert(1289.into(), &super::use_counter_css_doc::css_scroll_padding_block_start);
        map.insert(1290.into(), &super::use_counter_css_doc::css_scroll_padding_bottom);
        map.insert(1291.into(), &super::use_counter_css_doc::css_scroll_padding_inline);
        map.insert(1292.into(), &super::use_counter_css_doc::css_scroll_padding_inline_end);
        map.insert(1293.into(), &super::use_counter_css_doc::css_scroll_padding_inline_start);
        map.insert(1294.into(), &super::use_counter_css_doc::css_scroll_padding_left);
        map.insert(1295.into(), &super::use_counter_css_doc::css_scroll_padding_right);
        map.insert(1296.into(), &super::use_counter_css_doc::css_scroll_padding_top);
        map.insert(1297.into(), &super::use_counter_css_doc::css_scroll_snap_align);
        map.insert(1298.into(), &super::use_counter_css_doc::css_scroll_snap_stop);
        map.insert(1299.into(), &super::use_counter_css_doc::css_scroll_snap_type);
        map.insert(1300.into(), &super::use_counter_css_doc::css_scroll_timeline);
        map.insert(1301.into(), &super::use_counter_css_doc::css_scroll_timeline_axis);
        map.insert(1302.into(), &super::use_counter_css_doc::css_scroll_timeline_name);
        map.insert(1303.into(), &super::use_counter_css_doc::css_scrollbar_color);
        map.insert(1304.into(), &super::use_counter_css_doc::css_scrollbar_gutter);
        map.insert(1305.into(), &super::use_counter_css_doc::css_scrollbar_width);
        map.insert(1306.into(), &super::use_counter_css_doc::css_shape_image_threshold);
        map.insert(1307.into(), &super::use_counter_css_doc::css_shape_margin);
        map.insert(1308.into(), &super::use_counter_css_doc::css_shape_outside);
        map.insert(1309.into(), &super::use_counter_css_doc::css_shape_rendering);
        map.insert(1310.into(), &super::use_counter_css_doc::css_size);
        map.insert(1311.into(), &super::use_counter_css_doc::css_stop_color);
        map.insert(1312.into(), &super::use_counter_css_doc::css_stop_opacity);
        map.insert(1313.into(), &super::use_counter_css_doc::css_stroke);
        map.insert(1314.into(), &super::use_counter_css_doc::css_stroke_dasharray);
        map.insert(1315.into(), &super::use_counter_css_doc::css_stroke_dashoffset);
        map.insert(1316.into(), &super::use_counter_css_doc::css_stroke_linecap);
        map.insert(1317.into(), &super::use_counter_css_doc::css_stroke_linejoin);
        map.insert(1318.into(), &super::use_counter_css_doc::css_stroke_miterlimit);
        map.insert(1319.into(), &super::use_counter_css_doc::css_stroke_opacity);
        map.insert(1320.into(), &super::use_counter_css_doc::css_stroke_width);
        map.insert(1321.into(), &super::use_counter_css_doc::css_tab_size);
        map.insert(1322.into(), &super::use_counter_css_doc::css_table_layout);
        map.insert(1323.into(), &super::use_counter_css_doc::css_text_align);
        map.insert(1324.into(), &super::use_counter_css_doc::css_text_align_last);
        map.insert(1325.into(), &super::use_counter_css_doc::css_text_anchor);
        map.insert(1326.into(), &super::use_counter_css_doc::css_text_combine_upright);
        map.insert(1327.into(), &super::use_counter_css_doc::css_text_decoration);
        map.insert(1328.into(), &super::use_counter_css_doc::css_text_decoration_color);
        map.insert(1329.into(), &super::use_counter_css_doc::css_text_decoration_line);
        map.insert(1330.into(), &super::use_counter_css_doc::css_text_decoration_skip_ink);
        map.insert(1331.into(), &super::use_counter_css_doc::css_text_decoration_style);
        map.insert(1332.into(), &super::use_counter_css_doc::css_text_decoration_thickness);
        map.insert(1333.into(), &super::use_counter_css_doc::css_text_emphasis);
        map.insert(1334.into(), &super::use_counter_css_doc::css_text_emphasis_color);
        map.insert(1335.into(), &super::use_counter_css_doc::css_text_emphasis_position);
        map.insert(1336.into(), &super::use_counter_css_doc::css_text_emphasis_style);
        map.insert(1337.into(), &super::use_counter_css_doc::css_text_indent);
        map.insert(1338.into(), &super::use_counter_css_doc::css_text_justify);
        map.insert(1339.into(), &super::use_counter_css_doc::css_text_orientation);
        map.insert(1340.into(), &super::use_counter_css_doc::css_text_overflow);
        map.insert(1341.into(), &super::use_counter_css_doc::css_text_rendering);
        map.insert(1342.into(), &super::use_counter_css_doc::css_text_shadow);
        map.insert(1343.into(), &super::use_counter_css_doc::css_text_transform);
        map.insert(1344.into(), &super::use_counter_css_doc::css_text_underline_offset);
        map.insert(1345.into(), &super::use_counter_css_doc::css_text_underline_position);
        map.insert(1346.into(), &super::use_counter_css_doc::css_text_wrap);
        map.insert(1347.into(), &super::use_counter_css_doc::css_text_wrap_mode);
        map.insert(1348.into(), &super::use_counter_css_doc::css_text_wrap_style);
        map.insert(1349.into(), &super::use_counter_css_doc::css_top);
        map.insert(1350.into(), &super::use_counter_css_doc::css_touch_action);
        map.insert(1351.into(), &super::use_counter_css_doc::css_transform);
        map.insert(1352.into(), &super::use_counter_css_doc::css_transform_box);
        map.insert(1353.into(), &super::use_counter_css_doc::css_transform_origin);
        map.insert(1354.into(), &super::use_counter_css_doc::css_transform_style);
        map.insert(1355.into(), &super::use_counter_css_doc::css_transition);
        map.insert(1356.into(), &super::use_counter_css_doc::css_transition_behavior);
        map.insert(1357.into(), &super::use_counter_css_doc::css_transition_delay);
        map.insert(1358.into(), &super::use_counter_css_doc::css_transition_duration);
        map.insert(1359.into(), &super::use_counter_css_doc::css_transition_property);
        map.insert(1360.into(), &super::use_counter_css_doc::css_transition_timing_function);
        map.insert(1361.into(), &super::use_counter_css_doc::css_translate);
        map.insert(1362.into(), &super::use_counter_css_doc::css_unicode_bidi);
        map.insert(1363.into(), &super::use_counter_css_doc::css_user_select);
        map.insert(1364.into(), &super::use_counter_css_doc::css_vector_effect);
        map.insert(1365.into(), &super::use_counter_css_doc::css_vertical_align);
        map.insert(1366.into(), &super::use_counter_css_doc::css_view_timeline);
        map.insert(1367.into(), &super::use_counter_css_doc::css_view_timeline_axis);
        map.insert(1368.into(), &super::use_counter_css_doc::css_view_timeline_inset);
        map.insert(1369.into(), &super::use_counter_css_doc::css_view_timeline_name);
        map.insert(1370.into(), &super::use_counter_css_doc::css_view_transition_name);
        map.insert(1371.into(), &super::use_counter_css_doc::css_visibility);
        map.insert(1372.into(), &super::use_counter_css_doc::css_webkit_align_content);
        map.insert(1373.into(), &super::use_counter_css_doc::css_webkit_align_items);
        map.insert(1374.into(), &super::use_counter_css_doc::css_webkit_align_self);
        map.insert(1375.into(), &super::use_counter_css_doc::css_webkit_animation);
        map.insert(1376.into(), &super::use_counter_css_doc::css_webkit_animation_delay);
        map.insert(1377.into(), &super::use_counter_css_doc::css_webkit_animation_direction);
        map.insert(1378.into(), &super::use_counter_css_doc::css_webkit_animation_duration);
        map.insert(1379.into(), &super::use_counter_css_doc::css_webkit_animation_fill_mode);
        map.insert(1380.into(), &super::use_counter_css_doc::css_webkit_animation_iteration_count);
        map.insert(1381.into(), &super::use_counter_css_doc::css_webkit_animation_name);
        map.insert(1382.into(), &super::use_counter_css_doc::css_webkit_animation_play_state);
        map.insert(1383.into(), &super::use_counter_css_doc::css_webkit_animation_timing_function);
        map.insert(1384.into(), &super::use_counter_css_doc::css_webkit_appearance);
        map.insert(1385.into(), &super::use_counter_css_doc::css_webkit_backface_visibility);
        map.insert(1386.into(), &super::use_counter_css_doc::css_webkit_background_clip);
        map.insert(1387.into(), &super::use_counter_css_doc::css_webkit_background_origin);
        map.insert(1388.into(), &super::use_counter_css_doc::css_webkit_background_size);
        map.insert(1389.into(), &super::use_counter_css_doc::css_webkit_border_bottom_left_radius);
        map.insert(1390.into(), &super::use_counter_css_doc::css_webkit_border_bottom_right_radius);
        map.insert(1391.into(), &super::use_counter_css_doc::css_webkit_border_image);
        map.insert(1392.into(), &super::use_counter_css_doc::css_webkit_border_radius);
        map.insert(1393.into(), &super::use_counter_css_doc::css_webkit_border_top_left_radius);
        map.insert(1394.into(), &super::use_counter_css_doc::css_webkit_border_top_right_radius);
        map.insert(1395.into(), &super::use_counter_css_doc::css_webkit_box_align);
        map.insert(1396.into(), &super::use_counter_css_doc::css_webkit_box_direction);
        map.insert(1397.into(), &super::use_counter_css_doc::css_webkit_box_flex);
        map.insert(1398.into(), &super::use_counter_css_doc::css_webkit_box_ordinal_group);
        map.insert(1399.into(), &super::use_counter_css_doc::css_webkit_box_orient);
        map.insert(1400.into(), &super::use_counter_css_doc::css_webkit_box_pack);
        map.insert(1401.into(), &super::use_counter_css_doc::css_webkit_box_shadow);
        map.insert(1402.into(), &super::use_counter_css_doc::css_webkit_box_sizing);
        map.insert(1403.into(), &super::use_counter_css_doc::css_webkit_clip_path);
        map.insert(1404.into(), &super::use_counter_css_doc::css_webkit_filter);
        map.insert(1405.into(), &super::use_counter_css_doc::css_webkit_flex);
        map.insert(1406.into(), &super::use_counter_css_doc::css_webkit_flex_basis);
        map.insert(1407.into(), &super::use_counter_css_doc::css_webkit_flex_direction);
        map.insert(1408.into(), &super::use_counter_css_doc::css_webkit_flex_flow);
        map.insert(1409.into(), &super::use_counter_css_doc::css_webkit_flex_grow);
        map.insert(1410.into(), &super::use_counter_css_doc::css_webkit_flex_shrink);
        map.insert(1411.into(), &super::use_counter_css_doc::css_webkit_flex_wrap);
        map.insert(1412.into(), &super::use_counter_css_doc::css_webkit_font_feature_settings);
        map.insert(1413.into(), &super::use_counter_css_doc::css_webkit_font_smoothing);
        map.insert(1414.into(), &super::use_counter_css_doc::css_webkit_justify_content);
        map.insert(1415.into(), &super::use_counter_css_doc::css_webkit_line_clamp);
        map.insert(1416.into(), &super::use_counter_css_doc::css_webkit_mask);
        map.insert(1417.into(), &super::use_counter_css_doc::css_webkit_mask_clip);
        map.insert(1418.into(), &super::use_counter_css_doc::css_webkit_mask_composite);
        map.insert(1419.into(), &super::use_counter_css_doc::css_webkit_mask_image);
        map.insert(1420.into(), &super::use_counter_css_doc::css_webkit_mask_origin);
        map.insert(1421.into(), &super::use_counter_css_doc::css_webkit_mask_position);
        map.insert(1422.into(), &super::use_counter_css_doc::css_webkit_mask_position_x);
        map.insert(1423.into(), &super::use_counter_css_doc::css_webkit_mask_position_y);
        map.insert(1424.into(), &super::use_counter_css_doc::css_webkit_mask_repeat);
        map.insert(1425.into(), &super::use_counter_css_doc::css_webkit_mask_size);
        map.insert(1426.into(), &super::use_counter_css_doc::css_webkit_order);
        map.insert(1427.into(), &super::use_counter_css_doc::css_webkit_perspective);
        map.insert(1428.into(), &super::use_counter_css_doc::css_webkit_perspective_origin);
        map.insert(1429.into(), &super::use_counter_css_doc::css_webkit_text_fill_color);
        map.insert(1430.into(), &super::use_counter_css_doc::css_webkit_text_security);
        map.insert(1431.into(), &super::use_counter_css_doc::css_webkit_text_size_adjust);
        map.insert(1432.into(), &super::use_counter_css_doc::css_webkit_text_stroke);
        map.insert(1433.into(), &super::use_counter_css_doc::css_webkit_text_stroke_color);
        map.insert(1434.into(), &super::use_counter_css_doc::css_webkit_text_stroke_width);
        map.insert(1435.into(), &super::use_counter_css_doc::css_webkit_transform);
        map.insert(1436.into(), &super::use_counter_css_doc::css_webkit_transform_origin);
        map.insert(1437.into(), &super::use_counter_css_doc::css_webkit_transform_style);
        map.insert(1438.into(), &super::use_counter_css_doc::css_webkit_transition);
        map.insert(1439.into(), &super::use_counter_css_doc::css_webkit_transition_delay);
        map.insert(1440.into(), &super::use_counter_css_doc::css_webkit_transition_duration);
        map.insert(1441.into(), &super::use_counter_css_doc::css_webkit_transition_property);
        map.insert(1442.into(), &super::use_counter_css_doc::css_webkit_transition_timing_function);
        map.insert(1443.into(), &super::use_counter_css_doc::css_webkit_user_select);
        map.insert(1444.into(), &super::use_counter_css_doc::css_white_space);
        map.insert(1445.into(), &super::use_counter_css_doc::css_white_space_collapse);
        map.insert(1446.into(), &super::use_counter_css_doc::css_width);
        map.insert(1447.into(), &super::use_counter_css_doc::css_will_change);
        map.insert(1448.into(), &super::use_counter_css_doc::css_word_break);
        map.insert(1449.into(), &super::use_counter_css_doc::css_word_spacing);
        map.insert(1450.into(), &super::use_counter_css_doc::css_word_wrap);
        map.insert(1451.into(), &super::use_counter_css_doc::css_writing_mode);
        map.insert(1452.into(), &super::use_counter_css_doc::css_x);
        map.insert(1453.into(), &super::use_counter_css_doc::css_x_lang);
        map.insert(1454.into(), &super::use_counter_css_doc::css_x_span);
        map.insert(1455.into(), &super::use_counter_css_doc::css_x_text_scale);
        map.insert(1456.into(), &super::use_counter_css_doc::css_y);
        map.insert(1457.into(), &super::use_counter_css_doc::css_z_index);
        map.insert(1458.into(), &super::use_counter_css_doc::css_zoom);
        map.insert(1459.into(), &super::use_counter_css_doc::max_zoom);
        map.insert(1460.into(), &super::use_counter_css_doc::min_zoom);
        map.insert(1461.into(), &super::use_counter_css_doc::orientation);
        map.insert(1462.into(), &super::use_counter_css_doc::orphans);
        map.insert(1463.into(), &super::use_counter_css_doc::speak);
        map.insert(1464.into(), &super::use_counter_css_doc::text_size_adjust);
        map.insert(1465.into(), &super::use_counter_css_doc::user_zoom);
        map.insert(1466.into(), &super::use_counter_css_doc::webkit_app_region);
        map.insert(1467.into(), &super::use_counter_css_doc::webkit_border_after);
        map.insert(1468.into(), &super::use_counter_css_doc::webkit_border_after_color);
        map.insert(1469.into(), &super::use_counter_css_doc::webkit_border_after_style);
        map.insert(1470.into(), &super::use_counter_css_doc::webkit_border_after_width);
        map.insert(1471.into(), &super::use_counter_css_doc::webkit_border_before);
        map.insert(1472.into(), &super::use_counter_css_doc::webkit_border_before_color);
        map.insert(1473.into(), &super::use_counter_css_doc::webkit_border_before_style);
        map.insert(1474.into(), &super::use_counter_css_doc::webkit_border_before_width);
        map.insert(1475.into(), &super::use_counter_css_doc::webkit_border_end);
        map.insert(1476.into(), &super::use_counter_css_doc::webkit_border_end_color);
        map.insert(1477.into(), &super::use_counter_css_doc::webkit_border_end_style);
        map.insert(1478.into(), &super::use_counter_css_doc::webkit_border_end_width);
        map.insert(1479.into(), &super::use_counter_css_doc::webkit_border_horizontal_spacing);
        map.insert(1480.into(), &super::use_counter_css_doc::webkit_border_start);
        map.insert(1481.into(), &super::use_counter_css_doc::webkit_border_start_color);
        map.insert(1482.into(), &super::use_counter_css_doc::webkit_border_start_style);
        map.insert(1483.into(), &super::use_counter_css_doc::webkit_border_start_width);
        map.insert(1484.into(), &super::use_counter_css_doc::webkit_border_vertical_spacing);
        map.insert(1485.into(), &super::use_counter_css_doc::webkit_box_decoration_break);
        map.insert(1486.into(), &super::use_counter_css_doc::webkit_box_reflect);
        map.insert(1487.into(), &super::use_counter_css_doc::webkit_column_break_after);
        map.insert(1488.into(), &super::use_counter_css_doc::webkit_column_break_before);
        map.insert(1489.into(), &super::use_counter_css_doc::webkit_column_break_inside);
        map.insert(1490.into(), &super::use_counter_css_doc::webkit_column_count);
        map.insert(1491.into(), &super::use_counter_css_doc::webkit_column_gap);
        map.insert(1492.into(), &super::use_counter_css_doc::webkit_column_rule);
        map.insert(1493.into(), &super::use_counter_css_doc::webkit_column_rule_color);
        map.insert(1494.into(), &super::use_counter_css_doc::webkit_column_rule_style);
        map.insert(1495.into(), &super::use_counter_css_doc::webkit_column_rule_width);
        map.insert(1496.into(), &super::use_counter_css_doc::webkit_column_span);
        map.insert(1497.into(), &super::use_counter_css_doc::webkit_column_width);
        map.insert(1498.into(), &super::use_counter_css_doc::webkit_columns);
        map.insert(1499.into(), &super::use_counter_css_doc::webkit_font_size_delta);
        map.insert(1500.into(), &super::use_counter_css_doc::webkit_highlight);
        map.insert(1501.into(), &super::use_counter_css_doc::webkit_hyphenate_character);
        map.insert(1502.into(), &super::use_counter_css_doc::webkit_line_break);
        map.insert(1503.into(), &super::use_counter_css_doc::webkit_locale);
        map.insert(1504.into(), &super::use_counter_css_doc::webkit_logical_height);
        map.insert(1505.into(), &super::use_counter_css_doc::webkit_logical_width);
        map.insert(1506.into(), &super::use_counter_css_doc::webkit_margin_after);
        map.insert(1507.into(), &super::use_counter_css_doc::webkit_margin_after_collapse);
        map.insert(1508.into(), &super::use_counter_css_doc::webkit_margin_before);
        map.insert(1509.into(), &super::use_counter_css_doc::webkit_margin_before_collapse);
        map.insert(1510.into(), &super::use_counter_css_doc::webkit_margin_bottom_collapse);
        map.insert(1511.into(), &super::use_counter_css_doc::webkit_margin_collapse);
        map.insert(1512.into(), &super::use_counter_css_doc::webkit_margin_end);
        map.insert(1513.into(), &super::use_counter_css_doc::webkit_margin_start);
        map.insert(1514.into(), &super::use_counter_css_doc::webkit_margin_top_collapse);
        map.insert(1515.into(), &super::use_counter_css_doc::webkit_mask_box_image);
        map.insert(1516.into(), &super::use_counter_css_doc::webkit_mask_box_image_outset);
        map.insert(1517.into(), &super::use_counter_css_doc::webkit_mask_box_image_repeat);
        map.insert(1518.into(), &super::use_counter_css_doc::webkit_mask_box_image_slice);
        map.insert(1519.into(), &super::use_counter_css_doc::webkit_mask_box_image_source);
        map.insert(1520.into(), &super::use_counter_css_doc::webkit_mask_box_image_width);
        map.insert(1521.into(), &super::use_counter_css_doc::webkit_mask_repeat_x);
        map.insert(1522.into(), &super::use_counter_css_doc::webkit_mask_repeat_y);
        map.insert(1523.into(), &super::use_counter_css_doc::webkit_max_logical_height);
        map.insert(1524.into(), &super::use_counter_css_doc::webkit_max_logical_width);
        map.insert(1525.into(), &super::use_counter_css_doc::webkit_min_logical_height);
        map.insert(1526.into(), &super::use_counter_css_doc::webkit_min_logical_width);
        map.insert(1527.into(), &super::use_counter_css_doc::webkit_opacity);
        map.insert(1528.into(), &super::use_counter_css_doc::webkit_padding_after);
        map.insert(1529.into(), &super::use_counter_css_doc::webkit_padding_before);
        map.insert(1530.into(), &super::use_counter_css_doc::webkit_padding_end);
        map.insert(1531.into(), &super::use_counter_css_doc::webkit_padding_start);
        map.insert(1532.into(), &super::use_counter_css_doc::webkit_perspective_origin_x);
        map.insert(1533.into(), &super::use_counter_css_doc::webkit_perspective_origin_y);
        map.insert(1534.into(), &super::use_counter_css_doc::webkit_print_color_adjust);
        map.insert(1535.into(), &super::use_counter_css_doc::webkit_rtl_ordering);
        map.insert(1536.into(), &super::use_counter_css_doc::webkit_ruby_position);
        map.insert(1537.into(), &super::use_counter_css_doc::webkit_shape_image_threshold);
        map.insert(1538.into(), &super::use_counter_css_doc::webkit_shape_margin);
        map.insert(1539.into(), &super::use_counter_css_doc::webkit_shape_outside);
        map.insert(1540.into(), &super::use_counter_css_doc::webkit_tap_highlight_color);
        map.insert(1541.into(), &super::use_counter_css_doc::webkit_text_combine);
        map.insert(1542.into(), &super::use_counter_css_doc::webkit_text_decorations_in_effect);
        map.insert(1543.into(), &super::use_counter_css_doc::webkit_text_emphasis);
        map.insert(1544.into(), &super::use_counter_css_doc::webkit_text_emphasis_color);
        map.insert(1545.into(), &super::use_counter_css_doc::webkit_text_emphasis_position);
        map.insert(1546.into(), &super::use_counter_css_doc::webkit_text_emphasis_style);
        map.insert(1547.into(), &super::use_counter_css_doc::webkit_text_orientation);
        map.insert(1548.into(), &super::use_counter_css_doc::webkit_transform_origin_x);
        map.insert(1549.into(), &super::use_counter_css_doc::webkit_transform_origin_y);
        map.insert(1550.into(), &super::use_counter_css_doc::webkit_transform_origin_z);
        map.insert(1551.into(), &super::use_counter_css_doc::webkit_user_drag);
        map.insert(1552.into(), &super::use_counter_css_doc::webkit_user_modify);
        map.insert(1553.into(), &super::use_counter_css_doc::webkit_writing_mode);
        map.insert(1554.into(), &super::use_counter_css_doc::widows);
        map.insert(1555.into(), &super::use_counter_css_page::alignment_baseline);
        map.insert(1556.into(), &super::use_counter_css_page::background_repeat_x);
        map.insert(1557.into(), &super::use_counter_css_page::background_repeat_y);
        map.insert(1558.into(), &super::use_counter_css_page::baseline_shift);
        map.insert(1559.into(), &super::use_counter_css_page::buffered_rendering);
        map.insert(1560.into(), &super::use_counter_css_page::color_rendering);
        map.insert(1561.into(), &super::use_counter_css_page::css_accent_color);
        map.insert(1562.into(), &super::use_counter_css_page::css_align_content);
        map.insert(1563.into(), &super::use_counter_css_page::css_align_items);
        map.insert(1564.into(), &super::use_counter_css_page::css_align_self);
        map.insert(1565.into(), &super::use_counter_css_page::css_all);
        map.insert(1566.into(), &super::use_counter_css_page::css_anchor_name);
        map.insert(1567.into(), &super::use_counter_css_page::css_anchor_scope);
        map.insert(1568.into(), &super::use_counter_css_page::css_animation);
        map.insert(1569.into(), &super::use_counter_css_page::css_animation_composition);
        map.insert(1570.into(), &super::use_counter_css_page::css_animation_delay);
        map.insert(1571.into(), &super::use_counter_css_page::css_animation_direction);
        map.insert(1572.into(), &super::use_counter_css_page::css_animation_duration);
        map.insert(1573.into(), &super::use_counter_css_page::css_animation_fill_mode);
        map.insert(1574.into(), &super::use_counter_css_page::css_animation_iteration_count);
        map.insert(1575.into(), &super::use_counter_css_page::css_animation_name);
        map.insert(1576.into(), &super::use_counter_css_page::css_animation_play_state);
        map.insert(1577.into(), &super::use_counter_css_page::css_animation_timeline);
        map.insert(1578.into(), &super::use_counter_css_page::css_animation_timing_function);
        map.insert(1579.into(), &super::use_counter_css_page::css_appearance);
        map.insert(1580.into(), &super::use_counter_css_page::css_aspect_ratio);
        map.insert(1581.into(), &super::use_counter_css_page::css_backdrop_filter);
        map.insert(1582.into(), &super::use_counter_css_page::css_backface_visibility);
        map.insert(1583.into(), &super::use_counter_css_page::css_background);
        map.insert(1584.into(), &super::use_counter_css_page::css_background_attachment);
        map.insert(1585.into(), &super::use_counter_css_page::css_background_blend_mode);
        map.insert(1586.into(), &super::use_counter_css_page::css_background_clip);
        map.insert(1587.into(), &super::use_counter_css_page::css_background_color);
        map.insert(1588.into(), &super::use_counter_css_page::css_background_image);
        map.insert(1589.into(), &super::use_counter_css_page::css_background_origin);
        map.insert(1590.into(), &super::use_counter_css_page::css_background_position);
        map.insert(1591.into(), &super::use_counter_css_page::css_background_position_x);
        map.insert(1592.into(), &super::use_counter_css_page::css_background_position_y);
        map.insert(1593.into(), &super::use_counter_css_page::css_background_repeat);
        map.insert(1594.into(), &super::use_counter_css_page::css_background_size);
        map.insert(1595.into(), &super::use_counter_css_page::css_baseline_source);
        map.insert(1596.into(), &super::use_counter_css_page::css_block_size);
        map.insert(1597.into(), &super::use_counter_css_page::css_border);
        map.insert(1598.into(), &super::use_counter_css_page::css_border_block);
        map.insert(1599.into(), &super::use_counter_css_page::css_border_block_color);
        map.insert(1600.into(), &super::use_counter_css_page::css_border_block_end);
        map.insert(1601.into(), &super::use_counter_css_page::css_border_block_end_color);
        map.insert(1602.into(), &super::use_counter_css_page::css_border_block_end_style);
        map.insert(1603.into(), &super::use_counter_css_page::css_border_block_end_width);
        map.insert(1604.into(), &super::use_counter_css_page::css_border_block_start);
        map.insert(1605.into(), &super::use_counter_css_page::css_border_block_start_color);
        map.insert(1606.into(), &super::use_counter_css_page::css_border_block_start_style);
        map.insert(1607.into(), &super::use_counter_css_page::css_border_block_start_width);
        map.insert(1608.into(), &super::use_counter_css_page::css_border_block_style);
        map.insert(1609.into(), &super::use_counter_css_page::css_border_block_width);
        map.insert(1610.into(), &super::use_counter_css_page::css_border_bottom);
        map.insert(1611.into(), &super::use_counter_css_page::css_border_bottom_color);
        map.insert(1612.into(), &super::use_counter_css_page::css_border_bottom_left_radius);
        map.insert(1613.into(), &super::use_counter_css_page::css_border_bottom_right_radius);
        map.insert(1614.into(), &super::use_counter_css_page::css_border_bottom_style);
        map.insert(1615.into(), &super::use_counter_css_page::css_border_bottom_width);
        map.insert(1616.into(), &super::use_counter_css_page::css_border_collapse);
        map.insert(1617.into(), &super::use_counter_css_page::css_border_color);
        map.insert(1618.into(), &super::use_counter_css_page::css_border_end_end_radius);
        map.insert(1619.into(), &super::use_counter_css_page::css_border_end_start_radius);
        map.insert(1620.into(), &super::use_counter_css_page::css_border_image);
        map.insert(1621.into(), &super::use_counter_css_page::css_border_image_outset);
        map.insert(1622.into(), &super::use_counter_css_page::css_border_image_repeat);
        map.insert(1623.into(), &super::use_counter_css_page::css_border_image_slice);
        map.insert(1624.into(), &super::use_counter_css_page::css_border_image_source);
        map.insert(1625.into(), &super::use_counter_css_page::css_border_image_width);
        map.insert(1626.into(), &super::use_counter_css_page::css_border_inline);
        map.insert(1627.into(), &super::use_counter_css_page::css_border_inline_color);
        map.insert(1628.into(), &super::use_counter_css_page::css_border_inline_end);
        map.insert(1629.into(), &super::use_counter_css_page::css_border_inline_end_color);
        map.insert(1630.into(), &super::use_counter_css_page::css_border_inline_end_style);
        map.insert(1631.into(), &super::use_counter_css_page::css_border_inline_end_width);
        map.insert(1632.into(), &super::use_counter_css_page::css_border_inline_start);
        map.insert(1633.into(), &super::use_counter_css_page::css_border_inline_start_color);
        map.insert(1634.into(), &super::use_counter_css_page::css_border_inline_start_style);
        map.insert(1635.into(), &super::use_counter_css_page::css_border_inline_start_width);
        map.insert(1636.into(), &super::use_counter_css_page::css_border_inline_style);
        map.insert(1637.into(), &super::use_counter_css_page::css_border_inline_width);
        map.insert(1638.into(), &super::use_counter_css_page::css_border_left);
        map.insert(1639.into(), &super::use_counter_css_page::css_border_left_color);
        map.insert(1640.into(), &super::use_counter_css_page::css_border_left_style);
        map.insert(1641.into(), &super::use_counter_css_page::css_border_left_width);
        map.insert(1642.into(), &super::use_counter_css_page::css_border_radius);
        map.insert(1643.into(), &super::use_counter_css_page::css_border_right);
        map.insert(1644.into(), &super::use_counter_css_page::css_border_right_color);
        map.insert(1645.into(), &super::use_counter_css_page::css_border_right_style);
        map.insert(1646.into(), &super::use_counter_css_page::css_border_right_width);
        map.insert(1647.into(), &super::use_counter_css_page::css_border_spacing);
        map.insert(1648.into(), &super::use_counter_css_page::css_border_start_end_radius);
        map.insert(1649.into(), &super::use_counter_css_page::css_border_start_start_radius);
        map.insert(1650.into(), &super::use_counter_css_page::css_border_style);
        map.insert(1651.into(), &super::use_counter_css_page::css_border_top);
        map.insert(1652.into(), &super::use_counter_css_page::css_border_top_color);
        map.insert(1653.into(), &super::use_counter_css_page::css_border_top_left_radius);
        map.insert(1654.into(), &super::use_counter_css_page::css_border_top_right_radius);
        map.insert(1655.into(), &super::use_counter_css_page::css_border_top_style);
        map.insert(1656.into(), &super::use_counter_css_page::css_border_top_width);
        map.insert(1657.into(), &super::use_counter_css_page::css_border_width);
        map.insert(1658.into(), &super::use_counter_css_page::css_bottom);
        map.insert(1659.into(), &super::use_counter_css_page::css_box_decoration_break);
        map.insert(1660.into(), &super::use_counter_css_page::css_box_shadow);
        map.insert(1661.into(), &super::use_counter_css_page::css_box_sizing);
        map.insert(1662.into(), &super::use_counter_css_page::css_break_after);
        map.insert(1663.into(), &super::use_counter_css_page::css_break_before);
        map.insert(1664.into(), &super::use_counter_css_page::css_break_inside);
        map.insert(1665.into(), &super::use_counter_css_page::css_caption_side);
        map.insert(1666.into(), &super::use_counter_css_page::css_caret_color);
        map.insert(1667.into(), &super::use_counter_css_page::css_clear);
        map.insert(1668.into(), &super::use_counter_css_page::css_clip);
        map.insert(1669.into(), &super::use_counter_css_page::css_clip_path);
        map.insert(1670.into(), &super::use_counter_css_page::css_clip_rule);
        map.insert(1671.into(), &super::use_counter_css_page::css_color);
        map.insert(1672.into(), &super::use_counter_css_page::css_color_adjust);
        map.insert(1673.into(), &super::use_counter_css_page::css_color_interpolation);
        map.insert(1674.into(), &super::use_counter_css_page::css_color_interpolation_filters);
        map.insert(1675.into(), &super::use_counter_css_page::css_color_scheme);
        map.insert(1676.into(), &super::use_counter_css_page::css_column_count);
        map.insert(1677.into(), &super::use_counter_css_page::css_column_fill);
        map.insert(1678.into(), &super::use_counter_css_page::css_column_gap);
        map.insert(1679.into(), &super::use_counter_css_page::css_column_rule);
        map.insert(1680.into(), &super::use_counter_css_page::css_column_rule_color);
        map.insert(1681.into(), &super::use_counter_css_page::css_column_rule_style);
        map.insert(1682.into(), &super::use_counter_css_page::css_column_rule_width);
        map.insert(1683.into(), &super::use_counter_css_page::css_column_span);
        map.insert(1684.into(), &super::use_counter_css_page::css_column_width);
        map.insert(1685.into(), &super::use_counter_css_page::css_columns);
        map.insert(1686.into(), &super::use_counter_css_page::css_contain);
        map.insert(1687.into(), &super::use_counter_css_page::css_contain_intrinsic_block_size);
        map.insert(1688.into(), &super::use_counter_css_page::css_contain_intrinsic_height);
        map.insert(1689.into(), &super::use_counter_css_page::css_contain_intrinsic_inline_size);
        map.insert(1690.into(), &super::use_counter_css_page::css_contain_intrinsic_size);
        map.insert(1691.into(), &super::use_counter_css_page::css_contain_intrinsic_width);
        map.insert(1692.into(), &super::use_counter_css_page::css_container);
        map.insert(1693.into(), &super::use_counter_css_page::css_container_name);
        map.insert(1694.into(), &super::use_counter_css_page::css_container_type);
        map.insert(1695.into(), &super::use_counter_css_page::css_content);
        map.insert(1696.into(), &super::use_counter_css_page::css_content_visibility);
        map.insert(1697.into(), &super::use_counter_css_page::css_counter_increment);
        map.insert(1698.into(), &super::use_counter_css_page::css_counter_reset);
        map.insert(1699.into(), &super::use_counter_css_page::css_counter_set);
        map.insert(1700.into(), &super::use_counter_css_page::css_cursor);
        map.insert(1701.into(), &super::use_counter_css_page::css_cx);
        map.insert(1702.into(), &super::use_counter_css_page::css_cy);
        map.insert(1703.into(), &super::use_counter_css_page::css_d);
        map.insert(1704.into(), &super::use_counter_css_page::css_direction);
        map.insert(1705.into(), &super::use_counter_css_page::css_display);
        map.insert(1706.into(), &super::use_counter_css_page::css_dominant_baseline);
        map.insert(1707.into(), &super::use_counter_css_page::css_empty_cells);
        map.insert(1708.into(), &super::use_counter_css_page::css_field_sizing);
        map.insert(1709.into(), &super::use_counter_css_page::css_fill);
        map.insert(1710.into(), &super::use_counter_css_page::css_fill_opacity);
        map.insert(1711.into(), &super::use_counter_css_page::css_fill_rule);
        map.insert(1712.into(), &super::use_counter_css_page::css_filter);
        map.insert(1713.into(), &super::use_counter_css_page::css_flex);
        map.insert(1714.into(), &super::use_counter_css_page::css_flex_basis);
        map.insert(1715.into(), &super::use_counter_css_page::css_flex_direction);
        map.insert(1716.into(), &super::use_counter_css_page::css_flex_flow);
        map.insert(1717.into(), &super::use_counter_css_page::css_flex_grow);
        map.insert(1718.into(), &super::use_counter_css_page::css_flex_shrink);
        map.insert(1719.into(), &super::use_counter_css_page::css_flex_wrap);
        map.insert(1720.into(), &super::use_counter_css_page::css_float);
        map.insert(1721.into(), &super::use_counter_css_page::css_flood_color);
        map.insert(1722.into(), &super::use_counter_css_page::css_flood_opacity);
        map.insert(1723.into(), &super::use_counter_css_page::css_font);
        map.insert(1724.into(), &super::use_counter_css_page::css_font_family);
        map.insert(1725.into(), &super::use_counter_css_page::css_font_feature_settings);
        map.insert(1726.into(), &super::use_counter_css_page::css_font_kerning);
        map.insert(1727.into(), &super::use_counter_css_page::css_font_language_override);
        map.insert(1728.into(), &super::use_counter_css_page::css_font_optical_sizing);
        map.insert(1729.into(), &super::use_counter_css_page::css_font_palette);
        map.insert(1730.into(), &super::use_counter_css_page::css_font_size);
        map.insert(1731.into(), &super::use_counter_css_page::css_font_size_adjust);
        map.insert(1732.into(), &super::use_counter_css_page::css_font_stretch);
        map.insert(1733.into(), &super::use_counter_css_page::css_font_style);
        map.insert(1734.into(), &super::use_counter_css_page::css_font_synthesis);
        map.insert(1735.into(), &super::use_counter_css_page::css_font_synthesis_position);
        map.insert(1736.into(), &super::use_counter_css_page::css_font_synthesis_small_caps);
        map.insert(1737.into(), &super::use_counter_css_page::css_font_synthesis_style);
        map.insert(1738.into(), &super::use_counter_css_page::css_font_synthesis_weight);
        map.insert(1739.into(), &super::use_counter_css_page::css_font_variant);
        map.insert(1740.into(), &super::use_counter_css_page::css_font_variant_alternates);
        map.insert(1741.into(), &super::use_counter_css_page::css_font_variant_caps);
        map.insert(1742.into(), &super::use_counter_css_page::css_font_variant_east_asian);
        map.insert(1743.into(), &super::use_counter_css_page::css_font_variant_emoji);
        map.insert(1744.into(), &super::use_counter_css_page::css_font_variant_ligatures);
        map.insert(1745.into(), &super::use_counter_css_page::css_font_variant_numeric);
        map.insert(1746.into(), &super::use_counter_css_page::css_font_variant_position);
        map.insert(1747.into(), &super::use_counter_css_page::css_font_variation_settings);
        map.insert(1748.into(), &super::use_counter_css_page::css_font_weight);
        map.insert(1749.into(), &super::use_counter_css_page::css_forced_color_adjust);
        map.insert(1750.into(), &super::use_counter_css_page::css_gap);
        map.insert(1751.into(), &super::use_counter_css_page::css_grid);
        map.insert(1752.into(), &super::use_counter_css_page::css_grid_area);
        map.insert(1753.into(), &super::use_counter_css_page::css_grid_auto_columns);
        map.insert(1754.into(), &super::use_counter_css_page::css_grid_auto_flow);
        map.insert(1755.into(), &super::use_counter_css_page::css_grid_auto_rows);
        map.insert(1756.into(), &super::use_counter_css_page::css_grid_column);
        map.insert(1757.into(), &super::use_counter_css_page::css_grid_column_end);
        map.insert(1758.into(), &super::use_counter_css_page::css_grid_column_gap);
        map.insert(1759.into(), &super::use_counter_css_page::css_grid_column_start);
        map.insert(1760.into(), &super::use_counter_css_page::css_grid_gap);
        map.insert(1761.into(), &super::use_counter_css_page::css_grid_row);
        map.insert(1762.into(), &super::use_counter_css_page::css_grid_row_end);
        map.insert(1763.into(), &super::use_counter_css_page::css_grid_row_gap);
        map.insert(1764.into(), &super::use_counter_css_page::css_grid_row_start);
        map.insert(1765.into(), &super::use_counter_css_page::css_grid_template);
        map.insert(1766.into(), &super::use_counter_css_page::css_grid_template_areas);
        map.insert(1767.into(), &super::use_counter_css_page::css_grid_template_columns);
        map.insert(1768.into(), &super::use_counter_css_page::css_grid_template_rows);
        map.insert(1769.into(), &super::use_counter_css_page::css_height);
        map.insert(1770.into(), &super::use_counter_css_page::css_hyphenate_character);
        map.insert(1771.into(), &super::use_counter_css_page::css_hyphens);
        map.insert(1772.into(), &super::use_counter_css_page::css_image_orientation);
        map.insert(1773.into(), &super::use_counter_css_page::css_image_rendering);
        map.insert(1774.into(), &super::use_counter_css_page::css_ime_mode);
        map.insert(1775.into(), &super::use_counter_css_page::css_initial_letter);
        map.insert(1776.into(), &super::use_counter_css_page::css_inline_size);
        map.insert(1777.into(), &super::use_counter_css_page::css_inset);
        map.insert(1778.into(), &super::use_counter_css_page::css_inset_block);
        map.insert(1779.into(), &super::use_counter_css_page::css_inset_block_end);
        map.insert(1780.into(), &super::use_counter_css_page::css_inset_block_start);
        map.insert(1781.into(), &super::use_counter_css_page::css_inset_inline);
        map.insert(1782.into(), &super::use_counter_css_page::css_inset_inline_end);
        map.insert(1783.into(), &super::use_counter_css_page::css_inset_inline_start);
        map.insert(1784.into(), &super::use_counter_css_page::css_isolation);
        map.insert(1785.into(), &super::use_counter_css_page::css_justify_content);
        map.insert(1786.into(), &super::use_counter_css_page::css_justify_items);
        map.insert(1787.into(), &super::use_counter_css_page::css_justify_self);
        map.insert(1788.into(), &super::use_counter_css_page::css_left);
        map.insert(1789.into(), &super::use_counter_css_page::css_letter_spacing);
        map.insert(1790.into(), &super::use_counter_css_page::css_lighting_color);
        map.insert(1791.into(), &super::use_counter_css_page::css_line_break);
        map.insert(1792.into(), &super::use_counter_css_page::css_line_height);
        map.insert(1793.into(), &super::use_counter_css_page::css_list_style);
        map.insert(1794.into(), &super::use_counter_css_page::css_list_style_image);
        map.insert(1795.into(), &super::use_counter_css_page::css_list_style_position);
        map.insert(1796.into(), &super::use_counter_css_page::css_list_style_type);
        map.insert(1797.into(), &super::use_counter_css_page::css_margin);
        map.insert(1798.into(), &super::use_counter_css_page::css_margin_block);
        map.insert(1799.into(), &super::use_counter_css_page::css_margin_block_end);
        map.insert(1800.into(), &super::use_counter_css_page::css_margin_block_start);
        map.insert(1801.into(), &super::use_counter_css_page::css_margin_bottom);
        map.insert(1802.into(), &super::use_counter_css_page::css_margin_inline);
        map.insert(1803.into(), &super::use_counter_css_page::css_margin_inline_end);
        map.insert(1804.into(), &super::use_counter_css_page::css_margin_inline_start);
        map.insert(1805.into(), &super::use_counter_css_page::css_margin_left);
        map.insert(1806.into(), &super::use_counter_css_page::css_margin_right);
        map.insert(1807.into(), &super::use_counter_css_page::css_margin_top);
        map.insert(1808.into(), &super::use_counter_css_page::css_marker);
        map.insert(1809.into(), &super::use_counter_css_page::css_marker_end);
        map.insert(1810.into(), &super::use_counter_css_page::css_marker_mid);
        map.insert(1811.into(), &super::use_counter_css_page::css_marker_start);
        map.insert(1812.into(), &super::use_counter_css_page::css_mask);
        map.insert(1813.into(), &super::use_counter_css_page::css_mask_clip);
        map.insert(1814.into(), &super::use_counter_css_page::css_mask_composite);
        map.insert(1815.into(), &super::use_counter_css_page::css_mask_image);
        map.insert(1816.into(), &super::use_counter_css_page::css_mask_mode);
        map.insert(1817.into(), &super::use_counter_css_page::css_mask_origin);
        map.insert(1818.into(), &super::use_counter_css_page::css_mask_position);
        map.insert(1819.into(), &super::use_counter_css_page::css_mask_position_x);
        map.insert(1820.into(), &super::use_counter_css_page::css_mask_position_y);
        map.insert(1821.into(), &super::use_counter_css_page::css_mask_repeat);
        map.insert(1822.into(), &super::use_counter_css_page::css_mask_size);
        map.insert(1823.into(), &super::use_counter_css_page::css_mask_type);
        map.insert(1824.into(), &super::use_counter_css_page::css_masonry_auto_flow);
        map.insert(1825.into(), &super::use_counter_css_page::css_math_depth);
        map.insert(1826.into(), &super::use_counter_css_page::css_math_style);
        map.insert(1827.into(), &super::use_counter_css_page::css_max_block_size);
        map.insert(1828.into(), &super::use_counter_css_page::css_max_height);
        map.insert(1829.into(), &super::use_counter_css_page::css_max_inline_size);
        map.insert(1830.into(), &super::use_counter_css_page::css_max_width);
        map.insert(1831.into(), &super::use_counter_css_page::css_min_block_size);
        map.insert(1832.into(), &super::use_counter_css_page::css_min_height);
        map.insert(1833.into(), &super::use_counter_css_page::css_min_inline_size);
        map.insert(1834.into(), &super::use_counter_css_page::css_min_width);
        map.insert(1835.into(), &super::use_counter_css_page::css_mix_blend_mode);
        map.insert(1836.into(), &super::use_counter_css_page::css_moz_animation);
        map.insert(1837.into(), &super::use_counter_css_page::css_moz_animation_delay);
        map.insert(1838.into(), &super::use_counter_css_page::css_moz_animation_direction);
        map.insert(1839.into(), &super::use_counter_css_page::css_moz_animation_duration);
        map.insert(1840.into(), &super::use_counter_css_page::css_moz_animation_fill_mode);
        map.insert(1841.into(), &super::use_counter_css_page::css_moz_animation_iteration_count);
        map.insert(1842.into(), &super::use_counter_css_page::css_moz_animation_name);
        map.insert(1843.into(), &super::use_counter_css_page::css_moz_animation_play_state);
        map.insert(1844.into(), &super::use_counter_css_page::css_moz_animation_timing_function);
        map.insert(1845.into(), &super::use_counter_css_page::css_moz_appearance);
        map.insert(1846.into(), &super::use_counter_css_page::css_moz_backface_visibility);
        map.insert(1847.into(), &super::use_counter_css_page::css_moz_border_end);
        map.insert(1848.into(), &super::use_counter_css_page::css_moz_border_end_color);
        map.insert(1849.into(), &super::use_counter_css_page::css_moz_border_end_style);
        map.insert(1850.into(), &super::use_counter_css_page::css_moz_border_end_width);
        map.insert(1851.into(), &super::use_counter_css_page::css_moz_border_image);
        map.insert(1852.into(), &super::use_counter_css_page::css_moz_border_start);
        map.insert(1853.into(), &super::use_counter_css_page::css_moz_border_start_color);
        map.insert(1854.into(), &super::use_counter_css_page::css_moz_border_start_style);
        map.insert(1855.into(), &super::use_counter_css_page::css_moz_border_start_width);
        map.insert(1856.into(), &super::use_counter_css_page::css_moz_box_align);
        map.insert(1857.into(), &super::use_counter_css_page::css_moz_box_collapse);
        map.insert(1858.into(), &super::use_counter_css_page::css_moz_box_direction);
        map.insert(1859.into(), &super::use_counter_css_page::css_moz_box_flex);
        map.insert(1860.into(), &super::use_counter_css_page::css_moz_box_ordinal_group);
        map.insert(1861.into(), &super::use_counter_css_page::css_moz_box_orient);
        map.insert(1862.into(), &super::use_counter_css_page::css_moz_box_pack);
        map.insert(1863.into(), &super::use_counter_css_page::css_moz_box_sizing);
        map.insert(1864.into(), &super::use_counter_css_page::css_moz_context_properties);
        map.insert(1865.into(), &super::use_counter_css_page::css_moz_control_character_visibility);
        map.insert(1866.into(), &super::use_counter_css_page::css_moz_default_appearance);
        map.insert(1867.into(), &super::use_counter_css_page::css_moz_float_edge);
        map.insert(1868.into(), &super::use_counter_css_page::css_moz_font_feature_settings);
        map.insert(1869.into(), &super::use_counter_css_page::css_moz_font_language_override);
        map.insert(1870.into(), &super::use_counter_css_page::css_moz_force_broken_image_icon);
        map.insert(1871.into(), &super::use_counter_css_page::css_moz_hyphens);
        map.insert(1872.into(), &super::use_counter_css_page::css_moz_inert);
        map.insert(1873.into(), &super::use_counter_css_page::css_moz_margin_end);
        map.insert(1874.into(), &super::use_counter_css_page::css_moz_margin_start);
        map.insert(1875.into(), &super::use_counter_css_page::css_moz_math_variant);
        map.insert(1876.into(), &super::use_counter_css_page::css_moz_min_font_size_ratio);
        map.insert(1877.into(), &super::use_counter_css_page::css_moz_orient);
        map.insert(1878.into(), &super::use_counter_css_page::css_moz_osx_font_smoothing);
        map.insert(1879.into(), &super::use_counter_css_page::css_moz_padding_end);
        map.insert(1880.into(), &super::use_counter_css_page::css_moz_padding_start);
        map.insert(1881.into(), &super::use_counter_css_page::css_moz_perspective);
        map.insert(1882.into(), &super::use_counter_css_page::css_moz_perspective_origin);
        map.insert(1883.into(), &super::use_counter_css_page::css_moz_subtree_hidden_only_visually);
        map.insert(1884.into(), &super::use_counter_css_page::css_moz_tab_size);
        map.insert(1885.into(), &super::use_counter_css_page::css_moz_text_size_adjust);
        map.insert(1886.into(), &super::use_counter_css_page::css_moz_theme);
        map.insert(1887.into(), &super::use_counter_css_page::css_moz_top_layer);
        map.insert(1888.into(), &super::use_counter_css_page::css_moz_transform);
        map.insert(1889.into(), &super::use_counter_css_page::css_moz_transform_origin);
        map.insert(1890.into(), &super::use_counter_css_page::css_moz_transform_style);
        map.insert(1891.into(), &super::use_counter_css_page::css_moz_transition);
        map.insert(1892.into(), &super::use_counter_css_page::css_moz_transition_delay);
        map.insert(1893.into(), &super::use_counter_css_page::css_moz_transition_duration);
        map.insert(1894.into(), &super::use_counter_css_page::css_moz_transition_property);
        map.insert(1895.into(), &super::use_counter_css_page::css_moz_transition_timing_function);
        map.insert(1896.into(), &super::use_counter_css_page::css_moz_user_focus);
        map.insert(1897.into(), &super::use_counter_css_page::css_moz_user_input);
        map.insert(1898.into(), &super::use_counter_css_page::css_moz_user_modify);
        map.insert(1899.into(), &super::use_counter_css_page::css_moz_user_select);
        map.insert(1900.into(), &super::use_counter_css_page::css_moz_window_dragging);
        map.insert(1901.into(), &super::use_counter_css_page::css_moz_window_input_region_margin);
        map.insert(1902.into(), &super::use_counter_css_page::css_moz_window_opacity);
        map.insert(1903.into(), &super::use_counter_css_page::css_moz_window_shadow);
        map.insert(1904.into(), &super::use_counter_css_page::css_moz_window_transform);
        map.insert(1905.into(), &super::use_counter_css_page::css_moz_window_transform_origin);
        map.insert(1906.into(), &super::use_counter_css_page::css_object_fit);
        map.insert(1907.into(), &super::use_counter_css_page::css_object_position);
        map.insert(1908.into(), &super::use_counter_css_page::css_offset);
        map.insert(1909.into(), &super::use_counter_css_page::css_offset_anchor);
        map.insert(1910.into(), &super::use_counter_css_page::css_offset_distance);
        map.insert(1911.into(), &super::use_counter_css_page::css_offset_path);
        map.insert(1912.into(), &super::use_counter_css_page::css_offset_position);
        map.insert(1913.into(), &super::use_counter_css_page::css_offset_rotate);
        map.insert(1914.into(), &super::use_counter_css_page::css_opacity);
        map.insert(1915.into(), &super::use_counter_css_page::css_order);
        map.insert(1916.into(), &super::use_counter_css_page::css_outline);
        map.insert(1917.into(), &super::use_counter_css_page::css_outline_color);
        map.insert(1918.into(), &super::use_counter_css_page::css_outline_offset);
        map.insert(1919.into(), &super::use_counter_css_page::css_outline_style);
        map.insert(1920.into(), &super::use_counter_css_page::css_outline_width);
        map.insert(1921.into(), &super::use_counter_css_page::css_overflow);
        map.insert(1922.into(), &super::use_counter_css_page::css_overflow_anchor);
        map.insert(1923.into(), &super::use_counter_css_page::css_overflow_block);
        map.insert(1924.into(), &super::use_counter_css_page::css_overflow_clip_box);
        map.insert(1925.into(), &super::use_counter_css_page::css_overflow_clip_box_block);
        map.insert(1926.into(), &super::use_counter_css_page::css_overflow_clip_box_inline);
        map.insert(1927.into(), &super::use_counter_css_page::css_overflow_clip_margin);
        map.insert(1928.into(), &super::use_counter_css_page::css_overflow_inline);
        map.insert(1929.into(), &super::use_counter_css_page::css_overflow_wrap);
        map.insert(1930.into(), &super::use_counter_css_page::css_overflow_x);
        map.insert(1931.into(), &super::use_counter_css_page::css_overflow_y);
        map.insert(1932.into(), &super::use_counter_css_page::css_overscroll_behavior);
        map.insert(1933.into(), &super::use_counter_css_page::css_overscroll_behavior_block);
        map.insert(1934.into(), &super::use_counter_css_page::css_overscroll_behavior_inline);
        map.insert(1935.into(), &super::use_counter_css_page::css_overscroll_behavior_x);
        map.insert(1936.into(), &super::use_counter_css_page::css_overscroll_behavior_y);
        map.insert(1937.into(), &super::use_counter_css_page::css_padding);
        map.insert(1938.into(), &super::use_counter_css_page::css_padding_block);
        map.insert(1939.into(), &super::use_counter_css_page::css_padding_block_end);
        map.insert(1940.into(), &super::use_counter_css_page::css_padding_block_start);
        map.insert(1941.into(), &super::use_counter_css_page::css_padding_bottom);
        map.insert(1942.into(), &super::use_counter_css_page::css_padding_inline);
        map.insert(1943.into(), &super::use_counter_css_page::css_padding_inline_end);
        map.insert(1944.into(), &super::use_counter_css_page::css_padding_inline_start);
        map.insert(1945.into(), &super::use_counter_css_page::css_padding_left);
        map.insert(1946.into(), &super::use_counter_css_page::css_padding_right);
        map.insert(1947.into(), &super::use_counter_css_page::css_padding_top);
        map.insert(1948.into(), &super::use_counter_css_page::css_page);
        map.insert(1949.into(), &super::use_counter_css_page::css_page_break_after);
        map.insert(1950.into(), &super::use_counter_css_page::css_page_break_before);
        map.insert(1951.into(), &super::use_counter_css_page::css_page_break_inside);
        map.insert(1952.into(), &super::use_counter_css_page::css_page_orientation);
        map.insert(1953.into(), &super::use_counter_css_page::css_paint_order);
        map.insert(1954.into(), &super::use_counter_css_page::css_perspective);
        map.insert(1955.into(), &super::use_counter_css_page::css_perspective_origin);
        map.insert(1956.into(), &super::use_counter_css_page::css_place_content);
        map.insert(1957.into(), &super::use_counter_css_page::css_place_items);
        map.insert(1958.into(), &super::use_counter_css_page::css_place_self);
        map.insert(1959.into(), &super::use_counter_css_page::css_pointer_events);
        map.insert(1960.into(), &super::use_counter_css_page::css_position);
        map.insert(1961.into(), &super::use_counter_css_page::css_position_anchor);
        map.insert(1962.into(), &super::use_counter_css_page::css_position_area);
        map.insert(1963.into(), &super::use_counter_css_page::css_position_try);
        map.insert(1964.into(), &super::use_counter_css_page::css_position_try_fallbacks);
        map.insert(1965.into(), &super::use_counter_css_page::css_position_try_order);
        map.insert(1966.into(), &super::use_counter_css_page::css_position_visibility);
        map.insert(1967.into(), &super::use_counter_css_page::css_print_color_adjust);
        map.insert(1968.into(), &super::use_counter_css_page::css_quotes);
        map.insert(1969.into(), &super::use_counter_css_page::css_r);
        map.insert(1970.into(), &super::use_counter_css_page::css_resize);
        map.insert(1971.into(), &super::use_counter_css_page::css_right);
        map.insert(1972.into(), &super::use_counter_css_page::css_rotate);
        map.insert(1973.into(), &super::use_counter_css_page::css_row_gap);
        map.insert(1974.into(), &super::use_counter_css_page::css_ruby_align);
        map.insert(1975.into(), &super::use_counter_css_page::css_ruby_position);
        map.insert(1976.into(), &super::use_counter_css_page::css_rx);
        map.insert(1977.into(), &super::use_counter_css_page::css_ry);
        map.insert(1978.into(), &super::use_counter_css_page::css_scale);
        map.insert(1979.into(), &super::use_counter_css_page::css_scroll_behavior);
        map.insert(1980.into(), &super::use_counter_css_page::css_scroll_margin);
        map.insert(1981.into(), &super::use_counter_css_page::css_scroll_margin_block);
        map.insert(1982.into(), &super::use_counter_css_page::css_scroll_margin_block_end);
        map.insert(1983.into(), &super::use_counter_css_page::css_scroll_margin_block_start);
        map.insert(1984.into(), &super::use_counter_css_page::css_scroll_margin_bottom);
        map.insert(1985.into(), &super::use_counter_css_page::css_scroll_margin_inline);
        map.insert(1986.into(), &super::use_counter_css_page::css_scroll_margin_inline_end);
        map.insert(1987.into(), &super::use_counter_css_page::css_scroll_margin_inline_start);
        map.insert(1988.into(), &super::use_counter_css_page::css_scroll_margin_left);
        map.insert(1989.into(), &super::use_counter_css_page::css_scroll_margin_right);
        map.insert(1990.into(), &super::use_counter_css_page::css_scroll_margin_top);
        map.insert(1991.into(), &super::use_counter_css_page::css_scroll_padding);
        map.insert(1992.into(), &super::use_counter_css_page::css_scroll_padding_block);
        map.insert(1993.into(), &super::use_counter_css_page::css_scroll_padding_block_end);
        map.insert(1994.into(), &super::use_counter_css_page::css_scroll_padding_block_start);
        map.insert(1995.into(), &super::use_counter_css_page::css_scroll_padding_bottom);
        map.insert(1996.into(), &super::use_counter_css_page::css_scroll_padding_inline);
        map.insert(1997.into(), &super::use_counter_css_page::css_scroll_padding_inline_end);
        map.insert(1998.into(), &super::use_counter_css_page::css_scroll_padding_inline_start);
        map.insert(1999.into(), &super::use_counter_css_page::css_scroll_padding_left);
        map.insert(2000.into(), &super::use_counter_css_page::css_scroll_padding_right);
        map.insert(2001.into(), &super::use_counter_css_page::css_scroll_padding_top);
        map.insert(2002.into(), &super::use_counter_css_page::css_scroll_snap_align);
        map.insert(2003.into(), &super::use_counter_css_page::css_scroll_snap_stop);
        map.insert(2004.into(), &super::use_counter_css_page::css_scroll_snap_type);
        map.insert(2005.into(), &super::use_counter_css_page::css_scroll_timeline);
        map.insert(2006.into(), &super::use_counter_css_page::css_scroll_timeline_axis);
        map.insert(2007.into(), &super::use_counter_css_page::css_scroll_timeline_name);
        map.insert(2008.into(), &super::use_counter_css_page::css_scrollbar_color);
        map.insert(2009.into(), &super::use_counter_css_page::css_scrollbar_gutter);
        map.insert(2010.into(), &super::use_counter_css_page::css_scrollbar_width);
        map.insert(2011.into(), &super::use_counter_css_page::css_shape_image_threshold);
        map.insert(2012.into(), &super::use_counter_css_page::css_shape_margin);
        map.insert(2013.into(), &super::use_counter_css_page::css_shape_outside);
        map.insert(2014.into(), &super::use_counter_css_page::css_shape_rendering);
        map.insert(2015.into(), &super::use_counter_css_page::css_size);
        map.insert(2016.into(), &super::use_counter_css_page::css_stop_color);
        map.insert(2017.into(), &super::use_counter_css_page::css_stop_opacity);
        map.insert(2018.into(), &super::use_counter_css_page::css_stroke);
        map.insert(2019.into(), &super::use_counter_css_page::css_stroke_dasharray);
        map.insert(2020.into(), &super::use_counter_css_page::css_stroke_dashoffset);
        map.insert(2021.into(), &super::use_counter_css_page::css_stroke_linecap);
        map.insert(2022.into(), &super::use_counter_css_page::css_stroke_linejoin);
        map.insert(2023.into(), &super::use_counter_css_page::css_stroke_miterlimit);
        map.insert(2024.into(), &super::use_counter_css_page::css_stroke_opacity);
        map.insert(2025.into(), &super::use_counter_css_page::css_stroke_width);
        map.insert(2026.into(), &super::use_counter_css_page::css_tab_size);
        map.insert(2027.into(), &super::use_counter_css_page::css_table_layout);
        map.insert(2028.into(), &super::use_counter_css_page::css_text_align);
        map.insert(2029.into(), &super::use_counter_css_page::css_text_align_last);
        map.insert(2030.into(), &super::use_counter_css_page::css_text_anchor);
        map.insert(2031.into(), &super::use_counter_css_page::css_text_combine_upright);
        map.insert(2032.into(), &super::use_counter_css_page::css_text_decoration);
        map.insert(2033.into(), &super::use_counter_css_page::css_text_decoration_color);
        map.insert(2034.into(), &super::use_counter_css_page::css_text_decoration_line);
        map.insert(2035.into(), &super::use_counter_css_page::css_text_decoration_skip_ink);
        map.insert(2036.into(), &super::use_counter_css_page::css_text_decoration_style);
        map.insert(2037.into(), &super::use_counter_css_page::css_text_decoration_thickness);
        map.insert(2038.into(), &super::use_counter_css_page::css_text_emphasis);
        map.insert(2039.into(), &super::use_counter_css_page::css_text_emphasis_color);
        map.insert(2040.into(), &super::use_counter_css_page::css_text_emphasis_position);
        map.insert(2041.into(), &super::use_counter_css_page::css_text_emphasis_style);
        map.insert(2042.into(), &super::use_counter_css_page::css_text_indent);
        map.insert(2043.into(), &super::use_counter_css_page::css_text_justify);
        map.insert(2044.into(), &super::use_counter_css_page::css_text_orientation);
        map.insert(2045.into(), &super::use_counter_css_page::css_text_overflow);
        map.insert(2046.into(), &super::use_counter_css_page::css_text_rendering);
        map.insert(2047.into(), &super::use_counter_css_page::css_text_shadow);
        map.insert(2048.into(), &super::use_counter_css_page::css_text_transform);
        map.insert(2049.into(), &super::use_counter_css_page::css_text_underline_offset);
        map.insert(2050.into(), &super::use_counter_css_page::css_text_underline_position);
        map.insert(2051.into(), &super::use_counter_css_page::css_text_wrap);
        map.insert(2052.into(), &super::use_counter_css_page::css_text_wrap_mode);
        map.insert(2053.into(), &super::use_counter_css_page::css_text_wrap_style);
        map.insert(2054.into(), &super::use_counter_css_page::css_top);
        map.insert(2055.into(), &super::use_counter_css_page::css_touch_action);
        map.insert(2056.into(), &super::use_counter_css_page::css_transform);
        map.insert(2057.into(), &super::use_counter_css_page::css_transform_box);
        map.insert(2058.into(), &super::use_counter_css_page::css_transform_origin);
        map.insert(2059.into(), &super::use_counter_css_page::css_transform_style);
        map.insert(2060.into(), &super::use_counter_css_page::css_transition);
        map.insert(2061.into(), &super::use_counter_css_page::css_transition_behavior);
        map.insert(2062.into(), &super::use_counter_css_page::css_transition_delay);
        map.insert(2063.into(), &super::use_counter_css_page::css_transition_duration);
        map.insert(2064.into(), &super::use_counter_css_page::css_transition_property);
        map.insert(2065.into(), &super::use_counter_css_page::css_transition_timing_function);
        map.insert(2066.into(), &super::use_counter_css_page::css_translate);
        map.insert(2067.into(), &super::use_counter_css_page::css_unicode_bidi);
        map.insert(2068.into(), &super::use_counter_css_page::css_user_select);
        map.insert(2069.into(), &super::use_counter_css_page::css_vector_effect);
        map.insert(2070.into(), &super::use_counter_css_page::css_vertical_align);
        map.insert(2071.into(), &super::use_counter_css_page::css_view_timeline);
        map.insert(2072.into(), &super::use_counter_css_page::css_view_timeline_axis);
        map.insert(2073.into(), &super::use_counter_css_page::css_view_timeline_inset);
        map.insert(2074.into(), &super::use_counter_css_page::css_view_timeline_name);
        map.insert(2075.into(), &super::use_counter_css_page::css_view_transition_name);
        map.insert(2076.into(), &super::use_counter_css_page::css_visibility);
        map.insert(2077.into(), &super::use_counter_css_page::css_webkit_align_content);
        map.insert(2078.into(), &super::use_counter_css_page::css_webkit_align_items);
        map.insert(2079.into(), &super::use_counter_css_page::css_webkit_align_self);
        map.insert(2080.into(), &super::use_counter_css_page::css_webkit_animation);
        map.insert(2081.into(), &super::use_counter_css_page::css_webkit_animation_delay);
        map.insert(2082.into(), &super::use_counter_css_page::css_webkit_animation_direction);
        map.insert(2083.into(), &super::use_counter_css_page::css_webkit_animation_duration);
        map.insert(2084.into(), &super::use_counter_css_page::css_webkit_animation_fill_mode);
        map.insert(2085.into(), &super::use_counter_css_page::css_webkit_animation_iteration_count);
        map.insert(2086.into(), &super::use_counter_css_page::css_webkit_animation_name);
        map.insert(2087.into(), &super::use_counter_css_page::css_webkit_animation_play_state);
        map.insert(2088.into(), &super::use_counter_css_page::css_webkit_animation_timing_function);
        map.insert(2089.into(), &super::use_counter_css_page::css_webkit_appearance);
        map.insert(2090.into(), &super::use_counter_css_page::css_webkit_backface_visibility);
        map.insert(2091.into(), &super::use_counter_css_page::css_webkit_background_clip);
        map.insert(2092.into(), &super::use_counter_css_page::css_webkit_background_origin);
        map.insert(2093.into(), &super::use_counter_css_page::css_webkit_background_size);
        map.insert(2094.into(), &super::use_counter_css_page::css_webkit_border_bottom_left_radius);
        map.insert(2095.into(), &super::use_counter_css_page::css_webkit_border_bottom_right_radius);
        map.insert(2096.into(), &super::use_counter_css_page::css_webkit_border_image);
        map.insert(2097.into(), &super::use_counter_css_page::css_webkit_border_radius);
        map.insert(2098.into(), &super::use_counter_css_page::css_webkit_border_top_left_radius);
        map.insert(2099.into(), &super::use_counter_css_page::css_webkit_border_top_right_radius);
        map.insert(2100.into(), &super::use_counter_css_page::css_webkit_box_align);
        map.insert(2101.into(), &super::use_counter_css_page::css_webkit_box_direction);
        map.insert(2102.into(), &super::use_counter_css_page::css_webkit_box_flex);
        map.insert(2103.into(), &super::use_counter_css_page::css_webkit_box_ordinal_group);
        map.insert(2104.into(), &super::use_counter_css_page::css_webkit_box_orient);
        map.insert(2105.into(), &super::use_counter_css_page::css_webkit_box_pack);
        map.insert(2106.into(), &super::use_counter_css_page::css_webkit_box_shadow);
        map.insert(2107.into(), &super::use_counter_css_page::css_webkit_box_sizing);
        map.insert(2108.into(), &super::use_counter_css_page::css_webkit_clip_path);
        map.insert(2109.into(), &super::use_counter_css_page::css_webkit_filter);
        map.insert(2110.into(), &super::use_counter_css_page::css_webkit_flex);
        map.insert(2111.into(), &super::use_counter_css_page::css_webkit_flex_basis);
        map.insert(2112.into(), &super::use_counter_css_page::css_webkit_flex_direction);
        map.insert(2113.into(), &super::use_counter_css_page::css_webkit_flex_flow);
        map.insert(2114.into(), &super::use_counter_css_page::css_webkit_flex_grow);
        map.insert(2115.into(), &super::use_counter_css_page::css_webkit_flex_shrink);
        map.insert(2116.into(), &super::use_counter_css_page::css_webkit_flex_wrap);
        map.insert(2117.into(), &super::use_counter_css_page::css_webkit_font_feature_settings);
        map.insert(2118.into(), &super::use_counter_css_page::css_webkit_font_smoothing);
        map.insert(2119.into(), &super::use_counter_css_page::css_webkit_justify_content);
        map.insert(2120.into(), &super::use_counter_css_page::css_webkit_line_clamp);
        map.insert(2121.into(), &super::use_counter_css_page::css_webkit_mask);
        map.insert(2122.into(), &super::use_counter_css_page::css_webkit_mask_clip);
        map.insert(2123.into(), &super::use_counter_css_page::css_webkit_mask_composite);
        map.insert(2124.into(), &super::use_counter_css_page::css_webkit_mask_image);
        map.insert(2125.into(), &super::use_counter_css_page::css_webkit_mask_origin);
        map.insert(2126.into(), &super::use_counter_css_page::css_webkit_mask_position);
        map.insert(2127.into(), &super::use_counter_css_page::css_webkit_mask_position_x);
        map.insert(2128.into(), &super::use_counter_css_page::css_webkit_mask_position_y);
        map.insert(2129.into(), &super::use_counter_css_page::css_webkit_mask_repeat);
        map.insert(2130.into(), &super::use_counter_css_page::css_webkit_mask_size);
        map.insert(2131.into(), &super::use_counter_css_page::css_webkit_order);
        map.insert(2132.into(), &super::use_counter_css_page::css_webkit_perspective);
        map.insert(2133.into(), &super::use_counter_css_page::css_webkit_perspective_origin);
        map.insert(2134.into(), &super::use_counter_css_page::css_webkit_text_fill_color);
        map.insert(2135.into(), &super::use_counter_css_page::css_webkit_text_security);
        map.insert(2136.into(), &super::use_counter_css_page::css_webkit_text_size_adjust);
        map.insert(2137.into(), &super::use_counter_css_page::css_webkit_text_stroke);
        map.insert(2138.into(), &super::use_counter_css_page::css_webkit_text_stroke_color);
        map.insert(2139.into(), &super::use_counter_css_page::css_webkit_text_stroke_width);
        map.insert(2140.into(), &super::use_counter_css_page::css_webkit_transform);
        map.insert(2141.into(), &super::use_counter_css_page::css_webkit_transform_origin);
        map.insert(2142.into(), &super::use_counter_css_page::css_webkit_transform_style);
        map.insert(2143.into(), &super::use_counter_css_page::css_webkit_transition);
        map.insert(2144.into(), &super::use_counter_css_page::css_webkit_transition_delay);
        map.insert(2145.into(), &super::use_counter_css_page::css_webkit_transition_duration);
        map.insert(2146.into(), &super::use_counter_css_page::css_webkit_transition_property);
        map.insert(2147.into(), &super::use_counter_css_page::css_webkit_transition_timing_function);
        map.insert(2148.into(), &super::use_counter_css_page::css_webkit_user_select);
        map.insert(2149.into(), &super::use_counter_css_page::css_white_space);
        map.insert(2150.into(), &super::use_counter_css_page::css_white_space_collapse);
        map.insert(2151.into(), &super::use_counter_css_page::css_width);
        map.insert(2152.into(), &super::use_counter_css_page::css_will_change);
        map.insert(2153.into(), &super::use_counter_css_page::css_word_break);
        map.insert(2154.into(), &super::use_counter_css_page::css_word_spacing);
        map.insert(2155.into(), &super::use_counter_css_page::css_word_wrap);
        map.insert(2156.into(), &super::use_counter_css_page::css_writing_mode);
        map.insert(2157.into(), &super::use_counter_css_page::css_x);
        map.insert(2158.into(), &super::use_counter_css_page::css_x_lang);
        map.insert(2159.into(), &super::use_counter_css_page::css_x_span);
        map.insert(2160.into(), &super::use_counter_css_page::css_x_text_scale);
        map.insert(2161.into(), &super::use_counter_css_page::css_y);
        map.insert(2162.into(), &super::use_counter_css_page::css_z_index);
        map.insert(2163.into(), &super::use_counter_css_page::css_zoom);
        map.insert(2164.into(), &super::use_counter_css_page::max_zoom);
        map.insert(2165.into(), &super::use_counter_css_page::min_zoom);
        map.insert(2166.into(), &super::use_counter_css_page::orientation);
        map.insert(2167.into(), &super::use_counter_css_page::orphans);
        map.insert(2168.into(), &super::use_counter_css_page::speak);
        map.insert(2169.into(), &super::use_counter_css_page::text_size_adjust);
        map.insert(2170.into(), &super::use_counter_css_page::user_zoom);
        map.insert(2171.into(), &super::use_counter_css_page::webkit_app_region);
        map.insert(2172.into(), &super::use_counter_css_page::webkit_border_after);
        map.insert(2173.into(), &super::use_counter_css_page::webkit_border_after_color);
        map.insert(2174.into(), &super::use_counter_css_page::webkit_border_after_style);
        map.insert(2175.into(), &super::use_counter_css_page::webkit_border_after_width);
        map.insert(2176.into(), &super::use_counter_css_page::webkit_border_before);
        map.insert(2177.into(), &super::use_counter_css_page::webkit_border_before_color);
        map.insert(2178.into(), &super::use_counter_css_page::webkit_border_before_style);
        map.insert(2179.into(), &super::use_counter_css_page::webkit_border_before_width);
        map.insert(2180.into(), &super::use_counter_css_page::webkit_border_end);
        map.insert(2181.into(), &super::use_counter_css_page::webkit_border_end_color);
        map.insert(2182.into(), &super::use_counter_css_page::webkit_border_end_style);
        map.insert(2183.into(), &super::use_counter_css_page::webkit_border_end_width);
        map.insert(2184.into(), &super::use_counter_css_page::webkit_border_horizontal_spacing);
        map.insert(2185.into(), &super::use_counter_css_page::webkit_border_start);
        map.insert(2186.into(), &super::use_counter_css_page::webkit_border_start_color);
        map.insert(2187.into(), &super::use_counter_css_page::webkit_border_start_style);
        map.insert(2188.into(), &super::use_counter_css_page::webkit_border_start_width);
        map.insert(2189.into(), &super::use_counter_css_page::webkit_border_vertical_spacing);
        map.insert(2190.into(), &super::use_counter_css_page::webkit_box_decoration_break);
        map.insert(2191.into(), &super::use_counter_css_page::webkit_box_reflect);
        map.insert(2192.into(), &super::use_counter_css_page::webkit_column_break_after);
        map.insert(2193.into(), &super::use_counter_css_page::webkit_column_break_before);
        map.insert(2194.into(), &super::use_counter_css_page::webkit_column_break_inside);
        map.insert(2195.into(), &super::use_counter_css_page::webkit_column_count);
        map.insert(2196.into(), &super::use_counter_css_page::webkit_column_gap);
        map.insert(2197.into(), &super::use_counter_css_page::webkit_column_rule);
        map.insert(2198.into(), &super::use_counter_css_page::webkit_column_rule_color);
        map.insert(2199.into(), &super::use_counter_css_page::webkit_column_rule_style);
        map.insert(2200.into(), &super::use_counter_css_page::webkit_column_rule_width);
        map.insert(2201.into(), &super::use_counter_css_page::webkit_column_span);
        map.insert(2202.into(), &super::use_counter_css_page::webkit_column_width);
        map.insert(2203.into(), &super::use_counter_css_page::webkit_columns);
        map.insert(2204.into(), &super::use_counter_css_page::webkit_font_size_delta);
        map.insert(2205.into(), &super::use_counter_css_page::webkit_highlight);
        map.insert(2206.into(), &super::use_counter_css_page::webkit_hyphenate_character);
        map.insert(2207.into(), &super::use_counter_css_page::webkit_line_break);
        map.insert(2208.into(), &super::use_counter_css_page::webkit_locale);
        map.insert(2209.into(), &super::use_counter_css_page::webkit_logical_height);
        map.insert(2210.into(), &super::use_counter_css_page::webkit_logical_width);
        map.insert(2211.into(), &super::use_counter_css_page::webkit_margin_after);
        map.insert(2212.into(), &super::use_counter_css_page::webkit_margin_after_collapse);
        map.insert(2213.into(), &super::use_counter_css_page::webkit_margin_before);
        map.insert(2214.into(), &super::use_counter_css_page::webkit_margin_before_collapse);
        map.insert(2215.into(), &super::use_counter_css_page::webkit_margin_bottom_collapse);
        map.insert(2216.into(), &super::use_counter_css_page::webkit_margin_collapse);
        map.insert(2217.into(), &super::use_counter_css_page::webkit_margin_end);
        map.insert(2218.into(), &super::use_counter_css_page::webkit_margin_start);
        map.insert(2219.into(), &super::use_counter_css_page::webkit_margin_top_collapse);
        map.insert(2220.into(), &super::use_counter_css_page::webkit_mask_box_image);
        map.insert(2221.into(), &super::use_counter_css_page::webkit_mask_box_image_outset);
        map.insert(2222.into(), &super::use_counter_css_page::webkit_mask_box_image_repeat);
        map.insert(2223.into(), &super::use_counter_css_page::webkit_mask_box_image_slice);
        map.insert(2224.into(), &super::use_counter_css_page::webkit_mask_box_image_source);
        map.insert(2225.into(), &super::use_counter_css_page::webkit_mask_box_image_width);
        map.insert(2226.into(), &super::use_counter_css_page::webkit_mask_repeat_x);
        map.insert(2227.into(), &super::use_counter_css_page::webkit_mask_repeat_y);
        map.insert(2228.into(), &super::use_counter_css_page::webkit_max_logical_height);
        map.insert(2229.into(), &super::use_counter_css_page::webkit_max_logical_width);
        map.insert(2230.into(), &super::use_counter_css_page::webkit_min_logical_height);
        map.insert(2231.into(), &super::use_counter_css_page::webkit_min_logical_width);
        map.insert(2232.into(), &super::use_counter_css_page::webkit_opacity);
        map.insert(2233.into(), &super::use_counter_css_page::webkit_padding_after);
        map.insert(2234.into(), &super::use_counter_css_page::webkit_padding_before);
        map.insert(2235.into(), &super::use_counter_css_page::webkit_padding_end);
        map.insert(2236.into(), &super::use_counter_css_page::webkit_padding_start);
        map.insert(2237.into(), &super::use_counter_css_page::webkit_perspective_origin_x);
        map.insert(2238.into(), &super::use_counter_css_page::webkit_perspective_origin_y);
        map.insert(2239.into(), &super::use_counter_css_page::webkit_print_color_adjust);
        map.insert(2240.into(), &super::use_counter_css_page::webkit_rtl_ordering);
        map.insert(2241.into(), &super::use_counter_css_page::webkit_ruby_position);
        map.insert(2242.into(), &super::use_counter_css_page::webkit_shape_image_threshold);
        map.insert(2243.into(), &super::use_counter_css_page::webkit_shape_margin);
        map.insert(2244.into(), &super::use_counter_css_page::webkit_shape_outside);
        map.insert(2245.into(), &super::use_counter_css_page::webkit_tap_highlight_color);
        map.insert(2246.into(), &super::use_counter_css_page::webkit_text_combine);
        map.insert(2247.into(), &super::use_counter_css_page::webkit_text_decorations_in_effect);
        map.insert(2248.into(), &super::use_counter_css_page::webkit_text_emphasis);
        map.insert(2249.into(), &super::use_counter_css_page::webkit_text_emphasis_color);
        map.insert(2250.into(), &super::use_counter_css_page::webkit_text_emphasis_position);
        map.insert(2251.into(), &super::use_counter_css_page::webkit_text_emphasis_style);
        map.insert(2252.into(), &super::use_counter_css_page::webkit_text_orientation);
        map.insert(2253.into(), &super::use_counter_css_page::webkit_transform_origin_x);
        map.insert(2254.into(), &super::use_counter_css_page::webkit_transform_origin_y);
        map.insert(2255.into(), &super::use_counter_css_page::webkit_transform_origin_z);
        map.insert(2256.into(), &super::use_counter_css_page::webkit_user_drag);
        map.insert(2257.into(), &super::use_counter_css_page::webkit_user_modify);
        map.insert(2258.into(), &super::use_counter_css_page::webkit_writing_mode);
        map.insert(2259.into(), &super::use_counter_css_page::widows);
        map.insert(2260.into(), &super::use_counter_deprecated_ops_doc::ambient_light_event);
        map.insert(2261.into(), &super::use_counter_deprecated_ops_doc::app_cache);
        map.insert(2262.into(), &super::use_counter_deprecated_ops_doc::components);
        map.insert(2263.into(), &super::use_counter_deprecated_ops_doc::create_image_bitmap_canvas_rendering_context2_d);
        map.insert(2264.into(), &super::use_counter_deprecated_ops_doc::deprecated_testing_attribute);
        map.insert(2265.into(), &super::use_counter_deprecated_ops_doc::deprecated_testing_interface);
        map.insert(2266.into(), &super::use_counter_deprecated_ops_doc::deprecated_testing_method);
        map.insert(2267.into(), &super::use_counter_deprecated_ops_doc::document_release_capture);
        map.insert(2268.into(), &super::use_counter_deprecated_ops_doc::domattr_modified);
        map.insert(2269.into(), &super::use_counter_deprecated_ops_doc::domcharacter_data_modified);
        map.insert(2270.into(), &super::use_counter_deprecated_ops_doc::domnode_inserted);
        map.insert(2271.into(), &super::use_counter_deprecated_ops_doc::domnode_inserted_into_document);
        map.insert(2272.into(), &super::use_counter_deprecated_ops_doc::domnode_removed);
        map.insert(2273.into(), &super::use_counter_deprecated_ops_doc::domnode_removed_from_document);
        map.insert(2274.into(), &super::use_counter_deprecated_ops_doc::domquad_bounds_attr);
        map.insert(2275.into(), &super::use_counter_deprecated_ops_doc::domsubtree_modified);
        map.insert(2276.into(), &super::use_counter_deprecated_ops_doc::draw_window_canvas_rendering_context2_d);
        map.insert(2277.into(), &super::use_counter_deprecated_ops_doc::element_release_capture);
        map.insert(2278.into(), &super::use_counter_deprecated_ops_doc::element_set_capture);
        map.insert(2279.into(), &super::use_counter_deprecated_ops_doc::external__add_search_provider);
        map.insert(2280.into(), &super::use_counter_deprecated_ops_doc::form_submission_untrusted_event);
        map.insert(2281.into(), &super::use_counter_deprecated_ops_doc::idbobject_store_create_index_locale);
        map.insert(2282.into(), &super::use_counter_deprecated_ops_doc::idbopen_dboptions__storage_type);
        map.insert(2283.into(), &super::use_counter_deprecated_ops_doc::image_bitmap_rendering_context__transfer_image_bitmap);
        map.insert(2284.into(), &super::use_counter_deprecated_ops_doc::import_xulinto_content);
        map.insert(2285.into(), &super::use_counter_deprecated_ops_doc::init_mouse_event);
        map.insert(2286.into(), &super::use_counter_deprecated_ops_doc::init_nsmouse_event);
        map.insert(2287.into(), &super::use_counter_deprecated_ops_doc::install_trigger_deprecated);
        map.insert(2288.into(), &super::use_counter_deprecated_ops_doc::install_trigger_install_deprecated);
        map.insert(2289.into(), &super::use_counter_deprecated_ops_doc::lenient_setter);
        map.insert(2290.into(), &super::use_counter_deprecated_ops_doc::lenient_this);
        map.insert(2291.into(), &super::use_counter_deprecated_ops_doc::math_ml__deprecated_math_space_value2);
        map.insert(2292.into(), &super::use_counter_deprecated_ops_doc::math_ml__deprecated_math_variant);
        map.insert(2293.into(), &super::use_counter_deprecated_ops_doc::math_ml__deprecated_stixgeneral_operator_stretching);
        map.insert(2294.into(), &super::use_counter_deprecated_ops_doc::motion_event);
        map.insert(2295.into(), &super::use_counter_deprecated_ops_doc::mouse_event__moz_pressure);
        map.insert(2296.into(), &super::use_counter_deprecated_ops_doc::moz_input_source);
        map.insert(2297.into(), &super::use_counter_deprecated_ops_doc::moz_request_full_screen_deprecated_prefix);
        map.insert(2298.into(), &super::use_counter_deprecated_ops_doc::mozfullscreenchange_deprecated_prefix);
        map.insert(2299.into(), &super::use_counter_deprecated_ops_doc::mozfullscreenerror_deprecated_prefix);
        map.insert(2300.into(), &super::use_counter_deprecated_ops_doc::navigator_get_user_media);
        map.insert(2301.into(), &super::use_counter_deprecated_ops_doc::node_iterator_detach);
        map.insert(2302.into(), &super::use_counter_deprecated_ops_doc::offscreen_canvas_to_blob);
        map.insert(2303.into(), &super::use_counter_deprecated_ops_doc::orientation_event);
        map.insert(2304.into(), &super::use_counter_deprecated_ops_doc::proximity_event);
        map.insert(2305.into(), &super::use_counter_deprecated_ops_doc::rtcpeer_connection_get_streams);
        map.insert(2306.into(), &super::use_counter_deprecated_ops_doc::svgdeselect_all);
        map.insert(2307.into(), &super::use_counter_deprecated_ops_doc::svgfarthest_viewport_element);
        map.insert(2308.into(), &super::use_counter_deprecated_ops_doc::svgnearest_viewport_element);
        map.insert(2309.into(), &super::use_counter_deprecated_ops_doc::sync_xmlhttp_request_deprecated);
        map.insert(2310.into(), &super::use_counter_deprecated_ops_doc::use_of_capture_events);
        map.insert(2311.into(), &super::use_counter_deprecated_ops_doc::use_of_release_events);
        map.insert(2312.into(), &super::use_counter_deprecated_ops_doc::webrtc_deprecated_prefix);
        map.insert(2313.into(), &super::use_counter_deprecated_ops_doc::window__cc_ontrollers);
        map.insert(2314.into(), &super::use_counter_deprecated_ops_doc::window_content_untrusted);
        map.insert(2315.into(), &super::use_counter_deprecated_ops_page::ambient_light_event);
        map.insert(2316.into(), &super::use_counter_deprecated_ops_page::app_cache);
        map.insert(2317.into(), &super::use_counter_deprecated_ops_page::components);
        map.insert(2318.into(), &super::use_counter_deprecated_ops_page::create_image_bitmap_canvas_rendering_context2_d);
        map.insert(2319.into(), &super::use_counter_deprecated_ops_page::deprecated_testing_attribute);
        map.insert(2320.into(), &super::use_counter_deprecated_ops_page::deprecated_testing_interface);
        map.insert(2321.into(), &super::use_counter_deprecated_ops_page::deprecated_testing_method);
        map.insert(2322.into(), &super::use_counter_deprecated_ops_page::document_release_capture);
        map.insert(2323.into(), &super::use_counter_deprecated_ops_page::domattr_modified);
        map.insert(2324.into(), &super::use_counter_deprecated_ops_page::domcharacter_data_modified);
        map.insert(2325.into(), &super::use_counter_deprecated_ops_page::domnode_inserted);
        map.insert(2326.into(), &super::use_counter_deprecated_ops_page::domnode_inserted_into_document);
        map.insert(2327.into(), &super::use_counter_deprecated_ops_page::domnode_removed);
        map.insert(2328.into(), &super::use_counter_deprecated_ops_page::domnode_removed_from_document);
        map.insert(2329.into(), &super::use_counter_deprecated_ops_page::domquad_bounds_attr);
        map.insert(2330.into(), &super::use_counter_deprecated_ops_page::domsubtree_modified);
        map.insert(2331.into(), &super::use_counter_deprecated_ops_page::draw_window_canvas_rendering_context2_d);
        map.insert(2332.into(), &super::use_counter_deprecated_ops_page::element_release_capture);
        map.insert(2333.into(), &super::use_counter_deprecated_ops_page::element_set_capture);
        map.insert(2334.into(), &super::use_counter_deprecated_ops_page::external__add_search_provider);
        map.insert(2335.into(), &super::use_counter_deprecated_ops_page::form_submission_untrusted_event);
        map.insert(2336.into(), &super::use_counter_deprecated_ops_page::idbobject_store_create_index_locale);
        map.insert(2337.into(), &super::use_counter_deprecated_ops_page::idbopen_dboptions__storage_type);
        map.insert(2338.into(), &super::use_counter_deprecated_ops_page::image_bitmap_rendering_context__transfer_image_bitmap);
        map.insert(2339.into(), &super::use_counter_deprecated_ops_page::import_xulinto_content);
        map.insert(2340.into(), &super::use_counter_deprecated_ops_page::init_mouse_event);
        map.insert(2341.into(), &super::use_counter_deprecated_ops_page::init_nsmouse_event);
        map.insert(2342.into(), &super::use_counter_deprecated_ops_page::install_trigger_deprecated);
        map.insert(2343.into(), &super::use_counter_deprecated_ops_page::install_trigger_install_deprecated);
        map.insert(2344.into(), &super::use_counter_deprecated_ops_page::lenient_setter);
        map.insert(2345.into(), &super::use_counter_deprecated_ops_page::lenient_this);
        map.insert(2346.into(), &super::use_counter_deprecated_ops_page::math_ml__deprecated_math_space_value2);
        map.insert(2347.into(), &super::use_counter_deprecated_ops_page::math_ml__deprecated_math_variant);
        map.insert(2348.into(), &super::use_counter_deprecated_ops_page::math_ml__deprecated_stixgeneral_operator_stretching);
        map.insert(2349.into(), &super::use_counter_deprecated_ops_page::motion_event);
        map.insert(2350.into(), &super::use_counter_deprecated_ops_page::mouse_event__moz_pressure);
        map.insert(2351.into(), &super::use_counter_deprecated_ops_page::moz_input_source);
        map.insert(2352.into(), &super::use_counter_deprecated_ops_page::moz_request_full_screen_deprecated_prefix);
        map.insert(2353.into(), &super::use_counter_deprecated_ops_page::mozfullscreenchange_deprecated_prefix);
        map.insert(2354.into(), &super::use_counter_deprecated_ops_page::mozfullscreenerror_deprecated_prefix);
        map.insert(2355.into(), &super::use_counter_deprecated_ops_page::navigator_get_user_media);
        map.insert(2356.into(), &super::use_counter_deprecated_ops_page::node_iterator_detach);
        map.insert(2357.into(), &super::use_counter_deprecated_ops_page::offscreen_canvas_to_blob);
        map.insert(2358.into(), &super::use_counter_deprecated_ops_page::orientation_event);
        map.insert(2359.into(), &super::use_counter_deprecated_ops_page::proximity_event);
        map.insert(2360.into(), &super::use_counter_deprecated_ops_page::rtcpeer_connection_get_streams);
        map.insert(2361.into(), &super::use_counter_deprecated_ops_page::svgdeselect_all);
        map.insert(2362.into(), &super::use_counter_deprecated_ops_page::svgfarthest_viewport_element);
        map.insert(2363.into(), &super::use_counter_deprecated_ops_page::svgnearest_viewport_element);
        map.insert(2364.into(), &super::use_counter_deprecated_ops_page::sync_xmlhttp_request_deprecated);
        map.insert(2365.into(), &super::use_counter_deprecated_ops_page::use_of_capture_events);
        map.insert(2366.into(), &super::use_counter_deprecated_ops_page::use_of_release_events);
        map.insert(2367.into(), &super::use_counter_deprecated_ops_page::webrtc_deprecated_prefix);
        map.insert(2368.into(), &super::use_counter_deprecated_ops_page::window__cc_ontrollers);
        map.insert(2369.into(), &super::use_counter_deprecated_ops_page::window_content_untrusted);
        map.insert(2370.into(), &super::use_counter_doc::clipboard_read);
        map.insert(2371.into(), &super::use_counter_doc::clipboard_readtext);
        map.insert(2372.into(), &super::use_counter_doc::clipboard_write);
        map.insert(2373.into(), &super::use_counter_doc::console_assert);
        map.insert(2374.into(), &super::use_counter_doc::console_clear);
        map.insert(2375.into(), &super::use_counter_doc::console_count);
        map.insert(2376.into(), &super::use_counter_doc::console_countreset);
        map.insert(2377.into(), &super::use_counter_doc::console_debug);
        map.insert(2378.into(), &super::use_counter_doc::console_dir);
        map.insert(2379.into(), &super::use_counter_doc::console_dirxml);
        map.insert(2380.into(), &super::use_counter_doc::console_error);
        map.insert(2381.into(), &super::use_counter_doc::console_exception);
        map.insert(2382.into(), &super::use_counter_doc::console_group);
        map.insert(2383.into(), &super::use_counter_doc::console_groupcollapsed);
        map.insert(2384.into(), &super::use_counter_doc::console_groupend);
        map.insert(2385.into(), &super::use_counter_doc::console_info);
        map.insert(2386.into(), &super::use_counter_doc::console_log);
        map.insert(2387.into(), &super::use_counter_doc::console_profile);
        map.insert(2388.into(), &super::use_counter_doc::console_profileend);
        map.insert(2389.into(), &super::use_counter_doc::console_table);
        map.insert(2390.into(), &super::use_counter_doc::console_time);
        map.insert(2391.into(), &super::use_counter_doc::console_timeend);
        map.insert(2392.into(), &super::use_counter_doc::console_timelog);
        map.insert(2393.into(), &super::use_counter_doc::console_timestamp);
        map.insert(2394.into(), &super::use_counter_doc::console_trace);
        map.insert(2395.into(), &super::use_counter_doc::console_warn);
        map.insert(2396.into(), &super::use_counter_doc::customelementregistry_define);
        map.insert(2397.into(), &super::use_counter_doc::customized_builtin);
        map.insert(2398.into(), &super::use_counter_doc::datatransfer_addelement);
        map.insert(2399.into(), &super::use_counter_doc::datatransfer_mozcleardataat);
        map.insert(2400.into(), &super::use_counter_doc::datatransfer_mozcursor_getter);
        map.insert(2401.into(), &super::use_counter_doc::datatransfer_mozcursor_setter);
        map.insert(2402.into(), &super::use_counter_doc::datatransfer_mozgetdataat);
        map.insert(2403.into(), &super::use_counter_doc::datatransfer_mozitemcount_getter);
        map.insert(2404.into(), &super::use_counter_doc::datatransfer_mozitemcount_setter);
        map.insert(2405.into(), &super::use_counter_doc::datatransfer_mozsetdataat);
        map.insert(2406.into(), &super::use_counter_doc::datatransfer_mozsourcenode_getter);
        map.insert(2407.into(), &super::use_counter_doc::datatransfer_mozsourcenode_setter);
        map.insert(2408.into(), &super::use_counter_doc::datatransfer_moztypesat);
        map.insert(2409.into(), &super::use_counter_doc::datatransfer_mozusercancelled_getter);
        map.insert(2410.into(), &super::use_counter_doc::datatransfer_mozusercancelled_setter);
        map.insert(2411.into(), &super::use_counter_doc::datatransferitem_webkitgetasentry);
        map.insert(2412.into(), &super::use_counter_doc::document_caretrangefrompoint);
        map.insert(2413.into(), &super::use_counter_doc::document_exec_command_content_read_only);
        map.insert(2414.into(), &super::use_counter_doc::document_exitpictureinpicture);
        map.insert(2415.into(), &super::use_counter_doc::document_featurepolicy);
        map.insert(2416.into(), &super::use_counter_doc::document_mozsetimageelement);
        map.insert(2417.into(), &super::use_counter_doc::document_onbeforecopy);
        map.insert(2418.into(), &super::use_counter_doc::document_onbeforecut);
        map.insert(2419.into(), &super::use_counter_doc::document_onbeforepaste);
        map.insert(2420.into(), &super::use_counter_doc::document_oncancel);
        map.insert(2421.into(), &super::use_counter_doc::document_onfreeze);
        map.insert(2422.into(), &super::use_counter_doc::document_onmousewheel);
        map.insert(2423.into(), &super::use_counter_doc::document_onresume);
        map.insert(2424.into(), &super::use_counter_doc::document_onsearch);
        map.insert(2425.into(), &super::use_counter_doc::document_onwebkitfullscreenchange);
        map.insert(2426.into(), &super::use_counter_doc::document_onwebkitfullscreenerror);
        map.insert(2427.into(), &super::use_counter_doc::document_open);
        map.insert(2428.into(), &super::use_counter_doc::document_pictureinpictureelement);
        map.insert(2429.into(), &super::use_counter_doc::document_pictureinpictureenabled);
        map.insert(2430.into(), &super::use_counter_doc::document_query_command_state_or_value_content_read_only);
        map.insert(2431.into(), &super::use_counter_doc::document_query_command_state_or_value_insert_br_on_return);
        map.insert(2432.into(), &super::use_counter_doc::document_query_command_supported_or_enabled_content_read_only);
        map.insert(2433.into(), &super::use_counter_doc::document_query_command_supported_or_enabled_insert_br_on_return);
        map.insert(2434.into(), &super::use_counter_doc::document_registerelement);
        map.insert(2435.into(), &super::use_counter_doc::document_wasdiscarded);
        map.insert(2436.into(), &super::use_counter_doc::document_webkitcancelfullscreen);
        map.insert(2437.into(), &super::use_counter_doc::document_webkitcurrentfullscreenelement);
        map.insert(2438.into(), &super::use_counter_doc::document_webkitexitfullscreen);
        map.insert(2439.into(), &super::use_counter_doc::document_webkitfullscreenelement);
        map.insert(2440.into(), &super::use_counter_doc::document_webkitfullscreenenabled);
        map.insert(2441.into(), &super::use_counter_doc::document_webkithidden);
        map.insert(2442.into(), &super::use_counter_doc::document_webkitisfullscreen);
        map.insert(2443.into(), &super::use_counter_doc::document_webkitvisibilitystate);
        map.insert(2444.into(), &super::use_counter_doc::document_xmlencoding);
        map.insert(2445.into(), &super::use_counter_doc::document_xmlstandalone);
        map.insert(2446.into(), &super::use_counter_doc::document_xmlversion);
        map.insert(2447.into(), &super::use_counter_doc::domparser_parsefromstring);
        map.insert(2448.into(), &super::use_counter_doc::element_attachshadow);
        map.insert(2449.into(), &super::use_counter_doc::element_computedstylemap);
        map.insert(2450.into(), &super::use_counter_doc::element_onmousewheel);
        map.insert(2451.into(), &super::use_counter_doc::element_releasecapture);
        map.insert(2452.into(), &super::use_counter_doc::element_releasepointercapture);
        map.insert(2453.into(), &super::use_counter_doc::element_scrollintoviewifneeded);
        map.insert(2454.into(), &super::use_counter_doc::element_setcapture);
        map.insert(2455.into(), &super::use_counter_doc::element_sethtml);
        map.insert(2456.into(), &super::use_counter_doc::element_setpointercapture);
        map.insert(2457.into(), &super::use_counter_doc::enumerate_devices_insec);
        map.insert(2458.into(), &super::use_counter_doc::enumerate_devices_unfocused);
        map.insert(2459.into(), &super::use_counter_doc::fe_blend);
        map.insert(2460.into(), &super::use_counter_doc::fe_color_matrix);
        map.insert(2461.into(), &super::use_counter_doc::fe_component_transfer);
        map.insert(2462.into(), &super::use_counter_doc::fe_composite);
        map.insert(2463.into(), &super::use_counter_doc::fe_convolve_matrix);
        map.insert(2464.into(), &super::use_counter_doc::fe_diffuse_lighting);
        map.insert(2465.into(), &super::use_counter_doc::fe_displacement_map);
        map.insert(2466.into(), &super::use_counter_doc::fe_flood);
        map.insert(2467.into(), &super::use_counter_doc::fe_gaussian_blur);
        map.insert(2468.into(), &super::use_counter_doc::fe_image);
        map.insert(2469.into(), &super::use_counter_doc::fe_merge);
        map.insert(2470.into(), &super::use_counter_doc::fe_morphology);
        map.insert(2471.into(), &super::use_counter_doc::fe_offset);
        map.insert(2472.into(), &super::use_counter_doc::fe_specular_lighting);
        map.insert(2473.into(), &super::use_counter_doc::fe_tile);
        map.insert(2474.into(), &super::use_counter_doc::fe_turbulence);
        map.insert(2475.into(), &super::use_counter_doc::filtered_cross_origin_iframe);
        map.insert(2476.into(), &super::use_counter_doc::get_user_media_insec);
        map.insert(2477.into(), &super::use_counter_doc::get_user_media_unfocused);
        map.insert(2478.into(), &super::use_counter_doc::htmlbuttonelement_popovertargetaction);
        map.insert(2479.into(), &super::use_counter_doc::htmlbuttonelement_popovertargetelement);
        map.insert(2480.into(), &super::use_counter_doc::htmldialogelement_show);
        map.insert(2481.into(), &super::use_counter_doc::htmldocument_named_getter_hit);
        map.insert(2482.into(), &super::use_counter_doc::htmlelement_attributestylemap);
        map.insert(2483.into(), &super::use_counter_doc::htmlelement_hidepopover);
        map.insert(2484.into(), &super::use_counter_doc::htmlelement_popover);
        map.insert(2485.into(), &super::use_counter_doc::htmlelement_showpopover);
        map.insert(2486.into(), &super::use_counter_doc::htmlelement_togglepopover);
        map.insert(2487.into(), &super::use_counter_doc::htmliframeelement_loading);
        map.insert(2488.into(), &super::use_counter_doc::htmlinputelement_capture);
        map.insert(2489.into(), &super::use_counter_doc::htmlinputelement_incremental);
        map.insert(2490.into(), &super::use_counter_doc::htmlinputelement_onsearch);
        map.insert(2491.into(), &super::use_counter_doc::htmlinputelement_popovertargetaction);
        map.insert(2492.into(), &super::use_counter_doc::htmlinputelement_popovertargetelement);
        map.insert(2493.into(), &super::use_counter_doc::htmlinputelement_webkitdirectory);
        map.insert(2494.into(), &super::use_counter_doc::htmlinputelement_webkitentries);
        map.insert(2495.into(), &super::use_counter_doc::htmlmediaelement_disableremoteplayback);
        map.insert(2496.into(), &super::use_counter_doc::htmlmediaelement_remote);
        map.insert(2497.into(), &super::use_counter_doc::htmlvideoelement_cancelvideoframecallback);
        map.insert(2498.into(), &super::use_counter_doc::htmlvideoelement_disablepictureinpicture);
        map.insert(2499.into(), &super::use_counter_doc::htmlvideoelement_onenterpictureinpicture);
        map.insert(2500.into(), &super::use_counter_doc::htmlvideoelement_onleavepictureinpicture);
        map.insert(2501.into(), &super::use_counter_doc::htmlvideoelement_playsinline);
        map.insert(2502.into(), &super::use_counter_doc::htmlvideoelement_requestpictureinpicture);
        map.insert(2503.into(), &super::use_counter_doc::htmlvideoelement_requestvideoframecallback);
        map.insert(2504.into(), &super::use_counter_doc::imagedata_colorspace);
        map.insert(2505.into(), &super::use_counter_doc::js_asmjs);
        map.insert(2506.into(), &super::use_counter_doc::js_wasm);
        map.insert(2507.into(), &super::use_counter_doc::js_wasm_legacy_exceptions);
        map.insert(2508.into(), &super::use_counter_doc::location_ancestororigins);
        map.insert(2509.into(), &super::use_counter_doc::mediadevices_enumeratedevices);
        map.insert(2510.into(), &super::use_counter_doc::mediadevices_getdisplaymedia);
        map.insert(2511.into(), &super::use_counter_doc::mediadevices_getusermedia);
        map.insert(2512.into(), &super::use_counter_doc::mixed_content_not_upgraded_audio_failure);
        map.insert(2513.into(), &super::use_counter_doc::mixed_content_not_upgraded_audio_success);
        map.insert(2514.into(), &super::use_counter_doc::mixed_content_not_upgraded_image_failure);
        map.insert(2515.into(), &super::use_counter_doc::mixed_content_not_upgraded_image_success);
        map.insert(2516.into(), &super::use_counter_doc::mixed_content_not_upgraded_video_failure);
        map.insert(2517.into(), &super::use_counter_doc::mixed_content_not_upgraded_video_success);
        map.insert(2518.into(), &super::use_counter_doc::mixed_content_upgraded_audio_failure);
        map.insert(2519.into(), &super::use_counter_doc::mixed_content_upgraded_audio_success);
        map.insert(2520.into(), &super::use_counter_doc::mixed_content_upgraded_image_failure);
        map.insert(2521.into(), &super::use_counter_doc::mixed_content_upgraded_image_success);
        map.insert(2522.into(), &super::use_counter_doc::mixed_content_upgraded_video_failure);
        map.insert(2523.into(), &super::use_counter_doc::mixed_content_upgraded_video_success);
        map.insert(2524.into(), &super::use_counter_doc::moz_get_user_media_insec);
        map.insert(2525.into(), &super::use_counter_doc::navigator_canshare);
        map.insert(2526.into(), &super::use_counter_doc::navigator_clearappbadge);
        map.insert(2527.into(), &super::use_counter_doc::navigator_mozgetusermedia);
        map.insert(2528.into(), &super::use_counter_doc::navigator_setappbadge);
        map.insert(2529.into(), &super::use_counter_doc::navigator_share);
        map.insert(2530.into(), &super::use_counter_doc::navigator_useractivation);
        map.insert(2531.into(), &super::use_counter_doc::navigator_wakelock);
        map.insert(2532.into(), &super::use_counter_doc::ondommousescroll);
        map.insert(2533.into(), &super::use_counter_doc::onmozmousepixelscroll);
        map.insert(2534.into(), &super::use_counter_doc::onoverflow);
        map.insert(2535.into(), &super::use_counter_doc::onunderflow);
        map.insert(2536.into(), &super::use_counter_doc::percentage_stroke_width_in_svg);
        map.insert(2537.into(), &super::use_counter_doc::percentage_stroke_width_in_svgtext);
        map.insert(2538.into(), &super::use_counter_doc::private_browsing_caches_delete);
        map.insert(2539.into(), &super::use_counter_doc::private_browsing_caches_has);
        map.insert(2540.into(), &super::use_counter_doc::private_browsing_caches_keys);
        map.insert(2541.into(), &super::use_counter_doc::private_browsing_caches_match);
        map.insert(2542.into(), &super::use_counter_doc::private_browsing_caches_open);
        map.insert(2543.into(), &super::use_counter_doc::private_browsing_idbfactory_delete_database);
        map.insert(2544.into(), &super::use_counter_doc::private_browsing_idbfactory_open);
        map.insert(2545.into(), &super::use_counter_doc::private_browsing_navigator_service_worker);
        map.insert(2546.into(), &super::use_counter_doc::pushmanager_subscribe);
        map.insert(2547.into(), &super::use_counter_doc::pushsubscription_unsubscribe);
        map.insert(2548.into(), &super::use_counter_doc::range_createcontextualfragment);
        map.insert(2549.into(), &super::use_counter_doc::sanitizer_constructor);
        map.insert(2550.into(), &super::use_counter_doc::sanitizer_sanitize);
        map.insert(2551.into(), &super::use_counter_doc::scheduler_posttask);
        map.insert(2552.into(), &super::use_counter_doc::shadowroot_pictureinpictureelement);
        map.insert(2553.into(), &super::use_counter_doc::svgsvgelement_currentscale_getter);
        map.insert(2554.into(), &super::use_counter_doc::svgsvgelement_currentscale_setter);
        map.insert(2555.into(), &super::use_counter_doc::svgsvgelement_getelementbyid);
        map.insert(2556.into(), &super::use_counter_doc::window_absoluteorientationsensor);
        map.insert(2557.into(), &super::use_counter_doc::window_accelerometer);
        map.insert(2558.into(), &super::use_counter_doc::window_backgroundfetchmanager);
        map.insert(2559.into(), &super::use_counter_doc::window_backgroundfetchrecord);
        map.insert(2560.into(), &super::use_counter_doc::window_backgroundfetchregistration);
        map.insert(2561.into(), &super::use_counter_doc::window_beforeinstallpromptevent);
        map.insert(2562.into(), &super::use_counter_doc::window_bluetooth);
        map.insert(2563.into(), &super::use_counter_doc::window_bluetoothcharacteristicproperties);
        map.insert(2564.into(), &super::use_counter_doc::window_bluetoothdevice);
        map.insert(2565.into(), &super::use_counter_doc::window_bluetoothremotegattcharacteristic);
        map.insert(2566.into(), &super::use_counter_doc::window_bluetoothremotegattdescriptor);
        map.insert(2567.into(), &super::use_counter_doc::window_bluetoothremotegattserver);
        map.insert(2568.into(), &super::use_counter_doc::window_bluetoothremotegattservice);
        map.insert(2569.into(), &super::use_counter_doc::window_bluetoothuuid);
        map.insert(2570.into(), &super::use_counter_doc::window_canvascapturemediastreamtrack);
        map.insert(2571.into(), &super::use_counter_doc::window_chrome);
        map.insert(2572.into(), &super::use_counter_doc::window_clipboarditem);
        map.insert(2573.into(), &super::use_counter_doc::window_cssimagevalue);
        map.insert(2574.into(), &super::use_counter_doc::window_csskeywordvalue);
        map.insert(2575.into(), &super::use_counter_doc::window_cssmathclamp);
        map.insert(2576.into(), &super::use_counter_doc::window_cssmathinvert);
        map.insert(2577.into(), &super::use_counter_doc::window_cssmathmax);
        map.insert(2578.into(), &super::use_counter_doc::window_cssmathmin);
        map.insert(2579.into(), &super::use_counter_doc::window_cssmathnegate);
        map.insert(2580.into(), &super::use_counter_doc::window_cssmathproduct);
        map.insert(2581.into(), &super::use_counter_doc::window_cssmathsum);
        map.insert(2582.into(), &super::use_counter_doc::window_cssmathvalue);
        map.insert(2583.into(), &super::use_counter_doc::window_cssmatrixcomponent);
        map.insert(2584.into(), &super::use_counter_doc::window_cssnumericarray);
        map.insert(2585.into(), &super::use_counter_doc::window_cssnumericvalue);
        map.insert(2586.into(), &super::use_counter_doc::window_cssperspective);
        map.insert(2587.into(), &super::use_counter_doc::window_csspositionvalue);
        map.insert(2588.into(), &super::use_counter_doc::window_csspropertyrule);
        map.insert(2589.into(), &super::use_counter_doc::window_cssrotate);
        map.insert(2590.into(), &super::use_counter_doc::window_cssscale);
        map.insert(2591.into(), &super::use_counter_doc::window_cssskew);
        map.insert(2592.into(), &super::use_counter_doc::window_cssskewx);
        map.insert(2593.into(), &super::use_counter_doc::window_cssskewy);
        map.insert(2594.into(), &super::use_counter_doc::window_cssstylevalue);
        map.insert(2595.into(), &super::use_counter_doc::window_csstransformcomponent);
        map.insert(2596.into(), &super::use_counter_doc::window_csstransformvalue);
        map.insert(2597.into(), &super::use_counter_doc::window_csstranslate);
        map.insert(2598.into(), &super::use_counter_doc::window_cssunitvalue);
        map.insert(2599.into(), &super::use_counter_doc::window_cssunparsedvalue);
        map.insert(2600.into(), &super::use_counter_doc::window_cssvariablereferencevalue);
        map.insert(2601.into(), &super::use_counter_doc::window_defaultstatus);
        map.insert(2602.into(), &super::use_counter_doc::window_devicemotioneventacceleration);
        map.insert(2603.into(), &super::use_counter_doc::window_devicemotioneventrotationrate);
        map.insert(2604.into(), &super::use_counter_doc::window_domerror);
        map.insert(2605.into(), &super::use_counter_doc::window_encodedvideochunk);
        map.insert(2606.into(), &super::use_counter_doc::window_enterpictureinpictureevent);
        map.insert(2607.into(), &super::use_counter_doc::window_external);
        map.insert(2608.into(), &super::use_counter_doc::window_federatedcredential);
        map.insert(2609.into(), &super::use_counter_doc::window_gyroscope);
        map.insert(2610.into(), &super::use_counter_doc::window_htmlcontentelement);
        map.insert(2611.into(), &super::use_counter_doc::window_htmlshadowelement);
        map.insert(2612.into(), &super::use_counter_doc::window_imagecapture);
        map.insert(2613.into(), &super::use_counter_doc::window_inputdevicecapabilities);
        map.insert(2614.into(), &super::use_counter_doc::window_inputdeviceinfo);
        map.insert(2615.into(), &super::use_counter_doc::window_keyboard);
        map.insert(2616.into(), &super::use_counter_doc::window_keyboardlayoutmap);
        map.insert(2617.into(), &super::use_counter_doc::window_linearaccelerationsensor);
        map.insert(2618.into(), &super::use_counter_doc::window_mediasettingsrange);
        map.insert(2619.into(), &super::use_counter_doc::window_midiaccess);
        map.insert(2620.into(), &super::use_counter_doc::window_midiconnectionevent);
        map.insert(2621.into(), &super::use_counter_doc::window_midiinput);
        map.insert(2622.into(), &super::use_counter_doc::window_midiinputmap);
        map.insert(2623.into(), &super::use_counter_doc::window_midimessageevent);
        map.insert(2624.into(), &super::use_counter_doc::window_midioutput);
        map.insert(2625.into(), &super::use_counter_doc::window_midioutputmap);
        map.insert(2626.into(), &super::use_counter_doc::window_midiport);
        map.insert(2627.into(), &super::use_counter_doc::window_networkinformation);
        map.insert(2628.into(), &super::use_counter_doc::window_offscreenbuffering);
        map.insert(2629.into(), &super::use_counter_doc::window_onbeforeinstallprompt);
        map.insert(2630.into(), &super::use_counter_doc::window_oncancel);
        map.insert(2631.into(), &super::use_counter_doc::window_onmousewheel);
        map.insert(2632.into(), &super::use_counter_doc::window_onorientationchange);
        map.insert(2633.into(), &super::use_counter_doc::window_onsearch);
        map.insert(2634.into(), &super::use_counter_doc::window_onselectionchange);
        map.insert(2635.into(), &super::use_counter_doc::window_open_empty_url);
        map.insert(2636.into(), &super::use_counter_doc::window_opendatabase);
        map.insert(2637.into(), &super::use_counter_doc::window_orientation);
        map.insert(2638.into(), &super::use_counter_doc::window_orientationsensor);
        map.insert(2639.into(), &super::use_counter_doc::window_overconstrainederror);
        map.insert(2640.into(), &super::use_counter_doc::window_passwordcredential);
        map.insert(2641.into(), &super::use_counter_doc::window_paymentaddress);
        map.insert(2642.into(), &super::use_counter_doc::window_paymentinstruments);
        map.insert(2643.into(), &super::use_counter_doc::window_paymentmanager);
        map.insert(2644.into(), &super::use_counter_doc::window_paymentmethodchangeevent);
        map.insert(2645.into(), &super::use_counter_doc::window_paymentrequest);
        map.insert(2646.into(), &super::use_counter_doc::window_paymentrequestupdateevent);
        map.insert(2647.into(), &super::use_counter_doc::window_paymentresponse);
        map.insert(2648.into(), &super::use_counter_doc::window_performancelongtasktiming);
        map.insert(2649.into(), &super::use_counter_doc::window_photocapabilities);
        map.insert(2650.into(), &super::use_counter_doc::window_pictureinpictureevent);
        map.insert(2651.into(), &super::use_counter_doc::window_pictureinpicturewindow);
        map.insert(2652.into(), &super::use_counter_doc::window_presentation);
        map.insert(2653.into(), &super::use_counter_doc::window_presentationavailability);
        map.insert(2654.into(), &super::use_counter_doc::window_presentationconnection);
        map.insert(2655.into(), &super::use_counter_doc::window_presentationconnectionavailableevent);
        map.insert(2656.into(), &super::use_counter_doc::window_presentationconnectioncloseevent);
        map.insert(2657.into(), &super::use_counter_doc::window_presentationconnectionlist);
        map.insert(2658.into(), &super::use_counter_doc::window_presentationreceiver);
        map.insert(2659.into(), &super::use_counter_doc::window_presentationrequest);
        map.insert(2660.into(), &super::use_counter_doc::window_relativeorientationsensor);
        map.insert(2661.into(), &super::use_counter_doc::window_remoteplayback);
        map.insert(2662.into(), &super::use_counter_doc::window_report);
        map.insert(2663.into(), &super::use_counter_doc::window_reportbody);
        map.insert(2664.into(), &super::use_counter_doc::window_reportingobserver);
        map.insert(2665.into(), &super::use_counter_doc::window_rtcerror);
        map.insert(2666.into(), &super::use_counter_doc::window_rtcerrorevent);
        map.insert(2667.into(), &super::use_counter_doc::window_rtcicetransport);
        map.insert(2668.into(), &super::use_counter_doc::window_rtcpeerconnectioniceerrorevent);
        map.insert(2669.into(), &super::use_counter_doc::window_sensor);
        map.insert(2670.into(), &super::use_counter_doc::window_sensorerrorevent);
        map.insert(2671.into(), &super::use_counter_doc::window_sidebar_getter);
        map.insert(2672.into(), &super::use_counter_doc::window_sidebar_setter);
        map.insert(2673.into(), &super::use_counter_doc::window_speechrecognitionalternative);
        map.insert(2674.into(), &super::use_counter_doc::window_speechrecognitionresult);
        map.insert(2675.into(), &super::use_counter_doc::window_speechrecognitionresultlist);
        map.insert(2676.into(), &super::use_counter_doc::window_stylemedia);
        map.insert(2677.into(), &super::use_counter_doc::window_stylepropertymap);
        map.insert(2678.into(), &super::use_counter_doc::window_stylepropertymapreadonly);
        map.insert(2679.into(), &super::use_counter_doc::window_svgdiscardelement);
        map.insert(2680.into(), &super::use_counter_doc::window_syncmanager);
        map.insert(2681.into(), &super::use_counter_doc::window_taskattributiontiming);
        map.insert(2682.into(), &super::use_counter_doc::window_textevent);
        map.insert(2683.into(), &super::use_counter_doc::window_touch);
        map.insert(2684.into(), &super::use_counter_doc::window_touchevent);
        map.insert(2685.into(), &super::use_counter_doc::window_touchlist);
        map.insert(2686.into(), &super::use_counter_doc::window_usb);
        map.insert(2687.into(), &super::use_counter_doc::window_usbalternateinterface);
        map.insert(2688.into(), &super::use_counter_doc::window_usbconfiguration);
        map.insert(2689.into(), &super::use_counter_doc::window_usbconnectionevent);
        map.insert(2690.into(), &super::use_counter_doc::window_usbdevice);
        map.insert(2691.into(), &super::use_counter_doc::window_usbendpoint);
        map.insert(2692.into(), &super::use_counter_doc::window_usbinterface);
        map.insert(2693.into(), &super::use_counter_doc::window_usbintransferresult);
        map.insert(2694.into(), &super::use_counter_doc::window_usbisochronousintransferpacket);
        map.insert(2695.into(), &super::use_counter_doc::window_usbisochronousintransferresult);
        map.insert(2696.into(), &super::use_counter_doc::window_usbisochronousouttransferpacket);
        map.insert(2697.into(), &super::use_counter_doc::window_usbisochronousouttransferresult);
        map.insert(2698.into(), &super::use_counter_doc::window_usbouttransferresult);
        map.insert(2699.into(), &super::use_counter_doc::window_useractivation);
        map.insert(2700.into(), &super::use_counter_doc::window_videocolorspace);
        map.insert(2701.into(), &super::use_counter_doc::window_videodecoder);
        map.insert(2702.into(), &super::use_counter_doc::window_videoencoder);
        map.insert(2703.into(), &super::use_counter_doc::window_videoframe);
        map.insert(2704.into(), &super::use_counter_doc::window_wakelock);
        map.insert(2705.into(), &super::use_counter_doc::window_wakelocksentinel);
        map.insert(2706.into(), &super::use_counter_doc::window_webkitcancelanimationframe);
        map.insert(2707.into(), &super::use_counter_doc::window_webkitmediastream);
        map.insert(2708.into(), &super::use_counter_doc::window_webkitmutationobserver);
        map.insert(2709.into(), &super::use_counter_doc::window_webkitrequestanimationframe);
        map.insert(2710.into(), &super::use_counter_doc::window_webkitrequestfilesystem);
        map.insert(2711.into(), &super::use_counter_doc::window_webkitresolvelocalfilesystemurl);
        map.insert(2712.into(), &super::use_counter_doc::window_webkitrtcpeerconnection);
        map.insert(2713.into(), &super::use_counter_doc::window_webkitspeechgrammar);
        map.insert(2714.into(), &super::use_counter_doc::window_webkitspeechgrammarlist);
        map.insert(2715.into(), &super::use_counter_doc::window_webkitspeechrecognition);
        map.insert(2716.into(), &super::use_counter_doc::window_webkitspeechrecognitionerror);
        map.insert(2717.into(), &super::use_counter_doc::window_webkitspeechrecognitionevent);
        map.insert(2718.into(), &super::use_counter_doc::window_webkitstorageinfo);
        map.insert(2719.into(), &super::use_counter_doc::workernavigator_permissions);
        map.insert(2720.into(), &super::use_counter_doc::wr_filter_fallback);
        map.insert(2721.into(), &super::use_counter_doc::xslstylesheet);
        map.insert(2722.into(), &super::use_counter_doc::xsltprocessor_constructor);
        map.insert(2723.into(), &super::use_counter_doc::you_tube_flash_embed);
        map.insert(2724.into(), &super::use_counter_page::clipboard_read);
        map.insert(2725.into(), &super::use_counter_page::clipboard_readtext);
        map.insert(2726.into(), &super::use_counter_page::clipboard_write);
        map.insert(2727.into(), &super::use_counter_page::console_assert);
        map.insert(2728.into(), &super::use_counter_page::console_clear);
        map.insert(2729.into(), &super::use_counter_page::console_count);
        map.insert(2730.into(), &super::use_counter_page::console_countreset);
        map.insert(2731.into(), &super::use_counter_page::console_debug);
        map.insert(2732.into(), &super::use_counter_page::console_dir);
        map.insert(2733.into(), &super::use_counter_page::console_dirxml);
        map.insert(2734.into(), &super::use_counter_page::console_error);
        map.insert(2735.into(), &super::use_counter_page::console_exception);
        map.insert(2736.into(), &super::use_counter_page::console_group);
        map.insert(2737.into(), &super::use_counter_page::console_groupcollapsed);
        map.insert(2738.into(), &super::use_counter_page::console_groupend);
        map.insert(2739.into(), &super::use_counter_page::console_info);
        map.insert(2740.into(), &super::use_counter_page::console_log);
        map.insert(2741.into(), &super::use_counter_page::console_profile);
        map.insert(2742.into(), &super::use_counter_page::console_profileend);
        map.insert(2743.into(), &super::use_counter_page::console_table);
        map.insert(2744.into(), &super::use_counter_page::console_time);
        map.insert(2745.into(), &super::use_counter_page::console_timeend);
        map.insert(2746.into(), &super::use_counter_page::console_timelog);
        map.insert(2747.into(), &super::use_counter_page::console_timestamp);
        map.insert(2748.into(), &super::use_counter_page::console_trace);
        map.insert(2749.into(), &super::use_counter_page::console_warn);
        map.insert(2750.into(), &super::use_counter_page::customelementregistry_define);
        map.insert(2751.into(), &super::use_counter_page::customized_builtin);
        map.insert(2752.into(), &super::use_counter_page::datatransfer_addelement);
        map.insert(2753.into(), &super::use_counter_page::datatransfer_mozcleardataat);
        map.insert(2754.into(), &super::use_counter_page::datatransfer_mozcursor_getter);
        map.insert(2755.into(), &super::use_counter_page::datatransfer_mozcursor_setter);
        map.insert(2756.into(), &super::use_counter_page::datatransfer_mozgetdataat);
        map.insert(2757.into(), &super::use_counter_page::datatransfer_mozitemcount_getter);
        map.insert(2758.into(), &super::use_counter_page::datatransfer_mozitemcount_setter);
        map.insert(2759.into(), &super::use_counter_page::datatransfer_mozsetdataat);
        map.insert(2760.into(), &super::use_counter_page::datatransfer_mozsourcenode_getter);
        map.insert(2761.into(), &super::use_counter_page::datatransfer_mozsourcenode_setter);
        map.insert(2762.into(), &super::use_counter_page::datatransfer_moztypesat);
        map.insert(2763.into(), &super::use_counter_page::datatransfer_mozusercancelled_getter);
        map.insert(2764.into(), &super::use_counter_page::datatransfer_mozusercancelled_setter);
        map.insert(2765.into(), &super::use_counter_page::datatransferitem_webkitgetasentry);
        map.insert(2766.into(), &super::use_counter_page::document_caretrangefrompoint);
        map.insert(2767.into(), &super::use_counter_page::document_exec_command_content_read_only);
        map.insert(2768.into(), &super::use_counter_page::document_exitpictureinpicture);
        map.insert(2769.into(), &super::use_counter_page::document_featurepolicy);
        map.insert(2770.into(), &super::use_counter_page::document_mozsetimageelement);
        map.insert(2771.into(), &super::use_counter_page::document_onbeforecopy);
        map.insert(2772.into(), &super::use_counter_page::document_onbeforecut);
        map.insert(2773.into(), &super::use_counter_page::document_onbeforepaste);
        map.insert(2774.into(), &super::use_counter_page::document_oncancel);
        map.insert(2775.into(), &super::use_counter_page::document_onfreeze);
        map.insert(2776.into(), &super::use_counter_page::document_onmousewheel);
        map.insert(2777.into(), &super::use_counter_page::document_onresume);
        map.insert(2778.into(), &super::use_counter_page::document_onsearch);
        map.insert(2779.into(), &super::use_counter_page::document_onwebkitfullscreenchange);
        map.insert(2780.into(), &super::use_counter_page::document_onwebkitfullscreenerror);
        map.insert(2781.into(), &super::use_counter_page::document_open);
        map.insert(2782.into(), &super::use_counter_page::document_pictureinpictureelement);
        map.insert(2783.into(), &super::use_counter_page::document_pictureinpictureenabled);
        map.insert(2784.into(), &super::use_counter_page::document_query_command_state_or_value_content_read_only);
        map.insert(2785.into(), &super::use_counter_page::document_query_command_state_or_value_insert_br_on_return);
        map.insert(2786.into(), &super::use_counter_page::document_query_command_supported_or_enabled_content_read_only);
        map.insert(2787.into(), &super::use_counter_page::document_query_command_supported_or_enabled_insert_br_on_return);
        map.insert(2788.into(), &super::use_counter_page::document_registerelement);
        map.insert(2789.into(), &super::use_counter_page::document_wasdiscarded);
        map.insert(2790.into(), &super::use_counter_page::document_webkitcancelfullscreen);
        map.insert(2791.into(), &super::use_counter_page::document_webkitcurrentfullscreenelement);
        map.insert(2792.into(), &super::use_counter_page::document_webkitexitfullscreen);
        map.insert(2793.into(), &super::use_counter_page::document_webkitfullscreenelement);
        map.insert(2794.into(), &super::use_counter_page::document_webkitfullscreenenabled);
        map.insert(2795.into(), &super::use_counter_page::document_webkithidden);
        map.insert(2796.into(), &super::use_counter_page::document_webkitisfullscreen);
        map.insert(2797.into(), &super::use_counter_page::document_webkitvisibilitystate);
        map.insert(2798.into(), &super::use_counter_page::document_xmlencoding);
        map.insert(2799.into(), &super::use_counter_page::document_xmlstandalone);
        map.insert(2800.into(), &super::use_counter_page::document_xmlversion);
        map.insert(2801.into(), &super::use_counter_page::domparser_parsefromstring);
        map.insert(2802.into(), &super::use_counter_page::element_attachshadow);
        map.insert(2803.into(), &super::use_counter_page::element_computedstylemap);
        map.insert(2804.into(), &super::use_counter_page::element_onmousewheel);
        map.insert(2805.into(), &super::use_counter_page::element_releasecapture);
        map.insert(2806.into(), &super::use_counter_page::element_releasepointercapture);
        map.insert(2807.into(), &super::use_counter_page::element_scrollintoviewifneeded);
        map.insert(2808.into(), &super::use_counter_page::element_setcapture);
        map.insert(2809.into(), &super::use_counter_page::element_sethtml);
        map.insert(2810.into(), &super::use_counter_page::element_setpointercapture);
        map.insert(2811.into(), &super::use_counter_page::enumerate_devices_insec);
        map.insert(2812.into(), &super::use_counter_page::enumerate_devices_unfocused);
        map.insert(2813.into(), &super::use_counter_page::fe_blend);
        map.insert(2814.into(), &super::use_counter_page::fe_color_matrix);
        map.insert(2815.into(), &super::use_counter_page::fe_component_transfer);
        map.insert(2816.into(), &super::use_counter_page::fe_composite);
        map.insert(2817.into(), &super::use_counter_page::fe_convolve_matrix);
        map.insert(2818.into(), &super::use_counter_page::fe_diffuse_lighting);
        map.insert(2819.into(), &super::use_counter_page::fe_displacement_map);
        map.insert(2820.into(), &super::use_counter_page::fe_flood);
        map.insert(2821.into(), &super::use_counter_page::fe_gaussian_blur);
        map.insert(2822.into(), &super::use_counter_page::fe_image);
        map.insert(2823.into(), &super::use_counter_page::fe_merge);
        map.insert(2824.into(), &super::use_counter_page::fe_morphology);
        map.insert(2825.into(), &super::use_counter_page::fe_offset);
        map.insert(2826.into(), &super::use_counter_page::fe_specular_lighting);
        map.insert(2827.into(), &super::use_counter_page::fe_tile);
        map.insert(2828.into(), &super::use_counter_page::fe_turbulence);
        map.insert(2829.into(), &super::use_counter_page::filtered_cross_origin_iframe);
        map.insert(2830.into(), &super::use_counter_page::get_user_media_insec);
        map.insert(2831.into(), &super::use_counter_page::get_user_media_unfocused);
        map.insert(2832.into(), &super::use_counter_page::htmlbuttonelement_popovertargetaction);
        map.insert(2833.into(), &super::use_counter_page::htmlbuttonelement_popovertargetelement);
        map.insert(2834.into(), &super::use_counter_page::htmldialogelement_show);
        map.insert(2835.into(), &super::use_counter_page::htmldocument_named_getter_hit);
        map.insert(2836.into(), &super::use_counter_page::htmlelement_attributestylemap);
        map.insert(2837.into(), &super::use_counter_page::htmlelement_hidepopover);
        map.insert(2838.into(), &super::use_counter_page::htmlelement_popover);
        map.insert(2839.into(), &super::use_counter_page::htmlelement_showpopover);
        map.insert(2840.into(), &super::use_counter_page::htmlelement_togglepopover);
        map.insert(2841.into(), &super::use_counter_page::htmliframeelement_loading);
        map.insert(2842.into(), &super::use_counter_page::htmlinputelement_capture);
        map.insert(2843.into(), &super::use_counter_page::htmlinputelement_incremental);
        map.insert(2844.into(), &super::use_counter_page::htmlinputelement_onsearch);
        map.insert(2845.into(), &super::use_counter_page::htmlinputelement_popovertargetaction);
        map.insert(2846.into(), &super::use_counter_page::htmlinputelement_popovertargetelement);
        map.insert(2847.into(), &super::use_counter_page::htmlinputelement_webkitdirectory);
        map.insert(2848.into(), &super::use_counter_page::htmlinputelement_webkitentries);
        map.insert(2849.into(), &super::use_counter_page::htmlmediaelement_disableremoteplayback);
        map.insert(2850.into(), &super::use_counter_page::htmlmediaelement_remote);
        map.insert(2851.into(), &super::use_counter_page::htmlvideoelement_cancelvideoframecallback);
        map.insert(2852.into(), &super::use_counter_page::htmlvideoelement_disablepictureinpicture);
        map.insert(2853.into(), &super::use_counter_page::htmlvideoelement_onenterpictureinpicture);
        map.insert(2854.into(), &super::use_counter_page::htmlvideoelement_onleavepictureinpicture);
        map.insert(2855.into(), &super::use_counter_page::htmlvideoelement_playsinline);
        map.insert(2856.into(), &super::use_counter_page::htmlvideoelement_requestpictureinpicture);
        map.insert(2857.into(), &super::use_counter_page::htmlvideoelement_requestvideoframecallback);
        map.insert(2858.into(), &super::use_counter_page::imagedata_colorspace);
        map.insert(2859.into(), &super::use_counter_page::js_asmjs);
        map.insert(2860.into(), &super::use_counter_page::js_wasm);
        map.insert(2861.into(), &super::use_counter_page::js_wasm_legacy_exceptions);
        map.insert(2862.into(), &super::use_counter_page::location_ancestororigins);
        map.insert(2863.into(), &super::use_counter_page::mediadevices_enumeratedevices);
        map.insert(2864.into(), &super::use_counter_page::mediadevices_getdisplaymedia);
        map.insert(2865.into(), &super::use_counter_page::mediadevices_getusermedia);
        map.insert(2866.into(), &super::use_counter_page::mixed_content_not_upgraded_audio_failure);
        map.insert(2867.into(), &super::use_counter_page::mixed_content_not_upgraded_audio_success);
        map.insert(2868.into(), &super::use_counter_page::mixed_content_not_upgraded_image_failure);
        map.insert(2869.into(), &super::use_counter_page::mixed_content_not_upgraded_image_success);
        map.insert(2870.into(), &super::use_counter_page::mixed_content_not_upgraded_video_failure);
        map.insert(2871.into(), &super::use_counter_page::mixed_content_not_upgraded_video_success);
        map.insert(2872.into(), &super::use_counter_page::mixed_content_upgraded_audio_failure);
        map.insert(2873.into(), &super::use_counter_page::mixed_content_upgraded_audio_success);
        map.insert(2874.into(), &super::use_counter_page::mixed_content_upgraded_image_failure);
        map.insert(2875.into(), &super::use_counter_page::mixed_content_upgraded_image_success);
        map.insert(2876.into(), &super::use_counter_page::mixed_content_upgraded_video_failure);
        map.insert(2877.into(), &super::use_counter_page::mixed_content_upgraded_video_success);
        map.insert(2878.into(), &super::use_counter_page::moz_get_user_media_insec);
        map.insert(2879.into(), &super::use_counter_page::navigator_canshare);
        map.insert(2880.into(), &super::use_counter_page::navigator_clearappbadge);
        map.insert(2881.into(), &super::use_counter_page::navigator_mozgetusermedia);
        map.insert(2882.into(), &super::use_counter_page::navigator_setappbadge);
        map.insert(2883.into(), &super::use_counter_page::navigator_share);
        map.insert(2884.into(), &super::use_counter_page::navigator_useractivation);
        map.insert(2885.into(), &super::use_counter_page::navigator_wakelock);
        map.insert(2886.into(), &super::use_counter_page::ondommousescroll);
        map.insert(2887.into(), &super::use_counter_page::onmozmousepixelscroll);
        map.insert(2888.into(), &super::use_counter_page::onoverflow);
        map.insert(2889.into(), &super::use_counter_page::onunderflow);
        map.insert(2890.into(), &super::use_counter_page::percentage_stroke_width_in_svg);
        map.insert(2891.into(), &super::use_counter_page::percentage_stroke_width_in_svgtext);
        map.insert(2892.into(), &super::use_counter_page::private_browsing_caches_delete);
        map.insert(2893.into(), &super::use_counter_page::private_browsing_caches_has);
        map.insert(2894.into(), &super::use_counter_page::private_browsing_caches_keys);
        map.insert(2895.into(), &super::use_counter_page::private_browsing_caches_match);
        map.insert(2896.into(), &super::use_counter_page::private_browsing_caches_open);
        map.insert(2897.into(), &super::use_counter_page::private_browsing_idbfactory_delete_database);
        map.insert(2898.into(), &super::use_counter_page::private_browsing_idbfactory_open);
        map.insert(2899.into(), &super::use_counter_page::private_browsing_navigator_service_worker);
        map.insert(2900.into(), &super::use_counter_page::pushmanager_subscribe);
        map.insert(2901.into(), &super::use_counter_page::pushsubscription_unsubscribe);
        map.insert(2902.into(), &super::use_counter_page::range_createcontextualfragment);
        map.insert(2903.into(), &super::use_counter_page::sanitizer_constructor);
        map.insert(2904.into(), &super::use_counter_page::sanitizer_sanitize);
        map.insert(2905.into(), &super::use_counter_page::scheduler_posttask);
        map.insert(2906.into(), &super::use_counter_page::shadowroot_pictureinpictureelement);
        map.insert(2907.into(), &super::use_counter_page::svgsvgelement_currentscale_getter);
        map.insert(2908.into(), &super::use_counter_page::svgsvgelement_currentscale_setter);
        map.insert(2909.into(), &super::use_counter_page::svgsvgelement_getelementbyid);
        map.insert(2910.into(), &super::use_counter_page::window_absoluteorientationsensor);
        map.insert(2911.into(), &super::use_counter_page::window_accelerometer);
        map.insert(2912.into(), &super::use_counter_page::window_backgroundfetchmanager);
        map.insert(2913.into(), &super::use_counter_page::window_backgroundfetchrecord);
        map.insert(2914.into(), &super::use_counter_page::window_backgroundfetchregistration);
        map.insert(2915.into(), &super::use_counter_page::window_beforeinstallpromptevent);
        map.insert(2916.into(), &super::use_counter_page::window_bluetooth);
        map.insert(2917.into(), &super::use_counter_page::window_bluetoothcharacteristicproperties);
        map.insert(2918.into(), &super::use_counter_page::window_bluetoothdevice);
        map.insert(2919.into(), &super::use_counter_page::window_bluetoothremotegattcharacteristic);
        map.insert(2920.into(), &super::use_counter_page::window_bluetoothremotegattdescriptor);
        map.insert(2921.into(), &super::use_counter_page::window_bluetoothremotegattserver);
        map.insert(2922.into(), &super::use_counter_page::window_bluetoothremotegattservice);
        map.insert(2923.into(), &super::use_counter_page::window_bluetoothuuid);
        map.insert(2924.into(), &super::use_counter_page::window_canvascapturemediastreamtrack);
        map.insert(2925.into(), &super::use_counter_page::window_chrome);
        map.insert(2926.into(), &super::use_counter_page::window_clipboarditem);
        map.insert(2927.into(), &super::use_counter_page::window_cssimagevalue);
        map.insert(2928.into(), &super::use_counter_page::window_csskeywordvalue);
        map.insert(2929.into(), &super::use_counter_page::window_cssmathclamp);
        map.insert(2930.into(), &super::use_counter_page::window_cssmathinvert);
        map.insert(2931.into(), &super::use_counter_page::window_cssmathmax);
        map.insert(2932.into(), &super::use_counter_page::window_cssmathmin);
        map.insert(2933.into(), &super::use_counter_page::window_cssmathnegate);
        map.insert(2934.into(), &super::use_counter_page::window_cssmathproduct);
        map.insert(2935.into(), &super::use_counter_page::window_cssmathsum);
        map.insert(2936.into(), &super::use_counter_page::window_cssmathvalue);
        map.insert(2937.into(), &super::use_counter_page::window_cssmatrixcomponent);
        map.insert(2938.into(), &super::use_counter_page::window_cssnumericarray);
        map.insert(2939.into(), &super::use_counter_page::window_cssnumericvalue);
        map.insert(2940.into(), &super::use_counter_page::window_cssperspective);
        map.insert(2941.into(), &super::use_counter_page::window_csspositionvalue);
        map.insert(2942.into(), &super::use_counter_page::window_csspropertyrule);
        map.insert(2943.into(), &super::use_counter_page::window_cssrotate);
        map.insert(2944.into(), &super::use_counter_page::window_cssscale);
        map.insert(2945.into(), &super::use_counter_page::window_cssskew);
        map.insert(2946.into(), &super::use_counter_page::window_cssskewx);
        map.insert(2947.into(), &super::use_counter_page::window_cssskewy);
        map.insert(2948.into(), &super::use_counter_page::window_cssstylevalue);
        map.insert(2949.into(), &super::use_counter_page::window_csstransformcomponent);
        map.insert(2950.into(), &super::use_counter_page::window_csstransformvalue);
        map.insert(2951.into(), &super::use_counter_page::window_csstranslate);
        map.insert(2952.into(), &super::use_counter_page::window_cssunitvalue);
        map.insert(2953.into(), &super::use_counter_page::window_cssunparsedvalue);
        map.insert(2954.into(), &super::use_counter_page::window_cssvariablereferencevalue);
        map.insert(2955.into(), &super::use_counter_page::window_defaultstatus);
        map.insert(2956.into(), &super::use_counter_page::window_devicemotioneventacceleration);
        map.insert(2957.into(), &super::use_counter_page::window_devicemotioneventrotationrate);
        map.insert(2958.into(), &super::use_counter_page::window_domerror);
        map.insert(2959.into(), &super::use_counter_page::window_encodedvideochunk);
        map.insert(2960.into(), &super::use_counter_page::window_enterpictureinpictureevent);
        map.insert(2961.into(), &super::use_counter_page::window_external);
        map.insert(2962.into(), &super::use_counter_page::window_federatedcredential);
        map.insert(2963.into(), &super::use_counter_page::window_gyroscope);
        map.insert(2964.into(), &super::use_counter_page::window_htmlcontentelement);
        map.insert(2965.into(), &super::use_counter_page::window_htmlshadowelement);
        map.insert(2966.into(), &super::use_counter_page::window_imagecapture);
        map.insert(2967.into(), &super::use_counter_page::window_inputdevicecapabilities);
        map.insert(2968.into(), &super::use_counter_page::window_inputdeviceinfo);
        map.insert(2969.into(), &super::use_counter_page::window_keyboard);
        map.insert(2970.into(), &super::use_counter_page::window_keyboardlayoutmap);
        map.insert(2971.into(), &super::use_counter_page::window_linearaccelerationsensor);
        map.insert(2972.into(), &super::use_counter_page::window_mediasettingsrange);
        map.insert(2973.into(), &super::use_counter_page::window_midiaccess);
        map.insert(2974.into(), &super::use_counter_page::window_midiconnectionevent);
        map.insert(2975.into(), &super::use_counter_page::window_midiinput);
        map.insert(2976.into(), &super::use_counter_page::window_midiinputmap);
        map.insert(2977.into(), &super::use_counter_page::window_midimessageevent);
        map.insert(2978.into(), &super::use_counter_page::window_midioutput);
        map.insert(2979.into(), &super::use_counter_page::window_midioutputmap);
        map.insert(2980.into(), &super::use_counter_page::window_midiport);
        map.insert(2981.into(), &super::use_counter_page::window_networkinformation);
        map.insert(2982.into(), &super::use_counter_page::window_offscreenbuffering);
        map.insert(2983.into(), &super::use_counter_page::window_onbeforeinstallprompt);
        map.insert(2984.into(), &super::use_counter_page::window_oncancel);
        map.insert(2985.into(), &super::use_counter_page::window_onmousewheel);
        map.insert(2986.into(), &super::use_counter_page::window_onorientationchange);
        map.insert(2987.into(), &super::use_counter_page::window_onsearch);
        map.insert(2988.into(), &super::use_counter_page::window_onselectionchange);
        map.insert(2989.into(), &super::use_counter_page::window_open_empty_url);
        map.insert(2990.into(), &super::use_counter_page::window_opendatabase);
        map.insert(2991.into(), &super::use_counter_page::window_orientation);
        map.insert(2992.into(), &super::use_counter_page::window_orientationsensor);
        map.insert(2993.into(), &super::use_counter_page::window_overconstrainederror);
        map.insert(2994.into(), &super::use_counter_page::window_passwordcredential);
        map.insert(2995.into(), &super::use_counter_page::window_paymentaddress);
        map.insert(2996.into(), &super::use_counter_page::window_paymentinstruments);
        map.insert(2997.into(), &super::use_counter_page::window_paymentmanager);
        map.insert(2998.into(), &super::use_counter_page::window_paymentmethodchangeevent);
        map.insert(2999.into(), &super::use_counter_page::window_paymentrequest);
        map.insert(3000.into(), &super::use_counter_page::window_paymentrequestupdateevent);
        map.insert(3001.into(), &super::use_counter_page::window_paymentresponse);
        map.insert(3002.into(), &super::use_counter_page::window_performancelongtasktiming);
        map.insert(3003.into(), &super::use_counter_page::window_photocapabilities);
        map.insert(3004.into(), &super::use_counter_page::window_pictureinpictureevent);
        map.insert(3005.into(), &super::use_counter_page::window_pictureinpicturewindow);
        map.insert(3006.into(), &super::use_counter_page::window_presentation);
        map.insert(3007.into(), &super::use_counter_page::window_presentationavailability);
        map.insert(3008.into(), &super::use_counter_page::window_presentationconnection);
        map.insert(3009.into(), &super::use_counter_page::window_presentationconnectionavailableevent);
        map.insert(3010.into(), &super::use_counter_page::window_presentationconnectioncloseevent);
        map.insert(3011.into(), &super::use_counter_page::window_presentationconnectionlist);
        map.insert(3012.into(), &super::use_counter_page::window_presentationreceiver);
        map.insert(3013.into(), &super::use_counter_page::window_presentationrequest);
        map.insert(3014.into(), &super::use_counter_page::window_relativeorientationsensor);
        map.insert(3015.into(), &super::use_counter_page::window_remoteplayback);
        map.insert(3016.into(), &super::use_counter_page::window_report);
        map.insert(3017.into(), &super::use_counter_page::window_reportbody);
        map.insert(3018.into(), &super::use_counter_page::window_reportingobserver);
        map.insert(3019.into(), &super::use_counter_page::window_rtcerror);
        map.insert(3020.into(), &super::use_counter_page::window_rtcerrorevent);
        map.insert(3021.into(), &super::use_counter_page::window_rtcicetransport);
        map.insert(3022.into(), &super::use_counter_page::window_rtcpeerconnectioniceerrorevent);
        map.insert(3023.into(), &super::use_counter_page::window_sensor);
        map.insert(3024.into(), &super::use_counter_page::window_sensorerrorevent);
        map.insert(3025.into(), &super::use_counter_page::window_sidebar_getter);
        map.insert(3026.into(), &super::use_counter_page::window_sidebar_setter);
        map.insert(3027.into(), &super::use_counter_page::window_speechrecognitionalternative);
        map.insert(3028.into(), &super::use_counter_page::window_speechrecognitionresult);
        map.insert(3029.into(), &super::use_counter_page::window_speechrecognitionresultlist);
        map.insert(3030.into(), &super::use_counter_page::window_stylemedia);
        map.insert(3031.into(), &super::use_counter_page::window_stylepropertymap);
        map.insert(3032.into(), &super::use_counter_page::window_stylepropertymapreadonly);
        map.insert(3033.into(), &super::use_counter_page::window_svgdiscardelement);
        map.insert(3034.into(), &super::use_counter_page::window_syncmanager);
        map.insert(3035.into(), &super::use_counter_page::window_taskattributiontiming);
        map.insert(3036.into(), &super::use_counter_page::window_textevent);
        map.insert(3037.into(), &super::use_counter_page::window_touch);
        map.insert(3038.into(), &super::use_counter_page::window_touchevent);
        map.insert(3039.into(), &super::use_counter_page::window_touchlist);
        map.insert(3040.into(), &super::use_counter_page::window_usb);
        map.insert(3041.into(), &super::use_counter_page::window_usbalternateinterface);
        map.insert(3042.into(), &super::use_counter_page::window_usbconfiguration);
        map.insert(3043.into(), &super::use_counter_page::window_usbconnectionevent);
        map.insert(3044.into(), &super::use_counter_page::window_usbdevice);
        map.insert(3045.into(), &super::use_counter_page::window_usbendpoint);
        map.insert(3046.into(), &super::use_counter_page::window_usbinterface);
        map.insert(3047.into(), &super::use_counter_page::window_usbintransferresult);
        map.insert(3048.into(), &super::use_counter_page::window_usbisochronousintransferpacket);
        map.insert(3049.into(), &super::use_counter_page::window_usbisochronousintransferresult);
        map.insert(3050.into(), &super::use_counter_page::window_usbisochronousouttransferpacket);
        map.insert(3051.into(), &super::use_counter_page::window_usbisochronousouttransferresult);
        map.insert(3052.into(), &super::use_counter_page::window_usbouttransferresult);
        map.insert(3053.into(), &super::use_counter_page::window_useractivation);
        map.insert(3054.into(), &super::use_counter_page::window_videocolorspace);
        map.insert(3055.into(), &super::use_counter_page::window_videodecoder);
        map.insert(3056.into(), &super::use_counter_page::window_videoencoder);
        map.insert(3057.into(), &super::use_counter_page::window_videoframe);
        map.insert(3058.into(), &super::use_counter_page::window_wakelock);
        map.insert(3059.into(), &super::use_counter_page::window_wakelocksentinel);
        map.insert(3060.into(), &super::use_counter_page::window_webkitcancelanimationframe);
        map.insert(3061.into(), &super::use_counter_page::window_webkitmediastream);
        map.insert(3062.into(), &super::use_counter_page::window_webkitmutationobserver);
        map.insert(3063.into(), &super::use_counter_page::window_webkitrequestanimationframe);
        map.insert(3064.into(), &super::use_counter_page::window_webkitrequestfilesystem);
        map.insert(3065.into(), &super::use_counter_page::window_webkitresolvelocalfilesystemurl);
        map.insert(3066.into(), &super::use_counter_page::window_webkitrtcpeerconnection);
        map.insert(3067.into(), &super::use_counter_page::window_webkitspeechgrammar);
        map.insert(3068.into(), &super::use_counter_page::window_webkitspeechgrammarlist);
        map.insert(3069.into(), &super::use_counter_page::window_webkitspeechrecognition);
        map.insert(3070.into(), &super::use_counter_page::window_webkitspeechrecognitionerror);
        map.insert(3071.into(), &super::use_counter_page::window_webkitspeechrecognitionevent);
        map.insert(3072.into(), &super::use_counter_page::window_webkitstorageinfo);
        map.insert(3073.into(), &super::use_counter_page::workernavigator_permissions);
        map.insert(3074.into(), &super::use_counter_page::wr_filter_fallback);
        map.insert(3075.into(), &super::use_counter_page::xslstylesheet);
        map.insert(3076.into(), &super::use_counter_page::xsltprocessor_constructor);
        map.insert(3077.into(), &super::use_counter_page::you_tube_flash_embed);
        map.insert(3078.into(), &super::use_counter_worker_dedicated::console_assert);
        map.insert(3079.into(), &super::use_counter_worker_dedicated::console_clear);
        map.insert(3080.into(), &super::use_counter_worker_dedicated::console_count);
        map.insert(3081.into(), &super::use_counter_worker_dedicated::console_countreset);
        map.insert(3082.into(), &super::use_counter_worker_dedicated::console_debug);
        map.insert(3083.into(), &super::use_counter_worker_dedicated::console_dir);
        map.insert(3084.into(), &super::use_counter_worker_dedicated::console_dirxml);
        map.insert(3085.into(), &super::use_counter_worker_dedicated::console_error);
        map.insert(3086.into(), &super::use_counter_worker_dedicated::console_exception);
        map.insert(3087.into(), &super::use_counter_worker_dedicated::console_group);
        map.insert(3088.into(), &super::use_counter_worker_dedicated::console_groupcollapsed);
        map.insert(3089.into(), &super::use_counter_worker_dedicated::console_groupend);
        map.insert(3090.into(), &super::use_counter_worker_dedicated::console_info);
        map.insert(3091.into(), &super::use_counter_worker_dedicated::console_log);
        map.insert(3092.into(), &super::use_counter_worker_dedicated::console_profile);
        map.insert(3093.into(), &super::use_counter_worker_dedicated::console_profileend);
        map.insert(3094.into(), &super::use_counter_worker_dedicated::console_table);
        map.insert(3095.into(), &super::use_counter_worker_dedicated::console_time);
        map.insert(3096.into(), &super::use_counter_worker_dedicated::console_timeend);
        map.insert(3097.into(), &super::use_counter_worker_dedicated::console_timelog);
        map.insert(3098.into(), &super::use_counter_worker_dedicated::console_timestamp);
        map.insert(3099.into(), &super::use_counter_worker_dedicated::console_trace);
        map.insert(3100.into(), &super::use_counter_worker_dedicated::console_warn);
        map.insert(3101.into(), &super::use_counter_worker_dedicated::private_browsing_caches_delete);
        map.insert(3102.into(), &super::use_counter_worker_dedicated::private_browsing_caches_has);
        map.insert(3103.into(), &super::use_counter_worker_dedicated::private_browsing_caches_keys);
        map.insert(3104.into(), &super::use_counter_worker_dedicated::private_browsing_caches_match);
        map.insert(3105.into(), &super::use_counter_worker_dedicated::private_browsing_caches_open);
        map.insert(3106.into(), &super::use_counter_worker_dedicated::private_browsing_idbfactory_delete_database);
        map.insert(3107.into(), &super::use_counter_worker_dedicated::private_browsing_idbfactory_open);
        map.insert(3108.into(), &super::use_counter_worker_dedicated::pushmanager_subscribe);
        map.insert(3109.into(), &super::use_counter_worker_dedicated::pushsubscription_unsubscribe);
        map.insert(3110.into(), &super::use_counter_worker_dedicated::scheduler_posttask);
        map.insert(3111.into(), &super::use_counter_worker_service::console_assert);
        map.insert(3112.into(), &super::use_counter_worker_service::console_clear);
        map.insert(3113.into(), &super::use_counter_worker_service::console_count);
        map.insert(3114.into(), &super::use_counter_worker_service::console_countreset);
        map.insert(3115.into(), &super::use_counter_worker_service::console_debug);
        map.insert(3116.into(), &super::use_counter_worker_service::console_dir);
        map.insert(3117.into(), &super::use_counter_worker_service::console_dirxml);
        map.insert(3118.into(), &super::use_counter_worker_service::console_error);
        map.insert(3119.into(), &super::use_counter_worker_service::console_exception);
        map.insert(3120.into(), &super::use_counter_worker_service::console_group);
        map.insert(3121.into(), &super::use_counter_worker_service::console_groupcollapsed);
        map.insert(3122.into(), &super::use_counter_worker_service::console_groupend);
        map.insert(3123.into(), &super::use_counter_worker_service::console_info);
        map.insert(3124.into(), &super::use_counter_worker_service::console_log);
        map.insert(3125.into(), &super::use_counter_worker_service::console_profile);
        map.insert(3126.into(), &super::use_counter_worker_service::console_profileend);
        map.insert(3127.into(), &super::use_counter_worker_service::console_table);
        map.insert(3128.into(), &super::use_counter_worker_service::console_time);
        map.insert(3129.into(), &super::use_counter_worker_service::console_timeend);
        map.insert(3130.into(), &super::use_counter_worker_service::console_timelog);
        map.insert(3131.into(), &super::use_counter_worker_service::console_timestamp);
        map.insert(3132.into(), &super::use_counter_worker_service::console_trace);
        map.insert(3133.into(), &super::use_counter_worker_service::console_warn);
        map.insert(3134.into(), &super::use_counter_worker_service::private_browsing_caches_delete);
        map.insert(3135.into(), &super::use_counter_worker_service::private_browsing_caches_has);
        map.insert(3136.into(), &super::use_counter_worker_service::private_browsing_caches_keys);
        map.insert(3137.into(), &super::use_counter_worker_service::private_browsing_caches_match);
        map.insert(3138.into(), &super::use_counter_worker_service::private_browsing_caches_open);
        map.insert(3139.into(), &super::use_counter_worker_service::private_browsing_idbfactory_delete_database);
        map.insert(3140.into(), &super::use_counter_worker_service::private_browsing_idbfactory_open);
        map.insert(3141.into(), &super::use_counter_worker_service::pushmanager_subscribe);
        map.insert(3142.into(), &super::use_counter_worker_service::pushsubscription_unsubscribe);
        map.insert(3143.into(), &super::use_counter_worker_service::scheduler_posttask);
        map.insert(3144.into(), &super::use_counter_worker_shared::console_assert);
        map.insert(3145.into(), &super::use_counter_worker_shared::console_clear);
        map.insert(3146.into(), &super::use_counter_worker_shared::console_count);
        map.insert(3147.into(), &super::use_counter_worker_shared::console_countreset);
        map.insert(3148.into(), &super::use_counter_worker_shared::console_debug);
        map.insert(3149.into(), &super::use_counter_worker_shared::console_dir);
        map.insert(3150.into(), &super::use_counter_worker_shared::console_dirxml);
        map.insert(3151.into(), &super::use_counter_worker_shared::console_error);
        map.insert(3152.into(), &super::use_counter_worker_shared::console_exception);
        map.insert(3153.into(), &super::use_counter_worker_shared::console_group);
        map.insert(3154.into(), &super::use_counter_worker_shared::console_groupcollapsed);
        map.insert(3155.into(), &super::use_counter_worker_shared::console_groupend);
        map.insert(3156.into(), &super::use_counter_worker_shared::console_info);
        map.insert(3157.into(), &super::use_counter_worker_shared::console_log);
        map.insert(3158.into(), &super::use_counter_worker_shared::console_profile);
        map.insert(3159.into(), &super::use_counter_worker_shared::console_profileend);
        map.insert(3160.into(), &super::use_counter_worker_shared::console_table);
        map.insert(3161.into(), &super::use_counter_worker_shared::console_time);
        map.insert(3162.into(), &super::use_counter_worker_shared::console_timeend);
        map.insert(3163.into(), &super::use_counter_worker_shared::console_timelog);
        map.insert(3164.into(), &super::use_counter_worker_shared::console_timestamp);
        map.insert(3165.into(), &super::use_counter_worker_shared::console_trace);
        map.insert(3166.into(), &super::use_counter_worker_shared::console_warn);
        map.insert(3167.into(), &super::use_counter_worker_shared::private_browsing_caches_delete);
        map.insert(3168.into(), &super::use_counter_worker_shared::private_browsing_caches_has);
        map.insert(3169.into(), &super::use_counter_worker_shared::private_browsing_caches_keys);
        map.insert(3170.into(), &super::use_counter_worker_shared::private_browsing_caches_match);
        map.insert(3171.into(), &super::use_counter_worker_shared::private_browsing_caches_open);
        map.insert(3172.into(), &super::use_counter_worker_shared::private_browsing_idbfactory_delete_database);
        map.insert(3173.into(), &super::use_counter_worker_shared::private_browsing_idbfactory_open);
        map.insert(3174.into(), &super::use_counter_worker_shared::pushmanager_subscribe);
        map.insert(3175.into(), &super::use_counter_worker_shared::pushsubscription_unsubscribe);
        map.insert(3176.into(), &super::use_counter_worker_shared::scheduler_posttask);
        map.insert(3183.into(), &super::ls_request::recv_cancellation);
        map.insert(3184.into(), &super::ls_request::send_cancellation);
        map.insert(3186.into(), &super::hls::canplay_requested);
        map.insert(3187.into(), &super::hls::canplay_supported);
        map.insert(3191.into(), &super::media::element_in_page_count);
        map.insert(3222.into(), &super::webrtcdtls::client_handshake_started_counter);
        map.insert(3225.into(), &super::webrtcdtls::server_handshake_started_counter);
        map.insert(3227.into(), &super::dom_contentprocess::build_id_mismatch);
        map.insert(3228.into(), &super::dom_contentprocess::build_id_mismatch_false_positive);
        map.insert(3229.into(), &super::dom_contentprocess::os_priority_change_considered);
        map.insert(3230.into(), &super::dom_contentprocess::os_priority_lowered);
        map.insert(3231.into(), &super::dom_contentprocess::os_priority_raised);
        map.insert(3241.into(), &super::mathml::doc_count);
        map.insert(3261.into(), &super::web_notification::insecure_context_permission_request);
        map.insert(3265.into(), &super::web_push::detected_duplicated_message_ids);
        map.insert(3274.into(), &super::httpsfirst::upgraded);
        map.insert(3275.into(), &super::httpsfirst::upgraded_schemeless);
        map.insert(3277.into(), &super::webauthn_create::failure);
        map.insert(3278.into(), &super::webauthn_create::passkey);
        map.insert(3279.into(), &super::webauthn_create::success);
        map.insert(3281.into(), &super::webauthn_get::failure);
        map.insert(3282.into(), &super::webauthn_get::success);
        map.insert(3287.into(), &super::gfx::skipped_composites);
        map.insert(3391.into(), &super::netwerk::parent_connect_timeout);
        map.insert(3438.into(), &super::opaque_response_blocking::cross_origin_opaque_response_count);
        map.insert(3439.into(), &super::opaque_response_blocking::javascript_validation_count);
        map.insert(3516.into(), &super::bounce_tracking_protection::purge_count_classified_tracker);
        map.insert(3521.into(), &super::contentblocking::trackers_blocked_count);
        map.insert(3549.into(), &super::cookie_banners::cookie_injection_fail);
        map.insert(3593.into(), &super::crash_submission::failure);
        map.insert(3594.into(), &super::crash_submission::pending);
        map.insert(3595.into(), &super::crash_submission::success);
        map.insert(3711.into(), &super::fog::inits_during_shutdown);
        map.insert(3715.into(), &super::fog_ipc::flush_failures);
        map.insert(3716.into(), &super::fog_ipc::replay_failures);
        map.insert(3717.into(), &super::fog_ipc::shutdown_registration_failures);
        map.insert(3718.into(), &super::test_only::bad_code);
        map.insert(3746.into(), &super::test_only_ipc::a_counter);
        map.insert(3767.into(), &super::test_only_jog::a_counter);
        map.insert(3888.into(), &super::pdfjs::used);
        map.insert(3890.into(), &super::pdfjs_editing_highlight::color_changed);
        map.insert(3891.into(), &super::pdfjs_editing_highlight::deleted);
        map.insert(3892.into(), &super::pdfjs_editing_highlight::edited);
        map.insert(3896.into(), &super::pdfjs_editing_highlight::print);
        map.insert(3897.into(), &super::pdfjs_editing_highlight::save);
        map.insert(3899.into(), &super::pdfjs_editing_highlight::thickness_changed);
        map.insert(3900.into(), &super::pdfjs_editing_highlight::toggle_visibility);
        map.insert(3954.into(), &super::page_icon::fit_icon_count);
        map.insert(3955.into(), &super::page_icon::small_icon_count);
        map.insert(3959.into(), &super::places::sponsored_visit_no_triggering_url);
        map.insert(3960.into(), &super::printing::dialog_opened_via_preview_tm);
        map.insert(3961.into(), &super::printing::dialog_via_preview_cancelled_tm);
        map.insert(3963.into(), &super::printing::preview_cancelled_tm);
        map.insert(3964.into(), &super::printing::preview_opened_tm);
        map.insert(3966.into(), &super::printing::silent_print);
        map.insert(3968.into(), &super::power::cpu_time_bogus_values);
        map.insert(3972.into(), &super::power::gpu_time_bogus_values);
        map.insert(3974.into(), &super::power::total_cpu_time_ms);
        map.insert(3975.into(), &super::power::total_gpu_time_ms);
        map.insert(3976.into(), &super::power::total_thread_wakeups);
        map.insert(4300.into(), &super::findbar::find_next);
        map.insert(4301.into(), &super::findbar::find_prev);
        map.insert(4302.into(), &super::findbar::highlight_all);
        map.insert(4303.into(), &super::findbar::match_case);
        map.insert(4304.into(), &super::findbar::match_diacritics);
        map.insert(4305.into(), &super::findbar::shown);
        map.insert(4306.into(), &super::findbar::whole_words);
        map.insert(4420.into(), &super::update::no_window_auto_restarts);
        map
    });

    pub static CUSTOM_DISTRIBUTION_MAP: Lazy<HashMap<MetricId, &Lazy<CustomDistributionMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(58);
        map.insert(68.into(), &super::networking::cookie_access_fixup_diff);
        map.insert(69.into(), &super::networking::cookie_chips_partition_limit_overflow);
        map.insert(70.into(), &super::networking::cookie_count_part_by_key);
        map.insert(71.into(), &super::networking::cookie_count_partitioned);
        map.insert(72.into(), &super::networking::cookie_count_total);
        map.insert(73.into(), &super::networking::cookie_count_unpart_by_key);
        map.insert(74.into(), &super::networking::cookie_count_unpartitioned);
        map.insert(75.into(), &super::networking::cookie_creation_fixup_diff);
        map.insert(76.into(), &super::networking::cookie_purge_entry_max);
        map.insert(77.into(), &super::networking::cookie_purge_max);
        map.insert(87.into(), &super::networking::http_1_download_throughput);
        map.insert(88.into(), &super::networking::http_1_upload_throughput);
        map.insert(89.into(), &super::networking::http_1_upload_throughput_100);
        map.insert(90.into(), &super::networking::http_1_upload_throughput_10_50);
        map.insert(91.into(), &super::networking::http_1_upload_throughput_50_100);
        map.insert(92.into(), &super::networking::http_2_download_throughput);
        map.insert(93.into(), &super::networking::http_2_upload_throughput);
        map.insert(94.into(), &super::networking::http_2_upload_throughput_100);
        map.insert(95.into(), &super::networking::http_2_upload_throughput_10_50);
        map.insert(96.into(), &super::networking::http_2_upload_throughput_50_100);
        map.insert(97.into(), &super::networking::http_3_download_throughput);
        map.insert(98.into(), &super::networking::http_3_download_throughput_100);
        map.insert(99.into(), &super::networking::http_3_download_throughput_10_50);
        map.insert(100.into(), &super::networking::http_3_download_throughput_50_100);
        map.insert(101.into(), &super::networking::http_3_ecn_ce_ect0_ratio_received);
        map.insert(102.into(), &super::networking::http_3_ecn_ce_ect0_ratio_sent);
        map.insert(104.into(), &super::networking::http_3_loss_ratio);
        map.insert(107.into(), &super::networking::http_3_udp_datagram_segments_received);
        map.insert(109.into(), &super::networking::http_3_upload_throughput);
        map.insert(110.into(), &super::networking::http_3_upload_throughput_100);
        map.insert(111.into(), &super::networking::http_3_upload_throughput_10_50);
        map.insert(112.into(), &super::networking::http_3_upload_throughput_50_100);
        map.insert(3177.into(), &super::geolocation::accuracy);
        map.insert(3300.into(), &super::gfx_checkerboard::peak_pixel_count);
        map.insert(3302.into(), &super::gfx_checkerboard::severity);
        map.insert(3305.into(), &super::gfx_content_frame_time::from_paint);
        map.insert(3306.into(), &super::gfx_content_frame_time::from_vsync);
        map.insert(3308.into(), &super::gfx_content_frame_time::with_svg);
        map.insert(3309.into(), &super::gfx_content_frame_time::without_resource_upload);
        map.insert(3310.into(), &super::gfx_content_frame_time::without_upload);
        map.insert(3363.into(), &super::performance_clone_deserialize::items);
        map.insert(3369.into(), &super::geckoview::document_site_origins);
        map.insert(3373.into(), &super::geckoview::per_document_site_origins);
        map.insert(3435.into(), &super::network::tls_early_data_bytes_written);
        map.insert(3452.into(), &super::cert_compression::brotli_saved_bytes);
        map.insert(3455.into(), &super::cert_compression::zlib_saved_bytes);
        map.insert(3456.into(), &super::cert_compression::zstd_saved_bytes);
        map.insert(3513.into(), &super::bounce_tracking_protection::num_hosts_per_purge_run);
        map.insert(3559.into(), &super::cookie_banners_click::query_selector_run_count_per_window_frame);
        map.insert(3560.into(), &super::cookie_banners_click::query_selector_run_count_per_window_top_level);
        map.insert(3561.into(), &super::cookie_banners_click::query_selector_run_duration_per_window_frame);
        map.insert(3562.into(), &super::cookie_banners_click::query_selector_run_duration_per_window_top_level);
        map.insert(3639.into(), &super::extensions_timing::event_page_running_time);
        map.insert(3747.into(), &super::test_only_ipc::a_custom_dist);
        map.insert(3887.into(), &super::pdfjs::time_to_view);
        map.insert(3898.into(), &super::pdfjs_editing_highlight::thickness);
        map.insert(3978.into(), &super::power_battery::percentage_when_user_active);
        map.insert(4434.into(), &super::timer_thread::timers_fired_per_wakeup);
        map
    });

    pub static DENOMINATOR_MAP: Lazy<HashMap<MetricId, &Lazy<DenominatorMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(11);
        map.insert(145.into(), &super::networking::set_cookie);
        map.insert(3205.into(), &super::rtcrtpsender::count);
        map.insert(3206.into(), &super::rtcrtpsender::count_setparameters_compat);
        map.insert(3270.into(), &super::httpsfirst::downgraded);
        map.insert(3273.into(), &super::httpsfirst::downgraded_schemeless);
        map.insert(3443.into(), &super::cert_signature_cache::total);
        map.insert(3445.into(), &super::cert_trust_cache::total);
        map.insert(3451.into(), &super::sct_signature_cache::total);
        map.insert(3467.into(), &super::tls::certificate_verifications);
        map.insert(3759.into(), &super::test_only_ipc::an_external_denominator);
        map.insert(4259.into(), &super::translations::requests_count);
        map
    });

    pub static NUMERATOR_MAP: Lazy<HashMap<MetricId, &Lazy<NumeratorMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(27);
        map.insert(146.into(), &super::networking::set_cookie_expired_without_server_time);
        map.insert(147.into(), &super::networking::set_cookie_foreign);
        map.insert(148.into(), &super::networking::set_cookie_foreign_partitioned);
        map.insert(149.into(), &super::networking::set_cookie_partitioned);
        map.insert(3207.into(), &super::rtcrtpsender::used_sendencodings);
        map.insert(3208.into(), &super::rtcrtpsender_setparameters::fail_length_changed);
        map.insert(3209.into(), &super::rtcrtpsender_setparameters::fail_no_encodings);
        map.insert(3210.into(), &super::rtcrtpsender_setparameters::fail_no_getparameters);
        map.insert(3211.into(), &super::rtcrtpsender_setparameters::fail_no_transactionid);
        map.insert(3212.into(), &super::rtcrtpsender_setparameters::fail_other);
        map.insert(3213.into(), &super::rtcrtpsender_setparameters::fail_rid_changed);
        map.insert(3214.into(), &super::rtcrtpsender_setparameters::fail_stale_transactionid);
        map.insert(3215.into(), &super::rtcrtpsender_setparameters::warn_length_changed);
        map.insert(3216.into(), &super::rtcrtpsender_setparameters::warn_no_getparameters);
        map.insert(3217.into(), &super::rtcrtpsender_setparameters::warn_no_transactionid);
        map.insert(3271.into(), &super::httpsfirst::downgraded_on_timer);
        map.insert(3272.into(), &super::httpsfirst::downgraded_on_timer_schemeless);
        map.insert(3442.into(), &super::cert_signature_cache::hits);
        map.insert(3444.into(), &super::cert_trust_cache::hits);
        map.insert(3450.into(), &super::sct_signature_cache::hits);
        map.insert(3469.into(), &super::verification_used_cert_from::built_in_roots_module);
        map.insert(3470.into(), &super::verification_used_cert_from::nss_cert_db);
        map.insert(3471.into(), &super::verification_used_cert_from::preloaded_intermediates);
        map.insert(3472.into(), &super::verification_used_cert_from::third_party_certificates);
        map.insert(3473.into(), &super::verification_used_cert_from::tls_handshake);
        map.insert(3766.into(), &super::test_only_ipc::rate_with_external_denominator);
        map.insert(4257.into(), &super::translations::error_rate);
        map
    });

    pub static STRING_LIST_MAP: Lazy<HashMap<MetricId, &Lazy<StringListMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(19);
        map.insert(215.into(), &super::background_update::reasons_to_not_update);
        map.insert(223.into(), &super::background_update::reasons);
        map.insert(224.into(), &super::background_update::states);
        map.insert(275.into(), &super::browser_migration::matched_extensions);
        map.insert(284.into(), &super::browser_migration::unmatched_extensions);
        map.insert(375.into(), &super::newtab::blocked_sponsors);
        map.insert(387.into(), &super::newtab::selected_topics);
        map.insert(388.into(), &super::newtab::sov_allocation);
        map.insert(3588.into(), &super::crash::utility_actors_name);
        map.insert(3597.into(), &super::dll_blocklist::list);
        map.insert(3599.into(), &super::environment::experimental_features);
        map.insert(3723.into(), &super::test_only::cheesy_string_list);
        map.insert(3753.into(), &super::test_only_ipc::a_string_list);
        map.insert(3995.into(), &super::broken_site_report_browser_info_app::default_locales);
        map.insert(4013.into(), &super::broken_site_report_browser_info_security::antispyware);
        map.insert(4014.into(), &super::broken_site_report_browser_info_security::antivirus);
        map.insert(4015.into(), &super::broken_site_report_browser_info_security::firewall);
        map.insert(4018.into(), &super::broken_site_report_tab_info::languages);
        map.insert(4109.into(), &super::characteristics::gamepads);
        map
    });

    pub static DATETIME_MAP: Lazy<HashMap<MetricId, &Lazy<DatetimeMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(13);
        map.insert(216.into(), &super::background_update::time_last_update_scheduled);
        map.insert(225.into(), &super::background_update::targeting_env_current_date);
        map.insert(227.into(), &super::background_update::targeting_env_profile_age);
        map.insert(409.into(), &super::pocket::fetch_timestamp);
        map.insert(412.into(), &super::pocket::newtab_creation_timestamp);
        map.insert(3587.into(), &super::crash::time);
        map.insert(3740.into(), &super::test_only::what_a_date);
        map.insert(3748.into(), &super::test_only_ipc::a_date);
        map.insert(4403.into(), &super::blocklist::last_modified_rs_addons_mblf);
        map.insert(4404.into(), &super::blocklist::mlbf_generation_time);
        map.insert(4405.into(), &super::blocklist::mlbf_softblocks_generation_time);
        map.insert(4408.into(), &super::blocklist::mlbf_stash_time_newest);
        map.insert(4409.into(), &super::blocklist::mlbf_stash_time_oldest);
        map
    });

    pub static UUID_MAP: Lazy<HashMap<MetricId, &Lazy<UuidMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(14);
        map.insert(219.into(), &super::background_update::client_id);
        map.insert(342.into(), &super::messaging_system::browser_session_id);
        map.insert(344.into(), &super::messaging_system::client_id);
        map.insert(356.into(), &super::messaging_system::impression_id);
        map.insert(419.into(), &super::top_sites::context_id);
        map.insert(441.into(), &super::pocket_button::impression_id);
        map.insert(562.into(), &super::search_with::context_id);
        map.insert(689.into(), &super::quick_suggest::context_id);
        map.insert(3476.into(), &super::client_association::legacy_client_id);
        map.insert(3742.into(), &super::test_only::what_id_it);
        map.insert(3757.into(), &super::test_only_ipc::a_uuid);
        map.insert(4069.into(), &super::characteristics::client_identifier);
        map.insert(4250.into(), &super::legacy_telemetry::client_id);
        map.insert(4251.into(), &super::legacy_telemetry::profile_group_id);
        map
    });

    pub static TIMESPAN_MAP: Lazy<HashMap<MetricId, &Lazy<TimespanMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(7);
        map.insert(286.into(), &super::migration::time_to_produce_migrator_list);
        map.insert(3601.into(), &super::environment::uptime);
        map.insert(3618.into(), &super::extensions::startup_cache_load_time);
        map.insert(3710.into(), &super::fog::initialization);
        map.insert(3721.into(), &super::test_only::can_we_time_it);
        map.insert(3736.into(), &super::test_only::mirror_time);
        map.insert(3737.into(), &super::test_only::mirror_time_nanos);
        map
    });

    pub static TEXT_MAP: Lazy<HashMap<MetricId, &Lazy<TextMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(38);
        map.insert(346.into(), &super::messaging_system::event_context);
        map.insert(350.into(), &super::messaging_system::event_screen_family);
        map.insert(351.into(), &super::messaging_system::event_screen_id);
        map.insert(353.into(), &super::messaging_system::event_screen_initials);
        map.insert(359.into(), &super::messaging_system::message_id);
        map.insert(414.into(), &super::pocket::shim);
        map.insert(434.into(), &super::topsites::sponsored_tiles_received);
        map.insert(3754.into(), &super::test_only_ipc::a_text);
        map.insert(3993.into(), &super::broken_site_report::description);
        map.insert(3996.into(), &super::broken_site_report_browser_info_app::default_useragent_string);
        map.insert(3999.into(), &super::broken_site_report_browser_info_graphics::devices_json);
        map.insert(4000.into(), &super::broken_site_report_browser_info_graphics::drivers_json);
        map.insert(4001.into(), &super::broken_site_report_browser_info_graphics::features_json);
        map.insert(4003.into(), &super::broken_site_report_browser_info_graphics::monitors_json);
        map.insert(4019.into(), &super::broken_site_report_tab_info::useragent_string);
        map.insert(4082.into(), &super::characteristics::errors);
        map.insert(4110.into(), &super::characteristics::gl_extensions);
        map.insert(4111.into(), &super::characteristics::gl_extensions_raw);
        map.insert(4113.into(), &super::characteristics::gl_minimal_source);
        map.insert(4114.into(), &super::characteristics::gl_params_extensions);
        map.insert(4115.into(), &super::characteristics::gl_params_v1);
        map.insert(4116.into(), &super::characteristics::gl_params_v2);
        map.insert(4117.into(), &super::characteristics::gl_precision_fragment);
        map.insert(4118.into(), &super::characteristics::gl_precision_vertex);
        map.insert(4128.into(), &super::characteristics::ice_foundations);
        map.insert(4135.into(), &super::characteristics::js_errors);
        map.insert(4138.into(), &super::characteristics::math_ops);
        map.insert(4150.into(), &super::characteristics::media_capabilities);
        map.insert(4151.into(), &super::characteristics::media_capabilities_h264);
        map.insert(4152.into(), &super::characteristics::media_capabilities_not_efficient);
        map.insert(4153.into(), &super::characteristics::media_capabilities_not_smooth);
        map.insert(4154.into(), &super::characteristics::media_capabilities_unsupported);
        map.insert(4155.into(), &super::characteristics::media_devices);
        map.insert(4157.into(), &super::characteristics::missing_fonts);
        map.insert(4215.into(), &super::characteristics::voices);
        map.insert(4222.into(), &super::characteristics::voices_sample);
        map.insert(4223.into(), &super::characteristics::voices_sha1);
        map.insert(4224.into(), &super::characteristics::webglinfo);
        map
    });

    pub static URL_MAP: Lazy<HashMap<MetricId, &Lazy<UrlMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(7);
        map.insert(422.into(), &super::top_sites::reporting_url);
        map.insert(563.into(), &super::search_with::reporting_url);
        map.insert(696.into(), &super::quick_suggest::reporting_url);
        map.insert(3756.into(), &super::test_only_ipc::a_url);
        map.insert(3994.into(), &super::broken_site_report::url);
        map.insert(4231.into(), &super::search_engine_default::submission_url);
        map.insert(4237.into(), &super::search_engine_private::submission_url);
        map
    });

    pub static RATE_MAP: Lazy<HashMap<MetricId, &Lazy<RateMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(3);
        map.insert(3440.into(), &super::parsing::svg_unusual_pcdata);
        map.insert(3565.into(), &super::cookie_banners_cmp::ratio_handled_by_cmp_rule);
        map.insert(3764.into(), &super::test_only_ipc::irate);
        map
    });


    pub(crate) fn set_object_by_id(metric_id: u32, value: String) -> Result<(), ()> {
        match metric_id {
          571 => {
              super::serp::experiment_info.set_string(value);
              Ok(())
          }
          726 => {
              super::browser_ui::toolbar_widgets.set_string(value);
              Ok(())
          }
          3570 => {
              super::crash::async_shutdown_timeout.set_string(value);
              Ok(())
          }
          3582 => {
              super::crash::quota_manager_shutdown_timeout.set_string(value);
              Ok(())
          }
          3585 => {
              super::crash::stack_traces.set_string(value);
              Ok(())
          }
          3719 => {
              super::test_only::balloons.set_string(value);
              Ok(())
          }
          3724 => {
              super::test_only::crash_stack.set_string(value);
              Ok(())
          }
           _ => Err(()),
        }
    }

    /// Wrapper to get the currently stored object for object metric as a string.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `ping_name` - (Optional) The ping name to look into.
    ///                 Defaults to the first value in `send_in_pings`.
    ///
    /// # Returns
    ///
    /// Returns the recorded object serialized as a JSON string or `None` if nothing stored.
    ///
    /// # Panics
    ///
    /// Panics if no object by the given metric ID could be found.
    pub(crate) fn object_test_get_value(metric_id: u32, ping_name: Option<String>) -> Option<String> {
        match metric_id {
           571 => super::serp::experiment_info.test_get_value_as_str(ping_name.as_deref()),
           726 => super::browser_ui::toolbar_widgets.test_get_value_as_str(ping_name.as_deref()),
           3570 => super::crash::async_shutdown_timeout.test_get_value_as_str(ping_name.as_deref()),
           3582 => super::crash::quota_manager_shutdown_timeout.test_get_value_as_str(ping_name.as_deref()),
           3585 => super::crash::stack_traces.test_get_value_as_str(ping_name.as_deref()),
           3719 => super::test_only::balloons.test_get_value_as_str(ping_name.as_deref()),
           3724 => super::test_only::crash_stack.test_get_value_as_str(ping_name.as_deref()),
           _ => panic!("No object for metric id {}", metric_id),
        }
    }

    /// Check the provided object for errors.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    ///
    /// # Returns
    ///
    /// Returns a string for the recorded error or `None`.
    ///
    /// # Panics
    ///
    /// Panics if no object by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn object_test_get_error(metric_id: u32) -> Option<String> {
        #[cfg(feature = "with_gecko")]
        match metric_id {
           571 => test_get_errors!(super::serp::experiment_info),
           726 => test_get_errors!(super::browser_ui::toolbar_widgets),
           3570 => test_get_errors!(super::crash::async_shutdown_timeout),
           3582 => test_get_errors!(super::crash::quota_manager_shutdown_timeout),
           3585 => test_get_errors!(super::crash::stack_traces),
           3719 => test_get_errors!(super::test_only::balloons),
           3724 => test_get_errors!(super::test_only::crash_stack),
           _ => panic!("No object for metric id {}", metric_id),
        }

        #[cfg(not(feature = "with_gecko"))]
        {
            return None;
        }
    }

    /// Wrapper to record an event based on its metric ID.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `extra`     - An map of (extra key id, string) pairs.
    ///                 The map will be decoded into the appropriate `ExtraKeys` type.
    /// # Returns
    ///
    /// Returns `Ok(())` if the event was found and `record` was called with the given `extra`,
    /// or an `EventRecordingError::InvalidId` if no event by that ID exists
    /// or an `EventRecordingError::InvalidExtraKey` if the `extra` map could not be deserialized.
    pub(crate) fn record_event_by_id(metric_id: u32, extra: HashMap<String, String>) -> Result<(), EventRecordingError> {
        match metric_id {
          9 => {
              super::privacy_sanitize::clear.record_raw(extra);
              Ok(())
          }
          10 => {
              super::privacy_sanitize::clearing_time_span_selected.record_raw(extra);
              Ok(())
          }
          11 => {
              super::privacy_sanitize::dialog_open.record_raw(extra);
              Ok(())
          }
          13 => {
              super::security_ui_protectionspopup::click_cookieb_toggle_off.record_raw(extra);
              Ok(())
          }
          14 => {
              super::security_ui_protectionspopup::click_cookieb_toggle_on.record_raw(extra);
              Ok(())
          }
          15 => {
              super::security_ui_protectionspopup::click_cookies.record_raw(extra);
              Ok(())
          }
          16 => {
              super::security_ui_protectionspopup::click_cryptominers.record_raw(extra);
              Ok(())
          }
          17 => {
              super::security_ui_protectionspopup::click_etp_toggle_off.record_raw(extra);
              Ok(())
          }
          18 => {
              super::security_ui_protectionspopup::click_etp_toggle_on.record_raw(extra);
              Ok(())
          }
          19 => {
              super::security_ui_protectionspopup::click_fingerprinters.record_raw(extra);
              Ok(())
          }
          20 => {
              super::security_ui_protectionspopup::click_full_report.record_raw(extra);
              Ok(())
          }
          21 => {
              super::security_ui_protectionspopup::click_milestone_message.record_raw(extra);
              Ok(())
          }
          22 => {
              super::security_ui_protectionspopup::click_protectionspopup_cfr.record_raw(extra);
              Ok(())
          }
          23 => {
              super::security_ui_protectionspopup::click_settings.record_raw(extra);
              Ok(())
          }
          24 => {
              super::security_ui_protectionspopup::click_social.record_raw(extra);
              Ok(())
          }
          25 => {
              super::security_ui_protectionspopup::click_subview_settings.record_raw(extra);
              Ok(())
          }
          26 => {
              super::security_ui_protectionspopup::click_trackers.record_raw(extra);
              Ok(())
          }
          27 => {
              super::security_ui_protectionspopup::open_protections_popup.record_raw(extra);
              Ok(())
          }
          28 => {
              super::security_ui_protectionspopup::open_protectionspopup_cfr.record_raw(extra);
              Ok(())
          }
          51 => {
              super::doh::evaluate_v2_heuristics.record_raw(extra);
              Ok(())
          }
          52 => {
              super::doh::state_disabled.record_raw(extra);
              Ok(())
          }
          53 => {
              super::doh::state_enabled.record_raw(extra);
              Ok(())
          }
          54 => {
              super::doh::state_manually_disabled.record_raw(extra);
              Ok(())
          }
          55 => {
              super::doh::state_policy_disabled.record_raw(extra);
              Ok(())
          }
          56 => {
              super::doh::state_rollback.record_raw(extra);
              Ok(())
          }
          57 => {
              super::doh::state_shutdown.record_raw(extra);
              Ok(())
          }
          58 => {
              super::doh::state_uidisabled.record_raw(extra);
              Ok(())
          }
          59 => {
              super::doh::state_uiok.record_raw(extra);
              Ok(())
          }
          60 => {
              super::doh::state_uninstalled.record_raw(extra);
              Ok(())
          }
          164 => {
              super::security_doh_trr_performance::resolved_record.record_raw(extra);
              Ok(())
          }
          165 => {
              super::security_doh_trr_performance::trrselect_dryrunresult.record_raw(extra);
              Ok(())
          }
          167 => {
              super::downloads::added_file_extension.record_raw(extra);
              Ok(())
          }
          169 => {
              super::firefoxview_next::browser_context_menu_tabs.record_raw(extra);
              Ok(())
          }
          170 => {
              super::firefoxview_next::card_collapsed_card_container.record_raw(extra);
              Ok(())
          }
          171 => {
              super::firefoxview_next::card_expanded_card_container.record_raw(extra);
              Ok(())
          }
          172 => {
              super::firefoxview_next::change_page_navigation.record_raw(extra);
              Ok(())
          }
          173 => {
              super::firefoxview_next::close_open_tab_tabs.record_raw(extra);
              Ok(())
          }
          174 => {
              super::firefoxview_next::context_menu_tabs.record_raw(extra);
              Ok(())
          }
          175 => {
              super::firefoxview_next::dismiss_closed_tab_tabs.record_raw(extra);
              Ok(())
          }
          176 => {
              super::firefoxview_next::entered_firefoxview.record_raw(extra);
              Ok(())
          }
          177 => {
              super::firefoxview_next::fxa_continue_sync.record_raw(extra);
              Ok(())
          }
          178 => {
              super::firefoxview_next::fxa_mobile_sync.record_raw(extra);
              Ok(())
          }
          179 => {
              super::firefoxview_next::history_visits.record_raw(extra);
              Ok(())
          }
          180 => {
              super::firefoxview_next::open_tab_tabs.record_raw(extra);
              Ok(())
          }
          181 => {
              super::firefoxview_next::recently_closed_tabs.record_raw(extra);
              Ok(())
          }
          182 => {
              super::firefoxview_next::search_initiated_search.record_raw(extra);
              Ok(())
          }
          183 => {
              super::firefoxview_next::search_show_all_showallbutton.record_raw(extra);
              Ok(())
          }
          184 => {
              super::firefoxview_next::show_all_history_tabs.record_raw(extra);
              Ok(())
          }
          185 => {
              super::firefoxview_next::sort_history_tabs.record_raw(extra);
              Ok(())
          }
          186 => {
              super::firefoxview_next::synced_tabs_tabs.record_raw(extra);
              Ok(())
          }
          187 => {
              super::firefoxview_next::tab_selected_toolbarbutton.record_raw(extra);
              Ok(())
          }
          188 => {
              super::genai_chatbot::contextmenu_prompt_click.record_raw(extra);
              Ok(())
          }
          190 => {
              super::genai_chatbot::experiment_checkbox_click.record_raw(extra);
              Ok(())
          }
          191 => {
              super::genai_chatbot::onboarding_close.record_raw(extra);
              Ok(())
          }
          192 => {
              super::genai_chatbot::onboarding_continue.record_raw(extra);
              Ok(())
          }
          193 => {
              super::genai_chatbot::onboarding_finish.record_raw(extra);
              Ok(())
          }
          194 => {
              super::genai_chatbot::onboarding_learn_more.record_raw(extra);
              Ok(())
          }
          195 => {
              super::genai_chatbot::onboarding_provider_choice_displayed.record_raw(extra);
              Ok(())
          }
          196 => {
              super::genai_chatbot::onboarding_provider_learn.record_raw(extra);
              Ok(())
          }
          197 => {
              super::genai_chatbot::onboarding_provider_selection.record_raw(extra);
              Ok(())
          }
          198 => {
              super::genai_chatbot::onboarding_provider_terms.record_raw(extra);
              Ok(())
          }
          199 => {
              super::genai_chatbot::onboarding_text_highlight_displayed.record_raw(extra);
              Ok(())
          }
          201 => {
              super::genai_chatbot::provider_change.record_raw(extra);
              Ok(())
          }
          203 => {
              super::genai_chatbot::shortcuts_checkbox_click.record_raw(extra);
              Ok(())
          }
          205 => {
              super::genai_chatbot::shortcuts_displayed.record_raw(extra);
              Ok(())
          }
          206 => {
              super::genai_chatbot::shortcuts_expanded.record_raw(extra);
              Ok(())
          }
          207 => {
              super::genai_chatbot::shortcuts_hide_click.record_raw(extra);
              Ok(())
          }
          208 => {
              super::genai_chatbot::shortcuts_prompt_click.record_raw(extra);
              Ok(())
          }
          210 => {
              super::genai_chatbot::sidebar_close_click.record_raw(extra);
              Ok(())
          }
          211 => {
              super::genai_chatbot::sidebar_more_menu_click.record_raw(extra);
              Ok(())
          }
          212 => {
              super::genai_chatbot::sidebar_more_menu_display.record_raw(extra);
              Ok(())
          }
          213 => {
              super::genai_chatbot::sidebar_provider_menu_click.record_raw(extra);
              Ok(())
          }
          214 => {
              super::genai_chatbot::sidebar_toggle.record_raw(extra);
              Ok(())
          }
          231 => {
              super::browser_launched_to_handle::system_notification.record_raw(extra);
              Ok(())
          }
          245 => {
              super::launch_on_login::last_profile_disable_startup.record_raw(extra);
              Ok(())
          }
          258 => {
              super::security::fission_principals.record_raw(extra);
              Ok(())
          }
          259 => {
              super::security::eval_usage_parent_process.record_raw(extra);
              Ok(())
          }
          260 => {
              super::security::eval_usage_system_context.record_raw(extra);
              Ok(())
          }
          261 => {
              super::security::javascript_load_parent_process.record_raw(extra);
              Ok(())
          }
          262 => {
              super::security::unexpected_load.record_raw(extra);
              Ok(())
          }
          263 => {
              super::security::pref_usage_content_process.record_raw(extra);
              Ok(())
          }
          266 => {
              super::start_menu::manually_unpinned_since_last_launch.record_raw(extra);
              Ok(())
          }
          272 => {
              super::upgrade_dialog::trigger_reason.record_raw(extra);
              Ok(())
          }
          273 => {
              super::browser_migration::browser_selected_wizard.record_raw(extra);
              Ok(())
          }
          274 => {
              super::browser_migration::linux_perms_wizard.record_raw(extra);
              Ok(())
          }
          276 => {
              super::browser_migration::migration_finished_wizard.record_raw(extra);
              Ok(())
          }
          277 => {
              super::browser_migration::migration_started_wizard.record_raw(extra);
              Ok(())
          }
          278 => {
              super::browser_migration::no_browsers_found_wizard.record_raw(extra);
              Ok(())
          }
          279 => {
              super::browser_migration::opened_wizard.record_raw(extra);
              Ok(())
          }
          280 => {
              super::browser_migration::profile_selected_wizard.record_raw(extra);
              Ok(())
          }
          281 => {
              super::browser_migration::resources_selected_wizard.record_raw(extra);
              Ok(())
          }
          282 => {
              super::browser_migration::safari_password_file_wizard.record_raw(extra);
              Ok(())
          }
          283 => {
              super::browser_migration::safari_perms_wizard.record_raw(extra);
              Ok(())
          }
          288 => {
              super::activity_stream::end_session.record_raw(extra);
              Ok(())
          }
          289 => {
              super::activity_stream::event_archive_from_pocket.record_raw(extra);
              Ok(())
          }
          290 => {
              super::activity_stream::event_block.record_raw(extra);
              Ok(())
          }
          291 => {
              super::activity_stream::event_bookmark_add.record_raw(extra);
              Ok(())
          }
          292 => {
              super::activity_stream::event_bookmark_delete.record_raw(extra);
              Ok(())
          }
          293 => {
              super::activity_stream::event_click.record_raw(extra);
              Ok(())
          }
          294 => {
              super::activity_stream::event_click_privacy_info.record_raw(extra);
              Ok(())
          }
          295 => {
              super::activity_stream::event_close_newtab_prefs.record_raw(extra);
              Ok(())
          }
          296 => {
              super::activity_stream::event_delete.record_raw(extra);
              Ok(())
          }
          297 => {
              super::activity_stream::event_delete_confirm.record_raw(extra);
              Ok(())
          }
          298 => {
              super::activity_stream::event_delete_from_pocket.record_raw(extra);
              Ok(())
          }
          299 => {
              super::activity_stream::event_dialog_cancel.record_raw(extra);
              Ok(())
          }
          300 => {
              super::activity_stream::event_dialog_open.record_raw(extra);
              Ok(())
          }
          301 => {
              super::activity_stream::event_disclaimer_acked.record_raw(extra);
              Ok(())
          }
          302 => {
              super::activity_stream::event_drag.record_raw(extra);
              Ok(())
          }
          303 => {
              super::activity_stream::event_drop.record_raw(extra);
              Ok(())
          }
          304 => {
              super::activity_stream::event_fakespot_category.record_raw(extra);
              Ok(())
          }
          305 => {
              super::activity_stream::event_fakespot_click.record_raw(extra);
              Ok(())
          }
          306 => {
              super::activity_stream::event_hide_personalize.record_raw(extra);
              Ok(())
          }
          307 => {
              super::activity_stream::event_impression.record_raw(extra);
              Ok(())
          }
          308 => {
              super::activity_stream::event_menu_add_search.record_raw(extra);
              Ok(())
          }
          309 => {
              super::activity_stream::event_menu_add_topsite.record_raw(extra);
              Ok(())
          }
          310 => {
              super::activity_stream::event_menu_collapse.record_raw(extra);
              Ok(())
          }
          311 => {
              super::activity_stream::event_menu_expand.record_raw(extra);
              Ok(())
          }
          312 => {
              super::activity_stream::event_menu_manage.record_raw(extra);
              Ok(())
          }
          313 => {
              super::activity_stream::event_menu_move_down.record_raw(extra);
              Ok(())
          }
          314 => {
              super::activity_stream::event_menu_move_up.record_raw(extra);
              Ok(())
          }
          315 => {
              super::activity_stream::event_menu_privacy_notice.record_raw(extra);
              Ok(())
          }
          316 => {
              super::activity_stream::event_menu_remove.record_raw(extra);
              Ok(())
          }
          317 => {
              super::activity_stream::event_migration_cancel.record_raw(extra);
              Ok(())
          }
          318 => {
              super::activity_stream::event_migration_start.record_raw(extra);
              Ok(())
          }
          319 => {
              super::activity_stream::event_open_new_window.record_raw(extra);
              Ok(())
          }
          320 => {
              super::activity_stream::event_open_newtab_prefs.record_raw(extra);
              Ok(())
          }
          321 => {
              super::activity_stream::event_open_private_window.record_raw(extra);
              Ok(())
          }
          322 => {
              super::activity_stream::event_pin.record_raw(extra);
              Ok(())
          }
          323 => {
              super::activity_stream::event_pocket_thumbs_down.record_raw(extra);
              Ok(())
          }
          324 => {
              super::activity_stream::event_pocket_thumbs_up.record_raw(extra);
              Ok(())
          }
          325 => {
              super::activity_stream::event_pref_changed.record_raw(extra);
              Ok(())
          }
          326 => {
              super::activity_stream::event_preview_request.record_raw(extra);
              Ok(())
          }
          327 => {
              super::activity_stream::event_save_to_pocket.record_raw(extra);
              Ok(())
          }
          328 => {
              super::activity_stream::event_search.record_raw(extra);
              Ok(())
          }
          329 => {
              super::activity_stream::event_search_edit_add.record_raw(extra);
              Ok(())
          }
          330 => {
              super::activity_stream::event_search_edit_close.record_raw(extra);
              Ok(())
          }
          331 => {
              super::activity_stream::event_search_edit_delete.record_raw(extra);
              Ok(())
          }
          332 => {
              super::activity_stream::event_search_handoff.record_raw(extra);
              Ok(())
          }
          333 => {
              super::activity_stream::event_show_personalize.record_raw(extra);
              Ok(())
          }
          334 => {
              super::activity_stream::event_show_privacy_info.record_raw(extra);
              Ok(())
          }
          335 => {
              super::activity_stream::event_skipped_signin.record_raw(extra);
              Ok(())
          }
          336 => {
              super::activity_stream::event_submit_email.record_raw(extra);
              Ok(())
          }
          337 => {
              super::activity_stream::event_top_sites_edit.record_raw(extra);
              Ok(())
          }
          338 => {
              super::activity_stream::event_top_sites_edit_close.record_raw(extra);
              Ok(())
          }
          339 => {
              super::activity_stream::event_topsite_sponsor_info.record_raw(extra);
              Ok(())
          }
          340 => {
              super::activity_stream::event_unpin.record_raw(extra);
              Ok(())
          }
          376 => {
              super::newtab::closed.record_raw(extra);
              Ok(())
          }
          377 => {
              super::newtab::fakespot_about_click.record_raw(extra);
              Ok(())
          }
          378 => {
              super::newtab::fakespot_category.record_raw(extra);
              Ok(())
          }
          379 => {
              super::newtab::fakespot_click.record_raw(extra);
              Ok(())
          }
          380 => {
              super::newtab::fakespot_cta_click.record_raw(extra);
              Ok(())
          }
          381 => {
              super::newtab::fakespot_dismiss.record_raw(extra);
              Ok(())
          }
          382 => {
              super::newtab::fakespot_product_impression.record_raw(extra);
              Ok(())
          }
          386 => {
              super::newtab::opened.record_raw(extra);
              Ok(())
          }
          389 => {
              super::newtab::tooltip_click.record_raw(extra);
              Ok(())
          }
          390 => {
              super::newtab::topic_selection_dismiss.record_raw(extra);
              Ok(())
          }
          391 => {
              super::newtab::topic_selection_open.record_raw(extra);
              Ok(())
          }
          392 => {
              super::newtab::topic_selection_topics_saved.record_raw(extra);
              Ok(())
          }
          393 => {
              super::newtab::wallpaper_category_click.record_raw(extra);
              Ok(())
          }
          394 => {
              super::newtab::wallpaper_click.record_raw(extra);
              Ok(())
          }
          395 => {
              super::newtab::wallpaper_highlight_cta_click.record_raw(extra);
              Ok(())
          }
          396 => {
              super::newtab::wallpaper_highlight_dismissed.record_raw(extra);
              Ok(())
          }
          397 => {
              super::newtab::weather_change_display.record_raw(extra);
              Ok(())
          }
          399 => {
              super::newtab::weather_impression.record_raw(extra);
              Ok(())
          }
          400 => {
              super::newtab::weather_load_error.record_raw(extra);
              Ok(())
          }
          401 => {
              super::newtab::weather_location_selected.record_raw(extra);
              Ok(())
          }
          402 => {
              super::newtab::weather_open_provider_url.record_raw(extra);
              Ok(())
          }
          405 => {
              super::newtab_search::issued.record_raw(extra);
              Ok(())
          }
          406 => {
              super::pocket::click.record_raw(extra);
              Ok(())
          }
          407 => {
              super::pocket::dismiss.record_raw(extra);
              Ok(())
          }
          410 => {
              super::pocket::impression.record_raw(extra);
              Ok(())
          }
          413 => {
              super::pocket::save.record_raw(extra);
              Ok(())
          }
          416 => {
              super::pocket::thumb_voting_interaction.record_raw(extra);
              Ok(())
          }
          417 => {
              super::pocket::topic_click.record_raw(extra);
              Ok(())
          }
          425 => {
              super::topsites::click.record_raw(extra);
              Ok(())
          }
          426 => {
              super::topsites::dismiss.record_raw(extra);
              Ok(())
          }
          428 => {
              super::topsites::impression.record_raw(extra);
              Ok(())
          }
          429 => {
              super::topsites::pref_changed.record_raw(extra);
              Ok(())
          }
          431 => {
              super::topsites::show_privacy_click.record_raw(extra);
              Ok(())
          }
          445 => {
              super::aboutpreferences::show_click.record_raw(extra);
              Ok(())
          }
          446 => {
              super::aboutpreferences::show_hash.record_raw(extra);
              Ok(())
          }
          447 => {
              super::aboutpreferences::show_initial.record_raw(extra);
              Ok(())
          }
          448 => {
              super::intl_ui_browser_language::accept_dialog.record_raw(extra);
              Ok(())
          }
          449 => {
              super::intl_ui_browser_language::add_dialog.record_raw(extra);
              Ok(())
          }
          450 => {
              super::intl_ui_browser_language::apply_main.record_raw(extra);
              Ok(())
          }
          451 => {
              super::intl_ui_browser_language::cancel_dialog.record_raw(extra);
              Ok(())
          }
          452 => {
              super::intl_ui_browser_language::manage_main.record_raw(extra);
              Ok(())
          }
          453 => {
              super::intl_ui_browser_language::remove_dialog.record_raw(extra);
              Ok(())
          }
          454 => {
              super::intl_ui_browser_language::reorder_dialog.record_raw(extra);
              Ok(())
          }
          455 => {
              super::intl_ui_browser_language::reorder_main.record_raw(extra);
              Ok(())
          }
          456 => {
              super::intl_ui_browser_language::search_dialog.record_raw(extra);
              Ok(())
          }
          457 => {
              super::intl_ui_browser_language::search_main.record_raw(extra);
              Ok(())
          }
          458 => {
              super::intl_ui_browser_language::set_fallback_dialog.record_raw(extra);
              Ok(())
          }
          459 => {
              super::privacy_ui_fpp_click::checkbox.record_raw(extra);
              Ok(())
          }
          460 => {
              super::privacy_ui_fpp_click::menu.record_raw(extra);
              Ok(())
          }
          461 => {
              super::security_doh_settings::mode_changed_button.record_raw(extra);
              Ok(())
          }
          462 => {
              super::security_doh_settings::provider_choice_value.record_raw(extra);
              Ok(())
          }
          463 => {
              super::security_doh_settings::warn_checkbox_checkbox.record_raw(extra);
              Ok(())
          }
          464 => {
              super::aboutprivatebrowsing::click_dismiss_button.record_raw(extra);
              Ok(())
          }
          465 => {
              super::aboutprivatebrowsing::click_info_link.record_raw(extra);
              Ok(())
          }
          466 => {
              super::aboutprivatebrowsing::click_promo_link.record_raw(extra);
              Ok(())
          }
          467 => {
              super::private_browsing_reset_pbm::confirm_panel.record_raw(extra);
              Ok(())
          }
          468 => {
              super::private_browsing_reset_pbm::reset_action.record_raw(extra);
              Ok(())
          }
          469 => {
              super::security_ui_protections::click_lw_about_link.record_raw(extra);
              Ok(())
          }
          470 => {
              super::security_ui_protections::click_lw_open_button.record_raw(extra);
              Ok(())
          }
          471 => {
              super::security_ui_protections::click_lw_sync_link.record_raw(extra);
              Ok(())
          }
          472 => {
              super::security_ui_protections::click_mobile_app_link.record_raw(extra);
              Ok(())
          }
          473 => {
              super::security_ui_protections::click_mtr_about_link.record_raw(extra);
              Ok(())
          }
          474 => {
              super::security_ui_protections::click_mtr_report_link.record_raw(extra);
              Ok(())
          }
          475 => {
              super::security_ui_protections::click_mtr_signup_button.record_raw(extra);
              Ok(())
          }
          476 => {
              super::security_ui_protections::click_settings_link.record_raw(extra);
              Ok(())
          }
          477 => {
              super::security_ui_protections::click_trackers_about_link.record_raw(extra);
              Ok(())
          }
          478 => {
              super::security_ui_protections::click_vpn_app_link_android.record_raw(extra);
              Ok(())
          }
          479 => {
              super::security_ui_protections::click_vpn_app_link_ios.record_raw(extra);
              Ok(())
          }
          480 => {
              super::security_ui_protections::click_vpn_banner_close.record_raw(extra);
              Ok(())
          }
          481 => {
              super::security_ui_protections::click_vpn_banner_link.record_raw(extra);
              Ok(())
          }
          482 => {
              super::security_ui_protections::click_vpn_card_link.record_raw(extra);
              Ok(())
          }
          483 => {
              super::security_ui_protections::close_protection_report.record_raw(extra);
              Ok(())
          }
          484 => {
              super::security_ui_protections::show_protection_report.record_raw(extra);
              Ok(())
          }
          485 => {
              super::security_ui_protections::show_vpn_banner.record_raw(extra);
              Ok(())
          }
          488 => {
              super::protocolhandler_mailto::visit.record_raw(extra);
              Ok(())
          }
          489 => {
              super::screenshots::canceled_context_menu.record_raw(extra);
              Ok(())
          }
          490 => {
              super::screenshots::canceled_escape.record_raw(extra);
              Ok(())
          }
          491 => {
              super::screenshots::canceled_navigation.record_raw(extra);
              Ok(())
          }
          492 => {
              super::screenshots::canceled_overlay_cancel.record_raw(extra);
              Ok(())
          }
          493 => {
              super::screenshots::canceled_preview_cancel.record_raw(extra);
              Ok(())
          }
          494 => {
              super::screenshots::canceled_quick_actions.record_raw(extra);
              Ok(())
          }
          495 => {
              super::screenshots::canceled_shortcut.record_raw(extra);
              Ok(())
          }
          496 => {
              super::screenshots::canceled_toolbar_button.record_raw(extra);
              Ok(())
          }
          497 => {
              super::screenshots::copy_overlay_copy.record_raw(extra);
              Ok(())
          }
          498 => {
              super::screenshots::copy_preview_copy.record_raw(extra);
              Ok(())
          }
          499 => {
              super::screenshots::download_overlay_download.record_raw(extra);
              Ok(())
          }
          500 => {
              super::screenshots::download_preview_download.record_raw(extra);
              Ok(())
          }
          501 => {
              super::screenshots::failed_screenshot_too_large.record_raw(extra);
              Ok(())
          }
          502 => {
              super::screenshots::selected_element.record_raw(extra);
              Ok(())
          }
          503 => {
              super::screenshots::selected_full_page.record_raw(extra);
              Ok(())
          }
          504 => {
              super::screenshots::selected_region_selection.record_raw(extra);
              Ok(())
          }
          505 => {
              super::screenshots::selected_visible.record_raw(extra);
              Ok(())
          }
          506 => {
              super::screenshots::started_context_menu.record_raw(extra);
              Ok(())
          }
          507 => {
              super::screenshots::started_overlay_retry.record_raw(extra);
              Ok(())
          }
          508 => {
              super::screenshots::started_preview_retry.record_raw(extra);
              Ok(())
          }
          509 => {
              super::screenshots::started_quick_actions.record_raw(extra);
              Ok(())
          }
          510 => {
              super::screenshots::started_shortcut.record_raw(extra);
              Ok(())
          }
          511 => {
              super::screenshots::started_toolbar_button.record_raw(extra);
              Ok(())
          }
          560 => {
              super::newtab_search_ad::click.record_raw(extra);
              Ok(())
          }
          561 => {
              super::newtab_search_ad::impression.record_raw(extra);
              Ok(())
          }
          564 => {
              super::serp::abandonment.record_raw(extra);
              Ok(())
          }
          565 => {
              super::serp::ad_impression.record_raw(extra);
              Ok(())
          }
          567 => {
              super::serp::categorization.record_raw(extra);
              Ok(())
          }
          570 => {
              super::serp::engagement.record_raw(extra);
              Ok(())
          }
          572 => {
              super::serp::impression.record_raw(extra);
              Ok(())
          }
          588 => {
              super::session_restore::backup_can_be_loaded_session_file.record_raw(extra);
              Ok(())
          }
          589 => {
              super::session_restore::shutdown_success_session_startup.record_raw(extra);
              Ok(())
          }
          590 => {
              super::shopping::address_bar_feature_callout_displayed.record_raw(extra);
              Ok(())
          }
          591 => {
              super::shopping::address_bar_icon_clicked.record_raw(extra);
              Ok(())
          }
          592 => {
              super::shopping::address_bar_icon_displayed.record_raw(extra);
              Ok(())
          }
          593 => {
              super::shopping::ads_exposure.record_raw(extra);
              Ok(())
          }
          595 => {
              super::shopping::surface_ads_clicked.record_raw(extra);
              Ok(())
          }
          596 => {
              super::shopping::surface_ads_impression.record_raw(extra);
              Ok(())
          }
          597 => {
              super::shopping::surface_ads_placement.record_raw(extra);
              Ok(())
          }
          598 => {
              super::shopping::surface_ads_setting_toggled.record_raw(extra);
              Ok(())
          }
          599 => {
              super::shopping::surface_analyze_reviews_none_available_clicked.record_raw(extra);
              Ok(())
          }
          600 => {
              super::shopping::surface_auto_open_setting_toggled.record_raw(extra);
              Ok(())
          }
          601 => {
              super::shopping::surface_closed.record_raw(extra);
              Ok(())
          }
          602 => {
              super::shopping::surface_displayed.record_raw(extra);
              Ok(())
          }
          603 => {
              super::shopping::surface_learn_more_clicked.record_raw(extra);
              Ok(())
          }
          604 => {
              super::shopping::surface_no_ads_available.record_raw(extra);
              Ok(())
          }
          605 => {
              super::shopping::surface_no_review_reliability_available.record_raw(extra);
              Ok(())
          }
          606 => {
              super::shopping::surface_no_thanks_button_clicked.record_raw(extra);
              Ok(())
          }
          607 => {
              super::shopping::surface_not_now_clicked.record_raw(extra);
              Ok(())
          }
          608 => {
              super::shopping::surface_onboarding_displayed.record_raw(extra);
              Ok(())
          }
          609 => {
              super::shopping::surface_opt_in_clicked.record_raw(extra);
              Ok(())
          }
          610 => {
              super::shopping::surface_opt_out_button_clicked.record_raw(extra);
              Ok(())
          }
          611 => {
              super::shopping::surface_powered_by_fakespot_link_clicked.record_raw(extra);
              Ok(())
          }
          612 => {
              super::shopping::surface_reactivated_button_clicked.record_raw(extra);
              Ok(())
          }
          613 => {
              super::shopping::surface_reanalyze_clicked.record_raw(extra);
              Ok(())
          }
          614 => {
              super::shopping::surface_settings_expand_clicked.record_raw(extra);
              Ok(())
          }
          615 => {
              super::shopping::surface_show_more_reviews_button_clicked.record_raw(extra);
              Ok(())
          }
          616 => {
              super::shopping::surface_show_privacy_policy_clicked.record_raw(extra);
              Ok(())
          }
          617 => {
              super::shopping::surface_show_quality_explainer_clicked.record_raw(extra);
              Ok(())
          }
          618 => {
              super::shopping::surface_show_quality_explainer_url_clicked.record_raw(extra);
              Ok(())
          }
          619 => {
              super::shopping::surface_show_terms_clicked.record_raw(extra);
              Ok(())
          }
          620 => {
              super::shopping::surface_stale_analysis_shown.record_raw(extra);
              Ok(())
          }
          621 => {
              super::shopping::surface_yes_keep_closed_button_clicked.record_raw(extra);
              Ok(())
          }
          627 => {
              super::bookmarks::sidebar_toggle.record_raw(extra);
              Ok(())
          }
          628 => {
              super::extension::sidebar_toggle.record_raw(extra);
              Ok(())
          }
          629 => {
              super::history::sidebar_toggle.record_raw(extra);
              Ok(())
          }
          630 => {
              super::sidebar::addon_icon_click.record_raw(extra);
              Ok(())
          }
          631 => {
              super::sidebar::bookmarks_icon_click.record_raw(extra);
              Ok(())
          }
          632 => {
              super::sidebar::chatbot_icon_click.record_raw(extra);
              Ok(())
          }
          634 => {
              super::sidebar::expand.record_raw(extra);
              Ok(())
          }
          635 => {
              super::sidebar::history_icon_click.record_raw(extra);
              Ok(())
          }
          638 => {
              super::sidebar::resize.record_raw(extra);
              Ok(())
          }
          640 => {
              super::sidebar::synced_tabs_icon_click.record_raw(extra);
              Ok(())
          }
          643 => {
              super::sidebar_customize::bookmarks_enabled.record_raw(extra);
              Ok(())
          }
          644 => {
              super::sidebar_customize::chatbot_enabled.record_raw(extra);
              Ok(())
          }
          645 => {
              super::sidebar_customize::extensions_clicked.record_raw(extra);
              Ok(())
          }
          646 => {
              super::sidebar_customize::firefox_settings_clicked.record_raw(extra);
              Ok(())
          }
          647 => {
              super::sidebar_customize::history_enabled.record_raw(extra);
              Ok(())
          }
          648 => {
              super::sidebar_customize::icon_click.record_raw(extra);
              Ok(())
          }
          649 => {
              super::sidebar_customize::panel_toggle.record_raw(extra);
              Ok(())
          }
          650 => {
              super::sidebar_customize::sidebar_display.record_raw(extra);
              Ok(())
          }
          651 => {
              super::sidebar_customize::sidebar_position.record_raw(extra);
              Ok(())
          }
          652 => {
              super::sidebar_customize::synced_tabs_enabled.record_raw(extra);
              Ok(())
          }
          653 => {
              super::sidebar_customize::tabs_display.record_raw(extra);
              Ok(())
          }
          654 => {
              super::sidebar_customize::tabs_layout.record_raw(extra);
              Ok(())
          }
          655 => {
              super::synced_tabs::sidebar_toggle.record_raw(extra);
              Ok(())
          }
          656 => {
              super::synced_tabs::click_fxa_app_menu.record_raw(extra);
              Ok(())
          }
          657 => {
              super::synced_tabs::click_fxa_avatar_menu.record_raw(extra);
              Ok(())
          }
          658 => {
              super::synced_tabs::click_synced_tabs_sidebar.record_raw(extra);
              Ok(())
          }
          706 => {
              super::urlbar::abandonment.record_raw(extra);
              Ok(())
          }
          707 => {
              super::urlbar::engagement.record_raw(extra);
              Ok(())
          }
          708 => {
              super::urlbar::exposure.record_raw(extra);
              Ok(())
          }
          709 => {
              super::urlbar::fakespot_engagement.record_raw(extra);
              Ok(())
          }
          710 => {
              super::urlbar::keyword_exposure.record_raw(extra);
              Ok(())
          }
          716 => {
              super::urlbar::quick_suggest_contextual_opt_in.record_raw(extra);
              Ok(())
          }
          718 => {
              super::addons_search_detection::etld_change_other.record_raw(extra);
              Ok(())
          }
          719 => {
              super::addons_search_detection::etld_change_webrequest.record_raw(extra);
              Ok(())
          }
          727 => {
              super::browser_usage::interaction.record_raw(extra);
              Ok(())
          }
          728 => {
              super::homepage::preference_ignore.record_raw(extra);
              Ok(())
          }
          729 => {
              super::installation::first_seen_full.record_raw(extra);
              Ok(())
          }
          730 => {
              super::installation::first_seen_msix.record_raw(extra);
              Ok(())
          }
          731 => {
              super::installation::first_seen_stub.record_raw(extra);
              Ok(())
          }
          743 => {
              super::partner_link::attribution_abort.record_raw(extra);
              Ok(())
          }
          744 => {
              super::partner_link::attribution_failure.record_raw(extra);
              Ok(())
          }
          745 => {
              super::partner_link::attribution_success.record_raw(extra);
              Ok(())
          }
          746 => {
              super::partner_link::click_newtab.record_raw(extra);
              Ok(())
          }
          747 => {
              super::partner_link::click_urlbar.record_raw(extra);
              Ok(())
          }
          751 => {
              super::devtools_main::activate_responsive_design.record_raw(extra);
              Ok(())
          }
          752 => {
              super::devtools_main::activate_split_console.record_raw(extra);
              Ok(())
          }
          753 => {
              super::devtools_main::add_breakpoint_debugger.record_raw(extra);
              Ok(())
          }
          754 => {
              super::devtools_main::blackbox_debugger.record_raw(extra);
              Ok(())
          }
          755 => {
              super::devtools_main::close_adbg_aboutdebugging.record_raw(extra);
              Ok(())
          }
          756 => {
              super::devtools_main::close_tools.record_raw(extra);
              Ok(())
          }
          757 => {
              super::devtools_main::connection_attempt_aboutdebugging.record_raw(extra);
              Ok(())
          }
          758 => {
              super::devtools_main::continue_debugger.record_raw(extra);
              Ok(())
          }
          759 => {
              super::devtools_main::deactivate_responsive_design.record_raw(extra);
              Ok(())
          }
          760 => {
              super::devtools_main::deactivate_split_console.record_raw(extra);
              Ok(())
          }
          761 => {
              super::devtools_main::device_added_aboutdebugging.record_raw(extra);
              Ok(())
          }
          762 => {
              super::devtools_main::device_removed_aboutdebugging.record_raw(extra);
              Ok(())
          }
          763 => {
              super::devtools_main::edit_html_inspector.record_raw(extra);
              Ok(())
          }
          764 => {
              super::devtools_main::edit_resend_netmonitor.record_raw(extra);
              Ok(())
          }
          765 => {
              super::devtools_main::edit_rule_ruleview.record_raw(extra);
              Ok(())
          }
          766 => {
              super::devtools_main::enter_accessibility.record_raw(extra);
              Ok(())
          }
          767 => {
              super::devtools_main::enter_application.record_raw(extra);
              Ok(())
          }
          768 => {
              super::devtools_main::enter_dom.record_raw(extra);
              Ok(())
          }
          769 => {
              super::devtools_main::enter_fake_tool4242.record_raw(extra);
              Ok(())
          }
          770 => {
              super::devtools_main::enter_inspector.record_raw(extra);
              Ok(())
          }
          771 => {
              super::devtools_main::enter_jsdebugger.record_raw(extra);
              Ok(())
          }
          772 => {
              super::devtools_main::enter_memory.record_raw(extra);
              Ok(())
          }
          773 => {
              super::devtools_main::enter_netmonitor.record_raw(extra);
              Ok(())
          }
          774 => {
              super::devtools_main::enter_options.record_raw(extra);
              Ok(())
          }
          775 => {
              super::devtools_main::enter_other.record_raw(extra);
              Ok(())
          }
          776 => {
              super::devtools_main::enter_performance.record_raw(extra);
              Ok(())
          }
          777 => {
              super::devtools_main::enter_storage.record_raw(extra);
              Ok(())
          }
          778 => {
              super::devtools_main::enter_styleeditor.record_raw(extra);
              Ok(())
          }
          779 => {
              super::devtools_main::enter_test_blank_panel.record_raw(extra);
              Ok(())
          }
          780 => {
              super::devtools_main::enter_test_tool.record_raw(extra);
              Ok(())
          }
          781 => {
              super::devtools_main::enter_test_tool1072208.record_raw(extra);
              Ok(())
          }
          782 => {
              super::devtools_main::enter_testtool1.record_raw(extra);
              Ok(())
          }
          783 => {
              super::devtools_main::enter_testtool2.record_raw(extra);
              Ok(())
          }
          784 => {
              super::devtools_main::enter_webconsole.record_raw(extra);
              Ok(())
          }
          785 => {
              super::devtools_main::enter_whatsnew.record_raw(extra);
              Ok(())
          }
          786 => {
              super::devtools_main::execute_js_webconsole.record_raw(extra);
              Ok(())
          }
          787 => {
              super::devtools_main::exit_accessibility.record_raw(extra);
              Ok(())
          }
          788 => {
              super::devtools_main::exit_application.record_raw(extra);
              Ok(())
          }
          789 => {
              super::devtools_main::exit_dom.record_raw(extra);
              Ok(())
          }
          790 => {
              super::devtools_main::exit_fake_tool4242.record_raw(extra);
              Ok(())
          }
          791 => {
              super::devtools_main::exit_inspector.record_raw(extra);
              Ok(())
          }
          792 => {
              super::devtools_main::exit_jsdebugger.record_raw(extra);
              Ok(())
          }
          793 => {
              super::devtools_main::exit_memory.record_raw(extra);
              Ok(())
          }
          794 => {
              super::devtools_main::exit_netmonitor.record_raw(extra);
              Ok(())
          }
          795 => {
              super::devtools_main::exit_options.record_raw(extra);
              Ok(())
          }
          796 => {
              super::devtools_main::exit_other.record_raw(extra);
              Ok(())
          }
          797 => {
              super::devtools_main::exit_performance.record_raw(extra);
              Ok(())
          }
          798 => {
              super::devtools_main::exit_storage.record_raw(extra);
              Ok(())
          }
          799 => {
              super::devtools_main::exit_styleeditor.record_raw(extra);
              Ok(())
          }
          800 => {
              super::devtools_main::exit_test_blank_panel.record_raw(extra);
              Ok(())
          }
          801 => {
              super::devtools_main::exit_test_tool.record_raw(extra);
              Ok(())
          }
          802 => {
              super::devtools_main::exit_test_tool1072208.record_raw(extra);
              Ok(())
          }
          803 => {
              super::devtools_main::exit_testtool1.record_raw(extra);
              Ok(())
          }
          804 => {
              super::devtools_main::exit_testtool2.record_raw(extra);
              Ok(())
          }
          805 => {
              super::devtools_main::exit_webconsole.record_raw(extra);
              Ok(())
          }
          806 => {
              super::devtools_main::exit_whatsnew.record_raw(extra);
              Ok(())
          }
          807 => {
              super::devtools_main::filters_changed_netmonitor.record_raw(extra);
              Ok(())
          }
          808 => {
              super::devtools_main::filters_changed_webconsole.record_raw(extra);
              Ok(())
          }
          809 => {
              super::devtools_main::inspect_aboutdebugging.record_raw(extra);
              Ok(())
          }
          810 => {
              super::devtools_main::jump_to_definition_webconsole.record_raw(extra);
              Ok(())
          }
          811 => {
              super::devtools_main::jump_to_source_webconsole.record_raw(extra);
              Ok(())
          }
          812 => {
              super::devtools_main::object_expanded_webconsole.record_raw(extra);
              Ok(())
          }
          813 => {
              super::devtools_main::open_adbg_aboutdebugging.record_raw(extra);
              Ok(())
          }
          814 => {
              super::devtools_main::open_tools.record_raw(extra);
              Ok(())
          }
          815 => {
              super::devtools_main::pause_debugger.record_raw(extra);
              Ok(())
          }
          816 => {
              super::devtools_main::pause_on_exceptions_debugger.record_raw(extra);
              Ok(())
          }
          817 => {
              super::devtools_main::persist_changed_netmonitor.record_raw(extra);
              Ok(())
          }
          818 => {
              super::devtools_main::persist_changed_webconsole.record_raw(extra);
              Ok(())
          }
          819 => {
              super::devtools_main::pretty_print_debugger.record_raw(extra);
              Ok(())
          }
          820 => {
              super::devtools_main::remove_breakpoint_debugger.record_raw(extra);
              Ok(())
          }
          821 => {
              super::devtools_main::reverse_search_webconsole.record_raw(extra);
              Ok(())
          }
          822 => {
              super::devtools_main::runtime_added_aboutdebugging.record_raw(extra);
              Ok(())
          }
          823 => {
              super::devtools_main::runtime_connected_aboutdebugging.record_raw(extra);
              Ok(())
          }
          824 => {
              super::devtools_main::runtime_disconnected_aboutdebugging.record_raw(extra);
              Ok(())
          }
          825 => {
              super::devtools_main::runtime_removed_aboutdebugging.record_raw(extra);
              Ok(())
          }
          826 => {
              super::devtools_main::select_page_aboutdebugging.record_raw(extra);
              Ok(())
          }
          827 => {
              super::devtools_main::select_page_application.record_raw(extra);
              Ok(())
          }
          828 => {
              super::devtools_main::select_ws_frame_netmonitor.record_raw(extra);
              Ok(())
          }
          829 => {
              super::devtools_main::show_profiler_aboutdebugging.record_raw(extra);
              Ok(())
          }
          830 => {
              super::devtools_main::sidepanel_changed_inspector.record_raw(extra);
              Ok(())
          }
          831 => {
              super::devtools_main::sidepanel_changed_netmonitor.record_raw(extra);
              Ok(())
          }
          832 => {
              super::devtools_main::start_worker_application.record_raw(extra);
              Ok(())
          }
          833 => {
              super::devtools_main::throttle_changed_netmonitor.record_raw(extra);
              Ok(())
          }
          834 => {
              super::devtools_main::tool_timer_animationinspector.record_raw(extra);
              Ok(())
          }
          835 => {
              super::devtools_main::tool_timer_changesview.record_raw(extra);
              Ok(())
          }
          836 => {
              super::devtools_main::tool_timer_compatibilityview.record_raw(extra);
              Ok(())
          }
          837 => {
              super::devtools_main::tool_timer_computedview.record_raw(extra);
              Ok(())
          }
          838 => {
              super::devtools_main::tool_timer_fontinspector.record_raw(extra);
              Ok(())
          }
          839 => {
              super::devtools_main::tool_timer_layoutview.record_raw(extra);
              Ok(())
          }
          840 => {
              super::devtools_main::tool_timer_ruleview.record_raw(extra);
              Ok(())
          }
          841 => {
              super::devtools_main::unregister_worker_application.record_raw(extra);
              Ok(())
          }
          842 => {
              super::devtools_main::update_conn_prompt_aboutdebugging.record_raw(extra);
              Ok(())
          }
          3185 => {
              super::mediadrm::eme_playback.record_raw(extra);
              Ok(())
          }
          3188 => {
              super::hls::media_load.record_raw(extra);
              Ok(())
          }
          3197 => {
              super::media_playback::first_frame_loaded.record_raw(extra);
              Ok(())
          }
          3199 => {
              super::mfcdm::eme_playback.record_raw(extra);
              Ok(())
          }
          3200 => {
              super::mfcdm::error.record_raw(extra);
              Ok(())
          }
          3244 => {
              super::perf::page_load.record_raw(extra);
              Ok(())
          }
          3267 => {
              super::dom_quota_try::error_step.record_raw(extra);
              Ok(())
          }
          3345 => {
              super::avif::dav1d_get_picture_return_value.record_raw(extra);
              Ok(())
          }
          3366 => {
              super::slow_script_warning::shown_browser.record_raw(extra);
              Ok(())
          }
          3367 => {
              super::slow_script_warning::shown_content.record_raw(extra);
              Ok(())
          }
          3375 => {
              super::zero_byte_load::load_css.record_raw(extra);
              Ok(())
          }
          3376 => {
              super::zero_byte_load::load_dtd.record_raw(extra);
              Ok(())
          }
          3377 => {
              super::zero_byte_load::load_ftl.record_raw(extra);
              Ok(())
          }
          3378 => {
              super::zero_byte_load::load_html.record_raw(extra);
              Ok(())
          }
          3379 => {
              super::zero_byte_load::load_js.record_raw(extra);
              Ok(())
          }
          3380 => {
              super::zero_byte_load::load_json.record_raw(extra);
              Ok(())
          }
          3381 => {
              super::zero_byte_load::load_others.record_raw(extra);
              Ok(())
          }
          3382 => {
              super::zero_byte_load::load_png.record_raw(extra);
              Ok(())
          }
          3383 => {
              super::zero_byte_load::load_properties.record_raw(extra);
              Ok(())
          }
          3384 => {
              super::zero_byte_load::load_svg.record_raw(extra);
              Ok(())
          }
          3385 => {
              super::zero_byte_load::load_xhtml.record_raw(extra);
              Ok(())
          }
          3386 => {
              super::zero_byte_load::load_xml.record_raw(extra);
              Ok(())
          }
          3388 => {
              super::network_dns::trr_confirmation_context.record_raw(extra);
              Ok(())
          }
          3441 => {
              super::ysod::shown_ysod.record_raw(extra);
              Ok(())
          }
          3474 => {
              super::uptake_remotecontent_result::uptake_normandy.record_raw(extra);
              Ok(())
          }
          3475 => {
              super::uptake_remotecontent_result::uptake_remotesettings.record_raw(extra);
              Ok(())
          }
          3478 => {
              super::fxa::connect_account.record_raw(extra);
              Ok(())
          }
          3479 => {
              super::fxa::disconnect_account.record_raw(extra);
              Ok(())
          }
          3480 => {
              super::fxa_app_menu::click_account_settings.record_raw(extra);
              Ok(())
          }
          3481 => {
              super::fxa_app_menu::click_cad.record_raw(extra);
              Ok(())
          }
          3482 => {
              super::fxa_app_menu::click_login.record_raw(extra);
              Ok(())
          }
          3483 => {
              super::fxa_app_menu::click_monitor_cta.record_raw(extra);
              Ok(())
          }
          3484 => {
              super::fxa_app_menu::click_open_monitor.record_raw(extra);
              Ok(())
          }
          3485 => {
              super::fxa_app_menu::click_open_send.record_raw(extra);
              Ok(())
          }
          3486 => {
              super::fxa_app_menu::click_relay_cta.record_raw(extra);
              Ok(())
          }
          3487 => {
              super::fxa_app_menu::click_send_tab.record_raw(extra);
              Ok(())
          }
          3488 => {
              super::fxa_app_menu::click_sync_cta.record_raw(extra);
              Ok(())
          }
          3489 => {
              super::fxa_app_menu::click_sync_now.record_raw(extra);
              Ok(())
          }
          3490 => {
              super::fxa_app_menu::click_sync_settings.record_raw(extra);
              Ok(())
          }
          3491 => {
              super::fxa_app_menu::click_sync_tabs.record_raw(extra);
              Ok(())
          }
          3492 => {
              super::fxa_app_menu::click_sync_tabs_sidebar.record_raw(extra);
              Ok(())
          }
          3493 => {
              super::fxa_app_menu::click_toolbar_icon.record_raw(extra);
              Ok(())
          }
          3494 => {
              super::fxa_app_menu::click_unver_sync_settings.record_raw(extra);
              Ok(())
          }
          3495 => {
              super::fxa_app_menu::click_vpn_cta.record_raw(extra);
              Ok(())
          }
          3496 => {
              super::fxa_avatar_menu::click_account_settings.record_raw(extra);
              Ok(())
          }
          3497 => {
              super::fxa_avatar_menu::click_cad.record_raw(extra);
              Ok(())
          }
          3498 => {
              super::fxa_avatar_menu::click_login.record_raw(extra);
              Ok(())
          }
          3499 => {
              super::fxa_avatar_menu::click_monitor_cta.record_raw(extra);
              Ok(())
          }
          3500 => {
              super::fxa_avatar_menu::click_open_monitor.record_raw(extra);
              Ok(())
          }
          3501 => {
              super::fxa_avatar_menu::click_open_send.record_raw(extra);
              Ok(())
          }
          3502 => {
              super::fxa_avatar_menu::click_relay_cta.record_raw(extra);
              Ok(())
          }
          3503 => {
              super::fxa_avatar_menu::click_send_tab.record_raw(extra);
              Ok(())
          }
          3504 => {
              super::fxa_avatar_menu::click_sync_cta.record_raw(extra);
              Ok(())
          }
          3505 => {
              super::fxa_avatar_menu::click_sync_now.record_raw(extra);
              Ok(())
          }
          3506 => {
              super::fxa_avatar_menu::click_sync_settings.record_raw(extra);
              Ok(())
          }
          3507 => {
              super::fxa_avatar_menu::click_sync_tabs.record_raw(extra);
              Ok(())
          }
          3508 => {
              super::fxa_avatar_menu::click_sync_tabs_sidebar.record_raw(extra);
              Ok(())
          }
          3509 => {
              super::fxa_avatar_menu::click_toolbar_icon.record_raw(extra);
              Ok(())
          }
          3510 => {
              super::fxa_avatar_menu::click_unver_sync_settings.record_raw(extra);
              Ok(())
          }
          3511 => {
              super::fxa_avatar_menu::click_vpn_cta.record_raw(extra);
              Ok(())
          }
          3514 => {
              super::bounce_tracking_protection::purge_action.record_raw(extra);
              Ok(())
          }
          3523 => {
              super::background_tasks_rmdir_base::metric_base.record_raw(extra);
              Ok(())
          }
          3531 => {
              super::background_tasks_rmdir_http_cache::metric_base.record_raw(extra);
              Ok(())
          }
          3539 => {
              super::background_tasks_rmdir_quota::metric_base.record_raw(extra);
              Ok(())
          }
          3547 => {
              super::relevancy_classify::fail.record_raw(extra);
              Ok(())
          }
          3548 => {
              super::relevancy_classify::succeed.record_raw(extra);
              Ok(())
          }
          3551 => {
              super::cookie_banners::google_gdpr_choice_cookie_event.record_raw(extra);
              Ok(())
          }
          3552 => {
              super::cookie_banners::google_gdpr_choice_cookie_event_pbm.record_raw(extra);
              Ok(())
          }
          3555 => {
              super::cookie_banners::reload.record_raw(extra);
              Ok(())
          }
          3633 => {
              super::extensions_data::migrate_result.record_raw(extra);
              Ok(())
          }
          3634 => {
              super::extensions_data::storage_local_error.record_raw(extra);
              Ok(())
          }
          3635 => {
              super::extensions_data::sync_usage_quotas.record_raw(extra);
              Ok(())
          }
          3644 => {
              super::address::add_manage.record_raw(extra);
              Ok(())
          }
          3645 => {
              super::address::cancel_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          3646 => {
              super::address::cancel_edit_doorhanger.record_raw(extra);
              Ok(())
          }
          3647 => {
              super::address::cancel_update_doorhanger.record_raw(extra);
              Ok(())
          }
          3648 => {
              super::address::cleared_address_form.record_raw(extra);
              Ok(())
          }
          3649 => {
              super::address::delete_manage.record_raw(extra);
              Ok(())
          }
          3650 => {
              super::address::detected_address_form.record_raw(extra);
              Ok(())
          }
          3651 => {
              super::address::detected_address_form_ext.record_raw(extra);
              Ok(())
          }
          3652 => {
              super::address::disable_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          3653 => {
              super::address::disable_edit_doorhanger.record_raw(extra);
              Ok(())
          }
          3654 => {
              super::address::disable_update_doorhanger.record_raw(extra);
              Ok(())
          }
          3655 => {
              super::address::edit_manage.record_raw(extra);
              Ok(())
          }
          3656 => {
              super::address::filled_address_form.record_raw(extra);
              Ok(())
          }
          3657 => {
              super::address::filled_address_form_ext.record_raw(extra);
              Ok(())
          }
          3658 => {
              super::address::filled_modified_address_form.record_raw(extra);
              Ok(())
          }
          3659 => {
              super::address::learn_more_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          3660 => {
              super::address::learn_more_edit_doorhanger.record_raw(extra);
              Ok(())
          }
          3661 => {
              super::address::learn_more_update_doorhanger.record_raw(extra);
              Ok(())
          }
          3662 => {
              super::address::popup_shown_address_form.record_raw(extra);
              Ok(())
          }
          3663 => {
              super::address::pref_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          3664 => {
              super::address::pref_edit_doorhanger.record_raw(extra);
              Ok(())
          }
          3665 => {
              super::address::pref_update_doorhanger.record_raw(extra);
              Ok(())
          }
          3666 => {
              super::address::save_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          3667 => {
              super::address::save_edit_doorhanger.record_raw(extra);
              Ok(())
          }
          3668 => {
              super::address::save_update_doorhanger.record_raw(extra);
              Ok(())
          }
          3669 => {
              super::address::show_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          3670 => {
              super::address::show_edit_doorhanger.record_raw(extra);
              Ok(())
          }
          3671 => {
              super::address::show_entry_manage.record_raw(extra);
              Ok(())
          }
          3672 => {
              super::address::show_manage.record_raw(extra);
              Ok(())
          }
          3673 => {
              super::address::show_update_doorhanger.record_raw(extra);
              Ok(())
          }
          3674 => {
              super::address::submitted_address_form.record_raw(extra);
              Ok(())
          }
          3675 => {
              super::address::submitted_address_form_ext.record_raw(extra);
              Ok(())
          }
          3676 => {
              super::address::update_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          3677 => {
              super::address::update_edit_doorhanger.record_raw(extra);
              Ok(())
          }
          3678 => {
              super::address::update_update_doorhanger.record_raw(extra);
              Ok(())
          }
          3679 => {
              super::creditcard::add_manage.record_raw(extra);
              Ok(())
          }
          3680 => {
              super::creditcard::cancel_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          3681 => {
              super::creditcard::cancel_update_doorhanger.record_raw(extra);
              Ok(())
          }
          3682 => {
              super::creditcard::cleared_cc_form_v2.record_raw(extra);
              Ok(())
          }
          3683 => {
              super::creditcard::delete_manage.record_raw(extra);
              Ok(())
          }
          3684 => {
              super::creditcard::detected_cc_form_v2.record_raw(extra);
              Ok(())
          }
          3685 => {
              super::creditcard::disable_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          3686 => {
              super::creditcard::disable_update_doorhanger.record_raw(extra);
              Ok(())
          }
          3687 => {
              super::creditcard::edit_manage.record_raw(extra);
              Ok(())
          }
          3688 => {
              super::creditcard::filled_cc_form_v2.record_raw(extra);
              Ok(())
          }
          3689 => {
              super::creditcard::filled_modified_cc_form_v2.record_raw(extra);
              Ok(())
          }
          3690 => {
              super::creditcard::popup_shown_cc_form_v2.record_raw(extra);
              Ok(())
          }
          3691 => {
              super::creditcard::save_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          3692 => {
              super::creditcard::save_update_doorhanger.record_raw(extra);
              Ok(())
          }
          3693 => {
              super::creditcard::show_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          3694 => {
              super::creditcard::show_entry_manage.record_raw(extra);
              Ok(())
          }
          3695 => {
              super::creditcard::show_manage.record_raw(extra);
              Ok(())
          }
          3696 => {
              super::creditcard::show_update_doorhanger.record_raw(extra);
              Ok(())
          }
          3697 => {
              super::creditcard::submitted_cc_form_v2.record_raw(extra);
              Ok(())
          }
          3698 => {
              super::creditcard::update_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          3699 => {
              super::creditcard::update_update_doorhanger.record_raw(extra);
              Ok(())
          }
          3701 => {
              super::formautofill::iframe_layout_detection.record_raw(extra);
              Ok(())
          }
          3703 => {
              super::formautofill_creditcards::form_cleared.record_raw(extra);
              Ok(())
          }
          3704 => {
              super::formautofill_creditcards::form_detected.record_raw(extra);
              Ok(())
          }
          3705 => {
              super::formautofill_creditcards::form_filled.record_raw(extra);
              Ok(())
          }
          3706 => {
              super::formautofill_creditcards::form_filled_modified.record_raw(extra);
              Ok(())
          }
          3707 => {
              super::formautofill_creditcards::form_popup_shown.record_raw(extra);
              Ok(())
          }
          3708 => {
              super::formautofill_creditcards::form_submitted.record_raw(extra);
              Ok(())
          }
          3758 => {
              super::test_only_ipc::an_event.record_raw(extra);
              Ok(())
          }
          3763 => {
              super::test_only_ipc::event_with_extra.record_raw(extra);
              Ok(())
          }
          3765 => {
              super::test_only_ipc::no_extra_event.record_raw(extra);
              Ok(())
          }
          3768 => {
              super::test_only_jog::an_event.record_raw(extra);
              Ok(())
          }
          3769 => {
              super::messaging_experiments::reach_cfr.record_raw(extra);
              Ok(())
          }
          3770 => {
              super::messaging_experiments::reach_feature_callout.record_raw(extra);
              Ok(())
          }
          3771 => {
              super::messaging_experiments::reach_fxms_bmb_button.record_raw(extra);
              Ok(())
          }
          3772 => {
              super::messaging_experiments::reach_fxms_message_1.record_raw(extra);
              Ok(())
          }
          3773 => {
              super::messaging_experiments::reach_fxms_message_10.record_raw(extra);
              Ok(())
          }
          3774 => {
              super::messaging_experiments::reach_fxms_message_11.record_raw(extra);
              Ok(())
          }
          3775 => {
              super::messaging_experiments::reach_fxms_message_2.record_raw(extra);
              Ok(())
          }
          3776 => {
              super::messaging_experiments::reach_fxms_message_3.record_raw(extra);
              Ok(())
          }
          3777 => {
              super::messaging_experiments::reach_fxms_message_4.record_raw(extra);
              Ok(())
          }
          3778 => {
              super::messaging_experiments::reach_fxms_message_5.record_raw(extra);
              Ok(())
          }
          3779 => {
              super::messaging_experiments::reach_fxms_message_6.record_raw(extra);
              Ok(())
          }
          3780 => {
              super::messaging_experiments::reach_fxms_message_7.record_raw(extra);
              Ok(())
          }
          3781 => {
              super::messaging_experiments::reach_fxms_message_8.record_raw(extra);
              Ok(())
          }
          3782 => {
              super::messaging_experiments::reach_fxms_message_9.record_raw(extra);
              Ok(())
          }
          3783 => {
              super::messaging_experiments::reach_infobar.record_raw(extra);
              Ok(())
          }
          3784 => {
              super::messaging_experiments::reach_moments_page.record_raw(extra);
              Ok(())
          }
          3785 => {
              super::messaging_experiments::reach_spotlight.record_raw(extra);
              Ok(())
          }
          3786 => {
              super::messaging_experiments::targeting_attribute_error.record_raw(extra);
              Ok(())
          }
          3787 => {
              super::messaging_experiments::targeting_attribute_timeout.record_raw(extra);
              Ok(())
          }
          3788 => {
              super::nimbus_events::enroll_failed.record_raw(extra);
              Ok(())
          }
          3789 => {
              super::nimbus_events::enrollment.record_raw(extra);
              Ok(())
          }
          3790 => {
              super::nimbus_events::enrollment_status.record_raw(extra);
              Ok(())
          }
          3791 => {
              super::nimbus_events::exposure.record_raw(extra);
              Ok(())
          }
          3792 => {
              super::nimbus_events::is_ready.record_raw(extra);
              Ok(())
          }
          3793 => {
              super::nimbus_events::unenroll_failed.record_raw(extra);
              Ok(())
          }
          3794 => {
              super::nimbus_events::unenrollment.record_raw(extra);
              Ok(())
          }
          3795 => {
              super::nimbus_events::validation_failed.record_raw(extra);
              Ok(())
          }
          3796 => {
              super::normandy::expose_nimbus_experiment.record_raw(extra);
              Ok(())
          }
          3797 => {
              super::normandy::enroll_addon_rollout.record_raw(extra);
              Ok(())
          }
          3798 => {
              super::normandy::enroll_addon_study.record_raw(extra);
              Ok(())
          }
          3799 => {
              super::normandy::enroll_failed_addon_rollout.record_raw(extra);
              Ok(())
          }
          3800 => {
              super::normandy::enroll_failed_addon_study.record_raw(extra);
              Ok(())
          }
          3801 => {
              super::normandy::enroll_failed_nimbus_experiment.record_raw(extra);
              Ok(())
          }
          3802 => {
              super::normandy::enroll_failed_preference_rollout.record_raw(extra);
              Ok(())
          }
          3803 => {
              super::normandy::enroll_failed_preference_study.record_raw(extra);
              Ok(())
          }
          3804 => {
              super::normandy::enroll_nimbus_experiment.record_raw(extra);
              Ok(())
          }
          3805 => {
              super::normandy::enroll_preference_rollout.record_raw(extra);
              Ok(())
          }
          3806 => {
              super::normandy::enroll_preference_study.record_raw(extra);
              Ok(())
          }
          3807 => {
              super::normandy::exp_pref_changed_preference_study.record_raw(extra);
              Ok(())
          }
          3808 => {
              super::normandy::graduate_preference_rollout.record_raw(extra);
              Ok(())
          }
          3809 => {
              super::normandy::unenroll_addon_rollback.record_raw(extra);
              Ok(())
          }
          3810 => {
              super::normandy::unenroll_addon_study.record_raw(extra);
              Ok(())
          }
          3811 => {
              super::normandy::unenroll_failed_addon_rollback.record_raw(extra);
              Ok(())
          }
          3812 => {
              super::normandy::unenroll_failed_nimbus_experiment.record_raw(extra);
              Ok(())
          }
          3813 => {
              super::normandy::unenroll_failed_preference_rollback.record_raw(extra);
              Ok(())
          }
          3814 => {
              super::normandy::unenroll_failed_preference_study.record_raw(extra);
              Ok(())
          }
          3815 => {
              super::normandy::unenroll_nimbus_experiment.record_raw(extra);
              Ok(())
          }
          3816 => {
              super::normandy::unenroll_preference_rollback.record_raw(extra);
              Ok(())
          }
          3817 => {
              super::normandy::unenroll_preference_study.record_raw(extra);
              Ok(())
          }
          3818 => {
              super::normandy::update_addon_rollout.record_raw(extra);
              Ok(())
          }
          3819 => {
              super::normandy::update_addon_study.record_raw(extra);
              Ok(())
          }
          3820 => {
              super::normandy::update_failed_addon_rollout.record_raw(extra);
              Ok(())
          }
          3821 => {
              super::normandy::update_failed_addon_study.record_raw(extra);
              Ok(())
          }
          3822 => {
              super::normandy::update_nimbus_experiment.record_raw(extra);
              Ok(())
          }
          3823 => {
              super::normandy::update_preference_rollout.record_raw(extra);
              Ok(())
          }
          3824 => {
              super::normandy::validation_failed_nimbus_experiment.record_raw(extra);
              Ok(())
          }
          3825 => {
              super::form_autocomplete::show_logins.record_raw(extra);
              Ok(())
          }
          3826 => {
              super::pwmgr::autocomplete_field_generatedpassword.record_raw(extra);
              Ok(())
          }
          3827 => {
              super::pwmgr::autocomplete_shown_generatedpassword.record_raw(extra);
              Ok(())
          }
          3828 => {
              super::pwmgr::cancel_existing_login.record_raw(extra);
              Ok(())
          }
          3829 => {
              super::pwmgr::cancel_new_login.record_raw(extra);
              Ok(())
          }
          3830 => {
              super::pwmgr::copy_password.record_raw(extra);
              Ok(())
          }
          3831 => {
              super::pwmgr::copy_username.record_raw(extra);
              Ok(())
          }
          3832 => {
              super::pwmgr::delete_existing_login.record_raw(extra);
              Ok(())
          }
          3833 => {
              super::pwmgr::delete_new_login.record_raw(extra);
              Ok(())
          }
          3834 => {
              super::pwmgr::doorhanger_submitted_save.record_raw(extra);
              Ok(())
          }
          3835 => {
              super::pwmgr::doorhanger_submitted_update.record_raw(extra);
              Ok(())
          }
          3836 => {
              super::pwmgr::edit_existing_login.record_raw(extra);
              Ok(())
          }
          3837 => {
              super::pwmgr::filled_field_edited_generatedpassword.record_raw(extra);
              Ok(())
          }
          3838 => {
              super::pwmgr::filter_list.record_raw(extra);
              Ok(())
          }
          3840 => {
              super::pwmgr::hide_password.record_raw(extra);
              Ok(())
          }
          3841 => {
              super::pwmgr::learn_more_vuln_existing_login.record_raw(extra);
              Ok(())
          }
          3842 => {
              super::pwmgr::mgmt_menu_item_used_export.record_raw(extra);
              Ok(())
          }
          3843 => {
              super::pwmgr::mgmt_menu_item_used_export_complete.record_raw(extra);
              Ok(())
          }
          3844 => {
              super::pwmgr::mgmt_menu_item_used_import_csv_complete.record_raw(extra);
              Ok(())
          }
          3845 => {
              super::pwmgr::mgmt_menu_item_used_import_from_browser.record_raw(extra);
              Ok(())
          }
          3846 => {
              super::pwmgr::mgmt_menu_item_used_import_from_csv.record_raw(extra);
              Ok(())
          }
          3847 => {
              super::pwmgr::mgmt_menu_item_used_preferences.record_raw(extra);
              Ok(())
          }
          3848 => {
              super::pwmgr::new_new_login.record_raw(extra);
              Ok(())
          }
          3849 => {
              super::pwmgr::open_management_aboutprotections.record_raw(extra);
              Ok(())
          }
          3850 => {
              super::pwmgr::open_management_autocomplete.record_raw(extra);
              Ok(())
          }
          3851 => {
              super::pwmgr::open_management_contextmenu.record_raw(extra);
              Ok(())
          }
          3852 => {
              super::pwmgr::open_management_direct.record_raw(extra);
              Ok(())
          }
          3853 => {
              super::pwmgr::open_management_mainmenu.record_raw(extra);
              Ok(())
          }
          3854 => {
              super::pwmgr::open_management_pageinfo.record_raw(extra);
              Ok(())
          }
          3855 => {
              super::pwmgr::open_management_preferences.record_raw(extra);
              Ok(())
          }
          3856 => {
              super::pwmgr::open_management_snippet.record_raw(extra);
              Ok(())
          }
          3857 => {
              super::pwmgr::open_site_existing_login.record_raw(extra);
              Ok(())
          }
          3859 => {
              super::pwmgr::reauthenticate_master_password.record_raw(extra);
              Ok(())
          }
          3860 => {
              super::pwmgr::reauthenticate_os_auth.record_raw(extra);
              Ok(())
          }
          3861 => {
              super::pwmgr::save_existing_login.record_raw(extra);
              Ok(())
          }
          3862 => {
              super::pwmgr::save_new_login.record_raw(extra);
              Ok(())
          }
          3863 => {
              super::pwmgr::saved_login_used_auth_login.record_raw(extra);
              Ok(())
          }
          3864 => {
              super::pwmgr::saved_login_used_form_login.record_raw(extra);
              Ok(())
          }
          3865 => {
              super::pwmgr::saved_login_used_form_password.record_raw(extra);
              Ok(())
          }
          3866 => {
              super::pwmgr::saved_login_used_prompt_login.record_raw(extra);
              Ok(())
          }
          3867 => {
              super::pwmgr::select_existing_login.record_raw(extra);
              Ok(())
          }
          3868 => {
              super::pwmgr::show_password.record_raw(extra);
              Ok(())
          }
          3869 => {
              super::pwmgr::sort_list.record_raw(extra);
              Ok(())
          }
          3870 => {
              super::relay_integration::clicked_fill_username.record_raw(extra);
              Ok(())
          }
          3871 => {
              super::relay_integration::clicked_offer_relay.record_raw(extra);
              Ok(())
          }
          3872 => {
              super::relay_integration::disabled_opt_in_panel.record_raw(extra);
              Ok(())
          }
          3873 => {
              super::relay_integration::disabled_pref_change.record_raw(extra);
              Ok(())
          }
          3874 => {
              super::relay_integration::enabled_opt_in_panel.record_raw(extra);
              Ok(())
          }
          3875 => {
              super::relay_integration::enabled_pref_change.record_raw(extra);
              Ok(())
          }
          3876 => {
              super::relay_integration::get_unlimited_masks_reuse_panel.record_raw(extra);
              Ok(())
          }
          3877 => {
              super::relay_integration::postponed_opt_in_panel.record_raw(extra);
              Ok(())
          }
          3878 => {
              super::relay_integration::reuse_mask_reuse_panel.record_raw(extra);
              Ok(())
          }
          3879 => {
              super::relay_integration::shown_fill_username.record_raw(extra);
              Ok(())
          }
          3880 => {
              super::relay_integration::shown_offer_relay.record_raw(extra);
              Ok(())
          }
          3881 => {
              super::relay_integration::shown_opt_in_panel.record_raw(extra);
              Ok(())
          }
          3882 => {
              super::relay_integration::shown_reuse_panel.record_raw(extra);
              Ok(())
          }
          3901 => {
              super::pdfjs_image::add_image_click.record_raw(extra);
              Ok(())
          }
          3904 => {
              super::pdfjs_image::icon_click.record_raw(extra);
              Ok(())
          }
          3905 => {
              super::pdfjs_image::image_added.record_raw(extra);
              Ok(())
          }
          3906 => {
              super::pdfjs_image::image_selected.record_raw(extra);
              Ok(())
          }
          3907 => {
              super::pdfjs_image_alt_text::ai_generation_check.record_raw(extra);
              Ok(())
          }
          3908 => {
              super::pdfjs_image_alt_text::callout_dismissed.record_raw(extra);
              Ok(())
          }
          3909 => {
              super::pdfjs_image_alt_text::callout_displayed.record_raw(extra);
              Ok(())
          }
          3910 => {
              super::pdfjs_image_alt_text::dismiss.record_raw(extra);
              Ok(())
          }
          3911 => {
              super::pdfjs_image_alt_text::image_status_label_clicked.record_raw(extra);
              Ok(())
          }
          3912 => {
              super::pdfjs_image_alt_text::image_status_label_displayed.record_raw(extra);
              Ok(())
          }
          3913 => {
              super::pdfjs_image_alt_text::info.record_raw(extra);
              Ok(())
          }
          3914 => {
              super::pdfjs_image_alt_text::model_deleted.record_raw(extra);
              Ok(())
          }
          3915 => {
              super::pdfjs_image_alt_text::model_download_complete.record_raw(extra);
              Ok(())
          }
          3916 => {
              super::pdfjs_image_alt_text::model_download_error.record_raw(extra);
              Ok(())
          }
          3917 => {
              super::pdfjs_image_alt_text::model_download_start.record_raw(extra);
              Ok(())
          }
          3918 => {
              super::pdfjs_image_alt_text::model_result.record_raw(extra);
              Ok(())
          }
          3919 => {
              super::pdfjs_image_alt_text::save.record_raw(extra);
              Ok(())
          }
          3920 => {
              super::pdfjs_image_alt_text::settings_ai_generation_check.record_raw(extra);
              Ok(())
          }
          3921 => {
              super::pdfjs_image_alt_text::settings_displayed.record_raw(extra);
              Ok(())
          }
          3922 => {
              super::pdfjs_image_alt_text::settings_edit_alt_text_check.record_raw(extra);
              Ok(())
          }
          3923 => {
              super::pdfjs_image_alt_text::user_edit.record_raw(extra);
              Ok(())
          }
          3924 => {
              super::pictureinpicture::closed_method_browser_crash.record_raw(extra);
              Ok(())
          }
          3925 => {
              super::pictureinpicture::closed_method_close_button.record_raw(extra);
              Ok(())
          }
          3926 => {
              super::pictureinpicture::closed_method_close_player_shortcut.record_raw(extra);
              Ok(())
          }
          3927 => {
              super::pictureinpicture::closed_method_context_menu.record_raw(extra);
              Ok(())
          }
          3928 => {
              super::pictureinpicture::closed_method_foregrounded.record_raw(extra);
              Ok(())
          }
          3929 => {
              super::pictureinpicture::closed_method_fullscreen.record_raw(extra);
              Ok(())
          }
          3930 => {
              super::pictureinpicture::closed_method_pagehide.record_raw(extra);
              Ok(())
          }
          3931 => {
              super::pictureinpicture::closed_method_setup_failure.record_raw(extra);
              Ok(())
          }
          3932 => {
              super::pictureinpicture::closed_method_shortcut.record_raw(extra);
              Ok(())
          }
          3933 => {
              super::pictureinpicture::closed_method_unpip.record_raw(extra);
              Ok(())
          }
          3934 => {
              super::pictureinpicture::closed_method_url_bar.record_raw(extra);
              Ok(())
          }
          3935 => {
              super::pictureinpicture::closed_method_video_el_emptied.record_raw(extra);
              Ok(())
          }
          3936 => {
              super::pictureinpicture::closed_method_video_el_remove.record_raw(extra);
              Ok(())
          }
          3937 => {
              super::pictureinpicture::create_player.record_raw(extra);
              Ok(())
          }
          3938 => {
              super::pictureinpicture::disrespect_disable_url_bar.record_raw(extra);
              Ok(())
          }
          3939 => {
              super::pictureinpicture::fullscreen_player.record_raw(extra);
              Ok(())
          }
          3941 => {
              super::pictureinpicture::opened_method_auto_pip.record_raw(extra);
              Ok(())
          }
          3942 => {
              super::pictureinpicture::opened_method_context_menu.record_raw(extra);
              Ok(())
          }
          3943 => {
              super::pictureinpicture::opened_method_shortcut.record_raw(extra);
              Ok(())
          }
          3944 => {
              super::pictureinpicture::opened_method_toggle.record_raw(extra);
              Ok(())
          }
          3945 => {
              super::pictureinpicture::opened_method_url_bar.record_raw(extra);
              Ok(())
          }
          3946 => {
              super::pictureinpicture::resize_player.record_raw(extra);
              Ok(())
          }
          3947 => {
              super::pictureinpicture::saw_toggle_toggle.record_raw(extra);
              Ok(())
          }
          3948 => {
              super::pictureinpicture::subtitles_shown_subtitles.record_raw(extra);
              Ok(())
          }
          3950 => {
              super::pictureinpicture_settings::disable_player.record_raw(extra);
              Ok(())
          }
          3951 => {
              super::pictureinpicture_settings::disable_settings.record_raw(extra);
              Ok(())
          }
          3952 => {
              super::pictureinpicture_settings::enable_autotrigger_settings.record_raw(extra);
              Ok(())
          }
          3953 => {
              super::pictureinpicture_settings::enable_settings.record_raw(extra);
              Ok(())
          }
          3989 => {
              super::readermode::button_click.record_raw(extra);
              Ok(())
          }
          3990 => {
              super::readermode::view_off.record_raw(extra);
              Ok(())
          }
          3991 => {
              super::readermode::view_on.record_raw(extra);
              Ok(())
          }
          4028 => {
              super::webcompatreporting::opened.record_raw(extra);
              Ok(())
          }
          4029 => {
              super::webcompatreporting::reason_dropdown.record_raw(extra);
              Ok(())
          }
          4030 => {
              super::webcompatreporting::send.record_raw(extra);
              Ok(())
          }
          4031 => {
              super::webcompatreporting::send_more_info.record_raw(extra);
              Ok(())
          }
          4227 => {
              super::search_engine_default::changed.record_raw(extra);
              Ok(())
          }
          4233 => {
              super::search_engine_private::changed.record_raw(extra);
              Ok(())
          }
          4241 => {
              super::shopping_product::invalid_ohttp_config.record_raw(extra);
              Ok(())
          }
          4242 => {
              super::shopping_product::invalid_request.record_raw(extra);
              Ok(())
          }
          4243 => {
              super::shopping_product::invalid_response.record_raw(extra);
              Ok(())
          }
          4244 => {
              super::shopping_product::request_aborted.record_raw(extra);
              Ok(())
          }
          4245 => {
              super::shopping_product::request_error.record_raw(extra);
              Ok(())
          }
          4246 => {
              super::shopping_product::request_failure.record_raw(extra);
              Ok(())
          }
          4247 => {
              super::shopping_product::request_retried.record_raw(extra);
              Ok(())
          }
          4248 => {
              super::shopping_product::request_retries_failed.record_raw(extra);
              Ok(())
          }
          4249 => {
              super::shopping_product::server_failure.record_raw(extra);
              Ok(())
          }
          4253 => {
              super::telemetry_test::test1_object1.record_raw(extra);
              Ok(())
          }
          4254 => {
              super::telemetry_test::test2_object1.record_raw(extra);
              Ok(())
          }
          4255 => {
              super::telemetry_test::test2_object2.record_raw(extra);
              Ok(())
          }
          4256 => {
              super::translations::error.record_raw(extra);
              Ok(())
          }
          4260 => {
              super::translations::restore_page.record_raw(extra);
              Ok(())
          }
          4261 => {
              super::translations::translation_request.record_raw(extra);
              Ok(())
          }
          4262 => {
              super::translations_panel::about_translations.record_raw(extra);
              Ok(())
          }
          4263 => {
              super::translations_panel::always_offer_translations.record_raw(extra);
              Ok(())
          }
          4264 => {
              super::translations_panel::always_translate_language.record_raw(extra);
              Ok(())
          }
          4265 => {
              super::translations_panel::cancel_button.record_raw(extra);
              Ok(())
          }
          4266 => {
              super::translations_panel::change_from_language.record_raw(extra);
              Ok(())
          }
          4267 => {
              super::translations_panel::change_source_language_button.record_raw(extra);
              Ok(())
          }
          4268 => {
              super::translations_panel::change_to_language.record_raw(extra);
              Ok(())
          }
          4269 => {
              super::translations_panel::close.record_raw(extra);
              Ok(())
          }
          4270 => {
              super::translations_panel::close_from_language_menu.record_raw(extra);
              Ok(())
          }
          4271 => {
              super::translations_panel::close_settings_menu.record_raw(extra);
              Ok(())
          }
          4272 => {
              super::translations_panel::close_to_language_menu.record_raw(extra);
              Ok(())
          }
          4273 => {
              super::translations_panel::dismiss_error_button.record_raw(extra);
              Ok(())
          }
          4274 => {
              super::translations_panel::learn_more.record_raw(extra);
              Ok(())
          }
          4275 => {
              super::translations_panel::manage_languages.record_raw(extra);
              Ok(())
          }
          4276 => {
              super::translations_panel::never_translate_language.record_raw(extra);
              Ok(())
          }
          4277 => {
              super::translations_panel::never_translate_site.record_raw(extra);
              Ok(())
          }
          4278 => {
              super::translations_panel::open.record_raw(extra);
              Ok(())
          }
          4279 => {
              super::translations_panel::open_from_language_menu.record_raw(extra);
              Ok(())
          }
          4280 => {
              super::translations_panel::open_settings_menu.record_raw(extra);
              Ok(())
          }
          4281 => {
              super::translations_panel::open_to_language_menu.record_raw(extra);
              Ok(())
          }
          4282 => {
              super::translations_panel::restore_page_button.record_raw(extra);
              Ok(())
          }
          4283 => {
              super::translations_panel::translate_button.record_raw(extra);
              Ok(())
          }
          4284 => {
              super::translations_select_translations_panel::about_translations.record_raw(extra);
              Ok(())
          }
          4285 => {
              super::translations_select_translations_panel::cancel_button.record_raw(extra);
              Ok(())
          }
          4286 => {
              super::translations_select_translations_panel::change_from_language.record_raw(extra);
              Ok(())
          }
          4287 => {
              super::translations_select_translations_panel::change_to_language.record_raw(extra);
              Ok(())
          }
          4288 => {
              super::translations_select_translations_panel::close.record_raw(extra);
              Ok(())
          }
          4289 => {
              super::translations_select_translations_panel::copy_button.record_raw(extra);
              Ok(())
          }
          4290 => {
              super::translations_select_translations_panel::done_button.record_raw(extra);
              Ok(())
          }
          4291 => {
              super::translations_select_translations_panel::initialization_failure_message.record_raw(extra);
              Ok(())
          }
          4292 => {
              super::translations_select_translations_panel::open.record_raw(extra);
              Ok(())
          }
          4293 => {
              super::translations_select_translations_panel::open_settings_menu.record_raw(extra);
              Ok(())
          }
          4294 => {
              super::translations_select_translations_panel::translate_button.record_raw(extra);
              Ok(())
          }
          4295 => {
              super::translations_select_translations_panel::translate_full_page_button.record_raw(extra);
              Ok(())
          }
          4296 => {
              super::translations_select_translations_panel::translation_failure_message.record_raw(extra);
              Ok(())
          }
          4297 => {
              super::translations_select_translations_panel::translation_settings.record_raw(extra);
              Ok(())
          }
          4298 => {
              super::translations_select_translations_panel::try_again_button.record_raw(extra);
              Ok(())
          }
          4299 => {
              super::translations_select_translations_panel::unsupported_language_message.record_raw(extra);
              Ok(())
          }
          4307 => {
              super::security_doh_neterror::click_add_exception_button.record_raw(extra);
              Ok(())
          }
          4308 => {
              super::security_doh_neterror::click_continue_button.record_raw(extra);
              Ok(())
          }
          4309 => {
              super::security_doh_neterror::click_disable_warning.record_raw(extra);
              Ok(())
          }
          4310 => {
              super::security_doh_neterror::click_learn_more_link.record_raw(extra);
              Ok(())
          }
          4311 => {
              super::security_doh_neterror::click_settings_button.record_raw(extra);
              Ok(())
          }
          4312 => {
              super::security_doh_neterror::click_try_again_button.record_raw(extra);
              Ok(())
          }
          4313 => {
              super::security_doh_neterror::load_dohwarning.record_raw(extra);
              Ok(())
          }
          4314 => {
              super::security_ui_certerror::click_advanced_button.record_raw(extra);
              Ok(())
          }
          4315 => {
              super::security_ui_certerror::click_auto_report_cb.record_raw(extra);
              Ok(())
          }
          4316 => {
              super::security_ui_certerror::click_clipboard_button_bot.record_raw(extra);
              Ok(())
          }
          4317 => {
              super::security_ui_certerror::click_clipboard_button_top.record_raw(extra);
              Ok(())
          }
          4318 => {
              super::security_ui_certerror::click_error_code_link.record_raw(extra);
              Ok(())
          }
          4319 => {
              super::security_ui_certerror::click_exception_button.record_raw(extra);
              Ok(())
          }
          4320 => {
              super::security_ui_certerror::click_learn_more_link.record_raw(extra);
              Ok(())
          }
          4321 => {
              super::security_ui_certerror::click_return_button_adv.record_raw(extra);
              Ok(())
          }
          4322 => {
              super::security_ui_certerror::click_return_button_top.record_raw(extra);
              Ok(())
          }
          4323 => {
              super::security_ui_certerror::load_aboutcerterror.record_raw(extra);
              Ok(())
          }
          4324 => {
              super::security_ui_tlserror::load_abouttlserror.record_raw(extra);
              Ok(())
          }
          4330 => {
              super::jsonfile::load_autofillprofiles.record_raw(extra);
              Ok(())
          }
          4331 => {
              super::jsonfile::load_logins.record_raw(extra);
              Ok(())
          }
          4332 => {
              super::service_request::bypass_proxy_info.record_raw(extra);
              Ok(())
          }
          4341 => {
              super::addons_manager::install.record_raw(extra);
              Ok(())
          }
          4342 => {
              super::addons_manager::install_stats.record_raw(extra);
              Ok(())
          }
          4343 => {
              super::addons_manager::manage.record_raw(extra);
              Ok(())
          }
          4344 => {
              super::addons_manager::report_suspicious_site.record_raw(extra);
              Ok(())
          }
          4345 => {
              super::addons_manager::update.record_raw(extra);
              Ok(())
          }
          4346 => {
              super::addons_manager::disable_dictionary.record_raw(extra);
              Ok(())
          }
          4347 => {
              super::addons_manager::disable_extension.record_raw(extra);
              Ok(())
          }
          4348 => {
              super::addons_manager::disable_locale.record_raw(extra);
              Ok(())
          }
          4349 => {
              super::addons_manager::disable_other.record_raw(extra);
              Ok(())
          }
          4350 => {
              super::addons_manager::disable_siteperm_deprecated.record_raw(extra);
              Ok(())
          }
          4351 => {
              super::addons_manager::disable_sitepermission.record_raw(extra);
              Ok(())
          }
          4352 => {
              super::addons_manager::disable_theme.record_raw(extra);
              Ok(())
          }
          4353 => {
              super::addons_manager::disable_unknown.record_raw(extra);
              Ok(())
          }
          4354 => {
              super::addons_manager::enable_dictionary.record_raw(extra);
              Ok(())
          }
          4355 => {
              super::addons_manager::enable_extension.record_raw(extra);
              Ok(())
          }
          4356 => {
              super::addons_manager::enable_locale.record_raw(extra);
              Ok(())
          }
          4357 => {
              super::addons_manager::enable_other.record_raw(extra);
              Ok(())
          }
          4358 => {
              super::addons_manager::enable_siteperm_deprecated.record_raw(extra);
              Ok(())
          }
          4359 => {
              super::addons_manager::enable_sitepermission.record_raw(extra);
              Ok(())
          }
          4360 => {
              super::addons_manager::enable_theme.record_raw(extra);
              Ok(())
          }
          4361 => {
              super::addons_manager::enable_unknown.record_raw(extra);
              Ok(())
          }
          4362 => {
              super::addons_manager::install_dictionary.record_raw(extra);
              Ok(())
          }
          4363 => {
              super::addons_manager::install_extension.record_raw(extra);
              Ok(())
          }
          4364 => {
              super::addons_manager::install_locale.record_raw(extra);
              Ok(())
          }
          4365 => {
              super::addons_manager::install_other.record_raw(extra);
              Ok(())
          }
          4366 => {
              super::addons_manager::install_siteperm_deprecated.record_raw(extra);
              Ok(())
          }
          4367 => {
              super::addons_manager::install_sitepermission.record_raw(extra);
              Ok(())
          }
          4368 => {
              super::addons_manager::install_stats_dictionary.record_raw(extra);
              Ok(())
          }
          4369 => {
              super::addons_manager::install_stats_extension.record_raw(extra);
              Ok(())
          }
          4370 => {
              super::addons_manager::install_stats_locale.record_raw(extra);
              Ok(())
          }
          4371 => {
              super::addons_manager::install_stats_other.record_raw(extra);
              Ok(())
          }
          4372 => {
              super::addons_manager::install_stats_siteperm_deprecated.record_raw(extra);
              Ok(())
          }
          4373 => {
              super::addons_manager::install_stats_sitepermission.record_raw(extra);
              Ok(())
          }
          4374 => {
              super::addons_manager::install_stats_theme.record_raw(extra);
              Ok(())
          }
          4375 => {
              super::addons_manager::install_stats_unknown.record_raw(extra);
              Ok(())
          }
          4376 => {
              super::addons_manager::install_theme.record_raw(extra);
              Ok(())
          }
          4377 => {
              super::addons_manager::install_unknown.record_raw(extra);
              Ok(())
          }
          4378 => {
              super::addons_manager::sideload_prompt_dictionary.record_raw(extra);
              Ok(())
          }
          4379 => {
              super::addons_manager::sideload_prompt_extension.record_raw(extra);
              Ok(())
          }
          4380 => {
              super::addons_manager::sideload_prompt_locale.record_raw(extra);
              Ok(())
          }
          4381 => {
              super::addons_manager::sideload_prompt_other.record_raw(extra);
              Ok(())
          }
          4382 => {
              super::addons_manager::sideload_prompt_siteperm_deprecated.record_raw(extra);
              Ok(())
          }
          4383 => {
              super::addons_manager::sideload_prompt_sitepermission.record_raw(extra);
              Ok(())
          }
          4384 => {
              super::addons_manager::sideload_prompt_theme.record_raw(extra);
              Ok(())
          }
          4385 => {
              super::addons_manager::sideload_prompt_unknown.record_raw(extra);
              Ok(())
          }
          4386 => {
              super::addons_manager::uninstall_dictionary.record_raw(extra);
              Ok(())
          }
          4387 => {
              super::addons_manager::uninstall_extension.record_raw(extra);
              Ok(())
          }
          4388 => {
              super::addons_manager::uninstall_locale.record_raw(extra);
              Ok(())
          }
          4389 => {
              super::addons_manager::uninstall_other.record_raw(extra);
              Ok(())
          }
          4390 => {
              super::addons_manager::uninstall_siteperm_deprecated.record_raw(extra);
              Ok(())
          }
          4391 => {
              super::addons_manager::uninstall_sitepermission.record_raw(extra);
              Ok(())
          }
          4392 => {
              super::addons_manager::uninstall_theme.record_raw(extra);
              Ok(())
          }
          4393 => {
              super::addons_manager::uninstall_unknown.record_raw(extra);
              Ok(())
          }
          4394 => {
              super::addons_manager::update_dictionary.record_raw(extra);
              Ok(())
          }
          4395 => {
              super::addons_manager::update_extension.record_raw(extra);
              Ok(())
          }
          4396 => {
              super::addons_manager::update_locale.record_raw(extra);
              Ok(())
          }
          4397 => {
              super::addons_manager::update_other.record_raw(extra);
              Ok(())
          }
          4398 => {
              super::addons_manager::update_siteperm_deprecated.record_raw(extra);
              Ok(())
          }
          4399 => {
              super::addons_manager::update_sitepermission.record_raw(extra);
              Ok(())
          }
          4400 => {
              super::addons_manager::update_theme.record_raw(extra);
              Ok(())
          }
          4401 => {
              super::addons_manager::update_unknown.record_raw(extra);
              Ok(())
          }
          4402 => {
              super::blocklist::addon_block_change.record_raw(extra);
              Ok(())
          }
          4432 => {
              super::file_dialog::fallback_v2_1.record_raw(extra);
              Ok(())
          }
          4433 => {
              super::memory_watcher::on_high_memory_stats.record_raw(extra);
              Ok(())
          }
           _ => Err(EventRecordingError::InvalidId),
        }
    }

    /// Wrapper to record an event based on its metric ID, with a provided timestamp.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `timestamp` - The time at which this event was recorded.
    /// * `extra`     - An map of (extra key id, string) pairs.
    ///                 The map will be decoded into the appropriate `ExtraKeys` type.
    /// # Returns
    ///
    /// Returns `Ok(())` if the event was found and `record` was called with the given `extra`,
    /// or an `EventRecordingError::InvalidId` if no event by that ID exists
    /// or an `EventRecordingError::InvalidExtraKey` if the event doesn't take extra pairs,
    /// but some are passed in.
    pub(crate) fn record_event_by_id_with_time(metric_id: MetricId, timestamp: u64, extra: HashMap<String, String>) -> Result<(), EventRecordingError> {
        match metric_id {
          MetricId(9) => {
              if extra_keys_len(&super::privacy_sanitize::clear) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::privacy_sanitize::clear.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(10) => {
              if extra_keys_len(&super::privacy_sanitize::clearing_time_span_selected) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::privacy_sanitize::clearing_time_span_selected.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(11) => {
              if extra_keys_len(&super::privacy_sanitize::dialog_open) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::privacy_sanitize::dialog_open.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(13) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_cookieb_toggle_off) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_cookieb_toggle_off.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(14) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_cookieb_toggle_on) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_cookieb_toggle_on.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(15) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_cookies) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_cookies.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(16) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_cryptominers) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_cryptominers.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(17) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_etp_toggle_off) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_etp_toggle_off.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(18) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_etp_toggle_on) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_etp_toggle_on.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(19) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_fingerprinters) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_fingerprinters.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(20) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_full_report) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_full_report.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(21) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_milestone_message) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_milestone_message.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(22) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_protectionspopup_cfr) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_protectionspopup_cfr.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(23) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(24) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_social) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_social.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(25) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_subview_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_subview_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(26) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_trackers) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_trackers.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(27) => {
              if extra_keys_len(&super::security_ui_protectionspopup::open_protections_popup) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::open_protections_popup.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(28) => {
              if extra_keys_len(&super::security_ui_protectionspopup::open_protectionspopup_cfr) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::open_protectionspopup_cfr.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(51) => {
              if extra_keys_len(&super::doh::evaluate_v2_heuristics) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::doh::evaluate_v2_heuristics.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(52) => {
              if extra_keys_len(&super::doh::state_disabled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::doh::state_disabled.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(53) => {
              if extra_keys_len(&super::doh::state_enabled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::doh::state_enabled.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(54) => {
              if extra_keys_len(&super::doh::state_manually_disabled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::doh::state_manually_disabled.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(55) => {
              if extra_keys_len(&super::doh::state_policy_disabled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::doh::state_policy_disabled.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(56) => {
              if extra_keys_len(&super::doh::state_rollback) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::doh::state_rollback.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(57) => {
              if extra_keys_len(&super::doh::state_shutdown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::doh::state_shutdown.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(58) => {
              if extra_keys_len(&super::doh::state_uidisabled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::doh::state_uidisabled.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(59) => {
              if extra_keys_len(&super::doh::state_uiok) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::doh::state_uiok.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(60) => {
              if extra_keys_len(&super::doh::state_uninstalled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::doh::state_uninstalled.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(164) => {
              if extra_keys_len(&super::security_doh_trr_performance::resolved_record) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_trr_performance::resolved_record.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(165) => {
              if extra_keys_len(&super::security_doh_trr_performance::trrselect_dryrunresult) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_trr_performance::trrselect_dryrunresult.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(167) => {
              if extra_keys_len(&super::downloads::added_file_extension) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::downloads::added_file_extension.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(169) => {
              if extra_keys_len(&super::firefoxview_next::browser_context_menu_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::browser_context_menu_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(170) => {
              if extra_keys_len(&super::firefoxview_next::card_collapsed_card_container) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::card_collapsed_card_container.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(171) => {
              if extra_keys_len(&super::firefoxview_next::card_expanded_card_container) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::card_expanded_card_container.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(172) => {
              if extra_keys_len(&super::firefoxview_next::change_page_navigation) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::change_page_navigation.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(173) => {
              if extra_keys_len(&super::firefoxview_next::close_open_tab_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::close_open_tab_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(174) => {
              if extra_keys_len(&super::firefoxview_next::context_menu_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::context_menu_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(175) => {
              if extra_keys_len(&super::firefoxview_next::dismiss_closed_tab_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::dismiss_closed_tab_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(176) => {
              if extra_keys_len(&super::firefoxview_next::entered_firefoxview) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::entered_firefoxview.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(177) => {
              if extra_keys_len(&super::firefoxview_next::fxa_continue_sync) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::fxa_continue_sync.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(178) => {
              if extra_keys_len(&super::firefoxview_next::fxa_mobile_sync) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::fxa_mobile_sync.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(179) => {
              if extra_keys_len(&super::firefoxview_next::history_visits) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::history_visits.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(180) => {
              if extra_keys_len(&super::firefoxview_next::open_tab_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::open_tab_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(181) => {
              if extra_keys_len(&super::firefoxview_next::recently_closed_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::recently_closed_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(182) => {
              if extra_keys_len(&super::firefoxview_next::search_initiated_search) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::search_initiated_search.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(183) => {
              if extra_keys_len(&super::firefoxview_next::search_show_all_showallbutton) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::search_show_all_showallbutton.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(184) => {
              if extra_keys_len(&super::firefoxview_next::show_all_history_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::show_all_history_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(185) => {
              if extra_keys_len(&super::firefoxview_next::sort_history_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::sort_history_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(186) => {
              if extra_keys_len(&super::firefoxview_next::synced_tabs_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::synced_tabs_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(187) => {
              if extra_keys_len(&super::firefoxview_next::tab_selected_toolbarbutton) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::tab_selected_toolbarbutton.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(188) => {
              if extra_keys_len(&super::genai_chatbot::contextmenu_prompt_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::contextmenu_prompt_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(190) => {
              if extra_keys_len(&super::genai_chatbot::experiment_checkbox_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::experiment_checkbox_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(191) => {
              if extra_keys_len(&super::genai_chatbot::onboarding_close) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::onboarding_close.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(192) => {
              if extra_keys_len(&super::genai_chatbot::onboarding_continue) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::onboarding_continue.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(193) => {
              if extra_keys_len(&super::genai_chatbot::onboarding_finish) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::onboarding_finish.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(194) => {
              if extra_keys_len(&super::genai_chatbot::onboarding_learn_more) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::onboarding_learn_more.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(195) => {
              if extra_keys_len(&super::genai_chatbot::onboarding_provider_choice_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::onboarding_provider_choice_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(196) => {
              if extra_keys_len(&super::genai_chatbot::onboarding_provider_learn) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::onboarding_provider_learn.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(197) => {
              if extra_keys_len(&super::genai_chatbot::onboarding_provider_selection) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::onboarding_provider_selection.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(198) => {
              if extra_keys_len(&super::genai_chatbot::onboarding_provider_terms) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::onboarding_provider_terms.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(199) => {
              if extra_keys_len(&super::genai_chatbot::onboarding_text_highlight_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::onboarding_text_highlight_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(201) => {
              if extra_keys_len(&super::genai_chatbot::provider_change) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::provider_change.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(203) => {
              if extra_keys_len(&super::genai_chatbot::shortcuts_checkbox_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::shortcuts_checkbox_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(205) => {
              if extra_keys_len(&super::genai_chatbot::shortcuts_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::shortcuts_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(206) => {
              if extra_keys_len(&super::genai_chatbot::shortcuts_expanded) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::shortcuts_expanded.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(207) => {
              if extra_keys_len(&super::genai_chatbot::shortcuts_hide_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::shortcuts_hide_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(208) => {
              if extra_keys_len(&super::genai_chatbot::shortcuts_prompt_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::shortcuts_prompt_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(210) => {
              if extra_keys_len(&super::genai_chatbot::sidebar_close_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::sidebar_close_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(211) => {
              if extra_keys_len(&super::genai_chatbot::sidebar_more_menu_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::sidebar_more_menu_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(212) => {
              if extra_keys_len(&super::genai_chatbot::sidebar_more_menu_display) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::sidebar_more_menu_display.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(213) => {
              if extra_keys_len(&super::genai_chatbot::sidebar_provider_menu_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::sidebar_provider_menu_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(214) => {
              if extra_keys_len(&super::genai_chatbot::sidebar_toggle) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::sidebar_toggle.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(231) => {
              if extra_keys_len(&super::browser_launched_to_handle::system_notification) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_launched_to_handle::system_notification.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(245) => {
              if extra_keys_len(&super::launch_on_login::last_profile_disable_startup) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::launch_on_login::last_profile_disable_startup.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(258) => {
              if extra_keys_len(&super::security::fission_principals) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security::fission_principals.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(259) => {
              if extra_keys_len(&super::security::eval_usage_parent_process) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security::eval_usage_parent_process.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(260) => {
              if extra_keys_len(&super::security::eval_usage_system_context) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security::eval_usage_system_context.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(261) => {
              if extra_keys_len(&super::security::javascript_load_parent_process) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security::javascript_load_parent_process.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(262) => {
              if extra_keys_len(&super::security::unexpected_load) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security::unexpected_load.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(263) => {
              if extra_keys_len(&super::security::pref_usage_content_process) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security::pref_usage_content_process.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(266) => {
              if extra_keys_len(&super::start_menu::manually_unpinned_since_last_launch) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::start_menu::manually_unpinned_since_last_launch.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(272) => {
              if extra_keys_len(&super::upgrade_dialog::trigger_reason) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::upgrade_dialog::trigger_reason.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(273) => {
              if extra_keys_len(&super::browser_migration::browser_selected_wizard) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_migration::browser_selected_wizard.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(274) => {
              if extra_keys_len(&super::browser_migration::linux_perms_wizard) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_migration::linux_perms_wizard.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(276) => {
              if extra_keys_len(&super::browser_migration::migration_finished_wizard) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_migration::migration_finished_wizard.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(277) => {
              if extra_keys_len(&super::browser_migration::migration_started_wizard) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_migration::migration_started_wizard.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(278) => {
              if extra_keys_len(&super::browser_migration::no_browsers_found_wizard) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_migration::no_browsers_found_wizard.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(279) => {
              if extra_keys_len(&super::browser_migration::opened_wizard) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_migration::opened_wizard.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(280) => {
              if extra_keys_len(&super::browser_migration::profile_selected_wizard) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_migration::profile_selected_wizard.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(281) => {
              if extra_keys_len(&super::browser_migration::resources_selected_wizard) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_migration::resources_selected_wizard.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(282) => {
              if extra_keys_len(&super::browser_migration::safari_password_file_wizard) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_migration::safari_password_file_wizard.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(283) => {
              if extra_keys_len(&super::browser_migration::safari_perms_wizard) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_migration::safari_perms_wizard.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(288) => {
              if extra_keys_len(&super::activity_stream::end_session) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::end_session.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(289) => {
              if extra_keys_len(&super::activity_stream::event_archive_from_pocket) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_archive_from_pocket.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(290) => {
              if extra_keys_len(&super::activity_stream::event_block) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_block.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(291) => {
              if extra_keys_len(&super::activity_stream::event_bookmark_add) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_bookmark_add.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(292) => {
              if extra_keys_len(&super::activity_stream::event_bookmark_delete) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_bookmark_delete.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(293) => {
              if extra_keys_len(&super::activity_stream::event_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(294) => {
              if extra_keys_len(&super::activity_stream::event_click_privacy_info) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_click_privacy_info.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(295) => {
              if extra_keys_len(&super::activity_stream::event_close_newtab_prefs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_close_newtab_prefs.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(296) => {
              if extra_keys_len(&super::activity_stream::event_delete) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_delete.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(297) => {
              if extra_keys_len(&super::activity_stream::event_delete_confirm) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_delete_confirm.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(298) => {
              if extra_keys_len(&super::activity_stream::event_delete_from_pocket) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_delete_from_pocket.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(299) => {
              if extra_keys_len(&super::activity_stream::event_dialog_cancel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_dialog_cancel.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(300) => {
              if extra_keys_len(&super::activity_stream::event_dialog_open) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_dialog_open.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(301) => {
              if extra_keys_len(&super::activity_stream::event_disclaimer_acked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_disclaimer_acked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(302) => {
              if extra_keys_len(&super::activity_stream::event_drag) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_drag.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(303) => {
              if extra_keys_len(&super::activity_stream::event_drop) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_drop.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(304) => {
              if extra_keys_len(&super::activity_stream::event_fakespot_category) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_fakespot_category.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(305) => {
              if extra_keys_len(&super::activity_stream::event_fakespot_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_fakespot_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(306) => {
              if extra_keys_len(&super::activity_stream::event_hide_personalize) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_hide_personalize.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(307) => {
              if extra_keys_len(&super::activity_stream::event_impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(308) => {
              if extra_keys_len(&super::activity_stream::event_menu_add_search) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_menu_add_search.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(309) => {
              if extra_keys_len(&super::activity_stream::event_menu_add_topsite) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_menu_add_topsite.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(310) => {
              if extra_keys_len(&super::activity_stream::event_menu_collapse) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_menu_collapse.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(311) => {
              if extra_keys_len(&super::activity_stream::event_menu_expand) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_menu_expand.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(312) => {
              if extra_keys_len(&super::activity_stream::event_menu_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_menu_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(313) => {
              if extra_keys_len(&super::activity_stream::event_menu_move_down) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_menu_move_down.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(314) => {
              if extra_keys_len(&super::activity_stream::event_menu_move_up) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_menu_move_up.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(315) => {
              if extra_keys_len(&super::activity_stream::event_menu_privacy_notice) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_menu_privacy_notice.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(316) => {
              if extra_keys_len(&super::activity_stream::event_menu_remove) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_menu_remove.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(317) => {
              if extra_keys_len(&super::activity_stream::event_migration_cancel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_migration_cancel.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(318) => {
              if extra_keys_len(&super::activity_stream::event_migration_start) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_migration_start.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(319) => {
              if extra_keys_len(&super::activity_stream::event_open_new_window) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_open_new_window.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(320) => {
              if extra_keys_len(&super::activity_stream::event_open_newtab_prefs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_open_newtab_prefs.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(321) => {
              if extra_keys_len(&super::activity_stream::event_open_private_window) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_open_private_window.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(322) => {
              if extra_keys_len(&super::activity_stream::event_pin) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_pin.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(323) => {
              if extra_keys_len(&super::activity_stream::event_pocket_thumbs_down) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_pocket_thumbs_down.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(324) => {
              if extra_keys_len(&super::activity_stream::event_pocket_thumbs_up) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_pocket_thumbs_up.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(325) => {
              if extra_keys_len(&super::activity_stream::event_pref_changed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_pref_changed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(326) => {
              if extra_keys_len(&super::activity_stream::event_preview_request) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_preview_request.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(327) => {
              if extra_keys_len(&super::activity_stream::event_save_to_pocket) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_save_to_pocket.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(328) => {
              if extra_keys_len(&super::activity_stream::event_search) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_search.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(329) => {
              if extra_keys_len(&super::activity_stream::event_search_edit_add) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_search_edit_add.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(330) => {
              if extra_keys_len(&super::activity_stream::event_search_edit_close) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_search_edit_close.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(331) => {
              if extra_keys_len(&super::activity_stream::event_search_edit_delete) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_search_edit_delete.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(332) => {
              if extra_keys_len(&super::activity_stream::event_search_handoff) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_search_handoff.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(333) => {
              if extra_keys_len(&super::activity_stream::event_show_personalize) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_show_personalize.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(334) => {
              if extra_keys_len(&super::activity_stream::event_show_privacy_info) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_show_privacy_info.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(335) => {
              if extra_keys_len(&super::activity_stream::event_skipped_signin) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_skipped_signin.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(336) => {
              if extra_keys_len(&super::activity_stream::event_submit_email) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_submit_email.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(337) => {
              if extra_keys_len(&super::activity_stream::event_top_sites_edit) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_top_sites_edit.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(338) => {
              if extra_keys_len(&super::activity_stream::event_top_sites_edit_close) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_top_sites_edit_close.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(339) => {
              if extra_keys_len(&super::activity_stream::event_topsite_sponsor_info) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_topsite_sponsor_info.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(340) => {
              if extra_keys_len(&super::activity_stream::event_unpin) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_unpin.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(376) => {
              if extra_keys_len(&super::newtab::closed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::closed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(377) => {
              if extra_keys_len(&super::newtab::fakespot_about_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::fakespot_about_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(378) => {
              if extra_keys_len(&super::newtab::fakespot_category) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::fakespot_category.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(379) => {
              if extra_keys_len(&super::newtab::fakespot_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::fakespot_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(380) => {
              if extra_keys_len(&super::newtab::fakespot_cta_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::fakespot_cta_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(381) => {
              if extra_keys_len(&super::newtab::fakespot_dismiss) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::fakespot_dismiss.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(382) => {
              if extra_keys_len(&super::newtab::fakespot_product_impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::fakespot_product_impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(386) => {
              if extra_keys_len(&super::newtab::opened) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::opened.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(389) => {
              if extra_keys_len(&super::newtab::tooltip_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::tooltip_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(390) => {
              if extra_keys_len(&super::newtab::topic_selection_dismiss) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::topic_selection_dismiss.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(391) => {
              if extra_keys_len(&super::newtab::topic_selection_open) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::topic_selection_open.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(392) => {
              if extra_keys_len(&super::newtab::topic_selection_topics_saved) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::topic_selection_topics_saved.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(393) => {
              if extra_keys_len(&super::newtab::wallpaper_category_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::wallpaper_category_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(394) => {
              if extra_keys_len(&super::newtab::wallpaper_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::wallpaper_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(395) => {
              if extra_keys_len(&super::newtab::wallpaper_highlight_cta_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::wallpaper_highlight_cta_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(396) => {
              if extra_keys_len(&super::newtab::wallpaper_highlight_dismissed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::wallpaper_highlight_dismissed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(397) => {
              if extra_keys_len(&super::newtab::weather_change_display) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::weather_change_display.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(399) => {
              if extra_keys_len(&super::newtab::weather_impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::weather_impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(400) => {
              if extra_keys_len(&super::newtab::weather_load_error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::weather_load_error.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(401) => {
              if extra_keys_len(&super::newtab::weather_location_selected) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::weather_location_selected.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(402) => {
              if extra_keys_len(&super::newtab::weather_open_provider_url) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::weather_open_provider_url.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(405) => {
              if extra_keys_len(&super::newtab_search::issued) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_search::issued.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(406) => {
              if extra_keys_len(&super::pocket::click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(407) => {
              if extra_keys_len(&super::pocket::dismiss) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::dismiss.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(410) => {
              if extra_keys_len(&super::pocket::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(413) => {
              if extra_keys_len(&super::pocket::save) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::save.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(416) => {
              if extra_keys_len(&super::pocket::thumb_voting_interaction) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::thumb_voting_interaction.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(417) => {
              if extra_keys_len(&super::pocket::topic_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::topic_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(425) => {
              if extra_keys_len(&super::topsites::click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::topsites::click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(426) => {
              if extra_keys_len(&super::topsites::dismiss) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::topsites::dismiss.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(428) => {
              if extra_keys_len(&super::topsites::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::topsites::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(429) => {
              if extra_keys_len(&super::topsites::pref_changed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::topsites::pref_changed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(431) => {
              if extra_keys_len(&super::topsites::show_privacy_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::topsites::show_privacy_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(445) => {
              if extra_keys_len(&super::aboutpreferences::show_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::aboutpreferences::show_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(446) => {
              if extra_keys_len(&super::aboutpreferences::show_hash) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::aboutpreferences::show_hash.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(447) => {
              if extra_keys_len(&super::aboutpreferences::show_initial) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::aboutpreferences::show_initial.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(448) => {
              if extra_keys_len(&super::intl_ui_browser_language::accept_dialog) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::accept_dialog.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(449) => {
              if extra_keys_len(&super::intl_ui_browser_language::add_dialog) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::add_dialog.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(450) => {
              if extra_keys_len(&super::intl_ui_browser_language::apply_main) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::apply_main.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(451) => {
              if extra_keys_len(&super::intl_ui_browser_language::cancel_dialog) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::cancel_dialog.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(452) => {
              if extra_keys_len(&super::intl_ui_browser_language::manage_main) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::manage_main.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(453) => {
              if extra_keys_len(&super::intl_ui_browser_language::remove_dialog) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::remove_dialog.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(454) => {
              if extra_keys_len(&super::intl_ui_browser_language::reorder_dialog) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::reorder_dialog.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(455) => {
              if extra_keys_len(&super::intl_ui_browser_language::reorder_main) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::reorder_main.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(456) => {
              if extra_keys_len(&super::intl_ui_browser_language::search_dialog) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::search_dialog.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(457) => {
              if extra_keys_len(&super::intl_ui_browser_language::search_main) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::search_main.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(458) => {
              if extra_keys_len(&super::intl_ui_browser_language::set_fallback_dialog) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::set_fallback_dialog.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(459) => {
              if extra_keys_len(&super::privacy_ui_fpp_click::checkbox) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::privacy_ui_fpp_click::checkbox.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(460) => {
              if extra_keys_len(&super::privacy_ui_fpp_click::menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::privacy_ui_fpp_click::menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(461) => {
              if extra_keys_len(&super::security_doh_settings::mode_changed_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_settings::mode_changed_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(462) => {
              if extra_keys_len(&super::security_doh_settings::provider_choice_value) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_settings::provider_choice_value.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(463) => {
              if extra_keys_len(&super::security_doh_settings::warn_checkbox_checkbox) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_settings::warn_checkbox_checkbox.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(464) => {
              if extra_keys_len(&super::aboutprivatebrowsing::click_dismiss_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::aboutprivatebrowsing::click_dismiss_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(465) => {
              if extra_keys_len(&super::aboutprivatebrowsing::click_info_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::aboutprivatebrowsing::click_info_link.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(466) => {
              if extra_keys_len(&super::aboutprivatebrowsing::click_promo_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::aboutprivatebrowsing::click_promo_link.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(467) => {
              if extra_keys_len(&super::private_browsing_reset_pbm::confirm_panel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::private_browsing_reset_pbm::confirm_panel.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(468) => {
              if extra_keys_len(&super::private_browsing_reset_pbm::reset_action) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::private_browsing_reset_pbm::reset_action.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(469) => {
              if extra_keys_len(&super::security_ui_protections::click_lw_about_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_lw_about_link.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(470) => {
              if extra_keys_len(&super::security_ui_protections::click_lw_open_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_lw_open_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(471) => {
              if extra_keys_len(&super::security_ui_protections::click_lw_sync_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_lw_sync_link.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(472) => {
              if extra_keys_len(&super::security_ui_protections::click_mobile_app_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_mobile_app_link.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(473) => {
              if extra_keys_len(&super::security_ui_protections::click_mtr_about_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_mtr_about_link.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(474) => {
              if extra_keys_len(&super::security_ui_protections::click_mtr_report_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_mtr_report_link.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(475) => {
              if extra_keys_len(&super::security_ui_protections::click_mtr_signup_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_mtr_signup_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(476) => {
              if extra_keys_len(&super::security_ui_protections::click_settings_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_settings_link.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(477) => {
              if extra_keys_len(&super::security_ui_protections::click_trackers_about_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_trackers_about_link.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(478) => {
              if extra_keys_len(&super::security_ui_protections::click_vpn_app_link_android) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_vpn_app_link_android.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(479) => {
              if extra_keys_len(&super::security_ui_protections::click_vpn_app_link_ios) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_vpn_app_link_ios.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(480) => {
              if extra_keys_len(&super::security_ui_protections::click_vpn_banner_close) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_vpn_banner_close.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(481) => {
              if extra_keys_len(&super::security_ui_protections::click_vpn_banner_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_vpn_banner_link.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(482) => {
              if extra_keys_len(&super::security_ui_protections::click_vpn_card_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_vpn_card_link.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(483) => {
              if extra_keys_len(&super::security_ui_protections::close_protection_report) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::close_protection_report.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(484) => {
              if extra_keys_len(&super::security_ui_protections::show_protection_report) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::show_protection_report.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(485) => {
              if extra_keys_len(&super::security_ui_protections::show_vpn_banner) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::show_vpn_banner.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(488) => {
              if extra_keys_len(&super::protocolhandler_mailto::visit) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::protocolhandler_mailto::visit.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(489) => {
              if extra_keys_len(&super::screenshots::canceled_context_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::canceled_context_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(490) => {
              if extra_keys_len(&super::screenshots::canceled_escape) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::canceled_escape.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(491) => {
              if extra_keys_len(&super::screenshots::canceled_navigation) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::canceled_navigation.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(492) => {
              if extra_keys_len(&super::screenshots::canceled_overlay_cancel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::canceled_overlay_cancel.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(493) => {
              if extra_keys_len(&super::screenshots::canceled_preview_cancel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::canceled_preview_cancel.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(494) => {
              if extra_keys_len(&super::screenshots::canceled_quick_actions) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::canceled_quick_actions.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(495) => {
              if extra_keys_len(&super::screenshots::canceled_shortcut) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::canceled_shortcut.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(496) => {
              if extra_keys_len(&super::screenshots::canceled_toolbar_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::canceled_toolbar_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(497) => {
              if extra_keys_len(&super::screenshots::copy_overlay_copy) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::copy_overlay_copy.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(498) => {
              if extra_keys_len(&super::screenshots::copy_preview_copy) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::copy_preview_copy.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(499) => {
              if extra_keys_len(&super::screenshots::download_overlay_download) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::download_overlay_download.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(500) => {
              if extra_keys_len(&super::screenshots::download_preview_download) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::download_preview_download.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(501) => {
              if extra_keys_len(&super::screenshots::failed_screenshot_too_large) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::failed_screenshot_too_large.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(502) => {
              if extra_keys_len(&super::screenshots::selected_element) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::selected_element.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(503) => {
              if extra_keys_len(&super::screenshots::selected_full_page) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::selected_full_page.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(504) => {
              if extra_keys_len(&super::screenshots::selected_region_selection) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::selected_region_selection.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(505) => {
              if extra_keys_len(&super::screenshots::selected_visible) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::selected_visible.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(506) => {
              if extra_keys_len(&super::screenshots::started_context_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::started_context_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(507) => {
              if extra_keys_len(&super::screenshots::started_overlay_retry) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::started_overlay_retry.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(508) => {
              if extra_keys_len(&super::screenshots::started_preview_retry) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::started_preview_retry.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(509) => {
              if extra_keys_len(&super::screenshots::started_quick_actions) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::started_quick_actions.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(510) => {
              if extra_keys_len(&super::screenshots::started_shortcut) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::started_shortcut.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(511) => {
              if extra_keys_len(&super::screenshots::started_toolbar_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::started_toolbar_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(560) => {
              if extra_keys_len(&super::newtab_search_ad::click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_search_ad::click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(561) => {
              if extra_keys_len(&super::newtab_search_ad::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_search_ad::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(564) => {
              if extra_keys_len(&super::serp::abandonment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::serp::abandonment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(565) => {
              if extra_keys_len(&super::serp::ad_impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::serp::ad_impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(567) => {
              if extra_keys_len(&super::serp::categorization) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::serp::categorization.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(570) => {
              if extra_keys_len(&super::serp::engagement) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::serp::engagement.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(572) => {
              if extra_keys_len(&super::serp::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::serp::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(588) => {
              if extra_keys_len(&super::session_restore::backup_can_be_loaded_session_file) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::session_restore::backup_can_be_loaded_session_file.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(589) => {
              if extra_keys_len(&super::session_restore::shutdown_success_session_startup) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::session_restore::shutdown_success_session_startup.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(590) => {
              if extra_keys_len(&super::shopping::address_bar_feature_callout_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::address_bar_feature_callout_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(591) => {
              if extra_keys_len(&super::shopping::address_bar_icon_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::address_bar_icon_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(592) => {
              if extra_keys_len(&super::shopping::address_bar_icon_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::address_bar_icon_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(593) => {
              if extra_keys_len(&super::shopping::ads_exposure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::ads_exposure.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(595) => {
              if extra_keys_len(&super::shopping::surface_ads_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_ads_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(596) => {
              if extra_keys_len(&super::shopping::surface_ads_impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_ads_impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(597) => {
              if extra_keys_len(&super::shopping::surface_ads_placement) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_ads_placement.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(598) => {
              if extra_keys_len(&super::shopping::surface_ads_setting_toggled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_ads_setting_toggled.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(599) => {
              if extra_keys_len(&super::shopping::surface_analyze_reviews_none_available_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_analyze_reviews_none_available_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(600) => {
              if extra_keys_len(&super::shopping::surface_auto_open_setting_toggled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_auto_open_setting_toggled.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(601) => {
              if extra_keys_len(&super::shopping::surface_closed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_closed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(602) => {
              if extra_keys_len(&super::shopping::surface_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(603) => {
              if extra_keys_len(&super::shopping::surface_learn_more_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_learn_more_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(604) => {
              if extra_keys_len(&super::shopping::surface_no_ads_available) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_no_ads_available.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(605) => {
              if extra_keys_len(&super::shopping::surface_no_review_reliability_available) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_no_review_reliability_available.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(606) => {
              if extra_keys_len(&super::shopping::surface_no_thanks_button_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_no_thanks_button_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(607) => {
              if extra_keys_len(&super::shopping::surface_not_now_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_not_now_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(608) => {
              if extra_keys_len(&super::shopping::surface_onboarding_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_onboarding_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(609) => {
              if extra_keys_len(&super::shopping::surface_opt_in_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_opt_in_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(610) => {
              if extra_keys_len(&super::shopping::surface_opt_out_button_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_opt_out_button_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(611) => {
              if extra_keys_len(&super::shopping::surface_powered_by_fakespot_link_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_powered_by_fakespot_link_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(612) => {
              if extra_keys_len(&super::shopping::surface_reactivated_button_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_reactivated_button_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(613) => {
              if extra_keys_len(&super::shopping::surface_reanalyze_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_reanalyze_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(614) => {
              if extra_keys_len(&super::shopping::surface_settings_expand_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_settings_expand_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(615) => {
              if extra_keys_len(&super::shopping::surface_show_more_reviews_button_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_show_more_reviews_button_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(616) => {
              if extra_keys_len(&super::shopping::surface_show_privacy_policy_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_show_privacy_policy_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(617) => {
              if extra_keys_len(&super::shopping::surface_show_quality_explainer_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_show_quality_explainer_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(618) => {
              if extra_keys_len(&super::shopping::surface_show_quality_explainer_url_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_show_quality_explainer_url_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(619) => {
              if extra_keys_len(&super::shopping::surface_show_terms_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_show_terms_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(620) => {
              if extra_keys_len(&super::shopping::surface_stale_analysis_shown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_stale_analysis_shown.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(621) => {
              if extra_keys_len(&super::shopping::surface_yes_keep_closed_button_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_yes_keep_closed_button_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(627) => {
              if extra_keys_len(&super::bookmarks::sidebar_toggle) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::bookmarks::sidebar_toggle.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(628) => {
              if extra_keys_len(&super::extension::sidebar_toggle) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::extension::sidebar_toggle.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(629) => {
              if extra_keys_len(&super::history::sidebar_toggle) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::history::sidebar_toggle.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(630) => {
              if extra_keys_len(&super::sidebar::addon_icon_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar::addon_icon_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(631) => {
              if extra_keys_len(&super::sidebar::bookmarks_icon_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar::bookmarks_icon_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(632) => {
              if extra_keys_len(&super::sidebar::chatbot_icon_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar::chatbot_icon_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(634) => {
              if extra_keys_len(&super::sidebar::expand) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar::expand.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(635) => {
              if extra_keys_len(&super::sidebar::history_icon_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar::history_icon_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(638) => {
              if extra_keys_len(&super::sidebar::resize) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar::resize.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(640) => {
              if extra_keys_len(&super::sidebar::synced_tabs_icon_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar::synced_tabs_icon_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(643) => {
              if extra_keys_len(&super::sidebar_customize::bookmarks_enabled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::bookmarks_enabled.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(644) => {
              if extra_keys_len(&super::sidebar_customize::chatbot_enabled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::chatbot_enabled.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(645) => {
              if extra_keys_len(&super::sidebar_customize::extensions_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::extensions_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(646) => {
              if extra_keys_len(&super::sidebar_customize::firefox_settings_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::firefox_settings_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(647) => {
              if extra_keys_len(&super::sidebar_customize::history_enabled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::history_enabled.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(648) => {
              if extra_keys_len(&super::sidebar_customize::icon_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::icon_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(649) => {
              if extra_keys_len(&super::sidebar_customize::panel_toggle) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::panel_toggle.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(650) => {
              if extra_keys_len(&super::sidebar_customize::sidebar_display) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::sidebar_display.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(651) => {
              if extra_keys_len(&super::sidebar_customize::sidebar_position) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::sidebar_position.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(652) => {
              if extra_keys_len(&super::sidebar_customize::synced_tabs_enabled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::synced_tabs_enabled.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(653) => {
              if extra_keys_len(&super::sidebar_customize::tabs_display) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::tabs_display.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(654) => {
              if extra_keys_len(&super::sidebar_customize::tabs_layout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::tabs_layout.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(655) => {
              if extra_keys_len(&super::synced_tabs::sidebar_toggle) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::synced_tabs::sidebar_toggle.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(656) => {
              if extra_keys_len(&super::synced_tabs::click_fxa_app_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::synced_tabs::click_fxa_app_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(657) => {
              if extra_keys_len(&super::synced_tabs::click_fxa_avatar_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::synced_tabs::click_fxa_avatar_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(658) => {
              if extra_keys_len(&super::synced_tabs::click_synced_tabs_sidebar) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::synced_tabs::click_synced_tabs_sidebar.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(706) => {
              if extra_keys_len(&super::urlbar::abandonment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::abandonment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(707) => {
              if extra_keys_len(&super::urlbar::engagement) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::engagement.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(708) => {
              if extra_keys_len(&super::urlbar::exposure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::exposure.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(709) => {
              if extra_keys_len(&super::urlbar::fakespot_engagement) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::fakespot_engagement.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(710) => {
              if extra_keys_len(&super::urlbar::keyword_exposure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::keyword_exposure.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(716) => {
              if extra_keys_len(&super::urlbar::quick_suggest_contextual_opt_in) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::quick_suggest_contextual_opt_in.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(718) => {
              if extra_keys_len(&super::addons_search_detection::etld_change_other) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_search_detection::etld_change_other.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(719) => {
              if extra_keys_len(&super::addons_search_detection::etld_change_webrequest) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_search_detection::etld_change_webrequest.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(727) => {
              if extra_keys_len(&super::browser_usage::interaction) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_usage::interaction.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(728) => {
              if extra_keys_len(&super::homepage::preference_ignore) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::homepage::preference_ignore.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(729) => {
              if extra_keys_len(&super::installation::first_seen_full) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::installation::first_seen_full.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(730) => {
              if extra_keys_len(&super::installation::first_seen_msix) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::installation::first_seen_msix.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(731) => {
              if extra_keys_len(&super::installation::first_seen_stub) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::installation::first_seen_stub.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(743) => {
              if extra_keys_len(&super::partner_link::attribution_abort) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::partner_link::attribution_abort.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(744) => {
              if extra_keys_len(&super::partner_link::attribution_failure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::partner_link::attribution_failure.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(745) => {
              if extra_keys_len(&super::partner_link::attribution_success) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::partner_link::attribution_success.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(746) => {
              if extra_keys_len(&super::partner_link::click_newtab) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::partner_link::click_newtab.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(747) => {
              if extra_keys_len(&super::partner_link::click_urlbar) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::partner_link::click_urlbar.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(751) => {
              if extra_keys_len(&super::devtools_main::activate_responsive_design) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::activate_responsive_design.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(752) => {
              if extra_keys_len(&super::devtools_main::activate_split_console) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::activate_split_console.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(753) => {
              if extra_keys_len(&super::devtools_main::add_breakpoint_debugger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::add_breakpoint_debugger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(754) => {
              if extra_keys_len(&super::devtools_main::blackbox_debugger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::blackbox_debugger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(755) => {
              if extra_keys_len(&super::devtools_main::close_adbg_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::close_adbg_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(756) => {
              if extra_keys_len(&super::devtools_main::close_tools) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::close_tools.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(757) => {
              if extra_keys_len(&super::devtools_main::connection_attempt_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::connection_attempt_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(758) => {
              if extra_keys_len(&super::devtools_main::continue_debugger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::continue_debugger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(759) => {
              if extra_keys_len(&super::devtools_main::deactivate_responsive_design) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::deactivate_responsive_design.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(760) => {
              if extra_keys_len(&super::devtools_main::deactivate_split_console) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::deactivate_split_console.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(761) => {
              if extra_keys_len(&super::devtools_main::device_added_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::device_added_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(762) => {
              if extra_keys_len(&super::devtools_main::device_removed_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::device_removed_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(763) => {
              if extra_keys_len(&super::devtools_main::edit_html_inspector) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::edit_html_inspector.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(764) => {
              if extra_keys_len(&super::devtools_main::edit_resend_netmonitor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::edit_resend_netmonitor.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(765) => {
              if extra_keys_len(&super::devtools_main::edit_rule_ruleview) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::edit_rule_ruleview.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(766) => {
              if extra_keys_len(&super::devtools_main::enter_accessibility) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_accessibility.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(767) => {
              if extra_keys_len(&super::devtools_main::enter_application) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_application.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(768) => {
              if extra_keys_len(&super::devtools_main::enter_dom) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_dom.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(769) => {
              if extra_keys_len(&super::devtools_main::enter_fake_tool4242) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_fake_tool4242.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(770) => {
              if extra_keys_len(&super::devtools_main::enter_inspector) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_inspector.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(771) => {
              if extra_keys_len(&super::devtools_main::enter_jsdebugger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_jsdebugger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(772) => {
              if extra_keys_len(&super::devtools_main::enter_memory) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_memory.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(773) => {
              if extra_keys_len(&super::devtools_main::enter_netmonitor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_netmonitor.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(774) => {
              if extra_keys_len(&super::devtools_main::enter_options) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_options.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(775) => {
              if extra_keys_len(&super::devtools_main::enter_other) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_other.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(776) => {
              if extra_keys_len(&super::devtools_main::enter_performance) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_performance.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(777) => {
              if extra_keys_len(&super::devtools_main::enter_storage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_storage.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(778) => {
              if extra_keys_len(&super::devtools_main::enter_styleeditor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_styleeditor.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(779) => {
              if extra_keys_len(&super::devtools_main::enter_test_blank_panel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_test_blank_panel.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(780) => {
              if extra_keys_len(&super::devtools_main::enter_test_tool) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_test_tool.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(781) => {
              if extra_keys_len(&super::devtools_main::enter_test_tool1072208) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_test_tool1072208.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(782) => {
              if extra_keys_len(&super::devtools_main::enter_testtool1) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_testtool1.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(783) => {
              if extra_keys_len(&super::devtools_main::enter_testtool2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_testtool2.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(784) => {
              if extra_keys_len(&super::devtools_main::enter_webconsole) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_webconsole.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(785) => {
              if extra_keys_len(&super::devtools_main::enter_whatsnew) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_whatsnew.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(786) => {
              if extra_keys_len(&super::devtools_main::execute_js_webconsole) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::execute_js_webconsole.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(787) => {
              if extra_keys_len(&super::devtools_main::exit_accessibility) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_accessibility.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(788) => {
              if extra_keys_len(&super::devtools_main::exit_application) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_application.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(789) => {
              if extra_keys_len(&super::devtools_main::exit_dom) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_dom.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(790) => {
              if extra_keys_len(&super::devtools_main::exit_fake_tool4242) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_fake_tool4242.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(791) => {
              if extra_keys_len(&super::devtools_main::exit_inspector) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_inspector.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(792) => {
              if extra_keys_len(&super::devtools_main::exit_jsdebugger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_jsdebugger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(793) => {
              if extra_keys_len(&super::devtools_main::exit_memory) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_memory.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(794) => {
              if extra_keys_len(&super::devtools_main::exit_netmonitor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_netmonitor.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(795) => {
              if extra_keys_len(&super::devtools_main::exit_options) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_options.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(796) => {
              if extra_keys_len(&super::devtools_main::exit_other) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_other.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(797) => {
              if extra_keys_len(&super::devtools_main::exit_performance) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_performance.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(798) => {
              if extra_keys_len(&super::devtools_main::exit_storage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_storage.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(799) => {
              if extra_keys_len(&super::devtools_main::exit_styleeditor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_styleeditor.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(800) => {
              if extra_keys_len(&super::devtools_main::exit_test_blank_panel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_test_blank_panel.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(801) => {
              if extra_keys_len(&super::devtools_main::exit_test_tool) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_test_tool.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(802) => {
              if extra_keys_len(&super::devtools_main::exit_test_tool1072208) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_test_tool1072208.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(803) => {
              if extra_keys_len(&super::devtools_main::exit_testtool1) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_testtool1.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(804) => {
              if extra_keys_len(&super::devtools_main::exit_testtool2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_testtool2.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(805) => {
              if extra_keys_len(&super::devtools_main::exit_webconsole) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_webconsole.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(806) => {
              if extra_keys_len(&super::devtools_main::exit_whatsnew) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_whatsnew.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(807) => {
              if extra_keys_len(&super::devtools_main::filters_changed_netmonitor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::filters_changed_netmonitor.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(808) => {
              if extra_keys_len(&super::devtools_main::filters_changed_webconsole) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::filters_changed_webconsole.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(809) => {
              if extra_keys_len(&super::devtools_main::inspect_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::inspect_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(810) => {
              if extra_keys_len(&super::devtools_main::jump_to_definition_webconsole) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::jump_to_definition_webconsole.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(811) => {
              if extra_keys_len(&super::devtools_main::jump_to_source_webconsole) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::jump_to_source_webconsole.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(812) => {
              if extra_keys_len(&super::devtools_main::object_expanded_webconsole) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::object_expanded_webconsole.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(813) => {
              if extra_keys_len(&super::devtools_main::open_adbg_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::open_adbg_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(814) => {
              if extra_keys_len(&super::devtools_main::open_tools) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::open_tools.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(815) => {
              if extra_keys_len(&super::devtools_main::pause_debugger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::pause_debugger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(816) => {
              if extra_keys_len(&super::devtools_main::pause_on_exceptions_debugger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::pause_on_exceptions_debugger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(817) => {
              if extra_keys_len(&super::devtools_main::persist_changed_netmonitor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::persist_changed_netmonitor.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(818) => {
              if extra_keys_len(&super::devtools_main::persist_changed_webconsole) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::persist_changed_webconsole.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(819) => {
              if extra_keys_len(&super::devtools_main::pretty_print_debugger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::pretty_print_debugger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(820) => {
              if extra_keys_len(&super::devtools_main::remove_breakpoint_debugger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::remove_breakpoint_debugger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(821) => {
              if extra_keys_len(&super::devtools_main::reverse_search_webconsole) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::reverse_search_webconsole.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(822) => {
              if extra_keys_len(&super::devtools_main::runtime_added_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::runtime_added_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(823) => {
              if extra_keys_len(&super::devtools_main::runtime_connected_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::runtime_connected_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(824) => {
              if extra_keys_len(&super::devtools_main::runtime_disconnected_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::runtime_disconnected_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(825) => {
              if extra_keys_len(&super::devtools_main::runtime_removed_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::runtime_removed_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(826) => {
              if extra_keys_len(&super::devtools_main::select_page_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::select_page_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(827) => {
              if extra_keys_len(&super::devtools_main::select_page_application) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::select_page_application.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(828) => {
              if extra_keys_len(&super::devtools_main::select_ws_frame_netmonitor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::select_ws_frame_netmonitor.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(829) => {
              if extra_keys_len(&super::devtools_main::show_profiler_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::show_profiler_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(830) => {
              if extra_keys_len(&super::devtools_main::sidepanel_changed_inspector) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::sidepanel_changed_inspector.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(831) => {
              if extra_keys_len(&super::devtools_main::sidepanel_changed_netmonitor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::sidepanel_changed_netmonitor.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(832) => {
              if extra_keys_len(&super::devtools_main::start_worker_application) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::start_worker_application.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(833) => {
              if extra_keys_len(&super::devtools_main::throttle_changed_netmonitor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::throttle_changed_netmonitor.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(834) => {
              if extra_keys_len(&super::devtools_main::tool_timer_animationinspector) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::tool_timer_animationinspector.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(835) => {
              if extra_keys_len(&super::devtools_main::tool_timer_changesview) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::tool_timer_changesview.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(836) => {
              if extra_keys_len(&super::devtools_main::tool_timer_compatibilityview) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::tool_timer_compatibilityview.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(837) => {
              if extra_keys_len(&super::devtools_main::tool_timer_computedview) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::tool_timer_computedview.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(838) => {
              if extra_keys_len(&super::devtools_main::tool_timer_fontinspector) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::tool_timer_fontinspector.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(839) => {
              if extra_keys_len(&super::devtools_main::tool_timer_layoutview) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::tool_timer_layoutview.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(840) => {
              if extra_keys_len(&super::devtools_main::tool_timer_ruleview) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::tool_timer_ruleview.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(841) => {
              if extra_keys_len(&super::devtools_main::unregister_worker_application) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::unregister_worker_application.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(842) => {
              if extra_keys_len(&super::devtools_main::update_conn_prompt_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::update_conn_prompt_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3185) => {
              if extra_keys_len(&super::mediadrm::eme_playback) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::mediadrm::eme_playback.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3188) => {
              if extra_keys_len(&super::hls::media_load) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::hls::media_load.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3197) => {
              if extra_keys_len(&super::media_playback::first_frame_loaded) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::media_playback::first_frame_loaded.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3199) => {
              if extra_keys_len(&super::mfcdm::eme_playback) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::mfcdm::eme_playback.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3200) => {
              if extra_keys_len(&super::mfcdm::error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::mfcdm::error.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3244) => {
              if extra_keys_len(&super::perf::page_load) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::perf::page_load.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3267) => {
              if extra_keys_len(&super::dom_quota_try::error_step) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::dom_quota_try::error_step.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3345) => {
              if extra_keys_len(&super::avif::dav1d_get_picture_return_value) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::avif::dav1d_get_picture_return_value.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3366) => {
              if extra_keys_len(&super::slow_script_warning::shown_browser) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::slow_script_warning::shown_browser.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3367) => {
              if extra_keys_len(&super::slow_script_warning::shown_content) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::slow_script_warning::shown_content.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3375) => {
              if extra_keys_len(&super::zero_byte_load::load_css) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_css.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3376) => {
              if extra_keys_len(&super::zero_byte_load::load_dtd) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_dtd.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3377) => {
              if extra_keys_len(&super::zero_byte_load::load_ftl) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_ftl.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3378) => {
              if extra_keys_len(&super::zero_byte_load::load_html) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_html.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3379) => {
              if extra_keys_len(&super::zero_byte_load::load_js) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_js.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3380) => {
              if extra_keys_len(&super::zero_byte_load::load_json) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_json.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3381) => {
              if extra_keys_len(&super::zero_byte_load::load_others) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_others.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3382) => {
              if extra_keys_len(&super::zero_byte_load::load_png) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_png.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3383) => {
              if extra_keys_len(&super::zero_byte_load::load_properties) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_properties.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3384) => {
              if extra_keys_len(&super::zero_byte_load::load_svg) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_svg.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3385) => {
              if extra_keys_len(&super::zero_byte_load::load_xhtml) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_xhtml.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3386) => {
              if extra_keys_len(&super::zero_byte_load::load_xml) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_xml.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3388) => {
              if extra_keys_len(&super::network_dns::trr_confirmation_context) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::network_dns::trr_confirmation_context.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3441) => {
              if extra_keys_len(&super::ysod::shown_ysod) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::ysod::shown_ysod.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3474) => {
              if extra_keys_len(&super::uptake_remotecontent_result::uptake_normandy) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::uptake_remotecontent_result::uptake_normandy.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3475) => {
              if extra_keys_len(&super::uptake_remotecontent_result::uptake_remotesettings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::uptake_remotecontent_result::uptake_remotesettings.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3478) => {
              if extra_keys_len(&super::fxa::connect_account) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa::connect_account.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3479) => {
              if extra_keys_len(&super::fxa::disconnect_account) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa::disconnect_account.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3480) => {
              if extra_keys_len(&super::fxa_app_menu::click_account_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_account_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3481) => {
              if extra_keys_len(&super::fxa_app_menu::click_cad) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_cad.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3482) => {
              if extra_keys_len(&super::fxa_app_menu::click_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_login.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3483) => {
              if extra_keys_len(&super::fxa_app_menu::click_monitor_cta) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_monitor_cta.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3484) => {
              if extra_keys_len(&super::fxa_app_menu::click_open_monitor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_open_monitor.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3485) => {
              if extra_keys_len(&super::fxa_app_menu::click_open_send) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_open_send.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3486) => {
              if extra_keys_len(&super::fxa_app_menu::click_relay_cta) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_relay_cta.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3487) => {
              if extra_keys_len(&super::fxa_app_menu::click_send_tab) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_send_tab.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3488) => {
              if extra_keys_len(&super::fxa_app_menu::click_sync_cta) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_sync_cta.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3489) => {
              if extra_keys_len(&super::fxa_app_menu::click_sync_now) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_sync_now.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3490) => {
              if extra_keys_len(&super::fxa_app_menu::click_sync_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_sync_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3491) => {
              if extra_keys_len(&super::fxa_app_menu::click_sync_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_sync_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3492) => {
              if extra_keys_len(&super::fxa_app_menu::click_sync_tabs_sidebar) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_sync_tabs_sidebar.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3493) => {
              if extra_keys_len(&super::fxa_app_menu::click_toolbar_icon) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_toolbar_icon.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3494) => {
              if extra_keys_len(&super::fxa_app_menu::click_unver_sync_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_unver_sync_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3495) => {
              if extra_keys_len(&super::fxa_app_menu::click_vpn_cta) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_vpn_cta.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3496) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_account_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_account_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3497) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_cad) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_cad.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3498) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_login.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3499) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_monitor_cta) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_monitor_cta.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3500) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_open_monitor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_open_monitor.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3501) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_open_send) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_open_send.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3502) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_relay_cta) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_relay_cta.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3503) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_send_tab) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_send_tab.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3504) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_sync_cta) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_sync_cta.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3505) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_sync_now) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_sync_now.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3506) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_sync_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_sync_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3507) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_sync_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_sync_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3508) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_sync_tabs_sidebar) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_sync_tabs_sidebar.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3509) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_toolbar_icon) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_toolbar_icon.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3510) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_unver_sync_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_unver_sync_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3511) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_vpn_cta) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_vpn_cta.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3514) => {
              if extra_keys_len(&super::bounce_tracking_protection::purge_action) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::bounce_tracking_protection::purge_action.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3523) => {
              if extra_keys_len(&super::background_tasks_rmdir_base::metric_base) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::background_tasks_rmdir_base::metric_base.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3531) => {
              if extra_keys_len(&super::background_tasks_rmdir_http_cache::metric_base) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::background_tasks_rmdir_http_cache::metric_base.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3539) => {
              if extra_keys_len(&super::background_tasks_rmdir_quota::metric_base) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::background_tasks_rmdir_quota::metric_base.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3547) => {
              if extra_keys_len(&super::relevancy_classify::fail) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relevancy_classify::fail.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3548) => {
              if extra_keys_len(&super::relevancy_classify::succeed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relevancy_classify::succeed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3551) => {
              if extra_keys_len(&super::cookie_banners::google_gdpr_choice_cookie_event) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::cookie_banners::google_gdpr_choice_cookie_event.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3552) => {
              if extra_keys_len(&super::cookie_banners::google_gdpr_choice_cookie_event_pbm) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::cookie_banners::google_gdpr_choice_cookie_event_pbm.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3555) => {
              if extra_keys_len(&super::cookie_banners::reload) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::cookie_banners::reload.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3633) => {
              if extra_keys_len(&super::extensions_data::migrate_result) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::extensions_data::migrate_result.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3634) => {
              if extra_keys_len(&super::extensions_data::storage_local_error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::extensions_data::storage_local_error.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3635) => {
              if extra_keys_len(&super::extensions_data::sync_usage_quotas) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::extensions_data::sync_usage_quotas.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3644) => {
              if extra_keys_len(&super::address::add_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::add_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3645) => {
              if extra_keys_len(&super::address::cancel_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::cancel_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3646) => {
              if extra_keys_len(&super::address::cancel_edit_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::cancel_edit_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3647) => {
              if extra_keys_len(&super::address::cancel_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::cancel_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3648) => {
              if extra_keys_len(&super::address::cleared_address_form) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::cleared_address_form.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3649) => {
              if extra_keys_len(&super::address::delete_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::delete_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3650) => {
              if extra_keys_len(&super::address::detected_address_form) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::detected_address_form.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3651) => {
              if extra_keys_len(&super::address::detected_address_form_ext) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::detected_address_form_ext.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3652) => {
              if extra_keys_len(&super::address::disable_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::disable_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3653) => {
              if extra_keys_len(&super::address::disable_edit_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::disable_edit_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3654) => {
              if extra_keys_len(&super::address::disable_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::disable_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3655) => {
              if extra_keys_len(&super::address::edit_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::edit_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3656) => {
              if extra_keys_len(&super::address::filled_address_form) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::filled_address_form.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3657) => {
              if extra_keys_len(&super::address::filled_address_form_ext) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::filled_address_form_ext.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3658) => {
              if extra_keys_len(&super::address::filled_modified_address_form) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::filled_modified_address_form.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3659) => {
              if extra_keys_len(&super::address::learn_more_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::learn_more_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3660) => {
              if extra_keys_len(&super::address::learn_more_edit_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::learn_more_edit_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3661) => {
              if extra_keys_len(&super::address::learn_more_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::learn_more_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3662) => {
              if extra_keys_len(&super::address::popup_shown_address_form) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::popup_shown_address_form.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3663) => {
              if extra_keys_len(&super::address::pref_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::pref_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3664) => {
              if extra_keys_len(&super::address::pref_edit_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::pref_edit_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3665) => {
              if extra_keys_len(&super::address::pref_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::pref_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3666) => {
              if extra_keys_len(&super::address::save_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::save_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3667) => {
              if extra_keys_len(&super::address::save_edit_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::save_edit_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3668) => {
              if extra_keys_len(&super::address::save_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::save_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3669) => {
              if extra_keys_len(&super::address::show_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::show_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3670) => {
              if extra_keys_len(&super::address::show_edit_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::show_edit_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3671) => {
              if extra_keys_len(&super::address::show_entry_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::show_entry_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3672) => {
              if extra_keys_len(&super::address::show_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::show_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3673) => {
              if extra_keys_len(&super::address::show_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::show_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3674) => {
              if extra_keys_len(&super::address::submitted_address_form) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::submitted_address_form.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3675) => {
              if extra_keys_len(&super::address::submitted_address_form_ext) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::submitted_address_form_ext.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3676) => {
              if extra_keys_len(&super::address::update_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::update_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3677) => {
              if extra_keys_len(&super::address::update_edit_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::update_edit_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3678) => {
              if extra_keys_len(&super::address::update_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::update_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3679) => {
              if extra_keys_len(&super::creditcard::add_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::add_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3680) => {
              if extra_keys_len(&super::creditcard::cancel_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::cancel_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3681) => {
              if extra_keys_len(&super::creditcard::cancel_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::cancel_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3682) => {
              if extra_keys_len(&super::creditcard::cleared_cc_form_v2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::cleared_cc_form_v2.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3683) => {
              if extra_keys_len(&super::creditcard::delete_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::delete_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3684) => {
              if extra_keys_len(&super::creditcard::detected_cc_form_v2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::detected_cc_form_v2.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3685) => {
              if extra_keys_len(&super::creditcard::disable_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::disable_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3686) => {
              if extra_keys_len(&super::creditcard::disable_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::disable_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3687) => {
              if extra_keys_len(&super::creditcard::edit_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::edit_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3688) => {
              if extra_keys_len(&super::creditcard::filled_cc_form_v2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::filled_cc_form_v2.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3689) => {
              if extra_keys_len(&super::creditcard::filled_modified_cc_form_v2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::filled_modified_cc_form_v2.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3690) => {
              if extra_keys_len(&super::creditcard::popup_shown_cc_form_v2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::popup_shown_cc_form_v2.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3691) => {
              if extra_keys_len(&super::creditcard::save_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::save_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3692) => {
              if extra_keys_len(&super::creditcard::save_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::save_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3693) => {
              if extra_keys_len(&super::creditcard::show_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::show_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3694) => {
              if extra_keys_len(&super::creditcard::show_entry_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::show_entry_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3695) => {
              if extra_keys_len(&super::creditcard::show_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::show_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3696) => {
              if extra_keys_len(&super::creditcard::show_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::show_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3697) => {
              if extra_keys_len(&super::creditcard::submitted_cc_form_v2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::submitted_cc_form_v2.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3698) => {
              if extra_keys_len(&super::creditcard::update_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::update_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3699) => {
              if extra_keys_len(&super::creditcard::update_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::update_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3701) => {
              if extra_keys_len(&super::formautofill::iframe_layout_detection) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::formautofill::iframe_layout_detection.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3703) => {
              if extra_keys_len(&super::formautofill_creditcards::form_cleared) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::formautofill_creditcards::form_cleared.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3704) => {
              if extra_keys_len(&super::formautofill_creditcards::form_detected) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::formautofill_creditcards::form_detected.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3705) => {
              if extra_keys_len(&super::formautofill_creditcards::form_filled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::formautofill_creditcards::form_filled.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3706) => {
              if extra_keys_len(&super::formautofill_creditcards::form_filled_modified) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::formautofill_creditcards::form_filled_modified.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3707) => {
              if extra_keys_len(&super::formautofill_creditcards::form_popup_shown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::formautofill_creditcards::form_popup_shown.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3708) => {
              if extra_keys_len(&super::formautofill_creditcards::form_submitted) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::formautofill_creditcards::form_submitted.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3758) => {
              if extra_keys_len(&super::test_only_ipc::an_event) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::test_only_ipc::an_event.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3763) => {
              if extra_keys_len(&super::test_only_ipc::event_with_extra) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::test_only_ipc::event_with_extra.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3765) => {
              if extra_keys_len(&super::test_only_ipc::no_extra_event) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::test_only_ipc::no_extra_event.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3768) => {
              if extra_keys_len(&super::test_only_jog::an_event) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::test_only_jog::an_event.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3769) => {
              if extra_keys_len(&super::messaging_experiments::reach_cfr) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_cfr.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3770) => {
              if extra_keys_len(&super::messaging_experiments::reach_feature_callout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_feature_callout.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3771) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_bmb_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_bmb_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3772) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_1) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_1.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3773) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_10) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_10.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3774) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_11) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_11.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3775) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_2.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3776) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_3) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_3.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3777) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_4) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_4.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3778) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_5) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_5.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3779) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_6) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_6.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3780) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_7) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_7.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3781) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_8) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_8.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3782) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_9) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_9.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3783) => {
              if extra_keys_len(&super::messaging_experiments::reach_infobar) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_infobar.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3784) => {
              if extra_keys_len(&super::messaging_experiments::reach_moments_page) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_moments_page.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3785) => {
              if extra_keys_len(&super::messaging_experiments::reach_spotlight) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_spotlight.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3786) => {
              if extra_keys_len(&super::messaging_experiments::targeting_attribute_error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::targeting_attribute_error.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3787) => {
              if extra_keys_len(&super::messaging_experiments::targeting_attribute_timeout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::targeting_attribute_timeout.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3788) => {
              if extra_keys_len(&super::nimbus_events::enroll_failed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::enroll_failed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3789) => {
              if extra_keys_len(&super::nimbus_events::enrollment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::enrollment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3790) => {
              if extra_keys_len(&super::nimbus_events::enrollment_status) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::enrollment_status.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3791) => {
              if extra_keys_len(&super::nimbus_events::exposure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::exposure.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3792) => {
              if extra_keys_len(&super::nimbus_events::is_ready) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::is_ready.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3793) => {
              if extra_keys_len(&super::nimbus_events::unenroll_failed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::unenroll_failed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3794) => {
              if extra_keys_len(&super::nimbus_events::unenrollment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::unenrollment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3795) => {
              if extra_keys_len(&super::nimbus_events::validation_failed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::validation_failed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3796) => {
              if extra_keys_len(&super::normandy::expose_nimbus_experiment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::expose_nimbus_experiment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3797) => {
              if extra_keys_len(&super::normandy::enroll_addon_rollout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::enroll_addon_rollout.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3798) => {
              if extra_keys_len(&super::normandy::enroll_addon_study) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::enroll_addon_study.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3799) => {
              if extra_keys_len(&super::normandy::enroll_failed_addon_rollout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::enroll_failed_addon_rollout.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3800) => {
              if extra_keys_len(&super::normandy::enroll_failed_addon_study) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::enroll_failed_addon_study.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3801) => {
              if extra_keys_len(&super::normandy::enroll_failed_nimbus_experiment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::enroll_failed_nimbus_experiment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3802) => {
              if extra_keys_len(&super::normandy::enroll_failed_preference_rollout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::enroll_failed_preference_rollout.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3803) => {
              if extra_keys_len(&super::normandy::enroll_failed_preference_study) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::enroll_failed_preference_study.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3804) => {
              if extra_keys_len(&super::normandy::enroll_nimbus_experiment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::enroll_nimbus_experiment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3805) => {
              if extra_keys_len(&super::normandy::enroll_preference_rollout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::enroll_preference_rollout.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3806) => {
              if extra_keys_len(&super::normandy::enroll_preference_study) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::enroll_preference_study.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3807) => {
              if extra_keys_len(&super::normandy::exp_pref_changed_preference_study) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::exp_pref_changed_preference_study.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3808) => {
              if extra_keys_len(&super::normandy::graduate_preference_rollout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::graduate_preference_rollout.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3809) => {
              if extra_keys_len(&super::normandy::unenroll_addon_rollback) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::unenroll_addon_rollback.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3810) => {
              if extra_keys_len(&super::normandy::unenroll_addon_study) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::unenroll_addon_study.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3811) => {
              if extra_keys_len(&super::normandy::unenroll_failed_addon_rollback) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::unenroll_failed_addon_rollback.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3812) => {
              if extra_keys_len(&super::normandy::unenroll_failed_nimbus_experiment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::unenroll_failed_nimbus_experiment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3813) => {
              if extra_keys_len(&super::normandy::unenroll_failed_preference_rollback) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::unenroll_failed_preference_rollback.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3814) => {
              if extra_keys_len(&super::normandy::unenroll_failed_preference_study) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::unenroll_failed_preference_study.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3815) => {
              if extra_keys_len(&super::normandy::unenroll_nimbus_experiment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::unenroll_nimbus_experiment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3816) => {
              if extra_keys_len(&super::normandy::unenroll_preference_rollback) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::unenroll_preference_rollback.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3817) => {
              if extra_keys_len(&super::normandy::unenroll_preference_study) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::unenroll_preference_study.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3818) => {
              if extra_keys_len(&super::normandy::update_addon_rollout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::update_addon_rollout.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3819) => {
              if extra_keys_len(&super::normandy::update_addon_study) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::update_addon_study.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3820) => {
              if extra_keys_len(&super::normandy::update_failed_addon_rollout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::update_failed_addon_rollout.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3821) => {
              if extra_keys_len(&super::normandy::update_failed_addon_study) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::update_failed_addon_study.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3822) => {
              if extra_keys_len(&super::normandy::update_nimbus_experiment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::update_nimbus_experiment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3823) => {
              if extra_keys_len(&super::normandy::update_preference_rollout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::update_preference_rollout.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3824) => {
              if extra_keys_len(&super::normandy::validation_failed_nimbus_experiment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::validation_failed_nimbus_experiment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3825) => {
              if extra_keys_len(&super::form_autocomplete::show_logins) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::form_autocomplete::show_logins.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3826) => {
              if extra_keys_len(&super::pwmgr::autocomplete_field_generatedpassword) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::autocomplete_field_generatedpassword.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3827) => {
              if extra_keys_len(&super::pwmgr::autocomplete_shown_generatedpassword) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::autocomplete_shown_generatedpassword.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3828) => {
              if extra_keys_len(&super::pwmgr::cancel_existing_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::cancel_existing_login.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3829) => {
              if extra_keys_len(&super::pwmgr::cancel_new_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::cancel_new_login.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3830) => {
              if extra_keys_len(&super::pwmgr::copy_password) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::copy_password.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3831) => {
              if extra_keys_len(&super::pwmgr::copy_username) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::copy_username.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3832) => {
              if extra_keys_len(&super::pwmgr::delete_existing_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::delete_existing_login.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3833) => {
              if extra_keys_len(&super::pwmgr::delete_new_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::delete_new_login.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3834) => {
              if extra_keys_len(&super::pwmgr::doorhanger_submitted_save) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::doorhanger_submitted_save.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3835) => {
              if extra_keys_len(&super::pwmgr::doorhanger_submitted_update) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::doorhanger_submitted_update.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3836) => {
              if extra_keys_len(&super::pwmgr::edit_existing_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::edit_existing_login.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3837) => {
              if extra_keys_len(&super::pwmgr::filled_field_edited_generatedpassword) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::filled_field_edited_generatedpassword.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3838) => {
              if extra_keys_len(&super::pwmgr::filter_list) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::filter_list.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3840) => {
              if extra_keys_len(&super::pwmgr::hide_password) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::hide_password.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3841) => {
              if extra_keys_len(&super::pwmgr::learn_more_vuln_existing_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::learn_more_vuln_existing_login.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3842) => {
              if extra_keys_len(&super::pwmgr::mgmt_menu_item_used_export) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::mgmt_menu_item_used_export.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3843) => {
              if extra_keys_len(&super::pwmgr::mgmt_menu_item_used_export_complete) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::mgmt_menu_item_used_export_complete.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3844) => {
              if extra_keys_len(&super::pwmgr::mgmt_menu_item_used_import_csv_complete) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::mgmt_menu_item_used_import_csv_complete.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3845) => {
              if extra_keys_len(&super::pwmgr::mgmt_menu_item_used_import_from_browser) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::mgmt_menu_item_used_import_from_browser.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3846) => {
              if extra_keys_len(&super::pwmgr::mgmt_menu_item_used_import_from_csv) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::mgmt_menu_item_used_import_from_csv.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3847) => {
              if extra_keys_len(&super::pwmgr::mgmt_menu_item_used_preferences) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::mgmt_menu_item_used_preferences.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3848) => {
              if extra_keys_len(&super::pwmgr::new_new_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::new_new_login.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3849) => {
              if extra_keys_len(&super::pwmgr::open_management_aboutprotections) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::open_management_aboutprotections.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3850) => {
              if extra_keys_len(&super::pwmgr::open_management_autocomplete) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::open_management_autocomplete.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3851) => {
              if extra_keys_len(&super::pwmgr::open_management_contextmenu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::open_management_contextmenu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3852) => {
              if extra_keys_len(&super::pwmgr::open_management_direct) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::open_management_direct.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3853) => {
              if extra_keys_len(&super::pwmgr::open_management_mainmenu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::open_management_mainmenu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3854) => {
              if extra_keys_len(&super::pwmgr::open_management_pageinfo) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::open_management_pageinfo.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3855) => {
              if extra_keys_len(&super::pwmgr::open_management_preferences) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::open_management_preferences.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3856) => {
              if extra_keys_len(&super::pwmgr::open_management_snippet) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::open_management_snippet.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3857) => {
              if extra_keys_len(&super::pwmgr::open_site_existing_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::open_site_existing_login.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3859) => {
              if extra_keys_len(&super::pwmgr::reauthenticate_master_password) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::reauthenticate_master_password.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3860) => {
              if extra_keys_len(&super::pwmgr::reauthenticate_os_auth) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::reauthenticate_os_auth.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3861) => {
              if extra_keys_len(&super::pwmgr::save_existing_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::save_existing_login.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3862) => {
              if extra_keys_len(&super::pwmgr::save_new_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::save_new_login.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3863) => {
              if extra_keys_len(&super::pwmgr::saved_login_used_auth_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::saved_login_used_auth_login.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3864) => {
              if extra_keys_len(&super::pwmgr::saved_login_used_form_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::saved_login_used_form_login.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3865) => {
              if extra_keys_len(&super::pwmgr::saved_login_used_form_password) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::saved_login_used_form_password.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3866) => {
              if extra_keys_len(&super::pwmgr::saved_login_used_prompt_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::saved_login_used_prompt_login.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3867) => {
              if extra_keys_len(&super::pwmgr::select_existing_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::select_existing_login.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3868) => {
              if extra_keys_len(&super::pwmgr::show_password) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::show_password.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3869) => {
              if extra_keys_len(&super::pwmgr::sort_list) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::sort_list.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3870) => {
              if extra_keys_len(&super::relay_integration::clicked_fill_username) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::clicked_fill_username.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3871) => {
              if extra_keys_len(&super::relay_integration::clicked_offer_relay) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::clicked_offer_relay.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3872) => {
              if extra_keys_len(&super::relay_integration::disabled_opt_in_panel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::disabled_opt_in_panel.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3873) => {
              if extra_keys_len(&super::relay_integration::disabled_pref_change) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::disabled_pref_change.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3874) => {
              if extra_keys_len(&super::relay_integration::enabled_opt_in_panel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::enabled_opt_in_panel.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3875) => {
              if extra_keys_len(&super::relay_integration::enabled_pref_change) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::enabled_pref_change.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3876) => {
              if extra_keys_len(&super::relay_integration::get_unlimited_masks_reuse_panel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::get_unlimited_masks_reuse_panel.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3877) => {
              if extra_keys_len(&super::relay_integration::postponed_opt_in_panel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::postponed_opt_in_panel.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3878) => {
              if extra_keys_len(&super::relay_integration::reuse_mask_reuse_panel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::reuse_mask_reuse_panel.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3879) => {
              if extra_keys_len(&super::relay_integration::shown_fill_username) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::shown_fill_username.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3880) => {
              if extra_keys_len(&super::relay_integration::shown_offer_relay) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::shown_offer_relay.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3881) => {
              if extra_keys_len(&super::relay_integration::shown_opt_in_panel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::shown_opt_in_panel.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3882) => {
              if extra_keys_len(&super::relay_integration::shown_reuse_panel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::shown_reuse_panel.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3901) => {
              if extra_keys_len(&super::pdfjs_image::add_image_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image::add_image_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3904) => {
              if extra_keys_len(&super::pdfjs_image::icon_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image::icon_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3905) => {
              if extra_keys_len(&super::pdfjs_image::image_added) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image::image_added.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3906) => {
              if extra_keys_len(&super::pdfjs_image::image_selected) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image::image_selected.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3907) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::ai_generation_check) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::ai_generation_check.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3908) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::callout_dismissed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::callout_dismissed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3909) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::callout_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::callout_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3910) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::dismiss) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::dismiss.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3911) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::image_status_label_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::image_status_label_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3912) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::image_status_label_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::image_status_label_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3913) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::info) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::info.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3914) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::model_deleted) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::model_deleted.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3915) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::model_download_complete) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::model_download_complete.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3916) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::model_download_error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::model_download_error.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3917) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::model_download_start) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::model_download_start.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3918) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::model_result) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::model_result.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3919) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::save) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::save.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3920) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::settings_ai_generation_check) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::settings_ai_generation_check.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3921) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::settings_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::settings_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3922) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::settings_edit_alt_text_check) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::settings_edit_alt_text_check.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3923) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::user_edit) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::user_edit.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3924) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_browser_crash) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_browser_crash.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3925) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_close_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_close_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3926) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_close_player_shortcut) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_close_player_shortcut.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3927) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_context_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_context_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3928) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_foregrounded) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_foregrounded.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3929) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_fullscreen) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_fullscreen.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3930) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_pagehide) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_pagehide.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3931) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_setup_failure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_setup_failure.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3932) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_shortcut) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_shortcut.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3933) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_unpip) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_unpip.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3934) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_url_bar) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_url_bar.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3935) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_video_el_emptied) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_video_el_emptied.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3936) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_video_el_remove) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_video_el_remove.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3937) => {
              if extra_keys_len(&super::pictureinpicture::create_player) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::create_player.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3938) => {
              if extra_keys_len(&super::pictureinpicture::disrespect_disable_url_bar) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::disrespect_disable_url_bar.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3939) => {
              if extra_keys_len(&super::pictureinpicture::fullscreen_player) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::fullscreen_player.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3941) => {
              if extra_keys_len(&super::pictureinpicture::opened_method_auto_pip) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::opened_method_auto_pip.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3942) => {
              if extra_keys_len(&super::pictureinpicture::opened_method_context_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::opened_method_context_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3943) => {
              if extra_keys_len(&super::pictureinpicture::opened_method_shortcut) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::opened_method_shortcut.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3944) => {
              if extra_keys_len(&super::pictureinpicture::opened_method_toggle) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::opened_method_toggle.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3945) => {
              if extra_keys_len(&super::pictureinpicture::opened_method_url_bar) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::opened_method_url_bar.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3946) => {
              if extra_keys_len(&super::pictureinpicture::resize_player) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::resize_player.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3947) => {
              if extra_keys_len(&super::pictureinpicture::saw_toggle_toggle) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::saw_toggle_toggle.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3948) => {
              if extra_keys_len(&super::pictureinpicture::subtitles_shown_subtitles) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::subtitles_shown_subtitles.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3950) => {
              if extra_keys_len(&super::pictureinpicture_settings::disable_player) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture_settings::disable_player.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3951) => {
              if extra_keys_len(&super::pictureinpicture_settings::disable_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture_settings::disable_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3952) => {
              if extra_keys_len(&super::pictureinpicture_settings::enable_autotrigger_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture_settings::enable_autotrigger_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3953) => {
              if extra_keys_len(&super::pictureinpicture_settings::enable_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture_settings::enable_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3989) => {
              if extra_keys_len(&super::readermode::button_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::readermode::button_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3990) => {
              if extra_keys_len(&super::readermode::view_off) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::readermode::view_off.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3991) => {
              if extra_keys_len(&super::readermode::view_on) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::readermode::view_on.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4028) => {
              if extra_keys_len(&super::webcompatreporting::opened) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::webcompatreporting::opened.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4029) => {
              if extra_keys_len(&super::webcompatreporting::reason_dropdown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::webcompatreporting::reason_dropdown.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4030) => {
              if extra_keys_len(&super::webcompatreporting::send) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::webcompatreporting::send.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4031) => {
              if extra_keys_len(&super::webcompatreporting::send_more_info) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::webcompatreporting::send_more_info.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4227) => {
              if extra_keys_len(&super::search_engine_default::changed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::search_engine_default::changed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4233) => {
              if extra_keys_len(&super::search_engine_private::changed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::search_engine_private::changed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4241) => {
              if extra_keys_len(&super::shopping_product::invalid_ohttp_config) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::invalid_ohttp_config.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4242) => {
              if extra_keys_len(&super::shopping_product::invalid_request) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::invalid_request.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4243) => {
              if extra_keys_len(&super::shopping_product::invalid_response) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::invalid_response.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4244) => {
              if extra_keys_len(&super::shopping_product::request_aborted) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::request_aborted.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4245) => {
              if extra_keys_len(&super::shopping_product::request_error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::request_error.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4246) => {
              if extra_keys_len(&super::shopping_product::request_failure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::request_failure.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4247) => {
              if extra_keys_len(&super::shopping_product::request_retried) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::request_retried.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4248) => {
              if extra_keys_len(&super::shopping_product::request_retries_failed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::request_retries_failed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4249) => {
              if extra_keys_len(&super::shopping_product::server_failure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::server_failure.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4253) => {
              if extra_keys_len(&super::telemetry_test::test1_object1) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::telemetry_test::test1_object1.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4254) => {
              if extra_keys_len(&super::telemetry_test::test2_object1) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::telemetry_test::test2_object1.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4255) => {
              if extra_keys_len(&super::telemetry_test::test2_object2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::telemetry_test::test2_object2.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4256) => {
              if extra_keys_len(&super::translations::error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations::error.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4260) => {
              if extra_keys_len(&super::translations::restore_page) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations::restore_page.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4261) => {
              if extra_keys_len(&super::translations::translation_request) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations::translation_request.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4262) => {
              if extra_keys_len(&super::translations_panel::about_translations) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::about_translations.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4263) => {
              if extra_keys_len(&super::translations_panel::always_offer_translations) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::always_offer_translations.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4264) => {
              if extra_keys_len(&super::translations_panel::always_translate_language) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::always_translate_language.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4265) => {
              if extra_keys_len(&super::translations_panel::cancel_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::cancel_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4266) => {
              if extra_keys_len(&super::translations_panel::change_from_language) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::change_from_language.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4267) => {
              if extra_keys_len(&super::translations_panel::change_source_language_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::change_source_language_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4268) => {
              if extra_keys_len(&super::translations_panel::change_to_language) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::change_to_language.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4269) => {
              if extra_keys_len(&super::translations_panel::close) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::close.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4270) => {
              if extra_keys_len(&super::translations_panel::close_from_language_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::close_from_language_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4271) => {
              if extra_keys_len(&super::translations_panel::close_settings_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::close_settings_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4272) => {
              if extra_keys_len(&super::translations_panel::close_to_language_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::close_to_language_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4273) => {
              if extra_keys_len(&super::translations_panel::dismiss_error_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::dismiss_error_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4274) => {
              if extra_keys_len(&super::translations_panel::learn_more) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::learn_more.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4275) => {
              if extra_keys_len(&super::translations_panel::manage_languages) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::manage_languages.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4276) => {
              if extra_keys_len(&super::translations_panel::never_translate_language) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::never_translate_language.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4277) => {
              if extra_keys_len(&super::translations_panel::never_translate_site) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::never_translate_site.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4278) => {
              if extra_keys_len(&super::translations_panel::open) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::open.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4279) => {
              if extra_keys_len(&super::translations_panel::open_from_language_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::open_from_language_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4280) => {
              if extra_keys_len(&super::translations_panel::open_settings_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::open_settings_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4281) => {
              if extra_keys_len(&super::translations_panel::open_to_language_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::open_to_language_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4282) => {
              if extra_keys_len(&super::translations_panel::restore_page_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::restore_page_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4283) => {
              if extra_keys_len(&super::translations_panel::translate_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::translate_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4284) => {
              if extra_keys_len(&super::translations_select_translations_panel::about_translations) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::about_translations.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4285) => {
              if extra_keys_len(&super::translations_select_translations_panel::cancel_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::cancel_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4286) => {
              if extra_keys_len(&super::translations_select_translations_panel::change_from_language) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::change_from_language.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4287) => {
              if extra_keys_len(&super::translations_select_translations_panel::change_to_language) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::change_to_language.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4288) => {
              if extra_keys_len(&super::translations_select_translations_panel::close) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::close.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4289) => {
              if extra_keys_len(&super::translations_select_translations_panel::copy_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::copy_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4290) => {
              if extra_keys_len(&super::translations_select_translations_panel::done_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::done_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4291) => {
              if extra_keys_len(&super::translations_select_translations_panel::initialization_failure_message) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::initialization_failure_message.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4292) => {
              if extra_keys_len(&super::translations_select_translations_panel::open) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::open.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4293) => {
              if extra_keys_len(&super::translations_select_translations_panel::open_settings_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::open_settings_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4294) => {
              if extra_keys_len(&super::translations_select_translations_panel::translate_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::translate_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4295) => {
              if extra_keys_len(&super::translations_select_translations_panel::translate_full_page_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::translate_full_page_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4296) => {
              if extra_keys_len(&super::translations_select_translations_panel::translation_failure_message) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::translation_failure_message.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4297) => {
              if extra_keys_len(&super::translations_select_translations_panel::translation_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::translation_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4298) => {
              if extra_keys_len(&super::translations_select_translations_panel::try_again_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::try_again_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4299) => {
              if extra_keys_len(&super::translations_select_translations_panel::unsupported_language_message) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::unsupported_language_message.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4307) => {
              if extra_keys_len(&super::security_doh_neterror::click_add_exception_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_neterror::click_add_exception_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4308) => {
              if extra_keys_len(&super::security_doh_neterror::click_continue_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_neterror::click_continue_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4309) => {
              if extra_keys_len(&super::security_doh_neterror::click_disable_warning) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_neterror::click_disable_warning.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4310) => {
              if extra_keys_len(&super::security_doh_neterror::click_learn_more_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_neterror::click_learn_more_link.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4311) => {
              if extra_keys_len(&super::security_doh_neterror::click_settings_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_neterror::click_settings_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4312) => {
              if extra_keys_len(&super::security_doh_neterror::click_try_again_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_neterror::click_try_again_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4313) => {
              if extra_keys_len(&super::security_doh_neterror::load_dohwarning) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_neterror::load_dohwarning.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4314) => {
              if extra_keys_len(&super::security_ui_certerror::click_advanced_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_certerror::click_advanced_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4315) => {
              if extra_keys_len(&super::security_ui_certerror::click_auto_report_cb) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_certerror::click_auto_report_cb.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4316) => {
              if extra_keys_len(&super::security_ui_certerror::click_clipboard_button_bot) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_certerror::click_clipboard_button_bot.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4317) => {
              if extra_keys_len(&super::security_ui_certerror::click_clipboard_button_top) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_certerror::click_clipboard_button_top.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4318) => {
              if extra_keys_len(&super::security_ui_certerror::click_error_code_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_certerror::click_error_code_link.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4319) => {
              if extra_keys_len(&super::security_ui_certerror::click_exception_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_certerror::click_exception_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4320) => {
              if extra_keys_len(&super::security_ui_certerror::click_learn_more_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_certerror::click_learn_more_link.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4321) => {
              if extra_keys_len(&super::security_ui_certerror::click_return_button_adv) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_certerror::click_return_button_adv.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4322) => {
              if extra_keys_len(&super::security_ui_certerror::click_return_button_top) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_certerror::click_return_button_top.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4323) => {
              if extra_keys_len(&super::security_ui_certerror::load_aboutcerterror) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_certerror::load_aboutcerterror.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4324) => {
              if extra_keys_len(&super::security_ui_tlserror::load_abouttlserror) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_tlserror::load_abouttlserror.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4330) => {
              if extra_keys_len(&super::jsonfile::load_autofillprofiles) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::jsonfile::load_autofillprofiles.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4331) => {
              if extra_keys_len(&super::jsonfile::load_logins) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::jsonfile::load_logins.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4332) => {
              if extra_keys_len(&super::service_request::bypass_proxy_info) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::service_request::bypass_proxy_info.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4341) => {
              if extra_keys_len(&super::addons_manager::install) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4342) => {
              if extra_keys_len(&super::addons_manager::install_stats) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_stats.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4343) => {
              if extra_keys_len(&super::addons_manager::manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::manage.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4344) => {
              if extra_keys_len(&super::addons_manager::report_suspicious_site) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::report_suspicious_site.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4345) => {
              if extra_keys_len(&super::addons_manager::update) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::update.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4346) => {
              if extra_keys_len(&super::addons_manager::disable_dictionary) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::disable_dictionary.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4347) => {
              if extra_keys_len(&super::addons_manager::disable_extension) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::disable_extension.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4348) => {
              if extra_keys_len(&super::addons_manager::disable_locale) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::disable_locale.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4349) => {
              if extra_keys_len(&super::addons_manager::disable_other) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::disable_other.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4350) => {
              if extra_keys_len(&super::addons_manager::disable_siteperm_deprecated) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::disable_siteperm_deprecated.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4351) => {
              if extra_keys_len(&super::addons_manager::disable_sitepermission) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::disable_sitepermission.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4352) => {
              if extra_keys_len(&super::addons_manager::disable_theme) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::disable_theme.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4353) => {
              if extra_keys_len(&super::addons_manager::disable_unknown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::disable_unknown.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4354) => {
              if extra_keys_len(&super::addons_manager::enable_dictionary) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::enable_dictionary.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4355) => {
              if extra_keys_len(&super::addons_manager::enable_extension) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::enable_extension.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4356) => {
              if extra_keys_len(&super::addons_manager::enable_locale) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::enable_locale.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4357) => {
              if extra_keys_len(&super::addons_manager::enable_other) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::enable_other.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4358) => {
              if extra_keys_len(&super::addons_manager::enable_siteperm_deprecated) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::enable_siteperm_deprecated.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4359) => {
              if extra_keys_len(&super::addons_manager::enable_sitepermission) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::enable_sitepermission.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4360) => {
              if extra_keys_len(&super::addons_manager::enable_theme) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::enable_theme.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4361) => {
              if extra_keys_len(&super::addons_manager::enable_unknown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::enable_unknown.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4362) => {
              if extra_keys_len(&super::addons_manager::install_dictionary) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_dictionary.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4363) => {
              if extra_keys_len(&super::addons_manager::install_extension) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_extension.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4364) => {
              if extra_keys_len(&super::addons_manager::install_locale) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_locale.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4365) => {
              if extra_keys_len(&super::addons_manager::install_other) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_other.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4366) => {
              if extra_keys_len(&super::addons_manager::install_siteperm_deprecated) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_siteperm_deprecated.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4367) => {
              if extra_keys_len(&super::addons_manager::install_sitepermission) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_sitepermission.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4368) => {
              if extra_keys_len(&super::addons_manager::install_stats_dictionary) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_stats_dictionary.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4369) => {
              if extra_keys_len(&super::addons_manager::install_stats_extension) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_stats_extension.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4370) => {
              if extra_keys_len(&super::addons_manager::install_stats_locale) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_stats_locale.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4371) => {
              if extra_keys_len(&super::addons_manager::install_stats_other) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_stats_other.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4372) => {
              if extra_keys_len(&super::addons_manager::install_stats_siteperm_deprecated) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_stats_siteperm_deprecated.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4373) => {
              if extra_keys_len(&super::addons_manager::install_stats_sitepermission) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_stats_sitepermission.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4374) => {
              if extra_keys_len(&super::addons_manager::install_stats_theme) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_stats_theme.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4375) => {
              if extra_keys_len(&super::addons_manager::install_stats_unknown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_stats_unknown.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4376) => {
              if extra_keys_len(&super::addons_manager::install_theme) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_theme.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4377) => {
              if extra_keys_len(&super::addons_manager::install_unknown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_unknown.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4378) => {
              if extra_keys_len(&super::addons_manager::sideload_prompt_dictionary) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::sideload_prompt_dictionary.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4379) => {
              if extra_keys_len(&super::addons_manager::sideload_prompt_extension) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::sideload_prompt_extension.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4380) => {
              if extra_keys_len(&super::addons_manager::sideload_prompt_locale) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::sideload_prompt_locale.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4381) => {
              if extra_keys_len(&super::addons_manager::sideload_prompt_other) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::sideload_prompt_other.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4382) => {
              if extra_keys_len(&super::addons_manager::sideload_prompt_siteperm_deprecated) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::sideload_prompt_siteperm_deprecated.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4383) => {
              if extra_keys_len(&super::addons_manager::sideload_prompt_sitepermission) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::sideload_prompt_sitepermission.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4384) => {
              if extra_keys_len(&super::addons_manager::sideload_prompt_theme) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::sideload_prompt_theme.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4385) => {
              if extra_keys_len(&super::addons_manager::sideload_prompt_unknown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::sideload_prompt_unknown.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4386) => {
              if extra_keys_len(&super::addons_manager::uninstall_dictionary) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::uninstall_dictionary.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4387) => {
              if extra_keys_len(&super::addons_manager::uninstall_extension) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::uninstall_extension.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4388) => {
              if extra_keys_len(&super::addons_manager::uninstall_locale) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::uninstall_locale.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4389) => {
              if extra_keys_len(&super::addons_manager::uninstall_other) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::uninstall_other.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4390) => {
              if extra_keys_len(&super::addons_manager::uninstall_siteperm_deprecated) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::uninstall_siteperm_deprecated.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4391) => {
              if extra_keys_len(&super::addons_manager::uninstall_sitepermission) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::uninstall_sitepermission.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4392) => {
              if extra_keys_len(&super::addons_manager::uninstall_theme) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::uninstall_theme.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4393) => {
              if extra_keys_len(&super::addons_manager::uninstall_unknown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::uninstall_unknown.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4394) => {
              if extra_keys_len(&super::addons_manager::update_dictionary) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::update_dictionary.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4395) => {
              if extra_keys_len(&super::addons_manager::update_extension) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::update_extension.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4396) => {
              if extra_keys_len(&super::addons_manager::update_locale) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::update_locale.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4397) => {
              if extra_keys_len(&super::addons_manager::update_other) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::update_other.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4398) => {
              if extra_keys_len(&super::addons_manager::update_siteperm_deprecated) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::update_siteperm_deprecated.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4399) => {
              if extra_keys_len(&super::addons_manager::update_sitepermission) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::update_sitepermission.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4400) => {
              if extra_keys_len(&super::addons_manager::update_theme) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::update_theme.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4401) => {
              if extra_keys_len(&super::addons_manager::update_unknown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::update_unknown.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4402) => {
              if extra_keys_len(&super::blocklist::addon_block_change) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::blocklist::addon_block_change.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4432) => {
              if extra_keys_len(&super::file_dialog::fallback_v2_1) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::file_dialog::fallback_v2_1.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(4433) => {
              if extra_keys_len(&super::memory_watcher::on_high_memory_stats) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::memory_watcher::on_high_memory_stats.record_with_time(timestamp, extra);
              Ok(())
          }
           _ => Err(EventRecordingError::InvalidId),
        }
    }

    /// Wrapper to get the currently stored events for event metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `ping_name` - (Optional) The ping name to look into.
    ///                 Defaults to the first value in `send_in_pings`.
    ///
    /// # Returns
    ///
    /// Returns the recorded events or `None` if nothing stored.
    ///
    /// # Panics
    ///
    /// Panics if no event by the given metric ID could be found.
    pub(crate) fn event_test_get_value_wrapper(metric_id: u32, ping_name: Option<String>) -> Option<Vec<RecordedEvent>> {
        match metric_id {
           9 => super::privacy_sanitize::clear.test_get_value(ping_name.as_deref()),
           10 => super::privacy_sanitize::clearing_time_span_selected.test_get_value(ping_name.as_deref()),
           11 => super::privacy_sanitize::dialog_open.test_get_value(ping_name.as_deref()),
           13 => super::security_ui_protectionspopup::click_cookieb_toggle_off.test_get_value(ping_name.as_deref()),
           14 => super::security_ui_protectionspopup::click_cookieb_toggle_on.test_get_value(ping_name.as_deref()),
           15 => super::security_ui_protectionspopup::click_cookies.test_get_value(ping_name.as_deref()),
           16 => super::security_ui_protectionspopup::click_cryptominers.test_get_value(ping_name.as_deref()),
           17 => super::security_ui_protectionspopup::click_etp_toggle_off.test_get_value(ping_name.as_deref()),
           18 => super::security_ui_protectionspopup::click_etp_toggle_on.test_get_value(ping_name.as_deref()),
           19 => super::security_ui_protectionspopup::click_fingerprinters.test_get_value(ping_name.as_deref()),
           20 => super::security_ui_protectionspopup::click_full_report.test_get_value(ping_name.as_deref()),
           21 => super::security_ui_protectionspopup::click_milestone_message.test_get_value(ping_name.as_deref()),
           22 => super::security_ui_protectionspopup::click_protectionspopup_cfr.test_get_value(ping_name.as_deref()),
           23 => super::security_ui_protectionspopup::click_settings.test_get_value(ping_name.as_deref()),
           24 => super::security_ui_protectionspopup::click_social.test_get_value(ping_name.as_deref()),
           25 => super::security_ui_protectionspopup::click_subview_settings.test_get_value(ping_name.as_deref()),
           26 => super::security_ui_protectionspopup::click_trackers.test_get_value(ping_name.as_deref()),
           27 => super::security_ui_protectionspopup::open_protections_popup.test_get_value(ping_name.as_deref()),
           28 => super::security_ui_protectionspopup::open_protectionspopup_cfr.test_get_value(ping_name.as_deref()),
           51 => super::doh::evaluate_v2_heuristics.test_get_value(ping_name.as_deref()),
           52 => super::doh::state_disabled.test_get_value(ping_name.as_deref()),
           53 => super::doh::state_enabled.test_get_value(ping_name.as_deref()),
           54 => super::doh::state_manually_disabled.test_get_value(ping_name.as_deref()),
           55 => super::doh::state_policy_disabled.test_get_value(ping_name.as_deref()),
           56 => super::doh::state_rollback.test_get_value(ping_name.as_deref()),
           57 => super::doh::state_shutdown.test_get_value(ping_name.as_deref()),
           58 => super::doh::state_uidisabled.test_get_value(ping_name.as_deref()),
           59 => super::doh::state_uiok.test_get_value(ping_name.as_deref()),
           60 => super::doh::state_uninstalled.test_get_value(ping_name.as_deref()),
           164 => super::security_doh_trr_performance::resolved_record.test_get_value(ping_name.as_deref()),
           165 => super::security_doh_trr_performance::trrselect_dryrunresult.test_get_value(ping_name.as_deref()),
           167 => super::downloads::added_file_extension.test_get_value(ping_name.as_deref()),
           169 => super::firefoxview_next::browser_context_menu_tabs.test_get_value(ping_name.as_deref()),
           170 => super::firefoxview_next::card_collapsed_card_container.test_get_value(ping_name.as_deref()),
           171 => super::firefoxview_next::card_expanded_card_container.test_get_value(ping_name.as_deref()),
           172 => super::firefoxview_next::change_page_navigation.test_get_value(ping_name.as_deref()),
           173 => super::firefoxview_next::close_open_tab_tabs.test_get_value(ping_name.as_deref()),
           174 => super::firefoxview_next::context_menu_tabs.test_get_value(ping_name.as_deref()),
           175 => super::firefoxview_next::dismiss_closed_tab_tabs.test_get_value(ping_name.as_deref()),
           176 => super::firefoxview_next::entered_firefoxview.test_get_value(ping_name.as_deref()),
           177 => super::firefoxview_next::fxa_continue_sync.test_get_value(ping_name.as_deref()),
           178 => super::firefoxview_next::fxa_mobile_sync.test_get_value(ping_name.as_deref()),
           179 => super::firefoxview_next::history_visits.test_get_value(ping_name.as_deref()),
           180 => super::firefoxview_next::open_tab_tabs.test_get_value(ping_name.as_deref()),
           181 => super::firefoxview_next::recently_closed_tabs.test_get_value(ping_name.as_deref()),
           182 => super::firefoxview_next::search_initiated_search.test_get_value(ping_name.as_deref()),
           183 => super::firefoxview_next::search_show_all_showallbutton.test_get_value(ping_name.as_deref()),
           184 => super::firefoxview_next::show_all_history_tabs.test_get_value(ping_name.as_deref()),
           185 => super::firefoxview_next::sort_history_tabs.test_get_value(ping_name.as_deref()),
           186 => super::firefoxview_next::synced_tabs_tabs.test_get_value(ping_name.as_deref()),
           187 => super::firefoxview_next::tab_selected_toolbarbutton.test_get_value(ping_name.as_deref()),
           188 => super::genai_chatbot::contextmenu_prompt_click.test_get_value(ping_name.as_deref()),
           190 => super::genai_chatbot::experiment_checkbox_click.test_get_value(ping_name.as_deref()),
           191 => super::genai_chatbot::onboarding_close.test_get_value(ping_name.as_deref()),
           192 => super::genai_chatbot::onboarding_continue.test_get_value(ping_name.as_deref()),
           193 => super::genai_chatbot::onboarding_finish.test_get_value(ping_name.as_deref()),
           194 => super::genai_chatbot::onboarding_learn_more.test_get_value(ping_name.as_deref()),
           195 => super::genai_chatbot::onboarding_provider_choice_displayed.test_get_value(ping_name.as_deref()),
           196 => super::genai_chatbot::onboarding_provider_learn.test_get_value(ping_name.as_deref()),
           197 => super::genai_chatbot::onboarding_provider_selection.test_get_value(ping_name.as_deref()),
           198 => super::genai_chatbot::onboarding_provider_terms.test_get_value(ping_name.as_deref()),
           199 => super::genai_chatbot::onboarding_text_highlight_displayed.test_get_value(ping_name.as_deref()),
           201 => super::genai_chatbot::provider_change.test_get_value(ping_name.as_deref()),
           203 => super::genai_chatbot::shortcuts_checkbox_click.test_get_value(ping_name.as_deref()),
           205 => super::genai_chatbot::shortcuts_displayed.test_get_value(ping_name.as_deref()),
           206 => super::genai_chatbot::shortcuts_expanded.test_get_value(ping_name.as_deref()),
           207 => super::genai_chatbot::shortcuts_hide_click.test_get_value(ping_name.as_deref()),
           208 => super::genai_chatbot::shortcuts_prompt_click.test_get_value(ping_name.as_deref()),
           210 => super::genai_chatbot::sidebar_close_click.test_get_value(ping_name.as_deref()),
           211 => super::genai_chatbot::sidebar_more_menu_click.test_get_value(ping_name.as_deref()),
           212 => super::genai_chatbot::sidebar_more_menu_display.test_get_value(ping_name.as_deref()),
           213 => super::genai_chatbot::sidebar_provider_menu_click.test_get_value(ping_name.as_deref()),
           214 => super::genai_chatbot::sidebar_toggle.test_get_value(ping_name.as_deref()),
           231 => super::browser_launched_to_handle::system_notification.test_get_value(ping_name.as_deref()),
           245 => super::launch_on_login::last_profile_disable_startup.test_get_value(ping_name.as_deref()),
           258 => super::security::fission_principals.test_get_value(ping_name.as_deref()),
           259 => super::security::eval_usage_parent_process.test_get_value(ping_name.as_deref()),
           260 => super::security::eval_usage_system_context.test_get_value(ping_name.as_deref()),
           261 => super::security::javascript_load_parent_process.test_get_value(ping_name.as_deref()),
           262 => super::security::unexpected_load.test_get_value(ping_name.as_deref()),
           263 => super::security::pref_usage_content_process.test_get_value(ping_name.as_deref()),
           266 => super::start_menu::manually_unpinned_since_last_launch.test_get_value(ping_name.as_deref()),
           272 => super::upgrade_dialog::trigger_reason.test_get_value(ping_name.as_deref()),
           273 => super::browser_migration::browser_selected_wizard.test_get_value(ping_name.as_deref()),
           274 => super::browser_migration::linux_perms_wizard.test_get_value(ping_name.as_deref()),
           276 => super::browser_migration::migration_finished_wizard.test_get_value(ping_name.as_deref()),
           277 => super::browser_migration::migration_started_wizard.test_get_value(ping_name.as_deref()),
           278 => super::browser_migration::no_browsers_found_wizard.test_get_value(ping_name.as_deref()),
           279 => super::browser_migration::opened_wizard.test_get_value(ping_name.as_deref()),
           280 => super::browser_migration::profile_selected_wizard.test_get_value(ping_name.as_deref()),
           281 => super::browser_migration::resources_selected_wizard.test_get_value(ping_name.as_deref()),
           282 => super::browser_migration::safari_password_file_wizard.test_get_value(ping_name.as_deref()),
           283 => super::browser_migration::safari_perms_wizard.test_get_value(ping_name.as_deref()),
           288 => super::activity_stream::end_session.test_get_value(ping_name.as_deref()),
           289 => super::activity_stream::event_archive_from_pocket.test_get_value(ping_name.as_deref()),
           290 => super::activity_stream::event_block.test_get_value(ping_name.as_deref()),
           291 => super::activity_stream::event_bookmark_add.test_get_value(ping_name.as_deref()),
           292 => super::activity_stream::event_bookmark_delete.test_get_value(ping_name.as_deref()),
           293 => super::activity_stream::event_click.test_get_value(ping_name.as_deref()),
           294 => super::activity_stream::event_click_privacy_info.test_get_value(ping_name.as_deref()),
           295 => super::activity_stream::event_close_newtab_prefs.test_get_value(ping_name.as_deref()),
           296 => super::activity_stream::event_delete.test_get_value(ping_name.as_deref()),
           297 => super::activity_stream::event_delete_confirm.test_get_value(ping_name.as_deref()),
           298 => super::activity_stream::event_delete_from_pocket.test_get_value(ping_name.as_deref()),
           299 => super::activity_stream::event_dialog_cancel.test_get_value(ping_name.as_deref()),
           300 => super::activity_stream::event_dialog_open.test_get_value(ping_name.as_deref()),
           301 => super::activity_stream::event_disclaimer_acked.test_get_value(ping_name.as_deref()),
           302 => super::activity_stream::event_drag.test_get_value(ping_name.as_deref()),
           303 => super::activity_stream::event_drop.test_get_value(ping_name.as_deref()),
           304 => super::activity_stream::event_fakespot_category.test_get_value(ping_name.as_deref()),
           305 => super::activity_stream::event_fakespot_click.test_get_value(ping_name.as_deref()),
           306 => super::activity_stream::event_hide_personalize.test_get_value(ping_name.as_deref()),
           307 => super::activity_stream::event_impression.test_get_value(ping_name.as_deref()),
           308 => super::activity_stream::event_menu_add_search.test_get_value(ping_name.as_deref()),
           309 => super::activity_stream::event_menu_add_topsite.test_get_value(ping_name.as_deref()),
           310 => super::activity_stream::event_menu_collapse.test_get_value(ping_name.as_deref()),
           311 => super::activity_stream::event_menu_expand.test_get_value(ping_name.as_deref()),
           312 => super::activity_stream::event_menu_manage.test_get_value(ping_name.as_deref()),
           313 => super::activity_stream::event_menu_move_down.test_get_value(ping_name.as_deref()),
           314 => super::activity_stream::event_menu_move_up.test_get_value(ping_name.as_deref()),
           315 => super::activity_stream::event_menu_privacy_notice.test_get_value(ping_name.as_deref()),
           316 => super::activity_stream::event_menu_remove.test_get_value(ping_name.as_deref()),
           317 => super::activity_stream::event_migration_cancel.test_get_value(ping_name.as_deref()),
           318 => super::activity_stream::event_migration_start.test_get_value(ping_name.as_deref()),
           319 => super::activity_stream::event_open_new_window.test_get_value(ping_name.as_deref()),
           320 => super::activity_stream::event_open_newtab_prefs.test_get_value(ping_name.as_deref()),
           321 => super::activity_stream::event_open_private_window.test_get_value(ping_name.as_deref()),
           322 => super::activity_stream::event_pin.test_get_value(ping_name.as_deref()),
           323 => super::activity_stream::event_pocket_thumbs_down.test_get_value(ping_name.as_deref()),
           324 => super::activity_stream::event_pocket_thumbs_up.test_get_value(ping_name.as_deref()),
           325 => super::activity_stream::event_pref_changed.test_get_value(ping_name.as_deref()),
           326 => super::activity_stream::event_preview_request.test_get_value(ping_name.as_deref()),
           327 => super::activity_stream::event_save_to_pocket.test_get_value(ping_name.as_deref()),
           328 => super::activity_stream::event_search.test_get_value(ping_name.as_deref()),
           329 => super::activity_stream::event_search_edit_add.test_get_value(ping_name.as_deref()),
           330 => super::activity_stream::event_search_edit_close.test_get_value(ping_name.as_deref()),
           331 => super::activity_stream::event_search_edit_delete.test_get_value(ping_name.as_deref()),
           332 => super::activity_stream::event_search_handoff.test_get_value(ping_name.as_deref()),
           333 => super::activity_stream::event_show_personalize.test_get_value(ping_name.as_deref()),
           334 => super::activity_stream::event_show_privacy_info.test_get_value(ping_name.as_deref()),
           335 => super::activity_stream::event_skipped_signin.test_get_value(ping_name.as_deref()),
           336 => super::activity_stream::event_submit_email.test_get_value(ping_name.as_deref()),
           337 => super::activity_stream::event_top_sites_edit.test_get_value(ping_name.as_deref()),
           338 => super::activity_stream::event_top_sites_edit_close.test_get_value(ping_name.as_deref()),
           339 => super::activity_stream::event_topsite_sponsor_info.test_get_value(ping_name.as_deref()),
           340 => super::activity_stream::event_unpin.test_get_value(ping_name.as_deref()),
           376 => super::newtab::closed.test_get_value(ping_name.as_deref()),
           377 => super::newtab::fakespot_about_click.test_get_value(ping_name.as_deref()),
           378 => super::newtab::fakespot_category.test_get_value(ping_name.as_deref()),
           379 => super::newtab::fakespot_click.test_get_value(ping_name.as_deref()),
           380 => super::newtab::fakespot_cta_click.test_get_value(ping_name.as_deref()),
           381 => super::newtab::fakespot_dismiss.test_get_value(ping_name.as_deref()),
           382 => super::newtab::fakespot_product_impression.test_get_value(ping_name.as_deref()),
           386 => super::newtab::opened.test_get_value(ping_name.as_deref()),
           389 => super::newtab::tooltip_click.test_get_value(ping_name.as_deref()),
           390 => super::newtab::topic_selection_dismiss.test_get_value(ping_name.as_deref()),
           391 => super::newtab::topic_selection_open.test_get_value(ping_name.as_deref()),
           392 => super::newtab::topic_selection_topics_saved.test_get_value(ping_name.as_deref()),
           393 => super::newtab::wallpaper_category_click.test_get_value(ping_name.as_deref()),
           394 => super::newtab::wallpaper_click.test_get_value(ping_name.as_deref()),
           395 => super::newtab::wallpaper_highlight_cta_click.test_get_value(ping_name.as_deref()),
           396 => super::newtab::wallpaper_highlight_dismissed.test_get_value(ping_name.as_deref()),
           397 => super::newtab::weather_change_display.test_get_value(ping_name.as_deref()),
           399 => super::newtab::weather_impression.test_get_value(ping_name.as_deref()),
           400 => super::newtab::weather_load_error.test_get_value(ping_name.as_deref()),
           401 => super::newtab::weather_location_selected.test_get_value(ping_name.as_deref()),
           402 => super::newtab::weather_open_provider_url.test_get_value(ping_name.as_deref()),
           405 => super::newtab_search::issued.test_get_value(ping_name.as_deref()),
           406 => super::pocket::click.test_get_value(ping_name.as_deref()),
           407 => super::pocket::dismiss.test_get_value(ping_name.as_deref()),
           410 => super::pocket::impression.test_get_value(ping_name.as_deref()),
           413 => super::pocket::save.test_get_value(ping_name.as_deref()),
           416 => super::pocket::thumb_voting_interaction.test_get_value(ping_name.as_deref()),
           417 => super::pocket::topic_click.test_get_value(ping_name.as_deref()),
           425 => super::topsites::click.test_get_value(ping_name.as_deref()),
           426 => super::topsites::dismiss.test_get_value(ping_name.as_deref()),
           428 => super::topsites::impression.test_get_value(ping_name.as_deref()),
           429 => super::topsites::pref_changed.test_get_value(ping_name.as_deref()),
           431 => super::topsites::show_privacy_click.test_get_value(ping_name.as_deref()),
           445 => super::aboutpreferences::show_click.test_get_value(ping_name.as_deref()),
           446 => super::aboutpreferences::show_hash.test_get_value(ping_name.as_deref()),
           447 => super::aboutpreferences::show_initial.test_get_value(ping_name.as_deref()),
           448 => super::intl_ui_browser_language::accept_dialog.test_get_value(ping_name.as_deref()),
           449 => super::intl_ui_browser_language::add_dialog.test_get_value(ping_name.as_deref()),
           450 => super::intl_ui_browser_language::apply_main.test_get_value(ping_name.as_deref()),
           451 => super::intl_ui_browser_language::cancel_dialog.test_get_value(ping_name.as_deref()),
           452 => super::intl_ui_browser_language::manage_main.test_get_value(ping_name.as_deref()),
           453 => super::intl_ui_browser_language::remove_dialog.test_get_value(ping_name.as_deref()),
           454 => super::intl_ui_browser_language::reorder_dialog.test_get_value(ping_name.as_deref()),
           455 => super::intl_ui_browser_language::reorder_main.test_get_value(ping_name.as_deref()),
           456 => super::intl_ui_browser_language::search_dialog.test_get_value(ping_name.as_deref()),
           457 => super::intl_ui_browser_language::search_main.test_get_value(ping_name.as_deref()),
           458 => super::intl_ui_browser_language::set_fallback_dialog.test_get_value(ping_name.as_deref()),
           459 => super::privacy_ui_fpp_click::checkbox.test_get_value(ping_name.as_deref()),
           460 => super::privacy_ui_fpp_click::menu.test_get_value(ping_name.as_deref()),
           461 => super::security_doh_settings::mode_changed_button.test_get_value(ping_name.as_deref()),
           462 => super::security_doh_settings::provider_choice_value.test_get_value(ping_name.as_deref()),
           463 => super::security_doh_settings::warn_checkbox_checkbox.test_get_value(ping_name.as_deref()),
           464 => super::aboutprivatebrowsing::click_dismiss_button.test_get_value(ping_name.as_deref()),
           465 => super::aboutprivatebrowsing::click_info_link.test_get_value(ping_name.as_deref()),
           466 => super::aboutprivatebrowsing::click_promo_link.test_get_value(ping_name.as_deref()),
           467 => super::private_browsing_reset_pbm::confirm_panel.test_get_value(ping_name.as_deref()),
           468 => super::private_browsing_reset_pbm::reset_action.test_get_value(ping_name.as_deref()),
           469 => super::security_ui_protections::click_lw_about_link.test_get_value(ping_name.as_deref()),
           470 => super::security_ui_protections::click_lw_open_button.test_get_value(ping_name.as_deref()),
           471 => super::security_ui_protections::click_lw_sync_link.test_get_value(ping_name.as_deref()),
           472 => super::security_ui_protections::click_mobile_app_link.test_get_value(ping_name.as_deref()),
           473 => super::security_ui_protections::click_mtr_about_link.test_get_value(ping_name.as_deref()),
           474 => super::security_ui_protections::click_mtr_report_link.test_get_value(ping_name.as_deref()),
           475 => super::security_ui_protections::click_mtr_signup_button.test_get_value(ping_name.as_deref()),
           476 => super::security_ui_protections::click_settings_link.test_get_value(ping_name.as_deref()),
           477 => super::security_ui_protections::click_trackers_about_link.test_get_value(ping_name.as_deref()),
           478 => super::security_ui_protections::click_vpn_app_link_android.test_get_value(ping_name.as_deref()),
           479 => super::security_ui_protections::click_vpn_app_link_ios.test_get_value(ping_name.as_deref()),
           480 => super::security_ui_protections::click_vpn_banner_close.test_get_value(ping_name.as_deref()),
           481 => super::security_ui_protections::click_vpn_banner_link.test_get_value(ping_name.as_deref()),
           482 => super::security_ui_protections::click_vpn_card_link.test_get_value(ping_name.as_deref()),
           483 => super::security_ui_protections::close_protection_report.test_get_value(ping_name.as_deref()),
           484 => super::security_ui_protections::show_protection_report.test_get_value(ping_name.as_deref()),
           485 => super::security_ui_protections::show_vpn_banner.test_get_value(ping_name.as_deref()),
           488 => super::protocolhandler_mailto::visit.test_get_value(ping_name.as_deref()),
           489 => super::screenshots::canceled_context_menu.test_get_value(ping_name.as_deref()),
           490 => super::screenshots::canceled_escape.test_get_value(ping_name.as_deref()),
           491 => super::screenshots::canceled_navigation.test_get_value(ping_name.as_deref()),
           492 => super::screenshots::canceled_overlay_cancel.test_get_value(ping_name.as_deref()),
           493 => super::screenshots::canceled_preview_cancel.test_get_value(ping_name.as_deref()),
           494 => super::screenshots::canceled_quick_actions.test_get_value(ping_name.as_deref()),
           495 => super::screenshots::canceled_shortcut.test_get_value(ping_name.as_deref()),
           496 => super::screenshots::canceled_toolbar_button.test_get_value(ping_name.as_deref()),
           497 => super::screenshots::copy_overlay_copy.test_get_value(ping_name.as_deref()),
           498 => super::screenshots::copy_preview_copy.test_get_value(ping_name.as_deref()),
           499 => super::screenshots::download_overlay_download.test_get_value(ping_name.as_deref()),
           500 => super::screenshots::download_preview_download.test_get_value(ping_name.as_deref()),
           501 => super::screenshots::failed_screenshot_too_large.test_get_value(ping_name.as_deref()),
           502 => super::screenshots::selected_element.test_get_value(ping_name.as_deref()),
           503 => super::screenshots::selected_full_page.test_get_value(ping_name.as_deref()),
           504 => super::screenshots::selected_region_selection.test_get_value(ping_name.as_deref()),
           505 => super::screenshots::selected_visible.test_get_value(ping_name.as_deref()),
           506 => super::screenshots::started_context_menu.test_get_value(ping_name.as_deref()),
           507 => super::screenshots::started_overlay_retry.test_get_value(ping_name.as_deref()),
           508 => super::screenshots::started_preview_retry.test_get_value(ping_name.as_deref()),
           509 => super::screenshots::started_quick_actions.test_get_value(ping_name.as_deref()),
           510 => super::screenshots::started_shortcut.test_get_value(ping_name.as_deref()),
           511 => super::screenshots::started_toolbar_button.test_get_value(ping_name.as_deref()),
           560 => super::newtab_search_ad::click.test_get_value(ping_name.as_deref()),
           561 => super::newtab_search_ad::impression.test_get_value(ping_name.as_deref()),
           564 => super::serp::abandonment.test_get_value(ping_name.as_deref()),
           565 => super::serp::ad_impression.test_get_value(ping_name.as_deref()),
           567 => super::serp::categorization.test_get_value(ping_name.as_deref()),
           570 => super::serp::engagement.test_get_value(ping_name.as_deref()),
           572 => super::serp::impression.test_get_value(ping_name.as_deref()),
           588 => super::session_restore::backup_can_be_loaded_session_file.test_get_value(ping_name.as_deref()),
           589 => super::session_restore::shutdown_success_session_startup.test_get_value(ping_name.as_deref()),
           590 => super::shopping::address_bar_feature_callout_displayed.test_get_value(ping_name.as_deref()),
           591 => super::shopping::address_bar_icon_clicked.test_get_value(ping_name.as_deref()),
           592 => super::shopping::address_bar_icon_displayed.test_get_value(ping_name.as_deref()),
           593 => super::shopping::ads_exposure.test_get_value(ping_name.as_deref()),
           595 => super::shopping::surface_ads_clicked.test_get_value(ping_name.as_deref()),
           596 => super::shopping::surface_ads_impression.test_get_value(ping_name.as_deref()),
           597 => super::shopping::surface_ads_placement.test_get_value(ping_name.as_deref()),
           598 => super::shopping::surface_ads_setting_toggled.test_get_value(ping_name.as_deref()),
           599 => super::shopping::surface_analyze_reviews_none_available_clicked.test_get_value(ping_name.as_deref()),
           600 => super::shopping::surface_auto_open_setting_toggled.test_get_value(ping_name.as_deref()),
           601 => super::shopping::surface_closed.test_get_value(ping_name.as_deref()),
           602 => super::shopping::surface_displayed.test_get_value(ping_name.as_deref()),
           603 => super::shopping::surface_learn_more_clicked.test_get_value(ping_name.as_deref()),
           604 => super::shopping::surface_no_ads_available.test_get_value(ping_name.as_deref()),
           605 => super::shopping::surface_no_review_reliability_available.test_get_value(ping_name.as_deref()),
           606 => super::shopping::surface_no_thanks_button_clicked.test_get_value(ping_name.as_deref()),
           607 => super::shopping::surface_not_now_clicked.test_get_value(ping_name.as_deref()),
           608 => super::shopping::surface_onboarding_displayed.test_get_value(ping_name.as_deref()),
           609 => super::shopping::surface_opt_in_clicked.test_get_value(ping_name.as_deref()),
           610 => super::shopping::surface_opt_out_button_clicked.test_get_value(ping_name.as_deref()),
           611 => super::shopping::surface_powered_by_fakespot_link_clicked.test_get_value(ping_name.as_deref()),
           612 => super::shopping::surface_reactivated_button_clicked.test_get_value(ping_name.as_deref()),
           613 => super::shopping::surface_reanalyze_clicked.test_get_value(ping_name.as_deref()),
           614 => super::shopping::surface_settings_expand_clicked.test_get_value(ping_name.as_deref()),
           615 => super::shopping::surface_show_more_reviews_button_clicked.test_get_value(ping_name.as_deref()),
           616 => super::shopping::surface_show_privacy_policy_clicked.test_get_value(ping_name.as_deref()),
           617 => super::shopping::surface_show_quality_explainer_clicked.test_get_value(ping_name.as_deref()),
           618 => super::shopping::surface_show_quality_explainer_url_clicked.test_get_value(ping_name.as_deref()),
           619 => super::shopping::surface_show_terms_clicked.test_get_value(ping_name.as_deref()),
           620 => super::shopping::surface_stale_analysis_shown.test_get_value(ping_name.as_deref()),
           621 => super::shopping::surface_yes_keep_closed_button_clicked.test_get_value(ping_name.as_deref()),
           627 => super::bookmarks::sidebar_toggle.test_get_value(ping_name.as_deref()),
           628 => super::extension::sidebar_toggle.test_get_value(ping_name.as_deref()),
           629 => super::history::sidebar_toggle.test_get_value(ping_name.as_deref()),
           630 => super::sidebar::addon_icon_click.test_get_value(ping_name.as_deref()),
           631 => super::sidebar::bookmarks_icon_click.test_get_value(ping_name.as_deref()),
           632 => super::sidebar::chatbot_icon_click.test_get_value(ping_name.as_deref()),
           634 => super::sidebar::expand.test_get_value(ping_name.as_deref()),
           635 => super::sidebar::history_icon_click.test_get_value(ping_name.as_deref()),
           638 => super::sidebar::resize.test_get_value(ping_name.as_deref()),
           640 => super::sidebar::synced_tabs_icon_click.test_get_value(ping_name.as_deref()),
           643 => super::sidebar_customize::bookmarks_enabled.test_get_value(ping_name.as_deref()),
           644 => super::sidebar_customize::chatbot_enabled.test_get_value(ping_name.as_deref()),
           645 => super::sidebar_customize::extensions_clicked.test_get_value(ping_name.as_deref()),
           646 => super::sidebar_customize::firefox_settings_clicked.test_get_value(ping_name.as_deref()),
           647 => super::sidebar_customize::history_enabled.test_get_value(ping_name.as_deref()),
           648 => super::sidebar_customize::icon_click.test_get_value(ping_name.as_deref()),
           649 => super::sidebar_customize::panel_toggle.test_get_value(ping_name.as_deref()),
           650 => super::sidebar_customize::sidebar_display.test_get_value(ping_name.as_deref()),
           651 => super::sidebar_customize::sidebar_position.test_get_value(ping_name.as_deref()),
           652 => super::sidebar_customize::synced_tabs_enabled.test_get_value(ping_name.as_deref()),
           653 => super::sidebar_customize::tabs_display.test_get_value(ping_name.as_deref()),
           654 => super::sidebar_customize::tabs_layout.test_get_value(ping_name.as_deref()),
           655 => super::synced_tabs::sidebar_toggle.test_get_value(ping_name.as_deref()),
           656 => super::synced_tabs::click_fxa_app_menu.test_get_value(ping_name.as_deref()),
           657 => super::synced_tabs::click_fxa_avatar_menu.test_get_value(ping_name.as_deref()),
           658 => super::synced_tabs::click_synced_tabs_sidebar.test_get_value(ping_name.as_deref()),
           706 => super::urlbar::abandonment.test_get_value(ping_name.as_deref()),
           707 => super::urlbar::engagement.test_get_value(ping_name.as_deref()),
           708 => super::urlbar::exposure.test_get_value(ping_name.as_deref()),
           709 => super::urlbar::fakespot_engagement.test_get_value(ping_name.as_deref()),
           710 => super::urlbar::keyword_exposure.test_get_value(ping_name.as_deref()),
           716 => super::urlbar::quick_suggest_contextual_opt_in.test_get_value(ping_name.as_deref()),
           718 => super::addons_search_detection::etld_change_other.test_get_value(ping_name.as_deref()),
           719 => super::addons_search_detection::etld_change_webrequest.test_get_value(ping_name.as_deref()),
           727 => super::browser_usage::interaction.test_get_value(ping_name.as_deref()),
           728 => super::homepage::preference_ignore.test_get_value(ping_name.as_deref()),
           729 => super::installation::first_seen_full.test_get_value(ping_name.as_deref()),
           730 => super::installation::first_seen_msix.test_get_value(ping_name.as_deref()),
           731 => super::installation::first_seen_stub.test_get_value(ping_name.as_deref()),
           743 => super::partner_link::attribution_abort.test_get_value(ping_name.as_deref()),
           744 => super::partner_link::attribution_failure.test_get_value(ping_name.as_deref()),
           745 => super::partner_link::attribution_success.test_get_value(ping_name.as_deref()),
           746 => super::partner_link::click_newtab.test_get_value(ping_name.as_deref()),
           747 => super::partner_link::click_urlbar.test_get_value(ping_name.as_deref()),
           751 => super::devtools_main::activate_responsive_design.test_get_value(ping_name.as_deref()),
           752 => super::devtools_main::activate_split_console.test_get_value(ping_name.as_deref()),
           753 => super::devtools_main::add_breakpoint_debugger.test_get_value(ping_name.as_deref()),
           754 => super::devtools_main::blackbox_debugger.test_get_value(ping_name.as_deref()),
           755 => super::devtools_main::close_adbg_aboutdebugging.test_get_value(ping_name.as_deref()),
           756 => super::devtools_main::close_tools.test_get_value(ping_name.as_deref()),
           757 => super::devtools_main::connection_attempt_aboutdebugging.test_get_value(ping_name.as_deref()),
           758 => super::devtools_main::continue_debugger.test_get_value(ping_name.as_deref()),
           759 => super::devtools_main::deactivate_responsive_design.test_get_value(ping_name.as_deref()),
           760 => super::devtools_main::deactivate_split_console.test_get_value(ping_name.as_deref()),
           761 => super::devtools_main::device_added_aboutdebugging.test_get_value(ping_name.as_deref()),
           762 => super::devtools_main::device_removed_aboutdebugging.test_get_value(ping_name.as_deref()),
           763 => super::devtools_main::edit_html_inspector.test_get_value(ping_name.as_deref()),
           764 => super::devtools_main::edit_resend_netmonitor.test_get_value(ping_name.as_deref()),
           765 => super::devtools_main::edit_rule_ruleview.test_get_value(ping_name.as_deref()),
           766 => super::devtools_main::enter_accessibility.test_get_value(ping_name.as_deref()),
           767 => super::devtools_main::enter_application.test_get_value(ping_name.as_deref()),
           768 => super::devtools_main::enter_dom.test_get_value(ping_name.as_deref()),
           769 => super::devtools_main::enter_fake_tool4242.test_get_value(ping_name.as_deref()),
           770 => super::devtools_main::enter_inspector.test_get_value(ping_name.as_deref()),
           771 => super::devtools_main::enter_jsdebugger.test_get_value(ping_name.as_deref()),
           772 => super::devtools_main::enter_memory.test_get_value(ping_name.as_deref()),
           773 => super::devtools_main::enter_netmonitor.test_get_value(ping_name.as_deref()),
           774 => super::devtools_main::enter_options.test_get_value(ping_name.as_deref()),
           775 => super::devtools_main::enter_other.test_get_value(ping_name.as_deref()),
           776 => super::devtools_main::enter_performance.test_get_value(ping_name.as_deref()),
           777 => super::devtools_main::enter_storage.test_get_value(ping_name.as_deref()),
           778 => super::devtools_main::enter_styleeditor.test_get_value(ping_name.as_deref()),
           779 => super::devtools_main::enter_test_blank_panel.test_get_value(ping_name.as_deref()),
           780 => super::devtools_main::enter_test_tool.test_get_value(ping_name.as_deref()),
           781 => super::devtools_main::enter_test_tool1072208.test_get_value(ping_name.as_deref()),
           782 => super::devtools_main::enter_testtool1.test_get_value(ping_name.as_deref()),
           783 => super::devtools_main::enter_testtool2.test_get_value(ping_name.as_deref()),
           784 => super::devtools_main::enter_webconsole.test_get_value(ping_name.as_deref()),
           785 => super::devtools_main::enter_whatsnew.test_get_value(ping_name.as_deref()),
           786 => super::devtools_main::execute_js_webconsole.test_get_value(ping_name.as_deref()),
           787 => super::devtools_main::exit_accessibility.test_get_value(ping_name.as_deref()),
           788 => super::devtools_main::exit_application.test_get_value(ping_name.as_deref()),
           789 => super::devtools_main::exit_dom.test_get_value(ping_name.as_deref()),
           790 => super::devtools_main::exit_fake_tool4242.test_get_value(ping_name.as_deref()),
           791 => super::devtools_main::exit_inspector.test_get_value(ping_name.as_deref()),
           792 => super::devtools_main::exit_jsdebugger.test_get_value(ping_name.as_deref()),
           793 => super::devtools_main::exit_memory.test_get_value(ping_name.as_deref()),
           794 => super::devtools_main::exit_netmonitor.test_get_value(ping_name.as_deref()),
           795 => super::devtools_main::exit_options.test_get_value(ping_name.as_deref()),
           796 => super::devtools_main::exit_other.test_get_value(ping_name.as_deref()),
           797 => super::devtools_main::exit_performance.test_get_value(ping_name.as_deref()),
           798 => super::devtools_main::exit_storage.test_get_value(ping_name.as_deref()),
           799 => super::devtools_main::exit_styleeditor.test_get_value(ping_name.as_deref()),
           800 => super::devtools_main::exit_test_blank_panel.test_get_value(ping_name.as_deref()),
           801 => super::devtools_main::exit_test_tool.test_get_value(ping_name.as_deref()),
           802 => super::devtools_main::exit_test_tool1072208.test_get_value(ping_name.as_deref()),
           803 => super::devtools_main::exit_testtool1.test_get_value(ping_name.as_deref()),
           804 => super::devtools_main::exit_testtool2.test_get_value(ping_name.as_deref()),
           805 => super::devtools_main::exit_webconsole.test_get_value(ping_name.as_deref()),
           806 => super::devtools_main::exit_whatsnew.test_get_value(ping_name.as_deref()),
           807 => super::devtools_main::filters_changed_netmonitor.test_get_value(ping_name.as_deref()),
           808 => super::devtools_main::filters_changed_webconsole.test_get_value(ping_name.as_deref()),
           809 => super::devtools_main::inspect_aboutdebugging.test_get_value(ping_name.as_deref()),
           810 => super::devtools_main::jump_to_definition_webconsole.test_get_value(ping_name.as_deref()),
           811 => super::devtools_main::jump_to_source_webconsole.test_get_value(ping_name.as_deref()),
           812 => super::devtools_main::object_expanded_webconsole.test_get_value(ping_name.as_deref()),
           813 => super::devtools_main::open_adbg_aboutdebugging.test_get_value(ping_name.as_deref()),
           814 => super::devtools_main::open_tools.test_get_value(ping_name.as_deref()),
           815 => super::devtools_main::pause_debugger.test_get_value(ping_name.as_deref()),
           816 => super::devtools_main::pause_on_exceptions_debugger.test_get_value(ping_name.as_deref()),
           817 => super::devtools_main::persist_changed_netmonitor.test_get_value(ping_name.as_deref()),
           818 => super::devtools_main::persist_changed_webconsole.test_get_value(ping_name.as_deref()),
           819 => super::devtools_main::pretty_print_debugger.test_get_value(ping_name.as_deref()),
           820 => super::devtools_main::remove_breakpoint_debugger.test_get_value(ping_name.as_deref()),
           821 => super::devtools_main::reverse_search_webconsole.test_get_value(ping_name.as_deref()),
           822 => super::devtools_main::runtime_added_aboutdebugging.test_get_value(ping_name.as_deref()),
           823 => super::devtools_main::runtime_connected_aboutdebugging.test_get_value(ping_name.as_deref()),
           824 => super::devtools_main::runtime_disconnected_aboutdebugging.test_get_value(ping_name.as_deref()),
           825 => super::devtools_main::runtime_removed_aboutdebugging.test_get_value(ping_name.as_deref()),
           826 => super::devtools_main::select_page_aboutdebugging.test_get_value(ping_name.as_deref()),
           827 => super::devtools_main::select_page_application.test_get_value(ping_name.as_deref()),
           828 => super::devtools_main::select_ws_frame_netmonitor.test_get_value(ping_name.as_deref()),
           829 => super::devtools_main::show_profiler_aboutdebugging.test_get_value(ping_name.as_deref()),
           830 => super::devtools_main::sidepanel_changed_inspector.test_get_value(ping_name.as_deref()),
           831 => super::devtools_main::sidepanel_changed_netmonitor.test_get_value(ping_name.as_deref()),
           832 => super::devtools_main::start_worker_application.test_get_value(ping_name.as_deref()),
           833 => super::devtools_main::throttle_changed_netmonitor.test_get_value(ping_name.as_deref()),
           834 => super::devtools_main::tool_timer_animationinspector.test_get_value(ping_name.as_deref()),
           835 => super::devtools_main::tool_timer_changesview.test_get_value(ping_name.as_deref()),
           836 => super::devtools_main::tool_timer_compatibilityview.test_get_value(ping_name.as_deref()),
           837 => super::devtools_main::tool_timer_computedview.test_get_value(ping_name.as_deref()),
           838 => super::devtools_main::tool_timer_fontinspector.test_get_value(ping_name.as_deref()),
           839 => super::devtools_main::tool_timer_layoutview.test_get_value(ping_name.as_deref()),
           840 => super::devtools_main::tool_timer_ruleview.test_get_value(ping_name.as_deref()),
           841 => super::devtools_main::unregister_worker_application.test_get_value(ping_name.as_deref()),
           842 => super::devtools_main::update_conn_prompt_aboutdebugging.test_get_value(ping_name.as_deref()),
           3185 => super::mediadrm::eme_playback.test_get_value(ping_name.as_deref()),
           3188 => super::hls::media_load.test_get_value(ping_name.as_deref()),
           3197 => super::media_playback::first_frame_loaded.test_get_value(ping_name.as_deref()),
           3199 => super::mfcdm::eme_playback.test_get_value(ping_name.as_deref()),
           3200 => super::mfcdm::error.test_get_value(ping_name.as_deref()),
           3244 => super::perf::page_load.test_get_value(ping_name.as_deref()),
           3267 => super::dom_quota_try::error_step.test_get_value(ping_name.as_deref()),
           3345 => super::avif::dav1d_get_picture_return_value.test_get_value(ping_name.as_deref()),
           3366 => super::slow_script_warning::shown_browser.test_get_value(ping_name.as_deref()),
           3367 => super::slow_script_warning::shown_content.test_get_value(ping_name.as_deref()),
           3375 => super::zero_byte_load::load_css.test_get_value(ping_name.as_deref()),
           3376 => super::zero_byte_load::load_dtd.test_get_value(ping_name.as_deref()),
           3377 => super::zero_byte_load::load_ftl.test_get_value(ping_name.as_deref()),
           3378 => super::zero_byte_load::load_html.test_get_value(ping_name.as_deref()),
           3379 => super::zero_byte_load::load_js.test_get_value(ping_name.as_deref()),
           3380 => super::zero_byte_load::load_json.test_get_value(ping_name.as_deref()),
           3381 => super::zero_byte_load::load_others.test_get_value(ping_name.as_deref()),
           3382 => super::zero_byte_load::load_png.test_get_value(ping_name.as_deref()),
           3383 => super::zero_byte_load::load_properties.test_get_value(ping_name.as_deref()),
           3384 => super::zero_byte_load::load_svg.test_get_value(ping_name.as_deref()),
           3385 => super::zero_byte_load::load_xhtml.test_get_value(ping_name.as_deref()),
           3386 => super::zero_byte_load::load_xml.test_get_value(ping_name.as_deref()),
           3388 => super::network_dns::trr_confirmation_context.test_get_value(ping_name.as_deref()),
           3441 => super::ysod::shown_ysod.test_get_value(ping_name.as_deref()),
           3474 => super::uptake_remotecontent_result::uptake_normandy.test_get_value(ping_name.as_deref()),
           3475 => super::uptake_remotecontent_result::uptake_remotesettings.test_get_value(ping_name.as_deref()),
           3478 => super::fxa::connect_account.test_get_value(ping_name.as_deref()),
           3479 => super::fxa::disconnect_account.test_get_value(ping_name.as_deref()),
           3480 => super::fxa_app_menu::click_account_settings.test_get_value(ping_name.as_deref()),
           3481 => super::fxa_app_menu::click_cad.test_get_value(ping_name.as_deref()),
           3482 => super::fxa_app_menu::click_login.test_get_value(ping_name.as_deref()),
           3483 => super::fxa_app_menu::click_monitor_cta.test_get_value(ping_name.as_deref()),
           3484 => super::fxa_app_menu::click_open_monitor.test_get_value(ping_name.as_deref()),
           3485 => super::fxa_app_menu::click_open_send.test_get_value(ping_name.as_deref()),
           3486 => super::fxa_app_menu::click_relay_cta.test_get_value(ping_name.as_deref()),
           3487 => super::fxa_app_menu::click_send_tab.test_get_value(ping_name.as_deref()),
           3488 => super::fxa_app_menu::click_sync_cta.test_get_value(ping_name.as_deref()),
           3489 => super::fxa_app_menu::click_sync_now.test_get_value(ping_name.as_deref()),
           3490 => super::fxa_app_menu::click_sync_settings.test_get_value(ping_name.as_deref()),
           3491 => super::fxa_app_menu::click_sync_tabs.test_get_value(ping_name.as_deref()),
           3492 => super::fxa_app_menu::click_sync_tabs_sidebar.test_get_value(ping_name.as_deref()),
           3493 => super::fxa_app_menu::click_toolbar_icon.test_get_value(ping_name.as_deref()),
           3494 => super::fxa_app_menu::click_unver_sync_settings.test_get_value(ping_name.as_deref()),
           3495 => super::fxa_app_menu::click_vpn_cta.test_get_value(ping_name.as_deref()),
           3496 => super::fxa_avatar_menu::click_account_settings.test_get_value(ping_name.as_deref()),
           3497 => super::fxa_avatar_menu::click_cad.test_get_value(ping_name.as_deref()),
           3498 => super::fxa_avatar_menu::click_login.test_get_value(ping_name.as_deref()),
           3499 => super::fxa_avatar_menu::click_monitor_cta.test_get_value(ping_name.as_deref()),
           3500 => super::fxa_avatar_menu::click_open_monitor.test_get_value(ping_name.as_deref()),
           3501 => super::fxa_avatar_menu::click_open_send.test_get_value(ping_name.as_deref()),
           3502 => super::fxa_avatar_menu::click_relay_cta.test_get_value(ping_name.as_deref()),
           3503 => super::fxa_avatar_menu::click_send_tab.test_get_value(ping_name.as_deref()),
           3504 => super::fxa_avatar_menu::click_sync_cta.test_get_value(ping_name.as_deref()),
           3505 => super::fxa_avatar_menu::click_sync_now.test_get_value(ping_name.as_deref()),
           3506 => super::fxa_avatar_menu::click_sync_settings.test_get_value(ping_name.as_deref()),
           3507 => super::fxa_avatar_menu::click_sync_tabs.test_get_value(ping_name.as_deref()),
           3508 => super::fxa_avatar_menu::click_sync_tabs_sidebar.test_get_value(ping_name.as_deref()),
           3509 => super::fxa_avatar_menu::click_toolbar_icon.test_get_value(ping_name.as_deref()),
           3510 => super::fxa_avatar_menu::click_unver_sync_settings.test_get_value(ping_name.as_deref()),
           3511 => super::fxa_avatar_menu::click_vpn_cta.test_get_value(ping_name.as_deref()),
           3514 => super::bounce_tracking_protection::purge_action.test_get_value(ping_name.as_deref()),
           3523 => super::background_tasks_rmdir_base::metric_base.test_get_value(ping_name.as_deref()),
           3531 => super::background_tasks_rmdir_http_cache::metric_base.test_get_value(ping_name.as_deref()),
           3539 => super::background_tasks_rmdir_quota::metric_base.test_get_value(ping_name.as_deref()),
           3547 => super::relevancy_classify::fail.test_get_value(ping_name.as_deref()),
           3548 => super::relevancy_classify::succeed.test_get_value(ping_name.as_deref()),
           3551 => super::cookie_banners::google_gdpr_choice_cookie_event.test_get_value(ping_name.as_deref()),
           3552 => super::cookie_banners::google_gdpr_choice_cookie_event_pbm.test_get_value(ping_name.as_deref()),
           3555 => super::cookie_banners::reload.test_get_value(ping_name.as_deref()),
           3633 => super::extensions_data::migrate_result.test_get_value(ping_name.as_deref()),
           3634 => super::extensions_data::storage_local_error.test_get_value(ping_name.as_deref()),
           3635 => super::extensions_data::sync_usage_quotas.test_get_value(ping_name.as_deref()),
           3644 => super::address::add_manage.test_get_value(ping_name.as_deref()),
           3645 => super::address::cancel_capture_doorhanger.test_get_value(ping_name.as_deref()),
           3646 => super::address::cancel_edit_doorhanger.test_get_value(ping_name.as_deref()),
           3647 => super::address::cancel_update_doorhanger.test_get_value(ping_name.as_deref()),
           3648 => super::address::cleared_address_form.test_get_value(ping_name.as_deref()),
           3649 => super::address::delete_manage.test_get_value(ping_name.as_deref()),
           3650 => super::address::detected_address_form.test_get_value(ping_name.as_deref()),
           3651 => super::address::detected_address_form_ext.test_get_value(ping_name.as_deref()),
           3652 => super::address::disable_capture_doorhanger.test_get_value(ping_name.as_deref()),
           3653 => super::address::disable_edit_doorhanger.test_get_value(ping_name.as_deref()),
           3654 => super::address::disable_update_doorhanger.test_get_value(ping_name.as_deref()),
           3655 => super::address::edit_manage.test_get_value(ping_name.as_deref()),
           3656 => super::address::filled_address_form.test_get_value(ping_name.as_deref()),
           3657 => super::address::filled_address_form_ext.test_get_value(ping_name.as_deref()),
           3658 => super::address::filled_modified_address_form.test_get_value(ping_name.as_deref()),
           3659 => super::address::learn_more_capture_doorhanger.test_get_value(ping_name.as_deref()),
           3660 => super::address::learn_more_edit_doorhanger.test_get_value(ping_name.as_deref()),
           3661 => super::address::learn_more_update_doorhanger.test_get_value(ping_name.as_deref()),
           3662 => super::address::popup_shown_address_form.test_get_value(ping_name.as_deref()),
           3663 => super::address::pref_capture_doorhanger.test_get_value(ping_name.as_deref()),
           3664 => super::address::pref_edit_doorhanger.test_get_value(ping_name.as_deref()),
           3665 => super::address::pref_update_doorhanger.test_get_value(ping_name.as_deref()),
           3666 => super::address::save_capture_doorhanger.test_get_value(ping_name.as_deref()),
           3667 => super::address::save_edit_doorhanger.test_get_value(ping_name.as_deref()),
           3668 => super::address::save_update_doorhanger.test_get_value(ping_name.as_deref()),
           3669 => super::address::show_capture_doorhanger.test_get_value(ping_name.as_deref()),
           3670 => super::address::show_edit_doorhanger.test_get_value(ping_name.as_deref()),
           3671 => super::address::show_entry_manage.test_get_value(ping_name.as_deref()),
           3672 => super::address::show_manage.test_get_value(ping_name.as_deref()),
           3673 => super::address::show_update_doorhanger.test_get_value(ping_name.as_deref()),
           3674 => super::address::submitted_address_form.test_get_value(ping_name.as_deref()),
           3675 => super::address::submitted_address_form_ext.test_get_value(ping_name.as_deref()),
           3676 => super::address::update_capture_doorhanger.test_get_value(ping_name.as_deref()),
           3677 => super::address::update_edit_doorhanger.test_get_value(ping_name.as_deref()),
           3678 => super::address::update_update_doorhanger.test_get_value(ping_name.as_deref()),
           3679 => super::creditcard::add_manage.test_get_value(ping_name.as_deref()),
           3680 => super::creditcard::cancel_capture_doorhanger.test_get_value(ping_name.as_deref()),
           3681 => super::creditcard::cancel_update_doorhanger.test_get_value(ping_name.as_deref()),
           3682 => super::creditcard::cleared_cc_form_v2.test_get_value(ping_name.as_deref()),
           3683 => super::creditcard::delete_manage.test_get_value(ping_name.as_deref()),
           3684 => super::creditcard::detected_cc_form_v2.test_get_value(ping_name.as_deref()),
           3685 => super::creditcard::disable_capture_doorhanger.test_get_value(ping_name.as_deref()),
           3686 => super::creditcard::disable_update_doorhanger.test_get_value(ping_name.as_deref()),
           3687 => super::creditcard::edit_manage.test_get_value(ping_name.as_deref()),
           3688 => super::creditcard::filled_cc_form_v2.test_get_value(ping_name.as_deref()),
           3689 => super::creditcard::filled_modified_cc_form_v2.test_get_value(ping_name.as_deref()),
           3690 => super::creditcard::popup_shown_cc_form_v2.test_get_value(ping_name.as_deref()),
           3691 => super::creditcard::save_capture_doorhanger.test_get_value(ping_name.as_deref()),
           3692 => super::creditcard::save_update_doorhanger.test_get_value(ping_name.as_deref()),
           3693 => super::creditcard::show_capture_doorhanger.test_get_value(ping_name.as_deref()),
           3694 => super::creditcard::show_entry_manage.test_get_value(ping_name.as_deref()),
           3695 => super::creditcard::show_manage.test_get_value(ping_name.as_deref()),
           3696 => super::creditcard::show_update_doorhanger.test_get_value(ping_name.as_deref()),
           3697 => super::creditcard::submitted_cc_form_v2.test_get_value(ping_name.as_deref()),
           3698 => super::creditcard::update_capture_doorhanger.test_get_value(ping_name.as_deref()),
           3699 => super::creditcard::update_update_doorhanger.test_get_value(ping_name.as_deref()),
           3701 => super::formautofill::iframe_layout_detection.test_get_value(ping_name.as_deref()),
           3703 => super::formautofill_creditcards::form_cleared.test_get_value(ping_name.as_deref()),
           3704 => super::formautofill_creditcards::form_detected.test_get_value(ping_name.as_deref()),
           3705 => super::formautofill_creditcards::form_filled.test_get_value(ping_name.as_deref()),
           3706 => super::formautofill_creditcards::form_filled_modified.test_get_value(ping_name.as_deref()),
           3707 => super::formautofill_creditcards::form_popup_shown.test_get_value(ping_name.as_deref()),
           3708 => super::formautofill_creditcards::form_submitted.test_get_value(ping_name.as_deref()),
           3758 => super::test_only_ipc::an_event.test_get_value(ping_name.as_deref()),
           3763 => super::test_only_ipc::event_with_extra.test_get_value(ping_name.as_deref()),
           3765 => super::test_only_ipc::no_extra_event.test_get_value(ping_name.as_deref()),
           3768 => super::test_only_jog::an_event.test_get_value(ping_name.as_deref()),
           3769 => super::messaging_experiments::reach_cfr.test_get_value(ping_name.as_deref()),
           3770 => super::messaging_experiments::reach_feature_callout.test_get_value(ping_name.as_deref()),
           3771 => super::messaging_experiments::reach_fxms_bmb_button.test_get_value(ping_name.as_deref()),
           3772 => super::messaging_experiments::reach_fxms_message_1.test_get_value(ping_name.as_deref()),
           3773 => super::messaging_experiments::reach_fxms_message_10.test_get_value(ping_name.as_deref()),
           3774 => super::messaging_experiments::reach_fxms_message_11.test_get_value(ping_name.as_deref()),
           3775 => super::messaging_experiments::reach_fxms_message_2.test_get_value(ping_name.as_deref()),
           3776 => super::messaging_experiments::reach_fxms_message_3.test_get_value(ping_name.as_deref()),
           3777 => super::messaging_experiments::reach_fxms_message_4.test_get_value(ping_name.as_deref()),
           3778 => super::messaging_experiments::reach_fxms_message_5.test_get_value(ping_name.as_deref()),
           3779 => super::messaging_experiments::reach_fxms_message_6.test_get_value(ping_name.as_deref()),
           3780 => super::messaging_experiments::reach_fxms_message_7.test_get_value(ping_name.as_deref()),
           3781 => super::messaging_experiments::reach_fxms_message_8.test_get_value(ping_name.as_deref()),
           3782 => super::messaging_experiments::reach_fxms_message_9.test_get_value(ping_name.as_deref()),
           3783 => super::messaging_experiments::reach_infobar.test_get_value(ping_name.as_deref()),
           3784 => super::messaging_experiments::reach_moments_page.test_get_value(ping_name.as_deref()),
           3785 => super::messaging_experiments::reach_spotlight.test_get_value(ping_name.as_deref()),
           3786 => super::messaging_experiments::targeting_attribute_error.test_get_value(ping_name.as_deref()),
           3787 => super::messaging_experiments::targeting_attribute_timeout.test_get_value(ping_name.as_deref()),
           3788 => super::nimbus_events::enroll_failed.test_get_value(ping_name.as_deref()),
           3789 => super::nimbus_events::enrollment.test_get_value(ping_name.as_deref()),
           3790 => super::nimbus_events::enrollment_status.test_get_value(ping_name.as_deref()),
           3791 => super::nimbus_events::exposure.test_get_value(ping_name.as_deref()),
           3792 => super::nimbus_events::is_ready.test_get_value(ping_name.as_deref()),
           3793 => super::nimbus_events::unenroll_failed.test_get_value(ping_name.as_deref()),
           3794 => super::nimbus_events::unenrollment.test_get_value(ping_name.as_deref()),
           3795 => super::nimbus_events::validation_failed.test_get_value(ping_name.as_deref()),
           3796 => super::normandy::expose_nimbus_experiment.test_get_value(ping_name.as_deref()),
           3797 => super::normandy::enroll_addon_rollout.test_get_value(ping_name.as_deref()),
           3798 => super::normandy::enroll_addon_study.test_get_value(ping_name.as_deref()),
           3799 => super::normandy::enroll_failed_addon_rollout.test_get_value(ping_name.as_deref()),
           3800 => super::normandy::enroll_failed_addon_study.test_get_value(ping_name.as_deref()),
           3801 => super::normandy::enroll_failed_nimbus_experiment.test_get_value(ping_name.as_deref()),
           3802 => super::normandy::enroll_failed_preference_rollout.test_get_value(ping_name.as_deref()),
           3803 => super::normandy::enroll_failed_preference_study.test_get_value(ping_name.as_deref()),
           3804 => super::normandy::enroll_nimbus_experiment.test_get_value(ping_name.as_deref()),
           3805 => super::normandy::enroll_preference_rollout.test_get_value(ping_name.as_deref()),
           3806 => super::normandy::enroll_preference_study.test_get_value(ping_name.as_deref()),
           3807 => super::normandy::exp_pref_changed_preference_study.test_get_value(ping_name.as_deref()),
           3808 => super::normandy::graduate_preference_rollout.test_get_value(ping_name.as_deref()),
           3809 => super::normandy::unenroll_addon_rollback.test_get_value(ping_name.as_deref()),
           3810 => super::normandy::unenroll_addon_study.test_get_value(ping_name.as_deref()),
           3811 => super::normandy::unenroll_failed_addon_rollback.test_get_value(ping_name.as_deref()),
           3812 => super::normandy::unenroll_failed_nimbus_experiment.test_get_value(ping_name.as_deref()),
           3813 => super::normandy::unenroll_failed_preference_rollback.test_get_value(ping_name.as_deref()),
           3814 => super::normandy::unenroll_failed_preference_study.test_get_value(ping_name.as_deref()),
           3815 => super::normandy::unenroll_nimbus_experiment.test_get_value(ping_name.as_deref()),
           3816 => super::normandy::unenroll_preference_rollback.test_get_value(ping_name.as_deref()),
           3817 => super::normandy::unenroll_preference_study.test_get_value(ping_name.as_deref()),
           3818 => super::normandy::update_addon_rollout.test_get_value(ping_name.as_deref()),
           3819 => super::normandy::update_addon_study.test_get_value(ping_name.as_deref()),
           3820 => super::normandy::update_failed_addon_rollout.test_get_value(ping_name.as_deref()),
           3821 => super::normandy::update_failed_addon_study.test_get_value(ping_name.as_deref()),
           3822 => super::normandy::update_nimbus_experiment.test_get_value(ping_name.as_deref()),
           3823 => super::normandy::update_preference_rollout.test_get_value(ping_name.as_deref()),
           3824 => super::normandy::validation_failed_nimbus_experiment.test_get_value(ping_name.as_deref()),
           3825 => super::form_autocomplete::show_logins.test_get_value(ping_name.as_deref()),
           3826 => super::pwmgr::autocomplete_field_generatedpassword.test_get_value(ping_name.as_deref()),
           3827 => super::pwmgr::autocomplete_shown_generatedpassword.test_get_value(ping_name.as_deref()),
           3828 => super::pwmgr::cancel_existing_login.test_get_value(ping_name.as_deref()),
           3829 => super::pwmgr::cancel_new_login.test_get_value(ping_name.as_deref()),
           3830 => super::pwmgr::copy_password.test_get_value(ping_name.as_deref()),
           3831 => super::pwmgr::copy_username.test_get_value(ping_name.as_deref()),
           3832 => super::pwmgr::delete_existing_login.test_get_value(ping_name.as_deref()),
           3833 => super::pwmgr::delete_new_login.test_get_value(ping_name.as_deref()),
           3834 => super::pwmgr::doorhanger_submitted_save.test_get_value(ping_name.as_deref()),
           3835 => super::pwmgr::doorhanger_submitted_update.test_get_value(ping_name.as_deref()),
           3836 => super::pwmgr::edit_existing_login.test_get_value(ping_name.as_deref()),
           3837 => super::pwmgr::filled_field_edited_generatedpassword.test_get_value(ping_name.as_deref()),
           3838 => super::pwmgr::filter_list.test_get_value(ping_name.as_deref()),
           3840 => super::pwmgr::hide_password.test_get_value(ping_name.as_deref()),
           3841 => super::pwmgr::learn_more_vuln_existing_login.test_get_value(ping_name.as_deref()),
           3842 => super::pwmgr::mgmt_menu_item_used_export.test_get_value(ping_name.as_deref()),
           3843 => super::pwmgr::mgmt_menu_item_used_export_complete.test_get_value(ping_name.as_deref()),
           3844 => super::pwmgr::mgmt_menu_item_used_import_csv_complete.test_get_value(ping_name.as_deref()),
           3845 => super::pwmgr::mgmt_menu_item_used_import_from_browser.test_get_value(ping_name.as_deref()),
           3846 => super::pwmgr::mgmt_menu_item_used_import_from_csv.test_get_value(ping_name.as_deref()),
           3847 => super::pwmgr::mgmt_menu_item_used_preferences.test_get_value(ping_name.as_deref()),
           3848 => super::pwmgr::new_new_login.test_get_value(ping_name.as_deref()),
           3849 => super::pwmgr::open_management_aboutprotections.test_get_value(ping_name.as_deref()),
           3850 => super::pwmgr::open_management_autocomplete.test_get_value(ping_name.as_deref()),
           3851 => super::pwmgr::open_management_contextmenu.test_get_value(ping_name.as_deref()),
           3852 => super::pwmgr::open_management_direct.test_get_value(ping_name.as_deref()),
           3853 => super::pwmgr::open_management_mainmenu.test_get_value(ping_name.as_deref()),
           3854 => super::pwmgr::open_management_pageinfo.test_get_value(ping_name.as_deref()),
           3855 => super::pwmgr::open_management_preferences.test_get_value(ping_name.as_deref()),
           3856 => super::pwmgr::open_management_snippet.test_get_value(ping_name.as_deref()),
           3857 => super::pwmgr::open_site_existing_login.test_get_value(ping_name.as_deref()),
           3859 => super::pwmgr::reauthenticate_master_password.test_get_value(ping_name.as_deref()),
           3860 => super::pwmgr::reauthenticate_os_auth.test_get_value(ping_name.as_deref()),
           3861 => super::pwmgr::save_existing_login.test_get_value(ping_name.as_deref()),
           3862 => super::pwmgr::save_new_login.test_get_value(ping_name.as_deref()),
           3863 => super::pwmgr::saved_login_used_auth_login.test_get_value(ping_name.as_deref()),
           3864 => super::pwmgr::saved_login_used_form_login.test_get_value(ping_name.as_deref()),
           3865 => super::pwmgr::saved_login_used_form_password.test_get_value(ping_name.as_deref()),
           3866 => super::pwmgr::saved_login_used_prompt_login.test_get_value(ping_name.as_deref()),
           3867 => super::pwmgr::select_existing_login.test_get_value(ping_name.as_deref()),
           3868 => super::pwmgr::show_password.test_get_value(ping_name.as_deref()),
           3869 => super::pwmgr::sort_list.test_get_value(ping_name.as_deref()),
           3870 => super::relay_integration::clicked_fill_username.test_get_value(ping_name.as_deref()),
           3871 => super::relay_integration::clicked_offer_relay.test_get_value(ping_name.as_deref()),
           3872 => super::relay_integration::disabled_opt_in_panel.test_get_value(ping_name.as_deref()),
           3873 => super::relay_integration::disabled_pref_change.test_get_value(ping_name.as_deref()),
           3874 => super::relay_integration::enabled_opt_in_panel.test_get_value(ping_name.as_deref()),
           3875 => super::relay_integration::enabled_pref_change.test_get_value(ping_name.as_deref()),
           3876 => super::relay_integration::get_unlimited_masks_reuse_panel.test_get_value(ping_name.as_deref()),
           3877 => super::relay_integration::postponed_opt_in_panel.test_get_value(ping_name.as_deref()),
           3878 => super::relay_integration::reuse_mask_reuse_panel.test_get_value(ping_name.as_deref()),
           3879 => super::relay_integration::shown_fill_username.test_get_value(ping_name.as_deref()),
           3880 => super::relay_integration::shown_offer_relay.test_get_value(ping_name.as_deref()),
           3881 => super::relay_integration::shown_opt_in_panel.test_get_value(ping_name.as_deref()),
           3882 => super::relay_integration::shown_reuse_panel.test_get_value(ping_name.as_deref()),
           3901 => super::pdfjs_image::add_image_click.test_get_value(ping_name.as_deref()),
           3904 => super::pdfjs_image::icon_click.test_get_value(ping_name.as_deref()),
           3905 => super::pdfjs_image::image_added.test_get_value(ping_name.as_deref()),
           3906 => super::pdfjs_image::image_selected.test_get_value(ping_name.as_deref()),
           3907 => super::pdfjs_image_alt_text::ai_generation_check.test_get_value(ping_name.as_deref()),
           3908 => super::pdfjs_image_alt_text::callout_dismissed.test_get_value(ping_name.as_deref()),
           3909 => super::pdfjs_image_alt_text::callout_displayed.test_get_value(ping_name.as_deref()),
           3910 => super::pdfjs_image_alt_text::dismiss.test_get_value(ping_name.as_deref()),
           3911 => super::pdfjs_image_alt_text::image_status_label_clicked.test_get_value(ping_name.as_deref()),
           3912 => super::pdfjs_image_alt_text::image_status_label_displayed.test_get_value(ping_name.as_deref()),
           3913 => super::pdfjs_image_alt_text::info.test_get_value(ping_name.as_deref()),
           3914 => super::pdfjs_image_alt_text::model_deleted.test_get_value(ping_name.as_deref()),
           3915 => super::pdfjs_image_alt_text::model_download_complete.test_get_value(ping_name.as_deref()),
           3916 => super::pdfjs_image_alt_text::model_download_error.test_get_value(ping_name.as_deref()),
           3917 => super::pdfjs_image_alt_text::model_download_start.test_get_value(ping_name.as_deref()),
           3918 => super::pdfjs_image_alt_text::model_result.test_get_value(ping_name.as_deref()),
           3919 => super::pdfjs_image_alt_text::save.test_get_value(ping_name.as_deref()),
           3920 => super::pdfjs_image_alt_text::settings_ai_generation_check.test_get_value(ping_name.as_deref()),
           3921 => super::pdfjs_image_alt_text::settings_displayed.test_get_value(ping_name.as_deref()),
           3922 => super::pdfjs_image_alt_text::settings_edit_alt_text_check.test_get_value(ping_name.as_deref()),
           3923 => super::pdfjs_image_alt_text::user_edit.test_get_value(ping_name.as_deref()),
           3924 => super::pictureinpicture::closed_method_browser_crash.test_get_value(ping_name.as_deref()),
           3925 => super::pictureinpicture::closed_method_close_button.test_get_value(ping_name.as_deref()),
           3926 => super::pictureinpicture::closed_method_close_player_shortcut.test_get_value(ping_name.as_deref()),
           3927 => super::pictureinpicture::closed_method_context_menu.test_get_value(ping_name.as_deref()),
           3928 => super::pictureinpicture::closed_method_foregrounded.test_get_value(ping_name.as_deref()),
           3929 => super::pictureinpicture::closed_method_fullscreen.test_get_value(ping_name.as_deref()),
           3930 => super::pictureinpicture::closed_method_pagehide.test_get_value(ping_name.as_deref()),
           3931 => super::pictureinpicture::closed_method_setup_failure.test_get_value(ping_name.as_deref()),
           3932 => super::pictureinpicture::closed_method_shortcut.test_get_value(ping_name.as_deref()),
           3933 => super::pictureinpicture::closed_method_unpip.test_get_value(ping_name.as_deref()),
           3934 => super::pictureinpicture::closed_method_url_bar.test_get_value(ping_name.as_deref()),
           3935 => super::pictureinpicture::closed_method_video_el_emptied.test_get_value(ping_name.as_deref()),
           3936 => super::pictureinpicture::closed_method_video_el_remove.test_get_value(ping_name.as_deref()),
           3937 => super::pictureinpicture::create_player.test_get_value(ping_name.as_deref()),
           3938 => super::pictureinpicture::disrespect_disable_url_bar.test_get_value(ping_name.as_deref()),
           3939 => super::pictureinpicture::fullscreen_player.test_get_value(ping_name.as_deref()),
           3941 => super::pictureinpicture::opened_method_auto_pip.test_get_value(ping_name.as_deref()),
           3942 => super::pictureinpicture::opened_method_context_menu.test_get_value(ping_name.as_deref()),
           3943 => super::pictureinpicture::opened_method_shortcut.test_get_value(ping_name.as_deref()),
           3944 => super::pictureinpicture::opened_method_toggle.test_get_value(ping_name.as_deref()),
           3945 => super::pictureinpicture::opened_method_url_bar.test_get_value(ping_name.as_deref()),
           3946 => super::pictureinpicture::resize_player.test_get_value(ping_name.as_deref()),
           3947 => super::pictureinpicture::saw_toggle_toggle.test_get_value(ping_name.as_deref()),
           3948 => super::pictureinpicture::subtitles_shown_subtitles.test_get_value(ping_name.as_deref()),
           3950 => super::pictureinpicture_settings::disable_player.test_get_value(ping_name.as_deref()),
           3951 => super::pictureinpicture_settings::disable_settings.test_get_value(ping_name.as_deref()),
           3952 => super::pictureinpicture_settings::enable_autotrigger_settings.test_get_value(ping_name.as_deref()),
           3953 => super::pictureinpicture_settings::enable_settings.test_get_value(ping_name.as_deref()),
           3989 => super::readermode::button_click.test_get_value(ping_name.as_deref()),
           3990 => super::readermode::view_off.test_get_value(ping_name.as_deref()),
           3991 => super::readermode::view_on.test_get_value(ping_name.as_deref()),
           4028 => super::webcompatreporting::opened.test_get_value(ping_name.as_deref()),
           4029 => super::webcompatreporting::reason_dropdown.test_get_value(ping_name.as_deref()),
           4030 => super::webcompatreporting::send.test_get_value(ping_name.as_deref()),
           4031 => super::webcompatreporting::send_more_info.test_get_value(ping_name.as_deref()),
           4227 => super::search_engine_default::changed.test_get_value(ping_name.as_deref()),
           4233 => super::search_engine_private::changed.test_get_value(ping_name.as_deref()),
           4241 => super::shopping_product::invalid_ohttp_config.test_get_value(ping_name.as_deref()),
           4242 => super::shopping_product::invalid_request.test_get_value(ping_name.as_deref()),
           4243 => super::shopping_product::invalid_response.test_get_value(ping_name.as_deref()),
           4244 => super::shopping_product::request_aborted.test_get_value(ping_name.as_deref()),
           4245 => super::shopping_product::request_error.test_get_value(ping_name.as_deref()),
           4246 => super::shopping_product::request_failure.test_get_value(ping_name.as_deref()),
           4247 => super::shopping_product::request_retried.test_get_value(ping_name.as_deref()),
           4248 => super::shopping_product::request_retries_failed.test_get_value(ping_name.as_deref()),
           4249 => super::shopping_product::server_failure.test_get_value(ping_name.as_deref()),
           4253 => super::telemetry_test::test1_object1.test_get_value(ping_name.as_deref()),
           4254 => super::telemetry_test::test2_object1.test_get_value(ping_name.as_deref()),
           4255 => super::telemetry_test::test2_object2.test_get_value(ping_name.as_deref()),
           4256 => super::translations::error.test_get_value(ping_name.as_deref()),
           4260 => super::translations::restore_page.test_get_value(ping_name.as_deref()),
           4261 => super::translations::translation_request.test_get_value(ping_name.as_deref()),
           4262 => super::translations_panel::about_translations.test_get_value(ping_name.as_deref()),
           4263 => super::translations_panel::always_offer_translations.test_get_value(ping_name.as_deref()),
           4264 => super::translations_panel::always_translate_language.test_get_value(ping_name.as_deref()),
           4265 => super::translations_panel::cancel_button.test_get_value(ping_name.as_deref()),
           4266 => super::translations_panel::change_from_language.test_get_value(ping_name.as_deref()),
           4267 => super::translations_panel::change_source_language_button.test_get_value(ping_name.as_deref()),
           4268 => super::translations_panel::change_to_language.test_get_value(ping_name.as_deref()),
           4269 => super::translations_panel::close.test_get_value(ping_name.as_deref()),
           4270 => super::translations_panel::close_from_language_menu.test_get_value(ping_name.as_deref()),
           4271 => super::translations_panel::close_settings_menu.test_get_value(ping_name.as_deref()),
           4272 => super::translations_panel::close_to_language_menu.test_get_value(ping_name.as_deref()),
           4273 => super::translations_panel::dismiss_error_button.test_get_value(ping_name.as_deref()),
           4274 => super::translations_panel::learn_more.test_get_value(ping_name.as_deref()),
           4275 => super::translations_panel::manage_languages.test_get_value(ping_name.as_deref()),
           4276 => super::translations_panel::never_translate_language.test_get_value(ping_name.as_deref()),
           4277 => super::translations_panel::never_translate_site.test_get_value(ping_name.as_deref()),
           4278 => super::translations_panel::open.test_get_value(ping_name.as_deref()),
           4279 => super::translations_panel::open_from_language_menu.test_get_value(ping_name.as_deref()),
           4280 => super::translations_panel::open_settings_menu.test_get_value(ping_name.as_deref()),
           4281 => super::translations_panel::open_to_language_menu.test_get_value(ping_name.as_deref()),
           4282 => super::translations_panel::restore_page_button.test_get_value(ping_name.as_deref()),
           4283 => super::translations_panel::translate_button.test_get_value(ping_name.as_deref()),
           4284 => super::translations_select_translations_panel::about_translations.test_get_value(ping_name.as_deref()),
           4285 => super::translations_select_translations_panel::cancel_button.test_get_value(ping_name.as_deref()),
           4286 => super::translations_select_translations_panel::change_from_language.test_get_value(ping_name.as_deref()),
           4287 => super::translations_select_translations_panel::change_to_language.test_get_value(ping_name.as_deref()),
           4288 => super::translations_select_translations_panel::close.test_get_value(ping_name.as_deref()),
           4289 => super::translations_select_translations_panel::copy_button.test_get_value(ping_name.as_deref()),
           4290 => super::translations_select_translations_panel::done_button.test_get_value(ping_name.as_deref()),
           4291 => super::translations_select_translations_panel::initialization_failure_message.test_get_value(ping_name.as_deref()),
           4292 => super::translations_select_translations_panel::open.test_get_value(ping_name.as_deref()),
           4293 => super::translations_select_translations_panel::open_settings_menu.test_get_value(ping_name.as_deref()),
           4294 => super::translations_select_translations_panel::translate_button.test_get_value(ping_name.as_deref()),
           4295 => super::translations_select_translations_panel::translate_full_page_button.test_get_value(ping_name.as_deref()),
           4296 => super::translations_select_translations_panel::translation_failure_message.test_get_value(ping_name.as_deref()),
           4297 => super::translations_select_translations_panel::translation_settings.test_get_value(ping_name.as_deref()),
           4298 => super::translations_select_translations_panel::try_again_button.test_get_value(ping_name.as_deref()),
           4299 => super::translations_select_translations_panel::unsupported_language_message.test_get_value(ping_name.as_deref()),
           4307 => super::security_doh_neterror::click_add_exception_button.test_get_value(ping_name.as_deref()),
           4308 => super::security_doh_neterror::click_continue_button.test_get_value(ping_name.as_deref()),
           4309 => super::security_doh_neterror::click_disable_warning.test_get_value(ping_name.as_deref()),
           4310 => super::security_doh_neterror::click_learn_more_link.test_get_value(ping_name.as_deref()),
           4311 => super::security_doh_neterror::click_settings_button.test_get_value(ping_name.as_deref()),
           4312 => super::security_doh_neterror::click_try_again_button.test_get_value(ping_name.as_deref()),
           4313 => super::security_doh_neterror::load_dohwarning.test_get_value(ping_name.as_deref()),
           4314 => super::security_ui_certerror::click_advanced_button.test_get_value(ping_name.as_deref()),
           4315 => super::security_ui_certerror::click_auto_report_cb.test_get_value(ping_name.as_deref()),
           4316 => super::security_ui_certerror::click_clipboard_button_bot.test_get_value(ping_name.as_deref()),
           4317 => super::security_ui_certerror::click_clipboard_button_top.test_get_value(ping_name.as_deref()),
           4318 => super::security_ui_certerror::click_error_code_link.test_get_value(ping_name.as_deref()),
           4319 => super::security_ui_certerror::click_exception_button.test_get_value(ping_name.as_deref()),
           4320 => super::security_ui_certerror::click_learn_more_link.test_get_value(ping_name.as_deref()),
           4321 => super::security_ui_certerror::click_return_button_adv.test_get_value(ping_name.as_deref()),
           4322 => super::security_ui_certerror::click_return_button_top.test_get_value(ping_name.as_deref()),
           4323 => super::security_ui_certerror::load_aboutcerterror.test_get_value(ping_name.as_deref()),
           4324 => super::security_ui_tlserror::load_abouttlserror.test_get_value(ping_name.as_deref()),
           4330 => super::jsonfile::load_autofillprofiles.test_get_value(ping_name.as_deref()),
           4331 => super::jsonfile::load_logins.test_get_value(ping_name.as_deref()),
           4332 => super::service_request::bypass_proxy_info.test_get_value(ping_name.as_deref()),
           4341 => super::addons_manager::install.test_get_value(ping_name.as_deref()),
           4342 => super::addons_manager::install_stats.test_get_value(ping_name.as_deref()),
           4343 => super::addons_manager::manage.test_get_value(ping_name.as_deref()),
           4344 => super::addons_manager::report_suspicious_site.test_get_value(ping_name.as_deref()),
           4345 => super::addons_manager::update.test_get_value(ping_name.as_deref()),
           4346 => super::addons_manager::disable_dictionary.test_get_value(ping_name.as_deref()),
           4347 => super::addons_manager::disable_extension.test_get_value(ping_name.as_deref()),
           4348 => super::addons_manager::disable_locale.test_get_value(ping_name.as_deref()),
           4349 => super::addons_manager::disable_other.test_get_value(ping_name.as_deref()),
           4350 => super::addons_manager::disable_siteperm_deprecated.test_get_value(ping_name.as_deref()),
           4351 => super::addons_manager::disable_sitepermission.test_get_value(ping_name.as_deref()),
           4352 => super::addons_manager::disable_theme.test_get_value(ping_name.as_deref()),
           4353 => super::addons_manager::disable_unknown.test_get_value(ping_name.as_deref()),
           4354 => super::addons_manager::enable_dictionary.test_get_value(ping_name.as_deref()),
           4355 => super::addons_manager::enable_extension.test_get_value(ping_name.as_deref()),
           4356 => super::addons_manager::enable_locale.test_get_value(ping_name.as_deref()),
           4357 => super::addons_manager::enable_other.test_get_value(ping_name.as_deref()),
           4358 => super::addons_manager::enable_siteperm_deprecated.test_get_value(ping_name.as_deref()),
           4359 => super::addons_manager::enable_sitepermission.test_get_value(ping_name.as_deref()),
           4360 => super::addons_manager::enable_theme.test_get_value(ping_name.as_deref()),
           4361 => super::addons_manager::enable_unknown.test_get_value(ping_name.as_deref()),
           4362 => super::addons_manager::install_dictionary.test_get_value(ping_name.as_deref()),
           4363 => super::addons_manager::install_extension.test_get_value(ping_name.as_deref()),
           4364 => super::addons_manager::install_locale.test_get_value(ping_name.as_deref()),
           4365 => super::addons_manager::install_other.test_get_value(ping_name.as_deref()),
           4366 => super::addons_manager::install_siteperm_deprecated.test_get_value(ping_name.as_deref()),
           4367 => super::addons_manager::install_sitepermission.test_get_value(ping_name.as_deref()),
           4368 => super::addons_manager::install_stats_dictionary.test_get_value(ping_name.as_deref()),
           4369 => super::addons_manager::install_stats_extension.test_get_value(ping_name.as_deref()),
           4370 => super::addons_manager::install_stats_locale.test_get_value(ping_name.as_deref()),
           4371 => super::addons_manager::install_stats_other.test_get_value(ping_name.as_deref()),
           4372 => super::addons_manager::install_stats_siteperm_deprecated.test_get_value(ping_name.as_deref()),
           4373 => super::addons_manager::install_stats_sitepermission.test_get_value(ping_name.as_deref()),
           4374 => super::addons_manager::install_stats_theme.test_get_value(ping_name.as_deref()),
           4375 => super::addons_manager::install_stats_unknown.test_get_value(ping_name.as_deref()),
           4376 => super::addons_manager::install_theme.test_get_value(ping_name.as_deref()),
           4377 => super::addons_manager::install_unknown.test_get_value(ping_name.as_deref()),
           4378 => super::addons_manager::sideload_prompt_dictionary.test_get_value(ping_name.as_deref()),
           4379 => super::addons_manager::sideload_prompt_extension.test_get_value(ping_name.as_deref()),
           4380 => super::addons_manager::sideload_prompt_locale.test_get_value(ping_name.as_deref()),
           4381 => super::addons_manager::sideload_prompt_other.test_get_value(ping_name.as_deref()),
           4382 => super::addons_manager::sideload_prompt_siteperm_deprecated.test_get_value(ping_name.as_deref()),
           4383 => super::addons_manager::sideload_prompt_sitepermission.test_get_value(ping_name.as_deref()),
           4384 => super::addons_manager::sideload_prompt_theme.test_get_value(ping_name.as_deref()),
           4385 => super::addons_manager::sideload_prompt_unknown.test_get_value(ping_name.as_deref()),
           4386 => super::addons_manager::uninstall_dictionary.test_get_value(ping_name.as_deref()),
           4387 => super::addons_manager::uninstall_extension.test_get_value(ping_name.as_deref()),
           4388 => super::addons_manager::uninstall_locale.test_get_value(ping_name.as_deref()),
           4389 => super::addons_manager::uninstall_other.test_get_value(ping_name.as_deref()),
           4390 => super::addons_manager::uninstall_siteperm_deprecated.test_get_value(ping_name.as_deref()),
           4391 => super::addons_manager::uninstall_sitepermission.test_get_value(ping_name.as_deref()),
           4392 => super::addons_manager::uninstall_theme.test_get_value(ping_name.as_deref()),
           4393 => super::addons_manager::uninstall_unknown.test_get_value(ping_name.as_deref()),
           4394 => super::addons_manager::update_dictionary.test_get_value(ping_name.as_deref()),
           4395 => super::addons_manager::update_extension.test_get_value(ping_name.as_deref()),
           4396 => super::addons_manager::update_locale.test_get_value(ping_name.as_deref()),
           4397 => super::addons_manager::update_other.test_get_value(ping_name.as_deref()),
           4398 => super::addons_manager::update_siteperm_deprecated.test_get_value(ping_name.as_deref()),
           4399 => super::addons_manager::update_sitepermission.test_get_value(ping_name.as_deref()),
           4400 => super::addons_manager::update_theme.test_get_value(ping_name.as_deref()),
           4401 => super::addons_manager::update_unknown.test_get_value(ping_name.as_deref()),
           4402 => super::blocklist::addon_block_change.test_get_value(ping_name.as_deref()),
           4432 => super::file_dialog::fallback_v2_1.test_get_value(ping_name.as_deref()),
           4433 => super::memory_watcher::on_high_memory_stats.test_get_value(ping_name.as_deref()),
           _ => panic!("No event for metric id {}", metric_id),
        }
    }

    /// Check the provided event for errors.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `ping_name` - (Optional) The ping name to look into.
    ///                 Defaults to the first value in `send_in_pings`.
    ///
    /// # Returns
    ///
    /// Returns a string for the recorded error or `None`.
    ///
    /// # Panics
    ///
    /// Panics if no event by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn event_test_get_error(metric_id: u32) -> Option<String> {
        #[cfg(feature = "with_gecko")]
        match metric_id {
           9 => test_get_errors!(super::privacy_sanitize::clear),
           10 => test_get_errors!(super::privacy_sanitize::clearing_time_span_selected),
           11 => test_get_errors!(super::privacy_sanitize::dialog_open),
           13 => test_get_errors!(super::security_ui_protectionspopup::click_cookieb_toggle_off),
           14 => test_get_errors!(super::security_ui_protectionspopup::click_cookieb_toggle_on),
           15 => test_get_errors!(super::security_ui_protectionspopup::click_cookies),
           16 => test_get_errors!(super::security_ui_protectionspopup::click_cryptominers),
           17 => test_get_errors!(super::security_ui_protectionspopup::click_etp_toggle_off),
           18 => test_get_errors!(super::security_ui_protectionspopup::click_etp_toggle_on),
           19 => test_get_errors!(super::security_ui_protectionspopup::click_fingerprinters),
           20 => test_get_errors!(super::security_ui_protectionspopup::click_full_report),
           21 => test_get_errors!(super::security_ui_protectionspopup::click_milestone_message),
           22 => test_get_errors!(super::security_ui_protectionspopup::click_protectionspopup_cfr),
           23 => test_get_errors!(super::security_ui_protectionspopup::click_settings),
           24 => test_get_errors!(super::security_ui_protectionspopup::click_social),
           25 => test_get_errors!(super::security_ui_protectionspopup::click_subview_settings),
           26 => test_get_errors!(super::security_ui_protectionspopup::click_trackers),
           27 => test_get_errors!(super::security_ui_protectionspopup::open_protections_popup),
           28 => test_get_errors!(super::security_ui_protectionspopup::open_protectionspopup_cfr),
           51 => test_get_errors!(super::doh::evaluate_v2_heuristics),
           52 => test_get_errors!(super::doh::state_disabled),
           53 => test_get_errors!(super::doh::state_enabled),
           54 => test_get_errors!(super::doh::state_manually_disabled),
           55 => test_get_errors!(super::doh::state_policy_disabled),
           56 => test_get_errors!(super::doh::state_rollback),
           57 => test_get_errors!(super::doh::state_shutdown),
           58 => test_get_errors!(super::doh::state_uidisabled),
           59 => test_get_errors!(super::doh::state_uiok),
           60 => test_get_errors!(super::doh::state_uninstalled),
           164 => test_get_errors!(super::security_doh_trr_performance::resolved_record),
           165 => test_get_errors!(super::security_doh_trr_performance::trrselect_dryrunresult),
           167 => test_get_errors!(super::downloads::added_file_extension),
           169 => test_get_errors!(super::firefoxview_next::browser_context_menu_tabs),
           170 => test_get_errors!(super::firefoxview_next::card_collapsed_card_container),
           171 => test_get_errors!(super::firefoxview_next::card_expanded_card_container),
           172 => test_get_errors!(super::firefoxview_next::change_page_navigation),
           173 => test_get_errors!(super::firefoxview_next::close_open_tab_tabs),
           174 => test_get_errors!(super::firefoxview_next::context_menu_tabs),
           175 => test_get_errors!(super::firefoxview_next::dismiss_closed_tab_tabs),
           176 => test_get_errors!(super::firefoxview_next::entered_firefoxview),
           177 => test_get_errors!(super::firefoxview_next::fxa_continue_sync),
           178 => test_get_errors!(super::firefoxview_next::fxa_mobile_sync),
           179 => test_get_errors!(super::firefoxview_next::history_visits),
           180 => test_get_errors!(super::firefoxview_next::open_tab_tabs),
           181 => test_get_errors!(super::firefoxview_next::recently_closed_tabs),
           182 => test_get_errors!(super::firefoxview_next::search_initiated_search),
           183 => test_get_errors!(super::firefoxview_next::search_show_all_showallbutton),
           184 => test_get_errors!(super::firefoxview_next::show_all_history_tabs),
           185 => test_get_errors!(super::firefoxview_next::sort_history_tabs),
           186 => test_get_errors!(super::firefoxview_next::synced_tabs_tabs),
           187 => test_get_errors!(super::firefoxview_next::tab_selected_toolbarbutton),
           188 => test_get_errors!(super::genai_chatbot::contextmenu_prompt_click),
           190 => test_get_errors!(super::genai_chatbot::experiment_checkbox_click),
           191 => test_get_errors!(super::genai_chatbot::onboarding_close),
           192 => test_get_errors!(super::genai_chatbot::onboarding_continue),
           193 => test_get_errors!(super::genai_chatbot::onboarding_finish),
           194 => test_get_errors!(super::genai_chatbot::onboarding_learn_more),
           195 => test_get_errors!(super::genai_chatbot::onboarding_provider_choice_displayed),
           196 => test_get_errors!(super::genai_chatbot::onboarding_provider_learn),
           197 => test_get_errors!(super::genai_chatbot::onboarding_provider_selection),
           198 => test_get_errors!(super::genai_chatbot::onboarding_provider_terms),
           199 => test_get_errors!(super::genai_chatbot::onboarding_text_highlight_displayed),
           201 => test_get_errors!(super::genai_chatbot::provider_change),
           203 => test_get_errors!(super::genai_chatbot::shortcuts_checkbox_click),
           205 => test_get_errors!(super::genai_chatbot::shortcuts_displayed),
           206 => test_get_errors!(super::genai_chatbot::shortcuts_expanded),
           207 => test_get_errors!(super::genai_chatbot::shortcuts_hide_click),
           208 => test_get_errors!(super::genai_chatbot::shortcuts_prompt_click),
           210 => test_get_errors!(super::genai_chatbot::sidebar_close_click),
           211 => test_get_errors!(super::genai_chatbot::sidebar_more_menu_click),
           212 => test_get_errors!(super::genai_chatbot::sidebar_more_menu_display),
           213 => test_get_errors!(super::genai_chatbot::sidebar_provider_menu_click),
           214 => test_get_errors!(super::genai_chatbot::sidebar_toggle),
           231 => test_get_errors!(super::browser_launched_to_handle::system_notification),
           245 => test_get_errors!(super::launch_on_login::last_profile_disable_startup),
           258 => test_get_errors!(super::security::fission_principals),
           259 => test_get_errors!(super::security::eval_usage_parent_process),
           260 => test_get_errors!(super::security::eval_usage_system_context),
           261 => test_get_errors!(super::security::javascript_load_parent_process),
           262 => test_get_errors!(super::security::unexpected_load),
           263 => test_get_errors!(super::security::pref_usage_content_process),
           266 => test_get_errors!(super::start_menu::manually_unpinned_since_last_launch),
           272 => test_get_errors!(super::upgrade_dialog::trigger_reason),
           273 => test_get_errors!(super::browser_migration::browser_selected_wizard),
           274 => test_get_errors!(super::browser_migration::linux_perms_wizard),
           276 => test_get_errors!(super::browser_migration::migration_finished_wizard),
           277 => test_get_errors!(super::browser_migration::migration_started_wizard),
           278 => test_get_errors!(super::browser_migration::no_browsers_found_wizard),
           279 => test_get_errors!(super::browser_migration::opened_wizard),
           280 => test_get_errors!(super::browser_migration::profile_selected_wizard),
           281 => test_get_errors!(super::browser_migration::resources_selected_wizard),
           282 => test_get_errors!(super::browser_migration::safari_password_file_wizard),
           283 => test_get_errors!(super::browser_migration::safari_perms_wizard),
           288 => test_get_errors!(super::activity_stream::end_session),
           289 => test_get_errors!(super::activity_stream::event_archive_from_pocket),
           290 => test_get_errors!(super::activity_stream::event_block),
           291 => test_get_errors!(super::activity_stream::event_bookmark_add),
           292 => test_get_errors!(super::activity_stream::event_bookmark_delete),
           293 => test_get_errors!(super::activity_stream::event_click),
           294 => test_get_errors!(super::activity_stream::event_click_privacy_info),
           295 => test_get_errors!(super::activity_stream::event_close_newtab_prefs),
           296 => test_get_errors!(super::activity_stream::event_delete),
           297 => test_get_errors!(super::activity_stream::event_delete_confirm),
           298 => test_get_errors!(super::activity_stream::event_delete_from_pocket),
           299 => test_get_errors!(super::activity_stream::event_dialog_cancel),
           300 => test_get_errors!(super::activity_stream::event_dialog_open),
           301 => test_get_errors!(super::activity_stream::event_disclaimer_acked),
           302 => test_get_errors!(super::activity_stream::event_drag),
           303 => test_get_errors!(super::activity_stream::event_drop),
           304 => test_get_errors!(super::activity_stream::event_fakespot_category),
           305 => test_get_errors!(super::activity_stream::event_fakespot_click),
           306 => test_get_errors!(super::activity_stream::event_hide_personalize),
           307 => test_get_errors!(super::activity_stream::event_impression),
           308 => test_get_errors!(super::activity_stream::event_menu_add_search),
           309 => test_get_errors!(super::activity_stream::event_menu_add_topsite),
           310 => test_get_errors!(super::activity_stream::event_menu_collapse),
           311 => test_get_errors!(super::activity_stream::event_menu_expand),
           312 => test_get_errors!(super::activity_stream::event_menu_manage),
           313 => test_get_errors!(super::activity_stream::event_menu_move_down),
           314 => test_get_errors!(super::activity_stream::event_menu_move_up),
           315 => test_get_errors!(super::activity_stream::event_menu_privacy_notice),
           316 => test_get_errors!(super::activity_stream::event_menu_remove),
           317 => test_get_errors!(super::activity_stream::event_migration_cancel),
           318 => test_get_errors!(super::activity_stream::event_migration_start),
           319 => test_get_errors!(super::activity_stream::event_open_new_window),
           320 => test_get_errors!(super::activity_stream::event_open_newtab_prefs),
           321 => test_get_errors!(super::activity_stream::event_open_private_window),
           322 => test_get_errors!(super::activity_stream::event_pin),
           323 => test_get_errors!(super::activity_stream::event_pocket_thumbs_down),
           324 => test_get_errors!(super::activity_stream::event_pocket_thumbs_up),
           325 => test_get_errors!(super::activity_stream::event_pref_changed),
           326 => test_get_errors!(super::activity_stream::event_preview_request),
           327 => test_get_errors!(super::activity_stream::event_save_to_pocket),
           328 => test_get_errors!(super::activity_stream::event_search),
           329 => test_get_errors!(super::activity_stream::event_search_edit_add),
           330 => test_get_errors!(super::activity_stream::event_search_edit_close),
           331 => test_get_errors!(super::activity_stream::event_search_edit_delete),
           332 => test_get_errors!(super::activity_stream::event_search_handoff),
           333 => test_get_errors!(super::activity_stream::event_show_personalize),
           334 => test_get_errors!(super::activity_stream::event_show_privacy_info),
           335 => test_get_errors!(super::activity_stream::event_skipped_signin),
           336 => test_get_errors!(super::activity_stream::event_submit_email),
           337 => test_get_errors!(super::activity_stream::event_top_sites_edit),
           338 => test_get_errors!(super::activity_stream::event_top_sites_edit_close),
           339 => test_get_errors!(super::activity_stream::event_topsite_sponsor_info),
           340 => test_get_errors!(super::activity_stream::event_unpin),
           376 => test_get_errors!(super::newtab::closed),
           377 => test_get_errors!(super::newtab::fakespot_about_click),
           378 => test_get_errors!(super::newtab::fakespot_category),
           379 => test_get_errors!(super::newtab::fakespot_click),
           380 => test_get_errors!(super::newtab::fakespot_cta_click),
           381 => test_get_errors!(super::newtab::fakespot_dismiss),
           382 => test_get_errors!(super::newtab::fakespot_product_impression),
           386 => test_get_errors!(super::newtab::opened),
           389 => test_get_errors!(super::newtab::tooltip_click),
           390 => test_get_errors!(super::newtab::topic_selection_dismiss),
           391 => test_get_errors!(super::newtab::topic_selection_open),
           392 => test_get_errors!(super::newtab::topic_selection_topics_saved),
           393 => test_get_errors!(super::newtab::wallpaper_category_click),
           394 => test_get_errors!(super::newtab::wallpaper_click),
           395 => test_get_errors!(super::newtab::wallpaper_highlight_cta_click),
           396 => test_get_errors!(super::newtab::wallpaper_highlight_dismissed),
           397 => test_get_errors!(super::newtab::weather_change_display),
           399 => test_get_errors!(super::newtab::weather_impression),
           400 => test_get_errors!(super::newtab::weather_load_error),
           401 => test_get_errors!(super::newtab::weather_location_selected),
           402 => test_get_errors!(super::newtab::weather_open_provider_url),
           405 => test_get_errors!(super::newtab_search::issued),
           406 => test_get_errors!(super::pocket::click),
           407 => test_get_errors!(super::pocket::dismiss),
           410 => test_get_errors!(super::pocket::impression),
           413 => test_get_errors!(super::pocket::save),
           416 => test_get_errors!(super::pocket::thumb_voting_interaction),
           417 => test_get_errors!(super::pocket::topic_click),
           425 => test_get_errors!(super::topsites::click),
           426 => test_get_errors!(super::topsites::dismiss),
           428 => test_get_errors!(super::topsites::impression),
           429 => test_get_errors!(super::topsites::pref_changed),
           431 => test_get_errors!(super::topsites::show_privacy_click),
           445 => test_get_errors!(super::aboutpreferences::show_click),
           446 => test_get_errors!(super::aboutpreferences::show_hash),
           447 => test_get_errors!(super::aboutpreferences::show_initial),
           448 => test_get_errors!(super::intl_ui_browser_language::accept_dialog),
           449 => test_get_errors!(super::intl_ui_browser_language::add_dialog),
           450 => test_get_errors!(super::intl_ui_browser_language::apply_main),
           451 => test_get_errors!(super::intl_ui_browser_language::cancel_dialog),
           452 => test_get_errors!(super::intl_ui_browser_language::manage_main),
           453 => test_get_errors!(super::intl_ui_browser_language::remove_dialog),
           454 => test_get_errors!(super::intl_ui_browser_language::reorder_dialog),
           455 => test_get_errors!(super::intl_ui_browser_language::reorder_main),
           456 => test_get_errors!(super::intl_ui_browser_language::search_dialog),
           457 => test_get_errors!(super::intl_ui_browser_language::search_main),
           458 => test_get_errors!(super::intl_ui_browser_language::set_fallback_dialog),
           459 => test_get_errors!(super::privacy_ui_fpp_click::checkbox),
           460 => test_get_errors!(super::privacy_ui_fpp_click::menu),
           461 => test_get_errors!(super::security_doh_settings::mode_changed_button),
           462 => test_get_errors!(super::security_doh_settings::provider_choice_value),
           463 => test_get_errors!(super::security_doh_settings::warn_checkbox_checkbox),
           464 => test_get_errors!(super::aboutprivatebrowsing::click_dismiss_button),
           465 => test_get_errors!(super::aboutprivatebrowsing::click_info_link),
           466 => test_get_errors!(super::aboutprivatebrowsing::click_promo_link),
           467 => test_get_errors!(super::private_browsing_reset_pbm::confirm_panel),
           468 => test_get_errors!(super::private_browsing_reset_pbm::reset_action),
           469 => test_get_errors!(super::security_ui_protections::click_lw_about_link),
           470 => test_get_errors!(super::security_ui_protections::click_lw_open_button),
           471 => test_get_errors!(super::security_ui_protections::click_lw_sync_link),
           472 => test_get_errors!(super::security_ui_protections::click_mobile_app_link),
           473 => test_get_errors!(super::security_ui_protections::click_mtr_about_link),
           474 => test_get_errors!(super::security_ui_protections::click_mtr_report_link),
           475 => test_get_errors!(super::security_ui_protections::click_mtr_signup_button),
           476 => test_get_errors!(super::security_ui_protections::click_settings_link),
           477 => test_get_errors!(super::security_ui_protections::click_trackers_about_link),
           478 => test_get_errors!(super::security_ui_protections::click_vpn_app_link_android),
           479 => test_get_errors!(super::security_ui_protections::click_vpn_app_link_ios),
           480 => test_get_errors!(super::security_ui_protections::click_vpn_banner_close),
           481 => test_get_errors!(super::security_ui_protections::click_vpn_banner_link),
           482 => test_get_errors!(super::security_ui_protections::click_vpn_card_link),
           483 => test_get_errors!(super::security_ui_protections::close_protection_report),
           484 => test_get_errors!(super::security_ui_protections::show_protection_report),
           485 => test_get_errors!(super::security_ui_protections::show_vpn_banner),
           488 => test_get_errors!(super::protocolhandler_mailto::visit),
           489 => test_get_errors!(super::screenshots::canceled_context_menu),
           490 => test_get_errors!(super::screenshots::canceled_escape),
           491 => test_get_errors!(super::screenshots::canceled_navigation),
           492 => test_get_errors!(super::screenshots::canceled_overlay_cancel),
           493 => test_get_errors!(super::screenshots::canceled_preview_cancel),
           494 => test_get_errors!(super::screenshots::canceled_quick_actions),
           495 => test_get_errors!(super::screenshots::canceled_shortcut),
           496 => test_get_errors!(super::screenshots::canceled_toolbar_button),
           497 => test_get_errors!(super::screenshots::copy_overlay_copy),
           498 => test_get_errors!(super::screenshots::copy_preview_copy),
           499 => test_get_errors!(super::screenshots::download_overlay_download),
           500 => test_get_errors!(super::screenshots::download_preview_download),
           501 => test_get_errors!(super::screenshots::failed_screenshot_too_large),
           502 => test_get_errors!(super::screenshots::selected_element),
           503 => test_get_errors!(super::screenshots::selected_full_page),
           504 => test_get_errors!(super::screenshots::selected_region_selection),
           505 => test_get_errors!(super::screenshots::selected_visible),
           506 => test_get_errors!(super::screenshots::started_context_menu),
           507 => test_get_errors!(super::screenshots::started_overlay_retry),
           508 => test_get_errors!(super::screenshots::started_preview_retry),
           509 => test_get_errors!(super::screenshots::started_quick_actions),
           510 => test_get_errors!(super::screenshots::started_shortcut),
           511 => test_get_errors!(super::screenshots::started_toolbar_button),
           560 => test_get_errors!(super::newtab_search_ad::click),
           561 => test_get_errors!(super::newtab_search_ad::impression),
           564 => test_get_errors!(super::serp::abandonment),
           565 => test_get_errors!(super::serp::ad_impression),
           567 => test_get_errors!(super::serp::categorization),
           570 => test_get_errors!(super::serp::engagement),
           572 => test_get_errors!(super::serp::impression),
           588 => test_get_errors!(super::session_restore::backup_can_be_loaded_session_file),
           589 => test_get_errors!(super::session_restore::shutdown_success_session_startup),
           590 => test_get_errors!(super::shopping::address_bar_feature_callout_displayed),
           591 => test_get_errors!(super::shopping::address_bar_icon_clicked),
           592 => test_get_errors!(super::shopping::address_bar_icon_displayed),
           593 => test_get_errors!(super::shopping::ads_exposure),
           595 => test_get_errors!(super::shopping::surface_ads_clicked),
           596 => test_get_errors!(super::shopping::surface_ads_impression),
           597 => test_get_errors!(super::shopping::surface_ads_placement),
           598 => test_get_errors!(super::shopping::surface_ads_setting_toggled),
           599 => test_get_errors!(super::shopping::surface_analyze_reviews_none_available_clicked),
           600 => test_get_errors!(super::shopping::surface_auto_open_setting_toggled),
           601 => test_get_errors!(super::shopping::surface_closed),
           602 => test_get_errors!(super::shopping::surface_displayed),
           603 => test_get_errors!(super::shopping::surface_learn_more_clicked),
           604 => test_get_errors!(super::shopping::surface_no_ads_available),
           605 => test_get_errors!(super::shopping::surface_no_review_reliability_available),
           606 => test_get_errors!(super::shopping::surface_no_thanks_button_clicked),
           607 => test_get_errors!(super::shopping::surface_not_now_clicked),
           608 => test_get_errors!(super::shopping::surface_onboarding_displayed),
           609 => test_get_errors!(super::shopping::surface_opt_in_clicked),
           610 => test_get_errors!(super::shopping::surface_opt_out_button_clicked),
           611 => test_get_errors!(super::shopping::surface_powered_by_fakespot_link_clicked),
           612 => test_get_errors!(super::shopping::surface_reactivated_button_clicked),
           613 => test_get_errors!(super::shopping::surface_reanalyze_clicked),
           614 => test_get_errors!(super::shopping::surface_settings_expand_clicked),
           615 => test_get_errors!(super::shopping::surface_show_more_reviews_button_clicked),
           616 => test_get_errors!(super::shopping::surface_show_privacy_policy_clicked),
           617 => test_get_errors!(super::shopping::surface_show_quality_explainer_clicked),
           618 => test_get_errors!(super::shopping::surface_show_quality_explainer_url_clicked),
           619 => test_get_errors!(super::shopping::surface_show_terms_clicked),
           620 => test_get_errors!(super::shopping::surface_stale_analysis_shown),
           621 => test_get_errors!(super::shopping::surface_yes_keep_closed_button_clicked),
           627 => test_get_errors!(super::bookmarks::sidebar_toggle),
           628 => test_get_errors!(super::extension::sidebar_toggle),
           629 => test_get_errors!(super::history::sidebar_toggle),
           630 => test_get_errors!(super::sidebar::addon_icon_click),
           631 => test_get_errors!(super::sidebar::bookmarks_icon_click),
           632 => test_get_errors!(super::sidebar::chatbot_icon_click),
           634 => test_get_errors!(super::sidebar::expand),
           635 => test_get_errors!(super::sidebar::history_icon_click),
           638 => test_get_errors!(super::sidebar::resize),
           640 => test_get_errors!(super::sidebar::synced_tabs_icon_click),
           643 => test_get_errors!(super::sidebar_customize::bookmarks_enabled),
           644 => test_get_errors!(super::sidebar_customize::chatbot_enabled),
           645 => test_get_errors!(super::sidebar_customize::extensions_clicked),
           646 => test_get_errors!(super::sidebar_customize::firefox_settings_clicked),
           647 => test_get_errors!(super::sidebar_customize::history_enabled),
           648 => test_get_errors!(super::sidebar_customize::icon_click),
           649 => test_get_errors!(super::sidebar_customize::panel_toggle),
           650 => test_get_errors!(super::sidebar_customize::sidebar_display),
           651 => test_get_errors!(super::sidebar_customize::sidebar_position),
           652 => test_get_errors!(super::sidebar_customize::synced_tabs_enabled),
           653 => test_get_errors!(super::sidebar_customize::tabs_display),
           654 => test_get_errors!(super::sidebar_customize::tabs_layout),
           655 => test_get_errors!(super::synced_tabs::sidebar_toggle),
           656 => test_get_errors!(super::synced_tabs::click_fxa_app_menu),
           657 => test_get_errors!(super::synced_tabs::click_fxa_avatar_menu),
           658 => test_get_errors!(super::synced_tabs::click_synced_tabs_sidebar),
           706 => test_get_errors!(super::urlbar::abandonment),
           707 => test_get_errors!(super::urlbar::engagement),
           708 => test_get_errors!(super::urlbar::exposure),
           709 => test_get_errors!(super::urlbar::fakespot_engagement),
           710 => test_get_errors!(super::urlbar::keyword_exposure),
           716 => test_get_errors!(super::urlbar::quick_suggest_contextual_opt_in),
           718 => test_get_errors!(super::addons_search_detection::etld_change_other),
           719 => test_get_errors!(super::addons_search_detection::etld_change_webrequest),
           727 => test_get_errors!(super::browser_usage::interaction),
           728 => test_get_errors!(super::homepage::preference_ignore),
           729 => test_get_errors!(super::installation::first_seen_full),
           730 => test_get_errors!(super::installation::first_seen_msix),
           731 => test_get_errors!(super::installation::first_seen_stub),
           743 => test_get_errors!(super::partner_link::attribution_abort),
           744 => test_get_errors!(super::partner_link::attribution_failure),
           745 => test_get_errors!(super::partner_link::attribution_success),
           746 => test_get_errors!(super::partner_link::click_newtab),
           747 => test_get_errors!(super::partner_link::click_urlbar),
           751 => test_get_errors!(super::devtools_main::activate_responsive_design),
           752 => test_get_errors!(super::devtools_main::activate_split_console),
           753 => test_get_errors!(super::devtools_main::add_breakpoint_debugger),
           754 => test_get_errors!(super::devtools_main::blackbox_debugger),
           755 => test_get_errors!(super::devtools_main::close_adbg_aboutdebugging),
           756 => test_get_errors!(super::devtools_main::close_tools),
           757 => test_get_errors!(super::devtools_main::connection_attempt_aboutdebugging),
           758 => test_get_errors!(super::devtools_main::continue_debugger),
           759 => test_get_errors!(super::devtools_main::deactivate_responsive_design),
           760 => test_get_errors!(super::devtools_main::deactivate_split_console),
           761 => test_get_errors!(super::devtools_main::device_added_aboutdebugging),
           762 => test_get_errors!(super::devtools_main::device_removed_aboutdebugging),
           763 => test_get_errors!(super::devtools_main::edit_html_inspector),
           764 => test_get_errors!(super::devtools_main::edit_resend_netmonitor),
           765 => test_get_errors!(super::devtools_main::edit_rule_ruleview),
           766 => test_get_errors!(super::devtools_main::enter_accessibility),
           767 => test_get_errors!(super::devtools_main::enter_application),
           768 => test_get_errors!(super::devtools_main::enter_dom),
           769 => test_get_errors!(super::devtools_main::enter_fake_tool4242),
           770 => test_get_errors!(super::devtools_main::enter_inspector),
           771 => test_get_errors!(super::devtools_main::enter_jsdebugger),
           772 => test_get_errors!(super::devtools_main::enter_memory),
           773 => test_get_errors!(super::devtools_main::enter_netmonitor),
           774 => test_get_errors!(super::devtools_main::enter_options),
           775 => test_get_errors!(super::devtools_main::enter_other),
           776 => test_get_errors!(super::devtools_main::enter_performance),
           777 => test_get_errors!(super::devtools_main::enter_storage),
           778 => test_get_errors!(super::devtools_main::enter_styleeditor),
           779 => test_get_errors!(super::devtools_main::enter_test_blank_panel),
           780 => test_get_errors!(super::devtools_main::enter_test_tool),
           781 => test_get_errors!(super::devtools_main::enter_test_tool1072208),
           782 => test_get_errors!(super::devtools_main::enter_testtool1),
           783 => test_get_errors!(super::devtools_main::enter_testtool2),
           784 => test_get_errors!(super::devtools_main::enter_webconsole),
           785 => test_get_errors!(super::devtools_main::enter_whatsnew),
           786 => test_get_errors!(super::devtools_main::execute_js_webconsole),
           787 => test_get_errors!(super::devtools_main::exit_accessibility),
           788 => test_get_errors!(super::devtools_main::exit_application),
           789 => test_get_errors!(super::devtools_main::exit_dom),
           790 => test_get_errors!(super::devtools_main::exit_fake_tool4242),
           791 => test_get_errors!(super::devtools_main::exit_inspector),
           792 => test_get_errors!(super::devtools_main::exit_jsdebugger),
           793 => test_get_errors!(super::devtools_main::exit_memory),
           794 => test_get_errors!(super::devtools_main::exit_netmonitor),
           795 => test_get_errors!(super::devtools_main::exit_options),
           796 => test_get_errors!(super::devtools_main::exit_other),
           797 => test_get_errors!(super::devtools_main::exit_performance),
           798 => test_get_errors!(super::devtools_main::exit_storage),
           799 => test_get_errors!(super::devtools_main::exit_styleeditor),
           800 => test_get_errors!(super::devtools_main::exit_test_blank_panel),
           801 => test_get_errors!(super::devtools_main::exit_test_tool),
           802 => test_get_errors!(super::devtools_main::exit_test_tool1072208),
           803 => test_get_errors!(super::devtools_main::exit_testtool1),
           804 => test_get_errors!(super::devtools_main::exit_testtool2),
           805 => test_get_errors!(super::devtools_main::exit_webconsole),
           806 => test_get_errors!(super::devtools_main::exit_whatsnew),
           807 => test_get_errors!(super::devtools_main::filters_changed_netmonitor),
           808 => test_get_errors!(super::devtools_main::filters_changed_webconsole),
           809 => test_get_errors!(super::devtools_main::inspect_aboutdebugging),
           810 => test_get_errors!(super::devtools_main::jump_to_definition_webconsole),
           811 => test_get_errors!(super::devtools_main::jump_to_source_webconsole),
           812 => test_get_errors!(super::devtools_main::object_expanded_webconsole),
           813 => test_get_errors!(super::devtools_main::open_adbg_aboutdebugging),
           814 => test_get_errors!(super::devtools_main::open_tools),
           815 => test_get_errors!(super::devtools_main::pause_debugger),
           816 => test_get_errors!(super::devtools_main::pause_on_exceptions_debugger),
           817 => test_get_errors!(super::devtools_main::persist_changed_netmonitor),
           818 => test_get_errors!(super::devtools_main::persist_changed_webconsole),
           819 => test_get_errors!(super::devtools_main::pretty_print_debugger),
           820 => test_get_errors!(super::devtools_main::remove_breakpoint_debugger),
           821 => test_get_errors!(super::devtools_main::reverse_search_webconsole),
           822 => test_get_errors!(super::devtools_main::runtime_added_aboutdebugging),
           823 => test_get_errors!(super::devtools_main::runtime_connected_aboutdebugging),
           824 => test_get_errors!(super::devtools_main::runtime_disconnected_aboutdebugging),
           825 => test_get_errors!(super::devtools_main::runtime_removed_aboutdebugging),
           826 => test_get_errors!(super::devtools_main::select_page_aboutdebugging),
           827 => test_get_errors!(super::devtools_main::select_page_application),
           828 => test_get_errors!(super::devtools_main::select_ws_frame_netmonitor),
           829 => test_get_errors!(super::devtools_main::show_profiler_aboutdebugging),
           830 => test_get_errors!(super::devtools_main::sidepanel_changed_inspector),
           831 => test_get_errors!(super::devtools_main::sidepanel_changed_netmonitor),
           832 => test_get_errors!(super::devtools_main::start_worker_application),
           833 => test_get_errors!(super::devtools_main::throttle_changed_netmonitor),
           834 => test_get_errors!(super::devtools_main::tool_timer_animationinspector),
           835 => test_get_errors!(super::devtools_main::tool_timer_changesview),
           836 => test_get_errors!(super::devtools_main::tool_timer_compatibilityview),
           837 => test_get_errors!(super::devtools_main::tool_timer_computedview),
           838 => test_get_errors!(super::devtools_main::tool_timer_fontinspector),
           839 => test_get_errors!(super::devtools_main::tool_timer_layoutview),
           840 => test_get_errors!(super::devtools_main::tool_timer_ruleview),
           841 => test_get_errors!(super::devtools_main::unregister_worker_application),
           842 => test_get_errors!(super::devtools_main::update_conn_prompt_aboutdebugging),
           3185 => test_get_errors!(super::mediadrm::eme_playback),
           3188 => test_get_errors!(super::hls::media_load),
           3197 => test_get_errors!(super::media_playback::first_frame_loaded),
           3199 => test_get_errors!(super::mfcdm::eme_playback),
           3200 => test_get_errors!(super::mfcdm::error),
           3244 => test_get_errors!(super::perf::page_load),
           3267 => test_get_errors!(super::dom_quota_try::error_step),
           3345 => test_get_errors!(super::avif::dav1d_get_picture_return_value),
           3366 => test_get_errors!(super::slow_script_warning::shown_browser),
           3367 => test_get_errors!(super::slow_script_warning::shown_content),
           3375 => test_get_errors!(super::zero_byte_load::load_css),
           3376 => test_get_errors!(super::zero_byte_load::load_dtd),
           3377 => test_get_errors!(super::zero_byte_load::load_ftl),
           3378 => test_get_errors!(super::zero_byte_load::load_html),
           3379 => test_get_errors!(super::zero_byte_load::load_js),
           3380 => test_get_errors!(super::zero_byte_load::load_json),
           3381 => test_get_errors!(super::zero_byte_load::load_others),
           3382 => test_get_errors!(super::zero_byte_load::load_png),
           3383 => test_get_errors!(super::zero_byte_load::load_properties),
           3384 => test_get_errors!(super::zero_byte_load::load_svg),
           3385 => test_get_errors!(super::zero_byte_load::load_xhtml),
           3386 => test_get_errors!(super::zero_byte_load::load_xml),
           3388 => test_get_errors!(super::network_dns::trr_confirmation_context),
           3441 => test_get_errors!(super::ysod::shown_ysod),
           3474 => test_get_errors!(super::uptake_remotecontent_result::uptake_normandy),
           3475 => test_get_errors!(super::uptake_remotecontent_result::uptake_remotesettings),
           3478 => test_get_errors!(super::fxa::connect_account),
           3479 => test_get_errors!(super::fxa::disconnect_account),
           3480 => test_get_errors!(super::fxa_app_menu::click_account_settings),
           3481 => test_get_errors!(super::fxa_app_menu::click_cad),
           3482 => test_get_errors!(super::fxa_app_menu::click_login),
           3483 => test_get_errors!(super::fxa_app_menu::click_monitor_cta),
           3484 => test_get_errors!(super::fxa_app_menu::click_open_monitor),
           3485 => test_get_errors!(super::fxa_app_menu::click_open_send),
           3486 => test_get_errors!(super::fxa_app_menu::click_relay_cta),
           3487 => test_get_errors!(super::fxa_app_menu::click_send_tab),
           3488 => test_get_errors!(super::fxa_app_menu::click_sync_cta),
           3489 => test_get_errors!(super::fxa_app_menu::click_sync_now),
           3490 => test_get_errors!(super::fxa_app_menu::click_sync_settings),
           3491 => test_get_errors!(super::fxa_app_menu::click_sync_tabs),
           3492 => test_get_errors!(super::fxa_app_menu::click_sync_tabs_sidebar),
           3493 => test_get_errors!(super::fxa_app_menu::click_toolbar_icon),
           3494 => test_get_errors!(super::fxa_app_menu::click_unver_sync_settings),
           3495 => test_get_errors!(super::fxa_app_menu::click_vpn_cta),
           3496 => test_get_errors!(super::fxa_avatar_menu::click_account_settings),
           3497 => test_get_errors!(super::fxa_avatar_menu::click_cad),
           3498 => test_get_errors!(super::fxa_avatar_menu::click_login),
           3499 => test_get_errors!(super::fxa_avatar_menu::click_monitor_cta),
           3500 => test_get_errors!(super::fxa_avatar_menu::click_open_monitor),
           3501 => test_get_errors!(super::fxa_avatar_menu::click_open_send),
           3502 => test_get_errors!(super::fxa_avatar_menu::click_relay_cta),
           3503 => test_get_errors!(super::fxa_avatar_menu::click_send_tab),
           3504 => test_get_errors!(super::fxa_avatar_menu::click_sync_cta),
           3505 => test_get_errors!(super::fxa_avatar_menu::click_sync_now),
           3506 => test_get_errors!(super::fxa_avatar_menu::click_sync_settings),
           3507 => test_get_errors!(super::fxa_avatar_menu::click_sync_tabs),
           3508 => test_get_errors!(super::fxa_avatar_menu::click_sync_tabs_sidebar),
           3509 => test_get_errors!(super::fxa_avatar_menu::click_toolbar_icon),
           3510 => test_get_errors!(super::fxa_avatar_menu::click_unver_sync_settings),
           3511 => test_get_errors!(super::fxa_avatar_menu::click_vpn_cta),
           3514 => test_get_errors!(super::bounce_tracking_protection::purge_action),
           3523 => test_get_errors!(super::background_tasks_rmdir_base::metric_base),
           3531 => test_get_errors!(super::background_tasks_rmdir_http_cache::metric_base),
           3539 => test_get_errors!(super::background_tasks_rmdir_quota::metric_base),
           3547 => test_get_errors!(super::relevancy_classify::fail),
           3548 => test_get_errors!(super::relevancy_classify::succeed),
           3551 => test_get_errors!(super::cookie_banners::google_gdpr_choice_cookie_event),
           3552 => test_get_errors!(super::cookie_banners::google_gdpr_choice_cookie_event_pbm),
           3555 => test_get_errors!(super::cookie_banners::reload),
           3633 => test_get_errors!(super::extensions_data::migrate_result),
           3634 => test_get_errors!(super::extensions_data::storage_local_error),
           3635 => test_get_errors!(super::extensions_data::sync_usage_quotas),
           3644 => test_get_errors!(super::address::add_manage),
           3645 => test_get_errors!(super::address::cancel_capture_doorhanger),
           3646 => test_get_errors!(super::address::cancel_edit_doorhanger),
           3647 => test_get_errors!(super::address::cancel_update_doorhanger),
           3648 => test_get_errors!(super::address::cleared_address_form),
           3649 => test_get_errors!(super::address::delete_manage),
           3650 => test_get_errors!(super::address::detected_address_form),
           3651 => test_get_errors!(super::address::detected_address_form_ext),
           3652 => test_get_errors!(super::address::disable_capture_doorhanger),
           3653 => test_get_errors!(super::address::disable_edit_doorhanger),
           3654 => test_get_errors!(super::address::disable_update_doorhanger),
           3655 => test_get_errors!(super::address::edit_manage),
           3656 => test_get_errors!(super::address::filled_address_form),
           3657 => test_get_errors!(super::address::filled_address_form_ext),
           3658 => test_get_errors!(super::address::filled_modified_address_form),
           3659 => test_get_errors!(super::address::learn_more_capture_doorhanger),
           3660 => test_get_errors!(super::address::learn_more_edit_doorhanger),
           3661 => test_get_errors!(super::address::learn_more_update_doorhanger),
           3662 => test_get_errors!(super::address::popup_shown_address_form),
           3663 => test_get_errors!(super::address::pref_capture_doorhanger),
           3664 => test_get_errors!(super::address::pref_edit_doorhanger),
           3665 => test_get_errors!(super::address::pref_update_doorhanger),
           3666 => test_get_errors!(super::address::save_capture_doorhanger),
           3667 => test_get_errors!(super::address::save_edit_doorhanger),
           3668 => test_get_errors!(super::address::save_update_doorhanger),
           3669 => test_get_errors!(super::address::show_capture_doorhanger),
           3670 => test_get_errors!(super::address::show_edit_doorhanger),
           3671 => test_get_errors!(super::address::show_entry_manage),
           3672 => test_get_errors!(super::address::show_manage),
           3673 => test_get_errors!(super::address::show_update_doorhanger),
           3674 => test_get_errors!(super::address::submitted_address_form),
           3675 => test_get_errors!(super::address::submitted_address_form_ext),
           3676 => test_get_errors!(super::address::update_capture_doorhanger),
           3677 => test_get_errors!(super::address::update_edit_doorhanger),
           3678 => test_get_errors!(super::address::update_update_doorhanger),
           3679 => test_get_errors!(super::creditcard::add_manage),
           3680 => test_get_errors!(super::creditcard::cancel_capture_doorhanger),
           3681 => test_get_errors!(super::creditcard::cancel_update_doorhanger),
           3682 => test_get_errors!(super::creditcard::cleared_cc_form_v2),
           3683 => test_get_errors!(super::creditcard::delete_manage),
           3684 => test_get_errors!(super::creditcard::detected_cc_form_v2),
           3685 => test_get_errors!(super::creditcard::disable_capture_doorhanger),
           3686 => test_get_errors!(super::creditcard::disable_update_doorhanger),
           3687 => test_get_errors!(super::creditcard::edit_manage),
           3688 => test_get_errors!(super::creditcard::filled_cc_form_v2),
           3689 => test_get_errors!(super::creditcard::filled_modified_cc_form_v2),
           3690 => test_get_errors!(super::creditcard::popup_shown_cc_form_v2),
           3691 => test_get_errors!(super::creditcard::save_capture_doorhanger),
           3692 => test_get_errors!(super::creditcard::save_update_doorhanger),
           3693 => test_get_errors!(super::creditcard::show_capture_doorhanger),
           3694 => test_get_errors!(super::creditcard::show_entry_manage),
           3695 => test_get_errors!(super::creditcard::show_manage),
           3696 => test_get_errors!(super::creditcard::show_update_doorhanger),
           3697 => test_get_errors!(super::creditcard::submitted_cc_form_v2),
           3698 => test_get_errors!(super::creditcard::update_capture_doorhanger),
           3699 => test_get_errors!(super::creditcard::update_update_doorhanger),
           3701 => test_get_errors!(super::formautofill::iframe_layout_detection),
           3703 => test_get_errors!(super::formautofill_creditcards::form_cleared),
           3704 => test_get_errors!(super::formautofill_creditcards::form_detected),
           3705 => test_get_errors!(super::formautofill_creditcards::form_filled),
           3706 => test_get_errors!(super::formautofill_creditcards::form_filled_modified),
           3707 => test_get_errors!(super::formautofill_creditcards::form_popup_shown),
           3708 => test_get_errors!(super::formautofill_creditcards::form_submitted),
           3758 => test_get_errors!(super::test_only_ipc::an_event),
           3763 => test_get_errors!(super::test_only_ipc::event_with_extra),
           3765 => test_get_errors!(super::test_only_ipc::no_extra_event),
           3768 => test_get_errors!(super::test_only_jog::an_event),
           3769 => test_get_errors!(super::messaging_experiments::reach_cfr),
           3770 => test_get_errors!(super::messaging_experiments::reach_feature_callout),
           3771 => test_get_errors!(super::messaging_experiments::reach_fxms_bmb_button),
           3772 => test_get_errors!(super::messaging_experiments::reach_fxms_message_1),
           3773 => test_get_errors!(super::messaging_experiments::reach_fxms_message_10),
           3774 => test_get_errors!(super::messaging_experiments::reach_fxms_message_11),
           3775 => test_get_errors!(super::messaging_experiments::reach_fxms_message_2),
           3776 => test_get_errors!(super::messaging_experiments::reach_fxms_message_3),
           3777 => test_get_errors!(super::messaging_experiments::reach_fxms_message_4),
           3778 => test_get_errors!(super::messaging_experiments::reach_fxms_message_5),
           3779 => test_get_errors!(super::messaging_experiments::reach_fxms_message_6),
           3780 => test_get_errors!(super::messaging_experiments::reach_fxms_message_7),
           3781 => test_get_errors!(super::messaging_experiments::reach_fxms_message_8),
           3782 => test_get_errors!(super::messaging_experiments::reach_fxms_message_9),
           3783 => test_get_errors!(super::messaging_experiments::reach_infobar),
           3784 => test_get_errors!(super::messaging_experiments::reach_moments_page),
           3785 => test_get_errors!(super::messaging_experiments::reach_spotlight),
           3786 => test_get_errors!(super::messaging_experiments::targeting_attribute_error),
           3787 => test_get_errors!(super::messaging_experiments::targeting_attribute_timeout),
           3788 => test_get_errors!(super::nimbus_events::enroll_failed),
           3789 => test_get_errors!(super::nimbus_events::enrollment),
           3790 => test_get_errors!(super::nimbus_events::enrollment_status),
           3791 => test_get_errors!(super::nimbus_events::exposure),
           3792 => test_get_errors!(super::nimbus_events::is_ready),
           3793 => test_get_errors!(super::nimbus_events::unenroll_failed),
           3794 => test_get_errors!(super::nimbus_events::unenrollment),
           3795 => test_get_errors!(super::nimbus_events::validation_failed),
           3796 => test_get_errors!(super::normandy::expose_nimbus_experiment),
           3797 => test_get_errors!(super::normandy::enroll_addon_rollout),
           3798 => test_get_errors!(super::normandy::enroll_addon_study),
           3799 => test_get_errors!(super::normandy::enroll_failed_addon_rollout),
           3800 => test_get_errors!(super::normandy::enroll_failed_addon_study),
           3801 => test_get_errors!(super::normandy::enroll_failed_nimbus_experiment),
           3802 => test_get_errors!(super::normandy::enroll_failed_preference_rollout),
           3803 => test_get_errors!(super::normandy::enroll_failed_preference_study),
           3804 => test_get_errors!(super::normandy::enroll_nimbus_experiment),
           3805 => test_get_errors!(super::normandy::enroll_preference_rollout),
           3806 => test_get_errors!(super::normandy::enroll_preference_study),
           3807 => test_get_errors!(super::normandy::exp_pref_changed_preference_study),
           3808 => test_get_errors!(super::normandy::graduate_preference_rollout),
           3809 => test_get_errors!(super::normandy::unenroll_addon_rollback),
           3810 => test_get_errors!(super::normandy::unenroll_addon_study),
           3811 => test_get_errors!(super::normandy::unenroll_failed_addon_rollback),
           3812 => test_get_errors!(super::normandy::unenroll_failed_nimbus_experiment),
           3813 => test_get_errors!(super::normandy::unenroll_failed_preference_rollback),
           3814 => test_get_errors!(super::normandy::unenroll_failed_preference_study),
           3815 => test_get_errors!(super::normandy::unenroll_nimbus_experiment),
           3816 => test_get_errors!(super::normandy::unenroll_preference_rollback),
           3817 => test_get_errors!(super::normandy::unenroll_preference_study),
           3818 => test_get_errors!(super::normandy::update_addon_rollout),
           3819 => test_get_errors!(super::normandy::update_addon_study),
           3820 => test_get_errors!(super::normandy::update_failed_addon_rollout),
           3821 => test_get_errors!(super::normandy::update_failed_addon_study),
           3822 => test_get_errors!(super::normandy::update_nimbus_experiment),
           3823 => test_get_errors!(super::normandy::update_preference_rollout),
           3824 => test_get_errors!(super::normandy::validation_failed_nimbus_experiment),
           3825 => test_get_errors!(super::form_autocomplete::show_logins),
           3826 => test_get_errors!(super::pwmgr::autocomplete_field_generatedpassword),
           3827 => test_get_errors!(super::pwmgr::autocomplete_shown_generatedpassword),
           3828 => test_get_errors!(super::pwmgr::cancel_existing_login),
           3829 => test_get_errors!(super::pwmgr::cancel_new_login),
           3830 => test_get_errors!(super::pwmgr::copy_password),
           3831 => test_get_errors!(super::pwmgr::copy_username),
           3832 => test_get_errors!(super::pwmgr::delete_existing_login),
           3833 => test_get_errors!(super::pwmgr::delete_new_login),
           3834 => test_get_errors!(super::pwmgr::doorhanger_submitted_save),
           3835 => test_get_errors!(super::pwmgr::doorhanger_submitted_update),
           3836 => test_get_errors!(super::pwmgr::edit_existing_login),
           3837 => test_get_errors!(super::pwmgr::filled_field_edited_generatedpassword),
           3838 => test_get_errors!(super::pwmgr::filter_list),
           3840 => test_get_errors!(super::pwmgr::hide_password),
           3841 => test_get_errors!(super::pwmgr::learn_more_vuln_existing_login),
           3842 => test_get_errors!(super::pwmgr::mgmt_menu_item_used_export),
           3843 => test_get_errors!(super::pwmgr::mgmt_menu_item_used_export_complete),
           3844 => test_get_errors!(super::pwmgr::mgmt_menu_item_used_import_csv_complete),
           3845 => test_get_errors!(super::pwmgr::mgmt_menu_item_used_import_from_browser),
           3846 => test_get_errors!(super::pwmgr::mgmt_menu_item_used_import_from_csv),
           3847 => test_get_errors!(super::pwmgr::mgmt_menu_item_used_preferences),
           3848 => test_get_errors!(super::pwmgr::new_new_login),
           3849 => test_get_errors!(super::pwmgr::open_management_aboutprotections),
           3850 => test_get_errors!(super::pwmgr::open_management_autocomplete),
           3851 => test_get_errors!(super::pwmgr::open_management_contextmenu),
           3852 => test_get_errors!(super::pwmgr::open_management_direct),
           3853 => test_get_errors!(super::pwmgr::open_management_mainmenu),
           3854 => test_get_errors!(super::pwmgr::open_management_pageinfo),
           3855 => test_get_errors!(super::pwmgr::open_management_preferences),
           3856 => test_get_errors!(super::pwmgr::open_management_snippet),
           3857 => test_get_errors!(super::pwmgr::open_site_existing_login),
           3859 => test_get_errors!(super::pwmgr::reauthenticate_master_password),
           3860 => test_get_errors!(super::pwmgr::reauthenticate_os_auth),
           3861 => test_get_errors!(super::pwmgr::save_existing_login),
           3862 => test_get_errors!(super::pwmgr::save_new_login),
           3863 => test_get_errors!(super::pwmgr::saved_login_used_auth_login),
           3864 => test_get_errors!(super::pwmgr::saved_login_used_form_login),
           3865 => test_get_errors!(super::pwmgr::saved_login_used_form_password),
           3866 => test_get_errors!(super::pwmgr::saved_login_used_prompt_login),
           3867 => test_get_errors!(super::pwmgr::select_existing_login),
           3868 => test_get_errors!(super::pwmgr::show_password),
           3869 => test_get_errors!(super::pwmgr::sort_list),
           3870 => test_get_errors!(super::relay_integration::clicked_fill_username),
           3871 => test_get_errors!(super::relay_integration::clicked_offer_relay),
           3872 => test_get_errors!(super::relay_integration::disabled_opt_in_panel),
           3873 => test_get_errors!(super::relay_integration::disabled_pref_change),
           3874 => test_get_errors!(super::relay_integration::enabled_opt_in_panel),
           3875 => test_get_errors!(super::relay_integration::enabled_pref_change),
           3876 => test_get_errors!(super::relay_integration::get_unlimited_masks_reuse_panel),
           3877 => test_get_errors!(super::relay_integration::postponed_opt_in_panel),
           3878 => test_get_errors!(super::relay_integration::reuse_mask_reuse_panel),
           3879 => test_get_errors!(super::relay_integration::shown_fill_username),
           3880 => test_get_errors!(super::relay_integration::shown_offer_relay),
           3881 => test_get_errors!(super::relay_integration::shown_opt_in_panel),
           3882 => test_get_errors!(super::relay_integration::shown_reuse_panel),
           3901 => test_get_errors!(super::pdfjs_image::add_image_click),
           3904 => test_get_errors!(super::pdfjs_image::icon_click),
           3905 => test_get_errors!(super::pdfjs_image::image_added),
           3906 => test_get_errors!(super::pdfjs_image::image_selected),
           3907 => test_get_errors!(super::pdfjs_image_alt_text::ai_generation_check),
           3908 => test_get_errors!(super::pdfjs_image_alt_text::callout_dismissed),
           3909 => test_get_errors!(super::pdfjs_image_alt_text::callout_displayed),
           3910 => test_get_errors!(super::pdfjs_image_alt_text::dismiss),
           3911 => test_get_errors!(super::pdfjs_image_alt_text::image_status_label_clicked),
           3912 => test_get_errors!(super::pdfjs_image_alt_text::image_status_label_displayed),
           3913 => test_get_errors!(super::pdfjs_image_alt_text::info),
           3914 => test_get_errors!(super::pdfjs_image_alt_text::model_deleted),
           3915 => test_get_errors!(super::pdfjs_image_alt_text::model_download_complete),
           3916 => test_get_errors!(super::pdfjs_image_alt_text::model_download_error),
           3917 => test_get_errors!(super::pdfjs_image_alt_text::model_download_start),
           3918 => test_get_errors!(super::pdfjs_image_alt_text::model_result),
           3919 => test_get_errors!(super::pdfjs_image_alt_text::save),
           3920 => test_get_errors!(super::pdfjs_image_alt_text::settings_ai_generation_check),
           3921 => test_get_errors!(super::pdfjs_image_alt_text::settings_displayed),
           3922 => test_get_errors!(super::pdfjs_image_alt_text::settings_edit_alt_text_check),
           3923 => test_get_errors!(super::pdfjs_image_alt_text::user_edit),
           3924 => test_get_errors!(super::pictureinpicture::closed_method_browser_crash),
           3925 => test_get_errors!(super::pictureinpicture::closed_method_close_button),
           3926 => test_get_errors!(super::pictureinpicture::closed_method_close_player_shortcut),
           3927 => test_get_errors!(super::pictureinpicture::closed_method_context_menu),
           3928 => test_get_errors!(super::pictureinpicture::closed_method_foregrounded),
           3929 => test_get_errors!(super::pictureinpicture::closed_method_fullscreen),
           3930 => test_get_errors!(super::pictureinpicture::closed_method_pagehide),
           3931 => test_get_errors!(super::pictureinpicture::closed_method_setup_failure),
           3932 => test_get_errors!(super::pictureinpicture::closed_method_shortcut),
           3933 => test_get_errors!(super::pictureinpicture::closed_method_unpip),
           3934 => test_get_errors!(super::pictureinpicture::closed_method_url_bar),
           3935 => test_get_errors!(super::pictureinpicture::closed_method_video_el_emptied),
           3936 => test_get_errors!(super::pictureinpicture::closed_method_video_el_remove),
           3937 => test_get_errors!(super::pictureinpicture::create_player),
           3938 => test_get_errors!(super::pictureinpicture::disrespect_disable_url_bar),
           3939 => test_get_errors!(super::pictureinpicture::fullscreen_player),
           3941 => test_get_errors!(super::pictureinpicture::opened_method_auto_pip),
           3942 => test_get_errors!(super::pictureinpicture::opened_method_context_menu),
           3943 => test_get_errors!(super::pictureinpicture::opened_method_shortcut),
           3944 => test_get_errors!(super::pictureinpicture::opened_method_toggle),
           3945 => test_get_errors!(super::pictureinpicture::opened_method_url_bar),
           3946 => test_get_errors!(super::pictureinpicture::resize_player),
           3947 => test_get_errors!(super::pictureinpicture::saw_toggle_toggle),
           3948 => test_get_errors!(super::pictureinpicture::subtitles_shown_subtitles),
           3950 => test_get_errors!(super::pictureinpicture_settings::disable_player),
           3951 => test_get_errors!(super::pictureinpicture_settings::disable_settings),
           3952 => test_get_errors!(super::pictureinpicture_settings::enable_autotrigger_settings),
           3953 => test_get_errors!(super::pictureinpicture_settings::enable_settings),
           3989 => test_get_errors!(super::readermode::button_click),
           3990 => test_get_errors!(super::readermode::view_off),
           3991 => test_get_errors!(super::readermode::view_on),
           4028 => test_get_errors!(super::webcompatreporting::opened),
           4029 => test_get_errors!(super::webcompatreporting::reason_dropdown),
           4030 => test_get_errors!(super::webcompatreporting::send),
           4031 => test_get_errors!(super::webcompatreporting::send_more_info),
           4227 => test_get_errors!(super::search_engine_default::changed),
           4233 => test_get_errors!(super::search_engine_private::changed),
           4241 => test_get_errors!(super::shopping_product::invalid_ohttp_config),
           4242 => test_get_errors!(super::shopping_product::invalid_request),
           4243 => test_get_errors!(super::shopping_product::invalid_response),
           4244 => test_get_errors!(super::shopping_product::request_aborted),
           4245 => test_get_errors!(super::shopping_product::request_error),
           4246 => test_get_errors!(super::shopping_product::request_failure),
           4247 => test_get_errors!(super::shopping_product::request_retried),
           4248 => test_get_errors!(super::shopping_product::request_retries_failed),
           4249 => test_get_errors!(super::shopping_product::server_failure),
           4253 => test_get_errors!(super::telemetry_test::test1_object1),
           4254 => test_get_errors!(super::telemetry_test::test2_object1),
           4255 => test_get_errors!(super::telemetry_test::test2_object2),
           4256 => test_get_errors!(super::translations::error),
           4260 => test_get_errors!(super::translations::restore_page),
           4261 => test_get_errors!(super::translations::translation_request),
           4262 => test_get_errors!(super::translations_panel::about_translations),
           4263 => test_get_errors!(super::translations_panel::always_offer_translations),
           4264 => test_get_errors!(super::translations_panel::always_translate_language),
           4265 => test_get_errors!(super::translations_panel::cancel_button),
           4266 => test_get_errors!(super::translations_panel::change_from_language),
           4267 => test_get_errors!(super::translations_panel::change_source_language_button),
           4268 => test_get_errors!(super::translations_panel::change_to_language),
           4269 => test_get_errors!(super::translations_panel::close),
           4270 => test_get_errors!(super::translations_panel::close_from_language_menu),
           4271 => test_get_errors!(super::translations_panel::close_settings_menu),
           4272 => test_get_errors!(super::translations_panel::close_to_language_menu),
           4273 => test_get_errors!(super::translations_panel::dismiss_error_button),
           4274 => test_get_errors!(super::translations_panel::learn_more),
           4275 => test_get_errors!(super::translations_panel::manage_languages),
           4276 => test_get_errors!(super::translations_panel::never_translate_language),
           4277 => test_get_errors!(super::translations_panel::never_translate_site),
           4278 => test_get_errors!(super::translations_panel::open),
           4279 => test_get_errors!(super::translations_panel::open_from_language_menu),
           4280 => test_get_errors!(super::translations_panel::open_settings_menu),
           4281 => test_get_errors!(super::translations_panel::open_to_language_menu),
           4282 => test_get_errors!(super::translations_panel::restore_page_button),
           4283 => test_get_errors!(super::translations_panel::translate_button),
           4284 => test_get_errors!(super::translations_select_translations_panel::about_translations),
           4285 => test_get_errors!(super::translations_select_translations_panel::cancel_button),
           4286 => test_get_errors!(super::translations_select_translations_panel::change_from_language),
           4287 => test_get_errors!(super::translations_select_translations_panel::change_to_language),
           4288 => test_get_errors!(super::translations_select_translations_panel::close),
           4289 => test_get_errors!(super::translations_select_translations_panel::copy_button),
           4290 => test_get_errors!(super::translations_select_translations_panel::done_button),
           4291 => test_get_errors!(super::translations_select_translations_panel::initialization_failure_message),
           4292 => test_get_errors!(super::translations_select_translations_panel::open),
           4293 => test_get_errors!(super::translations_select_translations_panel::open_settings_menu),
           4294 => test_get_errors!(super::translations_select_translations_panel::translate_button),
           4295 => test_get_errors!(super::translations_select_translations_panel::translate_full_page_button),
           4296 => test_get_errors!(super::translations_select_translations_panel::translation_failure_message),
           4297 => test_get_errors!(super::translations_select_translations_panel::translation_settings),
           4298 => test_get_errors!(super::translations_select_translations_panel::try_again_button),
           4299 => test_get_errors!(super::translations_select_translations_panel::unsupported_language_message),
           4307 => test_get_errors!(super::security_doh_neterror::click_add_exception_button),
           4308 => test_get_errors!(super::security_doh_neterror::click_continue_button),
           4309 => test_get_errors!(super::security_doh_neterror::click_disable_warning),
           4310 => test_get_errors!(super::security_doh_neterror::click_learn_more_link),
           4311 => test_get_errors!(super::security_doh_neterror::click_settings_button),
           4312 => test_get_errors!(super::security_doh_neterror::click_try_again_button),
           4313 => test_get_errors!(super::security_doh_neterror::load_dohwarning),
           4314 => test_get_errors!(super::security_ui_certerror::click_advanced_button),
           4315 => test_get_errors!(super::security_ui_certerror::click_auto_report_cb),
           4316 => test_get_errors!(super::security_ui_certerror::click_clipboard_button_bot),
           4317 => test_get_errors!(super::security_ui_certerror::click_clipboard_button_top),
           4318 => test_get_errors!(super::security_ui_certerror::click_error_code_link),
           4319 => test_get_errors!(super::security_ui_certerror::click_exception_button),
           4320 => test_get_errors!(super::security_ui_certerror::click_learn_more_link),
           4321 => test_get_errors!(super::security_ui_certerror::click_return_button_adv),
           4322 => test_get_errors!(super::security_ui_certerror::click_return_button_top),
           4323 => test_get_errors!(super::security_ui_certerror::load_aboutcerterror),
           4324 => test_get_errors!(super::security_ui_tlserror::load_abouttlserror),
           4330 => test_get_errors!(super::jsonfile::load_autofillprofiles),
           4331 => test_get_errors!(super::jsonfile::load_logins),
           4332 => test_get_errors!(super::service_request::bypass_proxy_info),
           4341 => test_get_errors!(super::addons_manager::install),
           4342 => test_get_errors!(super::addons_manager::install_stats),
           4343 => test_get_errors!(super::addons_manager::manage),
           4344 => test_get_errors!(super::addons_manager::report_suspicious_site),
           4345 => test_get_errors!(super::addons_manager::update),
           4346 => test_get_errors!(super::addons_manager::disable_dictionary),
           4347 => test_get_errors!(super::addons_manager::disable_extension),
           4348 => test_get_errors!(super::addons_manager::disable_locale),
           4349 => test_get_errors!(super::addons_manager::disable_other),
           4350 => test_get_errors!(super::addons_manager::disable_siteperm_deprecated),
           4351 => test_get_errors!(super::addons_manager::disable_sitepermission),
           4352 => test_get_errors!(super::addons_manager::disable_theme),
           4353 => test_get_errors!(super::addons_manager::disable_unknown),
           4354 => test_get_errors!(super::addons_manager::enable_dictionary),
           4355 => test_get_errors!(super::addons_manager::enable_extension),
           4356 => test_get_errors!(super::addons_manager::enable_locale),
           4357 => test_get_errors!(super::addons_manager::enable_other),
           4358 => test_get_errors!(super::addons_manager::enable_siteperm_deprecated),
           4359 => test_get_errors!(super::addons_manager::enable_sitepermission),
           4360 => test_get_errors!(super::addons_manager::enable_theme),
           4361 => test_get_errors!(super::addons_manager::enable_unknown),
           4362 => test_get_errors!(super::addons_manager::install_dictionary),
           4363 => test_get_errors!(super::addons_manager::install_extension),
           4364 => test_get_errors!(super::addons_manager::install_locale),
           4365 => test_get_errors!(super::addons_manager::install_other),
           4366 => test_get_errors!(super::addons_manager::install_siteperm_deprecated),
           4367 => test_get_errors!(super::addons_manager::install_sitepermission),
           4368 => test_get_errors!(super::addons_manager::install_stats_dictionary),
           4369 => test_get_errors!(super::addons_manager::install_stats_extension),
           4370 => test_get_errors!(super::addons_manager::install_stats_locale),
           4371 => test_get_errors!(super::addons_manager::install_stats_other),
           4372 => test_get_errors!(super::addons_manager::install_stats_siteperm_deprecated),
           4373 => test_get_errors!(super::addons_manager::install_stats_sitepermission),
           4374 => test_get_errors!(super::addons_manager::install_stats_theme),
           4375 => test_get_errors!(super::addons_manager::install_stats_unknown),
           4376 => test_get_errors!(super::addons_manager::install_theme),
           4377 => test_get_errors!(super::addons_manager::install_unknown),
           4378 => test_get_errors!(super::addons_manager::sideload_prompt_dictionary),
           4379 => test_get_errors!(super::addons_manager::sideload_prompt_extension),
           4380 => test_get_errors!(super::addons_manager::sideload_prompt_locale),
           4381 => test_get_errors!(super::addons_manager::sideload_prompt_other),
           4382 => test_get_errors!(super::addons_manager::sideload_prompt_siteperm_deprecated),
           4383 => test_get_errors!(super::addons_manager::sideload_prompt_sitepermission),
           4384 => test_get_errors!(super::addons_manager::sideload_prompt_theme),
           4385 => test_get_errors!(super::addons_manager::sideload_prompt_unknown),
           4386 => test_get_errors!(super::addons_manager::uninstall_dictionary),
           4387 => test_get_errors!(super::addons_manager::uninstall_extension),
           4388 => test_get_errors!(super::addons_manager::uninstall_locale),
           4389 => test_get_errors!(super::addons_manager::uninstall_other),
           4390 => test_get_errors!(super::addons_manager::uninstall_siteperm_deprecated),
           4391 => test_get_errors!(super::addons_manager::uninstall_sitepermission),
           4392 => test_get_errors!(super::addons_manager::uninstall_theme),
           4393 => test_get_errors!(super::addons_manager::uninstall_unknown),
           4394 => test_get_errors!(super::addons_manager::update_dictionary),
           4395 => test_get_errors!(super::addons_manager::update_extension),
           4396 => test_get_errors!(super::addons_manager::update_locale),
           4397 => test_get_errors!(super::addons_manager::update_other),
           4398 => test_get_errors!(super::addons_manager::update_siteperm_deprecated),
           4399 => test_get_errors!(super::addons_manager::update_sitepermission),
           4400 => test_get_errors!(super::addons_manager::update_theme),
           4401 => test_get_errors!(super::addons_manager::update_unknown),
           4402 => test_get_errors!(super::blocklist::addon_block_change),
           4432 => test_get_errors!(super::file_dialog::fallback_v2_1),
           4433 => test_get_errors!(super::memory_watcher::on_high_memory_stats),
           _ => panic!("No event for metric id {}", metric_id),
        }

        #[cfg(not(feature = "with_gecko"))]
        {
            return None;
        }
    }

    /// Gets the submetric from the specified labeled_boolean metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label` - The label identifying the boolean submetric.
    ///
    /// # Returns
    ///
    /// Returns the boolean submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_boolean by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_boolean_get(metric_id: u32, label: &str) -> LabeledBooleanMetric {
        match metric_id {
            7 => super::a11y::theme.get(label),
            61 => super::networking::doh_heuristic_ever_tripped.get(label),
            247 => super::os_environment::is_default_handler.get(label),
            725 => super::browser_ui::mirror_for_toolbar_widgets.get(label),
            3179 => super::geolocation::linux_provider.get(label),
            3192 => super::media::video_hardware_decoding_support.get(label),
            3193 => super::media::video_hd_hardware_decoding_support.get(label),
            3196 => super::media_playback::device_hardware_decoder_support.get(label),
            3553 => super::cookie_banners::normal_window_service_mode.get(label),
            3554 => super::cookie_banners::private_window_service_mode.get(label),
            3733 => super::test_only::mabels_like_balloons.get(label),
            3734 => super::test_only::mabels_like_labeled_balloons.get(label),
            3738 => super::test_only::mirrors_for_labeled_bools.get(label),
            3761 => super::test_only_ipc::an_unordered_labeled_boolean.get(label),
            3903 => super::pdfjs_image::alt_text_edit.get(label),
            4426 => super::widget::ime_name_on_mac.get(label),
            4428 => super::widget::ime_name_on_linux.get(label),
            4430 => super::widget::ime_name_on_windows.get(label),
            4431 => super::widget::ime_name_on_windows_inserted_crlf.get(label),
            _ => panic!("No labeled_boolean for metric id {}", metric_id),
        }
    }

    /// Gets the submetric from the specified labeled_boolean metric, by enum.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label_enum` - The label enum identifying the boolean submetric.
    ///
    /// # Returns
    ///
    /// Returns the boolean submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_boolean by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_boolean_enum_get(metric_id: u32, label_enum: u16) -> LabeledBooleanMetric {
        match metric_id {
            7 => super::a11y::theme.get(labeled_enum_to_str(metric_id, label_enum)),
            3179 => super::geolocation::linux_provider.get(labeled_enum_to_str(metric_id, label_enum)),
            3196 => super::media_playback::device_hardware_decoder_support.get(labeled_enum_to_str(metric_id, label_enum)),
            3553 => super::cookie_banners::normal_window_service_mode.get(labeled_enum_to_str(metric_id, label_enum)),
            3554 => super::cookie_banners::private_window_service_mode.get(labeled_enum_to_str(metric_id, label_enum)),
            3734 => super::test_only::mabels_like_labeled_balloons.get(labeled_enum_to_str(metric_id, label_enum)),
            3903 => super::pdfjs_image::alt_text_edit.get(labeled_enum_to_str(metric_id, label_enum)),
            _ => panic!("No labeled_boolean for metric id {}", metric_id),
        }
    }
    /// Gets the submetric from the specified labeled_counter metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label` - The label identifying the counter submetric.
    ///
    /// # Returns
    ///
    /// Returns the counter submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_counter by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_counter_get(metric_id: u32, label: &str) -> LabeledCounterMetric {
        match metric_id {
            78 => super::networking::cookie_timestamp_fixed_count.get(label),
            81 => super::networking::dns_native_count.get(label),
            85 => super::networking::fetch_keepalive_discard_count.get(label),
            86 => super::networking::fetch_keepalive_request_count.get(label),
            103 => super::networking::http_3_ecn_path_capability.get(label),
            113 => super::networking::http_channel_disposition.get(label),
            114 => super::networking::http_channel_disposition_disabled_no_reason.get(label),
            115 => super::networking::http_channel_disposition_disabled_upgrade.get(label),
            116 => super::networking::http_channel_disposition_disabled_wont.get(label),
            117 => super::networking::http_channel_disposition_enabled_no_reason.get(label),
            118 => super::networking::http_channel_disposition_enabled_upgrade.get(label),
            119 => super::networking::http_channel_disposition_enabled_wont.get(label),
            120 => super::networking::http_channel_onstart_status.get(label),
            121 => super::networking::http_channel_onstart_success_https_rr.get(label),
            133 => super::networking::http_ip_addr_any_count.get(label),
            135 => super::networking::http_redirect_to_scheme_subresource.get(label),
            136 => super::networking::http_redirect_to_scheme_top_level.get(label),
            137 => super::networking::http_response_status_code.get(label),
            138 => super::networking::http_response_version.get(label),
            139 => super::networking::http_to_https_upgrade_reason.get(label),
            140 => super::networking::https_rr_presented.get(label),
            142 => super::networking::proxy_info_type.get(label),
            144 => super::networking::residual_cache_folder_removal.get(label),
            150 => super::networking::speculative_connect_outcome.get(label),
            156 => super::networking::trr_request_count.get(label),
            157 => super::networking::trr_request_count_per_conn.get(label),
            158 => super::networking::data_transferred_v3_kb.get(label),
            161 => super::networking::trr_connection_cycle_count.get(label),
            246 => super::os_environment::invoked_to_handle.get(label),
            252 => super::os_environment::launched_to_handle.get(label),
            264 => super::security::client_auth_cert_usage.get(label),
            285 => super::migration::discovered_migrators.get(label),
            357 => super::messaging_system::invalid_nested_data.get(label),
            363 => super::messaging_system::unknown_keys.get(label),
            373 => super::messaging_system_attribution::unknown_keys.get(label),
            435 => super::library::link.get(label),
            436 => super::library::opened.get(label),
            437 => super::library::search.get(label),
            486 => super::protocolhandler_mailto::handler_prompt_shown.get(label),
            487 => super::protocolhandler_mailto::prompt_clicked.get(label),
            512 => super::browser_engagement_navigation::about_home.get(label),
            513 => super::browser_engagement_navigation::about_newtab.get(label),
            514 => super::browser_engagement_navigation::contextmenu.get(label),
            515 => super::browser_engagement_navigation::searchbar.get(label),
            516 => super::browser_engagement_navigation::urlbar.get(label),
            517 => super::browser_engagement_navigation::urlbar_handoff.get(label),
            518 => super::browser_engagement_navigation::urlbar_persisted.get(label),
            519 => super::browser_engagement_navigation::urlbar_searchmode.get(label),
            520 => super::browser_engagement_navigation::webextension.get(label),
            521 => super::browser_search_adclicks::about_home.get(label),
            522 => super::browser_search_adclicks::about_newtab.get(label),
            523 => super::browser_search_adclicks::contextmenu.get(label),
            524 => super::browser_search_adclicks::reload.get(label),
            525 => super::browser_search_adclicks::searchbar.get(label),
            526 => super::browser_search_adclicks::system.get(label),
            527 => super::browser_search_adclicks::tabhistory.get(label),
            528 => super::browser_search_adclicks::unknown.get(label),
            529 => super::browser_search_adclicks::urlbar.get(label),
            530 => super::browser_search_adclicks::urlbar_handoff.get(label),
            531 => super::browser_search_adclicks::urlbar_persisted.get(label),
            532 => super::browser_search_adclicks::urlbar_searchmode.get(label),
            533 => super::browser_search_adclicks::webextension.get(label),
            534 => super::browser_search_content::about_home.get(label),
            535 => super::browser_search_content::about_newtab.get(label),
            536 => super::browser_search_content::contextmenu.get(label),
            537 => super::browser_search_content::reload.get(label),
            538 => super::browser_search_content::searchbar.get(label),
            539 => super::browser_search_content::system.get(label),
            540 => super::browser_search_content::tabhistory.get(label),
            541 => super::browser_search_content::unknown.get(label),
            542 => super::browser_search_content::urlbar.get(label),
            543 => super::browser_search_content::urlbar_handoff.get(label),
            544 => super::browser_search_content::urlbar_persisted.get(label),
            545 => super::browser_search_content::urlbar_searchmode.get(label),
            546 => super::browser_search_content::webextension.get(label),
            547 => super::browser_search_withads::about_home.get(label),
            548 => super::browser_search_withads::about_newtab.get(label),
            549 => super::browser_search_withads::contextmenu.get(label),
            550 => super::browser_search_withads::reload.get(label),
            551 => super::browser_search_withads::searchbar.get(label),
            552 => super::browser_search_withads::system.get(label),
            553 => super::browser_search_withads::tabhistory.get(label),
            554 => super::browser_search_withads::unknown.get(label),
            555 => super::browser_search_withads::urlbar.get(label),
            556 => super::browser_search_withads::urlbar_handoff.get(label),
            557 => super::browser_search_withads::urlbar_persisted.get(label),
            558 => super::browser_search_withads::urlbar_searchmode.get(label),
            559 => super::browser_search_withads::webextension.get(label),
            566 => super::serp::ads_blocked_count.get(label),
            573 => super::urlbar_searchmode::bookmarkmenu.get(label),
            574 => super::urlbar_searchmode::handoff.get(label),
            575 => super::urlbar_searchmode::historymenu.get(label),
            576 => super::urlbar_searchmode::keywordoffer.get(label),
            577 => super::urlbar_searchmode::oneoff.get(label),
            578 => super::urlbar_searchmode::other.get(label),
            579 => super::urlbar_searchmode::searchbutton.get(label),
            580 => super::urlbar_searchmode::shortcut.get(label),
            581 => super::urlbar_searchmode::tabmenu.get(label),
            582 => super::urlbar_searchmode::tabtosearch.get(label),
            583 => super::urlbar_searchmode::tabtosearch_onboard.get(label),
            584 => super::urlbar_searchmode::topsites_newtab.get(label),
            585 => super::urlbar_searchmode::topsites_urlbar.get(label),
            586 => super::urlbar_searchmode::touchbar.get(label),
            587 => super::urlbar_searchmode::typed.get(label),
            636 => super::sidebar::link.get(label),
            639 => super::sidebar::search.get(label),
            660 => super::browser_ui_interaction::all_tabs_panel_entrypoint.get(label),
            662 => super::browser_ui_interaction::app_menu.get(label),
            663 => super::browser_ui_interaction::bookmarks_bar.get(label),
            664 => super::browser_ui_interaction::content_context.get(label),
            665 => super::browser_ui_interaction::menu_bar.get(label),
            666 => super::browser_ui_interaction::nav_bar.get(label),
            667 => super::browser_ui_interaction::overflow_menu.get(label),
            668 => super::browser_ui_interaction::pageaction_panel.get(label),
            669 => super::browser_ui_interaction::pageaction_urlbar.get(label),
            670 => super::browser_ui_interaction::pinned_overflow_menu.get(label),
            671 => super::browser_ui_interaction::preferences_pane_containers.get(label),
            672 => super::browser_ui_interaction::preferences_pane_experimental.get(label),
            673 => super::browser_ui_interaction::preferences_pane_general.get(label),
            674 => super::browser_ui_interaction::preferences_pane_home.get(label),
            675 => super::browser_ui_interaction::preferences_pane_more_from_mozilla.get(label),
            676 => super::browser_ui_interaction::preferences_pane_privacy.get(label),
            677 => super::browser_ui_interaction::preferences_pane_search.get(label),
            678 => super::browser_ui_interaction::preferences_pane_search_results.get(label),
            679 => super::browser_ui_interaction::preferences_pane_sync.get(label),
            680 => super::browser_ui_interaction::preferences_pane_unknown.get(label),
            681 => super::browser_ui_interaction::tabs_bar.get(label),
            682 => super::browser_ui_interaction::tabs_context.get(label),
            683 => super::browser_ui_interaction::tabs_context_entrypoint.get(label),
            684 => super::browser_ui_interaction::unified_extensions_area.get(label),
            685 => super::browser_ui_interaction::vertical_tabs_container.get(label),
            686 => super::browser_ui_interaction::keyboard.get(label),
            704 => super::suggest_relevance::outcome.get(label),
            705 => super::suggest_relevance::status.get(label),
            724 => super::browser_ui::customized_widgets.get(label),
            3178 => super::geolocation::fallback.get(label),
            3180 => super::geolocation::request_result.get(label),
            3189 => super::gmp::update_xml_fetch_result.get(label),
            3190 => super::media::decode_error_per_mime_type.get(label),
            3194 => super::media_audio::backend.get(label),
            3195 => super::media_audio::init_failure.get(label),
            3198 => super::media_playback::not_supported_video_per_mime_type.get(label),
            3201 => super::codec_stats::audio_preferred_codec.get(label),
            3202 => super::codec_stats::other_fec_signaled.get(label),
            3203 => super::codec_stats::ulpfec_negotiated.get(label),
            3204 => super::codec_stats::video_preferred_codec.get(label),
            3218 => super::webrtc_video::recv_codec_used.get(label),
            3219 => super::webrtc_video::send_codec_used.get(label),
            3220 => super::webrtcdtls::cipher.get(label),
            3221 => super::webrtcdtls::client_handshake_result.get(label),
            3223 => super::webrtcdtls::protocol_version.get(label),
            3224 => super::webrtcdtls::server_handshake_result.get(label),
            3226 => super::webrtcdtls::srtp_cipher.get(label),
            3233 => super::dom_parentprocess::process_launch_errors.get(label),
            3262 => super::web_notification::permission_origin.get(label),
            3263 => super::web_notification::request_permission_origin.get(label),
            3264 => super::web_notification::show_origin.get(label),
            3266 => super::web_push::error_code.get(label),
            3276 => super::webauthn_create::authenticator_attachment.get(label),
            3280 => super::webauthn_get::authenticator_attachment.get(label),
            3307 => super::gfx_content_frame_time::reason.get(label),
            3319 => super::gpu_process::crash_fallbacks.get(label),
            3335 => super::avif::a1lx.get(label),
            3336 => super::avif::a1op.get(label),
            3337 => super::avif::alpha.get(label),
            3338 => super::avif::aom_decode_error.get(label),
            3339 => super::avif::bit_depth.get(label),
            3340 => super::avif::cicp_cp.get(label),
            3341 => super::avif::cicp_mc.get(label),
            3342 => super::avif::cicp_tc.get(label),
            3343 => super::avif::clap.get(label),
            3344 => super::avif::colr.get(label),
            3346 => super::avif::decode_result.get(label),
            3347 => super::avif::decoder.get(label),
            3348 => super::avif::grid.get(label),
            3349 => super::avif::ipro.get(label),
            3350 => super::avif::ispe.get(label),
            3351 => super::avif::lsel.get(label),
            3352 => super::avif::pasp.get(label),
            3353 => super::avif::pixi.get(label),
            3354 => super::avif::yuv_color_space.get(label),
            3389 => super::netwerk::http3_0rtt_state.get(label),
            3392 => super::network::byte_range_request.get(label),
            3398 => super::network::cors_authorization_header.get(label),
            3426 => super::network::system_channel_addon_status.get(label),
            3427 => super::network::system_channel_addonversion_status.get(label),
            3428 => super::network::system_channel_other_status.get(label),
            3429 => super::network::system_channel_remote_settings_status.get(label),
            3430 => super::network::system_channel_success_or_failure.get(label),
            3431 => super::network::system_channel_telemetry_status.get(label),
            3432 => super::network::system_channel_update_status.get(label),
            3434 => super::network::tls_early_data_accepted.get(label),
            3436 => super::network::tls_early_data_negotiated.get(label),
            3446 => super::cert_verifier::cert_revocation_mechanisms.get(label),
            3447 => super::cert_verifier::crlite_status.get(label),
            3448 => super::cert_verifier::crlite_vs_ocsp_result.get(label),
            3453 => super::cert_compression::failures.get(label),
            3454 => super::cert_compression::used.get(label),
            3468 => super::tls::xyber_intolerance_reason.get(label),
            3515 => super::bounce_tracking_protection::purge_count.get(label),
            3556 => super::cookie_banners::rule_lookup_by_domain.get(label),
            3557 => super::cookie_banners::rule_lookup_by_load.get(label),
            3563 => super::cookie_banners_click::result.get(label),
            3564 => super::cookie_banners_cmp::detected_cmp.get(label),
            3566 => super::cookie_banners_cmp::result.get(label),
            3591 => super::crash_submission::channel_status.get(label),
            3592 => super::crash_submission::collector_errors.get(label),
            3617 => super::extensions::process_event.get(label),
            3619 => super::extensions::startup_cache_read_errors.get(label),
            3625 => super::extensions_apis_dnr::startup_cache_entries.get(label),
            3631 => super::extensions_counters::browser_action_preload_result.get(label),
            3632 => super::extensions_counters::event_page_idle_result.get(label),
            3700 => super::formautofill::form_submission_heuristic.get(label),
            3728 => super::test_only::mabels_bathroom_counters.get(label),
            3730 => super::test_only::mabels_kitchen_counters.get(label),
            3732 => super::test_only::mabels_labeled_counters.get(label),
            3749 => super::test_only_ipc::a_labeled_counter.get(label),
            3762 => super::test_only_ipc::another_labeled_counter.get(label),
            3839 => super::pwmgr::form_autofill_result.get(label),
            3883 => super::pdfjs::buttons.get(label),
            3884 => super::pdfjs::editing.get(label),
            3885 => super::pdfjs::geckoview.get(label),
            3886 => super::pdfjs::stamp.get(label),
            3889 => super::pdfjs_editing_highlight::color.get(label),
            3893 => super::pdfjs_editing_highlight::kind.get(label),
            3894 => super::pdfjs_editing_highlight::method.get(label),
            3895 => super::pdfjs_editing_highlight::number_of_colors.get(label),
            3902 => super::pdfjs_image::added.get(label),
            3962 => super::printing::error.get(label),
            3965 => super::printing::settings_changed.get(label),
            3967 => super::printing::target_type.get(label),
            3969 => super::power::cpu_time_per_process_type_ms.get(label),
            3970 => super::power::cpu_time_per_tracker_type_ms.get(label),
            3971 => super::power::energy_per_process_type.get(label),
            3973 => super::power::gpu_time_per_process_type_ms.get(label),
            3977 => super::power::wakeups_per_process_type.get(label),
            3979 => super::power_cpu_ms_per_thread::content_background.get(label),
            3980 => super::power_cpu_ms_per_thread::content_foreground.get(label),
            3981 => super::power_cpu_ms_per_thread::gpu_process.get(label),
            3982 => super::power_cpu_ms_per_thread::parent_active.get(label),
            3983 => super::power_cpu_ms_per_thread::parent_inactive.get(label),
            3984 => super::power_wakeups_per_thread::content_background.get(label),
            3985 => super::power_wakeups_per_thread::content_foreground.get(label),
            3986 => super::power_wakeups_per_thread::gpu_process.get(label),
            3987 => super::power_wakeups_per_thread::parent_active.get(label),
            3988 => super::power_wakeups_per_thread::parent_inactive.get(label),
            4239 => super::search_service::initialization_status.get(label),
            4258 => super::translations::request_count.get(label),
            4412 => super::update::bitshresult.get(label),
            4419 => super::update::move_result.get(label),
            _ => panic!("No labeled_counter for metric id {}", metric_id),
        }
    }

    /// Gets the submetric from the specified labeled_counter metric, by enum.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label_enum` - The label enum identifying the counter submetric.
    ///
    /// # Returns
    ///
    /// Returns the counter submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_counter by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_counter_enum_get(metric_id: u32, label_enum: u16) -> LabeledCounterMetric {
        match metric_id {
            78 => super::networking::cookie_timestamp_fixed_count.get(labeled_enum_to_str(metric_id, label_enum)),
            81 => super::networking::dns_native_count.get(labeled_enum_to_str(metric_id, label_enum)),
            85 => super::networking::fetch_keepalive_discard_count.get(labeled_enum_to_str(metric_id, label_enum)),
            86 => super::networking::fetch_keepalive_request_count.get(labeled_enum_to_str(metric_id, label_enum)),
            103 => super::networking::http_3_ecn_path_capability.get(labeled_enum_to_str(metric_id, label_enum)),
            113 => super::networking::http_channel_disposition.get(labeled_enum_to_str(metric_id, label_enum)),
            114 => super::networking::http_channel_disposition_disabled_no_reason.get(labeled_enum_to_str(metric_id, label_enum)),
            115 => super::networking::http_channel_disposition_disabled_upgrade.get(labeled_enum_to_str(metric_id, label_enum)),
            116 => super::networking::http_channel_disposition_disabled_wont.get(labeled_enum_to_str(metric_id, label_enum)),
            117 => super::networking::http_channel_disposition_enabled_no_reason.get(labeled_enum_to_str(metric_id, label_enum)),
            118 => super::networking::http_channel_disposition_enabled_upgrade.get(labeled_enum_to_str(metric_id, label_enum)),
            119 => super::networking::http_channel_disposition_enabled_wont.get(labeled_enum_to_str(metric_id, label_enum)),
            120 => super::networking::http_channel_onstart_status.get(labeled_enum_to_str(metric_id, label_enum)),
            121 => super::networking::http_channel_onstart_success_https_rr.get(labeled_enum_to_str(metric_id, label_enum)),
            133 => super::networking::http_ip_addr_any_count.get(labeled_enum_to_str(metric_id, label_enum)),
            137 => super::networking::http_response_status_code.get(labeled_enum_to_str(metric_id, label_enum)),
            138 => super::networking::http_response_version.get(labeled_enum_to_str(metric_id, label_enum)),
            139 => super::networking::http_to_https_upgrade_reason.get(labeled_enum_to_str(metric_id, label_enum)),
            140 => super::networking::https_rr_presented.get(labeled_enum_to_str(metric_id, label_enum)),
            142 => super::networking::proxy_info_type.get(labeled_enum_to_str(metric_id, label_enum)),
            144 => super::networking::residual_cache_folder_removal.get(labeled_enum_to_str(metric_id, label_enum)),
            150 => super::networking::speculative_connect_outcome.get(labeled_enum_to_str(metric_id, label_enum)),
            156 => super::networking::trr_request_count.get(labeled_enum_to_str(metric_id, label_enum)),
            157 => super::networking::trr_request_count_per_conn.get(labeled_enum_to_str(metric_id, label_enum)),
            486 => super::protocolhandler_mailto::handler_prompt_shown.get(labeled_enum_to_str(metric_id, label_enum)),
            487 => super::protocolhandler_mailto::prompt_clicked.get(labeled_enum_to_str(metric_id, label_enum)),
            566 => super::serp::ads_blocked_count.get(labeled_enum_to_str(metric_id, label_enum)),
            704 => super::suggest_relevance::outcome.get(labeled_enum_to_str(metric_id, label_enum)),
            705 => super::suggest_relevance::status.get(labeled_enum_to_str(metric_id, label_enum)),
            3178 => super::geolocation::fallback.get(labeled_enum_to_str(metric_id, label_enum)),
            3180 => super::geolocation::request_result.get(labeled_enum_to_str(metric_id, label_enum)),
            3189 => super::gmp::update_xml_fetch_result.get(labeled_enum_to_str(metric_id, label_enum)),
            3194 => super::media_audio::backend.get(labeled_enum_to_str(metric_id, label_enum)),
            3195 => super::media_audio::init_failure.get(labeled_enum_to_str(metric_id, label_enum)),
            3203 => super::codec_stats::ulpfec_negotiated.get(labeled_enum_to_str(metric_id, label_enum)),
            3262 => super::web_notification::permission_origin.get(labeled_enum_to_str(metric_id, label_enum)),
            3263 => super::web_notification::request_permission_origin.get(labeled_enum_to_str(metric_id, label_enum)),
            3264 => super::web_notification::show_origin.get(labeled_enum_to_str(metric_id, label_enum)),
            3266 => super::web_push::error_code.get(labeled_enum_to_str(metric_id, label_enum)),
            3276 => super::webauthn_create::authenticator_attachment.get(labeled_enum_to_str(metric_id, label_enum)),
            3280 => super::webauthn_get::authenticator_attachment.get(labeled_enum_to_str(metric_id, label_enum)),
            3307 => super::gfx_content_frame_time::reason.get(labeled_enum_to_str(metric_id, label_enum)),
            3319 => super::gpu_process::crash_fallbacks.get(labeled_enum_to_str(metric_id, label_enum)),
            3335 => super::avif::a1lx.get(labeled_enum_to_str(metric_id, label_enum)),
            3336 => super::avif::a1op.get(labeled_enum_to_str(metric_id, label_enum)),
            3337 => super::avif::alpha.get(labeled_enum_to_str(metric_id, label_enum)),
            3338 => super::avif::aom_decode_error.get(labeled_enum_to_str(metric_id, label_enum)),
            3339 => super::avif::bit_depth.get(labeled_enum_to_str(metric_id, label_enum)),
            3340 => super::avif::cicp_cp.get(labeled_enum_to_str(metric_id, label_enum)),
            3341 => super::avif::cicp_mc.get(labeled_enum_to_str(metric_id, label_enum)),
            3342 => super::avif::cicp_tc.get(labeled_enum_to_str(metric_id, label_enum)),
            3343 => super::avif::clap.get(labeled_enum_to_str(metric_id, label_enum)),
            3344 => super::avif::colr.get(labeled_enum_to_str(metric_id, label_enum)),
            3346 => super::avif::decode_result.get(labeled_enum_to_str(metric_id, label_enum)),
            3347 => super::avif::decoder.get(labeled_enum_to_str(metric_id, label_enum)),
            3348 => super::avif::grid.get(labeled_enum_to_str(metric_id, label_enum)),
            3349 => super::avif::ipro.get(labeled_enum_to_str(metric_id, label_enum)),
            3350 => super::avif::ispe.get(labeled_enum_to_str(metric_id, label_enum)),
            3351 => super::avif::lsel.get(labeled_enum_to_str(metric_id, label_enum)),
            3352 => super::avif::pasp.get(labeled_enum_to_str(metric_id, label_enum)),
            3353 => super::avif::pixi.get(labeled_enum_to_str(metric_id, label_enum)),
            3354 => super::avif::yuv_color_space.get(labeled_enum_to_str(metric_id, label_enum)),
            3389 => super::netwerk::http3_0rtt_state.get(labeled_enum_to_str(metric_id, label_enum)),
            3392 => super::network::byte_range_request.get(labeled_enum_to_str(metric_id, label_enum)),
            3398 => super::network::cors_authorization_header.get(labeled_enum_to_str(metric_id, label_enum)),
            3426 => super::network::system_channel_addon_status.get(labeled_enum_to_str(metric_id, label_enum)),
            3427 => super::network::system_channel_addonversion_status.get(labeled_enum_to_str(metric_id, label_enum)),
            3428 => super::network::system_channel_other_status.get(labeled_enum_to_str(metric_id, label_enum)),
            3429 => super::network::system_channel_remote_settings_status.get(labeled_enum_to_str(metric_id, label_enum)),
            3430 => super::network::system_channel_success_or_failure.get(labeled_enum_to_str(metric_id, label_enum)),
            3431 => super::network::system_channel_telemetry_status.get(labeled_enum_to_str(metric_id, label_enum)),
            3432 => super::network::system_channel_update_status.get(labeled_enum_to_str(metric_id, label_enum)),
            3434 => super::network::tls_early_data_accepted.get(labeled_enum_to_str(metric_id, label_enum)),
            3436 => super::network::tls_early_data_negotiated.get(labeled_enum_to_str(metric_id, label_enum)),
            3446 => super::cert_verifier::cert_revocation_mechanisms.get(labeled_enum_to_str(metric_id, label_enum)),
            3447 => super::cert_verifier::crlite_status.get(labeled_enum_to_str(metric_id, label_enum)),
            3448 => super::cert_verifier::crlite_vs_ocsp_result.get(labeled_enum_to_str(metric_id, label_enum)),
            3453 => super::cert_compression::failures.get(labeled_enum_to_str(metric_id, label_enum)),
            3454 => super::cert_compression::used.get(labeled_enum_to_str(metric_id, label_enum)),
            3468 => super::tls::xyber_intolerance_reason.get(labeled_enum_to_str(metric_id, label_enum)),
            3515 => super::bounce_tracking_protection::purge_count.get(labeled_enum_to_str(metric_id, label_enum)),
            3556 => super::cookie_banners::rule_lookup_by_domain.get(labeled_enum_to_str(metric_id, label_enum)),
            3557 => super::cookie_banners::rule_lookup_by_load.get(labeled_enum_to_str(metric_id, label_enum)),
            3563 => super::cookie_banners_click::result.get(labeled_enum_to_str(metric_id, label_enum)),
            3566 => super::cookie_banners_cmp::result.get(labeled_enum_to_str(metric_id, label_enum)),
            3617 => super::extensions::process_event.get(labeled_enum_to_str(metric_id, label_enum)),
            3625 => super::extensions_apis_dnr::startup_cache_entries.get(labeled_enum_to_str(metric_id, label_enum)),
            3631 => super::extensions_counters::browser_action_preload_result.get(labeled_enum_to_str(metric_id, label_enum)),
            3632 => super::extensions_counters::event_page_idle_result.get(labeled_enum_to_str(metric_id, label_enum)),
            3700 => super::formautofill::form_submission_heuristic.get(labeled_enum_to_str(metric_id, label_enum)),
            3732 => super::test_only::mabels_labeled_counters.get(labeled_enum_to_str(metric_id, label_enum)),
            3839 => super::pwmgr::form_autofill_result.get(labeled_enum_to_str(metric_id, label_enum)),
            3883 => super::pdfjs::buttons.get(labeled_enum_to_str(metric_id, label_enum)),
            3884 => super::pdfjs::editing.get(labeled_enum_to_str(metric_id, label_enum)),
            3885 => super::pdfjs::geckoview.get(labeled_enum_to_str(metric_id, label_enum)),
            3886 => super::pdfjs::stamp.get(labeled_enum_to_str(metric_id, label_enum)),
            3889 => super::pdfjs_editing_highlight::color.get(labeled_enum_to_str(metric_id, label_enum)),
            3893 => super::pdfjs_editing_highlight::kind.get(labeled_enum_to_str(metric_id, label_enum)),
            3894 => super::pdfjs_editing_highlight::method.get(labeled_enum_to_str(metric_id, label_enum)),
            3895 => super::pdfjs_editing_highlight::number_of_colors.get(labeled_enum_to_str(metric_id, label_enum)),
            3902 => super::pdfjs_image::added.get(labeled_enum_to_str(metric_id, label_enum)),
            3962 => super::printing::error.get(labeled_enum_to_str(metric_id, label_enum)),
            3967 => super::printing::target_type.get(labeled_enum_to_str(metric_id, label_enum)),
            3969 => super::power::cpu_time_per_process_type_ms.get(labeled_enum_to_str(metric_id, label_enum)),
            3970 => super::power::cpu_time_per_tracker_type_ms.get(labeled_enum_to_str(metric_id, label_enum)),
            3971 => super::power::energy_per_process_type.get(labeled_enum_to_str(metric_id, label_enum)),
            3973 => super::power::gpu_time_per_process_type_ms.get(labeled_enum_to_str(metric_id, label_enum)),
            3977 => super::power::wakeups_per_process_type.get(labeled_enum_to_str(metric_id, label_enum)),
            3979 => super::power_cpu_ms_per_thread::content_background.get(labeled_enum_to_str(metric_id, label_enum)),
            3980 => super::power_cpu_ms_per_thread::content_foreground.get(labeled_enum_to_str(metric_id, label_enum)),
            3981 => super::power_cpu_ms_per_thread::gpu_process.get(labeled_enum_to_str(metric_id, label_enum)),
            3982 => super::power_cpu_ms_per_thread::parent_active.get(labeled_enum_to_str(metric_id, label_enum)),
            3983 => super::power_cpu_ms_per_thread::parent_inactive.get(labeled_enum_to_str(metric_id, label_enum)),
            3984 => super::power_wakeups_per_thread::content_background.get(labeled_enum_to_str(metric_id, label_enum)),
            3985 => super::power_wakeups_per_thread::content_foreground.get(labeled_enum_to_str(metric_id, label_enum)),
            3986 => super::power_wakeups_per_thread::gpu_process.get(labeled_enum_to_str(metric_id, label_enum)),
            3987 => super::power_wakeups_per_thread::parent_active.get(labeled_enum_to_str(metric_id, label_enum)),
            3988 => super::power_wakeups_per_thread::parent_inactive.get(labeled_enum_to_str(metric_id, label_enum)),
            4239 => super::search_service::initialization_status.get(labeled_enum_to_str(metric_id, label_enum)),
            4258 => super::translations::request_count.get(labeled_enum_to_str(metric_id, label_enum)),
            _ => panic!("No labeled_counter for metric id {}", metric_id),
        }
    }
    /// Gets the submetric from the specified labeled_timing_distribution metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label` - The label identifying the timing_distribution submetric.
    ///
    /// # Returns
    ///
    /// Returns the timing_distribution submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_timing_distribution by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_timing_distribution_get(metric_id: u32, label: &str) -> LabeledTimingDistributionMetric {
        match metric_id {
            155 => super::networking::trr_fetch_duration.get(label),
            701 => super::suggest::ingest_download_time.get(label),
            702 => super::suggest::ingest_time.get(label),
            703 => super::suggest::query_time.get(label),
            3390 => super::netwerk::http3_0rtt_state_duration.get(label),
            3404 => super::network::http3_complete_load.get(label),
            3405 => super::network::http3_first_sent_to_last_received.get(label),
            3406 => super::network::http3_open_to_first_received.get(label),
            3407 => super::network::http3_open_to_first_sent.get(label),
            3408 => super::network::http3_tls_handshake.get(label),
            3425 => super::network::sup_http3_tcp_connection.get(label),
            3744 => super::test_only::where_has_the_time_gone.get(label),
            _ => panic!("No labeled_timing_distribution for metric id {}", metric_id),
        }
    }

    /// Gets the submetric from the specified labeled_timing_distribution metric, by enum.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label_enum` - The label enum identifying the timing_distribution submetric.
    ///
    /// # Returns
    ///
    /// Returns the timing_distribution submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_timing_distribution by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_timing_distribution_enum_get(metric_id: u32, label_enum: u16) -> LabeledTimingDistributionMetric {
        match metric_id {
            155 => super::networking::trr_fetch_duration.get(labeled_enum_to_str(metric_id, label_enum)),
            701 => super::suggest::ingest_download_time.get(labeled_enum_to_str(metric_id, label_enum)),
            702 => super::suggest::ingest_time.get(labeled_enum_to_str(metric_id, label_enum)),
            703 => super::suggest::query_time.get(labeled_enum_to_str(metric_id, label_enum)),
            3390 => super::netwerk::http3_0rtt_state_duration.get(labeled_enum_to_str(metric_id, label_enum)),
            3404 => super::network::http3_complete_load.get(labeled_enum_to_str(metric_id, label_enum)),
            3405 => super::network::http3_first_sent_to_last_received.get(labeled_enum_to_str(metric_id, label_enum)),
            3406 => super::network::http3_open_to_first_received.get(labeled_enum_to_str(metric_id, label_enum)),
            3407 => super::network::http3_open_to_first_sent.get(labeled_enum_to_str(metric_id, label_enum)),
            3408 => super::network::http3_tls_handshake.get(labeled_enum_to_str(metric_id, label_enum)),
            3425 => super::network::sup_http3_tcp_connection.get(labeled_enum_to_str(metric_id, label_enum)),
            _ => panic!("No labeled_timing_distribution for metric id {}", metric_id),
        }
    }
    /// Gets the submetric from the specified labeled_string metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label` - The label identifying the string submetric.
    ///
    /// # Returns
    ///
    /// Returns the string submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_string by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_string_get(metric_id: u32, label: &str) -> LabeledStringMetric {
        match metric_id {
            3550 => super::cookie_banners::google_gdpr_choice_cookie.get(label),
            3726 => super::test_only::mabels_balloon_labels.get(label),
            3727 => super::test_only::mabels_balloon_strings.get(label),
            3731 => super::test_only::mabels_label_maker.get(label),
            3957 => super::places::places_database_corruption_handling_stage.get(label),
            _ => panic!("No labeled_string for metric id {}", metric_id),
        }
    }

    /// Gets the submetric from the specified labeled_string metric, by enum.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label_enum` - The label enum identifying the string submetric.
    ///
    /// # Returns
    ///
    /// Returns the string submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_string by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_string_enum_get(metric_id: u32, label_enum: u16) -> LabeledStringMetric {
        match metric_id {
            3726 => super::test_only::mabels_balloon_labels.get(labeled_enum_to_str(metric_id, label_enum)),
            _ => panic!("No labeled_string for metric id {}", metric_id),
        }
    }
    /// Gets the submetric from the specified labeled_custom_distribution metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label` - The label identifying the custom_distribution submetric.
    ///
    /// # Returns
    ///
    /// Returns the custom_distribution submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_custom_distribution by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_custom_distribution_get(metric_id: u32, label: &str) -> LabeledCustomDistributionMetric {
        match metric_id {
            3729 => super::test_only::mabels_custom_label_lengths.get(label),
            _ => panic!("No labeled_custom_distribution for metric id {}", metric_id),
        }
    }

    /// Gets the submetric from the specified labeled_custom_distribution metric, by enum.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label_enum` - The label enum identifying the custom_distribution submetric.
    ///
    /// # Returns
    ///
    /// Returns the custom_distribution submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_custom_distribution by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_custom_distribution_enum_get(metric_id: u32, label_enum: u16) -> LabeledCustomDistributionMetric {
        match metric_id {
            _ => panic!("No labeled_custom_distribution for metric id {}", metric_id),
        }
    }
    /// Gets the submetric from the specified labeled_memory_distribution metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label` - The label identifying the memory_distribution submetric.
    ///
    /// # Returns
    ///
    /// Returns the memory_distribution submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_memory_distribution by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_memory_distribution_get(metric_id: u32, label: &str) -> LabeledMemoryDistributionMetric {
        match metric_id {
            3741 => super::test_only::what_do_you_remember.get(label),
            _ => panic!("No labeled_memory_distribution for metric id {}", metric_id),
        }
    }

    /// Gets the submetric from the specified labeled_memory_distribution metric, by enum.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label_enum` - The label enum identifying the memory_distribution submetric.
    ///
    /// # Returns
    ///
    /// Returns the memory_distribution submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_memory_distribution by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_memory_distribution_enum_get(metric_id: u32, label_enum: u16) -> LabeledMemoryDistributionMetric {
        match metric_id {
            _ => panic!("No labeled_memory_distribution for metric id {}", metric_id),
        }
    }

    pub(crate) fn labeled_enum_to_str(metric_id: u32, label: u16) -> &'static str {
        match metric_id {
            7 => super::a11y::ThemeLabel::from(label).into(),
            78 => super::networking::CookieTimestampFixedCountLabel::from(label).into(),
            81 => super::networking::DnsNativeCountLabel::from(label).into(),
            85 => super::networking::FetchKeepaliveDiscardCountLabel::from(label).into(),
            86 => super::networking::FetchKeepaliveRequestCountLabel::from(label).into(),
            103 => super::networking::Http3EcnPathCapabilityLabel::from(label).into(),
            113 => super::networking::HttpChannelDispositionLabel::from(label).into(),
            114 => super::networking::HttpChannelDispositionDisabledNoReasonLabel::from(label).into(),
            115 => super::networking::HttpChannelDispositionDisabledUpgradeLabel::from(label).into(),
            116 => super::networking::HttpChannelDispositionDisabledWontLabel::from(label).into(),
            117 => super::networking::HttpChannelDispositionEnabledNoReasonLabel::from(label).into(),
            118 => super::networking::HttpChannelDispositionEnabledUpgradeLabel::from(label).into(),
            119 => super::networking::HttpChannelDispositionEnabledWontLabel::from(label).into(),
            120 => super::networking::HttpChannelOnstartStatusLabel::from(label).into(),
            121 => super::networking::HttpChannelOnstartSuccessHttpsRrLabel::from(label).into(),
            133 => super::networking::HttpIpAddrAnyCountLabel::from(label).into(),
            137 => super::networking::HttpResponseStatusCodeLabel::from(label).into(),
            138 => super::networking::HttpResponseVersionLabel::from(label).into(),
            139 => super::networking::HttpToHttpsUpgradeReasonLabel::from(label).into(),
            140 => super::networking::HttpsRrPresentedLabel::from(label).into(),
            142 => super::networking::ProxyInfoTypeLabel::from(label).into(),
            144 => super::networking::ResidualCacheFolderRemovalLabel::from(label).into(),
            150 => super::networking::SpeculativeConnectOutcomeLabel::from(label).into(),
            155 => super::networking::TrrFetchDurationLabel::from(label).into(),
            156 => super::networking::TrrRequestCountLabel::from(label).into(),
            157 => super::networking::TrrRequestCountPerConnLabel::from(label).into(),
            486 => super::protocolhandler_mailto::HandlerPromptShownLabel::from(label).into(),
            487 => super::protocolhandler_mailto::PromptClickedLabel::from(label).into(),
            566 => super::serp::AdsBlockedCountLabel::from(label).into(),
            701 => super::suggest::IngestDownloadTimeLabel::from(label).into(),
            702 => super::suggest::IngestTimeLabel::from(label).into(),
            703 => super::suggest::QueryTimeLabel::from(label).into(),
            704 => super::suggest_relevance::OutcomeLabel::from(label).into(),
            705 => super::suggest_relevance::StatusLabel::from(label).into(),
            3178 => super::geolocation::FallbackLabel::from(label).into(),
            3179 => super::geolocation::LinuxProviderLabel::from(label).into(),
            3180 => super::geolocation::RequestResultLabel::from(label).into(),
            3189 => super::gmp::UpdateXmlFetchResultLabel::from(label).into(),
            3194 => super::media_audio::BackendLabel::from(label).into(),
            3195 => super::media_audio::InitFailureLabel::from(label).into(),
            3196 => super::media_playback::DeviceHardwareDecoderSupportLabel::from(label).into(),
            3203 => super::codec_stats::UlpfecNegotiatedLabel::from(label).into(),
            3262 => super::web_notification::PermissionOriginLabel::from(label).into(),
            3263 => super::web_notification::RequestPermissionOriginLabel::from(label).into(),
            3264 => super::web_notification::ShowOriginLabel::from(label).into(),
            3266 => super::web_push::ErrorCodeLabel::from(label).into(),
            3276 => super::webauthn_create::AuthenticatorAttachmentLabel::from(label).into(),
            3280 => super::webauthn_get::AuthenticatorAttachmentLabel::from(label).into(),
            3307 => super::gfx_content_frame_time::ReasonLabel::from(label).into(),
            3319 => super::gpu_process::CrashFallbacksLabel::from(label).into(),
            3335 => super::avif::A1lxLabel::from(label).into(),
            3336 => super::avif::A1opLabel::from(label).into(),
            3337 => super::avif::AlphaLabel::from(label).into(),
            3338 => super::avif::AomDecodeErrorLabel::from(label).into(),
            3339 => super::avif::BitDepthLabel::from(label).into(),
            3340 => super::avif::CicpCpLabel::from(label).into(),
            3341 => super::avif::CicpMcLabel::from(label).into(),
            3342 => super::avif::CicpTcLabel::from(label).into(),
            3343 => super::avif::ClapLabel::from(label).into(),
            3344 => super::avif::ColrLabel::from(label).into(),
            3346 => super::avif::DecodeResultLabel::from(label).into(),
            3347 => super::avif::DecoderLabel::from(label).into(),
            3348 => super::avif::GridLabel::from(label).into(),
            3349 => super::avif::IproLabel::from(label).into(),
            3350 => super::avif::IspeLabel::from(label).into(),
            3351 => super::avif::LselLabel::from(label).into(),
            3352 => super::avif::PaspLabel::from(label).into(),
            3353 => super::avif::PixiLabel::from(label).into(),
            3354 => super::avif::YuvColorSpaceLabel::from(label).into(),
            3389 => super::netwerk::Http30rttStateLabel::from(label).into(),
            3390 => super::netwerk::Http30rttStateDurationLabel::from(label).into(),
            3392 => super::network::ByteRangeRequestLabel::from(label).into(),
            3398 => super::network::CorsAuthorizationHeaderLabel::from(label).into(),
            3404 => super::network::Http3CompleteLoadLabel::from(label).into(),
            3405 => super::network::Http3FirstSentToLastReceivedLabel::from(label).into(),
            3406 => super::network::Http3OpenToFirstReceivedLabel::from(label).into(),
            3407 => super::network::Http3OpenToFirstSentLabel::from(label).into(),
            3408 => super::network::Http3TlsHandshakeLabel::from(label).into(),
            3425 => super::network::SupHttp3TcpConnectionLabel::from(label).into(),
            3426 => super::network::SystemChannelAddonStatusLabel::from(label).into(),
            3427 => super::network::SystemChannelAddonversionStatusLabel::from(label).into(),
            3428 => super::network::SystemChannelOtherStatusLabel::from(label).into(),
            3429 => super::network::SystemChannelRemoteSettingsStatusLabel::from(label).into(),
            3430 => super::network::SystemChannelSuccessOrFailureLabel::from(label).into(),
            3431 => super::network::SystemChannelTelemetryStatusLabel::from(label).into(),
            3432 => super::network::SystemChannelUpdateStatusLabel::from(label).into(),
            3434 => super::network::TlsEarlyDataAcceptedLabel::from(label).into(),
            3436 => super::network::TlsEarlyDataNegotiatedLabel::from(label).into(),
            3446 => super::cert_verifier::CertRevocationMechanismsLabel::from(label).into(),
            3447 => super::cert_verifier::CrliteStatusLabel::from(label).into(),
            3448 => super::cert_verifier::CrliteVsOcspResultLabel::from(label).into(),
            3453 => super::cert_compression::FailuresLabel::from(label).into(),
            3454 => super::cert_compression::UsedLabel::from(label).into(),
            3468 => super::tls::XyberIntoleranceReasonLabel::from(label).into(),
            3515 => super::bounce_tracking_protection::PurgeCountLabel::from(label).into(),
            3553 => super::cookie_banners::NormalWindowServiceModeLabel::from(label).into(),
            3554 => super::cookie_banners::PrivateWindowServiceModeLabel::from(label).into(),
            3556 => super::cookie_banners::RuleLookupByDomainLabel::from(label).into(),
            3557 => super::cookie_banners::RuleLookupByLoadLabel::from(label).into(),
            3563 => super::cookie_banners_click::ResultLabel::from(label).into(),
            3566 => super::cookie_banners_cmp::ResultLabel::from(label).into(),
            3617 => super::extensions::ProcessEventLabel::from(label).into(),
            3625 => super::extensions_apis_dnr::StartupCacheEntriesLabel::from(label).into(),
            3631 => super::extensions_counters::BrowserActionPreloadResultLabel::from(label).into(),
            3632 => super::extensions_counters::EventPageIdleResultLabel::from(label).into(),
            3700 => super::formautofill::FormSubmissionHeuristicLabel::from(label).into(),
            3726 => super::test_only::MabelsBalloonLabelsLabel::from(label).into(),
            3732 => super::test_only::MabelsLabeledCountersLabel::from(label).into(),
            3734 => super::test_only::MabelsLikeLabeledBalloonsLabel::from(label).into(),
            3839 => super::pwmgr::FormAutofillResultLabel::from(label).into(),
            3883 => super::pdfjs::ButtonsLabel::from(label).into(),
            3884 => super::pdfjs::EditingLabel::from(label).into(),
            3885 => super::pdfjs::GeckoviewLabel::from(label).into(),
            3886 => super::pdfjs::StampLabel::from(label).into(),
            3889 => super::pdfjs_editing_highlight::ColorLabel::from(label).into(),
            3893 => super::pdfjs_editing_highlight::KindLabel::from(label).into(),
            3894 => super::pdfjs_editing_highlight::MethodLabel::from(label).into(),
            3895 => super::pdfjs_editing_highlight::NumberOfColorsLabel::from(label).into(),
            3902 => super::pdfjs_image::AddedLabel::from(label).into(),
            3903 => super::pdfjs_image::AltTextEditLabel::from(label).into(),
            3962 => super::printing::ErrorLabel::from(label).into(),
            3967 => super::printing::TargetTypeLabel::from(label).into(),
            3969 => super::power::CpuTimePerProcessTypeMsLabel::from(label).into(),
            3970 => super::power::CpuTimePerTrackerTypeMsLabel::from(label).into(),
            3971 => super::power::EnergyPerProcessTypeLabel::from(label).into(),
            3973 => super::power::GpuTimePerProcessTypeMsLabel::from(label).into(),
            3977 => super::power::WakeupsPerProcessTypeLabel::from(label).into(),
            3979 => super::power_cpu_ms_per_thread::ContentBackgroundLabel::from(label).into(),
            3980 => super::power_cpu_ms_per_thread::ContentForegroundLabel::from(label).into(),
            3981 => super::power_cpu_ms_per_thread::GpuProcessLabel::from(label).into(),
            3982 => super::power_cpu_ms_per_thread::ParentActiveLabel::from(label).into(),
            3983 => super::power_cpu_ms_per_thread::ParentInactiveLabel::from(label).into(),
            3984 => super::power_wakeups_per_thread::ContentBackgroundLabel::from(label).into(),
            3985 => super::power_wakeups_per_thread::ContentForegroundLabel::from(label).into(),
            3986 => super::power_wakeups_per_thread::GpuProcessLabel::from(label).into(),
            3987 => super::power_wakeups_per_thread::ParentActiveLabel::from(label).into(),
            3988 => super::power_wakeups_per_thread::ParentInactiveLabel::from(label).into(),
            4239 => super::search_service::InitializationStatusLabel::from(label).into(),
            4258 => super::translations::RequestCountLabel::from(label).into(),
            _ => panic!("Can't turn label enum to string for metric {} which isn't a labeled metric with static labels", metric_id),
        }
    }

    pub(crate) mod submetric_maps {
        use std::sync::{
          atomic::AtomicU32,
          RwLock,
        };
        use super::*;

        pub(crate) const SUBMETRIC_BIT: u32 = 25;
        pub(crate) static NEXT_LABELED_SUBMETRIC_ID: AtomicU32 = AtomicU32::new((1 << SUBMETRIC_BIT) + 1);
        pub(crate) static LABELED_METRICS_TO_IDS: Lazy<RwLock<HashMap<(u32, String), u32>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
        pub(crate) static LABELED_ENUMS_TO_IDS: Lazy<RwLock<HashMap<(u32, u16), u32>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );

        pub static BOOLEAN_MAP: Lazy<RwLock<HashMap<MetricId, LabeledBooleanMetric>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
        pub static STRING_MAP: Lazy<RwLock<HashMap<MetricId, LabeledStringMetric>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
        pub static TIMING_DISTRIBUTION_MAP: Lazy<RwLock<HashMap<MetricId, LabeledTimingDistributionMetric>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
        pub static MEMORY_DISTRIBUTION_MAP: Lazy<RwLock<HashMap<MetricId, LabeledMemoryDistributionMetric>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
        pub static COUNTER_MAP: Lazy<RwLock<HashMap<MetricId, LabeledCounterMetric>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
        pub static CUSTOM_DISTRIBUTION_MAP: Lazy<RwLock<HashMap<MetricId, LabeledCustomDistributionMetric>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
    }
}

